( *! Bufferclass                                            )
( *T A CIAO Class for BUFFERS                               )
( *H based on the BUFF structure that has int's for base and size )


struct{ BUFF
        int             base
        int             size
}


( *S Buffer Class Definition                                )


operator: Scroll
operator: CopyTo

Class Buffer : public BUFF
public:           
                  meth: getbase
                  meth: getsize
                  meth: addr
                  meth: Move
                  meth: resize
                  meth: copy
                  meth: discard
                  meth: PrintBuffer
                  meth: init
                  meth: erase
                  meth: SetAt
                  meth: GetAt

      Scroll      oper: Move
      CopyTo      oper: copy
end-class



: buffer::GetBase \ -- n
( *G returns the base address of the buffer                 )
      base 
;

: Buffer::GetSize \ -- n
( *G returns the size of the buffer in bytes                )
      size
;

: Buffer::addr          \ n -- addr
( *G returns the address of base+n                          )
            base + 
;

: Buffer::SetAt         \ n index --
      addr c!
;

: Buffer::GetAt         \ index -- n
      addr c@
; 

: Buffer::init          \ n --
( *G inits the buffer to size n,                            )
      Dup               \
      Allocate 0=       \ try to get memory
      if                \ ok
       to base          \ pointer to base
       to size          \ size in bytes
      else 
      Abort" Mem Alloc fail"
      Then
;

: Buffer::ReSize  \ n --
( *G resizes the buffer to n                                )
      base                    \ base is non zero if already allocated memory
      If
       base free drop         \ discard
      Then
      init                    \ grab new memory
;

: Buffer::Move          \ s d b --
( *G moves data in the buffer.                              )
( ** the caller has responsibility for ensuring data is not )
( ** moved past the end of the buffer                       )
            >r >r             \
            base +            \ source
            r> base +         \ destination
            r> ::move         \ size : move it
;

: Buffer::discard       \ -- 
( *G frees memory                                           )
      base Free drop    \ free up memory
      0 To base         \ make sure no re use
      0 to size
;

: Buffer::erase         \ --
( *G erases the buffer                                      )
      base size ::Erase
;

: Buffer::copy          \ *buff -- 
( *G copies one buffer to another                           )
      >r                            \ save pointer
      r@ (buffer).Size Size >       \ need more space
      If                            \ yes
       r@ (buffer).Size ReSize      \ resize target buffer
      Then
      r@ (buffer).GetBase           \ source
      base                          \ destination
      r> (buffer).Size              \ size
      ::move                        \ move
;
       
: Buffer::PrintBuffer
( *G prints the buffers base address and size               )
      cr ." Buffer base address " Base .
      cr ." Buffer Size         " Size .
;


( *S CELLbuffer Class Definition                            )

Class CELLbuffer : public Buffer

public:
                  meth: GetAt
                  meth: SetAt
                  meth: init
      []          oper: GetAt
      []to        oper: SetAt
      CopyTo      oper: copy
end-class

: CEllBuffer::init      \ n --
      CELLS Dup               \
      Allocate 0=       \ try to get memory
      if                \ ok
       to base          \ pointer to base
       to size          \ size in bytes
      else 
      Abort" Mem Alloc fail"
      Then
;

: CEllBuffer::GetAt     \ n -- n
( *G returns the value at nth element                       )
            CELLS base + @ 
;

: cellBuffer::SetAt     \ n m --
( *G sets the mth element to n                              )
            CELLS base + ! 
;

: CELLbuffer::Resize
            CELLS Resize
;

