\ CRECT.FTH - rectangle class for CIAO

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeltd.demon.co.uk
     tech-support@mpeltd.demon.co.uk
web: www.mpeltd.demon.co.uk

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691
))

( *> classlib                                                           )
( *S CRECT - Rect Class                                                 )
( **                                                                    )
( *P This is a class version of the RECT structure. The CRECT class is	)
( ** publicly derived from RECT with methods and operators.		)
( *E class CRect : public Rect						)
( ** public:							            )
( **                    meth:   Width				      )
( **                    meth:   Height				      )
( **                    meth:   SetXYWH				      )
( **                    meth:   SetLPRECT			            )
( **                    meth:   dump				      )
( **    ->              oper:   SetLPRect			            )
( **    xywh->          oper:   SetXYWH				      )
( **    lprect->        oper:   SetLPRECT			            )
( **    cout<<          oper:   dump				      )

class CRect : public Rect
public:
                        meth:   Width
                        meth:   Height
				meth:   TopLeft
				meth:   BottomRight
				meth:   CenterPoint
				meth:   IsRectEmpty
				meth:   IsRectNull
				meth:   SetRectEmpty
				meth:   InflateRect
				meth:   DeflateRect
                        meth:   SetXYWH
                        meth:   SetLPRECT
				meth:   SetTop
				meth:   SetLeft
				meth:   SetBottom
				meth:   SetRight
                        meth:   dump
				meth:   PtInRect
				meth:   XYPtInRect
				meth:   NormalizeRect
				Meth:   OffsetRect

        ->              oper:   SetLPRect
        xywh->          oper:   SetXYWH
        lprect->        oper:   SetLPRECT
        cout<<          oper:   dump
end-class

: CRect::SetLPRECT      \ *rect --
  >r
  r@ (rect).left to left
  r@ (rect).top  to top
  r@ (rect).right to right
  r> (rect).bottom to bottom
;

: CRect::SetXYWH        \ x y w h --
  2over
  to top
  to left
  rot + to bottom
  + to right
;

: CRect::Width          \ -- n
  right left -
;

: CRect::Height         \ -- n
  bottom top -
;

: CRect::dump           \ --
  cr ." Rectangle left  (X)     $" left .
  cr ."           top   (Y)     $" top .
  cr ."           right         $" right .
  cr ."           bottom        $" bottom .
;


: CRect::TopLeft		\ -- x y
	Left Top 
;

: CRect::BottomRight	\ -- x y
	Right Bottom 
;

: CRect::CenterPoint	\ -- x y
	Right Left + 2 /
	Bottom Top + 2 /
;

: CRect::IsRectEmpty	\ -- f
	right left - bottom top - And 0=
;

: CRect::IsRectNull	\ -- f
	 Left Top - Right Bottom - And 0=
;

: CRect::SetRectEmpty	\ --
	0 to Top
	0 to Right
	0 to Left
	0 to Bottom
;

: CRect::InflateRect	\ x y --
	{ x y }
	Top y - to Top
	Bottom y + to Bottom
	Left x - to Left
	Right x + to Right
;

: CRect::DeflateRect	\ x y --
	{ x y }
	Top y + to Top
	Bottom y - to Bottom
	Left x + to Left
	Right x - to Right
;

: CRect::NormalizeRect
	Top Bottom >
	If
	 Bottom Top to Bottom To Top
	Then
	Left Right >
	If
	 Right Left to Right to Left
	Then
;

: Crect::OffsetRect	\ x y --
	{ x y }
	Top y + to Top
	Left x + to Left
	Bottom y + to Bottom
	Right x + to Right
;


: CRect::SetTop		\ n -- 
	To Top
;

: CRect::SetLeft		\ n -- 
	To Left
;

: CRect::SetBottom	\ n -- 
	To Bottom
;

: CRect::SetRight		\ n -- 
	To Right
;

: CRect::PtInRect		\ point* -- f
		{ CP }
		CP (CPoint).x Left >=
		CP (CPoint).x Right < And
		CP (CPoint).y Top >=
		CP (CPoint).y Bottom < And
		And
;

: CRect::XYPtInRect    \ x y -- ff
            { x y }
            x Left >=
            x Right < And
            y Top >=
            y Bottom < And
            And
;
            
( *> ### )

