\ **********************
\ TerminalBlock
\ **********************

Class CTerminalBlock : public CObject

public:

      CBox    TextBox
      CCircle TextTerminal
      CLine   TopLine
      CLine   MiddleLine
      CPoint  temp
      CPoint  LinkOut
      CPoint  LinkIn
      CRect   BoundingRect
      CString CommentText1
      CString CommentText2
      CString CommentText3
      CString LogicText
      CList   Inputs
      
      int Parent
      int inputs

      15 Buffer: FileBuff
      
      Meth: Create
      Meth: Draw
      Meth: DrawBoundingBox
      Meth: SetBoxText
      Meth: SetTerminalText 
      Meth: GetBoxText
      Meth: GetTerminalText 
      Meth: AddInput
      Meth: Move 
      Meth: Print
      Meth: InFindRect  
      Meth: SetBoxText
      Meth: SetTerminalText
      Meth: GetBoxText
      Meth: GetTerminalText
      Meth: SetTextOn
      Meth: SetTextOff 
      Meth: GetInputs
      Meth: GetInput 
      Meth: RemoveInput
      Meth: GetLinkOut
      Meth: GetLinkIn   
      Meth: SetParent
      Meth: GetParent 
      Meth: Save 
      Meth: GetTop
      Meth: GetLeft
      Meth: GetBottom
      Meth: GetRight   
End-Class



: CTerminalBlock::SetBoxText       \ z$ n -- 
      case
      1 of CommentText1 (CString).SetLPCTSTR endof
      2 of CommentText2 (CString).SetLPCTSTR endof
      3 of CommentText3 (CString).SetLPCTSTR endof
      endcase
;

: CTerminalBlock::SetTerminalText       \ z$ -- 
      LogicText (CString).SetLPCTSTR
;

: CTerminalBlock::GetBoxText       \ n -- z$
      case
      1 of CommentText1 (CString).GetLPCTSTR endof
      2 of CommentText2 (CString).GetLPCTSTR endof
      3 of CommentText3 (CString).GetLPCTSTR endof
      endcase 
;

: CTerminalBlock::GetTerminalText       \  -- z$
      LogicText (CString).GetLPCTSTR
;

: CTerminalBlock::SetTextOn               \  --
      TRUE to DrawText
;

: CTerminalBlock::SetTextOff               \  --
      FALSE to DrawText
;


: CTerminalBlock::Create       \ *CPoint -- 
      { *Point | id }
      NULL to Parent
      *Point LinkIn (CPoint).To
      \ create the top line
      *Point (CPoint).X *Point (CPoint).Y  *Point (CPoint).X *Point (CPoint).Y 10 + TopLine (CLine).CreateLine

    
      \ create the text box
      *Point (CPoint).GetXY Swap 50 - swap 10 + 100 40 BoundingRect (CRect).SetXYWH
      BoundingRect TextBox (CBox).CreateBox  
      

      \ create the middle line
      *Point (CPoint).X *Point (CPoint).Y 50 + *Point (CPoint).X *Point (CPoint).Y 60 + MiddleLine (CLine).CreateLine  
      
      \ create the circle
      *Point (CPoint).GetXY Swap 30 - swap 60 + 60 60 BoundingRect (CRect).SetXYWH
      BoundingRect TextTerminal (CCircle).CreateCircle   
      
      
      
      TextBox (CBox).GetTopLeft drop BoundingRect (CRect).SetLeft
      TopLine (CLine).GetStart (CPoint).Y BoundingRect (CRect).SetTop
      TextBox (CBox).GetBottomRight drop  BoundingRect (CRect).SetRight
      TextTerminal (CCircle).GetEnd nip BoundingRect (CRect).SetBottom
      
;

: CTerminalBlock::DrawBoundingBox   \ *DC 
      { *DC }
      Red Pen (CPen).SetColor
      LineWidth Pen (CPen).SetLineSize
      Selected 
      If
       PS_DOT
       Else
        PS_SOLID  
      Then 
      Pen (CPen).SetStyle
      Pen (CPen).MakePen
      *DC Pen (CPen).Select          \ select it      
      *DC BoundingRect (CRect).TopLeft temp ::MoveToEx drop
      *DC BoundingRect (CRect).BottomRight drop BoundingRect (CRect).TopLeft Nip ::LineTo drop
      *DC BoundingRect (CRect).BottomRight ::LineTo drop
      *DC BoundingRect (CRect).TopLeft drop BoundingRect (CRect).BottomRight Nip ::LineTo drop
      *DC BoundingRect (CRect).TopLeft ::LineTo drop 
      *DC BLUE BoundingRect (CRect).CenterPoint DrawBox 
      Pen (CPen).Delete 
;     
 
: CTerminalBlock::Draw      \  DC -- 
      { *DC | Text$ }
      *DC TopLine (CLine).Draw  
      *DC TextBox (CBox).Draw  
      *DC MiddleLine (CLine).Draw     
      *DC TextTerminal (CCircle).Draw
      DrawText
      If
       CommentText1 (CString).IsEmpty 0=
       If
         CommentText1 (CString).GetLPCTSTR to Text$
         *DC TextBox (CBox).GetCenter Swap Text$ zcount nip Chwidth * 2 / - swap 19 - Text$ zcount TextOut Drop
       Then
       
       CommentText2 (CString).IsEmpty 0=
       If
         CommentText2 (CString).GetLPCTSTR to Text$
         *DC TextBox (CBox).GetCenter Swap Text$ zcount nip Chwidth * 2 / - swap 7 - Text$ zcount TextOut Drop
       Then       
       
       CommentText3 (CString).IsEmpty 0=
       If
         CommentText3 (CString).GetLPCTSTR to Text$
         *DC TextBox (CBox).GetCenter Swap Text$ zcount nip Chwidth * 2 / - swap 5 + Text$ zcount TextOut Drop
       Then       
       
       
       
       LogicText (CString).IsEmpty 0=
       If 
         LogicText (CString).GetLPCTSTR to Text$
         *DC TextTerminal (CCircle).GetCenter Swap Text$ zcount nip Chwidth * 2 / - swap 4 - Text$ zcount TextOut Drop
       Then
      Then
      Selected
      If
       *DC DrawBoundingBox
      Then
;

 
: CTerminalBlock::Move            \ *DC *CPoint
      { *DC *Point }
      *DC *Point TopLine (CLine).move
      *DC *Point TextBox (CBox).moveBox
      *DC *Point middleLine (CLine).move
      *DC *Point TextTerminal (CCircle).moveCircle
      *Point (CPoint).GetXY BoundingRect (CRect).OffsetRect
      *Point LinkIn (CPoint).+=
;
 

: CTerminalBlock::Print
      Cr ." And Entity"
      Cr TopLine (CLine).Print
      cr TextBox (CBox).Print
      Cr middleline (CLine).Print
      cr TextTerminal (CCircle).Print    
;


: CTerminalBlock::InFindRect            \ *Rect -- f
      { *Rect }
      BoundingRect (CRect).TopLeft *Rect (CRect).XYPtInRect
      BoundingRect (CRect).BottomRight *Rect (CRect).XYPtInRect And
;  

: CTerminalBlock::AddInput
      inputs (CList).Add
;

: CTerminalBlock::GetInputs        \ -- n
      Inputs (CList).Items
;

: CTerminalBlock::RemoveInput        \ *Item --
      { *Item | *List *Obj }
      Inputs (CList).Items 0 >
      If
      CList Dnew to *List          \ make a new list
      20 *List (CList).init        \ initalize it 
      Inputs (CList).Items 0
      ?Do
        i Inputs (CList).FetchItem to *Obj
        *Item *Obj <>
        If
         *Obj *List (CList).add 
        Then
       Loop
       Inputs (CList).Free
       Inputs delete                  \ get rid
       *List to Inputs
       Then
;



: CTerminalBlock::GetInput         \ n -- n
      Inputs (CList).FetchItem
;
: CTerminalBlock::GetLinkIn  \ -- x y
      LinkIn (CPoint).GetXY
;

: CTerminalBlock::GetLinkOut
      LinkOut (CPoint).GetXY
;

: CTerminalBlock::SetParent  \ n --
      To Parent
;

: CTerminalBlock::GetParent
      Parent
;

: CTerminalBlock::Save
      ID_TERMINALBLOCK         FileBuff ! FileBuff CELL WriteFile ior If z" TerminalBlocK Failed to write type" ErrorBox.Msg ErrorBox.ShowMsgBox Then 
      LinkIn (CPoint).X        FileBuff ! FileBuff CELL WriteFile  ior If z" TerminalBlocK Failed to write X" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      LinkIn (CPoint).Y        FileBuff ! FileBuff CELL WriteFile ior If z" TerminalBlocK Failed to write Y" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      FileBuff 20 Erase
      CommentText1 (CString).IsEmpty 0=
      If
       CommentText1 (CString).GetLPCTSTR  zcount FileBuff Swap ::move
      Then
      FileBuff 20 WriteFile ior If z" TerminalBlocK Failed to write Text1" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      
      FileBuff 20 Erase
      CommentText2 (CString).IsEmpty 0=
      If
       CommentText2 (CString).GetLPCTSTR  zcount FileBuff Swap ::move
      Then
      FileBuff 20 WriteFile ior If z" TerminalBlocK Failed to write Text2" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      
      FileBuff 20 Erase
      CommentText3 (CString).IsEmpty 0=
      If
       CommentText3 (CString).GetLPCTSTR  zcount FileBuff Swap ::move
      Then
      FileBuff 20 WriteFile ior If z" TerminalBlocK Failed to write Text3" ErrorBox.Msg ErrorBox.ShowMsgBox Then           
      
      FileBuff 20 Erase
       LogicText   (CString).IsEmpty 0=
       If
        LogicText   (CString).GetLPCTSTR  zcount FileBuff Swap ::move
       Then
      FileBuff 20 WriteFile  ior If z" TerminalBlocK Failed to write Text2" ErrorBox.Msg ErrorBox.ShowMsgBox Then     
      Parent                  FileBuff ! FileBuff CELL WriteFile ior If z" TerminalBlocK Failed to write Parent" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      NULL                    FileBuff ! FileBuff CELL WriteFile   \ no link outs from terminals
;


: CTerminalBlock::GetTop        \ -- top
     BoundingRect (CRect).TopLeft Nip
;

: CTerminalBlock::GetLeft        \ -- left
     BoundingRect (CRect).TopLeft Drop
;


: CTerminalBlock::GetBottom    \ -- bottom
     BoundingRect (CRect).BottomRight nip
;

: CTerminalBlock::GetRight   \ -- right 
     BoundingRect (CRect).BottomRight drop
;  