0 [IF]
From mhx@iae.nl Tue Jul 25 21:11:21 2006
Newsgroups: comp.lang.forth
Subject: ICFP Contest - Sandmark in VFX
From: mhx@iae.nl (Marcel Hendrix)
Date: Tue, 25 Jul 2006 20:11:21 GMT

  [icfp-discuss] Who's got the fastest sandmark?
	Li, Peng lipeng at cis.upenn.edu 
	Mon Jul 24 15:38:14 EDT 2006 
	--------------------------------------------------------------------------------
	I got the following time on a Intel(R) Xeon(TM) CPU 3.20GHz. Source
	code is attached. Feel free to compile and compare. Have fun!

	real    0m55.453s
	user    0m55.427s
	sys     0m0.004s


All tests on:
  2.8 GHz P4, 512Mb RAM, Windows XP SP1, 4Gb page file

VFXForth v4.0 with HeapAlloc and LFH
=============
176640 ms - build 2203, Loads forced, ORIGINAL? set to 0
198515 ms - build 2203, Loads forced
209610 ms - build 2203, Loads not forced, indexing and disambiguation changes
225469 ms - build 2116, revamped shuffle
227515 ms - build 2106, no CASE alignment
230719 ms - build 2095
231578 ms - v3.x before v4.x optimiser update

Heap impact on v4.x,  Loads forced, ORIGINAL? set to 0
===================
176547 ms - build 2276, relocated some vars, optimiser is aware of
                        ALLOCATE and friends.
181547 ms - build 2255, HeapAlloc and LFH, no IDATA vars
200422 ms - build 2254, C library with calloc() and free().
176640 ms - build 2253, HeapAlloc and LFH in SandMark

Heap impact on v3.x
===================
THROWs    - VirtualAlloc
273718 ms - GlobalAlloc
266266 ms - Basic HeapAlloc
231578 ms - HeapAlloc with LFH


iForth 2.1.1662
===============
208773 ms

[THEN]


\ *******************
\ Select coding style
\ *******************
\ The original code accesses locals more often than is strictly
\ necessary. A more stack-oriented approach can be compiled by
\ setting ORIGINAL? to 0.

0 constant Original?


\ *************
\ Select system
\ *************

1 constant VFXsys	\ VFX Forth v3/4
2 constant iF2sys	\ iForth 2.x
3 constant SFsys	\ SwiftForth 3.0

  VFXsys constant ForthSys
\ iF2sys constant ForthSys
\ SFsys constant ForthSys


\ *****************
\ VFX Forth harness
\ *****************

VFXsys ForthSys = [if]

[defined] +idata [if]
  +idata	\ enable P4 data options
  variable zzz	\ preallocate first IDATA buffer
[then]
#0 LoopAlignment
[defined] +MustLoad [if] +MustLoad [then]

[undefined] timer-reset [if]
0 VALUE _time_
: timer-reset gettickcount TO _time_ ;
: .elapsed    gettickcount _time_ - . ." ms elapsed."  ;
[then]

0 constant diags?	\ -- n ; true to compile diagnostic code

0 constant UseBaseAlloc	\ use implementation heap
1 constant UseVirtAlloc	\ use VirtualAlloc and friends
2 constant UseHeapAlloc	\ use HeapAlloc and friends

UseBaseAlloc constant MemType	\ which heap type to use

#4 Mb constant /heap	\ how much heap to preallocate

: .HeapType	\ --
  cr ." Memory allocation strategy: "
  case MemType
    UseBaseAlloc of  ." Implementation default"  endof
    UseVirtAlloc of  ." VirtualAlloc and friends"  endof
    UseHeapAlloc of  ." HeapAlloc and friends"  endof
      ." Unknown"
  endcase
  cr
;
.HeapType


\ ===========
\ Diagnostics
\ ===========

diags? [if]
cr .( compiling diagnostics )

variable #mem		\ memory in use
variable #maxMem	\ maximum memory used
variable #vallocs
variable #vfrees
variable #vallocmin
variable #vallocmax

: initStats	\ --
\ *G Initialise the statistics.
  #Mem off  #maxMem off
  #vallocs off  #vfrees off
  $7FFFFFFF #vallocmin !
  0 #vallocmax !
;
initstats

: .thou		\ d -- d'
  # # # [char] , hold
;

: .K		\ n --
  0 <# .thou #s #> type space
;

: .M		\ n --
  0 <#  .thou .thou #s  #> type space
;

: .G		\ n --
  0 <#  .thou .thou .thou #s  #> type space
;

: .gen		\ n --
  dup #1000000000 1- u>
  if  .G  exit  endif
  dup #1000000 1- u>
  if  .M  exit  endif
  dup #1000 1- u>
  if  .K  exit  endif
  u.
;

: .Vheap	\ --
  cr ." Memory in use  " #Mem @ .gen
  cr ." Max mem used   " #maxMem @ .gen
  cr ." #Allocations   " #vallocs @ .gen
  cr ." #frees         " #vfrees @ .gen
  cr ." Min allocation " #vallocmin @ .gen
  cr ." Max allocation " #vallocmax @ .gen
;

: +Mem		\ size --
\ *G Update the amount of memory in use and the maximum
\ ** allocation required.
  dup #VallocMin @ min #VallocMin !
  dup #VallocMax @ max #VallocMax !
  #Mem +!  #MaxMem @ #Mem @ max #MaxMem !
  #vallocs incr
;

: -Ptr		\ ptr --
\ *G Free up the statistics. Assume the implementation has
\ ** the block length in cells in the first cell.
  @ cells #Mem -!  #vfrees incr
;

[then]	\ diags?


\ ==================
\ Using VirtualAlloc
\ ==================

UseVirtAlloc MemType = [if]

\ runs out - called 80,000+ times

\ LPVOID VirtualAlloc(lpAddress, dwSize, dwAllocationType, dwProtect)
Extern: void * PASCAL VirtualAlloc( void *, dword, dword, dword );
\ BOOL VirtualFree(lpAddress, dwSize, dwFreeType)
Extern: BOOL PASCAL VirtualFree( void *, dword, dword );

variable #vallocs
variable #vfrees

: Vallocate	\ size -- ptr ior
[ diags? ] [if]
  dup >r  dup +Mem
[then]
  NULL
  swap
  MEM_COMMIT ( MEM_RESERVE or )
  ( PAGE_EXECUTE_READWRITE ) PAGE_READWRITE
  VirtualAlloc dup NULL =
[ diags? ] [if]
  dup if
    cr ." Error in VALLOCATE " r@ . ." bytes"
  endif
  r> drop
[then]
;

: Vfree		\ ptr -- ior
[ diags? ] [if]
  dup -Ptr
[then]
  0 MEM_RELEASE VirtualFree 0=
[ diags? ] [if]
  dup if
    cr ." error in VFREE"
  endif
[then]
;

: Vcreate	\ --
;

: Vdestroy	\ --
;

[then]


\ ====================
\ Using heap functions
\ ====================

UseHeapAlloc MemType = [if]

Extern: HANDLE PASCAL HeapCreate(
  DWORD flOptions, dword dwInitialSize, dword dwMaximumSize
);
Extern: BOOL PASCAL HeapDestroy(
  HANDLE hHeap
);
Extern: void * PASCAL HeapAlloc(
  HANDLE hHeap, DWORD dwFlags, dword dwBytes
);
Extern: void * PASCAL HeapReAlloc(
  HANDLE hHeap, DWORD dwFlags, void * lpMem, dword dwBytes
);
Extern: BOOL PASCAL HeapFree(
  HANDLE hHeap, DWORD dwFlags, VOID * lpMem
);
Extern BOOL PASCAL HeapSetInformation(
  HANDLE HeapHandle,
  dword HeapInformationClass,
  void * HeapInformation,
  DWORD HeapInformationLength
);
Extern: HANDLE PASCAL GetProcessHeap( void );
Extern: DWORD PASCAL HeapSize(
  HANDLE hHeap,
  DWORD dwFlags,
  void * lpMem
);

: SetLFH	\ hHeap -- res
  { | hvar1[ cell ] -- }
  2 hvar1[ !
  0 hvar1[ cell HeapSetInformation
;

0 value hHeap	\ -- hHeap

: Vcreate	\ --
  0 ( 0x00040000 ) ( HEAP_CREATE_ENABLE_EXECUTE )
  /heap 0 HeapCreate
  dup to hHeap  NULL = if
    cr ." Error in VCREATE" abort
  endif
\ slows down with LFH?
  hHeap SetLFH 0= if
    cr ." Error in SetLFH" abort
  endif
;

: Vdestroy	\ --
  hHeap HeapDestroy drop
;

: Vallocate	\ size -- ptr ior
[ diags? ] [if]
  dup >r  dup +Mem
[then]
  hHeap HEAP_ZERO_MEMORY rot
  HeapAlloc dup NULL =
[ diags? ] [if]
  dup if
    cr ." Error in VALLOCATE " r@ . ." bytes"
  endif
  r> drop
[then]
;

: Vfree		\ ptr -- ior
[ diags? ] [if]
  dup -Ptr
[then]
  hHeap NULL rot HeapFree 0=
[ diags? ] [if]
  dup if
    cr ." Error in VFREE"
  endif
[then]
;

[then]


\ ============================
\ Using implementation default
\ ============================

UseBaseAlloc MemType = [if]

: Vallocate	\ size -- ptr ior
[ diags? ] [if]
  dup >r  dup +Mem
[then]
  allocate
[ diags? ] [if]
  dup if
    cr ." Error in VALLOCATE " r@ . ." bytes"
  endif
  r> drop
[then]
;

: Vfree		\ ptr -- ior
[ diags? ] [if]
  dup -Ptr
[then]
  free
[ diags? ] [if]
  dup if
    cr ." Error in VFREE"
  endif
[then]
;

: Vcreate	\ --
;

: Vdestroy	\ --
;

[then]

: xcr	cr emptyidle  ;
\ Huh? takes about three seconds off the run time!

[then]	\ VFXsys


\ ******************
\ iForth 2.x harness
\ ******************
\ Contributed by Marcel Hendrix, 14 Aug 2006

iF2sys ForthSys = [if]	\ iForth 2.x

1 [if]
	NEEDS -dynlink

	PRIVATES

#22 2^x =: /heap 	PRIVATE -- 4 Mbytes
8 =: HEAP_ZERO_MEMORY	PRIVATE
0 VALUE hHeap		PRIVATE

LIBRARY kernel32

3 IMPORT HeapCreate
1 IMPORT HeapDestroy
3 IMPORT HeapAlloc
4 IMPORT HeapRealloc
3 IMPORT HeapFree
4 IMPORT HeapSetInformation

  	.LIBRARIES
  	.FUNCTIONS

-- 2 : set Low Fragmentation Heap
: SetLFH ( hHeap -- )
	2 LOCAL HeapInformation
	0  'OF HeapInformation  =CELL  
	HeapSetInformation 0= ABORT" SetLFH :: error" ; PRIVATE

: VCREATE   ( -- )
  0 /heap 0 HeapCreate DUP TO hHeap 0= ABORT" VCREATE :: error"
  hHeap SetLFH ;
: VDESTROY  ( -- )
  hHeap HeapDestroy 0= ABORT" VDESTROY :: error" ;
: VALLOCATE ( size -- addr ior )
  hHeap HEAP_ZERO_MEMORY ROT HeapAlloc DUP 0= ;
: VFREE	    ( addr -- ior )
  hHeap 0 ROT HeapFree 0= ;

	DEPRIVE
[then]

[then]


\ **********************
\ SwiftForth 3.x harness
\ **********************

SFsys ForthSys = [if]	\ iForth 2.x

: endif		postpone then  ; immediate

[undefined] timer-reset [if]
0 VALUE _time_
: timer-reset Counter TO _time_ ;
: .elapsed    Counter _time_ - . ." ms elapsed."  ;
[then]

[then]


\ ************************************
\ Use defaults if not already provided
\ ************************************

\ These words are to allow heap strategies to be tested
[undefined] vallocate [if]
: vallocate allocate ;
: vfree free ;
: vcreate  ;
: vdestroy  ;
[then]

\ This word allows Windows system to pump the message loop.
[undefined] xcr [if]
: xcr  cr  ;
[then]

\ These words display heap statistics for VFX Forth
[undefined] .Vheap [if]
: .Vheap  ;
: initStats  ;
[then]

[undefined] .HeapType [if]
: .HeapType  ;
[then]

\ These words are for array indexing.
[undefined] cell[] [if]
: CELL[]	CELLS + ;
[then]

[undefined] []cell [if]
: []CELL	SWAP  CELLS + ;
[then]


\ **********************
\ Sandmark portable code
\ **********************

0 VALUE codex
[defined] buffer: [if]
  8 cells buffer: regs
[else]
  CREATE regs  0 , 0 , 0 , 0 ,   0 , 0 , 0 , 0 , 
[then]

: my_alloc   ( size -- addr )
  DUP 1+ CELLS VALLOCATE THROW DUP >R ! R> CELL+
\  DUP 1+ CELLS VALLOCATE THROW tuck ! CELL+
;
: my_free    ( addr -- )
  CELL- VFREE THROW 
;
: my_getsize ( addr -- )
  CELL- @
;

: regs@		regs []CELL @ ;
: regs!		regs []CELL ! ; 

: run ( -- )
  0 0  0 0 0  0 0 LOCALS| pc seg a b c w opcode |
  codex TO seg 
  0 TO pc
  BEGIN
[ Original? ] [if]
    seg pc CELL[] @ TO w  1 pc + TO pc
    w #28 RSHIFT        TO opcode
    w   6 RSHIFT  7 AND TO a
    w   3 RSHIFT  7 AND TO b
    w   7 AND TO c
    CASE opcode
[else]
    seg pc CELL[] @ dup TO w   1 pc + TO pc
    dup   6 RSHIFT  7 AND TO a
    dup   3 RSHIFT  7 AND TO b
    dup             7 AND TO c
        #28 RSHIFT  dup  TO opcode
    CASE
[then]
       0 OF  c regs@ IF  b regs@  a regs!  ENDIF  ENDOF
       1 OF  b regs@ IF
               c regs@  b regs@  []CELL @  a regs!
             ELSE
               c regs@  seg []CELL @  a regs!
             ENDIF
         ENDOF
       2 OF  a regs@ IF
               c regs@  b regs@  a regs@ []CELL !
             ELSE  c regs@  b regs@  seg []CELL !
             ENDIF
         ENDOF
       3 OF  b regs@  c regs@ +  a regs!  ENDOF
       4 OF  b regs@  c regs@ UM* DROP	a regs!  ENDOF
       5 OF  b regs@ 0  c regs@ UM/MOD NIP  a regs!  ENDOF
       6 OF  b regs@  c regs@ AND INVERT  a regs!  ENDOF
       7 OF  EXIT  ENDOF
       8 OF  c regs@ my_alloc b regs!  ENDOF
       9 OF  c regs@ my_free  ENDOF
      10 OF  c regs@ DUP #10 =
             if  drop xcr  else  emit  endif
         ENDOF
      11 OF  EKEY DUP 4 =
             IF  DROP -1  ENDIF
             c regs!
         ENDOF
      12 OF  b regs@ IF
               seg codex <>
               IF  seg my_free ENDIF
               b regs@ my_getsize DUP my_alloc TO seg >R
               b regs@  seg  R> CELLS MOVE
             ENDIF
             c regs@ TO pc
         ENDOF
      13 OF  w 7 LSHIFT 7 RSHIFT ( dat)
             w #25 RSHIFT 7 AND regs!
         ENDOF
    ENDCASE
  AGAIN ;
\ ' run here disasm/ft

: (main) ( -- )
  0 0 LOCALS| size handle |
  S" sandmark-be.umz" R/O BIN OPEN-FILE THROW TO handle
  handle FILE-SIZE  THROW DROP TO size 
  size CELL+ ALLOCATE THROW  size OVER ! CELL+ TO codex
  codex size handle READ-FILE THROW DROP 
  handle CLOSE-FILE THROW 
  TIMER-RESET ['] run catch CR .ELAPSED
  throw
;

: main		\ --
  .HeapType Vcreate initStats
  ['] (main) catch
  cr ." Finished "
  if  ." with "  else ." without "  endif
  ." THROW"
  Vdestroy
  .Vheap
;

CR .( cmachine; type: main )


\ ****************
\ Conversion tools
\ ****************

0 value infile
0 value outfile
variable indata
variable outdata

: Read4		\ --
  indata 1 cells infile read-file abort" read error" drop
;

: write4	\ --
  outdata 1 cells outfile write-file abort" write error"
;

: swapb4	\ x -- x' ; flip bytes
  dup $FF and	swap 8 rshift swap		\ -- x<<8 out
  8 lshift  over $FF and or  swap 8 rshift swap
  8 lshift  over $FF and or  swap 8 rshift swap
  8 lshift  swap $FF and or
;

: le>be		\ --
  s" sandmark-be.umz" R/W CREATE-FILE throw  to outfile
  s" sandmark.umz" R/O OPEN-FILE throw  to infile
  infile FILE-SIZE THROW DROP
cr ." input file size = " dup .
  0 do
    Read4  indata @ swapb4  outdata !  Write4
  4 +loop
  infile close-file drop
  outfile close-file drop
;

                                             