\ Class testing
\ Version 1.1, 6 Feb 2006
\ Doug Hoffman

DECIMAL

: ?? ( n1 n2 -- ) <> IF cr abort" test failed" THEN ;

  
\ ======================================================================

cr .( TESTING OBJECT CREATION )

 Var x


 99 Put: x  
 Get: x  99 ??
 Var y
 Get: x 1+ Put: y
 Get: y  100 ??

: T1  Get: x ;
 T1  99 ??

\ ======================================================================

cr .( TESTING CLASS )


:Class Point  <Super Object

 Var x
 Var y

 :M Get:  Get: x  Get: y  ;M
 :M Put:  Put: y  Put: x  ;M

 :M Print:  Get: self  SWAP . .  ;M

 :M ClassInit:   1 Put: x  2 Put: y ;M

;Class


 Point p  
 Get: p  2  ??  1 ??
 3 4 Put: p  
 Get: p  4  ??  3 ??


:Class Pixel  <Super Point

 Var color

 :M Put:  ( x y color -- )  Put: color  Put: super  ;M
 :M Get:  Get: super  Get: color  ;M

 :M Print:   Print: super  Print: color  ;M

;Class

 Pixel pix  
 1 2 3 Put: pix  
 Get: pix  3 ?? 2 ?? 1 ??



cr .( TESTING ExecVec )

ExecVec ex
 Exec: ex  
: NINE 9 ;
' NINE Put: ex
 Exec: ex  9  ??



\ ======================================================================

cr .( TESTING LATE BINDING )

:Class C1  <Super Object  <General

 :M Draw:   1 ;M

 :M Print:  3 0 DO  Draw: [ self ]  LOOP ;M

;Class

 C1 o1  
 Print: o1  1 1 1 ?? ?? ??

:Class C2   <Super C1

 :M Draw:   2  ;M

;Class


 C2 o2  
 Print: o2  2 2 2  ?? ?? ??


 o2 print: ** 2 2 2  ?? ?? ?? \ object message syntax interpretted

 : t51 o2 print: ** ; t51 2 2 2  ?? ?? ?? \ object message syntax compiled






\ ======================================================================

cr .( TESTING OBJECT POINTER )

:Class C3  <Super Object

 C1 p1
 C2 p2
 Var pp1  \ pointer to p1
 Var pp2

 :M ClassInit:  Addr: p1 Put: pp1   Addr: p2 Put: pp2 ;M
 :M Print:      Print: [ Get: pp1 ]  Print: [ Get: pp2 ]  ;M
 :M Switch:     Get: pp1 Get: pp2   Put: pp1 Put: pp2 ;M
;Class

 C3 o3  
 Print: o3 2 2 2 ?? ?? ??  1 1 1 ?? ?? ??
 Switch: o3  
 Print: o3  1 1 1  ?? ?? ??    2 2 2 ?? ?? ??



\ ======================================================================

cr .( TESTING ARRAY  )

10 Array a1
 6 2 To: a1  
 2 At: a1  6  ??
 99 Fill: a1  
 5 At: a1  99  ??

:Class C4  <Super Object

    10 Array a1

    :M At:  ( index -- value )  At: a1  ;M
    :M To:  ( value index -- )  To: a1  ;M
    :M Fill:  Fill: a1  ;M

;Class

 C4 o4  
 6 2 To: o4  
 2 At: o4  6  ??
 99 Fill: o4  
 5 At: o4  99 ??


30 array o5
99 fill: o5
: t50 20 o5 at: array ; t50 99 ??
20 o5 at: array   99 ??




cr .( TESTING X-ARRAY )

 10 X-Array xa  
: ONE 111 ;
: TWO 222 ;
: THREE 333 ;
 ' ONE 1 To: xa  
 ' TWO 2 To: xa  
 : T3 ['] THREE 3 To: xa ; T3  
 1 Exec: xa  111  ??
 2 Exec: xa  222   ??
 3 Exec: xa  333   ??
 4 Exec: xa 



\ ======================================================================

HAVE ALLOCATE [IF]
cr .( TESTING HEAP OBJECTS )

0 VALUE POBJ

 Heap> Point TO POBJ  
 Get: [ POBJ ]   2 ?? 1 ??
 3 4 Put: [ POBJ ]  
 Get: [ POBJ ]   4 ?? 3 ??
 POBJ Get: Point   4  ?? 3 ?? ( class binding )
 POBJ <release

 10 Heap> Array TO POBJ  
 6 2 To: [ POBJ ]  
 2 At: [ POBJ ]  6  ??
 99 Fill: [ POBJ ]  
 5 At: [ POBJ ]  99 ??
 POBJ <release  

 : T10  10 Heap> Array TO POBJ ; T10  
 : T11  6 2 To: [ POBJ ] ; T11  
 : T12  2 At: [ POBJ ] ; T12  6  ??
 : T13  99 Fill: [ POBJ ] ; T13  
 : T14  5 At: [ POBJ ] ; T14  99 ??
 : T15  5 POBJ At: Array ; T15  99 ??  ( class binding ) 
 : T16  POBJ <release ; T16

[THEN]

\ ======================================================================


 
 
cr .( TESTING CASCADED MESSAGES )
 
var myMarvelousObject 

25 put: myMarvelousObject get: |  25 ??

: t52 34 put: myMarvelousObject  2 +: |  get: | ; t52 36 ??

var x1  33 put: x1
7 x1 +: ** get: | 40 ??


cr .( TESTING TICKED MESSAGES )

' get: value myMsg-xt
' myMarvelousObject value myObj-xt

myMsg-xt myObj-xt exm  36 ??

: t53 3 ['] +: myObj-xt exm
   myMsg-xt myObj-xt exm ; t53 39 ??



var x2 45 put: x2

' get: ' x2 putMparms


getMparms exm   45 ??


cr .( TESTING PRIVATE and PUBLIC METHODS )

:class pp <super var
 :m put1: put: self ;m
private 
 :m priv: put: self ;m 
public
 :m put3: priv: self ;m 
;class

:class p4 <super pp
 :m goo: priv: self ;m  \ OK to call priv: because p4 is a subclass of pp
;class

p4 tt
100 goo: tt
get: tt 100 ??

\ 101 priv: tt  \ should fail with error message

:class p5 <super p4
 :m go: priv: self ;m  \ OK to call priv: because p5 descended from pp
;class

p5 tt2
55 go: tt2 get: tt2 55 ??

pp p1
88 put1: p1
get: p1 88 ??

\ 99 priv: p1  \ should fail with error message

99 put3: p1 
get: p1 99 ??

\ :class ppp <super var
\  :m put: priv: p1 ;m    \ should not compile!!
\ ;class

have macforth.picture [IF]
cr .( TESTING MESSAGES to VALUEs and LOCALs )

0 value myValue
x to myValue
22 put: x

get: myValue 22 ??

: t54 2 +: myValue  get: | ; t54 24 ??  \ compiled message to value, with cascade

: t55  ( ^obj -- n )
  locals| myLocal |
  3 +: myLocal get: | ;  x t55  27 ??  \ message to local variable, with cascade

[THEN]

cr .( TESTING ORDERED-COL )

10 ordered-col oc
45 add: oc
66 add: oc
55 add: oc

size: oc  3 ??

0 at: oc 45 ??

66 indexof: oc   -1  ??  1 ??
1 remove: oc
size: oc  2 ??

cr .( TESTING 2ARRAY )

3 3 dimension 2array myArray

12 0 0 to: myArray
33 0 1 to: |
12345678 1 0 to: |

0 0 at: | 12 ??

0 1 at: | 33 ??

1 0 at: | 12345678 ??

print: |


cr .( TESTING 2ARRAYGEN ) 

2arrayGen gg
6 new: gg

s" teststring" 0 0 to: gg

s" test2" 0 1 to: gg
s" test3" 1 0 to: gg

print: gg

CR .( Class tests complete )


