\ GraphicsTest.fth - Demo of graphics for GTK in the Borland style.

((
Copyright (c) 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       901 313 4312 (North American access number to UK office)

"Gdk-pixbuf currently supports PNG, XPM, JPEG, TIFF, PNM, RAS,
BMP, and even the patented GIF format"

To do
=====

Change history
==============
20110914 SFP003 First release.
20110909 RML003 Fixed shared graphics context problem.
20110909 SFP002 Fixed redraw problem with more callbacks.
20110821 RML001 First delivery
))

only forth definitions
decimal


\ ===============
\ *! graphicstest
\ *T Demo of GTK/GDK Graphics
\ ===============

0 value MainBuilder	\ -- x ; main GtkBuilder object
0 value window1		\ -- x ; main window object
0 value MainAbout	\ -- x ; main About dialog object
0 value DrawingArea1	\ -- GtkWidget

\ Some signal handlers
2 0 CCBproc: on_save1_activate
  2drop
;

3 1 CCBproc: on_delete1_activate
\ cr ." delete event called" cr .s
  2drop drop  0				\ 0 to destroy
;

2 0 CCBproc: on_cut1_activate
  2drop
;

2 0 CCBproc: on_about1_activate	\ *widget *user -- ; -- entry
\ *G Callback to run the About dialog.
  2drop  MainAbout runDlg drop
;

2 0 CCBproc: on_aboutdialog1_close	\ *widget *user -- ; -- entry
\ .s ." on_aboutdialog1_close_fn" cr
  2drop
;

2 0 CCBproc: on_open1_activate
  2drop
;

2 0 CCBproc: on_paste1_activate
  2drop
;

2 0 CCBproc: on_new1_activate
  2drop
;

2 0 CCBproc: on_save_as1_activate
  2drop
;

2 0 CCBproc: on_copy1_activate
  2drop
;

2 0 CCBproc: on_window1_destroy	\ *widget *user -- ; -- entry
  2drop  -gtimer  GtkAppQuit
;

gwin: win1	\ -- addr
\ *G Graphics window structure for the first example.
gwin: win2
\ *G Graphics window structure for the second and third examples.

: showGraphics1	\ --
\ *G Primitive graphics all drawn direct.
  initGTK  +gtimer
  200 100 win1 setupGwin		\ Draw basic boxes
  win1 enable-graphics
  win1 onto  dirty			\ force initial redraw
  black cleardevice
  white  50 circle
  green  200 100 line
;

: showGraphics2	\ --
\ *G Test word to read a Glade Builder XML file and run the GUUI
\ ** it describes.
  initGTK  +gtimer

  z" gdemo2bld.ui" loadBuilderXML
  0= abort" Can't load builder file"
  z" window1" builderObject to window1
  z" drawingarea1" builderObject to DrawingArea1
  z" aboutdialog1" builderObject to MainAbout
  freeBuilder

  window1 gtk_widget_show_all
  DrawingArea1 win2 initGWin
  win2 enable-graphics
  win2 onto  dirty
  black cleardevice
  white  50 circle
  green  200 100 line
;

: showGraphics3	\ --
\ *G Test word to read a Glade Builder XML file and run the
\ ** GUI it describes.
  initGTK  +gtimer			\ start GTK and timer

  z" ./gdemo3bld.ui" loadBuilderXML	\ load GTK builder design
  0= abort" Can't load builder file"
  z" window1" builderObject to window1	\ get handles
  z" drawingarea1" builderObject to DrawingArea1
  z" aboutdialog1" builderObject to MainAbout
  freeBuilder

  window1 gtk_widget_show_all		\ show design
  DrawingArea1 win2 initGWin		\ initialise graphics area
  win2 enable-graphics  win2 onto  dirty
  black cleardevice			\ drawing commands
  white  50 circle
  green  200 100 line
  red 30 30 at  70 30 filled rectangle
  80 70 at  100 40 blue filled ellipse
;


cr .( Type: )
cr .(   ShowGraphics1 )
cr .( to display the simple graphics window. )
cr
cr .( Type: )
cr .(   ShowGraphics2 )
cr .( to display the basic Glade GUI graphics window. )
cr
cr .( Type: )
cr .(   ShowGraphics3 )
cr .( to display the drawn Glade GUI graphics window. )
cr
cr .( Try out graphics commands interactively: )
cr .(   AT FILLED LINE LINETO LINEREL LINERELTO ELLIPSE CIRCLE )
cr .(   RECTANGLE PUTPIXEL CLEARDEVICE RED BLUE etc. )


\ ======
\ *> ###
\ ======
