\ gtkbindings.fth - bind to libgtk2 for GTK-style widgets

((
Copyright (c) 2008, 2011, 2014
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

>From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
20141006 SFP004 Updated documentation.
20110831 SFP003 Converted to MPE house style.
		Removed some O/S dependencies.
20110817 RML002 added "c" to bindings
20080325 VRW001 Initial release

++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Updated for GTK3 and with many corrections and additions
++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Nick Nelson
Micross Electronics Ltd.
Unit 6 Ashburton Industrial Estate
Ross-on-Wye
Herefordshire
HR9 7BW
UK

Phone +44 1989 768080
Email sales@micross.co.uk
Web www.laundryautomation.com

History:
Writing commenced 29/2/16
++++++++++++++++++++++++++++++++++++++++++++++++++++++++
))

[undefined] CCB: [if]
: CCB:		\ #in #out "<name>" -- ; -- a-addr
  callback:  ;
: CCBproc:	\ #in #out "<name>" -- ; -- entry
  CallProc:  ;
[then]

\ =========
\ Libraries
\ =========

\ library: libgtk-x11-2.0.so.0

library: libgtk-3.so.0

library: libgobject-2.0.so.0
library: libglib-2.0.so.0
\ Library: libgdk-x11-2.0.so.0

library: libgdk-3.so

Library: libgdk_pixbuf-2.0.so.0
Library: libpango-1.0.so.0
also  types definitions
: uint  unsigned int  ;
previous definitions


\ ============
\ Extend TYPES
\ ============

also types definitions
: GtkBuilder  void  ;
: GtkWidget   void  ;
: GtkWindow   void  ;
: GdkWindow   void  ;
: GtkTextBuffer void  ;
: GtkTextIter void  ;
: GObject     void  ;
: GError      void  ;
: gchar       char  ;
: gboolean    bool4  ;
: gsize       unsigned int  ;
: guint       unsigned int  ;
: gint        int  ;
: gpointer    void *  ;
: GtkCalender void  ;
: GtkSpinButton void  ;
: GtkComboBoxText void  ;
: GtkEntry    void  ;
: GtkMenuDetachFunc void  ;
: GtkMenu     void  ;
: GtkMessageDialog void  ;
: GtkColorChooser void  ;
previous definitions

  0 CONSTANT GTK_STATE_FLAG_NORMAL
  1 CONSTANT GTK_STATE_FLAG_ACTIVE
  2 CONSTANT GTK_STATE_FLAG_PRELIGHT
  4 CONSTANT GTK_STATE_FLAG_SELECTIVE
  8 CONSTANT GTK_STATE_FLAG_INSENSITIVE
 16 CONSTANT GTK_STATE_FLAG_INCONSISTENT
 32 CONSTANT GTK_STATE_FLAG_FOCUSED
 64 CONSTANT GTK_STATE_FLAG_BACKDROP
128 CONSTANT GTK_STATE_FLAG_DIR_LTR
256 CONSTANT GTK_STATE_FLAG_DIR_RTL

enum GtkOrientation {
                      GTK_ORIENTATION_HORIZONTAL,
                      GTK_ORIENTATION_VERTICAL
                    };

enum GtkShadowType {
                     GTK_SHADOW_NONE
                     GTK_SHADOW_IN
                     GTK_SHADOW_OUT
                     GTK_SHADOW_ETCHED_IN
                     GTK_SHADOW_ETCHED_OUT
                   };

ENUM GtkReliefStyle {
                     GTK_RELIEF_NORMAL
                     GTK_RELIEF_HALF
                     GTK_RELIEF_NONE
                    };

ENUM GtkJustification {
                       GTK_JUSTIFY_LEFT
                       GTK_JUSTIFY_RIGHT
                       GTK_JUSTIFY_CENTER
                       GTK_JUSTIFY_FILL
                      };

ENUM PangoEllipsizeMode {
                         PANGO_ELLIPSIZE_NONE
                         PANGO_ELLIPSIZE_START
                         PANGO_ELLIPSIZE_MIDDLE
                         PANGO_ELLIPSIZE_END
                        };

ENUM PangoWrapMode {
                    PANGO_WRAP_WORD
                    PANGO_WRAP_CHAR
                    PANGO_WRAP_WORD_CHAR
                   };

ENUM GdkEventType {
	GDK_NOTHING
	GDK_DELETE
	GDK_DESTROY
	GDK_EXPOSE
	GDK_MOTION_NOTIFY
	GDK_BUTTON_PRESS
	GDK_2BUTTON_PRESS
	GDK_DOUBLE_BUTTON_PRESS
	GDK_3BUTTON_PRESS
	GDK_TRIPLE_BUTTON_PRESS
	GDK_BUTTON_RELEASE
	GDK_KEY_PRESS
	GDK_KEY_RELEASE
	GDK_ENTER_NOTIFY
	GDK_LEAVE_NOTIFY
	GDK_FOCUS_CHANGE
	GDK_CONFIGURE
	GDK_MAP
	GDK_UNMAP
	GDK_PROPERTY_NOTIFY
	GDK_SELECTION_CLEAR
	GDK_SELECTION_REQUEST
	GDK_SELECTION_NOTIFY
	GDK_PROXIMITY_IN
	GDK_PROXIMITY_OUT
	GDK_DRAG_ENTER
	GDK_DRAG_LEAVE
	GDK_DRAG_MOTION
	GDK_DRAG_STATUS
	GDK_DROP_START
	GDK_DROP_FINISHED
	GDK_CLIENT_EVENT
	GDK_VISIBILITY_NOTIFY
	GDK_SCROLL
	GDK_WINDOW_STATE
	GDK_SETTING
	GDK_OWNER_CHANGE
	GDK_GRAB_BROKEN
	GDK_DAMAGE
	GDK_TOUCH_BEGIN
	GDK_TOUCH_UPDATE
	GDK_TOUCH_END
	GDK_TOUCH_CANCEL
	GDK_TOUCHPAD_SWIPE
	GDK_TOUCHPAD_PINCH
	GDK_EVENT_LAST
		 };

enum GtkIconSize {
	GTK_ICON_SIZE_INVALID
	GTK_ICON_SIZE_MENU
	GTK_ICON_SIZE_SMALL_TOOLBAR
	GTK_ICON_SIZE_LARGE_TOOLBAR
	GTK_ICON_SIZE_BUTTON
	GTK_ICON_SIZE_DND
	GTK_ICON_SIZE_DIALOG
		};

#define GTK_STYLE_PROVIDER_PRIORITY_FALLBACK      1
#define GTK_STYLE_PROVIDER_PRIORITY_THEME     	200
#define GTK_STYLE_PROVIDER_PRIORITY_SETTINGS    400
#define GTK_STYLE_PROVIDER_PRIORITY_APPLICATION 600
#define GTK_STYLE_PROVIDER_PRIORITY_USER        800

\ =================
\ Primary GTK tools
\ =================

extern: void "c" gtk_init( int *, char *);
extern: void "c" gtk_main ( void );
extern: void "c" gtk_main_quit ( void );
\ MAIN
extern: gboolean "C" gtk_events_pending( void );
extern: gboolean "C" gtk_main_iteration( void );
extern: gboolean "C" gtk_main_iteration_do( gboolean blocking );
extern: void "C" gtk_render_background( int * context, int * cr, double x, double y, double width, double height );


\ BIN

extern: void * "c" gtk_bin_get_child( void * );

\ WIDGET
extern: void "c" gtk_widget_show( void * widget );
extern: void "c" gtk_widget_show_all( void * widget );
extern: void "c" gtk_widget_hide( void * widget );
extern: void "c" gtk_widget_destroy( int * );
extern: void * "c" gtk_widget_get_toplevel( void * );
extern: int "c" gtk_widget_get_type( void );
extern: void "C" gtk_widget_get_allocation( void * widget, void * allocation );
extern: void "C" gtk_widget_add_events( void * widget, int events );
extern: int * "c" gtk_widget_get_window( int *widget );
extern: int * "c" gtk_widget_get_style( int *widget );
extern: void "C" gtk_widget_set_parent_window( GtkWidget * widget, GdkWindow * parent_window );
extern: void "C" gtk_widget_set_sensitive( GtkWidget * widget, gboolean sensitive );
extern: void "C" gtk_widget_set_size_request( int * widget, gint width, gint height);
extern: void "C" gtk_widget_override_background_color( int * widget, int state, int * colour );
extern: void "C" gtk_widget_grab_focus( int * widget );
extern: int "C" gtk_widget_is_visible( int * widget );
extern: void "C" gtk_widget_unmap( GtkWidget * widget );
extern: void "C" gtk_widget_map( GtkWidget * widget );
extern: int * "C" gtk_widget_get_style_context( GtkWidget * widget );
extern: int "C" gtk_widget_get_allocated_width( GtkWidget * widget );
extern: int "C" gtk_widget_get_allocated_height( GtkWidget * widget );
extern: void "C" gtk_widget_queue_draw_area( GtkWidget * widget, int x, int y, int w, int h );


\ BUTTON
extern: int * "c" gtk_button_new_with_label( char * );
extern: void  "c" gtk_button_set_relief( int * button, int style );
extern: void  "c" gtk_button_set_image( int * button, int * image );
extern: void  "c" gtk_button_set_label( int * button, int * label );
extern: VOID  "C" gtk_button_set_always_show_image( int * button, gboolean always_show );
extern: gchar * "C" gtk_button_get_label( void * button );
extern: GtkWidget * "C" gtk_image_new_from_file( const gchar * filename );

\ TOGGLE BUTTON
extern: void     "c" gtk_toggle_button_set_active( int * togglebutton, gboolean is_active );
extern: gboolean "c" gtk_toggle_button_get_active( int * togglebutton );

\ CONTAINER
extern: void "c" gtk_container_add( int * , int * );
extern: int  "c" gtk_container_get_type( void );
extern: void "c" gtk_container_set_border_width( void * container, int border_width );

\ BOX
extern: int "c" gtk_box_get_type( void );

\ DRAWING AREA
extern: int * "c" gtk_drawing_area_new( void );

\ LABEL
extern: int * "C" gtk_label_new( void );
extern: void "C" gtk_label_set_text( void * label, gchar * text );
extern: gchar * "C" gtk_label_get_text( void * label );
extern: void "C" gtk_label_set_markup( void * label, gchar * text );
extern: void "C" gtk_label_set_line_wrap( void * label, gboolean wrap );
extern: void "C" gtk_label_set_lines( void * label, gint lines );
extern: void "C" gtk_label_set_justify( void * label, gint jtype );
extern: void "C" gtk_label_set_ellipsize( void * label, gint mode );
extern:	void "C" gtk_label_set_max_width_chars( void * label, gint n_chars );
extern: void "C" gtk_label_set_line_wrap_mode( void * label, gint wrap_mode );

\ EVENTBOX
extern: int * "C" gtk_event_box_new( void );

\ GRID
extern: int * "C" gtk_grid_new( void );
extern: void "C" gtk_grid_attach( void * grid, void * child, gint left, gint right, gint width, gint height );

\ BOX
extern: int * "C" gtk_box_new( int orientation, gint spacing );
extern: void "C" gtk_box_pack_start( void * box, void * child, gboolean expand, gboolean fill, gint padding );

\ IMAGE
extern: int * "C" gtk_image_new_from_file( gchar *  filename );
extern: void "C" gtk_image_set_from_animation( void * image, void * animation );
extern: void "C" gtk_image_set_from_pixbuf( void *image, void * pixbuf );
extern: int * "C" gtk_image_new_from_stock ( gchar * stock_id, int size );

\ FRAME
extern: int * "C" gtk_frame_new( gchar * label );
extern: void "C" gtk_frame_set_shadow_type( void * frame, int type );

\ ENTRY
extern: gchar * "C" gtk_entry_get_text( void * entry );
extern: void "C" gtk_entry_set_text( void * entry, void * text );
extern: void "C" gtk_entry_grab_focus_without_selecting( GtkEntry * entry );

\ EDITABLE
extern: void "C" gtk_editable_delete_selection( void * editable );
extern: void "C" gtk_editable_select_region( void * editable, int start_pos, int end_pos );
extern: void "C" gtk_editable_set_position( void * editable, int position);

\ COMBO BOX

extern: gchar * gtk_combo_box_get_active_id( void * combo_box );
extern: gint * gtk_combo_box_get_active( void * combo_box );
extern: gboolean gtk_combo_box_set_active_id( void * combo_box, gchar * active_id );

\ COMBO BOX TEXT

extern: void "C" gtk_combo_box_text_append( void * combo_box, gchar * id, gchar * text );
extern: gchar * gtk_combo_box_text_get_active_text( GtkComboBoxText * combo_box );

\ CALENDER

extern: void "C" gtk_calendar_select_month( GtkCalender * calender, guint month, guint year );
extern: void "C" gtk_calendar_select_day( GtkCalender * calender, guint day );
extern: void "C" gtk_calendar_get_date( GtkCalender * calender, guint year, guint month, guint day );

\ SPIN BUTTON

extern: void "C" gtk_spin_button_set_value( GtkSpinButton * spin_button, double value );
extern: double "C" gtk_spin_button_get_value ( GtkSpinButton * spin_button );

\ SCREEN

extern: int * "C" gdk_screen_get_width( void * screen );
extern: int * "C" gdk_screen_get_height( void * screen );

\ DIALOG

extern: void "C" gtk_message_dialog_set_markup (GtkMessageDialog * message_dialog, const gchar * str);
extern: void "C" gtk_message_dialog_format_secondary_text (GtkMessageDialog * message_dialog, const gchar * message_format );


\ =======
\ Windows
\ =======

0 CONSTANT GTK_WINDOW_TOPLEVEL

extern: int * "c" gtk_window_new( int );
extern: void "c" gtk_window_set_title(
  void * window, const char * title
);
extern: void "C" gtk_window_set_position(
  void * window, int position
);
extern: void "C" gtk_window_resize(
  void * window, int width, int height
);
extern: void "C" gtk_window_get_size(
  void * window, int *width, int *height
);
extern: void "C" gtk_window_set_default_icon_name( const gchar *name );
extern: int "c" gtk_window_get_type( void );
extern: void "c" gtk_window_resize( int * win, int width, int height );
extern: void "C" gtk_window_set_default_size( void * window, int *width, int *height );
extern: void "C" gtk_window_set_decorated( void * window, gboolean setting);

0 CONSTANT GTK_WIN_POS_NONE
1 CONSTANT GTK_WIN_POS_CENTER
2 CONSTANT GTK_WIN_POS_MOUSE
3 CONSTANT GTK_WIN_POS_CENTER_ALWAYS
4 CONSTANT GTK_WIN_POS_CENTER_ON_PARENT

extern: void "C" gtk_window_set_position( int * win, int position );
extern: int * "C" gtk_window_get_screen( int * win );
extern: void "C" gtk_window_fullscreen( int * win );

\ ===============
\ Fixed container
\ ===============

extern: int * "C" gtk_fixed_new( void );
extern: void "C" gtk_fixed_put( int * fixed, int * widget, gint x, gint y);
extern: void "C" gtk_fixed_move( int * fixed, int * widget, gint x, gint y);

\ CSS

extern: int * "C" gtk_css_provider_new( void );
extern: gboolean "C" gtk_css_provider_load_from_path( int * provider, gchar * path, GError ** error );


\ =============
\ Memory Slices
\ =============

extern: void * "C" g_slice_alloc( gsize block_size );
extern: void "C" g_slice_free1( gsize block_size, gpointer mem_block );


\ =======
\ Dialogs
\ =======

\ Flags

1 constant GTK_DIALOG_MODAL
2 constant GTK_DIALOG_DESTROY_WITH_PARENT
4 constant GTK_DIALOG_NO_SEPARATOR

\ Message type

0 constant GTK_MESSAGE_INFO
1 constant GTK_MESSAGE_WARNING
2 constant GTK_MESSAGE_QUESTION
3 constant GTK_MESSAGE_ERROR
4 constant GTK_MESSAGE_OTHER

\ Buttons

0 constant GTK_BUTTONS_NONE
1 constant GTK_BUTTONS_OK
2 constant GTK_BUTTONS_CLOSE
3 constant GTK_BUTTONS_CANCEL
4 constant GTK_BUTTONS_YES_NO
5 constant GTK_BUTTONS_OK_CANCEL

\ Response codes

-1 constant GTK_RESPONSE_NONE

/* GTK won't return these unless you pass them in
 * as the response for an action widget. They are
 * for your convenience.
 */
-2 constant GTK_RESPONSE_REJECT
-3 constant GTK_RESPONSE_ACCEPT

/* If the dialog is deleted. */
-4 constant GTK_RESPONSE_DELETE_EVENT

/* These are returned from GTK dialogs, and you can also use them
 * yourself if you like.
 */
-5 constant GTK_RESPONSE_OK
-6 constant GTK_RESPONSE_CANCEL
-7 constant GTK_RESPONSE_CLOSE
-8 constant GTK_RESPONSE_YES
-9 constant GTK_RESPONSE_NO
-10 constant GTK_RESPONSE_APPLY
-11 constant GTK_RESPONSE_HELP

extern: void * "C" gtk_dialog_new( void );
extern: int "C" gtk_dialog_run( void * dialog );
extern: void "C" gtk_dialog_response(
  void * dialog, int response_id
);


\ ===========
\ Status Bars
\ ===========

Extern: GtkWidget * "C" gtk_statusbar_new( void );
extern: guint "C" gtk_statusbar_get_context_id(
  void * statusbar, const gchar * context_description
);
extern: guint "C" gtk_statusbar_push(
  void * statusbar, guint context_id, const gchar * text
);
extern: void "C" gtk_statusbar_pop(
  void * statusbar, guint context_id
);
(( Not on Linux
extern: void "C" gtk_statusbar_remove_all(
  void * statusbar, guint context_id
);
))


\ =====
\ Fonts
\ =====

extern: void "C" gtk_widget_modify_font(
  GtkWidget *widget, void * font_desc
);
extern: void * "C" pango_font_description_from_string( const char *str );
extern: void "C" pango_font_description_free( void *desc );


\ =====================
\ TextViews and Buffers
\ =====================

extern: gboolean "C" gtk_text_buffer_get_modified( void * buffer );
Extern: void "C" gtk_text_buffer_set_modified(
  GtkTextBuffer * buffer, gboolean setting
);
Extern: gchar * "C" gtk_text_buffer_get_text(
  GtkTextBuffer * buffer, GtkTextIter * start, GtkTextIter * end,
  gboolean include_hidden_chars
);
Extern: void "C" gtk_text_buffer_set_text(
  GtkTextBuffer * buffer, const gchar * text, gint len
);
extern: void * "C" gtk_text_view_get_buffer( void * text_view );

14 cells constant /GtkTextIter

Extern: void "C" gtk_text_buffer_get_start_iter(
  GtkTextBuffer * buffer, GtkTextIter * iter
);
Extern: void "C" gtk_text_buffer_get_end_iter(
  GtkTextBuffer * buffer, GtkTextIter * iter
);
Extern: void "C" gtk_text_buffer_get_bounds(
  GtkTextBuffer * buffer, GtkTextIter * start, GtkTextIter * end
);


\ =====
\ Files
\ =====

Extern: gboolean "C" g_file_set_contents(
  const gchar * filename, const gchar * contents, gsize length, GError ** error
);
Extern: gboolean "C" g_file_get_contents(
  const gchar * filename, gchar ** contents, gsize * length, GError ** error
);


\ =========
\ Clipboard
\ =========

Extern: void * "C" gtk_clipboard_get( guint selection );
Extern: void "C" gtk_text_buffer_cut_clipboard(
  void * buffer, void * clipboard, gboolean default_editable
);
Extern: void "C" gtk_text_buffer_copy_clipboard(
  void * buffer, void * clipboard
);
Extern: void "C" gtk_text_buffer_paste_clipboard(
  void * buffer, void * clipboard, void * override_location, gboolean default_editable
);
Extern: gboolean "C" gtk_text_buffer_delete_selection(
  void * buffer, gboolean interactive, gboolean default_editable
);

\ STYLE CONTEXT

extern: void "C" gtk_style_context_add_provider_for_screen( int * screen, int * provider, int priority );
extern: void "C" gtk_style_context_get_color( int * context, int state, int * color );
extern: int "C" gtk_style_context_get_state( int * context );

\ ===
\ GDK
\ ===

extern: void * "c" gdk_pixbuf_new_from_file( const char *filename, void ** error );
extern: void * "c" gdk_pixbuf_animation_new_from_file( const char * filename, void ** error );
extern: int "c" gdk_pixbuf_get_width( void * pixbuf );
extern: int "c" gdk_pixbuf_get_height( void * pixbuf );
extern: int "c" gdk_pixbuf_save(
  void * pixbuf, void * filename, void * type, void ** error,
  int zparam, int zvalue, int NULL
);

extern: void "C" gdk_threads_init( void );
extern: void "C" gdk_threads_enter( void );
extern: void "C" gdk_threads_leave( void );

\ =======
\ Screens
\ =======

extern: void * "C" gdk_screen_get_default( void );
extern: int "C" gdk_screen_get_width( void * screen );
extern: int "C" gdk_screen_get_height( void * screen );

\ ========
\ Displays
\ ========

extern: int * "C" gdk_display_get_default( void );
extern: int * "C" gdk_display_get_default_screen( int * display );

\ =================
\ Cairo interaction
\ =================

extern: void gdk_cairo_set_source_rgba( int * cr, int * rgba );

\ =======
\ Colours
\ =======

STRUCT GdkRGBA
  8 FIELD .RED
  8 FIELD .GREEN
  8 FIELD .BLUE
  8 FIELD .ALPHA
END-STRUCT

\ BUTTON CHOOSER

extern: void "C" gtk_color_button_set_color( GtkColorChooser * chooser, const int * color );

extern: gboolean "C" gdk_rgba_parse( void * rgba, void * spec );

\ ====
\ Misc
\ ====


extern: void * "c" g_type_check_instance_cast(
  void * instance, int type
);

extern: int "c" g_timeout_add(
  int interval, void * function, void * data
);
extern: int "C" g_source_remove( uint tag );

\ extern: void * "c" g_main_context_new ();
extern: void * "c" g_main_context_default( void );
\ extern: void * "c" g_main_loop_new ( void * context, int );
\ extern: void   "c" g_main_loop_run ( void * loop );
extern: int "c" g_main_context_iteration(
  void * context, int may_block
);
extern: void "C" g_object_unref( void * object );
extern: void "C" g_clear_error( int ** err );
extern: void "C" g_error_free( int * err );
extern: void "C" g_free( gpointer mem );

extern: void * "C" g_markup_escape_text( void * text, int );

extern: gchar * "C" g_convert( void * str, int len, void * tocode, void * fromcode, int * bread, int * bwritten, int * error );

extern: void * "C" gtk_builder_new( void );
extern: uint "C" gtk_builder_add_from_file(
  void * builder, char * filename, uint ** error
);
extern: void "C" gtk_builder_connect_signals_full(
  void * builder, void * func, void * user_data
);
extern: void * "C" gtk_builder_get_object(
  void * builder, const char * name
);

extern: void "C" gtk_builder_connect_signals(
  void * builder, void * user_data
);

\ ********************
\ *S Signal Connection
\ ********************

\ ==============
\ *N Recommended
\ ==============

\ *[
extern: long "C" g_signal_connect_object(
  void * instance, char * detailed_signal, void * c_handler,
  void * gobject, uint connect_flags
);
extern: long "C" g_signal_connect_data(
  void * instance, char * detailed_signal, void * c_handler, void * data,
  int destroy_data, uint connect_flags
);

: g_signal_connect	\ instance detailed_signal c_handler data -- ulong
  0 0 g_signal_connect_data
;

\ *]

: GTK_CONTAINER   \ object -- cast_container
  gtk_container_get_type g_type_check_instance_cast
;

: GTK_BOX   \ object -- cast_box
  gtk_box_get_type g_type_check_instance_cast
;

: GTK_WIDGET   \ object -- cast_widget
  gtk_widget_get_type g_type_check_instance_cast
;

: GTK_WINDOW   \ object -- cast_window
  gtk_window_get_type g_type_check_instance_cast
;

struct /GError	\ -- len
\ *G Definition of a *\b{GError} structure.
  int ge.domain				\ 32 bit
  int ge.code				\ C int
  int ge.*message			\ pointer to text
end-struct


\ *******************
\ *S GTK message pump
\ *******************

: gtk-step	\ -- flag
\ *G Iterate GTK's inner loop, process any events and exit immediately.
\ ** *\i{flag} is returned true if a GTK event was processed.
  g_main_context_default 0 g_main_context_iteration  ;

: gtk-step-blocking	\ -- flag
\ *G Iterate gtk's inner loop, process any events, wait until there are
\ **  events if none are waiting when the function was called.
  g_main_context_default -1 g_main_context_iteration  ;

: gtkPump	\ --
\ *G Empty the GTK event queue.
  begin  gtk_events_pending while  gtk_main_iteration drop  repeat
;


\ ========
\ *N Linux
\ ========

[defined] Target_386_Linux
[defined] Target_ARM_Linux or
[if]
: gui-WaitIdle	\ --
\ *G Wait for message or GTK events and process it/them.
  gtk-step-blocking DROP
;

: gui-BusyIdle	\ --
\ *G If a message or GTK events are available, process them.
  gtk-step drop
;

: gui-EmptyIdle \ --
\ *G While messages and GTK events are available, process them.
  BEGIN gtk-step 0= UNTIL
;

: installGTKhooks	\ --
\ *G Install the GTK+ versions of the message pumps.
  ['] gui-WaitIdle is WaitIdle
  ['] gui-BusyIdle is BusyIdle
  ['] gui-EmptyIdle is EmptyIdle
;
[then]

\ ======
\ *> ###
\ ======

decimal

