\ glade.fth - interface to libglade

((
Copyright (c) 2008, 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
20110817 RML002 added "c" to bindings
20080325 VRW001 Initial (incomplete) release
))

\ *************
\ *S External bindings
\ *************
\ *P Load up the GTK bindings, and then bind the libglade API

[defined] Target_386_Windows [if]
library: libglade-2.0-0.dll
[then]

[defined] Target_386_Linux [if]
library: libglade-2.0.so.0
[then]

[defined] Target_386_OSX [if]
\ library: libglade-2.0.dylib
library: /Users/gtkosx/gtk/inst/lib/libglade-2.0.dylib
[then]

extern: void "c" *glade_xml_new( char * , char * , char * );
extern: void "c" glade_xml_signal_autoconnect( void * );
extern: void "c" glade_xml_signal_autoconnect_full( void *, void *, void * );
\ extern: void * "c" glade_xml_get_widget( void * , char * );
extern: void * "C" glade_xml_get_widget(
  void * self, const char *name
);

ErrDef NoCallBack "Signal Handler doesn't exist"
ErrDef ImmediateCallBack "Signal Handle is declared IMMEDIATE"

: LookupGladeCallback      \ zHandlerName -- xt | 0
\ *G Search the current context for the callback word passed in.
  zcount       \ -- caddr len
  \ Might want to change this to \*fo{SEARCH-WORDLIST} later
  search-context     \ -- 0 | xt 1 | xt -1
\  dup 0= NoCallBack ?throw   \ Abort if handler can't be found
  dup 0= if exit then      \ Return NULL if handler can't be found
  0> ImmediateCallBack ?throw \ Abort if handler is IMMEDIATE
  \ If we get here, we've got the callback for the handler
  execute         \ Find XT from callback
;

: GladeXMLConnectFunc   { zHandlerName pObject zSignalName zSignalData pConnObject after pUserData -- }
\ *G The main Glade signal connection callback. This is called for each signal
\ ** handler specified in the XML (i.e. handlers named by the GUI designer).
\ ** Handler names are looked up in the current context & the words found
\ ** are linked to the appropriate object by way of the GTK signal connection
\ ** bindings.
\  cr ." GladeXMLConnectFunc called : "
\  zSignalName zcount type cr
\  zHandlerName zcount type cr
  zHandlerName LookupGladeCallback	\ -- xt or NULL if invalid
  dup if
    pObject zSignalName rot		\ -- Object Name Func
    pConnObject ?dup if			\ -- Object Name Func ConnObj
      \ It's an "object"-type connect
      after if
        gtk_signal_connect_object_after
      else
        gtk_signal_connect_object
      then
    else
      \ Not an "object" connect
      pUserData				\ -- Object Name Func FuncData
      after if
        gtk_signal_connect_after
      else
        gtk_signal_connect
      then
    then
    drop       \ signal_connect_* now return error code
  else
    zHandlerName .z$ ."  not found by lookup, for signal " zSignalName .z$ cr
  then
;

7 0 CCB: GladeXMLConnectFunc_cb	\ -- entry
\ *G Call used to connect to handlers named in Glade.
' GladeXMLConnectFunc to-callback GladeXMLConnectFunc_cb

: loadGladeXML	\ z$ -- *GladeXML|0
\ *G Load a Glade XML file and return the pointer/handle or zero
\ ** on error. On success, the connections are made.
  0 0 glade_xml_new dup if
    dup GladeXMLConnectFunc_cb 0
    glade_xml_signal_autoconnect_full
    1000 ms
  endif
;


\ ======
\ *> ###
\ ======

decimal


