\ IC2 8574 driver

((
Copyright (c) 1999
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)2380 631441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com
))


\ ------------------------------------------------------------------------------
\ I2C address constants
\ ------------------------------------------------------------------------------

$040 constant 8574_id0		\ manufacturers address prefix - for 8574 = 040 hex


\ ------------------------------------------------------------------------------
\ writes a data-byte on the 8574 using ( address, data )
\ address:  4 MSBs = Manufacturers prefix, bits 4,3,2 = device address, LSB = R/W - R=1, W=0
\ data: The data you are sending
\ ------------------------------------------------------------------------------

: write_8574	\ data devaddr --
  $0FE AND				\ force bit 0 low for write
  start_i2c           			\ -- data address 	 	; send start condition
  write_byte_i2c			\ -- data 			; send address
  write_byte_i2c               		\ -- 	 			; send data
  stop_i2c				\			        ; send stop condition
;

\ ------------------------------------------------------------------------------
\ reads a data-byte from 8574 at specified address using address
\ address:  4 MSBs = Manufacturers prefix, bits 4,3,2 = device address, LSB = R/W - R=1, W=0
\ ------------------------------------------------------------------------------

: read_8574	\ devaddr -- data
  $001 OR				\ set read bit
  start_i2c		   	  	\ -- address 		; send start condition
  write_byte_i2c			\ -- 			; send address byte
  read_byte_i2c        	         	\ -- data 	        ; read a byte of data
  stop_i2c				\		        ; send a stop condition
;

