\ Parallel port driver for I2C

((
Copyright (c) 1999
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)2380 631441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com
))


\ ProForth VFX / Parallel Port Driver Layer
\ This code provides 2 port pin IO's from the PC printer port.

\ Printer Port ------------ I2C device
\ Auto Feed [pin 14] --------- SDA
\ STROBE [pin 1] ------------- SCL
\ GND [pin 18] --------------- GND


\ Parallel port addresses

\ $001 constant sda	        \ sda mask
\ $001 constant scl	        \ scl mask

$001 constant sda	        \ sda mask
$001 constant scl	        \ scl mask

\ ----------------------------------------------------------------------------
\ ( *S VFX Harness )
\ ----------------------------------------------------------------------------

variable <delay>
  200 <delay> !		\ gives 40uS delay on P166Mhz CPU

: delay			\ -- ; short wait
  <delay> @ 0
  ?do  noop  loop
;

: ?delay		\ flag -- ; Perform delay if flag is true
  if delay then
;

\ ----------------------------------------------------------------------------
\ Definitions to set SDA and SCL high and low, but perserves other
\ bits on parallel port by reading and masking
\ ----------------------------------------------------------------------------


: sda_low 	\ --
  sda@ sda OR sda! 				\		; set SDA LOW - inversion required
;

: sda_high  	\ --
  sda@ sda OR sda XOR sda!			\		; set SDA HIGH - inversion required
;

: scl_low 	\ --
  scl@ scl OR scl XOR scl!			\		; set SCL LOW
;

: scl_high	\ --
  delay    					\	        ; delay
  scl@ scl OR scl!				\	        ; set SCL high
  delay    					\	        ; delay
;

: read_sda	\ -- sda
  sda@ sda AND sda XOR if 1 else 0 endif	\ sda-flag	; reads sda and inverts for parallel port
;

\ ----------------------------------------------------------------------------
