\ crc3216.fth - 32 and 16 bit CRCs

((
Copyright (c) 2010, 2013
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
))

only forth definitions
decimal

\ ==========
\ *! crc3216
\ *T 32 and 16 bit CRCs
\ ==========
\ *P The code here is compiled if words are not already defined.

\ *************
\ *S 32 bit CRC
\ *************

[undefined] genCRC32 [if]

[undefined] +CRC32 [if]
: +CRC32	\ crc b -- crc'
\ *G Update CRC32 with one byte.
  8 0 do
    2dup xor  1 and if
      swap 1 rshift $EDB8:8320 xor swap	\ XOR in polynomial to crc
    Else
      swap 1 rshift swap		\ just shift crc
    Endif
    1 rshift				\ shift b
  Loop
  drop					\ discard b
;
[then]

: genCRC32	\ crc addr len -- crc'
\ *G Generate a 32 bit CRC for a block of memory, given an initial CRC.
\ ** value.
  bounds				\ -- crc addr+len addr
  ?do  i c@ +crc32  loop
;
[then]


\ *************
\ *S 16 bit CRC
\ *************
\ *P This version is as used by the XModem CRC.

[undefined] genCRC16 [if]

[undefined] +crc16 [if]		\ high level version
: +crc16	\ crc char -- crc'
\ *G Update the XMODEM CRC with the given character. The initial
\ ** value should be zero.
  8 lshift xor
  8 0 do
    dup $8000 and if
      1 lshift  $1021 xor
    else
      1 lshift
    then
  loop
  $FFFF and
;
[then]

: genCRC16	\ crc addr len -- crc'
\ *G Generate a 16 bit CRC for a block of memory, given an initial CRC.
\ ** value (normally 0).
  bounds				\ -- crc addr+len addr
  ?do  i c@ +crc16  loop
;

[then]


\ ======
\ *> ###
\ ======

decimal
