(*
 * LANGUAGE    : Forth; ***** ONLY iForth and VFX Forth are supported *****
 * PROJECT     : Forth Tool
 * DESCRIPTION : Audio processing client using JACK
 * CATEGORY    : Realtime Audio tools
 * AUTHOR      : Hanno Schwalm
 * LAST CHANGE : 2009-08-25 21:05:32; Hanno Schwalm hanno@schwalm-bremen.de
		 2009-12-19 18:11:00; additions for overlay generation
		 2011-08-11 22:33:04; fixed for 1.10
 *)

	FORTH DEFINITIONS

[DEFINED] IFORTH!
[IF]	NEEDS -miscutil
	NEEDS -dynlibs

	0	\ ##### Developer Option ###### true -> assemble the optimized sse2 primitives
		\ must be done both for 32 and 64 bit systems
	[IF]	CREATE save-sse2-overlay? NEEDS -assemble [THEN]
	FORTH DEFINITIONS

	REVISION -fjack "--- fJACK audio client  Version 1.13 ---"
	INCLUDE fjack/main.frt
[THEN]

[DEFINED] VFXFORTH
[IF]	\ a quick hack until macros are correct for vfxforth linux
	[DEFINED] target_386_linux [IF] C" /usr/share/doc/VfxForth/Lib" setmacro LIBRARYDIR [THEN]
	[UNDEFINED] CreateThread [DEFINED] target_386_windows AND
					[IF] INCLUDE %Lib%/Win32/MultiWin32.fth [THEN]
	FpSystem 0=			[IF] INCLUDE %Lib%/Ndp387.fth [THEN]
	FpSystem 2 >			[IF] CR .( fJACK needs a seperate floating point stack, NDP is fastest) ABORT [THEN]
	0	\ ##### Developer Option ###### make sure the docs are written, this needs vfx
	[IF]	FORTH DEFINITIONS
		CREATE MAKE-JACK-DOCS
		[UNDEFINED] +docgen	[IF] INCLUDE %Lib%/DocGen.fth [THEN]
		+docgen docgen_html
		+TOC
	[THEN]
	FORTH DEFINITIONS
	ANEW -fjack
	[DEFINED] target_386_windows	CONSTANT WINDOWS?
	[DEFINED] target_386_linux	CONSTANT LINUX?
	[DEFINED] target_386_osx	CONSTANT DARWIN?
	INCLUDE fjack/main.frt
[THEN]

[UNDEFINED] JACKAUDIO [IF] CR .( Your Forth system is not supported) [THEN]
