(*
 * LANGUAGE    : ANS Forth
 * PROJECT     : Audio processing
 * DESCRIPTION : Implementing an autoleveler
 * CATEGORY    : audio processing tool
 * AUTHOR      : Hanno Schwalm
 * LAST CHANGE : 2009-04-28 07:56:10
 *)

\ *S The Autolevel Object
\ *P This set the *\forth{JACK-IO-LEVEL} to a moderate level.


DECIMAL ALSO JACKAUDIO ALSO DEFINITIONS

HERE ," Level adaption" CONSTANT #autolevel-id

#PRIVATE-DSP
	DSP-VALUE last-over
	DSP-VALUE sum-over
	DSP-VALUE sum-far-over
	CONSTANT #autolevel_struct

: calc-autolevel-val	\ ( -- ) (F val -- val' )
	FDUP
	FABS FDUP	0.9e0 F>	IF	1 +TO sum-over		THEN
			2e0 F>		IF	1 +TO sum-far-over	THEN
	#FJACK-SAMPLE last-over - JACK-SAMPLE-RATE 3 RSHIFT >
	IF	sum-over 2 >		IF	JACK-IO-LEVEL 1.01e0 F/ 0.5e0 FMAX TO JACK-IO-LEVEL		THEN
		sum-far-over 1 >	IF	JACK-IO-LEVEL 2e0 F/ 0.5e0 FMAX TO JACK-IO-LEVEL		THEN
		sum-over 0=		IF	JACK-IO-LEVEL 1.01e0 F* 1e0 FMIN TO JACK-IO-LEVEL		THEN
		0 TO sum-over  0 TO sum-far-over
		#FJACK-SAMPLE TO last-over
	THEN ;
: (init-autolevel-object)
	#FJACK-SAMPLE TO last-over  0 TO sum-over  0 TO sum-far-over ;
FORTH DEFINITIONS

: MAKE-AUTOLEVELER	( -- object )
\ *G Construct a autolevel object and leave it's address.
	['] (init-autolevel-object) 0 #autolevel_struct MAKE&ALLOCATE-PLUGIN-OBJECT
	AUTOLEVEL TO plug_filtype  #autolevel-id TO plug_type
	['] calc-autolevel-val TO plug_xt @DSP ;
: AUTOLEVELER:	\ ( -- ) name
\ *G Define a named autolevel object
	MAKE-AUTOLEVELER CONSTANT ;

PREVIOUS PREVIOUS DEFINITIONS
