(*
 * LANGUAGE    : Forth
 * PROJECT     : Audio processing
 * DESCRIPTION : Prototype for fJACK plugins
 * CATEGORY    : audio processing tool
 * AUTHOR      : Hanno Schwalm
 * LAST CHANGE : 2009-05-31 18:49:24
 *)

[UNDEFINED] JACKAUDIO [IF] CR .( fjack/prototype needs fjack ... ) ABORT [THEN]
ALSO JACKAUDIO ALSO DEFINITIONS

HERE ," Prototype" CONSTANT #proto-id
#PRIVATE-DSP
	DSP-VALUE proto_par
	DSP-VALUE proto_buff
	CONSTANT #proto_struct

$10000	CONSTANT #proto_size
#-123	CONSTANT #proto-magic

: calc-prototype-val  \ ( object -- ) (F val -- val' )
	FDUP #FJACK-SAMPLE #proto_size 1- AND SFLOATS  proto_buff + SF! ;
: init-prototype
	plug_dynmem TO proto_buff
	proto_buff #proto_size SFLOATS ERASE
	#proto-magic TO plug_filtype
	#proto-id TO plug_type ;

: CHK-PROTO
	#proto-id plug_type <> ABORT" Invalid PROTOTYPE object" ;


FORTH DEFINITIONS
: MAKE-PROTOTYPE	( -- object )
	['] init-prototype
	#proto_size SFLOATS $10 + #proto_struct MAKE&ALLOCATE-PLUGIN-OBJECT
	['] calc-prototype-val TO plug_xt
	@DSP ;
: PROTOTYPE:
	MAKE-PROTOTYPE CONSTANT ;
: SET-PROTO-PAR	( n object -- )
	-->DSP CHK-PROTO TO proto_par ;


PREVIOUS PREVIOUS DEFINITIONS
