\ *T Some tests
\ *P Some working plugins found in fjack/examples are here for you to start.
\ ** All the plugins defined here and the test suite are NOT included in the default fjack
\ ** module.

[UNDEFINED] JACKAUDIO [IF] CR .( fjack/examples/tests needs fjack ... ) ABORT [THEN]

INCLUDE fjack/examples/sinus.frt
INCLUDE fjack/examples/notch.frt
INCLUDE fjack/examples/delay.frt
INCLUDE fjack/examples/vibrato.frt
INCLUDE fjack/examples/leveler.frt
INCLUDE fjack/examples/phaser.frt

DECIMAL ALSO JACKAUDIO ALSO DEFINITIONS

S" fjack/snippets/bassdrum.wav"	SNIPPET bassdrum
S" fjack/snippets/cowbell.wav"	SNIPPET cowbell
S" fjack/snippets/hihatb.wav"	SNIPPET hihatb
S" fjack/snippets/hihat.wav"	SNIPPET hihat
S" fjack/snippets/handclap.wav"	SNIPPET handclap
S" fjack/snippets/cymbal.wav"	SNIPPET cymbal
S" fjack/snippets/hightom.wav"	SNIPPET hightom
S" fjack/snippets/lowtom.wav"	SNIPPET lowtom
S" fjack/snippets/midtom.wav"	SNIPPET midtom
S" fjack/snippets/maracass.wav"	SNIPPET maracass
S" fjack/snippets/hibongo.wav"	SNIPPET highbongo
S" fjack/snippets/lowbongo.wav"	SNIPPET lowbongo
S" fjack/snippets/cardbox.wav"	SNIPPET cardbox
S" fjack/snippets/woodblk.wav"	SNIPPET woodblock

#300 VALUE delay
: sound ( -- )
	delay MS #100 CHOOSE #50 + S>F 100e0 F/ TO SPEEDUP ;
FORTH DEFINITIONS
: (PLAY-SNIPPETS)
	bassdrum  sound
	cowbell	  sound
	hihatb    sound
	cymbal    sound
	hihat 	  sound
	cardbox	  sound
	handclap  sound
	hightom   sound
	midtom    sound
	lowtom	  sound
	maracass  sound
	lowbongo  sound
	highbongo sound
	woodblock sound ;


SINE-OSCILLATOR: SINUS-OSZ  #440 SINUS-OSZ SET-OBJ-FREQUENCY
HIGH-PASS $200 FIR-FILTER: HIGHFIL
HIGH-PASS $200 FIR-FILTER: HIGHFIL2
$400 ADAPTIVE-FILTER: ADPFIL
LOW-PASS IIR-FILTER: IIRFIL
LOW-PASS IIR-FILTER: IIRFIL2
DELAYER: DELFIL
VIBRATO: vibbox
MIXER: testmix
AUTOLEVELER: testlevel
PHASER: testphaser0
PHASER: testphaser1

: PLAY-SNIPPETS	 ( -- )		BEGIN (PLAY-SNIPPETS) KEY? UNTIL KEY DROP 1e0 TO SPEEDUP ;

: ON-SINUS	 ( -- )		0.5e0 SINUS-OSZ SET-OBJ-LEVEL SINUS-OSZ 0 0  SET-JACK-PLUGIN ;
: OFF-SINUS	 ( -- )		SINUS-OSZ REMOVE-JACK-PLUGIN ;

: ON-FIR	 ( -- )		#800 HIGHFIL SET-OBJ-FREQUENCY  #800 HIGHFIL2 SET-OBJ-FREQUENCY
				HIGHFIL 3 0 SET-JACK-PLUGIN	HIGHFIL2 3 1 SET-JACK-PLUGIN ;
: OFF-FIR	 ( -- )		HIGHFIL REMOVE-JACK-PLUGIN	HIGHFIL2 REMOVE-JACK-PLUGIN ;

: ON-ADP	 ( -- )		ADPFIL 2 0 SET-JACK-PLUGIN ;
: OFF-ADP	 ( -- )		ADPFIL REMOVE-JACK-PLUGIN ;

: ON-IIR	 ( -- )		#2000 IIRFIL SET-OBJ-FREQUENCY	#2000 IIRFIL2 SET-OBJ-FREQUENCY
				IIRFIL 4 0 SET-JACK-PLUGIN	IIRFIL2 4 1 SET-JACK-PLUGIN ;
: OFF-IIR	 ( -- )		IIRFIL REMOVE-JACK-PLUGIN  IIRFIL2 REMOVE-JACK-PLUGIN ;


: ON-DELAY	 ( -- )		#500000 DELFIL SET-DELAY-TIME	0.5e0 0.5e0 DELFIL SET-DELAY-LEVELS
				DELFIL 5 0 SET-JACK-PLUGIN ;
: OFF-DELAY	 ( -- )		DELFIL REMOVE-JACK-PLUGIN ;

: ON-PHASER	( -- )
				testphaser0 6 0 SET-JACK-PLUGIN testphaser1 6 1 SET-JACK-PLUGIN ;
: OFF-PHASER	( -- )		testphaser0 REMOVE-JACK-PLUGIN testphaser1 REMOVE-JACK-PLUGIN ;

: ON-NOTCHES	( -- )		#300 0 SET-NOTCH-FILTER   #380 0 SET-NOTCH-FILTER  #450 0 SET-NOTCH-FILTER  ;
: OFF-NOTCHES	( -- )		CLEAR-ALL-NOTCHES  ;

: ON-VIB	( -- )		vibbox 1 0 SET-JACK-PLUGIN  10000 vibbox SET-OBJ-FREQUENCY  20e0 vibbox  SET-OBJ-LEVEL ;
: OFF-VIB	( -- )		vibbox REMOVE-JACK-PLUGIN ;

: ON-MIXER	( -- )		testmix	30 2 SET-JACK-PLUGIN
				1 0  1e0 0e0 testmix SET-MIXER-INPUT	5 0  1e0 0e0 testmix SET-MIXER-INPUT ;
: OFF-MIXER	( -- )		testmix REMOVE-JACK-PLUGIN ;

: ON-LEVELER	( -- )		testlevel 25 0 SET-JACK-PLUGIN ;
: OFF-LEVELER	( -- )		testlevel REMOVE-JACK-PLUGIN ;

FFTW3-LIB?
[IF]	#500 EQUALIZER: testequalizer
	: ON-EQUALIZER	( -- )	testequalizer	24 0 SET-JACK-PLUGIN
				testequalizer	0e0 350e0	0e0 550e0 SET-EQUALIZER-RANGE
				testequalizer	0e0 0e0		0e0 100e0 SET-EQUALIZER-RANGE
				testequalizer	0e0 4000e0	0e0 40000e0 SET-EQUALIZER-RANGE ;
	: OFF-EQUALIZER		testequalizer REMOVE-JACK-PLUGIN ;
[ELSE]	: ON-EQUALIZER		CR ." No equalizer because it needs the fftw3 library" CR ;
	: OFF-EQUALIZER	;
[THEN]

: HURRAY	 ( -- )
 	ON-SINUS
	#300 SINUS-OSZ SET-OBJ-FREQUENCY #250 MS
 	#380 SINUS-OSZ SET-OBJ-FREQUENCY #250 MS
 	#450 SINUS-OSZ SET-OBJ-FREQUENCY #250 MS
 	#600 SINUS-OSZ SET-OBJ-FREQUENCY #600 MS
 	OFF-SINUS ;
: OOOOOH
 	ON-SINUS
	#600 SINUS-OSZ SET-OBJ-FREQUENCY #250 MS
 	#450 SINUS-OSZ SET-OBJ-FREQUENCY #250 MS
 	#380 SINUS-OSZ SET-OBJ-FREQUENCY #250 MS
 	#300 SINUS-OSZ SET-OBJ-FREQUENCY #600 MS
 	OFF-SINUS ;

: JACK-BENCHMARK	 ( -- )
\ *G A little fjack processing benchmark
	   %0111111111 >R
	R@ %0000000001 AND	IF ON-SINUS THEN
	R@ %0000000010 AND	IF ON-FIR THEN
	R@ %0000000100 AND	IF ON-ADP THEN
	R@ %0000001000 AND	IF ON-IIR THEN
	R@ %0000010000 AND	IF ON-NOTCHES THEN
	R@ %0000100000 AND	IF ON-DELAY THEN
	R@ %0001000000 AND	IF ON-VIB THEN
	R@ %0010000000 AND	IF ON-MIXER CR ." Mixer status" testmix .MIXER-INFO THEN
	R@ %0100000000 AND	IF ON-LEVELER THEN
	R@ %1000000000 AND	IF ON-EQUALIZER THEN
	R> DROP
 	CR LIST-PLUGINS
	CR ." *** testing for performance - takes 10 seconds ***" CR
	3 0 DO (PLAY-SNIPPETS) LOOP
  	CR JACK-INFO
	OFF-MIXER OFF-DELAY OFF-VIB OFF-NOTCHES OFF-FIR OFF-IIR OFF-SINUS OFF-ADP OFF-LEVELER OFF-EQUALIZER
	1.0e0 TO SPEEDUP ;
PREVIOUS PREVIOUS DEFINITIONS
