(*
 * LANGUAGE    : ANS Forth
 * PROJECT     : Forth Environments
 * DESCRIPTION : Vibrato effect for jack >= 0.115
 * CATEGORY    : Sound processing
 * AUTHOR      : Hanno Schwalm
 * LAST CHANGE : 2009-12-01 22:31:12
		2009-12-30 13:28:26 no explicit plug_xt_quality clearing as ioplugs does this
 *)

\ *S A Vibrato effect - you can select the vibrato frequency and the strength.

ALSO JACKAUDIO ALSO DEFINITIONS

HERE ," Vibrato effect" CONSTANT #vib-id
#PRIVATE-DSP
	DSP-FVALUE vib_phase
	DSP-FVALUE vib_step
	CONSTANT #vib-struct

: CHK-VIB	#vib-id plug_type <> ABORT" Invalid VIBRATO object" ;

: calc_vib_val	\ ( -- ) (F val -- val' )
	vib_step vib_phase F+ REDUCE.2PI FDUP TO vib_phase
	FSIN 1e0 F+ plug_level F* JACK-SAMPLE-RATE S>F F/ plug_input
	@INTERPOLATED-HISTORY-DATA F+ F2/ ;
: (tune-vib-object)	( F: frequency -- )
	FDUP TO plug_frequency PI F* 500e0 F/ JACK-SAMPLE-RATE S>F F/ TO vib_step ;

FORTH DEFINITIONS
: MAKE-VIBRATO	( -- addr )
\ *G Make a vibrato effect plugin object and leave a pointer to it.
\ ** When setting the frequency by *\forth{SET-OBJ-FREQUENCY} the argument is the frequency*1000 to allow
\ ** more precise settings.
\ *P The vibrato strength is set as usual by the *\forth{SET-OBJ-LEVEL} method.
	['] NOOP 0 #vib-struct MAKE&ALLOCATE-PLUGIN-OBJECT
	#vib-id TO plug_type  VIBRATO-PLUGIN TO plug_filtype
	['] calc_vib_val TO plug_xt
	['] (tune-vib-object) TO plug_xt_tune
	0e0 TO vib_step  0e0 TO vib_phase  0e0 TO plug_level
	@DSP ;

: VIBRATO:	( -- ) \ name
\ *G make a named vibrato effect plugin
        MAKE-VIBRATO CONSTANT ;

PREVIOUS PREVIOUS DEFINITIONS
