JACKAUDIO DEFINITIONS
\ generic forth high-level fir filter routines, can be replaced by optimized
\ sse2 code when a) the cpu supports it and b) a supporting assembler is available

0 VALUE (calc-fir-val)		\ ( muls data size -- )	(F -- val )
\ This points to the valid function. It has the current data in the array, does the multiply&add and
\ returns the value.
0 VALUE (calc-adp-muls)		\ ( muls data cnt -- )	(F corr -- )
\ This points to the valid function. It has the current data in the array, does the calculation of the coefficients.
\ The correction val is consumed from the floating stack.

\ These are the standard floating point definitions for the above
: (calc-fir-val-forth)
	0e0
	BEGIN	#16 - DUP 0< 0=
	WHILE	>R DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
		DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
		DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
		DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
		DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
		DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
		DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
		DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+ R>
	REPEAT #16 + >R
	R@ 8 AND
	IF	DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
		DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
		DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
		DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
	THEN
	R@ 4 AND
	IF	DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
		DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
	THEN
	R@ 2 AND
	IF	DF@+ SWAP DF@+ F* F+	DF@+ SWAP DF@+ F* F+
	THEN
	R> 1 AND
	IF	DF@+ SWAP DF@+ F* F+
	THEN	2DROP ;

: (calc-adp-muls-forth)
	BEGIN	#16 - DUP 0< 0=
	WHILE	>R FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP	R>
	REPEAT	#16 + >R
	R@ 8 AND
	IF	FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
	THEN
	R@ 4 AND
	IF	FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
	THEN
	R> 2 AND
	IF	FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
		FDUP DF@+ F* OVER DF@ F+	SWAP DF!+ SWAP
	THEN
	2DROP FDROP ;	\ forget correction factor and addresses; just leave output data
