
FORTH DEFINITIONS
DEFER DO-PROCESS-MIDI-IN-EVENT	' DROP IS DO-PROCESS-MIDI-IN-EVENT

ALSO JACKAUDIO ALSO DEFINITIONS
\ *S The MIDI Future ...
\ *P So far the fJACK MIDI support is mediocre but there are many users out there that might profit
\ ** from a MIDI integration.
\ ** Also JACKs future plans seem to follow that direction. As i have *\bold{no} experience with MIDI at all
\ ** i am dependent on contributions from everyone out there. A first step has been done already, the libjack
\ ** library calls are integrated and the processing callback reads the incoming events and presents them
\ ** in an event queue.
\ *P Some hope is here - a fJACK (Bill Codington) user has started some sort of midi support. See also examples/

Extern: void "C" jack_midi_clear_buffer			( void * port_buffer);
Extern: int "C" jack_midi_event_get			( jack_midi_event_t * event, void * port_buffer, jack_nframes_t event_index);
Extern: jack_midi_data_t "C" jack_midi_event_reserve	( void * port_buffer, jack_nframes_t  time, int data_size);
Extern: int "C" jack_midi_event_write			( void * port_buffer, jack_nframes_t time, const jack_midi_data_t * data, int data_size);
Extern: jack_nframes_t "C" jack_midi_get_event_count	( void * port_buffer);
Extern: jack_nframes_t "C" jack_midi_get_lost_event_count ( void * port_buffer);
Extern: int "C" jack_midi_max_event_size		( void * port_buffer);

: *midi		( n -- offset)	#midi-events 1- AND #midi-event-size * ;
: >midi_in	( n -- addr )	*midi midi_in_queue + ;
: >midi_out	( n -- addr )	*midi midi_out_queue + ;	\ addr to write midi data

: SEND-MIDI-OUTEVENT	( addr size -- ) \ now saves length in first byte
	$100 MIN 1 MAX
	#midi_out >midi_out 2dup c! 1+ SWAP MOVE
	1 +TO #midi_out ;
0 value size
: PROCESS-MIDI
	\ Get the current port buffers for MIDI
	0 >midiport #midi-frames jack_port_get_buffer
	1 >midiport #midi-frames jack_port_get_buffer  LOCALS| outbuff inbuff |
	outbuff jack_midi_clear_buffer
	\ get the number of pending input events
	inbuff jack_midi_get_event_count 0
 	?DO	#midi_in >midi_in DUP inbuff I jack_midi_event_get DROP
		DO-PROCESS-MIDI-IN-EVENT
		1 +TO #midi_in
  	LOOP
	#midi_out #midi_out_read - 0 MAX 0
	?DO	#midi_out_read  >midi_out dup \ addr of data
		\ my attempt
		c@  >r  ( save size on rs) 1+
		outbuff i r@  jack_midi_event_reserve	\ reserve space for command
		r> move
		1 +TO #midi_out_read
	LOOP
	 ;
 ' PROCESS-MIDI IS MIDI-PROCESS-HOOK


FORTH DEFINITIONS
: SHOW-MIDI-EVENTS
\ *G Shows processed midi events until a key is pressed.
	BEGIN	KEY? 0=
	WHILE	#midi_in_read #midi_in <
		IF	#midi_in_read  >midi_in $10 DUMP
			1 +TO #midi_in_read
		ELSE	#20 MS
		THEN
	REPEAT ;

CREATE midipad $10 ALLOT
\ channels are 0-15
: NOTE-ON ( ch note# vel -- )
	midipad 2+ c!	\ velocity
	midipad 1+ c!	\ note#
	$90 or midipad c!	\ noteon
	midipad 3  SEND-MIDI-OUTEVENT
	;
: NOTE-OFF ( ch note#  -- )
	0 midipad 2+ c!	\ velocity
	midipad 1+ c!	\ note#
	$80 or midipad c!	\ noteoff
	midipad 3  SEND-MIDI-OUTEVENT
	;
: PROG-CHANGE ( ch prog#  -- )
	midipad 1+ c!	\ prog#
	$c0 or  midipad c!
	midipad 2  SEND-MIDI-OUTEVENT
	;


PREVIOUS PREVIOUS DEFINITIONS
