\ TSEPOS 77 1 1 \
\ -- R.G.G -- 19/2/92 --  Eight Queens Problem, by Jerry Levan

((
Every programming language contains an example of this
problem - PowerForth/386 is no exception.

There seem to be no stack comments for this example, so they
are left as an exercise for our readers!

Exercise in Recursion from
FORTH DIMENSIONS II/1 page 6
))

: iarray		\ n -- ; makes an array of n 1's
  create
    0
    do 1 , loop				\ array of ones
  does>
    swap cells+				\ leave indexed address in array
;

 8 iarray a				\ workspace for solutions
16 iarray b
16 iarray c
 8 iarray x

: safe
  swap over over over over - 7 +
  c @ >r
  +
  b @ >r
  drop
  a @  r>  r>  * *  
;

: mark
  swap over over over over - 7 + c 0 swap !
  + b 0 swap ! drop a 0 swap ! 
;

: unmark
  swap over over over over - 7 + c 1 swap !
  + b 1 swap ! drop a 1 swap ! 
;

variable tries

: printsol
  ." found on try " tries @ 6 .r 8 0
  do  i x @ 1+ 5 .r  loop
  cr
;

: try
  8 0
  do  1 tries +!  key?
      if quit then
      dup i safe
      if  dup i mark  dup i swap x !  dup 7 <
          if  dup 1+ ?stack  recurse
          else printsol
          then
          dup i unmark
      then
  loop
  drop 
;

: do-it
  0 tries !
  cr  0 try 
;

do-it

