\ PROFILE.FTH - Dick Pountain's profiler for VFX Forth

((
Copyright (c) 2002
Dick Pountain
  and
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


Notes by Dick Pountain about the profiler
=========================================
To use the profiler, just compile this page. Then
compile the words to be profiled on top, and execute them.

Typing PROFILE then prints an execution count for all the words
compiled after PROFILE. Note that PROFILE resets the counters,
so if you have more than a screenful, take a hard copy.

The code is very spartan; you can tart up the formatting etc.
to taste. It is not too dificult to redefine VARIABLE and
CONSTANT in a similar way, to profile variables and constants.
CREATE ... DOES> definitions are more difficult to cope with.


To do
=====

Change history
==============
))

[undefined] tab [if]
8 value tab-width

: tab		\ -- ; issue at least one space up to next tab stop
  begin
    space  out @ tab-width mod 0=
  until
;
[then]

[undefined] link, [if]
: link,		\ var-addr -- ; lay a link in a chain whose head is at var-addr
\ *G Add a link to a chain anchored at address var-addr. The old contents of
\ ** var-addr are added to the dictionary as the new link, and the address
\ ** of the new link is placed at var-addr.
  here  over @ ,  swap !
;
[then]

[-sin		\ VFX Forth specific

variable plink	\ -- addr ; anchor for profiled words chain

: 1+!		\ addr -- ; increment contents by one
  1 swap +!
;

: :		\ <name> -- ; redefine : to insert a count field and skip over it
  align  plink link,  0 ,  :		\ lay link and counter, do old :
;

: ;		\ -- ; redefine ; to increment the count field
  latest ctrl>nfa n>link cell -		\ addr counter compiled as a literal
  postpone literal  postpone 1+!	\ force increment
  postpone ;				\ perform original ;
; immediate

: profile	\ --
  cr  plink				\ walk list of profiled words
  begin
    @ dup
   while
    dup cell + @  tab 0 8 d.r		\ print counter contents
    dup cell + off			\ reset counter contents
    dup 2 cells + link>n space .name	\ and the word's name
  repeat
  drop  cr
;

sin]		\ VFX Forth specific


\ *********
\ Test code
\ *********

[-sin		\ VFX Forth specific

: t1 ;
: t2 ;
: t3  t1  10 0 do t2 loop  t1  ;
t3 profile

sin]		\ VFX Forth specific
