\ taskhacked.fth

((
Copyright (c) 2019
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)

Please note that MPE files have hard tabs set to 8. Hence, tabs
are at columns 1, 9, 17, 25 ...

To do
=====

Change history
==============
))

only forth definitions
decimal

\ ===========
\ *! interrupthacked
\ *T Task on the fly
\ ===========
\ *P This task run in the background and illustrates messages and events.

Task Repl-Server

cell +user msg-sender

: mesg>repl	\ mesg --
\ *G Send message to the REPL server.
  Repl-Server send-message
;

: ?message	\ --
\ *G Process message and handle it.
  self msg? if
    get-message msg-sender !		\ -- mesg
    cr ." Message is " .dword ."  from task " msg-sender @ .dword
  then
;

: ?event	\ --
\ *G Process event and handle it.
  self event? if
    cr ." Event processed"  clr-event-run
  then
;

100 +user event-data

: set-repl-event	\ first second --
  repl-server event-data his		\ -- first second addr
  tuck cell + !  !
  repl-server set-event
;

: repl-event-handler	\ --
\ *G  JED's requirement.
  event-data 2@ +
  cr ." After much thought, the result is not 42, but " .
;


: repl-loop	\ --
\ *G Endless loop for REPL.
  TASK0-IO                 \ select the console as the I/O device
  DUP IP-HANDLE !  OP-HANDLE !
  ['] repl-event-handler self tcb.event !
  begin
    ['] ?message catch drop   ['] ?event catch drop
    pause
  again
;

: start-repl	\ --
\ Start task running.
  ['] repl-loop repl-server initiate
;

\ ======
\ *> ###
\ ======

decimal
