\ transients.fth - transient words

((
Copyright (c) 2019
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone numbers are:
       011 44 23 8063 1441
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
))

only forth definitions
decimal

\ ===========
\ *! filename
\ *T Chapter Title
\ ===========

ErrDef bad_transientArea	"Not in transient area"

64 kb value /TA	\ -- len
\ Size of a transient area.

0 value anchorTR	\ -- addr|0
\ *G Anchors the linked list of transient areas.

struct /transient	\ -- len
\ *G Defines the head of the transient region.
  int tr.link			\ previous transient area in chain
  int tr.prevDP			\ previous DP
  int tr.idata			\ IDATA state
  int tr.sp			\ SP on entry
  int tr.s0			\ S0 on entry
end-struct

: [TR		\ --
\ *G Allocate a new transient area
  sp@ >r				\ stack pointer
  anchorTR  /TA protAlloc		\ get space, THROW on error
  tuck tr.link !  			\ save previous transient area
  dp @ over tr.prevDP !			\ save previous DP
  idata? over tr.idata !		\ IDATA state
  r> over tr.sp !			\ preserve old stack pointer
  S0 @ over tr.s0 !			\ preserve old S0
  dup -> anchorTR			\ save new transient area
  /transient + DP !			\ set new DP (HERE).
  0 -> idata?				\ no IDATA
  0 0 0 0  0 0 0 0			\ guard cells on data stack
  sp@ s0 !				\ reset S0
;

: TR]		\ --
\ *G End the current transient area and remove it
  anchorTR				\ -- ta ; last TA
  dup 0= bad_transientArea ?throw	\ check transient area
  dup /transient + here trim-dictionary	\ forget transient words
  dup tr.idata @ -> idata?		\ restore IDATA state
  dup tr.prevDP @ dp !			\ restore HERE
  dup tr.sp @ >r			\ previous SP
  dup tr.s0 @ S0 !
  dup tr.link @  swap protFree -> anchorTR  \ unlink and free
  r> sp!				\ restore stack
;


\ ======
\ *> ###
\ ======

decimal
