0 [if]
From mhx@iaehv.iae.nl Sat Apr 14 15:24:57 2001
Newsgroups: comp.lang.forth
Subject: why?
From: mhx@iaehv.iae.nl (Marcel Hendrix)
Date: 14 Apr 2001 14:24:57 GMT

A question that comes up frequently can now be answered authoratively.

Here's some output:

WHY?
	They told me to.
	She obeyed a bald kid.
	The tall sphinx told me to.
	A smart young hamster suggested it.
	Bill Ragsdale insisted on it.
	She told me to.
	I knew it was a good idea.
	You insisted on it.
	He told me to.
	I told me to.
	Wil Baden knew it was a good idea.
	For the approval from Skip Carter.

-marcel
===============================================
[DEFINED] -work [IF] -work [THEN] MARKER -work
[then]

[defined] vfxforth [if]
: randomize  ( -- )  ;
: place+     ( caddr len dest -- )  append  ;
: >upc       ( char -- char' ) upc  ;
: doc        ( -- )  s" enddoc" parseuntil  ;
[then]

\ WHY?    Provides succinct answers to almost any question.
\   WHY? provides a random answer.
\   Please embellish or modify this function to suit your own tastes.
\   (Based on a MATLAB system function with the same name).

CREATE master$ 0 C, #255 ALLOT

: STR+ ( c-addr u -- )
	master$ C@ #255 > ABORT" master$ :: string overflow"
	master$ PLACE+ ;

: BL+ ( -- ) S"  " STR+ ;
: .+  ( -- ) S" ." STR+ ;

: proper_noun ( -- )
	CASE #20 CHOOSE
     	   0 OF S" Chuck Moore" ENDOF
    	   1 OF S" Philip Preston" ENDOF
    	   2 OF S" Bill Ragsdale" ENDOF
    	   3 OF S" Elizabeth D. Rather" ENDOF
    	   4 OF S" Anton" ENDOF
    	   5 OF S" Bernd" ENDOF
    	   6 OF S" Skip Carter"  ENDOF
    	   7 OF S" Stephen Pelc" ENDOF
	   8 OF S" John Hall" ENDOF
	   9 OF S" Leonard Zettel" ENDOF
	 #10 OF S" Leo Wong" ENDOF
	 #11 OF S" Leo Brodie" ENDOF
	 #12 OF S" Gary Chanson" ENDOF
	 #13 OF S" m_l_g3" ENDOF
	 #14 OF S" Paul E. Bennett" ENDOF
	 #15 OF S" J. Thomas" ENDOF
	 #16 OF S" Leonard Zettel" ENDOF
	 #17 OF S" Bruce Hoyt" ENDOF
	 #18 OF S" Dilbert" ENDOF
	 #19 OF S" Wil Baden" ENDOF
    	ENDCASE STR+ ;

: noun ( -- )
	CASE #15 CHOOSE
    	   0 OF S" mathematician"   ENDOF
    	   1 OF S" programmer"      ENDOF
    	   2 OF S" system manager"  ENDOF
    	   3 OF S" engineer" 	    ENDOF
    	   4 OF S" hamster"	    ENDOF
    	   5 OF S" kid"		    ENDOF
    	   6 OF S" nerd"	    ENDOF
    	   7 OF S" swapdragon"	    ENDOF
    	   8 OF S" program manager" ENDOF
    	   9 OF S" Young Higgins"   ENDOF
    	 #10 OF S" sphinx"          ENDOF
    	 #11 OF S" engineer"        ENDOF
    	 #12 OF S" PITA"            ENDOF
    	 #13 OF S" philosopher"     ENDOF
    	 #14 OF S" dark force"      ENDOF
	ENDCASE STR+ ;

: nominative_pronoun ( -- )
	CASE 5 CHOOSE
    	 0 OF S" I"    ENDOF
    	 1 OF S" you"  ENDOF
    	 2 OF S" he"   ENDOF
    	 3 OF S" she"  ENDOF
    	 4 OF S" they" ENDOF
	ENDCASE STR+ ;

: accusative_pronoun ( -- )
	CASE 4 CHOOSE
    	  0 OF S" me"  ENDOF
    	  1 OF S" all" ENDOF
    	  2 OF S" her" ENDOF
    	  3 OF S" him" ENDOF
	ENDCASE STR+ ;

: nouned_verb ( -- )
	2 CHOOSE IF S" love" ELSE S" approval" ENDIF STR+ ;

: adverb ( -- )
	CASE 3 CHOOSE
    	 0 OF S" very" ENDOF
    	 1 OF S" not very" ENDOF
    	 2 OF S" not excessively" ENDOF
	ENDCASE STR+ ;

: adjective ( -- )
	CASE 8 CHOOSE
    	 0 OF S" tall" 	    ENDOF
    	 1 OF S" bald" 	    ENDOF
    	 2 OF S" young"     ENDOF
    	 3 OF S" smart"     ENDOF
    	 4 OF S" rich" 	    ENDOF
    	 5 OF S" terrified" ENDOF
    	 6 OF S" good" 	    ENDOF
    	 7 OF S" nerdy"	    ENDOF
	ENDCASE STR+ ;

: article ( -- )
	CASE 3 CHOOSE
    	  0 OF S" the"  ENDOF
    	  1 OF S" some" ENDOF
    	  2 OF S" a"    ENDOF
	ENDCASE STR+ ;

: adjective_phrase ( -- )
	CASE 6 CHOOSE
    	  0 OF  adjective  ENDOF
    	  1 OF  adjective  ENDOF
    	  2 OF  adjective  ENDOF
	  3 OF  RECURSE S"  and " STR+ RECURSE ENDOF
    	        >R  adverb BL+ adjective R>
	ENDCASE ;

: noun_phrase ( --  )
	CASE 4 CHOOSE
    	  0 OF noun ENDOF
    	  1 OF adjective_phrase BL+ RECURSE ENDOF
    	       >R adjective_phrase BL+ noun R>
	ENDCASE ;

: subject ( -- )
	CASE 4 CHOOSE
    	  0 OF  proper_noun 	    ENDOF
    	  1 OF  nominative_pronoun  ENDOF
    		>R  article BL+ noun_phrase  R>
	ENDCASE ;

: present_verb ( -- )
	CASE 3 CHOOSE
    	  0 OF S" fool"    ENDOF
    	  1 OF S" please"  ENDOF
    	  2 OF S" satisfy" ENDOF
	ENDCASE STR+ ;

: transitive_verb ( -- )
	CASE #10 CHOOSE
    	  0 OF S" threatened" 	ENDOF
    	  1 OF S" told" 	ENDOF
    	  2 OF S" asked" 	ENDOF
    	  3 OF S" helped" 	ENDOF
	       >R S" obeyed" R>
	ENDCASE STR+ ;

: intransitive_verb ( -- )
	CASE 6 CHOOSE
    	  0 OF S" insisted on it" ENDOF
    	  1 OF S" told me to"     ENDOF
    	  2 OF S" wanted it"      ENDOF
    	  3 OF S" suggested it"   ENDOF
    	  4 OF S" knew it was a good idea" ENDOF
	       >R S" wanted it that way" R>
	ENDCASE STR+ ;

: object ( -- )
	#10 CHOOSE 0= IF accusative_pronoun EXIT ENDIF
    	article BL+ noun_phrase ;

: predicate ( -- )
	CASE 3 CHOOSE
    	  0 OF transitive_verb BL+ object ENDOF
    	  1 OF intransitive_verb ENDOF
	  2 OF intransitive_verb ENDOF
	ENDCASE ;

: preposition ( -- )
	2 CHOOSE IF S" of" ELSE S" from" ENDIF STR+ ;

: prepositional_phrase ( -- )
 	preposition BL+
	CASE 3 CHOOSE
    	  0 OF article BL+ noun_phrase ENDOF
    	  1 OF proper_noun ENDOF
    	  2 OF accusative_pronoun ENDOF
	ENDCASE ;

: sentence ( -- )
	subject BL+ predicate .+ ;

: phrase ( -- )
	CASE 3 CHOOSE
    	  0 OF S" for the " STR+ nouned_verb BL+ prepositional_phrase .+ ENDOF
    	  1 OF S" to " STR+ present_verb BL+ object .+	ENDOF
    	  2 OF S" because " STR+ sentence 		ENDOF
	ENDCASE ;

: special_case ( -- )
	CASE #13 CHOOSE
	  0 OF  S" why not?"	ENDOF
	  1 OF	S" why?"	ENDOF
	  2 OF	S" don't ask!"  	ENDOF
	  3 OF	S" it's your karma." 	ENDOF
	  4 OF	S" stupid question!" 	ENDOF
	  5 OF	S" how should I know?" 	ENDOF
	  6 OF	S" can you rephrase that?" 	ENDOF
	  7 OF	S" it should be obvious." 	ENDOF
	  8 OF	S" the devil made me do it." 	ENDOF
	  9 OF	S" the computer did it." 	ENDOF
	#10 OF	S" the customer is always right." ENDOF
	#11 OF	S" don't you have something better to do?" ENDOF
	#12 OF	S" it's the Forth way." ENDOF
	ENDCASE STR+ ;

: WHY? ( -- )
	0 master$ C!  RANDOMIZE
	CASE #10 CHOOSE
	  0 OF special_case ENDOF
	  1 OF phrase       ENDOF
	       sentence
	ENDCASE
	master$ CHAR+ DUP C@ >UPC SWAP C!
	master$ COUNT CR TYPE ;

DOC
(*	FORTH> WHY? many
	Anton told the bald swapdragon.
	They told me to.
	She obeyed a bald kid.
	The tall sphinx told me to.
	A smart young hamster suggested it.
	Bill Ragsdale insisted on it.
	She told me to.
	I knew it was a good idea.
	Bernd insisted on it.
	You insisted on it.
	He told me to.
	Stephen Pelc obeyed some swapdragon.
	I told me to.
	Wil Baden knew it was a good idea.
	For the approval from Skip Carter.
	Because some not excessively rich Young Higgins wanted it.
*)
ENDDOC

\ EOF

