#! /bin/bash

# delete previous versions in /usr/bin etc
if [ -e Bin/vfxosx ]; then
if [ -e /usr/bin/vfxosx ]; then
  sudo rm /usr/bin/vfxosx
  sudo rm /usr/bin/stubosx
  sudo rm /usr/bin/skimpage.scpt
  sudo rm /usr/lib/libmpeparser.0.dylib
  sudo rm /usr/lib/vfxsupp.1.dylib
fi
fi

VFXBINFILE=VfxForth_x86_mac.mo

# Install the compiler and VFX Forth to /usr/local/bin
# Install the shared libraries to /usr/local/lib
# because of El Capitan/10.11
if [ -d Bin ]
then
  # not Mission
  sudo cp -a Bin/x386OSX               /usr/local/bin/
  sudo cp -a Bin/VfxForth*_mac.mo      /usr/local/bin/
  sudo cp -a Bin/stubosx               /usr/local/bin/
  sudo cp -a Bin/skimpage.scpt         /usr/local/bin/
  sudo cp -a Bin/libmpeparser.0.dylib  /usr/local/lib/
  sudo cp -a Bin/vfxsupp.1.dylib       /usr/local/lib/
  # set directory vars used later to set INI file
  VFXSRCDIR=`pwd`
  VFXROOTDIR=`pwd`
else
  if [ -d Sources/Images ]
  then
    # Mission
    sudo cp -a Sources/Images/x386OSX                  /usr/local/bin/
    sudo cp -a Sources/Images/VfxForth_x86_mac.mo      /usr/local/bin/
    sudo cp -a Sources/Images/VfxCommunity_x86_mac.mo  /usr/local/bin/
    sudo cp -a Sources/Images/stubosx                  /usr/local/bin/
    sudo cp -a Sources/Images/skimpage.scpt            /usr/local/bin/
    sudo cp -a Sources/Images/libmpeparser.0.dylib     /usr/local/lib/
    sudo cp -a Sources/Images/vfxsupp.1.dylib          /usr/local/lib/
    # set directory vars used later to set INI file
    VFXSRCDIR=`pwd`/Sources
    VFXROOTDIR=`pwd`
  else
    echo Cannot find executable files
    exit 2
  fi
fi
pushd /usr/local/bin
if [ -e vfxosx ]; then
  sudo rm vfxosx
fi
ln -s VfxForth_x86_mac.mo vfxosx
if [ -e VfxForth ]; then
  sudo rm VfxForth
fi
ln -s VfxForth_x86_mac.mo VfxForth
popd


# make directory vars visible
export VFXSRCDIR
export VFXROOTDIR


# Create a default INI file if there isn't one
if [ ! -f  ${HOME}/.VfxForth.ini ]
then
  ./ChangeIni.Osx32.sh
fi

# Run VFX to finish the INI file set up
# Uses VFXSRCDIR and VFXROOTDIR variables
${VFXBINFILE} "cr .( type bye to exit ) cr"
