\ DASM387.FTH - 387+ Floating point disassembler

((
Copyright (c) 2001, 2002
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441

PLEASE NOTE THAT OUR PHONE NUMBER CHANGED IN APRIL 2000


Notes
=====
All NDP instructions start 1101_1xxx. See the 387 DX Users Manual,
Appendix E, page E-36 for more details of the instruction formats.
Even more detail is available in the Intel ISA32 Instruction set
manual available at developer.intel.com

This code is not written for performance!


To do
=====
MMX and Pentium instructions

Change history
==============
20020220 SFP001 Fixed display of 'R' in FSUB and FDIV.
		Fixed FSTP
))

only forth  also disassembler definitions

variable result	\ -- addr ; true if NDPins found

: .op		\ -- ; displays attached name
  create
    ",
  does>
    count >disline
;

interpreter
: .opt		\ -- ; displays attached name and tabs
  create
    ",
  does>
    count >disline  parm-tab
;
target
: .opt		\ -- ; displays attached name and tabs
  create
    ",
  does>
    count >disline  parm-tab
;

.opt .??? ???"

\ special
.opt .fnop FNOP"
.opt .fstsw FSTSW"
.opt .fcompp FCOMPP"
\ format 4
.opt .fxam FXAM"
.opt .fldz FLDZ"
.opt .fld1 FLD1"
.opt .fldpi FLDPI"
.opt .fldl2t FLDL2T"
.opt .fldl2e FLDL2E"
.opt .fldlg2 FLDLG2"
.opt .fldln2 FLDLN2"
.opt .fsqrt FSQRT"
.opt .fscale FSCALE"
.opt .fprem FPREM"
.opt .fprem1 FPREM1"
.opt .frndint FRNDINT"
.opt .fxtract FXTRACT"
.opt .fabs FABS"
.opt .fchs FCHS"
.opt .fcos FCOS"
.opt .fptan FPTAN"
.opt .fpatan FPATAN"
.opt .fsin FSIN"
.opt .fsincos FSINCOS"
.opt .f2xm1 F2XM1"
.opt .fyl2x FYL2X"
.opt .fyl2xp1 FYL2XP1"
.opt .fincstp FINCSTP"
.opt .fdecstp FDECSTP"
.opt .ftst FTST"
\ format 5
.opt .finit FINIT"
.opt .fclex FCLEX"
\ formats 1,2,3
.opt .fld FLD"
.opt .fst FST"
.opt .fstp FSTP"
.opt .fxch FXCH"
.opt .fcom FCOM"
.opt .fcomp FCOMP"
.opt .fucom FUCOM"
.opt .fucomp FUCOMP"
.opt .fucompp FUCOMPP"
.opt .ffree FFREE"
.opt .fild FILD"
.opt .fbld FBLD"
.opt .fbstp FBSTP"
.opt .fldcw FLDCW"
.opt .fstcw FSTCW"
.opt .fldenv FLDENV"
.opt .fstenv FSTENV"
.opt .fsave FSAVE"
.opt .frstor FRSTOR"
\ terminator for Format3
.opt .p P"
\ non-tabbing for instructions that can have P suffix in Format3
.op .fadd FADD"
.op .fsub FSUB"
.op .fmul FMUL"
.op .fdiv FDIV"


: badResult	\ opcode --
  drop  result off
;

: badNDP	\ opcode --
  .???  badResult
;

[switch F4switch badNDP
  $E4 runs .ftst
  $E5 runs .fxam

  $EE runs .fldz
  $E8 runs .fld1
  $EB runs .fldpi
  $E9 runs .fldl2t
  $EA runs .fldl2e
  $EC runs .fldlg2
  $ED runs .fldln2

  $FA runs .fsqrt
  $FD runs .fscale
  $F8 runs .fprem
  $F5 runs .fprem1
  $FC runs .frndint
  $F4 runs .fxtract
  $E1 runs .fabs
  $E0 runs .fchs
  $FF runs .fcos
  $F2 runs .fptan
  $F3 runs .fpatan
  $FE runs .fsin
  $FB runs .fsincos
  $F0 runs .f2xm1
  $F1 runs .fyl2x
  $F9 runs .fyl2xp1

  $F7 runs .fincstp
  $F6 runs .fdecstp
switch]

[switch F5switch badNDP
  $E3 runs .finit
  $E2 runs .fclex
switch]

create mfs	\ -- addr ; strings for memory format
  ", FLOAT "  ", DWORD "  ", DOUBLE "  ", WORD "

: .mf		\ -- ; display memory format
  mfs opcode1 @ 1 rshift 3 and byte-jumper count >disline
;

: .qword	\ -- ; 64 bit integer
  s" QWORD " >disline
;

: .ext		\ -- ; extended 80 bit real
  s" TBYTE " >disline
;

create stregs	\ -- addr ; holds register strings
  ", ST"      ", ST(1)"   ", ST(2)"   ", ST(3)"
  ", ST(4)"   ", ST(5)"   ", ST(6)"   ", ST(7)"

: (.st)		\ -- ; raw register display
  stregs opcode2 @ 7 and byte-jumper count >disline
;

: .st		\ -- ; display register value
  (.st) bl>dis
;

: .st,		\ -- ; display register value with trailing comma
  (.st) ,>dis
;

: .popped	\ -- ; for Format3 instructions
  opcode1 @ $02 and
  if  .p  else  parm-tab  endif
;

: .reversed	\ -- ; for format3 instructions
  opcode2 @ $08 and
  if  s" R" >disline  endif
;

: .revreg	\ -- ; for format3 instructions with reg, st or st, reg ; SFP001
  opcode2 @ $08 and 0=
  if  s" R" >disline  endif
;

: .dreg		\ -- ; display reg pair for Format3
  opcode1 @ $04 and if
    .st, s" ST" >disline
  else
    s" ST, " >disline .st
  endif
;

: op16		\ -- w ; form 16 bit opcode from first two bytes
  opcode1 @ 8 lshift  opcode2 @ or
;

[switch F3switch badResult	\ mop -- ; takes masked 16bit opcode
  $01C0 run: .fld .st  ;
  $05D0 run: .fst .st  ;
  $05D8 run: .fstp .st  ;
  $01C8 run: .fxch .st  ;
  $00D0 run: .fcom .st  ;
  $00D8 run: .fcomp .st  ;
  $05E0 run: .fucom .st  ;
  $05E8 run: .fucomp .st  ;
  $05C0 run: .ffree .st  ;
switch]

[switch F3DPswitch badNDP	\ mop -- ; takes masked 16bit opcode
  $00C0 run: .fadd .popped .dreg  ;
  $00E0 run: .fsub .revreg .popped .dreg  ;
  $00E8 run: .fsub .revreg .popped .dreg  ;
  $00C8 run: .fmul .popped .dreg  ;
  $00F0 run: .fdiv .revreg .popped .dreg  ;
  $00F8 run: .fdiv .revreg .popped .dreg  ;
switch]

: doFormat3	\ -- ; process Format 3 instructions
  op16 $07F8 and F3switch
  result @ 0= if
    result on
    op16 $01F8 and F3DPswitch
  endif
;

[switch F1switch badNDP	\ mop -- ; takes masked 16bit opcode
  $0728 run: .fild .qword @modrm r/m+disp>dis  ;
  $0328 run: .fld .ext @modrm r/m+disp>dis  ;
  $0720 run: .fbld @modrm r/m+disp>dis  ;
  $0738 run: .fstp .qword @modrm r/m+disp>dis  ;
  $0338 run: .fstp .ext @modrm r/m+disp>dis  ;
  $0730 run: .fbstp @modrm r/m+disp>dis  ;
  $0128 run: .fldcw @modrm r/m+disp>dis  ;
  $0138 run: .fstcw @modrm r/m+disp>dis  ;
  $0538 run: .fstsw @modrm r/m+disp>dis  ;
  $0130 run: .fstenv @modrm r/m+disp>dis  ;
  $0120 run: .fldenv @modrm r/m+disp>dis  ;
  $0530 run: .fsave @modrm r/m+disp>dis  ;
  $0520 run: .frstor @modrm r/m+disp>dis  ;
switch]

[switch F2switch badResult
  $0100 run: .fld  .mf @modrm r/m+disp>dis  ;
  $0110 run: .fst  .mf @modrm r/m+disp>dis  ;
  $0118 run: .fstp  .mf @modrm r/m+disp>dis  ;	\ SFP001
  $0138 run: .fstp  .mf @modrm r/m+disp>dis  ;
  $0010 run: .fcom  .mf @modrm r/m+disp>dis  ;
  $0018 run: .fcomp  .mf @modrm r/m+disp>dis  ;
  $0000 run: .fadd  parm-tab .mf @modrm r/m+disp>dis  ;
  $0020 run: .fsub .reversed parm-tab  .mf @modrm r/m+disp>dis  ;
  $0028 run: .fsub .reversed parm-tab  .mf @modrm r/m+disp>dis  ;
  $0030 run: .fdiv .reversed parm-tab  .mf @modrm r/m+disp>dis  ;
  $0038 run: .fdiv .reversed parm-tab  .mf @modrm r/m+disp>dis  ;
switch]

: Format1?	\ -- flag ; true if opcode = 1101.1xx1_xx1x.xxxx
  op16 $F920 and $D920 =
;

: Format3?	\ -- flag ; true if opcode = 1101.1xxx_11xx.xxxx
  op16 $F8C0 and $D8C0 =
;

: Format4?	\ -- flag ; true if opcode = 1101.1001_111x.xxxx
  op16 $FFE0 and $D9E0 =
;

: Format5?	\ -- flag ; true if opcode = 1101.1011_111x.xxxx
  op16 $FFE0 and $DBE0 =
;

: stepB		\ -- ; get next byte and discard, updates display
  @byte drop
;

: (NDPins?)	\ -- flag ; hook to main disassembler
  DisAddr c@ Opcode2 !			\ collect 16 bit opcode
  result on				\ assume ok

  case op16				\ special cases
    $DFE0 of  stepb  .fstsw s" AX" >disline  true exit  endof
    $D9D0 of  stepb  .fnop  true exit  endof
    $DED9 of  stepb  .fcompp  true exit  endof
    $DAE9 of  stepb  .fucompp  true exit  endof
  endcase
  Format4?
  if  @byte F4switch  result @ exit  endif
  Format5?
  if  @byte F5switch  result @ exit  endif
  Format3?
  if  stepb  doFormat3  result @ exit  endif
  Format1?
  if  op16 $0738 and F1switch  result @ exit  endif

  op16 $0138 and F2switch

  result @					\ not an NDP instruction?
;
assign (NDPins?) to-do NDPins?

previous definitions

