\ REQDCODE.FTH - required code fragments

((
Copyright (c) 2001, 2002, 2006, 2008, 2009, 2013, 2014
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====
Recode SKIP SCAN to avoid double branch at JECX.


Change history
==============
20140723 SFP012 Removed divide primitives, done by cross compiler.
20131212 SFP011 Added overlap checks to CMOVE and CMOVE>.
		On overlap, always use a byte by byte copy.
20090603 SFP010 Fixed RELLVS
20080930 SFP009 Added DU< and DU>.
20061002 SFP008 Recoded S= for longer strings.
20060807 SFP007 Rewrote FILL for P4.
20060606 SFP006 Added CMOVE primitives for P4 and above.
20020811 SFP005 Fixed bug in S= for len=0.
20020318 SFP004 Make SKIPCALL PATCHCALL GETCALLDEST !JUMP visible.
20010702 SFP003 Added S= SKIP and SCAN
19990924 SFP002 Made doLayAbsCall visible
19990905 SFP001 Added INLINE-ALWAYS where possible
		Added _/MOD _/ _MOD
))



\ Undocumented fragments of carnal knowledge code for the Kernel
\ These are things you just can't do in portable high-level Forth

proc DODOES     \                                               MPE.0000
        pop     eax
        sub     ebp, 4
        mov     0 [ebp], ebx
        pop     ebx
        jmp     eax
L: DOCREATE     \                                               MPE.0000
        sub     ebp, 4
        mov     0 [ebp], ebx
        pop     ebx
        next,
end-code

((
code (+LOOP)    \ n --
        mov     eax, ebx
        mov     ebx, 0 [ebp]
        add     ebp, 4
        add     4 [esp], eax
        jo      leave_ploop
        pop     eax
        mov     eax, 0 [eax]
        jmp     eax
l: leave_ploop
        pop     eax
        add     esp, 12
        add     eax, 4
        jmp     eax
end-code
))
code (+LOOP)    \ n --
\ ESP+C:  exit address
\ ESP+8:  index-limit-$8000.0000  (incremented by LOOP)
\ ESP+4:  index                   (incremented by LOOP)
        mov     eax, ebx
        mov     ebx, 0 [ebp]
        add     ebp, # 4		\ EAX=step, EBX restored
        add     4 [esp], eax		\ step index
        add     8 [esp], eax		\ step limit
        jo      leave_ploop
        pop     eax
        mov     eax, 0 [eax]
        jmp     eax
l: leave_ploop
        pop     eax
        add     esp, # 12
        add     eax, # 4
        jmp     eax
end-code

code (LOOP)    \ --
\ ESP+C:  exit address
\ ESP+8:  index-limit-$8000.0000  (incremented by LOOP)
\ ESP+4:  index                   (incremented by LOOP)
        add     4 [esp], # 1		\ step index
        add     8 [esp], # 1		\ step limit
        jo      leave_loop
        pop     eax
        mov     eax, 0 [eax]
        jmp     eax
l: leave_loop
        pop     eax
        add     esp, # 12
        add     eax, # 4
        jmp     eax
end-code


\ **************************
\ machine code CALL handlers
\ **************************

: doLayAbsCall  \ address --
  $E8 C,  here cell+ - ,
;

: PatchCall     \ abs:32 address-of-call-instruction --
  dup 5 +               \ abs32 aoci after-ci
  swap -rot             \ aoci abs32 after-ci
  - swap 1+ !
;

: SkipCall      \ a-addr -- 'a-addr
\ +G Modify address by size of a CALL instruction.
  5 +
;

: GetCallDest   \ a-addr -- abs:32
\ +G Given the address of a CALL instruction return the CALL
\ +* target address.
  dup 1 + @             \ get rel:32 part of instruction
  swap 5 + +            \ +end-of-instruction ptr = ABS:32
;

: !call         \ target where --
  $E8 over c!
  1+ tuck
  cell+ - swap !
;

: !jump         \ target where --
  $E9 over c!
  1+ tuck
  cell+ - swap !
;

CODE LV!	\ n -- ; store local variable [offset in-line]
        pop     eax
        mov     edx, 0 [eax]
        add     eax, 4
        add     edx, edi
        mov     0 [edx], ebx
        mov     ebx, 0 [ebp]
        add     ebp, 4
        jmp     eax
END-CODE

CODE LV@	\ -- n ; read local variable [offset in-line]
        pop     eax
        mov     edx, 0 [eax]
        add     eax, 4
        add     edx, edi
        sub     ebp, 4
        mov     0 [ebp], ebx
        mov     ebx, 0 [edx]
        jmp     eax
END-CODE

CODE LV		\ -- a-addr ; read local variable address [offset in-line]
        pop     eax
        mov     edx, 0 [eax]
        add     eax, 4
        add     edx, edi
        sub     ebp, 4
        mov     0 [ebp], ebx
        mov     ebx, edx
        jmp     eax
END-CODE

CODE MAKELVS	\ -- ; make space for local variables  )
                \ #args (cells), #locals (cells) in-line
                \ Frame structure is as OTA spec, vol1 3.2.5
                \ arguments +ve offset, locals -ve offset

\ allocate a frame for the arguments

        pop     eax
        mov     ecx, esp

        sub     edx, edx
        mov     dx, 0 [eax]
        add     eax, 2
        shl     edx, 2
        sub     esp, edx

        push    ecx
        push    edi
        mov     edi, esp

        cmp     edx, 0
        je      makelvs3
        mov     ecx, esp
        add     ecx, 8
        mov     0 [ecx], ebx
        add     ecx, 4
l: makelvs1
        sub     edx, 4
        je      makelvs2
        mov     ebx, 0 [ebp]
        add     ebp, 4
        mov     0 [ecx], ebx
        add     ecx, 4
        jmp     makelvs1
l: makelvs2
        mov     ebx, 0 [ebp]
        add     ebp, 4
l: makelvs3
        sub     edx, edx
        mov     dx, 0 [eax]
        add     eax, 2
        shl     edx, 2
        sub     esp, edx
        jmp     eax
END-CODE

CODE RELLVS  ( -- ; drop local variables )
	pop	eax			\ SFP010
        mov     esp, 4 [edi]
        mov     edi, 0 [edi]
	jmp	eax			\ SFP010
END-CODE

\ Here you put things you want your cross-compiler code generator to simply
\ TARGET-REF because you can't write a code generator

INTERNAL

code doNrev     \ XN..X1 count -- x1..XN
        cmp     ebx, 1			\ ignore count <1
        g, if,
         dec     ebx			\ item n at offset n-1
         mov     ecx, ebp		\ data stack pointer
         shl     ebx, 2			\ in cells
         add     ebx, ecx		\ EBX points to XN, ECX to X1
         begin,
          mov     edx, 0 [ebx]		\ perform exchange
          mov     eax, 0 [ecx]
          mov     0 [ecx], edx
          add     ecx, 4
          mov     0 [ebx], eax
          sub     ebx, 4
          cmp     ecx, ebx
         a, until,
        endif,
        mov     ebx, 0 [ebp]
        add     ebp, 4
        next,
end-code  inline-always	\ SFP001

CODE mpeWITHIN?    \ n1 n2 n3 -- flag
        mov     eax, 0 [ebp]
        mov     edx, 4 [ebp]
        mov     ecx, ebx
        xor     ebx, ebx
        add     ebp, 8
        cmp     edx, eax
        ge, if,
          cmp edx, ecx
          le, if,
            dec     ebx
          endif,
        endif,
        next,
END-CODE  inline-always	\ SFP001

((
: within	\ n1|u1 n2|u2 n3|u3 -- flag
  over - -rot			\ -- n3-n2 n1 n2
  -				\ -- n3-n2 n1-n2
  swap u<			\ (n1-n2)-(n3-n2), cy -> -1, ncy -> 0
;
))
CODE ansWITHIN	\ n1|u1 n2|u2 n3|u3 -- flag
        mov     eax, 0 [ebp]		\ EDX=n2|u2
        mov     ecx, 4 [ebp]		\ ECX=n1|u1
        sub     ebx, eax		\ EBX=n3-n2, rebased to n2
        sub     ecx, eax		\ ECX=n1-n2, rebased to n2
        lea     ebp, 8 [ebp]		\ adjust data stack
        sub     ecx, ebx		\ ECX=(n1-n2)-(n3-n2)
	sbb	ebx, ebx		\ cy -> -1, ncy -> 0
        next,
END-CODE  inline-always	\ SFP001

((
CODE _M*        \ n1 n2 -- d                                     6.1.1810
        mov     eax, 0 [ebp]
        imul    ebx
        mov     0 [ebp], eax
        mov     ebx, edx
        next,
END-CODE  inline-always	\ SFP001
))

CODE _UM*       \ u1 u2 -- ud                                    6.1.2360
        mov     eax, 0 [ebp]
        mul     ebx
        mov     0 [ebp], eax
        mov     ebx, edx
        next,
END-CODE  inline-always	\ SFP001

((
CODE _/MOD      \ n1 n2 -- rem quot                              6.1.0240
( *G Signed division of N1 by N2, single-precision yielding remainder   )
( ** and quotient.                                                      )
	mov	eax, 0 [ebp]		\ dividend
	cdq				\ sign extend into EDX
	idiv	ebx			\ signed divide
        mov     0 [ebp], edx		\ remainder
        mov     ebx, eax		\ quotient
        next,
END-CODE  inline-always
))
((
CODE _/         \ n1 n2 -- n3                                    6.1.0230
( *G Standard signed division operator. n3 = n1/n2.                     )
	mov	eax, 0 [ebp]		\ dividend
	add	ebp, # 4		\ update stack pointer
	cdq				\ sign extend into EDX
	idiv	ebx			\ signed divide
        mov     ebx, eax		\ quotient
        next,
END-CODE  inline-always
))
((
CODE _MOD       \ n1 n2 -- n3                                    6.1.1890
( *G Return remainder of division of N1 by N2. n3 = n1 mod n2.          )
	mov	eax, 0 [ebp]		\ dividend
	add	ebp, # 4		\ update stack pointer
	cdq				\ sign extend into EDX
	idiv	ebx			\ signed divide
        mov     ebx, edx		\ remainder
        next,
END-CODE  inline-always
))
((
CODE _UM/MOD    \ ud u -- urem uquot                             6.1.2370
        mov     edx, 0 [ebp]
        add     ebp, 4
        mov     eax, 0 [ebp]
        div     ebx
        mov     0 [ebp], edx
        mov     ebx, eax
        next,
END-CODE  inline-always	\ SFP001
))
((
\ replaced by SM/REM
CODE _M/MOD      \ d1 n2 -- rem quot                            MPE.0000
        mov     edx, 0 [ebp]
        add     ebp, 4
        mov     eax, 0 [ebp]
        idiv    ebx
        mov     0 [ebp], edx
        mov     ebx, eax
        next,
END-CODE  inline-always	\ SFP001

CODE _DNEGATE    \ d -- -d                                     8.6.1.1230
        mov     eax, 0 [ebp]
        add     ebp, 4
        not     eax
        not     ebx
        add     eax, 1
        adc     ebx, 0
        sub     ebp, 4
        mov     0 [ebp], eax
        next,
end-code  inline-always	\ SFP001

CODE _D+         \ d1 d2 -- d3                                  8.6.1.1040
        mov     eax, 0 [ebp]
        add     8 [ebp], eax
        adc     ebx, 4 [ebp]
        add     ebp, 8
        next,
END-CODE  inline-always	\ SFP001

CODE _D-         \ d1 d2 -- d3                                  8.6.1.1050
        xchg    ebp, esp
        pop     ecx
        pop     edx
        pop     eax
        sub     eax, ecx
        sbb     edx, ebx
        push    eax
        mov     ebx, edx
        xchg    ebp, esp
        next,
END-CODE  inline-always	\ SFP001
))

code _D2*        \ d1 -- d1*2                                   8.6.1.1090
  mov eax, 0 [ebp]
  shl eax, 1
  rcl ebx, 1
  mov 0 [ebp], eax
  next,
end-code  inline-always	\ SFP001

code _D2/        \ d1 -- d1/2                                   8.6.1.1100
  mov eax, 0 [ebp]
  sar ebx, 1
  rcr eax, 1
  mov 0 [ebp], eax
  next,
end-code  inline-always	\ SFP001

EXTERNAL

code du<	\ d1l d1h d2l d2h -- flag
  mov  eax, 0 [ebp]			\ d2 = EBX:EAX
  mov  edx, 8 [ebp]
  mov  ecx, 4 [ebp]			\ d1 = ECX:EDX
  sub  edx, eax				\ d1l - d2l
  sbb  ecx, ebx				\ d1h - d2h
  sbb  ebx, ebx				\ flag
  lea  ebp, #12 [ebp]
  next,
end-code

code du>	\ d1l d1h d2l d2h -- flag
  mov  eax, 0 [ebp]			\ d2 = EBX:EAX
  mov  edx, 8 [ebp]
  mov  ecx, 4 [ebp]			\ d1 = ECX:EDX
  sub  eax, edx				\ d2l - d1l
  sbb  ebx, ecx				\ d2h - d1h
  sbb  ebx, ebx				\ flag
  lea  ebp, #12 [ebp]
  next,
end-code


\ ****************************************************************
\ If these words are not defined, high level versions will be used
\ ****************************************************************

CODE */MOD	\ n1 n2 n3 -- rem quot                          6.1.0110
  mov	eax, 0 [ebp]			\ n1
  mov	ecx, 4 [ebp]			\ n2
  imul	ecx				\ n1*n2
  idiv	ebx				\ n1*n2/n3
  add	ebp, # 4			\ adjust stack
  mov   0 [ebp], edx			\ remainder
  mov	ebx, eax			\ quotient
  next,
end-code  inline

CODE */         \ n1 n2 n3 -- n4                                6.1.0100
  mov	eax, 0 [ebp]			\ n1
  mov	ecx, 4 [ebp]			\ n2
  imul	ecx				\ n1*n2
  idiv	ebx				\ n1*n2/n3
  add	ebp, # 8			\ adjust stack
  mov	ebx, eax			\ quotient
  next,
end-code  inline

CODE M/         \ d1 n2 -- quot                                 MPE.0000
  mov   edx, 0 [ebp]		\ d1h
  mov   eax, 4 [ebp]		\ d1l
  add	ebp, 8			\ adjust stack
  idiv  ebx
  mov   ebx, eax
  next,
END-CODE  inline

CODE SM/REM	\ d1 n2 -- rem quot                            6.1.2214
  mov   edx, 0 [ebp]
  add   ebp, 4
  mov   eax, 0 [ebp]
  idiv  ebx
  mov   0 [ebp], edx
  mov   ebx, eax
  next,
END-CODE  inline-always	\ SFP001

\ replace ORs by TESTs
CODE FM/MOD	\ d1 n2 -- rem quot                            6.1.1561
  mov   edx, 0 [ebp]			\ dividend high
  mov   eax, 4 [ebp]			\ dividend low
  mov   ecx, ebx                	\ sign of quotient by XOR
  add	ebp, # 4			\ drop one item from stack
  xor   ecx, edx
  idiv  ebx                     	\ do division
  or    ecx, ecx                	\ test sign of quotient
  jns   msx                     	\ skip if positive
    or    edx, edx                  	\ test remainder
    jz    msx                     	\ skip if 0
      dec   eax                     	\ decrement quotient
      add   edx, ebx                	\ adjust remainder
l: msx
  mov   0 [ebp], edx			\ set remainder
  mov   ebx, eax			\ set quotient
  next,
END-CODE

cpu? p4cpu >= [if]
code move	\ src dest len --
  cmp   ebx, # 0		\ if len != 0
  push  esi
  push  edi
  mov   edi, 0 [ebp]		\ EDI=dest
  mov   esi, 4 [ebp]		\ ESI=source
  a, if,			\ EBX=len
    cmp   edi, esi
    mov   ecx, ebx		\ ECX=len
    a, if,
\ dest below source, copy backwards - massage addresses
      and   ecx, # 3		\ number of bytes before len is multiple of four
      lea   esi, -1 [esi] [ebx]	\ src+len-1
      lea   edi, -1 [edi] [ebx]	\ dest+len-1
      nz, if,
        begin,
          mov   al, 0 [esi]
          sub   ecx, # 1
          lea   esi, -1 [esi]
          mov   0 [edi], al
          lea   edi, -1 [edi]
        z, until,
      endif,
      shr   ebx, # 2		\ number of quadwords
      lea   esi, -3 [esi]	\ realign to quadword after dec by 1
      lea   edi, -3 [edi]
      nz, if,
        begin,
          mov    eax, 0 [esi]
          sub    ebx, # 1
          lea    esi, -4 [esi]
          mov    0 [edi], eax
          lea    edi, -4 [edi]
        z, until,
      endif,
    else,
\ dest above source, copy forwards
      and   ecx, # 3		\ number of bytes before len is multiple of four
      nz, if,
        begin,
          mov   al, 0 [esi]
          lea   esi, 1 [esi]
          mov   0 [edi], al
          sub   ecx, # 1
          lea   edi, 1 [edi]
        z, until,
      then,
      shr   ebx, # 2		\ number of quadwords
      nz, if,
        begin,
          mov   eax, 0 [esi]
          lea   esi, 4 [esi]
          mov   0 [edi], eax
          sub   ebx, # 1
          lea   edi, 4 [edi]
        z, until,
      then,
    endif,
  then,
  pop   edi
  pop   esi
  mov   ebx, 8 [ebp]
  lea   ebp, #12 [ebp]
  next,
end-code
[else]
code move	\ src dest len --
        cmp     ebx, # 0		\ if len<=0
        jbe     movex1

        push    esi
        push    edi
        mov     ecx, ebx		\ ECX=len
        mov     esi, 4 [ebp]		\ ESI=source
        mov     edi, 0 [ebp]		\ EDI=dest
        mov     ebx, 8 [ebp]		\ restore TOS
        add     ebp, 12

        cmp     edi, esi
        jbe     movex3
\ dest below source, copy backwards - massage addresses
        dec     ecx
        add     esi, ecx
        add     edi, ecx
        inc     ecx
        std

        mov     edx, ecx	\ move bytes until count is divisible by four
        and     ecx, 3
        rep     movsb
        mov     ecx, edx
        shr     ecx, 2		\ count = number of four-byte units
        sub     esi, 3		\ point to first four byte source unit
        sub     edi, 3		\ point to first four byte dest unit
        rep     movsd		\ move four-byte units
        jmp     movex2

l: movex3                       \ perform copy
\ dest above source, copy forwards
        cld
        mov     edx, ecx	\ move bytes until count is divisible by four
        and     ecx, 3
        rep     movsb
        mov     ecx, edx
        shr     ecx, 2		\ count = number of four-byte units
        rep     movsd		\ move four-byte units
l: movex2
        pop     edi
        pop     esi
        cld
        next,
l: movex1
        mov     ebx, 8 [ebp]
        add     ebp, 12
        next,
end-code

[then]

((
: compare       \ c-addr1 u1 c-addr2 u2 -- n                    17.6.1.0935
  rot swap                      \ c-addr1 c-addr2 u1 u2
  2dup - >r min                 \ c-addr1 c-addr2 minlen -- R: lendiff? --

  begin
    dup
  while
    -rot over c@ over c@ -      \ length c-addr1 c-addr2 (char1-char2)
\   ?dup if                     \ If chars are different
    dup if                      \ If chars are different
      r> drop >r                \  replace lendiff result with error code
      drop 0                    \  and put 0 on TOS (make len==0 at BEGIN)
    else                        \ otherwise
      drop			\ discard 0 lendiff
      1+ swap 1+ swap rot 1-    \ increment addresses and decrement length
    then
  repeat
  drop 2drop                    \ remove addresses and null count from stack
                                \ -- ; R: result --
  r> dup if 0< 1 or then        \ make nice flag, 0 becomes 0, -ve becomes -1
                                \            and  +ve becomes 1
;
))

code compare	\ c-addr1 u1 c-addr2 u2 -- n ; 17.6.1.0935
  mov	ecx, ebx			\ ECX=u2
  push	esi				\ preserve Forth regs
  push	edi
  xor	ebx, ebx			\ EBX=flag, assume success
  cmp	ecx, 4 [ebp]			\ select min of u1/u2
  je	compare2			\ same
  jnb	compare1
  inc	ebx				\ result = 1
  jmp	chere(t) 6 + ( short compare2 )	\ 2 bytes
l: compare1
  dec	ebx				\ 1 byte  ; result = -1
  mov	ecx, 4 [ebp]			\ 3 bytes ; u1 < u2
l: compare2
  jecxz	compare4			\ min(u1,u2)=0 check
  mov	esi, 8 [ebp]			\ c-addr1
  mov	edi, 0 [ebp]			\ c-addr1
  repe cmpsb				\ compare strings
  je	compare4			\ same
  jb	compare3
  mov	ebx, # 1
  jmp	chere(t) 7 + ( short compare4 )	\ 2 bytes
l: compare3
  mov	ebx, # -1			\ 5 bytes
l: compare4
  pop	edi
  pop	esi
  lea	ebp, #12 [ebp]
  next,
end-code

((
: s=            \ addr1 addr2 len -- flag                          MPE.0000
  dup if
    bounds do
      dup c@ i c@ <> if
        drop false  unloop exit
      endif
      1 chars +
    loop
    drop true
  else
    3drop true
  endif
;
))
cpu? p4cpu >= [if]
CODE s=		\ caddr1 caddr2 u -- flag ; true if strings same ; SFP008
\ Without prefetch fault, but slower.
  mov   ecx, 0 [ebp]			\ ECX=caddr2
  mov   0 [ebp], ebx			\ EBX=u, make copy
  shr   ebx, # 2			\ #cells **1
  mov   edx, 4 [ebp]			\ EDX=caddr1
  nz, if,				\ **1
    begin,				\ **2
      mov   eax, 0 [edx]
      lea   edx, 4 [edx]
      cmp   eax, 0 [ecx]
      lea   ecx, 4 [ecx]
      jne   s=x
      dec   ebx
    z, until,
  endif,
  mov   ebx, 0 [ebp]			\ restore copy
  and   ebx, # 3			\ #bytes **1
  nz, if,				\ **1
    begin,				\ **2
      mov   al, 0 [edx]
      lea   edx, 1 [edx]
      cmp   al, 0 [ecx]
      lea   ecx, 1 [ecx]
      jne   s=x
      dec   ebx
    z, until,
  endif,
  mov   ebx, # -1			\ same, return -1
  lea   ebp, 8 [ebp]			\ restore stack
  next,
l: s=x
  xor   ebx, ebx			\ different, return 0
  lea   ebp, 8 [ebp]			\ restore stack
  next,
end-code
[else]
CODE s=		\ caddr1 caddr2 u -- flag ; true if strings same
  mov	ecx, ebx			\ u
  push	esi				\ preserve Forth registers
  push	edi
  mov	esi, 4 [ebp]			\ caddr1
  mov	edi, 0 [ebp]			\ caddr2
  lea   ebp, 8 [ebp]			\ drop the two items removed
  jecxz	s=x				\ SFP005
  rep					\ compare strings
  cmpsb
  nz, if,
    xor	  ebx, ebx			\ different, return 0
  else,
l: s=x
    mov	  ebx, # -1			\ same, return -1
  endif,
  pop	edi				\ restore Forth registers
  pop	esi
  next,
end-code
[then]
((
: SKIP          \ c-addr u char -- 'c-addr 'u                    MPE.0000
  over 0= if drop exit then
  >r
  begin					\ -- caddr u
    over c@ dup ATAB =			\ if character is TAB
    if  drop BL  endif			\ convert to space
    r@ =
    over and				\ 0 length will stop
  while
    1- swap 1+ swap
  repeat
  r> drop
;
))
code SKIP	\ c-addr u char -- 'c-addr 'u                    MPE.0000
  mov	edx, ebx			\ EDX=char
  mov	ecx, 0 [ebp]			\ ECX=u=len
  mov   ebx, 4 [ebp]			\ EBX=caddr
l: skip1
  jecxz skipx				\ exit if len=0
  mov	al, 0 [ebx]			\ get character
  cmp	al, # 9				\ convert tab to space
  z, if,  mov  al, # $020  endif,
  cmp	al, dl				\ get out if not char to skip
  jne	skipx
  dec	ecx				\ step count and address
  inc	ebx
  jmp	skip1
l: skipx
  mov	4 [ebp], ebx			\ 'c-addr
  mov	ebx, ecx			\ 'u=len'
  lea	ebp, 4 [ebp]			\ restore stack
  next,
end-code

((
: scan          \ caddr u char -- caddr2 u2                      MPE.0000
  over 0= if drop exit then
  >r
  begin
    over c@ dup ATAB =			\ if character is TAB
    if  drop BL  endif			\ convert to space
    r@ <>
    over and
  while
    1- swap 1+ swap
  repeat
  r> drop
;
))
code scan	\ caddr u char -- caddr2 u2                      MPE.0000
  mov	edx, ebx			\ EDX=char
  mov	ecx, 0 [ebp]			\ ECX=u=len
  mov   ebx, 4 [ebp]			\ EBX=caddr
l: scan1
  jecxz scanx				\ exit if len=0
  mov	al, 0 [ebx]			\ get character
  cmp	al, # 9				\ convert tab to space
  z, if,  mov  al, # $020  endif,
  cmp	al, dl				\ get out if char to scan for
  je	scanx
  dec	ecx				\ step count and address
  inc	ebx
  jmp	scan1
l: scanx
  mov	4 [ebp], ebx			\ 'c-addr
  mov	ebx, ecx			\ 'u=len'
  lea	ebp, 4 [ebp]			\ restore stack
  next,
end-code

((
: fill          \ addr len char -- ; 6.1.1540
  -rot bounds ?do
    dup i c!
  loop
  drop
;
))

cpu? p4cpu >= [if]
code fill	\ addr len char -- ; 6.1.1540
  mov   edx, 0 [ebp]		\ EDX=len
  mov   ecx, 4 [ebp]		\ ECX=dest
  mov   al, bl                  \ EAX=chars
  mov   ah, bl			\ 00cc
  shl   eax, # #16		\ cc00
  mov   al, bl			\ cc0c
  mov   ah, bl			\ cccc
  mov   ebx, edx		\ 32 bit words to move?
  and   edx, # 3		\ EDX=following bytes to move
  shr   ebx, # 2		\ EBX=cells to move
  nz, if,
    begin,
      sub   ebx, # 1		\ **2
      mov   0 [ecx], eax
      lea   ecx, 4 [ecx]
    z, until,			\ **2
  endif,
  test  edx, edx
  nz, if,
    begin,
      sub   edx, # 1		\ **3
      mov   0 [ecx], al
      lea   ecx, 1 [ecx]
    z, until,			\ **3
  endif,
  mov	ebx, 8 [ebp]		\ pop TOS
  lea	ebp, #12 [ebp]
  next,
end-code
[else]
code fill	\ addr len char -- ; 6.1.1540
  mov	ecx, 0 [ebp]
  mov   eax, ebx
  mov	edx, edi
  jecxz fillx
  mov	edi, 4 [ebp]
  rep stosb
l: fillx
  mov	ebx, 8 [ebp]
  mov	edi, edx
  lea	ebp, #12 [ebp]
  next,
end-code
[then]


\ SFP006...
cpu? p4cpu >= [if]

\ Recode CMOVE and CMOVE> for cells.
((
code cmove	\ src dest len --
  mov    edx, 0 [ebp]	\ edx=dest
  mov    ecx, 4 [ebp]	\ ecx=src
  cmp    ebx, # 0
  nz, if,
    begin,
      mov  al, 0 [ecx]
      lea  ecx, 1 [ecx]
      mov  0 [edx], al
      sub  ebx, # 1
      lea  edx, 1 [edx]
    z, until,
  then,
  mov       ebx, 8 [ebp]
  lea       ebp, #12 [ebp]
  next,
end-code
))
code cmove	\ src dest len --
\ load parameters
  mov    edx, 0 [ebp]	\ edx=dest
  mov    ecx, 4 [ebp]	\ ecx=src
			\ ebx=len
\ check for overlap
  lea    eax, 0 [ecx] [ebx]	\ eax = src+len
  cmp    eax, edx		\ edx = dest
  jbe    cmopt			\ src+len <= dest ; no overlap
  lea    eax, 0 [edx] [ebx]	\ eax = dest+len
  cmp    ecx, eax		\ ecx = src
  jbe    cmslow			\ src <= dest+len ; overlap
\ optimised move - 4 bytes at a time
l: cmopt
  push   ebx		\ ebx=len
  shr    ebx, # 2	\ number of cells to move
  nz, if,
    begin,		\ copy cells
      mov    eax, 0 [ecx]
      lea    ecx, 4 [ecx]
      mov    0 [edx], eax
      sub    ebx, # 1
      lea    edx, 4 [edx]
    z, until,
  then,
  pop    ebx
  and    ebx, # 3	\ number of bytes to move
  nz, if,
    begin,		\ copy bytes
      mov    al, 0 [ecx]
      lea    ecx, 1 [ecx]
      mov    0 [edx], al
      sub    ebx, # 1
      lea    edx, 1 [edx]
    z, until,
  then,
  mov       ebx, 8 [ebp]
  lea       ebp, #12 [ebp]
  next,
\ classical one byte at a time move
l: cmslow
  cmp    ebx, # 0
  nz, if,
    begin,
      mov  al, 0 [ecx]
      lea  ecx, 1 [ecx]
      mov  0 [edx], al
      sub  ebx, # 1
      lea  edx, 1 [edx]
    z, until,
  then,
  mov       ebx, 8 [ebp]
  lea       ebp, #12 [ebp]
  next,
end-code

((
code cmove>	\ src dest len --
  mov    ecx, 4 [ebp]	\ ecx=src
  mov    edx, 0 [ebp]
  cmp    ebx, # 0
  nz, if,
    lea    ecx, -1 [ecx] [ebx]
    lea    edx, -1 [edx] [ebx]
    begin,
      mov    al, 0 [ecx]
      sub    ebx, # 1
      lea    ecx, -1 [ecx]
      mov    0 [edx], al
      lea    edx, -1 [edx]
    z, until,
  then,
  mov       ebx, 8 [ebp]
  lea       ebp, #12 [ebp]
  next,
end-code
))
code cmove>	\ src dest len --
\ load parameters
  mov    ecx, 4 [ebp]	\ ecx=src
  mov    edx, 0 [ebp]	\ edx=dest
			\ ebx=len
\ check for overlap
  lea    eax, 0 [ecx] [ebx]	\ eax = src+len
  cmp    eax, edx		\ edx = dest
  jbe    cm>opt			\ src+len <= dest ; no overlap
  lea    eax, 0 [edx] [ebx]	\ eax = dest+len
  cmp    ecx, eax		\ ecx = src
  jbe    cm>slow		\ src <= dest+len ; overlap
\ optimised move - four bytes at a time
l: cm>opt
  push   ebx		\ ebx=len
  lea    ecx, -4 [ecx] [ebx]	\ point to last cells
  lea    edx, -4 [edx] [ebx]
  shr    ebx, # 2	\ number of cells to move
  nz, if,
    begin,
      mov    eax, 0 [ecx]
      sub    ebx, # 1
      lea    ecx, -4 [ecx]
      mov    0 [edx], eax
      lea    edx, -4 [edx]
    z, until,				\ points to NEXT cells
  then,
  pop    ebx		\ EBX=len
  and    ebx, # 3	\ number of bytes to move
  lea    ecx, 3 [ecx]			\ adjust cell to byte addresses
  lea    edx, 3 [edx]
  nz, if,
    begin,
      mov    al, 0 [ecx]
      sub    ebx, # 1
      lea    ecx, -1 [ecx]
      mov    0 [edx], al
      lea    edx, -1 [edx]
    z, until,
  then,
  mov       ebx, 8 [ebp]
  lea       ebp, #12 [ebp]
  next,
\ classical byte by byte move
l: cm>slow
  cmp    ebx, # 0
  nz, if,
    lea    ecx, -1 [ecx] [ebx]
    lea    edx, -1 [edx] [ebx]
    begin,
      mov    al, 0 [ecx]
      sub    ebx, # 1
      lea    ecx, -1 [ecx]
      mov    0 [edx], al
      lea    edx, -1 [edx]
    z, until,
  then,
  mov       ebx, 8 [ebp]
  lea       ebp, #12 [ebp]
  next,
end-code

[then]
\ ...SFP006

code ucmove	\ src dest len --
\ As CMOVE but converts to upper case.
  mov    edx, 0 [ebp]	\ edx=dest
  mov    ecx, 4 [ebp]	\ ecx=src
  cmp    ebx, # 0
  nz, if,
    begin,
      mov    al, 0 [ecx]
      lea    ecx, 1 [ecx]
      cmp    al, # char a
      ae, if,
        cmp    al, # char z
        be, if,
          and    al, # $0DF
        endif,
      endif,
      sub    ebx, # 1
      mov    0 [edx], al
      lea    edx, 1 [edx]
    z, until,
  then,
  mov    ebx, 8 [ebp]
  lea    ebp, #12 [ebp]
  next,
end-code

code ucmove>	\ src dest len --
\ As CMOVE> but converts to upper case.
  mov    ecx, 4 [ebp]	\ ecx=src
  mov    edx, 0 [ebp]
  cmp    ebx, # 0
  nz, if,
    lea    ecx, -1 [ecx] [ebx]
    lea    edx, -1 [edx] [ebx]
    begin,
      mov    al, 0 [ecx]
      lea    ecx, -1 [ecx]
      cmp    al, # char a
      ae, if,
        cmp    al, # char z
        be, if,
          and    al, # $0DF
        endif,
      endif,
      sub    ebx, # 1
      mov    0 [edx], al
      lea    edx, -1 [edx]
    z, until,
  then,
  mov    ebx, 8 [ebp]
  lea    ebp, #12 [ebp]
  next,
end-code


\ ************
\ Name hashing
\ ************

\ If you change the hash function, you MUST also change the
\ hash functions in the cross compiler VfxHead.fth, the target
\ files KERNEL.FTH and REQDCODE.FTH to be the same.
((
compiler
: OldHash	\ c-addr len -- hash
  swap c@ +				\ count & first char
;

: NewHash1	\ c-addr len -- hash
  tuck  over c@ -rot			\ -- len first caddr len
  + 1- c@				\ -- len first last
  + +					\ -- hash
;

: NewHash2	\ c-addr len -- hash
  tuck  over c@ 1 lshift -rot		\ -- len first caddr len
  + 1 - c@ 2 lshift			\ -- len first last
  + +					\ -- hash
;

: NewHash3	\ caddr len -- hash ; previous best
  tuck					\ -- len caddr len
  over c@ 2 lshift -rot			\ -- len first caddr len
  + 1 - c@ 4 lshift			\ -- len first last
  + +					\ -- hash
;

: NewHash4	\ caddr len -- hash
  0 -rot  bounds
  do  1 lshift  i c@ +  loop
;

: NewHash5	\ caddr len -- hash
  dup 3 and 6 lshift -rot	\ -- len' caddr len
  over c@ 3 lshift -rot		\ -- len' first' caddr len
  + 1 - c@			\ -- len' first' last
  + +				\ -- hash
;
target
))

\ $8FDB equ CRCPoly
 $A001 equ CrcPoly
\ $013C equ CrcPoly

align
l: CRCTBL  #256 2* ALLOT

interpreter
: INIT-CRC16-TABLE	\ --
  #256 0 DO
    I  8 0 DO
      DUP 1 AND
      swap 1 rshift swap
\      >R  1 RSHIFT  R>
      IF  CrcPoly XOR  THEN
    LOOP
    I 2*  CRCTBL + W!
  LOOP
;
target
INIT-CRC16-TABLE

((
compiler
: CRC-16	\ crc byte -- crc'
  OVER  XOR  255 AND  2* CRCTBL + W@  SWAP  8 RSHIFT  XOR
;

: CRChash1	\ caddr len -- hash
  dup 3 lshift -rot		\ crc caddr len
  bounds ?do			\ -- crc
    i c@ crc-16
  loop
  $FFFF and
;

: GenHash	\ caddr len -- hash
  CRChash1
;
target
))

code GenHash	\ caddr len -- hash
  mov   ecx, ebx			\ ECX = len
  mov   ebx, 0 [ebp]			\ EBX = addr
  lea   ebp, 4 [ebp]			\ update stack
  lea   edx, 0 [ecx*8]			\ EDX = crc = len<<3
  jecxz ghx
    movzx eax, byte 0 [ebx]		\ first byte	i c@	\ -- crc byte
    lea   ebx, 1 [ebx]
  begin,
\    movzx eax, byte 0 [ebx]		\ next byte	i c@	\ -- crc byte
\    lea   ebx, 1 [ebx]
    xor   eax, edx			\		over xor
    and   eax, # $FF			\		255 and
    shr   edx, # 8			\ avoid pipeline stutter
    movzx eax, word CRCTBL [eax*2]	\		2* CRCTBL + W@
\    shr   edx, # 8			\		swap 8 rshift
    xor   edx, eax			\		xor
    sub   ecx, # 1
    movzx eax, byte 0 [ebx]		\ next byte	i c@	\ -- crc byte
    lea   ebx, 1 [ebx]
  z, until,
l: ghx
  mov   ebx, edx			\ return hash value
  and   ebx, # $FFFF
  ret
end-code

