//  VFX Forth tests of OSX 10.7 dlopen() and friends and Mach-O format

// Build with:
//  /usr/bin/gcc -m32 -o osxopen osxopen.c

#include <stdio.h>
#include <mach-o/loader.h>
#include <dlfcn.h>

const char szAAA[] = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
const char szlibname[] = "/usr/lib/libSystem.B.dylib" ;
const char szprintf[] = "printf" ;

const char szformat[] = "Hello from %s, my number is %d\n";
const char szmyname[] = "Stephen";
const int mynum = 12345678;

int (*pprintf)(const char *, ...);
const char szZZZ[]=" ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";

int main( int argc, char *argv[] )
{

   int res;
   void *hlib;
   void *pfunc;

   hlib = dlopen( szlibname, RTLD_LAZY );
   if( hlib == NULL ) return 1;
   pfunc = dlsym( hlib, szprintf );
   if ( pfunc == NULL ) return 2;
   pprintf = pfunc;
   res = (*pprintf)( szformat, szmyname, mynum );
   if (res < 0 ) return 3;

   res = dlclose( hlib );

   return 0;
}
