\ VfxSupp.fth - support shared library access

((
Copyright (c) 1999-2004, 2006, 2008, 2009, 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
20180504 SFP007 VFX 5.0 changes
20090129 SFP006 Updated for NXCALL
20080205 VRW005 Linux overhaul/rewrite.
20061115 SFP004 Moved initialisation to SysPatch.fth.
20040607 SFP003 Added version number call initialisation
20030917 SFP002 Changed DLL startup detection
20020409 SFP001 Extended conversion string size in WinInteger?
))

also system definitions
: isWinInteger?	{ caddr len | zstr[ #256 ] n[ cell ] -- d|n|X 2|1|0 }
  caddr len #255 umin isInteger?
  dup 0= suppcall @ 0<> and if
    caddr len #255 umin zstr[ zplace
    n[ zstr[ suppcall @ 2 nxcall if
      drop n[ @ 1
    then
  then
;
assign isWinInteger? to-do isNumber?
((
: winINTEGER?	{ caddr | zstr[ #256 ] n[ cell ] -- d|n|X 2|1|0 }
  caddr integer?
  dup 0= suppcall @ 0<> and if
    caddr zstr[ caddr>zaddr
    n[ zstr[ suppcall @ 2 nxcall if	\ SFP006
      drop n[ @ 1
    then
  then
;
assign winINTEGER? to-do number?
))
previous definitions

also system
: #OsConstants	\ -- u
  NumCall @ if
    NumCall @ 0 nxcall
  else
    0
  endif
;
previous



\ =============================
\ VfxSupp extension to SIMILARS
\ =============================

-short-branches

: supsim	{ z$addr | notfound index res[ 256 ] -- }
  [ also system ] suppcall [ previous ] @ if
    0 -> index
    true -> notfound
    begin
      index -1 <> halt? 0= and
    while
      res[ index z$addr [ also system ] simcall [ previous ] @
      3 nxcall				\ SFP006
      dup -1 <> if
        1+  notfound if
          cr cr ." Words in VFX support library:" cr
	  false -> notfound
        endif
        res[ ASCIIz>$ .tabword
      endif
      -> index
    repeat
  endif
;

+short-branches

: dosupsim	\ --
  here $>ASCIIz supsim
;
assign dosupsim to-do similars-extension

