\ CONSOLE.FTH - character I/O for TTY devices

((
Copyright (c) 1997-2004, 2005, 2007
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
20071126 SFP005 Added Unix/DOS sensitivity.
20071102 SFP004 Changed KEY again to speed message handling.
20070806 SFP003 Added 2 ms time delay in KEY.
20070624 SFP002 Added Multitasker hook for Windows version
20050701 SFP001 Added multitasker hook for DOS version.
		Changed ACCEPT to use current SID for KEY.
))


Target_386_Linux [if]
  #10 equ EOLchar_con		\ character marking end of line
  #13 equ IGNchar_con		\ character to ignore
[else]
  #13 equ EOLchar_con		\ character marking end of line
  #10 equ IGNchar_con		\ character to ignore
[then]

also system definitions

struct console-sid      \ -- len ; defines the SID of a console device
  gen-sid +                             \ reuse field names of GEN-SID
end-struct

: open-console    \ addr len attribs sid -- handle/sid ior
  nip nip nip 0
  $40 c/line !
;

: close-console   \ sid -- ior
  drop 0
;

: read-console    \ addr len sid -- ior
  2drop drop
  0
;

: write-console   \ addr len sid -- ior
  2drop drop
  0
;

: key?-console	\ sid -- 0
  drop OS_KEY?
;

Target_386_WDosX [if]
: key-console   \ sid -- key ; SFP001
  drop
  begin OS_KEY? 0= while pause repeat
  OS_KEY
;
[else]
: key-console   \ sid -- key ; SFP001
  drop
  begin OS_KEY? 0= while  emptyidle 2 ms  repeat	\ SFP003, SFP004
  OS_KEY
;
[then]

: ekey?-console   \ sid -- flag ; SFP001
  key?-console
;

: ekey-console    \ sid -- echar ; SFP001
  key-console
;

: emit-console    \ char sid --
  1 out +!
  drop OS_EMIT
;

: emit?-console   \ sid -- flag
  drop  true  ;

: type-console    \ *ptr length sid --
  over 0> if
    drop  dup out +!
    os_type
  else
    2drop drop
  then
;

: cr-console      \ sid --
[defined] os_cr [if]
  drop  os_cr
[else]
  #13 over emit-console  #10 swap emit-console
[then]
  out off  op-line# incr
;

: lf-console      \ sid --
  cr-console
;

: ff-console      \ sid -- ; page/cls on display devices
  cr-console
;

: bs-console      \ sid -- ; destructive on display devices
  #8 swap emit-console
;

: accept-console  { address maxlen sid | len -- len' }

  0 -> len

  address maxlen bounds ?do
    case  sid key-console

\ [ Target_386_Linux ] [IF] dup #127 = if drop #8 then [THEN]
      dup #127 = if  drop #8  then	\ treat DEL as BS

      #8 of                             \ <BACKSPACE>
        len 0<> if                      \ if not at left edge
          len 1- -> len                 \ decrement length
          #8 emit  #32 emit  #8 emit
          -1                            \ +LOOP modification -1
        else
          0                             \ Don't increment Loop
        then
      endof

      #9 of                             \ <TAB>
        bl dup emit  i c!               \ treat as space
        len 1+ -> len
        1
      endof

      EOLchar_con of                    \ <CR> for DOS/Win, <LF> for Unices ; SFP005
        bl dup emit                     \ output a <SPACE>
        i c!                            \ store on end of string
        leave                           \ and leave
      endof

      IGNchar_con of                    \ <LF> for DOS/Win, <CR> for Unices ; SFP005
        0				\ ignore
      endof

      dup emit                          \ DEFAULT
      i c!                              \ store char in buffer
      len 1+ -> len                     \ increment string length
      1                                 \ modify address by 1 (+LOOP)

    end-case
  +loop

  len
;

: bell-console    \ sid -- ; audible beeper
  drop  ;

: setpos-console  \ x y mode sid -- ior
  2drop 2drop 0  ;

: getpos-console  \ mode sid -- x y ior
  2drop  0 0 0  ;

: ioctl-console   \ addr len fn sid -- ior
  2drop 2drop  0  ;

: flushOP-console \ sid -- ior
  drop 0  ;

: RFU-console     \ --
  1 abort" RFU not supported"  ;

: init-console    \ addr len sid -- ior
  drop 2drop  0  ;

: term-console    \ sid -- ior
  drop  0  ;

: config-console  \ sid -- ior ; produces a dialog
  drop  0  ;

create console-vectors
  ' Open-console ,
  ' Close-console ,
  ' Read-console ,
  ' Write-console ,
  ' Key-console ,
  ' Key?-console ,
  ' Ekey-console ,
  ' EKey?-console ,
  ' Accept-console ,
  ' Emit-console ,
  ' Emit?-console ,
  ' Type-console ,
  ' CR-console ,
  ' LF-console ,
  ' FF-console ,
  ' BS-console ,
  ' Bell-console ,
  ' setpos-console ,
  ' Getpos-console ,
  ' Ioctl-console ,
  ' FlushOP-console  ,
  ' RFU-console ,
  ' Init-console ,
  ' Term-console ,
  ' config-console ,

previous definitions

also system

: console:      \ -- ; -- addr
  create
    0 ,                         \ handle
    ['] console-vectors >body ,	\ vector
    0 , 0 ,                     \ stdin stdout
;


\ ================================
\ Install VFX Forth default device
\ ================================

console: default-console

: init-io	\ --
  default-console dup ip-handle ! dup op-handle !  to PauseConsole
  NULL NULL NULL open-gen 2drop
;
' init-io AtCold

previous

\ =============================================================================
