\ ENVIRON.FTH - environment string definitions

((
Copyright (c) 1997-2001, 2003, 2012
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====
Document it!

Change history
==============
20120705 SFP003 Documentation overhaul.
20111010 SFP002 Exposed more after Forth200x meeting.
20030401 SFP001 Fixed value returned by ADDRESS-UNIT-BITS from 32 to 8.
))

\ ========
\ *> tools
\ *S ENVIRONMENT queries
\ ========
\ *P The ENVIRONMENT system was defined by ANS Forth to enable
\ ** you to find out about the underlying Forth system. The needs
\ ** of modern portable libraries have proven the ENVIRONMENT system
\ ** to be inadequate and so it is little used. The ENVIRONMENT
\ ** system may be removed in a future standard.

\ *P You use the system through the word *\fo{ENVIRONMENT?}
\ *C  caddr len -- false | i*x true
\ *P where *\i{caddr/len} represents the name of a query. If the
\ ** system does not know this query, it just returns false (0).
\ ** If it does know the query, it return the relevant value with
\ ** true (-1) on top of the stack.

\ *P In VFX Forth, *\fo{ENVIRONMENT?} is implemented by searching
\ ** a vocabulary called *\fo{ENVIRONMENT}. If the query is found,
\ ** it is executed.

\ =====================
\ *N Predefined queries
\ =====================
\ *P The words in this section are defined in the *\fo{ENVIRONMENT}
\ ** vocabulary.

also environment definitions

#255 constant /COUNTED-STRING	\ -- n
\ *G Maximum length of a counted string.

picnumsize constant /HOLD	\ -- n
\ *G Maximum size of HOLD area.

padsize constant /PAD		\ -- n
\ *G Maximum size of PAD.

8 constant ADDRESS-UNIT-BITS	\ -- n
\ *G Number of bits in an address unit (byte in this system).

true constant CORE		\ -- TRUE
\ *G The full CORE wordset is present.

true constant CORE-EXT		\ -- TRUE
\ *G The full CORE-EXT wordset is present.

false constant FLOORED		\ -- flag
\ *G The standard division operators use symmetric (normal)
\ ** division.

#255 constant MAX-CHAR		\ -- u ; max value of char
\ *G Characters are 8 bit units.

64bit? [if]
: MAX-D		\ -- d
\ *G Maximum positive value of a double number.
  lit#64 $FFFF:FFFF,FFFF:FFFF  lit#64 $7FFF:FFFF,FFFF:FFFF
;

: MAX-N		\ -- n
\ *G Maximum positive value of a single signed number.
  lit#64 $7FFF:FFFF,FFFF:FFFF
;

: MAX-U		\ -- u ; max size unsigned number
\ *G Maximum value of a single unsigned number.
  -1
;

: MAX-UD	\ -- u ; max size unsigned double
\ *G Maximum value of a double unsigned number.
  -1 -1
;
[then]

32bit? [if]
: MAX-D		\ -- d
\ *G Maximum positive value of a double number.
  $FFFFFFFF $7FFFFFFF
;

: MAX-N		\ -- n
\ *G Maximum positive value of a single signed number.
  $7FFFFFFF
;

: MAX-U		\ -- u ; max size unsigned number
\ *G Maximum value of a single unsigned number.
  $FFFFFFFF
;

: MAX-UD	\ -- u ; max size unsigned double
\ *G Maximum value of a double unsigned number.
  $FFFFFFFF $FFFFFFFF
;
[then]

rp-size cell / constant RETURN-STACK-CELLS	\ -- n
\ *G Maximum size of the return stack (in cells).

sp-size cell / constant STACK-CELLS	\ -- n
\ *G Maximum size of the data stack (in cells).

true constant EXCEPTION		\ -- TRUE
\ *G EXCEPTION word-set is present.

true constant EXCEPTION-EXT	\ -- TRUE
\ *G EXCEPTION EXT word-set is present.

previous definitions


\ =============
\ *N User words
\ =============

' environment >body @ constant environment-wordlist	\ -- wid
\ *G The wid used by *\fo{ENVIRONMENT?} for look ups. You can add
\ ** your own queries to this wordlist.

: ENVIRONMENT?  \ c-addr u -- false | i*x true                  6.1.1345
\ *G The text string c-addr/u is of a keyword from ANS 3.2.6
\ ** Environmental queries or the optional word sets to be checked
\ ** for correspondence with an attribute of the present environment.
\ ** If the system treats the attribute as unknown, the returned flag
\ ** is false; otherwise, the flag is true and the i*x returned is of
\ ** the type specified in the table for the attribute queried.
  ['] environment >body @
  search-wordlist dup			\ see if name exists
  if  drop execute true  then		\ yes
;

: [environment?]	\ "string" -- false | i*x true
\ *G As *\fo{ENVIRONMENT?} but is IMMEDIATE and takes the string
\ ** from the input stream.
  parse-name environment?  ;  immediate

: .environment	\ --
\ *G Display a list of queries.
  also environment words previous  ;


\ ======
\ *> ###
\ ======

