\ VERSION.FTH - version information

((
Copyright (c) 1997-2003, 2019
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
20190301 GFW001 shorter, non-clearing greeting on Linux
))


decimal

create rel-date	 32 allot 0 rel-date c!
create short-rel-date 11 allot 0 short-rel-date c!
create version#  64 allot 0 version# c!

\ Helpful words

: n>str		\ n -- addr len
  0 <# #S #>
;

: 0n>str	\ n -- addr len
  \ 2 digits, leading zero if single digit
  0 <# # # #>
;

: BuildDateString       \ -- ; Fills REL-DATE with the build date.
  decimal
  time&date	\ -- seconds mins hours day month year
  rot n>str rel-date place		\ process day
  case  swap				\ process month
    1  of s"  January "   endof
    2  of s"  February "  endof
    3  of s"  March "     endof
    4  of s"  April "     endof
    5  of s"  May "       endof
    6  of s"  June "      endof
    7  of s"  July "      endof
    8  of s"  August "    endof
    9  of s"  September " endof
    10 of s"  October "   endof
    11 of s"  November "  endof
    12 of s"  December "  endof
          rel-date 0  swap
  endcase
  rel-date append
  n>str rel-date append			\ process year
  3drop					\ discard s/m/h

  time&date
  n>str  short-rel-date place
  s" -"  short-rel-date append
  0n>str short-rel-date append
  s" -"  short-rel-date append
  0n>str short-rel-date append
  3drop
;

: .release	\ -- ; print the release info
  cr ."  Version: " version# $.
  cr ."  Build date: " rel-date $.
;

: .short-release \ -- ; print short release info
  version# $.
  ."  " short-rel-date $.
;

align
Target_386_Windows
Target_386_WDosX
or [if]
l: copyright-string
  ",   MicroProcessor Engineering Ltd, "	\ $23 characters
[else]
l: copyright-string
  $23 c,					\ string length
  $C2 c, $A9 c,					\ UTF-8 copyright symbol
  z",  MicroProcessor Engineering Ltd, "
[then]

: (.cold)	\ -- ; print the sign on message
\ copyright-date is in VfxForth.ctl
  page
  cr
  ."  " product-title $. ."  for " host_target $. space cpu_target $. cr
  ."  " copyright-string $.  copyright-date $. cr
  .release cr cr  ."  " .free cr
  cr
;

: (.short-cold)	\ -- ; print a short sign on message
  product-title $. ."  " .short-release
  ."  for " host_target $. space cpu_target $. cr
  copyright-string $.  copyright-date $. cr
;

Target_x64_Linux  Target_386_Linux or  Target_ARM_Linux  or [if]
  assign (.short-cold) to-do .cold
[else]
  assign (.cold) to-do .cold
[then]
