\ Docgen test file

\ ======
\ *! dg4test
\ *T DocGen tests
\ ======

\ ******************************
\ *SE Tags with three characters
\ ******************************
\ *PA A paragraph produced by a three-character tag '*PA'.
\ *** and this is the continuation.

\ ====================
\ *H A simple heading.
\ ====================

\ *PA Division produces a quotient q and a remainder r by dividing
\ *** operand a by operand b. Division operations return q, r, or
\ *** both. The identity
\ *CD   b*q + r = a
\ *PA shall hold for all a and b.

\ ****************
\ *SE Conditionals
\ ****************
\ *IF  1
\ *PA This line should show 1111111
\ *EL
\ *PA This line should show 0000000
\ *TH

\ *IF  0
\ *PA This line should show all 1111111s
\ *EL
\ *PA This line should show all 0000000s
\ *TH


\ ========
\ *SE Words
\ ========

: foo1  ( -- )
\ *GL Says hello
  ." hello"  ;
: foo2  ( -- )
\ *GL Says goodbye
  ." goodbye"  ;

\ ========
\ *SE lists
\ ========

\ -----------------
\ *N Old style list
\ -----------------
\ *P Old style list
\ *B Item 1
\ ** continue item 1 text
\ *B Item 2
\ *B Item 3

\ ------------------
\ *SS New style lists
\ ------------------
\ *PA New style lists
\ *L(
\ *IT Item 1
\ *IT Item 2
\ *L( A
\ *IT Item 2A
\ *IT Item 2B
\ *IT Item 2C
\ *L)
\ *IT Item 3
\ *L( a
\ *IT Item 3a
\ *IT Item 3b
\ *IT Item 3c
\ *L)
\ *L)

\ *L( 1
\ *B Item 1
\ *B Item 2
\ *B Item 3
\ *L)

\ *L( A
\ *IT Item 1
\ *IT Item 2
\ *IT Item 3
\ *L)

\ *L( a
\ *IT Item 1
\ *IT Item 2
\ *IT Item 3
\ *L)

\ -----------------
\ *N Old style list
\ -----------------
\ *P Old style list
\ *B Item 1
\ *B Item 2
\ *B Item 3

\ *L

\ ==============
\ *T Macro usage
\ ==============

\ ================
\ *S Simple Macros
\ ================

\ *P Displays text in a fixed *\fixed{typewriter}font.

\ *P More fixed text *\f{ : 1+ 1 + ; }.

\ *P Do some inline forth *\fo{\#no-name: QUIT},.

\ *P Do some inline forth *\forth{: 1+ 1 + ;},.

\ *P Make text italic *\italic{Italic}.

\ *P Make text italic *\i{Other italic text.}.

\ *P Make text bold *\bold{Bold}.

\ *P Make text bold *\b{#Bold text.}.

\ *P This sentence needs a line break *\br{ffdgf}, text between {} gets ignored.

\ *P There comes a time in every sentence's life when a *\starbslash{} is required.

\ *********
\ *S Tables
\ *********

\ *P *\table{ "Cortex Register usage" 20 20 60 }
\ ** *\hrow{} *\col{} Cortex register *\col{} Forth register *\col{} Notes
\ ** *\row{} *\col{} R15 or PC *\col{} IP
\ ** *\col{} The program counter. Altering this register will
\ ** cause the processor to jump to a new address.
\ ** *\row{} *\col{} R14 or LINK *\col{} _
\ ** *\endtable{}


\ =======================================
\ *T Dictionary Organisation/Manipulation
\ =======================================
\ *P The heart of any Forth system is the dictionary. There are two
\ ** types of word which act on the dictionary. The first are those
\ ** words which act on definition headers, whilst the second set act on
\ ** dictionary "data-space."

\ ******************************
\ *S Definition Header Structure
\ ******************************
\ *P Definitions created with any standard defining word except
\ ** *\fo{:NONAME} have a header within the dictionary. The header
\ ** format is:
( *E Link | Ctrl | Count | <name> | Term | Line# | Info | XRef | Len/xt | Cgen )
( ** ------------------------------------------------------------------------- )
( ** Cell | Byte |  Byte | n Bytes| Byte |  Word | Word | Cell |  Cell  | Cell )
( ** ------------------------------------------------------------------------- )
( *D Link       Also called LFA. This field contains the address of the )
( **            "Ctrl Byte" of the previous word in the same wordlist.  )
\ *D Ctrl       The Control Byte: The top three bits are all set.
\ **            The lower five bits are:
\ *E            Bit4    SYNONYM bit
\ **            Bit3    Smudge bit
\ **            Bit2    Immediate bit
\ **            Bit1    ** bit
\ **            Bit0    *** bit
( *D Count      Also called the Count Byte. This field contains a byte  )
( **            which is the length of the name.                        )
( *D <name>     A string of ASCII characters which make up the     )
( **            definition name.                                        )
( *D Term       All definition names are terminated with a 0 ASCII byte.)
( *D Line#      This field holds the line number of the first line of   )
( **            source which built the definition. The actual source    )
( **            file reponsible can be found from the SOURCES structure )
( **            described in the FILE section of this manual.           )
\ *D Info       MPE/CCS Reserved field.
\ **            low byte for MPE, high byte for CCS
\ **            bit 0: 1 = optimised
\ **            bits 7:4 = RS undershoot.
( *D XRef       Pointer to XREF Information                             )
\ *D Len/xt     Binary length of the word, or the xt of the code generator
\ **            for this word.
\ *D Cgen       Holds the address of additional code generator information.

\ *P Image example *\image{"logo text 1" "technics" "jpg" 50 100}


\ *#
\ *> ###
