\ User extensible versions of VALUE and locals

((
Copyright (c) 1999, 2002
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)2380 631441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com


To do
=====

Change history
==============
20090409 SFP002 Converted for v4.3.
20020306 SFP001 Converted to use SEARCH-RANGE instead of SEARCH-BASE.
))

\ *************
\ Support words
\ *************

\ requires LIB\SWITCHES

here constant valtop			\ avoid redefinition problems

: val(		\ -- ; macro ; )
\  ?comp
  s" search-range 2@ 2>r  search-ovl @ >r  0 valtop search-base !" evaluate
; immediate

: )val		\ -- ; macro
\  ?comp
  s" r> search-ovl !  2r> search-range 2!" evaluate
; immediate


\ *********************
\ Value chain and VALUE
\ *********************

[switch value-chain bad-method		\ extensible chain for VALUE
  0 run:  val( s" @" evaluate )val  ;
  1 run:  val( s" !" evaluate )val  ;
  2 run:  ( noop )  ;
  3 run: val( s" 1 swap +!" evaluate )val ;
  4 run: val( s" -1 swap +!" evaluate )val ;
  5 run: val( s" +!" evaluate )val ;
  6 run: val( s" off" evaluate )val ;
  7 run: val( s" swap negate swap +!" evaluate )val ;
  8 run: val( s" drop cell" evaluate )val ;
  9 run: val( s" on" evaluate )val ;
switch]

: exValComp,	\ xt --
\ Compiler for VALUE below.
  [compile] literal  OperatorType @off value-chain

: value         \ n -- ; ??? -- ???
  create
    ,  ['] exValComp, set-compiler
  interp>
    OperatorType @off value-chain
;


\ ***************
\ Extended locals
\ ***************

[switch local-chain bad-method		\ offset type -- ; extensible chain for locals
  0 runs lv@,
  1 runs lv!,
  2 runs lv,
  3 run:  lv,  postpone incr  ;
  4 run:  lv,  postpone decr  ;
  5 run:  lv,  postpone +!  ;
  6 run:  lv,  postpone off  ;
  7 run:  postpone negate  lv,  postpone +!  ;
  8 run:  drop  postpone cell  ;
  9 run:  lv,  postpone on  ;
switch]

: exlvarg,	\ offset -- ; process locals
  OperatorType @off  local-chain
;
assign exlvarg, to-do s_lvarg,

[switch local[-chain bad-method		\ offset -- ; extensible chain for local arrays
  0 runs lv,
  2 runs lv,
switch]

: exlvarray,	\ offset -- ; process local arrays
  OperatorType @off  local[-chain
;
assign exlvarray, to-do s_lvarray,

