\ TSEPOS 169 9 25 \
\ =======================================================================
( *> GENIO                                                              )
( **                                                                    )
( *N NULL Device                                                        )
( **                                                                    )
( *P This Generic IO Device is used as a bit bucket for unwanted output.)
( ** When used as input KEY? is always false and and read will never    )
( ** return.                                                            )
( **                                                                    )
( *P In order to create a device use the NULLDEV: definition given      )
( ** later.                                                             )
( **                                                                    )
( *P When opening a null device the parameters to OPEN-GEN have no      )
( ** meaning.                                                           )
\ =======================================================================

                MODULE  GENIO-NULL

struct nulldev-sid
  gen-sid +                             \ reuse field names of GEN-SID
end-struct

: nulldev-open          \ caddr len fam sid -- sid ior
  nip nip nip 0
;

: nulldev-close         \ sid -- ior
  drop 0
;

: nulldev-read          \ addr len sid -- ior
  3drop 0
;

: nulldev-write         \ addr len sid -- ior
  3drop 0
;

: nulldev-key           \ sid -- char
  begin busyidle again
;

: nulldev-key?          \ sid -- flag
  drop 0
;

: nulldev-ekey          \ sid -- echar
  begin busyidle again
;

: nulldev-ekey?         \ sid -- flag
  drop 0
;

: nulldev-accept        \ addr len sid -- len'
  begin busyidle again
;

: nulldev-emit?         \ sid -- flag
  drop 0
;

: nulldev-type          \ addr len sid --
  3drop
;

: nulldev-emit          \ char sid --
  2drop
;

: nulldev-cr            \ sid --
  drop
;

: nulldev-lf            \ sid --
  drop
;

: nulldev-ff            \ sid -- ; page/cls on display devices
  drop
;

: nulldev-bs            \ sid -- ; destructive on display devices
  drop
;

: nulldev-bell          \ sid -- ; audible beeper
  drop
;

: nulldev-setpos        \ x y mode sid -- ior
  4drop 0
;

: nulldev-getpos        \ mode sid -- x y ior
  2drop 0 0 0
;

: nulldev-ioctl         \ addr len fn sid -- ior
  4drop 0
;

: nulldev-flushOP       \ sid -- ior
  drop 0
;

: nulldev-RFU           \ sid --
  drop
;

: nulldev-init          \ addr len sid -- ior
  3drop 0
;

: nulldev-term          \ sid -- ior
  drop 0
;

: nulldev-config        \ sid -- ior ; produces a dialog
  drop 0
;

create nulldev-vectors
  ' nulldev-open ,
  ' nulldev-close ,
  ' nulldev-read ,
  ' nulldev-write ,
  ' nulldev-Key ,
  ' nulldev-Key? ,
  ' nulldev-Ekey ,
  ' nulldev-EKey? ,
  ' nulldev-Accept ,
  ' nulldev-Emit ,
  ' nulldev-Emit? ,
  ' nulldev-Type ,
  ' nulldev-CR ,
  ' nulldev-LF ,
  ' nulldev-FF ,
  ' nulldev-BS ,
  ' nulldev-Bell ,
  ' nulldev-setpos ,
  ' nulldev-Getpos ,
  ' nulldev-Ioctl ,
  ' nulldev-FlushOP  ,
  ' nulldev-RFU ,
  ' nulldev-Init ,
  ' nulldev-Term ,
  ' nulldev-Config ,

\ =======================================================================
( *H Device Creation                                                    )
\ =======================================================================

: nulldev:        \ "name" -- ; Exec: -- sid
( *G Create a NULL Generic IO device in the dictionary.                 )
  create
    -1 ,  nulldev-vectors ,             \ handle, vector
    INVALID_HANDLE_VALUE ,              \ file-handle
    0 , 0 ,                             \ scratch
;



                EXPORT nulldev:
                END-MODULE

\ =======================================================================
( *> ###                                                                )
\ =======================================================================

