(* ====================================================================
Load scrap/paste/clipboard

copyright 2010 Roelf Toxopeus

VFX version.
Dealing with scrap on the main pasteboard a.k.a. Clipboard
Last: 14 April 2018 at 16:22:42 CEST  -rt
==================================================================== *)

(( --------------------------------------------------------------------
For now only looking for text scrap (from editors).

PUT-SCRAP -- paste/put string in clipboard. Returns true if succes.
GET-SCRAP --  copy/get text from clipboard. Returns string pair if succes,
0 0 if not.
INCLUDE-SCRAP -- include scrap as temporary file.
LOAD-SCRAP -- include/load contents clipboard if any.
-------------------------------------------------------------------- ))

/forth
decimal

cocoaclass NSPasteboard

cocoa: @generalPasteboard ( -- id ) \ NSPasteboard object
: CLIPBOARD ( -- ref ) NSPasteboard @generalPasteboard ;

global: NSPasteboardTypeString  ( text type, in NSPasteboard.h )

cocoa: @clearContents ( -- n )      \ NSInteger
cocoa: @setString:forType: ( string datatype -- flag ) \ NSString object, NSstring object -- BOOL

: PUT-SCRAP ( a n -- bool )
   clipboard @clearContents drop
   pad zplace pad >nsstring dup >r
   NSPasteboardTypeString @
   clipboard @setString:forType:
   r> @release drop ;

cocoa: @stringForType: ( type -- concatstring ) \ NSString object -- NSString object

: GET-SCRAP ( -- a n | 0 0 )
   NSPasteboardTypeString @
   clipboard @stringForType:
   dup if >4thstring  else dup  then ;

\ --------------------------------------------------------------------
\ Include contents clipboard.

: INCLUDE-SCRAP ( a n -- )
   s" /tmp/scrap.fth" r/w create-file throw
   dup >r write-file throw
   r@ flush-file drop                          \ necessary?
   0 dup r@ reposition-file throw              \ ESSENTIAL for VFX and i4
   r> include-file        ( closes file)       \ sf ok! doesn't work in VFX and i4 without REPOSITION-FILE
   \ r> close-file drop                          \ work around, first close-file
   \ s" /tmp/scrap.fth" included                 \ then include by name, ok for all
   s" /tmp/scrap.fth" delete-file drop ; 

: LOAD-SCRAP ( -- )   get-scrap dup if include-scrap exit then 2drop ;

\\ ( eof )