(* ====================================================================
Keep Forth running

copyright 2015 Roelf Toxopeus

Part of the interface to ObjC 2 Runtime.
VFX version.
Move Forth to another thread
Last: 16 Nov 2015 10:07:01 CET  -rt
==================================================================== *)

(( --------------------------------------------------------------------
Run Forth in another task (thread), pretending to be MAIN. Hence it's
name IMPOSTOR.
Global variables are used to maintain the dictionary, so no special care
have to be taken for synchronization as with SwiftForth.

MAIN'S -- use default I/O setting.
IMPOSTOR'S -- use IMPOSTOR's I/O setting.

'PRETENDING -- execution vector used by the coco-vfx startup word.
Can be used as a hook for extra initialisation.
PRETENDING -- activate and run the IMPOSTOR task.

--  some cocoa stuff invoked from Forth thread need an autorelease pool
--  new Forth thread uses Main's I/O settings
-------------------------------------------------------------------- ))

/forth
decimal

\ --------------------------------------------------------------------
\ IMPOSTOR task and behaviours.

\ stay safe for now with allocated user area
task IMPOSTOR

\ VFX MAIN task is SwiftForth OPERATOR
op-handle @ value MAIN-IO

: MAIN'S   \ -- ; set up default I/O
  ip-default @ ip-handle !
  op-default @ op-handle !
;

: IMPOSTOR'S ( -- )
   impostor op-handle his @ op-handle !
   impostor ip-handle his @ ip-handle ! ;
   
\ --- setup IMPOSTOR running Forth and MAIN runnning Cocoa:
\ see the magical fix ?!?!?

also system         \ for testing the magic typing fix

variable 'PRETENDING
variable FORTH.POOL

: PRETENDING ( -- )
   impostor activate
      finit
      allocpool forth.pool !
      main's
      s" " swap stdout @ dll_WriteFile @ 3 nxcall drop  \ (OS_Type) in syspatch.fth
      'pretending @execute ;

previous

\\ ( eof)