(* ====================================================================
Running a cocoa interface

copyright 2009 Roelf Toxopeus

Part of adding Cocoa event handling to Forth.
MFonVFX version
Running a cocoa interface on the main thread
Last: 9 February 2018 at 10:47:34 CEST   -rt
==================================================================== *)

(( --------------------------------------------------------------------
The ObjC interface will not work properly when it isn't run on the main
thread. At least wrt GUI and graphic stuff.
In MFonVFX it is run on the main thread. Cocoa and Carbon, side by side.

MAIN'S -- use main task/thread I/O setting.

/COCOALINKS -- relink all our cocoa and cocoa related words before
we can use them safely in turnkey.

COCO.RUN -- topword: init, launch ObjC runtime with NSApplicationLoad.
Setup and save autoreleasepool in main.pool. Might be drained automaticly
eventualy, so saved pool is not valid after a while.

NoTE: for turnkey remove the comment \ in front of /cocoalinks !
-------------------------------------------------------------------- ))

/forth
decimal

\ --- main thread specifics
: main's ( -- )
   main op-handle his @ op-handle !
   main ip-handle his @ ip-handle ! ;
   
\ --- the first initialization to have Cocoa in Carbon:
: /cocoalinks
   /cocoaclasses /cocoaselectors
   /forth-cocoaclasses /forth-cocoamethods /forth-cocoaivars ;

function: NSApplicationLoad ( -- ret )

variable mainpool    \ cache main autoreleasepool

cocoaclass NSApplication
cocoa: @sharedApplication ( -- NSApplication:ref )

: cocoa.run
   cr ." Not innitiating Cocoa links !"
   \ /cocoalinks   \ for turnkey, do /cocoalinks !
   NSApplicationLoad 0= abort" Oh Noooooo! Problems launching Cocoa..."
   allocPool mainpool !
   NSApplication @sharedApplication 0= abort" Can't create a shared application !" ;

\\ ( eof )
