(* ====================================================================
Appearances

Copyright 2018 Roelf Toxopeus

VFX version.
Dark and Light Mode for macOS 10.14 Mojave.
NSApp level only for now.
Last: 4 February 2019 at 13:47:52 CEST   -rt
==================================================================== *)

(( --------------------------------------------------------------------
APPEARANCE? -- test for the appearance property in object/instance.

APPEARANCE -- set object/instance to the given named appearance.
macOS versions prior to 10.14 Mojave might ignore this.

DarkMode -- set our NSApp, the Cocoa part of coco-sf, to Dark Mode.
LightMode -- set our NSApp the Cocoa part of coco-sf, to Light Mode.

Windows and views with an 'appearance' property can be individualy set
to whatever named appearances with APPEARANCE.

See:
https://developer.apple.com/documentation/appkit/nsappearance?language=objc
https://developer.apple.com/documentation/appkit/supporting_dark_mode_in_your_interface?language=objc
-------------------------------------------------------------------- ))

/forth
decimal

function: class_getProperty ( class name -- ref )

: APPEARANCE? ( id -- f )    object_getClass  z" appearance" class_getProperty 0<> ;

cocoaclass NSAppearance
cocoa: @appearanceNamed: ( NSStringRef -- NSAppearanceRef )

: APPEARANCE ( za id -- )
   dup appearance? if
      >r
      >NSString dup
      NSAppearance @appearanceNamed:
      z" setAppearance:" @selector over no r> formain drop
      @release drop @release DROP  ( could be released too soon!)
   else  2drop then ;
   
: DarkMode ( -- )   z" NSAppearanceNameDarkAqua" NSApp @ appearance ;

: LightMode ( -- )   z" NSAppearanceNameAqua" NSApp @ appearance ;

\\ ( eof)

