(* ====================================================================
Background Window

copyright 2010 Roelf Tooxpeus

VFX version.
Implements NSWindow subclass BigWindowClass.
In use as curtain to hide desktop and other applications from view
Can't be brought to the front (I hope)
Last: 4 February 2019 at 13:13:30 CEST  -rt
==================================================================== *)

/forth
decimal

cocoa: @windowNumbersWithOptions: ( options -- array )                     \ NSWindow
cocoa: @lastObject ( -- id )                                                \ NSArray 
cocoa: @integerValue ( -- n )                                                \ NSNUmber
cocoa: @orderWindow:relativeTo: ( orderingmode otherwindownumber -- ret )    \ NSWindow
-1 constant NSWINDOWBELOW

forthcall: *mouseDown: ( rec sel event -- ret )
    2drop >r
    nswindowbelow
    0 NSWindow @windowNumbersWithOptions: @lastObject @integerValue
    r> @orderWindow:relativeTo: ;

: BWTYPES1   0" v@:V" ;

NSWindow new.class BigWindowClass

*mouseDown: bwtypes1 0" mouseDown:" BigWindowClass add.method

BigWindowClass add.class

\ --- usage

new.window BIGWINDOW


nowidgets            bigwindow w.style
0e0 fdup fdup 1e0    bigwindow w.background
                     bigwindow full.frame  f2drop f2drop

: (NEW.BIGWINDOW) ( wptr4 -- )
   dup window.args  BigWindowClass @alloc @initWithContentRect:styleMask:backing:defer:
\ default opaque setting is YES, so need to chage it to change transparency!
   no over @setOpaque: Drop
   swap +w.ref ! ;
   
: NEW.BIGWINDOW ( -- )
   bigwindow dup +w.ref @  if bigwindow close.window then
   dup 1 0 ['] (new.bigwindow) pass 100 ms pause
   dup +w.background cg4@ dup set.wbackground
   show.window ;

\\ ( eof )