(* ====================================================================
terminate and relaunch

VFX version

Copyrught (c) 1999 Roelf Toxopeus

Last: 30 March 2018 at 12:45:19 CEST  -rt
==================================================================== *)

0 [IF]  --------------------------------------------------------------
First in PowerMacForth.

HELLO -- Sends a request to the OS to 'relaunch us' and executes BYE
to leave current Forth gracefully. This is different from the often
found COLD, we really clear out.
This can be done in the form of an Applescript or a string of commands
for the shell. The latter is used here. Relaunches in a new shell window.
Another implementation using NSWorkspace can be found in launches.fth
But see bash alternative at end!

Note: if you launched vfx in your shell with  vfx;exit  the shell window
will be closed after BYE. The newly launched vfx with HELLO is launched
this way by the   open  shell command.

Where do I need this?
I short-circuit Forth systems many times a day.
This means terminating and re-launching the used Forth system with a
minimum of fuzz.
In nearly an eye wink you're back in a fresh pristine Forth system.
Used when I think I messed up too much. For instance, I redefine a lot,
1000 x the same word if I have too. Can't be bothered (anymore) with
ANEW, MARKER, REMEMBER, FORGET etc. and even EMPTY. Just terminate and
relaunch, OS mops up after me (mostly), which is essential!

Alternative for Darwin Forth systems is executing BYE, hit up-arrow
in shell to retrieve last ran command (do a Forth) and hit return.
Same shell window is used!

Even better, launch <forth> in a loop in bash.

You can add the following to your shell profile:
function hello {
   (exit 0)              # clear exitstatus
   while [ $? = 0 ]      # $? returns exit status
   do eval $1            # $1 first argument to function
   done
}
alias HELLO=hello

Usage:  HELLO sf   hello vfx   HELLO i4 etc.

BYE will end current <forth> and a new one will be launched ad infinitum.
Close terminal window or quit Terminal to stop. Alternatively exit out of
<forth> with a non-zero exitcode.

SwfitForth:  1 EXITSTATUS ! BYE
VFX:         1 EXITCODE ! BYE
iForth:      1 TERMINATE

A simple but effective HELLO !

--------------------------------------------------------------- [THEN]

/forth
decimal

: HELLO ( -- )
   here dup >r 1024 erase
   s\" open \""               r@ zplace
   pad dup GetExeNameZ zcount r@ zappend
   s\" \""                    r@ zappend
   r> >shell bye ;

\\ ( eof)
