(* ====================================================================
CoreGraphics Affine Transform Matrices

copyright 2011 Roelf Toxopeus

VFX version.
Current transformation matrix
Use together with CGContextSaveGState and CGContextRestoreGState
Most of these transform the space, not the points!!!
Last: 15 October 2014 17:20:07 CEST  -rt
==================================================================== *)

(( --------------------------------------------------------------------
Affine Transform Matrices to transform the CGContexts

CGatf -- a pad for temporary storage of a ATM
CGATF@ -- passing the AffineTransformstructure contents for calls.
Similar to CGRECT@ etc.

For transforming the context space there is: CGTRANSLATE CGSCALE and
CGROTATE, which do what their name suggest.
-------------------------------------------------------------------- ))

\ --------------------------------------------------------------------

/forth
decimal

function: CGContextGetCTM ( *cgatf cgcontext -- ret )
function: CGContextGetUserSpaceToDeviceSpaceTransform ( *cgatf cgcontext -- ret )
\ cgatf is a structure with 6 sfloat/cell memebers to big to pass by value, a reference?
function: CGContextConcatCTM ( cgcontext *cgatf -- ret )
function: CGContextTranslateCTM ( cgcontext sf sf -- ret )
function: CGContextScaleCTM ( cgcontext sf sf -- ret )
function: CGContextRotateCTM ( cgcontext sf:radians -- ret ) \ use D>R !!

6 sfloats buffer: CGatf

\ Passing the AffineTransformstructure:
: CGATF@ ( addr -- a b c d tx ty )
   dup >r cg2@ 2fpushs r> [ 2 sfloats ] literal + cg4@ 4fpushs ;

\ Transform the context space:   
: CGTRANSLATE ( cgcontext -- ) ( F: x y -- )  2fpushs CGContextTranslateCTM drop ;

: CGSCALE ( cgcontext -- )  ( F: x y -- )  2fpushs CGContextScaleCTM drop ;

: CGROTATE ( cgcontext -- )  ( F: degrees -- )  d>r fpushs CGContextRotateCTM drop ;

cr .( Transform matrices loaded )

\\ ( eof )