(* ====================================================================
CoreGraphic Blendmodes

copyright 2006 Roelf Toxopeus

VFX version.
The possible blendmodes when displaying images in Quartz.
Last: 15 October 2014 17:07:22 CEST  -rt
==================================================================== *)

(( --------------------------------------------------------------------
Many blendmodes are defined here as constants.

BLENDMODE -- a temporary storage for current blendmode. Used by some: 
SET.BLENDMODE -- set the CGContext's blend mode.
-------------------------------------------------------------------- ))

/forth
decimal

function: CGContextSetBlendMode ( cgcontext blendmode -- ret )

32 constant blend
33 constant addpin
34 constant addOver
35 constant subPin
36 constant transparent
37 constant addMax
38 constant subOver
39 constant adMin
64 constant ditherCopy

\ CGBlendModes
: CONSTANT+ ( n1 <name> -- n2 )   dup constant 1+ ;

0
constant+ kCGBlendModeNormal
constant+ kCGBlendModeMultiply
constant+ kCGBlendModeScreen
constant+ kCGBlendModeOverlay
constant+ kCGBlendModeDarken
constant+ kCGBlendModeLighten
constant+ kCGBlendModeColorDodge
constant+ kCGBlendModeColorBurn
constant+ kCGBlendModeSoftLight
constant+ kCGBlendModeHardLight
constant+ kCGBlendModeDifference
constant+ kCGBlendModeExclusion
constant+ kCGBlendModeHue
constant+ kCGBlendModeSaturation
constant+ kCGBlendModeColor
constant+ kCGBlendModeLuminosity
constant+ kCGBlendModeClear
constant+ kCGBlendModeCopy
constant+ kCGBlendModeSourceIn
constant+ kCGBlendModeSourceOut
constant+ kCGBlendModeSourceAtop
constant+ kCGBlendModeDestinationOver
constant+ kCGBlendModeDestinationIn
constant+ kCGBlendModeDestinationOut
constant+ kCGBlendModeDestinationAtop
constant+ kCGBlendModeXOR
constant+ kCGBlendModePlusDarker
constant+ kCGBlendModePlusLighter
constant #BLENDMODES

variable BLENDMODE kCGBlendModeNormal blendmode !

: SET.BLENDMODE ( mode context -- )   swap dup blendmode ! CGContextSetBlendMode drop ;

cr .( CGBlendmode loaded)

\\ ( eof )
