(* ====================================================================
CoreGraphic Image display

copyright 2006 Roelf Toxopeus

VFX version.
Drawing pictures in a Core Graphic Context from a file or memory.
Last: 15 October 2014 17:22:04 CEST     -rt
==================================================================== *)

(( --------------------------------------------------------------------
CGImage -- a pad for a CGImage.
>CGIMAGE -- return a CGImage created from an url.
DRAW.CGIMAGE -- draw a CGImage in the context from a given window.
NoTE: the rectangle size is the display size in the window to which
the picture is scaled.
DRAWPIC -- draw picture at url in window.
-------------------------------------------------------------------- ))

/forth
decimal

quartz.framework

function: CGImageSourceCreateWithURL ( CFURLRef NULL -- CGImageSourceRef )
function: CGImageSourceCreateImageAtIndex ( CGImageSourceRef index NULL -- CGIOmageRef )
function: CGContextDrawImage ( CGContext sf:x sf:y sf:w sf:h CGImage -- ret )
function: CGImageGetWidth ( CGImage -- size:pixels )
function: CGImageGetHeight ( CGImage -- size:pixels )

variable CGImage

: >CGIMAGE ( zstringurl -- cgimage )
   >cfurl
   0 CGImageSourceCreateWithURL dup 0= abort" Can't create image form URL"
   dup 0 0 CGImageSourceCreateImageAtIndex
   swap CFRelease drop ;

: DRAW.CGIMAGE ( cgimage wptr4 -- )
   swap >r
   dup CGContext tuck
   blendmode @ over set.blendmode
   swap content.frame 4fpushs r@ CGContextDrawImage drop
   CGContextFlush drop
   r> CFRelease drop ;

: DRAWPIC ( zstringurl wptr4 -- )   >r >cgimage r> draw.cgimage ;

cr .( CoreGraphics picture loader and drawing loaded )

\\ ( eof )