(* ====================================================================
ABI call extra's

copyright 2010 Roelf Toxopeus

VFX version
Extra words wrt Mac OSX function call ABI
Last: 14 October 2014 13:50:49 CEST  -rt
==================================================================== *)

(( --------------------------------------------------------------------
2RET> and >2RET are used with passing POINTs, SIZEs, RANGEs etc.
FUNCTION: and COCOA: take care of the output parameters doing 2RET> depending
on the parameterlist passed along.
Example:   COCOA: @mouseLocation ( -- x y )

>2RET is used when a callback has to leave/pass two parameters.
Example:  the textView:willChangeSelectionFromCharacterRange:toCharacterRange:
         callback leaves a range: location and length
See:
http://developer.apple.com/library/mac/#documentation/DeveloperTools/Conceptual/LowLevelABI/130-IA-32_Function_Calling_Conventions/IA32.html%23//apple_ref/doc/uid/TP40002492-SW4
-------------------------------------------------------------------- ))

/forth
decimal

\ Retrieve second return from EDX
code 2ret> ( n -- n n2 )
   lea   ebp, -4 [ebp]
   mov   0 [ebp], ebx
   mov   ebx, edx
   next,
end-code

\ Pass a second item in EDX
code >2ret ( n --  )
   mov   edx, ebx
   mov   ebx, 0 [ebp]
   lea   ebp, 4 [ebp]
   next,
end-code

cr .( ABI call extras loaded)

\\ ( eof )