(* ====================================================================
Mach kernel task and thread stuff

copyright 2011 Roelf Toxopeus

VFX version
Last: 6 February 2011 23:21:44 CET  -rt
==================================================================== *)

(( --------------------------------------------------------------------
Utillities for Mach tasks and threads.

#THREADS -- return threadlist and current number of threads in our
task/process. This is an ever changing number!
THREAD# -- return port number id from calling thread. Same number as
used by GDB for THREAD n.
I'M -- set current forth-task's mach thread name. While including this
file, it's assumed I'm Impostor...
-------------------------------------------------------------------- ))

/forth
decimal

lacking System.framework   framework System.framework

System.framework

function: mach_task_self ( -- mach_port_t )
function: task_threads ( task *thread_list *thread_count -- ret )
function: mach_thread_self ( -- thread_port )
function: pthread_getname_np ( thread *name size -- ret )  
function: pthread_setname_np ( name -- ret )      

: #THREADS ( -- addr n )
   mach_task_self 0 >r rp@ 0 >r rp@
   task_threads drop r> r> swap ;

: THREAD# ( -- n )
   mach_thread_self
   #threads 0 do
      tuck @ over =
      if 2drop i 1+  unloop exit then
      swap cell+
   loop drop 0 ;

: I'M ( 0$name -- )   pthread_setname_np drop ;

z" impostor" i'm 

cr .( mach task and thread info loaded)

\\ ( eof )