(* ====================================================================
fp utillities

copyright 2002 Roelf Toxopeus

SwiftForth version.
Origin MacForth version, which uses PPC instructions.
FP utillities for fp stack juggling and FP parameter passing.
Last: 19 March 2018 at 08:39:05 CEST  rt
==================================================================== *)

/forth
decimal

' F2DUP 0= [IF]

(( --------------------------------------------------------------------
fp stack jugglers

Due to the Mac's usage of fp for all graphic related things, fp stack
jugglers similar to those for the data stack are handy.
We deal with fp pairs as used for points, sizes and ranges and fp quads
for rectangles and colours.
F2SWAP F2OVER F2DROP F4DUP FTUCK FNIP do what you expect ...
Most are now in VFX.
-FROT is added here. Also known as F-ROT in some systems.
-------------------------------------------------------------------- ))

\ NoTE: these are for the internal/hardware FPU stack !!
code F2DUP ( F: r1 r2 -- r1 r2 r1 r2 )
 fld   st(1)            \ r1 r2 -- r1 r2 r1
 fld   st(1)            \ r1 r2 r1 -- r1 r2 r1 r2
 fnext,
end-code

code F2SWAP ( F: r1 r2 r3 r4 -- r3 r4 r1 r2 )
 fxch   st(2)            \ r1 r2 r3 r4 -- r1 r4 r3 r2
 fxch   st(1)            \ r1 r4 r3 r2 -- r1 r4 r2 r3
 fxch   st(3)            \ r1 r4 r2 r3 -- r3 r4 r2 r1
 fxch   st(1)            \ r3 r4 r2 r1 -- r3 r4 r1 r2
 fnext,
end-code

code F2OVER ( F: r1 r2 r3 r4 -- r1 r2 r3 r4 r1 r2 )
 fld   st(3)            \ r1 r2 r3 r4 -- r1 r2 r3 r4 r1 
 fld   st(3)            \ r1 r2 r3 r4 r1 -- r1 r2 r3 r4 r1 r2
 fnext,
end-code

code F2DROP ( F: r1 r2 -- )
 fstp   st(0)            \ r1 r2 -- r1
 fstp   st(0)            \ r1 --
 fnext,
end-code
   
code F4DUP ( F: r1 r2 r3 r4 -- r1 r2 r3 r4 r1 r2 r3 r4 )
 fld   st(3)            \ r1 r2 r3 r4 -- r1 r2 r3 r4 r1 
 fld   st(3)            \ r1 r2 r3 r4 r1 -- r1 r2 r3 r4 r1 r2
 fld   st(3)            \ r1 r2 r3 r4 r1 r2 -- r1 r2 r3 r4 r1 r2 r3 
 fld   st(3)            \ r1 r2 r3 r4 r1 r2 r3 -- r1 r2 r3 r4 r1 r2 r3 r4
 fnext,
end-code

code FTUCK ( F: r1 r2 -- r2 r1 r2 )
 fxch   st(1)            \ r1 r2 -- r2 r1 
 fld   st(1)            \ r2 r1 -- r2 r1 r2
 fnext,
end-code

code FNIP ( F: r1 r2 -- r2 )
 fxch   st(1)            \ r1 r2 -- r2 r1
 fstp   st(0)            \ r2 r1 -- r2
 fnext,
end-code

[THEN]

code -FROT ( F: r1 r2 r3 -- r3 r1 r2 )
  fxch  st(2)
  fxch  st(1)
  fnext,
end-code
fseq: -FROT   fxch st(2)  fxch st(1)  ;fseq

(( --------------------------------------------------------------------
Temporarely store top fp stack on return stack.
Note: native fp in VFX is FPCELL=10
Similar rules as >R R> R@
   : ff ( -- )   1234e-2 f.s f>r f.s rp@ f@ f. fr@ f. fr> f. ;
-------------------------------------------------------------------- ))

: F>R ( F: r -- ) ( R: -- r )  r>  0 dup dup >r 2>r rp@ f!  >r ;

: FR> ( F: -- r ) ( R: r -- )  r>  rp@ f@ 2r> 2drop r> drop  >r ;

: FR@ ( F: -- r ) ( R: r -- r )  r>  rp@ f@  >r ;

cr .( fp utilities loaded)

\\ ( eof )

