(* ====================================================================
Mach absolute time

copyright 2002 - 2017 Roelf Toxopeus

VFX version.
Much faster return than VFX 'times' lib function
Last: 15 October 2014 15:14:24 CEST  -rt
==================================================================== *)

/forth
decimal

(( --------------------------------------------------------------------
/MACHTIME -- initialise the TIMEBASEINFO structure
MACHTIME -- return time in nanoseconds. Forth double!
MachTicks -- returns ms
-------------------------------------------------------------------- ))

/forth
decimal

function: mach_absolute_time ( -- lo hi )
function: mach_timebase_info ( addr -- ret )

2variable timebaseinfo
: /MACHTIME ( -- )   timebaseinfo mach_timebase_info drop ; 

/machtime         \ do it now

\ using 2@ SWAP is slower!
: MACHTIME ( -- ud )  mach_absolute_time timebaseinfo @ timebaseinfo cell+ @ M*/ ;

: MachTicks ( -- ms )   machtime 1000000 M/ ;

: /MachTicks ( -- )   /machtime ['] machticks is ticks ;

\ cr .( machtime loaded )

\\ ( eof )

\ test:
: tt
   counter 1000 + 
   0 begin random drop 1+ over expired until
   nip . ;
   
\ using (ticks)
' (ticks) is ticks
tt ( 1405264  ok )
  
\ using machticks
' machticks is ticks  ok
tt ( 15046343  ok )
