(* ====================================================================
relative linked lists

copyright 1989- Roelf Toxopeus

VFX version.
Defines where necessary the relative linked list words as used and
learned in Mach2 and MacForth.
Last: 14 October 2014 13:16:49 CEST -rt
==================================================================== *)

/forth
decimal

(( --------------------------------------------------------------------
Compatibility layer for relative chaining (lists). VFX doesn't need this
for relocation.
-------------------------------------------------------------------- ))

: @rel      \ addr -- x
\ *G In some Forths, this word allows for relocation.
  @  ;
: !rel      \ x addr --
\ *G In some Forths, this word allows for relocation.
  !  ;
: ,rel      \ x --
\ *G In some Forths, this word allows for relocation.
  ,  ;

: >link      \ var --
\ *G Add a link to a chain anchored at address var-addr. The old contents of
\ ** var-addr are added to the dictionary as the new link, and the address
\ ** of the new link is placed at var-addr.
  link,  ;

(( --------------------------------------------------------------------
Aliasses for SwiftForth's chains/list words
NODE, alias for ,REL    comma n relative to HERE
NODE  alias for >LINK   add a node to the chain
ALLNodes -- Execute xt for every node in the list. Lisp's MAPCAR.
Don't leave anything on the stack

A NODE is 2 cells: link cell and payload cell
-------------------------------------------------------------------- ))

: NODE, ( n -- )   ,rel ;

: NODE   ( list -- )  >link ;

: allNodes ( xt list -- )
   swap >r
       begin @rel dup
      while dup cell+ @rel r@ execute
   repeat r> 2drop ;

cr .( nodes loaded)

\\ ( eof )
