(* ====================================================================
bundle resources

Copyrights (c) 2014 Roelf Toxopeus

VFX version.
Implements resource utillities like COPY-RESOURCE.
Last: 15 October 2014 17:40:59 CEST   -rt
==================================================================== *)

(( --------------------------------------------------------------------
Convenient way to copy resources like nib bundles and icon files, from
the development path as indicated by >NIBPATH to the appropriate Resources
folder inside an application bundle.
COPY-RESOURCE -- copies resource (a1 n2) to app(a2 n2) bundle Resources
folder.

Example usage:
s" vfxmenu.nib" s" sf-app"  copy-resource
s" app.icns"    s" sf-app"  copy-resource
-------------------------------------------------------------------- ))

/forth
decimal

: COPY-RESOURCE ( a1 n2 a2 n2 -- )
   pad >r
   cwd zcount r@ zplace
   r@ zappend
   s" .app/Contents/Resources/" r@ zappend
   2dup r@ zappend
   r@ zcount + char+ dup >r zplace r> >nibpath   \ NSStringRef source,  >NIBPATH takes zerostring, uses next available PAD storage
   r>  >nsstring   \ NSStringRef destination
   2dup (copy-item) @release drop @release drop ;

\\ ( oef )