(* ====================================================================
Turnkey application

Copyrights (c) 2013 Roelf Toxopeus

VFX version.
Creating an application bundle:
Set appropriate working directory
GILD if necessary
Make app bundle with: s" mystuff" APPBUNDLE or TURNKEY mystuff
Add your nib files and icons to the Resources folder in the bundle
Last: 29 July 2020 at 12:36:32 CEST   -rt
==================================================================== *)

(( --------------------------------------------------------------------
TRASH-APP -- move app to thrash if it exist. An xxx.app is a directory,
so direxists? is used to check if it's there.

/APPBUNDLE -- create an application bundle directory tree in current working 
directory. Add some default files needed for the application to run.
Sets the MacOS folder in the bundle as current working directory. 
Some standard folders in the bundle are commented out, adapt to your situation.

APPBUNDLE -- saves turnkey in new created application bundle. 

TURNKEY -- as APPBUNDLE but parsing.
-------------------------------------------------------------------- ))

/forth
decimal

: TRASH-APP ( a n -- )
   pad zplace s" .app" pad zappend
   pad zcount direxists? if  pad trash-item drop  then ;

: /APPBUNDLE ( a n -- )
   2dup pad place s" .app" pad append
   pad count folder+          ( cr pwd )
   s" Contents" folder+       ( cr pwd )
   s" Resources" folder       ( cr pwd )
   \ s" Frameworks" folder    ( cr pwd )
   \ s" Plugins" folder       ( cr pwd )
   \ s" SharedSupport" folder ( cr pwd )
   2dup infoplist-file
   pkginfo-file
   s" MacOS" folder+          ( cr pwd )     \ turnkey in this folder
;

: PROGRAM>BUNDLE ( a n -- )
   s" save " pocket place
   pocket append
   pocket count evaluate ;

: APPBUNDLE ( a n -- )
   2dup trash-app
   pushpath 
   2dup /appbundle program>bundle
   poppath ;

: TURNKEY ( <text> -- )   bl parse appbundle ;

cr .( application bundling loaded)
cr .( set appropriate workin directory)
cr .( make app bundle with:)
cr .(    s" mystuff" APPBUNDLE or TURNKEY mystuff)

\\ ( eof )
