(* ====================================================================
Cocoa classes

copyright 2008 Roelf Toxopeus

Part of the interface to ObjC 2 Runtime.
VFX version.
Get id from existing Cocoa class and cache it like a constant.
NoTE: I'm using the name Cocoa class for ObjC class. Because that's
how I use them, for interfacing to Cocoa, not programming in ObjC.
Last: 24 February 2013 17:29:43 CET     -rt
==================================================================== *)

(( --------------------------------------------------------------------
Forth interface to existing ObjC classes.

Turnkey proof:
A linked list is created, which will hold the class structures.
Upon booting coco-vfx, the list is traversed and all our defined Cocoa
classes are initialised.

@COCOACLASS -- return id for classname.
COCOACLASSES -- holds head linked list for Cocoa classes.
>COCOACLASSES -- adds a class to the list.
/COCOACLASSES -- initialise the classes in the list to their proper id's,
execute this somewhere in the startup from a turnkeyed coco-vfx.
.COCOACLASSES -- show the classes in the list by their name.

COCOACLASS -- create a named structure from parsed name containing the
class id and the name string. Pass a pointer to this structure to the
herefore mentioned list. When name is executed, return class id. 
-------------------------------------------------------------------- ))

/forth
decimal

\ --------------------------------------------------------------------
\ relink classes

: @COCOACLASS ( 0string -- id )  objc_getClass dup 0= abort" cocoaClass failed" ;

variable COCOACLASSES

: >COCOACLASSES ( a -- )  cocoaclasses node node, ;

: relinkclass ( a -- )
   dup          \ pointer id
   cell+        \ pointer to classname
   @cocoaclass
   swap !       \ save new id
   ;

: /COCOACLASSES ( -- )   ['] relinkclass cocoaclasses allnodes ;

: .COCOACLASSNAME ( A -- )  cell+ zcount cr type ;

: .COCOACLASSES ( -- )   ['] .cocoaclassname cocoaclasses allnodes ;

\ --------------------------------------------------------------------
\ define COCOACLASS

: COCOACLASS ( <name> -- )
   >in @ >r  bl parse pocket zplace  r> >in !
   pocket @cocoaclass
   create
   here swap , pocket zcount z, >cocoaclasses
   does> ( a -- id )
    @ ;

\\ ( eof )