(* ====================================================================
Base functionality for calling ObjC

copyright 2006 Roelf Toxopeus

Part of the interface to ObjC 2 Runtime.
VFX version.
The main functions to deal with the ObjC Runtime, which 'runs' Cocoa.
Last: 15 October 2014 09:07:57 CEST     -rt
==================================================================== *)

(( --------------------------------------------------------------------
Cocoa.framework -- the Cocoa umbrella framework, i.e. everything connected
with Cocoa.
objc_getClass -- return class definition (id) from given class name
sel_getUid -- return selector from given method name

To do the 'call' i.e. send the message, the OS provides us with a set
of procedural C functions.
All the message sending C functions are vararg functions. The id from
the receiver and the message selector should be passed along with the
actual parameters (arguments). Some have a SUPER variant to send the message
to the super class of the receiver.

objc_msgSend -- ( id:receiver SEL:selector arg1 ... argn -- ret )
objc_msgSendSuper -- ( objc_super*:superContext SEL:selector arg1 ... argn -- ret )

objc_msgSend_stret -- ( *stretaddr id:receiver SEL:selector arg1 ... argn  -- ret )
objc_msgSendSuper_stret -- ( *stretaddr objc_super*:superContext SEL:selector arg1 ... argn  -- ret )
Sends a message with a data-structure return value to an instance of a class.
So these pass a STucture for RETurn value(s)as well: the left most parameter.

objc_msgSend_fpret -- ( id:receiver SEL:selector arg1 ... argn -- double )
Sends a message with a floating-point return value to an instance of a class.

NSApp -- a variable created by the OS for our application.
Contains our NSApplication instance ref after SHAREAPP is executed.
-------------------------------------------------------------------- ))

/forth
decimal

framework Cocoa.framework

function: objc_getClass ( 0string:class -- id )
function: sel_getUid ( 0string:method -- SEL )

\ --------------------------------------------------------------------
\ Because we use a special OBJC-CALL we only need their pointers
\ so GLOBAL: instead of FUNCTION:
global: objc_msgSend
global: objc_msgSendSuper
global: objc_msgSend_stret
global: objc_msgSendSuper_stret
global: objc_msgSend_fpret

global: NSApp   \ use @

\\  ( eof )
