(* ====================================================================
The file kite...

copyright 2009 Roelf Toxopeus

VFX version.
Loading files with the Cocoa file kite.
Last: 4 February 2019 at 14:09:49 CEST  -rt
==================================================================== *)

(( --------------------------------------------------------------------
File kite is the name given to the file open/save dialog window hovering
on top of all, like a kite. Term used in the 1980's in Atari GEM (Mac?).
Name stuck...

PIMP.KITE -- allows to add widgets and text to NSOpenPanel instance.
NEW.KITE -- return new NSOpenPanel instance.
CHOICE -- retrieves choosen file path from NSOpenPanel instance after
user modal interaction.
EZGET -- 'easy get' file path. Return path and true flag if user made
choice, or just false flag if user canceled. EZGET is MacForth.
EZGETMAIN -- is the proper way of running EZGET: on the main thread.
Uses PASS to deliver EZGET to the main eventloop. Uses POCKET for the
return string: a zstring !
LOAD-FILE -- include/load file choosen with EZGETMAIN.
-------------------------------------------------------------------- ))

/forth
decimal

\ --------------------------------------------------------------------
\ NSOpenPanel aka File Kite.

cocoaclass NSOpenPanel

cocoa: @openPanel   ( -- id ) \ NSOpenPanel object
cocoa: @setCanChooseFiles: ( flag -- ret ) \ BOOL

\ --------------------------------------------------------------------
\ NSSavePanel methods inherited by NSOpenPanel

cocoa: @setPrompt: ( prompt -- ret )   \ NSString object
cocoa: @URL ( -- id )                   \ NSURL object
cocoa: @runModal ( -- int )             \ NSInteger 1 or 0

\ --------------------------------------------------------------------
\ NSURL method

cocoa: @path ( -- path )                \ NSString object            

: PIMP.KITE ( panel -- )
   0" Choose" >NSSTRING over @setTitle: drop
   \ 100 ms
   0" Load" >nsstring swap @setPrompt: drop ;

: NEW.KITE ( -- panel )
   NSOpenPanel @openPanel
   dup 0= abort" Can't open a panel !"
   dup @retain drop         \  Mountain Lion4 August 2012 09:53:17 CEST -rt
   yes over @setcanchoosefiles: drop
   dup pimp.kite ;

: CHOICE ( panel -- a n )
   dup @url swap @release drop   \ get rid of panel
   @path >4thstring
   \ 2dup type         \ for testing
;

: EZGET ( -- a n true | false )   pushme new.kite dup @runModal dup >r if choice else @release drop then r> ;

\ --------------------------------------------------------------------
\ run kite on main thread to include file

: (EZGETMAIN) ( -- ret )  pathpad  ezget if rot zplace else off then  0 ;

: EZGETMAIN  ( -- a n true | false )
   0 0 ['] (ezgetmain) pass
   pathpad zcount dup 0<> dup if else nip nip then ;

: LOAD-FILE ( -- )   ezgetmain if included then ;

\\ ( eof )