(* ====================================================================
Mouse cursor visibility.

copyright 2011 Roelf Toxopeus

VFX version.
Hide and show mouse/cursor, handy for presentations.
Needs a GUI element like a window hanging around to be effective.
Last: 16 October 2014 17:10:46 CEST  -rt
==================================================================== *)

/forth
decimal

cocoaclass NSCursor

cocoa: @hide ( -- ret )
cocoa: @unhide ( -- ret )
cocoa: @setHiddenUntilMouseMoves: ( flag -- ret )

: HIDE-MOUSE ( -- )
   NSCursor @hide drop
   no NSCursor @setHiddenUntilMouseMoves: drop ;

: SHOW-MOUSE ( -- )   NSCursor @unhide drop ;

\\ ( eof )

\ test:
new.window win win add.window
hide-mouse                           \ click on window, mouse pinter vanishes
   