(* ====================================================================
Show alert

Copyright 2010 Roelf Toxopeus

VFX version.
Preferred alert usage: NSAlert
Last: 14 August 2020 at 19:47:30 CEST  -rt
==================================================================== *)

(( --------------------------------------------------------------------
/ALERT -- returns an alert reference initialised with info and message
zstrings. As of 10.14 Mojave the @alloc @init needs to be done on the
main thread!
ALERT -- runs the alert panel from the mainthread. The id from the
button hit to dismiss the panel is returned.
WELCOME -- example
-------------------------------------------------------------------- ))

/forth
decimal

cocoaclass NSAlert

cocoa: @setAlertStyle: ( style -- ret )
cocoa: @setInformativeText: ( NSStringRef -- ret )
cocoa: @setMessageText: ( NSStringRef -- ret )

1 constant NSAlertStyleInformational

: /ALERT ( info message -- NSAlertRef )
   NSAlert @alloc @init >r
   NSAlertStyleInformational r@ @setAlertStyle: drop
   >nsstring dup r@ @setMessageText: drop @release drop
   >nsstring dup r@ @setInformativeText: drop @release drop
   r> ;

: (ALERT) ( NSAlertRef -- )   /ALERT DUP @runModal POCKET !  @release DROP ;
: ALERT ( NSAlertRef -- button )   2 0 ['] (ALERT) PASS POCKET @ ;

: /WELCOME ( -- za1 za2 )
   Z" Yes, again..."
   Z" Hi !" ;

: WELCOME  ( -- )    /welcome alert drop ;

cr .( type   welcome)

\\ ( eof )


