(* ====================================================================
A simple example showing class build procedure.

copyright 2008 Roelf Toxopeus

VFX version.
Creating class with methods and instance variable(s).
Last: 4 February 2019 at 13:15:35 CEST -rt
==================================================================== *)

(( --------------------------------------------------------------------
Create and test a class in 7 steps.
Instructions precede the code, which is assumed to be self explaining.

Still some notes:
To differentiate a callback for ObjC from a executable word in Forth,
normally a leading * character is used. Similar to the pointer
directive in C declararions. Here it looks to confusing so ' tick is
used in stead.

Another diverging from the used style in the cocoa interface:
A leading @ character is normaly used while defining methods using
COCOA:. Here it's ommited.
-------------------------------------------------------------------- ))

/forth
decimal

\ --- 1. create the class using NSObject as super class

NSObject new.class myClass

\ --- 2. add methods, 

forthcall: '/me ( rec sel -- void )   drop >r $deadbeef 0" mydata" r> !ivar  0 ; 
: /METYPES   0" v@:" ;
'/me /metypes 0" /me" myClass add.method

forthcall: 'me ( rec sel -- n )   drop >r 0" mydata" r> @ivar ; 
: METYPES   0" i@:" ;
'me metypes 0" me" myClass add.method

\ --- 3. add some ivars

: MYDATATYPE  0" i" ;
mydatatype 0" mydata" myClass add.ivar

\ --- 4. now add/register the class

myClass add.class

\ --- 5. make instance etc.

\ cocoaclass myClass   \ <-- don't need this, we have the ref!
myClass @alloc @init value MYOMY

\ --- 6. define the methods for Forth usage
cocoa: /me ( -- ret )

cocoa: me ( -- n )

\ --- 7. test it
(*
myomy /me drop
myomy me .h
0 0" mydata"  myomy !ivar
myomy me .h
*)

\\ ( eof )