(* ====================================================================
CoreGraphic Blendmodes

Copyright 2006 Roelf Toxopeus

VFX version.
The possible blendmodes when displaying images in Quartz.
Last: 24 March 2011 11:35:39 CET  -rt
==================================================================== *)

(* --------------------------------------------------------------------
Many blendmodes are defined here as constants.

BLENDMODE -- a temporary storage for current blendmode. Used by some: 
SET.BLENDMODE -- set the CGContext's blend mode.
-------------------------------------------------------------------- *)

/FORTH
DECIMAL

FUNCTION: CGContextSetBlendMode ( cgcontext blendmode -- ret )

32 CONSTANT blend
33 CONSTANT addpin
34 CONSTANT addOver
35 CONSTANT subPin
36 CONSTANT transparent
37 CONSTANT addMax
38 CONSTANT subOver
39 CONSTANT adMin
64 CONSTANT ditherCopy

\ CGBlendModes
: MYENUM ( n1 <name> -- n2 )  DUP CONSTANT 1+ ;

0
MYENUM kCGBlendModeNormal
MYENUM kCGBlendModeMultiply
MYENUM kCGBlendModeScreen
MYENUM kCGBlendModeOverlay
MYENUM kCGBlendModeDarken
MYENUM kCGBlendModeLighten
MYENUM kCGBlendModeColorDodge
MYENUM kCGBlendModeColorBurn
MYENUM kCGBlendModeSoftLight
MYENUM kCGBlendModeHardLight
MYENUM kCGBlendModeDifference
MYENUM kCGBlendModeExclusion
MYENUM kCGBlendModeHue
MYENUM kCGBlendModeSaturation
MYENUM kCGBlendModeColor
MYENUM kCGBlendModeLuminosity
MYENUM kCGBlendModeClear
MYENUM kCGBlendModeCopy
MYENUM kCGBlendModeSourceIn
MYENUM kCGBlendModeSourceOut
MYENUM kCGBlendModeSourceAtop
MYENUM kCGBlendModeDestinationOver
MYENUM kCGBlendModeDestinationIn
MYENUM kCGBlendModeDestinationOut
MYENUM kCGBlendModeDestinationAtop
MYENUM kCGBlendModeXOR
MYENUM kCGBlendModePlusDarker
MYENUM kCGBlendModePlusLighter
CONSTANT #BLENDMODES

VARIABLE BLENDMODE kCGBlendModeNormal BLENDMODE !

: SET.BLENDMODE ( mode context -- )   SWAP CGContextSetBlendMode DROP ;

CR .( CGBlendmode loaded)

\\ ( eof )
