(* ====================================================================
CoreGraphic Image display

Copyright 2006 Roelf Toxopeus

VFX64 version.
Drawing pictures in a Core Graphic Context from a file or memory.
Last: 9 August 2020 at 21:09:11 CEST  -rt
==================================================================== *)

(* --------------------------------------------------------------------
CGImage -- a pad for a CGImage.
>CGIMAGE -- return a CGImage created from an url.
DRAW.CGIMAGE -- draw a CGImage in the context from a given window.
Note: the rectangle size is the display size in the window to which
the picture is scaled.
DRAWPIC -- draw picture at url in window.
-------------------------------------------------------------------- *)

/FORTH
DECIMAL

Quartz.framework
FUNCTION: CGImageSourceCreateWithURL ( CFURLRef NULL -- CGImageSourceRef )
FUNCTION: CGImageSourceCreateImageAtIndex ( CGImageSOurceRef index NULL -- CGIOmageRef )
FUNCTION: CGContextDrawImage ( CGContext CGImage dummy dummy dummy dummy x y w h -- ret )
: CGContextDrawImage ( CGContext CGImage -- ret ) ( F: x y w h -- ) 4 DFIX  CGContextDrawImage ;
FUNCTION: CGImageGetWidth ( CGImage -- width:pixels )
FUNCTION: CGImageGetHeight ( CGImage -- height:pixels )

VARIABLE CGImage

: >CGIMAGE ( 0stringurl -- cgimage )
   >CFURL
   0 CGImageSourceCreateWithURL DUP 0= ABORT" Can't create image form URL"
   DUP 0 0 CGImageSourceCreateImageAtIndex
   SWAP CFRelease DROP ;

: DRAW.CGIMAGE ( cgimage wptr4 -- )
   SWAP >R
   DUP CGContext TUCK
   BLENDMODE @ OVER SET.BLENDMODE
   SWAP CONTENT.FRAME R@ CGContextDrawImage DROP
   CGContextFlush DROP
   R> CFRelease DROP ;

: DRAWPIC ( 0stringurl wptr4 -- )   >R >CGIMAGE R> DRAW.CGIMAGE ;

CR .( CoreGraphics 64bit picture loader and drawing loaded )

\\ ( eof )

