(* ====================================================================
Random Walk Demo

copyright 1988 Roelf Toxopeus

VFX64 version
Last: 18 August 2020 at 15:30:41 CEST  -rt
==================================================================== *)

(( --------------------------------------------------------------------
First type  WALKWIN /GWINDOW  when included from LOAD-FILE menu.
RR -- randomwalk controlled from IMPOSTOR.
DO.WALK -- randomwalk by WALKER task.
WDONE -- stops WALKER.

Play with parameters.
-------------------------------------------------------------------- ))

/forth
decimal

new.window WALKWIN
s" random walks"      walkwin w.title

: /WALKWIN ( -- )   walkwin dup add.window /gwindow ;

/walkwin

\ --- Random walk

: BOUNCEX ( F: x1 -- x2 )
   fabs walkwin content.size fdrop ftuck f- fabs f- ;

: BOUNCEY ( F: x1 -- x2 )
   fabs walkwin content.size fnip ftuck f- fabs f- ;

: /WALK ( cgcontext -- )
   1e0 dup line.width
   walkwin content.size fswap 5e-1 f* fswap 5e-1 f* move.to ;

: RR ( -- )
   walkwin cgcontext
   dup /walk
   dup penloc
   begin
      fswap 21 choose 10 - s>f f+ bouncex
      fswap 21 choose 10 - s>f f+ bouncey
      f2dup dup draw.to
      33 ms            \ show each step in 30 fps
   ?pause until
   drop f2drop ;
   
\ assign a task to do the walking
variable 'WDONE
: WDONE ( -- )   'wdone on ;
: -WDONE ( -- )  'wdone off ;
: WDONE? ( -- flag )   pause 'wdone @ ;

: /WALK ( cgcontext -- )  /walk -wdone ;

: CUTS ( -- %cut )   10 choose dup 7 < if drop 1 then ;

: RANDOMWALK ( -- )
   walkwin cgcontext
   dup /walk
   dup penloc
   begin
      fswap 21 choose 10 - s>f f+ bouncex
      fswap 21 choose 10 - s>f f+ bouncey
      f2dup dup draw.to
      33 ms            \ show each step in 30 fps
      wdone?
   until
   drop f2drop ;

: RANDOMWALK2 ( -- )
   walkwin cgcontext
   dup /walk
   dup penloc
   begin
      cuts %cut if
         walkwin wipe
         f2dup dup move.to
      else
         fswap 21 choose 10 - s>f f+ bouncex
         fswap 21 choose 10 - s>f f+ bouncey
         f2dup dup draw.to
      then
      33 ms            \ show each step in 30 fps
      wdone?
   until
   drop f2drop ;

task WALKER  \ don't forget FINIT in task

: DO.WALK ( -- )   walker activate finit allocpool  randomwalk  releasepool drop ;

cr .( WALKWIN /GWINDOW    when included from LOAD-FILE menu)
cr .( DO.WALK   to start walking)
cr .( WDONE     to stop walking)

\\ ( eof )
