(* ====================================================================
Launch GDB

copyright 2003 Roelf Toxopeus

VFX64 version.
Last: 10 August 2020 at 12:54:21 CEST    -rt
==================================================================== *)

(( --------------------------------------------------------------------
Launching GDB with VFX attached
Using '3 INT' signal sigtrap instruction directly ensures we stop immediately
in the right calling thread!
Original from CarbonMacForth, this version much simplified!
Layout is very important for Applescript!

GDB -- launch GDB with me attached.
>GDB -- jump into GDB as a breakpoint.
-------------------------------------------------------------------- ))

/forth
decimal

\ lacking system.framework  framework System.framework

\ system.framework

lacking getpid  function: getpid ( -- mypid )

: "debugme" ( -- pad )
   s`
tell application "Terminal"
   activate
   do script with command "gdb -pid  `  pad zplace   
   getpid s>d <# #s #>                  pad zappend
   s` "
end tell`                               pad zappend
   pad ;

: GDB ( -- )   "debugme" doscript 0= abort" Debug DOSCRIPT Error !" ;

also asm-access definitions also asm-core 
hex

\ VFX standard doesn't allow a 3 int !!!
: 3int ( -- )
  0cd c,c(t)                   \ INT opcode
  3   c,c(t)
;

decimal
previous previous definitions

code >GDB ( -- )
   3int
   ret
end-code inline


: GDB-HELP
CR ."   vfx:  gdb         -- start new gdb session: vfx stopped in gdb"
CR ."   vfx:  >gdb        -- break in to gdb if there and attached"
CR ."   gdb:  hi          -- see current and next 3 three instructions"
CR ."   gdb:  c  or  g    -- continue (till breakpoint if any) eventually in to vfx"
CR ."   gdb:  words       -- show simple macsbug like words"
CR ."   gdb:  bye         -- quits gdb, vfx continues detached"
;

cr .( gdb stuff loaded)

\\ ( oef )