(* ====================================================================
Launch Apple's LLDB

copyright 2013 Roelf Toxopeus

VFX64 version.
Last: 10 August 2020 at 12:58:35 CEST    -rt
==================================================================== *)

(( --------------------------------------------------------------------
Launching Apple's LLDB with VFX attached
Using '3 INT' signal sigtrap instruction directly ensures we stop immediately
in the right calling thread!
Original in GDB.f
Gnu's GDB changed for Apple's LLDB.
Layout is very important for Applescript!

DB -- launch LLDB with me attached.
>DB -- jump into LLDB as a breakpoint.
-------------------------------------------------------------------- ))

/forth
decimal

\ lacking system.framework  framework System.framework

\ system.framework

lacking getpid  function: getpid ( -- mypid )

: "debugme" ( -- pad )
   s`
tell application "Terminal"
   activate
   do script with command "lldb -p  `  pad zplace   
   getpid s>d <# #s #>                 pad zappend
   s` "
end tell`                              pad zappend
   pad ;

: DB   "debugme" doscript 0= abort" Debug DOSCRIPT Error !" ;

also asm-access definitions also asm-core 
hex

\ VFX standard doesn't allow a 3 int !!!
: 3int ( -- )
  0cd c,c(t)                   \ INT opcode
  3   c,c(t)
;

decimal
previous previous definitions

code >DB ( -- )
   3int
   ret
end-code inline

: db-help
cr ."   vfx:   db      -- start new lldb session: vfx stopped in lldb"
cr ."   vfx:   >db     -- break in to lldb if there and attached"
\ cr ."   gdb:  hi        -- see current and next 3 three instructions"
cr ."   lldb: c       -- continue (till breakpoint if any) eventually in to vfx"
\ cr ."   gdb:  words     -- show simple macsbug like words"
cr ."   lldb: quit    -- quits lldb, vfx continues if detached"
;

cr .( lldb stuff loaded)

\\ ( oef )