\ vfx-prelude.fth - prelude for cocoa extensions

((
copyright 2010-2017
Roelf Toxopeus
Utrecht
Netherlands

copyright 2012-2017
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
21 October 2014 08:27:20 CEST  -rt Added >ARGUMENTS and /CMDLINE
4 September 2015 08:12:53 CEST -rt Added FINIT
5 August 2020 at 15:45:27 CEST -rt Removed PARSE-PARAMS
))

only forth definitions
decimal

\ == start with empty fp stack
finit

\ == corrections, redefinitions and special preludes 

: deprecate   \ xt --
\ *G Indicate that the word given by *\i{xt} should not be used.
  dup doCall,            \ unoptimised compile
  cr >name .name ." is deprecated"   \ say
  .source-line            \ where used
;

: deprecated   \ --
\ *G Used after a word definition (like IMMEDIATE) so that its use
\ ** is reported.
\ *C   : foo ... ; deprecated
  ['] deprecate latest-xt >code-len tuck !  cell+ off
;

256 buffer: AppDataDir$   \ -- addr
\ *G A buffer that holds the directory holding the application's
\ ** permanaent data, e.g. nib and image files. You should set
\ ** *\fo{AppData$} yourself.

\ set it later
\ ms" %basepathh%/Lib/Osx32/mac" AppDataDir$ place

\ getting commandline arguments for evaluation on OSX.
\ NoTE: argv[ needs an extra @ to get the string pointer
\ a1 n1 is the commandline
\ NoTE: >ARGUMENTS is defined already somewhere in the kernel
: >ARGUMENTS ( a1 n1 -- a2 n2 )
   argc 1 > if                      \ any arguments for us?
      0 argv[ @ zcount nip /string  \ yep, skip past processname
      exit
   then drop 0 ;                       \ no extra arguments

\ command line evaluation.
\ This is a *named* variation on a nonamed version in the kernel.
: /CMDLINE ( -- )
   commandline            \ -- a n
   dup if
       >arguments ['] evaluate catch ?dup if
      .throw
      clean-opt cleanup-locals      \ compiler state clean up
      OperatorType off
      QuitHook            \ User defined clean up
      init-quit  r0 @ rp!  exc0 @ excp ! \ QUIT loop clean up ; SFP072
      s0 @ sp!
      cr ." ERROR on command line"
   then
     else 2drop
     then ;

cr .( VFX prelude loaded)

\\ ( eof )