(* ====================================================================
Temporary Yosemite fixes

copyright 2014 Roelf Toxopeus

VFX version.
Some work-arounds for OS glitches.
They stay in place till Apple fixes it.
Last: 28 Oct 2016 10:42:27 CEST  -rt
==================================================================== *)

(( --------------------------------------------------------------------
OSX 10.10 Yosemite
Words affected in coco-vfx:  EZGETMAIN LOAD-FILE EDIT-FILE
Glitch: NSopenPanel @openPanel combined with @runModal will litter the
Forth console with error messages and warnings directed at Apple's
programmers. Guess it's debug information left over from the beta testing.
It doesn't affect the functionality AFAIK. But the littering is annoying.
Herefore words to temporary suppress the STDERR output.

STDERR -- the stderr file descriptor
-STDERR -- stop stderr output
+STDERR -- allow stderr output

EZGETMAIN, LOAD-FILE and EDIT-FILE are redefined using -STDERR
and +STDERR

XEZGETMAIN -- original version just in case ...
-------------------------------------------------------------------- ))

/forth
decimal

1010 constant yosemite

lacking system.framework  framework System.framework

system.framework

ascall: _dup dup ( fd -- n )

ascall: _dup2 dup2 ( fd1 fd2 -- n )

variable 'STDERR
variable 'FD-NULL

2 constant STDERR

: /DEVNULL ( -- )   S" /dev/null" w/o open-file throw  'fd-null ! ;
: -DEVNULL ( -- )   'fd-null @ close-file throw ;

\ : >DEVNULL ( -- )   'fd-null @ fd-out ! ;

: -STDERR ( -- )   /devnull stderr _dup 'stderr ! 'fd-null @ stderr _dup2 drop ;
: +STDERR ( -- )   'stderr @ dup stderr _dup2 drop  close-file throw -devnull ;

\ --------------------------------------------------------------------
\ temporary redefinitions:

: XEZGETMAIN  ( -- a n true | false )     ezgetmain ;

: EZGETMAIN  ( -- a n true | false )    -stderr ezgetmain +stderr ;

: LOAD-FILE ( -- )   ezgetmain if included then ;

: EDIT-FILE ( -- )
   ezgetmain if
      2dup
      s\" \"" 'edit-file place   \ $edit needs " around path with spaces
      'edit-file append
      s\" \"" 'edit-file append
      'edit-file $edit
      'edit-file place            \ LOAD-EDIT doesn't understand " around path
   then ;

cr .( temporary Yosemite fixes loaded)

\\ ( eof )