(* ====================================================================
$PATH

Copyright 2019 Roelf Toxopeus

VFX version.
Set $PATH env variable.
Last: 25 September 2019 at 12:12:03 CEST   -rt
==================================================================== *)

(( --------------------------------------------------------------------
App bundled applications launched without Terminal involved, i.e. double
clicked or ctrl-click-open in Finder, have a different PATH environmental
variable from those launched with Terminal with a shell.
Found out while running the experimental sf-app a bundled coco-sf launched
without Terminal involved.
My global PATH=/usr/local/bin:/usr/bin:/bin:/usr/sbin:/sbin is not propagated!
Instead PATH=/usr/bin:/bin:/usr/sbin:/sbin is used. This means that the editor
and possible other executables in /usr/local/bin can't be found!

PATHENV+ -- checks the app's $PATH. If the provided path is not in, it will
be added as first path in $PATH
A default often used extra path is  /usr/local/bin

Example usage:
: /PATHENV ( -- )   S" /usr/local/bin" PATHENV+ ;

More inspiration, information and possible solutions:
https://apple.stackexchange.com/questions/51677/how-to-set-path-for-finder-launched-applications
https://unix.stackexchange.com/questions/26047/how-to-correctly-add-a-path-to-path
https://unix.stackexchange.com/questions/40749/remove-duplicate-path-entries-with-awk-command
-------------------------------------------------------------------- ))

/forth
decimal

function: getenv ( za1 -- za2 )
function: putenv ( za -- int )

: PATHENV+ ( a n -- )                        \ example: S" /usr/local/bin" PATHENV+
   z" PATH" getenv zcount
   2over search if 2drop 2drop exit then
   s" PATH=" pad zplace                      \ PATH=
   2swap pad zappend                         \ PATH=/usr/local/bin
   s" :" pad zappend                         \ PATH=/usr/local/bin:
   pad zappend                               \ PATH=/usr/local/bin:oldPATH
   pad putenv drop ;
   
\\ 