(* ====================================================================
fp utillities

copyright 2002 Roelf Toxopeus

VFX64 version.
Origin MacForth version, which uses PPC instructions.
FP utillities for fp stack juggling and FP parameter passing.
Last: 18 August 2020 at 17:06:23 CEST  rt
==================================================================== *)

/forth
decimal


(( --------------------------------------------------------------------
fp stack jugglers

Due to the Mac's usage of fp for all graphic related things, fp stack
jugglers similar to those for the data stack are handy.
We deal with fp pairs as used for points, sizes and ranges and fp quads
for rectangles and colours.
F2SWAP F2OVER F2DROP F4DUP FTUCK FNIP do what you expect ...
-FROT is added here. Also known as F-ROT in some systems.
-------------------------------------------------------------------- ))
1 [IF]
\ in kernel
\ : -FROT ( F: r1 r2 r3 -- r3 r1 r2 )   fswap f>r fswap fr> ;
synonym -FROT F-ROT

\ : F2DUP ( F: r1 r2 -- r1 r2 r1 r2 )   fover fover ;
code F2DUP ( F: r1 r2 -- r1 r2 r1 r2 )
   movsd  xmm9, 0 [r13]
   sub    r13, # fpcell 2 *
   movsd  8 [r13], xmm8
   movsd  0 [r13], xmm9
   next,
end-code
   
\ : F2SWAP ( F: r1 r2 r3 r4 -- r3 r4 r1 r2 )   frot f>r frot fr>  ;
code F2SWAP ( F: r1 r2 r3 r4 -- r3 r4 r1 r2 )
   movsd xmm9, 8 [r13]
   movsd 8 [r13], xmm8
   movsd xmm8, xmm9
   movsd xmm9, 0 [r13]
   movsd xmm10, $10 [r13]
   movsd $10 [r13], xmm9
   movsd 0 [r13], xmm10
   next,
end-code

\ : F2OVER ( F: r1 r2 r3 r4 -- r1 r2 r3 r4 r1 r2 )   f>r f>r f2dup fr> fr> f2swap ;
code F2OVER ( F: r1 r2 r3 r4 -- r1 r2 r3 r4 r1 r2 )
   movsd xmm9, 8 [r13]
   movsd xmm10, $10 [r13]
   sub   r13, # fpcell 2 *
   movsd 8 [r13], xmm8
   movsd 0 [r13], xmm10
   movsd xmm8, xmm9
   next,
end-code

\ : F2DROP ( F: r1 r2 -- )   fdrop fdrop ;
code F2DROP ( F: r1 r2 -- )
   movsd xmm8, 8 [r13]
   add r13, # fpcell 2 *
   next,
end-code

(*
code F4DUP ( F: r1 r2 r3 r4 -- r1 r2 r3 r4 r1 r2 r3 r4 )
 fld   st(3)            \ r1 r2 r3 r4 -- r1 r2 r3 r4 r1 
 fld   st(3)            \ r1 r2 r3 r4 r1 -- r1 r2 r3 r4 r1 r2
 fld   st(3)            \ r1 r2 r3 r4 r1 r2 -- r1 r2 r3 r4 r1 r2 r3 
 fld   st(3)            \ r1 r2 r3 r4 r1 r2 r3 -- r1 r2 r3 r4 r1 r2 r3 r4
 fnext,
end-code
*)

\ : FTUCK ( F: r1 r2 -- r2 r1 r2 )   fswap fover ;
code FTUCK ( F: r1 r2 -- r2 r1 r2 )
   movsd xmm9, 0 [r13]
   movsd 0 [r13], xmm8
   sub r13, # fpcell
   movsd 0 [r13], xmm9
   next,
end-code

\ in kernel
\ : FNIP ( F: r1 r2 -- r2 )   fswap fdrop ;
[THEN]

cr .( fp utilities loaded)

\\ ( eof )

