(* ====================================================================
Mach absolute time

copyright 2002 Roelf Toxopeus

VFX64 version.

Last: 14 June 2020 at 13:52:27 CEST  -rt
==================================================================== *)

/forth
decimal

(( --------------------------------------------------------------------
/MACHTIME -- initialise the TIMEBASEINFO structure
MACHTIME -- return time in nanoseconds. Similar to VFX64 ns@
MachTicks -- returns ms. Similar to VFX64 ms@
-------------------------------------------------------------------- ))

/forth
decimal

function: mach_absolute_time ( -- n:uint64_t )
function: mach_timebase_info ( &info -- ret )

variable timebaseinfo
: /MACHTIME ( -- )   timebaseinfo mach_timebase_info drop ; 

/machtime         \ do it now

\ returns u nanosecs
: MACHTIME ( -- u )  mach_absolute_time timebaseinfo l@ timebaseinfo lcell+ l@ M*/ ;

: MachTicks ( -- ms )   machtime 1000000 / ;

: /MachTicks ( -- )   /machtime ['] machticks is ticks ;

\ cr .( machtime loaded )

\\ ( eof )

\ test:
: tt
   counter 1000 + 
   0 begin random drop 1+ over expired until
   nip . ;
   
\ using (ticks)
' (ticks) is ticks
tt ( 1405264  ok )
  
\ using machticks
' machticks is ticks  ok
tt ( 15046343  ok )
