(* ====================================================================
Mach2 prompt

copyright 2010 Roelf Toxopeus

VFX version.
OK prompt with stacks depth, a la Mach2 from the Palo Alto Shipping Co.
Last: 16 October 2014 12:09:44 CEST     -rt
==================================================================== *)

(( --------------------------------------------------------------------
BASEID -- return a one char string pair with base identifier.
STACKDEPTH -- return stack depth as string pair.
FSTACKDEPTH -- return numeric stack depth as string pair.
M2PROMPT -- display a Mach2 prompt:  ok <0>
/OK -- save current prompt and set Mach2 prompt.
-OK -- set saved prompt.
-------------------------------------------------------------------- ))

/forth
decimal

: BASEID ( -- a n )
   base @ dup 10 = if drop s" "  exit then
          dup 16 = if drop s" $" exit then
          dup  8 = if drop s" &" exit then
               2 = if      s" %" exit then
                           s" ?" ;
   
: STACKDEPTH ( -- a n )   depth s>d <# #s #> ;

: .M2STACK ( -- )
   pocket >r
   s" <"      r@ place
   baseid     r@ append
   stackdepth r@ append
   s" >"      r@ append
   r> count type ;
   
: FSTACKDEPTH ( -- a n )   fdepth s>d <# #s #> ;

: .M2FSTACK ( -- )
   pocket >r
   s" ["     r@ place
   baseid      r@ append
   fstackdepth r@ append
   s" ]"       r@ append
   r> count type ;

: M2PROMPT ( -- )
   state @ 0= if
      ."  ok" space
      .m2stack
      fdepth if space .m2fstack then
      \ cr
   then
   depth -> SbDepth
   base @ -> SbBase
   context @ -> sbContext
   current @ -> sbCurrent ;
   
: OK   postpone \ ; immediate

variable 'OK

: /OK
   action-of .prompt DUP ['] m2prompt = if drop exit then
   'ok !
   ['] m2prompt is .prompt ;

: -OK   'ok @ ?dup if is .prompt then ;


cr .( Mach2 like prompt loaded...)
cr .( /ok -- set Mach2 prompt)
cr .( -ok -- set previous prompt)


\\ ( eof )