\ libXL.fth

((
Copyright (c) 2014
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
20140521 MPE001 First release
))

only forth definitions
decimal


\ ===========
\ *> sharedlibs
\ *S LibXL - Excel interface
\ ===========
\ *P *\i{LibXL} is a library that can read and write Excel files. It
\ ** doesn't require Microsoft Excel or the .NET framework, and combines
\ ** a set of easy to use and powerful features. The library can be
\ ** used to:
\ *(
\ *B Generate a new spreadsheet from scratch
\ *B Extract data from an existing spreadsheet
\ *B Edit an existing spreadsheet
\ *)

\ *P *\i{LibXL} is proprietary code, but the price is very
\ ** reasonable. Versions exist for Windows, OS X, iOS and Linux.
\ ** *\i{LibXL} can be obtained from:
\ *C   www.libxl.com

\ *P This code is built as 32 bit code using the ASCII interface.
\ ** Consequently, strings shown with *\b{L"} in the C examples
\ ** are ASCII zero-terminated strings and the Forth word *\fo{z"}
\ ** can be used for them. The DLL interface uses the "C" calling
\ ** convention for all operating systems. The Windows version
\ ** should use *\i{libXL.dll} from the *\i{bin} directory of
\ ** *\i{LibXL} distribution.

[defined] Target_386_Windows [if]
Library: libXL.dll
[then]

[defined] Target_386_Linux [if]
[then]

[defined] Target_386_OSX [if]
[then]

: XLAPI   Extern:  ;

also types definitions
\ setup.h
: XLAPIENTRY	"C"  ;
\ handle.h
: BookHandle	void *  ;
: SheetHandle	void *  ;
: FormatHandle	void *  ;
: FontHandle	void *  ;
previous definitions

\ BookA.h

    XLAPI     BookHandle XLAPIENTRY xlCreateBookCA(void);
    XLAPI     BookHandle XLAPIENTRY xlCreateXMLBookCA(void);

    XLAPI    int XLAPIENTRY xlBookLoadA(BookHandle handle, const char * filename);
    XLAPI    int XLAPIENTRY xlBookSaveA(BookHandle handle, const char * filename);

    XLAPI    int XLAPIENTRY xlBookLoadRawA(BookHandle handle, const char * data, unsigned size);
    XLAPI    int XLAPIENTRY xlBookSaveRawA(BookHandle handle, const char ** data, unsigned* size);

    XLAPI    SheetHandle XLAPIENTRY xlBookAddSheetA(BookHandle handle, const char * name, SheetHandle initSheet);
    XLAPI    SheetHandle XLAPIENTRY xlBookInsertSheetA(BookHandle handle, int index, const char * name, SheetHandle initSheet);
    XLAPI    SheetHandle XLAPIENTRY xlBookGetSheetA(BookHandle handle, int index);
    XLAPI    int XLAPIENTRY xlBookSheetTypeA(BookHandle handle, int index);
    XLAPI    int XLAPIENTRY xlBookDelSheetA(BookHandle handle, int index);
    XLAPI    int XLAPIENTRY xlBookSheetCountA(BookHandle handle);

    XLAPI   FormatHandle XLAPIENTRY xlBookAddFormatA(BookHandle handle, FormatHandle initFormat);
    XLAPI    FontHandle XLAPIENTRY xlBookAddFontA(BookHandle handle, FontHandle initFont);
    XLAPI    int XLAPIENTRY xlBookAddCustomNumFormatA(BookHandle handle, const char * customNumFormat);
    XLAPI    const char * XLAPIENTRY xlBookCustomNumFormatA(BookHandle handle, int fmt);

    XLAPI   FormatHandle XLAPIENTRY xlBookFormatA(BookHandle handle, int index);
    XLAPI    int XLAPIENTRY xlBookFormatSizeA(BookHandle handle);

    XLAPI     FontHandle XLAPIENTRY xlBookFontA(BookHandle handle, int index);
    XLAPI     int XLAPIENTRY xlBookFontSizeA(BookHandle handle);

    XLAPI         double XLAPIENTRY xlBookDatePackA(BookHandle handle, int year, int month, int day, int hour, int min, int sec, int msec);
    XLAPI            int XLAPIENTRY xlBookDateUnpackA(BookHandle handle, double value, int * year, int * month, int * day, int * hour, int * min, int * sec, int * msec);

    XLAPI            int XLAPIENTRY xlBookColorPackA(BookHandle handle, int red, int green, int blue);
    XLAPI           void XLAPIENTRY xlBookColorUnpackA(BookHandle handle, int color, int * red, int * green, int * blue);

    XLAPI            int XLAPIENTRY xlBookActiveSheetA(BookHandle handle);
    XLAPI           void XLAPIENTRY xlBookSetActiveSheetA(BookHandle handle, int index);

    XLAPI            int XLAPIENTRY xlBookPictureSizeA(BookHandle handle);
    XLAPI            int XLAPIENTRY xlBookGetPictureA(BookHandle handle, int index, const char ** data, unsigned * size);

    XLAPI            int XLAPIENTRY xlBookAddPictureA(BookHandle handle, const char * filename);
    XLAPI            int XLAPIENTRY xlBookAddPicture2A(BookHandle handle, const char * data, unsigned size);

    XLAPI    const char * XLAPIENTRY xlBookDefaultFontA(BookHandle handle, int * fontSize);
    XLAPI           void XLAPIENTRY xlBookSetDefaultFontA(BookHandle handle, const char * fontName, int fontSize);

    XLAPI            int XLAPIENTRY xlBookRefR1C1A(BookHandle handle);
    XLAPI           void XLAPIENTRY xlBookSetRefR1C1A(BookHandle handle, int refR1C1);

    XLAPI           void XLAPIENTRY xlBookSetKeyA(BookHandle handle, const char * name, const char * key);

    XLAPI            int XLAPIENTRY xlBookRgbModeA(BookHandle handle);
    XLAPI           void XLAPIENTRY xlBookSetRgbModeA(BookHandle handle, int rgbMode);

    XLAPI            int XLAPIENTRY xlBookVersionA(BookHandle handle);
    XLAPI            int XLAPIENTRY xlBookBiffVersionA(BookHandle handle);

    XLAPI            int XLAPIENTRY xlBookIsDate1904A(BookHandle handle);
    XLAPI           void XLAPIENTRY xlBookSetDate1904A(BookHandle handle, int date1904);

    XLAPI            int XLAPIENTRY xlBookIsTemplateA(BookHandle handle);
    XLAPI           void XLAPIENTRY xlBookSetTemplateA(BookHandle handle, int tmpl);

    XLAPI            int XLAPIENTRY xlBookSetLocaleA(BookHandle handle, const char * locale);
    XLAPI    const char * XLAPIENTRY xlBookErrorMessageA(BookHandle handle);

    XLAPI           void XLAPIENTRY xlBookReleaseA(BookHandle handle);

\ FontA.h

    XLAPI         int XLAPIENTRY xlFontSizeA(FontHandle handle);
    XLAPI        void XLAPIENTRY xlFontSetSizeA(FontHandle handle, int size);

    XLAPI         int XLAPIENTRY xlFontItalicA(FontHandle handle);
    XLAPI        void XLAPIENTRY xlFontSetItalicA(FontHandle handle, int italic);

    XLAPI         int XLAPIENTRY xlFontStrikeOutA(FontHandle handle);
    XLAPI        void XLAPIENTRY xlFontSetStrikeOutA(FontHandle handle, int strikeOut);

    XLAPI         int XLAPIENTRY xlFontColorA(FontHandle handle);
    XLAPI        void XLAPIENTRY xlFontSetColorA(FontHandle handle, int color);

    XLAPI         int XLAPIENTRY xlFontBoldA(FontHandle handle);
    XLAPI        void XLAPIENTRY xlFontSetBoldA(FontHandle handle, int bold);

    XLAPI         int XLAPIENTRY xlFontScriptA(FontHandle handle);
    XLAPI        void XLAPIENTRY xlFontSetScriptA(FontHandle handle, int script);

    XLAPI         int XLAPIENTRY xlFontUnderlineA(FontHandle handle);
    XLAPI        void XLAPIENTRY xlFontSetUnderlineA(FontHandle handle, int underline);

    XLAPI const char * XLAPIENTRY xlFontNameA(FontHandle handle);
    XLAPI        void XLAPIENTRY xlFontSetNameA(FontHandle handle, const char * name);

\ FormatA.h

    XLAPI FontHandle XLAPIENTRY xlFormatFontA(FormatHandle handle);
    XLAPI        int XLAPIENTRY xlFormatSetFontA(FormatHandle handle, FontHandle fontHandle);

    XLAPI        int XLAPIENTRY xlFormatNumFormatA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetNumFormatA(FormatHandle handle, int numFormat);

    XLAPI        int XLAPIENTRY xlFormatAlignHA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetAlignHA(FormatHandle handle, int align);

    XLAPI        int XLAPIENTRY xlFormatAlignVA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetAlignVA(FormatHandle handle, int align);

    XLAPI        int XLAPIENTRY xlFormatWrapA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetWrapA(FormatHandle handle, int wrap);

    XLAPI        int XLAPIENTRY xlFormatRotationA(FormatHandle handle);
    XLAPI        int XLAPIENTRY xlFormatSetRotationA(FormatHandle handle, int rotation);

    XLAPI        int XLAPIENTRY xlFormatIndentA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetIndentA(FormatHandle handle, int indent);

    XLAPI        int XLAPIENTRY xlFormatShrinkToFitA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetShrinkToFitA(FormatHandle handle, int shrinkToFit);

    XLAPI       void XLAPIENTRY xlFormatSetBorderA(FormatHandle handle, int style);
    XLAPI       void XLAPIENTRY xlFormatSetBorderColorA(FormatHandle handle, int color);

    XLAPI        int XLAPIENTRY xlFormatBorderLeftA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetBorderLeftA(FormatHandle handle, int style);

    XLAPI        int XLAPIENTRY xlFormatBorderRightA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetBorderRightA(FormatHandle handle, int style);

    XLAPI        int XLAPIENTRY xlFormatBorderTopA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetBorderTopA(FormatHandle handle, int style);

    XLAPI        int XLAPIENTRY xlFormatBorderBottomA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetBorderBottomA(FormatHandle handle, int style);

    XLAPI        int XLAPIENTRY xlFormatBorderLeftColorA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetBorderLeftColorA(FormatHandle handle, int color);

    XLAPI        int XLAPIENTRY xlFormatBorderRightColorA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetBorderRightColorA(FormatHandle handle, int color);

    XLAPI        int XLAPIENTRY xlFormatBorderTopColorA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetBorderTopColorA(FormatHandle handle, int color);

    XLAPI        int XLAPIENTRY xlFormatBorderBottomColorA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetBorderBottomColorA(FormatHandle handle, int color);

    XLAPI        int XLAPIENTRY xlFormatBorderDiagonalA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetBorderDiagonalA(FormatHandle handle, int border);

    XLAPI        int XLAPIENTRY xlFormatBorderDiagonalStyleA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetBorderDiagonalStyleA(FormatHandle handle, int style);

    XLAPI        int XLAPIENTRY xlFormatBorderDiagonalColorA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetBorderDiagonalColorA(FormatHandle handle, int color);

    XLAPI        int XLAPIENTRY xlFormatFillPatternA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetFillPatternA(FormatHandle handle, int pattern);

    XLAPI        int XLAPIENTRY xlFormatPatternForegroundColorA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetPatternForegroundColorA(FormatHandle handle, int color);

    XLAPI        int XLAPIENTRY xlFormatPatternBackgroundColorA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetPatternBackgroundColorA(FormatHandle handle, int color);

    XLAPI        int XLAPIENTRY xlFormatLockedA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetLockedA(FormatHandle handle, int locked);

    XLAPI        int XLAPIENTRY xlFormatHiddenA(FormatHandle handle);
    XLAPI       void XLAPIENTRY xlFormatSetHiddenA(FormatHandle handle, int hidden);


\ SheetA.h

    XLAPI            int XLAPIENTRY xlSheetCellTypeA(SheetHandle handle, int row, int col);
    XLAPI            int XLAPIENTRY xlSheetIsFormulaA(SheetHandle handle, int row, int col);

    XLAPI   FormatHandle XLAPIENTRY xlSheetCellFormatA(SheetHandle handle, int row, int col);
    XLAPI           void XLAPIENTRY xlSheetSetCellFormatA(SheetHandle handle, int row, int col, FormatHandle format);

    XLAPI    const char * XLAPIENTRY xlSheetReadStrA(SheetHandle handle, int row, int col, FormatHandle * format);
    XLAPI            int XLAPIENTRY xlSheetWriteStrA(SheetHandle handle, int row, int col, const char * value, FormatHandle format);

    XLAPI         double XLAPIENTRY xlSheetReadNumA(SheetHandle handle, int row, int col, FormatHandle * format);
    XLAPI            int XLAPIENTRY xlSheetWriteNumA(SheetHandle handle, int row, int col, double value, FormatHandle format);

    XLAPI            int XLAPIENTRY xlSheetReadBoolA(SheetHandle handle, int row, int col, FormatHandle * format);
    XLAPI            int XLAPIENTRY xlSheetWriteBoolA(SheetHandle handle, int row, int col, int value, FormatHandle format);

    XLAPI            int XLAPIENTRY xlSheetReadBlankA(SheetHandle handle, int row, int col, FormatHandle * format);
    XLAPI            int XLAPIENTRY xlSheetWriteBlankA(SheetHandle handle, int row, int col, FormatHandle format);

    XLAPI    const char * XLAPIENTRY xlSheetReadFormulaA(SheetHandle handle, int row, int col, FormatHandle * format);
    XLAPI            int XLAPIENTRY xlSheetWriteFormulaA(SheetHandle handle, int row, int col, const char * value, FormatHandle format);

    XLAPI    const char * XLAPIENTRY xlSheetReadCommentA(SheetHandle handle, int row, int col);
    XLAPI           void XLAPIENTRY xlSheetWriteCommentA(SheetHandle handle, int row, int col, const char * value, const char * author, int width, int height);

    XLAPI            int XLAPIENTRY xlSheetIsDateA(SheetHandle handle, int row, int col);
    XLAPI            int XLAPIENTRY xlSheetReadErrorA(SheetHandle handle, int row, int col);

    XLAPI         double XLAPIENTRY xlSheetColWidthA(SheetHandle handle, int col);
    XLAPI         double XLAPIENTRY xlSheetRowHeightA(SheetHandle handle, int row);

    XLAPI            int XLAPIENTRY xlSheetSetColA(SheetHandle handle, int colFirst, int colLast, double width, FormatHandle format, int hidden);
    XLAPI            int XLAPIENTRY xlSheetSetRowA(SheetHandle handle, int row, double height, FormatHandle format, int hidden);

    XLAPI            int XLAPIENTRY xlSheetRowHiddenA(SheetHandle handle, int row);
    XLAPI            int XLAPIENTRY xlSheetSetRowHiddenA(SheetHandle handle, int row, int hidden);

    XLAPI            int XLAPIENTRY xlSheetColHiddenA(SheetHandle handle, int col);
    XLAPI            int XLAPIENTRY xlSheetSetColHiddenA(SheetHandle handle, int col, int hidden);

    XLAPI            int XLAPIENTRY xlSheetGetMergeA(SheetHandle handle, int row, int col, int * rowFirst, int * rowLast, int * colFirst, int * colLast);
    XLAPI            int XLAPIENTRY xlSheetSetMergeA(SheetHandle handle, int rowFirst, int rowLast, int colFirst, int colLast);
    XLAPI            int XLAPIENTRY xlSheetDelMergeA(SheetHandle handle, int row, int col);

    XLAPI            int XLAPIENTRY xlSheetPictureSizeA(SheetHandle handle);
    XLAPI            int XLAPIENTRY xlSheetGetPictureA(SheetHandle handle, int index, int * rowTop, int * colLeft, int * rowBottom, int * colRight,
                                                                                      int * width, int * height, int * offset_x, int * offset_y);

    XLAPI           void XLAPIENTRY xlSheetSetPictureA(SheetHandle handle, int row, int col, int pictureId, double scale, int offset_x, int offset_y);
    XLAPI           void XLAPIENTRY xlSheetSetPicture2A(SheetHandle handle, int row, int col, int pictureId, int width, int height, int offset_x, int offset_y);

    XLAPI            int XLAPIENTRY xlSheetGetHorPageBreakA(SheetHandle handle, int index);
    XLAPI            int XLAPIENTRY xlSheetGetHorPageBreakSizeA(SheetHandle handle);

    XLAPI            int XLAPIENTRY xlSheetGetVerPageBreakA(SheetHandle handle, int index);
    XLAPI            int XLAPIENTRY xlSheetGetVerPageBreakSizeA(SheetHandle handle);

    XLAPI            int XLAPIENTRY xlSheetSetHorPageBreakA(SheetHandle handle, int row, int pageBreak);
    XLAPI            int XLAPIENTRY xlSheetSetVerPageBreakA(SheetHandle handle, int col, int pageBreak);

    XLAPI           void XLAPIENTRY xlSheetSplitA(SheetHandle handle, int row, int col);

    XLAPI            int XLAPIENTRY xlSheetGroupRowsA(SheetHandle handle, int rowFirst, int rowLast, int collapsed);
    XLAPI            int XLAPIENTRY xlSheetGroupColsA(SheetHandle handle, int colFirst, int colLast, int collapsed);

    XLAPI            int XLAPIENTRY xlSheetGroupSummaryBelowA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetGroupSummaryBelowA(SheetHandle handle, int below);

    XLAPI            int XLAPIENTRY xlSheetGroupSummaryRightA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetGroupSummaryRightA(SheetHandle handle, int right);

    XLAPI           void XLAPIENTRY xlSheetClearA(SheetHandle handle, int rowFirst, int rowLast, int colFirst, int colLast);

    XLAPI            int XLAPIENTRY xlSheetInsertColA(SheetHandle handle, int colFirst, int colLast);
    XLAPI            int XLAPIENTRY xlSheetInsertRowA(SheetHandle handle, int rowFirst, int rowLast);
    XLAPI            int XLAPIENTRY xlSheetRemoveColA(SheetHandle handle, int colFirst, int colLast);
    XLAPI            int XLAPIENTRY xlSheetRemoveRowA(SheetHandle handle, int rowFirst, int rowLast);

    XLAPI            int XLAPIENTRY xlSheetCopyCellA(SheetHandle handle, int rowSrc, int colSrc, int rowDst, int colDst);

    XLAPI            int XLAPIENTRY xlSheetFirstRowA(SheetHandle handle);
    XLAPI            int XLAPIENTRY xlSheetLastRowA(SheetHandle handle);
    XLAPI            int XLAPIENTRY xlSheetFirstColA(SheetHandle handle);
    XLAPI            int XLAPIENTRY xlSheetLastColA(SheetHandle handle);

    XLAPI            int XLAPIENTRY xlSheetDisplayGridlinesA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetDisplayGridlinesA(SheetHandle handle, int show);

    XLAPI            int XLAPIENTRY xlSheetPrintGridlinesA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetPrintGridlinesA(SheetHandle handle, int print);

    XLAPI            int XLAPIENTRY xlSheetZoomA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetZoomA(SheetHandle handle, int zoom);

    XLAPI            int XLAPIENTRY xlSheetPrintZoomA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetPrintZoomA(SheetHandle handle, int zoom);

    XLAPI            int XLAPIENTRY xlSheetGetPrintFitA(SheetHandle handle, int * wPages, int * hPages);
    XLAPI           void XLAPIENTRY xlSheetSetPrintFitA(SheetHandle handle, int wPages, int hPages);

    XLAPI            int XLAPIENTRY xlSheetLandscapeA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetLandscapeA(SheetHandle handle, int landscape);

    XLAPI            int XLAPIENTRY xlSheetPaperA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetPaperA(SheetHandle handle, int paper);

    XLAPI    const char * XLAPIENTRY xlSheetHeaderA(SheetHandle handle);
    XLAPI            int XLAPIENTRY xlSheetSetHeaderA(SheetHandle handle, const char * header, double margin);
    XLAPI         double XLAPIENTRY xlSheetHeaderMarginA(SheetHandle handle);

    XLAPI    const char * XLAPIENTRY xlSheetFooterA(SheetHandle handle);
    XLAPI            int XLAPIENTRY xlSheetSetFooterA(SheetHandle handle, const char * footer, double margin);
    XLAPI         double XLAPIENTRY xlSheetFooterMarginA(SheetHandle handle);

    XLAPI            int XLAPIENTRY xlSheetHCenterA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetHCenterA(SheetHandle handle, int hCenter);

    XLAPI            int XLAPIENTRY xlSheetVCenterA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetVCenterA(SheetHandle handle, int vCenter);

    XLAPI         double XLAPIENTRY xlSheetMarginLeftA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetMarginLeftA(SheetHandle handle, double margin);

    XLAPI         double XLAPIENTRY xlSheetMarginRightA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetMarginRightA(SheetHandle handle, double margin);

    XLAPI         double XLAPIENTRY xlSheetMarginTopA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetMarginTopA(SheetHandle handle, double margin);

    XLAPI         double XLAPIENTRY xlSheetMarginBottomA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetMarginBottomA(SheetHandle handle, double margin);

    XLAPI            int XLAPIENTRY xlSheetPrintRowColA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetPrintRowColA(SheetHandle handle, int print);

    XLAPI           void XLAPIENTRY xlSheetSetPrintRepeatRowsA(SheetHandle handle, int rowFirst, int rowLast);
    XLAPI           void XLAPIENTRY xlSheetSetPrintRepeatColsA(SheetHandle handle, int colFirst, int colLast);
    XLAPI           void XLAPIENTRY xlSheetSetPrintAreaA(SheetHandle handle, int rowFirst, int rowLast, int colFirst, int colLast);

    XLAPI           void XLAPIENTRY xlSheetClearPrintRepeatsA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetClearPrintAreaA(SheetHandle handle);

    XLAPI            int XLAPIENTRY xlSheetGetNamedRangeA(SheetHandle handle, const char * name, int * rowFirst, int * rowLast, int * colFirst, int * colLast, int scopeId, int * hidden);
    XLAPI            int XLAPIENTRY xlSheetSetNamedRangeA(SheetHandle handle, const char * name, int rowFirst, int rowLast, int colFirst, int colLast, int scopeId);
    XLAPI            int XLAPIENTRY xlSheetDelNamedRangeA(SheetHandle handle, const char * name, int scopeId);

    XLAPI            int XLAPIENTRY xlSheetNamedRangeSizeA(SheetHandle handle);
    XLAPI    const char * XLAPIENTRY xlSheetNamedRangeA(SheetHandle handle, int index, int * rowFirst, int * rowLast, int * colFirst, int * colLast, int * scopeId, int * hidden);

    XLAPI    const char * XLAPIENTRY xlSheetNameA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetNameA(SheetHandle handle, const char * name);

    XLAPI            int XLAPIENTRY xlSheetProtectA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetProtectA(SheetHandle handle, int protect);

    XLAPI            int XLAPIENTRY xlSheetHiddenA(SheetHandle handle);
    XLAPI            int XLAPIENTRY xlSheetSetHiddenA(SheetHandle handle, int hidden);

    XLAPI           void XLAPIENTRY xlSheetGetTopLeftViewA(SheetHandle handle, int * row, int * col);
    XLAPI           void XLAPIENTRY xlSheetSetTopLeftViewA(SheetHandle handle, int row, int col);

    XLAPI            int XLAPIENTRY xlSheetRightToLeftA(SheetHandle handle);
    XLAPI           void XLAPIENTRY xlSheetSetRightToLeftA(SheetHandle handle, int rightToLeft);

    XLAPI           void XLAPIENTRY xlSheetAddrToRowColA(SheetHandle handle, const char * addr, int * row, int * col, int * rowRelative, int * colRelative);
    XLAPI    const char * XLAPIENTRY xlSheetRowColToAddrA(SheetHandle handle, int row, int col, int rowRelative, int colRelative);


\ libxl.h

    synonym xlCreateBook xlCreateBookCA
    synonym xlCreateXMLBook xlCreateXMLBookCA
    synonym xlBookLoad xlBookLoadA
    synonym xlBookSave xlBookSaveA
    synonym xlBookLoadRaw xlBookLoadRawA
    synonym xlBookSaveRaw xlBookSaveRawA
    synonym xlBookAddSheet xlBookAddSheetA
    synonym xlBookInsertSheet xlBookInsertSheetA
    synonym xlBookGetSheet xlBookGetSheetA
    synonym xlBookSheetType xlBookSheetTypeA
    synonym xlBookDelSheet xlBookDelSheetA
    synonym xlBookSheetCount xlBookSheetCountA
    synonym xlBookAddFormat xlBookAddFormatA
    synonym xlBookAddFont xlBookAddFontA
    synonym xlBookAddCustomNumFormat xlBookAddCustomNumFormatA
    synonym xlBookCustomNumFormat xlBookCustomNumFormatA
    synonym xlBookFormat xlBookFormatA
    synonym xlBookFormatSize xlBookFormatSizeA
    synonym xlBookFont xlBookFontA
    synonym xlBookFontSize xlBookFontSizeA
    synonym xlBookDatePack xlBookDatePackA
    synonym xlBookDateUnpack xlBookDateUnpackA
    synonym xlBookColorPack xlBookColorPackA
    synonym xlBookColorUnpack xlBookColorUnpackA
    synonym xlBookActiveSheet xlBookActiveSheetA
    synonym xlBookSetActiveSheet xlBookSetActiveSheetA
    synonym xlBookPictureSize xlBookPictureSizeA
    synonym xlBookGetPicture xlBookGetPictureA
    synonym xlBookAddPicture xlBookAddPictureA
    synonym xlBookAddPicture2 xlBookAddPicture2A
    synonym xlBookDefaultFont xlBookDefaultFontA
    synonym xlBookSetDefaultFont xlBookSetDefaultFontA
    synonym xlBookSetKey xlBookSetKeyA
    synonym xlBookRefR1C1 xlBookRefR1C1A
    synonym xlBookSetRefR1C1 xlBookSetRefR1C1A
    synonym xlBookRgbMode xlBookRgbModeA
    synonym xlBookSetRgbMode xlBookSetRgbModeA
    synonym xlBookVersion xlBookVersionA
    synonym xlBookBiffVersion xlBookBiffVersionA
    synonym xlBookIsDate1904 xlBookIsDate1904A
    synonym xlBookSetDate1904 xlBookSetDate1904A
    synonym xlBookIsTemplate xlBookIsTemplateA
    synonym xlBookSetTemplate xlBookSetTemplateA
    synonym xlBookSetLocale xlBookSetLocaleA
    synonym xlBookErrorMessage xlBookErrorMessageA
    synonym xlBookRelease xlBookReleaseA

    synonym xlSheetCellType xlSheetCellTypeA
    synonym xlSheetCellFormat xlSheetCellFormatA
    synonym xlSheetSetCellFormat xlSheetSetCellFormatA
    synonym xlSheetIsFormula xlSheetIsFormulaA
    synonym xlSheetReadStr xlSheetReadStrA
    synonym xlSheetWriteStr xlSheetWriteStrA
    synonym xlSheetReadNum xlSheetReadNumA
    synonym xlSheetWriteNum xlSheetWriteNumA
    synonym xlSheetReadBool xlSheetReadBoolA
    synonym xlSheetWriteBool xlSheetWriteBoolA
    synonym xlSheetReadBlank xlSheetReadBlankA
    synonym xlSheetWriteBlank xlSheetWriteBlankA
    synonym xlSheetReadFormula xlSheetReadFormulaA
    synonym xlSheetWriteFormula xlSheetWriteFormulaA
    synonym xlSheetReadComment xlSheetReadCommentA
    synonym xlSheetWriteComment xlSheetWriteCommentA
    synonym xlSheetIsDate xlSheetIsDateA
    synonym xlSheetReadError xlSheetReadErrorA
    synonym xlSheetColWidth xlSheetColWidthA
    synonym xlSheetRowHeight xlSheetRowHeightA
    synonym xlSheetSetCol xlSheetSetColA
    synonym xlSheetSetRow xlSheetSetRowA
    synonym xlSheetRowHidden xlSheetRowHiddenA
    synonym xlSheetSetRowHidden xlSheetSetRowHiddenA
    synonym xlSheetColHidden xlSheetColHiddenA
    synonym xlSheetSetColHidden xlSheetSetColHiddenA
    synonym xlSheetGetMerge xlSheetGetMergeA
    synonym xlSheetSetMerge xlSheetSetMergeA
    synonym xlSheetDelMerge xlSheetDelMergeA
    synonym xlSheetPictureSize xlSheetPictureSizeA
    synonym xlSheetGetPicture xlSheetGetPictureA
    synonym xlSheetSetPicture xlSheetSetPictureA
    synonym xlSheetSetPicture2 xlSheetSetPicture2A
    synonym xlSheetGetHorPageBreak xlSheetGetHorPageBreakA
    synonym xlSheetGetHorPageBreakSize xlSheetGetHorPageBreakSizeA
    synonym xlSheetGetVerPageBreak xlSheetGetVerPageBreakA
    synonym xlSheetGetVerPageBreakSize xlSheetGetVerPageBreakSizeA
    synonym xlSheetSetHorPageBreak xlSheetSetHorPageBreakA
    synonym xlSheetSetVerPageBreak xlSheetSetVerPageBreakA
    synonym xlSheetSplit xlSheetSplitA
    synonym xlSheetGroupRows xlSheetGroupRowsA
    synonym xlSheetGroupCols xlSheetGroupColsA
    synonym xlSheetGroupSummaryBelow xlSheetGroupSummaryBelowA
    synonym xlSheetSetGroupSummaryBelow xlSheetSetGroupSummaryBelowA
    synonym xlSheetGroupSummaryRight xlSheetGroupSummaryRightA
    synonym xlSheetSetGroupSummaryRight xlSheetSetGroupSummaryRightA
    synonym xlSheetClear xlSheetClearA
    synonym xlSheetInsertCol xlSheetInsertColA
    synonym xlSheetInsertRow xlSheetInsertRowA
    synonym xlSheetRemoveCol xlSheetRemoveColA
    synonym xlSheetRemoveRow xlSheetRemoveRowA
    synonym xlSheetCopyCell xlSheetCopyCellA
    synonym xlSheetFirstRow xlSheetFirstRowA
    synonym xlSheetLastRow xlSheetLastRowA
    synonym xlSheetFirstCol xlSheetFirstColA
    synonym xlSheetLastCol xlSheetLastColA
    synonym xlSheetDisplayGridlines xlSheetDisplayGridlinesA
    synonym xlSheetSetDisplayGridlines xlSheetSetDisplayGridlinesA
    synonym xlSheetPrintGridlines xlSheetPrintGridlinesA
    synonym xlSheetSetPrintGridlines xlSheetSetPrintGridlinesA
    synonym xlSheetZoom xlSheetZoomA
    synonym xlSheetSetZoom xlSheetSetZoomA
    synonym xlSheetPrintZoom xlSheetPrintZoomA
    synonym xlSheetSetPrintZoom xlSheetSetPrintZoomA
    synonym xlSheetGetPrintFit xlSheetGetPrintFitA
    synonym xlSheetSetPrintFit xlSheetSetPrintFitA
    synonym xlSheetLandscape xlSheetLandscapeA
    synonym xlSheetSetLandscape xlSheetSetLandscapeA
    synonym xlSheetPaper xlSheetPaperA
    synonym xlSheetSetPaper xlSheetSetPaperA
    synonym xlSheetHeader xlSheetHeaderA
    synonym xlSheetSetHeader xlSheetSetHeaderA
    synonym xlSheetHeaderMargin xlSheetHeaderMarginA
    synonym xlSheetFooter xlSheetFooterA
    synonym xlSheetSetFooter xlSheetSetFooterA
    synonym xlSheetFooterMargin xlSheetFooterMarginA
    synonym xlSheetHCenter xlSheetHCenterA
    synonym xlSheetSetHCenter xlSheetSetHCenterA
    synonym xlSheetVCenter xlSheetVCenterA
    synonym xlSheetSetVCenter xlSheetSetVCenterA
    synonym xlSheetMarginLeft xlSheetMarginLeftA
    synonym xlSheetSetMarginLeft xlSheetSetMarginLeftA
    synonym xlSheetMarginRight xlSheetMarginRightA
    synonym xlSheetSetMarginRight xlSheetSetMarginRightA
    synonym xlSheetMarginTop xlSheetMarginTopA
    synonym xlSheetSetMarginTop xlSheetSetMarginTopA
    synonym xlSheetMarginBottom xlSheetMarginBottomA
    synonym xlSheetSetMarginBottom xlSheetSetMarginBottomA
    synonym xlSheetPrintRowCol xlSheetPrintRowColA
    synonym xlSheetSetPrintRowCol xlSheetSetPrintRowColA
    synonym xlSheetSetPrintRepeatRows xlSheetSetPrintRepeatRowsA
    synonym xlSheetSetPrintRepeatCols xlSheetSetPrintRepeatColsA
    synonym xlSheetSetPrintArea xlSheetSetPrintAreaA
    synonym xlSheetClearPrintRepeats xlSheetClearPrintRepeatsA
    synonym xlSheetClearPrintArea xlSheetClearPrintAreaA
    synonym xlSheetGetNamedRange xlSheetGetNamedRangeA
    synonym xlSheetSetNamedRange xlSheetSetNamedRangeA
    synonym xlSheetDelNamedRange xlSheetDelNamedRangeA
    synonym xlSheetNamedRangeSize xlSheetNamedRangeSizeA
    synonym xlSheetNamedRange xlSheetNamedRangeA
    synonym xlSheetName xlSheetNameA
    synonym xlSheetSetName xlSheetSetNameA
    synonym xlSheetProtect xlSheetProtectA
    synonym xlSheetSetProtect xlSheetSetProtectA
    synonym xlSheetHidden xlSheetHiddenA
    synonym xlSheetSetHidden xlSheetSetHiddenA
    synonym xlSheetGetTopLeftView xlSheetGetTopLeftViewA
    synonym xlSheetSetTopLeftView xlSheetSetTopLeftViewA
    synonym xlSheetRightToLeft xlSheetRightToLeftA
    synonym xlSheetSetRightToLeft xlSheetSetRightToLeftA
    synonym xlSheetAddrToRowCol xlSheetAddrToRowColA
    synonym xlSheetRowColToAddr xlSheetRowColToAddrA

    synonym xlFontSize xlFontSizeA
    synonym xlFontSetSize xlFontSetSizeA
    synonym xlFontItalic xlFontItalicA
    synonym xlFontSetItalic xlFontSetItalicA
    synonym xlFontStrikeOut xlFontStrikeOutA
    synonym xlFontSetStrikeOut xlFontSetStrikeOutA
    synonym xlFontColor xlFontColorA
    synonym xlFontSetColor xlFontSetColorA
    synonym xlFontBold xlFontBoldA
    synonym xlFontSetBold xlFontSetBoldA
    synonym xlFontScript xlFontScriptA
    synonym xlFontSetScript xlFontSetScriptA
    synonym xlFontUnderline xlFontUnderlineA
    synonym xlFontSetUnderline xlFontSetUnderlineA
    synonym xlFontName xlFontNameA
    synonym xlFontSetName xlFontSetNameA

    synonym xlFormatFont xlFormatFontA
    synonym xlFormatSetFont xlFormatSetFontA
    synonym xlFormatNumFormat xlFormatNumFormatA
    synonym xlFormatSetNumFormat xlFormatSetNumFormatA
    synonym xlFormatAlignH xlFormatAlignHA
    synonym xlFormatSetAlignH xlFormatSetAlignHA
    synonym xlFormatAlignV xlFormatAlignVA
    synonym xlFormatSetAlignV xlFormatSetAlignVA
    synonym xlFormatWrap xlFormatWrapA
    synonym xlFormatSetWrap xlFormatSetWrapA
    synonym xlFormatRotation xlFormatRotationA
    synonym xlFormatSetRotation xlFormatSetRotationA
    synonym xlFormatIndent xlFormatIndentA
    synonym xlFormatSetIndent xlFormatSetIndentA
    synonym xlFormatShrinkToFit xlFormatShrinkToFitA
    synonym xlFormatSetShrinkToFit xlFormatSetShrinkToFitA
    synonym xlFormatSetBorder xlFormatSetBorderA
    synonym xlFormatSetBorderColor xlFormatSetBorderColorA
    synonym xlFormatBorderLeft xlFormatBorderLeftA
    synonym xlFormatSetBorderLeft xlFormatSetBorderLeftA
    synonym xlFormatBorderRight xlFormatBorderRightA
    synonym xlFormatSetBorderRight xlFormatSetBorderRightA
    synonym xlFormatBorderTop xlFormatBorderTopA
    synonym xlFormatSetBorderTop xlFormatSetBorderTopA
    synonym xlFormatBorderBottom xlFormatBorderBottomA
    synonym xlFormatSetBorderBottom xlFormatSetBorderBottomA
    synonym xlFormatBorderLeftColor xlFormatBorderLeftColorA
    synonym xlFormatSetBorderLeftColor xlFormatSetBorderLeftColorA
    synonym xlFormatBorderRightColor xlFormatBorderRightColorA
    synonym xlFormatSetBorderRightColor xlFormatSetBorderRightColorA
    synonym xlFormatBorderTopColor xlFormatBorderTopColorA
    synonym xlFormatSetBorderTopColor xlFormatSetBorderTopColorA
    synonym xlFormatBorderBottomColor xlFormatBorderBottomColorA
    synonym xlFormatSetBorderBottomColor xlFormatSetBorderBottomColorA
    synonym xlFormatBorderDiagonal xlFormatBorderDiagonalA
    synonym xlFormatSetBorderDiagonal xlFormatSetBorderDiagonalA
    synonym xlFormatBorderDiagonalStyle xlFormatBorderDiagonalStyleA
    synonym xlFormatSetBorderDiagonalStyle xlFormatSetBorderDiagonalStyleA
    synonym xlFormatBorderDiagonalColor xlFormatBorderDiagonalColorA
    synonym xlFormatSetBorderDiagonalColor xlFormatSetBorderDiagonalColorA
    synonym xlFormatFillPattern xlFormatFillPatternA
    synonym xlFormatSetFillPattern xlFormatSetFillPatternA
    synonym xlFormatPatternForegroundColor xlFormatPatternForegroundColorA
    synonym xlFormatSetPatternForegroundColor xlFormatSetPatternForegroundColorA
    synonym xlFormatPatternBackgroundColor xlFormatPatternBackgroundColorA
    synonym xlFormatSetPatternBackgroundColor xlFormatSetPatternBackgroundColorA
    synonym xlFormatLocked xlFormatLockedA
    synonym xlFormatSetLocked xlFormatSetLockedA
    synonym xlFormatHidden xlFormatHiddenA
    synonym xlFormatSetHidden xlFormatSetHiddenA

\ enum parser for enum.h

[undefined] enum [if]

: next-enum \ -- caddr len
\ +G A version of *\fo{PARSE-NAME} that works across multiple lines.
\ +* If a word cannot be obtained, the input stream is *\fo{REFILL}ed.
  begin
    [char] , parse dup 0=		\ scan input, no token?
  while					\ -- caddr len
    2drop  refill 0= #-411 ?throw	\ discard null, reload i/p
  repeat				\ -- char
;

: enum-term?	\ caddr len -- caddr len' flag
\ +G Return true if the last character is '}' or last two are '};'.
  2dup + 1- c@ [char] } =		\ trailing }?
  if  1- 1  exit  endif
  dup 2 >= if
   2dup + 2- s" };" s=
   if  2- 2 exit  endif
  endif
  0
;

: process-enum	\ u caddr len -- u'
\ +G Process one element of an enum.
  {: | temp[ 256 ] -- :}
  -white dup 2 >= if			\ check for C comments
    over s" //" s=
    if  2drop exit  endif
    over s" /*" s=
    if  2drop exit  endif
  endif
  dup 0= if				\ check if empty
    ( cr ." empty" ) 2drop  exit
  endif
  rot >r
  [char] = csplit 2swap dup if		\ string contains '='
    1 /string -white			\ step over '='
    isInteger? 1 <> #-13 ?throw		\ convert string
    r> drop >r				\ replace current value
  else
    2drop
  endif
  s" CONSTANT " temp[ place		\ build "CONSTANT <name>"
  -white temp[ append
  r@ temp[ count evaluate		\ build constant
  r> 1+					\ -- u'
;

: (enum)	\ --
\ +G Process an enum once the name has been processed.
   0  begin
     next-enum enum-term? 0=		\ -- u caddr len ; terminator?
    while
     process-enum
   repeat
   process-enum  drop
;

: enum		\ --
\ *G Process an enum of the form:
\ *C   enum <name> { a, b, c=10, d };
\ *P <name> is ignored. The elements appear as Forth constants.
\ ** The definition may extend over many lines. C comments may
\ ** occur after the ',' separator, e.g.
\ *C  JIM = 25, // comment about this line
  [char] { word drop  (enum)
;

: enum{		\ --
\ *G Process an enum of the form:
\ *C   enum{ a, b, c=10, d };
  (enum)
;

[then]

enum Color { COLOR_BLACK = 8, COLOR_WHITE, COLOR_RED, COLOR_BRIGHTGREEN, COLOR_BLUE, COLOR_YELLOW, COLOR_PINK, COLOR_TURQUOISE, COLOR_DARKRED,
            COLOR_GREEN, COLOR_DARKBLUE, COLOR_DARKYELLOW, COLOR_VIOLET, COLOR_TEAL, COLOR_GRAY25, COLOR_GRAY50, COLOR_PERIWINKLE_CF,
            COLOR_PLUM_CF, COLOR_IVORY_CF, COLOR_LIGHTTURQUOISE_CF, COLOR_DARKPURPLE_CF, COLOR_CORAL_CF, COLOR_OCEANBLUE_CF, COLOR_ICEBLUE_CF,
            COLOR_DARKBLUE_CL, COLOR_PINK_CL, COLOR_YELLOW_CL, COLOR_TURQUOISE_CL, COLOR_VIOLET_CL, COLOR_DARKRED_CL, COLOR_TEAL_CL,
            COLOR_BLUE_CL, COLOR_SKYBLUE, COLOR_LIGHTTURQUOISE, COLOR_LIGHTGREEN, COLOR_LIGHTYELLOW, COLOR_PALEBLUE, COLOR_ROSE, COLOR_LAVENDER,
            COLOR_TAN, COLOR_LIGHTBLUE, COLOR_AQUA, COLOR_LIME, COLOR_GOLD, COLOR_LIGHTORANGE, COLOR_ORANGE, COLOR_BLUEGRAY, COLOR_GRAY40,
            COLOR_DARKTEAL, COLOR_SEAGREEN, COLOR_DARKGREEN, COLOR_OLIVEGREEN, COLOR_BROWN, COLOR_PLUM, COLOR_INDIGO, COLOR_GRAY80,
            COLOR_DEFAULT_FOREGROUND = 0x0040, COLOR_DEFAULT_BACKGROUND = 0x0041, COLOR_TOOLTIP = 0x0051, COLOR_AUTO = 0x7FFF};

enum NumFormat {NUMFORMAT_GENERAL, NUMFORMAT_NUMBER, NUMFORMAT_NUMBER_D2, NUMFORMAT_NUMBER_SEP, NUMFORMAT_NUMBER_SEP_D2,
                NUMFORMAT_CURRENCY_NEGBRA, NUMFORMAT_CURRENCY_NEGBRARED, NUMFORMAT_CURRENCY_D2_NEGBRA, NUMFORMAT_CURRENCY_D2_NEGBRARED,
                NUMFORMAT_PERCENT, NUMFORMAT_PERCENT_D2, NUMFORMAT_SCIENTIFIC_D2, NUMFORMAT_FRACTION_ONEDIG, NUMFORMAT_FRACTION_TWODIG,
                NUMFORMAT_DATE, NUMFORMAT_CUSTOM_D_MON_YY, NUMFORMAT_CUSTOM_D_MON, NUMFORMAT_CUSTOM_MON_YY,
                NUMFORMAT_CUSTOM_HMM_AM, NUMFORMAT_CUSTOM_HMMSS_AM, NUMFORMAT_CUSTOM_HMM, NUMFORMAT_CUSTOM_HMMSS,
                NUMFORMAT_CUSTOM_MDYYYY_HMM,
                NUMFORMAT_NUMBER_SEP_NEGBRA = 37, NUMFORMAT_NUMBER_SEP_NEGBRARED,
                NUMFORMAT_NUMBER_D2_SEP_NEGBRA, NUMFORMAT_NUMBER_D2_SEP_NEGBRARED, NUMFORMAT_ACCOUNT, NUMFORMAT_ACCOUNTCUR,
                NUMFORMAT_ACCOUNT_D2, NUMFORMAT_ACCOUNT_D2_CUR, NUMFORMAT_CUSTOM_MMSS, NUMFORMAT_CUSTOM_H0MMSS,
                NUMFORMAT_CUSTOM_MMSS0, NUMFORMAT_CUSTOM_000P0E_PLUS0, NUMFORMAT_TEXT};

enum AlignH {ALIGNH_GENERAL, ALIGNH_LEFT, ALIGNH_CENTER, ALIGNH_RIGHT, ALIGNH_FILL, ALIGNH_JUSTIFY, ALIGNH_MERGE, ALIGNH_DISTRIBUTED};
enum AlignV {ALIGNV_TOP, ALIGNV_CENTER, ALIGNV_BOTTOM, ALIGNV_JUSTIFY, ALIGNV_DISTRIBUTED};

enum BorderStyle {BORDERSTYLE_NONE, BORDERSTYLE_THIN, BORDERSTYLE_MEDIUM, BORDERSTYLE_DASHED, BORDERSTYLE_DOTTED, BORDERSTYLE_THICK,
                  BORDERSTYLE_DOUBLE, BORDERSTYLE_HAIR, BORDERSTYLE_MEDIUMDASHED, BORDERSTYLE_DASHDOT, BORDERSTYLE_MEDIUMDASHDOT,
                  BORDERSTYLE_DASHDOTDOT, BORDERSTYLE_MEDIUMDASHDOTDOT, BORDERSTYLE_SLANTDASHDOT};

enum BorderDiagonal {BORDERDIAGONAL_NONE, BORDERDIAGONAL_DOWN, BORDERDIAGONAL_UP, BORDERDIAGONAL_BOTH};

enum FillPattern {FILLPATTERN_NONE, FILLPATTERN_SOLID, FILLPATTERN_GRAY50, FILLPATTERN_GRAY75, FILLPATTERN_GRAY25,
                  FILLPATTERN_HORSTRIPE, FILLPATTERN_VERSTRIPE, FILLPATTERN_REVDIAGSTRIPE, FILLPATTERN_DIAGSTRIPE,
                  FILLPATTERN_DIAGCROSSHATCH, FILLPATTERN_THICKDIAGCROSSHATCH, FILLPATTERN_THINHORSTRIPE, FILLPATTERN_THINVERSTRIPE,
                  FILLPATTERN_THINREVDIAGSTRIPE, FILLPATTERN_THINDIAGSTRIPE, FILLPATTERN_THINHORCROSSHATCH, FILLPATTERN_THINDIAGCROSSHATCH,
                  FILLPATTERN_GRAY12P5, FILLPATTERN_GRAY6P25};

enum Script {SCRIPT_NORMAL, SCRIPT_SUPER, SCRIPT_SUB};
enum Underline {UNDERLINE_NONE, UNDERLINE_SINGLE, UNDERLINE_DOUBLE, UNDERLINE_SINGLEACC = 0x21, UNDERLINE_DOUBLEACC = 0x22};

enum Paper {PAPER_DEFAULT, PAPER_LETTER, PAPER_LETTERSMALL, PAPER_TABLOID, PAPER_LEDGER, PAPER_LEGAL, PAPER_STATEMENT, PAPER_EXECUTIVE, PAPER_A3,
            PAPER_A4, PAPER_A4SMALL, PAPER_A5, PAPER_B4, PAPER_B5, PAPER_FOLIO, PAPER_QUATRO, PAPER_10x14, PAPER_10x17, PAPER_NOTE, PAPER_ENVELOPE_9,
            PAPER_ENVELOPE_10, PAPER_ENVELOPE_11, PAPER_ENVELOPE_12, PAPER_ENVELOPE_14, PAPER_C_SIZE, PAPER_D_SIZE, PAPER_E_SIZE, PAPER_ENVELOPE_DL,
            PAPER_ENVELOPE_C5, PAPER_ENVELOPE_C3, PAPER_ENVELOPE_C4, PAPER_ENVELOPE_C6, PAPER_ENVELOPE_C65, PAPER_ENVELOPE_B4, PAPER_ENVELOPE_B5,
            PAPER_ENVELOPE_B6, PAPER_ENVELOPE, PAPER_ENVELOPE_MONARCH, PAPER_US_ENVELOPE, PAPER_FANFOLD, PAPER_GERMAN_STD_FANFOLD,
            PAPER_GERMAN_LEGAL_FANFOLD, PAPER_B4_ISO, PAPER_JAPANESE_POSTCARD, PAPER_9x11, PAPER_10x11, PAPER_15x11, PAPER_ENVELOPE_INVITE,
            PAPER_US_LETTER_EXTRA = 50, PAPER_US_LEGAL_EXTRA, PAPER_US_TABLOID_EXTRA, PAPER_A4_EXTRA, PAPER_LETTER_TRANSVERSE, PAPER_A4_TRANSVERSE,
            PAPER_LETTER_EXTRA_TRANSVERSE, PAPER_SUPERA, PAPER_SUPERB, PAPER_US_LETTER_PLUS, PAPER_A4_PLUS, PAPER_A5_TRANSVERSE, PAPER_B5_TRANSVERSE,
            PAPER_A3_EXTRA, PAPER_A5_EXTRA, PAPER_B5_EXTRA, PAPER_A2, PAPER_A3_TRANSVERSE, PAPER_A3_EXTRA_TRANSVERSE, PAPER_JAPANESE_DOUBLE_POSTCARD,
            PAPER_A6, PAPER_JAPANESE_ENVELOPE_KAKU2, PAPER_JAPANESE_ENVELOPE_KAKU3, PAPER_JAPANESE_ENVELOPE_CHOU3, PAPER_JAPANESE_ENVELOPE_CHOU4,
            PAPER_LETTER_ROTATED, PAPER_A3_ROTATED, PAPER_A4_ROTATED, PAPER_A5_ROTATED, PAPER_B4_ROTATED, PAPER_B5_ROTATED,
            PAPER_JAPANESE_POSTCARD_ROTATED, PAPER_DOUBLE_JAPANESE_POSTCARD_ROTATED, PAPER_A6_ROTATED, PAPER_JAPANESE_ENVELOPE_KAKU2_ROTATED,
            PAPER_JAPANESE_ENVELOPE_KAKU3_ROTATED, PAPER_JAPANESE_ENVELOPE_CHOU3_ROTATED, PAPER_JAPANESE_ENVELOPE_CHOU4_ROTATED, PAPER_B6,
            PAPER_B6_ROTATED, PAPER_12x11, PAPER_JAPANESE_ENVELOPE_YOU4, PAPER_JAPANESE_ENVELOPE_YOU4_ROTATED, PAPER_PRC16K, PAPER_PRC32K,
            PAPER_PRC32K_BIG, PAPER_PRC_ENVELOPE1, PAPER_PRC_ENVELOPE2, PAPER_PRC_ENVELOPE3, PAPER_PRC_ENVELOPE4, PAPER_PRC_ENVELOPE5,
            PAPER_PRC_ENVELOPE6, PAPER_PRC_ENVELOPE7, PAPER_PRC_ENVELOPE8, PAPER_PRC_ENVELOPE9, PAPER_PRC_ENVELOPE10, PAPER_PRC16K_ROTATED,
            PAPER_PRC32K_ROTATED, PAPER_PRC32KBIG_ROTATED, PAPER_PRC_ENVELOPE1_ROTATED, PAPER_PRC_ENVELOPE2_ROTATED, PAPER_PRC_ENVELOPE3_ROTATED,
            PAPER_PRC_ENVELOPE4_ROTATED, PAPER_PRC_ENVELOPE5_ROTATED, PAPER_PRC_ENVELOPE6_ROTATED, PAPER_PRC_ENVELOPE7_ROTATED,
            PAPER_PRC_ENVELOPE8_ROTATED, PAPER_PRC_ENVELOPE9_ROTATED, PAPER_PRC_ENVELOPE10_ROTATED};

enum SheetType { SHEETTYPE_SHEET, SHEETTYPE_CHART, SHEETTYPE_UNKNOWN };

enum CellType {CELLTYPE_EMPTY, CELLTYPE_NUMBER, CELLTYPE_STRING, CELLTYPE_BOOLEAN, CELLTYPE_BLANK, CELLTYPE_ERROR};

enum ErrorType {ERRORTYPE_NULL = 0x00, ERRORTYPE_DIV_0 = 0x07, ERRORTYPE_VALUE = 0x0F, ERRORTYPE_REF = 0x17, ERRORTYPE_NAME = 0x1D,
                ERRORTYPE_NUM = 0x24, ERRORTYPE_NA = 0x2A};

enum PictureType {PICTURETYPE_PNG, PICTURETYPE_JPEG, PICTURETYPE_WMF, PICTURETYPE_DIB, PICTURETYPE_EMF,
                  PICTURETYPE_PICT, PICTURETYPE_TIFF, PICTURETYPE_ERROR = 0xFF};

enum SheetState {SHEETSTATE_VISIBLE, SHEETSTATE_HIDDEN, SHEETSTATE_VERYHIDDEN};

enum Scope {SCOPE_UNDEFINED = -2, SCOPE_WORKBOOK = -1};


\ ************
\ *N Test code
\ ************

((
int main()
{
    BookHandle book = xlCreateBook(); // xlCreateXMLBook()
    if(book)
    {
        SheetHandle sheet = xlBookAddSheet(book, L"Sheet1", 0);
        if(sheet)
        {
            xlSheetWriteStr(sheet, 2, 1, L"Hello, World !", NULL);
            xlSheetWriteNum(sheet, 3, 1, 1000.0, NULL);
        }
        xlBookSave(book, L"example.xls");
        xlBookRelease(book);
    }
    return 0;
}
))

[undefined] f@ [if]
include %vfxpath%/Lib/x86/Ndp387
[then]

: UniPlace	\ addr len destaddr --
\ *G Store a Unicode string to an address. The string is stored
\ ** as a cell counted string with a 16 bit zero terminator. The
\ ** terminator is not included in the count.
   2dup ! cell + 2dup + 0 swap w! swap cmove ;

: UniAppend ( addr len destaddr -- )
\ *G Append a string to the end of an address
   2dup @ + >r dup >r dup @ + 4 + 2dup + 0 swap ! swap cmove r> r> swap ! ;

: Ascii>Uni,	\ addr len --
\ *G Store an ASCII string as a Unicode string in the dictionary.
\ ** The string is stored as a cell counted string with a 16 bit
\ ** zero terminator. The terminator is not included in the count.
  dup 2* ,  bounds
  ?do  i c@ w,  loop
  0 w,
;

: Ascii>Uni	\ addr len dest --
\ *G Store an ASCII string as a Unicode string at an address.
\ ** The string is stored as a cell counted string with a 16 bit
\ ** zero terminator. The terminator is not included in the count.
  2dup !  cell + -rot  bounds
  ?do  i c@  over w!  2+  loop
  0 swap w!
;

: UniCount ( addr -- addr len )
\ *G Fetch a unicode string from an address.
   dup 4 + swap @ ;

: (lz")
  r> UniCount over -rot  + 2 + aligned >r
;

: LZ"		\ "text" -- zaddr
\ *G Unicode string - should behave the same way as z"
  STATE @ if
    POSTPONE (lz")
    [char] " PARSE Ascii>Uni, align
  else
    [char] " PARSE  pad Ascii>Uni  pad 4 +
  then
; IMMEDIATE

[undefined] CompTestCode? [if]  0 value CompTestCode?  [then]
CompTestCode? [IF]

0 value Book
0 value Sheet

: xlTest	\ --
\ *G libXL example 1
  xlCreateBook dup to Book if
    Book z" Sheet1" 0 xlBookAddSheet dup to Sheet if
      Sheet 2 1 z" Hello, World !" NULL xlSheetWriteStr drop
      Sheet 3 1 1000.0e0 NULL xlSheetWriteNum drop
    endif
    Book z" example.xls" xlBookSave drop
    Book xlBookRelease
  endif
;
[THEN]


\ ======
\ *> ###
\ ======

decimal
