\ STRINGPK.FTH - extended string package

((
Copyright (c) 1993-2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441

PLEASE NOTE THAT OUR PHONE NUMBER CHANGED IN APRIL 2000

To do
=====

Change history
==============
))


\ ==========
\ *> library
\ *S Extended String Package
\ ==========
( *P This optional wordset found in *\i{/Lib/StringPk.fth} contains the )
( ** following definitions to aid in the manipulation of counted        )
( ** strings.                                                           )

: $variable	\ #chars "name" --
( *G Create a string buffer with space reserved for #chars characters   )
  create  0 c,  allot
;

: $constant     \ "name" "text" --
( *G Create a string constant called "name" and parse the the closing   )
( ** quotes for the content.                                            )
  create  ",
;

(( Now in the kernel
: ($+)          \ c-addr u $dest --
( *G Add the string described by C-ADDR U to the counted string at      )
( ** $DEST. This word is now in the kernel.                             )
  >r  2dup  r@ count + swap cmove       \ add source to end
  r@ c@ + r> c!                         \ add length to count
  drop                                  \ remove address
;

: $+		\ $addr1 $addr2 --
( *G Add the counted string $ADDR1 to the counted buffer at $ADDR2.     )
( ** This word is now in the kernel.					)
  >r count r> ($+)
;
))

: $left         \ $addr1 n $addr2 --
( *G Add the leftmost N characters of the counted string at $ADDR1 to   )
( ** the counted buffer at $ADDR2.                                      )
  rot 1+ -rot append
;

: $mid          \ $addr1 s n $addr2 --
( *G Add N characters starting at offset S from the counted string at   )
( ** $ADDR1 to the counted buffer at $ADDR.                             )
  >r >r  + 1+  r> r> append
;

: $right        \ $addr1 n $addr2 --
( *G Add the rightmost N characters of the counted string at $ADDR1 to  )
( ** the counted buffer at $ADDR2.                                      )
  >r >r  count r@ - +  r> r> append
;

: $val		\ $addr -- n1..nn n
( *G Attempt to convert the counted string at $ADDR1 into a number. The )
( ** top-most return item indicates the number of CELLS used on stack to)
( ** store the return result. 0 Indicates the string was not a number, 1)
( ** for a single and 2 for a double. $VAL obeys the same rules as NUMBER?. )
  number?
;

: $len          \ $addr -- len
( *G Return the length of a counted string. Actually performs C@ and is )
( ** the same as COUNT NIP.                                             )
  c@
;

: $clr          \ $addr --
( *G Clear the contents of a counted string. Actually sets its length  )
( ** to zero. Primarily used to reset buffers declared with $VARIABLE.  )
  0 swap c!
;

: $upc          \ $addr --
( *G Convert the counted string at $ADDR to uppercase. This acts in     )
( ** place.                                                             )
  count upper
;

: $compare      \ $addr1 $addr2 -- -1/0/+1
( *G Compare two counted strings. Performs the same action as the ANS    )
( ** kernel definition COMPARE except that it uses counted strings as input  )
( ** parameters.                                                        )
  swap count rot count compare
;

: $<            \ $1 $2 -- flag
( *G A counted string equivalent to the numeric < operator. Uses        )
( ** $COMPARE then generates a well - formed flag.                      )
  $compare 0<
;

: $=            \ $1 $2 -- flag
( *G A counted string equivalent to the numeric = operator. Uses        )
( ** $COMPARE then generates a well - formed flag.                      )
  $compare 0=
;

: $>            \ $1 $2 -- flag
( *G A counted string equivalent to the numeric > operator. Uses        )
( ** $COMPARE then generates a well - formed flag.                      )
  $compare 0>
;

: $<>           \ $1 $2 -- flag
( *G A counted string equivalent to the numeric <> operator. Uses       )
( ** $COMPARE then generates a well-formed flag.                      )
  $compare 0<>
;

: $instr	\ $1 $2 -- false | index true
( *G Look for an occurance of the counted string $2 within the string   )
( ** $1. If found then the start offset within $1 is returned along with)
( ** a TRUE flag, otherwise FALSE is returned.                          )
  swap count over >r rot count  \ c-addr1 u1 c-addr2 u2 -- ; R: c-addr1 --
  search 0= if 2drop r> drop 0 exit then
  drop r> - true
;

\ ======
\ *> ###
\ ======

