\ CHAIN.FTH - extensible CASE chain

((
Copyright (c) 2001
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441

PLEASE NOTE THAT OUR PHONE NUMBER CHANGED IN APRIL 2000

To do
=====

Change history
==============
))


\ ==========
\ *> library
\ *S Extensible CASE Mechanism
\ ==========
\ *P A CHAIN is an extensible version of the CASE..OF..ENDOF..ENDCASE
\ ** mechanism. It is very similar to the *\fo{SWITCH} mechanism
\ ** described in the *\i{Tools and Utilities} chapter.

: case-chain    \ -- addr ; -- addr                              MPE.0000
( *G Begin initial definition of a chain                                )
  create
    here  0 ,
;

: item:         \ addr n -- addr ;                               MPE.0000
( *G Begin definition of a conditional code block                       )
  here  swap ,                  \ lay selector
  over @ ,  over !              \ lay link, update link
  :noname drop  !csp            \ start headerless word
  r> drop                       \ exit interpreter loop
;

: end-chain     \ addr --                                        MPE.0000
( *G Flag the end of the current block of additions to a chain          )
  drop
;

: in-chain?     \ n addr -- flag ;                               MPE.0000
( *G Return TRUE if N is in the chain beginning at ADDR                 )
  begin
    @ ?dup                      \ fail
    while
      2dup @ =                  \ check selector
      if  2drop -1  exit  endif \ true if they match
      cell+                     \ point to next link
  repeat
  drop  0
;

: exec-chain?   \ i*x n addr -- j*x true | n FALSE               MPE.0000
( *G Run through a given chain using TOS as a selector. If a match is   )
( ** made execute the relevant code block and return TRUE otherwise     )
( ** the initial selector and a FALSE flag is returned.                 )
  begin
    @ ?dup                      \ fail/end
    while
      2dup @ =                  \ check selector
      if  nip                   \ discard selector
          cell+ cell+ execute   \ execute headerless word
          -1  exit              \ return true
      endif
      cell+                     \ point to next link
  repeat
  0                             \ return: n 0
;

\ =======================================================================
( *N Using the chain mechanism                                          )
( **                                                                    )
( *E CASE-CHAIN <foo>                                                   )
( **   <n> ITEM: <words> ;                                              )
( **   <m> ITEM: <words> ;                                              )
( **   <k> ITEM: <words> ;                                              )
( ** END-CHAIN                                                          )
(                                                                       )
( *P More items can be added later:                                     )
( **                                                                    )
( *E <foo>                                                              )
( **   <x> ITEM: <words> ;                                              )
( **   ...                                                              )
( ** END-CHAIN                                                          )
(                                                                       )
( *P The data structures are as follows:                                )
( **                                                                    )
( *P CASE-CHAIN <foo> generates a variable that points to the last item )
( ** added to the list.                                                 )
( **                                                                    )
( *E ITEM: generates two cells and a headerless word:                   )
( **   selector                                                         )
( **   link                                                             )
( **   headerless word .... exit                                        )
(                                                                       )

\ ======
\ *> ###
\ ======


