\ dshifts.fth - double left/right shift operations

((
Copyright (c) 2012, 2015
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
20151104 SFP002 Added high level version for non-x86 CPUs.
))

only forth definitions
decimal

\ ===========
\ *! dshifts
\ *T Double shifts
\ ===========

[defined] cpu=386 [if]
code dlshift	\ d u -- d<<u
\ *G Double left shift by *\i{u} bits.
  mov   ecx, ebx		\ n
  mov   ebx, 0 [ebp]		\ dh
  mov   edx, 4 [ebp]		\ dl
  lea   ebp, 4 [ebp]
  shld  ebx, edx, cl		\ dh<<n
  shl   edx, cl			\ dl<<n
  mov   0 [ebp], edx
  next,
end-code

code drshift	\ d u -- d>>u
\ *G Double right shift by *\i{u} bits.
  mov   ecx, ebx		\ n
  mov   ebx, 0 [ebp]		\ dh
  mov   edx, 4 [ebp]		\ dl
  lea   ebp, 4 [ebp]
  shrd  edx, ebx, cl		\ dl>>n
  shr   ebx, cl			\ dh>>n
  mov   0 [ebp], edx
  next,
end-code
[then]

[undefined] dlshift [if]
: DLSHIFT	\ d u -- d<<u
  dup #32 >=
  if -rot  drop 0 swap  rot #32 - then	\ -- 0 dl u-32
  >r swap dup r@ lshift  swap #32 r@ - rshift  rot r> lshift or
;

: DRSHIFT 	\ d u -- d>>u
  dup #32 >=
  if  -rot  nip 0  rot #32 -  then	\ -- dh 0 u-32
  >r dup r@ rshift  swap #32 r@ - lshift  rot r> rshift or swap
;
[then]


\ ======
\ *> ###
\ ======

decimal

