\ CRECT.FTH - rectangle class for CIAO

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
))

\ *> ciao
( *N CRECT - Rect Class                                                 )
( **                                                                    )
( *P This is a class version of the RECT structure. The CRECT class is	)
( ** publicly derived from RECT with methods and operators.		)
( *E class CRect : public Rect						)
( ** public:							        )
( **                    meth:   Width				        )
( **                    meth:   Height				        )
( **                    meth:   SetXYWH				        )
( **                    meth:   SetLPRECT			        )
( **                    meth:   dump				        )
( **    ->              oper:   SetLPRect			        )
( **    xywh->          oper:   SetXYWH				        )
( **    lprect->        oper:   SetLPRECT			        )
( **    cout<<          oper:   dump				        )

class CRect : public Rect
public:
                        meth:   Width
                        meth:   Height
                        meth:   SetXYWH
                        meth:   SetLPRECT
                        meth:   dump
        ->              oper:   SetLPRect
        xywh->          oper:   SetXYWH
        lprect->        oper:   SetLPRECT
        cout<<          oper:   dump
end-class

: CRect::SetLPRECT      \ *rect --
  >r
  r@ (rect).left to left
  r@ (rect).top  to top
  r@ (rect).right to right
  r> (rect).bottom to bottom
;

: CRect::SetXYWH        \ x y w h --
  2over
  to top
  to left
  rot + to bottom
  + to right
;

: CRect::Width          \ -- n
  right left -
;

: CRect::Height         \ -- n
  bottom top -
;

: CRect::dump           \ --
  cr ." Rectangle left  (X)     $" left .
  cr ."           top   (Y)     $" top .
  cr ."           right         $" right .
  cr ."           bottom        $" bottom .
;

( *> ### )

