\ PRIMTYPE.FTH - primitive types

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
))


\ *> ciao
( *N Primitive Types                                                    )
( **                                                                    )
( *P This collection of classes represents the primitive data types     )
( ** found in C++. They can be though of as extended Forth VALUEs.      )
( **                                                                    )

\ =======================================================================
( *H INT                                                                )
( *P This data type represents a simple number which is basically       )
( ** equivalent to a CELL. It has no methods publically callable but    )
( ** simply uses operators to access.                                   )
( **                                                                    )
( *P The following operators have been assigned to methods for this     )
( ** class.                                                             )
( **                                                                    )
( *D <default>       No operator, returns contents.                     )
( *D to              Set content from stack item.                       )
( *D addr            Get the address rather than contents.              )
( *D ++              Increment by 1.                                    )
( *D --              Decrement by 1.                                    )
( *D cout<<          Write contents to console.                         )
( *D cout<<hex       Write contents as hex to console.                  )
( **                                                                    )

class int
private:
                        cell:   m_data
                        meth:   fetch
                        meth:   addr
                        meth:   store
                        meth:   plus1
                        meth:   minus1
                        meth:   output
                        meth:   hex-output

                        \ associate methods with operators

                        oper:   fetch           \ associate methods with operators
        addr            oper:   addr
        ->              oper:   store
        ++              oper:   plus1
        --              oper:   minus1
        cout<<          oper:   output
        cout<<hex       oper:   hex-output
end-class

: int::fetch            m_data @                ;
: int::addr             m_data                  ;
: int::store            m_data !                ;
: int::plus1            1 m_data +!             ;
: int::minus1           -1 m_data +!            ;
: int::output           m_data @ .              ;
: int::hex-output       m_data @ .dword space   ;

( *> ### )

