\ ClassDiag.fth - Diagnostic tools for ClassVFX.fth

((
Copyright (c) 2000, 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441

To do
=====

Change History
==============
20110407 SFP010 Documentation update
20101001 WJB009 v4.4 conversion
))

[-sin

also system definitions

create op#strings
  ", DEFAULT "                                                               \ 0
  ", TO "                                                                    \ 1
  ", ADDR "                                                                  \ 2
  ", INC "                                                                   \ 3
  ", DEC "                                                                   \ 4
  ", ADD "                                                                   \ 5
  ", ZERO "                                                                  \ 6
  ", SUB "                                                                   \ 7
  ", SIZEOF "                                                                \ 8
  ", SET "                                                                   \ 9
  ", OFFSETOF "                                                             \ 10
  ", +OFFSETOF "                                                            \ 11
  ", FETCH "                                                                \ 12
  ", ADDR\CNT "                                                             \ 13
  ", TWIST "                                                                \ 14
  ", <fifteen>"	        \ 15
  ", <=>"	        \ 16
  ", <blank>"	        \ 17
  ", <erase>"		\ 18
  ", <count>"		\ 19
  ", <make>"		\ 20
  ", <destroy>"		\ 21
  ", <INIT>"		\ 22
  ", <fetch>"		\ 23

\ #23 constant #knownOps

: .op#		\ n --
  { %op# --- }
  OperatorChain @ begin
    dup
   while
    dup @ %op# = IF
      CR %op# 4 .r space  dup body> >name .name
      DROP False
    ELSE
      cell+ @
    THEN
  repeat
  drop
;

: .mchain	\ 1st --
  cr
  begin
    ?dup
   while
    cr
    ( #02 >pos ) 2 spaces  dup methodid @ .op#
    dup space mxt @ .dword
    dup space mxt @ IP>NFA .NAME
    dup space mflags @ .dword
    mlink @
  repeat
;

: .method-chain	\ type --
  dup
  cr ." TYPE methods:"
  type-chain @ .mchain
  cr ." INSTANCE methods:"
  inst-chain @ .mchain
;

: (.struct)	\ struct -- ; display structure details
  cr  dup body> >name .name
  cr  ."   Provider: " dup provider @ ?dup
  if  >name .name
  else  ." None"
  endif

  cr ."   Offset: "  dup off-start @ .
  #16 >pos ." Size: "  dup type-size @ .

  cr ."   Fields: "  #16 >pos ." Size:"
  dup
  begin
    field-link @ ?dup
    while
      cr
      4 spaces  dup body> >name .name
      #18 >pos  dup type-size @ 8 .R
                dup off-start @ 8 .R
  repeat

  .method-chain
;

also forth definitions

: mof		\ -- ; display methods of type in text stream
  ' >body .method-chain
;

: .struct       \ -- ; .STRUCT <name> to display structure details
  ' >body (.struct)
;

: .structs      \ -- ; display all structures
  struct-chain
  begin
    @ ?dup
   while
    dup (.struct) cr
    type-prev
  repeat
;

only forth definitions

sin]
