\ TestClassVfx.fth - ClassVFX test code

((
Copyright (c) 2000, 2005
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   htpp://www.mpeforth.com

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
))


\ *******************
\ test the dot parser
\ *******************

type: point:
  int: y0
  int: x0

  mruns default 2@                                             \ fetch operation
  mruns to      2!

end-type

point: MyPoint
  5 4 to MyPoint

: t1                                             \ -- ; show contents of MyPoint
  MyPoint
  swap ." X0 = " .  ."  Y0 = " .  ;

: t2                                               \ x y -- ; store into MyPoint
  to MyPoint  t1  ;

: t3                                                 \ -- ; show size of MyPoint
  cr ." Size of MyPoint = " sizeof MyPoint .
;

: t4                                              \ -- ; show address of MyPoint
  cr ." Address of MyPoint = " addr MyPoint .
;

: t5                                   \ -- ; test local variable implementation
  point: foo                       \ N.B. START-LOCALS and END-LOCALS not needed
  int: bah!
  zero bah!
  5 4 to foo
  foo swap . .
;

: t6                \ -- ; test that recursion works - do not execute, decompile
  point: bar
  6 10 to bar
  abort
  recurse
;

\ Compound structures test

: line@                                                \ addr -- p1x p1y p2x p2y
  >r  r@ 2@  r> 8 + 2@
;

: line!                                                \ p1x p1y p2x p2y addr --
  >r  r@ ( sizeof point: + ) 8 + 2!  r> 2!
;

type: line:
  point: p1
  point: p2

  mruns default line@
  mruns to      line!

end-type

Line: MyLine                                                \ Defines a new line
  1 2 3 4 to MyLine                                         \ and initialises it

+structures                                   \ Switch on the aaa.bbb.ccc parser

: .MyLine                                         \ -- ; show contents of MyLine
  MyLine.p1.x0 .
  MyLine.p1.y0 .
  MyLine.p2.x0 .
  MyLine.p2.y0 .
;

: .p1                                                 \ -- ; show contents of P1
  MyLine.p1  cr swap ." MYLINE.P1.X0 = " .  ."  Y0 = " .
;

: .p2                                                 \ -- ; show contents of P2
  MyLine.p2  cr swap ." MYLINE.P2.X0 = " .  ."  Y0 = " .
;

: .p1p2                                        \ -- ; show contents of P1 and P2
  .p1 .p2
;

: setp1                                        \ x y -- ; set P1 field of MYLINE
  to MyLine.p1  .p1
;

: setp2                                        \ x y -- ; set P2 field of MYLINE
  to MyLine.p2  .p2
;

: setp3		\ x y --
  Line: Aline
  to Aline.p2
  ALine.p2  cr swap ." ALINE.P2.X0 = " .  ."  Y0 = " .
;

: foo                                                                    ( --- )
  cr .Myline
  5 6 7 8 to MyLine
  cr .MyLine ." should be 5 6 7 8"
  1 to MyLine.p2.x0
  cr .Myline ." should be 5 6 1 8"
  inc MyLine.p2.x0
  cr .Myline ." should be 5 6 2 8"
  dec MyLine.p2.x0
  cr .Myline ." should be 5 6 1 8"
  zero Myline.p2.x0
  cr .Myline ." should be 5 6 0 8"
  set Myline.p2.x0
  cr .Myline ." should be 5 6 -1 8"
;

1 2 3 4 to MyLine   cr ." should be: 1 2 3 4      is:" .Myline
10 11 to Myline.p1  cr ." should be: 10 11 3 4    is:" .MyLine
12 13 to Myline.p2  cr ." should be: 10 11 12 13  is:" .Myline
20 to Myline.p1.x0  cr ." should be: 20 11 12 13  is:" .Myline
21 to Myline.p1.y0  cr ." should be: 20 21 12 13  is:" .Myline
22 to Myline.p2.x0  cr ." should be: 20 21 22 13  is:" .Myline
23 to Myline.p2.y0  cr ." should be: 20 21 22 23  is:" .Myline
  inc Myline.p2.y0  cr ." should be: 20 21 22 24  is:" .Myline
  dec Myline.p2.y0  cr ." should be: 20 21 22 23  is:" .Myline
  set Myline.p2.y0  cr ." should be: 20 21 22 -1  is:" .Myline
 zero Myline.p2.y0  cr ." should be: 20 21 22 0   is:" .Myline

-structures                                     \ Switch off the aa.bb.cc parser


\ **************
\ DOS FILE NAMES
\ **************
((
TYPE: DOSFILE$:
   12 SKIPPED
END-TYPE

operator: <=>

also system definitions

: DOSFILE$-<default>                                          \ obj --- addr cnt
   sizeof DOSFILE$: ;

: DOSFILE$-<to>                                             \ addr cnt obj --- )
   \ Move addr cnt to object and blank rest
    sizeof DOSFILE$:
    2DUP >R >R  $TO$ R> R> squeeze UPPER
  ;

: DOSFILE$-<=>                                                  \ addr obj --- )
  \ Move addr cnt to object and blank rest
    sizeof DOSFILE$: TUCK
    2DUP >R >R  $TO$ R> R> squeeze UPPER
  ;

previous definitions

also system
EXTEND-TYPE DOSFILE$:
\            mruns DEFAULT  DOSFILE$-<default>
           mruns TO       DOSFILE$-<to>
           mruns <=>      DOSFILE$-<=>
           :m ZERO    inst-blank ;m  structure-method
           :m DEFAULT inst-count ;m  structure-method
           :m <init>  inst-blank ;m  structure-method
	   :m dec     inst-count  postpone #65  postpone fill  ;m  structure-method
	   :m add     inst-count ;m  structure-method
END-TYPE
previous

: .$		\ addr len --
  cr [char] " emit  type  [char] " emit
;

: x1		\ --
  dosfile$: my$
  my$ blank
  my$ .$
  dec my$
  my$ .$
  add my$
  my$ .$
  c" hello" count to my$
  my$ .$
;

Line: AnotherLine

int: MyPtr  TypeCast: MyPtr Line:

Sizeof Line: buffer: SomeLine

+structures
: x2
\  SomeLine to MyPtr
  AnotherLine to MyPtr
  1 2 to MyPtr.P1
  MyPtr.P1 . .
;

: x3
  int: ThPtr  PointsTo: ThPtr Line:
  SomeLine to ThPtr
  1 2 to ThPtr.P1
  ThPtr.P1 . .
;

: x4
  Pointer: ThPtr Line:
  SomeLine to ThPtr
  1 2 to ThPtr.P1
  ThPtr.P1 . .
;
-structures
))
