
0 [if]
Class $x is a dictionary-based simple string class whose length may vary,
up to a maximum of 255, but the maximum length is defined at instantiation.
We cheat a bit here and use the INDEXED class definition abilities and 
indexed ivar data area in a way that was not really intended.  

$x's are nice for use as string ivars, or if you want a persistent string
object in the dictionary (no handles here so we don't need to do a new:
and restore the data at each runtime).

[then]

\ HAVE pad 0= [IF]
create pad2 100 allot
create pad3 100 allot
\ [THEN]

HAVE " 0= [IF]
 : " [char] " word pad move$ pad ;
\ : " [char] " parse ( addr len ) dup >r swap pad2 move
\   r> pad2 c! pad2 ;
[THEN]



:class $x <super IndexedObj  1 <indexed  \ Each character is one byte.
 \ At instantiation we simply declare the maximum size
 \ desired as if for a byte array.  Note that we must allow for the
 \ count byte.  So if we want 10 chars max we must instantiate with 11

:m limit:  ( -- lim )
 limit 1- ;m

:m get$: \ ( -- $ptr ) \ str255 format
 idxbase ;m

:m size:  \ ( -- len)
 get$: self c@ ;m


:m setsize:  \ ( len --)
 dup  limit: self > abort" No more room in $x."
 get$: self c!
 ;m

:m clear:
 0 setsize: self ;m

:m classinit:
 clear: self ;m

:m Addr: \ ( -- addr)  \ redefine to give us the indexed data area+1
   \ which will be the address of the first character of text
 idxbase 1+ ;m

:m put: ( addr len -- )
 dup >r  ( addr len )
 setsize: self  
 ( addr-src)  Addr: self ( dest) r> ( len-cnt) move ;m

:m get: ( -- addr len )
 Addr: self  size: self ;m

:m print:
 get: self type ;m

:m put$:  ( $ptr -- )
 count put: self ;m

:m add: ( addr len  -- )
 dup ( addr len len )
 size: self dup >r + setsize: self  ( addr len )
 ( addr-src len )
 Addr: self r> + ( addr-src len dest )
 swap move ;m


:m add$: ( $ptr -- )
 count add: self ;m

Have >= 0= [IF]
: >= ( n1 n2 -- f )
  swap 1+ < ;
[THEN]

Have <= 0= [IF]
: <= ( n1 n2 -- f )
  1+ swap > ;
[THEN]


:m uc: \  ( -- )  converts to upper case
 get: self TO-UPPER ;m

:m +:  ( c -- ) \ appends a char to the end of the string
 pad3 c! pad3 1 add: self ;m

:m clip:  ( n -- )  \ remove n characters from end of string
     \ if n is too large, string is just cleared with no error
 size: self over - 0 max setsize: self ;m

;class

0 [IF]

11 $x ss


S" Hello" put: ss




print: ss
Hello
s" World" add: ss

print: ss
HelloWorld

[THEN]
