\ class20dispatch

\ Neon Model, Full
0 [IF]
\ for gforth and VFX, do a copy/paste
include e:\class20dispatch.f

\ for Carbon MacForth and SwiftForth, just include... this file
[THEN]

DECIMAL


: HAVE  ( -- f )  BL WORD FIND NIP ;

0 value GF \ gforth
0 value VFX \ VFX Forth
0 value CMF \ Carbon MacForth
0 value SF \ SwiftForth
have no-interpretation-does-code [if] true to GF [then]
have OVI.MAGIC [if] true to VFX [then]
have macforth.picture [if] true to CMF [then]
have SWIFTFORTH-TOOLBAR [if] true to SF [then]


10 value line-end  \ Line Ends are decimal 10 for non-Macs

CMF [IF]

anew --class--  \ forget --class--  forget HAVE

trace off debug off

\ we know we are on a Macintosh
13 to line-end

\ just for Carbon MacForth, we must remove this name. Otherwise it will conflict
\ with the addr: selector
s" ADDR:"  FORTH-WORDLIST  >>FINDNAME
FORTH-WORDLIST >>REMOVEENTRY drop

\ Carbon MacForth version
: ?isLocal ( token -- t/f )
  info-find-token @infotype 13 = ;

\ Carbon MacForth version
 : ?isValue ( token -- t/f )
  info-find-token  @infotype 4 = ;
  
[ELSE]

: ?isLocal ( token -- t/f )
  drop false ;

 : ?isValue ( token -- t/f )
  drop false ;

[THEN]

\ HAVE PARSE 0= [IF]
\ : PARSE  ( -- addr len )  BL WORD COUNT ;
\ [THEN]

HAVE NOOP 0= [IF]
: NOOP ;
[THEN]

SF [IF]
: LROT  ( x1 u -- x2 )
 2DUP LSHIFT >R  32 SWAP - RSHIFT R> OR ;

\ from Charles Melice
 : HASH  ( addr u -- uh )
  TUCK OVER CHARS + SWAP  \ len addr+len addr
  ?DO 5 LROT I C@ BL OR BL XOR BL 1- - XOR LOOP 
  DUP 0< IF EXIT  INVERT THEN ;
[THEN]


HAVE HASH 0= [IF]
: LROT  ( x1 u -- x2 )
  2DUP LSHIFT >R  32 SWAP - RSHIFT R> OR ;

\ from Charles Melice
 : HASH  ( addr u -- uh )
  TUCK OVER CHARS + SWAP  \ len addr+len addr
  ?DO 5 LROT I C@ BL OR BL XOR BL 1- - XOR LOOP 
  DUP 0< IF EXIT  INVERT THEN ;

[THEN]

HAVE CELL 0= [IF]

1 CELLS CONSTANT CELL
[THEN]

: RESERVE  ( n -- )  HERE OVER ERASE ALLOT ;
: LINK  ( addr -- )   HERE  OVER @ ,  SWAP ! ;

0 VALUE ^Class
0 VALUE newObject
0 VALUE (ClassInit:)

: IFA ( ^class -- addr )
  1 CELLS  + ;    \ ivar dict Latest field

: DFA ( ^class -- addr ) \ data field addr
  2 CELLS  + ;

: XFA ( ^class -- addr )
  3 CELLS  + ;
  
: SFA ( ^class -- addr )
  4 CELLS  + ;

 \ # of columns for 2-dimensional array, if 0 then not 2-dim array
: 2DFA  ( ^class -- addr )
  5 CELLS + ;

: TAG   6 CELLS  + ;

7 CELLS CONSTANT classSize

CREATE classTag


: ?MEMERR  ( ior -- )  ABORT" Memory allocation error" ;

\ ***** heap table accessing
0 value heapTable \ will be an allocated pointer
0 value heapTableSize \ size in bytes

: initHeapTable ( n -- ) \ n is number of cells
 cells dup allocate
 ?MEMERR to heapTable to heapTableSize
 heapTable heapTableSize erase ; \ initialize all cells to zero
: freeHeapTable heapTable free ?MEMERR 0 to heapTableSize ;

: hTableSize ( -- cells) heapTableSize cell / ;

: resizeHeapTable ( n -- ) \ n is number of cells
 cells dup heapTable swap RESIZE
 ?MEMERR to heapTable to heapTableSize ;
: hElemAddr ( Idx -- addr) cells heapTable + ;
: toHeapTable ( n Idx -- ) hElemAddr ! ;
: atHeapTable ( Idx -- n ) hElemAddr @ ;
: incrHeapTable ( -- ) \ increase size by 1 cell
 hTableSize 1 + resizeHeapTable
 0 hTableSize 1 -  toHeapTable \ zero the slot
 ;

\ for debugging only
\ : dt ( Display heap Table )
\  hTableSize  0 DO cr i . space i atHeapTable . LOOP ;

\ ***** superclass table accessing
: supTable ( -- addr) \ address of first cell of table, which will be the size
 ^Class SFA @ @ ;
: supTableSize ( -- cells)
  supTable @ cell / ;
 
: atSupTable ( Idx -- n ) cells supTable + @ ;

\ ***** dispatch table accessing
: disTable ( -- addr) \ address of first cell of table, which will be the size
 ^class @ ;
: disTelemAddr ( Idx -- addr) disTable + ;

: toDisTable ( n Idx -- ) disTelemAddr ! ;
: atDisTable ( Idx -- n ) disTelemAddr @ ;

: notUnderStood true abort" Method not understood by object" ;

: transferMethodXTs  \ transfer from heap table to allotted table
  hTableSize   1 DO i atHeapTable ( xt)
     dup 0= IF drop ['] notUnderStood THEN   
      disTable i cell * + ! LOOP
      hTableSize 1 - cell *  ^class @ ! ; \ store number of xts*4 in cell zero

\ for debugging only, display dispatch table for given class
\ example usage:  ' var dxt
\ : dxt ( ^class -- )
\  >BODY locals| ^cls |
\  ^cls @ @ cell / 1 + ( #ofcells) 0 
\  DO cr i . space ^cls @ i cell * + @ . LOOP ;
\ 
\ : q ( ^class -- )
\  >BODY locals| ^cls |
\  ^cls @ @ cell / 1 + ( #ofcells) 0 
\  DO cr i  . 9 emit ^cls @ i cell * + @ dup
\   ['] notUnderStood = IF drop 0 THEN . LOOP ;

: AdvanceSuperclMethodXTs \ from supTable to heapTable
 hTableSize 1
 DO i atHeapTable 0=
  IF \ we have an open slot, so check superclass
     i supTableSize <= \ make sure super table is within bounds
     IF
      \ transfer the xt from superclass table to heap table
       i atSupTable ( xt) i toHeapTable
     THEN
  THEN
 LOOP ;

: ?isClass  ( pfa -- f )
 TAG @ classTag = ;

: ?isObj  ( pfa -- )
 @ DUP IF ?isClass THEN ;

: classAllot  ( n -- )
 ^Class DFA +! ;

: classAlign  ( -- )
 ^Class DFA @  ALIGNED  ^Class DFA ! ;

: @width  ( ^class -- elWidth )  \ return the indexed element width for a class
 XFA @  0 MAX ;

: ?Class   ^Class   0= ABORT" Not inside a class definition" ;

\ =====================================================================
\ Objects have a pointer to their class stored in the first cell of
\ their pfa. When they execute, they return the address of the cell
\ following the class pointer, which is location of the first named
\ instance variable.
\
\ Object structure: | ^class | named ivars |
\
\ If an object is indexed, an indexed header appears after the data area.
\ This header consists of a cell containing the number of elements.
\ The indexed data follows this header.
\
\ Indexed object: | ^class | named ivars | #elems | indexed ivars |
\ =====================================================================

: (Obj)  ( -- )  CREATE  DOES> CELL+ ;

: >obj  ( xt -- ^obj )
 >BODY CELL+ ;

: >class  ( ^obj -- ^class )
 CELL - @ ;
 
\ Find in Linked List.
\ Search for n0 in the linked list whose head is addr0.
\ Return hitAddr under true if n0 is found, else return false.

\ in an ivar search n0 is the hashed ivar name and addr0 is IFA
\ the hitAddr is for the offset of the ivar's data
   
: FIND-IVAR  ( n0 addr0 -- hitAddr true | false )
  BEGIN
    @ DUP  \ is the contents of the address non-zero?
  WHILE
    \ yes it is non-zero, it contains the address of the next node
   2DUP  \ n0 addr n0 addr
   CELL+ @
   =  \ does n0 match n at this node?
   IF
    \ yes it does, so get the address of the second dataField, or hitAddr
    \ and exit while indicating true
    [ 2 CELLS ] literal + NIP TRUE EXIT
   THEN
   \ no, so continue the loop using the next node's addr
  REPEAT
   \ the search failed, return false
   NIP ;

\ =====================================================================
\ Method execution. The current object address is stored in the value ^base.
\ The object is only valid inside of a method definition. When we call a
\ method, we save the old object pointer and set it to the current object.
\ When the method returns, we restore the object pointer.

0 VALUE ^base  \ pointer to current object

: EXECUTE-METHOD  ( ^obj xt -- )
 ^base >R
 SWAP ( xt ^obj ) to ^base   EXECUTE
 R> to ^base ;

: EXECUTE-IVAR  ( xt offset -- )
 ^base >R  ^base + to ^base  EXECUTE  R> to ^base ;

HAVE CATCH [IF]
: CATCH  ( -- n )  ^base >R   CATCH   R> to ^base ;
[THEN]


0 [if] \ default to error check

: >xt ( SelId ^class -- xt ) \ fastest version, no error check
					\ use after debugging program is done
 @ + @ ;

: Defer**   ( ^obj SelId --  ) \ fastest version, no error check
  postpone literal
  postpone over \ ^obj xt-offset ^obj
  cell postpone literal
  postpone -
  postpone @
  postpone @
  postpone +
  postpone @
  postpone EXECUTE-METHOD ;

[else]

 : >xt ( SelId ^class -- xt ) \ error check version for development
  over  over @ @ > IF true abort" Method not understood by object"  THEN
  @ + @ ;


: Defer**   ( ^obj SelId --  ) \ error check version
  postpone literal
  postpone over \ ^obj xt-offset ^obj
  cell postpone literal
  postpone -
  postpone @
  postpone >xt
  postpone EXECUTE-METHOD ;

 [then]

: obj>xt  ( SelId ^obj -- xt )
 >class >xt ;

: FIND-METHOD-RUN  ( SelID ^obj -- ^obj xt )
 tuck ( ^obj SelID ^obj )
 obj>xt ; 

: FIND-METHOD-RUN-EXECUTE ( SelID ^obj -- )
 FIND-METHOD-RUN EXECUTE-METHOD ;

: (Defer)  ( ^obj SelId -- )  over cell - @ >xt EXECUTE-METHOD ;

: Defer,   ( SelId -- )  POSTPONE LITERAL  POSTPONE (Defer) ;

: parse_]
 >R  [CHAR] ] PARSE  EVALUATE  R> ;
 
: Deferred  ( SelId -- )  \ run time
  parse_] (Defer) ;

: Deferred,  ( SelId -- )  \ compile time
  parse_] Defer, ;


: hash>  ( -- n )  BL WORD COUNT HASH ;

\ =====================================================================
\ Instance variable consists of five cell-sized fields. The fifth field
\ is used for indexed ivars only. Offsets are in cells.
\ 
\     Offset   Name      Description
\     ------   ----      ---------------------------------------
\        0     link      points to link of next ivar in chain
\        1     name      32-bit hash value of name
\        2     class     pointer to class
\        3     offset    offset in object to start of ivar data
\        4     #elem     number of elements (indexed ivars only)
\        5     #cols     number of columns (2-dim indexed ivars only)
\
\ In the stack diagrams, "ivar" refers to the starting address of this
\ structure.  The IFA field of a class points to the first ivar.
\ =====================================================================

: iclass     ( ivar -- 'class )   2 CELLS +   ;
: @IvarOffs  ( ivar -- offset )   3 CELLS + @ ;
: @IvarElems ( ivar -- #elems )   4 CELLS + @ ;
: @IvarCols  ( ivar -- #cols )    5 CELLS + @ ;
 
\ =====================================================================
\ Build SUPER and SELF pseudo ivars. These are always the last
\ two ivars in a class. When we define a class, we will patch the
\ class fields to the appropriate class and superclass.


CREATE ^Self
 0 ,  \ link
 hash> self , \ name
 0 ,  \ class
 0 ,    \ offset

CREATE ^Super
 ^Self ,  \ link
 hash> super , \ name
 0 ,  \ class
 0 ,    \ offset

\ Create a dummy class that "object" inherits from.

CREATE Meta classSize RESERVE

^Super   Meta IFA ! \ latest ivar
classTag Meta TAG ! \ class tag

: move$ ( src$ptr\dest$ptr --) \ copy src to dest, dest must be long enough
 over c@ 1+ move ;

\ ====================================================================
\ support for cascaded messages

0 value doingCascade

\ we store the last $ptr following a selector here
\ a $ptr is a counted string or Pascal type str255
create lastWord 64 allot

: handle_| ( $ptr1 -- $ptr2 )
 >R
 false to doingCascade
 R@ count ( addr len ) 1 = IF c@ [char] | = IF true to doingCascade THEN
        ELSE ( addr ) drop
        THEN
 doingCascade
 IF lastWord ( $ptr2 )  r> drop
 ELSE R@ lastWord move$ r>
 THEN ;


\ =====================================================================
\ Determine if next word is an instance var.
\ Return pointer to class field in ivar structure.

: vFind  ( str -- str false | ^iclass true )
  handle_| 
 ^Class
 IF DUP COUNT HASH ^Class IFA FIND-IVAR 
  DUP IF  ROT DROP  THEN
 ELSE FALSE
 THEN ;

\ send ClassInit: message to ivar on stack
: InitIvar  ( ivar offset -- )
 OVER @IvarOffs + newObject +   ( ivar addr )
 (ClassInit:) ROT iclass @ >xt EXECUTE-METHOD ;

: ClassInit  ( -- )  \ send ClassInit: to newObject
 newObject (ClassInit:)
 newObject obj>xt EXECUTE-METHOD ;

\ =====================================================================
\ ITRAV traverses the tree of nested ivar definitions in a class,
\ building necessary class pointers and indexed area headers.
 
\ used in ITRAV for 2-dim array support
0 value clss
0 value ivr
0 value adr

: ITRAV   ( ivar offset -- )  >R  ( ivar -- )
 BEGIN DUP ^Super <>
 WHILE DUP iclass @ IFA @
  OVER @IvarOffs R@ + RECURSE  ( initialize ivar's ivars )
  DUP iclass @  ( get ivar class )
  DUP XFA @  ( needs class pointer? )
  IF OVER @IvarOffs R@ + newObject +
   ( ivar ^Class ivarAddr -- )
   over to clss
   2DUP CELL - !   \ store class pointer
   OVER @width  ( indexed? )
   IF SWAP DFA @ +  \ addr of indexed area
    OVER dup to ivr @IvarElems  \ #elems
    SWAP dup to adr !   \ upper array limit #rows
    clss 2dfa @ IF ivr @ivarcols adr cell + ! THEN  \ store  #cols
   ELSE 2DROP
   THEN
  ELSE DROP
  THEN
  DUP R@ InitIvar  \ send ClassInit:
  @   \ next ivar in chain
 REPEAT R> 2DROP ;

\ Converts lower-case characters to upper case, modifying the contents
: TO-UPPER   ( addr cnt -- )
 over \ addr cnt addr
 + swap  \ cnt+addr addr
 ?DO i c@ dup
  [char] a [char] z 1+ WITHIN
  IF 32 - i c!
  ELSE drop
  THEN
 LOOP ;


\ =====================================================================
\ Compile an instance variable dictionary entry.

\ possibly a 1-dimension array
: 1<Var ( #rows ^Class | ^Class -- )  \ #rows = #elems
  DUP XFA @  \ #rows class xfa
 IF
  CELL classAllot \ if indexed, allow for class ptr ( add 4 to DFA )
 THEN
 \ #rows class
 ^Class DFA @ ,    \ offset to ivar data
 \ #rows class

 DUP @width DUP \ #rows class wid wid
 IF \ #rows class wid
  ROT \ class wid #rows
  DUP ,  \ store #rows  ( class wid #rows )
  * CELL+   \   ( class (wid*#rows)+cell )  CELL+ for idx-hdr
 THEN
 SWAP \  (wid*#rows)+cell class
 DFA @ + classAllot ;  \ Account for named ivar lengths

\ a 2-dimension array
: 2<Var ( #rows #cols ^Class  -- )
 >R    \ row col
 CELL classAllot \ indexed, allow for class ptr
 ^Class DFA @ ,    \ offset to ivar data
 2dup   \ row col row col
 swap
 ( row ) ,  \ store #rows
 ( col ) ,  \ store #cols
 \ row col
 * R@ @width * CELL+
 R> DFA @ + cell+ classAllot ;  \ Account for named ivar lengths

: <Var ( #rows #cols ^Class | #rows ^Class | ^Class -- )
 BL WORD vFind ( str false | ^iclass true ) ABORT" Duplicate instance variable"
 \ #rows #cols class str
 COUNT HASH     \ get hash value of name
 ALIGN ^Class IFA  ( addr ) LINK ( hashedN ) ,   \ link & name
 \ #rows #cols class
 DUP ,     \ store class  ( #rows #cols class )
 dup 2DFA @  \ -1 or 0
  IF
  2<Var
  ELSE
  1<Var
  THEN ;

: 1IDX-HDR   ( #rows ^Class | ^Class -- indlen )
 @width DUP  \ #rows wid wid
 IF \ width is non-zero \ #rows wid
  OVER \ #rows wid #elems
  ( limit ) , \ #rows wid
  *  \ indlen = #rows * wid
 THEN ;

: 2IDX-HDR   ( #rows #cols ^Class  -- indlen )
 @width DUP >R
  \ row col wid
 IF \ width is non-zero
    \ row col
  2dup  \ row col row col
  swap
  ( row ) ,
  ( col ) ,
              \ row col
  * R> ( wid ) *  \ indlen
 THEN ;

\ Compile the indexed data header into an object
: IDX-HDR   ( #rows #cols ^Class | #rows ^Class | ^Class -- indlen )
 dup 2DFA @
 IF
   2IDX-HDR
 ELSE
   1IDX-HDR
 THEN ;

\ =====================================================================
\ Build an instance of a class. If we are inside a class definition, 
\ build an instance variable. Otherwise build a global object.

: Build   ( ^Class -- )
  ^Class
 IF <Var \ build an ivar if we are inside a class
 ELSE
  (Obj)   \ create object 
  DUP >R ,  \ store class pointer 
  HERE TO newObject \ remember current object
  R@ DFA @ RESERVE \ allot space for ivars
  R@ IDX-HDR RESERVE \ allot space for indexed data
  R> IFA @ 0 ITRAV \ init instance variables
  ClassInit  \ send CLASSINIT: message
 THEN ;

create <ss ," <SUPER" 
create <s$ 64 allot

\ allows for abbreviated :class <name> syntax.  Default superclass is Object
: scanForSuper
 >in @ \ keep on stack for later restore
 bl word <s$ move$
 <s$ count to-upper
 <s$ count <ss count compare
 IF \ strings are not equal
  c" <super object" count evaluate
 THEN >in ! ;

\ =====================================================================
\ Build a class header with its superclass pointer.

\ Need the following to handle the case when a class(s) are forgotten.
\ We keep a linked list of addresses and Selindexs at the start of that address
0 value lastSelectorIndex
variable selectorList 0 selectorList !  \ initialize to zero

: resetLastSelectorIndex ( here -- )
 selectorList @ 0=
 IF drop exit THEN \ first time through (class object), so do nothing
 ( here) selectorList @
 BEGIN
 ( here addri) 2dup <
 WHILE
  @
 REPEAT
  dup cell+ @  \ here addri SelIndx
  dup to lastSelectorIndex \ reset index
  swap dup selectorList !  \ reset head of linked list
  cell+ ! \ store SelInx to match address at head of LL
  ( here) drop ;
 
: :Class
 here resetLastSelectorIndex
 CREATE 0 to ^Class
 scanForSuper
 DOES>  Build ;

: <Super
 HERE to ^Class   \ save current class
 classSize ALLOT   \ reserve rest of class data, except for method dispatch table
 ' >BODY    \ pfa of superclass
 DUP ^Class classSize MOVE \ copy class data
 DUP ^Class SFA !  \ store pointer to superclass
 ^Super iclass !   \ store superclass in SUPER
 ^Class ^Self iclass !  \ store my class in SELF

  ^Class SFA @ meta =  \ will be true only when compiling class OBJECT
  IF \ compiling class object, so there is no superclass dispatch table
  1 initHeapTable \ cell 0 will be #ofXTs for this class
  ELSE \ get initial size from superclass
   supTableSize ( size of superclass dispatch table in cells) 

     1 + initHeapTable \ start with a heap table same size as superclass
  THEN ;

: ;Class  ( -- )
 classAlign  \ align class data size (optional)
 here ^class !  hTableSize cells reserve
 AdvanceSuperclMethodXTs
 transferMethodXTs
 freeHeapTable
 selectorList link lastSelectorIndex ,
 0 ^Super iclass ! \ clear out super and self class pointers
 0 ^Self  iclass !
 0 to ^Class ;  \ clear class compiling flag

\ =====================================================================
\ Object Compiler. We rely on being able to classify the type of
\ object from it's execution token.
\
\
\ Key to instantiation actions
\ 1 = objType  defined as an object
\ 2 = classType  as a class
\ 3 = valueType  as a value  \ requires custom detection code for specific Forth used
\ 4 = localType  as a local  \ requires custom detection code for specific Forth used
\ 5 = leftBracketType  open bracket for defer group
\ 6 = **  late bind to object preceding message
\ 7 = brace type, left or right.  For repeating messages  e.g.  get: { obj1 obj2 obj3 ... }
\ 8 = ivarType  as an ivar
\
\ =====================================================================

\ support for cascaded messages
0 value lastToken
0 value lastTokenID

: saveLast ( xt tokenID -- xt tokenID )
 2dup to lastTokenID  to lastToken ;

: ?is** ( *ptr -- t/f )
  count 2 = IF dup c@ [char] * = swap
  1+ c@ [char] * = and
  ELSE drop false
  THEN ;

: ?isChar ( $ptr char -- t/f )
  swap count    \ char addr len
  1 =
  IF c@ =
  ELSE 2drop false
  THEN ;

: ?isCascade ( $ptr -- t/f )
 [char] | ?isChar ;

: ?isLeftBrace ( $ptr -- t/f )
 [char] { ?isChar ;

: ?isRightBrace ( $ptr -- t/f )
 [char] } ?isChar ;

: ?isLeftBracket ( $ptr -- t/f )
 [char] [ ?isChar ;

false value RptMsg?  

\ ( $ptr -- xt tokenID | tokenID )  Determine type of token referenced by string.
\ types 1-4 return an xt under the ID, types 5, 6, 7, and 8 return just the ID
: refToken
 DUP 8 = IF ( 8) exit ( compiling an ivar) THEN
 DUP ?isCascade  IF drop lastToken lastTokenID EXIT THEN
 DUP ?isLeftBracket IF drop 5 EXIT   THEN
 DUP ?is**   IF drop 6 EXIT   THEN  
 DUP ?isLeftBrace   IF drop true to RptMsg? 7 EXIT   THEN
 DUP ?isRightBrace   IF drop false to RptMsg? 7 EXIT   THEN
 FIND 0= ABORT" undefined object"
 DUP ?isLocal   IF  4 saveLast EXIT  THEN
 DUP ?isValue   IF  3 saveLast EXIT  THEN
 DUP >BODY ?isObj IF  1 saveLast EXIT   THEN
 DUP >BODY ?isClass IF  2 saveLast EXIT   THEN
 TRUE ABORT" Invalid object type" ;

: (ivarRef)   ( xt offset -- )
 SWAP  POSTPONE LITERAL  POSTPONE LITERAL  POSTPONE EXECUTE-IVAR ;

: FIND-METHOD-ivar   ( SelID ^obj -- ^obj xt )
 over >r		\ SelID ^obj
 dup >class ^class =
 IF \ we must look in heap table
  ( SelID ^obj ) swap cell / atHeapTable dup 0=
  IF drop ( ^obj ) \ we must look in superclass table
    r@ ( ^obj Sel) cell / atSupTable
  THEN
 ELSE ( ^obj Sel) FIND-METHOD-RUN
 THEN r> drop ;
 
: ivarRef   ( selID ^iclass -- )
 CELL+ FIND-METHOD-ivar  SWAP @  ( xt offset )  ?DUP
 IF (ivarRef)
 ELSE COMPILE,
 THEN ;

: callMethod  ( xt -- )
 POSTPONE LITERAL  POSTPONE EXECUTE-METHOD ;

: (objRef)   ( SelID objCfa -- )
 >obj ( SelID ^obj ) FIND-METHOD-RUN ( ^obj xt )
 swap ( xt ^obj )
 POSTPONE LITERAL  callMethod ;

0 value $str
0 value selID

: compileRef \ ( selID $str -- )  Compile a reference to an object.
 to $str to selID
 BEGIN
  selID $str 
  vFind ( $str -- $str false | ^iclass true ) IF 8 THEN
  refToken CASE
    1 ( object ) OF  (objRef)   ENDOF
    2 ( class  ) OF  >BODY ( SelID ^Class) >xt callMethod ENDOF
    3 ( value  ) OF  COMPILE, Defer, ENDOF
    4 ( local  ) OF  COMPILE, Defer, ENDOF
    5 ( leftBracket ) OF   Deferred,   ENDOF
    6 ( ** )   OF  ( ^obj selID )   Defer**  ENDOF  
    7 ( { or }  )   OF ( selID ) drop ENDOF
      8 ( ivar )   OF ( ^class ) ivarRef ENDOF
  ENDCASE
   RptMsg?
   IF BL WORD dup to $str ?isRightBrace \ f=loop, t=end_loop
   ELSE true \ not repeating, signal to end_loop
   THEN
 UNTIL ;
 
: runRef  \ ( selID $str -- )  Run time behavior.
  to $str to selID
 BEGIN
  selID $str  
  refToken CASE
    1 ( object ) OF ( SelID objCfa ) >obj  FIND-METHOD-RUN-EXECUTE ENDOF
    2 ( class  ) OF  >BODY >xt EXECUTE-METHOD ENDOF
    3 ( value ) OF  EXECUTE   FIND-METHOD-RUN-EXECUTE ENDOF
    5 ( leftBracket ) OF   Deferred EXIT  ENDOF
    6 ( ** )    OF  ( ^obj selID ) swap FIND-METHOD-RUN-EXECUTE ENDOF
    7 ( { or }  )   OF ( selID ) drop  ENDOF
  ENDCASE
  RptMsg?
  IF BL WORD to $str false  \ repeating, grab next word and signal continue
  ELSE true  \ not repeating, signal a stop-loop here
  THEN
 UNTIL ;

: handleMessage  ( SelID -- ) 
 false to RptMsg?  \ initialize
 BL WORD  STATE @
 IF compileRef
 ELSE runRef
 THEN ;

: ?isSel  ( str -- flag )
 DUP DUP C@ CHARS +  C@ [CHAR] :  =  SWAP C@ 1 > AND ;

: ?Selector ( -- )
 >IN @ BL WORD ?isSel 0= ABORT" Not a selector"  >IN ! ;
 
: Selector  ( <name:> -- )  ?Selector
 CREATE  IMMEDIATE
 lastSelectorIndex cell + dup to lastSelectorIndex
  ,
 selectorList link lastSelectorIndex ,
 DOES>  @
 handleMessage ;

: getSelect  ( -- SelID )
  >IN @  BL WORD FIND
 IF >BODY  @  NIP ( already defined)
 ELSE DROP >IN ! Selector
  HERE cell - @
 THEN ;


\ **************** NEW METHOD COMPILER 8-3-08 ******************

create methodText 1000 allot \ buffer in which to build a method
0 value methodTextSize

: $>mt ( $ptr -- ) \ 'string to methodText'
 count ( src len ) >r methodText methodTextSize + ( src dest )
    r@ move r> methodTextSize + to methodTextSize ;

create bl$ ( -- $ptr) 1 c, 32 c,

create pw ( -- $ptr) 64 allot  \ current parsed word from parsed line
create ;M$ ( -- $ptr) ," ;M"

create selectorbuff 64 allot

: $add ( src$ptr\dest$ptr --) \ adds src$ to the end of dest$.  src$ is unchanged.
 locals| $2 $1 |
 $1 1+ ( src)
 $2 dup c@ + 1+ ( dest)
 $1 c@ ( count)
 cmove
 $1 c@  $2 c@ + $2 c! ;

: isBackslash? ( $ptr -- flag)
 dup c@ 1 =
 swap 1 + c@ [char] \ = and ;


0 value lastWordSel? \ true if prior word was a selector
0 value lookingForRightBrace

create <cc ," CLASSINIT:"
create <c$ 64 allot

0 value compilingClassinit?

\ automatically compile classinit: super if defining classinit:
: scanForClassinit
 >in @ 
 bl word <c$ move$
 <c$ count to-upper
 <c$ count <cc count compare 0=
 IF \ we have classinit:
   -1 to compilingClassinit? \ set flag so we compile "classinit: super" in :M below
 THEN
 >in ! ;

0 value doClassinitScan \ must wait until class OBJECT is defined to invoke

\ =====================================================================
\ Build a methods dictionary entry. :M starts a method definition
\ by adding to the class method list and starting the compiler with
\ :NONAME. ;M ends a method and saves the method xt.

0 value curSelIdx

create parsedLine 500 allot \ should be enough
0 value parsedLineSize

create pw-upper 64 allot

\ pw will be the next counted string (word to process in the method compiler)
\ from the current line being processed
: process-word ( -- n ) \ 0= hit a backslash, 1= hit ;M, 2=process next word
 pw c@ 0= IF 2 exit THEN
 pw pw-upper move$ \ use a temp $ so we can keep the original's case
 pw-upper count to-upper
 pw-upper count ;M$ count compare 0= IF ( hit ;M ) 1 exit THEN
 pw ?isLeftBrace IF  true to lookingForRightBrace 2 exit THEN
 pw ?isRightBrace IF  2 exit THEN 
 pw isBackslash?
 IF 0 exit THEN
 pw-upper FIND nip
 IF ( found) pw ?isSel to lastWordSel? 2 exit
 ELSE pw ?isSel
    IF ( make new selector)
      c" selector " selectorbuff move$
      pw selectorbuff $add
      selectorbuff count evaluate
      true to lastWordSel? 2 exit \ 07/16/08 dbh  
    ELSE ( is it an ivar?)
     lastWordSel? IF false to lastWordSel? 2 exit THEN \ don't prepend "addr:"
     pw-upper vFind nip \ 08/05/08 dbh  +++
     lookingForRightBrace 0= and
      IF c" addr: " $>mt THEN \ prepend "addr:"
          true to lastWordSel? 2 exit
      THEN
 THEN false to lastWordSel? 2 ; \ 07/17/08 dbh  

: +mt ( char -- ) \ add one char to methodText
 methodText methodTextSize + c!
 methodTextSize 1+ to methodTextSize ;

: +;m? ( char -- ) \ add char to pw
 pw count ( addr len ) + c!
 pw c@ 1+ pw c! ;

: process-line ( -- n ) \ 0= hit ;M so stop, 1=process another line
  0 locals| n |
  parsedLine parsedLineSize + parsedLine
  ?DO i c@ 
  
  CASE
   32 OF 32 +mt process-word to n
     n 0= IF ( hit a \ ) 0 pw c! 1 unloop exit THEN
     n 1 = IF ( hit ;M ) 0 pw c! 0 unloop exit THEN
     pw $>mt bl$ $>mt  0 pw c!
     ENDOF
    9 OF  9 +mt process-word to n
     n 0= IF ( hit a \ ) 0 pw c! 1 unloop exit THEN
     n 1 = IF ( hit ;M ) 0 pw c! 0 unloop exit THEN
     pw $>mt bl$ $>mt  0 pw c!
     ENDOF
   ( all others) +;m?    0 ( dropped by endcase )
  ENDCASE
  
  LOOP process-word to n
      n 0= IF ( hit a \ ) 0 pw c! 1 exit THEN
      n 1 = IF ( hit ;M ) 0 pw c! 0 exit THEN
      pw $>mt bl$ $>mt  0 pw c! 1 ;
  

: :M  ( -- )
  0 to compilingClassinit?
  false to lookingForRightBrace
  ?Class
  doClassinitScan IF scanForClassinit THEN  
  getSelect 
  
  
  cell / to curSelIdx
  curSelIdx hTableSize 1- <=
  IF
   curSelIdx atHeapTable
   ABORT" Method redefined in same class"
  THEN
  
  
   0 to methodTextSize
   c" :NONAME " $>mt
   doClassinitScan compilingClassinit? and
   IF c" classinit: super " $>mt THEN
 
 BEGIN
  0 pw c!
  line-end parse ( addr len ) dup to parsedLineSize parsedLine swap move
  process-line
 WHILE
  refill drop
 REPEAT
 
 c"  ;" $>mt
    methodText methodTextSize evaluate 
  ( the xt from above :NONAME should be on stack)
  
  >r
  BEGIN
    hTableSize 1 - curSelIdx <
  WHILE
    incrHeapTable \ increase table size by one cell
  REPEAT
  r> ( curSelxt) curSelIdx toHeapTable  \ store xt in proper cell
  ; IMMEDIATE

: allocObj  ( size class -- )  \ allocate object and store in newObject
 OVER CELL+  \ allow for class ptr
 ALLOCATE ?MEMERR \ ( size class addr -- )
 DUP CELL+ to newObject  \ object address
 !   \ create the class ptr
 newObject SWAP ERASE ; \ clear to zero

: (heapObj)  ( #rows #cols class | class -- ^obj )
 >R  ( save class on return stack )
 R@ DFA @  ( ivar data size )
 R@ @width ?DUP
 IF \ indexed object, add size of indexed area
  R@ 2dfa @
  IF \ 2-dim array
  \ ( #rows #cols size width -- )
   2 pick *
   3 pick *  + cell+ cell+
   R@ allocObj
   newObject R@ DFA @ + cell+ !  \ store col
   newObject R@ DFA @ + !        \ store row
  ELSE
  \ ( #elems size width -- )
  2 PICK * + ( indexed data )  CELL+ ( idxHdr )
  R@ allocObj
  newObject R@ DFA @ + !  ( store #elems in idxHdr )
  THEN
 ELSE
  R@ allocObj \ non-indexed object
 THEN
 R> IFA @ 0 ITRAV \ initialize instance variables
 ClassInit  \ send ClassInit: message to new object
 newObject  ;  \ return object address

: clsscheck
 ' >BODY  DUP ?isClass 0= ABORT" Not a class" ;

\ usage is heap> <classname>
: HEAP>   ( -- addr ) \ use outside a definition
  clsscheck (heapObj) ; 

\ compiled version
: [HEAP>]   ( -- addr )  \ use inside a definition
  clsscheck
  POSTPONE LITERAL  POSTPONE (heapObj) ; IMMEDIATE

: self  ( -- ) ?Class
 POSTPONE ^base ; IMMEDIATE

\ =====================================================================
\ Support for indexed instance variables. When objects of these classes
\ are defined, the number of elements should be on the stack.

\ Set a class and its subclasses to indexed

: <Indexed  ( width -- )  ?Class  ^Class XFA !  ;

\ For some classes, we always want the class pointer to be stored whenever
\ the object is an instance variable, so that the object can receive late-
\ bound messages. This is already the case for indexed classes. Here we

\ fake it out by storing -1 into the indexed field. This is the reason
\ for the "0 MAX" in the definition of @width.

: <General  ( -- )  -1 <Indexed ;

: idxBase  ( -- addr )  \ get base of idx data area
 ^base  DUP >class DFA @ +  CELL+ ;

: idxBase2  ( -- addr )  \ get base of idx data area
 idxBase  CELL+ ;  \ need cell+ to skip over col

: limit    ( -- n )  \ get idx limit (#elems)
 ^base  DUP >class DFA @ +  @ ;

: limit2    ( -- n )  \ get idx limit (#cols)
  idxBase @ ;

: width    ( -- n )  \ width of an idx element
 ^base >class XFA @ ;

\ =====================================================================
\ Runtime indexed range checking. Use +range and -range to turn range
\ checking on and off.

: ?range  ( index -- index )  \ range check
 DUP limit u< IF EXIT THEN
 TRUE ABORT" Index out of range" ;

0 VALUE (?idx)  \ execution vector for range checking

: ?idx   (?idx) EXECUTE ;

: ^elem   ( index -- addr ) \ get addr of idx element
 width *  idxBase + ;

\ Fast access to byte and cell arrays.
: At1  ( index -- char )   idxBase + C@ ;
: At4  ( index -- cell )   CELLS idxBase + @ ;

: To1  ( char index -- )   idxBase + C! ;
: To4  ( cell index -- )   CELLS idxBase + ! ;

HAVE C+! 0= [if]
: C+!  ( char addr -- )   DUP C@  ROT +  SWAP C! ;
[then]

: ++1  ( char index -- )   idxBase + C+! ;
: ++4  ( cell index -- )   CELLS idxBase + +! ;

0 VALUE (?idx2)  \ execution vector for range checking 2-dimension
: ?idx2   (?idx2) EXECUTE ;

: ^elem2   ( r c -- addr ) \ get addr of r c element
 >R  \ c -> rs
 limit2 width * ( r ) * idxBase2 +
 width R> ( c ) * + ;

: ?range2  ( row col -- row col )  \ range check
 2DUP swap idxBase CELL - @ ( #rows ) U<
 IF limit2 ( #cols ) U<
  IF EXIT
  ELSE TRUE ABORT" Col Index out of range"
  THEN
 ELSE TRUE ABORT" Row Index out of range"
 THEN ;

: +range  ['] ?range to (?idx) ['] ?range2 to (?idx2) ;  
: -range  ['] NOOP dup  to (?idx) to (?idx2) ;
+range  \ default is range checking on

: <2Indexed  ( width -- )  ?Class  ^Class XFA ! 
  -1 ^Class 2DFA ! ; \ mark class as 2-dimension array

\ Compute total length of object.
\ The length does not include class pointer.
: (objlen)  ( ^class -- objlen )
 DUP >R DFA @  \ dl
 R@ @width  \ dl wid
 dup        \ dl wid wid
 IF  \ dl wid   ( wid is non-zero )
  R@ 2DFA @
  IF \ 2-dim array
     \ dl wid
   idxBase2 CELL - dup @ swap Cell - @ ( dl wid col row ) *  \ dl wid col*row
   *  \ dl wid*col*row
   + 2 CELLS +   \ 2 cells + to account for #rows , #cols
  ELSE \ 1-dim array
   \ dl wid
   idxBase CELL - @ * \ dl wid*#elems
   + CELL+  \ cell+ to account for #elems
  THEN
 ELSE \ no indexed data
  \ dl wid
  drop
  \ dl
 THEN R> drop ;

: objlen  ( -- objlen )
 ^base >class (objlen) ;

:Class Object  <Super Meta
 :M Addr: self   ;M
 :M ClassInit:   ;M
 :M Release:     ;M
;Class

getSelect ClassInit: to (ClassInit:)

: <RELEASE  ( ^obj -- ) \ defined after object class
 dup Release: **
 CELL - FREE ?MEMERR ;

-1 to doClassinitScan \  now enable this function

: bytes  ( n -- )
 ?Class  ['] Object >BODY <Var  classAllot ;

: MSG> ( -- selID ) \ use outside of a definition
    ' >BODY @ ;

: [MSG>] ( -- selID ) \ use inside a definition
    MSG> POSTPONE LITERAL ; IMMEDIATE

: <SEND-MSG   ( ^obj selID -- )
    over obj>xt EXECUTE-METHOD ;


0 [if]  
\ typical usage
  msg> print: value p

  var x 77 put: x

  x p <send-msg
77 


x value xx

xx p <send-msg
77 

\ or
: test [msg>] print: to p x p <send-msg ;

test
77 

: test2
 [msg>] print: to p
 x to xx
 xx p <send-msg ;


test2
77 

[then]


CMF 0= [if]

VFX [if]
\ VFX Forth
include e:\var13.f
include e:\sequence17.f
include e:\array13.f
include e:\2array13.f
include e:\ordered-col13.f
include e:\search20.f
include e:\$x20.f
include e:\string20.f
include e:\1objarray20a.f
include e:\objlist13.f
include e:\test20a.f

[else]
\ gforth and swiftforth
S" var13.f" included
S" sequence17.f" included
S" array13.f" included
S" 2array13.f" included
S" ordered-col13.f" INCLUDED
S" search20.f" INCLUDED
S" $x20.f" INCLUDED
S" string20.f" included
S" 1objarray20a.f" included
s" objlist13.f" included
S" test20a.f" included
[then]

[else]

\ Carbon MacForth
S" var13.mf"  included
S" sequence17.mf" included
S" array13.mf" included
S" 2array13.mf" included
S" ordered-col13.mf" included
S" search20.mf"  included
S" $x20.mf" included
S" string20.mf" included
S" 1objarray20a.mf" included
S" objlist13.mf" included
S" test20a.mf" included

[then]
[then]

0 [if]
\ for gforth and VFX, do a copy/paste
include e:\class20dispatch.f

[then]

