\ var

:Class CellObj

 CELL bytes Data

 :M  Get:   ( -- n )   self @   ;M
 :M  Put:   ( n -- )  self !   ;M

 :M  Clear:   0 self !  ;M
 :M  Print:   self @ .  ;M

 \ ( ^obj -- )
 :M ->:   @ self !  ;M
;class

:Class Var   <Super CellObj

 :M  +:  ( n -- )         self +!  ;M
 :M  -: ( n -- )  NEGATE self +!  ;M

 :M  *:  ( n -- )  self @  *      self !   ;M
 :M  /:  ( n -- )  self @  SWAP /  self !   ;M
 :M  Negate:   self @  NEGATE  self !   ;M

;Class


:Class Bool   <Super CellObj

 \ Put: always stored Forth boolean flag
 :M Put:  ( f -- )   0= 0= self !  ;M

 :M Set:      TRUE  self !  ;M
 :M Invert:   self @ 0= self !  ;M

 :M Print:  self @ IF ." true " ELSE ." false " THEN  ;M
;Class


:Class ExecVec   <Super CellObj

 \ Execute xt stored in variable
 :M Exec:  ( -- )   self @ EXECUTE  ;M

 \ Initialize to do nothing
 :M Clear:      ['] NOOP ^base !  ;M
 :M ClassInit:  Clear: self  ;M

;Class


HAVE ALLOCATE [IF]

:Class Ptr   <Super CellObj

 Var size \ current size, in bytes, of memory allocated

 \ ( -- n )  \ get current size
 :M Size:
  Get: size  ;M

\ release current memory
 :M Release:  ( -- )
  self @ IF  self @ FREE ?MEMERR  0 self !  THEN   Clear: size  ;M

 \ create a new memory block
 :M New:  ( len -- )
  Release: self  DUP ALLOCATE ?MEMERR  self !  Put: size  ;M

 \ resize memory block
 :M Resize:  ( len -- )
  self @ OVER RESIZE ?MEMERR  self !  Put: size  ;M

\ true if no memory has been allocated
 :M Nil?:  ( -- f )
  self @ 0=  ;M

 :m CLEAR: clear: { size super } ;m

;Class

[THEN]
