\ case insensitive search
\ TODO: put in kernel?

((
Copyright (c) 2021
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: info@vfxforth.com
web: https://vfxforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441

))

: (isearch)      { c-addr1 u1 c-addr2 u2 -- c-addr3 u3 flag }
  c-addr1 u1 u2 - 1+ bounds     \ Search for first char of $2 in $1.  Note that
  ?do                           \ we only check LEN($1)-LEN($2)+1 chars of $1.
    i c@ upc c-addr2 c@ upc = if	\ Compare next char of $1 with first char of $2.
      i c-addr2 u2 is= if       \ Is the whole of $2 present?
        i u1 i c-addr1 - - true \ Yes - build return parameters...
        unloop exit             \ ...and bail out.
      then
    then
  loop
  c-addr1 u1 false            \ End of loop and first char not found - no match.
;

: ISEARCH        \ c-addr1 u1 c-addr2 u2 -- c-addr3 u3 f     17.6.1.2191
\ *G Search the string *\i{c-addr1/u1} for the string (\i{c-addr2/u2}.
\ ** If a match is found return *\i{c-addr3/u3}, the address of
\ ** the start of the match and the number of characters remaining
\ ** in *\i{c-addr1/u1}, plus flag *\i{f} set to true. If no match
\ ** was found return *\i{c-addr1/u1} and *\i{f=0}. Case insensitive.
  2 pick over < if      \ Is $1 shorter than $2?
    2drop false exit    \ Yes - $2 *can't* be in $1.
  then
  dup 0 <= if           \ Is $2 zero length?
    2drop true exit     \ Yes - we have found it at the start of $1.
  then
  2 pick 0 <= if        \ Is $1 zero length?
    2drop false exit    \ Yes - string not found.
  then
  (isearch)
;

: isearch-split ( c-addr1 u1 caddr2 u2 -- c-addr-suffix n-suffix c-addr-match n-match c-addr-addr-prefix n-prefix -1 | c-addr1 u1 0 )
\ *G Search the string *\i{c-addr1/u1} for the string (\i{c-addr2/u2}.
\ ** If a match is found return 3 strings: prefix, match and suffix as well as -1.
\ ** If no match is found, just return \i{c-addr1/u1} and 0.
    { c-addr1 u1 c-addr2 u2 | c-addr-match n-remaining }
    c-addr1 u1 c-addr2 u2 isearch if
        to n-remaining
        to c-addr-match
        c-addr-match u2 + n-remaining u2 -  \ suffix
        c-addr-match u2                     \ match
        c-addr1 c-addr-match c-addr1 -      \ prefix
        -1 \ true flag
    else
        0
    then ;
