include vt100.fth

begin-structure /star
    2 cells +field label
    field: x
    field: y
    field: lastX
    field: lastY
    field: lastLen
    field: z
end-structure

100 constant #stars
/star #stars * buffer: stars

variable w
variable h
100 constant d

: w/2 w @ 2/ ;
: h/2 h @ 2/ ;

: map-stars ( xt [ addr-star ] --  )
    \ xt gets called for every star
    stars #stars /star * bounds do
        i over execute
    /star +loop drop ;

\ count words
variable #words
:noname 2drop 1 #words +! true ;
WalkAllWords

variable #choose-word
2variable choosen-word
: (choose-word) ( #thread nfa -- f )
    nip \ ignore #thead
    #choose-word @ 0= if
        name>string choosen-word 2!
        false \ found
    else
        drop true \ continue
    then
    -1 #choose-word +! ;
: choose-word ( -- c-addr n )
    \ return random word
    #words @ choose #choose-word !
    ['] (choose-word) WalkAllWords
    choosen-word 2@ ;

: random-star ( addr-star -- )
    >r
        w @ choose w/2 - r@ x !
        h @ choose h/2 - r@ y !
        d   choose       r@ z !
        choose-word r@ label 2!
    r> drop ;
: init-star ( addr-star -- )
    >r
        r@ random-star
        r@ x @ r@ lastX !
        r@ y @ r@ lastY !
        r@ label @ r@ lastLen !
    r> drop ;
: init-stars ( -- )
    ['] init-star map-stars ;

: move-star ( addr-star -- )
    dup z @ d = if
        \ TODO: who cleans the last word on the border?
        dup random-star
            z off
    else
        z 1 swap +!
    then ;
: move-stars ( -- )
    ['] move-star map-stars ;

: wh/2+ ( n-x1 n-y1 -- n-x2 n-y2 )
    h/2 +
    swap w/2 + swap ;

variable current-x
: type-safe ( c-addr n -- )
    bounds do
        current-x @ w @ > if
            leave
        then
        i c@ emit
        1 current-x +!
    loop ;


255 constant /spacebuffer
/spacebuffer buffer: spacebuffer
spacebuffer /spacebuffer bl fill
: spaces-safe ( n -- )
    /spacebuffer min
    spacebuffer swap type-safe ;

: cursor-position-safe ( x y -- f )
    \ move cursor if on screen
    2dup 0 h @ between
    swap 0 w @ between and
    if
        over current-x !
        cursor-position
        true
    else
        2drop
        false
    then ;

: draw-star ( addr-star -- )
    >r r@ x @ r@ z @ * 2* d /
       r@ y @ r@ z @ * 2* d /
    wh/2+ 

    \ check against last position
    2dup r@ lastX @ r@ lastY @ d= 0= if
        r@ lastX @ r@ lastY @
        red text-color
        cursor-position-safe if \ clear last position
            r@ lastLen @ spaces-safe
        then

        r@ label @ r@ lastLen !
        2dup r@ lastY !  r@ lastX ! \ store new position
    then

    cursor-position-safe if
        r@ z @
        2*
        8 lshift rgb-text-color
        \ ." X"
        r@ label 2@ type-safe
    then r> drop ;
: draw-stars ( -- )
    ['] draw-star map-stars ;

: star. ( addr-star -- )
    >r
    cr ." X: " r@ x @ .
    cr ." Y: " r> y @ .
    ;
: stars. ( -- )
    ['] star. map-stars ;

: starfield ( -- )
    black back-color
    white text-color
    erase-display

    terminal-size?  h ! w !
    init-stars
    draw-stars
    cursor-hide

    begin
        50 ms
        move-stars
        draw-stars
    key? until

    \ restore ui
    h @ 0 cursor-position
    cursor-show
    reset-text ;

starfield
