\ EARLY TOOLS
\ Last Revision: 20 Jan 2012  05:36:53  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


((

?LIBRARY:	 \ same as Library:  but ignores duplicate libraries
CON?		 \ show Context vocab list
LLOCATE		 \ LOCATE on all linked voc's
SSEE		 \ SEE  on all linked voc's
FindAnywhere \ Find on all linked voc's
WordsIn		 \ words on specified vocab
#WordsIn	 \ count of words in specified vocab
V?			 \ show all vocabs - enhanced ORDER
WORDS-WITH  ( name ( -- )	  \ list partial matches in Search Order
ALL-WORDS-WITH  ( name ( -- ) \ list partial matches in all vocabs
EXISTS?  ( "<name>"  ; -- xt |or| 0 )	  \ check for existence of name

))


only forth
also Extern.Voc
also forth definitions


also M4TH definitions


[undefined] GrabNextWord [IF]
: GrabNextWord ( -- c-addr u )	\ look ahead and grab next word in input stream
								\ without changing source, >IN, etc
	save-input
	bl PARSE-WORD 2>R
	restore-input drop			\ ? error check ?
	2R>	
;
[THEN]


: ?LIBRARY:	\ "<name>" -- ; -- loadaddr|0
\ same as Library:  but ignores duplicate libraries

	GrabNextWord  ( -- c-addr u )
	2dup Search-Context 
	IF 
		drop
		\ maybe use a compiler verbosity flag here?
		2DROP  \ cr 2 spaces type ."  - duplicate LIBRARY:  SKIPPED"
		bl word drop		\ throw away name
	ELSE
		2drop
		Library:
	THEN
; immediate


: IsStrInLib?  ( c-addr1 u  -- flag )
	{ | buf[ 256 ] }
	buf[ zplace
	buf[ find-libfunction 0<> ;




: CON?		 \ show Context vocab list  - similar to ORDER
	context vsize bounds
	do 
    	i @ ?dup
    	IF
    		cr space  .VOC
    	THEN
	cell +loop
;


: DoWithAllVocabs ( theXT -- )	\ do XT with EVERY voc
	{ theXT | temp[ vsize ] -- }
\ save search order
	CONTEXT temp[ vsize move
\ put all vocabs on current search-order
	ONLY
	voc-link
	BEGIN
		@ dup
	WHILE
		dup 
		ALSO  context !
		>voc-link
	REPEAT
	drop
	theXT execute
\ restore search order
	temp[ CONTEXT  vsize move
;



0 value LastWidSearched	

: Find+		\ c-addr -- c-addr 0 | xt 1 | xt -1
\ minor adaptation of FIND that saves LastWidSearched
\ does context ever have non-contiguous entries?  wid wid 0 wid wid

  { | temp[ #256 ] -- }			\ SFP045
  dup c@ if                             \ if there is any search text
    dup count temp[ uplace		\ convert to upper case ; SFP045
    0 context vsize bounds do           \ with all word lists in search order:
      drop
      temp[ count i @
      
      dup -> LastWidSearched			\ wjm
\      dup cr ." searching "   dup IF >vocname .name  ELSE . THEN
      
      (search-wordlist) dup 		\    search word list for text ; SFP045
      if  rot drop leave  then          \    if text is found then bail out now
    cell +loop                          \   on loop completion last search will have returned 0
    exit
  then
  0 dup -> LastNameFound
;


: (WHERE) ( -- )		\ on CONTEXT voc's
	bl word
	{ | temp[ #256 ] -- }			\ SFP045
	dup c@ 
	if                            \ if there is any search text
		count temp[ uplace			\ convert to upper case ; SFP045
		context vsize bounds do     \ with all word lists in search order:
		temp[ count i @
		
		dup -> LastWidSearched			\ wjm
		
		(search-wordlist) 	 	\ c-addr u wid -- 0 | xt 1 | xt -1
		IF
			cr  6 .R
			."   in "  LastWidSearched ?dup IF >vocname  .name ELSE ." ??" THEN
		THEN
		cell +loop 
	ELSE
		drop
	then
;

: WHERE (  -- )		\  WHERE <name>	   searches all linked voc's
	['] (where)  DoWithAllVocabs
;


: (SSEE)
	bl word Find+ ?undef
	." found in " LastWidSearched ?dup IF >vocname  .name ELSE ." ??" THEN
	(dis)
;

defer <LOCATE
	' locate is <LOCATE

also forth definitions

: LLOCATE		\ -- ; LLOCATE <name>			 LOCATE on all linked voc's
	['] <locate DoWithAllVocabs
;


: SSEE			\ -- ; SSEE <name>				 SEE  on all linked voc's
	['] (SSEE) DoWithAllVocabs
;
>m4th 


: FindAnywhere		\ c-addr -- c-addr 0 | xt 1 | xt -1
	\ FIND+ for all vocabs
	\ LastWidSearched contains what it says
	\ first look in Context, the "normal" way
	find+ ?dup IF exit THEN
	\ failing that, search all vocabs
	['] find+  DoWithAllVocabs
;


: (EXISTS?)  ( c-addr -- xt |or| 0 )
	FindAnywhere
	0= IF drop 0  THEN
; 

(( 
: (EXISTS?)  ( -- xt |or| 0 )
	bl word FindAnywhere
	0= IF drop 0  THEN
; 
 ))


: WordsIn 		\ -- ; WordsIn <name>			 WORDS on specified vocab
	[ also system ]  ['] (words)  [ previous ]
	' 
	voc>wid  dup voc?  0= abort" Not a Vocabulary"
	context @ >R
	dup cr ." Words in " .voc
	dup context !
	cr WalkWordList
	R> context !
;


0 value wordCount

: <IncCount ( thread#  nfa  -- continueflag )
	2drop
	1 +to wordCount
	true
;

: (#WordsIn) ( wid -- )
	['] <IncCount
	swap
	0 -> wordCount
	context @ >R
	." # Words = "
	dup context !
	 WalkWordList
	R> context !
	wordCount .
;

: #WordsIn 		\ -- ;  #WordsIn <name>			# WORDS on specified vocab
	' voc>wid  dup voc?  0= abort" Not a Vocabulary"
	cr 
	(#WordsIn)
;

: V?			\ show all vocabs - enhanced ORDER
	0 { TotalWords }
	cr ." Current: " cr space current @ .VOC
	cr ." Context: "  CON?
	cr ." Available:"
	voc-link
	BEGIN
		@ dup
	WHILE
		dup cr space  .VOC			\ dup .  >vocname  .name
		2 spaces dup (#WordsIn)
		wordCount +to TotalWords
		>voc-link
	REPEAT
	drop
	cr ." TOTAL #WORDS = " TotalWords .
;

create match$  100 allot&erase

: GetStringForWith ( -- )
	bl PARSE-WORD
	\ check length
		dup 0= abort" Nil search string"
		dup 99 > abort" Search string too long"
	match$ place
	match$ count UPPER
;


: SHOWIFCONTAINS ( thread# nfa -- continue? ) 
	\ assume both NFA and match$ are UPPER'ed
	dup
	count  match$ count 
	SEARCH nip nip
	IF
		 [ also system ] (words)  [ previous ]
	ELSE
		2drop true
	THEN
;


: (WORDS-WITH)  ( wid -- ? )
	['] showifcontains
	swap
	WalkWordList  \ xt wid --
	cr
;


: WORDS-WITH  ( name ( -- )		\ just context
	GetStringForWith
	context @
	(words-with)
;

: (WORDS-WITH+)				   \ check all word lists in search order
    context vsize bounds
    DO
    	i @
		?dup
		IF
    		." in  " >vocname .name cr
			i @  (WORDS-WITH)
		THEN
    cell +LOOP
;


: WORDS-WITH+  ( name ( -- )	\ SEARCH ORDER
	GetStringForWith
	(words-with+)
;


: ALL-WORDS-WITH  ( name ( -- )	\ ALL VOC's
	GetStringForWith
	['] (words-with+)  DoWithAllVocabs
;



>m4th


: EXISTS?  ( "<name>"  ; -- xt |or| 0 )
	bl word  (exists?)
; immediate

(( 

: EXISTS?  ( "<name>"  ; -- xt |or| 0 )
	['] (exists?) DoWithAllVocabs
; immediate

 ))



defer EXPECT ( addr\max cnt -- )   ' 2drop is expect


