\ MF STRUCTURES
\ Last Revision: 20 Jan 2012  06:22:19  ward@megawolf.com

\ support for MacForth Structure Syntax
 
\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>M4TH

decimal



: mfFIELD		\  ( n1  "<spaces>name" -- ) | run: ( n -- n+n1 )
	create ,
	does> @ +
;


: =HALFCELLS
	1 + -2 and ;  ( align on 2-byte boundry            *)


: :MEMBER  ( offset\element size -- offset' | define element )
	2 needed
	over mfFIELD + ;


: :ALIGNED  ( offset\element size -- offset' )
	2 needed
	swap =halfcells swap   over mfFIELD +  ;


VARIABLE EvenStructures	\ turn flag ON for word-aligned structure-length
  EvenStructures OFF	\ retain default behavior


: STRUCTURE  ( -- token to patch\0 | create & begin struct definition)
	0 constant
	latest-xt   		\ token to back patch
	0 ;					\ running structure size


: STRUCTURE.END  ( token to patch\offset -- | end structure definition)
	2 needed
	EvenStructures @ if =halfcells then
	swap 5 + !	; 					\ may not be best way to do this



: BYTE:   1 :member  ;       : BYTES:    :member ;
: SHORT:  2 :aligned ;       : SHORTS:  2 * :aligned ;
: LONG:   4 :aligned ;       : LONGS:   4 * :aligned ;
: STRING: 1 + bytes:  ;		 : FLOAT:   8 :aligned ;

: ADDR:   long:  ;           : ADDRS:   longs:  ;
: POINT:  long:  ;           : POINTS:  longs:  ;
: PTR:    long:  ;           : PTRS:    longs:  ;
: HANDLE: long:  ;

: RECT:  2 points:  ;

: STRUCT:  :aligned  ;       : STRUCTS:  =halfcells *  :aligned  ;

 
: BYTES.OF:  ( offset -- oS\oM\oN )
    dup  dup  ;
 
: ONE.OF:  ( offset -- oS\oM\oN )
    =halfcells  bytes.of:  ;
 
: OR.OF:  ( offset -- oS\oM\oN )
    max  over  ;
 
: XOR.OF:  ( offset -- oS\oM\oN )
    or.of:  ;
 
: ;GO.ON  ( oS\oM\oN -- offset )
    max  max  ;




StopIncluding ************************************
