\ GENERAL TRAPS
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>M4TH
decimal

?Library:  /System/Library/Frameworks/Carbon.framework/Versions/A/Carbon



Extern: void  ExitToShell  ( void );
Extern: UInt32 ticks TickCount ( void );
Extern: UInt32 * ^bitmap GetQDGlobalsScreenBits (  UInt32 * ^bitmap );

Extern: UInt32 gdhandle GetGDevice  ( void );
Extern: UInt32 * rect GetAvailableWindowPositioningBounds ( UInt32 * gdhandle, UInt32 * rect );

Extern: UInt32 OSStatus RegisterAppearanceClient  ( void );

Extern: void  FlushEvents  ( UInt32 eventMask, UInt32 stopMask );

: (FLUSH.EVENTS)  ( -- ) 65535 0 FlushEvents ;

defer Flush.Events  ' (FLUSH.EVENTS) is Flush.Events


Extern: void GetDateTime  ( UInt32 *datetime );

: _LMGetTime
	0 sp@ GetDateTime  ;


: @CLOCK  ( -- #seconds since 12:00:00 a.m. 01/01/04 *)
	_LMGetTime ;

60 constant 1second   \  ticks per second

Extern: void  Microseconds ( UInt32 * ^wide );

: MICROSECS ( -- d ) 		\ return current value of Mac _Microseconds
	0 0 sp@  Microseconds  swap ;



Extern: void SysBeep ( UInt32 n );


variable Noisy   noisy on

: BEEP ( -- )
	Noisy @
	IF
		1 sysbeep
	THEN
;

: Beep+ ( -- )		\ beep with 1 sec pause afterwards
	Noisy @
	IF
		1 sysbeep
		1000 ms
	THEN
;



Extern:  UInt32 result ResError  ( void );
Extern:  UInt32 rf#  CurResFile  ( void );
Extern:  UInt32 rf#  HomeResFile  ( UInt32 handle );

Extern:  void UseResFile  ( UInt32 rf# );
Extern:  void CloseResFile  ( UInt32 refNum );

Extern:  UInt32 * ref#  FSpOpenResFile  ( 
				UInt32 *	spec
				UInt32      permission );

Extern: UInt32 refNum HOpenResFile  ( 
		UInt32 vRefNum
		UInt32 dirID
		UInt32 * namePtr
		UInt32 permission );

Extern: void HCreateResFile ( UInt32 vRefNum, UInt32 dirID, UInt32 * namePtr  );
Extern: void UpdateResFile  ( UInt32 rf# );

Extern: UInt32 ResID UniqueID   ( UInt32 ResType );


Extern: UInt32 count CountResources  ( UInt32 ResType );
Extern: hndl GetResource   ( UInt32 resType, UInt32 resID );
Extern: hndl Get1Resource  ( UInt32 resType, UInt32 resID );
Extern: void ReleaseResource  ( UInt32 handle );


Extern: void RemoveResource  ( UInt32 handle );
Extern: void AddResource ( UInt32 handle, UInt32 type, UInt32 ID, UInt32 * name$ );

Extern:  UInt32 ResHandle GetIndResource ( UInt32 ResType, UInt32 Index );
Extern:  UInt32 ResHandle GetNamedResource  ( UInt32 ResType, UInt32 * $name  );

Extern: void SetResLoad  ( UInt32 flag );


\ Extern:  void GetResInfo (
AliasedExtern:  _GetResInfo void GetResInfo (
  UInt32    theResource,
  UInt32 *  theID,
  UInt32 *  theType,
  UInt32 *  name );

\ : _GetResInfo GetResInfo ;		\ disambiguate


: GetResInfo  ( handle\addr -- )	\ copy resource info into address 
	2 needed
	locals|  buf  |		\ buffer must be long enough to hold ResName
	buf 8 erase
	buf  buf 2 +  buf 6 + _GetResInfo ;
	\ info in buf is:
	\  	  short: ResID		(signed 16-bit number)
	\	   long: ResType
	\  1 string: ResName	(counted-string for resource name)
	\ Check Res.Error first, to be sure info is there





Extern:  UInt32 MenuBarHandle  GetMenuBar ( void );
Extern:  void   SetMenuBar ( UInt32 mbar );
Extern:  UInt32 MenuBarHandle GetNewMBar ( UInt32 menuBarID );
Extern:  UInt32 OSStatus  DisposeMenuBar ( UInt32 inMbar );
Extern:  void   ClearMenuBar ( void );
Extern:  void   HideMenuBar ( void );
Extern:  UInt32 height   GetMBarHeight ( void );
\ lots more menu externs in menus.fth


Extern:  void item ParamText  (
	UInt32 * s1
	UInt32 * s2
	UInt32 * s3
	UInt32 * s4 );


Extern:  UInt32 item Alert  ( 
	UInt32 resid
	UInt32 *filter );

 
(( 
Extern:  void Move   ( UInt32 Horiz, UInt32 Vert );	\ WARNING SYNONYM IN VFX
also externals
: qdMOVE move ;
' move >name off		\ behead external version of name
previous
 ))
AliasedExtern: qdMove  void  Move  ( UInt32 Horiz, UInt32 Vert );

Extern: void MoveTo ( UInt32 Horiz, UInt32 Vert, );
Extern: void LineTo ( UInt32 Horiz, UInt32 Vert, );
Extern: void Line  ( UInt32 h, UInt32 v );

Extern: void DrawChar    ( UInt32 char );
Extern: void DrawString  ( UInt32 * &string );
Extern: UInt32 width CharWidth  ( UInt32 char );
 

Extern: UInt32 flag   IsWindowUpdatePending ( UInt32 WindowRef );

AliasedExtern: _WaitNextEvent UInt32 theFlag WaitNextEvent  ( 
	UInt32 eventMask
	UInt32 * &theEvent
	UInt32 sleep
	UInt32 mouseRGN
);

\ : _WaitNextEvent  WaitNextEvent ;  \ to avoid later confusion

Extern: UInt32 down? StillDown ( void );
Extern: UInt32 down? WaitMouseUp  ( void );
Extern: UInt32 down? Button  ( void );


Extern:  UInt32 OSErr  GetCurrentProcess ( UInt32 * psn );
Extern:  UInt32 OSErr  GetProcessInformation  ( UInt32 * psn, UInt32 * Dest );
Extern:  UInt32 OSErr  GetNextProcess ( UInt32 * psn );
Extern:  UInt32 OSErr  SetFrontProcess ( UInt32 * psn );


Extern:  UInt32 OSErr PBHGetVolSync  ( UInt32 * PB );
Extern:  UInt32 osErr PBGetFCBInfoSync  ( UInt32 * &fcbPB );
Extern:  UInt32 OSErr PBGetFCBInfoAsync ( UInt32 * &fcbPB );
Extern:  UInt32 OSErr PBHGetFInfoSync  ( UInt32 pbPtr );



Extern:  UInt32 rgnHandle NewRgn  ( void );
Extern:  void DisposeRgn  ( UInt32 rgnHandle );
Extern:  void SetEmptyRgn ( UInt32 rgnHandle );
Extern:  UInt32 flag EmptyRgn  ( UInt32 rgnH );
Extern:  UInt32 flag PtInRgn   ( UInt32 pt, UInt32 rgnH );
Extern:  UInt32 flag RectInRgn ( UInt32 * &r, UInt32 rgnH );

Extern:  void RectRgn   ( UInt32 rgnHandle, UInt32 * &rect );
Extern:  void DiffRgn   ( UInt32 rgnH1, UInt32 rgnH2, UInt32 rgnH3 );
Extern:  void SectRgn   ( UInt32 rgnH1, UInt32 rgnH2, UInt32 rgnH3 );
Extern:  void UnionRgn  ( UInt32 rgnH1, UInt32 rgnH2, UInt32 rgnH3 );
Extern:  void XorRgn    ( UInt32 rgnH1, UInt32 rgnH2, UInt32 rgnH3 );
Extern:  void OffsetRgn ( UInt32 rgnH, UInt32 dh, UInt32 hv );
Extern:  void InsetRgn  ( UInt32 rgnH, UInt32 dh, UInt32 hv );
Extern:  void CopyRgn   ( UInt32 rgnH1, UInt32 rgnH2 );
Extern:  UInt32 flag EqualRgn   ( UInt32 rgnH1, UInt32  );

Extern:  void ScrollRect  ( UInt32 * &rect, UInt32 horiz, UInt32 vert, UInt32 updateRgn );
Extern:  void EraseRgn    ( UInt32 rgnHandle );



Extern:  void GlobalToLocal  ( UInt32 * point );
Extern:  void LocalToGlobal  ( UInt32 * point );

: GLOBAL>LOCAL  ( PT --  PT )  >R RP@ GlobalToLocal R> ;

: LOCAL>GLOBAL  ( PT --  PT )  >R RP@ LocalToGlobal R> ;

\ **********************************************************

Extern:  UInt32 resHandle GetPicture  ( UInt32 resID  );
Extern:  void DrawPicture  ( UInt32 pictHandle, UInt32 * rectPtr );

\ **********************************************************


Extern:  UInt32 state  HGetState  ( handle );
Extern:  void HSetState  ( UInt32 handle, UInt32 state );
Extern:  void ReserveMem  ( UInt32 size );

Extern:  UInt32 handle  NewHandle ( UInt32 size );
Extern:  UInt32 handle  NewHandleClear ( UInt32 size );

Extern:  UInt32 ptr    NewPtrClear ( UInt32 size );
Extern:  UInt32 ptr    NewPtr ( UInt32 size );
Extern:  UInt32 size   GetPtrSize ( UInt32 thePTR );
\ Extern:  UInt32 OSErr  PtrToHand  ( UInt32 srcPtr, UInt32 * &Handle, UInt32 size );

AliasedExtern: _PtrToHand UInt32 OSErr  PtrToHand  ( UInt32 srcPtr, UInt32 * &Handle, UInt32 size );  \ 10.46

: PtrToHand  ( ptr\size -- dstHand\resultCode )  \ 10.46
	0 >R RP@ swap _PtrToHand R> swap ;


Extern: UInt32 OSErr  PtrAndHand  ( UInt32 srcPtr, UInt32  Handle, UInt32 size );  \ 10.47
\ append srcptr\size to Handle

Extern: UInt32 OSErr  HandAndHand  ( UInt32  Handle1, UInt32  Handle2 );  \ 10.47
\ append contents of Handle1 to Handle2



AliasedExtern: _HandToHand UInt32 OSErr  HandToHand ( UInt32 * &Handle );
\ Extern:  UInt32 OSErr  HandToHand ( UInt32 * &Handle );

: HandToHand  ( srcHand -- dstHand\resultCode )
	>R RP@ _HandToHand R> swap ;



Extern:  void DisposePtr  ( ptr );

Extern:  void GetKeys ( UInt32 * addr );


: ModifierKey? ( mask -- flag )
	{ | buf[ 16 ] }
	buf[ GetKeys				\ get the Keymap
	buf[ 7 + C@					\ byte with option key info
	AND  Boolean ;			    \ check the mask

: OptionKey? ( -- flag | true if option key is currently down)
	4 ModifierKey? ;

: ShiftKey? ( -- flag | true if option key is currently down)
	1 ModifierKey? ;



Extern:  void BlockMove  ( UInt32 p1, UInt32 p2, UInt32 s );


Extern:  void TEActivate   ( UInt32 teH );
Extern:  void TEDeactivate ( UInt32 teH );


Extern:  void HLock ( UInt32 handle );
Extern:  void HUnlock ( UInt32 handle );
Extern:  void DisposeHandle ( UInt32 handle );
Extern:  UInt32 size  GetHandleSize ( UInt32 handle );
Extern:  void SetHandleSize ( UInt32 handle, UInt32 size );
Extern:  UInt32 err  MemError ( void );
Extern:  UInt32 #bytes  FreeMem ( void );
Extern:  void HPurge ( UInt32 handle );
Extern:  void HNoPurge ( UInt32 handle );
Extern:  UInt32 flag  IsHandleValid ( UInt32 handle );

Extern:  void DetachResource ( UInt32 handle );


: DISPOSE.HANDLE (  handle -- )
	DisposeHandle ;


: TO.HEAP (  handle -- )
	dup DetachResource  dispose.handle ;


: HANDLE.SIZE (  handle -- size  )
	GetHandleSize ;

: RESIZE.HANDLE ( handle\size -- flag )
	SetHandleSize
	MemError ;

: ?HEAP.SIZE  ( attrib -- available memory )
	drop FreeMem  ;

: PURGABLE ( handle -- )
	HPurge ;
	
: LOCK.HANDLE ( handle -- )
	HLock ;
	
: NON.PURGABLE ( handle -- )
	HNoPurge ;
	
: UNLOCK.HANDLE ( handle -- )
	HUnlock ;


: MEMORYTYPE? ( handle -- attributes )
	HGetState ;


: GET.MEMORY     ( size\attributes -- handle )
			\ 0 Set = System Heap
			\ 1 Set = Memory is cleared
			\ 2 Set = Move Low&Lock down
	dup 4 and IF	
		2dup 1 and IF ReserveMem ELSE ReserveMem THEN
	THEN
	tuck 3 and CASE
		0 OF NewHandle ENDOF
		1 OF NewHandle ENDOF		\ CARBON	1 OF _NewHandleSys ENDOF
		2 OF NewHandleClear ENDOF
		3 OF NewHandleClear ENDOF	\ CARBON	3 OF _NewHandleSysClear ENDOF
	ENDCASE	\ attr\handle
	swap 4 and IF dup HLock THEN ;

	
: FROM.HEAP  ( size -- handle )
	0 get.memory ;


: MemError?  ( error? -- )  \ if flag is TRUE, force abort
\	136  R$ABORT  ;		\ 136 is "Memory full" message
	abort" MemError" ;


: RealHandle?  ( handle -- real? )  \ TRUE if real handle
	locals|  theHandle  |
	FALSE								\ assume the worst.
	theHandle  IsHandleValid if			\ 6.045  seems to be safe..
		theHandle  handle.size 0 >= if	\ ..and is really a handle	!!!!!
			FALSE=							\ change FALSE to TRUE
		then
	then  ;


: Handle?  ( handle -- [handle\TRUE]or[FALSE] )  \ drop bogus handles
	dup RealHandle? dup false= if		\ if not a handle..
		nip						\ discard value, just return flag
	then  ;



: MakeHandle  ( size -- handle )  \ aborts if failed to make handle
	2 GET.MEMORY dup false= MemError?  ;


Extern: UInt32 offset Munger ( UInt32 destStrH, UInt32 offset, UInt32 * findStr, UInt32 findLen, UInt32 * replcStr, UInt32 replcLen );


Extern: UInt32 flag EqualString ( UInt32 strA, UInt32 StrB, UInt32 caseSens, UInt32 diacSens );

: -STRING  ( addr1\addr2 -- flag | true if not equal )
	false true EqualString FALSE= ;


\ -------------------------------------------------------------------
\ Window Title Proxy Icon toolbox calls:

Extern: UInt32 OSStatus SetWindowModified ( UInt32 WindowRef, UInt32 modifiedflag );
	\ controls grayed out state of proxy icon

Extern: UInt32 OSStatus SetWindowProxyCreatorAndType ( UInt32 WindowRef, UInt32 Creator, UInt32 FileType, UInt32 VRefNum );
	\ Use this to add proxy icon if we don't have a specific file
	\ vrefNum can be  kOnSystemDisk = -32768L = FFFF8000 

Extern: UInt32 OSStatus SetWindowProxyAlias ( UInt32 WindowRef, UInt32 AliasHandle );
	\ use this to associate the proper proxy icon
	\ also enables the Window Path Select popup menu

Extern: UInt32 OSStatus SetWindowProxyIcon  ( UInt32 WindowRef, UInt32 IconRef );
	\ use this to force any IconRef to be proxy icon  (see Apple's Icon Suite stuff)

Extern: UInt32 OSStatus RemoveWindowProxy ( UInt32 WindowRef );
	\ remove proxy icon and file association


Extern: UInt32 wasclicked? IsWindowPathSelectClick  ( UInt32 WindowRef, UInt32  * ^EventRecord );
	\ did we click in the window title?

Extern: UInt32 OSStatus WindowPathSelect  ( UInt32 WindowRef, UInt32 MenuRef, UInt32 * ^MenuResult );
	\ let Mac handle the popup menu

\ -------------------------------------------------------------------

AliasedExtern: _Gestalt UInt32 OSErr Gestalt  ( UInt32 selector, UInt32 * &response );

: Gestalt  ( selector -- response\result )
	0 >R RP@ _Gestalt R> swap ;

\ -------------------------------------------------------------------

: Copy.Rect  ( srcRectPtr\destRectPtr --  )
	8 MOVE  ;

\ -------------------------------------------------------------------

Extern: UInt32 handle GetIcon  ( UInt32 resid );

Extern:  void InitCursor  ( void );
Extern:  void ShowCursor  ( void );
Extern:  void ObscureCursor  ( void );

Extern:  void   SetCursor ( UInt32 addr );
Extern:  handle GetCursor  ( UInt32 res# );



create WatchCursor
hex
  3F c, 00 c, 3F c, 00 c, 3F c, 00 c, 3F c, 00 c,  40 c, 80 c, 84 c, 40 c, 84 c, 40 c, 84 c, 60 c,
  9C c, 60 c, 80 c, 40 c, 80 c, 40 c, 40 c, 80 c,  3F c, 00 c, 3F c, 00 c, 3F c, 00 c, 3F c, 00 c,
  3F c, 00 c, 3F c, 00 c, 3F c, 00 c, 3F c, 00 c,  7F c, 80 c, FF c, C0 c, FF c, C0 c, FF c, C0 c,
  FF c, C0 c, FF c, C0 c, FF c, C0 c, 7F c, 80 c,  3F c, 00 c, 3F c, 00 c, 3F c, 00 c, 3F c, 00 c,
  08 c, 00 c, 08 c, 00 c, 
decimal

variable CURSOR

: DfltBUSY  ( flag -- | indicate busy to operator if true )
 	IF
 		WatchCursor dup cursor ! SetCursor
 	ELSE
 		cursor off InitCursor
 	THEN ;

hex
CREATE IBEAM  ( IBEAM CURSOR  )
\ establish mask for CARBON
  0C c, 60 c, 02 c, 80 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c,
  01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 02 c, 80 c, 0C c, 60 c,
  0C c, 60 c, 02 c, 80 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c,
  01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 02 c, 80 c, 0C c, 60 c,
  00 c, 04 c, 00 c, 07 c, 	

CREATE wIBEAM  ( alternate IBEAM CURSOR, will be white on a black background )
\ from Doug Hoffman
  0C c, 60 c, 02 c, 80 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c,
  01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 01 c, 00 c, 02 c, 80 c, 0C c, 60 c,
  0 , 0 , 0 , 0 ,
  0 , 0 , 0 , 0 ,
  00 c, 04 c, 00 c, 07 c, 
decimal


StopIncluding ************************************


