\ Errors
\ Last Revision: 12 Jun 2012  12:57:09  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved.
\ Permission is hereby granted to VFX Forth for Mac customers
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited.
\ ***************************************************************************


((

needs more work

Should roughly match MF's old style, although for new code,
using VFX Weeoe handling is reccommended


Also some words to log to SYSTEM.CONSOLE

And some brute force alert-base debugging words


))

only Forth definitions
>M4TH

decimal



extern: void GetIndString  ( UInt32 addr, UInt32 resIDr, UInt32 index );

create ERR.MSG 128 allot&erase


: @R$  ( addr\stringid  -- fetches resource string)
		(         to addr if none, cnt @ addr is 0 )
	dup 7 arshift 128 +	\ resource ID
	swap 127 and 1 +	\ string index
	GetIndString ;


: R$  ( String.id -- address  converts stringid to address )
	err.msg  dup rot @R$ ;


: .R$  ( string# --  types string )
	R$  count type ;


: >ERR.MSG  ( addr\count -- )	\ holds content of last error
	127 min  err.msg place ;



: ABORT$  ( addr\cnt -- )
\	error.msg.shown? OFF
	>err.msg
	err.msg 'AbortText !  -2 throw ;


: ERR#->MSG ( err# --  )
	dup last.error !
	r$ count abort$
;


((
\ extra little goodie to see what strings are available
: ShowR$'s ( -- ) \ dump all error and message strings
	false locals| skipped |
	1000 0
	DO
		i r$ c@
		IF  cr i .  i .r$
			false -> skipped
		ELSE
			skipped 0= IF cr THEN
			true -> skipped
		THEN
	LOOP ;

))



: (R$ABORT) ( flag\string# -- )
	swap
	IF
\		cr ." Error Str # " .  true abort"  Aborted"
		r$ dup c@
		0= IF drop  0 r$  THEN	\ unspecified error
		'AbortText !  -2 throw
	ELSE
		drop
	THEN
;

defer R$ABORT  ( flag\string#  --  abort on true flag )
defer R$ERROR  ( flag\string#  --  abort on true flag )

' (r$abort) IS R$ABORT
' (r$abort) IS R$ERROR




: DfltISSUEALERT  ( str0\str1\str2\str3\ALRT resource ID -- item# )
	InitCursor ShowCursor >R ParamText R> 0 Alert	;


defer Dflt(ABORT$)  ( -- ) 	' beep is Dflt(ABORT$)

defer Dflt(ERROR$)  ( -- ) 	' beep is Dflt(ERROR$)


\ *******************************************************

\ favorite alert ids:

400 value !OK#
401 value OK#
402 value YNC#
403 value Continue#
806 value Big:-(OK#
807 value Big:-(OK/QUIT#
808 value Big:-(OK/QUIT/Abort#


\ *******************************************************


\ Send string to SYSTEM.LOG - viewable with /Applications/Utilities/Console
\ do not put LFs in string (treated as new command line)
\ CRs are displayed as ^ character
\ Some characters like > are treated specially by the OS - best to stick with simple
\	text and numbers
\ NBSP    shows a cute little unknown charcter good for hiliting console output

: SendMessageToConsole ( addr/cnt/class -- )
	{ addr cnt class | zBuff[ 1024 ] }
\	s" logger -i "		zBuff[ zplace		\ Log the process id
\	s" logger -is " 	zBuff[ zplace		\ also Log the message to standard error
\	s" logger [XXXX] "	zBuff[ zplace		\ preface with our "name"
	s" logger [MFonVFX] "	zBuff[ zplace		\ preface with our "name"

	CASE									\ optionally add a message "class"
		class
		1 OF s" ERR: " zBuff[ zAppend  ENDOF
		2 OF s" stat: " zBuff[ zAppend  ENDOF
	\ other classes do not add tags
	ENDCASE

	addr cnt zBuff[ zAppend
	zBuff[ z" r" popen ?dup
	IF
		pclose drop
	THEN
;


create numbuff 		20 allot&erase
create AlertBuff 	100 allot&erase

: (Num>$) ( N\buff -- )
	base @ >R
	decimal
	swap
	s>d 	\ <# # #S #>
	 tuck dabs <# bl hold #s rot sign #>
	rot
	place		\ c-addr1 u c-addr2 --
	R> base !
;

: Num>$ ( N -- )
	numbuff	(Num>$)
;


\ Allow logging to SYSTEM.LOG

variable ConsoleLogging		ConsoleLogging ON
variable ErrorLogging		ErrorLogging ON


: SysLogMsg1 ( c$ -- )
	ConsoleLogging @
	IF
		count 2 SendMessageToConsole
	ELSE
		drop
	THEN
;

: SysLogMsg2 ( c2$\c1$ -- )
	{  |  buf[ 1024 ] }
	ConsoleLogging @
	IF
		swap count buf[ place
		bl$  count buf[ append
			 count buf[ append
		buf[ count 2  SendMessageToConsole
	ELSE
		2drop
	THEN
;

: SysLogNumber ( n\c1$ -- )
	{  |  buf[ 1024 ] }
	ConsoleLogging @
	IF
		count				  buf[ place
		bl$  			count buf[ append
		Num>$ numbuff	count buf[ append

		buf[ count 2  SendMessageToConsole
	ELSE
		2drop
	THEN
;

: SysLogNumber+Depth ( n\c1$ -- )
	{  |  buf[ 1024 ] }
	ConsoleLogging @
	IF
		count				  buf[ place
		bl$  			count buf[ append
		Num>$ numbuff	count buf[ append
		s"  depth: "		  buf[ append
		depth Num>$ numbuff	count buf[ append
		buf[ count 2  SendMessageToConsole
	ELSE
		2drop
	THEN
;


: SysLogError# ( badword$ line# err# -- )
	{  |  buf[ 1024 ] }
	ConsoleLogging @
	ErrorLogging @
	AND
	IF
		s" error# "			  buf[ place
		Num>$ numbuff	count buf[ append
		drop 		\ skip line#
		count  				  buf[ append
	\	s"  depth: "		  buf[ append
	\	depth  3 -   Num>$ numbuff	count buf[ append

		buf[ count 1  SendMessageToConsole
	ELSE
		3drop
	THEN
;


: SysLogAbort# ( badword$ line# c-addr -- )
	{  |  buf[ 1024 ] }
	ConsoleLogging @
	ErrorLogging @
	AND
	IF
		count   			  buf[ place
		drop 		\ skip line#
	\	Num>$   numbuff count buf[ append
		s"  --  ABORTed in "  buf[ append
		count  				  buf[ append
	\	s"  depth: "		  buf[ append
	\	depth  3 -   Num>$ numbuff	count buf[ append

		buf[ count 1  SendMessageToConsole
	ELSE
		3drop
	THEN
;




\ **** ALERT DIAGNOSTICS ****************************************

\ mostly useful for brute-force testing


defer AlertAbort
	' Abort  is AlertAbort


\ use Big:-(OK/QUIT# instead in a Turnkey, when Quit is inappropriate
Big:-(OK/QUIT/Abort# 	value  DebugAlert#

: DebugAlertAction ( str0\str1\str2\str3 -- )
	DebugAlert# DfltISSUEALERT
	CASE
	\	1 OF  						\ OK
		2 OF  exittoshell 	ENDOF	\ QUIT
		3 OF  AlertAbort	ENDOF	\ ABORT
	ENDCASE
;

: GiveNotice ( str -- )
	>R
	c" successfully run to "
	cr$ cr$
	R> DebugAlertAction
;





: (DumpToAlertBuff) 	( addr\cnt -- )
	base @ >R
	hex
	BOUNDS	\ addr len -- addr+len addr
	?DO
		i c@  Num>$
		numbuff AlertBuff $+
		bl AlertBuff addchar
	LOOP
	R> base !
;

: DumpToAlertBuff 	( addr\cnt -- )
	AlertBuff off
	(DumpToAlertBuff)
;


: NoticeDump ( addr\cnt\str -- )
	>R
	DumpToAlertBuff
	R> cr$ cr$
	AlertBuff
	DebugAlertAction
;

: GiveNotice2 ( n\str -- )
	swap Num>$
	cr$ cr$
	numbuff
	DebugAlertAction
;

: GiveNotice3 ( str2\str -- )
	swap >r
	cr$ cr$
	r>
	DebugAlertAction
;




: UNKNOWN.FILE.ERROR  ( n -- )
	0 base @
	{ Err# theSize WasBase  |  buff[ 255 ] }
	decimal
	Err# last.error !
	23 r$ count buff[ place				\ dup c@ 1+ buff[ swap cmove
	Err# dup abs 0 <# #s rot sign #> 	\ to the.size
	buff[	append		\ buff[ count + the.size cmove
						\ buff[ c@ the.size + buff[ c!
	wasbase base !
	buff[ count abort$ ;



: .FILE.ERROR  ( error# -- )
	io-result off
	negate  33 61 range
	IF
		dup 95 +			\ 128 33 -
		err#->msg			\
		r$abort
	ELSE
		120  124 range
		IF
			dup 52 +   		\ 128 44 + 120 -
			err#->msg		\ handle recover into prior handler better
			r$abort
		ELSE
			37 err#->msg drop			\ handle recover into prior handler better
			negate unknown.file.error
		THEN
	THEN ;


: ?FILE.ERROR  ( --- )
	io-result @ ?dup		\ original
	IF
		.file.error
		\ c" MF FILE ERROR #"  GiveNotice2
	THEN  ;




StopIncluding ************************************

