\ CORE FOUNDATION Basics
\ Last Revision: 21 Jan 2012  12:48:25  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>M4TH

decimal



Extern: void  CFRelease ( UInt32 CFTypeRef  );
Extern: void  CFShow ( UInt32 CFTypeRef );	\ show information about CFTypeRef in CONSOLE


\ --- Basic CFStrings ------------------------------------------------- 
\ CFStrings are typically 16 bit Unicode (although this can be changed)

0  constant kCFStringEncodingMacRoman

Extern: UInt32 CFAllocatorRef  CFAllocatorGetDefault ( void );	\ default allocator can vary from machine to machine

Extern: UInt32 CFStringRef  CFStringCreateWithCString ( UInt32 CFAllocatorRef, UInt32 * ^0Str, UInt32 CFStringEncoding );
Extern: UInt32 CFStringRef  CFStringCreateWithBytes ( UInt32 CFAllocatorRef, UInt32 addr, UInt32 cnt, UInt32 CFStringEncoding, UInt32 externalFlag );
Extern: UInt32 CFStringRef  CFStringCreateWithPascalString ( UInt32 CFAllocatorRef, UInt32 * pStr, UInt32 CFStringEncoding );


Extern: UInt32 int CFStringGetIntValue    ( UInt32 CFStringRef );
Extern: double Result CFStringGetDoubleValue  ( UInt32 str);	\ result on floating stack

Extern: UInt32 result CFStringGetPascalString ( UInt32 CFStringRef, UInt32 * ^buffer, UInt32 bufferSize, UInt32 Encoding  );
	\ true if successful
	\ Copies the character contents of a CFString object to a local Pascal string
	\ buffer after converting the characters to a requested encoding. 

Extern: UInt32 length CFDataGetLength ( UInt32 CFDataRef );
Extern: void  CFDataGetBytes ( CFDataRef\startCFIndex\endCFIndex\^buffer );


Extern: UInt32 CFBundleRef CFBundleGetMainBundle ( void );
Extern: UInt32 OSStatus GetProcessBundleLocation ( UInt32 * ^PSN, UInt32 * ^FSRef );
\ Retrieves the file system location of the application bundle (or executable file) associated with a process.



\ ----- Mutable CFStrings ------------------------------------------------- 

\ "maxLength", if not 0, is a hard bound on the length of the string. If 0, there is no limit on the length.
extern: UInt32 CFMutableStringRef CFStringCreateMutable ( UInt32 CFAllocatorRef, UInt32 maxLength );
extern: UInt32 CFMutableStringRef CFStringCreateMutableCopy ( UInt32 CFAllocatorRef, UInt32 maxLength, UInt32 CFStringRef );


extern: void CFStringAppend ( UInt32 CFMutableStringRef, UInt32 CFStringRef );
\ void CFStringAppendCharacters(CFMutableStringRef theString, const UniChar *chars, CFIndex numChars);
extern: void CFStringAppendPascalString ( UInt32 CFMutableStringRef, UInt32 * pStr, UInt32 encoding );
extern: void CFStringAppendCString ( UInt32 CFMutableStringRef, UInt32 * cStr, UInt32 encoding );


extern: void CFStringReplaceAll ( UInt32 CFMutableStringRef, UInt32 CFStringRef );	/* Replaces whole string */

extern: void CFStringDelete ( UInt32 CFMutableStringRef, UInt32 startoffset, UInt32 length );
\ void CFStringDelete(CFMutableStringRef theString, CFRange range );

extern: void CFStringReplace ( UInt32 CFMutableStringRef, UInt32 startoffset, UInt32 length, UInt32 replacementCFstr );
\ void CFStringReplace(CFMutableStringRef theString, CFRange range, CFStringRef replacement );

\ there are also a bunch of search functions for CFStrings available - see CFString.h & StringCompare.h

\ ---------------------------------------------------------------- 


: >CFString ( 0$String -- CFStringRef )
	\ return a reference to a CoreFoundation string made from provided 0$String (Cstring)
	\ normally a CFStringRef should be _CFRelease'ed when done with it
	0 swap kCFStringEncodingMacRoman CFStringCreateWithCString ;


: ShowCFString ( CFStringRef -- )
	{  | strbuff[ 256 ] }
	strbuff[ 255 0			\ use default encoding
	CFStringGetPascalString
	IF
		strbuff[ count type
	ELSE
		." CFStringGetPascalString failed"
	THEN ;



: CFMutableEmpty ( CFMutableStringRef -- )
	\ empties an existing CFMutableString
	"" >cfstring dup >R
	CFStringReplaceAll
	R> CFRelease
;


: CFMutableAddCR ( CFMutableStringRef -- )
	zCR kCFStringEncodingMacRoman CFStringAppendCString
;


: CFMutableAddPSTR ( CFMutableStringRef\pstr -- )
	kCFStringEncodingMacRoman
	CFStringAppendPascalString
;




