\ OLD STYLE MF CONSOLE
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com

\ eventually phase this out in favor of VFX model

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************



only Forth definitions
>M4TH

decimal



: console.stream ;						\ !???!!!??!


: keyboardStream? ( -- flag )
	TRUE
\	defaultStream? streamRefNum @ ?interactive or
;



structure ConsoleRecord
	byte:	+conFlags
	byte:	+conEolInputChar
	byte:	+conEolEchoChar	\ to be echoed when EolInput is received
	byte:	+conBackspaceChar
	byte:	+conTabChar		\ will be converted to spaces
	byte:	+conCRLFLen		\ at most 6
	6 bytes: +conCRLF
	long:	+con?TerminalToken  ( -- n )
	long:	+conExpectToken  ( addr\cnt -- )
	long:	+conTypeToken  ( addr\cnt -- )		\ to outfile
	long:	+conKeyToken  ( -- char )
	long:	+conPrintToken  ( addr\cnt -- )		\ to prtfile
	long:	+conEprintToken  ( addr\cnt -- )	\ to debugfile
	long:	+conBusyToken  ( busy? -- )
	long:	+conAcceptToken  ( addr\cnt -- )
	long:	+con(abort$)Token  ( -- )	\ with: msg$ in ERR.MSG, err# in LAST.ERROR
	long:	+con(error$)Token  ( -- )	\ with: msg$ in ERR.MSG, err# in LAST.ERROR
	long:	+conIssueAlertToken  ( str0\str1\str2\str3\dlogID -- item# )
	long:	+conDo.EventsToken  ( -- event# )
	long:	+conDo.IO.EventsToken  ( -- )		\ called before each output
structure.end


((
?TerminalToken:     DFLT?TERMINAL 
ExpectToken:        DFLTEXPECT 
TypeToken:          DFLTTYPE 
KeyToken:           DFLTKEY 
PrintToken:         DFLTPRINT 
EprintToken:        DFLTEPRINT 
BusyToken:          DFLTBUSY 
AcceptToken:        DFLTACCEPT 
(abort$)Token:      DFLT(ABORT$) 
(error$)Token:      DFLT(ERROR$) 
IssueAlertToken:    DFLTISSUEALERT 
Do.EventsToken:     DFLTDO.EVENTS 
Do.IO.EventsToken:  DFLTDO.IO.EVENTS 
))


\ A MF console is 12 bytes of data followed by tokens for the following:

: ?TERMINAL ( -- cnt )
	mfconsole @  +con?TerminalToken @ execute ;

: mfEXPECT  ( ADDR\COUNT -- )
	mfconsole @  +conExpectToken @ execute ;

: mfTYPE  ( ADDR\COUNT -- )
	mfconsole @  +conTypeToken @ execute ;

: mfKEY  ( -- CHAR )
	mfconsole @  +conKeyToken @ execute  ;

: PRINT  ( addr\cnt  -- )
	mfconsole @  +conPrintToken @ execute ;

: EPRINT  ( addr\cnt  -- )
	mfconsole @  +conEprintToken @ execute ;

: BUSY  ( flag  -- )
	mfconsole @  +conBusyToken @ execute ;

: mfACCEPT  ( ADDR\COUNT -- )
	mfconsole @  +conAcceptToken @ execute ;

: (ABORT$)  ( -- )
	mfconsole @  +con(abort$)Token @ execute ;

: (ERROR$)  ( -- )
	mfconsole @  +con(error$)Token @ execute ;
	
: ISSUEALERT  ( str0\str1\str2\str3\ALRT resource ID -- item# )
	mfconsole @  +conIssueAlertToken @ execute ;

: DO.EVENTS  ( -- event# )
	mfconsole @  +conDo.EventsToken @ execute ;

: DO.IO.EVENTS  ( -- )
	mfconsole @  +conDo.IO.EventsToken @ execute  ;


((
\ ****************************************************************
\ we will define  these later  or use VFX
defer KEY? ( -- flag )
defer KEY  ( -- char )
defer EMIT ( char -- )
defer TYPE ( addr\cnt -- ) 
defer EXPECT ( addr\max cnt -- )
defer ACCEPT (  addr\n1 -- n2)
\ ****************************************************************
))


: TIDY.UP   ( -- | sweep floors )
	status follower !					\ stop tasking !!!
	console.stream  
	events off ;


variable BEFORE.BYE
 
: BYE    ( --- | return to Shell )
	before.bye @execute
	tidy.up
	Exodus ExecChain
\	ExitToShell
	bye					\ VFX version - does WalkExitChain
;



: ECHO.KEY  ( char -- eol.flag )
	false swap   ( default false )
	CASE
		EOLN ( echo 1 + c@ ) OF  drop -1  echo 2 + c@ ?dup  IF emit ( mfEMIT) THEN  ENDOF
		echo 3 + c@	OF  span @ 1 >
          				IF  8 emit ( mfEMIT) bl emit ( mfEMIT) 8 emit ( mfEMIT) -2  else 7 emit ( mfEMIT) -1  THEN
						span +!
					ENDOF
		9			OF	-1 span +!  ( back over tab character )
						echo 4 + c@ span @  over mod -
						cntr @ span @ -  min
						dup spaces  pntr @ span @ + over blank  span +!
					ENDOF
		echo c@ 128 and 
		IF
			dup emit ( mfEMIT )  
		THEN
	ENDCASE ;

 
: IEXPECT  ( addr\cnt -- sysyem specific interactive input )
           ( echo contains bytes: flags,eolchar,eolecho,bschar)
	cntr !  pntr !  span off
	BEGIN	\ 6.045 EOLN
			SPAN @ >R    mfKEY    R> SPAN !
			dup 3  = IF drop EOLN  ( 13 ) THEN	 \ replace Enter w/ Return
			dup 10 = IF drop EOLN ( 13 ) THEN	 \ replace LF w/ Return  \ 6.045
			dup 13 = IF drop EOLN ( 13 ) THEN	 \ replace LF w/ Return  \ 6.045
            dup pntr @ span @ + c!     
            1 span +!
            echo.key   ( handles cntrls, leaves eol flag )
            span @ cntr @ >= or
	UNTIL  ;


\ ACCEPT drives interpret via REFILL
: IACCEPT  ( addr\cnt -- n  | system specific interactive input )
			( echo contains bytes: flags,eolchar,eolecho,bschar)
	cntr !  pntr !  span off
	BEGIN	\ 6.045 EOLN
		SPAN @ >R    mfKEY    R> SPAN !
		dup 3  = IF drop EOLN ( 13 ) THEN	 \ replace Enter w/ Return
		dup 10 = IF drop EOLN ( 13 ) THEN	 \ replace LF w/ Return  \ 6.045
		dup 13 = IF drop EOLN ( 13 ) THEN	 \ replace LF w/ Return  \ 6.045
		dup EOLN ( 13 ) <> 
		IF
			span @ cntr @ < 
			IF 
				dup pntr @ span @ + c!
			THEN
			1 span +!
		THEN
		echo.key   ( handles cntrls, leaves eol flag )
	UNTIL 
	span @
	cntr @ min ;	\ 6.05435
 
DECIMAL


: DfltEXPECT    ( addr\cnt -- |  expect from console  )
	keyboardStream?
	IF
		iexpect                    ( interactive version)
	ELSE
		infile @  Read.text span !   ( file version )
	THEN
	;
 
 
: DfltACCEPT    ( addr\cnt -- n |  expect from console  )
	keyboardStream?
	IF
		iaccept                    ( interactive version)
	ELSE
		infile @
		Read.text dup span !   ( file version )
	THEN
;
 
 
: ANSEXPECT    ( addr\cnt -- |  expect from console  )
	cntr !  pntr !
	span off
	BEGIN	\ 6.045 EOLN
			SPAN @ >R   KEY    R> SPAN !
			dup 3  = IF drop EOLN ( 13 ) THEN	 \ replace Enter w/ Return
			dup 10 = IF drop EOLN ( 13 ) THEN	 \ replace LF w/ Return  \ 6.045
			dup 13 = IF drop EOLN ( 13 ) THEN	 \ replace LF w/ Return  \ 6.045
            dup pntr @ span @ + c!
            1 span +!
            echo.key   ( handles cntrls, leaves eol flag )
            span @ cntr @ >= or
	UNTIL  ;


: ANSACCEPT    ( addr\cnt -- n |  expect from console  )
	cntr !  pntr !  span off
	BEGIN
		SPAN @ >R    KEY    R> SPAN !
		dup 3  = IF drop EOLN ( 13 ) THEN	 \ replace Enter w/ Return
		dup 10 = IF drop EOLN ( 13 ) THEN	 \ replace LF w/ Return  \ 6.045
		dup 13 = IF drop EOLN ( 13 ) THEN	 \ replace LF w/ Return  \ 6.045
		dup EOLN ( 13 ) <>
		IF
			span @ cntr @ <
			IF 
				dup pntr @ span @ + c!
			THEN
			1 span +!
		THEN
		echo.key ( char -- eol.flag )   ( handles cntrls, leaves eol flag )
	UNTIL
	span @
	cntr @ min ;



: mfEMIT ( n --  output char with supplied highlight bits )
	sp@  1 mftype drop ;			\ ENDIAN





create LINES/PAGE   55 ,		\ 59 ,		\ PATCHED

hex

create  DFLT.CON
	c0 c,	\ +conFlags
	0d c,	\ +conEolInputChar
	20 c,	\ +conEolEchoChar	\ to be echoed when EolInput is received
	08 c,	\ +conBackspaceChar
    04 c,	\ +conTabChar
    01 c,	\ +conCRLFLen
    0d c,	\ +conCRLF ( 6 bytes )
    0A c,	\ 
    0 ,
	' Prim?terminal ,
	' DfltExpect ,
	' DfltTYPE ,
	' PrimKey ,
	' Dfltprint ,
	' DfltEprint ,
	' Dfltbusy ,
	' Dfltaccept ,
	' Dflt(abort$) ,
	' Dflt(error$) ,
	' DfltIssueAlert ,
	' null , \ ' DfltDO.EVENTS ,			patched in later
	' noop , \ ' DfltDO.IO.EVENTS ,		patched in later
\  ]  <?terminal  <<expect  +printer <key <print <debug  <busy [
 



\ create  PRINTER.ONLY  0 ,  0 ,  0 ,
\        ]  0  ABORT  PRINT  ABORT  2DROP  2DROP  drop  [



DECIMAL




: CRLF ( -- addr )
	echo 6 + ;
 
: (CR)  ( --- | echo cr/lf to the current output device  *)
	echo 5 + count type ( mfTYPE )
	1 op-line# +!					\ vfx
	out off							\ vfx
	col off 
\	1 mfline# +!
;

: PAGE  ( --   form feed )
	0 op-line# !					\ vfx
	$0C emit ( mfEMIT )  ;


: LCOUNT  ( a-addr -- c-addr\u )
	dup @ swap cell+
;



: NEW.CONSOLE  ( "<spaces>name" -- )	\ makes a copy of the current console
	create  
	dflt.con here
	consoleRecord allot 
	consoleRecord move ;


new.console CALLBACK.CONSOLE
\ a copy of DFLT.CON before event handlers have been added
\ for use in CALLBACK: words

new.console LOG.CONSOLE
\ another copy without event handlers

new.console NULL.CONSOLE
\ another copy without event handlers
	' null  	null.console	+con?TerminalToken !
	' 2drop  	null.console	+conExpectToken !
	' 2drop		null.console	+conTypeToken !
	' null 		null.console	+conKeyToken !
	' 2drop  	null.console	+conAcceptToken !


StopIncluding ************************************