\ MF LOG FILE
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>M4TH

decimal


variable MakeDatedLogs			MakeDatedLogs OFF

true value KeepLogFileInside
\ TRUE saves in our Bundle's Resources folder
\ FALSE saves in folder local to our app


0 value LogFile#

create LogFile$ 	256 allot&erase

create DfltLogFile$ 256 allot&erase
					s" m4th log" DfltLogFile$ place

((
LogFile$ count type
m4th log 27 Dec 2011  04.51.45
27 Dec 2011  04.51.45
0         1         2      
012345678901234567890123456
))


: LocateLogFile ( namebuf -- vol\dir )
	{ ^namebuf }
	KeepLogFileInside
	IF
		LogFile$ count  ^namebuf place
\		s" :Resources:" ^namebuf place
\		LogFile$ count  ^namebuf append
		GetCFURLofMyResources dup >R
		CFURL->VolDir
		R> CFRelease
	ELSE
		LogFile$ count ^namebuf place
		GetLocalVolDir
	THEN
;

\ NOTE: except for HCREATE (we want to easily set type and creator), have SWITCHED
\ TO VFX FILE CALLS, which are based on Posix calls so that we are more likely to 
\ be able to able to log from callbacks Log File will always be created in the 
\ folder our app lives in or inside our bundle

: CreateLogFile  ( -- ioR )
\ here we use traditional Mac calls to get correct file type
	{  | scr[ 1024 ] }
	scr[  LocateLogFile
	scr[  creator @  ascii TEXT  HCreate
	\ will return -48 (duplicate file) if exists
;


: StopLogging ( -- )
\	LogFile# ?dup IF Close-File drop THEN
	LogFile# 0>			\ ?dup   10.46
	IF
		LogFile# Close-File drop
\		0 -> LogFile# 
	THEN
	0 -> LogFile#
;                                                                                   


: OpenLogFile ( -- ref# )
	{  | scr[ 1024 ] }
	StopLogging				\ 10.46
(( 
	LogFile# 0>			\ ?dup   10.46
	IF
		LogFile# Close-File drop
		0 -> LogFile# 
	THEN
 ))
\	LogFile$ count r/w open-file drop
	scr[  LocateLogFile
	scr[  FileInfo->ZString
	zcount r/w open-file drop
;




: (Type->Log) ( addr\cnt -- )
	LogFile# dup 0>		\ 10.46
\	LogFile# ?dup
	IF
		dup >R
		file-size drop
		r@ Reposition-File drop
		r@ Write-File drop
		r> flush-file drop
	ELSE
		drop
		2drop
	THEN
;


defer Type->Log				\ 10.47
' (Type->Log) is Type->Log


' null  	log.console		+con?TerminalToken !
' 2drop  	log.console		+conExpectToken !
' Type->Log	log.console		+conTypeToken !
' null 		log.console		+conKeyToken !
' 2drop  	log.console		+conAcceptToken !
\ event words noop'ed already


exists? NULL.CONSOLE 0=
[IF]
	new.console NULL.CONSOLE
	log.console null.console ConsoleRecord move
	' 2drop		null.console	+conTypeToken !
[THEN]


variable LOGGING	logging off

: LOG[[		\ start logging all Text Output until ]]LOG
	logging @ 0=
	LogFile#  0>			\ 10.46
	AND						\ 10.47
	IF
		mfconsole @ logging !		\ save current mfconsole
		log.console mfconsole !		\ redirect output
	ELSE
		mfconsole @ logging !		\ save current mfconsole
		NULL.CONSOLE mfconsole !
	THEN
;


\ all normal text output between LOG[[  and  ]]LOG
\ is redirected to LogFile#

: ]]LOG		\ restore normal Text Output state
	logging @ ?dup
	IF
		mfconsole !					\ restore console
		logging off
	THEN
;  quitter linklasttoken			\ always restore on errors



\ use these when mfConsole not in use, as in Exception Handler
: Num->Log ( nn -- )
	Num>$ 
	numbuff count Type->Log
;

: Space->Log
	bl$ count Type->Log
;

: CR->Log
	cr$ count Type->Log
;


ALSO SYSTEM

: SetLogFileName ( -- )
	{:  | temp$[ 256 ]	:}
	DfltLogFile$ count  255 24 - min  ( room for date/time )
		LogFile$ place
	MakeDatedLogs @
	IF
		s"   "     					LogFile$ append
		temp$[ dup GetDate$	 count	LogFile$ append
		s"   "     					LogFile$ append
	
		(time) rot	 (2.R)			LogFile$ append
		ascii .						LogFile$ addchar
			   swap  (2.R)			LogFile$ append
		ascii .						LogFile$ addchar
					 (2.R)			LogFile$ append
	ELSE
		DfltLogFile$ count  255 24 - min  ( room for date/time )
		LogFile$ place
	THEN ;

0 value LogFileCreated	\ 10.48	- true if file did not exist at launch

: (StartLogging) ( -- )
	logging off
	SetLogFileName
	CreateLogFile	\ drop
	dup 0 =  +to LogFileCreated	\ 10.48	
	?DUP
	IF
		c" ioR during StartLogging "  SysLogNumber 	\ 10.46		
	THEN
	OpenLogFile dup -> LogFile#
\	0=  abort" OpenLogFile failed"
	0 <=  IF c" OpenLogFile failed" SysLogMsg1 THEN 	\ 10.46
;


: StartLogging ( -- )	\ invoked in DFLT.STARTUP
	{:  | temp$[ 256 ]	:}
	(StartLogging)
	LOG[[
		cr cr
		temp$[ dup GetDate$	count type
		2 spaces
		temp$[ dup GetTime$	count type
		cr cr
	]]LOG
;

previous


