\ WINDOWS and some QUICkDRAW stuff
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>M4TH

decimal



Extern: void HiliteControl  ( UInt32 ControlRef, UInt32 hiliteCode );
Extern: UInt32 in?  PtInRect  ( UInt32 pt, UInt32 * &rect );


AliasedExtern: _PenMode  void PenMode  ( UInt32 * newPenmode );
AliasedExtern: _PenSize  void PenSize  ( UInt32 * width, UInt32 * height );
\ Extern: void PenMode  ( UInt32 * newPenmode );
\ Extern: void PenSize  ( UInt32 * width, UInt32 * height );
Extern: void GetMouse ( UInt32 * &localPt );
Extern: void GetPen   ( UInt32 * &localPt );
Extern: void PenPat   ( UInt32 * &pat );


hex
structure WINDOW.TAIL.STRUCTURE
\ changing WINDOW.TAIL.STRUCTURE needs corresponding change in DFLT.WINDOW.TAIL

	long:	+windowref#
	long: 	+dlogref#			\ if it is a dialog
	long:	+WREFCON			\ private "WREFCON" - used by Editor windows
	long:	+teWREFCON			\ obsolete -- another "WREFCON" - used for te fields
	long:	+M4th.WTYPE			\ bit 0 == don't close
	short:	+WptrSize			\ total size of this Wptr
	2 +							\ 2 unused bytes - spare room...

	4 +							\ spare - was room for +ON.ACTIVATE module reference
	long:	 +ON.ACTIVATE
	4 +							\ spare - was room for +ON.UPDATE module reference
	long:	 +ON.UPDATE
	4 +							\ spare - was room for +WINDOW.ACTION module reference
	long:	 +WINDOW.ACTION		\ +W.EVENTHANDLER
	long:	 +W.HILITE
	long:	 +ON.NEWACTIVATE	\ 

	long:	 +ON.CLOSE			\ 
	4 +							\ SPARE

	long:	 +WFILE.PTR
	long:	 +WTITLE
	short:	 +W.ATTRIBUTES
	short:	 +W.TYPE
	long:	 +W.BEHIND
	rect:	 +WBOUNDS

dup negate mffield <XFORM  ( xform ptr -- fake wptr ) \ "from xform"
	rect:	 +WCBOUNDS
	long:	 +WLINE.HEIGHT
	rect:	 +WGROW
	long:	 +VBAR
	long:	 +HBAR

\ InitGraf clears from here...
	rect:	 +XYOFFSET
	long:	 +XYSCALE
	short:	 +XYPIVOT
	long:	 +XYBIAS			\ sin\cos
	long:	 +XYPOS
	long:	 +CARTESIAN
	6 +							\ 6 unused bytes in xform array
\ ...to here
dup <xform constant XFORM.SIZE	\ xg

	long:	 +NewWAttributes
	long:	 +WindowEventHandlerRef
	long:	 +SpecialEventHandler


	8 +	 4 +					\ spare room...

	long:	 +W.LINK			\
((
+W.LINK   wptr4 -- addr
	Returns the address within a MacForth window tail of the address of
	the prior chronologically defined window. This linked list is
	traversed during Forget to close any windows which are about to be
	forgotten.
))
structure.end

decimal


: GET.WINDOW.XFORM  ( -- ptr to xform structure )
	window.xform @ ;


: GET.XFORM.WINDOW  ( -- window ptr based on xform, may not be real window )
	get.window.xform <xform ;


: @MOUSE  ( -- point |  current mouse position in local  )
     0 >R RP@ GetMouse R> ;


: GET.XYOFFSET ( -- X\Y )
	get.xform.window +XYOFFSET 2@  ;



defer  XLATE  ( x\y\xform.array -- xr\yr)
				\   rotates and scales a point relative to origin
' drop is xlate


: WinXLate ( x\y -- xr\yr )  \ Xlate using current window's values
	Get.xform.Window +XYOffset Xlate ;


: @MouseXY  ( -- X\Y )  \ in local coordinate system
   @MOUSE POINT>XY GET.XYOFFSET -POINT
          WinXlate GET.XYOFFSET -POINT  ;



create SCREEN.BITS   14 allot  			  \ set during startup

: FULL.SCREEN.BOUNDS ( -- ^rect )
	screen.bits 6 + ;


\ Available Screen bounds -- less dock & menubar
create SCREEN.BOUNDS 		0 , 0 ,  		\ set during startup


: Screen.Width ( -- w )
	screen.bounds 6 + w@ 	\ right edge
	screen.bounds 2 + w@ 	\ left edge
	-
;


: Screen.Height ( -- h )
	screen.bounds 4 + w@ 	\ bottom edge
	screen.bounds w@ 		\ top edge
	-
;



variable ACTIVE.WINDOW		active.window off

VARIABLE W.LINKAGE  ( -- addr )  W.LINKAGE off
	\ contains most recently defined window


create EVENT.RECORD  32 allot  (  event working record )
	event.record  32 erase
    ( evnt.code.w, message, when, where.pt, modifiers.w, 16 bytes spare  )
(( 
	Array containing the event record for the current event.
	Bytes 0-1 contain the event code,
	Bytes 2-5 contain the event message,
	Bytes 6-9 contain the time in ticks when the event occurred,
	Bytes 10-13 contain the mouse location, and
	Bytes 14-15 contain the modifiers bits (kbd state).
 ))

create KEY.STROKE   18  allot  ( keystroke down record   )
	key.stroke  18 erase
 ( filler.w, evnt.code.w, message.l, when, where.pt, modifiers.w)
((  INTEL: event.code byte swapped,  as is message      

macforth on PPC
0  0  0  3   0  0  11  98  0  3  

macforth on vfx
0  0  3  0  98  11  0   0
))

create MOUSE.DOWN.RECORD   18  allot  ( mouse.down record   )
	mouse.down.record  18 erase
 ( filler.w, evnt.code.w, message, when, where.pt, modifiers.w)
\  0         2            4        8     12        16
create MOUSE.UP.RECORD     18  allot  ( mouse.up record   )
	mouse.up.record  18 erase
 ( filler.w, evnt.code.w, message, when, where.pt, modifiers.w)

create HIGH.LEVEL.EVENT.RECORD  18 allot  
	high.level.event.record  18 erase



create DFLT.WINDOW.XFORM
		( +WCBOUNDS )			0 w, 0 w, 500 w, 500 w,	\ 6.047
		( LINE.HEIGHT)			15 ,
		( WGROW )				32 w,  32 w,          	\ min 32x32
		 			        	-1 ,					\ default max size
		( SCROLL CONTROLS)		0 ,  0 ,
		( 2DGRAPHICS --  )
		( XYOFFSET )	 		0 , 0 ,
		( XYSCALE )				100 w, 100 w,
		( XYPIVOT ) 			0 w,
		( XYBIAS )  			10000 w, 0 w,
		( XYPOS )				0 ,
		( CARTESIAN )			0 ,
		( unused )				0 , 0 w,



((	retired as obsolete - use CreateNewWindow
Extern:  UInt32 theWind NewCWindow ( UInt32  wStorage, UInt32 * &bounds, UInt32 * title, UInt32  vis?,
									UInt32  wDefProcID, UInt32  behind, UInt32  goAway?, UInt32  refCon, );
))

Extern:  UInt32 CGrafPtr GetWindowPort ( UInt32 WindowRef );
Extern:  void  SetPort ( UInt32  theport );
AliasedExtern: _GetPort  void  GetPort ( UInt32 * grafPtr );
\ Extern:  void  GetPort ( UInt32 * grafPtr );


: GetPort  ( -- GrafPtr )
	0 >R RP@ _GetPort R> ;

: <SetPort ( GrafPtr -- )		\ 5.2 wjm
	?dup 
	IF
		dup CURRENTPORT !		\ 6.046
		SetPort 
	THEN ;

Extern:  void   DrawControls  ( UInt32 WindowRef );
Extern:  void   HiliteWindow  ( UInt32 WindowRef,  UInt32 onOffFlag );
Extern:  void   SendBehind    ( UInt32 WindowRef,  UInt32  behindWptr );
Extern:  void   BringToFront  ( UInt32 WindowRef );
Extern:  void   SelectWindow  ( UInt32 WindowRef );
Extern:  void   HideWindow    ( UInt32 WindowRef );
Extern:  void   ShowWindow    ( UInt32 WindowRef );

: _ShowWindow  ShowWindow ;

extern: void ShowHide ( UINt32 WindowRef, UInt32 showflag );
	\ Seems to work better with odd things like Nib Windows !

Extern:  void   SetWTitle     ( UInt32 WindowRef, UInt32  * newTitle );

Extern:  UInt32 OSStatus GetWindowBounds ( UInt32 WindowRef, UInt32 WindowRegionCode, UInt32 * ^Rect );
Extern:  UInt32 WindowRef  FrontWindow   ( void );
Extern:  UInt32 flag  IsWindowVisible ( UInt32 WindowRef );
Extern:  UInt32 flag  IsValidWindowPtr ( UInt32 possibleWindowRef );
Extern:  void   GetWTitle ( UInt32 WindowRef,  UInt32  * title );

Extern:  void   DrawGrowIcon  ( UInt32 WindowRef );
Extern:  void   DragWindow    ( UInt32 WindowRef,  UInt32 startPt,  UInt32  * bounds );

Extern:  void   BeginUpdate   ( UInt32 WindowRef );
Extern:  void   EndUpdate     ( UInt32 WindowRef );
Extern:  void   KillControls  ( UInt32 WindowRef );

Extern:  void   DisposeWindow  ( UInt32 WindowRef );
Extern:  void   DisposeDialog ( UInt32 dlogRef );


Extern:  UInt32 whereCode FindWindow  ( UInt32 point,  UInt32 *wptr  );


Extern:  void   SetWRefCon ( UInt32 WindowRef, UInt32 refcon );
AliasedExtern:  _GetWRefCon UInt32 refcon GetWRefCon ( UInt32 WindowRef  );
\ Extern:  UInt32 refcon GetWRefCon ( UInt32 WindowRef  );
\ : _GetWRefCon  ( WindowRef -- refcon)	dup IF GetWRefCon THEN	;	\ disambiguation with GetWRefCon

Extern:  UInt32 dlogRef GetDialogFromWindow ( UInt32 WindowPtr );
Extern:  UInt32 WindowRef GetWindowFromPort ( UInt32 CGrafPtr  );
\ Extern:  UInt32 WindowRef GetDialogWindow ( UInt32 dlogRef  );

Extern:  UInt32 oserr ValidWindowRect ( UInt32 WindowRef, UInt32 * rect );
Extern:  UInt32 oserr InvalWindowRect ( UInt32 WindowRef, UInt32 * rect  );
Extern:  UInt32 oserr InvalWindowRgn ( UInt32 WindowRef, UInt32 RgnHandle  );

Extern:  UInt32 oserr GetWindowRegion ( UInt32 WindowRef, UInt32 WindowRegionCode, UInt32 RgnHandle  );


AliasedExtern: _GetWindowAttributes  UInt32 oserr GetWindowAttributes ( UInt32 WindowRef, UInt32 * attributes  );
\ Extern:  UInt32 oserr GetWindowAttributes ( UInt32 WindowRef, UInt32 * attributes  );

Extern:  UInt32 flag TrackGoAway ( UInt32 WindowRef, UInt32 pt  );


Extern:  UInt32 newHeightWidth GrowWindow  ( UInt32 WindowRef, UInt32 startPt, UInt32 * sizeRect );
Extern:  UInt32 flag TrackBox    ( UInt32 WindowRef, UInt32 pt, UInt32partCode  );

Extern:  void   SizeWindow  ( UInt32 WindowRef, UInt32 wide, UInt32 high, UInt32 updateFlag );
Extern:  void   MoveWindow  ( UInt32 windowRef, UInt32 hGlobal, UInt32 vGlobal, UInt32 frontFlag );
Extern:  void   ZoomWindow  ( UInt32 WindowRef, UInt32 partCode, UInt32 front );

Extern:  UInt32 flag QDIsPortBuffered ( UInt32 CGrafPtr );
Extern:  UInt32 flag QDIsPortBufferDirty ( UInt32 CGrafPtr );
Extern:  void   QDFlushPortBuffer ( UInt32 CGrafPtr,  UInt32 RgnHandle );

Extern:  UInt16 font GetPortTextFont ( UInt32 CGrafPtr );
Extern:  UInt16 face/style GetPortTextFace ( UInt32 CGrafPtr );
Extern:  UInt16 mode GetPortTextMode ( UInt32 CGrafPtr );
Extern:  UInt16 size GetPortTextSize ( UInt32 CGrafPtr );
Extern:  void GetFNum ( UInt32 theName$, UInt32 * ^theID  );


Extern:  UInt32 WindowRef  GetWindowList  ( void );
Extern:  UInt32 WindowRef  GetNextWindow ( UInt32 WindowRef  );

Extern:  UInt32 RgnHandle  GetPortVisibleRegion ( UInt32 CGrafPtr, UInt32 RgnHandle );
AliasedExtern:  _GetWindowPortBounds UInt32 * &Rect GetWindowPortBounds ( UInt32  WindowRef, UInt32 * &Rect );
\ Extern:  UInt32 * &Rect    GetWindowPortBounds ( UInt32  WindowRef, UInt32 * &Rect );


Extern:  UInt32 * &Rect    GetControlBounds ( UInt32 ControlRef, UInt32 * &Rect );
Extern:  void   		   SetControlBounds ( UInt32 ControlRef, UInt32 * &Rect );


Extern:  UInt32 OSStatus ScrollWindowRect ( UInt32  WindowRef,
   UInt32 * inScrollRect,
   UInt32 inHPixels,
   UInt32 inVPixels,
   UInt32 inOptions,
   UInt32 outExposedRgn
);

\ these are for zooming
Extern:  UInt32 * &Rect   GetWindowStandardState ( UInt32 windowref, UInt32 * ^rect  );
Extern:  UInt32 * &Rect   GetWindowUserState     ( UInt32 windowref, UInt32 * ^rect  );
Extern:  void   		  SetWindowStandardState ( UInt32 windowref, UInt32 * ^rect  );
Extern:  void   		  SetWindowUserState 	 ( UInt32 windowref, UInt32 * ^rect  );


Extern:  UInt32  theKind  GetWindowKind ( UInt32 windowref );
((
	dialogKind						EQU		2
	userKind						EQU		8
	kDialogWindowKind				EQU		2
	kApplicationWindowKind			EQU		8
))



Extern:  void   SetClip   ( UInt32 newClipRgn );
Extern:  void   GetClip   ( UInt32 * rgnHandle );
Extern:  void   ClipRect  ( UInt32 * &rect );
Extern:  void   InsetRect ( UInt32 * &rect, UInt32 dh, UInt32 dv );
Extern:  void   EraseRect ( UInt32 * &rect );
Extern:  void   FrameRect ( UInt32 * &rect );
Extern:  void   FrameRoundRect ( UInt32 * &rect, UInt32 ovalWidth, UInt32ovalHeight  );
Extern:  void   InvertRect ( UInt32 * &rect );
Extern:  void   PaintRect  ( UInt32 * &rect );



Extern:  UInt32 ControlRef NewControl   ( UInt32 WindowRef, UInt32 * &Rect, UInt32 * &title, UInt32 visible, 
											UInt32 value, UInt32 min, UInt32 max, UInt32 type, UInt32 refCon );

Extern:  UInt32 partcode   TrackControl  ( UInt32 control, UInt32 localPt, UInt32 * actionProc );


: ADD.CONTROL  ( wptr\bounds rect\l.title\w.visible\ )
	( w.value\w.min\w.max\w.type\l.refcon -- ControlRef )
	\ " ADD.CONTROL" DebugStr
	8 roll @   8 bury
	NewControl  ;


: SAVE.CLIP    ( -- rgn.handle )
	NewRgn dup dup HNoPurge GetClip  ;


: RESTORE.CLIP ( rgn.handle -- )
	dup SetClip dup HPurge DisposeRgn ;


: InvalRect ( &rect -- )
	GetPort GetWindowFromPort  swap InvalWindowRect drop
;

: ValidRect ( &rect -- )
	GetPort GetWindowFromPort swap ValidWindowRect drop
;


: SET.CURSOR ( addr -- )
	?dup
    IF
    	dup cursor ! SetCursor
    ELSE  
    	cursor @ IF   cursor off  THEN
    	InitCursor
    THEN   ;


: GET.CURSOR ( -- addr )
	cursor @  ;

: INIT.CURSOR ( -- )
	0 set.cursor  ;


: GET.WINDOW ( -- wptr4 |or| 0 )
	GetPort GetWindowFromPort _GetWRefCon
	DUP
	IF
		dup @ IsValidWindowPtr	false= 
		IF
		    drop 0
		THEN
	THEN	;



: GET.FONT.NUMBER ( name$ -- id# )
	0 >R rp@			\ scratch area for id# on return stack
	GetFNum
	r>  ;


: GET.TEXTFONT  ( -- font )  get.window @ GetWindowPort GetPortTextFont ;
: GET.TEXTSTYLE ( -- style)  get.window @ GetWindowPort GetPortTextFace ;
: GET.TEXTMODE  ( -- mode )  get.window @ GetWindowPort GetPortTextMode ;
: GET.TEXTSIZE  ( -- size )  get.window @ GetWindowPort GetPortTextSize ;


Extern:  void   TextFont  ( UInt16 font );
Extern:  void   TextMode  ( UInt16 mode );
AliasedExtern: _TextSize   void   TextSize  ( UInt16 size );
\ Extern:  void   TextSize  ( UInt16 size );
Extern:  void   TextFace  ( UInt16 style );


\   Text Styles	- set with TEXTFACE
 0 constant PLAIN
 1 constant BOLD
 2 constant ITALIC
 4 constant UNDERLINE
 8 constant OUTLINE
16 constant SHADOW
32 constant CONDENSED
64 constant EXTENDED


\  QD bit Transfer modes
  0 constant SRCCOPY		1 constant SRCOR
  2 constant SRCXOR			3 constant srcbic
  4 constant notsrccopy     5 constant notsrcor
  6 constant notsrcxor      7 constant notsrcbic

  8 constant patcopy        9 constant pator
 10 constant patxor        11 constant patbic
 12 constant notpatcopy    13 constant notpator
 14 constant notpatxor     15 constant notpatbic

  
create WHITE          0 ,         0 ,		\ White Pattern
create BLACK  $ffffffff , $ffffffff ,		\ Black Pattern


create ScratchBoundsRect 8 allot
	\ used by _GetWindowPortBounds and GrayBounds

Extern:  UInt32 rgnHandle GetGrayRgn  ( void );
Extern:  UInt32 * ^rect  GetRegionBounds ( UInt32 rgnHandle,  UInt32 * ^rect );

: GrayBounds 	( -- addr )  \ address of gray region bounds rectangle
	GetGrayRgn ScratchBoundsRect GetRegionBounds ;



\ ************************************
\ ************************************



: CloseWindow ( WindowRef -- )
	DisposeWindow ;


: FIND.WINDOW  ( point -- WindowRef\where code )
	0 >R RP@ FindWindow R> swap ;
(( 
typedef SInt16 WindowPartCode ;
enum {
  inDesk                        = 0,
  inNoWindow                    = 0,
  inMenuBar                     = 1,
  inSysWindow                   = 2,
  inContent                     = 3,
  inDrag                        = 4,
  inGrow                        = 5,
  inGoAway                      = 6,
  inZoomIn                      = 7,
  inZoomOut                     = 8,
  inCollapseBox                 = 11,   /* Mac OS 8.0 forward*/
  inProxyIcon                   = 12,   /* Mac OS 8.5 forward*/
  inToolbarButton               = 13,   /* Mac OS X forward*/
  inStructure                   = 15    /* Mac OS X 10.1 forward*/
};
 ))


: GetWindowAttributes ( wptr4 -- attributes )
((
	kWindowNoAttributes			= 0L,							/* no attributes*/
	kWindowCloseBoxAttribute	= (1L << 0),					/* window has a close box*/
	kWindowHorizontalZoomAttribute = (1L << 1),					/* window has horizontal zoom box*/
	kWindowVerticalZoomAttribute = (1L << 2),					/* window has vertical zoom box*/
	kWindowFullZoomAttribute	= (kWindowVerticalZoomAttribute | kWindowHorizontalZoomAttribute),
	kWindowCollapseBoxAttribute	= (1L << 3),					/* window has a collapse box*/
	kWindowResizableAttribute	= (1L << 4),					/* window is resizable*/
	kWindowSideTitlebarAttribute = (1L << 5),					/* window wants a titlebar on the side	(floating window class only)*/
	kWindowNoUpdatesAttribute	= (1L << 16),					/* this window receives no update events*/
	kWindowNoActivatesAttribute	= (1L << 17),					/* this window receives no activate events*/
	kWindowNoBufferingAttribute	= (1L << 20),					/* this window is not buffered (Mac OS X only)*/
	kWindowStandardDocumentAttributes = (kWindowCloseBoxAttribute | kWindowFullZoomAttribute | kWindowCollapseBoxAttribute | kWindowResizableAttribute),
	kWindowStandardFloatingAttributes = (kWindowCloseBoxAttribute | kWindowCollapseBoxAttribute)
))
	@ 0 >R rp@ _GetWindowAttributes drop R>
;



: GetWRefCon ( wptr4 -- refcon )	\  -- returns 0 if window not added yet
	@ dup
	IF
		_GetWRefCon ( WindowRef -- refcon)
	THEN
;


: _LMGetWindowList GetWindowList ;


: ?ACTIVE.WindowRef  ( WindowRef -- flag | True if on WMgr list )
	dup
	locals| theWindowref |

	IF
	\	locals| theWindowref |
		_LMGetWindowList 				\ start with frontmost window
		BEGIN	dup						\ last window has 0 in +NextWindow
		WHILE	dup theWindowref =
				IF drop true exit THEN		
				GetNextWindow
		REPEAT
	ELSE
		0
	THEN ;


: ?ACTIVE.WPTR  ( wptr4 -- flag | True if on WMgr list )
	dup
	IF
		@ ?active.WindowRef
	THEN ;


: (?WPTR)  ( addr -- flag | True if MacForth wptr4  )
	dup
		w.linkage @  				\ last window added
		locals| testWindow theWptr |
	IF
		BEGIN
			testWindow 0 = IF 0 exit THEN
			testWindow theWptr <>
		WHILE
			testWindow +w.link @ 
			-> testWindow
		REPEAT
		true
	ELSE
		0
	THEN ;


defer ?UserWptr ( wptr -- flag )
	' DropFalse  is ?UserWptr


: ?WPTR  ( addr -- flag | True if MacForth wptr4  )
	dup  (?wptr)
	swap ?UserWptr OR ;


: -WPTR  ( addr  -- addr   |   error if not wptr4 )
	dup ?wptr false= 10 r$abort  ;



extern: UInt32 OSStatus CreateNewWindow ( UInt32 WindowClass, UInt32 WindowAttributes, 
											UInt32 * ^contentBounds, UInt32 * ^WindowRef );

extern: UInt32 OSStatus GetWindowClass ( UInt32 WindowRef, UInt32 * ^Class  );
extern: UInt32 OSStatus SetWindowClass ( UInt32 WindowRef, UInt32 Class  );
extern: UInt32 WindowAttributes GetAvailableWindowAttributes ( UInt32 WindowClass  );
extern: UInt32 OsErr ChangeWindowAttributes ( UInt32 WindowRef, UInt32 attrtoSet, UInt32 attrToClear );



: NewWAttributes ( attributes\wptr4  --  | sets window +NewWAttributes)
	-wptr +NewWAttributes !  ;


: ConvertOldWAttributes ( wptr4 -- n )
	\ convert old-style +W.ATTRIBUTES to +NewWAttributes 
	dup
	+w.attributes w@
	dup
	1 and				\ 1 = CLOSE.BOX == kWindowCloseBoxAttribute
	over 4 and			\ 4 = SIZE.BOX
		boolean 16 and	\ 16 = new attribute for kWindowResizableAttribute
		OR
	swap 128 and 		\ 128 = ZOOM.BOX
		boolean 6 and	\ 6 = new attribute for kWindowHorizontalZoomAttribute+kWindowVerticalZoomAttribute
		OR

	swap +w.type w@  $7FFF and			\ window class (type)
	0= IF 	8 OR THEN		\ for old-style type 0 windows, always add kWindowCollapseBoxAttribute
;


: ((CREATE.WINDOW))  ( wptr4 -- )
	dup >R
	+w.type w@  $7FFF and			\ window class (type)
	?dup 0= IF 6 THEN					\ 0 is not valid window class
	dup GetAvailableWindowAttributes
	r@ +NewWAttributes @				\ window attributes
	r@ ConvertOldWAttributes			\ import old attributes
	OR									\ merge attribites
	AND									\ avoid invalid attributes for the class
	r@ +wbounds
	r> +windowref#
	CreateNewWindow ( WindowClass\WindowAttributes\^contentBounds\^WindowRef  -- OSStatus )
\	44 R$abort		\ abort" CreateNewWindow failed!"
	abort" CreateNewWindow failed!"
;


defer SHOW.WINDOW

: ((ADD.WINDOW))  \ (CREATE.WINDOW)  ( wptr4 -- windowref | primitive for ADD.WINDOW )
	locals| wptr4 |
	wptr4 ((create.window))
	wptr4 +windowref# @  wptr4 SetWRefcon	\ save our wptr4 as the wrefcon

	\ now instantiate it as per window tail
	wptr4 +windowref# @  wptr4 +wTitle @ ( DBP+ ) SetWTitle
	wptr4 +w.behind @
	dup -1 <> 			\ -1 is in front
	IF
		dup 			\ 0 is all the way in the back
		IF
			( DBP+ ) 
			dup ?active.wptr 
			IF
				+windowref# @
			ELSE
				drop 0 
			THEN
		THEN 
		wptr4 @ swap SendBehind    ( wptr\behindWptr -- )
	ELSE
		drop 
		wptr4 @ BringToFront
	THEN
	wptr4 +windowref# @						\ return windowref
	wptr4 +w.Attributes w@ 2 and 0=			\ visible?
	IF
		wptr4 show.window
	THEN
;


: _InvalRect ( &rect -- )
	GetPort GetWindowFromPort  swap InvalWindowRect drop
;


: WPTR->WREF ( WPtr |or| WRef -- WindowRef |OR| 0 )
\ 0 will be returned if 4th window that has not been added yet
\ does not have to be visible, though
	locals| suppliedRef |
	suppliedRef (?WPTR)  			\ is it a forth window ?
	IF
		suppliedRef ?active.wptr	\ its wRef is in Mac wmgr list ??
		IF
			  suppliedRef @
		ELSE
			  0
		THEN
	ELSE							\ not a forth window -- is it already a wRef ?
		suppliedRef ?active.WindowRef 
		IF
			  suppliedRef
		ELSE
			  0
		THEN
	THEN ;



: (WINDOW)  ( wptr4 -- | sets grafport %)
	dup currentWindow !		\ update user variable
	
	GetPort GetWindowFromPort  _GetWRefCon
	over <>		\ if wptr4 == current port, we are ok
	IF			\ wptr ?<>? curPort
		-wptr
		dup 
		@ 		
		GetWindowPort
		<SetPort
	THEN
	dup ?wptr 
	IF
		dup 0 <xform negate +
	ELSE
		dflt.window.xform
	THEN
	window.xform !
	drop ;


\ use this when the window is already know to be in the MF window list
: (MFWINDOW)  ( wptr4 -- | sets grafport %)
	dup 
	currentWindow !					\ update user variable
	GetPort GetWindowFromPort  _GetWRefCon
	over <> 
	IF						\ wptr4 <> the one attached to current port
		dup @
		dup IsValidWindowPtr
		IF
			GetWindowPort
			<SetPort
		ELSE
		    2drop exit 
		THEN
	ELSE						\ wptr4
		dup @ GetWindowPort
		<SetPort
	THEN
	0 <xform negate +
	window.xform ! ;



: ?SETPORT  ( wptr4 -- ) \ only calls SetPort if port has changed
	?DUP
	IF
		dup >R currentWindow !						\ update user variable
		GetPort 
		dup currentport @ <>						\ is currentport set correctly?
		swap GetWindowFromPort  
		\ this could be 0 under VFX
	dup
	IF
		_GetWRefCon									\ wrefcon of current port
		r@ <>										\ is current port correct?
	THEN	
		OR
		
		
		IF					\ wptr ?<>? curPort
			R>
			@ 				\ wptr4\windowref
							\ dup _IsValidWindowPtr	not IF " not 4th window in ?SETPORT" DebugStr THEN		
			GetWindowPort
			<SetPort
		ELSE
			R> @ GetWindowPort  CURRENTPORT !		\ 6.04996
		THEN
		\ drop
	THEN ;


: @WINDOW.PAIR  ( -- wptr\xform ptr )
	get.window ( -- wptr4 )	
	window.xform @ ;


: !WINDOW.PAIR  ( wptr\xform ptr -- )
	window.xform ! ?setPort ;



: XYOFFSET ( X\Y -- )
	get.xform.window +xyoffset 2!  ;


: XYSCALE  ( x\y -- ) 
	get.xform.window +xyscale !point ;



: MOVE.TO   ( X\Y -- )
	2dup WinXlate MoveTo
	get.xform.window +XYPos !point
;


: DRAW.TO  ( X\Y -- )
	2dup WinXlate LineTo
	get.xform.window +XYPos !point ;


: RMOVE  ( dX\dY -- )  \ relative move
      GET.xform.WINDOW +XYPos @POINT +POINT MOVE.TO  ;


: RDRAW ( X\Y -- )  \ relative draw
      GET.xform.WINDOW +XYPos @POINT +POINT DRAW.TO  ;


: VECTOR  ( x1\y1\x2\y2 -- )
	2swap move.to draw.to ;


: DOT  ( x\y -- )
	2dup vector ;




: InitGraf  ( -- )  \ init CSI graphics
    get.xform.window +xyoffset  32 erase
	100 100 xyscale  
\	0 xypivot
		0        get.xform.window +xypivot W!
		0 10000  get.xform.window +xybias !point
	1 1 _PenSize   black penpat
    0 0 xyoffset
	0 0 move.to   ;




: FlushWindow (  wptr4 -- )
	@ GetWindowPort
	locals| thePort |
	thePort newRgn GetPortVisibleRegion >R
	thePort R@	   QDFlushPortBuffer
	r> DisposeRgn
;


2variable NextFlushTime  0 0 NextFlushTime 2!
1000000 30 /	value	MinMicrosecBetweenFlushes ( 30/sec update rate )


: SetNextFlushTime ( -- )
	microsecs  MinMicrosecBetweenFlushes s>d D+
	NextFlushTime 2!
; 	PRELUDES linklasttoken	\ do it at startup

SetNextFlushTime	\ do it now


\ faster than FlushWindow - silly to make it redraw faster than 30/sec
: (?FlushWindow) ( wptr4\RgnHandle -- )
	NextFlushTime 2@ microsecs
	DU<
	IF
		SetNextFlushTime
		swap @ GetWindowPort swap QDFlushPortBuffer
 	ELSE
 		2drop
	THEN
;


: ?FlushWindow ( wptr4 -- )	\ flush whole window
	0 (?FlushWindow)
;



: ?WVISIBLE  ( wptr4 -- flag | true if window is currently visible )
	dup ?Active.Wptr
	IF   \ 110 + c@ boolean
		 @ IsWindowVisible boolean
	ELSE drop false
	THEN ;


: -ACTIVE.WPTR  ( addr -- addr | aborts if not an active wptr4 )
	dup ?active.wptr false= 10 r$abort ;



: WINDOW  ( wptr4 -- ) \ Set window and grafport
	-wptr (mfwindow) ;


: SET.WTITLE  ( string\wptr4 -- )
	-active.wptr  
	@
	swap
	SetWTitle  ;


: Get.WTitle  ( ^string\wptr4 -- )
	-active.wptr  
	@
	swap
	GetWTitle  ;



: HILITE.WINDOW ( flag\wptr4 -- %)
	-active.wptr  
	@ 
	swap
	HiliteWindow ;


: BRING.TO.FRONT  ( wptr4 -- )
	-active.wptr  
	@
	BringToFront  ;


: DfltSEND.BEHIND  ( wptr4A\wptr4Behind -- )
	DUP						\ 0 for Behind window sends wptr4A behind all windows
	IF
		 -active.wptr +windowref# @
	THEN
	swap -active.wptr +windowref# @
	swap
	SendBehind ;


: DfltSHOW.WINDOW    ( wptr4 -- )
	-active.wptr  
	@ ShowWindow
;

: DfltHIDE.WINDOW    ( wptr4 -- )
	-active.wptr  
	@ HideWindow
;

: Dflt(CLOSE.WINDOW) ( wptr4 -- )
	-active.wptr  
	dup @ 
	swap off	\ clear reference to sys.window
	?dup		\ protect sys call from 0
	IF
		CloseWindow
	THEN
;

: DfltFRONT.WINDOW   ( -- wptr4 )
	FrontWindow _GetWRefCon ;


: DfltSELECT.WINDOW  ( wptr4 -- )
	-active.wptr  
	dup @ SelectWindow
	window
 ;


\ ********************************************************************************

defer SEND.BEHIND 	 ' DfltSEND.BEHIND    is SEND.BEHIND
\ defer SHOW.WINDOW  ( defined above )
					 ' DfltSHOW.WINDOW    is SHOW.WINDOW
defer HIDE.WINDOW 	 ' DfltHIDE.WINDOW    is HIDE.WINDOW
defer (CLOSE.WINDOW) ' Dflt(CLOSE.WINDOW) is (CLOSE.WINDOW)
defer FRONT.WINDOW 	 ' DfltFRONT.WINDOW   is FRONT.WINDOW
defer SELECT.WINDOW  ' DfltSELECT.WINDOW  is SELECT.WINDOW


: FORCE.WINDOW ( wptr -- )
	dup Show.Window
	dup window
	select.window ;



\	Window Definition Primitives

: W.TITLE ( $addr\wptr4 -- installs start.up title for window )
	-wptr  +wtitle ! ;

: W.BOUNDS    ( t\l\b\r\wptr4 -- installs start.up window bounds)
	-wptr +wbounds !rect  ;

: W.TYPE  ( type\wptr4 -- | sets window type   0 = doc *)
	-wptr +w.type w!  ;

: W.BEHIND  ( [wptr4] or [-1] or [0] \wptr -- | puts window behind *)
	-wptr  \ over 0>
\	IF swap  dbp- swap  THEN
	+w.behind !  ;

: W.ATTRIBUTES  ( attributes\wptr4  --  | sets window attributes)
	-wptr +w.attributes w!  ;


\ "Classic" Window Attribute Constants

  1  constant  CLOSE.BOX
  2  constant  NOT.VISIBLE
  4  constant  SIZE.BOX
  8  constant  SCROLL.UP/DOWN
 16  constant  SCROLL.LEFT/RIGHT

128  constant  ZOOM.BOX
256  constant  CLOSE.BEHIND		\ close box works when window not in front7

\ Additional Attributes available since switching to CreateNewWindow from NewCWindow
0   constant kWindowNoAttributes 						\ = 0,
1   constant kWindowCloseBoxAttribute					\ = (1L << 0)
2   constant kWindowHorizontalZoomAttribute				\ = (1L << 1)
4   constant kWindowVerticalZoomAttribute				\ = (1L << 2)
6	constant kWindowFullZoomAttribute
8   constant kWindowCollapseBoxAttribute				\ = (1L << 3)
16  constant kWindowResizableAttribute					\ = (1L << 4)
32  constant kWindowSideTitlebarAttribute				\ = (1L << 5)
64  constant kWindowToolbarButtonAttribute				\ = (1L << 6)
1  8 lshift  constant kWindowMetalAttribute				\ = (1L << 8)
1 16 lshift  constant kWindowNoUpdatesAttribute			\ = (1L << 16)
1 17 lshift  constant kWindowNoActivatesAttribute		\ = (1L << 17)
1 18 lshift  constant kWindowOpaqueForEventsAttribute	\ = (1L << 18)
1 19 lshift  constant kWindowCompositingAttribute		\ = (1L << 19)
1 21 lshift  constant kWindowNoShadowAttribute			\ = (1L << 21)
1 24 lshift  constant kWindowHideOnSuspendAttribute		\ = (1L << 24)
1 25 lshift  constant kWindowStandardHandlerAttribute	\ = (1L << 25)
1 26 lshift  constant kWindowHideOnFullScreenAttribute	\ = (1L << 26)
1 27 lshift  constant kWindowInWindowMenuAttribute		\ = (1L << 27)
1 28 lshift  constant kWindowLiveResizeAttribute		\ = (1L << 28)
1 29 lshift  constant kWindowIgnoreClicksAttribute		\ = (1L << 29)
1 31 lshift  constant kWindowNoConstrainAttribute		\ = (1L << 31)
kWindowCloseBoxAttribute kWindowFullZoomAttribute OR kWindowCollapseBoxAttribute OR
	kWindowResizableAttribute OR constant kWindowStandardDocumentAttributes



create COORD.BOUNDS		 \ maximum QD rect size
	-32000 W,  -32000 W,  32000 W,   32000 W,


: NO.CLIP  ( wptr4 -- clip to window bounds )
	get.window >r
	?SetPort 
	coord.bounds  ClipRect 
	r> ?SetPort  ;


: GetWindowPortBounds ( wptr4 -- ^rect )
	@ ScratchBoundsRect _GetWindowPortBounds
 ;


: CLIP>CONTENT  ( wptr4 -- clip to content area )
	GetPort >R
	dup  ?SetPort 
	dup  ?wptr
	IF
		  +wcbounds		\ use  wptr4 tail
	ELSE 
		  GetWindowPortBounds
	THEN  
	ClipRect
	R> <SetPort
;


: DEFAULT.ACTIVATE (  default activation... just beep  )
	IF
		BEGIN
			key.stroke off
			do.events
			IF  beep THEN
		AGAIN
	THEN  ;



here ( DBP- )  ," untitled"		\ new window title

create DFLT.WINDOW.TAIL  ( -- | starts at +WINDOW.RECORD.SIZE )
								0 ,		\ long: +windowref#	\ 
								0 ,		\ long: +dlogref#	\ 
								0 ,		\ long:	+WREFCON	\ obsolete
								0 ,		\ long:	+teWREFCON	\ obsolete

		( +M4th.WTYPE )			0 ,
		( +WptrSize )			0 w,
								0 w, 	\  realign and add some space

		( Activate )			0 ,		' DEFAULT.ACTIVATE ,
		( Update )				0 ,		' pause ,
		( +WINDOW.ACTION )		0 ,		0 ,
		( +W.HILITE )			' DROP ,
		( +ON.NEWACTIVATE )		' DROP ,

		( +ON.CLOSE ) 			0 ,
		( spare )	  			0 ,

		( +WFILE.PTR )			0 ,
		( TITLE)  				,
		( ATTRIBUTES)			0 W,
		( TYPE)					0 W,
		( BEHIND)				-1 ,
		( GLBL BOUNDS)  		100 W,   100 W,    200 W,  300 W,
		( LOCAL BOUNDS)			  0 W,     0 W,    150 W,  299 W,
		( LINE.HEIGHT)			15 ,
		( hex 28 bytes in )
		( +WGROW )				32 w,  32 w,          	\ min 32x32
		 			        	-1 ,					\ default max size
		( SCROLL CONTROLS)		0 ,  0 ,

		( XYOFFSET )	 		0 , 0 ,
		( XYSCALE )				100 w, 100 w,
		( XYPIVOT ) 			0 w,
		( XYBIAS )  			10000 w, 0 w,
		( XYPOS )				0 ,
		( CARTESIAN )			0 ,
		( unused )				0 , 0 w,
								0 , 0 ,
		( LINK)					0 ,
WINDOW.TAIL.STRUCTURE  DFLT.WINDOW.TAIL   +WptrSize w!



: NEW.WINDOW  ( --  creates new window structure, linked list extended )
	create
	here locals| WPTR |						\ window record addr
	0 +w.link allot
	dflt.window.tail
	wptr 
	0 +w.link 
	cmove									\ install MF tail
	w.linkage @ ,							\   and MF link
	wptr ( DBP- ) w.linkage !  ;				\ add to MF list


: NEW.XFORM  ( name ( -- )
	create here xform.size allot 
	dflt.window.tail swap xform.size cmove ;


\ ***********************  SYS.WINDOW  *************************************
\	SYSTEM   Window Creation
new.window SYS.WINDOW
	here	( left on stack for sys.window title below )
	," MacForth on VFX" 	align  
	sys.window w.title

	screen.bounds 2@  sp@ 4 6 InsetRect
	51 16 lshift +					\ fix top
	sys.window +wbounds 2!

	size.box close.box +
	zoom.box + 64 +
	CLOSE.BEHIND  +			\ 6.05437
	sys.window w.attributes
	8 sys.window +NewWAttributes  !		\  collapse button

\ ************************************************************************* 


: CLOSE.WINDOW ( wptr4 -- |  CLOSE WINDOW, DEALLOT MEMORY)
	-wptr
	dup @
	locals| WindowRef wptr4 |
	wptr4 active.window @ = IF active.window off THEN
	wptr4 ?active.wptr
	IF
		wptr4 sys.window <>
		IF  WindowRef KillControls
			WindowRef BeginUpdate  
			WindowRef EndUpdate		\ no update region
		THEN
		wptr4 (close.window)		\  allow (close.window)  on sys.window
	THEN ;


: VBAR.BOUNDS  ( wptr4 -- T\L\B\R )		\  change adjust if no size box
\	dup HasSizeBox? >R
	GetWindowPortBounds	\ @ ScratchBoundsRect _GetWindowPortBounds  \ CARBON   16 + 
	@rect				\ t\l\b\r  of portRect
	2swap drop over		\ b\r\t\r
		-1 -15 +point		\ b\r\t-1\r-15
	2swap						\ t-1\r-15\b\r
		-14 1 +point ;		\ t-1\r-15\b-14\r+1
\		R> IF -14 ELSE -1 THEN 1 +point ;		\ t-1\r-15\b-14\r+1


: HBAR.BOUNDS ( wptr4 -- T\L\B\R )		\  change adjust if no size box
\	dup HasSizeBox? >R
	GetWindowPortBounds
	2 +  \ CARBON   18 + 
	@rect				\ l\b\r\garbage   of portRect
	drop over 2swap		\ r\b\l\b
		-1 -15 +point		\ r\b\l-1\b-15
\		-1 R> IF -15 ELSE -1 THEN +point		\ r\b\l-1\b-15
	2swap						\ l-1\b-15\r\b
		-14 1 +point		\ l-1\b-15\r-14\b+1
\		R> IF -14 ELSE -1 THEN 1		\ l-1\b-15\r-14\b+1
	xy><tlbr ;				\ b-15\l-1\b+1\r-14


: CONTENT.RECT  ( wptr4 -- t\l\b\r )
	0 locals| ATTRS wptr4 |
	wptr4 GetWindowPortBounds	\ @ ScratchBoundsRect _GetWindowPortBounds  ( WindowRef &Rect -- &Rect )
	@rect
	wptr4 +w.attributes w@ to attrs
	attrs size.box scroll.left/right or and
	if   17 0 -point then
	attrs scroll.up/down and
	IF  17 -   THEN ;



create ScratchRect 8 allot

: XYXY>ScratchRECT ( X1\Y1\X2\Y2 -- &rect )
	rot SortTwo		\ x1\x2\T\B
	2swap SortTwo	\ T\B\L\R
	>R swap R> ScratchRect !RECT ScratchRect ;

: TLBR>ScratchRECT  ( t\l\b\r -- &rect )
	rot SortTwo		\ t\b\L\R
	2swap SortTwo	\ L\R\T\B
	>R -rot R> swap ScratchRect !RECT ScratchRect ;



16 value ScrollBarType


: VBAR  ( wptr4 -- | defines vbar for window )
	dup >r 
	@
	r@ vbar.bounds tlbr>ScratchRect ( t\l\b\r -- &rect )    
	""
	-1
	0  
	0  100    ( 0 of 0-100 )
	ScrollBarType			\ 16
	0
	NewControl
	r>  +vbar !   ;


: HBAR  ( wptr4 -- | defines hbar for window )
	dup >r 
	@
	r@ hbar.bounds tlbr>ScratchRect ( t\l\b\r -- &rect )    
	""
	-1
	0  
	0  100    ( 0 of 0-100 )
	ScrollBarType			\ 16
	0
	NewControl
	\ add.control ( wptr\&Rect\&title\visible\value\min\max\type\refCon -- handle )
	r>  +hbar !   ;


:  (CLEAN.CONTROLS) ( wptr4 -- | erases bars for window )
	@window.pair >r >r  
	dup (window)
	save.clip >r
	no.clip
	\ first clean up horiz scroll area
	get.window dup +hbar @	\ 6.053 make this conditional
	swap +w.attributes w@ size.box AND OR	\ 605432
	IF
		get.window 
			+wcbounds 4 + w@s				\ b        of wcbounds
		get.window
			GetWindowPortBounds
			2 +
			@rect drop						\ ..l\b\r  of Port.Bits.Bounds
			tlbr>ScratchRect
			dup EraseRect
			    InvalRect
	THEN

	\ then clean up vert scroll area
	get.window +vbar @	\ 6.053 make this conditional
	IF
		get.window
			GetWindowPortBounds
			@rect 2swap drop				\ b\r\t    of Port.Bits.Bounds
		get.window 
			+wcbounds 6 + w@s				\ ..r      of wcbounds
			2swap
			tlbr>ScratchRect 
			dup EraseRect
			    InvalRect
	THEN
	r> restore.clip
	r> r> !window.pair ;

defer CLEAN.CONTROLS			' (CLEAN.CONTROLS)   is  CLEAN.CONTROLS


\	WINDOW SIZING
: SIZE.BARS  ( wptr4 -- | SIZES SCROLL BARS FOR WINDOW ) 
	locals| wptr4 |
	wptr4 +vbar @ ?dup
	IF \ CARBON h@@ 8 + !rect
	   \ wptr4 +vbar @
	   wptr4 vbar.bounds ( WPTR -- T\L\B\R ) tlbr>ScratchRect
	   SetControlBounds ( ControlRef\^rect -- ) 
	THEN
	wptr4 +hbar @ ?dup
	IF \ CARBON h@@ 8 + !rect
	   \ wptr4 +hbar @
	   wptr4 hbar.bounds  ( WPTR -- T\L\B\R ) tlbr>ScratchRect
	   SetControlBounds ( ControlRef\^rect -- ) 
	THEN  ;


: SIZE.WINDOW  ( wptr4 -- | computes window content rect bounds )
	-wptr  locals| wptr4 |
	wptr4 content.rect
	wptr4 +wcbounds !rect 		( correct content rect )
	wptr4 size.bars				( MINUS H&V BARS)
	wptr4 clip>content ;		( CLIP TO NEW CONTENT)


: GET.LINE.HEIGHT  ( -- n )
	get.xform.window +wline.height @ ;



Extern: void GetPenState  ( UInt32 * &penState  );
Extern: void SetPenState  ( UInt32 * &penState  );

: @PENSTATE  ( -- 20 bytes on stack )
	{	| buff[ 20 ]  }		\ 20 localBuf		\ addr
	buff[ dup GetPenState
	5 0 DO dup @ swap 4 + LOOP drop ;

: !PENSTATE  ( 20 bytes on stack -- )
	{	| buff[ 20 ]  }		\ 20 localBuf		\ addr
	buff[  20 +
	5 0 DO 4 - tuck ! LOOP
	SetPenState ;


: @PEN  (  -- X\Y  PEN POSITIONS  )
	0 sp@ GetPen POINT>XY
;


: DRAW.BAR   ( hilite code\ControlRef -- hilite code )
	?dup
	IF
		2dup
		swap              HiliteControl    ( ControlRef\hiliteCode )
		ScratchBoundsRect GetControlBounds ( ControlRef\^rect -- ^rect )

		( hilite code\^rect )
											\ 2@ sp@
		dup
			ClipRect  ( &rect -- )			\ control rect
			ValidRect ( &rect -- )			\ prevent second draw on updates!
											\ 2drop
		get.window @  DrawControls
		\ GetWindowFromPort is needed to cast up to a WindowRef from a GrafPort
	THEN ;


: >GROW.ICON  ( flag -- )
	get.window 
	GetWindowPortBounds
	4 +
	@point swap						\ b\r  of PortRect
	2dup 14 dup -point				\ b\r\b-14\r-14 ..ok for MAKE.RECT
	tlbr>ScratchRect ClipRect				\ clip to icon rect
	IF
		get.window @ DrawGrowIcon
	ELSE
		get.window
		GetWindowPortBounds
		EraseRect
	THEN ;


: H&VBARS  ( Hilite Code -- | bar activation )
	save.clip >r
	>r  									( hilite code )
	get.window no.clip
	@penstate					\ ScratchPenState _GetPenState 
	1 1 _PenSize  
	9 ( pator ) _PenMode
	r>  ( hilite code )

	get.window +hbar @  draw.bar
	get.window +vbar @  draw.bar

	get.window +w.attributes w@  size.box and
	IF
		0= >grow.icon
	ELSE
		drop               \ hilite code
	THEN
	!penstate						\ ScratchPenState _SetPenState
	r> restore.clip   ;


: SHOW.CONTROLS  ( wptr4 -- | displays controls for window )
	TRUE
    over +w.attributes w@ size.box and
    or
	IF  @window.pair 
		>r >r  
		dup window
		active.window @ <>
		255 and h&vbars


		@penstate
		get.textmode
		1 1 _PenSize  
		9 ( pator ) _PenMode  
		srcor TextMode

		save.clip
			get.window content.rect tlbr>ScratchRect ClipRect
			get.window @ DrawControls
  		restore.clip

		TextMode  
		!penstate
		r> r> !window.pair
	ELSE  drop
    THEN  ;


: ADD.CONTROLS  (  wptr4 -- | appends controls called out )
				(  in window attributes to window )
				( sets up vbar and hbar control handles )
	locals| WPTR |
	
	wptr +w.attributes w@ dup
	scroll.up/down    and  IF  wptr vbar  THEN
	scroll.left/right and  IF  wptr hbar  THEN ;


: (ADD.WINDOW)   ( wptr4 -- )
	locals| wptr4 |
	wptr4  +vbar off    
	wptr4  +hbar off
	wptr4 ((add.window))  drop
	( Front.Window drop )
	wptr4 size.window
	wptr4 add.controls

	wptr4 size.window  			\ CARBON ?? to show controls
	\ wptr4 clean.controls
	\ wptr4 SHOW.CONTROLS
;


: ADD.WINDOW  ( wptr4 --- | creates a window *)
	get.window
	>R		\ CARBON
	    dup close.window  

	        (add.window)
	    ( Front.Window drop )
	R> dup ?wptr 
	IF   window 
	ELSE drop 
	THEN ;



: (GET.ZOOM.OUT) ( wptr4 -- t\l\b\r )	\ standard zoom state*
	@
	ScratchRect GetWindowStandardState @rect
;

: (GET.ZOOM.IN) ( wptr4 -- t\l\b\r )	\ user zoom state*
	@  ScratchRect GetWindowUserState @rect
;


: (SET.ZOOM.OUT) ( t\l\b\r\wptr4 -- )	\ standard zoom state*
	@ >R
	ScratchRect !rect
	R> ScratchRect SetWindowStandardState 
;

: (SET.ZOOM.IN) ( t\l\b\r\wptr4 --  )	\ user zoom state*
	@ >R
	ScratchRect !rect
	R> ScratchRect SetWindowUserState 
;


: ?ZOOM  ( -- flag )
	get.window GetWindowAttributes
	\ kWindowHorizontalZoomAttribute ( 2 )
	\ kWindowHorizontalZoomAttribute ( 4 )
	6 AND boolean ;


: SET.ZOOM.OUT  ( t\l\b\r -- )	\ standard zoom state*
	4 needed
	get.window ?zoom
	IF	 (set.zoom.out)
	ELSE drop 2drop 2drop
	THEN ;


: GET.ZOOM.OUT  ( -- t\l\b\r )	\ standard zoom state*
	get.window ?zoom
	IF	 (get.zoom.out)
	ELSE drop 0 0 0 0
	THEN ;


: SET.ZOOM.IN  ( t\l\b\r -- )	\ user zoom state*
	4 needed
	get.window ?zoom
	IF	 (set.zoom.in)
	ELSE drop 2drop 2drop
	THEN ;


: GET.ZOOM.IN  ( -- t\l\b\r )	\ user zoom state*
	get.window ?zoom
	IF	 (get.zoom.in)
	ELSE drop 0 0 0 0
	THEN ;



: SetWindowSize ( x\y\wptr -- )
	+windowref# @
	rot 200 max		Screen.Width  min	\ width clip
	rot  60 max		Screen.Height min	\ height clip
	true
	SizeWindow  ( WindowRef\wide\high\updateFlag -- )
;

: SetWindowPos ( x\y\wptr -- )
	+windowref# @
	rot screen.bounds 2 + w@ 2 + max	\ check left edge
	    screen.bounds 6 + w@ 20 - min	\ check right edge
	rot screen.bounds w@ 2* max			\ check top edge ( *2 for title bar)
	    screen.bounds 4 + w@ 20 - min	\ check bottom edge
	false
	MoveWindow  ( windowRef\hGlobal\vGlobal\frontFlag -- )
;


((
/**/
/*  FindWindow Result Codes                                                            */
/**/
typedef SInt16 WindowPartCode;
enum {
  inDesk                        = 0,
  inNoWindow                    = 0,
  inMenuBar                     = 1,
  inSysWindow                   = 2,
  inContent                     = 3,
  inDrag                        = 4,
  inGrow                        = 5,
  inGoAway                      = 6,
  inZoomIn                      = 7,
  inZoomOut                     = 8,
  inCollapseBox                 = 11,   /* Mac OS 8.0 forward*/
  inProxyIcon                   = 12,   /* Mac OS 8.5 forward*/
  inToolbarButton               = 13,   /* Mac OS X forward*/
  inStructure                   = 15    /* Mac OS X 10.1 forward*/
};
))


Extern:  UInt32 partCode  FindControl  ( UInt32 localPt, UInt32 wptr, UInt32 * &whichControl );
Extern:  UInt32 CtrlRef   FindControlUnderMouse  ( UInt32 localPt, UInt32 wptr, UInt32 * &outPart );


: FIND.CONTROL  ( point\wptr4 --  ControlRef\PartCode )
	@			\ wptr4->wRef
	0 >R RP@ 	\ &outPart
	FindControlUnderMouse 
	R> 								\ CtrlRef\partcode
\	swapw							\ 10.45 - inappropriate
	\ dimmed controls return 0\0, so cannot use 0 as alternate return
 ;



\ ************************************************************************

: CENTER.IN.HORIZONTAL  ( t\l\b\r -- t\l'\b\r' )
	rot -					( t\b\dh )
	screen.bounds 6 + w@	( t\b\dh\hmax )
	screen.bounds 2 + w@  dup >R -	\ t\b\dh\hscreen
	
	over - 					\ t\b\dh\hscreen-dh
	2/  r> + 						\ t\b\dh\availscr/2
	swap   					\ t\b\availscr/2\dh
	over +	
	( t\b\l'\r' )
	rot swap ;



: Center@Bottom  ( t\l\b\r -- t'\l'\b'\r')		\ reposition rect same size
												\ at bottom center of screen
	 center.in.horizontal
	 screen.bounds 4 + w@
	 locals| bottom r b l t  |
	 bottom b t -  -   3 -   ( t')   l  bottom 3 -  ( b' )  r  ;


: CENTER.ON.SCREEN  ( t\l\b\r -- t'\l'\b'\r' )
    2swap -point                   ( dh\dv )
    Screen.Bounds 4 + @point swap  ( dh\dv\hmax\vmax )
    2over -point 2/ swap 2/ swap   ( dh\dv\t'\l' )
    2swap 2over +point ;


: (WHERE.WINDOW) ( windowref -- t\l\b\r | get rect needed to reset w.bounds )
	40 ScratchBoundsRect GetWindowBounds drop
	ScratchBoundsRect @rect
;

: WHERE.WINDOW ( wptr4 -- t\l\b\r | get rect needed to reset w.bounds )
	@ (where.window) ;



create RECT2		0 , 0 ,		\ scratch rectangle

: RECT<GrayRegion? ( t/l/b/r -- flag | true if rect entirely within GrayRgn )
	4 needed
	rect2 !rect
	NewRgn  NewRgn
	locals| TheWRegion  TestRgn |
	TheWRegion rect2 RectRgn
	GetGrayRgn TheWRegion TestRgn   SectRgn		\ intersect of gray and window
	TestRgn    TheWRegion	        EqualRgn	\ equals window region if all on screen
	TestRgn		DisposeRgn
	TheWRegion	DisposeRgn
;


: CENTER.OVER.RECT ( t\l\b\r\t1\l1\b1\r1 -- t'\l'\b'\r')
	locals| fR fB fL fT  R B L T |
	fR fL -						\ front window width
	R L -						\ rect width
	-							\ delta width - + if rect narrower than wptr
	2/ dup
	fL + 		->	L		\ cr ." L = " .
	fR swap -	->	R		\ ."   R = " .

	fB fT -						\ front window height
	B T -						\ rect height
	-							\ delta height - + if rect shorter than wptr
	2/ dup
	fT +		->	T		\ cr ." T = " .
	fB swap -	->	B		\ ."   B = " .
	
	t l b r				\ now test that we will be entirely on screen
	rect<GrayRegion? ( t/l/b/r -- flag | true if rect entirely within GrayRgn )
	IF	 t l b r
	ELSE t l b r center.on.screen
	THEN ;


: CENTER.OVER.WPTR ( t\l\b\r\wptr -- t'\l'\b'\r')
	-wptr
	where.window
	CENTER.OVER.RECT
;


: CENTER.OVER.FRONT.WINDOW ( t\l\b\r -- t'\l'\b'\r')
	front.window center.over.wptr
 ;


: (PositionDLOGRect)  ( resHandle\token -- )  \ resHandle may be NIL
	\ from Greg Guerin
	locals|  theToken theHand  |
	\ theToken does:  ( T1\L1\B1\R1 -- T2\L2\B2\R2 )
	theHand IF
		theHand Non.Purgable
		theHand @  @RECT  theToken execute	\ transform rectangle
		theHand @  !RECT
	THEN ;


prune:
\ WINDOW FORGETTOR - prune windows whose action in forgotten range
	{: start end | ^priorwindowlink -- start end :}
	w.linkage -> ^priorwindowlink
	
	BEGIN	^priorwindowlink @
			?dup						\ is there another window ?
	WHILE
			start end range
      		IF	 dup  close.window
      			 +w.link @  	^priorwindowlink !		\ link following window instead
      		ELSE dup 	        ^priorwindowlink !		\ link this window
      			 +w.link	 -> ^priorwindowlink		\ new prior link	
      		THEN
	REPEAT
	start end
;


\ ************************************************************************
\ ************************************************************************
\ ************************************************************************
\ debugging - force dump to sys.window

\ SHOULD be safe to do from CALLBACK: words

: DoProtectedIO ( ....\token\window -- )
	mfconsole @ >R
	get.window >R
	outfile @ >R
	action-of pause >R
\	events @ >R
\	io.events @ >R
\	events off io.events off
	['] noop is PAUSE				\ not safe to do PAUSE inside callbacks
	callback.console mfconsole !	\ disable EVENT HANDLING
	dup outfile ! window
	execute
\	R> io.events !
\	R> events !
	R> is pause
	R> outfile !
	R> dup ?wptr
	IF window ELSE drop THEN
	R> mfconsole !
;



: S.RS ( .. -- .. )	\ .RS to SYS.WINDOW
	['] .rs sys.window DoProtectedIO
;

: S.S ( .. -- .. )		\ .S to SYS.WINDOW
	['] .s sys.window DoProtectedIO
;

: S. ( N -- )		\ . to SYS.WINDOW
	['] . sys.window DoProtectedIO
;

: S.TYPE ( addr\cnt -- )	\ TYPE to SYS.WINDOW
	['] type sys.window DoProtectedIO
;

: S.DUMP ( addr\cnt -- )	\ DUMP to SYS.WINDOW
	['] dump sys.window DoProtectedIO
;


: S.CR ( -- )
	callback.console 5 + count  s.type
;






StopIncluding ************************************

