\ MENU STUFF
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************



only Forth definitions
>M4TH

\ NOTE: MENUHANDLE AND MENUREF refer to the same thing
\ apple docs keep changing, it is an abstract REF not a true handle

Extern: void DrawMenuBar   ( void );
Extern: UInt32 menuH  NewMenu ( UInt32 menuId, UInt32 * &title );
Extern: UInt32 menuID:Item# MenuKey     ( UInt32 char );
Extern: UInt32 menuID:Item# MenuSelect  ( UInt32 startPt );
Extern: UInt32 menuH  GetMenuHandle  ( UInt32 menuID );   \ converse of GetMenuID
Extern: UInt32 MenuID GetMenuID 	 ( UInt32 MenuRef );  \ converse of GetMenuHandle

Extern: UInt32 item# MenuEvent 		( UInt32 * EventRecord );
AliasedExtern: _CountMenuItems UInt32 #items CountMenuItems  ( UInt32 menuHandle ) ;
\ Extern: UInt32 #items CountMenuItems  ( UInt32 menuHandle );

Extern: void InsertMenu  ( UInt32 menuH, UInt32 beforeID );
Extern: void AppendMenu  ( UInt32 menuH, UInt32 * &text );
Extern: void DeleteMenu  ( UInt32 menuID );
Extern: void DisposeMenu  ( UInt32 menuHandle );
Extern: void HiliteMenu   ( UInt32 menuID );

Extern: void InsertMenuItem   ( UInt32 menuH, UInt32 * &itemStr, UInt32 after# );
Extern: void DeleteMenuItem   ( UInt32 menuH, UInt32 item# );
Extern: void GetMenuItemText  ( UInt32 menuH, UInt32 item#, UInt32 * &itemStr );
Extern: void SetMenuItemText  ( UInt32 menuH, UInt32 item#, UInt32 * &itemStr );

Extern: void EnableMenuItem  ( UInt32 menuH, UInt32 item# );
Extern: void DisableMenuItem ( UInt32 menuH, UInt32 item# );
Extern: void FlashMenuBar    ( UInt32 menuID );

Extern: void CheckMenuItem  ( UInt32 menuH, UInt32 item#, UInt32 check? );
Extern: void SetItemStyle   ( UInt32 menuH, UInt32 item#, UInt32 style );
Extern: void SetItemMark    ( UInt32 menuH, UInt32 item#, UInt32 char );


Extern: UInt32 OSStatus SetMenuItemCommandKey (
	  UInt32        inMenu,
	  UInt32   		inItem,
	  UInt32        inSetVirtualKey,
	  UInt32        inKey );

Extern: UInt32 OSStatus ChangeMenuItemAttributes ( UInt32 MenuRef, UInt32 inItem, UInt32 setAttrs, UInt32 clearAttrs );
Extern: UInt32 OSErr SetMenuItemModifiers ( UInt32 MenuRef, UInt32 inItem, UInt32 inModifiers );
Extern: UInt32 OSErr SetMenuItemHierarchicalID ( UInt32 inMenu, UInt32 inItem, UInt32 HierID );
Extern: UInt32 menuID:Item# PopUpMenuSelect ( UInt32 MenuRef, UInt32 Top, UInt32 Left, UInt32 Item );
Extern: UInt32 OSErr SetMenuItemCommandID ( UInt32 MenuRef, UInt32 inItem, UInt32 inCommandID );


\ Extern: UInt32 OSStatus SetMenuTitle ( UInt32 MenuRef, UInt32 * title );
AliasedExtern: _SetMenuTitle UInt32 OSStatus SetMenuTitle ( UInt32 MenuRef, UInt32 * title );

: SetMenuTitle ( cString\menuID -- )
	GetMenuHandle ?dup
	IF 
		swap _SetMenuTitle
	ELSE
		drop
	THEN ;


: CountMenuItems  ( menuID -- itemCount )
	GetMenuHandle dup
	IF _CountMenuItems THEN  ;		\ returns 0 if no such menu


: MENU.SELECT  ( point -- item\menu id )
	MenuSelect dup Lo2 swap Hi2Lo ( extend ) ;


: MENU.KEY ( char -- item\menuid )
	MenuKey dup Lo2 swap Hi2Lo ( extend ) ;


: MENU.EVENT ( eventrecord -- item\menuid )
	MenuEvent dup Lo2 swap Hi2Lo  ;  \ 6.045


: (NEW.MENU)  ( position\title$\menu id --  )
				( creates, inserts menu at position)
	swap NewMenu		\ menuId\&title -- handle
	swap InsertMenu		\ handle\beforeID --
;


: (APPEND.ITEMS)  ( item$\menu id -- )
	GetMenuHandle swap AppendMenu ;


: MENU.HANDLE  ( MENU.ID -- MENU.HANDLE )
	GetMenuHandle ;


: MENU.SETUP  ( x\y\menu id -- menu handle\x\y )
	GetMenuHandle -rot ;


: -MENU.HANDLE ( menu id -- handle |or| ABORT if 0 )
	GetMenuHandle
	?dup false=
 	32 r$abort ;		\ " no menu assigned "


: APPEND.ITEMS  ( item$\menu id -- *)
	-menu.handle swap AppendMenu ;


\ special menu stuff:

variable (MENUS)   ( in.heap )
	(menus) off

variable #MENUS		\ xg 12/9/91, needed so cmd keys don't work if no menus
	#menus off

variable LAST.MENU	\ xg 12/9/91, can be use by a system menu handler
	last.menu off


: MAX#MENUS ( -- n )
	(menus) @ handle.size 0 max 4 / 1- ; \ system menu doesn't count


: ALLOT.MENUS ( nn -- install MENUS array as HANDLE )	\ add N -- 6.045
	32 
	max					\ never less than 32 slots
	4 *
	NewHandleClear		\ MakeHandle			\ not locked...
	(menus) !
	#menus off ;


: MENUS ( -- addr | array containing menus)
	(menus) @
	handle? false= 29 R$ABORT	\ abort" Menus not initialized!"
	@ ;


: >MENU  ( index -- addr )  \ index into MENUS array
	MAX#MENUS  min
	0 max				\ all neg. menus go to handler 0
	4 *  menus + ;


: (MENU.SELECTION:)  ( menuid\token -- | token to execute when the menu is pulled down  )
	swap >menu ! ;


: MENU.SELECTION:
	'
	Postpone literal
	Postpone (menu.selection:)
\	flushcaches
;
	immediate


create BEFORE.MENU.EXECUTE 0 ,
\ token should ( item\menu id -- item\menu id |or| item\0 to abort )


: EXECUTE.MENU  ( item\menu id -- | vectors to menu code *)
\	BeforeMenuExecute ExecChain
	before.menu.execute @execute
    dup
	IF	 dup last.menu ! 
		 >menu  @ ?dup
         IF   execute  
         ELSE drop   
         THEN
	ELSE 2drop
	THEN ;


: DELETE.MENU?  ( menu.id -- flag | true if a menu was actually deleted )
	dup menu.handle ?dup
    IF   over DeleteMenu DisposeMenu
         >menu off	true
         -1 #menus +!
    ELSE drop false
	THEN  ;


: DELETE.MENU  ( menu.id -- )
	delete.menu? IF DrawMenuBar THEN  ;


: OFF.MENUS ( -- | turn off any active menus when quitting  )
	0 HiliteMenu
;  	\ quitter LinkLastToken


: NEW.MENU  ( position\title$\menu id -- | does not update menubar )
	\ no check for menu id validity !!!!
	dup delete.menu? drop
    1 #menus +!
	(new.menu) ;


: GET.NEXT.ID  ( menuID -- nextMenuID )  \ get next menu ID in use
    32 OVER 1+
	DO
		I GetMenuHandle
		IF
			drop I LEAVE
		THEN
	LOOP  ;


 : 1stFreeMenu#  ( lowest -- free# | Return smallest free menu id >= lowest )
		\  Normal usage:  10 1stFreeMenu# 
		\  which returns lowest free menu id >= 10
	0
	max#menus rot
	DO
		I Menu.Handle 0=
		IF
			drop I leave
		THEN
	LOOP  ;


: -MENU.SETUP  ( n1\n2\menuID -- menuH\n1\n2 )
	-menu.handle -rot ;


: INS.MENU.ITEM$  ( item$\item#\menu id -- )
	-menu.setup InsertMenuItem ;


: DEL.MENU.ITEM   ( item#\menu id -- )
	-menu.handle swap DeleteMenuItem ;


: SET.ITEM$  ( item\item$\menu id -- )
	-menu.setup SetMenuItemText ;


: GET.ITEM$  ( item\item$\menu id -- )
	-menu.setup GetMenuItemText ;


: ITEM.ENABLE ( ITEM\ENABLE.FLAG\MENU.ID -- )
	-menu.setup IF EnableMenuItem ELSE DisableMenuItem THEN ;


: MENU.ENABLE  ( flag\menu# -- )
    0 -rot  ITEM.ENABLE  DrawMenuBar ;


: ITEM.CHECK ( item\check.flag\menu.id -- )
	-menu.setup CheckMenuItem ;


: ITEM.STYLE ( item\style\menu.id -- )
	-menu.setup SetItemStyle ;


: ITEM.MARK ( item\mark\menu.id -- )
	-menu.setup SetItemMark ;


: SET.ITEM.MODIFIERS ( item\modifer\menu.id -- )
	-menu.setup SetMenuItemModifiers drop ;
(*
	kMenuNoModifiers If no bit is set, only the Command key is used in the
	keyboard equivalent. 
	
	kMenuShiftModifier If this bit (bit 0) is set, the Shift key is used in the
	keyboard equivalent. 
	
	kMenuOptionModifier If this bit (bit 1) is set, the Option key is used in
	the keyboard equivalent. 
	
	kMenuControlModifier If this bit (bit 2) is set, the Control key is used in
	the keyboard equivalent. 
	
	kMenuNoCommandModifier If this bit (bit 3) is set, the Command key is not
	used in the keyboard equivalent. 
*)


: MakeMenuItemDynamic ( item\Key\modifiers\menu.id -- )
\ This allows menu item text to change automatically depending on which
\ modifier key(s) is down
\ See Editor File Menu for example
	-menu.handle
	locals| menuH modifiers cmdKey Item# |
	menuH Item# 0 cmdKey  SetMenuItemCommandKey	    drop
	menuH Item# modifiers SetMenuItemModifiers      drop
	menuH Item# 8 0       ChangeMenuItemAttributes	drop
;


\ menu items draw as --------------- if they have a leading '-'
\ so insert leading space when adding menu item with leading '-'
\ and remove it again when getting the string from a menu
\ Be sure there is enough room for an extra character in the
\  supplied string (using pad or item$ is a good way)
\ See Editor Popup, Project Menu, or Window Lister for examples of use

: FixLeadingDash ( addr -- )
	locals| str |
	str 1+ c@ bl =
	IF
		str c@ 1- str c!
		str count over 1+ 	\ addr\cnt\addr+1
		rot rot cmove
	ELSE
		str 1+ c@ $2D ( dash ) =
		IF
			str count		\ addr\cnt
			over 1+ swap cmove>
			bl str 1+ c!
			str c@ 1+ str c!
		THEN
	THEN
;



: PruneMenuTail ( item#\menu id --  | removes all menu items >= item# ) 
	locals| TheMenu TheItem# |
	TheMenu CountMenuItems 
	BEGIN
		dup
		TheItem# >=
	WHILE
		TheItem# TheMenu del.menu.item
		1-
	REPEAT
	drop
 ;



prune:
\ MENU FORGETTOR - delete menus whose action is in forgotten range
	{: start end | TheFlag -- start end :}
	0 -> TheFlag
	(menus) @ GetHandleSize 4 /
	0 ?DO
		i >menu @ ( token>addr low hi )
	
		start end range nip
		IF
			i delete.menu?
			 TheFlag or -> TheFlag
		THEN
	LOOP
	TheFlag IF DrawMenuBar THEN 		\ only redraw if any menus were deleted!	
	start end
;



StopIncluding ************************************

