\ BASIC CONTROLS
\ Last Revision: 21 Jan 2012  13:56:29  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************



only Forth definitions
>M4TH
decimal


Extern: void ShowControl ( UInt32 theControl );
Extern: void HideControl ( UInt32 theControl );
Extern: void MoveControl  ( UInt32 controlHandle, UInt32 h, UInt32 v );
Extern: void SizeControl  ( UInt32 controlHandle, UInt32 wide, UInt32 high );

Extern: void SetControlValue ( UInt32 ControlRef, UInt32 value );
Extern: void SetControl32BitValue   ( UInt32 ControlRef, UInt32 value );
Extern: void SetControl32BitMinimum ( UInt32 ControlRef, UInt32 value );
Extern: void SetControl32BitMaximum ( UInt32 ControlRef, UInt32 value );

Extern: void SetControlViewSize ( UInt32 ControlRef, UInt32 ViewSize );


Extern: UInt32 value GetControl32BitValue   ( UInt32 ControlRef );
Extern: UInt32 value GetControl32BitMinimum ( UInt32 ControlRef );
Extern: UInt32 value GetControl32BitMaximum ( UInt32 ControlRef );


: SET.CONTROL.32bitRANGE  ( ControlRef\min\max -- )
	locals| CMAX CMIN CHAND |
	chand cmax SetControl32BitMaximum
	chand cmin SetControl32BitMinimum ;


Extern: UInt32 partcode TestControl  ( UInt32 ControlRef, UInt32 localPt );

Extern: void  SetControlTitle  ( UInt32 ControlRef, UInt32 * title$ );

Extern: void  Draw1Control ( UInt32 ControlRef );

Extern: UInt32 OSStatus ActivateControl   ( UInt32 ControlRef );
Extern: UInt32 OSStatus DeactivateControl ( UInt32 ControlRef );
Extern: UInt32 OSStatus SetControlVisibility ( UInt32 ControlRef, UInt32 IsVisible?, UInt32 DoDraw? );
Extern: UInt32 Boolean  IsControlActive  ( UInt32 ControlRef );

Extern: UInt32 OSStatus EnableControl  ( UInt32 ControlRef );
Extern: UInt32 OSStatus DisableControl ( UInt32 ControlRef );

Extern: UInt32 OSStatus  GetControlByID ( UInt32 WindowRef, UInt32 * ^ControlID, UInt32 * ^ControlRef );
Extern: UInt32 WindowRef GetControlOwner ( UInt32 ControlRef );

Extern: UInt32 OSStatus GetControlData ( UInt32 ControlRef, UInt32 PartCode, UInt32 ResType, 
											UInt32 maxSize, UInt32 * ^buffer, UInt32 * ^ActualSize );
Extern: UInt32 OSStatus GetControlDataSize ( UInt32 ControlRef, UInt32 PartCode, UInt32 ResType, 
											UInt32 * ^ActualSize );
Extern: UInt32 OSStatus SetControlData ( UInt32 ControlRef, UInt32 PartCode, UInt32 ResType, 
											UInt32 dataSize, UInt32 * ^data );
AliasedExtern: _GetControlKind  UInt32 OSStatus GetControlKind ( UInt32 WindowRef, UInt32 * ^ControlKind );
\ Extern: UInt32 OSStatus GetControlKind ( UInt32 WindowRef, UInt32 * ^ControlKind );


Extern: UInt32 Boolean  IsValidControlHandle ( UInt32 ControlRef );

Extern: UInt32 RefCon  GetControlReference ( UInt32 ControlRef );
Extern: void   SetControlReference ( UInt32 ControlRef, UInt32 value );


\ SetControlAction very useful for scrollbars in composited windows, like Nibs
Extern: void   SetControlAction ( UInt32 ControlRef, UInt32 ControlActionUPP );
Extern: UInt32 ControlActionUPP NewControlActionUPP ( UInt32 * ControlActionProcPtr );
Extern: void DisposeControlActionUPP	( UInt32 ControlActionUPP );
\ Extern: void InvokeControlActionUPP	( UInt32 ControlRef, UInt32 ControlPartCode, UInt32 ControlActionUPP );


\ see Scientific Calculator demo or Vocab Browser for examples of usage
Extern: UInt32 OSErr SetControlFontStyle ( UInt32 ControlRef, UInt32 * ^FontStyleRec );
(*   from Controls.h
struct ControlFontStyleRec {
  SInt16              flags;
  SInt16              font;
  SInt16              size;
  SInt16              style;
  SInt16              mode;
  SInt16              just;
  RGBColor            foreColor;
  RGBColor            backColor;
};

constants for flags field:
   kControlUseFontMask = 0x0001,
   kControlUseFaceMask = 0x0002,
   kControlUseSizeMask = 0x0004,
   kControlUseForeColorMask = 0x0008,
   kControlUseBackColorMask = 0x0010,
   kControlUseModeMask = 0x0020,
   kControlUseJustMask = 0x0040,
   kControlUseAllMask = 0x00FF,
   kControlAddFontSizeMask = 0x0100
*)




: GetControlRefFromID ( WindowRef\^ControlID -- ControlRef |or| 0 )
	0 >R RP@ GetControlByID
	IF
		r> drop 0
	ELSE
		R>
	THEN
;

: GetControlKind ( ControlRef -- creatorSig\ControlKind |or| 0 )
	0 >R 0 >R RP@ _GetControlKind
	IF
		r> drop r> drop
		0
	ELSE
		R> R>
	THEN
;

 create THIS.CONTROL  0 ,   ( latest control handle )
 create THIS.PART     0 ,   ( latest control part )

   10 constant IN.BUTTON         11 constant IN.CHECKBOX
   20 constant UP.BUTTON         21 constant DOWN.BUTTON
   22 constant PAGE.UP           23 constant PAGE.DOWN
  129 constant IN.THUMB


: LAST.CONTROL  ( -- handle | returns value in THIS.CONTROL  )
    THIS.CONTROL @  ;



: Get.Control.Bounds ( ControlRef -- ^rect )
	ScratchRect GetControlBounds ;


: <DRAW.CONTROL>  ( control handle -- | draw only this control )
                  ( saving & restoring clip rgn of the window  )
    SAVE.CLIP >R
       Get.Control.Bounds ClipRect
       GET.WINDOW @ DrawControls     ( re-display the control)
   R> RESTORE.CLIP ;



: UPDATE.CONTROL  ( [part code] or [0] -- | updates the control)
       ( in the current window whose handle is in THIS.CONTROL,)
    last.control swap HiliteControl ( highlight the part )
    last.control <draw.control>  ;


: TRACK.CONTROL  ( controlRef\point -- flag )
	save.clip >r
		get.window  no.clip
		-1   TrackControl
	r> restore.clip ;


: ?IN.CONTROL (   -- flag | set if in control)
	this.part @  ;


StopIncluding ************************************


