\ MacForth IO
\ Last Revision: 22 Jan 2012  06:59:41  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


((

Old traditional MF words

eventually roll these into a VFX-style console

))

only Forth definitions
>M4TH

decimal



AliasedExtern: _DrawText void  DrawText  ( UInt32 textBuf, UInt32 byteOffset, UInt32 byteCount );
\ : _DrawText DrawText ; 	\ disambiguate for historical reasons

Extern: UInt32 time GetCaretTime ( void );
Extern: UInt32 time GetDblTime   ( void );


\ ****************************************************************
defer (DrawText)	( textBuf\byteOffset\byteCount -- )
defer CNTRL			( ADDR\CNT  --  ADDR'\CNT' )
defer StallCursor	( time -- )
defer DfltKEY		( -- char )
\ ****************************************************************



: DrawText  ( addr\cnt -- )
	0 swap _DrawText ;


: DrawPrintableText  ( addr\cnt --  addr'\cnt' )
					 ( leave residue for CONTROL intrepreter )
	over
	BEGIN				\ addr\cnt\addr2
		over 0>			\ while cnt > 0
						\ addr\cnt\addr2\flag
		over c@ bl >= 	\ and not a control character
		AND
	WHILE				\ while char at addr2 >= BL
		1+ swap 1- swap
	REPEAT				\ addr\cnt-1\addr2+1            \ addr\cnt'\addr'
	\ addr2 now points to 1st control character or end of string
	rot 				\ cnt'\addr'\addr
	2dup -				\ cnt'\addr'\addr\addr'-addr
	0 swap 				\ cnt'\addr'\addr\0\addr'-addr
	
	(DrawText)			\ DEFERred = _DrawText
	swap ;


: SCROLL.UP  ( -- )
	get.window 
	{ theW }
	theW ?wptr 
	IF									\ don't scroll for offscreen windows
		theW @ 

		theW +wcbounds					( window content rectangle)
		0 
		theW +wline.height @ negate		( deltax, deltay)

		2 ( kScrollWindowEraseToPortBackground )
		0
		ScrollWindowRect drop
	THEN
;


: >CR   ( cr in window,  start at pixel #4 within window )
	col off				\	OUT OFF				\ VFX
	get.xform.window 
	?dup
	IF
		+WCBOUNDS 2 + w@
		4 + 
		@pen nip  
		MoveTo
	THEN	
;


: >LF   ( LINE FEED IN WINDOW, SCROLL IF NECESSARY )
	get.window 
	{ theW }
	theW ?wptr 
	IF		\ only worry about scrolling for real MacForth windows
	    @pen  2dup  							\ x\y\x\y
	    theW +wline.height @ + 					\ x\y\x\y+
	    xy>point								\ x\y\newpt
	    theW +wcbounds PtInRect
	    IF
	    	theW +wline.height @ +  MoveTo
	    ELSE  									\ x\y
	    	swap  0 max 
	    	swap  0 max   dup
	        IF
	        	scroll.up 
	        ELSE
	        	theW +wline.height @ + 
	        THEN
	        theW +wcbounds 4 + W@
	        	        
	        3 - MIN ( ALLOW FOR DESCENDER )  MoveTo
	    THEN
	ELSE
		@pen get.xform.window +wline.height @ +  MoveTo
	THEN ;

	
: >PAGE ( -- CLR SCREEN )
	col off
	out off				\ VFX
	save.clip >r
	coord.bounds eraserect
	r> restore.clip
	get.window ?wptr IF get.window show.controls THEN
	4  get.xform.window +wline.height @ 2 +  MoveTo  ;


: >BS		( BS, STRIKE.OVER )
	@pen 
	get.xform.window +WLINE.HEIGHT @  
	BL CharWidth 
	col @
	locals| column BlWidth BlHeight  y x |
	column 0>
	if   x BlWidth  -  y MoveTo  			\ backup
	then
	@pen  blheight dup 4 /  - -   swap
	2dup  blheight dup 4 / +  blwidth  +point
	tlbr>ScratchRect  EraseRect  
	-1 col +! ;		\ erase char, bump col


: >TAB
	  echo 4 + c@ col @ over mod - spaces ;


0 value OtherCntrl			\ add OtherCntrl -- 6.047


: >CRLF
	>cr  >lf ;


defer LFEmit   ' >crlf is LFEmit
defer CREmit   ' >crlf is CREmit


: (CNTRL) ( ADDR\CNT  --  ADDR\CNT )
			\ Output control characters
			\ note:  we only get here if DrawPrintableText detects control chars
	OVER C@
	LOCALS|  CHAR CNT ADDR |
	BEGIN
		CHAR
      	CASE
				13 OF  CREmit	ENDOF
	         	10 OF  LFEmit	ENDOF
			\	13 OF  >CR  >LF	ENDOF
	        \ 	10 OF			ENDOF
				 9 OF  >TAB		ENDOF
     			 8 OF  >BS		ENDOF
				 7 OF  BEEP		ENDOF
            	12 OF  >PAGE	ENDOF
            	OtherCntrl ?dup IF emit THEN			\ 6.047
         ENDCASE

		-1 +to CNT 1 +to ADDR
		ADDR C@ TO CHAR
        CHAR BL >= 
        CNT  0 <= 
        OR
   UNTIL
   ADDR CNT 
   pause
 ;


: .TYPE  ( ADDR\CNT  --  )
	0 MAX
	BEGIN
		do.io.events
		DrawPrintableText dup 
		IF
			cntrl 
		THEN dup 0=
	UNTIL
	2DROP ;



: (WRITE)	( addr\cnt\fileid -- #written )
	\ write window intercept hook 				\ probably should factor
	dup -1 <>
	IF
    	dup ?wptr 						\ window protect into DrawPrintableText
		IF  @window.pair >r >r
			(window)
			dup >r .type  r>
	    	r> r> !window.pair
			\ r>drop   ( drop hook return)
		ELSE
			FileWrite
		THEN
	ELSE										\ outfile = -1 ==> .TYPE
		drop dup >r .type
		r> \  r>drop   							( drop hook return)
	THEN  ;




\ mac specific console input operations
\

: ?KEYSTROKE  ( -- [key\true] or [false]  *)
	key.stroke @
	dup
	IF	key.stroke
		\ " ?keystroke" DebugStr
		\ 7 + c@  
		4 + c@  
		swap
		key.stroke off
	THEN   ;


create CURSOR.CHAR  
hex
	04 w,				\ font  default monaco
	5f w,				\ char  default _
decimal



\ 1 value WNE.SLEEPTIME.KEY

: DfltStallCursor ( time -- )
\ this lowers the frequency of DO.EVENTS called for null events
\ when in SYS.WINDOW
	{ the.Time }
	BEGIN
		pause
		\ event.record  events @ -1 and
		event.record  events @ $FFFF:FFBF and   ( exclude update events)
		?event ( uses _EventAvail )
		TickCount the.time U>  or
		false=
	WHILE
		pause
		do.events drop
(( 
		can.sleep @
		IF
			0 
			Event.Record
			WNE.SLEEPTIME.KEY
			0
			WaitNextEvent ( mask\^eventrecord\sleep\mousergn -- eventcode )
			drop
		THEN
 ))
	REPEAT ;


: INVERT.INSERTION.CHAR ( -- )
	get.textmode >R
	get.textfont >R
	srcxor         TextMode			\ inverts character
	cursor.char w@ TextFont
	@pen
	cursor.char 2 + w@ DrawChar
	MoveTo
	R> TextFont
	R> TextMode
;


: FLASH.CURSOR ( -- | Invert cursor, delay count or any event )
	switched.out? @  IF exit THEN
	invert.insertion.char
	GetCaretTime TickCount + 
	StallCursor
;


: ansKEY? ( -- flag )
	span @ >r
\	wne.sleeptime >r
\	wne.sleeptime.key to wne.sleeptime
	do.events  drop	
	key.stroke @ boolean
\	r> to wne.sleeptime
	r> span !
;

: Dflt?TERMINAL   ( -- flag | handles window input )
    infile @ ?wptr
	IF	 ansKEY?
	ELSE Prim?terminal
	THEN	;


: ansKEY  ( -- char | handles window output )		\ 5.2
	BEGIN
		ansKEY?
	UNTIL
	?keystroke   drop ;


: <DfltKEY  ( -- char | handles window output )
	infile @ ?wptr
	IF
		BEGIN
			ansKEY?  FALSE=			 			
		WHILE
			flash.cursor 
			flash.cursor
		REPEAT
		?keystroke   drop
	ELSE PrimKey
	THEN    ;
	


\ ****************************************************************

' _DrawText			is (DrawText)
' (CNTRL)			is CNTRL
 ' (write)			IS DfltWRITE
' DfltStallCursor	is StallCursor
' <DfltKEY			is DfltKEY


' Dfltkey 			dflt.con 24 + !			\ KEY
' Dflt?terminal 	dflt.con 12 + !			\ ?TERMINAL



StopIncluding 
************************************************************************
************************************************************************

