\ Navigation Services
\ Last Revision: 22 Jan 2012  07:04:32  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>M4TH
decimal



Extern: UInt32 NavEventUPP NewNavEventUPP ( UInt32 NavEventProcPtr );
	\ proc gets called with:  ( NavEventCallbackMessage\callBackParms\&callBackUD -- )

Extern: void  DisposeNavEventUPP  ( UInt32  NavEventUPP );

Extern: UInt32 OSErr AEGetNthDesc ( UInt32 * theAEDescList, UInt32  index, UInt32 desiredDescType,
								 		UInt32 * theAEKeyword, UInt32 * AEDesc );

Extern: UInt32 OSErr NavGetDefaultDialogOptions ( UInt32 * NavDialogOptions  );
Extern: UInt32 OSErr NavDisposeReply ( UInt32 * NavReplyRecord );

Extern: UInt32 OSErr NavCompleteSave  ( UInt32 * NavReplyRecord, UInt32 NavTranslateOptions );
\		( NavReplyRecord *translateInfo, NavTranslateOptions howToTranslate  );
\ Extern: UInt32 OSErr NavPutFile  ( UInt32 * defaultLocation, UInt32 * reply, UInt32 * dialogOptions,
AliasedExtern: _NavPutFile UInt32 OSErr NavPutFile  ( UInt32 * defaultLocation, UInt32 * reply, UInt32 * dialogOptions,
					UInt32 * NavEventUPP, UInt32 fileType, UInt32 fileCreator, UInt32 * callBackUD );
			( AEDesc *defaultLocation, NavReplyRecord *reply, NavDialogOptions *dialogOptions, 
				NavEventUPP eventProc, OSType fileType, OSType fileCreator, void *callBackUD )
\ Extern: UInt32 OSErr NavChooseFile  ( UInt32 * defaultLocation, UInt32 * reply, UInt32 * dialogOptions,
AliasedExtern: _NavChooseFile UInt32 OSErr NavChooseFile  ( UInt32 * defaultLocation, UInt32 * reply, UInt32 * dialogOptions,

		UInt32 * NavEventUPP, UInt32 NavPreviewUPP, UInt32 NavObjectFilterUPP, UInt32 NavTypeListHandle, UInt32 * callBackUD );
			( AEDesc *defaultLocation, NavReplyRecord *reply, NavDialogOptions *dialogOptions, 
				NavEventUPP eventProc, NavPreviewUPP previewProc, NavObjectFilterUPP filterProc, 
				  NavTypeListHandle typeList, void *callBackUD )
\ Extern: UInt32 OSErr NavGetFile  ( UInt32 * defaultLocation, UInt32 * reply, UInt32 * dialogOptions,
AliasedExtern: _NavGetFile UInt32 OSErr NavGetFile  ( UInt32 * defaultLocation, UInt32 * reply, UInt32 * dialogOptions,
		UInt32 * NavEventUPP, UInt32 NavPreviewUPP, UInt32 NavObjectFilterUPP, UInt32 NavTypeListHandle, UInt32 * callBackUD );
				\ same as NavChooseFile



: NavChooseFile  ( overload to protect grafport )
	getport dup >R
	    GetPortTextFont	\ get current font
	r@ GetPortTextSize		\ get current font size
	r@ GetPortTextMode		\ get current textmode
	r@ GetPortTextFace		\ get current textface (style)
	r>
	locals| wasPort wasFace wasMode wasSize wasFont |
	_NavChooseFile
	wasPort <SetPort
	wasFont TextFont
	wasSize _TextSize
	wasMode TextMode
	wasFace TextFace ;


: NavGetFile  ( overload to protect grafport )
	getport dup >R
	    GetPortTextFont	\ get current font
	r@ GetPortTextSize		\ get current font size
	r@ GetPortTextMode		\ get current textmode
	r@ GetPortTextFace		\ get current textface (style)
	r>
	locals| wasPort wasFace wasMode wasSize wasFont |
	_NavGetFile
	wasPort <SetPort
	wasFont TextFont
	wasSize _TextSize
	wasMode TextMode
	wasFace TextFace ;


: NavPutFile  ( overload to protect grafport )
	getport dup >R
	    GetPortTextFont	\ get current font
	r@ GetPortTextSize		\ get current font size
	r@ GetPortTextMode		\ get current textmode
	r@ GetPortTextFace		\ get current textface (style)
	r>
	locals| wasPort wasFace wasMode wasSize wasFont |
	_NavPutFile
	wasPort <SetPort
	wasFont TextFont
	wasSize _TextSize
	wasMode TextMode
	wasFace TextFace ;



structure AEDescRecord
	long:		+AEDescType		\ descriptorType: {type of data being passed}
	handle: 	+AEDescHandle	\	{handle to data being passed}
structure.end


EvenStructures @  EvenStructures ON
structure NavReplyRecord
	short:	+NRversion
	byte:	+NRvalidRecord
	byte:	+NRreplacing
	byte:	+NRisStationery
	byte:	+NRtranslationNeeded
  8 bytes:	+NRselection			\ AEDescList
(*
    For a file-opening or file-choosing dialog, this is an Apple event
	descriptor list (AEDescList) containing references to items selected by
	the user.  Navigation Services creates this list, which is
	automatically disposed of when your application calls the
	NavDisposeReply function.  Some dialogs may return one or more items;
	you can determine the number of items in the list by calling the Apple
	Event Manager function AECountItems.  Each selected HFS file object is
	described in an AEDesc structure of type 'typeFSS' or 'typeFSRef'.  You
	can coerce this descriptor into a file reference to perform operations
	such as opening the file.  If you use one of the Carbon-compliant
	dialog creation functions described in Choosing Files, Folders and
	Volumes and Saving Files, the descriptor is of type 'typeFSS' on Mac
	OS 8 or 9; on Mac OS X systems, this descriptor is of type
	'typeFSRef'. File-saving dialogs always return a single descriptor in
	the list.  If you use the NavCreatePutFileDialog function, this
	descriptor specifies the directory where the file is to be saved.  You
	can obtain the name for the save file from the saveFileName field. 
*)
	short:	+NRkeyScript			\ ScriptCode
	long:	+NRfileTranslation		\ FileTranslationSpecArrayHandle
	long:	+NRreserved1
	long:	+NRsaveFileName				\ 6.05432 CFStringRef 
(*
    If the reply record is filled out by a dialog created with the
	NavCreatePutFileDialog function, this field contains a string specifying 
	the name of a file to be saved.  This field contains the entire name of 
	the file, regardless of whether or not any file extension is visible to 
	the user.  You can identify the directory in which the file is to be saved
	by checking the selection field.
	This field was added in structure version 1. 
*)	
	byte:	+NRsaveFileExtensionHidden	\ 6.05432
	byte:	+NRreserved2				\ 6.05432
  225 bytes: +NRreserved				\ 6.05432
structure.end
EvenStructures !	\ size = 256


structure NavDialogOptions
	short:	+NDversion
	long:	+NDdialogOptionFlags
	Point:	+NDlocation
255 string:	+NDclientName
255 string:	+NDwindowTitle
255 string:	+NDactionButtonLabel
255 string:	+NDcancelButtonLabel
255 string:	+NDsavedFileName
255 string:	+NDmessage
	long:	+NDpreferenceKey
	Handle: +NDpopupExtension
494 bytes:	+NDreserved
structure.end	\ size = 2048



0 value NDoptions
0 value NDFSSpec
0 value NRRecord			\ holds address of generic NavReplyRecord

: InitNavigationRecords ( -- )		\ do this at startup
	NavReplyRecord   NewPtrClear to NRRecord
	NavDialogOptions NewPtrClear to NDoptions
	FSSpecRecord     NewPtrClear to NDFSSpec
;



(*
AEDesc					RECORD 0
descriptorType			 ds.l	1				; offset: $0 (0)
dataHandle				 ds.l	1				; offset: $4 (4)
sizeof					 EQU *					; size:   $8 (8)
*)

Extern: UInt32 OSErr AEDisposeDesc	( UInt32 * &theAEDesc );
Extern: UInt32 OSErr AECreateDesc   ( UInt32 typeCode, UInt32 * ^data, UInt32 size, UInt32 * &theAEDesc );


ascii fss_  constant typeFSS
create NRAEKeyword 	0 ,
create NRAEDesc    	AEDescRecord allot&erase	


0 value NavPrefKey			\ one-shot
0 value NavDefaultLocation	\ address of AEDesc of defaultLocation
\ $00020007 value NavOptionFlags		\ ???one-shot
$00000007 value NavOptionFlags		\ ???one-shot
\	kNavNoTypePopup				= 0x00000001,	/* don't show file type/extension popup on Open/Save */
\	kNavDontAutoTranslate		= 0x00000002,	/* don't automatically translate on Open */
\	kNavDontAddTranslateItems	= 0x00000004,	/* don't add translation choices on Open/Save */
\   kNavPreserveSaveFileExtension = 0x00020000
(*
typedef UInt32 NavDialogOptionFlags;
enum {
   kNavDefaultNavDlogOptions = 0x000000E4,
   kNavNoTypePopup = 0x00000001,
   kNavDontAutoTranslate = 0x00000002,
   kNavDontAddTranslateItems = 0x0000.0004,
   kNavAllFilesInPopup = 0x00000010,
   kNavAllowStationery = 0x00000020,
   kNavAllowPreviews = 0x00000040,
   kNavAllowMultipleFiles = 0x00000080,
   kNavAllowInvisibleFiles = 0x00000100,
   kNavDontResolveAliases = 0x00000200,
   kNavSelectDefaultLocation = 0x00000400,
   kNavSelectAllReadableItem = 0x00000800,
   kNavSupportPackages = 0x00001000,
   kNavAllowOpenPackages = 0x00002000,
   kNavDontAddRecents = 0x00004000,
   kNavDontUseCustomFrame = 0x00008000,
   kNavDontConfirmReplacement = 0x00010000,
   kNavPreserveSaveFileExtension = 0x00020000
};
*)


: PSTRCPY ( src\dest -- )
	over c@ 1+ cmove ;


: ?PSTRCPY ( src\dest -- | copy only if both are non-0)
	2dup AND
	IF
		over c@ 1+ cmove
	ELSE
		2drop
	THEN ;


: CompleteNavSave ( &reply -- OSerr )	\ ?? ( &reply --  )
	locals| theReply |
	theReply +NRvalidRecord c@
	IF
		theReply 0 ( kNavTranslateInPlace ) NavCompleteSave	drop \ check for non-0 result
		theReply NavDisposeReply 								drop \ check for non-0 result
		-1 theReply +NRvalidRecord c!	\ 6.0.2a1
	THEN
;


: InitializeNDoptions ( client$\title$\action$\cancel$\message$\filename$ -- )
	6 needed
	NDoptions  NavDialogOptions erase
	NDoptions  NavGetDefaultDialogOptions		 drop \ check for non-0 result ??
	NDoptions +NDsavedFileName ?pstrcpy
	NDoptions +NDmessage ?pstrcpy
	NDoptions +NDcancelButtonLabel ?pstrcpy
	NDoptions +NDactionButtonLabel ?pstrcpy
	NDoptions +NDwindowTitle ?pstrcpy
	NDoptions +NDclientName ?pstrcpy
	NavPrefKey	   NDoptions +NDpreferenceKey !			\ set one shot
	NavOptionFlags NDoptions +NDdialogOptionFlags !		\ set one shot
;


: (NavPutFile)  (( callbackData\Type\Creator\&reply\...
 				...\ client$\title$\action$\cancel$\message\filename$\NavEventProcPtr -- OSErr ))
	11 needed
	>R					\ NavEventProcPtr
	InitializeNDoptions ( client$\title$\action$\cancel$\message$\filename$ -- )
	R>					\ NavEventProcPtr

	0
	locals| NavEventUPP  NavEventProcPtr theReply theCreator TheType callbackData |

	NavEventProcPtr  dup IF NewNavEventUPP THEN -> NavEventUPP
	NavDefaultLocation theReply NDoptions  NavEventUPP  TheType  
		theCreator  callbackData
	NavPutFile ?dup 0=
	IF
		theReply +NRvalidRecord c@
		IF
			theReply +NRselection
			1
			typeFSS
			NRAEKeyword
			NRAEDesc
			AEGetNthDesc 0=	\ no error
			IF	\ should we check the actual NRAEKeyword == typeFSS ??
				\ copy fs spec
				NDFSSpec  FSSpecRecord erase
				NRAEDesc +AEDescHandle @@  NDFSSpec  FSSpecRecord  BlockMove
				0	\ return if no error
			ELSE
				-2
			THEN
		ELSE
			-1 \	 invalid record
		THEN
		0 -> NavPrefKey				\ make this a one-shot
		0 -> NavDefaultLocation		\ make this a one-shot
	THEN
	theReply +NRvalidRecord c@ >R
	theReply  CompleteNavSave
	R> theReply +NRvalidRecord c!
	NavEventUPP ?dup  IF  DisposeNavEventUPP	( NavEventUPP --  )  THEN
;



\ aliases - old names historical 

: NavReplyOK?		( -- OK? )			NRRecord +NRvalidRecord c@ boolean ;
: ReplyOK?			( -- OK? )			NavReplyOK? ;
\ : ReplyType		( -- fileType )		NRRecord 2 + @ ;
: NavReplySpec		( -- &spec )		NDFSSpec ;
: NavReplyVolume	( -- VolRefNum )	NDFSSpec +FSSvRefNum w@s ;
: NavReplyDir		( -- dirID )		NDFSSpec +FSSparID     @ ;
: NavReplyName		( -- namePtr )		NDFSSpec +FSSname ;
: REPLY ( -- addr )  NRRecord ;	
: ClearReply  ( -- )  
	reply NavReplyRecord erase ;



: SetVolDirToNav ( -- )
	NavReplyVolume	volref# ! 
	NavReplyDir		ioDir !
;



Extern: UInt32 NavObjectFilterUPP NewNavObjectFilterUPP	( UInt32 NavObjectFilterProcPtr );
	\ proc gets called with:  ( ^AEDesc, ^info, ^callBackUD, filterMode)

Extern: void DisposeNavObjectFilterUPP	( UInt32 NavObjectFilterUPP  );



(*
	struct NavTypeList {
		OSType 							componentSignature;
		short 							reserved;
		short 							osTypeCount;
		OSType 							osType[1];
	};
*)

: MakeNavTypeListHandle ( &list\numtypes -- handle )
	dup 0= IF 2drop 0 exit THEN
	dup 4 *   8 + from.heap
	locals| theHand numTypes &list |
	theHand lock.handle				\ ??????
	ascii **** 
	theHand @ !			\ componentSignature = kNavGenericSignature
	0 theHand @ 4 + w!
	numTypes theHand @ 6 + w!
	&list theHand @ 8 + numTypes 4 * move
	theHand
;

