\ APPLE EVENTS
\ adapted from original code supplied by George Furnival
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>M4TH
decimal



ascii aevt constant kCoreEventClass
ascii oapp constant kAEOpenApplication
ascii odoc constant kAEOpenDocuments
ascii pdoc constant kAEPrintDocuments
ascii quit constant kAEQuitApplication
ascii rapp constant kAEReopenApplication	\ 6.05435 - received a dock icon click

ascii miss constant keyMissedKeywordAttr
\ lacking typeFSS	ascii fss_ constant typeFSS
ascii list constant typeAEList
ascii **** constant typeWildCard
ascii ---- constant keyDirectObject

-1701 constant errAEDescNotFound 
-1708 constant errAEEventNotHandled
-1717 constant errAEHandlerNotFound

Extern: UInt32 OSerr AEInstallEventHandler ( UInt32 theAEEventClass, UInt32 theAEEventID, UInt32 handler, UInt32 handlerRefcon, UInt32 isSysHandler);
AliasedExtern:  _AEGetEventHandler  UInt32 OSerr AEGetEventHandler ( UInt32 theAEEventClass, UInt32 theAEEventID, UInt32 * &handler, UInt32 * &handlerRefcon, UInt32 isSysHandler );
\ Extern: UInt32 OSerr AEGetEventHandler ( UInt32 theAEEventClass, UInt32 theAEEventID, UInt32 * &handler, UInt32 * &handlerRefcon, UInt32 isSysHandler );
Extern: UInt32 OSerr AERemoveEventHandler ( UInt32 theAEEventClass, UInt32 theAEEventID, UInt32 * handler, UInt32 isSysHandler );
Extern: UInt32 OSerr AEGetAttributePtr	 ( UInt32 * &theAppleEvent, UInt32 theAEKeyword, UInt32 desiredType, UInt32 * &typeCode, UInt32 dataPtr, UInt32 maximumSize, UInt32 * &actualSize );
Extern: UInt32 OSerr AEGetParamDesc ( UInt32 * &theAppleEvent, UInt32 AEKeyword, UInt32 desiredType, UInt32 * &result );
Extern: UInt32 OSerr AECountItems ( UInt32 * &theAEDescList, UInt32 * &theCount );
Extern: UInt32 OSerr AEGetNthPtr ( UInt32 * &theAEDescList, UInt32 index, UInt32 desiredType, UInt32 * &theAEKeyword, UInt32 * &typeCode, UInt32 * dataPtr, UInt32 maximumSize, UInt32 * &actualSize );
Extern: UInt32 OSerr AEProcessAppleEvent ( UInt32 * &theEventRecord );



: AEGetEventHandler ( kCoreEventClass\EventID -- [handler\noErr] or [error] )
	0 >R RP@ 
	0 >R RP@ false _AEGetEventHandler	\ AEGetEventHandler 
	R> drop R> swap
	dup 0<> IF nip THEN ;



\ ----- high-level AppleEvent Handling -----

defer AEDEFERREDACTION	\ for deferred handling of an AE

0 value THEAPPLEEVENT	\ addr of current AppleEvent
0 value AEREPLY			\ addr of current reply AppleEvent
0 value AEERR			\ current AppleEvent error code


: GotRequiredParams? ( -- flag )
	0 0 locals| dum err |
	theAppleEvent keyMissedKeywordAttr
	typeWildCard 
	0 >R rp@		\ returned type
	0 0	
	0 >R rp@		\ data ptr, size returned size
	AEGetAttributePtr dup to err
	R> drop R> drop
	errAEDescNotFound = 
	IF 
		 0 
	ELSE
		err 0 =
		IF   errAEEventNotHandled
		ELSE err
		THEN 
	THEN
	dup -> aeErr false= ;




: GeneralAppleEventHandler  ( theappleEvent\reply\refcon --- OSerr )
\ typedef CALLBACK_API( OSErr , AEEventHandlerProcPtr )(const AppleEvent *theAppleEvent, AppleEvent *reply, UInt32 handlerRefcon) ;

	0    -> aeErr
	swap -> aeReply
	swap -> theAppleEvent
	execute							\ call user's MacForth handler
	aeErr ;


Extern: UInt32 AEEventHandlerUPP NewAEEventHandlerUPP	( UInt32 AEEventHandlerProcPtr );
Extern: UInt32 AEIdleUPP    NewAEIdleUPP			( UInt32 AEIdleProcPtr );
Extern: UInt32 AEFilterUPP  NewAEFilterUPP		( UInt32 AEFilterProcPtr );

Extern: void DisposeAEEventHandlerUPP	( UInt32 AEEventHandlerUPP );
Extern: void DisposeAEIdleUPP			( UInt32 AEIdleUPP );
Extern: void DisposeAEFilterUPP			( UInt32 AEFilterUPP );



3 0  CALLBACK: AEHandlerProcPtr
' GeneralAppleEventHandler to-callback AEHandlerProcPtr

0  value AEHandlerUPP


: Install.AE ( -- )
	AEHandlerUPP false=		\ only do it once
	IF
		AEHandlerProcPtr  NewAEEventHandlerUPP -> AEHandlerUPP		\
	THEN  ;
\	restorer linklasttoken


: DISPOSE.AE ( -- )
	AEHandlerUPP								\ only do it once
	IF
		AEHandlerUPP  DisposeAEEventHandlerUPP	\ 
		0 -> AEHandlerUPP
	THEN
;
presnapshot linklasttoken
\ ' DISPOSE.AE AtExit
\ exodus linklasttoken


: (HANDLED.BY)  ( class\EventID\token -- )
	0 locals| err handlerToken ID class |
	class ID AEGetEventHandler dup to err false=
	IF  class ID rot false AERemoveEventHandler to err THEN
	err errAEHandlerNotFound = 
	err 0= or
	IF class ID AEHandlerUPP HandlerToken false AEInstallEventHandler to err THEN
	err abort" AppleEvent handler not installed" ;


: HANDLED.BY  ( <name> class\EventID -- )
	'
	compiling 
	IF
		Postpone literal 
		Postpone (handled.by)
	ELSE
		 (handled.by)
	THEN ; IMMEDIATE


: REMOVE.HANDLER  ( class\id -- )
	AEHandlerUPP false AERemoveEventHandler 
	abort" unable to remove handler" ;


: >HIGHLEVELEVENTS ( event -- event )
	['] noop is aeDeferredAction
	event.record high.level.event.record 2 + 16 move
	event.record AEProcessAppleEvent drop	\ calls our handler
											\ the handler sets aeDeferredAction
	['] aeDeferredAction 
	catch  							\  improve error recovery
	IF 
		high.level.event.record off
		'AbortText @ ?dup false=
		IF
			c" >HIGHLEVELEVENTS Error" 'AbortText !
		THEN 
		-2 throw
((		err.msg count ?dup false=
		IF
			drop s" >HIGHLEVELEVENTS Error" 
		THEN 
		abort$
))
	THEN

	high.level.event.record off		\ allow more high level events to come in
;



\ ensure that we clean up after a user ABORT that might
\ occur (due to IO.EVENTS) during printing multiple
\ documents, for example.

: QUIT.AEHandlers ( -- )
	high.level.event.record 18 erase ;
\ quitter LinkLastToken


variable SFPDirSet
	SFPDirSet OFF

defer AEOpenApp  ( -- )
defer AEOpenFile  ( vRefNum\dirID\name$ -- )
defer AEPrintFile  ( vRefNum\dirID\name$ -- )
defer AEQuitApp  ( -- )
defer AEReOpenApp  ( -- )	\ 6.05435 - received a dock icon click

\ lacking 3drop  : 3drop ( x1\x2\x3 -- )  drop 2drop ;

' noop  IS AEReOpenApp
' noop  IS AEOpenApp
' 3drop IS AEOpenFile	\ so stack stays balanced
' 3drop IS AEPrintFile	\ so stack stays balanced
' bye   IS AEQuitApp



: ReOpenApplicationHandler ( -- )	\ 6.05435 - received a dock icon click
	GotRequiredParams?
	IF
		['] AEReOpenApp is aeDeferredAction
	THEN ;


0 value DidAEOPENAPP?

: OpenApplicationHandler ( -- )
	GotRequiredParams?
	IF
		SFPDirSet ON	\ use default SFP dir
		['] AEOpenApp is aeDeferredAction
		true -> DidAEOPENAPP?	\ Lion may not use this if set to restore windows
	THEN ;



: QuitApplicationHandler ( -- )
	GotRequiredParams?
	IF
\		ownPrint get	\ make sure printing has finished
		high.level.event.record @			 	\ 6.044
		\ !!!!!!!!!!!! NOTE !!!!!!!!!!!
		\ OSX Application Menu Quit calls our handler directly without an AE
		IF
			['] AEQuitApp is aeDeferredAction 
		ELSE
\			AEQuitApp	\ 6.04998
		\ Doing AEQuitApp can be a problem on OS X if done here, since we
		\ are inside a UPP.  If user Cancels during FILE.CHECK then we do
		\ not exit the UPP properly and leave some registers mangled
\			['] AEQuitApp SpecialPauseAction ! 		\ 6.04998

\			event.filter @ wasEvent.Filter !
\			['] delayedbye Event.Filter !
			['] AEQuitApp SpecialEventAction !
			['] AEQuitApp is aeDeferredAction 

		THEN 
	THEN 
;




0 value #AEOpens

: OpenMyFile ( -- )  \ reply not same as reply from standard file
	NRRecord  w@s	  \ volref#
	NRRecord 2 + @	  \ ioDir
	NRRecord 6 +  	  \ name$

\ Lion may try and open our application as a file
\ since SYS.WINDOW has a proxy icon
\ to our app, so Lion thinks we want to open it in the editor
	3dup
	count MyNameBuffer count istr= 0=
	swap  MyIODir <>   OR
	swap  MyVolRef# <> OR

	IF
		AEOpenFile		\ default will be SE.AEOPENFILE
		1 +to #AEOpens
	ELSE
		c" AEOpenFile skipped " MyNameBuffer SysLogMsg2
		3drop
	THEN ;

	
\ slight modification of PRINT... will serve as PrintMyFile
: PrintMyFile ( -- )
	NRRecord w@s 			\ VolRef# !
	NRRecord 2 + @			\ ioDir !
	NRRecord 6 + AEPrintFile
;


create DOCLIST  0 , 0 ,

: CLEAR.DOCLIST ( -- )
	docList @
	IF  docList AEDisposeDesc drop
		docList 8 erase
	THEN
;

: Open/PrintDocuments  ( -- )  \ uses descriptor in docList
	0 0 0 0 0 0 locals| #items index vkey vtype vsize err |
	0 -> #AEOpens
	docList
	0 >R rp@
	AECountItems dup to err false= R> -> #items
	IF	\ get file system specification record for each file
		BEGIN
			#items index > 
			err false= 
			and
		WHILE
			NRRecord 74 erase
			1 +TO index
			docList			\ list to be searched
			index			\ index
			typeFSS			\ desired type of items in list
			0 >R rp@		\ returns keywd for keywd-specified descriptor 
			0 >R rp@		\ actual type of items in list
			NRRecord		\ reply record - vol word, dirID long, name$
			NavReplyRecord	\ length of reply record
			0 >R rp@		\ returns actual length of reply
			AEGetNthPtr dup to err false= 
			R> -> vsize 
			R> -> vtype 
			R> -> vkey
			IF  high.level.event.record 12 + @ kAEOpenDocuments = \ eventID is in where field
				IF ['] OpenMyFile ELSE ['] PrintMyFile THEN
				catch
				IF 
					clear.doclist
					high.level.event.record off
					'AbortText @ ?dup false=
					IF
						c" >HIGHLEVELEVENTS Error" 'AbortText !
					THEN 
					-2 throw
					
				((	err.msg count ?dup not
					IF
						drop s" Open/PrintDocuments Error" 
					THEN
					abort$
				))
				THEN
			THEN
		REPEAT
	THEN
 	clear.doclist
	#AEOpens 0=
	DidAEOPENAPP? 0=
	AND
	IF		\ simulate kAEOpenApplication on Lion
		AEOpenApp
	THEN
;


: Open/PrintDocumentsHandler ( -- )
	docList 8 erase
	theAppleEvent keyDirectObject typeAEList docList
	AEGetParamDesc dup to aeErr false=		\ get list of documents in docList
	IF	GotRequiredParams?				\ is that all?
		IF   ['] Open/PrintDocuments is aeDeferredAction
		ELSE clear.doclist
		THEN
	THEN ;



: InstallCoreAEventHandlers  ( -- )
	Install.AE
	false -> DidAEOPENAPP?
	SFPDirSet OFF	\ set by first 'oapp' or 'odoc' event
	kCoreEventClass kAEOpenApplication 		HANDLED.BY OpenApplicationHandler
	kCoreEventClass kAEOpenDocuments   		HANDLED.BY Open/PrintDocumentsHandler
	kCoreEventClass kAEPrintDocuments  		HANDLED.BY Open/PrintDocumentsHandler
	kCoreEventClass kAEQuitApplication		HANDLED.BY QuitApplicationHandler
	kCoreEventClass kAEReopenApplication	HANDLED.BY ReOpenApplicationHandler  	\ 6.05435

	high.level.event.record off		\ allow HLE's to come in
	['] >HighLevelEvents high.level.event >event !
	true  -> core.ae.handled? 
;
PRELUDES linklasttoken


: RemoveCoreAEventHandlers  ( -- )
	kCoreEventClass kAEOpenApplication REMOVE.HANDLER
	kCoreEventClass kAEOpenDocuments   REMOVE.HANDLER
	kCoreEventClass kAEPrintDocuments  REMOVE.HANDLER
	kCoreEventClass kAEQuitApplication REMOVE.HANDLER
	kCoreEventClass kAEReopenApplication REMOVE.HANDLER
	
	['] pause high.level.event >event !
	false -> core.AE.handled?
;
	
\ on.forget RemoveCoreAEventHandlers


\ InstallCoreAEventHandlers


\ ensure that we clean up after a user ABORT that might
\ occur (due to IO.EVENTS) during printing multiple
\ documents, for example.

: QUIT.AECoreHandlers ( -- )
	clear.doclist
	high.level.event.record 18 erase ;

quitter LinkLastToken


: NoOpenApp
	c" open App AE" GiveNotice
;

' NoOpenApp is AEOpenApp

: NoOpen
	3drop
	c" open file AE" GiveNotice
;

' NoOpen is AEOpenFile



StopIncluding ************************************
