\ Color Picker and RGB Colors
\ Created:       02/22/03  03:04:40 PM  wjm
\ Last Revision: 12 Feb 2012  08:22:15  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>M4TH

decimal



Extern:  void  RGBForeColor ( UInt32 * ^color  );
Extern:  void  GetForeColor ( UInt32 * ^color  );
Extern:  void  RGBBackColor ( UInt32 * ^color  );
Extern:  void  GetBackColor ( UInt32 * ^color  );
Extern:  void  GetCPixel    ( UInt32 x, UInt32 y, UInt32 * ^color );
Extern:  void  SetCPixel    ( UInt32 x, UInt32 y, UInt32 * ^color );


Extern: UInt32 flag GetColor ( UInt32 point, UInt32 * prompt$, UInt32 * inColor, UInt32 * outColor );
	\ while technically marked "obsolete" by Apple, this is still in Carbon and
	\ 	is the simplest way to present a color picker for the user
	\ point = 0, centers, else coordinates of top/left of dialog
	\ incolor  = starting color
	\ outcolor = selected color
	\ flag true if user did NOT cancel



(*
	TYPE RGBColor = 
	RECORD
		red: 	Integer;		{red component}
		green:	Integer;		{green component}
		blue:	Integer;		{blue component}
	END;
*)


: RGBColor ( r/g/b -- )		\ creates a RGB color word
	create rot w, swap w, w, ;


: !RGB ( r\g\b\addr -- )
	dup >R
	4 + w!
	r@ 2 + w!
	r> w! ;


: @RGB ( addr -- r\g\b )
	dup >R
	w@
	r@ 2 + w@
	r> 4 + w@ ;

hex
\ the first 8 correspond to the "old" color method
 0000  0000  0000  RGBColor RGBBlack
 FC00  F37D  052F  RGBColor RGBYellow
 F2D7  0856  84EC  RGBColor RGBMagenta
 D000  0000  0000  RGBColor RGBRed
\ DD6B  08C2  06A2  RGBColor RGBRed
 0241  AB54  EAFF  RGBColor RGBCyan
 0000  64AF  11B0  RGBColor RGBGreen
 0000  0000  D400  RGBColor RGBBlue
 FFFF  FFFF  FFFF  RGBColor RGBWhite

 F000  F000  F000  RGBColor RGBLtGray
 A000  A000  A000  RGBColor RGBDkGray
decimal



StopIncluding ************************************


\ simple example:

RGBLtGray @RGB RGBColor theForeColor
RGBLtGray @RGB RGBColor theBackColor

: SetColors ( -- )
	0 c" pick a background color"  theBackColor theBackColor GetColor
	IF
		theBackColor RGBBackColor
	THEN
	0 c" pick a foreground color"  theForeColor theForeColor GetColor
	IF
		theForeColor RGBForeColor
	THEN
;

