\ DIALOG STUFF
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>M4TH
decimal



Extern: UInt32 dlogRef GetNewDialog  ( UInt32 dlgID, UInt32 dStorage, UInt32 behind );
Extern: UInt32 windowRef GetDialogWindow ( UInt32 dlogRef );

Extern: void DrawDialog    ( UInt32 dlogRef );
Extern: void GetDialogItem  ( UInt32 dlogRef, UInt32 item#, UInt32 * &type, UInt32 * &Handle, UInt32 * &Rect );
Extern: void GetDialogItemText  ( UInt32 handle, UInt32 addr );
Extern: void SetDialogItemText  ( UInt32 handle, UInt32 addr );

Extern: void SelectDialogItemText  ( UInt32 dlogRef, UInt32 item#, UInt32 from, UInt32 to );
Extern: UInt32 selected?  DialogSelect  ( UInt32 * &event, UInt32 * &dlogRef, UInt32 * &itemHit );

Extern: UInt32 OSerr GetDialogItemAsControl ( UInt32 dlogRef, UInt32 item#, UInt32 Controlhandle );
Extern: UInt32 flag  IsDialogEvent  ( UInt32 * &event );

Extern: UInt32 OSErr SetDialogDefaultItem ( UInt32 dlogRef, UInt32 item# );

extern: UInt32 TEHandle GetDialogTextEditHandle ( UInt32 DialogRef );


((
\ favorite alert ids:

400 value !OK#
401 value OK#
402 value YNC#
403 value Continue#
806 value Big:-(OK#
807 value Big:-(OK/QUIT#
))


: CENTER.ALERT.OVER.FRONT ( nn -- )
	ascii ALRT  swap GetResource	\	get.resource
	['] center.over.front.window (PositionDLOGRect) ;


: CENTER.DLOG.OVER.FRONT.WINDOW ( nn -- )
	ascii DLOG  swap GetResource	\	get.resource
	['] center.over.front.window (PositionDLOGRect) ;



: IssueWindowCenteredAlert ( str1$\str2$\str3$\str4$\id -- selection )
	beep
	dup center.alert.over.front
		issuealert 
;


\ ************************************************************************
\ ************************************************************************

: (ErrorAlert) ( badword$ line# err# alertid -- alertitem# )
	{: badword$ line# err# alertid | buf1[ 256 ] buf2[ 256 ] buf3[ 256 ]  :}
	err#
	IF
		badword$ count buf1[ place			\ stash offending word
		cr$cr$   count buf1[ append			\ append 2 cr's

		s" Error # " buf2[ place
		err# s>d tuck dabs <# #s rot sign #>
		buf2[ append
		turnkeytoken @ 0=		\ 10.46
		line# 0 > AND			\ 10.46
		IF
			s"  on line# " buf2[ append
			line# s>d tuck dabs <# #s rot sign #>
			buf2[ append
		THEN
		cr$   count buf2[ append			\ append cr
		
		err#  Err$ dup 0=
		IF
			2drop
			s" No text available for THROW code"
		THEN
		buf3[ place
		
		buf1[ buf2[ cr$ buf3[
		alertid	  IssueWindowCenteredAlert
	ELSE
		0
	THEN
;


: ErrorAlert ( badword$ line# err# -- )
	3dup SysLogError# ( badword$ line# err# -- )
	Big:-(OK# (ErrorAlert) drop
;


: (AbortAlert) ( badword$ line# c-addr alertid -- alertitem# )
	{: badword$ line# c-addr alertid | buf1[ 256 ] buf2[ 256 ] :}
	badword$ count buf1[ place			\ stash offending word
	cr$cr$   count buf1[ append			\ append 2 cr's

	turnkeytoken @			\ 10.46
	line# 0=  OR			\ 10.46
	IF
		s" Aborted" buf2[ place
	ELSE
		s" Aborted on line# " buf2[ place
		line# s>d tuck dabs <# #s rot sign #>
			buf2[ append
	THEN
\	cr$   count buf2[ append			\ append a cr
			
	buf1[ buf2[ cr$cr$ c-addr
	alertid	  IssueWindowCenteredAlert
;



: AbortAlert ( badword$ line# c-addr -- )
	3dup SysLogAbort# ( badword$ line# c-addr -- )
	Big:-(OK# (AbortAlert) drop
;



\ ************************************************************************

\ 10.46 - put in a o_abort notifier to alert us to uncaught errors


ErrDef NoCatch  "Unspecified Error Occurred"


: mf(o_ABORT)	\ i*x -- ; R: j*x --
  s0 @ sp!  fs0 @ fsp ! reset-fpu
  \ similar to QUIT, but fall into EVENT.LOOP instead of Interpreter
  init-quit
  r0 @ rp!  exc0 @ excp !
  events on				\ 10.47
  event.loop
;

: SilentAbort  ( -- )	\ Like ABORT without an eror message
	mf(o_ABORT)
;


: My_O_ABORT
	""
	0  NoCatch ErrorAlert
	mf(o_ABORT)
;

\ assign My_O_ABORT  to-do	o_abort	


\ ************************************************************************

\ 10.46 - assign minimal alert-based error reporting for use when Editor
\			is not loaded (e.g., turnkeys)

(( 

: BadWord->Pocket ( -- )	\ 10.47 moved to 40 MF VFX CONSOLE
	turnkeytoken @ 
	IF
		"" count
	ELSE
		saved>in @ dup 'tib @ +		\ wasOffset\start
		>in @ rot -
		-white
	THEN
	pocket place
;

 ))

: MinDoAbortMessage ( c-addr -- )
	BadWord->Pocket
	pocket  0 rot

	AbortAlert ( badword$ line# c-addr -- )
	mf(o_ABORT)
;

\ assign MinDoAbortMessage   is DoAbortMessage	\ 10.47 move to M4PLSTART1



: MinDoAErrorMessage ( n -- )
	BadWord->Pocket
	pocket 0 rot
	ErrorAlert ( badword$ line# err# -- )
	mf(o_ABORT)
;

\ assign MinDoAErrorMessage  is DoErrorMessage	\ 10.47 move to M4PLSTART1



\ ************************************************************************
\ ************************************************************************


: ResourceMissing?  ( resType\resID -- missing? )
	\ Generally useful, but especially for DLOG and ALRT resources,
	\ to prevent bombs if missing resources.
	GetResource 0 = ;


: CheckForALRT  ( resID -- )
	ascii ALRT swap ResourceMissing? ABORT" Missing ALRT resource!"  ;

: CheckForDLOG  ( resID -- )
	ascii DLOG swap ResourceMissing? ABORT" Missing DLOG resource!"  ;


: BEGIN.DIALOG  ( resID -- dlogRef )	\ for MODAL dialogs
										\ does NOT set current 4th window
										\ is NOT attached to a MacForth wptr4
	1 needed
    dup CheckForDLOG	\ be sure DLOG is present
	BeforeDialog		\ perform any pre-dialog actions
    InitCursor			\ use arrow cursor
    0					\ use heap for storage  (wPtr = NIL)
    -1					\ make it front window
    GetNewDialog 		\ invoke trap
;


: END.MODELESS ( dialogRef -- )	\ factor out 605431
	1 needed
	dup GetDialogWindow 		\ dialogRef\wptr
	dup ?active.WindowRef 		\ dialogRef\wptr\flag 
	IF
		 HideWindow		\ false ShowHide	\ 
		 DisposeDialog
	ELSE
		2drop 
	THEN
;


: END.DIALOG  ( dialogRef |or| wptr -- )
	1 needed
	dup (?wptr)		  \ is it a forth window ?
	IF
		dup ?wvisible		\ 6.04998 ?active.wptr 
		IF
			dup hide.window			\ 6.04998
			dup  +dlogref# @ ?dup IF DisposeDialog THEN
			dup  +dlogref# off		\ 6.046 remove extra DUP
			     off
		ELSE 
			drop
		THEN
	ELSE				\ else assume MODAL dialogRef
		end.modeless	\ factor out 605431
	THEN
;


: ADD.DIALOG  ( resID\wptr4 -- )	\ for MODELESS dialogs
									\ like ADD.WINDOW  --  run as MF window
							\ Wptr4 parameter should be as allocated by NEW.WINDOW
	2 needed
	locals| THE.WPTR4 THE.ID |
	the.wptr4 end.dialog

	the.id CheckForDLOG					\ be sure DLOG is present
	the.id  0
	the.wptr4 +w.behind @ 
	dup -1 <> 							\ behind
	IF
		dup 
		IF  ( DBP+ ) 
			dup ?active.wptr FALSE= IF drop 0 THEN
		THEN 		
	THEN

	GetNewDialog ( dlgID\dStorage\behind -- dlogRef )
	dup	the.wptr4 +dlogref# !
	    GetDialogWindow ( dlogRef -- WindowRef )
	dup the.wptr4   !				\ save Windowref
	    the.wptr4 SetWRefCon ( WindowRef\refcon -- )

	the.wptr4 (window)
 ;



: DrawDialog4   ( wptr4 -- )  \ DrawDialog4 ( CARBON _DrawDialog )
	+dlogref# @ DrawDialog
;


: GetDialogItemAsControl4 ( wptr4\item#\&Controlhandle -- OSerr )
	2 roll +dlogref# @
	2 bury
	GetDialogItemAsControl
;

: GetDialogItem4   ( wptr4\item#\&type\&Handle\&Rect -- )  \ GetDialogItem4 ( CARBON _GetDialogItem )
	4 roll +dlogref# @
	4 bury
	GetDialogItem
;

: SelectDialogItemText4   ( wptr4\item#\from\to -- )  \ SelectDialogItemText4 ( CARBON _SelectDialogItemText )
	3 roll +dlogref# @
	3 bury
	SelectDialogItemText
;



\  modeless dialogs

: DIALOG.SELECT  ( eventRecPtr -- dlogRef\item#\dlogHit? )
	0 >R rp@ 
	0 >R rp@     DialogSelect ( &event\&dlogRef\&itemHit -- selected? )
\	0 >R rp@ 2 + DialogSelect ( &event\&dlogRef\&itemHit -- selected? )
	2R> rot 0<> ;


: CMD.KEY?  ( -- flag )
    ?CmdKey ;


: DIALOG.TYPE?  ( event# -- flag )
   CASE
   		key.down      OF cmd.key? FALSE= ENDOF
        abort.event   OF false     ENDOF
        switch.event  OF false     ENDOF
        true swap
    ENDCASE ;



: DIALOG.EVENT?  ( -- dlog ptr\item#\flag )
	event.record w@ dialog.type?
	event.record IsDialogEvent 
	and
	IF
		 event.record dialog.select
	ELSE
		 0 dup false
	THEN ;


: (CENTER)  ( ALRT or DLOG or WIND handle -- )
	?dup
	IF
		locals| THE.HNDL |
		the.hndl HNoPurge
		the.hndl @ @rect center.on.screen
		the.hndl @ !rect
	THEN ;


: (HCENTER)  ( ALRT or DLOG handle -- )
	?dup
	IF
		locals| THE.HNDL |
		the.hndl HNoPurge
		the.hndl @ @rect center.in.horizontal
		the.hndl @ !rect
	THEN ;


: CENTER.DIALOG  ( resID# -- )
	ascii DLOG over GetResource ?dup
	if 
		ReleaseResource		\ if dialog has been open once, rect is changed
		ascii DLOG swap GetResource
		(center)
	else
		drop
	then ;


: HCENTER.DIALOG  ( resID# -- )
	ascii DLOG over GetResource ?dup
	if 
		ReleaseResource		\ if dialog has been open once, rect is changed
		ascii DLOG swap GetResource
		(hcenter)
	else
		drop
	then ;


: CENTER.ALERT  ( resID# -- )
	ascii ALRT over GetResource ?dup
	if
		ReleaseResource		\ if alert has been open once, rect is changed
		ascii ALRT swap GetResource
		(center)
	else
		drop
	then ;


: HCENTER.ALERT  ( resID# -- )
	ascii ALRT over GetResource ?dup
	if
		ReleaseResource		\ if alert has been open once, rect is changed
		ascii ALRT swap GetResource
		(hcenter)
	else
		drop
	then ;



StopIncluding ************************************
