\ APPLICATION MENU
\ Last Revision: 12 Feb 2012  08:21:04  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************

\ The Old Apple Menu is now the Application Menu


only Forth definitions
>M4TH

decimal

CREATE ITEM$ 		 1024 allot&erase

create   APPLE.TITLE   01 c, $14 c,	0 w,		\ the "apple symbol" as a string

variable #PICTS   #Picts OFF


400 constant  MACFORTH.PICTURE

0 value PreferenceMenuAction	\ xt for this item
\ 0 value PreferenceMenuItem#


: APPEND.PICTURE  ( pictResHandle -- )  \ appends pict-name to Apple-menu
	item$ GetResInfo		\ put all info at ITEM$, only uses name at +6
	item$ 6 +  #picts @ 1 ins.menu.item$
	1 #Picts +!    ;


: INSERT.APPLE.ITEMS  ( -- )
	#Picts OFF
	MacForth.Picture
	BEGIN
		1+ dup GetPicture
		?dup
	WHILE
		dup Append.Picture
		HPurge
	REPEAT
	drop
	MacForth.Picture GetPicture  ?dup IF Append.Picture THEN
	PreferenceMenuAction
	IF	\ only add this item if a non-0 action
		#Picts @   c" -("  over 1  ins.menu.item$
		1+ 	\ dup to PreferenceMenuItem#
		c" Preferences/," swap 1  ins.menu.item$
	THEN
;


defer SHOW.ABOUT.ANYTHING ( picthandle -- )   ' drop is show.about.anything 


: SELECT.INFO  ( -- )
    ascii PICT  ITEM$ GetNamedResource
    show.about.anything 		\ About.Anything
;



: DO.APPLE.MENU  ( item# -- )
	20 item$ C!
	0 HiliteMenu 

	1 GetMenuHandle over item$ GetMenuItemText
	#Picts @ >  
	IF  
		PreferenceMenuAction execute
	ELSE
		Select.Info  
	THEN
;


: APPLE.MENU  ( -- )	\ really APPLICATION Menu now, old name
	1 Get.Next.ID  Apple.Title 1 new.menu
	Insert.Apple.Items
	DrawMenuBar

	1 MENU.SELECTION: do.apple.menu
;


