\ EDIT MENU
\ Last Revision: 12 Feb 2012  08:20:36  ward@megawolf.com
 

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************

\ minimal Edit Menu and Dialog Edit Menu

only Forth definitions
>M4TH

decimal


defer MinimalEditMenuAction
	  ' drop is MinimalEditMenuAction


3 value EditMenu#


: +EDIT.MENU
	true EditMenu# menu.enable ;

: -EDIT.MENU
	false EditMenu# menu.enable ;



: Do.Minimal.Edit.Menu ( item# -- )
	0 HiliteMenu
	MinimalEditMenuAction
;


: MINIMAL.EDIT.MENU ( -- )
	EditMenu# menu.selection: Do.Minimal.Edit.Menu ;


: EDIT.MENU ( -- )
	EditMenu#  get.next.id C" Edit" EditMenu# new.menu
	C" Undo/Z(;Redo/Z(;-(;Cut/X;Copy/C;Paste/V;Clear" EditMenu# append.items
	2 $01 EditMenu# set.item.modifiers		\ shift-Z
	DrawMenuBar 
	minimal.edit.menu ;


: EnableEditMenuItems ( flag -- )	\ enable/disable UNDO through SELECT.ALL
	locals| TheFlag |
	8 1
	DO
		i TheFlag EditMenu# item.enable
	LOOP
;






extern: void TECopy  ( UInt32 teH );
extern: void TECut   ( UInt32 teH );
extern: void TEDelete  ( UInt32 teH );
extern: void TEPaste   ( UInt32 teH );
extern: void TESetSelect  ( UInt32 start, UInt32 end, UInt32 teH );



: (DLOGTE)  ( wptr4 -- [TEHandle\true] or [false]  )
	+dlogref# @ GetDialogTextEditHandle
	?dup boolean ;

: DLGCOPY  ( wptr4 -- )
	(dlogte) if TECopy then ;

: DLGCUT  ( wptr4 -- )
	(dlogte) if TECut then ;

: DLGPASTE  ( wptr4 -- )
	(dlogte) if TEPaste then ;

: DLGDELETE  ( wptr4 -- )
	(dlogte) if TEDelete then ;

: DlgSelAll  ( wptr4 -- )
	(dlogte) if 0 32000 rot TESetSelect  ( start\end\teH -- ) then ;



: DO.DLOG.EDIT.MENU
	0 HiliteMenu
	get.window swap
	CASE  ( 1 is Undo )
		  ( 2 is Undo )
		  ( 3 is a separator )
			4 of DlgCut  TEScrap.changed on	ENDOF
			5 of DlgCopy TEScrap.changed on ENDOF
			6 of DlgPaste	ENDOF
			7 of DlgDelete	ENDOF	\ Clear
			9 OF DlgSelAll	ENDOF
	ENDCASE
;



(( 
ascii cut_  constant  kHICommandCut
ascii copy  constant  kHICommandCopy
ascii past  constant  kHICommandPaste
ascii clea  constant  kHICommandClear
ascii sall  constant  kHICommandSelectAll
 ))


: DLOG.EDIT.MENU		\ use only when current window is a dialog
	true EnableEditMenuItems
	1 false EditMenu# item.enable  		\ no Undo
	2 false EditMenu# item.enable  		\ no Redo
	9 true EditMenu# item.enable  		\ allow select all

	4 c" Cut"   EditMenu# set.item$
	5 c" Copy"  EditMenu# set.item$
	6 c" Paste" EditMenu# set.item$
	7 c" Clear" EditMenu# set.item$
	9 c" Select All" EditMenu# set.item$
	EditMenu# GetMenuHandle 
	dup 4	ascii cut_	SetMenuItemCommandID drop
	dup 5	ascii copy	SetMenuItemCommandID drop
	dup 6	ascii past	SetMenuItemCommandID drop
	dup 7	ascii clea	SetMenuItemCommandID drop
	    9	ascii sall	SetMenuItemCommandID drop

	EditMenu# menu.selection: DO.DLOG.EDIT.MENU ;



StopIncluding ************************************




