\ MACFORTH STARTUP
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com
 
\ define our ENTRYPOINT code that ets executed after VFX cold start

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>M4TH

decimal


0 value myResFile#
0 value MyRWResFile#
0 value BagFile#		\ 10.45
0 value BagFile2#		\ 10.45


: USE-CMF-FOLDER ( -- )
	myIODir   -> dfltIODir
	myVolRef# -> dfltVolRef#
;


(( 		\ moved earlier
variable StartupToken   StartupToken off
variable TurnkeyToken	TurnkeyToken off
variable SnapshotToken	SnapshotToken off
 ))


: ?TURNKEY  (  -- flag | true if we are running as a turnkey )
	TurnkeyToken @ 0<> ;


0 Value StartUpError?

0 value IncludedErr
0 value IncludedLine#

: MinimalDOERRORMESSAGE
	to IncludedErr
	line# @ -> IncludedLine#
;

: TryIncluded ( addr\cnt -- )
	0 to IncludedErr
	action-of DOERRORMESSAGE >R
	['] MinimalDOERRORMESSAGE is DOERRORMESSAGE
	['] included catch ?dup
	IF
		true -> StartUpError?
		IncludedErr ?dup
		IF
			nip			\ -1 will have been returned by CATCH
						\ else was probably a file error 
		THEN
		c" Error in Default.Extensions: " 2dup SysLogNumber ( n\c1$ -- )
		
		2dup 	\ cr->log  count type->log Num->Log
		LOG[[ cr count type . ]]LOG
		cr cr count type .
		IncludedLine# c" at line# " 2dup SysLogNumber ( n\c1$ -- )
		2dup   \ count type->log  Num->Log
		LOG[[ count type . ]]LOG
		count type .
	THEN
	R> is DOERRORMESSAGE
;


: DO.SUPPLIED.TIB ( -- )
	c" including Default.Extensions"  SysLogMsg1
	-source-files            \ don't add source file names
	startupdir 2@
	c" Default.Extensions" 
	FileInfo->ZString ( volref\iodir\file$ -- zStr )
	?dup
	IF
		zcount  TryIncluded
		c" finished Default.Extensions"  SysLogMsg1
	ELSE
		c" DO.SUPPLIED.TIB failed"  SysLogMsg1
	THEN
	+source-files            \ restore source action
;

\ --------------------------------------------------------------------------------


(*
	ProcessInfoRec			RECORD 0
	processInfoLength		 ds.l	1				; offset: $0 (0)
	processName				 ds.l	1				; offset: $4 (4)
	processNumber			 ds		ProcessSerialNumber ; offset: $8 (8)
	processType				 ds.l	1				; offset: $10 (16)
	processSignature		 ds.l	1				; offset: $14 (20)
	processMode				 ds.l	1				; offset: $18 (24)
	processLocation			 ds.l	1				; offset: $1C (28)
	processSize				 ds.l	1				; offset: $20 (32)
	processFreeMem			 ds.l	1				; offset: $24 (36)
	processLauncher			 ds		ProcessSerialNumber ; offset: $28 (40)
	processLaunchDate		 ds.l	1				; offset: $30 (48)
	processActiveTime		 ds.l	1				; offset: $34 (52)
	processAppSpec			 ds.l	1				; offset: $38 (56)
	sizeof					 EQU *					; size:   $3C (60)
							ENDR

for _GetProcessInformation
You need to specify values for the processInfoLength, processName, and processAppSpec
fields of the process information record.  Specify the length of the process
information record in the processInfoLength field.  If you do not want information
returned in the processName and processAppSpec fields, specify NIL for these fields. 
Otherwise, allocate at least 32 bytes of storage for the string pointed to by the
processName field and, in the processAppSpec field, specify a pointer to an FSSpec
record. 
*)

create aPSN				0 , 0 ,				\ ProcessSerialNumber of MF+
create MyProcessInfo	FSSpecRecord allot&erase
\ create MyNameBuffer 	256 allot&erase		\ was USER



: myPSN ( -- addr )
	MyProcessInfo 8 +
;

: GetMyProcessInfo ( -- )
	MyFSSpec 		FSSpecRecord erase
	myPSN    		8            erase
	MyProcessInfo	80			 erase
		aPSN GetCurrentProcess
		drop
	
		60 			MyProcessInfo !			\ save length 
		MyFSSpec	MyProcessInfo 56 +  !
	
		mynamebuffer  MyProcessInfo 4 + !		\ scratch for name
		aPSN  	    MyProcessInfo GetProcessInformation 	\ 
	
		drop 
;


: AdjustScreenBounds ( -- )
	GetGDevice  screen.bounds GetAvailableWindowPositioningBounds drop
;


\ --------------------------------------------------------------------------------

: TkY.Activate ( flag -- )
	\ SYS.WINDOW action in turnkey
	IF
		sys.window +windowref# @ 0 SendBehind	\ send behind all windows
		event.loop
	THEN
;

: FIRST.ACTIVATE ( flag -- )
	\ 	This is the first activate token for sys.window
	\ 	If MacForth was launched as a result of double clicking,
	\	Finder Open menu, or as a result of a chain sequence,
	\   any selected text files are included. 
	key.stroke off
	high.level.event.record off
	$fffffe8f io.events ! 

	dup c" FIRST.ACTIVATE "  SysLogNumber ( n\c1$ -- )

	sys.window on.activate sys.activate
	sys.activate
;


140 Value SmallHeight		\ height of a SmallWindow

: SmallWindow	( -- T\L\B\R  )		\ centered at bottom
	( T ) 0
	( L ) screen.bounds 2 + w@  10 +  
	( B ) SmallHeight
	( R ) screen.bounds 6 + w@  2 -
\	center@bottom  50  ;		\ 6.046
	center@bottom  100 ( 50 ) - 100 max ;		\ 6.046


: LargeWindow		( -- T\L\B\R )	 \ full screen
	screen.bounds @rect		\ get TLBR of screen
	2swap  55  10 +point	\ move down 55 lines from top, 10 from left
	2swap   3 100 -point	\ in 2 from bottom, 100 from right
;


\ --------------------------------------------------------------------------------


: DFLT.STARTUP  ( -- )  \ this is the default snapshot startup token for MF+
						\  NOT executed by default in Turnkeys
	0 -> LogFile# 
	['] StartLogging catch ?dup
	IF
		true to StartUpError?
		c" Error during StartLogging "  SysLogNumber
	ELSE
		c" MacForth Log Opened" SysLogMsg1
	\	s" Early Startup" Type->Log CR->Log
	THEN

	\ In snapshots, add in secondary resource "bag" file to enable
	\ all tools and demos
	\ Its resources normally not used in Turnkeys
	c" OptionalResources.rsrc" UseResourcesFile		\ 10.45
	drop
	-> BagFile2#

	64 allot.menus
	apple.menu
	file.menu
	edit.menu
\	options.menu			\ -> default.extensions
\	tools.menu				\ -> default.extensions
\	windows.menu			\ -> default.extensions

	300 -> SmallHeight

	\ Adjust initial bounds for sys.window at runtime
	SmallWindow sys.window w.bounds		\ !!!!

	\ designate sys.window as first window, set activate token
	sys.window on.activate first.activate
	sys.window ?active.wptr 0= 
	IF
		sys.window add.window
	THEN
	sys.window window 
	sys.window active.window !
	SmallWindow  set.zoom.in
	LargeWindow  set.zoom.out	

	\ setup i/o re-direction
	DebugFile ON  		\ trace to current window 

	 4 TextFont 		\ default font
	12 _TextSize 		\ default fontsize - 6.05431
	58 lines/page !		\ std for laserwriter, imagewriter

	100 c/line !
	17  c/cols !

\	Events ON			\ allow all events
	InitCursor			\ cursor becomes visible NW arrow
	ShowCursor

	SYS.WINDOW INFILE ! 		\  input starts from and
\	SYS.WINDOW streamRefNum !	\  defaults to sys.window 
	OutFile ON  				\ use current.window as OutFile

	>m4th					\ set vocabularies
;

' DFLT.STARTUP StartupToken !




: M4PLSTART1 ( -- )					\ finish intialization
	\ setup StartupDir
	DirGet  StartupDir 2!			\ Remember VRefNum & DirID of MF+ file

	\ this should return the same as DirGet above
	GetMyProcessInfo				\ get process info and MyFSSpec

	\ setup myVolRef# & myIODir
	MyFSSpec +FSSvRefNum w@s -> myVolRef# 
	MyFSSpec +FSSparID @	 -> myIODir
	
	\ set dfltVolRef & dfltIODir --> at this point it is where our mach-o app is
	use-cmf-folder		
	VolDirExpires

	\ if our app has no resource fork, we cannot open it - ! DOH !
	\ so we may need to create one, since VFX SAVE creates only a text fork
	\ BUT, we may want to access our own resource fork
	MyFSSpec +FSSvRefNum w@s
	 MyFSSpec +FSSparID @
	  MyFSSpec +FSSname
	   HCreateResFile 

	MyFSSpec 3 ( rw ) FSpOpenResFile -> MyRWResFile#
	MyRWResFile# useresfile

	MyFSRef 80 erase
	MyFSSpec MyFSRef FSpMakeFSRef drop
	
	0 MyFSRef  CFURLCreateFromFSRef  -> MyCFURL
	
	SetCDtoMyFolder drop
	IniDir$  count expand s" INIDIR"  replaces
	IniFile$ count expand s" INIFILE" replaces


	\ 10.47 reset defaults to our bundle's folder
	GetLocalVolDir -> myIODir  -> myVolRef#
	use-cmf-folder


	MyProcessInfo 20 + @ creator !
	ascii TEXT fileType !

\ use " :RESOURCES:RootResources.rsrc"
\ nothing bad should happen if it isnt there, except missing resources
	c" RootResources.rsrc" UseResourcesFile
	IF
		c" RootResources.rsrc MISSING" 
	ELSE
		c" RootResources.rsrc opened" 
	THEN
	SysLogMsg1
	-> BagFile#		\ 10.45


	assign MinDoAbortMessage   is DoAbortMessage
	assign MinDoAErrorMessage  is DoErrorMessage
	assign My_O_ABORT  to-do	o_abort


	128 GetCursor ?dup
	IF
		@ WatchCursor 68 cmove
	THEN
	130 GetCursor ?dup
	IF
		@ IBEAM 68 cmove
	THEN
	131 GetCursor ?dup
	IF
		@ wIBEAM 68 cmove
	THEN

	Preludes ExecMFChainFromOldest 	\ perform other essential early acts
	c" PRELUDES done"  SysLogMsg1

	flush.events
	skip.events OFF

	TurnkeyToken @ ?dup				\ TurnkeyToken overrides startup at this point
	IF
		\ allow sys.window to be safely added, but hidden if app needs A window open
		debugfile off
		-1 -1 0 0 sys.window w.bounds	\ offscreen
		0 sys.window w.type			\ plain box (no title bar)	
		sys.window on.activate Tky.Activate
		

	\ Enter TurnkeyToken with
	\	Interpreter disabled
	\	PRELUDES chain already excuted
	\	RESTORER chain NOT executed
	\   NO windows added
	\	NO menus added  ( room for 32 alloted )
	\	default directories as in the start of this word
	\	RootResources.rsrc open 
	\	has NOT run DEFAULT.EXTENSIONS
	\	Event Queue has been flushed
	\	Apple Event handlers unassigned (AEOpenApp AEOpenFile AEQuitApp etc)

	\	All USER Variables OFF
	\		including EVENTS  IO.EVENTS  OUTFILE  INFILE  EVENT.FILTER
	\   except MFCONSOLE set to DFLT.CON
	\	EVENTS OFF
	\	OLD.WINDOW.BEHAVIOR ON
	\	CREATOR set from Info.plist
	
		execute						\ go to TurnkeyToken
		bye							\ if Turnkey Token does not take control
	THEN

	StartupToken @execute			\ internal startup token - DFLT.STARTUP

	SnapshotToken @execute			\ user snapshot token

	RESTORER ExecMFChainFromOldest
\ restorer ExecMFCHAINFromOldest&Show  	\ see WalkColdChain
	c" RESTORER done"  SysLogMsg1


	do.supplied.tib					\ Include Default.Extensions

	events on
	skip.events off
	$FFFFFEBF IO.EVENTS !

	c" finished M4PLSTART1"  SysLogMsg1

	event.loop

	abort
;



: M4PLSTARTUP ( -- )
\	(init)						\  VFX  does this AtCold
	0 -> StartUpError?
	SafeWriteBuffer off
	AllocateSafeWriteBuffer		\ prepare early to handle exceptions

	\ check this if we add more user variables
	\ Lion can set these to random values and we need most of them 
	\ initially zero
	currentport  printer over - erase

	events off
	skip.events on
	SpecialEventAction off

	dflt.con mfconsole !
	init-mfcon						\ replace XTERM VFX COnsole
	ASSIGN ansexpect	to-do EXPECT

	s0 -> ParentUserBase			\ 10.46

\ do this early since many items are sized according to 
	screen.bits GetQDGlobalsScreenBits drop ( ^bitmap -- ^bitmap )
	full.screen.bounds  screen.bounds 8 cmove
	screen.bounds  AdjustScreenBounds

	decimal
	infile off
	printer off
	blk off
	debugfile on						\ default writes to current grafport
\	ownPrint OFF
	debug OFF
	active.window off
	0 to WNE.REGION
	key.stroke off
	high.level.event.record off
	old.window.behavior ON
	switched.window off
	['] NO.AEHANDLER	high.level.event >event !
	['] BetterQuit is QUIT


	RegisterAppearanceClient  drop
	InitNavigationRecords

	32 allot.menus

	m4plstart1
;



' M4PLSTARTUP  TO-DO ENTRYPOINT
