\ SNAPSHOT
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


0 [IF] 

Snapshot with MFonVFX is different than with older MacForth
Generally a little easier than previously.


1. MFonVFX is a BUNDLE (see '/MF Docs/Rebuilding MFonVFX')
  - a simple SAVE <name> as VFX uses will create only a Mach executable,
NOT a complete bundle

2. The only thing that needs changing on a snapshot is the Mach executable
part of the bundle.  We usually do not need to change resources, icons,
plist, etc. 


We offer 2 methods of snapshotting

 SNAPSHOT  uses Standard File and creates an identical copy of our
current application bundle with a different finder name.  If you need to
maintain different versions of MFonVFX each with their own preferences
(determines what files are reopened on Lion, etc), then be sure to open the
Bundle and rename the mach executable and modify 'Executable file' in its
INFO.PLIST to match the mach application's name


 SNAP  modifies our current application bundle, replacing its Mach
executable with a new one based on your current Dictionary.  For safety, the
prior Mach executable is retained in the Contents subfolder, but renamed with
an incrementing trailing index: MFonVFX, MFonVFX1, MFonVFX2, etc
So, if you find a problem with your new snapshot, open the bundle contents
and trash the new Mach executable and restore the name of the prior one.

If you use SNAP often, your application's /Contents/MacOS/ folder
should get an occasional manual pruning of the old versions


************************************

SNAPSHOT TIPS:

Destination file name *MUST* end with '.app' or MacOS will not recognize
it as an application, just a folder. (Yes, you might fiddle the folder's
Bundle Bit to get the same effect, but that is not guaranteed to work).


NO MORE WORRIES ABOUT RELOCATABLE CODE REFERENCES.  OS X always reloads
our kernel to the same address.  We only need to worry about Heap
addresses and opaque references returned by the OS (window pointers,
dialog ref's, Core Foundarion objects, etc)


Snapshotting simple code extensions is trivial.  Include your code
and execute SNAP or SNAPSHOT as described above.

Snapshotting code with UI elements, Core Foundation objects, heap
allocations, etc is trickier.

The snapshot will be an exact image of the MF dictionary at the time
the snapshot was made. References to dynamically allocated objects will
be WRONG.  Heap allocations, opening windows or nibs or resources or
menus, adding controls, etc need to be explicitly REdone after your 
Snashot is launched.

A common issue is to have your code do an ADD.WINDOW outside a colon
definition.  When you reload, the window isn't added.

Or you may do something like
  1000 newhandle value MyBuffer
On reload, MyBuffer contains an invalid handle.

So, an initialization word is required:

: InstallMyWidget 
  \ initialize heap allocations, Core Foundation objects, etc
  \ open resources
  \ add windows, controls, menus
  etc
;
And add it to the Restorer chain or add it to the other initialization code
in Default.Extensions

In a scratch Editor window, execute
  RESTORER ShowMFChainLinks
  PRELUDES ShowMFChainLinks
and do CMD-R on some of the words to see some examples


Even in RESTORER and PRELUDES words, you need to take a little care,
especially words that do things like

	<variable> @ ?DUP
	IF
Be sure <variable> is zeroed before snapshot. 

The kernel has a number of those issues and has some words that clean up
stuff prior to snapshot.

To see the ones we use, Execute in a scratch Editor window
  PRESNAPSHOT ShowMFTokenChain
these are automatically executed prior to snapshot that ensure that
such things are cleaned up prior to making the actual snapshot

[THEN]


only forth definitions
>m4th
decimal

\ FSSetCatalogInfo ( UInt32 * &fsRef, UInt32 whichInfo, UInt32 * catalogInfo )
\ FSGetCatalogInfo


: @GMTSeconds ( -- secs )		\ @clock, 1corrected to GMT  10.46
	systime&date  3drop nip nip		\ hours GMT
	time&date     3drop nip nip		\ hours local
	-  60 60 * *					\ seconds between local and gmt
	@clock +						\ locals time
;


: SetFileTimes  ( flags destpath$ len -- )   \ 10.46
\ update created and modified times
\ flags = combination of any of kFSCatInfoCreateDate + kFSCatInfoContentMod + kFSCatInfoAttrMod
	{  flags destpath$ len  | catinfo[ 144 ] fsref[ 80 ] }
	destpath$ len
	0
	flags			\ which dates to get
	catinfo[
	GetCatInfo  ( addr\cnt\whichInfo\^catinfo --  aFSSpec |or| 0 )
	IF
		aFSSpec fsref[ FSpMakeFSRef ( UInt32 * ^FSSpec, UInt32 * ^FSRef ) 0=
		IF
			@GMTSeconds					\ use GMT
			dup catinfo[  $12 + !		\ createDate
			dup catinfo[  $1A + !		\ contentModDate
			    catinfo[  $22 + !		\ attributeModDate
	
			fsref[
			flags			\ which dates to set
			catinfo[
			FSSetCatalogInfo ( UInt32 * &fsRef, UInt32 whichInfo, UInt32 * catalogInfo )
			drop
		THEN
	THEN
;


: DittoME ( destpath$ len -- ioR )
\ Make a duplicate of our application at the specified location
\ It will be an exact duplicate, including dates, permissions and all 
\	internal subfolders, files, etc - Just like a Finder DUPLICATE
\ destpath$ should contain the name of our copy as well as path
\	information if needed
\ If the destination name does not end in '.app' MacOS will not
\	recognize it as an application, just a folder
\ If only a file name is given, this should be saved into the same
\	folder we are running in.
	{ destpath$ len | Index OrigName[ 1024 ] Command$[ 2048 ] }
	GetCFURLofMyApp dup
		1 OrigName[ 1023 CFURLGetFileSystemRepresentation drop
	CFRelease
	s" ditto '"		 Command$[ zplace
	OrigName[ zcount Command$[ zappend
	s" ' '"			 Command$[ zappend
	destpath$ len 	 Command$[ zappend
	s" '"			 Command$[ zappend
	Command$[ >system
	$E0							\ kFSCatInfoCreateDate + kFSCatInfoContentMod + kFSCatInfoAttrMod
	destpath$ len 	 SetFileTimes				\ 10.46 - update dates
;


: (SaveMachCore) { machpath$ len -- }
	\ do necessary cleanup of MacForth portion
	presnapshot ExecMFChainFromOldest

	\ erase old marker if it exists
	c" XXXX" FindAnywhere 
	IF >name 1+  off
	ELSE drop
	THEN

	\ see SAVE - do additional cleanup, then save under the original name
	align BeforeSave
	machpath$ len 2dup $SaveImage drop
	setExecPerms
;


: (SnapshotTO) ( destpath$/len -- )
\ Make a copy of OUR Bundle with the name and location
\ specified by destpath$
\ SAVE our current code image to the /Contents/MacOS/ folder of the copy
\ BYE so we can re-initialize and test
	{ | SaveTargetPath[ 1024 ] }
	\ Get Current full path to our Mach "core"
	2dup SaveTargetPath[ zplace
	2dup Path$Buff		 zplace				\ save a global copy
	DittoME abort" Error in DittoME"

	s" /Contents/MacOS/"	SaveTargetPath[ zappend
	MyNameBuffer count		SaveTargetPath[ zappend

	SaveTargetPath[ zcount (SaveMachCore)
;


: SnapshotTO  \ "<name>" -- ; SAVE <name>
	GetPathSpec (SnapshotTO)
;

: (SNAPSHOT) ( &prompt\&defaultName --  )	\ 10.45 factored out
	\ assume NavReply has destination data
	ClearReply
	EZPut2 ( &prompt\&defaultName --  )
	navreplyok?
	IF
		\ create a temporary file in order to use FSSpec->ZString
		NavReplyVolume NavReplyDir NavReplyName
		0 0 HCreate drop
		NDFSSPec FSSpec->ZString zcount
		\ delete temporary file
		NavReplyVolume NavReplyDir 	NavReplyName HDelete drop
		(SnapshotTO)
	ELSE
		SilentAbort		\ 10.46 abort
	THEN
;


: SNAPSHOT ( -- )
	c" Save Snapshot as"
	c" untitled.app"
	(snapshot)
	bye						\ exit to test new version
;


defer WarmRecover ( --  )	\ handle user-sepcific recovery from  falling into QUIT in a turnkey
							\ which should only be encountered with unexpected errors
	' noop is WarmRecover

: TkyQUIT ( -- )	\ version of QUIT that bypasses Interpreter completely
	init-quit
	r0 @ rp!
	exc0 @ excp !
	quitter execchain
	WarmRecover
	skip.events OFF
	events on
	event.loop
;


: Index&Rename ( pathaddr\cnt -- )
\ rename file at path by adding an index# to the end
\ MyFile1, MyFile2, etc....
\ increment index as needed to avoid a duplicate name
	{ | Index OrigName[ 1024 ] NewName[ 1024 ] }
	OrigName[ place
	1 to Index
	BEGIN
		OrigName[ count  NewName[ place
		Index 0	<# #s #> NewName[ append
		1 +to Index
		NewName[ count IsFileMissing?
	UNTIL
	OrigName[ count NewName[ count  rename-file drop
;

\ ***************************************************************************

: SNAP ( -- )
	{ | myPath[ 1024 ] }
	\ Get the full path to our Mach executable
	MyCFURL 1 myPath[ 1023 CFURLGetFileSystemRepresentation drop
	
	\ change the name of the original Mach executable
	myPath[ zcount Index&Rename
	myPath[ zcount (SaveMachCore)

	\ 10.46 - update modified date
	GetCFURLofMyApp  1 myPath[ 1023 CFURLGetFileSystemRepresentation drop
	$40								\ only kFSCatInfoContentMod
	myPath[ zcount 	 SetFileTimes

	bye								\ exit to test new version
;


: SAVE				\ overwrite VFX to add our PRESNAPSHOT chain
	presnapshot ExecMFChainFromOldest
	save
;


\ ***************************************************************************


: BeheadOne ( thread#\nfa -- flag )
\ NOTE:  name? fails if we fill with spaces
	NIP
	count ?dup
	IF
		202 fill	\ leave the count, fill with NBSpChar's
\		bl fill		\ leave the count, fill with blanks
	ELSE
		drop
	THEN
	true
;


: Behead ( -- )	\ "<name>" -- ;  	\ Behead the next word in stream
	0			\ bogus thread#
	' 
	>name BeheadOne  drop
;


: (BeheadVocab)  ( wid -- )
	['] BeheadOne swap
	WalkWordList ( xt wid -- )
;


: BeheadVocab	 ( -- )  \ "<name>" -- ;   	\ Behead all words in the specified vocabulary
	' 
	voc>wid  dup voc?  0= abort" Not a Vocabulary"
	(BeheadVocab)
;

: BeheadAll ( -- )	\ Behead all words in all vocabs EXCEPT SUBSTITUTIONS
	voc-link
	BEGIN
		@ dup
	WHILE
		dup
		\ need to leave this one for readStub in $SaveImage in (SaveMachCore)
		['] substitutions voc>wid  <>
		IF
		  dup (BeheadVocab)
		THEN
		>voc-link
	REPEAT
	drop
;

\ ***************************************************************************

: (SetupTurnkey) ( XT -- )  \ "<name>" -- ; SetupTurnkey <wordname>
\ Once this word is executed, All vocabularies have been beheaded, so 
\ no further interpretation is possible
\ This word MUST be compiled into a higher level word
	turnkeytoken !

	\ QUIT should be revectored to bypass Interpreter
	['] TkyQUIT  is QUIT

	\ disable .INI files - enable in your turnkey word
	\		if you have assigned your own name & actions
	false -> GenIni?

	\ behead vocabularies
	BeheadAll
;


: SetupTurnkey ( -- )  \ "<name>" -- ; SetupTurnkey <wordname>
	'		\ look up XT for next word in stream
	(SetupTurnkey)
;

: PruneFileFromTky ( name len ^buff -- )		\ 10.46
	>R
	Path$Buff zcount 	R@	zplace
	R@ zappend
	R> zcount delete-file drop
;

: (TURNKEY) ( &prompt\&defaultName --  )	\ 10.46 - remve extra files from target
	{ | SaveTargetPath[ 1024 ] }
	(snapshot)

	\ modify contents of PkgInfo ??
	\ does not seem required any longer
	Path$Buff zcount 			SaveTargetPath[	zplace
	s" /Contents/PkgInfo"		SaveTargetPath[ zappend
	SaveTargetPath[ zcount r/w open-file 0=
	IF
		>R
		0. r@ Reposition-File drop
		s" APPLfTKY" R@ Write-File drop
		R> Close-File drop
	ELSE
		drop
	THEN

	\ delete "m4th log" of the new bundle if present
	Path$Buff zcount 			SaveTargetPath[	zplace
	s" /Contents/"				SaveTargetPath[ zappend
	LogFile$ count 				SaveTargetPath[ zappend
	SaveTargetPath[  zcount  delete-file drop

	\ delete "Recent Files.bag" of the new bundle  if present
	s" /Contents/Recent Files.bag"  SaveTargetPath[ PruneFileFromTky
	\ delete "Default.Extensions" of the new bundle  if present
	s" /Contents/MacOS/Default.Extensions"  SaveTargetPath[ PruneFileFromTky
	\ delete "stubosx" of the new bundle  if present
	s" /Contents/MacOS/stubosx"  SaveTargetPath[ PruneFileFromTky
	\ delete ".icns" files of the new bundle  if present
	s" /Contents/Resources/MFonVFX.icns"  SaveTargetPath[ PruneFileFromTky
	s" /Contents/Resources/SourceCode.icns"  SaveTargetPath[ PruneFileFromTky
	s" /Contents/Resources/Bag.icns"  SaveTargetPath[ PruneFileFromTky
	\ delete "SrcTemplate's" of the new bundle  if present
	s" /Contents/Resources/SrcTemplate1"  SaveTargetPath[ PruneFileFromTky
	s" /Contents/Resources/SrcTemplate2"  SaveTargetPath[ PruneFileFromTky
	\ delete INFO.PLIST of the new bundle
	s" /Contents/Info.plist"  SaveTargetPath[ PruneFileFromTky
	\ rename TURNKEY.PLIST to INFO.PLIST
	s" /Contents/turnkey.plist"	Path$Buff zappend
	Path$Buff zcount  SaveTargetPath[  zcount
	rename-file drop	\ caddr1 len1 caddr2 len2 -- ior
	bye						\ exit to test new version
;


(( 
Three variants
	if StartTurnkey is to be the TurnkeyToken (startup word)


TURNKEY StartTurnkey
	\ Use to build a full bundled application derived from MFonVFX
	\ uses nav services to select name and destination of final turnkey bundle
	\ Navigation Save dialog uses generic default name - "MyTurnkey.app"

TURNKEY" My Turnkey.app"  StartTurnkey
	\ like TURNKEY but lets you specify the default name for Navigation Save dialog

TKY  StartTurnkey  NameofMachFile
	\ does not save the bundle, but like SAVE, only as a MACH executable
	\ which must be dropped into a premade Bundle to execute as an application

 ))



: TURNKEY" ( -- )  \ file name"  "<action>" -- ; TURNKEY" MY TURNKEY.app" <wordname>
	c" Save Turnkey as"
	[char] " parse  item$ place  item$		\ default turnkey file name
	SetupTurnkey
	(turnkey)
; 



: TURNKEY ( -- )  \ "<action>" -- ; TURNKEY <action>
	c" Save Turnkey as"
	c" MyTurnkey.app"
	SetupTurnkey
	(turnkey)
;


: TKY ( -- )  \ "<action>"  "Filename" -- ; TURNKEY <action>  <saveasname>
\ this does not save the bundle, but like SAVE, only as a MACH executable
\ must be manually dropped into a premade Bundle to execute as an application
	SetupTurnkey
	save
	bye
;


\\
