\ Display a Picture in a Window
\ Last Revision: 15 Jan 2012  13:00:15  ward@megawolf.com
 
\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>M4TH

decimal


DEFER InfoActivate  ( -- )   \ for something special on activate (e.g. sound)
	' noop is InfoActivate

CREATE Pic.Res  32 allot&erase  ( +0 ID; +2 RESTYPE; +6 NAME.STRING )


: INFO.UPDATE  ( -- )  \ draw current picture in window
	Pic.Res W@ GetPicture 
	dup dup HLock
	Get.Window +wCBounds  DrawPicture 
	HUnlock ;



: INFO.EVENTS ( -- )	\ handle events for INFO.WINDOW 
	do.events 
\	dup in.close.box = IF BEEP THEN
	command.key = 
	IF
		event.record 5 + c@ 
		dup  ascii w = 
		swap ascii W = OR
		IF get.window hidewindow	\ false ShowHide  \  
		THEN
	THEN
	?keystroke IF  drop beep THEN
;

: INFO.LOOP  ( flag -- ) 
	IF
		outfile off
		?keystroke IF drop THEN  	\ purge any pending keys
		InfoActivate				\ optional deferred action
		old.window.behavior @		\ 6.04996
		IF
			BEGIN					\ allow exit with a cmd-W or cmd-w
				info.events
			AGAIN
		THEN
	THEN ;


NEW.WINDOW INFO.WINDOW
	6  Info.Window w.type
	Info.Window ON.ACTIVATE  Info.Loop			\ Just.Loop
	Info.Window ON.UPDATE    Info.Update
	
	' info.loop   Info.Window +on.newactivate !
	' info.events Info.Window +window.action  !



: CenterPict  ( pictHandle -- T'\L'\B'\R' )		\ was Pict.Size for some reason
	@ 2 + @RECT-E  Center.On.Screen  ;


: (ABOUT.ANYTHING)  ( pictHandle -- place picture in Info.Window )
	1 needed
	?dup IF
		dup CenterPict

		Info.Window +w.Type W@
		dup 4 =		\ if type 4..
		swap 6 =  OR	\ ..or type 6..
		IF		\ ..adjust window coords down by MBar-height (assume 20)
			2swap  20 0 +point		\ adjust top-right
			2swap  20 0 +point		\ adjust bottom-left
		THEN

		Info.Window +w.Type W@
		1 =		\ if type 1..
		IF		\ ..adjust window coords down by 6 pixels
			2swap  6 0 +point		\ adjust top-right
			2swap  6 0 +point		\ adjust bottom-left
		THEN

		\ S: T\L\B\R
		Info.Window W.Bounds

		PAD 30 blank   Pic.Res 20 erase
		PAD GetResInfo					\ get all info into PAD
		PAD 6 + Info.Window W.Title		\ use title from PAD+6
		PAD Pic.Res 6 CMOVE				\ copy other info to Pic.Res

		Get.Window ?Active.WPtr FALSE=
		IF
			Info.Window Close.Window
		THEN
		Close.Box  Info.Window W.Attributes
		kWindowCollapseBoxAttribute Info.Window NewWAttributes 
        Info.Window Add.Window
		Info.Window Show.Window
    ELSE
		Beep
    THEN  ;


 : About.Anything ( pictHandle -- )
	6 Info.Window W.Type
	Info.Window ON.ACTIVATE  Info.Loop	\ Just.Loop
	Info.Window ON.UPDATE    Info.Update
	['] info.loop   Info.Window +on.newactivate !
	['] info.events Info.Window +window.action  !
	(About.Anything)  ;


' about.anything  is show.about.anything 



StopIncluding ************************************
	



