
					*********************
					 MF EDITOR OVERVIEW
					*********************

Last Revision: 25 Feb 2012   ward@megawolf.com




***************************************************************
"Instant" Introduction to the Editor:

In an Untitled editor window (use NEW under the File Menu if needed) type
  V?  <enter key>
RIGHT-click in the word M4TH and select LOCATE

type a few characters of gibberish and hit the ENTER Key


RETURN key is an end of line as expected in a text editor.

ENTER key sends any selected text to the Forth Interpreter, or if there
us no text slected, sends the entire line of the insertion point

***************************************************************


The Old "manual" for the Editor follows below and has many tips and shortcuts,
although IT IS NOT COMPLETELY UP-TO-DATE.


I still need to clean up auto-horiz scroll and CRLF file handling, but overall
I am quite pleased with it - in colorized mode, it is much "snappier" than the
old version. 

One of Forth's big strengths is mutability.  You can redefine HOT as COLD or
RED as GREEN.  You can make new fancy creator words, special commenting tools,
DOES> words that spawn DOES> words, etc.  This flexible syntax does make it 
hard to handle syntax coloring.  I likely missed some classes of words that
would be useful to colorize, likely also some VFX words that would properly
fir in the existing categories.  New category types are welcome.  Color
choices of the current one have been heavily influenced by my Deuteranopia,
I selected only colors I can readily distinguish (note the abscence of greens
and browns).

Suggestions about color choices and Forth syntax to color are most welcome.



Here is a summary of some recent changes and tips

The Editor can display LF, CR or CRLF terminated files

The current EOL mode is displayed immediately to the left of the
	Horizontal Scroll Bar.  Click in this box to change the line
	endings of the current window.

Click in the little box at the far left of the horizontal scroll bar to
	change the "info mode"

Click in the odd little icon to the left of the horizontal scroll bar to
	enable/disable colorizing.


NOTE:
 CRLF files cannot be edited without changing to CR of LF termination.
 Colorizing is disabled for CRLF files.
 Selecting text, Searching and navigation functions may not work correctly
	in CRLF files.
 Display in CRLF files can get messed up (blank areas at top or bottom) that
	can be corrected by clicking the resize widget (lower right corner)




Many default settings, including font, colors, initial size, etc can be changed
	by editing Default.Extensions useing "Edit Launch Script" under the Options
	Menu. 
The new Autocompletion feature may be disabled under the Tools Menu or
	switched off by default by editing Default.Extensions
Suggest you open this file and change USERNAME$ (near the start of the file)
Others you might want to change are in the Editor Settings section:
	ShowOKPrompt
	Return.before.output

Example: 	
	PushAllRecentFiles .s  		\ enter key hit on this line
								\ Return.before.output adds an extra blank line here
	DATA STACK
	     top
	        9684966 0093:C7E6
	        9684952 0093:C7D8
	        9684938 0093:C7CA
	        9684924 0093:C7BC
	        9684910 0093:C7AE
	        9684896 0093:C7A0
	     -559038737 DEAD:BEEF
	
	ok \ 7 						\ ShowOKPrompt adds this
								\ NOTE: OK is a NOOP and can be safely executed
	


On a Mac, pressing the space bar when Option Key is down produces a
	non-breaking space character (ascii code 202).  Normally
	indistiguishable from regular spaces in text editors, most
	Forth compilers do NOT treat them as white space and can cause
	very inscrutable compilation errors.  The MF editor displays
	them as colored spaces so you cannot miss them --> 
	Unprintable control characters other than the usual ones (tab, LF, CR)
	are displayed as 


The current FIND Dialog has more options than described below.


Observe the File Menu while you press SHIFT or OPTION or OPTION+SHIFT


Use OPEN ANY AS TEXT to open/navigate to
- invisibles
- files inside bundles
- some text files that do not open with default settings (the explanation
	is long and painful - please make note of any you find that should be
	available by default).
- Just about any file can be opened with this, even ones that do not
	make sense to view in a text editor (try opening a big movie or music 
	file, up to a few hundred megs, I believe will work)
Possibly Open Any will go away and it will become the default behavior of
	Open.


Option-Return skips the auto-indent when entering text


Among my favorite shortcuts (detailed below) are

 Option-Click or Right Click a word to bring up shortcut popup menu.
 CMD-R (R for Reference) to LOCATE a selected word.
	- this version of locate first searches CONTEXT, if not found,
		proceeds to search all vocabs.
 Save&Include (cmd-K) is my #1 favorite. 
	- Does what it says to current Editor window
 Include (cmd-I) to include a file without viewing/editing it.
 Indent (cmd-]) & Outdent (cmd-[) for prettyprinting control structures, etc
	- works on a single line or on a range of lines
 CMD-U(pper) and CMD-L(ower) to force the case of selected text.
 Option-double-click a word to search for it from the top of the window.
 CMD-E(ditor) to rotate through visible editor windows.
 CMD-J for jump shortcuts, especially to the B(eginning) or E(nd) of the window.
 CMD-J..L to jump back to the last jumped from location.
 Folder Search option in Find


Shift or Caps Lock Key at launch - don't open empty editor window
OptionKey? at launch - do not open dragged files or old files on Lion


UNDO/REDO has had a MAJOR UPGRADE and needs additional testing to ensure
its behavior is robust and behaves as expected in all cases.



Major Items on To-Do list
 Add ability to restore prior session (re-open previously open files)
	- this is done by OS on Lion, so may not bother with this
 Fix occasional display weirdness with R-L auto-scrolling, especially in color
 Reduce redraw flicker sometimes noticeable with mouswheeel scrolling
 Fix display issues for CRLF files
 When Including, figure out a way to trim file name from the rest of the path
	in order to shorten it and make it easier to relocate a project


   ************************************************************************
   ************************************************************************
   ************************************************************************
   ************************************************************************


				***** USING THE MACFORTH EDITOR *****


Originally written by David Sibley (RIP), with enhancements from Don Colburn
(RIP), John Jeppson, Xan Gregg, Greg Guerin, Doug Hoffman, George
Furnival(RIP), Ward McFarland, and others, the "Sibley" MacForth Editor is a
very useful text editor for writing and modifying MacForth programs.  Up to
sixteen Editor Windows can be open at once (more if you make a trivial change
in the code.) Additionally, specialized variations of standard Editor windows
are used for the MacForth online glossary and a couple of other utilities
(Debugger and Log windows).  Full source code for the Editor is provided, so
you can make any changes or additions you desire. 


If MacForth is launched by double-clicking one of its text files, or by
dropping any text file(s) on its Finder icon, that text file (or files) will
be opened into Editor windows when MacForth launches.  If no text file was
selected from the desktop, an empty, untitled Editor Window is created when
MacForth is launched (unless the SHIFT key or CAPS LOCK is held down). 

The MacForth window (SYS.WINDOW) has no memory or scrollback features, so
Editor windows are commonly used instead of the MacForth window for
interactive programming, as well as editing source code or documentation. 
This is why our default is to present a blank Editor window when MacForth
starts if you did not launch by double-clicking a file and why we shrink the
MacForth window and move it to the bottom of the screen. 

Since you can interpret and execute MacForth code in an Editor window OR use
it for entering multiple lines of text as a regular editor, we have different
functions for the RETURN key and the ENTER key.  RETURN behaves like it would
in a standard editor, simply advancing the cursor to the next line for
additional text entry.  SHIFT-RETURN or ENTER behaves differently and passes
the selected range of text (or the entire current line, if no range is
selected) to the MacForth Interpreter for execution or compilation. 
OPTION-SHIFT-RETURN or OPTION-ENTER also executes the selected range of text
or current line, but is erases the selection and replaces it with any output
that is produced.  Output from executing MacForth code (including tracing)
is, by default, directed back to the Editor window.  Incremental program
building and testing is greatly facilitated in this manner. 

Although you should still do graphics prototyping in the SYS.WINDOW or a
window that you create specifically for that purpose, most other work is more
fluid using a Editor window.  Try it, we think you'll like it. 

When using the Editor interactively, standard words that change the FONT
(size, style, mode) are disabled.  To change the Editor's display, see
"Customizing the MacForth Editor" later in this document.  Monaco 9 point
font is the default assigned font and size. 

----------------------------------------------------------------------------

***IMPORTANT NOTE/WARNING***

Some call it a blessing, others call it a curse, but the MacForth Editor
allows multiple copies of the same file to be open at once in different
Editor windows.  It can be done on purpose or happen inadvertently (for
example, LOCATE will always bring up the original copy of the file containing
a word already defined - if that word is in a file you have modified in the
Editor, then you have 2 copies.)

It is a blessing when you want to recover something you accidentaly deleted
in a file you are editing and have not saved.  It is a blessing when you need
the functionality of a split-screen editor, which the MacForth Editor is not.
It is a blessing when you want to see the original line of code you just
modified.  It can be a curse when you have multiple MODIFIED
copies of the same file.  Worse, if you accidently Save both copies without
noticing.  A lesser curse is that the entire file is read into memory when
the Editor opens it, so if you are editing very large files on OS 9, be sure
to have ample Finder memory allocated to MacForth. 


The Editor will do three things to lessen the curse effect:
 - Any changes to an Editor window since it was opened or last saved will add
 a leading tilde (~) to the window title. 
 - Subsequent copies of a file already opened in the Editor will be opened
 with a window using a different background color than the window for the
 original copy. 
 - Attempting to SAVE a file that is open in multiple windows will cause a
 warning Alert explaining that there are multiple copies of that file open,
 giving you the option to cancel the SAVE. 

----------------------------------------------------------------------------

FILE MENU FUNCTIONS:
  (note: many file and edit menu items will be grayed out if an Editor 
         window is not the frontmost window.)

--> NEW (cmd-N) creates a new untitled Editor window, if fewer than sixteen
Editor windows are currently in use. 

--> OPEN (cmd-O) opens an existing text file for editing in a new Editor 
window, if fewer than sixteen Editor windows are in use.  Uses the Mac's
Navigation Services GetFile dialog box.

--> CLOSE (cmd-W) closes the frontmost Editor window (or the search dialog
window, if it is present).  If the Editor window contents have been modified,
prompts you to SAVE the current version. 

--> SAVE (cmd-S) saves contents of current Editor window, replacing the 
previous version on the disk.  

--> SAVE & INCLUDE (cmd-K) first does a SAVE (see above), then INCLUDEs
(i.e., compiles) that file.  If the window is Untitled, will do a SAVE AS
before the include.  This command is probably one of the most useful for
interactive program development. 

--> SAVE AS saves contents of current Editor window to a new filename and
changes the title of the window accordingly.  Uses the Mac's Navigation
Services PutFile dialog box. 

--> REVERT replaces contents of current Editor window with the last-saved 
version of the file.

--> FIND (cmd-F) Opens a dialog box to search and/or replace a given string.
Cut and Paste work as usual in the dialog. 
The Search Dialog allows several options:
   FOLDER -- this option forces a search of all files in the same folder as
     the file that is in the frontmost Editor window. 
   WHOLE WORD searches for all occurrences of the whole word.  You can set the
     delimeter for this search with the word DELIMITER.SET.  (The default
     delimiters are spaces and any punctuation character. 
   CASE SENS.  makes the search sensitive to UPPER/lower case. 
   
 The "CHANGE TO" text field and the change buttons should be self-explanatory.
 The CHANGE ALL button changes only those occurrences between the current
 cursor position and the end of the file.  (If the FOLDER option is checked,
 all occurrences of all files in the folder will be changed.)
Holding down the SHIFT key while selecting FIND (or using shift-cmd-F) forces 
the search to take place from the top of the file, rather than from the current
cursor location.

--> FIND SAME (cmd-G) Searches, from the current cursor location, for the
next occurrence of the string placed in the FIND dialog.  Holding down the
SHIFT key while selecting FIND SAME (or using shift-cmd-G) forces the search
to take place from the top of the file, rather than from the current cursor
location.  The Options selected by FIND stay in effect (like Folder Search,
Whole Word, Case Sensitive). 

--> FIND SELECTED (cmd-H) is a handy shortcut.  Select the text you want to
search for and hit cmd-H to find its next occurrence (pasting it into the
"SEARCH FOR" field of the Search Dialog).  Adding the Shift key when you use
this will search for the current selected text from the top of the file. 

--> EDIT (cmd-E) <next window> Brings the next open Editor window to the
front, while sending the current Editor window to the rear.  Effectively
"rotates" through multiple Editor windows. 

--> PAGE SETUP invokes the standard Macintosh Printer Setup dialog. 
Settings apply globally within MacForth and are not retained with specific
windows (unless you choose to modify the code).

--> PRINT prints the file selected from a Mac Navigation Services GetFile
dialog box, with simple formatting (named header, page#, etc.). 

--> PRINT SELECTION prints the selected range of text in the frontmost Editor
window.  If no text is selected, this menu item changes to PRINT WINDOW and
prints the current contents of the front window.

--> INCLUDE (cmd-I) uses a Mac Navigation Services GetFile dialog box to
allow you to select a file for loading (compiling). 

--> QUIT (cmd-Q)  exits MacForth and returns to the desktop.

----------------------------------------------------------------------------

EDIT MENU FUNCTIONS:
  (note: many file and edit menu items will not be enabled if an Editor 
         window is not the frontmost window.)

--> UNDO (cmd-Z) works for up to 8 keystrokes after reformatting, cut, paste,
delete or backspace, but before the next mouse click in the Editor window. 
It is replaced by REDO until the next key or mouse activity.  Some actions
are not undo-able, like text deleted by OPTION-ENTER or SHIFT-OPTION-RETURN. 

--> CUT (cmd-X) replaces the contents of the Clipboard with the current
selection range, deleting the current selection range in the process. 
Holding down the SHIFT key when CUTting causes the selection range to be
APPENDED to the contents of the Clipboard, rather than replacing it. 

--> COPY (cmd-C) replaces the contents of the Clipboard with the current
selection range.  Holding down the SHIFT key when COPYing causes the
selection range to be APPENDED to the Clipboard, rather than replacing it. 

--> PASTE (cmd-V) replaces the current selection range with the text
contained in the Clipboard. 

--> CLEAR deletes the current selection range in the Editor.  May be
canceled with UNDO. 

--> SELECT ALL (cmd-A) marks the entire file as the selection range.

--> PAGE BREAK inserts enough CRs from current insertion point (cursor) to
fill to the start of the next page (as determined by the variable
LINES/PAGE).  This may not exactly correspond to page numbers generated when
printing a file. 
  
--> GO TO PAGE# shows the current page# and allows you to jump to any other 
page#.  The insertion point (cursor) is NOT moved.

--> JUMP MARK (cmd-J) allows up to 10 invisible "marks" to be used. 
SHIFT-JUMP (or COMMAND-SHIFT-J) followed by a digit from 0-9 places a mark at
the current Insertion Point.  JUMP (or COMMAND-J) followed by a digit causes
the insertion point and display to "Jump" to the appropriate mark.  JUMP (or
COMMAND-J) followed by the letter "E" jumps to the End of the file, "B" to
the beginning, and "M" to the middle.  JUMP-"L" jumps to the Last location
JUMPed or searched from.  If the variable SAVE.MARKS is turned ON (default is
OFF), these marks will be saved into the resource fork of the file. 

--> UPPER CASE (cmd-U) converts the current selection range to upper case.

--> LOWER CASE (cmd-L) converts the current selection range to lower case.

--> MARGIN (cmd-M) re-formats the selection range into a paragraph.  TABs,
CRs, and multiple spaces are converted to single spaces.  The position of the
first character of the selection range is unchanged.  CRs are inserted so
that the text fits entirely within the current width of the Editor window. 
Two spaces will be placed after periods. 

--> R/L AUTOSCROLL when enabled causes the screen to autoscroll horizontally
to follow the current Insertion Point (cursor).  Vertical autoscrolling is
always enabled. 

--> AUTO INDENT when enabled causes each carriage return to copy the "white
space" (spaces and tabs) of the previous line.  It can be temporarily
disabled by using OPTION-Return instead of just Return. 


-----------------------------------------------------------------------------

OTHER MENU ITEMS AFFECTING THE EDITOR:

Some optional utilities add additional menu items that impact the Editor.


OPTIONS MENU:

--> Edit Launch Script opens the copy of Default.Extensions that was used
when you launched MacForth.

--> Edit Build Script opens the script file that was used to build the 
Extended MacForth kernel you are running.


TOOLS MENU:

--> Stamp emplaces a date/time stamp at the current cursor position using
the characters set in the INITIALS variable.

--> Reference uses the LOCATE function to bring up the definition of a word in
an Editor window if the source code is available (otherwise, it will bring up
the Glossary window). 

--> New Source File..  (opt-cmd-N) brings up a Mac Navigation Services PutFile
dialog box asking you to name a new file.  It then opens that file in the
Editor with some default "glue" filled in (which can easily be changed). 

--> Open Any File As Text..  (opt-cmd-O) brings up a Mac Navigation Services
GettFile dialog box that will allow you to open the text fork of ANY file. 
This can be useful for opening SimpleText files and other files containing
text that are not of file type TEXT.  Be careful, though, data files and
applications can fill the Editor window with gibberish or garbage characters. 

--> History Window creates a special Editor window that logs everything you
type in SYS.WINDOW.  (It will not log any text output generated by the word
that you execute).  This is useful for folks who prefer to work interactively
in SYS.WINDOW, but want a record of their activity that can be scrolled
through and saved. 


WINDOWS MENU:

--> Save All Editor Windows (opt-cmd-S) pretty much does what it says.  It is
equivalent to doing SAVE on all open Editor windows.  No warning prompts. 

--> Close All Editor Windows (opt-cmd-W) again, does what it says.  Unsaved
windows will generate the usual "Save Changes...?" dialog.

--> Discard Front Editor Window (shift-cmd-W) closes the front window. Does
NOT ask you if you want to save changes!!  Useful for quickly discarding a
window you did some scratch calculations in.

--> Stack Editor Windows repositions multiple Editor windows into a neatly
staggered "stack".

--> Tile Editor Windows repositions multiple Editor windows into tiles,
changing their sizes as necessary to make them all visible on the screen at
one time. 

--> Bring All To Front (OS X only) brings all MacForth windows, Editor
windows included, to the front of other applications.

--> All open windows will be displayed as items in the bottom part of this
menu.  Selecting any window from the menu will bring it to the front.


PROJECT MENU:
--> Files that you have been compiled into your current MacForth kernel show
up under this menu.  Selecting any of them will open that file into the
Editor. 

-----------------------------------------------------------------------------
-----------------------------------------------------------------------------

MISCELLANEOUS EDITOR FEATURES & SHORTCUTS:


--> Double-clicking anywhere within a word selects the entire word.

--> Triple-clicking anywhere on a line selects the entire line, including the
terminating carriage return. 

--> Clicking the mouse while pressing the SHIFT key selects the entire range
of text from the previous cursor location to the current mouse location. 
 
--> Holding the OPTION key down while double-clicking a word causes that word
to be pasted into the FIND dialog, and initiates a search from the TOP of the
file to find the first occurrence of that word in the file. 

--> OPTION-Drag to select text causes the selected text to be searched for. 

--> SHIFT-OPTION single-clicking uses the entire range from the previous mouse
position is used as the search string, and searches for that sequence from the
top of the file. 

--> CMD-double-clicking a word will attempt to bring up the vocabulary browser
tool (if available) with a list of close spelling matches displayed. 

--> Errors occurring during loading of a file or interpreting a selection
range (with ENTER or SHIFT-RETURN) will automatically select and highlight the
word producing the error. 

--> PAGE UP, PAGE DOWN, HOME, and END keys scroll the window without moving
the current insertion point. 

--> ARROW keys move the current insertion point in the specified direction.
	Command Key with an arrow key operates as follows:
	 - CMD-left arrow -- cursor to beginning of current line
	 - CMD-right arrow -- cursor to end of current line
	 - CMD-up arrow -- cursor to start of file
	 - CMD-down arrow -- cursor to end of file
	Shift Key with an arrow key operates as follows:
	 - SHIFT-left arrow -- includes one character to the left to selection
	 - SHIFT-right arrow -- includes one character to the right to selection
	 - SHIFT-up arrow -- includes one line up to selection
	 - SHIFT-down arrow -- includes one line down to selection
	Option Key with an arrow key operates as follows:
	 - OPT-left arrow -- moves cursor left one word
	 - OPT-right arrow -- moves cursor right one word
	 - OPT-up arrow -- moves cursor up a page
	 - OPT-down arrow -- moves cursor down a page

--> Doug Hoffman's INDENT tool (part of a standard MacForth Extended kernel)
allows you to indent an entire range of text, similar to the MPW Editor.  This
can help "pretty-print" your code.  If more lines are selected than are
visible in the Editor window, it does nothing. 

The shortcuts are:

	CMD-] (shift right) inserts a leading TAB on each selected line.
    CMD-[ (shift left) deletes a single non-visible character (space or
                       tab) at the start of each selected line. 

----------------------------------------------------------------------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------

CUSTOMIZING THE MACFORTH EDITOR

Many cosmetic features of the Editor are trivially set by the user.  Most of
these settings are initialized when MacForth launches and includes the file
"Default.Extensions". 

If you examine that file (use "Edit Launch Script" under the Options Menu),
you will see a section devoted to the Editor that should look something like
this:


EXISTS? SEDITOR					\ Editor Configurations
[IF]
	ALSO EDITOR 				\ add Editor vocabulary to search order
	 9 -> SE.TEXTSIZE
	11 -> SE.LINEHEIGHT
\ for those that prefer a bigger font:
\	12 -> SE.TEXTSIZE			
\	14 -> SE.LINEHEIGHT
	HAVING  GET.FONT.NUMBER " Monaco" GET.FONT.NUMBER -> SE.TEXTFONT
	LACKING GET.FONT.NUMBER 4 -> SE.TEXTFONT
	480 500 SET.SE.WINDOW.WH ( width\height -- )
	HEX
	HAVING !RGB		RGBWHITE @RGB	SE.BACKCOLOR		!RGB
	HAVING !RGB		RGBBLACK @RGB	SE.FORECOLOR		!RGB
	HAVING !RGB		FAE1 F852 BAE2	SE.DUPLICATECOLOR	!RGB
\ for those that prefer warmer colors:
\	HAVING !RGB		EBD1 FFB1 FFB1	SE.BACKCOLOR		!RGB
\	HAVING !RGB		0000 0000 FFFF	SE.FORECOLOR		!RGB
	DECIMAL
	SAVE.MARKS  ON				\ enable saving of Editor JUMP marks
	SE.RESTORER ON				\ enable restoring of prior Editor selection
	[CHAR] ~ -> THECHANGEDMARK	\ set prefixed mark for changed files
	800 -> PREFERREDSEZOOMWIDTH	\ set max zoomed out width
	NEWSEARCHMODE OFF			\ go to start of file when search fails?
	PREVIOUS					\ restore vocabulary search order
[THEN]



SE.TEXTSIZE & SE.LINEHEIGHT should be self-explanatory.  (You can change the
Monaco font for any MONOSPACED font you have installed.)

SET.SE.WINDOW.WH is used to modify the default initial dimensions of Editor
windows when they are opened.  Bigger might suit if you have a large monitor,
smaller perhaps for an iMac or laptop. 

SE.BACKCOLOR and SE.FORECOLOR are the colors used for background and text,
respectively.  You can use the Mac Color Picker to get the hex RGB values for
any colors you like and plug them in here (see the SetColors example at the
very end of the file "More Colors")

SE.DUPLICATECOLOR is the background color for duplicate copies of the same
file (see Important Note above).  You should NOT pick white for this unless
you have a masochistic streak. 

SAVE.MARKS is a flag that determines if the position of the Jump Marks (above)
are saved and restored when the file is saved. 

SE.RESTORER is a flag that determines if the current selection is saved and
restored when the file is saved.

THECHANGEDMARK is the character prepended to the window title when the
contents have been changed.

PREFERREDSEZOOMWIDTH is the default maximum zoomed out width.

NEWSEARCHMODE is a flag that determines the selection range after a search
fails.  If you search a file for occurrences of XYZ, and another occurrence is
not found, you get the "Not Found" alert.  If NEWSEARCHMODE is OFF, when you
dismiss the alert, your insertion point will be at the start (top) of the
file.  If NEWSEARCHMODE is ON, your insertion point or selection will remain
where it was before the search. 



----------------------------------------------------------------------------

ADVANCED EDITOR SETTINGS:

Some or all of these can be added to the Editor configuration section of
"Default.Extensions" for additional fine tuning of the Editor. 


Additional control over initial Editor position can be attained.  If you want
your Editor windows to open in the lower part of the screen, you could put
something like this above the line with SET.SE.WINDOW.WH:

 200 EDITOR.BOUNDS W!	   \ for top
  50 EDITOR.BOUNDS 2 + W!  \ for left edge


If you want to speed or slow the scrolling speed, use:

 2 -> SE.SCROLL.SPEED	\ scrolling via scroll-bar arrows
 8 -> SE.PAGE.SPEED		\ scrolling via scroll-bar pageup/down


Ordinarily files of type TEXT are the only ones that can be opened by the
Editor.  The user can add one, two, or three additional file types by using:

  ASCII XXXX  ALSO EDITOR SE.FileTypeList    !	\ if need one extra file types
  ASCII YYYY  ALSO EDITOR SE.FileTypeList 4+ !	\ if need 2 or 3 extra types
  ASCII ZZZZ  ALSO EDITOR SE.FileTypeList 8+ !	\ if need 3 extra types
(where XXXX , YYYY , and ZZZZ are 4 character Mac file type designations).


  0 ALSO EDITOR SE.FileTypeList !		\ allows Editor to open ANY type of file
										\ including ones that have no editable text

----------------------------------------------------------------------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------

\ ***************************************************************************
\ (c) Copyright 2004  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to registered MacForth customers to use this
\   source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************

