
OH, DAMN!  I crashed and don't know why or even where !



Since I have crashed/hung/exploded in almost every conceivable way in
the process of transporting MacForth to aa significantly different
environment, of necessiy I added a fair number of debugging goodies.

Some are more useful in diagnosing issues that occur when your code is
/mostly/ working,  Others when your Turnkey won't even complete the
launch process.



The first words I added were very brute-force (i.e., crude):
They were, however, a BIG help getting the startup code working to the
point where I could get Sys.Window up and handling text io and events.

GiveNotice ( str -- )
GiveNotice2 ( n\str -- )
GiveNotice3 ( str2\str -- )
NoticeDump ( addr\cnt\str -- )

Try them - they post an alert (and of course pause things so you can
visually check on what your code has done so far) with various messages
or numeric information.  I would sprinkle a number of them through a
problem stretch of code that simply gave messages like
 "Step 1"  "Step 2"  "Opened ResFile"  "About to DO.EVENTS"



 LOGFILE 

MacForth can (and does by default) create a log file, typically kept
inside our bundle, but can be assigned to our local folder (see
KeepLogFileInside in Default.Extensions)

This file can be quickly opned to view in the Editor using 
"Options Menu:View Log File"

StartLogging can be used to enable logging to this file (this is the
default set at startup)

StopLogging disables logging until StartLogging is executed again.

While TYPE->LOG NUM->LOG SPACE->LOG CR->LOG can be used in your code to
write stuff to this file, the easiest way to do it is to use 
LOG[[  and  ]]LOG

\ <---- select text from here
LOG[[ 

cr ." any text output between these words is written to the log file"
cr ." without disturbing the currentl active window"
cr .S  .RS
here 100 dump
\ ... etc

]]LOG
\ <---- to here and hit ENTER key.  

Then Options Menu: View Log to see the result


All sorts of diagnostic or progress messages can be written to the log
file. 



 SYSLOG 

OS X maintains a number of diagnostic log files that can be easily viewed
by /Applications/Utilities/Console

We can write some diagnostic information in System.Log

ConsoleLogging ON  enables the log messages to get written

SysLogMsg1 ( c$ -- )  writes a single string
SysLogMsg2 ( c2$\c1$ -- )  writes 2 strings
SysLogNumber ( n\c1$ -- )  writes a string and number (as in  myvariable = 27 )
SysLogNumber+Depth ( n\c1$ -- ) as above, but also shows the current stack depth

These are part of the default MacForth error handlers to log error
messages if

ErrorLogging ON

SysLogError#   SysLogAbort#


Several of these messages are present in the MacForth startup code to
help identify problems during early startip (before any windows are
open). 
If you use Console to look at your system.log, you should see something
like this:

Jul 25 16:56:13 iMac2009 ward[1813]: [MFonVFX] stat: RootResources.rsrc opened
Jul 25 16:56:13 iMac2009 ward[1814]: [MFonVFX] stat: PRELUDES done
Jul 25 16:56:13 iMac2009 ward[1815]: [MFonVFX] stat: ioR during StartLogging -48
Jul 25 16:56:13 iMac2009 ward[1816]: [MFonVFX] stat: MacForth Log Opened
Jul 25 16:56:13 iMac2009 ward[1817]: [MFonVFX] stat: RESTORER done
Jul 25 16:56:13 iMac2009 ward[1818]: [MFonVFX] stat: including Default.Extensions
Jul 25 16:56:13 iMac2009 ward[1819]: [MFonVFX] stat: ioR during StartLogging -48
Jul 25 16:56:13 iMac2009 ward[1820]: [MFonVFX] stat: finished Default.Extensions
Jul 25 16:56:13 iMac2009 ward[1821]: [MFonVFX] stat: finished M4PLSTART1
Jul 25 16:56:13 iMac2009 ward[1822]: [MFonVFX] stat: SE.AEOPENFILE Debugging Tips.fth

(the -48 ioR indicates only that a Log File alreay exists)


This is a good place to record messages for code you distribute to other
users to help you diagnosing errors "in the field"


One caveat: Avoid non-text characters and numbers in your message strings (like  >  $  etc)
as those may be interpreted by the OS as commands:

C" TYPE->LOG COMPLETED" SYSLOGMSG1

will put
TYPE- COMPLETED
into the log and create a file named LOG in your current directory
;-)




 TRACE 

Sometimes you need to figure out why a section of code is not producing
the expected result. or why a loop isn't exiting properly, or why the
stack is growing/shrinking.  The Trace function can be helpful for this.

The trace option provides a compile-time, elective trace feature.  It is
activated with the command
TRACEON
Basically, this option instructs the compiler to compile new definitions
in such a way that if DEBUG is ON when they are executed, the name of
each word will be printed along with the depth and contents of the stack. 

For an example, paste this snippet in an editor window,

TRACEON
DEBUGFILE ON

: TESTME
	10 0 DO
		." #" I . 
	LOOP ;

TRACEOFF
DEBUG ON 
TESTME

Then select the code and hit Enter to compile it

Because the definition was compiled with the trace option on, the name of
each word the definition executes is printed along with the contents of
the stack.  The debug option enables and disables the run-time trace
options out- put.  Now execute
DEBUG OFF TESTME

You will see that the trace is not performed when debug is off.


How Trace Works

The trace option disables the code optimizer and forces compilation of
the trace token before each compiled word.  This means that a great deal
of overhead is carried with each word when it is executed with the trace
option on.  To get accurate timing information in time-critical
operations, and for production applications code, disable the trace
feature and recompile the code. 


Trace output is generated to the current DEBUGFILE (which can be either a
file reference number or a windows pointer) at run time.  If no DEBUGFILE
has been opened, output is to the current OUTFILE.  To open a DEBUGFILE,
use something like

100 c" mylogfile" NEW.FILE DEBUGFILE !
or if that file already exists,
c" mylogfile" OPEN$ DEBUGFILE !




  THE "S." Family  

When diagnosing problems with deeply nested code operating in its own
non-interactive window, as in the Editor or the Vocab Browser, it is
often useful to check a value or the stack when one of the inner words
is executed.  Trace can be done to a file, but it is often excessively
verbose.
We have a group of words that will display in Sys.Window
without interfering with the acrions of the window under test.

The words look like standard output words, prefixed with "S.":

S.TYPE ( addr\cnt -- )
S. ( N -- )	
S.CR ( -- )
S.DUMP ( addr\cnt -- )
S.S ( .. -- .. )
S.RS ( .. -- .. )

I left some commented out examples in Vocabulary Browser for examples

