\ Color Picking
\ Created:       07/09/08  11:05:46 AM  wjm
\ Last Revision: 13 Dec 2011  05:19:22  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


(* *************************************************************************

Execute PAC (for Pick A Color ) in an Editor window

Select color from the ColorPicker tool

Returns a color definition all ready to name.


example output:

hex# F000  hex# 6423  hex# 3CB9  RGBColor  <pickaname> 


To start from a given color and "tweak it", you can do:

	hex# 4F6A  hex# 4040  hex# 0000 thePickedColor !rgb
	PAC

************************************************************************* *)

Only Forth Definitions

anew --Color_Picking--

>m4th
Decimal


RGBLtGray @RGB RGBColor thePickedColor

: .COLOR
	base @ >R
	hex
	." hex# "
	s>d <# # # # # #> type
	2 spaces
	R> base !
;


: PAC ( -- ) \ PICK A COLOR
	0 c" pick a color, any color" 
	thePickedColor thePickedColor GetColor
	IF
		cr
		thePickedColor @RGB
		rot .COLOR
		swap .COLOR
		.COLOR
		." RGBColor  <pickaname> "
	ELSE
		cr ." Cancelled"
	THEN
;



StopIncluding ************************************

after including,
select the next line ( PAC ) and hit ENTER

PAC


hex# 6388  hex# 4BB3  hex# F000  RGBColor  <pickaname> 

