\ Finger Paint example from the PowerMacForth manual
\ added a menu item to change the pen color
\ Last Revision: 9 Jan 2012  21:14:42  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************

only FORTH Definitions
decimal

anew demomarker

>m4th


new.window SHEET
	C" Finger Paint Window"		sheet w.title
	60 60 460 460				sheet w.bounds
	size.box close.box +		sheet w.attributes
having kWindowCollapseBoxAttribute  kWindowCollapseBoxAttribute sheet NewWAttributes  \ 6.053
\	sys.window					sheet w.behind


variable ConnectTheDots		ConnectTheDots OFF

rgbblue @rgb RGBColor theForeColor


: TRACE.FINGER ( -- )
	ObscureCursor
	@mousexy dot
	BEGIN
		StillDown
	WHILE
		@mousexy 
		ConnectTheDots @
		IF
			draw.to
		ELSE
			dot
		THEN
	REPEAT
	ShowCursor ;


: FINGER.PAINT  ( activate flag -- )
	IF
		theForeColor RGBForeColor
		BEGIN
			do.events
			CASE
				mouse.down	OF trace.finger ENDOF
				in.size.box	OF page			ENDOF
			ENDCASE
		AGAIN
	ELSE
		Beep
	THEN ;


: SelectFingerColor ( -- )
	0 c" pick a foreground color"  RGBLtGray theForeColor GetColor
	drop ;




15 constant FINGER.SIZE.MENU

: DO.FINGER.MENU  ( item# -- )
	0 HiliteMenu
	Get.Window >R 
	sheet window
	CASE
		1 OF 1 1 PenSize		 	 ENDOF
		2 OF 3 3 PenSize		 	 ENDOF
		3 OF 5 5 PenSize 		 	 ENDOF
		5 OF ConnectTheDots toggle32 ENDOF
		6 OF SelectFingerColor   	 ENDOF
	ENDCASE
	5 ConnectTheDots @ boolean finger.size.menu item.check
	r> window ;


: FINGER.MENU  ( -- )
	FINGER.SIZE.MENU DELETE.MENU
	0 C" The Finger" FINGER.SIZE.MENU NEW.MENU
	C" Small;Medium;Large" FINGER.SIZE.MENU append.items
	C" (-;Connect The Dots;Select Color" FINGER.SIZE.MENU append.items
	DrawMenuBar
	FINGER.SIZE.MENU menu.selection: do.finger.menu ;




finger.menu

sheet on.activate finger.paint
sheet add.window
