\ Finger Paint example from the PowerMacForth manual
\ converted to a turnkey

\ ***************************************************************************
\ (c) Copyright 2003  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to registered MacForth customers to use this
\   source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************

only FORTH Definitions
decimal
>m4th

\ ***************************************************************************
\ We first remove a lot of unnecessary tools to reduce the kernel size.
\ Even better would be to create a "minimal Root Extender Script"
\	and rebuild a new Extended Kernel to Turnkey from scratch

--NOTOOLS--

\ ***************************************************************************



new.window sheet
	here ," Finger Paint Window"	sheet w.title
\	60 5 200 300					sheet w.bounds
	60 20 400 600					sheet w.bounds
	size.box close.box +			sheet w.attributes
having kWindowCollapseBoxAttribute  kWindowCollapseBoxAttribute sheet NewWAttributes  \ 6.053


: TRACE.FINGER
	ObscureCursor	\ HideCursor
	@mousexy dot
	BEGIN
		StillDown
	WHILE
		@mousexy
		draw.to			\ dot
	REPEAT
	ShowCursor ;



: FINGER.PAINT  ( activate flag -- )
	IF
		sheet outfile !	\ need this for PAGE to work (it uses EMIT)
		BEGIN
			do.events
			CASE
				mouse.down   OF trace.finger ENDOF
				in.size.box  OF page 		 ENDOF
				in.close.box OF bye 		 ENDOF
			ENDCASE
			?keystroke IF drop beep THEN
		AGAIN
	ELSE
\		Beep
	THEN ;

sheet on.activate finger.paint


15 constant FINGER.SIZE.MENU

: DO.FINGER.MENU  ( item# -- )
	0 HiliteMenu
	Get.Window >R sheet window
	case
		1 of 1 1 PenSize endof
		2 of 3 3 PenSize endof
		3 of 5 5 PenSize endof
		\ 4 is separator
		5 of page		 endof
	endcase
	r> window ;



: FINGER.MENU  ( -- )
	0 C" Finger Size" 		finger.size.menu new.menu
	C" Small;Medium;Large"	finger.size.menu append.items
	c" -(;Clear Window" 	finger.size.menu append.items
	DrawMenuBar
	finger.size.menu menu.selection: do.finger.menu ;



: DO.TURNKEY ( -- | Turnkey startup word )
	\ We enter TurnkeyToken with 
	\	PRELUDES chain already excuted
(( 
		INSTALLCOMMANDEVENTHANDLER 
		INITTESCRAP 
		SETSIGTRAPS2 
		MAKEBINARYNIBUPP 
		RESTOREWINDOWACTIVATEHANDLER 
		INSTALLAPPLICATIONEVENTHANDLER 
		INITIALIZEEVENTQUEUE 
		INSTALLCOREAEVENTHANDLERS 
		SETNEXTFLUSHTIME 
 ))
	\	RESTORER chain NOT executed
	\   NO windows added
	\	NO menus added  ( room for 32 alloted )
	\	default directories as in the start of M4PLSTART1
	\	RootResources.rsrc open 
	\	has NOT run DEFAULT.EXTENSIONS
	\	Event Queue has been flushed

	\	All USER Variables OFF
	\		including EVENTS  IO.EVENTS  OUTFILE  INFILE  EVENT.FILTER
	\   except MFCONSOLE set to DFLT.CON
	\	EVENTS OFF
	\	OLD.WINDOW.BEHAVIOR ON
	\	CREATOR set from Info.plist

	apple.menu  
	edit.menu  -edit.menu
	finger.menu

	init.cursor
	ShowCursor

    sheet add.window

  	events on
	event.loop ;


turnkey do.turnkey

\ tky do.turnkey ATurnkey


\\
