\ Hello World Turnkey.fth
\ Created:       12 May 2012  07:23:19  ward@megawolf.com
\ Last Revision: 12 May 2012  07:23:19  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to registered MacForth customers to use this
\   source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


(* *************************************************************************

A 30 line (not counting comments) minimal Turnkey maker script

************************************************************************* *)

Only Forth Definitions
>M4TH
Decimal


\ ***************************************************************************
\ We first remove a lot of unnecessary tools to reduce the kernel size.
\ Even better would be to create a "minimal Root Extender Script"
\	and rebuild a new Extended Kernel to Turnkey from that

--NOTOOLS--				\ forgettable marker


\ ***************************************************************************
\ now we add our minimal application code..


new.window HelloWindow
	here ," My First Turnkey"	HelloWindow w.title
	60 5 200 300				HelloWindow w.bounds
	close.box 					HelloWindow w.attributes


: Do.Hello ( flag -- )	\ trivial activate word
	IF
		BEGIN
			do.events in.close.box =
			IF		\ only one window, so just quit if they close it
				bye
			THEN
		AGAIN
	THEN  ;
	
HelloWindow on.activate Do.Hello


: SayHello ( -- )	\ simple window update word
	page cr cr
	." Hello World" ;
	
HelloWindow on.update SayHello


\ ***************************************************************************
\ now we add our turnkey word to start it up

: DO.TURNKEY ( -- | Turnkey startup word )
	apple.menu 
	init.cursor
	ShowCursor
    HelloWindow +wbounds @rect center.on.screen HelloWindow w.bounds
    HelloWindow add.window
  	events on
	event.loop ;


\ ***************************************************************************
\ finally we execute the word to make the turnkey

TURNKEY" Hello World.app"  DO.TURNKEY






stopincluding *********************************************************
******************* comments and/or test code below *******************
***********************************************************************
