\ Editor Turnkey.fth
\ Created:       30 Apr 2012  14:45:53  ward@megawolf.com
\ Last Revision: 30 Apr 2012  14:45:53  ward@megawolf.com


\ Edit SrcTemplate1 & SrcTemplate2 in the Resources folder of the MFonVFX
\ 	Bundle to change the default contents of this file


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to registered MacForth customers to use this
\   source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


(* *************************************************************************

--> general description and/or comments <--

************************************************************************* *)

Only Forth Definitions

\ anew --Editor_Turnkey.fth--

>M4TH

having MetaComment.ToolGroup  forget MetaComment.ToolGroup

>M4TH

(( 

Should forget & rebuild the Tools Section with only those tools we actually
want to have in the Turnkey


))



>M4TH
Decimal


include" MF Remote/Remote Editor2.fth"


also editorvocab

\ PreferenceMenuAction


' (Se.quit) is se.quit

\ ' beep is  se.enterKey
	false -> GenINI?


: TkyEditor
	apple.menu  
\	file.menu
\	1 false FileMenu# Item.Enable 	\ disable INCLUDE...
	edit.menu  -edit.menu
	init.cursor
	ShowCursor
	
\ ? disable Ini file ?
	s" MFEditor.ini"  AppSuppIni$ place		\ a unique name to be sure it isnt created

\ Help Menu



\ initialize editor
\ open prefs
\ add Enable Remote
(( 
\ Open Document Types
0 -> #FILETYPES		\ allows drag and drop of anything our plist allows
\ 4 -> #FILETYPES	\ traditional PMF behavior, uses SE.DfltFileType


\ Editor Interpreter behavior
 	Return.before.output ON			\ change to OFF to be like VFX
 	ShowOKPrompt  ON				\ show OK prompt after Interpret
 	1 -> +CR						\ 2 gives extra terminating CR

\ Line Ending options.  LF=EOL  or  CR=EOL  can be used
	LF=EOL -> default.EOLMODE		\ For new Editor windows
	LF=EOL -> Interpreter.EOLMode	\ EOL expected by owning Forth
	true   -> useCRsInScrap?		\ converts LFs to CRs in SCRAP
 
\ Other options
	4 to SE.TABS				\ # spaces between tab stops

	127 to MissingCharChar		\ use this for unknown control chars (empty rect)
	\ 240 is another alternative

\ last page behavior
	true TO WILLSHOWBLANKPAGE	\ show a blank page?
	10   TO NUMPRIORLINES		\ how many lines to leave at top

\ miscellany
	SAVE.MARKS  ON				\ enable saving of Editor JUMP marks
	SE.RESTORER ON				\ enable restoring of prior Editor selection
	RESTORE.POSITIONS ON		\ enable restore of editor window size/position
	CHAR ~ -> THECHANGEDMARK	\ set prefixed mark for changed files
	800 -> PREFERREDSEZOOMWIDTH	\ set max zoomed out width

	2 -> SE.SCROLL.SPEED
 	8 -> SE.PAGE.SPEED


\ fonts
	 4 -> SE.TEXTFONT			\ Monaco
	11 -> SE.TEXTSIZE
	14 -> SE.LINEHEIGHT

	\ slightly prettier than Monaco, IMO
	c" Andale Mono" GET.FONT.NUMBER ?dup 
	[IF] 
		   -> SE.TEXTFONT
		13 -> SE.TEXTSIZE
	[THEN]



\ basic editor colors
hex
\	RGBBlack   @RGB RGBColor SE.ForeColor		\ default
\	RGBWhite   @RGB RGBColor SE.BackColor

	RGBMAGENTA @RGB INFOFORECOLOR		!RGB
	RGBLTGRAY  @RGB INFOBACKCOLOR		!RGB

	FAE1 F852 BAE2	SE.DUPLICATECOLOR	!RGB

\ OPTIONAL - use more lively colors
\ comment out if you want to stay Black on White

	0000 14A6 7C68	SE.FORECOLOR		!RGB

\ bluish shades
\	F123 F349 FFFF	SE.BACKCOLOR		!RGB
\	F891 f9a4 FFFF	SE.BACKCOLOR		!RGB
	Fa6c fb3a FFFF	SE.BACKCOLOR		!RGB


\ increasingly pale shades of beige for background color
\ comment all out to retain white background
\	F7BA F7FF EE6B	SE.BACKCOLOR		!RGB
\	FEB7 FE13 EEB7	SE.BACKCOLOR		!RGB
\	FF5B FF09 F75B  SE.BACKCOLOR		!RGB

	FFAD FF84 FBAD  SE.BACKCOLOR		!RGB

\	Fc48 fcd1 FFFF	SE.BACKCOLOR		!RGB

decimal


\ Set Editor Font colors & styles for Syntax Colorizer
EXISTS? !EditorStyle
[IF]
	false to ColoredDrags		\ True for slower, but continuous color updating
	plain		rgbBlack				PlainTextColor 		!EditorStyle
	plain		rgbBlue					CreatorColor 		!EditorStyle
	plain		rgbRed					ConditionalColor 	!EditorStyle
	plain		rgbTangerine			LoopColor 			!EditorStyle
	plain		rgbMidnight				TickColor 			!EditorStyle
\	underline	rgbDkGray				QuoteColor 			!EditorStyle
	underline	rgbSkyBlue				QuoteColor 			!EditorStyle
	plain		rgbOrange				LocalsColor 		!EditorStyle
	
	plain		rgbSteelColor			CommentColor		!EditorStyle
\	plain		rgbVeryDkGrayColor		CommentColor 		!EditorStyle
	plain		rgbSteelColor			MetaCommentColor 	!EditorStyle
\	plain		rgbVeryDkGrayColor		MetaCommentColor 	!EditorStyle
\	plain		rgbCyan					MetaCommentColor 	!EditorStyle
	italic		rgbCyan					SpecialCommentColor	!EditorStyle
	
	plain 	  	rgbOlive				[Conditional]Color 	!EditorStyle
	plain 		rgbSalmon				VocabColor 			!EditorStyle
	plain 		rgbAqua					StructureColor 		!EditorStyle
	plain 		rgbBrown				SelectorColor 		!EditorStyle
    underline	rgbOrange				HUH?Color 			!EditorStyle

	underline	rgbBlack				InterpretedColor 	!EditorStyle
	underline	rgbRED					CommandColor 		!EditorStyle
[THEN]


\ Set preferred Editor Window initial sizes
	screen.bounds 6 + W@ 100 - 2 /	\ width max is 1/2 screen width
	600 min
	SYS.WINDOW +WBOUNDS  W@			\ top of sys.window
	100 -
	SET.SE.WINDOW.WH

 ))

	INITIALIZEEDITORWINDOWPOSITIONS
	(INSTALL.SE)
	INSTALLEDITORHANDLERS
	ADJUSTSESIZETOSCREEN
	ENABLEEDITORERRORRECOVERY

	Tools.Menu
	InstallWindowsMenu


\ modify popup
	InstallEditorPopup


	InstallDSTool
	Install.Help.Menu
	
	InstallRecentFilesTool
	InstallAutoCompletionTool
	
	
	StartRemoteEditor

	skip.events OFF
	events on							\ enable events
	event.loop
;


turnkey" editor.app" TkyEditor

