\ Simple Nib Control Demo
\ Created:       04/14/05  11:50:39 AM  wjm
\ Last Revision: 06/04/06  04:48:58 PM  wjm
\ Last Revision: 13 Jan 2012  15:29:13  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved.
\ Permission is hereby granted to VFX Forth for Mac customers
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited.
\ ***************************************************************************


(* *************************************************************************

this version needs OS 10.6 or higher

A simple RPN Calculator built on a Nib Window

************************************************************************* *)



Only Forth Definitions
Decimal

anew --Calculator_Nib_Demo--	\ forgettable marker

>m4th


FpSystem 0 =
[if]
	include" lib/x86/Ndp387.fth"	\ s" lib/Ndp387.fth" included
	: FP-INIT ( -- )
		finit
	;

[then]


\ a couple of Toolbox calls we need to add..

extern: UInt32 UPP   NewControlUserPaneDrawUPP ( UInt32 procptr );
extern: UInt32 OSErr SetControlFontStyle ( UInt32 ControlRef, UInt32 * ^FontStyleRec );
extern: void DisposeControlUserPaneDrawUPP ( UInt32 procptr );


variable DrawBkgPaneUPP  DrawBkgPaneUPP off
variable CalcFormat   	 1 CalcFormat !			\ set by the Format popup
variable CalcPrecision   1 CalcPrecision !		\ set by the Precision popup
variable CalcMode		 1 CalcMode !			\ set by the Mode popup


\ create the MacForth window that will hold our NIB Window..
new.window CalculatorNibWindow



\ ----------------------------------------------------------------------------

64400 64400 55739  rgbcolor RGBCalcColor
62000 dup dup      rgbcolor RGBVeryLtGray

\ ----------------------------------------------------------------------------
\ This is the control action for all the buttons
\ All the controls will do is post a special event with the controlID and controlSIG
\	- Carbon Events posted from our Nib controls will be handled by a ProcPtr
\	- ProcPtr's maintain their own private (and transient) data and floating stacks
\	- Thus, to get data moved to our normal Floating Stack from a Carbon Event,
\		we use the Carbon Event handler to post a normal MacForth event.


13 constant IN.CALCULATOR.BUTTON	\ pseudo-event posted by clicking a calculator button


: DoCalculatorControl ( EventRef\mfCtrl -- result)
	dup  20 + @		\ controlID
	swap 16 + @		\ controlsig
	get.window @
	in.calculator.button
	MakePrivateEvent ( Modifiers\Where\Message\Event# -- )
	scratch.event.record PostPrivateEvent ( ^eventrecord -- )
	eventNotHandledErr
;

\ ----------------------------------------------------------------------------
\ cleanup word to put things back when we forget this

: ForgetCalculator ( -- )
	['] pause   in.calculator.button 4 * event.table + !
	DrawBkgPaneUPP @ DisposeControlUserPaneDrawUPP
; on.forget ForgetCalculator

\ ----------------------------------------------------------------------------
\ this is just a "User Pane" for allowing colorizing the main display...

1						\ control ID from IB
ascii bkgd				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: DispBkgdCtrl ( ID\sig\wptr -- )

\ ----------------------------------------------------------------------------
\ These are the static text controls used for the display...

1						\ control ID from IB
ascii disp				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: MainDispCtrl ( ID\sig\wptr -- )

2						\ control ID from IB
ascii disp				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: MsgDispCtrl ( ID\sig\wptr -- )


\ ----------------------------------------------------------------------------
\ These are the three popup menu controls..

1						\ control ID from IB
ascii form				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: FormatCtrl ( ID\sig\wptr -- )
' DoCalculatorControl FormatCtrl !NibControlAction
CalcFormat FormatCtrl !NibControlVariable ( addr\nibctrl -- )

2						\ control ID from IB
ascii form				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: PrecisionCtrl ( ID\sig\wptr -- )
' DoCalculatorControl PrecisionCtrl !NibControlAction
CalcPrecision PrecisionCtrl !NibControlVariable ( addr\nibctrl -- )

3						\ control ID from IB
ascii form				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: ModeCtrl ( ID\sig\wptr -- )
' DoCalculatorControl ModeCtrl !NibControlAction
CalcMode ModeCtrl !NibControlVariable ( addr\nibctrl -- )


\ ----------------------------------------------------------------------------
\ These are the numeric buttons...

0						\ control ID from IB
ascii num_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: NumCtrl0 ( ID\sig\wptr -- )
' DoCalculatorControl NumCtrl0 !NibControlAction

1						\ control ID from IB
ascii num_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: NumCtrl1 ( ID\sig\wptr -- )
' DoCalculatorControl NumCtrl1 !NibControlAction

2						\ control ID from IB
ascii num_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: NumCtrl2 ( ID\sig\wptr -- )
' DoCalculatorControl NumCtrl2 !NibControlAction

3						\ control ID from IB
ascii num_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: NumCtrl3 ( ID\sig\wptr -- )
' DoCalculatorControl NumCtrl3 !NibControlAction

4						\ control ID from IB
ascii num_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: NumCtrl4 ( ID\sig\wptr -- )
' DoCalculatorControl NumCtrl4 !NibControlAction

5						\ control ID from IB
ascii num_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: NumCtrl5 ( ID\sig\wptr -- )
' DoCalculatorControl NumCtrl5 !NibControlAction

6						\ control ID from IB
ascii num_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: NumCtrl6 ( ID\sig\wptr -- )
' DoCalculatorControl NumCtrl6 !NibControlAction

7						\ control ID from IB
ascii num_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: NumCtrl7 ( ID\sig\wptr -- )
' DoCalculatorControl NumCtrl7 !NibControlAction

8						\ control ID from IB
ascii num_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: NumCtrl8 ( ID\sig\wptr -- )
' DoCalculatorControl NumCtrl8 !NibControlAction

9						\ control ID from IB
ascii num_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: NumCtrl9 ( ID\sig\wptr -- )
' DoCalculatorControl NumCtrl9 !NibControlAction


\ ----------------------------------------------------------------------------
\ These are the "command" buttons...

0						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: DecPtCtrl ( ID\sig\wptr -- )
' DoCalculatorControl DecPtCtrl !NibControlAction

1						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: EnterCtrl ( ID\sig\wptr -- )
' DoCalculatorControl EnterCtrl !NibControlAction

2						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: PlusCtrl ( ID\sig\wptr -- )
' DoCalculatorControl PlusCtrl !NibControlAction

3						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: MinusCtrl ( ID\sig\wptr -- )
' DoCalculatorControl MinusCtrl !NibControlAction

4						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: TimesCtrl ( ID\sig\wptr -- )
' DoCalculatorControl TimesCtrl !NibControlAction

5						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: DivideCtrl ( ID\sig\wptr -- )
' DoCalculatorControl DivideCtrl !NibControlAction

6						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: DeleteCtrl ( ID\sig\wptr -- )
' DoCalculatorControl DeleteCtrl !NibControlAction

7						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: EEXCtrl ( ID\sig\wptr -- )
' DoCalculatorControl EEXCtrl !NibControlAction

8						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: NegateCtrl ( ID\sig\wptr -- )
' DoCalculatorControl NegateCtrl !NibControlAction

9						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: ClearCtrl ( ID\sig\wptr -- )
' DoCalculatorControl ClearCtrl !NibControlAction

10						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: DupCtrl ( ID\sig\wptr -- )
' DoCalculatorControl DupCtrl !NibControlAction

11						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: SwapCtrl ( ID\sig\wptr -- )
' DoCalculatorControl SwapCtrl !NibControlAction

12						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: OverCtrl ( ID\sig\wptr -- )
' DoCalculatorControl OverCtrl !NibControlAction

13						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: RotCtrl ( ID\sig\wptr -- )
' DoCalculatorControl RotCtrl !NibControlAction

14						\ control ID from IB
ascii cmd_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: DropCtrl ( ID\sig\wptr -- )
' DoCalculatorControl DropCtrl !NibControlAction

\ ----------------------------------------------------------------------------
\ These are the "scientific" buttons...

1						\ control ID from IB
ascii sci_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: PICtrl ( ID\sig\wptr -- )
' DoCalculatorControl PICtrl !NibControlAction

2						\ control ID from IB
ascii sci_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl:  INVCtrl ( ID\sig\wptr -- )
' DoCalculatorControl INVCtrl !NibControlAction

3						\ control ID from IB
ascii sci_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: SQRTCtrl ( ID\sig\wptr -- )
' DoCalculatorControl SQRTCtrl !NibControlAction

4						\ control ID from IB
ascii sci_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: LNCtrl ( ID\sig\wptr -- )
' DoCalculatorControl LNCtrl !NibControlAction

5						\ control ID from IB
ascii sci_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: LOGCtrl ( ID\sig\wptr -- )
' DoCalculatorControl LOGCtrl !NibControlAction

6						\ control ID from IB
ascii sci_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: SINCtrl ( ID\sig\wptr -- )
' DoCalculatorControl SINCtrl !NibControlAction

7						\ control ID from IB
ascii sci_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: COSCtrl ( ID\sig\wptr -- )
' DoCalculatorControl COSCtrl !NibControlAction

8						\ control ID from IB
ascii sci_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: TANCtrl ( ID\sig\wptr -- )
' DoCalculatorControl TANCtrl !NibControlAction

9						\ control ID from IB
ascii sci_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: X^^YCtrl ( ID\sig\wptr -- )
' DoCalculatorControl X^^YCtrl !NibControlAction

10						\ control ID from IB
ascii sci_				\ control SIG from IB
CalculatorNibWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: ARCCtrl ( ID\sig\wptr -- )
' DoCalculatorControl ARCCtrl !NibControlAction


\ ----------------------------------------------------------------------------
\ This routine toggles the names of some of the buttons depending on
\	the "ARC: button or the Option Key

variable InverseFunctions	InverseFunctions off

: RenameSciControls ( flag -- )
	IF
		InverseFunctions on
		c" undo"
		c" x^^2"
		c" e^^x"
		c" 10^^x"
		c" arcsin"
		c" arccos"
		c" arctan"
		c" yx"
	ELSE
		InverseFunctions off
		c" del"
		c" x"
		c" LN"
		c" LOG"
		c" SIN"
		c" COS"
		c" TAN"
		c" y^^x"
	THEN
	X^^YCtrl @ swap SetControlTitle
	TANCtrl  @ swap SetControlTitle
	COSCtrl  @ swap SetControlTitle
	SINCtrl  @ swap SetControlTitle
	LOGCtrl  @ swap SetControlTitle
	LNCtrl   @ swap SetControlTitle
	SQRTCtrl @ swap SetControlTitle
	DeleteCtrl @ swap SetControlTitle
;
\ ----------------------------------------------------------------------------
\ This allows us to override default control fonts for the display controls


(*
constants for flags field:
   kControlUseFontMask = 0x0001,
   kControlUseFaceMask = 0x0002,
   kControlUseSizeMask = 0x0004,
   kControlUseForeColorMask = 0x0008,
   kControlUseBackColorMask = 0x0010,
   kControlUseModeMask = 0x0020,
   kControlUseJustMask = 0x0040,
   kControlUseAllMask = 0x00FF,
   kControlAddFontSizeMask = 0x0100
*)

create MainFontStyle
	64 16 or 8 or 4 or 2 or 1 or w,	\ flags
	4 w,			\ font
	14 w,			\ size
	0 w,			\ style
	0 w,			\ mode
	0 w,			\ just
	RGBBlue 	    @rgb rot w, swap w, w,	\ foreColor
	RGBCalcColor	@rgb rot w, swap w, w,	\ backColor
\	RGBVeryLtGray	@rgb rot w, swap w, w,	\ backColor

create MsgFontStyle
	64 16 or 8 or 4 or 2 or 1 or  w,	\ flags
	4 w,			\ font
	12 w,			\ size
	2 w,			\ style - ITALIC
	0 w,			\ mode
	1 w,			\ just  - CENTERED
	RGBRed	 	    @rgb rot w, swap w, w,	\ foreColor
	RGBCalcColor	@rgb rot w, swap w, w,	\ backColor
\	RGBVeryLtGray	@rgb rot w, swap w, w,	\ backColor


\ ----------------------------------------------------------------------------
\ This is the "glue" for colorizing our display background User Pane control


: DrawBkgPane ( ctrlref\info -- )
	2drop
	CalculatorNibWindow window

	\ switched.out? @ 0= AND
	active.window @ CalculatorNibWindow =
	\ CalculatorNibWindow front.window =
	\ AND
	IF
		RGBBlue			RGBForeColor
		RGBCalcColor	RGBBackColor
		RGBBlue @rgb MainFontStyle 12 + !rgb
	ELSE
		RGBDkGray		RGBForeColor
		RGBVeryLtGray	RGBBackColor
		RGBDkGray @rgb MainFontStyle 12 + !rgb
	THEN
	MainDispCtrl @ MainFontStyle SetControlFontStyle drop

\	RGBVeryLtGray	RGBBackColor
	DispBkgdCtrl @  ScratchRect GetControlBounds drop
	ScratchRect EraseRect
	2 2 pensize
	ScratchRect	FrameRect
	1 1 pensize
	ScratchRect @rect		\ t\l\b\r
	nip 1- >R
	swap 25 +
	R>  over vector
;


\ 0 2 ' DrawBkgPane MakeProcPtr DrawBkgPaneProc ( ctrlref\info -- )
\	DrawBkgPaneProc NewControlUserPaneDrawUPP DrawBkgPaneUPP !


2 0  CALLBACK: DrawBkgPaneProc
	' DrawBkgPane to-callback DrawBkgPaneProc



\ ----------------------------------------------------------------------------
\ This handles our "message pane"..

: DisplayMessage ( addr\cnt -- )
	swap >R >R
	MsgDispCtrl @ 0 ascii text
	R> R>
	SetControlData ( ControlRef\PartCode\ResType\dataSize\^data -- OSStatus )
	drop
	MsgDispCtrl  @  Draw1Control
\	MainDispCtrl @  Draw1Control
	DispBkgdCtrl @  Draw1Control	\ seems to be necessary to properly update
;

: ClearMessage ( -- )
	s" " DisplayMessage
;

\ ----------------------------------------------------------------------------
\ Allot space for the Display and Input buffers

1024 constant CalcDisplayBufferSize

create CalcDisplayBuffer 	CalcDisplayBufferSize allot&erase
create CalcDisplayOffset 	0 ,


1024 constant CalcInBufferSize

create CalcInBuffer			CalcInBufferSize allot&erase
create CalcInBufferOffset   0 ,


\ ----------------------------------------------------------------------------
\ Basic words for the main display buffer

: UpdateMainDisplay ( -- )
	MainDispCtrl @ 0 ascii text
	CalcDisplayOffset @ CalcDisplayBuffer
	SetControlData ( ControlRef\PartCode\ResType\dataSize\^data -- OSStatus )
	drop
	MainDispCtrl @  Draw1Control
\	MsgDispCtrl  @  Draw1Control
\ next 2 is a trick to force redraw of MsgDispCtrl
	MsgDispCtrl  @  0  true SetControlVisibility drop
	MsgDispCtrl  @  true  true SetControlVisibility drop
	DispBkgdCtrl @  Draw1Control	\ seems to be necessary to properly update
;

: AddCharToCalcDisplayBuffer ( char -- )
	CalcDisplayOffset @ CalcDisplayBufferSize <
	IF
		CalcDisplayBuffer CalcDisplayOffset @ + c!
		1 CalcDisplayOffset +!
	ELSE
		beep drop
	THEN
;

: AddDataToCalcDisplayBuffer ( addr\cnt -- )
	dup CalcDisplayOffset @ + CalcDisplayBufferSize <
	IF
		>R
		CalcDisplayBuffer CalcDisplayOffset @ +
		R@ cmove
		R> CalcDisplayOffset +!
	ELSE
		beep 2drop
	THEN
;

: ClearCalcBuffers ( -- )
	CalcDisplayOffset   off
	CalcInBufferOffset  off
;



\ ----------------------------------------------------------------------------
\ The words to draw the main display
\ needs work !
: myNaN? ( -- flag ) ( F: r -- r )	\ speed is not an issue, so we will check
									\ each entry for validity
	fdepth 0>
	IF
		fdup BadFloat? 					\ F: f -- ; -- caddr u true | false
		dup
		IF
			nip nip
		THEN
	ELSE
		-1
	THEN
\	fdup 0 precision 1 + num2dec  ( style\digits -- ) ( F: r -- )
\	?ValidFloat not
;



: ?(F.) ( -- addr\cnt )    ( F: r -- )
	fdup fabs 1.0e23 F<
	IF
		#places @  (F.)

	ELSE
		fdrop
		s" too big for fixed point"
	THEN
;


: AddFloatToCalcDisplay ( -- )	( F: r -- )
	myNaN?
	IF
		fdrop
		s" Invalid Number!"
	ELSE
		CalcPrecision @ 1- 0 max 2 * set-precision
		CalcFormat @
		CASE
			1 OF ?(F.)  ENDOF
			2 OF  #places @ (FS.)  ENDOF
			3 OF  #places @ (FE.)  ENDOF
			s" bad format" rot
		ENDCASE
	THEN
	AddDataToCalcDisplayBuffer
	13 AddCharToCalcDisplayBuffer
;



: FillCalcDisplayBuffer ( -- )
	ascii 4  locals| IndexChar |
	CalcDisplayOffset off
	fdepth
	dup 4 <
	IF
		4 over - 0
		DO
			IndexChar  AddCharToCalcDisplayBuffer
			-1 +to IndexChar
			ascii :    AddCharToCalcDisplayBuffer
			13 AddCharToCalcDisplayBuffer
		LOOP
	THEN

	4 min			\ can only display 4 items
	BEGIN
		dup 0 >
	WHILE
		IndexChar AddCharToCalcDisplayBuffer
		-1 +to IndexChar
		s" : "  AddDataToCalcDisplayBuffer
		1-

		dup  fpick
\		dup b/fp * fp@ + f@
		AddFloatToCalcDisplay
	REPEAT
	drop
	s" > "  AddDataToCalcDisplayBuffer
	CalcInBuffer CalcInBufferOffset @ AddDataToCalcDisplayBuffer
	UpdateMainDisplay
;


\ ----------------------------------------------------------------------------
\ DoCalculator is the word that does all the work of setting up the demo

\ lacking CFBundleGetMainBundle 0 externfunc CFBundleGetMainBundle ( -- CFBundleRef )

: GetCalculatorNib ( -- )
	\ Locate our Nib file
	z" Calculator" GetNibReference ( 0$ -- NibReference |or| 0 )
		dup 0= abort" Could not open Calculator.nib"

(*	\ this method also works fine for more control over where to look for the Nib
	AreWeBundled?
	IF
		CFBundleGetMainBundle
	ELSE
		z" MacForth NIBbles" OpenLocalBundle
	THEN
	dup 0= abort" Bundle not found!"
	z" Calculator" GetNibReferenceFromBundle
*)
	z" Calculator3" CalculatorNibWindow add.window.from.nib
;


: DoCalculator ( -- )	\ main word for running Calculator
	GetCalculatorNib
	0 CalculatorNibWindow +M4th.WTYPE !		\ disable MacForth's special Nib Window activate stuff
\	CalculatorNibWindow UndoCompositingForOS9

	\ this is the magic dust for us to receive Activate events
	\	even when a Standard Event Handler is installed:
	CalculatorNibWindow InstallWindowEventCatcher

	DispBkgdCtrl InstallNibControl

	MainDispCtrl InstallNibControl
	MainDispCtrl @ MainFontStyle SetControlFontStyle abort" SetControlFontStyle error"

	MsgDispCtrl InstallNibControl
	MsgDispCtrl @ MsgFontStyle SetControlFontStyle abort" SetControlFontStyle error"

	NumCtrl0   InstallNibControl
	NumCtrl1   InstallNibControl
	NumCtrl2   InstallNibControl
	NumCtrl3   InstallNibControl
	NumCtrl4   InstallNibControl
	NumCtrl5   InstallNibControl
	NumCtrl6   InstallNibControl
	NumCtrl7   InstallNibControl
	NumCtrl8   InstallNibControl
	NumCtrl9   InstallNibControl

	DecPtCtrl  InstallNibControl
	EnterCtrl  InstallNibControl
	PlusCtrl   InstallNibControl
	MinusCtrl  InstallNibControl
	TimesCtrl  InstallNibControl
	DivideCtrl InstallNibControl
	DeleteCtrl InstallNibControl
	EEXCtrl	   InstallNibControl
	NegateCtrl InstallNibControl
	ClearCtrl  InstallNibControl
	DupCtrl    InstallNibControl
	SwapCtrl   InstallNibControl
	OverCtrl   InstallNibControl
	RotCtrl    InstallNibControl
	DropCtrl   InstallNibControl

	PICtrl    InstallNibControl
	SQRTCtrl  InstallNibControl
	INVCtrl   InstallNibControl
	LNCtrl    InstallNibControl
	LOGCtrl   InstallNibControl
	SINCtrl   InstallNibControl
	COSCtrl   InstallNibControl
	TANCtrl   InstallNibControl
	X^^YCtrl  InstallNibControl
	ARCCtrl   InstallNibControl

	FormatCtrl    InstallNibControl
	PrecisionCtrl InstallNibControl
	ModeCtrl	  InstallNibControl


	PrecisionCtrl @ 5 SetControl32BitValue
	5 CalcPrecision !

	\ set a special draw action for the background User Pane
	DrawBkgPaneProc NewControlUserPaneDrawUPP DrawBkgPaneUPP !
	DispBkgdCtrl @ 0
	ascii draw 				\ kControlUserPaneDrawProcTag
	4 DrawBkgPaneUPP
	SetControlData ( ControlRef\PartCode\ResType\dataSize\^data -- OSStatus )
	abort" SetControlData error"

	s" Your Ad Can Go Here"
	DisplayMessage ( addr\cnt -- )

	ClearCalcBuffers
	fp-init
	FillCalcDisplayBuffer
	InverseFunctions off

	CalculatorNibWindow show.window
;


\ ----------------------------------------------------------------------------
\ ----------------------------------------------------------------------------
\ ----------------------------------------------------------------------------
\ Some sound effects ;-)

: BMMPH ( -- )
	\ decimal# 10802 PlayResourceAsync drop ;
	beep ;

: UhOh ( -- )
	\ decimal# 10801 PlayResourceAsync drop ;
	beep ;


\ ----------------------------------------------------------------------------
\ These words handle entering data into the CalcInBuffer

: InsertCharToCalcInBuffer ( char -- )
	CalcInBufferOffset @ dup 60 <
	IF
		CalcInBuffer + c!
		1 CalcInBufferOffset +!
	ELSE
		2drop
		beep
	THEN
;

: InBufferHasDP? ( -- offset/flag )
	CalcInBufferOffset @ 0
	?DO
		CalcInBuffer i + c@ ascii . =
		IF i true unloop exit THEN
	LOOP
	0 0
;

: InBufferHasEXP? ( -- offset/flag )
	CalcInBufferOffset @ 0
	?DO
		CalcInBuffer i + c@ ascii E =
		IF i true unloop exit THEN
	LOOP
	0 0
;

: InsertDP ( -- )
	InBufferHasDP?  nip
	InBufferHasEXP? nip OR
	IF
		s" invalid format"  DisplayMessage
		bmmph
	ELSE
		CalcInBufferOffset @ 0=
		IF
			ascii 0 InsertCharToCalcInBuffer
		THEN
		ascii . InsertCharToCalcInBuffer
	THEN
;

: InsertEXP ( -- )
	InBufferHasEXP? nip
	IF
		s" invalid format"  DisplayMessage
		bmmph
	ELSE
		CalcInBufferOffset @ 0=
		IF
			ascii 1 InsertCharToCalcInBuffer
\			ascii . InsertCharToCalcInBuffer
		THEN
		ascii E InsertCharToCalcInBuffer
	THEN
;

\ ----------------------------------------------------------------------------
\ These words do the command button actions

: InvertExpSign ( expOffset -- )
	1+							\ offset to just after the "E"
	CalcInBufferOffset @ over >
	IF  dup
		CalcInBuffer + dup >R c@ ascii - =
		IF	\ already has "-"
			\ (-)offset
			CalcInBufferOffset @ swap -	\ # to move
			R> dup 1+ swap rot move
			-1 CalcInBufferOffset +!
		ELSE
			CalcInBufferOffset @ swap -	\ # to move
			R@	dup 1+ rot move
			1 CalcInBufferOffset +!
			ascii - R> c!
		THEN
	ELSE	\ nothing after the E, so insert "-"
		ascii - InsertCharToCalcInBuffer
	THEN
;

: InvertMantissaSign ( -- )
	CalcInBuffer c@ ascii - =
	IF
		CalcInBuffer dup 1+ swap CalcInBufferOffset @ move
		-1 CalcInBufferOffset +!
	ELSE
		CalcInBuffer dup 1+  CalcInBufferOffset @ move
		ascii - CalcInBuffer c!
		1 CalcInBufferOffset +!
	THEN
;

: InvertEntrySign ( -- )
	InBufferHasEXP?
	IF
		InvertExpSign
	ELSE
		drop
		InvertMantissaSign
	THEN
;

: InvertSign ( -- )
	CalcInBufferOffset @
	IF		\ data entry in progress
		InvertEntrySign
	ELSE	\ nothing being entered, so invert TOS item
		fnegate
	THEN
;



: (EnterInBuffer) ( -- flag )	\ flag = 0 if entered
	CalcInBufferOffset @ dup
	IF
		CalcInBuffer swap >float
		CalcInBufferOffset off
	THEN
	0=
;


: DepthChecker ( -- )	\ ??????
((	fp.size fp.top fp@ - - b/fp <=
	IF
		CalcInBufferOffset off
		fdrop
		FillCalcDisplayBuffer
		s" too many entries"  DisplayMessage
		UhOh
	THEN
))
;

fvariable LastEntry3
fvariable LastEntry2
fvariable LastEntry1
0 value Last#Args
0 value Last#Returned


: RestoreLastEntries ( -- )
	Last#Returned Last#Args OR
	IF
		Last#Returned 0
		?DO
			fdrop
		LOOP
		Last#Args ?dup
		IF
			dup 2 >
			IF
				LastEntry3 f@
			THEN
			1 >
			IF
				LastEntry2 f@
			THEN
			LastEntry1 f@
		THEN
		0 -> Last#Returned
		0 -> Last#Args
		CalcInBufferOffset off	\ clear pending entry
	ELSE
		s" cannot restore"  DisplayMessage
		UhOh
	THEN
;

: SaveLastEntries ( returned\needed -- )
	to Last#Args
	to Last#Returned
	fdup    LastEntry1 f!
	fover   LastEntry2 f!
	2 fpick LastEntry3 f!
;


: BackSpaceEntry ( -- )
	InverseFunctions @
	IF
		RestoreLastEntries
	ELSE
		CalcInBufferOffset @ 1- 0 max
		CalcInBufferOffset !
	THEN
;

: EnterIt ( -- )
	(EnterInBuffer)
	IF
		s" invalid entry"  DisplayMessage
		UhOh
	ELSE
		0 to Last#Args
	THEN
;



: DoCalculation ( token\returned\needed -- )
	dup >R
	(EnterInBuffer) drop
	fdepth <=
	IF
		R> SaveLastEntries
		execute
	ELSE
		R> DROP
		2drop
		s" too few arguments"  DisplayMessage
		UhOh
	THEN
;

: HandleCommand ( n -- )
	CASE
		0	OF	InsertDP					ENDOF	\ "."
		1	OF	EnterIt						ENDOF	\ "ENTER"
		2	OF	['] F+ 1 2 DoCalculation	ENDOF	\ "+"
		3	OF	['] F- 1 2 DoCalculation	ENDOF	\ "-"
		4	OF	['] F* 1 2 DoCalculation	ENDOF	\ "*"
		5	OF	['] F/ 1 2 DoCalculation	ENDOF	\ "/"
		6	OF	BackSpaceEntry				ENDOF	\ "DEL"
		7	OF	InsertEXP					ENDOF	\ "EEX"
		8	OF	InvertSign					ENDOF	\ "+/-"
		9	OF	ClearCalcBuffers fp-init	ENDOF	\ "CLEAR"

		10	OF	['] fdup  2 1 DoCalculation	ENDOF	\ "DUP"
		11	OF	['] fswap 2 2 DoCalculation	ENDOF	\ "FSWAP"
		12	OF	['] fover 3 2 DoCalculation	ENDOF	\ "OVER"
		13	OF	['] frot  3 3 DoCalculation	ENDOF	\ "ROT"
		14	OF	['] fdrop 0 1 DoCalculation	ENDOF	\ "DROP"
	ENDCASE
	FillCalcDisplayBuffer
;

\ ----------------------------------------------------------------------------
\ These words do the "scientific" button actions

variable wasARCed   wasARCed off

: FINV ( F: r1 -- r2 )
	1e0 fswap f/
;

: F?SQRT ( F: r1 -- r2 )
	InverseFunctions @
	IF  fdup f*  ELSE  fsqrt THEN	wasARCed off
;

: F?LN ( F: r1 -- r2 )
	InverseFunctions @
	IF fexp  ELSE fln  THEN	wasARCed off
;

: F?LOG ( F: r1 -- r2 )
	InverseFunctions @
	IF falog   ELSE flog  THEN	wasARCed off
;


1.0e fatan 4.0e f* fconstant PI
pi 180.e f/ fconstant >RADIANS

((
>RADIANS f.

))


: ?>RADIANS ( F: r1 -- r2 )
	calcmode @ 2 = IF >radians f* THEN
;

: ?>DEGREES ( F: r1 -- r2 )
	calcmode @ 2 = IF >radians f/ THEN
;

: F?SIN ( F: r1 -- r2 )
	InverseFunctions @
	IF fasin ?>degrees  ELSE ?>radians fsin  THEN	wasARCed off
;

: F?COS ( F: r1 -- r2 )
	InverseFunctions @
	IF facos ?>degrees  ELSE ?>radians fcos  THEN	wasARCed off
;

: F?TAN ( F: r1 -- r2 )
	InverseFunctions @
	IF fatan ?>degrees  ELSE ?>radians ftan  THEN	wasARCed off
;

: F?POW ( F: r1 -- r2 )
	InverseFunctions @
	IF flog fswap f/ falog   ELSE f**  THEN	wasARCed off
;

: DoArcControl ( -- )	\ this overrides option key
	wasARCed @ IF wasARCed off ELSE wasARCed ON THEN
	wasARCed @  RenameSciControls
;


: HandleScientific ( n -- )
	CASE
		1	OF	pi								ENDOF	\ "PI"
 		2	OF	['] FINV   1 1 DoCalculation	ENDOF	\ "1/x"
		3	OF	['] F?SQRT 1 1 DoCalculation	ENDOF	\ "SQRT"
		4	OF	['] F?LN   1 1 DoCalculation	ENDOF	\ "LN"
		5	OF	['] F?LOG  1 1 DoCalculation	ENDOF	\ "LOG"
		6	OF	['] F?SIN  1 1 DoCalculation	ENDOF	\ "SIN"
		7	OF	['] F?COS  1 1 DoCalculation	ENDOF	\ "COS"
		8	OF	['] F?TAN  1 1 DoCalculation	ENDOF	\ "TAN"
		9	OF	['] F?POW  1 2 DoCalculation	ENDOF	\ "X^^Y"

		10	OF	DoArcControl					ENDOF	\ "ARC"
	ENDCASE
	FillCalcDisplayBuffer
;


\ ----------------------------------------------------------------------------
\ These words added mostly for making debugging easier...


: HandleCommandButton ( n -- )
	ClearMessage
	HandleCommand
;

: HandleScientificButton ( n -- )
	ClearMessage
	HandleScientific
;

: HandleNumberButton ( n -- )
	ClearMessage
	ascii 0 +
	InsertCharToCalcInBuffer
	FillCalcDisplayBuffer
;

\ ----------------------------------------------------------------------------
\ Allow Keystrokes to handle the basic calculator functions
\ Still need mouse for most command and all scientific functions

: HandleCalculatorKeystroke ( n -- )
	ClearMessage
	dup 208	=	\ ascii - =
	IF	\ special case option-"-" from keyboard
		drop
		CalcInBufferOffset @ 0 =
		InBufferHasEXP? IF 1+ CalcInBufferOffset @ = OR ELSE drop THEN
		IF	\ is it 1st char of mantissa or exp ?
			ascii - InsertCharToCalcInBuffer
			FillCalcDisplayBuffer
		ELSE
			3 HandleCommand
		THEN
	ELSE
		ascii 0 ascii 9 range
		IF
			ascii 0 - HandleNumberButton
		ELSE
			CASE
				ascii . OF 0 	ENDOF
				3		OF 1	ENDOF
				13		OF 1	ENDOF
				ascii + OF 2	ENDOF
				ascii - OF 3	ENDOF
				ascii * OF 4	ENDOF
				ascii / OF 5	ENDOF
				8		OF 6	ENDOF
				ascii e OF 7	ENDOF
				ascii E OF 7	ENDOF
				s" huh??" DisplayMessage
				bmmph
				-1 swap
			ENDCASE
			HandleCommand
		THEN
	THEN
;

\ ----------------------------------------------------------------------------
\ ----------------------------------------------------------------------------
\ CalculatorNibWindow ON.ACTIVATE word, doing all the event handling
\ Note, we have a Mac "Standard Handler" installed on the window so we
\	never get update events, hence no ON.UPDATE word needed

: Option-InverseControls ( -- )
	wasARCed @ 0=
	IF
		OptionKey?
		IF
			InverseFunctions @ 0=
			IF
				true  RenameSciControls
			THEN
		ELSE
			InverseFunctions @
			IF
				false   RenameSciControls
			THEN
		THEN
	THEN
;

: ActivateNibWindow ( true -- )
	UpdateMainDisplay
	IF
		4 TextFont
		9 TextSize
		init.cursor

		CalculatorNibWindow @ DrawControls
		BEGIN
			Option-InverseControls
			do.events
\			dup in.close.box = IF bye THEN

			in.calculator.button =
			IF
				private.event.record  	\ dup 20 log+dump
				dup  14 + w@			\ controlID
				swap 10 +				\ controlsig
				@
				CASE
					ascii num_ OF HandleNumberButton		ENDOF
					ascii cmd_ OF HandleCommandButton		ENDOF
					ascii sci_ OF HandleScientificButton	ENDOF
					FillCalcDisplayBuffer		\ handles popups
					nip
				ENDCASE
			THEN
			?keystroke IF  HandleCalculatorKeystroke THEN
			DepthChecker
		AGAIN
	ELSE
		CalculatorNibWindow @ DrawControls
		s" Option Key for more functions"
		DisplayMessage ( addr\cnt -- )
	THEN
;

CalculatorNibWindow on.activate ActivateNibWindow


\ ----------------------------------------------------------------------------
\ ----------------------------------------------------------------------------
\ All done...

having test test DoCalculator

cr ." To run demo, type DOCALCULATOR or use cmd-\ (TEST in Tools Menu)"


\ ----------------------------------------------------------------------------
\ ----------------------------------------------------------------------------


\ *************** comments and/or test code below ***************
StopIncluding

