\  Sieve of Eratosthenes 
\  Commonly used as a speed benchmark
\ Last Revision: 1 Jan 2012  06:35:46  ward@megawolf.com

((

samples at end of this file

))

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************

only FORTH Definitions
decimal

\  04/09/86    By Don Colburn
\  For a complete discussion of the methods involved, and a better
\  understanding of use of the sieve as a benchmark, refer to
\  a Letter to the Editor of mine that was published in
\  Dr Dobb's Journal, September 1983, Pages 9-10.
\
\  This comparison contrasts the origional BYTE magazine coding,
\  coding with reasonable improvments based on address indices,
\  and the improved coding using local variables. The latter two
\  implementations more closely follow the methods used by the
\  C and Pascal implementations.
\




anew sieve

8192 constant size
variable flags  size allot



: prime3
   flags  size 1 fill                          \ set array
   flags size +  0  0
\   locals| #primes prime*2+3 limit |
	{ limit  prime*2+3  #primes }

   limit 1 +  flags  
   do
   	i c@                                     \ prime?
     if
	   i flags - 2* 3 + dup to prime*2+3       \ yup, use prime*2+3 as index
       i + limit <                              \ < size ?
          if 
          	limit 1 +   prime*2+3  i +          \ yes, hit modulo flags
             do 0 i c! prime*2+3 +loop
          then
        1 +to #primes                \ bump prime count
     then
	loop
\	#primes .  ." primes " 
;


: sieve100
   100 0 do prime3 loop ;


: SHOW.TIME  ( ticks -- )
    .  ." ticks     "
 ;

: SIEVE.DEMO
	cr ." 100 Iterations of Sieve: "
    ticks sieve100 ticks swap - cr show.time ;

: SIEVE.DEMO2
	cr ." 1000 Iterations of Sieve: "
    ticks
    1000 0 do prime3 loop
    ticks swap - cr show.time ;

: SIEVE.DEMO3
	cr ." 100000 Iterations of Sieve: "
    ticks
    100000 0 do prime3 loop
    ticks swap - cr show.time ;


: MILLION.LOOPS
    ticks
    1000000 0 DO LOOP
    ticks swap - show.time ;
    
: 10MILLION.LOOPS
    ticks
    10000000 0 DO LOOP
    ticks swap - show.time ;
    
cr ." Execute  SIEVE.DEMO  SIEVE.DEMO2  SIEVE.DEMO3 or 10MILLION.LOOPS"


StopIncluding ************************************


SIEVE.DEMO3

100000 Iterations of Sieve: 
8080 ticks     
ok



10MILLION.LOOPS
20 ticks     
ok

