\ Tabbed Nib Demo #3
\ Last Revision: 04/25/05  02:58:03 PM  wjm
\ Last Revision: 19 Jan 2012  11:00:47  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2005  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


(* ***************************************************************************

Almost identical to Tabbed Nib Demo #2

Instead of making a NEW window event handler from scratch, including making
	a Procptr and a UPP for it, we make a similar Window Event Handler
	and just piggy-back is as a window-specific handler on our
	Generic WindowActivateHandler that is already installed

*************************************************************************** *)


only FORTH Definitions
anew --tabbeddemo--
decimal
>m4th


13 constant kEventControlClick


\ Names for locating our Nib within a Nib file within a Nib Framework (directory)
\ create NibBndlName Z", MacForth NIBbles"
create NibFileName Z", TabbedDemo"		\ CasE sEnSiTivE !!!
create NibName     Z", TabbedWindow"	\ CasE sEnSiTivE !!!


\ First, create a regular MacForth window template:
NEW.WINDOW TabbedWindow


\ Control Identifiers for the Tabs and Panes
create theTabID  ascii tabs , 128 ,		\ set in Interface Builder for the Nib
create thePaneID ascii tabs , 128 ,		\ set in Interface Builder for the Nib


ascii ---- constant kEventParamDirectObject  \     = FOUR_CHAR_CODE('----')
ascii ctrl constant kEventParamControlRef    \     = FOUR_CHAR_CODE('ctrl')


\ make an event list for the window event handler
create TabbedWindowEventList
	kEventClassControl ,  kEventControlHit ,	\ respond to any control hit


\ *************************************************************************
\ Words for selecting the proper Pane to display..

0 value TheTabControlRef
0 value LastTabIndex


: GetPaneFromTab ( TabID -- PaneControlRef )
	thePaneID 4 + !
	TheTabControlRef GetControlOwner 	\ owning window
	thePaneID
	GetControlRefFromID		\ !!!!
;


: SelectPaneForTab ( -- )
	TheTabControlRef GetControl32BitValue
	locals| CurrentTabValue |
	4 1
	?DO
		CurrentTabValue i <>
		IF
			128 i + GetPaneFromTab
			dup DisableControl drop
			false false  SetControlVisibility drop
		THEN
	LOOP
	128 CurrentTabValue + GetPaneFromTab
	dup EnableControl drop
	true true SetControlVisibility drop
;



\ *************************************************************************
\ Build a Carbon Event Handler for the window

create TheClickedControl 0 ,


: DoTabbedWindowEvent ( EventRef\theWPTR4 -- handled? )	\ see DebugDoWindowEvent
	locals| theWPTR4 EventRef |
	\ first figure out what control triggered the event
	eventref
	kEventParamDirectObject	\ EventParamName
	kEventParamControlRef	\ EventParamType
	0						\ don't need ActualEventType
	4						\ MaxBufferSize = size of ControlRef
	0						\ don't need ActualSize
	TheClickedControl
	GetEventParameter ( EventRef\EventParamName\EventParamType\..
					..^ActualEventType\MaxBufferSize\^ActualSize\^outData -- OSStatus )
	IF TheClickedControl OFF THEN	\ don't really need to handle an error

	\ then see if it was our TAB control
	TheClickedControl @ TheTabControlRef =
	IF
		SelectPaneForTab
		true								\ return true since we DID handle it
	ELSE
	 	0									\ return 0 since we did NOT handle it
	THEN
;



\ *************************************************************************
\ Add standard MacForth activate and update routines...

: TabbedWindowUpdate ( flag -- )
\ would need this on OS 9 for compositing window
\	TabbedWindow @ DrawControls
;
TabbedWindow On.Update TabbedWindowUpdate


: TabbedWindowActivate ( flag -- )
	IF
		BEGIN
			do.events drop
		AGAIN
	ELSE
	THEN
;
TabbedWindow On.Activate TabbedWindowActivate


\ *************************************************************************
\ Now define the  controls on the "Widget" Pane...

1						\ control ID from IB
ascii tab1				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl1-1 ( ID\sig\wptr -- )

2						\ control ID from IB
ascii tab1				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl1-2 ( ID\sig\wptr -- )

3						\ control ID from IB
ascii tab1				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl1-3 ( ID\sig\wptr -- )

4						\ control ID from IB
ascii tab1				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl1-4 ( ID\sig\wptr -- )

5						\ control ID from IB
ascii tab1				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl1-5 ( ID\sig\wptr -- )

6						\ control ID from IB
ascii tab1				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl1-6 ( ID\sig\wptr -- )


\ *************************************************************************
\ "More Widgets" Pane controls...

1						\ control ID from IB
ascii tab2				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl2-1 ( ID\sig\wptr -- )

2						\ control ID from IB
ascii tab2				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl2-2 ( ID\sig\wptr -- )

3						\ control ID from IB
ascii tab2				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl2-3 ( ID\sig\wptr -- )

4						\ control ID from IB
ascii tab2				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl2-4 ( ID\sig\wptr -- )

5						\ control ID from IB
ascii tab2				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl2-5 ( ID\sig\wptr -- )

6						\ control ID from IB
ascii tab2				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl2-6 ( ID\sig\wptr -- )

7						\ control ID from IB
ascii tab2				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl2-7 ( ID\sig\wptr -- )

8						\ control ID from IB
ascii tab2				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl2-8 ( ID\sig\wptr -- )

9						\ control ID from IB
ascii tab2				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl2-9 ( ID\sig\wptr -- )

10						\ control ID from IB
ascii tab2				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl2-10 ( ID\sig\wptr -- )


\ *************************************************************************
\ "Miscellany" Pane controls...

1						\ control ID from IB
ascii tab3				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl3-1 ( ID\sig\wptr -- )

2						\ control ID from IB
ascii tab3				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl3-2 ( ID\sig\wptr -- )

3						\ control ID from IB
ascii tab3				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl3-3 ( ID\sig\wptr -- )

4						\ control ID from IB
ascii tab3				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl3-4 ( ID\sig\wptr -- )

\ Ctrl3-4 IS A STATIC TEXT FIELD and does not trigger a kEventControlHit
\ So we must add kEventControlClick to its list of control events handled..
kEventControlClick kEventClassControl  AddNibControlEvent ( type\class\nibctrl -- )
' beep Ctrl3-4 !NibControlAction

5						\ control ID from IB
ascii tab3				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl3-5 ( ID\sig\wptr -- )

6						\ control ID from IB
ascii tab3				\ control SIG from IB
TabbedWindow		\ the MacForth window referencing the Nib Window
NewNibBinControl: Ctrl3-6 ( ID\sig\wptr -- )


\ *************************************************************************
\ Finally, the word that connects all the dots...


: DOIT ( -- )
	\ Locate our Nib file     new method  - 6.05436
	\ GetNibReference uses our "poor man's Nib search order
	NibFileName GetNibReference ( 0$ -- NibReference |or| 0 )
		dup 0= abort" GetNibReference failed"

(*	\ this method also works fine for more control over where to look for the Nib
	NibBndlName OpenLocalBundle dup not abort" Bundle not found!"
	NibFileName GetNibReferenceFromBundle
*)

	\ find the specific Nib within the Nib file and attach to TabbedWindow
	\ this Nib DOES have a standard handler installed
	NibName     TabbedWindow add.window.from.nib

	\ need window standard handler to get click passed to control
	\ We can request Standard EventHandler in IB or do it here:
	TabbedWindow +windowref# @ GetWindowEventTarget InstallStandardEventHandler

	\ If we want a compositing window to work correctly on OS 8/9, we need this:
\	TabbedWindow UndoCompositingForOS9

	\ this is the magic dust for us to receive Activate events
	\	even when a Standard Event Handler is installed:
	TabbedWindow InstallWindowEventCatcher
	
	
	\ Instead of making and installing a NEW window event handler, as in Demo #2,
	\	We just piggy-back a window-specific handler on the
	\	Generic WindowActivateHandler we just installed
	['] DoTabbedWindowEvent  TabbedWindow +SpecialEventHandler !


	TabbedWindow +WindowEventHandlerRef @
	1
	TabbedWindowEventList 
	AddEventTypesToHandler ( EventHandlerRef\#types\^typeList -- OSStatus )
	drop

	TabbedWindow +windowref# @   
		theTabID
		GetControlRefFromID ( WindowRef\^ControlID -- ControlRef ) \	!!!
		to TheTabControlRef

	\ Retrieve the ControlRef's and install handlers for our controls...
	Ctrl1-1 InstallNibControl
	Ctrl1-2 InstallNibControl
	Ctrl1-3 InstallNibControl
	Ctrl1-4 InstallNibControl
	Ctrl1-5 InstallNibControl
	Ctrl1-6 InstallNibControl

	Ctrl2-1 InstallNibControl
	Ctrl2-2 InstallNibControl
	Ctrl2-3 InstallNibControl
	Ctrl2-4 InstallNibControl
	Ctrl2-5 InstallNibControl
	Ctrl2-6 InstallNibControl
	Ctrl2-7 InstallNibControl
	Ctrl2-8 InstallNibControl
	Ctrl2-9 InstallNibControl
	Ctrl2-10 InstallNibControl

	Ctrl3-1 InstallNibControl
	Ctrl3-2 InstallNibControl
	Ctrl3-3 InstallNibControl
	Ctrl3-4 InstallNibControl
	Ctrl3-5 InstallNibControl
	Ctrl3-6 InstallNibControl

	\ Select the pane and show the window
	TheTabControlRef GetControl32BitValue to LastTabIndex
	SelectPaneForTab
	TabbedWindow show.window	
;


: SwitchPane ( Tab# -- )	\ toggle pane in software
	1 3 range 0= abort" Invalid Tab#"
	TheTabControlRef swap SetControlValue
	SelectPaneForTab
;



having TEST  test doit
cr ." Type DOIT or CMD-\ for demo"


\ *************** comments and/or test code below ***************
stopincluding



