\ TEST CREATEWINDOW
\ Last Revision: 25 Feb 2012  11:32:24  ward@megawolf.com


\ Demonstrate the new window classes available using _CreateWindow


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


Only forth definitions
decimal

anew --windowsamples--
>m4th



new.window TestWindow
	1 TestWindow w.type
	100 300 300 700 TestWindow w.bounds
\ Not all these attributes can be applied to all window classes, but
\ ADD.WINDOW will automatically filter out inappropriate attributes
	kWindowCloseBoxAttribute    kWindowResizableAttribute   OR
	kWindowFullZoomAttribute OR kWindowCollapseBoxAttribute OR
	TestWindow NewWAttributes


defer NextWindow ( -- )   ' noop is NextWindow

lacking PaintRect  Extern:  void   PaintRect  ( UInt32 * &rect );


: TestWindowUpdate ( -- )
	TestWindow GetWindowAttributes kWindowCloseBoxAttribute and
	TestWindow +w.type w@
	locals| theClass HasCloseBox |
	page
	theClass 10 =		\ kHelpWindowClass
	theClass 12 = OR	\ kToolbarWindowClass
	IF	\ if we don't do this, these 2 classes come up white
		RGBYellow    RGBForeColor
		coord.bounds PaintRect
		RGBBlue      RGBForeColor
	THEN
	cr ." Window Type " theClass 0 .R ." :  "
		TestWindow +wtitle @  count type
	cr
	cr ." (Color was added to allow you to see borderless windows)"
	cr
	theClass 1 = 		\ kAlertWindowClass
	theClass 3 =  OR	\ kModalWindowClass
	IF
		cr ." Hit any key to continue"
	ELSE
		theClass 5 <>		\ kFloatingWindowClass
		theClass 8 <> and	\ kUtilityWindowClass
		theClass 10 <> and	\ kHelpWindowClass
		theClass 12 <> and	\ kToolbarWindowClass
		TestWindow active.window @ = and
		IF cr ." Hit ESC to cancel" THEN
		cr
		cr ." CMD-\ to see next window"
		HasCloseBox
		IF 
			cr ."   or use Close Box"
		ELSE
			cr ."   or hit any key"
		THEN
		theClass 2 <> 		\ kMovableAlertWindowClass
		theClass 4 <> and	\ kMovableModalWindowClass
		IF
			cr cr ." try switching windows and applications"
		THEN
	THEN
	cr
;
TestWindow on.update TestWindowUpdate


: TestWindowActivate ( flag -- )
	TestWindow GetWindowAttributes kWindowCloseBoxAttribute and
	locals| HasCloseBox |
	IF	beep
		RGBYellow RGBBackColor		\ make it very visible
		TestWindowUpdate

		BEGIN
			CheckEventQueueForUserCancel 0=
		WHILE
			do.events in.close.box =
			IF NextWindow THEN
			HasCloseBox 0=
			IF
				?keystroke
				IF  
					key.stroke off
					27 <>					\ escape key
					IF NextWindow THEN
					TestWindow close.window
				THEN
			THEN
		REPEAT
		TestWindow close.window
	THEN
;
TestWindow on.activate  TestWindowActivate


: (NextWindow) ( -- )
	TestWindow +w.type w@
	CASE
		1 OF 2  TestWindow w.type
				c" kMovableAlertWindowClass"  TestWindow w.title
			ENDOF
		2 OF 3  TestWindow w.type
				c" kModalWindowClass"  TestWindow w.title
			ENDOF
		3 OF 4  TestWindow w.type
				c" kMovableModalWindowClass"  TestWindow w.title
			ENDOF
		4 OF 5  TestWindow w.type
				c" kFloatingWindowClass"  TestWindow w.title
			ENDOF
		5 OF 6  TestWindow w.type
				c" kDocumentWindowClass"  TestWindow w.title
			ENDOF
		6 OF 8  TestWindow w.type
				c" kUtilityWindowClass"  TestWindow w.title
			ENDOF
		8 OF 10  TestWindow w.type
				c" kHelpWindowClass"  TestWindow w.title
			ENDOF
		10 OF 11  TestWindow w.type
				c" kSheetWindowClass"  TestWindow w.title
			ENDOF
		11 OF 12  TestWindow w.type
				c" kToolbarWindowClass"  TestWindow w.title
			ENDOF
		12 OF 13  TestWindow w.type
				c" kPlainWindowClass"  TestWindow w.title
			ENDOF
		13 OF 14  TestWindow w.type
				c" kOverlayWindowClass"  TestWindow w.title
			ENDOF
		14 OF 15  TestWindow w.type
				c" kSheetAlertWindowClass"  TestWindow w.title
			ENDOF
		15 OF 16  TestWindow w.type
				c" kAltPlainWindowClass"  TestWindow w.title
			ENDOF
		16 OF 20  TestWindow w.type
				c" kDrawerWindowClass"  TestWindow w.title
			ENDOF
	
	
		1 TestWindow w.type							\ restart from class 1
		c" kAlertWindowClass"  TestWindow w.title
	ENDCASE
	TestWindow add.window
	event.loop
;

' (NextWindow) is NextWindow


having TEST  test NextWindow
99 TestWindow w.type	\ invalid class to start the demo
NextWindow


