*************************************************************************
*************************************************************************
 OVERVIEW 


1. Include "Remote Editor.fth" on your MFonVFX kernel to create the
Remote Editor


2. Launch VFX in Terminal and execute

    s" MF Remote/client console.fth" included
    START


START puts VFX into slave mode with its "pipe-console" installed
Further interaction with VFX will be via the Remote Editor.


Remote Edit window normally behaves like an editor.  To send
text to the remote client, use ENTER key.  That will send the contents of
the current line if no text is selected, or the entire selected range of
text. 

For a speed check, execute in the Remote Edit window
WORDS  <ENTERKEY>



Sending EXITTERM from Remote Editor  (or Terminal Menu: Remote Disconnect)
will restore the normal VFX XCON.

START from VFX client will re-enable remote mode




For a range selection test,

\ select text from here --->>

: STARS ( N -- )
	0 ?DO
		[char] * emit
	LOOP
;

: TestMe
	50 0
	DO
	  cr i stars
	LOOP
	0 50
	DO
	  cr  i  stars
	-1 +LOOP
;

TestMe

\ <<--- to here

COPY (cmd-C)
then PASTE (cmd-V) into the MF Remote Edit window

Re-Select the range in the Remote Edit window and hit the ENTER key

(**** note the extra CR's, will discuss later)


To Test remote client file include & error catching:

Send "REMOTE ERROR TEST.FTH" to remote client using either
 	Remote Include File (TERMINAL Menu)
or open the file in this program and use
	Save & Remote Include (TERMINAL Menu)

The remote's error catcher should force "REMOTE ERROR TEST.FTH" to open
on the Editor side with the error highlited.

Then comment out the invocation of TestAbort and repeat the remote
include to test it with a -13 error




ESCAPE KEY in the Remote Edit window will switch to a more tradtional
dumb terminal mode where every character typed is sent immediately to
remote client.  
- This mode does not currently handle pasting into the terminal
- Because of local echo and the client issuing an EOL after each line,
	double EOLs are prone to occur
	

*************************************************************************
*************************************************************************
 
 SETTABLE PREFERENCES 

Default - replies from the remote are displayed at current insertion
	InsertAtSelend -> TerminalInsertionMode

Option - to make all replies from remote get displayed at the end:
	InsertAtEND -> TerminalInsertionMode


Default - Escape Key sends ONLY the next character immediately
	true -> One-ShotEscapeMode

Option -  Escape Key toggles Immediate text entry mode vs Editor Mode
	false -> One-ShotEscapeMode


Default - In Escape mode, characters are echoed locally
	true -> EchoEscapeChars

Option -  In Escape mode, characters are NOT echoed locally
	false -> EchoEscapeChars


#LFsAfterEnter  a value that can be 0, 1, 2
#LFsAfterReply  a value that can be 0, 1, 2



*************************************************************************
*************************************************************************

 ABOUT THE SOURCE FILES 

"PFIFOS.FTH"  is pretty nearly solid, I think.  It has the basic stuff
that both remote client and editor use for creating and using pipes.
Pipes are created in <user>/Library/Application Support/VfxForth


"CLIENT CONSOLE.FTH"  seems pretty solid also.  Some extra stuff will be
added to support my preferred "Find ANywhere" functions for LOCATE and
SEE.  Also, the test code at the end will be further developed to allow
the Editor side to silently gather the client's vocabulary lists.


"REMOTE EDITOR.FTH" under construction.  Basic functions seem OK, but
needs some tuning both for use in normal MoV as well as in Stand Alone
mode


"REMOTE ERROR TEST.FTH"
 Send this file to remote client using either
 	Remote Include File (TERMINAL Menu)
or
	Save & Remote Include (TERMINAL Menu)

The remote's error catcher should force this file to open on the Editor
side with an ABORT"-ed word. 

Then comment out the invocation of TestAbort and re-include to test it
with a -13 error




*************************************************************************
*************************************************************************

 COMMENTS, TO-DO, ETC 


The current version runs a single remote editor (terminal) window and
runs on top of normal MoV.  So editor window behavior does vary a bit
depending on which window is in front.

Specifically, LOCATE (or TOOLS MENU:REFERENCE) still works on MFoVFX

LOCATE in the Remote Edit window does a locate from data in remote VFX

Since user may be editing a file he wants to compile with VFX, I have
nearly finished a version of the Editor Popup that can be used to locate
words on the VFX client.

Similarly, AUTO-INCLUDE and the Spell-Suggestion functions need to work
with the apprpriate vocabularies.  Still thinking on a resolution to this
one.

In a stand-alone remote editor, the above will not be a problem, since
the stand-alone will have access to its underlying MoV disabled anyway.
However, in that mode, it is not clear whether ALL Editor windows should
be allowed to communicate with the remote client VFX.  Probably yes.


