\ Traditional MacForth Advanced QD Graphics words

\ Last Revision: 16 Feb 2012  08:26:28  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


Only Forth definitions
decimal

\ anew --mfgraphics--

>M4TH


Extern:  void   FillRect   ( UInt32 * &rect, UInt32 * pattern );

Extern:  void   FrameOval  ( UInt32 * &rect );
Extern:  void   PaintOval  ( UInt32 * &rect );
Extern:  void   EraseOval  ( UInt32 * &rect );
Extern:  void   InvertOval ( UInt32 * &rect );
Extern:  void   FillOval   ( UInt32 * &rect, UInt32 * pattern );

Extern:  void   PaintRoundRect  ( UInt32 * &rect, UInt32 ovalWidth, UInt32 ovalHeight );
Extern:  void   EraseRoundRect  ( UInt32 * &rect, UInt32 ovalWidth, UInt32 ovalHeight );
Extern:  void   InvertRoundRect ( UInt32 * &rect, UInt32 ovalWidth, UInt32 ovalHeight );
Extern:  void   FillRoundRect   ( UInt32 * &rect, UInt32 ovalWidth, UInt32 ovalHeight, UInt32 * pattern );

Extern:  void   FrameArc  ( UInt32 * &rect, UInt32 startAngle, UInt32 arcAngle );
Extern:  void   PaintArc  ( UInt32 * &rect, UInt32 startAngle, UInt32 arcAngle );
Extern:  void   EraseArc  ( UInt32 * &rect, UInt32 startAngle, UInt32 arcAngle );
Extern:  void   InvertArc ( UInt32 * &rect, UInt32 startAngle, UInt32 arcAngle );
Extern:  void   FillArc   ( UInt32 * &rect, UInt32 startAngle, UInt32 arcAngle, UInt32 * pattern );

Extern:  void   FramePoly  ( UInt32 handle );
Extern:  void   PaintPoly  ( UInt32 handle );
Extern:  void   ErasePoly  ( UInt32 handle );
Extern:  void   InvertPoly ( UInt32 handle );
Extern:  void   FillPoly   ( UInt32 handle, UInt32 * pattern );

Extern:  void   OpenRgn   ( UInt32 void );
Extern:  void   CloseRgn  ( UInt32 rgnH );
Extern:  void   FrameRgn  ( UInt32 handle );
Extern:  void   PaintRgn  ( UInt32 handle );
Extern:  void   InvertRgn ( UInt32 handle );
Extern:  void   FillRgn   ( UInt32 handle, UInt32 * pattern );

: Set.Rect.Region  ( rgn\T\L\B\R -- )
	{ | temp[ 8 ] }
	temp[ !rect temp[ RectRgn ;



Extern:  void   ShowPen ( void );
Extern:  void   HidePen ( void );
Extern:  void   PenNormal ( void );


Extern:  void   PlotIcon   ( UInt32 * &RECT, UInt32 ICON.HANDLE );
Extern:  void   BackPat    ( UInt32 * &pat );
\ Extern:  void   PenPat     ( UInt32 * &pat );
Extern:  void   SetOrigin  ( UInt32 h, UInt32 v );
Extern:  void   SetString  ( UInt32 handle, UInt32 * &str );
Extern:  UInt32 handle NewString  ( UInt32 * &str );
Extern:  UInt32 width  StringWidth  ( UInt32 * &str );
Extern:  UInt32 flag RealFont  ( UInt32 * fontNum, UInt32 size );


Extern:  UInt32 picH OpenPicture   ( UInt32 * &r  );
Extern:  UInt32 picH OpenCPicture  ( UInt32 * &newHeader  );
Extern:  void   ClosePicture  ( void );
Extern:  void   KillPicture   ( UInt32 pict );

Extern:  UInt32 polyH OpenPoly  ( void );
Extern:  void   ClosePoly  ( void );
Extern:  void   KillPoly   ( UInt32 polyH );
Extern:  void   OffsetPoly ( UInt32 polyH, UInt32 dh, UInt32 hv );



Extern:  void   PackBits    ( UInt32 * srcPtr, UInt32 * destPtr, UInt32 srcByteCount );
Extern:  void   UnpackBits  ( UInt32 * srcPtr, UInt32 * destPtr, UInt32 srcByteCount );
Extern:  void   CopyBits ( UInt32 * &srcMap, UInt32 * &destMap, UInt32 * &srcR, UInt32 * &destR, UInt32 mode, UInt32 maskRgn );
Extern:  void   CopyMask ( UInt32 * &srcMap, UInt32 * &maskMap, UInt32 * &destMap, UInt32 * &srcR\, UInt32 * &maskR, UInt32 * &destR );
Extern:  UInt32 * ^bitmap GetPortBitMapForCopyBits ( CGrafPtr );
(* 
    GetPortBitMapForCopyBits is provided for the specific purpose of
	using the return value as a parameter to CopyBits.  The return value
	can be used as the srcBits or dstBits parameter to CopyBits regardless
	of whether the port is color.  If the port parameter is a color port,
	however, the returned BitMapPtr does not actually point to a BitMap; it
	points to the PixMapHandle and other fields in the CGrafPort structure. 
	You should not dereference the BitMapPtr or otherwise depend on its
	contents unless you've confirmed that this port is a non-color port. 
*)

extern: UInt32 OSerr NewGWorld ( UInt32 GworldPtr.addr, UInt32 depth, UInt32 boundsRect,
								  UInt32 CTabhandle, UInt32 GDHandle, UInt32 flags );
extern: void DisposeGWorld ( UInt32 GWorldptr );




\    Shape drawing modes

0 constant QD-FRAME
1 constant QD-PAINT
2 constant QD-CLEAR
3 constant QD-INVERT
4 constant QD-PATTERN



structure rect.record
	short: +top
	short: +left
	short: +bottom
	short: +right
structure.end

HEX
create GRAY   aa55aa55 EndianSwap32 , aa55aa55 EndianSwap32 ,	\ Gray Pattern
create LTGRAY 88228822 EndianSwap32 , 88228822 EndianSwap32 ,	\ Light Grey Pattern
create DKGRAY 77dd77dd EndianSwap32 , 77dd77dd EndianSwap32 ,	\ Dark Grey Pattern
DECIMAL



create SINTABLE
         0 w,   175 w,   349 w,
       523 w,   698 w,   872 w,
      1045 w,  1219 w,  1392 w,
      1564 w,  1736 w,  1908 w,  2079 w,
      2250 w,  2419 w,  2588 w,
      2756 w,  2924 w,  3090 w,  3256 w,
      3420 w,  3584 w,  3746 w,
      3907 w,  4067 w,  4226 w,  4384 w,
      4540 w,  4695 w,  4848 w,
      5000 w,  5150 w,  5299 w,  5446 w,
      5592 w,  5736 w,  5878 w,
      6018 w,  6157 w,  6293 w,  6428 w,
      6561 w,  6691 w,  6820 w,

      6947 w,  7071 w,  7193 w,  7314 w,
      7431 w,  7547 w,  7660 w,
      7771 w,  7880 w,  7986 w,  8090 w,
      8192 w,  8290 w,  8387 w,
      8480 w,  8572 w,  8660 w,  8746 w,
      8829 w,  8910 w,  8988 w,
      9063 w,  9135 w,  9205 w,  9272 w,
      9336 w,  9397 w,  9455 w,
      9511 w,  9563 w,  9613 w,  9659 w,
      9703 w,  9744 w,  9781 w,
      9816 w,  9848 w,  9877 w,  9903 w,
      9925 w,  9945 w,  9962 w,
      9976 w,  9986 w,  9994 w,  9998 w,
	 10000 w,  0 ,      0 ,


: SIN ( deg -- sine*10k )
	360 mod
	dup 180 >
	IF
		180 -
		-1 >R
	ELSE
		0 >R
	THEN	
	dup 90 >
	IF
		180 swap -
	THEN
	2 * sintable + w@s
	R> IF negate THEN
;


: COS  ( deg-- cos*10k )
	90 + SIN ;



: XYPIVOT  ( angle --  )
     360 mod      dup  get.xform.window +xypivot w!
     dup sin swap cos  get.xform.window +xybias !point ;


: SCALE>XY  ( H\V -- H\V SCALED TO XYSCALE )
      get.xform.window +XYSCALE @POINT		\ h\v\sX\sY
      ROT SWAP ABS 100 */  >R ABS 100 */  R> ;


: SCALE>Y ( V -- V  SCALES TO Y )
      get.xform.window +XYSCALE W@ ABS 100 */  ;


: GET.XYSCALE  ( -- x\y )
	get.xform.window +XYSCALE @POINT  ;


: GET.XYPIVOT  ( -- angle  )
	get.xform.window +XYPIVOT w@s  ;


: -ROTATION  ( --  angle | zero pivot  )
	window.xform @ <xform +xypivot dup @ swap off ;


: +ROTATION  ( angle -- )
	window.xform @ <xform +xypivot ! ;


create RectTokens	' FrameRect , ' PaintRect , ' EraseRect , ' InvertRect , ' FillRect ,
create OvalTokens	' FrameOval , ' PaintOval , ' EraseOval , ' InvertOval , ' FillOval ,
create RRectTokens	' FrameRoundRect , ' PaintRoundRect , ' EraseRoundRect , ' InvertRoundRect , ' FillRoundRect ,
create ArcTokens	' FrameArc ,  ' PaintArc ,  ' EraseArc ,  ' InvertArc ,  ' FillArc ,
create PolyTokens	' FramePoly , ' PaintPoly , ' ErasePoly , ' InvertPoly , ' FillPoly ,
create RgnTokens	' FrameRgn ,  ' PaintRgn ,  ' EraseRgn ,  ' InvertRgn ,  ' FillRgn ,


create SHAPERECT  8 allot	\ only to be used preceding calls to DrawShape


: !ORDEREDRECT  ( x1\y1\x2\y2\addr -- )  
	>R rot SortTwo		\ x1\x2\t\b
	2swap SortTwo		\ t\b\l\r
	rot swap			\ t\l\b\r
	R> !rect ;


: DRAWSHAPE  ( ...\[pattern addr]\mode\&tokens -- )
	swap 4 * + @execute ;


: >SHAPERECT  ( x1\y1\x2\y2  -- &shapeRect )
	4 needed
	-rotation >r
		WinXlate 2swap WinXlate ShapeRect !OrderedRect  
	r> +rotation
	ShapeRect ;


: R&O   ( x1\y2\x2\y2\[pattern addr]\mode -- &r\[pattern addr]\mode )
	>R R@ qd-pattern = IF  >R >shaperect  R>  ELSE  >shaperect   THEN R> ;


: RECTANGLE  ( x1\y1\x2\y2\[pattern addr]\mode --  )
    r&o RectTokens DrawShape ;


: RRECTANGLE  ( x1\y1\x2\y2\ow\oh\[pattern addr]\mode -- )
	>r  r@  qd-pattern =
		IF    >r scale>xy  2>r  >shaperect  2r> r>
		ELSE  scale>xy 2>r  >shaperect  2r>
		THEN 
	R> RRectTokens DrawShape ;


: OVAL  ( x1\y1\x2\y2\[pattern addr]\mode --  )
    r&o OvalTokens DrawShape ;


: ARC  ( x1\y1\x2\y2\startAngle\arcAngle\[pattern addr]\mode -- )
    >r  r@  qd-pattern =
       IF    >r  2>r  >shaperect  2r> r>
       ELSE 2>r  >shaperect  2r>
       THEN  
	R> ArcTokens DrawShape ;


: REGION  ( handle\[pattern addr]\mode --  )
    RgnTokens DrawShape ;


: POLYGON  ( handle\[pattern addr]\mode --  )
    PolyTokens DrawShape ;


: CALC.CIRCLE  ( x\y\radius -- x1\y1\x2\y2 )
	locals| R Y X |
	x r - 	y r -
	x r +	y r + ;


: CIRCLE  ( x\y\radius\[pattern addr]\mode -- )
	>r  r@  qd-pattern =
	IF    >r  calc.circle  r>
	ELSE  calc.circle
	THEN  
	r>  oval   ;


: MAX.X  ( -- x )
	get.xform.window +wcbounds  6 + w@s ;
	
	
: MAX.Y  ( -- y )
	get.xform.window +wcbounds  4 + w@s ;
	

: CENTER  ( -- | sets offset for center coordinates )
     max.x 2/ max.y 2/ xyoffset  ;


: LOWER.LEFT  ( -- |  sets offset to lower left of screen )
	get.xform.window +wcbounds
	2 + @point swap 1- xyoffset ;


: UPPER.LEFT  ( -- | sets offset to 0, yscale positive )
	0 0 XYOFFSET get.xyscale  abs XYSCALE  ;


: CARTESIAN ( -- ADDR | inverts yscale WHEN TRUE)
	get.xform.window +cartesian  ;


: PENSIZE  ( x\y -- )
    scale>xy PenSize ;


: TEXTSIZE  ( size -- )
	scale>y TextSize ;


: LINE.HEIGHT  ( height -- )
	scale>y get.xform.window +wline.height ! ;


: XYAXIS  ( -- )
	@PenState
	1 1 PenSize  black PenPat

	( axes )
	100    0 -100    0  vector
	  0  100    0 -100  vector

	( + and - symbols )
	103    0  109    0  vector
	106    3  106   -3  vector
	  0  103    0  109  vector
	 -3  106    3  106  vector
   -109    0 -103    0  vector
	 -3 -103    3 -103  vector

	!PenState ;


: InitText  ( TextSize -- )  \ set text height and line height
	dup TextSize
	dup 4 / +  Line.Height  ;	\ heights are scaled by XYScale


: GInit  ( --- )
	InitGraf 12 InitText  ;		\ default to 12-point


: <<XLATE  ( x\y\xform.array -- xr\yr)
	{ x y xform | sin cos }
	xform 12 + ( +xypivot ) w@s
	IF
 		\ calculate y = ycos + xsin; x = xcos - ysin
 		xform 14 + ( +xybias ) @point	\ sin\cos
 		-> cos  -> sin
 		x cos * y sin * - 10000 / 
 		y cos * x sin * + 10000 / 
 		-> y
 		-> x
	THEN

	xform 8 + ( +xyscale ) w@s dup
	100 <>
	IF	\ adjust XScale
		x *
		50 +			\ not symmetrical ?
		100 /
	ELSE
		drop
		X
	THEN

	xform 10 + ( +xyscale )  w@s dup
	100 <>
	IF	\ adjust YScale
		y *
		50 +			\ not symmetrical ?
		100 /
	ELSE
		drop
		Y
	THEN
	
	xform 22 + ( +cartesian ) @
	IF
		negate
	THEN
	
	xform 2@  ( +XYOFFSET )
	+point
;

' <<XLATE is XLATE


: ForgetMFGraphics
	['] drop is xlate
;  on.forget ForgetMFGraphics


\   Error Checking Primitives 
                
VARIABLE %IN-PROGRESS

  %IN-PROGRESS OFF   ( start: no definition in progress )

( Type constants: )
   1 CONSTANT  %DEF.POLY
   2 CONSTANT  %DEF.REGN
   3 CONSTANT  %DEF.PICT


( Text for error messages:)
here ," Picture"  here ," Region"  here ," Polygon"	( 3 pointers on stack )
  CREATE %NAMES  , , ,			( compile into array )

here ," END.PICTURE"  here ," END.REGION"  here ," END.POLY"
  CREATE %ENDS   , , ,


\    Error Detection & Message Output 

: .MESSAGE ( type\array\text$ -- )  \ print message & ABORT
	rot  %def.poly -  4 *  rot + @   ( get text )
	ShowPen   count type  count type
	cr beep abort ;


: ?-IN.PROGRESS  ( type -- )  \ must not already be in progress
	%in-progress @  ?dup
	IF   ( already remembering )
		cr %names c"  definition in progress."  .message
	THEN
	%in-progress ! ;


\    Error Detection & Message Output 

: ?IN.PROGRESS  ( type -- )  \ be sure type = %IN-PROGRESS
	%in-progress @  dup 0=
	IF
		drop cr ." No "  %names c"  definition in progress."
		.message
	ELSE
		<>  IF
			%in-progress @  %ends  c"  required."  .message
		THEN
		?csp  %in-progress off
	THEN  ;



\	* * * * * *   P I C T S   * * * * * *

: Picture.IS:  ( rect -- pict ) 	\ begin PICT def'n
	OpenPicture ;

: Picture.END  ( --- ) 				\ end PICT def'n
	ClosePicture ;


: NEW.PICTURE  ( rect -- )  \ create and start defining new pict
   1 needed   %def.pict ?-in.progress
   picture.is:  value
   ( in.heap )    !csp  ;


: END.PICTURE  ( -- )  \ end picture definition
   %def.pict ?in.progress  picture.end  ;


\	* * * * * *   P O L Y G O N S   * * * * * *

: Poly.IS:  ( --  polyHand )  		\ opens a new polygon
	OpenPoly ;

: Poly.END  ( --- ) 				\ closes current polygon
	ClosePoly ;


: NEW.POLY  ( -- )  \ create word that leaves poly handle
	%def.poly ?-in.progress
	poly.is:  value  ( in.heap )   !csp  ;

: END.POLY  ( -- )  \ end poly definition
	%def.poly ?in.progress   poly.end  ;


\	* * * * * *   R E G I O N S   * * * * * *

: Region.IS:  ( --- )  		\ begin def'n of new region
	OpenRgn ;

: Region.END  ( rgn -- )	\ end def'n of new region
	CloseRgn ;


: CREATE.REGION  ( -- )  \ create new region. DON'T begin def.
	newrgn value ( in.heap ) ;      ( no security )

: NEW.REGION  ( -- rgn )  \ create new region. begin definition
	%def.regn ?-in.progress
	newrgn dup  value  ( in.heap )  region.is:  !csp  ;

: END.REGION  ( rgn -- )  \ end region definition
	%def.regn ?in.progress  region.end  ;







\\

code SIN  ( deg -- sine*10k )
	rY 360 li,
	r0 rTOS rY divw,
	r0 rY mullw,
	rTOS r0 rTOS subf.,	\ rTOS = remainder of deg/360
	lt if,
		rTOS 360 addi,	\ make it a true modulus
	then,
	rTOS 180 cmpi,
	r0 0 li,
	ge if,
		rTOS 180 subi,
		r0 -1 li,
	then,
	rTOS 90 cmpi,
	rY 180 li,
	gt if,
		rTOS rTOS rY subf,
	then,				\ rTOS now in [0..90]
	rTOS rTOS add,		\ prepare for half-cell addressing
	rX rDBP target['] SINTABLE getdfa databaseptr - addi,		\ !!!!!!!!!!!!
	rTOS rX rTOS lhzx,	\ get sin
	rTOS r0 xor,		\ negate..
	rTOS r0 rTOS subf,	\ ..if necessary
	next, end-code



code  XLATE  ( x\y\xform.array -- xr\yr)
			\   rotates and scales a point relative to origin
 	rY 0 rDSP lwz,	\ d2
 	rX 4 rDSP lwz,	\ d0
 	
 	r3 -4 rDSP stw,		\ r3 = xform
 	r4 -8 rDSP stw,		\ r4 = X
 	r5 -12 rDSP stw,	\ r5 = Y
 	
 	r0 12 rTOS lhz,
 	r0 0 cmpi,		\ angle present?			+XYPIVOT
 	ne if,			\ rotate coordinates
 		\ calculate y = ycos + xsin; x = xcos - ysin
 		r0 14 rTOS lha,	\ get cos * 10000
 		r3 rY r0 mullw,	\ r3 = ycos * 10000
 		r5 16 rTOS lha,	\ get sin * 10000
 		r4 rX r5 mullw,	\ r4 = xsin * 10000
 		r5 ry r5 mullw,	\ r5 = ysin * 10000
 		rY r3 r4 add,	\ rY = (ycos + xsin) * 10000
 		r4 10000 li,
 		rY r4 divw,		\ rY = (ycos + xsin)
 		r3 rX r0 mullw,	\ r3 = xcos * 10000
 		rX r5 r3 subf,	\ rX =(xcos - ysin) * 10000
 		rX r4 divw,		\ rY = (xcos - ysin)
 	then,

	r3 8 rTOS lhz,		\ get x scale
	crX r3 100 cmpi,
	r4 10 rTOS lhz,		\ get y scale
	crY r4 100 cmpi,
	r5 100 li,
	crX ne if,
		rX r3 mullw.,
		rX 50 addi,		\ round..
		lt if,
			rX 100 subi, \ ..symetrically
		then,
		rX r5 divw,
	then,
	crY ne if,
		rY r4 mullw.,
		rY 50 addi,		\ round..
		lt if,
			rY 100 subi, \ ..symetrically
		then,
		rY r5 divw,
	then,

	r3 22 rTOS lwz,		\ get cartesian flag
	rY r3 xor,
	rY r3 rY subf,		\ negate Y is necessary
	
	r3 4 rTOS lwz,		\ x offset
	r4 0 rTOS lwz,		\ y offset
	rX r3 add,
	rY r4 add,
	
 	r3 -4 rDSP lwz,
 	r4 -8 rDSP lwz,
 	r5 -12 rDSP lwz,

	rX 4 rDSP stwu,
	rTOS rY move,

	next,  end-code


