\ Show Menus.fth
\ Show Menus in use and their items
\ Last Revision: 7 May 2012  10:51:40  ward@megawolf.com



\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


(* *************************************************************************

ShowMenus     To review currently assigned MenuID's
ShowMenus+    To review all menus and their item lists
ShowMenuCMDs  To review only menu items that have command keys assigned

************************************************************************* *)



only forth definitions

decimal


anew --showmenus--

>m4th


extern: void GetItemCmd  ( UInt32 menuH, UInt32 item#, UInt32 &itemStr );


\ extern: UInt32 StringPtr GetMenuTitle ( UInt32 MenuRef, UInt32 * title );
\ this one is preferred nowadays:
extern: UInt32  OSStatus CopyMenuTitleAsCFString ( UInt32 MenuRef, UInt32 * CFStringRef );

extern: UInt32 OSStatus GetMenuItemModifiers ( UInt32 MenuRef, UInt32 item#, UInt8 *modifiers );
(( 
	kMenuNoModifiers If no bit is set, only the Command key is used in the
	keyboard equivalent. 
	
	kMenuShiftModifier If this bit (bit 0) is set, the Shift key is used in the
	keyboard equivalent. 
	
	kMenuOptionModifier If this bit (bit 1) is set, the Option key is used in
	the keyboard equivalent. 
	
	kMenuControlModifier If this bit (bit 2) is set, the Control key is used in
	the keyboard equivalent. 
	
	kMenuNoCommandModifier If this bit (bit 3) is set, the Command key is not
	used in the keyboard equivalent. 
 ))


: ShowMenu ( showaction?\menu# -- )
	{ showaction? menu#  }
	cr menu# 2 .R 4 spaces
	menu# GetMenuHandle item$ CopyMenuTitleAsCFString
	IF 
		." ???"
	ELSE
		item$ @ showcfstring
	THEN
	showaction?
	IF
		40 col @ - spaces 
		menu# >MENU @ ?dup
		IF
			dup >name ?dup
			IF
				count  type
				drop
			ELSE
				." ?? == " .
			THEN
		ELSE
			cr ." no action assigned"
		THEN
	THEN
;

: GetItemMods ( menuH\item -- modifiers )
	0 >R
	rp@ GetMenuItemModifiers drop
	R>
;

: ShowItemMods  ( menuH\item -- )
	GetItemMods
	dup 8 and		\ kMenuNoCommandModifier
	0=
	IF
	   ." Cmd-"
	THEN
	dup 4 and		\ kMenuControlModifier
	IF
	   ." Ctrl-"
	THEN
	dup 2 and		\ kMenuOptionModifier
	IF
	   ." Opt-"
	THEN
	1 and			\ kMenuShiftModifier
	IF
	   ." Shft-"
	THEN
;


: ShowItems ( indent\menu# -- )
	dup menu.handle 
	locals| theH theID indent |
	theID CountMenuItems 1+  ( menuID -- itemCount )
	1
	?DO
		cr indent spaces
\		theH i ShowItemMods
		theH i item$ GetItemCmd  ( menuH\item#\&itemStr -- )
		item$ w@ ?dup
		IF
			theH i  ShowItemMods  ( menuH\item -- )
			$FF and emit  2
		ELSE
			3
		THEN
		spaces
		theH i item$ GetMenuItemText  ( menuH\item#\&itemStr -- )
		16 indent + col @ - spaces
		i 2 .R 2 spaces
		item$ count type
	LOOP
;


: ShowMenus ( -- )		\ simplest version
	MAX#MENUS dup ." Max # Menus = " .
	cr ." ID    MENU TITLE                        MENU ACTION"
	cr ." ===================================================="
	0
	?DO
		i >MENU @
		IF
			true i ShowMenu
		THEN
	LOOP ;


: ShowMenus+ ( -- )		\ show menus and all their items
	MAX#MENUS 0
	?DO
		i >MENU @
		IF
			true i ShowMenu
			8 I ShowItems ( indent\menu# -- )
			cr
		THEN
	LOOP ;


: ShowItemsWithCmds ( indent\menu# -- )
	dup menu.handle 
	locals| theH theID indent |
	theID CountMenuItems 1+ ( menuID -- itemCount )
	0
	?DO
		theH i item$ GetItemCmd  ( menuH\item#\&itemStr -- )
		item$ w@ ?dup
		IF
			cr indent spaces
			theH i  ShowItemMods  ( menuH\item -- )

			$FF and emit
			16 indent + col @ - spaces
			i 2 .R 2 spaces
			theH i item$ GetMenuItemText  ( menuH\item#\&itemStr -- )
			item$ count type
		THEN
	LOOP
;


: ShowMenuCMDs ( -- )		\ show menu items that have command keys
	MAX#MENUS 0
	?DO
		i >MENU @
		IF
			false i ShowMenu
			8 I ShowItemsWithCmds ( indent\menu# -- )
		THEN
	LOOP ;


StopIncluding

ShowMenus
Max # Menus = 63 
ID    MENU TITLE                        MENU ACTION
====================================================
 1                                     DO.APPLE.MENU
 2    File                              SE.DO.FILE.MENU
 3    Edit                              SE.DO.EDIT.MENU
 4    Options                           DO.OPTIONS.MENU
 9    Tools                             TOOLSSELECTION
10    Windows                           DO.WINDOWSMENU
11    Project                           DO.PROJECT.MENU
20    Help                              DO.HELP.MENU
21    Open Recent                      DORECENTFILESMENU
22    LineEndingMenu                    DO.LINE.ENDING.SUBMENU
23    NewSourceFile                     DONEWHIERMENU




ShowMenuCMDs

 1    
        Cmd-,           Preferences
 2    File
        Cmd-O           Open...
        Cmd-Opt-O       Open Any As Text...
        Cmd-W           Close
        Cmd-Opt-W       Close All Editor Windows
        Cmd-Opt-Shft-W  Discard Front Window
        Cmd-S           Save
        Cmd-Opt-S       Save All Editor Windows
        Cmd-K           Save & Include
        Cmd-Opt-K       Include Front Window
        Cmd-E           Edit '~untitled.fth'
        Cmd-F           Find...
        Cmd-Opt-F       Find From Top...
        Cmd-Shft-F      Find Prior...
        Cmd-Opt-Shft-F  Find From End...
        Cmd-G           Find Next
        Cmd-Opt-G       Find Again From Top
        Cmd-Shft-G      Find Again Prior
        Cmd-Opt-Shft-G  Find Again From End
        Cmd-H           Find Next Selected
        Cmd-Opt-H       Find Selected From Top
        Cmd-Shft-H      Find Prior Selected
        Cmd-Opt-Shft-H  Find Selected From End
        Cmd-I           Include...
 3    Edit
        Cmd-Z           Undo Cut
        Cmd-Shft-Z      Redo 
        Cmd-X           Cut
        Cmd-C           Copy
        Cmd-V           Paste
        Cmd-A           Select All
        Cmd-J           Jump To Mark
        Cmd-U           Upper Case
        Cmd-L           Lower Case
        Cmd-]           Indent
        Cmd-[           Outdent
        Cmd-M           Re-Margin
 4    Options
        Cmd-.           Abort
 9    Tools
        Cmd-R           Reference
        Cmd-\           TEST_DUMMY
        Cmd-1           Insert |**** 
        Cmd-2           Insert ****| 
        Cmd-3           Insert --\-- 
        Cmd-4           Insert |********| 
        Cmd-5           |**** Range ****|
10    Windows
11    Project
20    Help
21    Open Recent
22    LineEndingMenu
23    NewSourceFile
        Cmd-N           New Empty File
        Cmd-Opt-N       New Source File


ShowMenus+

 1                                     DO.APPLE.MENU
                         1  About This Application
                         2  Adding Application Menu Items
                         3  About MacForth on VFX
                         4  -
        Cmd-,            5  Preferences

 2    File                              SE.DO.FILE.MENU
                         1  New
        Cmd-O            2  Open...
        Cmd-Opt-O        3  Open Any As Text...
                         4  Open Recent
        Cmd-W            5  Close
        Cmd-Opt-W        6  Close All Editor Windows
        Cmd-Opt-Shft-W   7  Discard Front Window
        Cmd-S            8  Save
        Cmd-Opt-S        9  Save All Editor Windows
                        10  Save As...
        Cmd-K           11  Save & Include
        Cmd-Opt-K       12  Include Front Window
                        13  -
                        14  Revert to Saved
        Cmd-E           15  Edit '~untitled.fth'
                        16  -
        Cmd-F           17  Find...
        Cmd-Opt-F       18  Find From Top...
        Cmd-Shft-F      19  Find Prior...
        Cmd-Opt-Shft-F  20  Find From End...
        Cmd-G           21  Find Next
        Cmd-Opt-G       22  Find Again From Top
        Cmd-Shft-G      23  Find Again Prior
        Cmd-Opt-Shft-G  24  Find Again From End
        Cmd-H           25  Find Next Selected
        Cmd-Opt-H       26  Find Selected From Top
        Cmd-Shft-H      27  Find Prior Selected
        Cmd-Opt-Shft-H  28  Find Selected From End
                        29  -
                        30  Change Line Endings
                        31  -
                        32  Page Setup...
                        33  Print...
                        34  Print Window
                        35  -
        Cmd-I           36  Include...

 3    Edit                              SE.DO.EDIT.MENU
        Cmd-Z            1  Undo Typing
        Cmd-Shft-Z       2  Redo 
                         3  -
        Cmd-X            4  Cut
        Cmd-C            5  Copy
        Cmd-V            6  Paste
                         7  Clear
                         8  -
        Cmd-A            9  Select All
                        10  Page Break
                        11  Go to Line#
                        12  Go to Page#
        Cmd-J           13  Jump To Mark
                        14  -
        Cmd-U           15  Upper Case
        Cmd-L           16  Lower Case
        Cmd-]           17  Indent
        Cmd-[           18  Outdent
        Cmd-M           19  Re-Margin
                        20  -
                        21  R\L Auto Scroll
                        22  Auto-Indent
                        23  -
                        24  Remember Window Positions

 4    Options                           DO.OPTIONS.MENU
        Cmd-.            1  Abort
                         2  -
                         3  Noisy
                         4  -
                         5  MacForth Window
                         6  -
                         7  Edit Launch Script
                         8  Edit Build Script
                         9  View Log File
                        10  -
                        11  Clean Workspace

 9    Tools                             TOOLSSELECTION
                         1  Date Stamp
                         2  -
        Cmd-R            3  Reference
                         4  -
        Cmd-\            5  TEST_DUMMY
                         6  -
                         7  (( Comment Range ))
                         8  -
                         9  Editor Autocompletion
                        10  -
                        11  History Window
                        12  -
                        13  Event Monitor
                        14  -
                        15  Compare Two Files
                        16  Collate Two Files
                        17  -
        Cmd-1           18  Insert |**** 
        Cmd-2           19  Insert ****| 
        Cmd-3           20  Insert --\-- 
        Cmd-4           21  Insert |********| 
        Cmd-5           22  |**** Range ****|

10    Windows                           DO.WINDOWSMENU
                         1  Stack Editor Windows
                         2  Tile Editor Windows
                         3  Bring All To Front
                         4  -
                         5  Show Menus.fth
                         6  untitled.fth
                         7  MacForth on VFX

11    Project                           DO.PROJECT.MENU
                         1  Select the file you wish to open
                         2  -
                         3  Trace.fth
                         4  Compare Files Tool.fth
                         5  Event Monitor Tool.fth
                         6  Numbering&Time.fth
                         7  Old Color.fth
                         8  Old Controls.fth
                         9  MacForth Graphics.fth
                        10  InsertMetaComments.fth
                        11  Autocompletion Tool.fth
                        12  Editor Popup.fth
                        13  HelpMenu.fth
                        14  ProjectMenu.fth
                        15  WindowsMenu.fth
                        16  Word List Extras.fth
                        17  Actels&Wordlists.fth
                        18  Sys.Window Extras.fth
                        19  Recent Files.fth
                        20  New Source File.fth
                        21  Colorize Editor.fth
                        22  Editor Tools.fth
                        23  Editor.fth
                        24  ToolsMenu.fth
                        25  PrintFile.fth
                        26  Printing.fth
                        27  OptionsMenu.fth
                        28  Ndp387.fth
                        29  Carbon Menus.fth
                        30  Modal Dialogs.fth
                        31  Misc.fth
                        32  InfoWindow.fth
                        33  Snapshot.fth
                        34  Startup Sequence.fth
                        35  EditMenu.fth
                        36  FileMenu.fth
                        37  AppMenu.fth
                        38  Dialogs.fth
                        39  Scrap.fth
                        40  Colors.fth
                        41  MF VFX Console.fth
                        42  Nib File Basics.fth
                        43  Nib Binary Controls.fth
                        44  Carbon Events.fth
                        45  Apple Events.fth
                        46  EZNav.fth
                        47  Navigation.fth
                        48  IO.fth
                        49  Resource Bagging.fth
                        50  Events.fth
                        51  Controls.fth
                        52  Menus.fth
                        53  Windows.fth
                        54  Logging.fth
                        55  MF Console.fth
                        56  Files.fth
                        57  CoreFoundation.fth
                        58  Errors.fth
                        59  Chains.fth
                        60  Traps.fth
                        61  User.fth
                        62  Structures.fth
                        63  Utils.fth
                        64  Compatility Changes.fth
                        65  Compatility Extras.fth
                        66  Early Extras.fth
                        67  mfbuild.fth
                        68  SysConfig.fth
                        69  random.fth
                        70  PDFhelp.fth
                        71  xterm.fth
                        72  IniParser.fth
                        73  MiscOSX.fth
                        74  signal.fth
                        75  defmac.fth
                        76  shell.fth
                        77  osxfunc.fth
                        78  PARSEL.fth
                        79  VOCTOOLS.fth
                        80  C_LANG.fth
                        81  BNF.fth
                        82  FIFO.fth
                        83  CommLine.fth
                        84  p4opt.fth
                        85  Extern.fth
                        86  MODULES.fth
                        87  Vfx2.BLD
                        88  DIS.FTH
                        89  DASM387.FTH
                        90  DASM386.FTH
                        91  SWITCHES.FTH
                        92  Tokeniser.fth
                        93  OPT386.FTH
                        94  INLINE.FTH
                        95  HARNESS.FTH
                        96  BUILD.FTH
                        97  ASM8687.FTH
                        98  console.fth
                        99  SaveOSX.fth
                        100  VfxSupp.fth
                        101  syspatch.fth
                        102  VERSION.FTH
                        103  BUILD.FTH
                        104  GENERIC.FTH
                        105  ENVIRON.FTH
                        106  GenLocals.fth
                        107  kernel.fth
                        108  REQDCODE.FTH
                        109  startup.fth

20    Help                              DO.HELP.MENU
                         1  MPE Web Page
                         2  -
                         3  VFX Manual
                         4  -
                         5  Help Selection
                         6  -
                         7  ANS Forth Standard

21    Open Recent                      DORECENTFILESMENU
                         1  Shift-Select toggles lock
                         2  Opt-Select removes an entry
                         3  -
                         4  Show Menus.fth
                         5  60 Misc.fth
                         6  50 Startup Sequence.fth
                         7  20 Windows.fth
                         8  80 Editor.fth
                         9  21 Menus.fth
                        10  kernel.fth
                        11  46 AppMenu.fth
                        12  Default.Extensions
                        13  Menus.h
                        14  Show Menus Deluxe
                        15  hanoi.fth
                        16  Only One
                        17  06 Traps.fth
                        18  26 Resource Bagging.fth
                        19  Menu Title Icon.fth
                        20  05 User.fth
                        21  08 Errors.fth
                        22  HIView.h
                        23  Icons.h
                        24  CGImageSource.h
                        25  IconsCore.h
                        26  83 New Source File.fth
                        27  93 HelpMenu.fth
                        28  change history
                        29  Tutorial Source
                        30  24 Events.fth
                        31  01 Compatility Extras.fth
                        32  Old Controls.fth
                        33  m4th log
                        34  86 Sys.Window Extras.fth
                        35  Compare Files Tool.fth
                        36  75 ToolsMenu.fth
                        37   ->0 TO DO
                        38  NAMES.fth
                        39  Directory Walker
                        40  GetDataFile
                        41  MFBuild.fth
                        42  Suggestions.fth

22    LineEndingMenu                    DO.LINE.ENDING.SUBMENU
                         1  LF's->CR's
                         2  CR's->LF's
                         3  Strip LF's

23    NewSourceFile                     DONEWSOURCEMENU
        Cmd-N            1  New Empty File
        Cmd-Opt-N        2  New Source File

ok
