\ TRACE
\ Last Revision: 4 Mar 2012  07:52:47  ward@megawolf.com


((

First pass at restoring TRACE to MFonVFX

To enable  tracing, use  TRACEON
To disable tracing, use  TRACEOFF

DEBUG ON  enables traced display

Pressing SPACE while Tracing pauses/resumes the display
Presing any other key aborts Tracing

TraceDelay may be used to slow display

Best done in an editor window


See "/MF Docs/Debugging Tops" for more info
 ))



only forth definitions

\ anew --tracetest--
>m4th
decimal


defer INTERPRET-TRACE  ( -- )	  ' noop is INTERPRET-TRACE
defer TRACEACTION  ( c-addr -- )  ' drop is traceaction

 0 value TraceDelay					\ milliseconds to pause between Trace lines
10 value TraceEOLChar				\ set preferred EOL character




: (INTERPRET+trace)   \ --     modified from VFX (INTERPRET)
  \ Added the following check along with PTO.
  \ If the first character in the input stream is an ASCII 12
  \ replace it with a space character
  source if
    dup c@ FFEED =
    if  abl swap c!  else  drop  then
  else
    drop
  then

  begin
    >in @ saved>in !
    ?stack  bl word dup c@
  while					\ -- caddr
    dup >r  count CLASSHOOK 0= if
      r> find		\ c-addr -- c-addr 0 | xt 1 | xt -1
      here count pocket place
      INTERPRET-TRACE		\ <<<<<<<---------

      ?dup if
        0< state @ and
        if   compile-word  else  Cexecute  then
      else
        DROP POCKET			\ <<<<<<<---------
        dup >r  count doIsNumber? ?dup if	\ ?? ; R: caddr --
          r> drop  state @ if
            dup 0<
	    	if  C#Fliteral  else  C#literal  then
          else
            drop
          then
        else
          r> count CUndefined
        then
      then
    else
      r> drop
    then
  repeat
  drop
;



: ?TRACE  ( -- | emplace trace if flag is set )
     compiling
\     trace @  and
     IF
\		here count pocket place
     	['] (C") compile,
     		pocket count $,
     	['] TRACEACTION compile,
\     	compile TRACEACTION
     THEN  ;


: (.S)  ( n --  depth to ignore )
	depth over - 1 -     ."     ( "  dup  .  ." ) "
	8 min		\ num to skip\num to show
	BEGIN  dup 0>
	WHILE  ." \ " 2dup + 1 +  pick .  1 -
	REPEAT
	2drop ;



: (TRACE)  ( $addr -- )
	locals| addr |
	debug @ 0= IF EXIT THEN			\ exit if not debugging
	events @ dup -257 and events !	\  disable activates while tracing
	TraceDelay ms
	key?  							\ keyboardStream? and
	IF
		key bl -
		IF
			events ON
			true abort"  Trace Aborted "
		THEN
		key drop
	THEN
	hld @
		dp @    					\ temporarily offset trace dp
			dup  10:000  + dp !
			outfile @
				debugfile @ ?dup IF outfile ! THEN	\ optional redirect output
				26 col @ - 2 max spaces  4  (.s)  TraceEOLChar emit
  				rdepth
				\ adjust indent when tracing in Editor window
				\ ( SE.INTERPRET is quite deeply nested )
				se.window get.window = IF 30 - THEN
				4 -  0 max spaces		\ indent return stack depth
				addr count type
				space
			outfile !
		dp !
	hld !
	events ! ;





: TraceOn ( -- )		\ enable Trace mode
	unoptimised
	['] ?trace  is interpret-trace
	['] (trace) is traceaction
	['] (interpret+trace) is interpret
\	trace on
;


: TraceOff ( -- )		\ Disable Trace mode
\	trace off
	['] (interpret) is interpret
	optimised
;  on.forget TraceOff





\\

test snippet

TraceOn
: A1 ( n -- n*n+6n )
	dup dup *
	swap 6 * +
;

: A2
	rdepth .
	5 0
	DO
		cr i dup . A1 .
	LOOP
;
TraceOff

100 to TraceDelay
Debug On
A2
