\ InsertMetaComments
\ Created:       10/27/02  04:03:40 PM  wjm
\ Last Revision: 10/27/02  04:03:40 PM  wjm
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\    to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


(* *************************************************************************

These " meta comment" words can be use to comment out stuff that can be removed
prior to distribution.  Stuff that is appropriate for this include old code,
historical anecdotes, private comments, dirty words, etc that are not useful to
the end-user, but may be of interest to the author. 

Use the "MetaComment Purger" tool to remove meta comments.


  is a commenting pair at the same level as (* and (


************************************************************************* *)

Only Forth Definitions
Decimal

\ anew --InsertMetaComments--

>m4th
also editorvocab
also ToolVocab definitions


ToolsMenu#  drop		\ needs Tools Menu


create MetaComment.ToolGroup -1 , 	\ holds ID of this tool group




: InsertEOL ( -- )			\ InsertCR
	SE.EOLMode @
	CASE
		CR=EOL   OF cr$		ENDOF
		LF=EOL   OF lf$		ENDOF
\		CRLF=EOL OF LF->CRLF 	ENDOF		\ blocked by InsertEOL
	ENDCASE

	count se.window selend @  dup selstart !
	(insert.text>se)
;


: InsertBL ( -- )
	bl$ count se.window selend @  dup selstart !
	(insert.text>se)
;


: OkToInsert? ( -- flag )
	?NoEditAllowed
	se.window front.window =
	dup 0= IF beep THEN
;


: Insert-|**** ( -- )
	OkToInsert?
	IF
		SE.DELETE
		c" |**** " count
		se.window selend @  dup selstart !
		(insert.text>se) ( addr\cnt\SEWindow\offset -- )
		InsertEOL
	THEN
;

: Insert-****| ( -- )
	OkToInsert?
	IF
		SE.DELETE
		c" ****|" count
		se.window selend @  dup selstart !
		(insert.text>se) ( addr\cnt\SEWindow\offset -- )
		InsertEOL
	THEN
;

: Insert---\-- ( -- )
	OkToInsert?
	IF
		SE.DELETE
		c" --\--" count
		se.window selend @  dup selstart !
		(insert.text>se) ( addr\cnt\SEWindow\offset -- )
		InsertBL
	THEN
;

: Insert-|********| ( -- )
	OkToInsert?
	IF
		SE.DELETE
		InsertEOL
		c" |********|" count
		se.window 				\ selend @  dup selstart !
		selstart @
		(insert.text>se) ( addr\cnt\SEWindow\offset -- )
		InsertEOL
	THEN
;


: |****CommentRange  ( -- )
	selstart @ selend @
	{ wasSelStart wasSelEnd }
	OkToInsert?
	IF
		5 SaveRangeOp		\ SaveFormattingRange
		InhibitUndo @ >R
		InhibitUndo ON

		wasSelEnd   selstart !   Insert-****|
		selend @ -> wasSelEnd
		
		wasSelStart selstart !
		wasSelStart selend !     Insert-|****

		wasSelEnd dup selend ! selstart !
		show.selend

		R> InhibitUndo !
		6 SaveRangeOp		\ CorrectFormattingEnd
	THEN
;



: RemoveMetaCommentTool (  -- | Remove the TestIT Tools menu group )
	MetaComment.ToolGroup @ dup -1 <> 		\ no room for group ?
	IF   PruneToolItem  
	ELSE drop
	THEN
;
on.forget RemoveMetaCommentTool


>m4th
also ToolVocab

: InstallMetaCommentTool ( -- | Install the TestIT Tools menu group )
	ToolsMenu# menu.handle 0= IF Tools.Menu THEN
	4 NewToolGroup          		\ Enough room to install items ?
	IF
		MetaComment.ToolGroup !      		\ Save separator item number

	    ['] Insert-|****		c" Insert |**** /1"			NewToolItem drop
	    ['] Insert-****|		c" Insert ****| /2"			NewToolItem drop
	    ['] Insert---\--		c" Insert --\-- /3"			NewToolItem drop
	    ['] Insert-|********|	c" Insert |********| /4"	NewToolItem drop
	    ['] |****CommentRange	c" |**** Range ****|/5"		NewToolItem drop
	THEN 
;


\ InstallMetaCommentTool


>m4th

\\


: RemoveMetaCommentTool ( lo\hi -- | Remove the TestIT Tools menu group )
	[ latestToken ] literal token>addr rot rot range
	IF
		MetaComment.ToolGroup @ dup -1 <> 		\ no room for group ?
		over ToolCount > not and
		IF   PruneToolItem  
			 -1 Test.ToolGroup !
		ELSE drop
		THEN
	THEN
	drop ;

forgettor linklasttoken		\ on.forget RemoveTestTool

\ previous

InstallMetaCommentTool

ok


ok
RemoveMetaCommentTool .s

DATA STACK
empty stack

ok

ToolCount .
6 
ok

ok


MetaComment.ToolGroup @ .s

DATA STACK
     top
              7 0000:0007

ok \ 1 

PruneToolItem

ok


