\ Modal Dialog Support
\ Last Revision: 1 Feb 2012  15:48:12  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************



only FORTH Definitions
decimal

>m4th


\ extern: void CloseDialog	( UInt32 dlogRef );  - no longer available  - use DisposeDialog
AliasedExtern: _ModalDialog  void ModalDialog	( UInt32 * filterProc, UInt32 * &itemHit );
\ extern: void ModalDialog	( UInt32 * filterProc, UInt32 * &itemHit );
extern: void HideDialogItem ( UInt32 dlogRef, UInt32 item# );
extern: void ShowDialogItem ( UInt32 dlogRef, UInt32 item# );

extern: void SetDialogItem  ( UInt32 dlogRef, UInt32 item#, UInt32 type, UInt32 Handle, UInt32 * &Rect );

\ extern: UInt32 OSErr SetDialogDefaultItem ( UInt32 DialogRef, UInt32 DialogItemIndex );
extern: UInt32 OSErr SetDialogCancelItem  ( UInt32 DialogRef, UInt32 DialogItemIndex );

extern: void OSErr DisposeModalFilterUPP ( UInt32 ModalFilterUPP );
extern: UInt32 ModalFilterUPP NewModalFilterUPP  ( UInt32 ModalFilterProcPtr );
	( filter does:  DialogPtr\^EventRecord\^itemHit -- Boolean )



\  Main routines

: ModalDialog  ( filterProc -- item# )  \ returns number of hit item
	\ filterProc =  ( bool.W\dlogRef.L\eventPtr.L\itemPtr.L -- bool.W )
	0 >R  rp@   _ModalDialog  R> extend ;


: DO.MODAL.DIALOG  ( -- item# )
	0 ModalDialog ;				\ default (nil) filter-proc



DEFER DialogFilter  ( dialogPtr\eventPtr\itemPtr -- flag )  ' 2drop is DialogFilter

3 0  CALLBACK: DialogFilterProcPtr
	' DialogFilter to-callback DialogFilterProcPtr

0  value DialogFilterUPP



: FilteredDialog  ( filterToken -- item# )
	\ filterToken executes as:  ( dlogRef\eventPtr\itemPtr -- flag )
	\ ref:
	IS DialogFilter
	
	DialogFilterProcPtr  NewModalFilterUPP -> DialogFilterUPP
	DialogFilterUPP ModalDialog
	DialogFilterUPP DisposeModalFilterUPP
;


: ESCAPE.MODELESS? ( -- )	\ force polite exit if front window is a MODAL
	front.window
	?wptr FALSE= ( true if **NOT** MacForth wptr4 , so ?must? be a modal dialog )
	IF
		FrontWindow GetDialogFromWindow end.modeless
	THEN
;	quitter LINKLASTTOKEN		\ to ensure safe return to Interpreter
								\ if a MODAL dialog is in front


create TEMPBUF  0 , 0 , 0 , 0 , 0 ,		\ scratch area for dlog item manipulation


: GET.DLOG.ITEM ( item#\dlogPtr -- )		\ copies results to TempBuf
	swap  tempbuf  tempbuf 4 +  tempbuf 8 +
	GetDialogItem ; ( dlogPtr\item#\addr of type\addr of handle\addr of rect -- )


: GET.I.TYPE ( item#\dlogPtr -- type )
	get.dlog.item
	tempbuf w@ ;


: SET.I.TYPE ( new type\item#\dlogPtr -- )
	2dup get.dlog.item
	swap
	ROT								\ use new TYPE
	tempbuf 4 + @ tempbuf 8 +		\ but old Handle and Rect
	SetDialogItem ;		( dlogPtr\item#\itemType\itemHandle\rectPtr -- )


: GET.ITEM.RECT ( item#\dlogPtr -- ^rect )
	get.dlog.item
	tempbuf 8 + ;


: SET.ITEM.RECT ( ^newrect\item#\dlogPtr -- )
	2dup get.dlog.item
	swap
	tempbuf w@  tempbuf 4 +	@		\ use old type and Handle
	4 roll								\ but use new rect
	SetDialogItem ;		( dlogPtr\item#\itemType\itemHandle\rectPtr -- )



: GET.DLOG$ ( ^str$dest\item#\dlogPtr -- )		\ check TYPE ??
	\ retrieve STR$ as ITEM# of DLOG
	get.dlog.item
	tempbuf 4 + @  						\ get item handle	
	swap GetDialogItemText ;       ( item handle\&text buffer -- )


: SET.DLOG$ ( str$\item#\dlogPtr -- )		\ check TYPE ??
	\ install STR$ as ITEM# of DLOG
	get.dlog.item
	tempbuf 4 + @  						\ get item handle	
	swap SetDialogItemText ;


: ENABLE.DLOG.ITEM ( flag\item#\dlogPtr -- | true flag enables )
	locals| DlogPtr TheItem# TheFlag |
	TheItem# DlogPtr get.dlog.item
	DlogPtr TheItem#
	tempbuf w@  						\ get item type
		theflag IF $7f and ELSE $80 OR THEN
	tempbuf 4 + @
	tempbuf 8 +
	SetDialogItem ;		( dlogPtr\item#\itemType\itemHandle\rectPtr -- )
	


: GET.DLOG.CONTROLREF ( item#\dlogPtr -- Controlref )
	swap tempbuf
	GetDialogItemAsControl ( dlogRef\item#\Controlhandle -- OSerr )
	IF
		0		\ return 0 if error
	ELSE
		tempbuf @
	THEN
;


: SET.DLOG.CONTROL ( value\item#\dlogPtr -- )
	\ adjust value of control item
	\ binary controls expect 0 or 1 (NOT -1)
	get.dlog.controlref  						\ get Controlref
	swap SetControl32BitValue ;


: GET.DLOG.CONTROL32 ( item#\dlogPtr -- value )	\ 605434
	get.dlog.controlref  						\ get Controlref
	GetControl32BitValue ;


: SET.DLOG.CONTROL32 ( value\item#\dlogPtr -- )	\ 605434
	\ adjust value of control item
	\ binary controls expect 0 or 1 (NOT -1)
	get.dlog.controlref  						\ get Controlref
	swap SetControlValue ;


: TOGGLE.DLOG.CONTROL ( item#\dlogPtr -- new result )
	\ toggle value of control item
	get.dlog.controlref  						\ get Controlref
	dup GetControl32BitValue IF 0 ELSE 1 THEN
	dup >R
	SetControlValue
	R> ;


: HILITE.DLOG.CONTROL ( hilite flag\item#\dlogPtr -- )		\ check TYPE ??
	\ adjust hiliting of control item
	get.dlog.controlref  						\ get Controlref
	swap HiliteControl  ;


lacking FrameRoundRect   Extern:  void   FrameRoundRect ( UInt32 * &rect, UInt32 ovalWidth, UInt32ovalHeight  );


: OUTLINE.DLOG.ITEM ( item#\dlogPtr -- | Outline item# in DLOG )
	getport
	get.window  
	locals| SavedWindow SavedPort |
	dup GetDialogWindow GetWindowPort <SetPort  \ (window)
	get.item.rect
    dup -4 -4 InsetRect
	3 3 _PenSize
	16 16 FrameRoundRect 
	SavedWindow ?wptr IF SavedWindow window THEN
	SavedPort <SetPort ;



: NUMBER->STRING ( n -- ^str | convert single to COUNTED String$ in current BASE )
	\ uses PAD
	base @ 10 =    ( signed output for base 10 )
	IF    s>d dup >R dabs <# #s R> sign #>
	ELSE  0 <# #s  #>
	THEN
	dup pad c! 
	pad 1+ swap cmove
	pad 
;


: GET.NUMERIC.FROM.DIALOG ( item/dlog -- [d\true] or [false] )
	pad rot rot get.dlog$ ( ^str$dest\item#\dlogPtr -- )
	0 s>d  pad count >number	nip 0=		\ if string length = 0 , then it completed conversion
	IF
		true
	ELSE
		2drop
		0
	THEN
 ;

