\ PRINTING
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions

>M4TH

vocabulary PrintVocab

also PrintVocab Definitions

decimal


\ defer PrintFile		' noop is PrintFile

structure PMRect
	float: +PMRectTop
	float: +PMRectLeft
	float: +PMRectBottom
	float: +PMRectRight
structure.end

(*
	Most Printing Structures are "opaque" under carbon and cannot be
	directly accessed.  Special Toolbox calls are available for
	accessing almost all internal values
*)


extern: UInt32 OSErr PMError    ( void );
extern: UInt32 OSErr PMSetError ( n  );	\ print manager error code - USAGE DISCOURAGED BY APPLE

\ PMCreateSession
extern: UInt32 OSErr PMBegin   ( void );
extern: UInt32 OSErr PMEnd	   ( void );

extern: UInt32 OSErr PMBeginDocument ( UInt32 PMPrintSettings, UInt32 PMPageFormat,  UInt32 * PMPrintContext  );

extern: UInt32 OSErr PMEndDocument ( UInt32 PMPrintContext  );

extern: UInt32 OSErr PMBeginPage  ( UInt32 PMPrintContext, UInt32 * PMRect  );
extern: UInt32 OSErr PMEndPage	( UInt32 PMPrintContext  );



(*
kPMGeneralError				EQU	-30870
kPMOutOfScope				EQU	-30871		; an API call is out of scope 
kPMInvalidParameter			EQU	-30872		; a required parameter is missing or invalid 
kPMNotImplemented			EQU	-30873		; this API call is not supported 
kPMNoSuchEntry				EQU	-30874		; no such entry 
kPMInvalidPrintSettings		EQU	-30875		; the printsettings reference is invalid 
kPMInvalidPageFormat		EQU	-30876		; the pageformat reference is invalid 
kPMValueOutOfRange			EQU	-30877		; a value passed in is out of range 
kPMLockIgnored				EQU	-30878		; the lock value was ignored 
*)


\ PMSessionGetCGGraphicsContext
extern: UInt32 OSErr PMGetGrafPtr ( UInt32 PMPrintContext, UInt32 * &grafPort  );


\ PAGE SETUP ( STYLE ) STUFF

\ PMCreatePageFormat  PMSessionDefaultPageFormat  PMSessionValidatePageFormat
extern: UInt32 OSErr PMNewPageFormat	  ( UInt32 * PMPageFormat  );
extern: UInt32 OSErr PMDefaultPageFormat  ( UInt32  PMPageFormat  );
extern: UInt32 OSErr PMValidatePageFormat ( UInt32  PMPageFormat,  UInt32 *result  );

\ PMRelease
extern: UInt32 OSErr PMDisposePageFormat	( UInt32 * PMPageFormat  );

\ deprecated
extern: UInt32 OSErr PMConvertOldPrintRecord ( UInt32 printRecordHandle, UInt32 * PMPrintSettings, UInt32 * PMPageFormat  );


\ PMPageFormatCreateDataRepresentation  PMPageFormatCreateWithDataRepresentation
extern: UInt32 OSErr PMFlattenPageFormat	( UInt32 * PMPageFormat, UInt32 flatFormatHandle  );
extern: UInt32 OSErr PMUnflattenPageFormat  ( UInt32 flatFormatHandle, UInt32 * PMPageFormat  );



extern: UInt32 OSErr PMPageSetupDialogInit	( UInt32 * PMPageFormat, UInt32 * PMDialog  );

extern: UInt32 OSErr PMPageSetupDialog ( UInt32 * PMPageFormat, UInt32 *accepted  );


\ PMCreatePrintSettings
extern: UInt32 OSErr PMNewPrintSettings		( UInt32 PMPrintSettings   );
\ PMRelease
extern: UInt32 OSErr PMDisposePrintSettings	( UInt32 PMPrintSettings   );
\ PMSessionDefaultPrintSettings
extern: UInt32 OSErr PMDefaultPrintSettings	( UInt32 PMPrintSettings   );

\ PMSessionValidatePrintSettings
extern: UInt32 OSErr PMValidatePrintSettings  ( UInt32  PMPrintSettings,  UInt32  *result  );

extern: UInt32 OSErr PMCopyPrintSettings	  ( UInt32  PMPrintSettingsSrc, UInt32  PMPrintSettingsDest );

\ deprecated PMPrintSettingsCreateDataRepresentation
extern: UInt32 OSErr PMFlattenPrintSettings   ( UInt32  PMPrintSettings,  UInt32  flatSettingsHandle  );
\ deprecated PMPrintSettingsCreateWithDataRepresentation
extern: UInt32 OSErr PMUnflattenPrintSettings ( UInt32  flatSettingsHandle, UInt32 PMPrintSettings  );



extern: UInt32 OSErr PMPrintDialog ( UInt32 PMPrintSettings,  UInt32 * PMPageFormat, UInt32 *accepted  );

extern: UInt32 PMIdleUPP NewPMIdleUPP	( UInt32 PMIdleProcPt   );
extern: void  DisposePMIdleUPP			( UInt32 PMIdleUPP );

extern: UInt32 OSErr PMGetAdjustedPageRect  (  UInt32 * PMPageFormat, UInt32 * PMRect  );
extern: UInt32 OSErr PMGetAdjustedPaperRect	(  UInt32 * PMPageFormat, UInt32 * PMRect  );


\ USE PMGetUnadjustedPaperRect  PMGetUnadjustedPageRect
extern: UInt32 OSErr PMGetPhysicalPaperSize	(  UInt32 * PMPageFormat,  UInt32 * PMRect );
extern: UInt32 OSErr PMGetPhysicalPageSize  (  UInt32 * PMPageFormat,  UInt32 * PMRect );


\ PMPrintSettingsGetJobName PMPrintSettingsSetJobName
extern: UInt32 OSErr PMGetJobName	( UInt32 PMPrintSettings, UInt32 StringPtr );
extern: UInt32 OSErr PMSetJobName	( UInt32 PMPrintSettings, UInt32 StringPtr );


extern: UInt32 OSErr PMGetCopies	( UInt32 PMPrintSettings, UInt32 *	#copies  );
extern: UInt32 OSErr PMSetCopies	( UInt32 PMPrintSettings, UInt32 #copies, UInt32 lock  );

extern: UInt32 OSErr PMGetFirstPage	( UInt32 PMPrintSettings, UInt32 * first  );
extern: UInt32 OSErr PMSetFirstPage	( UInt32 PMPrintSettings, UInt32 first, UInt32 lock  );

extern: UInt32 OSErr PMGetLastPage	( UInt32 PMPrintSettings, UInt32 * last  );
extern: UInt32 OSErr PMSetLastPage  ( UInt32 PMPrintSettings, UInt32 last, UInt32 lock  );

\ always returns VALID page range
extern: UInt32 OSErr PMGetPageRange	( UInt32 PMPrintSettings, UInt32 * minPage, UInt32 * maxPage  );
extern: UInt32 OSErr PMSetPageRange	( UInt32 PMPrintSettings, UInt32 minPage,  UInt32 maxPage  );





0 value oldWindow
0 value oldEvents
0 value oldOutfile
0 value windowChanged?
1 auto.key lshift  1 activate.event lshift  or  	\ to mask off auto
	invert constant  -auto-activates				\   and activate events


: SAVE.CURRENT.WINDOW ( -- )
	get.window		 -> oldWindow
	events @		 -> oldEvents
	events @  -auto-activates and  events !
	outfile @		 -> oldOutfile
	outfile on ;

: RESTORE.WINDOW ( -- )
	windowChanged?
	if	oldWindow		(window)
		oldOutfile		outfile !
		oldEvents		events !
		flush.events
		discard.activates
		false -> windowChanged?
	then ;



0 value hPrint			\ in.heap		\ old-style print-record handle storage

0 value pState
	\ pState = 0 ==> not printing
		\ Bit Flags:
		\  1 = we have executed PMBegin
		\  2 = we have a valid style
		\  4 = we have a valid job
		\  8 = we have a document open
		\ 16 = we have a page open



\ instead of printrec's, CARBON keeps 2 opaque objects:
\	PMPageFormat    --> holds style info
\   PMPrintSettings --> holds job info
\ Functions are available for converting between printrec and new format

create aPMPageFormat			0 ,
create aPMPrintSettings			0 ,


\ places to keep a handle to new-style "flattened" style & job objects
create aFlatPageFormatHandle	0 ,  \ in.heap
create aFlatPrintSettingsHandle	0 ,  \ in.heap


: ForceDefaultStyle ( -- )		\ restore current PMPageFormat to default
	aFlatPageFormatHandle @ ?dup
	IF  to.heap 
		aFlatPageFormatHandle off
	THEN
;


: ForceDefaultJob ( -- )		\ restore current PMPrintSettings to default
	aFlatPrintSettingsHandle @ ?dup
	IF  to.heap 
		aFlatPrintSettingsHandle off
	THEN
;


 128 Constant iPrAbort   	\ user abort id number
defer TerminatePrinting 	\ executed just before aborting with ?PrError message
	' noop is TerminatePrinting

: PRT.SHUTDOWN
	TerminatePrinting
	0 HiliteMenu ;


: prtAbort ( str -- )
	dup c@
	IF
		"" "" "" 401 issueAlert drop discard.activates
	ELSE	drop
	THEN ;


: DO.PRINTING.ERROR  ( error.code -- )
   	CASE
   	\ carbon errors returned by all PM functions
	-30870 OF c" PMGeneralError "			ENDOF
	-30871 OF c" PMOutOfScope "				ENDOF
	-30872 OF c" PMInvalidParameter "		ENDOF
	-30873 OF c" PMNotImplemented "			ENDOF
	-30874 OF c" PMNoSuchEntry "			ENDOF
	-30875 OF c" PMInvalidPrintSettings "	ENDOF
	-30876 OF c" PMInvalidPageFormat "		ENDOF
	-30877 OF c" PMValueOutOfRange "		ENDOF
	-30878 OF c" PMLockIgnored "			ENDOF

	\ old-style errors reported by 
	  -1   OF c" Error saving Print File"					ENDOF
	  -17  OF c" Unimplemented printer control function"	ENDOF
	  -27  OF c" I/O error during printing"					ENDOF
	  -108 OF c" Not enough room in heap for printing"		ENDOF
	   107 OF c" Out of Memory for Filter Stack"			ENDOF
	   108 OF c" Missing or invalid Print Record"			ENDOF
	 -4101 OF 2 -> pState c" Printer not responding"		ENDOF
  iPrAbort OF "" ( no alert for this )						ENDOF
	 		\  c" Error While Printing" swap
			dup
			\ s>d <# #s c" Print Error# " hold$  #>   addrcnt->pstr
			s" Print Error# "  pocket place
	    	pocket append
			pocket swap
	ENDCASE
	prtAbort
	pState			\ hang on to current value TO PASS TO ?RETRY
	prt.shutdown
\	?retry
	>mf.window ;


0 value PE


: (?PrintError) ( Err# -- | aborts if error code condition)
	pause
	?dup IF dup to pe do.printing.error THEN ;

: ?PrintError (  -- | aborts if error code condition)
	PMError (?PrintError) ;

0 value PriorIO.EVENTS

: StartPrinting ( -- OSerr )
	pState
	IF
		0
	ELSE
		aPMPageFormat off
		aPMPrintSettings off
		PMBegin 
		dup 0= IF 1 to pState THEN
		io.events @ -> PriorIO.EVENTS
		io.events OFF
	THEN
;

: EndPrinting ( -- OSerr )
	PriorIO.EVENTS  io.events !
	pState
	IF
		0 to pState
		PMEnd
		aPMPageFormat off
		aPMPrintSettings off
	ELSE
		0
	THEN
;


: (SetUpStyle) ( -- )	\ use prior settings or create default
\ must be called within  StartPrinting ... EndPrinting
	pState 2 and 0=
	IF
		aFlatPageFormatHandle @ ?dup	\ Carbon version in memory supercedes...
		IF
			aPMPageFormat PMUnflattenPageFormat (?PrintError)
		ELSE
			hPrint ?dup					\ old-style resource based if nothing saved
			IF		\ use hPrint if available, but must convert to old format
				aPMPrintSettings aPMPageFormat PMConvertOldPrintRecord (?PrintError)
			ELSE	\ else create new, default style
				aPMPageFormat   PMNewPageFormat (?PrintError)
				aPMPageFormat @ PMDefaultPageFormat (?PrintError)
			THEN
		THEN
		pState 2 OR -> pState
	THEN ;


: (PrStyleDialog) ( -- Boolean | style dialog, true if OK button)
\ must be called within  StartPrinting ... EndPrinting
	get.cursor 
	0
	locals| userOK?  theCursor |
	init.cursor

	(SetUpStyle)			\ get prior defaults

	aPMPageFormat @ pad dup off PMPageSetupDialog (?PrintError)
	pad @		\ no cancel
	IF
		true -> userOK?
		aPMPageFormat @ pad dup off PMValidatePageFormat (?PrintError)
		\ stash the results
		ForceDefaultStyle				\ clean up any old one
		aPMPageFormat @ aFlatPageFormatHandle PMFlattenPageFormat (?PrintError)
	THEN

	theCursor set.cursor
	discard.activates
	userOK?  ;


: PrStyleDialog ( -- Boolean | style dialog, true if OK button)
\ Do style dialog OUTSIDE of main print loop
\ Will start with prior style if there is one
	StartPrinting
	(?PrintError)
	(PrStyleDialog)
	EndPrinting   
	(?PrintError) ;



\ : (SetUpJob) ( -- )		\ use prior settings or create default

: SetUpPrJob ( -- )		\ use prior settings or create default
\ must be called within  StartPrinting ... EndPrinting
	pState 4 and 0=
	IF
		aFlatPrintSettingsHandle @ ?dup	\ Carbon version in memory supercedes...
		IF
			aPMPrintSettings PMUnflattenPrintSettings (?PrintError)
		ELSE
			aPMPrintSettings   PMNewPrintSettings     (?PrintError)
			aPMPrintSettings @ PMDefaultPrintSettings (?PrintError)
			aPMPrintSettings @ aFlatPrintSettingsHandle PMFlattenPrintSettings (?PrintError)
		THEN
	THEN
;


0 value JobName$

: NameTheJob ( -- )
	aPMPrintSettings @
	JobName$ ?dup 0=
	IF				\ nothing special assigned, so use default
		c" MacForth Print Job"
	THEN
	PMSetJobName  drop
	0 -> JobName$	\ make it a one-shot
;


defer AdditionalPrJobSetup ( -- )	
	' noop is AdditionalPrJobSetup


: PrJobDialog ( -- Boolean | style dialog, true if OK button)
\ must be called within  StartPrinting ... EndPrinting
\                    or  PMBegin      ... PMEnd
	get.cursor 
	locals|  theCursor |
	init.cursor

	(SetUpStyle)		\ use prior settings or create default
	SetUpPrJob			\ use prior settings or create default
	AdditionalPrJobSetup \ can add other initializations here,
						\ like PMSetFirstPage  PMSetLastPage  PMSetPageRange

	NameTheJob

	aPMPrintSettings @ 
	  aPMPageFormat @
		pad dup off PMPrintDialog (?PrintError)
	pad @		\ no cancel
	IF
		-1
		aPMPrintSettings @ pad dup off PMValidatePrintSettings (?PrintError)
		( what to do with result at PAD ?? )
		\ save prior value
		ForceDefaultJob					\ clean up any old one
		aPMPrintSettings @ aFlatPrintSettingsHandle PMFlattenPrintSettings (?PrintError)
\		NameTheJob
	ELSE
		0
	THEN
	theCursor set.cursor
	discard.activates ;



: PRINTING.PREP  ( -- )
	\ userAbortProc dup addTask stopTask
	StartPrinting (?PrintError)
	(SetUpStyle)
	SetUpPrJob
	0 PMSetError drop
	false -> windowChanged? ;




\ for possible later restoration of cancel dialog
defer Install.UserAbortProc ( -- )
	' noop is Install.UserAbortProc
defer Remove.UserAbortProc ( -- )
	' noop is Remove.UserAbortProc
defer StopCancelDlg ( -- )
	' noop is StopCancelDlg
defer StartCancelDlg ( -- )
	' noop is StartCancelDlg
defer SetCancelDialog ( ID#\run.token\init.token -- )
	' 3drop is SetCancelDialog




create  pPrPort  0 ,
create  aPMRect  4 8 * allot&erase			\ floating rectangle !!


defer LoadPrintRec ( -- )
	' noop is LoadPrintRec
defer SavePrintRec ( -- )
	' noop is SavePrintRec


create aPrintContext 0 ,

: (CLOSE.PAGE)  ( -- )
\ must be called within  StartPrinting ... EndPrinting
	pPrPort off 	\ remove reference to now invalid prport

	aPrintContext @  PMEndPage	drop ( check for error )
	pState 16 invert AND -> pState
;


: (CLOSE.DOCUMENT)  ( -- )
\ must be called within  StartPrinting ... EndPrinting
	pState 16 OR
	IF
		(close.page)
	THEN
	pState 8 OR
	IF
		aPrintContext @  PMEndDocument	drop ( check for error )
		pState 8 invert AND -> pState
	THEN
	stopCancelDlg
	restore.window
;


: (PRINTING.DONE)  ( -- )
\ must be called within  StartPrinting ... EndPrinting
	EndPrinting   (?PrintError)
	0 -> PState
;


: PRINTING.DONE  ( -- )
	pState 16 and  IF (close.page)		THEN
	pState  8 and  IF (close.document)	THEN
	pState  	   IF (printing.done)	THEN ;

' printing.done IS TerminatePrinting



NEW.XFORM PrinterXForm
		  dflt.window.xform PrinterXForm xform.size cmove
		  0 0 32000 32000 PrinterXForm !rect

: (OPEN.PAGE)  ( -- )
\ must be called within  (OPEN.DOCUMENT) ... (OPEN.DOCUMENT)
\ Because PMBeginPage also initializes the printing port, your application should
\ not make assumptions about the state of the port (for example, the current
\ font) between successive pages.  After each call to PMBeginPage , your
\ application should call PMGetGrafPtr to obtain the current printing
\ port, and set the drawing port to this port using the QuickDraw SetPort
\ function. 
	?PrintError
\	aPrintContext @	aPMRect	PMBeginPage drop
\ OSX ignores the scaling rectangle, so we won't use it either
	aPrintContext @	0		PMBeginPage (?PrintError)
	PMError dup 0= 
	swap iPrAbort = or 
	IF
		pState 16 OR -> pState
	THEN

	aPrintContext @  pPrPort  PMGetGrafPtr (?PrintError)
	pPrPort	@  <SetPort
	currentWindow off
	-1  outfile !
	PrinterXForm window.xform !
;


: (OPEN.DOCUMENT)  ( -- )
\ must be called within   StartPrinting ... EndPrinting
	0 PMSetError	drop ( probably not needed )
	false -> windowChanged?
	save.current.window
	startCancelDlg 
	?PrintError

	aPMPrintSettings @
	aPMPageFormat @
	aPrintContext
	PMBeginDocument	drop ( check for error )

	PMError dup 0= swap iPrAbort = or 
	IF
		pState 8 OR -> pState
		true -> windowChanged?
	THEN
	?PrintError
;


\ Some High-level words that can be revectored

defer OPEN.DOCUMENT			' (open.document)  is open.document
defer OPEN.PAGE				' (open.page)      is open.page
defer CLOSE.PAGE			' (close.page)     is close.page
defer CLOSE.DOCUMENT		' (close.document) is close.document



StopIncluding ************************************

