\ NEW SOURCE FILE
\ create a generic source file template
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\    to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


(* *************************************************************************

This converts the New item under the File Menu to a Hierarchical menu
with two Items
 New Empty File  CMD-N     - same as old New - creates empty untitled window
 New Source File opt-CMD-N - creates and saves a new Named file and editor window 
 					         prefilled with "boiler plate"

The boiler plate can be generated from this file but if MFonVFX's Bundle Resource folder
contains files named "Template1" and/or "Template2"  Those are used for presetting to
your choice.

Feel free to edit those files to your preference.  You will at least want to personalize
Template1's copyright notice

A new source file will look like this:

\ <name of the file>
\ Created:       28 Apr 2012  06:32:45  ward@megawolf.com
\ Last Revision: 28 Apr 2012  06:32:45  ward@megawolf.com

<< "Template1" placed here >>

Only Forth Definitions

anew --<nameoffile>--

>M4TH
Decimal

<< "Template2" placed here >>

************************************************************************* *)


Only Forth Definitions

\ anew --83_NewSourceFile.fth--

>M4TH
Decimal

also ToolVocab
also editorVocab definitions 


: PutSourceFile ( prompt$\defaultname$ -- file# )
	0 locals| file# name$ prompt$ |
	ClearReply

	SE.DfltFileType @ 			\ if not, use the default
	fileType !					\ leave CREATOR as is

	prompt$ name$ reply StandardPutFile
	discard.activates	
	replyOK? dup continue? !
	IF
		NavReplyVolume NavReplyDir NavReplyName  HDelete drop
		SetVolDirToNav
		0  NavReplyName new.file to file#	?file.error
	THEN
	file# ;


: AdjustNameStr ( str -- )	\ convert white spaces to underscores
	locals| theStr |
	theStr count
	0
	?DO
		dup i + c@  bl <=
		IF
			ascii _ over i + c!
		THEN
	LOOP
	drop					\ 10.45
	theStr c@ 27 min theStr c!
;



: SE.WINDOW.WRITE ( addr\cnt -- )	\ append string to current SE.WINDOW
	se.window (editor.write) drop
;

: SE.AppendCRs ( nn -- )				\ append nn CR's to current SE.WINDOW
	0 ?DO
		se.eolchar 1 se.window.write
	LOOP
;

: SE.APPEND.STARS ( nn-- )				\ append nn *'s to current SE.WINDOW
	0 ?DO
		ascii * sp@ 1 se.window.write drop
	LOOP
;


: SE.AppendHandle ( handle -- )
	?dup
	IF
		dup lock.handle
		dup  @
		swap handle.size
		se.window.write 
	THEN
;


: (NewSourceFile...) ( prompt$\filename$\FirstTemplate$\SecondTemplate$ -- )
	locals| SecondTemplate$ FirstTemplate$ |
	PutSourceFile ?dup
	IF
		dup >R before.se.save.as ?dup IF execute ELSE drop THEN
		se.new
		se.window	window
		NavReplyName se.window set.wtitle			\ file name becomes window title
		R@ SetProxyIcon
		R> fileclose								\ we do not need the file open before the save

		NavReplyVolume  se.volref# w!	
		NavReplyDir 	se.ioDir !
		-1              se.realfile w!
		
		c" \ " count  se.window.write 				\ 1st line of file = title
			NavReplyName count se.window.write 
		1  SE.AppendCRs
		make.created.stamp$ count se.window.write	\ 2nd line of file = created stamp
		make.revised.stamp$ count se.window.write	\ 3rd line of file = modified stamp

		FirstTemplate$ FileContents->Handle  ?dup
		IF
			dup SE.AppendHandle
				to.heap
		ELSE	\ if resource not present, use default
			c" (* "  count se.window.write
			72 se.append.stars
			2  SE.AppendCRs
			c" --> copyright notice, general description and/or comments <--"
				count se.window.write 
			2  SE.AppendCRs
			72 se.append.stars
			c"  *)" 
				count se.window.write 
			2  SE.AppendCRs
			c" Only Forth Definitions" count se.window.write 
			se.window cr>editor
			1  SE.AppendCRs
		THEN
			c" anew --" count se.window.write 
			NavReplyName AdjustNameStr
			NavReplyName count se.window.write 
			c" --" count se.window.write 

			2  SE.AppendCRs
			c" >M4TH" count se.window.write 
			1  SE.AppendCRs
			c" Decimal" count se.window.write 

		SecondTemplate$ FileContents->Handle  ?dup
		IF
			dup SE.AppendHandle  
			    to.heap
		ELSE	\ if resource not present, use default						
			20  SE.AppendCRs
			c" stopincluding "  count se.window.write
			57 se.append.stars
			1  SE.AppendCRs
			c" \ ****************** comments and/or test code below ******************"
				count se.window.write
			1  SE.AppendCRs
			71 se.append.stars
			2  SE.AppendCRs
		THEN

		true continue? !
		se.save
		0 (goJumpMark)
		se.window dup active.window ! dup outfile ! window
		se.window @ screen.bounds InvalWindowRect drop
	THEN
;


: NewSourceFile...
	C" Name New Source File"  C" A New File.fth"
    c" %MyResourcesPath%/SrcTemplate1"  c" %MyResourcesPath%/SrcTemplate2"	\ 10.46 - add /
	(NewSourceFile...)
;

: ForgetNewSourceFile ( -- )
	FileMenu# GetMenuHandle ?DUP
	IF
		dup 1 0 ascii N SetMenuItemCommandKey drop		\ enable cmd-N in File Menu
		    1 0 SetMenuItemHierarchicalID drop
		drawmenubar
	THEN
; on.forget ForgetNewSourceFile




0 value <NewSourceHierID>

: DoNewSourceMenu ( item# -- )
	0 HiliteMenu
	CASE
		1 OF se.new				ENDOF
		2 OF NewSourceFile...	ENDOF
	ENDCASE
;


>m4th
also editorvocab

\  kMenuItemAttrSubmenuParentChoosable = (1 << 2),


: InstallNewSourceFile ( -- )
	<NewSourceHierID> ?dup IF delete.menu 0 -> <NewSourceHierID> THEN
	20 1stFreeMenu# -> <NewSourceHierID>
	-1 c" NewSourceFile" <NewSourceHierID> new.menu
	c" New Empty File/N;New Source File/N" <NewSourceHierID> append.items
	FileMenu# -menu.handle 1 0 0 SetMenuItemCommandKey	drop \ disable cmd-N in File Menu
	2 2 <NewSourceHierID> set.item.modifiers ( item\modifer\menu.id -- )

	FileMenu# -menu.handle  dup 1 <NewSourceHierID> SetMenuItemHierarchicalID drop
	\ make the root NEW behave as it used to
				 1 4 0 ChangeMenuItemAttributes drop
	drawmenubar
	<NewSourceHierID>  menu.selection:  DoNewSourceMenu 
;


>m4th


stopincluding *********************************************************
******************* comments and/or test code below *******************
***********************************************************************
