\ SYS.WINDOW PASTE
\ Created:       09/21/03  01:36:38 PM  wjm
\ Last Revision: 09/21/03  01:36:38 PM  wjm
\ Last Revision: 12 Jan 2012  09:54:24  ward@megawolf.com


(( 
	Remember & Restore Sys.Window location
	
	Paste into Sys.Window
	
	Sys.Window History Window
 ))


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\    to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


Only Forth Definitions
Decimal

>m4th


\ ************************************************************************
\ Save Sys.Window bounds into our INI file
\ as well as a few misc preferences


also system
prune:
	2dup IniLoadChain trim-links
	2dup IniSaveChain trim-links
;
previous


variable Restore.Sys.Window   
			Restore.Sys.Window ON


also ToolVocab definitions

create SizePosBuff  
			0 , 		\ position
			0 ,			\ size


: (GetSize&Position) ( wptr -- )
	{ thewptr  }
	get.window >R
	thewptr window
		0 0 xy>point local>global
			SizePosBuff !
	thewptr GetWindowPortBounds 4 + @
			SizePosBuff 4 + !
	R> window
;


: (RestoreSize&Position) ( wptr -- )
	{ thewptr  }
	thewptr ?wvisible
	IF
		SizePosBuff 4 +  @ ?dup
		IF
			point>xy   thewptr SetWindowSize 
		THEN
		SizePosBuff  @ ?dup
		IF
			point>xy   thewptr SetWindowPos
		THEN
	ELSE
		SizePosBuff @rect ?dup
		IF
			2over d+ thewptr w.bounds
		ELSE
			3drop
		THEN
	THEN
	thewptr size.window
;

also editorvocab
also substitutions


: SaveMFPreferences			\ --
  s" macforth" Ini.Section
  
  s" mfSourcePath" 		 mfSourcePath count 		   Ini.WriteStr
  s" restore.positions"	 restore.positions	w@ boolean Ini.WriteBool
  s" auto.hscroll"		 auto.hscroll 		w@ boolean Ini.WriteBool
  s" auto.indent"		 auto.indent 		w@ boolean Ini.WriteBool
  s" noisy"				 noisy				@  boolean Ini.WriteBool
  s" restore.sys.window" Restore.Sys.Window @  boolean Ini.WriteBool
  s" UseAppForProxy"	 UseAppForProxy     @  boolean Ini.WriteBool	\ 10.47 
  
  sys.window (GetSize&Position)
  s" sys.windowlocation"   SizePosBuff 8    Ini.WriteMem	\ c-addr1 u1 c-addr2 u2 --
; ' SaveMFPreferences AtIniSave



: LoadMFPreferences			\ --
  s" macforth" Ini.Section

  s" mfSourcePath" 	mfSourcePath #255 cNull count Ini.ReadStr

  s" restore.positions"	 1	 Ini.ReadBool	restore.positions w!
  s" auto.hscroll"		 1	 Ini.ReadBool	auto.hscroll w!
  s" auto.indent"		 1	 Ini.ReadBool	auto.indent w!
  s" noisy"				 1	 Ini.ReadBool	noisy !
  s" restore.sys.window" 1	 Ini.ReadBool   Restore.Sys.Window !
  s" UseAppForProxy"	 1	 Ini.ReadBool   UseAppForProxy !	\ 10.47 
 
  s" sys.windowlocation" 	SizePosBuff 8 Ini.ReadMem
\	sys.window (RestoreSize&Position)		\ currently needs to be done after DFLT.STARTUP
; ' LoadMFPreferences AtIniLoad

previous
previous


: Resize.Sys.Window ( -- )
	Restore.Sys.Window @
	IF
		sys.window (RestoreSize&Position)
	THEN
;  restorer linklasttoken					\ currently needs to be done after DFLT.STARTUP





\ ************************************************************************
\ ************************************************************************

>m4th
also ToolVocab definitions

\ Allow Pasting into SYS.WINDOW

0 value PasteTextHandle
0 value PasteTextOffset


: PurgeTextHandle ( -- )
	PasteTextHandle
	IF
		PasteTextHandle RealHandle?
		IF
			PasteTextHandle to.heap
		THEN
	THEN
	0 -> PasteTextHandle
	0 -> PasteTextOffset
;
\ execute this when QUIT executes - kludge to clear PasteTextHandle 
\   when an error occurs in a multi-line paste
quitter linklasttoken	


: Scrap>PasteTextHandle ( -- true if copied )
	PurgeTextHandle
	0 from.heap -> PasteTextHandle
	PasteTextHandle ascii TEXT get.scrap ( DEST.HANDLE\FLAVOR -- IO-RESULT )	
	0>
;


: @PasteTextNextChar ( -- char or 0 )	\ extract chars 1 at a time
	PasteTextHandle dup
	IF
		handle.size PasteTextOffset <=
		IF
			0 -> PasteTextOffset
			PurgeTextHandle
			false
		ELSE
			PasteTextHandle @  PasteTextOffset + c@
			
			\ cr -> lf
			
			1 +to PasteTextOffset
		THEN
	THEN
;


: PasteableKey  ( -- char | handles window input )
	infile @ ?wptr
	IF
		BEGIN
			@PasteTextNextChar	\ anything in PasteTextHandle ?
			dup
			IF					\ simulate a keystroke
				dup key.stroke 4 + c!
				key.stroke on
			THEN
			0=
		WHILE
			ansKEY?  IF ?keystroke drop exit THEN
			flash.cursor 
			flash.cursor
		REPEAT
		?keystroke   ( -- [key\true] or [false]  )  
		drop
	ELSE 
		dfltkey
	THEN
;


\ ----------------------


: DoSysWindowEditMenu ( item# -- )
	6 =				  \ Paste
	IF
		Scrap>PasteTextHandle
		\ EvaluateScrap
		IF
			bl key.stroke 4 + c!
			key.stroke ON
		THEN
	ELSE
		beep
	THEN
;


0 value PriorConsole

new.console SpecialConsole
' PasteableKey   SpecialConsole +conKeyToken !


: SetEditMenuForSysWindow ( enableflag -- )	\ adjust Edit Menu
	EditMenu# GetMenuHandle
	IF
		IF	\ SYS.WINDOW activated
			false EnableEditMenuItems
			6 true  EditMenu# item.enable  		\ enable Paste
			6 c" Paste To Interpreter" EditMenu# set.item$
			['] DoSysWindowEditMenu is MinimalEditMenuAction
	\		console @ to PriorConsole
			dflt.con SpecialConsole consoleRecord move
			['] PasteableKey   SpecialConsole +conKeyToken !
			SpecialConsole mfconsole !
		ELSE	\ SYS.WINDOW deactivated
			true EnableEditMenuItems
			6 c" Paste" EditMenu# set.item$
			['] drop is MinimalEditMenuAction
	\		PriorConsole console !
		THEN
	THEN
;


' drop value OldSysActivate				\ save prior value
' drop value OldNewSysActivate


: Forget.Sys.Window_Paste ( -- )			\ undo changes when forgotten
	PurgeTextHandle
	true EnableEditMenuItems
	6 c" Paste" EditMenu# set.item$
	['] drop is MinimalEditMenuAction
	PriorConsole ?dup IF mfconsole ! THEN
	OldSysActivate    sys.window +on.activate !		\ Restore SysActivate
	OldNewSysActivate sys.window +on.newactivate !	\ Restore SysActivate
; on.forget Forget.Sys.Window_Paste
presnapshot linklasttoken



: Paste.SysActivate ( flag -- )		\ new on.activate for sys.window
	dup SetEditMenuForSysWindow
	OldSysActivate execute						\ execute the original
;


: Paste.NewSysActivate ( flag -- )	\ new +on.newactivate for sys.window
	dup SetEditMenuForSysWindow
	OldNewSysActivate execute						\ execute the original
;



>m4th
also toolvocab

: ENABLE.SYS.WINDOWPASTE ( -- )		\ installation word
	mfconsole @ -> PriorConsole
\	dflt.con -> PriorConsole
	['] sys.activate     -> OldSysActivate
	['] new.sys.activate -> OldNewSysActivate
	sys.window on.activate Paste.SysActivate
	['] Paste.NewSysActivate sys.window +on.newactivate !
;

>m4th



\ ************************************************************************
\ ************************************************************************

\ Copies everything you type into SYS.WINDOW into a special Editor Window
\ Another example of special use Editor Windows


>m4th
also editorvocab
also ToolVocab definitions




variable AllInput->History  \ this ON to also save ANYTHING sent to interpret
	AllInput->History OFF


sys.window +wbounds @rect 3 roll 100 - 3 bury
new.SEWindow			HistoryWindow
true 					HistoryWindow  	se.reserved!



action-of interpret value OldInterpretToken	\ save current token



: EchoInterpretToEditor ( -- )		\ modifed INTERPRET
	sys.window  infile @ =
	AllInput->History @
	OR
	HistoryWindow ?wvisible
	AND
	IF
		TIB  #TIB @  ?dup
		IF
			\ insert at end
			2dup NormalizeEOLinRange ( addr\cnt -- )
			HistoryWindow -1 (insert.text>se) ( addr\cnt\SEWindow\offset -- )
			HistoryWindow cr>editor
			HistoryWindow 4 MakeSelendVisible ( SEWindow\offset -- )
		ELSE
			drop
		THEN
	THEN
	OldInterpretToken execute
;


: Position.HistoryWindow ( -- )	\ create it above and slightly to the right of sys.window
	sys.window where.window
	locals| r b l t |
	t 150 -  40 max
	l 20 +
	over 140 +
	r 2/
	HistoryWindow w.bounds
;


: CloseHistory ( -- )
	HistoryWindow +se.realfile w@ 0=
	IF					\ it has not been saved, so don't ask to update
		(se.close)
		r> drop			\ exit calling word ( which would be SE.CLOSE)
	THEN
; DoNotSin  \ NEVER-INLINE




: InstallHistoryWindow ( -- )
	c" History"		HistoryWindow w.title
	Position.HistoryWindow

	se.window 
	front.window
	locals| oldFront oldSEWindow |
	HistoryWindow add.se				\ make History window visible
	HistoryWindow @ sys.window @ SendBehind

	HistoryWindow -> se.window
	['] CloseHistory  export.close !	\ optional - disables "Save Changes" on close
	oldSEWindow -> se.window
	oldFront select.window

	['] EchoInterpretToEditor  is interpret		\ change Interpret token
;



Create HistoryWindow.ToolGroup -1 , \ holds ID of this group of tools


: ForgetHistoryWindowTool ( -- )
	OldInterpretToken is interpret			\ restore Interpret token when forgotten
	HistoryWindow.ToolGroup @ dup -1 <>
	over ToolCount <= and
	If  PruneToolItem  
		-1 HistoryWindow.ToolGroup !
	ELSE drop
	THEN
;
		on.forget ForgetHistoryWindowTool



>m4th
also ToolVocab

 : InstallHistoryWindowTool ( low\high -- )
	ToolsMenu# menu.handle 0= IF Tools.Menu THEN
    1 NewToolGroup          						\ Enough room to install items ?
    IF
    	HistoryWindow.ToolGroup !      			\ Save separator item number
        ['] InstallHistoryWindow c" History Window"	NewToolItem drop
    THEN ;




?building 0= [IF]  InstallHistoryWindowTool  [THEN]



