\ WINDOWS MENU
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\    to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>M4TH
also ToolVocab definitions

decimal


12 value WindowsMenu#
0 value LAST.WPTR		\ wptr of front window at last menu computation
0 value PRIOR.WPTR		\ wptr of previously front window
5 constant 1st.WMENU.WINDOW ( -- item# of 1st window in wmenu )

0 value WindowNameBuffer

: (GetNextWPTR4) ( windowref -- wptr4' or 0 )	\ get OUR next window
	BEGIN
		GetNextWindow 			\ get next window from Mac
		dup
	WHILE						\ exit if next = 0 (no more in list)
		dup _GetWRefCon			\ is it ours?
		?wptr	\ ?dup 
		IF
			_GetWRefCon
			exit 				\ if it is, we can exit
		THEN
	REPEAT
;


: GetNextWPTR4 ( wptr4 -- wptr4' or 0 )		\ get OUR next window
	dup
	IF								\ pass 0, return 0
		+windowref# @				\ get windowref
		(GetNextWPTR4)
	THEN
;


: GetFirstWPTR4 ( -- wptr4' or 0 )	\ get OUR first 4th window - 0 if none
	GetWindowList		\ _LMGetWindowList 		\ start with frontmost Mac window
	_GetWRefCon dup					\ OS X might have front window not be ours
	?wptr 0=
	IF
		drop			\ 6.04994
		GetWindowList	\ _LMGetWindowList
		(GetNextWPTR4)
	THEN
;


: zSearchVisibleWindows { xt | thisOne -- wptr |or| 0 }		\ xt ( ....\wptr -- ...\continue? )
	\ z is for z-search --- front to back
	\ use locals to make relatively immune to stack hostile XT's
	GetFirstWPTR4 -> thisOne
	BEGIN
		thisOne
	WHILE	
		thisOne XT execute 0= IF thisOne exit THEN
		thisOne GetNextWPTR4 -> thisOne
	REPEAT
;


: SAVE.LAST.WPTR ( wptr -- )
	\ keep track of prior front window
	locals| TheWptr |
	TheWptr last.wptr <>
	IF	last.wptr ?wvisible
		IF	last.wptr -> prior.wptr
		THEN
	THEN
	TheWptr  -> last.wptr
 ;


: zToAllVisibleWindows	 { xt | thisOne -- }		\ was DO.MAC.WINDOWS
	\ use locals to make relatively immune to stack hostile XT's
	GetFirstWPTR4  dup	 save.last.wptr		\ update LAST.WPTR
	-> thisOne
	BEGIN
		thisOne
	WHILE	
		thisOne XT execute
		thisOne GetNextWPTR4 -> thisOne
	REPEAT
;


: GetNthVisibleWindow ( n -- wptr )
	0 locals| COUNT  N |
	dup  0= IF  exit THEN					\ no 0th window
	GetFirstWPTR4 							\ start with frontmost window
	
	BEGIN   dup								\ last window has 0 in +NextWindow
	WHILE   dup ?wvisible					\ only count it if it is visible
			IF  count 1+ to count			\ increment count
				count n = IF  exit THEN		\  exit if Nth window
			THEN
			GetNextWPTR4 					\ get next 4th window in linked list
	REPEAT
;


: PREPEND.TO.BUFF  ( char -- | insert character into string at WindowNameBuffer )
	WindowNameBuffer 1+ WindowNameBuffer 2 + WindowNameBuffer c@   cmove>	\ move it up 2 bytes
	WindowNameBuffer 1+ c!											\ copy word into head of string
	WindowNameBuffer c@ 1+ WindowNameBuffer c! ;					\ adjust string length



: WTITLE>BUFF ( wptr -- )
	locals| TheWptr |
	WindowNameBuffer  TheWptr Get.WTITLE  ( ^string\wptr4 -- )
	WindowNameBuffer c@ 0=							\ unnamed?
	IF 
		c" <unnamed>" WindowNameBuffer pstrcpy
	THEN ;


also editorvocab

: ?ADD.WTITLE  ( wptr4 -- | add title of a visible window to WindowsMenu#)
	0 locals| TheItem TheWptr |
	TheWptr ?active.wptr	\ replace with ?WPTR to show just 4th windows
	TheWptr ?wvisible and
	IF
		TheWptr wtitle>buff		  		\ fetch title string to PAD
		TheWptr prior.wptr =
		IF   ascii  prepend.to.buff 	\ mark prior front window
		THEN
		c" x" WindowsMenu# append.items
		WindowsMenu# CountMenuItems -> TheItem 
		WindowNameBuffer FixLeadingDash
		TheItem WindowNameBuffer WindowsMenu# set.item$

		TheWptr  valid.se?			\ is it a SE Window ?
		IF   
			 se.window					\ save old window
			 TheWptr -> se.window
			 se.changed @				\ get changed flag on this window
			 swap ->  se.window
			 IF
				TheItem 4 WindowsMenu# item.style
			 THEN
		ELSE 							\ OPTIONAL - italicize non-SE Windows
			TheItem 2 WindowsMenu# item.style
		THEN

		TheItem
		TheWptr active.window @ =		\ OPTIONAL - check the active window
		WindowsMenu# item.check
	THEN
;
previous



: CLEAR.ITEMS ( --- | removes all existing items before adding new list ) 
	WindowsMenu# ( -menu.handle ) CountMenuItems 
	1+   1st.wmenu.window
	2dup >
	IF   DO   1st.wmenu.window WindowsMenu# 		
			  del.menu.item
		 LOOP
	ELSE 2drop
	THEN ;


: UPDATE.WMENU ( -- )
	\ used to repace >MENUBAR as the default action for IN.MENUBAR  events
	\ used to ensure that WindowsMenu# is updated whenever the user picks a menu
	WindowsMenu# menu.handle				\ only if menu is active
	IF
		clear.items
		['] ?add.wtitle  zToAllVisibleWindows
		5
		get.window
		  dup  sys.window =
		  swap se.window  =
		  OR
		  IF
		  	true
		  ELSE
		  	false
		  THEN
		 WindowsMenu# item.enable
		 \ gray the Tile and Stack options if no Editor Windows open
		 se.window ?wvisible
		 1 over WindowsMenu# ITEM.ENABLE ( ITEM\ENABLE.FLAG\MENU.ID -- )
		 2 swap WindowsMenu# ITEM.ENABLE ( ITEM\ENABLE.FLAG\MENU.ID -- )
	THEN
;  BeforeMenuSelect LinkLastToken	\ do it when user clicks in menubar


 
: RESTORE.MENUS ( -- | restore event table when forgotten )
	0 -> WindowsMenu#				\ id# for WINDOWS menu
	WindowsMenu# ?dup IF delete.menu THEN
	WindowNameBuffer ?dup IF disposeptr THEN
 ;
on.forget RESTORE.MENUS
\ presnapshot LinkLastToken		\ be polite and de-install before snapshot




\ CleanUpWindows and TileWindows were adapted from code submitted by Jeff Dripps...

also editorvocab
: CleanUpWindows ( -- )
	se.window ?wvisible
	IF
		\ restore original SE window sizes and positions
		true busy
		se.window locals| se.wptr | 			\ begin at the current se.window
		BEGIN
			se.window se.reserved?	0=			\ look at se.reserved flag
			IF									\ protect reserved windows
				se.window dup (window) no.clip erase.se
				se.window dup @ swap +wbounds @point  ?OptionKey 0= MoveWindow
				se.window @
				se.window +wbounds dup 6 + w@ swap 2 + w@ - 
				se.window +wbounds dup 4 + w@ swap	 w@ - true SizeWindow
				se.window size.window
				resize.se
			THEN
			se.window next.active.window to se.window
			se.window se.wptr =						\ back to start
			se.window 0= or 						\ no more windows
		UNTIL
		se.wptr dup to se.window force.window
		false busy
	ELSE
		beep
	THEN ;

0 value The.Se.Wptr			\ ? make a local ??
0 value RightGutter
0 value BottomGutter

: (TileWindows) ( #Horiz\#vert -- | adapted from Jeff Dripps )
	se.window ?wvisible
	IF
		true busy
		se.window -> The.Se.Wptr
		40 4
		screen.bounds 4 + @ point>xy
		RightGutter BottomGutter -point
		0 0
		locals| Xo Yo sb sr sl st  #Vert #Horiz |
		sr sl - 	#Horiz 2* -
	
		#Horiz  /	to Xo									\ horiz size
		sb st - 1- 22 #Vert 1- * -   #Vert /  to Yo			\ vert size
		#Vert 0 DO											\ for rows
			#Horiz 0 DO
				se.window se.reserved? 						\ for columns
				IF  se.window next.active.window to se.window
					se.window 0=
					se.window The.Se.Wptr = or
					IF unloop leave THEN 
				THEN
				se.window dup window no.clip erase.se 
				se.window @  Xo 2 -  Yo  true SizeWindow

				se.window size.window
				resize.se
				se.window @   i Xo * sl +   j Yo 22 + * st +  
				?OptionKey 0=	MoveWindow

				se.window next.active.window to se.window
				se.window 0=
				se.window The.Se.Wptr = or 
				IF unloop leave THEN		\ all are done				
			LOOP
		LOOP
		The.Se.Wptr dup  to se.window force.window
		false busy
	ELSE
		2drop
		beep
	THEN ;


: CountSEWindows ( -- n )
	se.window
	0
	locals| count se.wptr | 			\ begin at the current se.window
	BEGIN
		1 +to count
		se.wptr next.active.window
		to se.wptr
		se.window se.wptr =						\ back to start
		se.wptr 0= or 							\ no more windows
	UNTIL
	count ;


: TileWindows ( -- )
	CountSEWindows ?dup
	IF
	CASE
		 0  1 range.of  1 1  ENDOF
		 2 		    of  2 1  ENDOF
		 3  4 range.of  2 2  ENDOF
		 5  6 range.of  2 3  ENDOF
		 7  9 range.of  3 3  ENDOF
		10 12 range.of  3 4  ENDOF
		13 16 range.of  4 4  ENDOF
		17 20 range.of  4 5  ENDOF
		21 25 range.of  5 5  ENDOF
		6 6 rot
	ENDCASE
	(TileWindows) ( #Horiz\#vert -- )
	THEN ;
	
previous





: DO.WindowsMenu ( item# -- )
	0 hilitemenu
	CASE
		1 OF cleanupwindows		ENDOF		\ Stack
		2 OF TileWindows 		ENDOF		\ Tile
		3 OF AllWindowsFront	ENDOF		\ 
		\ item 4 is the divider

		1st.wmenu.window 1- -  GetNthVisibleWindow ( n -- wptr )  
		dup								\ leave something for ENDCASE to drop
		IF  DUP select.window  THEN					
	ENDCASE ;




: WindowsMenu	( -- | window menu definition )
	Toolsmenu#  1stFreeMenu# -> WindowsMenu#
	WindowsMenu# delete.menu

	0 C" Windows"  WindowsMenu# NEW.MENU
	c" Stack Editor Windows;Tile Editor Windows"	WindowsMenu# append.items
	c" Bring All To Front;(-"						WindowsMenu# append.items

	['] ?ADD.WTITLE  zToAllVisibleWindows 
	drawmenubar

	WindowsMenu#  menu.selection: DO.WindowsMenu
  ; 

>m4th
also ToolVocab


: InstallWindowsMenu ( -- | startup wmenu )
	0 -> last.wptr
	0 -> prior.wptr
	1024 newptrclear to WindowNameBuffer
	\ first install the new IN.MENUBAR token
	WindowsMenu# 4 *  menus + @  ['] DO.WindowsMenu <>
	IF  
		WindowsMenu
	THEN ;



StopIncluding ************************************


\ SOme test words follow here...

: ShowOneWptr ( wptr --  )
	cr >name .name
;

:  ShowOneWptr+ ( wptr -- true )
	ShowOneWptr
	true
;

: ShowFrontToBack ( -- )
	['] ShowOneWptr+ zSearchVisibleWindows
;


: PushFrontToBack ( -- \..window list.. )
	GetFirstWPTR4
	BEGIN
		?dup
	WHILE
		dup
		GetNextWPTR4
	REPEAT
;


: DoBackToFront { xt -- }	\ xt ( wptr -- )
\ apply XT to all windows from the backmost forward
	-1
	PushFrontToBack
	BEGIN
		dup -1 <>
	WHILE
		xt execute
	REPEAT
	drop
;


: DO.4th.WINDOWS  ( token -- | apply <token> to all windows in MF list - added or not )
	locals| TheToken |
	w.linkage @				\ first window - next.ptr
	BEGIN	?dup
	WHILE					\ MF linkage is relocatable
			dup TheToken execute	\ execute TOKEN with <wptr4> on the stack
			+w.link @
	REPEAT ;

: Show2
	cr >name .name
;
' Show2 DO.4th.WINDOWS


WW1 
GHOSTY 
SE.WINDOW01 
SE.WINDOW02 
SE.WINDOW03 
SE.WINDOW04 
SE.WINDOW05 
SE.WINDOW06 
SE.WINDOW07 
SE.WINDOW08 
SE.WINDOW09 
SE.WINDOW10 
SE.WINDOW11 
SE.WINDOW12 
SE.WINDOW13 
SE.WINDOW14 
SE.WINDOW15 
SE.WINDOW16 
SEARCH.DLOG 
INFO.WINDOW 
SYS.WINDOW 
ok


