\ Project Menu
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\    to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>m4th
also ToolVocab definitions


decimal



0 value ProjectMenu#
4 constant 1st.PMENU.ITEM ( -- item# of 1st window in wmenu )

0 value PmenuItem#

0 value ProjectCutoffAddr	\ only add files who are above this address
	\ limit files shown under the Project Menu to only those in MF extensions
	\	exists? mfVersion to ProjectCutoffAddr
	\  limit files shown under the Project Menu to only those YOU add
	\	exists? XXXX to ProjectCutoffAddr


: StripLeadinNumbers ( cstr -- )
\ the numbers in front of most of our extension files help keep them
\ organized, but are useless in this menu
	{ theStr | buff$[ 256 ] }
	theStr count swap
	\ cnt\addr
	BEGIN
		dup c@ 
		dup ascii 0 ascii 9 range nip
		swap bl = OR
	WHILE
		-1 1 +point
	REPEAT
	swap ?dup
	IF
		theStr place
	ELSE
		drop
	THEN
;

: (AddOneSourceToProject) ( addr\cnt -- )
	expand
	{ addr cnt | strbuff[ 256 ] }
	addr cnt MakeCFURLfromPath			\ CFURL
	dup CFURLCopyLastPathComponent		\ CFURL\CFstr 
	dup
	strbuff[ 255 
	0									\ use default encoding
	CFStringGetPascalString 0=
	IF				\ bad string
		s" ??????" strbuff[ place
	THEN
									\ CFURL
	cfrelease						\ CFURL
	cfrelease						\ 

\ append to menu
	c"   " ProjectMenu# append.items
	strbuff[ FixLeadingDash
	strbuff[ StripLeadinNumbers
	PmenuItem# strbuff[ ProjectMenu# set.item$

\ disable if file not findable
	addr cnt Path->FSSpec
	PmenuItem# swap ProjectMenu# item.enable

	1 +to PmenuItem#
;


also system
: AddOneSourceToProject ( thread# nfa -- flag )
	nip
	dup ProjectCutoffAddr >
	IF
		name> >body sfstruct.szPathName zcount	\ get the long name from SFSTRUCT
		(AddOneSourceToProject)
	ELSE
		drop
	THEN
	true
;
previous


: AddSourcefilesToProject
	1st.pmenu.item ProjectMenu# PruneMenuTail
	1st.pmenu.item -> PmenuItem#
	['] AddOneSourceToProject 
		['] sourcefiles voc>wid
			WalkWordList
;


: ?AddSourcefilesToProject ( -- )
	ProjectMenu# GetMenuHandle		\ only if menu is active
	IF
		AddSourcefilesToProject
	THEN
;
BeforeMenuSelect LinkLastToken	 \ do it when user clicks in menubar


0 value nThProject#
0 value nthNFA
0 value TargetProject#

: CountSourceFiles ( thread# nfa -- flag )
	1 +to nThProject#
	nThProject# TargetProject# =
	IF
		-> nthNFA
		drop
		false
	ELSE
		2drop
		true
	THEN
;

: GetNthSourceFile ( n -- nfa )
	  -> TargetProject#
	0 -> nThProject#
	0 -> nthNFA
	['] CountSourceFiles 
		['] sourcefiles voc>wid
			WalkWordList
	nthNFA
;

also system
also editorvocab
: OpenNthProject ( n -- )	\ 1-based
	GetNthSourceFile ?dup
	IF
		name> >body sfstruct.szPathName 	\ get "long" name
		zcount expand
		se.open.from.path ( path$\len -- sewptr |or| 0 )
		drop
	ELSE
		beep
	THEN
;
previous
previous



: DO.PROJECT.MENU ( n -- )
	0 HiliteMenu
	1+ 1st.pmenu.item - OpenNthProject
;




>m4th
also ToolVocab

: InstallProjectMenu	( -- | window menu definition )
	\ METHOD #1: bring up PROJECT menu in a predicatable place:
\	toolsid menu.handle not IF ToolsMenu THEN
	Toolsmenu#  1stFreeMenu# -> ProjectMenu#	\  to right of tools menu
	ProjectMenu# delete.menu
	ProjectMenu# get.next.id  c" Project" 			ProjectMenu# new.menu
	c" Select the file you wish to open("			ProjectMenu# append.items
	c" Grayed-out files are missing or moved(;-("	ProjectMenu# append.items
	DrawMenuBar
	ProjectMenu# menu.selection:  do.project.menu   ; 



?building 0= [IF] InstallProjectMenu [THEN]



