\ Simple Help Menu
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\    to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************



only Forth definitions

>M4TH
also ToolVocab definitions

decimal


20 value HelpMenu#

1500 value startingHelpID
\ pictures in range of 1500-1599
\ resource name --> menu item name



also system
: OpenManual ( -- )
	HelpPage0 @ negate iPage# !	\ open to cover page
	LaunchHelp
;
previous


: (HELP) ( str$ -- )
	count $Help
	IF
		c" Error finding word or finding files"
			"" "" ""  !OK# IssueWindowCenteredAlert drop
	THEN
;

also editorvocab

: HELP.SELECTION  ( -- )
	se.window front.window <>
	selstart @ selend @ = 			\ just beep if nothing
	OR
	IF
		c" Select a word in an Editor Window"
			"" "" ""  !OK# IssueWindowCenteredAlert drop
	ELSE
		range->search$					\ move selection range to Search$
		hide.range
		selend @  selstart !			\ protect selection from eprint
		search$ (help)
	THEN
;
previous

: TryHelpPict ( item# -- )
	20  item$ C!
	item$  HelpMenu# get.item$  ( item\item$\menu id -- )
	Select.Info
;



: DO.HELP.MENU ( item# -- )
	0 HiliteMenu
	CASE
		1 OF c" www.mpeforth.com" launchurl drop ENDOF
		3 OF OpenManual 						 ENDOF
		5 OF help.selection 					 ENDOF
		7 OF c" http://lars.nocrew.org/dpans/dpans.htm" launchurl drop ENDOF
		TryHelpPict
		0
	ENDCASE
;

: Append.Help.Res  ( ResHandle -- )  \ appends pict-name to Apple-menu
	item$ GetResInfo		\ put all info at PAD, only uses name at +6
	\ this method of adding dummyentry and changing its value allows embedded menu control chars
	c" x" HelpMenu# Append.Items
	HelpMenu# CountMenuItems  item$ 6 + HelpMenu# set.item$  ( item\item$\menu id -- )
;

: Append.Help.Picts  ( -- )
	-1 locals| skippeditem |		\ 3-state flag
	false SetResLoad				\ identify help picts, but don't load them
\	1 -> #HelpPicts
	startingHelpID 99 +   startingHelpID	\ default PICT's 1500-1599
	DO
		i GetPicture
		?dup
		IF  
			skippeditem 0>
			IF								\ menu separator after missing items
				c" -)" HelpMenu# Append.Items
\				1 +to #HelpPicts
			THEN
			dup Append.Help.Res
			    HPurge
\			1 +to #HelpPicts
			0 -> skippeditem			\ none skipped after a load
		ELSE
			skippeditem 0=
			IF
				1 -> skippeditem
			THEN
		THEN
	LOOP
	true SetResLoad ;


>M4TH
also ToolVocab


: Install.Help.Menu  ( -- )
	HelpMenu#  1stFreeMenu# -> HelpMenu#
	HelpMenu# C" Help" HelpMenu# new.menu
	C" MPE Web Page;-(;VFX Manual;-(;Help Selection" HelpMenu# append.items
	C" -(;ANS Forth Standard;-(" 					 HelpMenu# append.items
	
	Append.Help.Picts

	DrawMenuBar 
	HelpMenu# menu.selection: do.help.menu ;



?BUILDING 0= [IF] Install.Help.Menu [THEN]



StopIncluding ************************************


\
\\
//


(*
{



LACKING
HAVING
POSSIBLY

[IF]


whereis


source-info
.sources

LOCATE

WORDSIN
