\ Contextual Popup Menu for Editor
\ Last Revision: 09/15/03  03:54:58 PM  wjm - clip to bottom of screen
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com

((
	OPTION-CLICK or RIGHT-CLICK on any text in Editor

))

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\    to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only forth definitions

\ anew --editorPopup--
decimal

>m4th



true 			value 		LowerCaseReplacements

also ToolVocab
also actels
also editorvocab definitions


25 				constant	PopupMenu#
0 0 xy>point	value		PopupTopLeft
4 				value		theDefaultItem
10				constant	NumMatchesToShow
0				value		PriorIB

NumMatchesToShow 10 + constant NumPopupItems


exists? LaunchURL constant  ?HandleURL


defer MakeFuzzyWL			' MakeWLFromContext is MakeFuzzyWL
		\ could also use all vocabularies, maybe an English language WL


: AppendFuzzyMatchList ( -- )
	{	|	scratch$[ 256 ] } 
	Max#FuzzyMatches NumMatchesToShow min 0
	?DO
		\ i @Harray[i] >>GetName$ dup scratch$[ c!  scratch$[ 1+ swap cmove
		i 2 cells * BestFuzzyMatches +   2@
		IF
			theWL >>GetName$
			scratch$[ place
			scratch$[ FixLeadingDash

			c"  " PopupMenu# append.items						\ add a dummy item
			PopupMenu# CountMenuItems scratch$[ PopupMenu# set.item$	\ modify it
		THEN
	LOOP
;


: InManual?  ( addr\cnt -- flag )
	[ also system ]
	['] OpenIndex catch
	0=
	IF
		['] (SearchHelp) catch dup
		CloseIndex
		IF
			nip nip
		THEN
		0=
	ELSE
		2drop
		0
	THEN
	[ previous ]
;

defer ValidWord? ( c$addr -- flag )
	' (exists?) is ValidWord?

defer AddHints?  ( -- flag )
	' true is AddHints?


: MakeEditorPopupMenu ( -- )
    -1  ""                      			PopupMenu# new.menu
    c" Goto URL;Locate;Manual" 				PopupMenu# append.items   
    c" -("   								PopupMenu# append.items
    c" Copy to Prior Insertion"   			PopupMenu# append.items
    c" -("   								PopupMenu# append.items
    c" Find Next;Find From Start;-("    	PopupMenu# append.items
    c" Upper Case;Lower Case;-("			PopupMenu# append.items

	range->search$
	search$ count upper
	search$ ValidWord?			\ FindAnywhere nip
	IF		\ the word exists in a vocab so allow all options
		2 to theDefaultItem		\ switching this to 1 makes it hard to estimate menu height (see below)
	ELSE	\ unknown word, so disable Glossary & Locate
		4 to  theDefaultItem
		2 false PopupMenu# item.enable
	THEN
	search$ count InManual? 0=
	IF
		3 false PopupMenu# item.enable
	THEN
	
	5  PriorIB -1 <>   PopupMenu# item.enable

	AddHints?
	IF
	\ for hint menu, search CONTEXT vocabs for matches
\		theWL >R					\ 10.44
		['] true is WLFilter		\ default is pass all words
		MakeFuzzyWL
		search$ (FindBestFuzzies)
		AppendFuzzyMatchList
\		R> to theWL					\ 10.44
	THEN
;


: ChangeEditorSelection ( item$ -- )
	selstart @ >R
	13 -
	2 cells * BestFuzzyMatches +   2@ drop
	theWL >>GetName$ ( addr\cnt )
	(se.paste.string)
	LowerCaseReplacements
	IF
		R> selstart !
		se.lower
	ELSE
		R> drop
	THEN
;


: CopyToPrior ( -- )
	selstart @ SE.DataStart  +
		selend @ selstart @ -
		se.window PriorIB  (INSERT.TEXT>SE)
;


: LaunchSelection ( -- )
	{  | buf$[ 1024 ] }
	selstart @ selend @  = 			\ just beep if nothing
		IF beep exit THEN
	range->search$
	hide.range
	selend @  selstart !			\ protect selection from eprint
	search$ buf$[  $move			\ move selection range to POCKET
	buf$[ LaunchURL drop
;


defer LocateFromPopup
	' locate.selection is LocateFromPopup


: DoEditorPopupItem ( item# -- )
    CASE
    	0 OF							ENDOF	\ no selection should not drop through to ChangeEditorSelection
   		1 OF  LaunchSelection			ENDOF
	   	2 OF  LocateFromPopup			ENDOF	\ locate.selection
  	    3 OF  help.selection			ENDOF
\		4 OF  ( separator )				ENDOF
		5 OF  CopyToPrior				ENDOF
\		6 OF  ( separator )				ENDOF
        7 OF  range->search$ re-search	ENDOF
        8 OF  range->search$ from.top  re-search ENDOF
\		9 OF  ( separator )				ENDOF
	   10 OF  se.upper					ENDOF
	   11 OF  se.lower					ENDOF
\	   12 OF ( separator )				ENDOF
           dup ChangeEditorSelection

	ENDCASE ;


: EditorPopupMenuSelect  ( item# -- itemSelected )
    locals| item# |
    PopupMenu# GetMenuHandle        	\ menu handle
    popupTopLeft
    point>xy
    2 + 								\ just a little to the right
    item#                       		\ starting item number
    PopupMenuSelect ;


: DoEditorPopupMenu ( -- )
	get.cursor >R
	init.cursor
	ShowCursor
    theDefaultItem EditorPopupMenuSelect
	R> set.cursor
    point>xy nip
    DoEditorPopupItem 
;


: EstimatePopupHeight ( -- n )
	20
	theDefaultItem -
	NumPopupItems  *
;


: AdjustEditorPopupPosition ( -- )	\ added 6.0491
	selend @  xCHAR>XY			\ OR put menu at right edge of selection
	swap right.edge min swap	\ 6.045 - clip to right edge of window
	xy>point local>global point>xy
	
	dup
	EstimatePopupHeight  +			\ bottom of menu
	screen.bounds 4 + w@ 			\ bottom of screen
	-
	dup 0>
	IF	\ clip to bottom
		- 20 max
	ELSE
		drop
	THEN
	swap  
	xy>point
	-> PopupTopLeft
;


: EditorPopup ( -- flag )
	selstart @ selend @ =
	IF
		TheIB -> PriorIB
		hide.range		\ RangeVis off
		selstart @ dup word.start  selstart !
					   word.end	   selend !
		show.range
	ELSE
		-1  -> PriorIB
	THEN
	selstart @ selend @ =
	IF	\ only works when click in a word, not in white space
		false
		beep
	ELSE
		AdjustEditorPopupPosition		\ 
		MakeEditorPopupMenu				\ build it on the fly
		DoEditorPopupMenu
		true							\ exit editor CLICK.LOOP after doing the Popup
	THEN
;


only forth definitions
>m4th
also actels
also editorvocab
also ToolVocab


: InstallEditorPopup ( -- )
	['] locate.selection  is LocateFromPopup
	['] (exists?) 		  is ValidWord?
	['] MakeWLFromContext is MakeFuzzyWL
	['] true 			  is AddHints?
	['] EditorPopup       is Editor-Cntrl-Click
;


?BUILDING 0= [IF] InstallEditorPopup [THEN]



>m4th
