\ Dumper Working.fth
\ Created:       14 Jun 2012  08:16:21  ward@megawolf.com
\ Last Revision: 16 Jul 2012  06:29:29  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


(* *************************************************************************

Vocabulary Browser Tool

 demonstrates some advanced tricks with WordLists
 	Filtered WordLists
 	Sorting  WordLists
 
 demonstrates a number of Nib and Carbon Event methods
	Edit Text Controls - getting and setting text - locking them
	Popup Button Controls
	User Pane Controls
	Scroll Bar Controls
	Using Control Actions ( SetControlAction )
	Raw Keyboard Events
	
	
DOUBLE CLICK
CMD-R


************************************************************************* *)
Only Forth Definitions
>M4TH also toolvocab
having BrowserWindow  forget BrowserWindow


Only Forth Definitions
>M4TH
also actels
also toolvocab	DEFINITIONS

Decimal

											
											

\ First, create a regular MacForth window to attach out Nib to
NEW.WINDOW BrowserWindow		


create BrowserPosition		0 ,		\ BrowserWindow current screen poisition


: SaveBrowserPosition ( -- )
	get.window >R
	BrowserWindow window
		0 0 xy>point local>global
			BrowserPosition !
	R> window
;

: RestoreBrowserPosition ( -- )		\ works after window is added, 
									\ does not need to be visible
	BrowserPosition @
	?dup
	IF
		point>xy  BrowserWindow SetWindowPos
	THEN
;



\ ***************************************************************************
\ Assign  names for all the Nib controls we will be using


1				\ control ID from IB
ascii User		\ control SIG from IB
BrowserWindow
NewNibBinControl:   ListPanel ( ID\sig\wptr -- )
kEventControlClick  ListPanel 44 + !		\ kEventControlClick replaces  kEventControlHit
											\ (we want response on muse downs)

1				\ control ID from IB
ascii lscr		\ control SIG from IB
BrowserWindow
NewNibBinControl:   ListScrollBar ( ID\sig\wptr -- )


\ ----------------------------------------------------------------------------
\ These are the buttons..

1						\ control ID from IB
ascii brow				\ control SIG from IB
BrowserWindow			\ the MacForth window referencing the Nib Window
NewNibBinControl: BrowseCtrl ( ID\sig\wptr -- )

1						\ control ID from IB
ascii loca				\ control SIG from IB
BrowserWindow			\ the MacForth window referencing the Nib Window
NewNibBinControl: LocateCtrl ( ID\sig\wptr -- )

1						\ control ID from IB
ascii clea				\ control SIG from IB
BrowserWindow			\ the MacForth window referencing the Nib Window
NewNibBinControl: ClearCtrl ( ID\sig\wptr -- )

create DuplicateMode 0 ,
1						\ control ID from IB
ascii dups				\ control SIG from IB
BrowserWindow			\ the MacForth window referencing the Nib Window
NewNibBinControl: DuplicatesCtrl ( ID\sig\wptr -- )
		DuplicateMode DuplicatesCtrl !NibControlVariable ( addr\nibctrl -- )

\ ----------------------------------------------------------------------------
\ These are the two popup menu controls..

: NullCtrlAction ( EventRef\mfCtrl -- result )
	s.cr s" NullCtrlAction " s.type
	2drop eventNotHandledErr
;

defer ModeChanged ( EventRef\mfCtrl -- result )
	' NullCtrlAction is ModeChanged


create VocabMode  0 ,
\ 1 - context
\ 2 - current
\ 3 - all

1						\ control ID from IB
ascii vocb				\ control SIG from IB
BrowserWindow			\ the MacForth window referencing the Nib Window
NewNibBinControl: VocabCtrl ( ID\sig\wptr -- )
	' ModeChanged VocabCtrl !NibControlAction
		VocabMode VocabCtrl !NibControlVariable ( addr\nibctrl -- )


create SortMode   0 ,
\ 1 - ascending alphabetic  
\ 2 - descending alphabetic  
\ 3 - ascending token order
\ 4 - descending token order
\ 5 - unsorted

1						\ control ID from IB
ascii sort				\ control SIG from IB
BrowserWindow			\ the MacForth window referencing the Nib Window
NewNibBinControl: SortCtrl ( ID\sig\wptr -- )
	' ModeChanged SortCtrl !NibControlAction
		 SortMode SortCtrl !NibControlVariable ( addr\nibctrl -- )


\ ----------------------------------------------------------------------------
\ These are the Editable Search Text controls


defer SearchChanged  ( EventRef\mfCtrl -- result )
	' NullCtrlAction is SearchChanged


1						\ control ID from IB
ascii srch				\ control SIG from IB
BrowserWindow			\ the MacForth window referencing the Nib Window
NewNibBinControl: StartsWithCtrl ( ID\sig\wptr -- )
 2  kEventClassTextInput AddNibControlEvent	\ kEventTextInputUnicodeForKeyEvent

' SearchChanged StartsWithCtrl !NibControlAction



2						\ control ID from IB
ascii srch				\ control SIG from IB
BrowserWindow			\ the MacForth window referencing the Nib Window
NewNibBinControl: ContainsCtrl ( ID\sig\wptr -- )
 2  kEventClassTextInput AddNibControlEvent	\ kEventTextInputUnicodeForKeyEvent

' SearchChanged ContainsCtrl !NibControlAction


\ ----------------------------------------------------------------------------
\ Un-editable Text controls - Used for Display only

1						\ control ID from IB
ascii stat				\ control SIG from IB
BrowserWindow			\ the MacForth window referencing the Nib Window
NewNibBinControl: FullNameCtrl ( ID\sig\wptr -- )

2						\ control ID from IB
ascii stat				\ control SIG from IB
BrowserWindow			\ the MacForth window referencing the Nib Window
NewNibBinControl: VocabNameCtrl ( ID\sig\wptr -- )

3						\ control ID from IB
ascii stat				\ control SIG from IB
BrowserWindow			\ the MacForth window referencing the Nib Window
NewNibBinControl: SourceNameCtrl ( ID\sig\wptr -- )

4						\ control ID from IB
ascii stat				\ control SIG from IB
BrowserWindow			\ the MacForth window referencing the Nib Window
NewNibBinControl: TokenCtrl ( ID\sig\wptr -- )

5						\ control ID from IB
ascii stat				\ control SIG from IB
BrowserWindow			\ the MacForth window referencing the Nib Window
NewNibBinControl: #FoundCntl ( ID\sig\wptr -- )




\ *************************************************************************


create StartsWithText$	256 allot&erase
create ContainsText$	256 allot&erase


: GetSearchStrings ( -- )
	StartsWithText$ 255  StartsWithCtrl @ GetTextFromControl
	ContainsText$   255  ContainsCtrl   @ GetTextFromControl
		and  1 <> abort" GetTextFromControl failed"
;


: BrowserZoomedOut? ( -- flag )		\ use for future enhancement
	browserwindow where.window
	nip swap - nip 600 >
;


\ ***************************************************************************
\ Item Info Display


 
-1 value SelectedItem#				\ global index
-1 value PriorSelectedItem#			\ global index


: InvertSort ( n -- n' )
	1- #SortableEntries swap -
;


: GetNthItem ( n -- ^WLNameField )		\ n is 0-based
	1+ 
	SortMode @
	CASE
		1 OF GetNthAlphaSorted				ENDOF
		2 OF InvertSort GetNthAlphaSorted	ENDOF
		3 OF InvertSort GetNthTokenSorted	ENDOF	
		4 OF GetNthTokenSorted				ENDOF	
		5 OF GetNthUnSorted					ENDOF
	ENDCASE
;


: UpdateTokenCtrl  ( theXT -- )
	{  | str[ 256 ] }
	dup (H.)	str[  place
	base @ >R
	decimal
	s"   (#"	str[  append
	(u.)		str[  append
	s" )"		str[  append
	r> base !
	str[ count TokenCtrl @ SetControlText
;


(( 

: DebugShowItem
	cr  ." item# "
	dup .
	GetNthItem dup count type
	17 -  dup @ ."  xt = "  .
	4 + @  ."  wid = "   >name .name
;

 ))

: ShowItem#Info ( item# -- )
	dup 0 <
	IF
		s" nothing selected "	FullNameCtrl   @ SetControlText
		S" -- " 				SourceNameCtrl @ SetControlText
		S" -- " 				VocabNameCtrl  @ SetControlText
		S" -- " 				TokenCtrl      @ SetControlText
	ELSE
		GetNthItem
		dup count FullNameCtrl @ SetControlText ( addr\len\ctrlref -- )
		dup 17 - @ ( <value1> ) dup UpdateTokenCtrl  ( theXT -- )
		  (whereis)     \ xt -- c-addr u line# TRUE | FALSE
			IF
			 	drop
			 	
			ELSE
			 	s" unknown file"
			THEN
			SourceNameCtrl @ SetControlText
		13 - @  ( <value2> ) ?dup
		    IF
		     	>name count 
		    ELSE
		     	s" ???"
		    THEN
		     VocabNameCtrl @ SetControlText

		BrowserZoomedOut?
		IF
			\ dump or disassembly in special pane
		THEN
	 THEN
;

\ ***************************************************************************
\ Action for LocateCtrl


also editorvocab
: LocateSelectedItem# ( -- )
	SelectedItem# dup 0 >=
	IF
		GetNthItem 17 - @  ((locate))
	ELSE
		drop
	THEN
;
previous

' LocateSelectedItem#  LocateCtrl  !nibcontrolaction


\ ***************************************************************************
\ Action for DuplicatesCtrl

: ClickDuplicatesCtrl  ( EventRef\mfCtrl -- result )
	DuplicatesCtrl @ 
	DuplicateMode  @
	IF
		c" show all"
	ELSE
		c" only duplicates"
	THEN
	SetControlTitle
	ModeChanged
;
' ClickDuplicatesCtrl DuplicatesCtrl !NibControlAction



0 value PriorMatchEntryTag
0 value PriorEntryTag

0 value TempWL


: AddToNew ( EntryTag -- )
\	s.cr s" Adding " s.type dup s.
	dup  SortableWL >>GetValue2		\ get theWID
	over SortableWL >>GetValue		\ get theToken
	rot  SortableWL >>GetName$		\ get NameAddr\NameLen
	
	TempWL >>AddEntry	( value\NameAddr\nameLen\aHandle -- EntryTag |or| 0 )
	TempWL >>SetValue2
;


: SameNameAsPrior? ( EntryTag -- true if = )
	SortableWL >>GetName$
	PriorEntryTag SortableWL >>GetName$
	istr=
;


: ?AddOneDuplicate  ( EntryTag -- )
	{ thisTag  }
	PriorEntryTag
	IF
		thisTag SameNameAsPrior?
		IF	\ a duplicate !
			PriorEntryTag AddToNew
			thisTag -> PriorMatchEntryTag
			thisTag -> PriorEntryTag
			
		ELSE	\ does not match
			PriorMatchEntryTag
			IF		\ then this one must be a match also
				PriorMatchEntryTag  AddToNew
			\ ELSE	\ first method tried to simply delete from SortableWL
				\ cannot do this safely - EntryTags change with >>RemoveEntry
				\ so out list of entrytags in SortableArray becomes invalid
				\ with the first deleteion
				\ PriorEntryTag  SortableWL >>RemoveEntry drop
			THEN
			thisTag -> PriorEntryTag
			0 -> PriorMatchEntryTag
		THEN
	ELSE
		thisTag -> PriorEntryTag
	THEN
;


: (BuildDuplicateWL) ( StartAddr -- )
	BEGIN
		dup +SWLEntryTag @  ?AddOneDuplicate
		+SWLEntryNextAlpha @ dup 0<
	UNTIL
	drop
;


: BuildDuplicateWL			\ WALK LIST ALPHABETICALLY
\ s.cr s" BuildDuplicateWL " s.type
	LoadNewWL -> TempWL

	0 -> PriorMatchEntryTag
	0 -> PriorEntryTag
	#Indices 0
	DO
		SearchIndexTable i cells + @ dup 0>
		IF
		    (BuildDuplicateWL)
		ELSE								\ no entries in this index
			drop
		THEN
	LOOP

	SortableWL >>Discard		\ out with the old
	TempWL -> SortableWL
;


\ ***************************************************************************
\ ***************************************************************************
\ Main List Drawing stuff
\ We could use a DataBrowser control for this, but for such a simple list, it
\	requires a lot more support code than doing it the old-fashioned way
\ We could have used a Text View control instead of a user control, but again
\	would use at least as much code and hiliting by line would have been tricky
\ The only real "problem" is that Copy will not work in the normal way - we will
\	take care of this in our raw keystroke handler


0 0 0 0 rect ListPanelRect
0 0 0 0 rect ListPanelFrameRect
0 0 0 0 rect ListPanelTextRect

0 0 0 0 rect ListPanelItemRect


 0 value ListPanelTop
 0 value ListPanelLeft
 0 value ListPanelRight
 0 value ListPanelHeight
 0 value ListPanel#Lines

16 value ListPanelLineHeight
 4 value listFontType				\ default Monaco - can change in Default.Extensions
14 value listFontSize

 4 value ListPanelTopGutter
 8 value ListPanelLeftGutter
 



: FirstVisibleEntry ( -- n )	\ assume ListScrollBar range set correctly
	ListScrollBar @  GetControl32BitValue
;
 

: ListPanelIndexLeftTop ( localindex - L/T )
	ListPanelLeft ListPanelLeftGutter +
	swap ListPanelLineHeight * ListPanelTopGutter + ListPanelTop +
;


: CalcListPanelIndexRect ( localindex -- )
	ListPanelIndexLeftTop					\ L/T
	3 +										\ L/T'
	swap over
	ListPanelRight ListPanelLeftGutter -	\ T/L/T/R
	swap ListPanelLineHeight +
	swap
	ListPanelItemRect !rect
;


: MoveToListPanelIndex# ( localindex -- )
	ListPanelLeft ListPanelLeftGutter +
	swap
	1 + ListPanelLineHeight * ListPanelTopGutter + ListPanelTop +
	moveTo
;


: ClipItem#ToRange ( n -- n' )
	0 max  #SortableEntries 1- min
;


: HiliteItem# ( n -- )		\ n is actual item#
	get.window >R
	BrowserWindow window
	ListPanelRect ClipRect

	ClipItem#ToRange
	dup -> SelectedItem#
	dup -> PriorSelectedItem#

	FirstVisibleEntry -		 \ convert to local entry
	0 ListPanel#Lines 1- range
	IF
		CalcListPanelIndexRect
		ListPanelItemRect invertrect
	ELSE
		drop
		-1 -> PriorSelectedItem#
	THEN

	SelectedItem# ShowItem#Info
	R> window
;


: CalcMaxScroll ( -- n )
	#SortableEntries dup  (u.) #FoundCntl @ SetControlText
	ListPanel#Lines  - 0 max
;


: SetScrollValue ( n -- )
	0 max
	CalcMaxScroll min
	ListScrollBar @ swap SetControl32BitValue
;



: SelectLocalItem ( n -- )		\ n = 0 .. ListPanel#Lines-1
\   s.cr s" SelectLocalItem " s.type
	FirstVisibleEntry +					\ absolute item#
	ClipItem#ToRange

	dup PriorSelectedItem# <>
	IF									\ unhilite prior
		PriorSelectedItem# HiliteItem#
	THEN
	dup SelectedItem# <>
	IF
		HiliteItem#
	ELSE
		drop
	THEN
;



: GetIthItem ( i -- $addr )		\ i is local index (
	SortableWL \ ?dup
	IF
		\ GetNthUnSorted
		ListScrollBar @  GetControl32BitValue +
		GetNthItem	\ 1+ GetNthAlphaSorted
	ELSE
		c" item"
	THEN
;



: BrowserFilter ( nfa -- nfa/true |or| false )	\ this will be our WLFilter
	true { nfa  flag }
	StartsWithText$ count ?dup
	IF
		nfa 1+ -rot is= -> flag
	ELSE
		drop
	THEN

	ContainsText$ count ?dup
	IF
		2dup upper
		nfa count 2swap search nip nip		\ maybe use $strmatch  ?
		flag AND -> flag
	ELSE
		drop
	THEN
	
	flag
	IF
		nfa  flag
	ELSE
		false
	THEN
;
\ ' BrowserFilter is WLFilter



defer ExtraVocabSelect	( item# -- item# )	\ dry powder
	' noop is ExtraVocabSelect


: BuildWordList ( -- )
	\ set up BrowserFilter
	GetSearchStrings

	\ Pick Vocabs to add from popup control
	VocabMode  @
	CASE
		1 OF  ContextToSortableWL	ENDOF
		2 OF  CurrentToSortableWL	ENDOF
		3 OF  AllToSortableWL		ENDOF
		ExtraVocabSelect
	ENDCASE
;



: DrawListEntries ( -- )	\ current window assumed BrowserWIndow
	ListPanelTextRect ClipRect
	#SortableEntries  0>
	IF
		ListPanel#Lines #SortableEntries min   0
		?DO
			i MoveToListPanelIndex#  	\ i . ." test"
			i GetIthItem count type
		LOOP
	ELSE
		ListPanel#Lines 2/ MoveToListPanelIndex#
		." Empty List"
	THEN
;


create theFocus	0 ,			\ control that has focus - 0 = ListPanel


: (DrawListPanel) ( -- )	\ handle all the drawing for ListPanel
	BrowserWindow no.clip
	srccopy textmode
	patcopy _PenMode
	black penpat
	rgbltgray rgbbackcolor
	RGBBlue   rgbforecolor

	listFontType TextFont
	listFontSize _TextSize
	bold TextFace

	ListPanelRect EraseRect

	BrowserWindow @ theFocus GetKeyboardFocus drop
	theFocus @ 0  =
	IF
		2 2 pensize
	THEN	
	ListPanelRect	FrameRect
	1 1 pensize

	DrawListEntries
\	s.cr s" (DrawListPanel) " s.type
	SelectedItem# HiliteItem#

	BrowserWindow @ frontwindow <>
	IF	\ gray out list when not front window
		gray penpat
		pator _PenMode
		rgbltgray rgbforecolor
		ListPanelRect paintrect	
	THEN
;


: DrawListPanel ( -- )		\ allow (DrawListPanel) to be safely called from anywhere
	['] (DrawListPanel)  BrowserWindow DoProtectedIO
;



0 value Waslatest-XT		\ marker for redrawing if disctionary changes


: InitListScroll ( -- )		\ initialze ListPanel
\ s.cr s" InitListScroll " s.type
	latest-xt -> Waslatest-XT
	['] BrowserFilter is WLFilter
	BuildWordList
	AlphaSortSortableWL
		
	DuplicateMode  @
	IF
		BuildDuplicateWL		\ extract duplicates into a new SortableWL
		AlphaSortSortableWL		\ new SortableWL needs sorting
	THEN

	ListScrollBar @  0 CalcMaxScroll set.control.32bitrange

	ListPanel @  ListPanelRect GetControlBounds drop
	ListPanelRect 2 + w@   -> ListPanelLeft
	ListPanelRect 6 + w@   -> ListPanelRight
	ListPanelRect 4 + w@
		ListPanelRect w@  dup -> ListPanelTop -
			dup -> ListPanelHeight
	ListPanelLineHeight /  -> ListPanel#Lines

	ListPanelRect @rect  5 - ListPanelTextRect !rect

	0 SetScrollValue
	0 -> SelectedItem#
	-1 -> PriorSelectedItem#
	DrawListPanel
;


\ ***************************************************************************
\ ***************************************************************************


: SetNormalFocus ( -- ) \ no focus is roughly equivalent to making ListPanel the focus
						\ since it is a User Pane, OS X will not give it real focus
	BrowserWindow @ ClearKeyboardFocus drop
;


: ClearBrowser ( -- )		\ action for Clear Button
	s" "  StartsWithCtrl @  SetControlText ( addr\len\ctrlref -- )
	s" "  ContainsCtrl   @  SetControlText ( addr\len\ctrlref -- )
	SetNormalFocus
	InitListScroll
;
' ClearBrowser  ClearCtrl  !nibcontrolaction



: ReInitList ( EventRef\mfCtrl -- result ) 
\	beep	s.cr s" ReInitList " s.type
	2drop
	InitListScroll
	eventnothandlederr
;
' ReInitList is ModeChanged \ invoked when popup controls are used
' ReInitList BrowseCtrl !nibcontrolaction	


: DelayedRedraw  ( EventRef\mfCtrl -- result )
\	s.cr s" !!! DelayedRedraw" s.type
	2drop
	['] InitListScroll SendExecuteEvent
	eventnothandlederr
;
' DelayedRedraw is SearchChanged	\ invoked when text entry in search controls




: DrawList ( ctrlref\info -- )		\ DrawListPanel for use by our UserPaneDrawProc
\ s.cr s" ***  DrawListUPP " s.type
	2drop
	DrawListPanel
;


variable DrawListUPP		DrawListUPP off

2 0  CALLBACK: DrawListProc
	' DrawList to-callback DrawListProc



\ ***************************************************************************
\ Mouse and Key list navigation


: DrawListFrom ( n -- )
	ClipItem#ToRange	\ 0 max   CalcMaxScroll min
	SetScrollValue		\ ListScrollBar @  swap  SetControl32BitValue
	DrawListPanel
\	DrawListEntries
;


: IncScroll ( n -- )
\	s.cr s" IncScroll" s.type
	ListScrollBar @ GetControl32BitValue +
	DrawListFrom
;


: Y->LocalItem# ( y -- n )
	ListPanelTopGutter - ListPanelTop - 3 - 		\ 0 max
	ListPanelLineHeight /  
\ item clicked	

;


: MouseDragInList ( -- )
	BEGIN
		100 ms
		stilldown
	WHILE
		@mouse point>xy  nip
		Y->LocalItem#

		dup 0<
		IF
			PriorSelectedItem# HiliteItem#
			-1 IncScroll
			drop 0
		THEN
		
		dup ListPanel#Lines >=
		IF
			PriorSelectedItem# HiliteItem#
			1 IncScroll
			drop ListPanel#Lines 1-
		THEN
		SelectLocalItem
	REPEAT
;


 0 value ClickTime
20 value BrowserDblTime		\ 1/3 sec seems about right

: ClickListPanel ( EventRef\mfCtrl -- result )
\	s.cr s"  ClickListPanel @ " s.type
	SetNormalFocus
	DrawListPanel
	
	@mouse point>xy  nip
 	Y->LocalItem#
 
\ item clicked	
	SelectLocalItem
	MouseDragInList

	2drop
\	s.cr s" ClickListPanel " s.type SelectedItem# s.

	PriorSelectedItem# SelectedItem# =
	IF
		tickcount ClickTime  -  
		\ GetDblTime <			\ GetDblTime can have unacceptable values for this
		BrowserDblTime <						
		IF							\ was it a double-click?
			LocateSelectedItem#
		ELSE
			tickcount -> ClickTime	\ reset timer
		THEN
	ELSE
		tickcount -> ClickTime
	THEN


	eventNotHandledErr
;
' ClickListPanel ListPanel !NibControlAction



: KeepSelectedVisible ( -- )	\ scroll list so SelectedItem# is visible
	SelectedItem# FirstVisibleEntry <
	IF
		SelectedItem# SetScrollValue
		DrawListPanel
	ELSE
		SelectedItem# FirstVisibleEntry -
		ListPanel#Lines >=
		IF
			SelectedItem# ListPanel#Lines - 1+ SetScrollValue
			DrawListPanel
		THEN
	THEN
;


: Select&Show ( n -- )
	FirstVisibleEntry - 
	SelectLocalItem
	KeepSelectedVisible
;


: IncrSelected ( n -- )
	SelectedItem# +	
	Select&Show
;


: DoBrowserKey	( key - )    \ only get this if not focused on text control
\	s.cr s" DoBrowserKey " s.type dup s.
	CASE
		30 OF -1 IncrSelected							ENDOF	\ up arrow
		31 OF  1 IncrSelected							ENDOF	\ down arrow
		11 OF  ListPanel#Lines 1- negate IncScroll		ENDOF	\ page up
		12 OF  ListPanel#Lines 1- 		 IncScroll		ENDOF	\ page down
		 1 OF  0 DrawListFrom  				 			ENDOF	\ home
		 4 OF  #SortableEntries DrawListFrom  			ENDOF	\ end
		 \ consider selecting by letter if in alpha sort
	ENDCASE
;


\ ***************************************************************************
\ Handling Scroll Bar


50 value ScrollDelay

: ContScroll ( delta -- )
	{ delta }
	delta IncScroll
	100 ms
	BEGIN
		ScrollDelay ms
		StillDown
	WHILE 
		delta IncScroll
	REPEAT
	eventNotHandledErr
;



: InListThumb ( -- )
	ListScrollBar @  GetControl32BitValue DrawListFrom
;


: (DO.LIST.SCROLL) ( partcode -- )
	CASE
		in.thumb	OF InListThumb		ENDOF	\ do.vthumb	ENDOF
		up.button	OF 0 -1 ContScroll  ENDOF
		down.button OF 0  1 ContScroll  ENDOF
		page.up		OF 0  ListPanel#Lines 2- negate ContScroll ENDOF
		page.down	OF 0  ListPanel#Lines 2- 		ContScroll ENDOF
	ENDCASE
;


: DoScrollControlAction  { ControlRef  ControlPartCode -- }
\	s.cr s" DoScrollControlAction " s.type
	ControlPartCode (do.list.scroll)
;



0 value ScrollControlActionUPP

2 0 callback: ScrollControlActionProcPtr ( ControlRef  ControlPartCode  )

' DoScrollControlAction to-callback ScrollControlActionProcPtr



: DoListScrollBar			\ see DO.SE.MOUSE
\	s" DoListScrollBar " s.type
	?in.control
	IF
\		s"  - in.control part = "  s.type  this.part @ s.
		this.control @ ListScrollBar @ =
		IF
\			s"  - ListScrollBar "  s.type
			this.part @ 	(do.list.scroll)
		THEN
	THEN
;


: DoBrowserMousewheel ( -- )
\	s.cr s" DoBrowserMousewheel " s.type
	event.record 10 + @ 
	ListScrollBar @ = 
	IF
		DoListScrollBar
	ELSE
		beep+	\ nothing else  should get here
	THEN
;


\ ***************************************************************************
\ BrowserWindow Activate and normal event handling


: DoBrowserAction ( -- )
	latest-xt Waslatest-XT <>		\ a changed LATEST-XT recalculates the list
	IF  
\		s.cr s" latest-xt changed" s.type
		InitListScroll
	THEN
	
	\ ??? rebuild list if changed CONTEXT or CURRENT

	do.events	\ Compositied Nib - very few events need handling this way
	CASE
		IN.NibControl	OF DoBrowserMousewheel	ENDOF  \ we get this from mousewheel

		\ mouse.down	OF DoBrowserMouse	ENDOF  \ composite window eats these
		\ in.zoom.in	OF beep				ENDOF  \ composite window eats these
		\ beep+ 
		\ s" --> EVENT" s.type 
		\ Event.Record 2 + @  ( _GetWRefCon >name count s.type )   s.s drop
	ENDCASE
	?keystroke IF  DoBrowserKey THEN
;


: BrowerActivate ( flag -- )			\ ?? needed ??
	drop
	DrawListPanel
;


: Activate.BrowserWindow
\	s.cr s" activate " s.type dup s.
	dup BrowerActivate
	IF
		BEGIN
			DoBrowserAction
		AGAIN
	ELSE
	
	THEN
;

BrowserWindow on.activate Activate.BrowserWindow
' BrowerActivate	BrowserWindow +on.newactivate !
' DoBrowserAction	BrowserWindow +Window.Action !


(( 

: Update.BrowserWindow		\ we never get an update from composited nib
	s.cr s" Update.BrowserWindow " s.type
	\ rgbltgray rgbbackcolor
	\ update.control
;
BrowserWindow on.update Update.BrowserWindow

 ))


\ ***************************************************************************
\ Override default Nib font for FullNameCtrl 
\ see SETCONTROLFONTSTYLE for more details

62000 dup dup      rgbcolor RGBVeryLtGray

create WordNameFontStyle
	64 16 or 8 or 4 or 2 or 1 or w,	\ flags
	c" Andale Mono" get.font.number ?dup  0=
	  [IF] c" Courier" get.font.number [THEN] 
	   w, 			\ font 
	18 w,			\ fontsize
	bold w,			\ fontstyle
	0 w,			\ mode
	1 w,			\ justification  - CENTERED
	RGBBlue 	    @rgb rot w, swap w, w,	\ foreColor
	RGBVeryLtGray	@rgb rot w, swap w, w,	\ backColor



create ButtonFontStyle
	4  w,			\ flags = kControlUseSizeMask
	0  w, 			\ font 
	14 w,			\ fontsize
	0  w,			\ fontstyle
	0  w,			\ mode
	0  w,			\ justification  - CENTERED
	0  w, 0 w, 0 w,	\ foreColor
	0  w, 0 w, 0 w,	\ backColor


\ ***************************************************************************
\ Add a kEventClassKeyboard event handler to the Browser Window
\ it will handle kEventRawKeyDown
\ to give us better control over Enter, Return, navigation keys when the user is
\ editing one of the text fields


create theChar	0 ,


: HandleEnterKey ( -- )		\ CR or ENTER key
	theFocus @ dup ContainsCtrl  @ =
	swap StartsWithCtrl @ = OR
	IF	\ cannot set focus on User Pane (main list), so set no focus
		SetNormalFocus
		['] InitListScroll SendExecuteEvent
		0
	ELSE
		EventNotHandledErr
	THEN
;


: HandleTabKey ( -- )  	\ OS wants to cycle through the popup controls as well as the text controls
						\ and ignores our User Pane (main list)
						\ so we handle tabs ourselves
	theFocus @  StartsWithCtrl  @ =			\ StartsWithCtrl --> ContainsCtrl
	IF
		BrowserWindow @ 
		ContainsCtrl @
		5						\ kControlEditTextPart
		SetKeyboardFocus
		drop
	ELSE
		theFocus @  ContainsCtrl @ = 		\ ContainsCtrl --> no focus (main list)
		IF	\ cannot set focus on User Pane (main list), so set no focus
			SetNormalFocus
		ELSE								\ no focus (main list) --> StartsWithCtrl
			BrowserWindow @ 
			StartsWithCtrl @
			5					\ kControlEditTextPart
			SetKeyboardFocus
			drop
		THEN
	THEN
	['] DrawListPanel SendExecuteEvent	\ DrawListPanel
;


: HandleCmdKey ( char -- OSErr )
	upc			\ force upper case
	
	dup [char] W =
	IF	\ cmd-W  --> Close Window
		drop
		BrowserWindow hide.window
		0								\ we handled event
	ELSE
		dup [char] C = 
		IF	\ cmd-C  --> Copy item if no focus and valid selected item
			drop
			theFocus @ 0=	\ normal COPY should work if we are in one of the Edit Text controls
			IF
				SelectedItem# GetNthItem count
					"TEXT put.scrap drop
				0						\ we handled event
			ELSE
				EventNotHandledErr		\ pass it to next handler
			THEN
		ELSE
			[char] R = 					\ Reference (locate)
			IF
				LocateSelectedItem#
				0						\ we handled event
			ELSE
				EventNotHandledErr			\ pass it to next handler
			THEN
		THEN
	THEN
;


: HandleRawKey ( EventHandlerCallRef\EventRef\userData --  EventHandled?  )
	locals| theWPTR4 eventref eventhandlerref |		\ UserData = WPTR4
	BrowserWindow @ theFocus GetKeyboardFocus drop	\ check current focus
\	{ EventRef }
	EventRef
	ascii kchr 				\ EventParamName
	ascii TEXT 				\ EventParamType
	0						\ ^ActualEventType
	1						\ MaxBufferSize
	0						\ ^ActualSize
	theChar dup off			\ ^outData
	GetEventParameter
	0=
	IF
\		theChar c@  s.

		EventRef GetEventModifiers
		\ see Modifier?
\		s.cr s" modifer = " s.type s.s 
		$100 and 0<>	\ cmdKey
		IF
			theChar c@ HandleCmdKey ( char -- OSErr )
		ELSE
			theChar c@  dup 13 = swap 3 = OR	\ RETURN or ENTER ?
			IF
				HandleEnterKey
				0								\ we handled event
			ELSE
				theChar c@ ATAB =				\ is it a tab?
				IF
					HandleTabKey
					0							\ we handled event
				ELSE
					theChar c@  dup BL <		\ control character ?
					  swap BSOUT <> and			\ but not a backspace
					IF
						SetNormalFocus
						['] DrawListPanel SendExecuteEvent
					THEN
					EventNotHandledErr			\ pass it to next handler
				THEN
			THEN
		THEN
	ELSE
		\ no key in this case means we caught a window drag
		SaveBrowserPosition
		EventNotHandledErr		\ pass it to next handler
	THEN
;



3 1  CALLBACK: BWKeyboardEventHandlerProcPtr
	' HandleRawKey to-callback BWKeyboardEventHandlerProcPtr


0 value  BWKeyboardEventHandlerUPP
variable BrowserWindowHandlerRef		BrowserWindowHandlerRef off


1  constant kEventRawKeyDown


create KeyboardEventList
	kEventClassKeyboard ,		\ typelist.eventClass
	kEventRawKeyDown 	,		\ typelist.eventKind
\ add drag window notification here so we can save window position
	kEventClassWindow ,		\ typelist.eventClass
	31 	,					\ typelist.eventKind


: InstallBrowserWindowHandler ( -- )
\	BWKeyboardEventHandlerProcPtr NewEventHandlerUPP  -> BWKeyboardEventHandlerUPP

	BrowserWindow @ GetWindowEventTarget	\ EventTargetRef
	BWKeyboardEventHandlerUPP			\ EventHandlerUPP
	2										\ NumTypes
	KeyboardEventList						\ ^TypeList
	BrowserWindow							\ UserData
	BrowserWindowHandlerRef					\ ^EventHandlerRef
	InstallEventHandler 
	drop		\ abort" InstallEventHandler Failed"
; 		\  PRELUDES linklasttoken  <--- NO - only can install when window has been added




\ ***************************************************************************
\ ***************************************************************************


: StartBroswer ( -- )
	\ Locate our Nib file
	z" Browser" GetNibReference ( 0$ -- NibReference |or| 0 )
		dup 0= abort" GetNibReference failed"

	\ find the specific Nib within the Nib file and attach to BrowserWindow
	\ this Nib DOES have standard handler installed
\	z" Large Browser" BrowserWindow add.window.from.nib
	z" Small Browser" BrowserWindow add.window.from.nib


\ this is the magic dust for us to receive Activate events
	\	even when a Standard Event Handler is installed:
	BrowserWindow InstallWindowEventCatcher

	0 -> Waslatest-XT
	
	-1 -> SelectedItem#
	-1 -> PriorSelectedItem#
 

	\ attach our controls to the nib window
	ListPanel			InstallNibControl
	ListScrollBar		InstallNibControl

	VocabCtrl			InstallNibControl
	SortCtrl			InstallNibControl
	StartsWithCtrl		InstallNibControl
	ContainsCtrl		InstallNibControl

	FullNameCtrl		InstallNibControl
	VocabNameCtrl		InstallNibControl
	SourceNameCtrl		InstallNibControl
	TokenCtrl			InstallNibControl
	#FoundCntl			InstallNibControl

	ClearCtrl			InstallNibControl
	LocateCtrl			InstallNibControl
	BrowseCtrl			InstallNibControl
	DuplicatesCtrl		InstallNibControl

	ListScrollBar @ BrowserWindow +vbar !

	RestoreBrowserPosition
	BrowserWindow show.window

	\ disable editability
	true pad !
	FullNameCtrl   @  5 ascii lock 1 pad SetControlData  drop
	VocabNameCtrl  @  5 ascii lock 1 pad SetControlData  drop
	SourceNameCtrl @  5 ascii lock 1 pad SetControlData  drop
	TokenCtrl      @  5 ascii lock 1 pad SetControlData  drop
	#FoundCntl     @  5 ascii lock 1 pad SetControlData  drop


	BWKeyboardEventHandlerUPP 0=	\ only do these once !
	IF
		BWKeyboardEventHandlerProcPtr NewEventHandlerUPP  		-> BWKeyboardEventHandlerUPP
		DrawListProc 				  NewControlUserPaneDrawUPP    DrawListUPP !
		ScrollControlActionProcPtr    NewControlActionUPP		-> ScrollControlActionUPP
	THEN

	\ set the special actions for ListScrollBar 
	ListScrollBar @ ScrollControlActionUPP SetControlAction

	\ Install kEventClassKeyboard event handler
	InstallBrowserWindowHandler

	\ set redraw action for ListPanel
	ListPanel @ 0
	 ascii draw 				\ kControlUserPaneDrawProcTag
	  4 DrawListUPP
	   SetControlData ( ControlRef\PartCode\ResType\dataSize\^data -- OSStatus )
	    drop	\ abort" SetControlData error"

	\ initialize our popup menu controls
	1 VocabMode !		\ CONTEXT
	1 SortMode !		\ Normal Alpha Sort
	VocabCtrl @ VocabMode @ setcontrol32bitvalue
	SortCtrl  @ SortMode  @ setcontrol32bitvalue

	\ Override default Nib font for FullNameCtrl 
	FullNameCtrl @ WordNameFontStyle SetControlFontStyle drop
	
	ClearCtrl  @ ButtonFontStyle SetControlFontStyle drop
	LocateCtrl @ ButtonFontStyle SetControlFontStyle drop
	BrowseCtrl @ ButtonFontStyle SetControlFontStyle drop

	ClearBrowser
;






\ ***************************************************************************


create Browser.ToolGroup -1 , 	\ holds ID of this tool group

: RemoveBrowserTool (  --  )	\ Lest we FORGET this code
	DrawListUPP @ 				DisposeControlUserPaneDrawUPP
	ScrollControlActionUPP		DisposeControlActionUPP
	BrowserWindowHandlerRef @   RemoveEventHandler drop
	BWKeyboardEventHandlerUPP	DisposeEventHandlerUPP

	Browser.ToolGroup @ dup -1 <> 		\ no room for group ?
	IF   PruneToolItem  
	ELSE drop
	THEN
;
on.forget RemoveBrowserTool


>M4TH
also toolvocab

: InstallBrowserTool ( -- )
	ToolsMenu# menu.handle 0= IF Tools.Menu THEN
	1 NewToolGroup          		\ Enough room to install items ?
	IF
		Browser.ToolGroup !      	\ Save separator item number
	    ['] StartBroswer   c" Vocabulary Browser/B" NewToolItem	 drop
	THEN 
;



?building 0= [IF] InstallBrowserTool [THEN]

>M4TH




stopincluding *********************************************************
******************* comments and/or test code below *******************
***********************************************************************


