\ Editor Autocompletion
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com



\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\    to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only forth definitions
>M4TH


variable Autocompletion			  Autocompletion ON
true value LowerCaseHints


also ToolVocab
also actels
also editorvocab definitions


 50  value MAX#HINTS

variable GHOSTING

create   GhostRect 0 , 0 ,
create   HintRect  0 , 0 ,
variable HintHilited?


16 value ghostyLineHeight
12 value ghostyTextSize
 4 value ghostyTextFont


200 value GhostHeight
100 value GhostWidth
  0 value #Hints


new.window Ghosty
	10 Ghosty w.type					\ kHelpWindowClass
	not.visible Ghosty w.attributes		\ invisible when added



defer AdjustGhostRect ( -- )	' noop is AdjustGhostRect
defer FillGhosty ( -- )			' noop is FillGhosty
defer AddHints ( -- )   		' noop is AddHints
defer SetGhostRect ( -- )   	' noop is SetGhostRect

defer MakeWL					' MakeWLFromContext is MakeWL
		\ could also use all vocabularies, maybe an English language WL




: GhostyNotFront ( -- )		\ fool FRONT.WINDOW into ignoring Ghosty
	FrontWindow _GetWRefCon dup
	Ghosty =
	IF
		GetNextWPTR4
	ELSE
		
	THEN
;




: <StopGhosting		\ beep+d
	ghosting @
	IF
		ghosting off
		Ghosty hide.window
	THEN
;
' <StopGhosting is StopGhosting



: MaxPossibleHints ( -- n )	\ room from IP to bottom of screen
							\ assume GhostRect setup
	screen.bounds 4 + w@s
	screen.bounds     w@s
	- ghostyLineHeight /
	max#hints min			\ no more than user specified value
;


: MaxHintsFromHere ( -- n )	\ room from IP to bottom of screen
							\ assume GhostRect setup
	screen.bounds 4 + w@s
	GhostRect     w@s
	- ghostyLineHeight /
	max#hints min			\ no more than user specified value
;



: <SetGhostRect
	selend @ char>xy  10 10 +point
	2dup  GhostRect !point
	
	#Hints  ghostyLineHeight * 5 +  ( 100 max ) -> GhostHeight
	TheLongestPartial 1+ 8 * -> GhostWidth
	
	GhostWidth GhostHeight +point  GhostRect 4 + !point
;
' <SetGhostRect	is SetGhostRect


: ShowGhosty ( -- ) \ beep+
	ghosting ON
	HintHilited? OFF
	
	SetGhostRect

	Ghosty @
	GhostRect @point xy>point local>global point>xy
	0
	MoveWindow  ( UInt32 windowRef, UInt32 hGlobal, UInt32 vGlobal, UInt32 frontFlag )

	Ghosty @
	GhostWidth  GhostHeight
	0
	SizeWindow

	Ghosty show.window
	discard.activates		\ !!!!! essential
;




create Partial$	255 allot&erase

0 value ThePartialWordStart


: CheckPartialMatches ( -- flag )	\ true if
	['] true is WLFilter		\ default is pass all words
	MakeWL

	Partial$ (FindPartials) ( cstr -- )
	#Partials 1 MaxHintsFromHere range
	IF
		-> #hints
		true
	ELSE
		drop
		false
	THEN
;


: GetPartial$ ( -- flag )	\ true if we are at the end of a sting > 1 chars
	Partial$ off
	selstart @
	dup dup word.end =	\ at the END of a word

	IF  
		dup word.start			\ cur\start
		dup  -> ThePartialWordStart
		
		2dup - dup 1 >
		IF						\ cur\start\len  PLACE
			swap SE.DataStart + swap
			Partial$ place
				drop
			CheckPartialMatches
		ELSE
			3drop
			0
		THEN
		
	ELSE
		drop
		0
	THEN
;



: InvokeGhost
	\ after a keystroke
	GetPartial$
	se.interpreting @ 0=
	AND
	IF
		ShowGhosty				\ calculates default ghostrect
		FillGhosty
	THEN
;	' InvokeGhost is AfterSEKeyEntry




: (FillGhosty)
	get.window >R
	outfile @  >R
	ghosty dup outfile ! window
	ghostyTextFont  TextFont
	ghostyTextSize  _TextSize
	plain 			TextFace
	ghostyLineHeight ghosty +wline.height !
	0 0 moveto	\ page
	addhints
	
	R> outfile !
	R> window
;	' (FillGhosty) is FillGhosty


: AddPartials ( -- )
	#hints 0
	DO
		i  2 cells * PartialMatchArray + 2@
		dup $7fffffff <
		IF
			4  i 1 +   ghostyLineHeight * moveto
			drop
			theWL >>GetName$ ?dup IF DrawText ELSE drop ." ???" THEN
		ELSE
			2drop unloop exit
		THEN
	LOOP
;		' AddPartials is AddHints



: ReplaceWithHint ( n -- )
	<StopGhosting
	ThePartialWordStart selstart !
	1-
	2 cells * PartialMatchArray + cell+ @
	theWL >>GetName$ ( addr\cnt )
	(se.paste.string)
	LowerCaseHints
	IF
		ThePartialWordStart selstart !
		se.lower
	THEN
;


: ClickedInGhosty
	\ mouse.down
	get.window >R
	ghosty window
	mouse.was..  global>local point>xy		\ where we clicked relative to ghost
	R> window
	nip
	4 -
	ghostyLineHeight /  1+
	ReplaceWithHint
;


: MAYBE>SELECT.WINDOW
	event.record 2 + @  ghosty =
	IF
		ClickedInGhosty
	ELSE
		>select.window
	THEN
;	' maybe>select.window in.lower.window >Event !


: Hint#->Rect ( nn -- )	\ hints start with #1
	1-
	ghostyLineHeight * 4 +		\ top
	2							\ left
	over ghostyLineHeight +		\ bottom
	GhostWidth  4 -				\ right
	HintRect !rect
;


: InvertHintRect ( -- )
	get.window >R
	ghosty window
	HintRect invertrect
	R> window
;


: HiliteHint ( n -- )
	HintHilited? @ ?dup
	IF
		over <>			\ new hint hilited?
		IF  \ beep
			InvertHintRect
		ELSE
			drop exit
		THEN
	THEN
	dup HintHilited? !
	Hint#->Rect
	InvertHintRect
;


: TrackGhostCursor
	get.window >R
	ghosty window
		@mouse point>xy
		nip
		4 -
		ghostyLineHeight / 1+   \ hint#
		HiliteHint
	R> window
;


: GhostCursor ( -- flag )
	ghosting @
	IF
		@mouse ghostrect  PtInRect
		IF
			init.cursor
			TrackGhostCursor
			true
		ELSE
			HintHilited? @
			IF
				InvertHintRect
				HintHilited? off
			THEN
			false
		THEN
	ELSE
		false
	THEN
;	' GhostCursor is SECursorHook



: EnableGhosty ( -- )
	['] maybe>select.window in.lower.window >Event !
	['] <StopGhosting is StopGhosting
	['] GhostCursor is SECursorHook
	['] InvokeGhost is AfterSEKeyEntry
	['] GhostyNotFront is front.window
	ghosting off
	ghosty add.window
;	


: DisableGhosty ( -- )
	['] >SELECT.WINDOW IN.LOWER.WINDOW >Event !
	['] noop  is StopGhosting
	['] false is SECursorHook
	['] noop  is AfterSEKeyEntry
	['] false is SpecialClick?
	['] noop is SEExitHook
	['] DfltFRONT.WINDOW   is front.window
	Ghosty ?wptr IF Ghosty close.window THEN
;
on.forget DisableGhosty
presnapshot linklasttoken



\ *** TOOLS MENU *************************************************************

Create Autocompletion.ToolGroup -1 , \ holds ID of this group of tools

: SetAutocompletion ( -- )
	Autocompletion @ 
	IF
		EnableGhosty
	ELSE
		DisableGhosty
	THEN
	Autocompletion.ToolGroup @ 1 +
		Autocompletion @
			ToolsMenu# item.check
;


: ToggleAutocompletion ( -- )
	Autocompletion dup @ 0= swap !
	SetAutocompletion
;


: RemoveAutoCompletionTool ( -- )
    Autocompletion.ToolGroup @ dup -1 <>	\ no room for group ?
	over ToolCount > 0= and
    If  PruneToolItem  
        -1 Autocompletion.ToolGroup !
    ELSE drop
    THEN
; on.forget RemoveAutoCompletionTool


>m4th
also editorvocab
also ToolVocab

: InstallAutoCompletionTool ( -- )
	ToolsMenu# menu.handle 0= IF Tools.Menu THEN
    1 NewToolGroup          						\ Enough room to install items ?
    IF
    	Autocompletion.ToolGroup !      					\ Save separator item number
        ['] ToggleAutocompletion  c" Editor Autocompletion"	NewToolItem drop
		SetAutocompletion
	THEN
;

?BUILDING 0= [IF] InstallAutoCompletionTool [THEN]

previous


\\

