\ Build Script for MacForth on VFX
\ Last Revision: 27 Jul 2012  12:03:38  ward@megawolf.com



only Forth definitions
decimal


cr	."   *************************************************************"
cr	."   **  MacForth Extensions to VFX  - Version 10.472           **"
cr	."   **  Adapted from MacForth by  Ward McFarland               **"
cr	."   **  Written by Xan Gregg, Don Colburn and  Ward McFarland  **"
cr	."   **  With generous contributions by many others             **"
cr	."   **  Copyright (c) 1988-201 MegaWolf, Inc.                 **"
cr	."   *************************************************************"


[undefined]  (o_abort)
[IF] CR ." NEEDS VFX BUILD DATE OF 12 June 2012 OR LATER !" abort
[THEN]


dp @
(ticks)
create mfVersion  ," MacForth GUI version 10.472"

\ new macro for our source file location
\ this script (MFBuild.fth) is assumed to be at the same level as the
\ MacForth source code folders and  MFonVFX itself
TextMacro: mfSourcePath			\ added 10.46
	pad 1023 getcwd
	asciiz>$
	setmacro mfSourcePath


s" %mfSourcePath%/MF Core/00 Early Extras.fth" included


only Forth definitions
>M4TH
decimal

create mfBuildDate 16 allot&erase
also system	mfBuildDate GetDate$ previous

true value ?BUILDING			\


only Forth definitions

[undefined] main
[IF]
	s" %VFXPATH%/Lib/Osx32/MultiOsx32.fth"  included	\ VFX Tasking Package
[THEN]

FpSystem 0=
[IF]
	s" %VFXPATH%/Lib/x86/Ndp387.fth"	included	\ VFX Floating Package
  \ s" %VFXPATH%/Lib/x86/Ndp387.v442.fth"  	included	\ alternate VFX Floating Package
[THEN]

>M4TH


include" %mfSourcePath%/MF Core/01 Compatility Extras.fth"
include" %mfSourcePath%/MF Core/02 Compatility Changes.fth"
include" %mfSourcePath%/MF Core/03 Utils.fth"
include" %mfSourcePath%/MF Core/04 Structures.fth"
include" %mfSourcePath%/MF Core/05 User.fth"
include" %mfSourcePath%/MF Core/06 Traps.fth"
include" %mfSourcePath%/MF Core/07 Chains.fth"

: FP-INIT  finit ; 	preludes linklasttoken


include" %mfSourcePath%/MF Core/08 Errors.fth"

include" %mfSourcePath%/MF Core/10 CoreFoundation.fth"


include" %mfSourcePath%/MF Core/14 Files.fth"
include" %mfSourcePath%/MF Core/15 MF Console.fth"
include" %mfSourcePath%/MF Core/16 Logging.fth"


include" %mfSourcePath%/MF Core/20 Windows.fth"
include" %mfSourcePath%/MF Core/21 Menus.fth"
include" %mfSourcePath%/MF Core/22 Controls.fth"

include" %mfSourcePath%/MF Core/24 Events.fth"

include" %mfSourcePath%/MF Core/26 Resource Bagging.fth"

include" %mfSourcePath%/MF Core/28 IO.fth"

include" %mfSourcePath%/MF Core/30 Navigation.fth"
include" %mfSourcePath%/MF Core/31 EZNav.fth"

include" %mfSourcePath%/MF Core/33 Apple Events.fth"
include" %mfSourcePath%/MF Core/34 Carbon Events.fth"

include" %mfSourcePath%/MF Core/37 Nib Binary Controls.fth"
include" %mfSourcePath%/MF Core/38 Nib File Basics.fth"
include" %mfSourcePath%/MF Core/39 Nib Miscellany.fth"
include" %mfSourcePath%/MF Core/40 MF VFX Console.fth"

include" %mfSourcePath%/MF Core/42 Colors.fth"
include" %mfSourcePath%/MF Core/43 Scrap.fth"
include" %mfSourcePath%/MF Core/44 Dialogs.fth"

include" %mfSourcePath%/MF Core/46 AppMenu.fth"
include" %mfSourcePath%/MF Core/47 FileMenu.fth"
include" %mfSourcePath%/MF Core/48 EditMenu.fth"

include" %mfSourcePath%/MF Core/50 Startup Sequence.fth"

include" %mfSourcePath%/MF Core/52 Snapshot.fth"

include" %mfSourcePath%/MF Core/59 InfoWindow.fth"
include" %mfSourcePath%/MF Core/60 Misc.fth"

\ ---------------------------------------------------------
\ Following is optional stuff

\ StopIncluding ********** uncomment for a Turnkey kernel **********


include" %mfSourcePath%/MF Tools/62 Modal Dialogs.fth"

include" %mfSourcePath%/MF Tools/64 Carbon Menus.fth"

marker --NOOPTIONS--	\  forgettable marker 


\ this grouped moved here 10.45
include" %mfSourcePath%/MF Extras/MacForth Graphics.fth"
include" %mfSourcePath%/MF Extras/Old Controls.fth"
include" %mfSourcePath%/MF Extras/Old Color.fth"


marker --NOTOOLS--		\  forgettable marker 


include" %mfSourcePath%/MF Tools/66 OptionsMenu.fth"


include" %mfSourcePath%/MF Tools/70 Printing.fth"
include" %mfSourcePath%/MF Tools/71 PrintFile.fth"


include" %mfSourcePath%/MF Tools/75 ToolsMenu.fth"


include" %mfSourcePath%/MF Tools/80 Editor.fth"
include" %mfSourcePath%/MF Tools/81 Editor Tools.fth"
include" %mfSourcePath%/MF Tools/82 Colorize Editor.fth"
include" %mfSourcePath%/MF Tools/83 New Source File.fth"
include" %mfSourcePath%/MF Tools/84 Recent Files.fth"

include" %mfSourcePath%/MF Tools/86 Sys.Window Extras.fth"

include" %mfSourcePath%/MF Tools/88 Actels&Wordlists.fth"
include" %mfSourcePath%/MF Tools/89 Word List Extras.fth"

include" %mfSourcePath%/MF Tools/91 WindowsMenu.fth"
include" %mfSourcePath%/MF Tools/92 ProjectMenu.fth"
include" %mfSourcePath%/MF Tools/93 HelpMenu.fth"
include" %mfSourcePath%/MF Tools/94 Editor Popup.fth"
include" %mfSourcePath%/MF Tools/96 Autocompletion Tool.fth"
include" %mfSourcePath%/MF Tools/95 Vocabulary Browser.fth"	\ 10.47

\ Ward's special deleteable comments
\ include" %mfSourcePath%/MF Tools/200 InsertMetaComments.fth"


\ OPTIONAL LEGACY STUFF...

include" %mfSourcePath%/MF Extras/Numbering&Time.fth"
include" %mfSourcePath%/MF Extras/Event Monitor Tool.fth"
include" %mfSourcePath%/MF Extras/Compare Files Tool.fth"

\ include" %mfSourcePath%/MF Extras/Trace.fth"	\ breaks on 5.1



\ Correct path names for 2 VFX Source files, so locate works with them
\ **************
also system
exists? ../LIB/PDFHELP.FTH ?dup
[IF]
	s" %BASEPATH%/Lib/PDFhelp.fth"
	rot
	>body sfstruct.szPathName zplace
\ originally "%VFXPATH%/VFXBase/../Lib/PDFhelp.fth%"
[THEN]

exists? ../LIB/OSX32/GENIO/XTERM.FTH ?dup
[IF]
	s" %BASEPATH%/Lib/Osx32/Genio/xterm.fth"
	rot
	>body sfstruct.szPathName zplace
\ originally "%VFXPATH%/VFXBase/../Lib/Osx32/Genio/xterm.fth"
[THEN]
previous
\ **************




: ShowSetup ( -- )
	(.cold)
	cr mfVersion $.
	."   -  build date: " mfBuildDate count type
	cr
	ascii sysv Gestalt		\ gestaltSystemVersion
	IF
		drop
	ELSE
		cr ." OS "
		base @ >R hex
		0 <#  # ascii . hold # ascii . hold #S #> type
		R> base !
	THEN
	ascii mnam Gestalt		\ gestaltUserVisibleMachineName
	IF
		drop
	ELSE
		3 spaces  $.
	THEN
	ascii ramm Gestalt		\ gestaltPhysicalRAMSizeInMegabytes
	IF
		drop
	ELSE
		3 spaces  base @ >R decimal . R> base !  ." megabytes physical RAM"
	THEN
;



false to ?BUILDING

(ticks) swap -  cr  6 .R  ."  ms"

dp @ swap - ." -- added  " 6 .R ."  bytes"



\ Set up INI file specification
s" %$home%/Library/Application Support" AppSupp$ place
s" VfxForth" 							AppSuppDir$ place
s" MFonVFX.ini"							AppSuppIni$ place
s" %$home%/.VfxForth.ini"				PrevIni$ place

CheckSysIni LoadSysIni


>VFX		\ don't use MF version of SAVE from terminal

save MFonVFX

((

\ switch to this (name modified as appropriate) to save directly into
\ the Bundle's /Contents/MacOS
>m4th

$E0  s" MFonVFX.app"  SetFileTimes
	 s" MFonVFX.app/Contents/m4th log"  delete-file drop

\ $E0  s" %mfSourcePath%/MFonVFX.app" expand SetFileTimes
\ s" %mfSourcePath%/MFonVFX.app/Contents/m4th log" expand delete-file drop

>VFX		\ don't use MF version of SAVE from terminal
save MFonVFX.app/Contents/MacOS/MFonVFX

 ))



StopIncluding ************************************

