\ VFXBase/Osx32/osxfunc.fth - OS X base EXTERN: definitions

((
Copyright (c) 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
))

only forth definitions
decimal

\ ===========
\ *! filename
\ *T Chapter Title
\ ===========

\ ====
\ libc
\ ====

library: /usr/lib/libSystem.B.dylib

Extern: int execve( const char * path, char * const argv[], char * const envp[] );
AliasedExtern: ssystem int system( const char * string );

Extern: int open( const char * pathname, int flags, mode_t mode );
Extern: int close( int fd );
Extern: int ioctl( int fd, int request, void * argp );
Extern: int read( int fd, void * buf, int count );
Extern: int write( int fd, void * buf, int count );
Extern: int rename( const char *old, const char *new );
Extern: int unlink( const char * pathname );
Extern: int remove( const char * pathname );
Extern: char * realpath( const char * path, char * resolved_path );
Extern: int isatty( int desc );
Extern: char * ttyname( int fd );
Extern: int fstat( int fildes, void * buf );
Extern: int copyfile(
  const char * from, const char * to, void * state, int flags
);

Extern: int rmdir( const char * pathname );
Extern: int mkdir( const char * pathname, int mode);
Extern: int chdir( const char * path );
Extern: char * getcwd( char * buf, int size );
Extern: DIR * opendir( const char * name );
Extern: int closedir( DIR * dir );
Extern: void * readdir( DIR * dir );
\ Extern: int dirfd( DIR * dir );
Extern: void rewinddir( DIR * dir );

Extern: pid_t getpid( void );
Extern: pid_t getppid( void );
Extern: pid_t getpgrp( void );
Extern: pid_t tcgetpgrp( int fd );
Extern: uid_t getuid(void);
Extern: uid_t geteuid(void);
Extern: void * getpwuid(uid_t uid);

Extern: FILE * fopen( const char * path, const char * mode );
Extern: FILE * fdopen( int fildes, const char * mode );
Extern: FILE * freopen( const char * path, const char * mode, FILE * stream );
Extern: size_t fread( void * ptr, size_t size, size_t nmemb, FILE * stream );
Extern: size_t fwrite( const void * ptr, size_t size, size_t nmemb, FILE * stream );
Extern: int fclose( FILE * stream );
Extern: int fgetc( FILE *stream );
Extern: char * fgets( char * s, int size, FILE * stream );
Extern: int getc( FILE *stream );
Extern: int ungetc( int c, FILE * stream );

Extern: FILE *popen( const char * command, const char * type );
Extern: int pclose( FILE * stream);

Extern: char * getenv( const char * name );
Extern: int setenv( const char *name, const char *value, int overwrite );
Extern: void unsetenv( const char * name );

Extern: time_t time( time_t * ptr );
Extern: time_t mktime( void * timeptr );
Extern: int gettimeofday( void * tv , void * tz );
Extern: int settimeofday( void * tv , void * tz );
Extern: void * gmtime_r( time_t * tim, void * output);

\ Extern: int ioperm( unsigned long from, unsigned long num, int turn_on );
\ Extern: int iopl( int level );
((
Extern: int i386_iopl( int iopl );
Extern: int i386_get_ioperm( void * iomap );
Extern: int i386_set_ioperm( void * iomap );
Extern: int ioperm( unsigned long from, unsigned long num, int turn_on );
))

Extern: void * mmap( void * start, size_t length, int prot, int flags, int fd, off_t offset );
Extern: int munmap( void * start, size_t length );
extern: int _NSGetExecutablePath( char * buf, int * size );

-1 constant invalid_handle_value
$4004:667f constant FIONREAD


\ ========
\ threads, pthreads and Grand Central Dispatch
\ ========

extern: int  pthread_create( unsigned long * thread, int * attr, void * start_routine, void * arg );
Extern: void pthread_exit( void * retval );
Extern: int pthread_kill( int thread, int sig );
Extern: int pthread_self( void );
Extern: int sched_yield( void );
(( no longer in POSIX
Extern: void pthread_yield( void );
))
Extern: int pthread_attr_init( void * attr );
\ Fill attr with the defaults.
Extern: int pthread_join( int thread, void * * thread_return );
\ Suspend caller until thread has finished. Thread_return may be zero.
Extern: int pthread_mach_thread_np( int thread );	\ thread -- machport

Extern: int thread_suspend( int machport );
Extern: int thread_resume( int machport );
Extern: int thread_terminate( int machport );

Extern: void * dispatch_get_global_queue( long priority, unsigned long flags );
Extern: void dispatch_async_f( void * queue, void * context, void * function );

Extern: int sem_wait( void * sem );
\ Wait until sem non-zero, then decrement
Extern: int sem_trywait( void * sem );
\ As sem_wait but returns immediately with nz if sem count=0.
Extern: int sem_post( void * sem );
\ increment sem
Extern: int sem_getvalue( void * sem, int * sval );
\ Place semapore count in sval.
Extern: int sem_unlink( const char * name );
\ remove references to semaphore in other processes.
Extern: int sem_close( void * sem );
\ release resources and invalidate descriptor.
AliasedExtern: sem_open4 int sem_open(
  const char * name, int flag, int mode, int value
);
AliasedExtern: sem_open2 int sem_open(
  const char * name, int flag
);

(( \ Unnamed semaphores do not work on OS X
Extern: int sem_init( void * sem, int pshared, unsigned int value );
\ Initialise sem, pshared must be 0.
Extern: int sem_destroy( void * sem );
\ Release semaphore resources
))

((
\ Frameworks
CSTRING LIB1 "/System/Library/Frameworks/System.framework/System"
CSTRING LIB2 "/usr/lib/libobjc.A.dylib"
CSTRING LIB3 "/System/Library/Frameworks/CoreServices.framework/CoreServices"
CSTRING LIB4 "/System/Library/Frameworks/CoreFoundation.framework/CoreFoundation"
CSTRING LIB5 "/System/Library/Frameworks/Cocoa.framework/Versions/A/Cocoa"
CSTRING LIB6 "/System/Library/Framewroks/AppKit.framework/Versions/C/AppKit"
))


\ ======
\ *> ###
\ ======

decimal
