\ Vfx2DocFiles - documentation file list for base versions

((
Copyright (c) 2000-2004, 2007, 2008, 2011, 2012, 2014, 2019
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
20190814 SFP002 Removed c_lang, added GenTools.
20120705 SFP001 Added environ.fth.
))


cr .( ************************************* )
cr .( *                                   * )
cr .( *  Common X86 Utilities/Extensions  * )
cr .( *                                   * )
cr .( ************************************* )
cr

[defined] Target_386_Windows [IF]
cr .( MAN: Start                      )   include "%vfxpath%/manual/manfiles/manual.man"
[then]
[defined] Target_386_WDosX [IF]
cr .( MAN: Start                      )   include "%vfxpath%/manual/manfiles/dosmanual.man"
[then]
[defined] Target_386_Linux [IF]
cr .( MAN: Start                      )   include "%vfxpath%/Manual/ManFiles/LinManual.man"
[then]
[defined] Target_386_OSX [IF]
cr .( MAN: Start                      )   include "%vfxpath%/Manual/ManFiles/OsxManual.man"
[then]
[defined] Target_ARM_Linux [IF]
cr .( MAN: Start                      )   include "%vfxpath%/Manual/ManFiles/ArmLinManual.man"
[then]

cr .( MAN: Title Page                 )   include "%vfxpath%/Manual/ManFiles/titlepg.man"
cr .( MAN: License Agreement/Terms    )   include "%vfxpath%/Manual/ManFiles/license.man"
cr .( MAN: Installation               )   include "%vfxpath%/Manual/ManFiles/install.man"
cr .( MAN: Migration Chapter          )   include "%vfxpath%/Manual/ManFiles/migrate.man"
cr .( MAN: Notation                   )   include GenericDocs/notation.man
cr .( MAN: Further Information        )   include GenericDocs/furtherinfo.man
cr .( MAN: Reparsing KERNEL           )   DocOnly "%vfxpath%/Kernel/Common/kernel.fth"
cr .( MAN: ENVIRON                    )   DocOnly "%vfxpath%/Kernel/Common/environ.fth"
cr .( MAN: Locals Extension           )   DocOnly "%vfxpath%/Kernel/Common/GenLocals.fth"

[defined] Target_386_Windows [IF]
cr .( MAN: Reparsing STARTUP          )   DocOnly "%vfxpath%/Kernel/386Win/STARTUP"
                                          DocOnly "%LIBRARYDIR%/Win32/SafeCallback"
cr .( MAN: Save Exe                   )   DocOnly "%vfxpath%/Kernel/386Win/save-exe"
cr .( MAN: Make Exe                   )   DocOnly "%vfxpath%/Manual/ManFiles/make-exe.man"
[THEN]
[defined] Target_386_WDosX [IF]
cr .( MAN: Reparsing STARTUP          )   DocOnly "%vfxpath%/Kernel/WDosX/startup"
cr .( MAN: Save Exe                   )   DocOnly "%vfxpath%/Kernel/WDosX/save-exe"
cr .( MAN: DOS Functions              )   DocOnly "%vfxpath%/Kernel/WDosX/DosFuncs"
[THEN]
[defined] Target_386_Linux [IF]
cr .( MAN: Reparsing STARTUP          )   DocOnly "%vfxpath%/Kernel/386Lin/startup"
cr .( MAN: Save Elf                   )   DocOnly "%vfxpath%/Kernel/386Lin/Save-Elf"
[THEN]
[defined] Target_386_OSX [IF]
cr .( MAN: Reparsing STARTUP          )   DocOnly "%vfxpath%/Kernel/386OSX/startup.fth"
cr .( MAN: Save Elf                   )   DocOnly "%vfxpath%/Kernel/386OSX/SaveOSX.fth"
[THEN]
[defined] Target_ARM_Linux [IF]
cr .( MAN: Reparsing STARTUP          )   DocOnly "%vfxpath%/Kernel/ArmLin/startup.fth"
cr .( MAN: Save Elf                   )   DocOnly "%vfxpath%/Kernel/ArmLin/Save-Elf.fth"
[THEN]

cr .( MAN: DocGen                     )   DocOnly "%vfxpath%/Lib/DocGen4.fth"
cr .( MAN: XREF                       )   DocOnly "%LIBRARYDIR%/xref"

[defined] Target_386_Windows [IF]
cr .( MAN: oop                        )   DocOnly "%LIBRARYDIR%/oop/Neon/v1.x/class2"
[THEN]

[defined] Target_ARM_Linux [if]
cr .( MAN: VFP 64 bit                 )   DocOnly "%LIBRARYDIR%/ARM/VFP64S"
[else]
cr .( MAN: NDP387                     )   DocOnly "%LIBRARYDIR%/x86/Ndp387"
[then]
cr .( MAN: String Pack                )   DocOnly "%LIBRARYDIR%/StringPk"

[defined] Target_386_Windows [IF]
cr .( MAN: Hello World Example        )   DocOnly "%vfxpath%/vfxbase/win32/hworld.man"
cr .( MAN: Stack Mon Program          )   DocOnly "%LIBRARYDIR%/Win32/stackmon"
cr .( MAN: WView System               )   DocOnly "%LIBRARYDIR%/Win32/wview"
cr .( MAN: EX-Except                  )   DocOnly "%LIBRARYDIR%/Win32/exexcept"
cr .( MAN: Forge Manual               )   DocOnly "%vfxpath%/Manual/ManFiles/forge.man"
cr .( MAN: ForthEd2                   )   DocOnly "%vfxpath%/examples/Win32/ForthEd2/F2app.bld"
[THEN]

cr .( MAN: GenericIO                  )   DocOnly "%vfxpath%/Kernel/Common/generic"
cr .( MAN: GenericIO - Memory Buffer  )   DocOnly "%LIBRARYDIR%/Genio/Buffer"
cr .( MAN: GenericIO - File Device    )   DocOnly "%LIBRARYDIR%/Genio/file"
cr .( MAN: GenericIO - Null Device    )   DocOnly "%LIBRARYDIR%/Genio/null"

[defined] Target_386_Windows [IF]
cr .( MAN: GenericIO - Serial Device  )   DocOnly "%LIBRARYDIR%/Win32/Genio/serialbuff"
cr .( MAN: GenericIO - Text Console   )   DocOnly "%LIBRARYDIR%/Win32/Genio/terminal"
cr .( MAN: GenericIO - Socket Device  )   DocOnly "%LIBRARYDIR%/Win32/Genio/socketio"
[THEN]
[defined] Target_386_WDOSX [IF]
cr .( MAN: GenericIO - INT 010H Dev   )   DocOnly "%LIBRARYDIR%\WDosX\genio\Int010"
cr .( MAN: GenericIO - Serial Device  )   DocOnly "%LIBRARYDIR%\WDosX\genio\SerDev"
cr .( MAN: GenericIO - ANS Terminal )     DocOnly "%LIBRARYDIR%\WDosX\genio\AnsTerm"
[THEN]
[defined] Target_386_Linux [IF]
cr .( MAN: GenericIO - Serial Device )    DocOnly %LIBRARYDIR%/Lin32/Genio/Serial
cr .( MAN: GenericIO - ANS Terminal )     DocOnly %LIBRARYDIR%/Lin32/Genio/xterm
cr .( MAN: GenericIO - Socket Device  )   DocOnly %LIBRARYDIR%/Lin32/Genio/SocketIo
[THEN]
[defined] Target_386_OSX [IF]
cr .( MAN: GenericIO - Serial Device )    DocOnly %LIBRARYDIR%/Osx32/Genio/Serial
cr .( MAN: GenericIO - ANS Terminal )     DocOnly %LIBRARYDIR%/Osx32/Genio/xterm
cr .( MAN: GenericIO - Socket Device  )   DocOnly %LIBRARYDIR%/Osx32/Genio/SocketIo
[THEN]
[defined] Target_ARM_Linux [IF]
cr .( MAN: GenericIO - Serial Device )    DocOnly %LIBRARYDIR%/Lin32/Genio/Serial
cr .( MAN: GenericIO - ANS Terminal )     DocOnly %LIBRARYDIR%/Lin32/Genio/xterm
cr .( MAN: GenericIO - Socket Device  )   DocOnly %LIBRARYDIR%/Lin32/Genio/SocketIo
[THEN]

[defined] Target_386_Windows [IF]
cr .( MAN: TimeBase                   )   DocOnly "%LIBRARYDIR%/Win32/timebase"
cr .( MAN: Tasker                     )   DocOnly "%LIBRARYDIR%/Win32/MultiWin32"
cr .( MAN: Hardware Port IO           )   DocOnly "%LIBRARYDIR%/Win32/portio"
cr .( MAN: GenericIO Example REMVDU2  )   DocOnly "%vfxpath%/examples/Win32/remvdu2"
[THEN]
[defined] Target_386_WDOSX [IF]
cr .( MAN: TimeBase                   )   DocOnly "%LIBRARYDIR%/WDosX/timebase"
cr .( MAN: Tasker                     )   DocOnly "%LIBRARYDIR%/WDosX/MultiDos"
[THEN]
[defined] Target_386_Linux [IF]
cr .( MAN: TimeBase                   )   DocOnly "%LIBRARYDIR%/Lin32/TimeBase"
cr .( MAN: Tasker                     )   DocOnly "%LIBRARYDIR%/Lin32/MultiLin32"
[THEN]
[defined] Target_386_OSX [IF]
cr .( MAN: TimeBase                   )   DocOnly "%LIBRARYDIR%/Osx32/TimeBase"
cr .( MAN: Tasker                     )   DocOnly "%LIBRARYDIR%/Osx32/MultiOsx32"
[THEN]
[defined] Target_ARM_Linux [IF]
cr .( MAN: TimeBase                   )   DocOnly "%LIBRARYDIR%/Lin32/TimeBase"
cr .( MAN: Tasker                     )   DocOnly "%LIBRARYDIR%/Lin32/MultiLin32"
[THEN]

cr .( MAN: Obsolete words             )   DocOnly "%LIBRARYDIR%/obsolete.fth"
cr .( MAN: Case Chain                 )   DocOnly "%LIBRARYDIR%/chain.fth"
cr .( MAN: Overlays                   )   DocOnly "%LIBRARYDIR%/ovlvfx"
cr .( MAN: MODULE handler             )   DocOnly "%vfxpath%/VFXBase/modules"
cr .( MAN: Build numbering            )   DocOnly "%vfxpath%/Kernel/Common/build"
[undefined] Target_386_WDosX [if]
cr .( PDF help )			  DocOnly "%librarydir%/PDFhelp"
[then]

cr .( MAN: CIAO core                  )   DocOnly "%LIBRARYDIR%/oop/Ciao/ciaocore"
cr .( MAN: CIAO class lib             )   DocOnly "%LIBRARYDIR%/oop/Ciao/libdoc"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/operator"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/primtype"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/wintype"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/winstrct"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/cpoint"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/crect"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/cstring"
cr .( MAN: ClassVFX )                     include "%LIBRARYDIR%/oop/ClassVFX/ClassDoc.bld"
\ cr .( MAN: ClassVFX )                     DocOnly "%LIBRARYDIR%/oop/ClassVFX/ClassVFX"
\                                           DocOnly "%LIBRARYDIR%/oop/ClassVFX/DotPsVFX"
cr .( MAN: Internationalisation       )   DocOnly "%LIBRARYDIR%/International"
cr .( MAN: XML                        )   DocOnly "%LIBRARYDIR%/XML"
cr .( Configuration Tools             )   DocOnly "%librarydir%/ConfigTools"
[undefined] Target_386_WDosX [if]
cr .( INI file parser )			  DocOnly "%vfxpath%/VFXBase/IniParser"
cr .( EXTERNal imports                )   DocOnly "%vfxpath%/VFXBase/Extern"
cr .( SharedLibs                      )   DocOnly "%vfxpath%/Manual/ManFiles/sharedlibs.man"
					  DocOnly "%vfxpath%/Lib/SharedLibs/libcurl/libcurl"
					  DocOnly "%vfxpath%/Lib/SharedLibs/libiconv/libiconv"
					  DocOnly "%vfxpath%/Lib/SharedLibs/SQLite3/sqlite3h"
					  DocOnly "%vfxpath%/Lib/SharedLibs/zlib/zlib"
					  DocOnly "%vfxpath%/Lib/SharedLibs/libXL/libXL
[then]

[defined] Target_386_Windows
[defined] Target_386_WDosX   or
[defined] Target_386_Linux   or
[defined] Target_386_OSX   or
[IF]
cr .( MAN: 386/87 Assembler           )   DocOnly "%vfxpath%/Kernel/386Com/asm8687"
cr .( MAN: PFW Target Optimiser       )   DocOnly "%vfxpath%/Kernel/386Com/optimise/build"
                                          DocOnly "%vfxpath%/Kernel/386Com/optimise/opt386"
                                          DocOnly "%vfxpath%/Kernel/386Com/optimise/Tokeniser"
cr .( MAN: Switches                   )   DocOnly "%vfxpath%/Kernel/386Com/switches"
cr .( MAN: i386 Disassembler          )   DocOnly "%vfxpath%/Kernel/386Com/dasm386"
cr .( MAN: i387 Disassembler          )   DocOnly "%vfxpath%/Kernel/386Com/dasm387"
cr .( MAN: Higher Level Disassembler  )   DocOnly "%vfxpath%/Kernel/386Com/dis"
cr .( Pentium 3/4 optimisations       )   DocOnly "%vfxpath%/Kernel/386Com/optimise/p4opt"
cr .( Quotations                      )   DocOnly "%vfxpath%/Kernel/Common/quotations"
[THEN]
[defined] Target_ARM_Linux [IF]
cr .( MAN: ARM Assembler              )   DocOnly "%vfxpath%/Kernel/ArmCom/HAsmCortex"
cr .( MAN: ARM Target Optimiser       )   DocOnly "%vfxpath%/Kernel/ArmCom/optimise/HoptCortex
                                          DocOnly "%vfxpath%/Kernel/ArmCom/optimise/Tokeniser"
cr .( Quotations                      )   DocOnly "%vfxpath%/Kernel/Common/quotations"
cr .( MAN: Switches                   )   DocOnly "%vfxpath%/Kernel/ArmCom/switches"
cr .( MAN: ARM Disassembler           )   DocOnly "%vfxpath%/Kernel/ArmCom/HDasmCortex"
[THEN]



[defined] Target_386_WDosX [if]
cr .( DOS specific functions          )   DocOnly %vfxpath%\kernel\wdosx\DosFuncs
cr .( DOS Interrupts                  )   DocOnly %vfxpath%\vfxbase\wdosx\DosInts
[then]

cr .( Generic FIFO Support            )   DocOnly "%vfxpath%/VFXBase/fifo"
cr .( BNF Parser                      )   DocOnly "%vfxpath%/VFXBase/bnf"
cr .( Random Number Generators        )   DocOnly "%vfxpath%/VFXBase/random"
cr .( Vocab/Wordlist Utilities        )   DocOnly "%vfxpath%/VFXBase/voctools"
cr .( Long Strings                    )   DocOnly "%vfxpath%/VFXBase/parsel"


[defined] Target_386_Windows [IF]
cr
cr .( ************************************* )
cr .( *                                   * )
cr .( *    Win32 Utilities/Extensions     * )
cr .( *                                   * )
cr .( ************************************* )
cr
cr .( Predefined WINDOWS Structures   )   DocOnly "%vfxpath%\vfxbase\win32\winstrct"
cr .( Pre-Declared WINDOWS API Calls  )   DocOnly "%vfxpath%\vfxbase\win32\winfunc"
cr .( Pseudo WINAPI Calls             )   DocOnly "%vfxpath%\vfxbase\win32\winfuncx"
cr .( Windows Tools                   )   DocOnly "%vfxpath%\vfxbase\win32\wintools"
cr .( WINDOWS MessageLoop definitions )   DocOnly "%vfxpath%\vfxbase\win32\winloop"
cr .( Command Line Parser             )   DocOnly "%vfxpath%/vfxbase/Win32/commline"
\ cr .( 'C' Language style constructs   )   DocOnly "%vfxpath%/VFXBase/c_lang"
cr .( Various 'SHELL' style commands  )   DocOnly "%vfxpath%\vfxbase\win32\shell"
cr .( BlowPipe                        )   DocOnly %vfxpath%/Lib/Win32/BlowPipe
cr .( Default System Macros           )   DocOnly "%vfxpath%\vfxbase\win32\defmac"
cr .( Win32 Exception Handler Support )   DocOnly "%vfxpath%\vfxbase\win32\wincatch"
cr .( Printer Support                 )   DocOnly "%vfxpath%\vfxbase\win32\printer"
cr .( Windows Help files              )   DocOnly "%vfxpath%\VFXBase\Win32\WinHelp"
cr .( WINDOWS Constants for Resources )   DocOnly "%vfxpath%\vfxbase\win32\winconst"
cr .( Win32 Resource Parser           )   DocOnly "%vfxpath%/vfxbase/resource"
                                          DocOnly "%vfxpath%/vfxbase/Resource/BITMAP"
                                          DocOnly "%vfxpath%/vfxbase/Resource/ICON"
                                          DocOnly "%vfxpath%/vfxbase/Resource/CURSOR"
                                          DocOnly "%vfxpath%/vfxbase/Resource/MENU"
                                          DocOnly "%vfxpath%/vfxbase/Resource/TOOLBAR"
                                          DocOnly "%vfxpath%/vfxbase/Resource/DIALOG"
                                          DocOnly "%vfxpath%/vfxbase/Resource/WINDOW"
                                          DocOnly "%vfxpath%/vfxbase/Resource/COOLBAR"
cr .( RICHEDIT Based GenericIO device )   DocOnly "%vfxpath%\vfxbase\win32\richedit"
cr .( GUI Development System Front End )  DocOnly "%vfxpath%\vfxbase\win32\newide"
cr .( MAN: Rebuild                    )   DocOnly "%vfxpath%/Manual/ManFiles/RebuildWin.man"
cr .( Dll Exports                     )   DocOnly "%vfxpath%\vfxbase\win32\dllexport"
				          DocOnly "%vfxpath%\examples\Win32\gendlltest"
cr .( Helpers                         )   DocOnly "%librarydir%\Win32\helpers"
cr .( GTK                             )   DocOnly %vfxpath%/Examples/GTK/gtkbindings
                                          DocOnly %vfxpath%/Examples/GTK/gtktools
                                          DocOnly %vfxpath%/Examples/GTK/graphics
                                          DocOnly %vfxpath%/Examples/GTK/TextEd/editor

[THEN]


[defined] Target_386_WDOSX [IF]
cr
cr .( ************************************* )
cr .( *                                   * )
cr .( *    WDOSX Utilities/Extensions     * )
cr .( *                                   * )
cr .( ************************************* )
cr

cr .( MAN: Graphics )			Doconly %librarydir%\WDosX\graphics\graphvfx
cr .( MAN: Rebuild )                    DocOnly "%vfxpath%/Manual/ManFiles/RebuildDOS.man"

[THEN]


[defined] Target_386_Linux [IF]
cr
cr .( ************************************* )
cr .( *                                   * )
cr .( *    Linux Utilities/Extensions     * )
cr .( *                                   * )
cr .( ************************************* )
cr

cr .( SHELL commands )                    DocOnly "%vfxpath%/VFXBase/Lin32/shell"
cr .( Signals )                           DocOnly "%vfxpath%/VFXBase/Lin32/signal"
cr .( Misc Linux tools )                  DocOnly "%vfxpath%/VFXBase/Lin32/MiscLinux"
cr .( Linux Text Macros )                 DocOnly "%vfxpath%/VFXBase/Lin32/defmac"
cr .( Command Line Parser             )   DocOnly "%vfxpath%/VFXBase/Lin32/CommLine"
\ cr .( 'C' Language style constructs   )   DocOnly "%vfxpath%/VFXBase/c_lang"
cr .( MAN: Rebuild                    )   DocOnly "%vfxpath%/Manual/ManFiles/RebuildLin.man"
cr .( GTK                             )   DocOnly %vfxpath%/Examples/GTK/gtkbindings
                                          DocOnly %vfxpath%/Examples/GTK/gtktools
                                          DocOnly %vfxpath%/Examples/GTK/graphics
                                          DocOnly %vfxpath%/Examples/GTK/TextEd/editor
[THEN]

[defined] Target_386_OSX [IF]
cr
cr .( ************************************* )
cr .( *                                   * )
cr .( *    OSX Utilities/Extensions       * )
cr .( *                                   * )
cr .( ************************************* )
cr

cr .( SHELL commands )                    DocOnly "%vfxpath%/VFXBase/Osx32/SHELL"
cr .( Signals )                           DocOnly "%vfxpath%/VFXBase/Osx32/SIGNAL"
cr .( Misc OSX tools )                    DocOnly "%vfxpath%/VFXBase/Osx32/MiscOsx"
cr .( OS X Text Macros )                  DocOnly "%vfxpath%/VFXBase/Osx32/defmac"
cr .( Command Line Parser             )   DocOnly "%vfxpath%/vfxbase/Osx32/CommLine"
\ cr .( 'C' Language style constructs   )   DocOnly "%vfxpath%/VFXBase/c_lang"
cr .( MAN: Rebuild                    )   DocOnly "%vfxpath%/Manual/ManFiles/RebuildOsx.man"
cr .( GTK                             )   DocOnly %vfxpath%/Examples/GTK/gtkbindings
                                          DocOnly %vfxpath%/Examples/GTK/gtktools
                                          DocOnly %vfxpath%/Examples/GTK/graphics
                                          DocOnly %vfxpath%/Examples/GTK/TextEd/editor
                                          DocOnly "%vfxpath%/Lib/Osx32/Cocoa/mac/cocoa/VfxExternObjC"
[THEN]

[defined] Target_ARM_Linux [IF]
cr
cr .( ************************************* )
cr .( *                                   * )
cr .( *  ARM Linux Utilities/Extensions   * )
cr .( *                                   * )
cr .( ************************************* )
cr

cr .( SHELL commands )                    DocOnly "%vfxpath%/VFXBase/Lin32/shell"
cr .( Signals )                           DocOnly "%vfxpath%/VFXBase/Lin32/signalarm"
cr .( Misc Linux tools )                  DocOnly "%vfxpath%/VFXBase/Lin32/MiscLinux"
cr .( Linux Text Macros )                 DocOnly "%vfxpath%/VFXBase/Lin32/defmac"
cr .( Command Line Parser             )   DocOnly "%vfxpath%/VFXBase/Lin32/CommLine"
\ cr .( 'C' Language style constructs   )   DocOnly "%vfxpath%/VFXBase/c_lang"
cr .( MAN: Rebuild                    )   DocOnly "%vfxpath%/Manual/ManFiles/RebuildLin.man"
cr .( GTK                             )   DocOnly %vfxpath%/Examples/GTK/gtkbindings
                                          DocOnly %vfxpath%/Examples/GTK/gtktools
                                          DocOnly %vfxpath%/Examples/GTK/graphics
                                          DocOnly %vfxpath%/Examples/GTK/TextEd/editor
[THEN]

cr .( General programming tools       )   DocOnly "%vfxpath%/VFXBase/gentools"

