\ Vfx64DocFiles - documentation file list for base versions

((
Copyright (c) 2000-2004, 2007, 2008, 2011, 2012, 2014, 2019
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
20190814 SFP002 Removed c_lang, added GenTools.
20120705 SFP001 Added environ.fth.
))


cr .( ************************************* )
cr .( *                                   * )
cr .( *  Common X64 Utilities/Extensions  * )
cr .( *                                   * )
cr .( ************************************* )
cr

[defined] Target_x64_OSX [IF]
cr .( MAN: Start                      )   include "%vfxpath%/Manual/ManFiles/Osx64Manual.man"
[then]
[defined] Target_x64_Linux [IF]
cr .( MAN: Start                      )   include "%vfxpath%/Manual/ManFiles/Lin64Manual.man"
[then]

cr .( MAN: Title Page                 )   include "%vfxpath%/Manual/ManFiles/titlepg.man"
cr .( MAN: License Agreement/Terms    )   include "%vfxpath%/Manual/ManFiles/license.man"
cr .( MAN: Installation               )   include "%vfxpath%/Manual/ManFiles/install.man"
cr .( MAN: Migration Chapter          )   include "%vfxpath%/Manual/ManFiles/migrate.man"
cr .( MAN: Notation                   )   include GenericDocs/notation.man
cr .( MAN: Further Information        )   include GenericDocs/furtherinfo.man
cr .( MAN: Reparsing KERNEL 64        )   DocOnly "%vfxpath%/Kernel/Common/kernel64.fth"
cr .( MAN: ENVIRON                    )   DocOnly "%vfxpath%/Kernel/Common/environ.fth"
cr .( MAN: Locals Extension           )   DocOnly "%vfxpath%/Kernel/Common/GenLocals.fth"

[defined] Target_x64_OSX [IF]
cr .( MAN: Reparsing STARTUP 64       )   DocOnly "%vfxpath%/Kernel/x64OSX/startup64.fth"
cr .( MAN: Save Mach-o                )   DocOnly "%vfxpath%/Kernel/x64OSX/SaveOSX64.fth"
[THEN]

[defined] Target_x64_Linux [IF]
cr .( MAN: Reparsing STARTUP  64      )   DocOnly "%vfxpath%/Kernel/x64Lin/startup64.fth"
cr .( MAN: Save ELF                   )   DocOnly "%vfxpath%/Kernel/x64Lin/SaveElf64.fth"
[THEN]

cr .( MAN: DocGen                     )   DocOnly "%vfxpath%/Lib/DocGen4.fth"
cr .( MAN: XREF                       )   DocOnly "%LIBRARYDIR%/xref"
cr .( MAN: String Pack                )   DocOnly "%LIBRARYDIR%/StringPk"

[defined] Target_x64_Windows [IF]
cr .( MAN: Hello World Example        )   DocOnly "%vfxpath%/vfxbase/win32/hworld.man"
cr .( MAN: Stack Mon Program          )   DocOnly "%LIBRARYDIR%/Win32/stackmon"
cr .( MAN: WView System               )   DocOnly "%LIBRARYDIR%/Win32/wview"
cr .( MAN: EX-Except                  )   DocOnly "%LIBRARYDIR%/Win32/exexcept"
cr .( MAN: ForthEd2                   )   DocOnly "%vfxpath%/examples/Win32/ForthEd2/F2app.bld"
[THEN]

cr .( MAN: GenericIO                  )   DocOnly "%vfxpath%/Kernel/Common/generic"
cr .( MAN: GenericIO - Memory Buffer  )   DocOnly "%LIBRARYDIR%/Genio/Buffer"
cr .( MAN: GenericIO - File Device    )   DocOnly "%LIBRARYDIR%/Genio/file"
cr .( MAN: GenericIO - Null Device    )   DocOnly "%LIBRARYDIR%/Genio/null"

[defined] Target_x64_Windows [IF]
cr .( MAN: GenericIO - Serial Device  )   DocOnly "%LIBRARYDIR%/Win32/Genio/serialbuff"
cr .( MAN: GenericIO - Text Console   )   DocOnly "%LIBRARYDIR%/Win32/Genio/terminal"
cr .( MAN: GenericIO - Socket Device  )   DocOnly "%LIBRARYDIR%/Win32/Genio/socketio"
cr .( MAN: TimeBase                   )   DocOnly "%LIBRARYDIR%/Win32/timebase"
cr .( MAN: Tasker                     )   DocOnly "%LIBRARYDIR%/Win32/MultiWin32"
cr .( MAN: Hardware Port IO           )   DocOnly "%LIBRARYDIR%/Win32/portio"
cr .( MAN: GenericIO Example REMVDU2  )   DocOnly "%vfxpath%/examples/Win32/remvdu2"
[THEN]
[defined] Target_x64_Linux [IF]
cr .( MAN: GenericIO - Serial Device )    DocOnly %LIBRARYDIR%/Lin64/Genio/Serial
cr .( MAN: GenericIO - ANS Terminal )     DocOnly %LIBRARYDIR%/Lin64/Genio/xterm
cr .( MAN: GenericIO - Socket Device  )   DocOnly %LIBRARYDIR%/Lin64/Genio/SocketIo
cr .( MAN: TimeBase                   )   DocOnly "%LIBRARYDIR%/Lin64/TimeBase"
cr .( MAN: Tasker                     )   DocOnly "%LIBRARYDIR%/Lin64/MultiLin64"
[THEN]
[defined] Target_x64_OSX [IF]
cr .( MAN: GenericIO - Serial Device )    DocOnly %LIBRARYDIR%/Osx64/Genio/Serial
cr .( MAN: GenericIO - ANS Terminal )     DocOnly %LIBRARYDIR%/Osx64/Genio/xterm
					  DocOnly %Lib%/Osx64/TermControl
cr .( MAN: GenericIO - Socket Device  )   DocOnly %LIBRARYDIR%/Osx64/Genio/SocketIo
cr .( MAN: TimeBase                   )   DocOnly "%LIBRARYDIR%/Osx64/TimeBase"
cr .( MAN: Tasker                     )   DocOnly "%LIBRARYDIR%/Osx64/MultiOsx64"
[THEN]
[defined] Target_Arm64_Linux [IF]
cr .( MAN: GenericIO - Serial Device )    DocOnly %LIBRARYDIR%/Lin32/Genio/Serial
cr .( MAN: GenericIO - ANS Terminal )     DocOnly %LIBRARYDIR%/Lin32/Genio/xterm
cr .( MAN: GenericIO - Socket Device  )   DocOnly %LIBRARYDIR%/Lin32/Genio/SocketIo
cr .( MAN: TimeBase                   )   DocOnly "%LIBRARYDIR%/Lin32/TimeBase"
cr .( MAN: Tasker                     )   DocOnly "%LIBRARYDIR%/Lin32/MultiLin32"
[THEN]

cr .( MAN: Obsolete words             )   DocOnly "%LIBRARYDIR%/obsolete.fth"
cr .( MAN: Case Chain                 )   DocOnly "%LIBRARYDIR%/chain.fth"
cr .( MAN: MODULE handler             )   DocOnly "%vfxpath%/VFXBase/modules"
cr .( MAN: Build numbering            )   DocOnly "%vfxpath%/Kernel/Common/build"

cr .( PDF help )			  DocOnly "%librarydir%/PDFhelp"
cr .( MAN: CIAO core                  )   DocOnly "%LIBRARYDIR%/oop/Ciao/ciaocore"
cr .( MAN: CIAO class lib             )   DocOnly "%LIBRARYDIR%/oop/Ciao/libdoc"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/operator"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/primtype"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/wintype"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/winstrct"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/cpoint"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/crect"
                                          DocOnly "%LIBRARYDIR%/oop/Ciao/cstring"
cr .( MAN: ClassVFX )                     include "%LIBRARYDIR%/oop/ClassVFX/ClassDoc.bld"
cr .( MAN: Internationalisation       )   DocOnly "%LIBRARYDIR%/International"
cr .( MAN: XML                        )   DocOnly "%LIBRARYDIR%/XML"
cr .( Configuration Tools             )   DocOnly "%librarydir%/ConfigTools"
cr .( INI file parser )			  DocOnly "%vfxpath%/VFXBase/IniParser"
cr .( EXTERNal imports                )   DocOnly "%vfxpath%/VFXBase/Extern"
cr .( SharedLibs                      )   DocOnly "%vfxpath%/Manual/ManFiles/sharedlibs.man"
					  DocOnly "%vfxpath%/Lib/SharedLibs/libcurl/libcurl"
					  DocOnly "%vfxpath%/Lib/SharedLibs/libiconv/libiconv"
					  DocOnly "%vfxpath%/Lib/SharedLibs/SQLite3/sqlite3h"
					  DocOnly "%vfxpath%/Lib/SharedLibs/zlib/zlib"
					  DocOnly "%vfxpath%/Lib/SharedLibs/libXL/libXL

[defined] Target_x64_Windows
[defined] Target_x64_Linux  or
[defined] Target_x64_OSX  or
[IF]
cr .( MAN: x64 Assembler              )   DocOnly "%vfxpath%/Kernel/x64Com/hasmx64"
cr .( MAN: VFX Target Optimiser       )   DocOnly "%vfxpath%/Kernel/x64Com/optimise/build"
                                          DocOnly "%vfxpath%/Kernel/x64Com/optimise/hoptx64"
                                          DocOnly "%vfxpath%/Kernel/x64Com/optimise/Tokeniser"
cr .( MAN: Switches                   )   DocOnly "%vfxpath%/Kernel/x64Com/switches"
cr .( MAN: x64 Disassembler           )   DocOnly "%vfxpath%/Kernel/x64Com/hdasmx64"
cr .( MAN: NDP Disassembler           )   DocOnly "%vfxpath%/Kernel/x64Com/hdasm387"
cr .( MAN: SSE Disassembler           )   DocOnly "%vfxpath%/Kernel/x64Com/hdasmSSE"
cr .( MAN: Higher Level Disassembler  )   DocOnly "%vfxpath%/Kernel/x64Com/dis"
cr .( Code/Data optimisations         )   DocOnly "%vfxpath%/Kernel/x64Com/optimise/p4opt"
cr .( Quotations                      )   DocOnly "%vfxpath%/Kernel/Common/quotations"
cr .( MAN: SSE FP for x64             )   DocOnly "%LIBRARYDIR%/x64/FPSSE64S"
cr .( MAN: NDP FP for x64             )   DocOnly "%LIBRARYDIR%/x64/Ndpx64"
[THEN]
[defined] Target_ARM64_Linux [IF]
cr .( MAN: Switches                   )   DocOnly "%vfxpath%/Kernel/ArmCom/switches"
cr .( MAN: ARM Assembler              )   DocOnly "%vfxpath%/Kernel/ArmCom/HAsmCortex"
cr .( MAN: ARM Target Optimiser       )   DocOnly "%vfxpath%/Kernel/ArmCom/optimise/HoptCortex
                                          DocOnly "%vfxpath%/Kernel/ArmCom/optimise/Tokeniser"
cr .( MAN: ARM Disassembler           )   DocOnly "%vfxpath%/Kernel/ArmCom/HDasmCortex"
cr .( Quotations                      )   DocOnly "%vfxpath%/Kernel/Common/quotations"
[THEN]

cr .( Generic FIFO Support            )   DocOnly "%vfxpath%/VFXBase/fifo"
cr .( BNF Parser                      )   DocOnly "%vfxpath%/VFXBase/bnf"
cr .( Random Number Generators        )   DocOnly "%vfxpath%/VFXBase/random"
cr .( Vocab/Wordlist Utilities        )   DocOnly "%vfxpath%/VFXBase/voctools"
cr .( Long Strings                    )   DocOnly "%vfxpath%/VFXBase/parsel"

[defined] Target_x64_OSX [IF]
cr
cr .( ************************************* )
cr .( *                                   * )
cr .( *    OSX Utilities/Extensions       * )
cr .( *                                   * )
cr .( ************************************* )
cr

cr .( SHELL commands )                    DocOnly "%vfxpath%/VFXBase/Osx64/SHELL"
cr .( Signals )                           DocOnly "%vfxpath%/VFXBase/Osx64/SIGNAL"
cr .( Misc OSX tools )                    DocOnly "%vfxpath%/VFXBase/Osx64/MiscOsx"
cr .( OS X Text Macros )                  DocOnly "%vfxpath%/VFXBase/Osx64/defmac"
cr .( Command Line Parser             )   DocOnly "%vfxpath%/vfxbase/Osx64/CommLine"
cr .( MAN: Rebuild                    )   DocOnly "%vfxpath%/Manual/ManFiles/RebuildOsx.man"
cr .( GTK                             )   DocOnly %vfxpath%/Examples/GTK/gtkbindings
                                          DocOnly %vfxpath%/Examples/GTK/gtktools
                                          DocOnly %vfxpath%/Examples/GTK/graphics
                                          DocOnly %vfxpath%/Examples/GTK/TextEd/editor
                                          DocOnly "%vfxpath%/Lib/Osx32/Cocoa/mac/cocoa/VfxExternObjC"
[THEN]

[defined] Target_x64_Windows [IF]
cr
cr .( ************************************* )
cr .( *                                   * )
cr .( *    Win64 Utilities/Extensions     * )
cr .( *                                   * )
cr .( ************************************* )
cr
cr .( Predefined WINDOWS Structures   )   DocOnly "%vfxpath%\vfxbase\win32\winstrct"
cr .( Pre-Declared WINDOWS API Calls  )   DocOnly "%vfxpath%\vfxbase\win32\winfunc"
cr .( Pseudo WINAPI Calls             )   DocOnly "%vfxpath%\vfxbase\win32\winfuncx"
cr .( Windows Tools                   )   DocOnly "%vfxpath%\vfxbase\win32\wintools"
cr .( WINDOWS MessageLoop definitions )   DocOnly "%vfxpath%\vfxbase\win32\winloop"
cr .( Command Line Parser             )   DocOnly "%vfxpath%/vfxbase/Win32/commline"
cr .( Various 'SHELL' style commands  )   DocOnly "%vfxpath%\vfxbase\win32\shell"
cr .( BlowPipe                        )   DocOnly %vfxpath%/Lib/Win32/BlowPipe
cr .( Default System Macros           )   DocOnly "%vfxpath%\vfxbase\win32\defmac"
cr .( Win32 Exception Handler Support )   DocOnly "%vfxpath%\vfxbase\win32\wincatch"
cr .( Printer Support                 )   DocOnly "%vfxpath%\vfxbase\win32\printer"
cr .( Windows Help files              )   DocOnly "%vfxpath%\VFXBase\Win32\WinHelp"
cr .( WINDOWS Constants for Resources )   DocOnly "%vfxpath%\vfxbase\win32\winconst"
cr .( Win32 Resource Parser           )   DocOnly "%vfxpath%/vfxbase/resource"
                                          DocOnly "%vfxpath%/vfxbase/Resource/BITMAP"
                                          DocOnly "%vfxpath%/vfxbase/Resource/ICON"
                                          DocOnly "%vfxpath%/vfxbase/Resource/CURSOR"
                                          DocOnly "%vfxpath%/vfxbase/Resource/MENU"
                                          DocOnly "%vfxpath%/vfxbase/Resource/TOOLBAR"
                                          DocOnly "%vfxpath%/vfxbase/Resource/DIALOG"
                                          DocOnly "%vfxpath%/vfxbase/Resource/WINDOW"
                                          DocOnly "%vfxpath%/vfxbase/Resource/COOLBAR"
cr .( RICHEDIT Based GenericIO device )   DocOnly "%vfxpath%\vfxbase\win32\richedit"
cr .( GUI Development System Front End )  DocOnly "%vfxpath%\vfxbase\win32\newide"
cr .( MAN: Rebuild                    )   DocOnly "%vfxpath%/Manual/ManFiles/RebuildWin.man"
cr .( Dll Exports                     )   DocOnly "%vfxpath%\vfxbase\win32\dllexport"
				          DocOnly "%vfxpath%\examples\Win32\gendlltest"
cr .( Helpers                         )   DocOnly "%librarydir%\Win32\helpers"
cr .( GTK                             )   DocOnly %vfxpath%/Examples/GTK/gtkbindings
                                          DocOnly %vfxpath%/Examples/GTK/gtktools
                                          DocOnly %vfxpath%/Examples/GTK/graphics
                                          DocOnly %vfxpath%/Examples/GTK/TextEd/editor
[THEN]

[defined] Target_x64_Linux [IF]
cr
cr .( ************************************* )
cr .( *                                   * )
cr .( *    Linux Utilities/Extensions     * )
cr .( *                                   * )
cr .( ************************************* )
cr

cr .( SHELL commands )                    DocOnly "%vfxpath%/VFXBase/Lin32/shell"
cr .( Signals )                           DocOnly "%vfxpath%/VFXBase/Lin32/signal"
cr .( Misc Linux tools )                  DocOnly "%vfxpath%/VFXBase/Lin32/MiscLinux"
cr .( Linux Text Macros )                 DocOnly "%vfxpath%/VFXBase/Lin32/defmac"
cr .( Command Line Parser             )   DocOnly "%vfxpath%/VFXBase/Lin32/CommLine"
cr .( MAN: Rebuild                    )   DocOnly "%vfxpath%/Manual/ManFiles/RebuildLin.man"
cr .( GTK                             )   DocOnly %vfxpath%/Examples/GTK/gtkbindings
                                          DocOnly %vfxpath%/Examples/GTK/gtktools
                                          DocOnly %vfxpath%/Examples/GTK/graphics
                                          DocOnly %vfxpath%/Examples/GTK/TextEd/editor
[THEN]

[defined] Target_ARM64_Linux [IF]
cr
cr .( ************************************* )
cr .( *                                   * )
cr .( *  ARM Linux Utilities/Extensions   * )
cr .( *                                   * )
cr .( ************************************* )
cr

cr .( SHELL commands )                    DocOnly "%vfxpath%/VFXBase/Lin32/shell"
cr .( Signals )                           DocOnly "%vfxpath%/VFXBase/Lin32/signalarm"
cr .( Misc Linux tools )                  DocOnly "%vfxpath%/VFXBase/Lin32/MiscLinux"
cr .( Linux Text Macros )                 DocOnly "%vfxpath%/VFXBase/Lin32/defmac"
cr .( Command Line Parser             )   DocOnly "%vfxpath%/VFXBase/Lin32/CommLine"
cr .( MAN: Rebuild                    )   DocOnly "%vfxpath%/Manual/ManFiles/RebuildLin.man"
cr .( GTK                             )   DocOnly %vfxpath%/Examples/GTK/gtkbindings
                                          DocOnly %vfxpath%/Examples/GTK/gtktools
                                          DocOnly %vfxpath%/Examples/GTK/graphics
                                          DocOnly %vfxpath%/Examples/GTK/TextEd/editor
[THEN]

cr .( General programming tools       )   DocOnly "%vfxpath%/VFXBase/gentools"

