#! /bin/bash
# second stage build
# 20191018 Build Community and Enterprise editions

# CI2020: setup directories
VFX_BUILDKIT_DIR=${VFX_BUILDKIT_DIR:-$HOME/buildkit.dev}
VFX_DEFAULT_INI=${VFX_DEFAULT_INI:-$HOME/.VfxForth/VfxForth.ini}

# default values
BUILD_LEVEL=2

# build arguments
VFX_ARGS="$BUILD_LEVEL to buildLevel"
if [ "$VFX_BATCH_MODE" = "1" ]; then
    VFX_ARGS+=" 1 constant BatchMode"
fi
VFX_ARGS+=" include VfxBase64.bld"

# save INI file
cp $VFX_DEFAULT_INI ini.temp

# Build proper
cp VfxLin.no VfxLin.tmp
../Images/VfxForthK_x64_lin.elf  $VFX_ARGS
cp -a vfxlin64 ../Images/VfxForth_x64_lin.elf
# mv -f vfxlin64 ../Images/VfxForth_x64_lin.elf
chmod +x ../Images/VfxForth_x64_lin.elf
cp VfxLin.tmp VfxLin.no

# restore INI file
mv ini.temp $VFX_DEFAULT_INI
