function print_macro(str)
{
  # print out the item within the expansion macro
  print "CONSTANT(" str ")"
}

function print_enum(str)
{
  # get rid of any #defines in the middle of enums...
  sub(/#define.*/, "", str)
  sub(/# *.*/, "", str)
  if (length(str) == 0) return
  # strip off any "enum" and "{" or "}" bits from the string
  sub(/(typedef[[:blank:]]+|[[:blank:]]+|^)enum[^\{]*\{?/, "", str)
  sub(/\{/, "", str)
  sub(/\}.*/, "", str)
  # Split the remnant at any commas
  elements = split(str, array, ",")
  # print out anything left
  for (i = 1; i <= elements; i++)
  {
    this_element = array[i]
    sub(/=.*/, "", this_element)
    gsub(/ +/, "", this_element)
    if (length(this_element) > 0)
    {
      print_macro(this_element)
    }
  }
}

BEGIN {printing = 0}
# {print "Trying: " $1 " " $2 " " $3}
# $1 ~ /#define/ { print "$1 match" }
# $2 !~ /\(/ { print "$2 match" }
# $3 ~ /[[:alnum:]]/ { print "$3 match" }
$1 ~ /#define/ && $2 !~ /\(/ && $3 ~ /[[:alnum:]]/ { print_macro($2) ; next}
/^enum\ / {printing++ }
/\ enum\ / {printing++ }
{if (printing != 0) print_enum($0)} 
# /\{/ {if (printing) printing++}
/\}/ {if (printing) printing--}
