\ Class testing
\ Doug Hoffman

DECIMAL

: ?? ( n1 n2 -- ) <> IF cr abort" test failed" THEN ;


cr .( TESTING OBJECT CREATION )

 Var x

 99 Put: x  
 Get: x  99 ??
 Var y
 Get: x 1+ Put: y
 Get: y  100 ??
 
: T1  Get: x ;
 T1  99 ??


cr .( TESTING REPEATING MESSAGE )

\ interpreting
get: { x y } 200  200 ??  100 ?? 99 ??

\ compiling
: yy get: { x   y  }  200 ;
 yy 200 ??  100 ?? 99 ??


bool bb set: bb

:class testit <super var
\ public
 var z
 var gg

:m get: get: { z gg super bb } 55 ;m \ mixed object types in same list
:m classinit: 33 put: z 99 put: gg 100 put: super ;m
;class

testit tt

get: tt   55 ?? -1 ?? 100 ?? 99 ?? 33 ??


cr .( TESTING CLASS )


:Class Point

 Var x
 Var y

 :M Get:  Get:  { x  y } ;M  \ note repeated message
 :M Put:  Put:  y put: x  ;M

 :M Print:  Get: self  SWAP . .  ;M

 :M ClassInit:   1 Put: x  2 Put: y ;M

;Class



 Point p 

 Get: p  2  ??  1 ??

 3 4 Put: p  
 Get: p  4  ??  3 ??
p get: point  4 ?? 3 ?? \ message to class

:Class Pixel  <Super Point

 Var color

 :M Put:  ( x y color -- )  Put: color put: super  ;M
 :M Get:  Get: { super color } ;M  \ repeated message

 :M Print:   Print: { super color } ;M

;Class

 Pixel pix  
 1 2 3 Put: pix  
 Get: pix  3 ?? 2 ?? 1 ??

cr ." Print: pix"
print: pix


cr .( TESTING ExecVec )

ExecVec ex
 Exec: ex  
: NINE 9 ;
' NINE Put: ex
 Exec: ex  9  ??

cr .( TESTING LATE BINDING ** )

:Class C1  <General

 :M Draw:   1 ;M

 :M Print:  3 0 DO  self Draw: **  LOOP ;M

;Class



 C1 o1  



 Print: o1  1 1 1 ?? ?? ??



:Class C2   <Super C1

 :M Draw:   2  ;M

;Class



 C2 o2  

 Print: o2  2 2 2  ?? ?? ??


 \ object message syntax interpretted
 o2 print: ** 2 2 2  ?? ?? ??

 \ object message syntax compiled
 : t51 o2 print: ** ; t51 2 2 2  ?? ?? ??


cr .( TESTING LATE BINDING [ ] )
\ 0 [if]
:Class aC1

 :M Draw:   1 ;M

 :M Print:  3 0 DO Draw: [ self ]  LOOP ;M

;Class

 aC1 ao1  


 Print: ao1  1 1 1 ?? ?? ??

:Class aC2   <Super aC1

 :M Draw:   2  ;M

;Class


 aC2 ao2  



 Print: ao2  2 2 2  ?? ?? ??


 \ late binding interpretted
 print: [ ao2 ] 2 2 2  ?? ?? ??


 \ late binding compiled
 : at51 print: [ ao2 ] ; at51 2 2 2  ?? ?? ??

\  [then]
\ ======================================================================





cr .( TESTING OBJECT POINTER )

:Class C3

 C1 p1
 C2 p2
 Var pp1  \ pointer to p1
 Var pp2

 :M ClassInit:  Addr: p1 Put: pp1   Addr: p2 Put: pp2 ;M
 :M Print:   Get: pp1   Print: **  Get: pp2 Print: **  ;M
 :M Switch:     Get: pp1 Get: pp2   Put: pp1 Put: pp2 ;M
;Class


 C3 o3  
 Print: o3 2 2 2 ?? ?? ??  1 1 1 ?? ?? ??
 Switch: o3  
 Print: o3  1 1 1  ?? ?? ??    2 2 2 ?? ?? ??

\ ======================================================================

cr .( TESTING ARRAY  )

10 Array a1
 6 2 To: a1  
 2 At: a1  6  ??
 99 Fill: a1  
 5 At: a1  99  ??


:Class C4

    10 Array a1

    :M At:  ( index -- value )  At: a1  ;M
    :M To:  ( value index -- )  To: a1  ;M
    :M Fill:  Fill: a1  ;M

;Class


 C4 o4  
 6 2 To: o4  
 2 At: o4  6  ??
 99 Fill: o4  
 5 At: o4  99 ??




30 array o5
99 fill: o5
: t50 20 o5 at: array ; t50 99 ??
20 o5 at: array   99 ??

cr .( TESTING 2ARRAY )

3 3 2array myArray

12 0 0 to: myArray
33 0 1 to: |
12345678 1 0 to: |

0 0 at: | 12 ??
0 1 at: | 33 ??
1 0 at: | 12345678 ??

print: |


cr .( TESTING X-ARRAY )

 10 X-Array xa

: ONE 111 ;
: TWO 222 ;
: THREE 333 ;

 ' ONE 1 To: xa  
 ' TWO 2 To: xa  
 : T3 ['] THREE 3 To: xa ; T3  

 1 Exec: xa  111  ??
 2 Exec: xa  222   ??
 3 Exec: xa  333   ??
 4 Exec: xa 

HAVE ALLOCATE [IF]
cr .( TESTING HEAP OBJECTS )

0 VALUE POBJ

 Heap> Point TO POBJ  \ non-compiling version

 POBJ Get: **   2 ?? 1 ??

 3 4 POBJ Put: **  

 POBJ Get: **   4 ?? 3 ??

 POBJ Get: Point   4  ?? 3 ?? ( class binding )

 POBJ <release

: tt33 [heap>] Point TO POBJ ;  \ compiling version
tt33
POBJ Get: ** 2 ?? 1 ??

[THEN]

cr .( TESTING IMPLICIT CLASSINIT: SUPER )

:class class1
 var x
 :m classinit:  33 put: x ;m
  :m get: get: x ;m
;class

class1 t100  get: t100 33 ??

:class class2 <super class1
 var y
 :m classinit: 44 put: y ;m  \ classinit: super should be automatically compiled
;class

class2 t101 get: t101 33 ??

:class class3 <super class1
 var y
 :m classinit: 55 put: x 44 put: y ;m  \ we can easily over-ride classinit: super
;class

class3 t103 get: t103 55 ??


cr .( TESTING CASCADED MESSAGES )
 
var myMarvelousObject 

25 put: myMarvelousObject get: |  25 ??

: t52 34 put: myMarvelousObject  2 +: |  get: | ; t52 36 ??

var x1  33 put: x1
7 x1  +: **  get: | 40 ??

have macforth.picture [IF]
cr .( TESTING MESSAGES to VALUEs and LOCALs )

0 value myValue
x to myValue
22 put: x

get: myValue 22 ??

: t54 2 +: myValue  get: | ; t54 24 ??  \ compiled message to value, with cascade

: t55  ( ^obj -- n )
  locals| myLocal |
  3 +: myLocal get: | ;  x t55  27 ??  \ message to local variable, with cascade

: t56  ( ^obj -- n )
  locals| myLocal |
  get: myLocal ;  x t56  27 ??  \ direct message to local variable


[THEN]


cr .( TESTING ORDERED-COL )

10 ordered-col oc
45 add: oc
66 add: oc
55 add: oc

size: oc  3 ??

0 at: oc 45 ??

66 indexof: oc   -1  ??  1 ??
1 remove: oc
size: oc  2 ??

cr .( TESTING $X ) 

11 $x ss

" Hello" put$: ss

" World" add$: ss

get: ss " HelloWorld" count compare  0 ??


cr .( TESTING STRING ) 


string s


" Hello " count put: s




print: s cr
\ 0 Hello 
\ dump: s
\ 
\ SIZE: 6 POS: 0 LIM: 6 
\ Hello 
\ P
\       L


" Worl" add$: s



char d +: s

all: s " Hello World" count compare  0 ??

reset: s print: s

\ Hello World
release: s

SF VFX or [if]

" :class aClass" count put: s all: s evaluate
" var x" count put: s all: s evaluate
" :m put: put: x ;m" count put: s all: s evaluate
" :m get: get: x ;m" count put: s all: s evaluate
" ;class " count put: s all: s evaluate


[else]

" :class aClass" count put: s
line-end +: s
" var x" add$: s
line-end +: s
" :m put: put: x ;m" add$: s
line-end +: s
" :m get: get: x ;m" add$: s
line-end +: s
" ;class " add$: s

all: s evaluate

[then]

aClass myClassObj

456 put: myClassObj

get: myClassObj 456 ??




CR .( TESTING 1objArray )

:class rect
 var x1
 var y1
 var x2
 var y2


:m put: ( x1 y1 x2 y2 -- )
 put: { y2 x2 y1 x1 } ;m

:m get: ( -- x1 y1 x2 y2 )
 get: { x1 y1 x2 y2 } ;m

:m print:
 get: x1 . get: y1 . get: x2 . get: y2 . ;m

:m classinit:
 10 10 50 50 put: self ;m

;class


\ SF 0= VFX 0= and [if]

\ create an objectArray class named rectArray for rect objects

1objArray rectArray rect

5 rectArray r5

printall: r5
r5 printall: **

3 select: r5

cr 1000 2000 3000 4000 put: r5 printall: r5

2 select: r5 get: |  50 ?? 50 ?? 10 ?? 10 ??


:class test10
 3 rectArray myArray  \ as an ivar

:m print: printall: myArray ;m
;class

test10 t10

cr cr print: t10

\ [then]



CR .( TESTING SEQUENCE )

5 ordered-col oc1

40 add: oc1
50 add: oc1
60 add: oc1

: testEach
  BEGIN
    each: oc1
  WHILE
    
  REPEAT ;

testEach  60 ?? 50 ?? 40 ??

:noname 5 + ; apply: oc1

testEach 65 ?? 55 ?? 45 ??



CR .( TESTING OBJLIST )

objlist h
' var add: h  33 swap put: **
' rect add: h drop
' var add: h drop

size: h 3 ??


:noname get: ** ;  apply: h
0 ??  \ the last var
50 ?? 50 ?? 10 ?? 10 ??  \ the rect
33 ??  \ the first var

release: h
size: h 0 ??


CR .( Class tests complete )

