
0 [IF]
\ for gforth, do a copy/paste 
include g:\neon+MI.f


[THEN]

DECIMAL

FORTH-WORDLIST  SET-CURRENT     \ a precaution

false CONSTANT errorcheck \ Compile time flag.
                      \ True checks for valid messages and array indices.
                      \ Set to false after development and recompile for
                      \ faster program execution.

: HAVE  ( -- f )  BL WORD FIND NIP ;
HAVE CELL 0= [IF] 1 CELLS CONSTANT CELL [THEN]

\ WORDLIST  CONSTANT  nclass               \ create separate wordlist ***
\ nclass SET-CURRENT                       \ for class def'ns
\ GET-ORDER  nclass  SWAP 1+  SET-ORDER    \ make nclass findable

0 VALUE GF \ Gforth
0 VALUE VFX \ VFX Forth
0 VALUE CMF \ Carbon MacForth
0 VALUE SF \ SwiftForth
HAVE no-interpretation-does-code
[IF] TRUE TO GF [THEN]
HAVE OVI.MAGIC [IF] TRUE TO VFX [THEN]
HAVE macforth.picture [IF] TRUE TO CMF [THEN]
HAVE SWIFTFORTH-TOOLBAR [IF] TRUE TO SF [THEN]

CMF [IF]
S" ADDR:"  FORTH-WORDLIST  >>FINDNAME
FORTH-WORDLIST >>REMOVEENTRY DROP
[THEN]

\ words you may already have
HAVE BOUNDS 0= [IF] : BOUNDS  OVER + SWAP ; [THEN]
HAVE LINK 0= [IF] : LINK  ( addr -- )   HERE  OVER @ ,  SWAP ! ; [THEN]

HAVE HASH 0=
SF OR
[IF]
: HASH  ( addr len -- n ) TUCK BOUNDS ?DO  5 LSHIFT  I C@ 32 OR XOR  LOOP
  DUP 0< IF EXIT THEN  INVERT ;
[THEN]

: RESERVE  ( n -- )  HERE OVER ERASE ALLOT ;
: ?MEMERR  ( ior -- )  ABORT" Memory allocation error" ;

0 VALUE ^class
: IFA ( ^class -- addr_ifa ) 1 CELLS + ; \ ivar dict Latest field
: DFA ( ^class -- addr_dfa ) 2 CELLS + ; \ datalen of named ivars
: SFA ( ^class -- addr_^nway ) 3 CELLS + ; \ ^class SFA @ => ^nway
: TAG ( ^class   -- addr_tag ) 4 CELLS + ; \ class tag field
5 CELLS CONSTANT classSize
CREATE classTag

: badMessage TRUE ABORT" message not understood" ;
FORTH-WORDLIST  SET-CURRENT
: notUnderStood 0 TO ^class badMessage ;

\ nclass SET-CURRENT \ ***
\ ========================= begin code unique to dispatch table ===============

\ ***** heap table accessing
\ the heap heap table is a temporary table that only exists during the
\ definition of a new class.  At the end of the class definition the
\ contents of the heap table are combined with the superclass table
\ to construct the final dispatch table that is allotted in the dictionary.
0 VALUE heapTable \ will be an allocated pointer
0 VALUE heapTableSize \ size in bytes

: initHeapTable ( n -- ) \ n is the initial number of records
  CELLS dup 2/ + DUP ALLOCATE ?MEMERR  \ allocate 1.5 cells for each method record
   TO heapTable TO heapTableSize
  heapTable heapTableSize ERASE ; \ initialize all cells to zero
: freeHeapTable
 heapTable FREE ?MEMERR ;

: hTableSize ( -- n ) heapTableSize CELL dup 2/ + / ; \ n= number of records

: resizeHeapTable ( n -- ) \ n is the new number of records
  CELLS dup 2/ + DUP heapTable SWAP RESIZE ?MEMERR
  TO heapTable TO heapTableSize ;

: recordSize ( -- n ) \ n in aus
 [ cell dup 2/ + ] literal ;
: records ( n -- 6n ) recordSize * ;
: XThElemAddr ( Idx -- addr) records  heapTable + ; \ Idx is record#
: OffsethElemAddr ( Idx -- addr) XThElemAddr cell+ ; \ Idx is record#

: XTtoHeapTable ( xt Idx -- ) XThElemAddr ! ;
: OffsettoHeapTable ( offset Idx -- ) OffsethElemAddr w! ;

: XTatHeapTable ( Idx -- xt ) XThElemAddr @ ;
: OffsetatHeapTable ( Idx -- offset ) OffsethElemAddr w@ ;

: incrHeapTable ( -- ) \ increase size by 1 record
  hTableSize 1+ resizeHeapTable
  0 hTableSize 1-  XTtoHeapTable \ zero the record
  0 hTableSize 1- OffsettoHeapTable ;

\ ***** superclass table accessing

0 VALUE ^nway

: dispTableSize ( ^class -- #records) \ not counting record(0), i.e. 1-based
   @ \ ^dispatchTable
   @ \ dispatchTable recordXT(0) = table size in aus
   recordSize / ;

0 value LtableSize

: largestSuperTableSize ( -- #records ) \ return largest superclass table size
 0 to LtableSize
 ^nway cell+ locals| addr |
 ^nway @ 0 ?DO  addr @ ( ^supclassi )
       dispTableSize LtableSize max to LtableSize
       addr cell+ cell+ to addr
       LOOP LtableSize ;

\ ***** dispatch table accessing

\ dispatch table records are a 1-based array of 1.5cell ( often 6 byte) records
: XTdisTable ( idx ^class -- addr ) \ address of dispatchtable record n
  @ >r
  ( idx ) records r> + ;
: OffsetdisTable ( idx ^class -- addr ) \ address of dispatchtable record n
  XTdisTable cell+ ;

: XTtoDisTable ( xt Idx ^class -- )  
  XTdisTable ! ;
: OffsettoDisTable ( offset Idx ^class -- )  
  OffsetdisTable w! ;

: XTatDisTable ( idx ^class -- xt )  
  XTdisTable @ ;
: OffsetatDisTable ( idx ^class -- offset )  
  OffsetdisTable w@ ;

0 value record#
0 value curSupClass
\ FindSuperclMethod searches sequentially up the MI superclass chain
\ But it should search recursively shoudn't it?
: FindSuperclMethod ( record# -- true | false ) \ true if found
 to record#
 ^nway cell+ locals| addr |
 ^nway @ 0 ?DO addr @ ( ^supclassi ) to curSupClass
     record#   curSupClass dispTableSize 1+  <
      IF \ this table is large enough to look in
         record# curSupClass XTatDisTable ( xt )
         ['] notUnderStood <> 
         IF \ we found it
            unloop true EXIT THEN
      THEN
       addr cell+ cell+ to addr
      LOOP ( we didn't find it ) false ;

: curSupClass-offset ( ^class -- offset ) \ get offset from ^nway list
 ^nway cell+ locals| addr ^cls |  \ step through addr of each superclass
          \ until a match is found
 ^nway @ 0 ?DO addr @  ^cls  =  IF addr cell+ @ unloop exit THEN
      addr cell+ cell+ to addr \ step to next superclass
      LOOP true abort" didn't find ^class in curSupClass-offset" ;


: AdvanceSuperclMethodXTs \ from supTable to heapTable as necessary
  \ also set the offset values in the XT records of the dispatch table
 hTableSize 1
 DO I XTatHeapTable 0=
  IF \ we have a zero record, so check superclasses
     I FindSuperclMethod
     IF
      \ transfer xt(i) and offset(i) from superclass table to heap table
       I curSupClass XTatDisTable ( xt) I XTtoHeapTable
       
     \ Now add the offset from the nway list for the given superclass
     \ to the offset from the superclass dispatch table for the given message,
     \ and place that combined offset in the dispatch table for the
     \ new class being defined.  This is important to keep straight.
     i ( message-idx ) curSupClass OffsetatDisTable ( offset-from-message )
     curSupClass curSupClass-offset ( offset-from-nway ) + I OffsettoHeapTable
     ELSE
       ['] notUnderStood I XTtoHeapTable  0 I OffsettoHeapTable
     THEN
   ELSE \ we don't have a zero record so
     \ this method is in the current class definition, just set the offset
     \ based on the current nway offset in the first superclass
     ^nway cell+ cell+ @ ( offset ) i OffsettoHeapTable
  THEN
 LOOP ;

: transferMethodXTs  \ transfer from heap table to newly allotted table
  \ covert 0 xts into notUnderStood xts
  hTableSize 1 \ for cells# 1 through heap table size
  DO I XTatHeapTable ( xt)
     DUP 0= IF DROP ['] notUnderStood THEN   
     I ^class XTtoDisTable
     
     i OffsetatHeapTable ( offset )
     i ^class OffsettoDisTable
  LOOP
      hTableSize 1- records ( aus ) 0 ^class XTtoDisTable ; \ store table max offset ( aus ) in cell zero

\ ========================= end code unique to dispatch table ===============

: ?isClass  ( addr -- flag) \ is addr a ^class?
    TAG @ classTag = ;
    
: ?isObj  ( pfa -- f ) @ DUP IF CELL - @ ?isClass THEN ;

: classAllot  ( n -- ) ^class DFA +! ;

: classAlign  ( -- ) ^class DFA @  ALIGNED  ^class DFA ! ;

\ The runtime action of an object is to return the address of its data,
\ which is one cell in front of the PFA. The PFA contains the address of the
\ first cell of the method dispatch table for the class of that object.
: (Obj)  ( -- )  CREATE  DOES> CELL+ ;

: >obj  ( objXT -- ^obj )
 >BODY CELL+ ;

: FIND-IVAR  ( ivarID addr0 -- addri true | false )
  BEGIN @ DUP WHILE 2DUP CELL+ @ = IF 2 CELLS + NIP TRUE EXIT THEN
  REPEAT NIP ;

0 VALUE ^base

0 value offset \ set by FIND-METHOD-RUN

: EXECUTE-METHOD  ( ^obj xt -- )
 swap offset + swap
 ^base >R
 SWAP ( xt ^obj ) TO ^base  EXECUTE
 R>  TO ^base
 ;

: EXECUTE-IVAR  ( xt offset -- )
  ^base DUP >R  + TO ^base  EXECUTE  R> TO ^base ;

HAVE CATCH [IF]
: CATCH  ( -- n )  ^base >R   CATCH   R> TO ^base ;
[THEN]

errorcheck [IF]
: >xt ( SelId ^dispatchTable -- xt )
    2DUP @ ( SelId ^dispatchTable SelId maxSelID )
    > IF badMessage THEN
   + @ ;

[ELSE]

: >xt ( SelId ^dispatchTable -- xt ) \ No error-check.  Faster.
    POSTPONE + POSTPONE @ ; IMMEDIATE \ inline it per Reinhold: faster

[THEN]

: Defer**   ( ^obj SelId --  )
  POSTPONE LITERAL
  POSTPONE OVER \ ^obj SelId ^obj
  CELL POSTPONE LITERAL
  POSTPONE -  \ ^obj SelId ^class
  POSTPONE @  \ ^obj SelId ^dispatchTable
  POSTPONE >xt  \ ^obj xt
  POSTPONE EXECUTE-METHOD ; \ offset is zero

: [self],  \ 06/04/09 dbh  
  S" self" EVALUATE
  POSTPONE LITERAL
  POSTPONE SWAP \ SelId ^obj
  CELL POSTPONE LITERAL POSTPONE -  \  SelId ^class
  POSTPONE @  \  SelId ^dispatchTable
  POSTPONE >xt
  POSTPONE EXECUTE ;

: >disp  ( ^obj -- ^dispatchTable )
 CELL - @ ;

: obj>xt  ( SelId ^obj -- xt )
  >disp >xt ;

: IVAR-FIND-METHOD-RUN  ( SelID ^obj -- ^obj xt )
    TUCK        \ ^obj SelID ^obj 
    >disp       \ ^obj SelID ^class
    @           \ ^obj SelID ^dispatchTable
    >xt         \ ^obj xt
    ;


: FIND-METHOD-RUN  ( SelID ^obj -- ^obj xt )
  locals| ^obj SelID |
  SelID recordSize / ( idx ) ^obj cell - @ ( idx ^dispatchtable )
    cell - @ ( idx ^class ) OffsetatDisTable to offset
  ^obj SelID ^obj ( ^obj SelID ^obj )
  obj>xt ; 

: hash>  ( -- n )  BL WORD COUNT HASH ;

\ =====================================================================
\ Instance variable consists of three cell-sized fields.
\ 
\     Offset   Name      Description
\     ------   ----      ---------------------------------------
\        0     link      points to link of next ivar in chain
\        1     name      32-bit hash value of ivar name
\        2     ^class     pointer to class
\        3     offset    offset in object to start of ivar data
\
\ In the stack diagrams, "ivar" refers to the starting address of this
\ structure.  The IFA field of a class points to the first ivar.
\ =====================================================================

: iclass     ( ivar -- ^class )   2 CELLS +   ;

CREATE ^Self 0 , hash> self , 0 , 0 ,
CREATE ^Super ^Self , hash> super , 0 , 0 ,
CREATE Meta classSize RESERVE

^Super   Meta IFA ! \ latest ivar
classTag Meta TAG ! \ class tag


0 value ^object \ will contain  ' object >body   after class object is defined
0 value vFind-offset \ will contain the nway offset to be applied
: vFind-nway ( str ^class -- str false | addri true )
 SFA @ ( ^nway ) locals| addr str |
 addr @ ( #ofSuperclasses )
 0 ?DO str COUNT HASH ( ivarID )
       addr cell+ @ ( ^supercl-i ) IFA FIND-IVAR 
       ( addr true | false )
       IF 
          addr cell+ cell+ @ ( offset ) to vFind-offset
          true unloop exit
       ELSE str   addr cell+ @ ( str ^class )
                dup ^object =
                   \ quit searching if we hit class object: it has no ivars
                   IF drop unloop false exit THEN recurse
           IF  
               true unloop exit
           ELSE ( str ) drop
           THEN
       THEN
       addr cell+ cell+ to addr
    LOOP str false ; \ if we got this far we failed to find the ivar *anywhere*


 \ addri points to ^class for the found ivar
 \ Recursively search ALL classes and superclasses in this MI class
 \ for the named ivar.  If there are name clashes then the first ivar
 \ in the hierarchy will be the one used (proper search order).
: vFind  ( str -- str false | addri true )
  ^class
  IF DUP COUNT HASH \ str ivarID
     ^class  \ str ivarID ^class
     IFA FIND-IVAR  \ search primary class
     DUP
     IF
       \ We found the ivar
       \ str addri true
       ROT  \ addri true str
       DROP \ addri true
     THEN
     ( str false | addri true )
         IF true
         ELSE  ( str ) ^class vFind-nway \ must search the superclasses recursively
         THEN
  ELSE FALSE \ str false
  THEN ;

: <Var ( ^class -- )
  BL WORD 
  COUNT HASH ALIGN ^class IFA LINK , DUP , 
  ^class DFA @ ,  DFA @ classAllot ;

: Build   ( ^class -- ) \ the action taken when a class name is executed
   ^class \ are we compiling a class?
  IF <Var \ yes, so this must be an embedded object-as-ivar declaration
  ELSE    \ no, so we must instantiate a new named dictionary object
  (Obj)
   DUP >R @ ,  \ store dispatch table pointer
   R> DFA @ RESERVE THEN ;  \ allot space for ivars

FORTH-WORDLIST   SET-CURRENT

: :class ( "spaces<name>" -- ) \ <name> is the name of the new class being defined
    CREATE 0 TO ^class
    DOES>  Build ;

\ Multiple inheritance support

\ These values are used in processing the superclass list.

0 VALUE ^sup
0 VALUE #sup
0 VALUE ivlen


\ store cumulative offsets
: next_super  ( ^sup -- )
 DUP ?isClass 0= ABORT" not a class"
 TO ^sup
 ^sup ,       \ Add ^class to n-way
 ivlen ,       \ store cumulative offset
 ^sup DFA @  ivlen +  TO ivlen \ And add ivar length of new class
 #sup 1+  TO #sup  ;

: }  ABORT" Unmatched }"  ; IMMEDIATE

: supers_loop
 BEGIN      \ Loop over superclasses:
  >IN @
  BL WORD     \ See if } follows - we don't use  ['] }
        \  since we don't want to prevent } from
        \  being redefined
  COUNT 1 =
  IF C@
   [CHAR] } =
   IF  DROP EXIT  THEN
  ELSE DROP
  THEN
  >IN !
  '      \ cfa of next item on list
  >BODY  next_super  \ handle next superclass
 AGAIN  ;

: super{ ( "spaces<name>" -- )  \ <name> is the name of the superclass
  HERE TO ^class   \ save current class
  classSize RESERVE   \ reserve rest of class data
  classtag ^class TAG !  \ tag it as a class
  HERE DUP TO ^nway   \ n-way for superclasses will start here
  ( HERE ) ^class SFA !  \ store pointer to n-way as superclass ptr
  ^class ^Super iclass !    \  is this wrong?  Posibly, see below
  ^class ^Self iclass !
  0 TO ivlen  0 to #sup
  0 , \ initial size of n-way is 0
  supers_loop
  #sup ^nway !
  ivlen  ^class DFA !   \ Set total ivar length in this class

^nway cell+ @ ( ^super1 ) ^Super iclass ! \ set the superclass for this class
    
  ^nway cell+ @ ( addr ) \ addr of 1st superclass, will be meta for class object
     cell+ @ ( addr_IFA )  ^class IFA ! \ store ivar link addr
   
   
  ^class SFA @ ( ^nway ) cell+ @ Meta = \ will be true only for class OBJECT
  IF \ compiling class object, so there are no superclass dispatch tables,
     \ therefore we must start a new heap table from scratch.
  1 initHeapTable \ cell 0 will be the #ofXTs for this class
  ELSE \ get initial size from superclass(es)
   largestSuperTableSize ( size of largest superclass dispatch table in records) 
     1+ initHeapTable \ start with a heap table of same size as largest superclass
  THEN
  ;
 
: ;class
  classAlign  \ align class data (optional)
  ^class ,  \ store ^class at one cell before the dispatch table
  HERE ^class ! \ now make ^class point to the first cell of the dispatch table
   hTableSize records ALLOT \ allot the dictionary dispatch table
  ^class SFA @ ( ^nway ) cell+ @ Meta <>
  IF \ Don't do AdvanceSuperclMethodXTs when compiling class object.
   \ Move XTs from superclass tables to empty cells in heap table.
   AdvanceSuperclMethodXTs
  THEN
   transferMethodXTs \ from the heap table to the dispatch table
   freeHeapTable
    0 ^Super iclass !
    0 ^Self  iclass !
    0 TO ^class
    ;
    
\ nclass SET-CURRENT \ ***

: ?is** ( *ptr -- t/f ) COUNT  S" **"  COMPARE 0= ;

\ Converts lower-case characters to upper case, modifying the contents
: to-upper   ( addr cnt -- )
 OVER \ addr cnt addr
 + SWAP  \ cnt+addr addr
 ?DO I C@ DUP
  [CHAR] a [CHAR] z 1+ WITHIN
  IF 32 - I C!
  ELSE DROP
  THEN
 LOOP ;

: ?is-super> ( *ptr -- t/f ) COUNT 2DUP to-upper  S" SUPER>"  COMPARE 0= ;

: ?is[self] ( *ptr -- t/f )  COUNT 2DUP to-upper  S" [SELF]"  COMPARE 0= ;

: refToken ( str -- xt tokenID | tokenID )
 DUP ?is**   IF DROP 2 EXIT   THEN
 DUP ?is-super> IF DROP 3 EXIT THEN
 DUP ?is[self] IF DROP 10 EXIT THEN
 FIND 0= ABORT" undef obj"
\ DUP ?isLocal IF 4 EXIT THEN
\ DUP ?isValue IF 5 EXIT THEN
 DUP >BODY TAG @ classTag = IF  1  EXIT   THEN
 DUP >BODY ?isObj IF  0  EXIT   THEN
 TRUE ABORT" Invld obj type" ;

: (ivarRef)   ( xt offset -- )
 SWAP  POSTPONE LITERAL  POSTPONE LITERAL  POSTPONE EXECUTE-IVAR ;
 
: FIND-METHOD-IVAR   ( SelID ^ivar -- ^ivar xt )
 DUP >disp ^class =
 IF ( SelID ^ivar ) \ we must look in heap table
    OVER >R  \ stash SelID
  ( SelID ^ivar ) SWAP recordSize / ( ^ivar idx ) XTatHeapTable DUP 0=
  IF DROP ( ^ivar ) \ we must look in superclass table(s)
   R@ ( ^ivar SelID) recordSize / ( ^ivar record# ) FindSuperclMethod
     ( ^ivar true | ^ivar false ) IF \ we found the method xt
               record# curSupClass XTatDisTable
               ( ^ivar xt )
             ELSE \ we did not find it
               R> DROP
               true abort" method not found"
             THEN
  THEN R> DROP
 ELSE IVAR-FIND-METHOD-RUN
 THEN ;

: ivarRef   ( selID ^iclass-of-ivar -- )
  CELL+ FIND-METHOD-IVAR  SWAP @  ( xt offset ) vFind-offset +  ?DUP
  IF (ivarRef)
  ELSE COMPILE,
  THEN
  0 to vFind-offset
  ;

: callMethod  ( xt -- )
  POSTPONE LITERAL  POSTPONE EXECUTE-METHOD ;

: (objRef)   ( SelID objCfa -- )
  >obj ( SelID ^obj ) FIND-METHOD-RUN ( ^obj xt )
  SWAP ( xt ^obj )
  POSTPONE LITERAL  callMethod ;

\ The following works only for the primary superclasses.
: findOffset ( ^iclass-of-ivar -- offset )
    ^nway cell+ locals| addr ^cls |
 ^nway @ 0 ?DO addr @ ^cls = IF addr cell+ @ ( offset ) unloop exit THEN
               addr cell+ cell+ to addr
            LOOP true abort" class after super> not found"
 ;

: (super>) ( ^obj selID ^iclass-of-ivar )
 dup ?isClass
 IF
      \ ^obj selID ^iclass-of-ivar
  dup findOffset >r
  @   \ ^obj selID ^dispatchTable
  >xt \ ^obj xt
  POSTPONE LITERAL r> POSTPONE LITERAL POSTPONE EXECUTE-IVAR
 ELSE
  true abort" super> not followed by classname"
 THEN ;

: compileRef ( selID $str -- )
 refToken CASE
   0 ( object ) OF   (objRef)                               ENDOF
   1 ( class  ) OF  >BODY ( SelID ^Class) @ >xt callMethod  ENDOF
   2 ( ** )     OF  ( selID )         Defer**               ENDOF
   3 ( super> ) OF  ' >body ( ^class ) (super>)    ENDOF
\   4 ( local )  OF  COMPILE, ( selID) Defer**               ENDOF
\   5 ( value )  OF  COUNT EVALUATE Defer**                ENDOF
  10 ( [self] ) OF [self],          ENDOF
 ENDCASE ;
 
: runRef ( selID $str -- )
 refToken CASE
   0 ( object ) OF  >obj FIND-METHOD-RUN                 ENDOF
   1 ( class  ) OF  >BODY @ >xt                          ENDOF
   2 ( ** )     OF  ( ^obj selID ) SWAP FIND-METHOD-RUN  ENDOF 
\   5 ( value )  OF  COUNT EVALUATE FIND-METHOD-RUN       ENDOF 
 ENDCASE EXECUTE-METHOD ;

\ Message is state smart.  This could be changed but it would be cumbersome.
: Message   ( SelID -- )
 BL WORD ( $str)  STATE @
 IF
   \ we are compiling
   vFind \ are we sending the message to an ivar?
   IF
     \ yes, it is an ivar
      ( ^class-of-ivar ) ivarRef
   ELSE
     \ no, it is something else
      compileRef
   THEN
 ELSE
    \ we are interpretting
    runRef
 THEN ;

0 VALUE lastSelectorIndex
0 VALUE curSelIdx

: Selector  ( "spaces<name:>" -- )
    CREATE IMMEDIATE
    lastSelectorIndex recordSize + DUP TO lastSelectorIndex ,
    DOES> @ Message ;

: getSelect  ( "spaces<name:>"-- SelID )
   >IN @  BL WORD FIND
  IF >BODY @ NIP  ( already defined)
  ELSE DROP >IN ! Selector
   HERE CELL - @
  THEN ;

FORTH-WORDLIST   SET-CURRENT

: :m  ( "spaces<name:>" -- methodXT ) 
  getSelect
  recordSize / TO curSelIdx
  :NONAME ;
   
: ;m  ( methodXT -- )
    POSTPONE ;
  \ the methodXT from above :NONAME will be on the stack
  ( methodXT ) \ save on stack, to be consumed after REPEAT
  BEGIN
    hTableSize 1- curSelIdx <
  WHILE
    incrHeapTable \ increase table size by one record
  REPEAT
  ( methodXT ) curSelIdx XTtoHeapTable  \ store xt in proper cell in dispatch table
 ; IMMEDIATE

: self ( -- ^obj )  POSTPONE ^base ; IMMEDIATE

-1 [IF]  \ optional debugging tools

: dh  \ dump heap table
 \ will only work if we have not used freeHeaptable
  CR ." Heap Table"
  hTableSize 0 ?DO cr i . 9 EMIT i XTatHeapTable . 9 EMIT
       i OffsetatHeapTable . LOOP
       ;

: dd \ dump dispatch table
  \ usage:   dd <classname>
 ." DUMP DISPATCH TABLE"
  ' >body locals| ^cls |
  cr ." ^dispatchTable-cell " ^cls @ cell - .  ."  = ^class => "
        ^cls @ cell - @ .
  cr ." ^dispatchTable =  " ^cls @ .
  cr ^cls @ @ 1 records / . ."  = #ofrecords "
  cr ." record#  " ." XT  "  ."   ivar-offset"
  ^cls @ @ 1 records / 1+ 0 ?DO cr i . i ^cls XTatDisTable  .
                     i ^cls OffsetatDisTable .
                 LOOP ;

: dumplinked-list ( addr -- )
  locals| addr |
  BEGIN
    addr @
  WHILE
    cr addr @ to addr  addr .
    addr cell+ @ .
    addr cell+ cell+ @ .
    addr cell+ cell+ cell+ @ .
  REPEAT ;
    

: di \ dump ivar linked-list
  \ usage:   di <classname>
  ' >body locals| ^cls |
 ." DUMP IVAR LINKED-LIST"
  cr ." Link  "  ." Hashed-Name  "  ." ^class  "  ."   Offset"
  ^cls IFA dumplinked-list ;



: d \ { addr n -- } \ for debugging, addr = beginning address n = # of cells to dump
  locals| n addr |
  n 0 ?DO CR I . ADDR I CELLS + DUP . @ . LOOP ;

[THEN]

 :class object  super{ Meta }
   :m addr: ( -- addr ) self ;m
   :m release: ;m
 ;class

' object >body to ^object

: bytes  ( n "spaces<name>" -- )  ['] object >BODY <Var  classAllot ;

\ nclass SET-CURRENT  \ ***

: allocObj  ( ^class ivar-size -- ^obj )
 CELL+  \ ^class total-size     \  allow for ^dispatchTable
 ALLOCATE ?MEMERR  \ ^class ptr
 DUP CELL+   \ ^class ptr ^obj
 >R       \ ^class ptr    
 SWAP        \ ptr ^class
 @    \ ptr ^dispatchTable
 SWAP   \ ^dispatchTable ptr
 !
 R> ; 

: (heapObj)  ( ^class  -- ^obj )
  DUP   \ ^class ^class
  DFA @  ( ^class ivar-size )
  allocObj ; \ return object address

FORTH-WORDLIST  SET-CURRENT

\ heap> must only be executed at run time (used in a definition).
: HEAP>   ( "spaces<classname>" -- ^obj )
 ' >BODY
 POSTPONE LITERAL  POSTPONE (heapObj)
 ; IMMEDIATE

: <RELEASE  ( ^obj -- )  \ free heap object
 DUP release: **       \ send Release: message to object
 CELL - FREE ?MEMERR ; \ deallocate it

\ GET-ORDER  NIP  1-  SET-ORDER     \ hide nclass definitions ***


-1 [IF]  \ optional debugging tool
: dc  \ dump class
  \ usage:   dc <classname>
 ." DUMP CLASS"
 ' >body 0 locals| addr ^cls |
 cr 0 . ^cls . ^cls @ .  ." ^class @ => ^dispatchTable"
 cr 1 . ^cls IFA dup . @ . ." ^class IFA @ => ivar link addr"
 cr 2 . ^cls DFA dup . @ . ."  ^class DFA @ => total ivar data length"
 cr 3 . ^cls SFA dup . @ . ."   ^class SFA @ => ^nway "
 cr 4 . ^cls TAG dup . @ dup . ."   ^class TAG @ => classtag" classtag = 
  IF ."  verified " ELSE -1 abort" classtag mismatch" THEN
 cr 5 . ^cls SFA @ dup . @ . ."  ^nway @ => # of superclasses"
  ^cls SFA @ cell+ to addr
    ^cls SFA @ @ 0
   ?DO cr   
       addr . addr @ dup . ." => super(i) "
       dup ['] object >body = IF ."  = OBJECT" THEN
       meta = IF ."  = Meta" THEN
       addr cell+ to addr
       cr addr . addr @ .  ." cum offset"
       addr cell+ to addr
    LOOP
 ;

[THEN]


 
