\ An example of the classical "Composite Pattern" described by Gamma et al.
\ in "Design Patterns: Elements of reusable Object-Oriented software".
\ by Rafael Gonzalez. Public Domain. NO WARRANTY.

include /usr/share/doc/VfxForth/Lib/Ndp387.fth
include objects.fs			\ my own porting of GForth's objects.fs
include string.fs			\ copied as is from GForth 0.6.2

include hwitem.fs			\ hardware item class
include hwcomp.fs			\ composite hardware item class
include hwspoil.fs	\ variations of above to exercise exceptions

\ syntactic sugar
: euros					  \ n1 -- n1
;

\ shortcut
: Object:				  \ class "name" -- ; [child] obj
   heap-new constant ;

cr .( Assembling a desktop PC ...)

0   euros s" PC City Bundle"       hw-comp Object: Desktop-PC 
200 euros s" Samsung 20'' TFT"     hw-item Object: screen
10  euros s" MS wireless mouse"    hw-item Object: mouse
12  euros s" MS wireless keyboard" hw-item Object: keyboard
99  euros s" HP 1020 LaserJet"     hw-item Object: printer
40  euros s" BoxKong Tower"        hw-comp Object: TowerBox

mouse         Desktop-PC push-back
keyboard      Desktop-PC push-back
screen        Desktop-PC push-back
printer       Desktop-PC push-back
TowerBox      Desktop-PC push-back

cr Desktop-PC price . .( euros so far)

cr .( Filling the tower with components ...)

120 euros s" Zalman ZM400-APS" hw-item  Object: Power-Supply
10 euros s" SONY DVD RW"      hw-item  Object: DVD-Writer
75 euros s" Asus Motehrboard" hw-smart Object: Motherboard

Power-Supply TowerBox push-back
DVD-Writer   TowerBox push-back
Motherboard  TowerBox push-back

cr Desktop-PC price . .( euros so far)

cr .( Filling the motherboard with components ...)

30  euros s" Conceptronics 10/100 LAN"  hw-item Object: Ethernet-Card
100 euros s" ATI Radeon"                hw-item Object: Graphics-Card
35  euros s" Conceptronix RS232"        hw-item Object: RS232-Card
150 euros s" Centrino@1.5 GHz"          hw-item Object: CPU
100 euros s" Kingston 1 GB RAM #1"      hw-item Object: RAM1
100 euros s" Kingston 1 GB RAM #2"      hw-bad  Object: RAM2
125 euros s" Maxtor 200 GB 7200 rpm"    hw-item Object: HardDisk


Ethernet-Card Motherboard push-back
Graphics-Card Motherboard push-back
RS232-Card    Motherboard push-back 
CPU           Motherboard push-back
RAM1          Motherboard push-back
RAM2          Motherboard push-back
HardDisk      Motherboard push-back

cr Desktop-PC price . .( euros in all)
cr Desktop-PC selftest




