\ The Composite class.
\ by Rafael Gonzalez. Public Domain. NO WARRANTY.


\ A generic interface for classes implementing lists
\ names have been taken from C++ STL to avoid name clashes
\ with common add, remove words

interface
   selector push-front
   selector push-back
   selector pop-front
   selector pop-back
end-interface i-list

hw-item class

   i-list implementation		\ uses push-back
      
   \ field members
   
   cell% inst-var m-head		\ head of list
   cell% inst-var m-last		\ tail of list

  public
   
   \ new selectors
   
   selector size       ( this -- u )
   
   \ methods

   m: ( price ca u this -- )
      this [parent] construct  0 dup m-head !  m-last ! ;m
   overrides construct
   
   m: ( node this -- )
      this over parent!			\ set other node parent to 'this'
      m-head @ 0= if dup m-head ! then	\ first time 
      m-last @ ?dup if >r dup r> next! then	\ updates last item pointer
      m-last !				\ set the last element
   ;m			
   overrides push-back

   \ Count items by sweping the list (just an exercise) ...
   m: ( this -- u )
      m-head @ 0			\ -- addr counter
      begin over while 1+ swap next@ swap repeat nip ;m
   overrides size
   
   \ iteratively calculates whole price based on children's price
   \ and my own price
   m: ( this --  price )
      m-head @	m-price @
      begin over while over price + swap next@ swap repeat nip ;m
   overrides price

   \ iteratively calculates whole price based on children's price
   \ and my own price
   m: ( this --  price )
      this print ." : Testing child components ..." cr
      m-head @	
      begin dup while dup selftest next@ repeat drop
      this print ." is also Ok." cr
   ;m
   overrides selftest

 end-class hw-comp

\ ----------------------------------------------------------------------


