#!/bin/sh
# 
# $Date: 2008-02-11 00:27:54 +0100 (lun, 11 feb 2008) $
# $Revision: 450 $
# $Author: astrorafael $
# $HeadURL$
#
# 2008 By Rafael Gonzalez Fuentetaja
# This file is placed in the public domain. NO WARRANTY.



normal="normal"
internal="internal"

if test $# -ne 1
then
    echo "Usage: $0 ( $normal | $internal )"
    exit 0
fi

if test $1 != "$normal" -a $1 != "$internal" 
then
    echo "Incorrect argument: $1"
    echo "Usage: $0 ( $normal | $internal )"
    exit 0
fi

mode=$1

if test ! -d "../doc"
then
    mkdir ../doc || exit
fi


echo "removing temporary files"
rm manual.* 
rm *.tex    

# generate .tex and html files by VFX's DocGen
vfxlin create $mode include docgen.dgs

# Rerun twice to generate proper TOC

# To generate an index texify -p manual.tex must be run instead of pdftex
# texify -p manual.tex
# texify -p manual.tex

pdftex manual.tex 
pdftex manual.tex

echo "copying manuals to the doc folder"
mv manual.pdf ../doc 
mv *.html     ../doc 
rm '../doc/###.html'

echo "cleaning again temporary files"
rm manual.* 
rm *.tex    
