((
$Date: 2008-02-11 00:27:54 +0100 (lun, 11 feb 2008) $
$Revision: 450 $
$Author: astrorafael $
$HeadURL$

2008 By Rafael Gonzalez Fuentetaja
This file is placed in the public domain. NO WARRANTY.
))

\ =======================================================================

\ *> examples

\ *S Multitasked TCP client example.
\ *P This example shows a multitasked client using the VFX preemptive
\ ** multitasker. Upon starting the client, the Forth console is still
\ ** available and active tasks are shown using multitasker's
\ ** *\fo{.tasks} word.
\
\ *P I/O through sockets is done using a GENIO *\fo{/SockDev} driver,
\ ** so words like *\fo{cr}, *\fo{type}, or *\fo{accept} are available.
\ **  Note that this example does not use event passing nor messages, so
\ ** there is no need to call *\fo{pause} and blocking sockets are used.
\ ** Also note that wihin the task, text can be printed in the console
\ ** surronded by a *\fo{[io}, *\fo{io]} context.
\ =========================================================================

\ *[

\ =========================================================================

include /usr/share/doc/VfxForth/Lib/Lin32/MultiLin32.fth
include ../src/sockets.fs 
include ../src/Genio/sockets.fs

0 Constant myflags

s" localhost" 7624 EndPoint: remote known-ip \ the "remote" end point

SockDev: mysock 

\ -----------------------------------------


: default-io	\ -- ; set up default I/O
   xconsole setIO ;

: suicide
   pause termThread 0 pthread_exit ;

: run-task \ xt --
   \ wrapper around real task code given by xt
   catch default-io dup errno-base <= if dup .errno-excp then suicide ;

\ -------------------------------------------------------

: .connect
   cr ."  Connected to server " cr ;

: .selfmsg	       \ --
   ." task " self ." sent a message" cr ;

: task1-init
   mysock SetIO
   remote -1 myflags open-gen throw drop
   [io default-io .connect io]   
;

: (task1-action)
   task1-init
   begin
      s" Hello TCP World!" type cr	\ send to remote
      [io default-io .selfmsg io]
      3000 ms
   again
;
   
: task1-action
   ['] (task1-action) run-task ;

\ ------------------------------------------------------


task task1

' task1-action task1 initiate
\ *]

\ ======
\ *> ###
\ ======

