\ kernel.fth - VFX Forth high level kernel
\ Note that undocumented words are subject to change.

((
Copyright (c) 2001-2012, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====
UnDEFER C#Literal.
Fix checking (+LOOP).
Refactor . and friends to provide versions using a buffer.


Change history
==============
20200409 SFP107 Removed SET-NEW-RECOGNISER SET-RECOGNISER and GET-RECOGNISER.
20200408 SFP106 Removed the DEFERred words CEXECUTE and CUNDEFINED
20200323 SFP105 Cleared CC-LEVEL at cold start.
20191012 SFP104 Fixed SKIP-SIGN for LEN=0
20190909 SFP103 Added ZTERM ( caddr len -- caddr len ).
20190819 SFP102 Changed conditional compilation check only to
		occur for succesful compilation.
20190815 SFP101 Added $CREATE-IN.
20190702 SFP100 Redid USER variable offsets to be 32/64 bit sensitive.
20190322 SFP099 Converted to recognisers for VFX 5.1
		Removed CEXECUTE.
		Removed CLASSHOOK.
		Separated duplicated error names.
20180512 SFP098 Updates for latest tests in Examples/tests/src.
20180501 SFP097 NDCS and header changes. Added NDCS bit to header.
20180321 SFP096 Converted to Community edition.
20170530 SFP095 Added initialisation of SYSPAD.
20170310 SFP094 Added checking of conditional compilation
		to INCLUDE and friends.
		Fixed INTERP> for when children are compiled
		in other words.
20161121 SFP093 Changes for systems with FSP in a register.
20161021 SFP092 Added Forth2012 UNESCAPE.
20160914 SFP091 Added changeNameWid.
20141007 SFP090 Enhanced standards compliance by not putting
		LOCALVARS in the search order.
20140823 SFP089 Made IMMEDIATE standards-compliant.
20140521 SFP088 Added CSPLIT to kernel.
20131212 SFP087	Updated S\" and friends to Forth2012 spec;
		2 hex digits only.
20131005 SFP086 Added TRAVERSE-WORDLIST and friends.
20130816 SFP085 Added SYNONYM bit to header.
                Added ' SYN.
20130503 SFP084 More protection for >NAME.
20130501 SFP083 Updated OS X command line processing.
20130128 SFP082 Corrected INSTRING to prevent overflow.
20120802 SFP081 Corrected SUBSITUTE for single % character.
20120723 SFP080 Added error codes.
20120715 SFP079 Updated wid handling routines.
20120531 SFP078 DEFERred O_ABORT for Ward McFarland.
		Changed (QUIT) to be less cute.
20120525 SFP077 Factored setting of HERE in INCLUDE and for SAVE.
20120426 SFP076 Overhauled ADDSOURCEFILE. Added SOURCETRACKRENAME.
20120306 SFP075 Made DELETE-FILE and RENAME-FILE use macros.
		Added SubstituteC and SubstituteZ.
20120225 SFP074 Updated macro documentation.
		Moved more defaults to the kernel.
20120220 SFP073 Updated factors of IDIR and INCLUDED.
20120208 SFP072 More resets of the exception stack.
20120124 SFP071 Corrected COMP:
20111104 SFP070 Corrected EMPTY and TRIM-DICTIONARY.
		Added CUT-DICTIONARY.
20111027 SFP069 Updated RESOLVEINCLUDEFILENAME.
20110418 SFP068 Rewrote text macro words.
20110412 SFP067 Added +ORDER and -ORDER.
                Made MOVEX a synonym for MOVE.
20101202 SFP066 Fixed unoptimised/optimised problem.
20101005 SFP065 Added 2VALUE.
		Removed obsolescent words.
20100327 SFP064 Added IDIR macro for current include directory.
		Added STRIPFILENAME to remove filename from path.
20100116 SFP063 Rewrote ASSESS for error handling.
20091220 SFP062 Added .\" to the escaped strings set.
20090908 SFP061 Recoded DO, LOOP, I and friends to match +FASTDO.
20090620 SFP060 Made state-smart words neither state-smart nor
		immediate.
20090617 SFP059 Rewrote SYNONYM so that children are not
		state-smart.
20090421 SFP058 Removed uses of PAD. Added SYSPAD.
20090408 SFP057 Added SET-COMPILER and GET-COMPILER.
		Major overhaul of defining words for ANS compliance
		and tokeniser.
20090308 SFP056 Fixed corner cases in D> D< DMIN DMAX.
20090228 SFP055 Cleared OPERATORTYPE after error.
20080929 SFP054 Added missing FILE-STATUS and RENAME-FILE.
20080624 SFP053 Removed OnCompilation and Saved>Here only used by PDB.
		Corrected DMIN.
20080512 SFP052 Replaced MIN or MAX by UMIN or UMAX as appropriate.
20080506 SFP051 Moved TICKS and friends into the kernel.
20080229 SFP050 Added OS_TYPE.
20080118 SFP049 Added EXPAND.
20080108 SFP048 Forced ] to run DISCARD-SINLINE.
20071228 SFP047 Corrected EVALUATE.
20071224 SFP046 Added FLUSH-FILE.
20071128 SFP045	Added PARSE-NAME and used it to replace BL WORD COUNT.
		Added upper case move operations.
		Changed DIGIT to be case insensitive.
		Removed redundant upper-casing and replaced these
		with the new words.
20071128 SFP044 Exposed CRLF$ and EOL$.
20071116 SFP043 Added EMPTY.
20071024 SFP042 Added IS= and ISTR=.
20071017 SFP041 Added UMIM and UMAX.
20070814 SFP040 Started 'a' character literals in INTEGER?, but still have
		problems with case conversion.
20070807 SFP039 Added VOC>WID macro.
		Added MACROEXISTS?.
20060930 SFP038 Changed Hash function to CRC16.
20060929 SFP037 Changed number of threads in Forth voc to 512.
20060911 SFP036 Changed I J for new style code.
20060814 SFP035 Added BEGINCASE.
20060124 SFP034 Refactored dictionary trmming.
		Exposed TRIM-DICTIONARY.
20051122 SFP033 Fixed D>.
20050831 SFP032 Corrected memory leak in VF-CLOSE-FILE.
		Added MEM-OPEN-FILE and INCLUDEMEM.
20050819 SFP031 Added escaped strings S\" C\" Z\".
		Minor kernel reordering and tweaking.
		Added PROTALLOC and PROTFREE.
20050726 SFP030 Fixed checking BASE twice in INTEGER?.
20050221 SFP029 REDEFHOOK now contains all display of redefinition data.
20041209 SFP028 Fixed INTEGER? for pathological BASE values.
20041205 SFP027 Refactored LOCATE components.
		Added PAUSECONSOLE, C/COLS.
		Updated HALT?
20040624 SFP026 Made >NUMBER case insensitive.
20040316 SFP025 Added NEXTCASE and NEXT-CASE.
20040311 SFP024 Refactored to avoid use of >NAME. Added LASTNAMEFOUND.
20040309 SFP023 FORTH vocabulary has 64 threads to improve compilation.
		Added locals code to DOES>.
20031203 SFP022 Added ThreadXXX user variables.
20031124 SFP021 Added EKEY and EKEY?
		Added DELLINK
20030804 SFP020 Changed default code alignment to 16 for performance.
		Added LATEST-XT.
20030706 SFP019 Added more debug info.
20030512 SFP018 Improved performance of COMPARE.
20030331 SFP017 Fixed ALIAS: for redefinitions.
20030125 SFP016 Reordered some words to improve the manual.
20020918 SFP015 Removed obsolescent words to LIB\OBSOLETE.FTH.
20020704 SFP014 Fixed GETPATHSPEC for '(xxx)'
20020602 SFP013 Rewrote ZPLACE to perform zero termination last.
		This avoids problems when src/dest overlap.
20020305 SFP012 Replaced SEARCH-BASE mechanism by SEARCH-RANGE.
20020221 SFP011 Changed PADSIZE to avoid overwriting the exception stack,
		which is in the user area.
20011212 SFP010 Added CATCH ... THROW to EVALUATE.
20011102 SFP009 Added redefinition checks.
		Modified and docced redefinitions flag.
		Added TEST-BIT.
20011026 SFP008 Modified EVALUATE to use SAVE-INPUT and RESTORE-INPUT.
		Added SETENDOFFILE.
20010721 SFP007 Refactored and changed (INCLUDE-FILE) not to
		close the file. This was done in order to
		support performance changes for the source
		inliner.
		Changed VFCACHE structure to include the file name.
		Added STR= ( c-add1 len1 c-addr2 len2 -- flag ).
20010629 SFP006 Changed ?DNEGATE to use a 0< test for
		compatibility with past practice.
		Source file locate line number set to 1
		in ADDSOURCEFILE.
20010621 SFP005 Reorganised string and memory operators to
		make the documentation more consistent.
20010620 SFP004 Minor speed upgrade to , W, and C,
20010614 SFP003 Fixed RESTORE-INPUT
20010613 SFP002 Replaced BINKERNELBUILD? by BUILDLEVEL.
		Made TEMPNAME[ local in ADDSOURCEFILE.
		Added Z$, ( c-addr u -- ).
20010612 SFP001 Changed LINE# to a USER variable.
))

\ =======================================================================
\ ( *! startup                                                            )
( *! struct                                                             )
( *! source                                                             )
( *! cond                                                               )
( *! file                                                               )
( *! user                                                               )
( *! dict                                                               )
( *! wid                                                                )
( *! tools                                                              )
( *! kerneldf                                                           )
( *! tmacro                                                             )
( *! turnkey                                                            )
( *! docgen                                                             )
( *! texterr                                                            )
( *> ###                                                                )
\ =-=====================================================================

\ =======================================================================
( *> kerneldf                                                           )
( **                                                                    )
( *T Base Kernel Definitions                                            )
( **                                                                    )
( *P This section describes a number of the base kernel definitions     )
( ** available to the system. This wordset includes the vast bulk of    )
( ** the ANS Forth specified words as well as a number of useful        )
( ** additions. Note that further information about some words may be   )
( ** found in the draft ANS specification, accessible from the Help     )
( ** menu.								)

( *S Glossary Notation                                                  )

( *P The notation for the glossary definitions found in this manual have)
( ** two major parts:                                                   )
\ *(
( *B The definition Line.                                               )
( *B The description Line.                                              )
\ *)

( *P The definition line varies depending on the definition type.       )
( ** For instance - a normal Forth word will look like:                 )
( *E : AND              \ n1 n2 -- n3                           6.1.0720)
\ *P where the left most column describes the word *\fo{AND} and
\ ** type (colon), the center column describes the stack effect
\ ** of the word and the far right column will specify the ANS
\ ** standard's reference ID, an MPE reference ID, *\f{Forth200x}
\ ** to indicate that the word is a standards proposal, or this
\ ** field may be empty.

\ =======================================================================

decimal only forth definitions

\ ===========
\ *> kerneldf
\ *S Main Vocabularies
\ ===========

#512 equ New#Thr	\ -- n ; number of threads required
\ FORTH vocabulary must have enough space for this.
vocabulary FORTH	\ --
\ *G The standard general purpose vocabulary.
  New#Thr #16 - cells allot&erase	\ for update to >16 threads
vocabulary ROOT		\ --
\ *G This vocabulary contains only the words
\ ** which ensure that you can select other vocabularies.
vocabulary SYSTEM	\ --
\ *G A repository for those words which are required
\ ** internally by the compiler/system but should never
\ ** appear in user code. *\fo{SYSTEM} words may be
\ ** changed without notice.
vocabulary ENVIRONMENT	\ --
\ *G Storage for ANS ENVIRONMENT stuff.
vocabulary SourceFiles	\ --
\ *G Storage for SourceFile descriptions after *\fo{INCLUDE}.
vocabulary substitutions	\ --
\ *G Repository for text macros.
vocabulary Externals	\ --
\ *G Repository for external library calls.
vocabulary Licensed	\ --
\ \ *G Repository for licensed copy only functionality.
vocabulary LOCALVARS	\ --
\ Contains local variable names


\ ============================
\ *S ASCII Character Constants
\ ============================
\ *P Various constants for ASCII characters to aid readability
\ ** and to provide some insulation between VFX Forth implementations
\ ** on different operating systems.

$07 constant ABELL	\ -- char
( *G Bell/sound character )
$08 constant BSIN       \ -- char
( *G Backspace on input character )
$7F constant DELIN      \  -- char
( *G Delete character )
$08 constant BSOUT      \ -- char
( *G Backspace on output character )
$09 constant ATAB       \ -- char
( *G Tab character )
$0D constant ACR        \ -- char
( *G Carriage Return character )
$0A constant ALF        \ -- char
( *G Line Feed character )
$0C constant FFEED      \ -- char
( *G Form Feed character )
$20 constant ABL        \ -- char
( *G Space character )
$2E constant ADOT       \ -- char
( *G Dot character )
$00 constant AEOL       \ -- char
\ *G Generic EOL marker.

Target_x64_Windows  Target_386_Windows or  Target_386_WDOSX or [if]
#13 constant ANL	\ -- char
\ *G Host specific constant for the character returned when you
\ ** press the Enter key on your keyboard.

create eol$	\ -- addr
\ *G A counted and zero terminated string holding the operating
\ ** system specific end of line sequence as a counted and zero
\ ** terminated string.
\ *(
\ *B For Windows, DOS and bare metal systems without an operating system,
\ ** this is CR/LF,
\ *B For Unix and derivatives such as Linux and Mac OS X, this is LF,
\ *B For Mac OS up to 9, this is CR.
\ *)
  2 c,  #13 c,  #10 c,  0 c,
[then]

Target_386_Linux  Target_ARM_Linux or
Target_386_OSX or Target_x64_OSX or [if]
#10 constant ANL	\ -- char

create eol$	\ -- addr
  1 c,  #10 c,  0 c,
[then]

create crlf$	\ -- addr
\ *G A counted and zero terminated string holding a CR/LF pair.
  2 c,  #13 c,  #10 c,  0 c,


\ ===================
\ *> kerneldf
\ *S System CONSTANTs
\ ===================
\ *P Various constants for the internal system.

 0 constant FALSE               \ -- 0                          6.2.1485
\ *G The well formed flag version for a logical negative.
-1 constant TRUE                \ -- -1                         6.2.2298
\ *G The well formed flag version for a logical positive.

ABL constant BL                 \ -- u                          6.1.0770
\ *G An internal constant for blank space.
$40 constant C/L                \ -- u
\ *G Max chars/line for internal displays under *\fo{C/LINE}.

64 constant #VOCS               \ -- u
\ *G Maximum number of Vocabularies in search order.
#VOCS cells constant VSIZE      \ -- u
\ *G Size of *\fo{CONTEXT} area for search order.

$200 constant FILETIBSZ         \ -- len
\ *G Size of *\fo{TIB} buffer when *\fo{SOURCE-ID} is a file pointer.

Target_x64_Windows  Target_386_Windows or  Target_386_WDOSX or [if]
#260 constant MAX_PATH		\ -- len
\ *G Size of longest file/path name for Windows and DOS.
\ ** 1024 is used for Linux and OS X.
[else]
#1024 constant MAX_PATH
[then]
$00 constant NULL
\ *G NULL pointer.


\ ===========
\ *> kerneldf
\ *S Defined USER Variables
\ ===========
\ *P *\fo{USER} variables are the Forth equivalent of Thread
\ ** Local Storage. They are for task specific information and
\ ** act as normal variables within their thread scope.

\ *P *\fo{USER} variables can be defined by the words *\fo{USER}
\ ** and *\fo{+USER}. They are defined using an offset from a
\ ** base address assigned at the start of each task.* Offsets in
\ ** the *\fo{USER} area below $1000 are reserved for kernel use.
\ ** The variable *\fo{NEXTUSER} is used by *\fo{+USER} and is
\ ** initialised to $1000 in the primary build of VFX Forth, with
\ ** 4k bytes of memory available for application use.

\ *P The following USER variables have been declared within the system.

\ BE WARNED. DON'T MODIFY THESE USER DECLARATIONS UNLESS YOU ALSO
\ CHANGE THE CALLBACK INTERFACE and the STARTUP file.
$00 cells user S0		\ -- addr
\ *G Initial Base of data stack.
\ DO NOT CHANGE offset above!
$01 cells user R0		\ -- addr
\ *G Initial Base of return stack.
\ DO NOT CHANGE offset above!
$02 cells user #TIB		\ -- addr ; 6.2.0060
\ *G Number of characters currently in *\fo{TIB}.
$04 cells user >IN		\ -- addr ; 6.1.0560
\ *G Pointer to next char in input stream.
$05 cells user OUT		\ -- addr
\ *G Number of characters output since last *\fo{CR}.
$06 cells user BASE		\ -- addr                               6.1.0750
\ *G Numeric Conversion Base.
\ DO NOT CHANGE offset above!
$07 cells user HLD		\ -- addr
\ *G Used during number formatting to point to next character to save.
$08 cells user #L		\ -- addr
\ *G Number of cells converted by *\fo{NUMBER?} and friends.
$09 cells user #D		\ -- addr
\ *G Number of digits converted by *\fo{NUMBER?} and friends.
$0A cells user DPL		\ -- addr
\ *G Position of double number indicator in number text.
$0B cells user 'TIB		\ -- addr
\ *G Address of *\fo{TIB}.
\ DO NOT CHANGE offset above!

$0E cells user OP-HANDLE	\ -- addr
\ *G Generic IO output handler structure.
\ DO NOT CHANGE offset above!
$0F cells user IP-HANDLE	\ -- addr
\ *G Generic IO input handler structure.
\ DO NOT CHANGE offset above!
$10 cells user CURROBJ	\ -- addr
\ *G Current Object Pointer for OOP extensions.
$11 cells user 'AbortText	\ -- addr
\ *G Pointer to counted string for last *\fo{ABORT"}.
$12 cells user $S0		\ -- addr
\ *G Initial Base of string stack.
$13 cells user $SP		\ -- addr
\ *G Current string stack pointer.
$14 cells user fs0
\ *G Initial Base of float stack.
\ DO NOT CHANGE offset above!
$15 cells user fsp
\ *G Current float stack pointer.
\ DO NOT CHANGE offset above!
$14 cells constant fs0-offset
\ DO NOT CHANGE offset above!
$15 cells constant fsp-offset
\ DO NOT CHANGE offset above!
$16 cells user line#			\ SFP001
\ *G Current source input line number. Note that this
\ ** variable does NOT describe the number of lines output,
\ ** but is reserved to hold the number of lines read from
\ ** the current source input device. For console devices,
\ ** *\fo{LINE#} should be set to -1 to indicate that the source
\ ** cannot be recovered for words such as *\fo{LOCATE} and
\ ** *\fo{XREF}.
$17 cells user op-line#		\ -- addr
\ *G Current output line number, incremented by CR and
\ ** reset by *\fo{QUIT}.
$18 cells USER ThreadExit?	\ -- addr
\ *G Used in the multitasker to indicate that the task/thread should terminate.
\ DO NOT CHANGE offset above! SFP022
$19 cells USER ThreadTCB	\ -- addr
\ *G Holds the address of a task/thread's Task Control Block.
\ DO NOT CHANGE offset above! SFP022
$1A cells USER ThreadSync	\ -- addr
\ *G User in a task/thread for synchronisation.
\ DO NOT CHANGE offset above! SFP022

\ Add new kernel USER vars here and adjust HOLD-BUFFER accordingly.
$1F cells user ^Syspad		\ points into SYSPAD ; DO NOT CHANGE
$20 cells user SyspadStart		\ start of SYSPAD buffer ; DO NOT CHANGE
$400 user SyspadEnd		\ end of SYSPAD buffer ; DO NOT CHANGE
$380 equ /SysPad		\ length of SYSPAD buffer ; DO NOT CHANGE
$400 equ HOLD-BUFFER		\ start of number conversion buffer up to PAD
32bit? [if] $480 [else] $500 [then]
 dup equ PAD-RELATIVE		\ start of PAD
  user PAD		\ -- addr ;                             6.2.2000
\ *G Transient data area. The size of *\fo{PAD} is given by the
\ ** constant *\fo{/PAD} in the *\fo{ENVIRONMENT} vocabulary.
$800 PAD-RELATIVE -             \ size of PAD
  equ PADSIZE			\ PAD ends at next USER var or ExceptStackEnd below
PAD-RELATIVE HOLD-BUFFER -      \
  equ PICNUMSIZE

$800 user ExceptStackEnd
$1000 4 cells - user ExceptStackStart
$1000 3 cells - user exc0	\ Initial Exception stack pointer
$1000 2 cells - dup user excp   \ Current Exception stack pointer
     equ  #excp                 \ offset of excp
((
$800 user ExceptStackEnd
$FF0 user ExceptStackStart
$FF4 user exc0                  \ Initial Exception stack pointer
$FF8 dup user excp              \ Current Exception stack pointer
     equ  #excp                 \ offset of excp
))

\ *******************************
\ *S System Variables and Buffers
\ *******************************
\ ============
\ *N Variables
\ ============

\ create foop  cell allot  foop @ .xword  foop 10 dump  $55AA foop !  foop 10 dump

variable c/Line		\ -- addr
\ *G Maximum number of chars/line in interpret console.
  #80 c/line !
variable c/Cols		\ -- addr
\ *G Character height in *\fo{DEFAULT-CONSOLE} device.
  #25 c/Cols !
variable dp-char	\ -- addr
\ *G Holds up to four ASCII values of double number separators.
\ ** Unused bytes must be set to zero.
  char , dp-char c!  char . dp-char 1+ c!  0 dp-char 2+ c!
variable fp-char	\ -- addr
\ *G Holds up to four ASCII values of floating point number separators.
  char . fp-char !
variable ign-char	\ -- addr
\ *G Holds ASCII values of characters that are ignored
\ ** during number scanning. Set to ':' by default.
  char : ign-char !
variable dir1-char	\ -- addr
\ *G CELL, holds the primary directory separator character
\ ** used when scanning file names.
\ ** Set to '\' by default for Windows/DOS and to '/'
\ ** for Unix derivatives.
variable dir2-char	\ -- addr
\ *G CELL, holds the secondary directory separator
\ ** character used when scanning file names.
\ ** Set to '/' by default for Windows/DOS and to '\'
\ ** for Unix derivatives.
Target_x64_Windows  Target_386_Windows or  Target_386_WDOSX or [if]
  char \ dir1-char !
  char / dir2-char !
[else]
  char / dir1-char !
  char \ dir2-char !
[then]
variable FENCE		\ -- addr
\ *G End of protected dictionary.
variable VOC-LINK	\ -- addr
\ *G Links vocabularies.
variable wid-link	\ -- addr
\ *G Links word-lists.
  wid-link label init-wid-link
variable res-link	\ -- addr
\ *G Links resources.
  res-link off
variable lib-link	\ -- addr
\ *G Links dynamic/shared libraries.
  lib-link off
variable ovl-link	\ -- addr
\ *G Links active overlays.
  ovl-link off
variable ovl-id		\ -- addr
\ *G Holds unique overlay ID
  1 ovl-id !
variable <id>		\ -- addr
\ *G A variable that holds the next available ID number.
\ ** See *\fo{NEXTID:} in the Resources Section.
  $2001 <id> !
variable import-func-link
\ *G Links imported API functions in shared libraries.
  import-func-link off
variable SCR		\ -- addr
\ *G For mass storage by old-timers.
  0 scr !
variable BLK		\ -- addr
\ *G User input device: 0 for keyboard/file, non-zero is block number.
  0 blk !
variable STATE		\ -- addr
\ *G Interpreting (0) or compiling (non-zero).
variable CSP
\ *G Stack pointer saved for error checking.
variable CURRENT	\ -- addr
\ *G Holds the wordlist/vocabulary in which new definitions are created.
vsize buffer: CONTEXT	\ -- addr
\ *G Search order array.
vsize buffer: MinContext	\ -- addr
\ *G A *\fo{CONTEXT} array for minimum search order.
variable LAST		\ -- addr
\ *G Points to last definition (after Link Field).
variable Last-colon-XT	\ -- addr ; xt of last : or :NONAME definition
variable #THREADS	\ -- addr
\ *G Default number of threads in a new wordlist.
  #64 #threads !
variable CHECKING	\ -- addr
\ *G True if checking structure definitions is enabled.
\ ** Note that this variable may be removed in a
\ ** future release.
2variable SOURCE-LINE-POS	\ -- addr
\ *G Contains double file position before refill.
variable Saved>IN	\ -- addr
\ *G Holds the value of *\fo{>IN} before each token parse in interpret.
variable <HeaderLess>	\ -- addr
\ *G A flag. Declares the presence of a header in the last definition.
variable 'SourceFile	\ -- addr
\ *G Pointer to source include struct for current file, or 0.
  0 'SourceFile !
variable tabwordstop	\ -- addr
\ *G Cursor X Position for tab stops.
  #32 tabwordstop !
2variable search-range	\ -- addr ; holds search base and overlay base ; SFP012
  -1 -1 search-range 2!
variable search-ovl	\ -- addr ; holds historical OVL-LINK ; SFP012
\ variable        search-base     -1 search-base !
variable ColdChain
  ColdChain off
variable ExitChain
  ExitChain off
variable Optimising	\ -- addr
\ *G Variable is set TRUE when optimisation should be used.
  Optimising off
variable NextUser
\ *G Next Valid offset for a new user variable.
  $1000 NextUser !
\ fs-size buffer: Fstack0                 \ Task0 float stack
variable OPERATORTYPE	\ -- addr
\ *G Set by prefix operators such as *\fo{TO} and *\fo{ADDR}.
variable Top-Mask	\ -- addr ; controls loop alignment
\ *G Mask that controls the alignment of loop heads
\ ** during code generation.
  7 top-mask !
variable TextChain	\ -- addr
\ *G Anchor for the linked list of error message structures.
  0 TextChain !
variable debug1		\ -- addr
\ *G When set, *\fo{INCLUDE} displays the lines of the file.
  0 debug1 !


\ =========
\ *N Values
\ =========

: valComp,	\ xt -- ; default compiler for a value child.
  >body s_val,
;
0 value sbBase		\ -- n ; base used by status bar
0 value sbDepth		\ -- n ; depth used by status bar
0 value sbContext	\ -- wid ; CONTEXT used by status bar
0 value sbCurrent	\ -- wid ; CURRENT used by status bar

0 value FpSystem	\ -- n
( *G The value *\fo{FPSYSTEM} defines which floating point pack is installed	)
( ** and active for compilation. See the Floating Point chapter for 	)
( ** further details.							)

0 value original-xt	\ -- xt
\ *G Set during a redefinition to preserve the xt of the word being
\ ** redefined.


\ ========================
\ *S Kernel DEFERred words
\ ========================
\ *P These words are *\fo{DEFER}red to allow later modification.


\ ===================
\ *N Input and Output
\ ===================
\ *P Although the standard Forth I/O functions are deferred, users
\ ** are strongly encouraged to use the generic I/O mechanism rather
\ ** than to change the global effect of the I/O words. The I/O
\ ** words are *\fo{DEFER}red for historical reasons and to ease
\ ** porting.

defer EMIT      \ char -- ; display char
( *G Display char on the current I/O device. )

defer EMIT?	\ -- ior
( *G Return a non-zero ior if the current output device is ready to	)
( ** receive a character. The ior may be device dependent.		)

defer KEY       \ -- char ; receive char
( *G Wait until the current input device receives a character and	)
( ** return it.								)

defer KEY?      \ -- flag ; check receive char
( *G Return true if a character is available at the current input	)
( ** device.								)

defer EKEY	\ -- char ; receive char
\ *G Wait until the current input device receives a character and
\ ** return it.
\ ** Note that the behaviour of *\fo{EKEY} and *\fo{EKEY?} may be
\ ** implementation dependent. See the ANS Forth standard
\ ** for more details.

defer EKEY?      \ -- flag ; check receive char
\ *G Return true if a character is available at the current input
\ ** device.
\ ** Note that the behaviour of *\fo{EKEY} and *\fo{EKEY?} may be
\ ** implementation dependent. See the ANS Forth standard
\ ** for more details.

defer CR        \ -- ; display new line
( *G Perform the equivalent of a CR/LF pair on the current output	)
( ** device. This action may be device dependent.			)

defer TYPE      \ c-addr len -- ; display string
( *G Display/write the string on the current output device.		)

defer ACCEPT	\ c-addr +n1 -- +n2
( *G Read a string of maximum size n1 characters to the buffer at	)
( ** c-addr, returning n2 the number of characters actually read. Input	)
( ** may be terminated by a CR. The action may be input device specific. )


\ =========================
\ *N Kernel and Convenience
\ =========================
\ *P These words are deferred to improve kernel portability,
\ ** and to provide points at which the default behaviour of the
\ ** Forth kernel can be changed.

defer EntryPoint	\ hmodule 0 commandline show -- res
\ *G This word is the entry point from the startup code to the
\ ** Forth system. The arguments follow the WinMain conventions,
\ ** except that the command line may include the program name.
\ ** See the chapter about creating turnkey applications for
\ ** more and important details.

defer ABORT	\ i*x -- ; R: j*x -- ; error handler
\ *G Empty the data stack and perform the action of *\fo{QUIT},
\ ** which includes emptying the return stack, without displaying
\ ** a message.

defer isNumber?	\ caddr len -- d 2 | n 1 | 0
\ *G Attempt to convert the string *\i{caddr/len} to an
\ ** integer. The return result is either zero for failed, a
\ ** single cell number and one for a single-cell conversion,
\ ** or a double cell number and two for a double number
\ ** conversion. The ASCII number string supplied can also contain
\ ** an explicit radix (number base) override. A leading $
\ ** enforces hexadecimal, a leading # enforces decimal and a
\ ** leading % enforces binary. Hexadecimal numbers can also be
\ ** specified by a leading '0x' or trailing 'h'. After a floating
\ ** point pack has been compiled from the *\i{Lib} directory, the
\ ** action of *\fo{NUMBER?} is changed to accept floating point
\ ** numbers as well as integers.

: NUMBER?   \ addr -- d 2 | n 1 | 0
\ *G As *\fo{isNumber?} but takes a counted string.
  count isNumber?
;

defer ShowSourceOnErrorHook	\ --
\ *G Performed at the end of *\fo{SHOWSOURCEONERROR}.

defer EditOnError	\ --
\ *G Performed in *\fo{DOERRORMESSAGE}. The default is *\fo{NOOP}.
\ ** This word is assigned a new action by the Studio environment.

defer pause	\ --
\ *G The multitasker is installed here. Until a multitasker is
\ ** installed the action is *\fo{NOOP} or *\fo{YIELD}.
\ ** Do *\b{not} call *\fo{PAUSE} inside callbacks.

defer ms	\ n --
\ *G Wait for *\i{n} milliseconds.

\ SFP051...
defer ticks	\ -- n
\ *G Return the system timer value in milliseconds. Treat the
\ ** returned value as a 32 bit unsigned number that wraps on
\ ** overflow.
\ ...SFP051

defer .cold
\ defer prompt-hook

defer interpret	\ i*x -- j*x ; process current input line
\ *G Process the current input line as if text entered at the keyboard.

defer QUIT              \ -- ; R: i*x --                        6.1.2050
\ *G Empty the return stack, store 0 in *\fo{SOURCE-ID}, make the
\ ** console the current input device, and enter interpretation
\ ** state. *\fo{QUIT} repeatedly *\fo{ACCEPT}s a line of input
\ ** and *\fo{INTERPRET}s it, with a prompt if in interpretation
\ ** state. See the separate chapters on error handling and
\ ** internationalisation for details of error message display.

defer .Prompt	\ --
\ *G The Forth console prompt.

\ ===================
\ Compilation support
\ ===================

defer DOEXIT,           \ --
\ Compile the code required at exit from a colon definition
\ by *\fo{EXIT}.

defer AddXref           \ xt -- ; Action for XREF hook in Search-wordlist
defer AddXrefLit        \ Nn .. N1 n -- Nn .. N1 n

defer doCall,           \ xt -- ; lays a CALL xt instruction
\ defer CExecute          \ Compiler action for executing XT's
defer clit,		\ x -- ; compile single literal ; SFP001
defer C#Literal         \ Compiler action for compiling Integer literals
defer C#FLiteral        \ Compiler action for compiling Real Literals
\ defer CUndefined        \ Compiler action taken for undefined word

\ DOCGEN hooks
defer DOCGEN_PREREFILL
defer DOCGEN_REFILL
defer +DOCGEN_hook
defer -DOCGEN_hook
0 value docgen?


\ =============
\ O/S specifics
\ =============
\ OS specific action words for implementation of kernel definitions
\ by convention these will all be named OS_xxxx

also system definitions

defer   os_key          \ -- key
defer   os_key?		\ -- flag
defer   os_emit         \ char --
defer	os_type		\ caddr len --

defer   os_bin
defer   os_r/o
defer   os_w/o
defer   os_r/w
defer   OS_Create-File
defer   OS_Open-File
defer   OS_Close-File
defer   OS_Write-File
defer   OS_Read-File
defer   OS_File-Size
defer   OS_File-Position
defer   OS_Reposition-File
defer   OS_Delete-File
defer   OS_SetEndOfFile		\ handle -- ior ; set EOF at current position
defer	OS_Flush-File		\ handle -- ior ; flush file data ; SFP046
defer   OS_Rename-File		\ ca-old lold ca-new lnew -- ior ; SFP054

defer   OS_GetLoadAddress       \ -- a-addr
defer   OS_GetCommandLine       \ -- z-addr
defer   OS_GetSystemTime	\ -- seconds mins hours day month year dow
defer   OS_GetLocalTime		\ -- seconds mins hours day month year dow

previous definitions


\ ======================
\ *N GUI interface hooks
\ ======================
\ *P These words provide hooks into systems, both GUI and kernel,
\ ** which use message passing or event handlers. These words are
\ ** mostly used by Generic I/O devices while waiting.

Target_x64_Windows  Target_386_Windows or [if]
defer Idle		\ --
\ *G *\b{Windows only}: Despatches the next message, waiting if none
\ ** are present. *\fo{Idle} only returns when a message has been
\ ** received.
[else]
defer WaitIdle		\ --
\ *G *\b{Linux, OS X and DOS}: Despatches the next message/event, waiting
\ ** if none are present. *\fo{WaitIdle} only returns when a message
\ ** has been received.
[then]

defer BusyIdle		\ --
\ *G Despatches one message/event if available. The word returns
\ ** immediately if no messages are available. The default action
\ ** is *\fo{(BusyIdle)}. See also *\fo{EmptyIdle}.

defer EmptyIdle	\ --
\ *G Empty the message/event loop, returning when no messages are
\ ** available. *\fo{EmptyIdle} can be used in applications to
\ ** ensure that the GUI system has an opportunity to process
\ ** messages/events.


\ ===========
\ *> kerneldf
\ *S Logic functions
\ ===========
\ *P Perform various logic and bit based operations on stack items.

: and           \ n1 n2 -- n3                                   6.1.0720
( *G Perform a logical AND between the top two stack items and retain  )
( ** the result in top of stack.                                       )
  and
;

: or            \ n1 n2 -- n3                                   6.1.1980
( *G Perform a logical OR between the top two stack items and retain   )
( ** the result in top of stack.                                       )
  or
;

: xor           \ n1 n2 -- n3                                   6.1.2490
( *G Perform a logical XOR between the top two stack items and retain  )
( ** the result in top of stack.                                       )
  xor
;

: invert        \ n1 -- ~n1                                     6.1.1720
\ *G Perform a bitwise inversion.
  invert
;

: not           \ n1 -- n1
\ *G Perform a bitwise NOT on the top stack item and retain result.
\ ** *\b{OBSOLETE} but retained because of widespread use. In VFX, *\fo{not}
\ ** is the same as *\fo{invert}, but in other Forth systems *\fo{not}
\ ** may be the same as *\fo{0=}.
  invert
;

: and!          \ x addr --
\ *G Logical AND x into the cell at addr.
  and!
;

: or!           \ x addr --
\ *G Logical OR x into the cell at addr.
  or!
;

: xor!           \ x addr --
\ *G Logical XOR x into the cell at addr.
  xor!
;

: bic!           \ x addr --
\ *G Invert x and logical AND it into the cell at addr. The effect
\ ** is to clear the bits at addr that are set in x.
  bic!
;

: false=        \ n1 -- flag
( *G Perform a logical NOT on the top stack item.                       )
  0=
;


\ ======================================================================
( *> kerneldf                                                          )
( *S Stack manipulations                                               )
\ ======================================================================
( *P The following words manipulate items on the data and return stacks )

: NOOP          \ --
\ *G A NOOP, null instruction.
;

: NIP           \ x1 x2 -- x2                                   6.2.1930
( *G Dispose of the second item on the data stack.                     )
  nip
;

: TUCK          \ x1 x2 -- x2 x1 x2                             6.2.2300
( *G Insert a copy of the top data stack item underneath the current   )
( ** second item.                                                      )
  tuck
;

: PICK          \ xu .. x0 u -- xu .. x0 xu                     6.2.2030
\ *G Get a copy of the Nth data stack item and place on top of stack.
\ ** *\fo{0 PICK} is equivalent to *\fo{DUP}.
  pick
;

: RPICK         \ n -- a
( *G Get a copy of the Nth return stack item and place on top of stack. )
  1+ rpick
;

: ROLL          \ nn..n0 n -- nn-1..n0 nn                       6.2.2150
\ *G Rotate the order of the top N stack items by one place such
\ ** that the current top of stack becomes the second item and
\ ** the Nth item becomes TOS. See also *\fo{ROT}.
  >R R@ PICK
  SP@ DUP CELL+   R> 1+ CELLS CMOVE>  DROP
;

(( from Andrew on clf - very neat
: pick   ?dup if  swap >r  1- recurse  r> swap  else  dup  then ;
: roll   ?dup if  swap >r  1- recurse  r> swap  then ;
: pick   dup if  swap >r  1- recurse  r> swap  else  drop dup  then ;
))

[undefined] nrev [if]
: nrev          \ xN...x1 count -- x1....xN
  doNrev
;
[then]

: nDrop         \ XN..X1 N -- xn..x2
( *G Drop N items from the data stack.                                 )
  1+ cells SP@ + SP!
;

: ROT           \ n1 n2 n3 -- n2 n3 n1                          6.1.2160
\ *G ROTate the positions of the top three stack items such that
\ ** the current top of stack becomes the second item. See also
\ ** *\fo{ROLL}.
  rot
;

: -ROT          \ n1 n2 n3 -- n3 n1 n2
\ *G The inverse of *\fo{ROT}.
  -rot
;

: >R            \ x -- ; R: -- x                                6.1.0580
\ *G Push the current top item of the data stack onto the top of the
\ ** return stack.
  r> swap >r >r
;

: R>            \ -- x ; R: x --                                6.1.2060
\ *G Pop the top item off the return stack and place on the data stack.
  r> r> swap >r
;

: R@            \ -- x                                          6.1.2070
\ *G Copy the top item of the return stack and place on the data stack.
  r> r@ swap >r
;

: 2>R           \ x1 x2 -- ; R: -- x1 x2                        6.2.0340
( *G Transfer the two top data stack items to the return stack.        )
  r> -rot 2>r >r
;

: 2R>           \ -- x1 x2 ; R: x1 x2 --                        6.2.0410
( *G Transfer the top two return stack items to the data stack.        )
  r> 2r> rot >r
;

: 2R@           \ -- x1 x2 ; R: x1 x2 -- x1 x2                  6.2.0415
( *G Copy the top two return stack items to the data stack.            )
  r> 2r@ rot >r
;

: N>R           \ xn .. x1 N -- ; R: -- x1 .. xn n
( *G Transfer N items and count to the return stack.                   )
  dup                   \ xn .. x1 N N --
  begin
    dup
  while
    rot r> swap >r >r   \ xn .. N N -- ; R: .. x1 --
    1-                  \ xn .. N 'N -- ; R: .. x1 --
  repeat
  drop                  \ N -- ; R: x1 .. xn --
  r> swap >r >r
;

: NR>           \ -- xn .. x1 N ; R: x1 .. xn N --
( *G Pull N items and count off the return stack.                       )
  r> r> swap >r dup
  begin
    dup
  while
    r> r> swap >r -rot
    1-
  repeat
  drop
;

: DROP          \ x --                                          6.1.1260
( *G Lose the top data stack item and promote NOS to TOS.              )
  drop
;

: 2DROP         \ x1 x2 --                                      6.1.1290
( *G Discard the top two data stack items.                             )
  drop drop
;

: 3drop         \ x1 x2 x3 --
\ *G Discard the top three data stack items.
  drop drop drop
;

: 4drop         \ x1 x2 x3 x4 --
\ *G Discard the top four data stack items.
  drop drop drop drop
;

: SWAP          \ x1 x2 -- x2 x1                                6.1.2260
( *G Exchange the top two data stack items.                            )
  swap
;

: 2SWAP         \ x1 x2 x3 x4 -- x3 x4 x1 x2                    6.1.0430
( *G Exchange the top two cell-pairs on the data stack.                )
  2swap
;

: DUP           \ x -- x x                                      6.1.1290
\ *G Duplicate the top stack item.
  dup
;

: ?DUP          \ x --  0 | x x                                 6.1.0630
\ *G *\fo{DUP}licate the top stack item only if it is non-zero.
  ?dup
;

: 2rot          \ 1 2 3 4 5 6 -- 3 4 5 6 1 2                   8.6.2.0420
\ *G Perform *\fo{ROT} operation on 3 double numbers.
  2>r 2swap             \ 3 4 1 2 -- ; R: 5 6 --
  2r> 2swap
;

: 2DUP          \ x1 x2 -- x1 x2 x1 x2                          6.1.0380
\ *G *\fo{DUP}licate the top cell-pair on the data stack.
  2dup
;

: 3dup          \ x1 x2 x3 -- x1 x2 x3 x1 x2 x3
\ *G *\fo{DUP}licate the top three items on the data stack.
  2 pick  2 pick  2 pick
;

: 4dup          \ x1 x2 x3 x4 -- x1 x2 x3 x4 x1 x2 x3 x4
\ *G *\fo{DUP}licate the top 4 data stack items.
  2over 2over
;

: OVER          \ x1 x2 -- x1 x2 x1                             6.1.1990
( *G Copy NOS to a new top-of-stack item.                              )
  over
;

: 2OVER         \ x1 x2 x3 x4 -- x1 x2 x3 x4 x1 x2              6.1.0400
\ *G Similar to *\fo{OVER} but works with cell-pairs rather than
\ ** cell items.
  2over
;

: UP@           \ -- up
( *G Get the current address value of the user-area pointer.           )
  up@
;

: UP!           \ up --
( *G Set the current address value of the user-area pointer.           )
  up!
;

: SP@           \ -- n
( *G Get the current address value of the data-stack pointer.          )
  sp@
;

: SP!           \ n --
( *G Set the current address value of the data-stack pointer.          )
  sp!
;

: RP@           \ -- m
( *G Get the current address value of the return-stack pointer.        )
  rp@                           \ get stack pointer (inline-def)
  cell+                         \ add 1 item ('cos I'm in a subroutine)
;
comp: doCall, discard-sinline  ;

: RP!           \ m --
( *G Set the current address value of the return-stack pointer.        )
  r> swap rp! >r
;
comp: doCall, discard-sinline  ;

: DEPTH         \ -- +n                                         6.1.1200
( *G Return the number of items on the data stack, excluding the count. )
  s0 @ sp@ - cell- cell /
;

: RDEPTH        \ -- +n
( *G Return the number of items on the return stack.                   )
  r0 @ rp@ - 4- 4/
;

: min           \ n1 n2 -- n1|n2                                6.1.1880
\ *G Given two data stack items preserve only the smallest.
  min
;

: MAX           \ n1 n2 -- n1|n2                                6.1.1870
\ *G Given two data stack items preserve only the largest.
  max
;

\ SFP041...
[undefined] umin [if]
: umin           \ n1 n2 -- n1|n2
\ *G Given two data stack items preserve only the smallest.
  umin
;
[then]

[undefined] umax [if]
: umax           \ n1 n2 -- n1|n2
\ *G Given two data stack items preserve only the largest.
  umax
;
[then]
\ ...SFP041

: LOWORD        \ n -- n16
( *G Mask off the low 16 bits of a cell.                               )
  $FFFF and
;

64bit? [if]
: HIWORD        \ n -- n16
( *G Mask off the high 16 bits of a cell and shift right by 16 bits.   )
  #16 rshift  $FFFF and
;
[else]
: HIWORD        \ n -- n16
  #16 rshift  ( $FFFF and )
;
[then]

: MAKELONG      \ lo hi -- 32bit
\ *G Given two 16 bit numbers produce a single 32 bit one.
  #16 lshift  swap $FFFF and  or
;

64bit? [if]
: nslWiden      \ ... n --
\ *G Sign extend from 32 bits to cell width on Nth stack item.
  nslWiden
;
[then]

: nswWiden      \ ... n --
\ *G Sign extend from 16 bits to cell width on Nth stack item.
  nswWiden
;

: nsbWiden      \ ... n --
\ *G Signed extend from 8 bits to cell width on Nth stack item.
  nsbWiden
;

64bit? [if]
: nulWiden      \ ... n --
\ *G Zero extend from 32 bits to cell width on Nth stack item.
  nulWiden
;
[then]

: nuwWiden      \ ... n --
\ *G Zero extend from 16 bits to cell width on Nth stack item.
  nuwWiden
;

: nubWiden      \ ... n --
\ *G Zero extend from 8 bits to cell width on Nth stack item.
  nubWiden
;


\ ======================================================================
( *> kerneldf                                                          )
( *S Comparisons                                                       )
\ ======================================================================
( *P Various words to compare stack items and return flags.            )

: 0=            \ n -- t/f                                       6.1.0270
( *G Compare the top stack item with 0 and return TRUE if equals.       )
  0=
;

: 0<>           \ n -- t/f                                       6.2.0260
( *G Compare the top stack item with 0 and return TRUE if not-equal.    )
  0<>
;

: 0<            \ n -- t/f                                       6.1.0250
( *G Return TRUE if the top of stack is less-than-zero.                 )
  0<
;

: 0>            \ n -- t/f                                       6.2.0280
( *G Return TRUE if the top of stack is greater-than-zero.              )
  0>
;

: =             \ n1 n2 -- t/f                                   6.1.0530
( *G Return TRUE if the two topmost stack items are equal.              )
  =
;

: <>            \ n1 n2 -- t/f                                   6.2.0500
( *G Return TRUE if the two topmost stack items are different.          )
  <>
;

: <             \ n1 n2 -- t/f                                   6.1.0480
( *G Return TRUE if the second stack item is less than the topmost.     )
  <
;

: >             \ n1 n2 -- t/f                                   6.1.0540
( *G Return TRUE if the second stack item is greater than the topmost.  )
  >
;

: <=            \ n1 n2 -- t/f
( *G Return TRUE if the second stack item is less than or equal to      )
( ** the topmost.                                                       )
  <=
;

: >=            \ n1 n2 -- t/f
( *G Return TRUE if the second stack item is greater than or equal to   )
( ** the topmost.                                                       )
  >=
;

: U>            \ n1 n2 -- t/f                                   6.2.2350
\ *G An UNSIGNED version of *\fo{>}.
  u>
;

: U<            \ n1 n2 -- t/f                                   6.1.2340
\ *G An UNSIGNED version of *\fo{<}.
  u<
;

: U>=           \ n1 n2 -- t/f
\ *G An UNSIGNED version of *\fo{>=}.
  u>=
;

: U<=           \ n1 n2 -- t/f
\ *G An UNSIGNED version of *\fo{<=}.
  u<=
;

: WITHIN?       \ n1 n2 n3 -- flag
\ *G Return TRUE if N1 is within the range N2..N3.
\ ** This word uses signed arithmetic.
  mpeWITHIN?
;

: WITHIN        \ n1|u1 n2|u2 n3|u3 -- flag                      6.2.2440
\ *G Return TRUE if  n2|u2 <= n1|u1 < n3
\ ** The ANS version of *\fo{WITHIN?}. Note the conditions
\ ** This word uses unsigned arithmetic, so that signed compares
\ ** are  treated as existing on a number circle.
  ansWITHIN
;

: D0<           \ d -- flag                                   8.6.1.1075
\ *G Return true if *\i{d} is less than zero (is negative).
  nip 0<
;

: D0=           \ d -- flag                                   8.6.1.1080
\ *G Return true if *\i{d} is zero.
  or 0=
;

: D0<>		\ d -- flag
\ *G Return true if *\i{d} is non-zero.
  or 0<>
;

: d=            \ d1 d2 -- flag                                8.6.1.1080
\ *G Return true if the two double numbers are equal.
  d- or 0=
;

: d<            \ d1 d2 -- flag                                8.6.1.1110
\ *G Return TRUE if the double number d1 is less than the double number d2.
\  d- nip 0<
  d- 0< nip		\ prevents optimiser issues to discard (d1-d2)l later
;

: d>            \ d1 d2 -- flag
\ *G Return TRUE if the double number d1 is greater than the double number d2.
\  2swap d- nip 0<			\ SFP033
  2swap d- 0< nip	\ prevents optimiser issues to discard (d2-d1)l later
;

: dmax          \ d1 d2 -- d1|d2                               8.6.1.1210
\ *G Return the maximum double number from the two supplied.
  2over 2over d- 0< if	\ prevents optimiser issues to discard (d1-d2)l later
    drop  2swap 2drop  exit			\ EXIT avoids two shuffles
  then
  drop  2drop
;

: dmin          \ d1 d2 -- d1|d2                               8.6.1.1220
\ *G Return the minimum double number from the two supplied.
  2over 2over 2swap d- 0< if		\ test d2<d1 ; SFP053
    drop  2swap 2drop  exit		\ EXIT avoids two shuffles
  then
  drop  2drop
;

[undefined] DU< [if]
: DU<		\ ud1 ud2 -- flag
\ *G True if ud1<ud2.
  ROT SWAP 2DUP U< IF
    4DROP True
  ELSE
    <>
    IF  2DROP False  ELSE  U<  THEN
  THEN
;
[then]

[undefined] DU> [if]
: DU>		\ ud1 ud2 -- flag
\ *G True if ud1>ud2.
  2swap du<
;
[then]

\ : dwithin ( n limit1 limit2+1 -- f ) 2over d- 2>r d- 2r> du< ;


\ ***********
\ *> kerneldf
\ *S Arithmetic Operators.
\ ***********

\ =========
\ *N Shifts
\ =========

: LSHIFT        \ x1 u -- x2                                     6.1.1805
\ *G Logically shift X1 by U bits left.
\ ** The result of shifting by more than 31 bits is undefined.
  lshift
;

: RSHIFT        \ x1 u -- x2                                     6.1.2162
\ *G Logically shift X1 by U bits right.
\ ** The result of shifting by more than 31 bits is undefined.
  rshift
;

: arshift	\ x1 u -- x2
\ *G Shift x1 right by u bits, filling with the previous top
\ ** bit. An arithmetic right shift.
\ ** The result of shifting by more than 31 bits is undefined.
  arshift
;

: ROL           \ x1 u -- x2
\ *G Logically rotate X1 by U bits left.
\ ** The result of shifting by more than 31 bits is undefined.
  rol
;

: ROR           \ x1 u -- x2
\ *G Logically rotate X1 by U bits right.
\ ** The result of shifting by more than 31 bits is undefined.
  ror
;


\ =================
\ *N Multiplication
\ =================

: *             \ n1 n2 -- n3                                    6.1.0090
\ *G Standard signed multiply. N3 = n1 * n2.
  *
;

[undefined] m* [if]
: M*            \ n1 n2 -- d                                     6.1.1810
\ *G Signed multiply yielding double result.
  M*
;
[then]

[undefined] um* [if]
: UM*           \ u1 u2 -- ud                                    6.1.2360
\ *G Perform unsigned-multiply between two numbers and return double
\ ** result.
  UM*
;
[then]

: D2*           \ d1 -- d1*2                                   8.6.1.1090
( *G Multiply the given double number by two.                           )
  _D2*
;


\ ===========
\ *N Division
\ ===========
\ *P The ANS specification contains a discussion of symmetric
\ ** and floored division.

\ *P Division produces a quotient q and a remainder r by dividing
\ ** operand a by operand b. Division operations return q, r, or
\ ** both. The identity
\ *C   b*q + r = a
\ *P shall hold for all a and b.

\ *P When unsigned integers are divided and the remainder is not
\ ** zero, q is the largest integer less than the true quotient.

\ *P When signed integers are divided, the remainder is not zero,
\ ** and a and b have the same sign, q is the largest integer
\ ** less than the true quotient. If only one operand is negative,
\ ** whether q is rounded toward negative infinity (floored division)
\ ** or rounded towards zero (symmetric division) is implementation
\ ** defined.

\ *P Floored division is integer division in which the remainder
\ ** carries the sign of the divisor or is zero, and the quotient
\ ** is rounded to its arithmetic floor. Symmetric division is
\ ** integer division in which the remainder carries the sign of
\ ** the dividend or is zero and the quotient is the mathematical
\ ** quotient rounded towards zero or truncated. Examples of each
\ ** are shown in the tables below.

\ *E Floored Division Example
\ **
\ ** Dividend        Divisor Remainder       Quotient
\ ** --------        ------- ---------       --------
\ ** 10                 7       3                1
\ ** -10                7       4               -2
\ ** 10                -7      -4               -2
\ ** -10               -7      -3                1

\ *E Symmetric Division Example
\ ** Dividend        Divisor Remainder       Quotient
\ ** --------        ------- ---------       --------
\ ** 10                 7       3                1
\ ** -10                7      -3               -1
\ ** 10                -7       3               -1
\ ** -10               -7      -3                1

\ *P Unless otherwise noted or specified, VFX Forth uses
\ ** symmetric division.

[undefined] um/mod [if]
: UM/MOD        \ ud u -- urem uquot                             6.1.2370
\ *G Perform unsigned division of double number UD by single number U
\ ** and return remainder and quotient.
  UM/MOD
;
[then]

(( for DOCGEN
: SM/REM	\ d1 n1 -- n2 n3 				6.1.2214
\ *G Divide d1 by n1, giving the symmetric quotient n3 and the
\ ** remainder n2. Input and output stack arguments are signed.
\ ** An ambiguous condition exists if n1 is zero or if the
\ ** quotient lies outside the range of a single-cell signed integer.
  sm/rem
;

: FM/MOD	\ d1 n1 -- n2 n3				6.1.1561
\ *G Divide d1 by n1, giving the floored quotient n3 and the
\ ** remainder n2. Input and output stack arguments are signed.
\ ** An ambiguous condition exists if n1 is zero or if the
\ ** quotient lies outside the range of a single-cell signed integer.
  fm/mod
;
))

: MU/MOD        \ ud1 u2 -- urem ud#quot
( *G Perform an unsigned divide of a double by a single, returning	)
( ** a single remainder and a double quotient.				)
  >r  0 r@ um/mod  r>  swap >r um/mod r>
;

[undefined] /mod [if]
: /MOD          \ n1 n2 -- rem quot                              6.1.0240
\ *G Signed division of N1 by N2 (single-precision) yielding remainder
\ ** and quotient.
  /MOD
;
[then]

[undefined] / [if]
: /             \ n1 n2 -- n3                                    6.1.0230
\ *G Standard signed division operator. n3 = n1/n2.
\  /mod nip
  /
;
[then]

: u/            \ u1 u2 -- u3
\ *G Unsigned division operator. U3 = u1/u2.
  0 swap um/mod nip
;

[undefined] mod [if]
: MOD           \ n1 n2 -- n3                                    6.1.1890
\ *G Return remainder of division of N1 by N2. n3 = n1 mod n2.
  MOD
;
[then]

[undefined] M/ [if]
: M/            \ d n1 -- n2
\ *G Signed divide of a double by a single integer.
  sm/rem nip
;
[then]

: D2/           \ d1 -- d1/2                                   8.6.1.1100
\ *G Divide the given double number by two. Signed and implemented
\ ** as an arithmetic right shift, and so produces floored dividion.
  _D2/
;


\ ===============================
\ *N Combined multiply and divide
\ ===============================
\ *P These words provide combined multiply and divide operations
\ ** with extended precision intermediate results. The point is to
\ ** prevent overflow during integer scaling operations.

[undefined] */MOD [if]
: */MOD         \ n1 n2 n3 -- rem quot                          6.1.0110
\ *G Multiply n1 by n2 to give a double precision result, and then
\ ** divide it by n3 returning the remainder and quotient. The point
\ ** of this operation is to avoid loss of precision.
  >r m* r> sm/rem
;
[then]

[undefined] */ [if]
: */            \ n1 n2 n3 -- n4                                6.1.0100
\ *G Multiply n1 by n2 to give a double precision result, and then
\ ** divide it by n3 returning the quotient. The point
\ ** of this operation is to avoid loss of precision.
  */mod nip
;
[then]

[undefined] m*/ [if]
: m*/		\ d1 n2 +n3 -- dquot
\ *G The result dquot=(d1*n2)/n3. The intermediate value d1*n2
\ ** is triple-precision. In an ANS Forth standard program n3
\ ** can only be a positive signed number and a negative value
\ ** for n3 generates an ambiguous condition, which may cause
\ ** an error on other implementations.
  >r					\ -- d1 n2 ; R: -- n3
  s>d >r abs				\ -- d1 |n2| ; R: -- n3 sign(n2)
  -rot					\ -- |n2| d1 ; R: -- n3 sign(n2)
  s>d r> xor				\ -- |n2| d1 d1h*sign(n2) ; R: -- n3
  r> swap >r >r				\ -- |n2| d1 ; R: -- d1h*sign(n2) n3
  dabs rot				\ -- |d1| |n2| ; R: -- d1h*sign(n2) n3
  tuck um* 2swap um*			\ -- d1h*n2 d1l*n2 ; R: -- d1h*sign(n2) n3
  swap >r  0 d+ r> -rot			\ -- t ; R: -- d1h*sign(n2) n3
  r@ um/mod -rot r> um/mod nip swap
  r> IF dnegate THEN
((
\ replace last two lines for floored version:
  r@ um/mod -rot r> um/mod -rot
  r> IF
   IF  1. d+  THEN
   dnegate
  ELSE
    drop
  THEN
))
;
[then]


\ ==========================
\ *N Traditional short forms
\ ==========================

: 1+            \ n1|u1 -- n2|u2                                 6.1.0290
( *G Add one to top-of stack.                                           )
  1 +
;

: 2+            \ n1|u1 -- n2|u2
( *G Add two to top-of stack.                                           )
  2 +
;

: 4+            \ n1|u1 -- n2|u2
( *G Add four to top-of stack.                                          )
  4 +
;

: 1-            \ n1|u1 -- n2|u2                                 6.1.0300
( *G Subtract one from top-of stack.                                    )
  1 -
;

: 2-            \ n1|u1 -- n2|u2
( *G Subtract two from top-of stack.                                    )
  2 -
;

: 4-            \ n1|u1 -- n2|u2
( *G Subtract four from top-of stack.                                   )
  4 -
;

: 2*            \ x1 -- x2                                       6.1.0320
( *G Signed multiply top of stack by 2.                                 )
  2*
;

: 4*            \ x1 -- x2
\ *G Signed multiply top of stack by 4.
  4*
;
64bit? [if]
: 8*            \ x1 -- x2
\ *G Signed multiply top of stack by 8. In 64 bit systems only.
  8*
;
[then]

: 2/            \ x1 -- x2                                       6.1.0330
\ *G Right shift x1 one bit, sign preserved. From build 1276
\ ** onwards, this is an ANS compliant signed right shift.
\ ** For an unsigned result, use *\fo{U2/} or *\fo{1 RSHIFT}.
  1 arshift
;

: U2/           \ x1 -- x2
\ *G Unsigned divide top of stack by 2.
  1 rshift
;

: 4/            \ x1 -- x2
\ *G Right shift x1 two bits, sign preserved. From build 1276
\ ** onwards, this is an ANS compliant signed right shift.
\ ** For an unsigned result, use *\fo{U4/} below or *\fo{2 RSHIFT}.
  2 arshift
;

: u4/           \ x1 -- x2
\ *G Unsigned divide top of stack by 4.
  2 rshift
;
64bit? [if]
: 8/            \ x1 -- x2
\ *G Right shift x1 three bits, sign preserved
\ ** For an unsigned result, use *\fo{U8/} below or *\fo{3 RSHIFT}.
  3 arshift
;

: u8/           \ x1 -- x2
\ *G Unsigned divide top of stack by 8.
  3 rshift
;
[then]

\ ===========================
\ *N Addition and subtraction
\ ===========================

: +             \ n1|u1 n2|u2 -- n3|u3                           6.1.0120
( *G Add two single precision integer numbers.                          )
  +
;

: -             \ n1|u1 n2|u2 -- n3|u3                           6.1.0160
( *G Subtract two single precision integer numbers.                     )
  -
;

: D+            \ d1 d2 -- d3                                  8.6.1.1040
( *G Add two double precision integers together.                        )
  D+                            \ SFP001
;

: D-            \ d1 d2 -- d3                                  8.6.1.1050
\ *G Subtract two double precision integers. D3=D1-D2.
  D-                            \ SFP001
;

: M+            \ d1 n -- d2                                   8.6.1.1830
( *G Add double d1 to sign extended single n to form double d2.		)
  s>d d+                        \ SFP001
;


\ ==========================
\ *N Negation and absolution
\ ==========================

: NEGATE        \ n1 -- n2                                       6.1.1910
\ *G Negate a single precision integer number.
  negate
;

: ?NEGATE       \ n1 flag -- n1|n2
\ *G If flag is negative, then negate n1.
  0< if negate then
;

: ABS           \ n -- u                                         6.1.0690
\ *G If n is negative, return its positive equivalent (absolute value).
  abs
;

: DNEGATE       \ d -- -d                                     8.6.1.1230
( *G Negate a double number.						)
  0 0 2swap d-
\  _DNEGATE
;

: ?dnegate      \ d n -- d'
( *G If n is negative, negate the double number d.			)
  0< if dnegate then			\ SFP006
;

: DABS          \ d -- |d|                                     8.6.1.1160
\ *G Double precision version of *\fo{ABS}.
  dup 0< if dnegate then
;


\ ===============================================
\ *N Converting between single and double numbers
\ ===============================================

: S>D           \ n -- d                                         6.1.2170
( *G Convert a single number to a double one.                           )
\  0 over 0< if 1- then          \ better on 386
\ dup 0<                        \ for everything else
  s>d
;

: D>S           \ d -- n                                       8.6.1.1140
( *G Convert a Double number to a single.                               )
  drop
;


\ ===================
\ *N Portability aids
\ ===================
\ *P These words make porting code between 16, 32, and 64 bit
\ ** systems much easier. They avoid the use of heritage
\ ** shortforms such as 2+ and 4+ which are dependent on the
\ ** size of items on the data stack and in memory.

: CELL+         \ a-addr1 -- a-addr2                             6.1.0880
\ *G Add size of a cell to the top-of stack.
  cell +
;

: CELLS         \ n1 -- n2                                       6.1.0890
\ *G Return size in address units of N1 cells in memory.
  cells
;

: CELL/         \ n1 -- n2
\ *G Divide top stack item by the size of a cell.
  cell /
;

: CELLS+        \ n1 n2 -- n3
\ *G Modify address 'n1' by the size of 'n2' cells.
  cells +
;

: CELL-         \ a-addr1 -- a-addr2
\ *G Decrement an address by the size of a cell.
  cell -
;

: CELL          \ -- n
\ *G Return the size in address units of one cell.
  cell
;

: CHAR+         \ c-addr1 -- c-addr2                             6.1.0897
\ *G Increment an address by the size of a character.
  1+
;

: CHARS         \ n1 -- n2                                       6.1.0898
\ *G Return size in address units of N1 characters.
; immediate

: cellbits	\ -- u
\ *G Count the number of bits in a cell - relies on 2s
\ ** complement arithmetic. Useful when porting code
\ ** between 16, 32 and 64 systems. Note that this is
\ ** not a constant; the calculation is made at each use.
  0 -1 begin				\ count mask --
    dup
   while
    swap 1+ swap
    1 lshift
  repeat
  drop
;


\ =================================
\ *S Dictionary Memory Manipulation
\ =================================
\ *P The following definitions provide the primitives for
\ ** manipulation of dictionary memory.

[defined] <dp> [if]
<dp> constant DP
[else]
variable DP	\ -- addr
\ *G Holds the address of the next free location in the dictionary.
[then]

compiler
: HERE          \ -- addr
  dp @
;

: ALLOT         \ n --
  dp +!
;

: ALIGNED       \ addr -- a-addr
  cell 1- +
  cell negate and
;
target

: HERE          \ -- addr                                        6.1.1650
( *G Return the current dictionary pointer which is the first           )
( ** address-unit of free space within the system.                      )
  dp @
;

: ALLOT         \ n --                                           6.1.0710
\ *G Allocate N address-units of data space from the current value of
\ ** *\fo{HERE} and move the pointer.
  dp +!
;

: ALLOT&ERASE   \ n --
( *G Allot n bytes of dictionary space and fill with Zero.            )
  here swap dup allot erase
;

: ,             \ x --                                           6.1.0150
\ *G Place the CELL value X into the dictionary at *\fo{HERE} and
\ ** increment the pointer.
  dp @ tuck !  cell +  dp !
;

64bit? [if]
: L,             \ x --                                           6.1.0150
\ *G Place the 32 bit value X into the dictionary at *\fo{HERE} and
\ ** increment the pointer.
  dp @ tuck l!  4 +  dp !
;
[then]

: W,            \ x --
\ *G Place the WORD value X into the dictionary at *\fo{HERE} and
\ ** increment the pointer.
\  here w!  2 allot
  dp @ tuck w!  2 +  dp !
;

: C,            \ x --                                           6.1.0860
\ *G Place the CHAR value X into the dictionary at *\fo{HERE} and
\ ** increment the pointer.
\  here c!  1 allot
  dp @ tuck c!  1+  dp !
;

: ALIGNED       \ addr -- a-addr                                 6.1.0706
\ *G Given an address pointer this word will return the next
\ ** *\fo{ALIGNED} address subject to system wide alignment
\ ** restrictions.
  cell 1- +
  0 cell -
  and
;

: HALF-ALIGNED  \ addr -- a-addr
\ *G Align an address pointer to within half the size of a CELL.
  1+
  0 cell 2/ -
  and
;

: ALIGN         \ --                                             6.1.0705
\ *G Align dictionary pointer using the same rules as
\ ** *\fo{ALIGNED}. Unused dictionary space is *\fo{ERASE}d.
  dp @ dup aligned dup dp !		\ -- here1 here2
  over - erase
\  here
\  here aligned dp !
\  here over - erase
;

: HALF-ALIGN    \ --
\ *G Align the dicionary pointer to a half-cell boundary. Unused
\ ** dictionary space is *\fo{ERASE}d.                                                           )
  here
  here half-aligned dp !
  here over - erase
;

(( \ has no impact on benchmarks, try in Xcompiler next.
#16 value XtAlignment	\ -- n
\ The required alignment of Xts. Must be a power of 2

: XT-ALIGN    \ --
\ ALIGN XT filling with breakpoints (used for code boundaries).
  here
  XtAlignment tuck 1- +  swap negate and
  here
  ?do  $CC c,  loop	\ $CC is the i32 INT 3 opcode
;
))


\ =======================================================================
( *S Branch and flow control                                            )
( **                                                                    )
( *P The following definitions allow for a variety of loops and         )
( ** conditional execution contructs.                                   )
\ =======================================================================

: >MARK         \ -- a-addr
  here  0 ,
;

: >RESOLVE      \ a-addr --
  here swap !
;

: <MARK         \ -- addr
  here
;

: <RESOLVE      \ a-addr --
  ,
;

: ?PAIRS        \ x1 x1 --
  - #-22 ?throw
;

: NoInterp	\ --
  #-14 throw
;

: ?CHECKING     \ -- flag
  checking @
;
compiler
: ?CHECKING     \ -- flag
  checking @
;
target

: branch        \ --
  r> @ >r
;

: ?branch       \ n --
  r> swap if
    cell+
  else
    @
  then
  >r
;

: (OF)          \ n1 n2 -- n1|
  2dup - if
    drop
    r> @ >r
  else
    2drop
    r> cell+ >r
  then
;

: (leave)       \ -- ; R: laddress limit index --
  r> drop               \ discard ret address
  2r> 2drop             \ discard limit and index
                        \ leaves LADDRESS as my return.
;

: (?leave)      \ flag --
  if
    r> drop  2r> 2drop
  then
;

[undefined] (LOOP) [if]
: (LOOP)        \ -- ; SFP061
\ ESP+8:  exit address
\ ESP+4:  index-limit-$8000.0000  (incremented by LOOP)
\ ESP+0:  index                   (incremented by LOOP)
  r> r> r>			\ -- exit index limit
  swap 1+ swap 1+		\ -- exit index' limit'
  dup $8000:0000 <> if		\ no limit overflow?
    >r >r			\ restore index and limit
    @ >r			\ get loop head address
  else
    2drop  r> drop		\ discard index, limit, leave address
    cell + >r			\ step over head address
  endif
;
[then]

[undefined] (+LOOP) [IF]
cr ." *** COMPILING SUSPECT (+LOOP) IN HIGH LEVEL KERNEL ***"
: (+LOOP)       \ step -- ; SFP061
\ ESP+8:  exit address
\ ESP+4:  index-limit-$8000.0000  (incremented by LOOP)
\ ESP+0:  index                   (incremented by LOOP)
  r> r> rot r> over		\ -- exit index step limit step
  2swap + -rot +		\ -- exit i+s l+s
  dup $8000:0000 and 0= if
    >r >r			\ restore index and limit
    @ >r			\ get loop head address
  else
    2drop  r> drop		\ discard index, limit, leave address
    cell + >r			\ step over head address
  endif
;
[THEN]

[undefined] (do) [if]
: (DO)          \ limit index -- ; SFP061
\ ESP+8:  exit address
\ ESP+4:  index-limit-$8000.0000  (incremented by LOOP)
\ ESP+0:  index                   (incremented by LOOP)
  r@ cell+ -rot         	\ def-exit limit index --
  r> @ >r			\ def-exit limit index -- ; R: leave --
  tuck swap - $8000:0000 - >r	\ def-exit index -- ; R: leave i-l-topbit
  >r				\ def-exit -- ; R: leave i-l-topbit index
  >r
;
[then]

[undefined] (?do) [if]
: (?DO)         \ limit index -- ; SFP061
  2dup <> if
    r@ cell+ -rot         	\ def-exit limit index --
    r> @ >r			\ def-exit limit index -- ; R: leave --
    tuck swap - $8000:0000 - >r	\ def-exit index -- ; R: leave i-l-topbit
    >r				\ def-exit -- ; R: leave i-l-topbit index
    >r
  else
    2drop  r> @ >r
  then
;
[then]

[undefined] i [if]
: I             \ -- n                                          6.1.1680
\ *G Return the current index of the inner-most *\fo{DO ... LOOP}.
  1 rpick				\ SFP061
;
[then]

[undefined] j [if]
: J             \ -- n                                          6.1.1730
\ *G Return the current index of the second *\fo{DO ... LOOP}.
  4 rpick				\ SFP061
;
[then]

[undefined] unloop [if]
: unloop        \ -- ; R: loop-sys --                           6.1.2380
\ *G Remove the *\fo{DO ... LOOP} control parameters from the
\ ** return stack.
  r>
  r> drop
  r> drop
  r> drop
  >r
;
[then]

: BOUNDS        \ addr len -- addr+len addr
\ *G Modify the address and length parameters to provide an
\ ** end-address and start-address pair suitable for a
\ ** *\fo{DO ... LOOP} construct.
  over + swap
;

: EXIT          \ -- ; R: next-sys --                           6.1.1380
\ *G Compile code into the current definition to cause a definition to
\ ** terminate. This is the Forth equivalent to inserting an RTS/RET
\ ** instruction in the middle of an assembler subroutine.
  NoInterp  ;
ndcs: ( -- )  discard-sinline
  [ also system ] drop-locals [ previous ]  doexit,
;

[undefined] execute [if]
: EXECUTE       \ xt --                                         6.1.1370
( *G Execute the code described by the XT. This is a Forth equivalent   )
( ** of an assembler JSR/CALL instruction.                              )
  >r
;
[then]

: perform	\ addr --
\ *G *\fo{EXECUTE} contents of addr if non-zero.
  @ ?dup
  if  execute  endif
;


\ ***********************
\ DO ... LOOP and friends
\ ***********************

defer s_do,     \ -- ; compile code for DO ; SFP001

: (s_do,)       \ -- ; compile code for DO ; SFP001
  compile (do) >mark <mark
;

: DO            \ Run: n1|u1 n2|u2 -- ; R: -- loop-sys           6.1.1240
\ *G Begin a *\fo{DO ... LOOP} construct. Takes the end-value and
\ ** start-value from the stack.
  NoInterp  ;
ndcs: ( -- )  s_do,  3  ;

defer s_?do,    \ -- dosys' ; compile code for ?DO ; SFP001

: (s_?do,)      \ -- dosys' ; compile code for ?DO ; SFP001
  compile (?do) >mark <mark
;

: ?DO           \ Run: n1|u1 n2|u2 -- ; R: -- | loop-sys         6.2.0620
\ *G Compile a *\fo{DO} which will only begin loop execution if
\ ** the loop parameters do not specify an interation count of 0.
  NoInterp  ;
ndcs: ( -- )  s_?do,  3  ;

defer s_loop,   \ dosys' -- ; SFP001

: (s_loop,)     \ dosys' -- ; SFP001
  compile (loop) <resolve >resolve
;

: LOOP          \ Run: -- ; R: loop-sys1 -- | loop-sys2         6.1.1800
\ *G The closing statement of a *\fo{DO ... LOOP} construct.
\ ** Increments the index and terminates when the index crosses
\ ** the limit.
  NoInterp  ;
ndcs:  ( -- )  3 ?pairs  s_loop,  ;

defer s_+loop,  \ dosys' -- ; SFP001

: (s_+loop,)    \ dosys' -- ; SFP001
  compile (+loop) <resolve >resolve
;

: +LOOP         \ Run: n -- ; R: loop-sys1 -- | loop-sys2       6.1.0140
\ *G As *\fo{LOOP} except that you specify the increment on the
\ ** stack. The action of *\fo{n +LOOP} is peculiar when n is
\ ** negative:
\ *C   -1 0 ?DO  i .  -1 +LOOP
\ *P prints *\fo{0 -1}, whereas:
\ *C   0 0 ?DO  i .  -1 +LOOP
\ *P prints nothing. This a result of the mathematical trick used
\ ** to detect the terminating condition. To prevent confusion
\ ** avoid using *\fo{n +LOOP} with negative *\i{n}.
  NoInterp  ;
ndcs:  ( -- )  3 ?pairs  s_+loop,  ;

defer s_leave,  \ -- ; SFP001

: (s_leave,)    \ -- ; SFP001
  compile (leave)
;

: LEAVE         \ -- ; R: loop-sys --                           6.1.1760
\ *G Compile code to exit a *\fo{DO ... LOOP}. Similar to 'C'
\ ** language *\f{break}.
  NoInterp  ;
ndcs:  ( -- )  s_leave,  ;

defer s_?leave, \ -- ; SFP001

: (s_?leave,)   \ -- ; SFP001
  compile (?leave)
;

: ?LEAVE        \ flag -- ; R: loop-sys --
\ *G A version of *\fo{LEAVE} which only takes effect if the
\ ** given flag is non-zero.
  NoInterp  ;
ndcs:  ( -- )  s_?leave,  ;


\ *******************************************************
\ Conditional structures IF ... ELSE ... THEN and friends
\ *******************************************************

defer s_mrk_br<,	\ -- addr
defer s_br<,
defer s_?br<,

defer s_res_br>,
defer s_br>,
defer s_?br>,

: (s_mrk_br<,)
  <mark
;

: (s_br<,)	\ dest --
  compile branch <resolve
;

: (s_?br<,)	\ dest --
  compile ?branch <resolve
;

: (s_res_br>,)	\ orig -- ; SFP066
  FlushCode >resolve
;

: (s_br>,)	\ -- orig
  compile branch >mark
;

: (s_?br>,)	\ -- orig
  compile ?branch >mark
;

: BEGIN         \ C: -- dest ; Run: --                          6.1.0760
\ *G Mark the start of a *\fo{BEGIN..[WHILE]..UNTIL/AGAIN/REPEAT}
\ ** construct.
  NoInterp  ;
ndcs: ( -- )  s_mrk_br<,  ?checking if  1  then  ;

: AGAIN         \ C: dest -- ; Run: --                          6.2.0700
\ *G The end of a *\fo{BEGIN..AGAIN} construct which specifies
\ ** an infinite loop.
  NoInterp  ;
ndcs: ( -- )  ?checking if  1 ?pairs  then  s_br<,  ;

: UNTIL         \ C: dest -- ; Run: flag --                      6.1.2390
\ *G Compile code into definition which will jump back to the
\ ** matching *\fo{BEGIN} if the supplied condition flag is zero
\ ** (false).
  NoInterp  ;
ndcs: ( -- )   ?checking if  1 ?pairs  then  s_?br<,  ;

: WHILE         \ C: dest -- orig dest ; Run: flag --            6.1.2430
\ *G Separate the condition test from the loop code in a
\ ** *\fo{BEGIN ... WHILE ... REPEAT} block.
  NoInterp  ;
ndcs: ( -- )   ?checking if
    1 ?pairs  s_?br>, 6
  else
    s_?br>, swap
  then  ;

: REPEAT        \ C: orig dest -- ; Run: --                     6.1.2140
\ *G Loop back to the conditional test code in a
\ ** *\fo{BEGIN ... WHILE ... REPEAT} construct.
  NoInterp  ;
ndcs: ( -- )
  ?checking if
    6 ?pairs  swap s_br<,  s_res_br>,
  else
    s_br<,  s_res_br>,
  then
;

: IF            \ C: -- orig ; Run: x --                        6.1.1700
\ *G Mark the start of an *\fo{IF ... [ELSE] ... THEN} conditional block.
\ ** *\fo{ELSE} is optional.
  NoInterp
;
ndcs: ( -- )  s_?br>,  ?checking if  2  then  ;

: THEN          \ C: orig -- ; Run: --                          6.1.2270
\ *G Mark the end of an *\fo{IF..THEN} or *\fo{IF..ELSE..THEN}
\ ** conditional block.
  NoInterp  ;
ndcs: ( -- )  ?checking if  2 ?pairs  then  s_res_br>,  ;

: ENDIF         \ C: orig -- ; Run: --
\ *G An alias for *\fo{THEN}. Note that ANS Forth describes
\ ** *\fo{THEN} not *\fo{ENDIF}.
  NoInterp  ;
ndcs: ( -- )  ?checking if  2 ?pairs  then  s_res_br>,  ;

: AHEAD         \ C: -- orig ; Run: --                       15.6.2.0702
\ *G Start an unconditional forward branch which will be resolved later.
  NoInterp  ;
ndcs: ( -- )  s_br>,  ;

: (ELSE)        \ orig1 -- orig2
  s_br>,  swap s_res_br>,
;

: ELSE          \ C: orig1 -- orig2 ; Run: --                   6.1.1310
\ *G Begin the failure condition code for an *\fo{IF}.
  NoInterp  ;
ndcs: ( -- )  ?checking if
    2 ?pairs  (else)  2
  else
    s_br>,  swap s_res_br>,
  then  ;

: FIX-EXITS     \ orig1..orign --
  begin
    sp@ csp @ <>
  while
    s_res_br>,
  repeat
;

\ SFP025 ...
variable NextCaseTarg   \ -- addr ; holds address of CASE

: CASE          \ C: -- case-sys ; Run: --                      6.2.0873
\ *G Begin a *\fo{CASE..ENDCASE} construct. Similar to the C *\f{switch}.
  NoInterp  ;
ndcs: ( -- )  csp @  NextCaseTarg dup @ swap off  !csp  4  ;

defer s_of,	\ -- addr ; forward branch "OVER = IF DROP"

: (s_of,)	\ -- addr ; forward branch "OVER = IF DROP"
  compile (of) >mark
;

: OF            \ C: -- of-sys ; Run: x1 x2 -- | x1             6.2.1950
\ *G Begin conditional block for *\fo{CASE}, executed when the
\ ** switch value *\i{x1} is equal to *\i{x2}.
  NoInterp  ;
ndcs: ( -- )  4 ?pairs  s_of,  5  ;

defer s_?of,	\ -- addr ; forward branch "IF"

: (s_?of,)	\ -- addr ; forward branch "IF"
  compile ?branch >mark
;

: ?OF           \ C: -- of-sys ; Run: flag --
\ *G Begin conditional block for *\fo{CASE}, executed when the flag
\ ** is true.
  NoInterp  ;
ndcs: ( -- )  4 ?pairs  s_?of,  5  ;

defer s_endof,  \ orig1 -- orig2 ; uses (ELSE)

: ENDOF         \ C: case-sys1 of-sys -- case-sys2 ; Run: --    6.2.1343
\ *G Mark the end of an *\fo{OF} conditional block within a
\ ** *\fo{CASE} construct. Compile a jump past the *\fo{ENDCASE}
\ ** marker at the end of the construct.
  NoInterp  ;
ndcs: ( -- )  5 ?pairs  s_endof, 4  ;

defer s_drop,	\ --

: (s_drop,)	\ --
  compile drop
;

: ENDCASE       \ C: case-sys -- ; Run: x --                    6.2.1342
\ *G Terminate a *\fo{CASE ... ENDCASE} construct. *\fo{DROP}s the
\ ** switch value from the stack.
  NoInterp  ;
ndcs: ( -- )  4 ?pairs  s_drop,  fix-exits  NextCaseTarg !  csp !  ;

: END-CASE      \ C: case-sys -- ; Run: --
\ *G A Version of *\fo{ENDCASE} which does not drop the switch
\ ** value. Used when the switch value itself is consumed by a
\ ** default condition or another result is to be returned.
  NoInterp  ;
ndcs: ( -- )  4 ?pairs  fix-exits  NextCaseTarg !  csp !  ;

: BEGINCASE	\ C: -- case-sys ; Run: --                      6.2.0873
\ *G Start a *\fo{BEGINCASE ... NEXTCASE} construct. This construct is
\ ** a loop which uses *\fo{OF ... ENDOF} clauses like *\fo{CASE ... ENDCASE},
\ ** but the loop terminates after the action in the *\fo{OF ... ENDOF} clause.
\ ** *\fo{BEGINCASE ... NEXTCASE} is used to construct multiple-exit loops
\ ** without the appearance of spaghetti code.
  NoInterp  ;
ndcs: ( -- )
  csp @  NextCaseTarg @  s_mrk_br<, NextCaseTarg !  !csp  4  ;

internal
: (nextcase,)	\ *casesys --
  NextCaseTarg @  dup 0= #-22 ?throw  s_br<,
  fix-exits  NextCaseTarg !  csp !
;
external

: NEXTCASE	\ C: case-sys -- ; Run: x --
\ *G Terminate a *\fo{BEGINCASE ... NEXTCASE} construct.
\ ** *\fo{DROP}s the switch value and branches back to *\fo{BEGINCASE}.
\ ** Note that from VFX Forth 4.0, *\fo{BEGINCASE} *\b{must} be
\ ** used with *\fo{NEXTCASE}.
  NoInterp  ;
ndcs: ( -- )  4 ?pairs  s_drop,  (nextcase,)  ;

: NEXT-CASE	\ C: case-sys -- ; Run: --
\ *G A Version of *\fo{NEXTCASE} which does not drop the switch
\ ** value. Used when the switch value itself is consumed by a
\ ** default condition.
\ ** Note that from VFX Forth 4.0, *\fo{BEGINCASE} *\b{must} be
\ ** used with *\fo{NEXTCASE}.
  NoInterp  ;
ndcs: ( -- )  4 ?pairs  (nextcase,)  ;
\ ...SFP025

: cs-pick	\ xu .. x0 u -- xu .. x0 xu                  15.6.2.1015
\ *G Get a copy of the *\i{u}th compilation stack item.
  pick  ;

: cs-roll	\ xu..x0 u -- xu-1..x0 xu                    15.6.2.1020
\ *G Rotate the order of the top *\i{u} compilation stack items
\ ** by one place such that the current top of stack becomes the
\ ** second item and the *\i{u}th item becomes TOS.
  roll  ;

: cs-drop	\ x --
\ *G Discard the top item on the compilation stack.
  drop  ;


\ *****************
\ End of structures
\ *****************

: RECURSE       \ Comp: --                                      6.1.2120
\ *G Compile a recursive call to the colon definition containing
\ ** *\fo{RECURSE} itself. Do not use *\fo{RECURSE} between
\ ** *\fo{DOES>} and *\fo{;}.
\ ** Used in the form:
\ *C : foo  ... recurse ... ;
\ *P to compile a reference to *\fo{FOO} from inside *\fo{FOO}.
  NoInterp  ;
ndcs: ( -- )
  discard-sinline  last-colon-xt @ dup 0= #-259 ?throw  docall,  ;


\ =======================================================================
( *> kerneldf                                                           )
( *S Memory operators )
\ =======================================================================
( *P The following words are used to operate on memory locations and    )
( ** arbitrary memory blocks.                                           )

: ON            \ addr --
( *G Given the address of a CELL this will set its contents to TRUE.   )
  on
;

: OFF           \ addr --
( *G Given the address of a CELL this will set its contents to FALSE.  )
  off
;

: @OFF		\ addr -- x
\ *G Read cell at addr, and set it to 0.
  dup @ swap off
;

: @on           \ addr -- val
\ *G Fetch contents of addr and set to -1.
  dup @ swap on
;

: +!            \ n addr --                                      6.1.0130
\ *G Add N to the CELL at memory address ADDR.
  +!
;

: w+!           \ w addr --
\ *G Add W to the 16 bit word at memory address ADDR.
  tuck w@ + swap w!
;

: C+!           \ b addr --
\ *G Add B to the character (byte) at memory address ADDR.
  c+!
;

: -!            \ n addr --
\ *G Subtract N from the CELL at memory address ADDR.
  swap negate swap +!
;

: w-!           \ w addr --
\ *G Subtract W from the 16 bit word at memory address ADDR.
  swap negate swap w+!
;

: C-!           \ b addr --
\ *G Subtract B from the character (byte) at memory address ADDR.
  swap negate swap c+!
;

: incr          \ a-addr --
\ *G Increment the data cell at a-addr by one.
  incr
;

: decr          \ a-addr --
\ *G Decrement the data cell at a-addr by one.
  decr
;

: 2@            \ a-addr -- x1 x2                                6.1.0350
\ *G Fetch and return the two CELLS from memory ADDR and ADDR+sizeof(CELL).
\ ** The cell at the lower address is on the top of the stack.
  2@
;

: @             \ addr -- n                                      6.1.0650
\ *G Fetch and return the CELL at memory ADDR.
  @
;
64bit? [if]
: l@            \ addr -- val
\ *G Fetch and 0 extend the word (32 bit) at memory ADDR.
  l@
;
[then]
: w@            \ addr -- val
\ *G Fetch and 0 extend the word (16 bit) at memory ADDR.
  w@
;

: c@            \ addr -- val                                    6.1.0870
\ *G Fetch and 0 extend the character at memory ADDR
  c@
;

64bit? [if]
: l@s            \ addr -- val
\ *G Fetch and sign extend the word (32 bit) at memory ADDR.
\ ** This word is in 64 bit systems only.
  l@s
;
[then]
: w@s           \ addr -- val(signed)
\ *G A sign extending version of *\fo{W@}.
  w@ dup $8000 and if $FFFF0000 or then
;

: c@s           \ addr -- val(signed)
\ *G A sign extending version of *\fo{C@}.
  c@ dup $80 and if $FFFFFF00 or then
;

: 2!            \ x1 x2 addr --                                  6.1.0310
\ *G Store the two CELLS x1 and x2 at memory ADDR.
\ ** X2 is stored at ADDR and X1 is stored at ADDR+CELL.
  2!
;

: !             \ n addr --                                      6.1.0010
\ *G Store the CELL quantity N at memory ADDR.
  !
;
64bit? [if]
: l!		\ val addr --
\ *G Store the word (32 bit) quantity VAL at memory ADDR.
  l!
;
[then]
: w!            \ val addr --
\ *G Store the word (16 bit) quantity VAL at memory ADDR.
  w!
;

: c!            \ val addr --                                    6.1.0850
\ *G Store the character VAL at memory ADDR.
  c!
;

[undefined] fill [if]
: fill          \ addr len char --                               6.1.1540
\ *G Fill *\i{LEN} bytes of memory starting at *\i{ADDR} with the
\ ** byte information specified as *\i{CHAR}.
  -rot bounds ?do
    dup i c!
  loop
  drop
;
[then]

Target_ARM_Linux [if]
: set-bit       \ mask c-addr --
  tuck c@  or  swap c!
;
: clear-bit     \ mask c-addr --
  tuck c@  swap invert and  swap c!
;
: toggle-bit    \ mask c-addr --
  tuck c@  xor  swap c!
;
[else]
: set-bit       \ mask c-addr --
\ *G Apply the *\i{mask} ORred with the contents of *\i{c-addr}.
\ ** Byte operation.
\  swap over
\  c@ or swap c!
  set-bit
;
: clear-bit     \ mask c-addr --
\ *G Apply the *\i{mask} inverted and ANDed with the contents of
\ ** *\i{c-addr}. Byte operation.
\  swap not over
\  c@ and swap c!
  clear-bit
;
: toggle-bit    \ mask c-addr --
\ *G Invert the bits at *\i{c-addr} specified by the *\i{mask}.
\ ** Byte operation.
\  dup -rot              \ c-addr u c-addr
\  c@ xor swap c!
  toggle-bit
;
[then]

: test-bit	\ mask addr -- flag
\ *G AND the *\i{mask} with the contents of *\i{addr} and return true if the
\ ** result is non-zero (-1) or false (0) if the result is zero.
  c@ and 0<>
;

[undefined] cmove [if]
: cmove         \ addr1 addr2 count --                        17.6.1.0910
\ *G Copy *\i{COUNT} bytes of memory forwards from *\i{ADDR1} to *\i{ADDR2}.
\ ** Note that as VFX Forth characters are 8 bit units, there is
\ ** an implicit connection between a byte and a character.
  cmove
;
[then]

[undefined] cmove> [if]
: cmove>        \ addr1 addr2 count --                        17.6.1.0920
\ *G As *\fo{CMOVE} but working in the opposite direction,
\ ** copying the last character in the string first.
\ ** Note that as VFX Forth characters are 8 bit units, there is
\ ** an implicit connection between a byte and a character.
  cmove>
;
[then]

[undefined] move [if]
: MOVE          \ addr1 addr2 u --                              6.1.1900
\ *G An intelligent memory move which avoids memory overlap problems.
\ ** Note that as VFX Forth characters are 8 bit units, there is
\ ** an implicit connection between a byte and a character.
  -rot                          \ hide count value
  2dup u< if                    \ compare addresses
    rot cmove>                  \ move down
  else
    rot cmove                   \ move up
  then
;
[then]

[undefined] movex [IF]
: movex         \ src dest +n --
\ *G An optimised version of *\fo{MOVE}. If n<=0, no action is
\ ** taken.
  move  ;
comp:  drop  postpone move  ;		\ SFP067
[THEN]

: ERASE         \ a-addr u --                                    6.2.1350
\ *G Fill U bytes of memory from A-ADDR with 0.
  0 fill  ;

: BLANK         \ a-addr u --                                 17.6.1.0780
\ *G Blank U bytes of memory from A-ADDR using ASCII 32 (space)
  bl fill  ;

: UNUSED        \ -- u                                           6.2.2395
( *G Return the number of bytes free in the dictionary.                 )
\  unused-top here -
  loadbase @ codesize @ + here -  ;


\ *******************
\ *S String operators
\ *******************
\ *P The following words are used to operate on strings.
\ ** With care, some of them may also be used on arbitrary
\ ** memory blocks.

\ *P In modern Forth strings are usually described by caddr/len
\ ** pairs on the stack *\fo{( -- caddr len)}, where *\i{caddr}
\ ** points to first character and *\i{len} is the number of
\ ** characters in the string. Another form often used is counted
\ ** strings *\fo{{ -- caddr )} in which caddr points to a count
\ ** byte that is then followed by that many characters. Zero
\ ** terminated strings are supported and are used for interfacing
\ ** with the operating system and other libraries. Zero terminated
\ ** string handling is described in a separate section of this
\ ** manual.

\ *P In VFX Forth implementations for byte-addressed CPUs such as
\ ** are used on PCs, a character is a byte-sized item. This means
\ ** that the common assumption that a character=byte is true.
\ ** However, if your code has to be ported to CPUs for which
\ ** this assumption is not true (e.g. DSPs) or for which the
\ ** size of a character is not one byte, then be very careful.


\ ====================
\ *N Caddr/len strings
\ ====================

: /string       \ addr len n -- addr+n len-n                  17.6.1.0245
( *G Modify a string address and length to remove the first N characters )
( ** from the string.                                                   )
  tuck - -rot + swap
;
compiler
: /string       \ --
  tuck - -rot + swap
;
target

[undefined] skip [if]	\ may already be in REQDCODE.FTH
: SKIP          \ c-addr u char -- 'c-addr 'u
\ *G Modify string description by skipping over leading occurrences
\ ** of *\i{char}. Note that when a space char is given, tabs are
\ ** also ignored.
  over 0= if drop exit then
  >r
  begin					\ -- caddr u
    over c@ dup ATAB =			\ if character is TAB
    if  drop BL  endif			\ convert to space
    r@ =
    over and				\ 0 length will stop
  while
    1- swap 1+ swap
  repeat
  r> drop
;
[then]

[undefined] scan [if]	\ may already be in REQDCODE.FTH
: scan          \ caddr u char -- caddr2 u2
\ *G Look for first occurrence of *\i{char} in string and return
\ ** the new string. *\i{C-addr2/u2} describe the string with
\ ** *\i{char} as the first character.
\ ** Note that when a space char is given, a tab is also
\ ** treated as a space.
  over 0= if drop exit then
  >r
  begin
    over c@ dup ATAB =			\ if character is TAB
    if  drop BL  endif			\ convert to space
    r@ <>
    over and
  while
    1- swap 1+ swap
  repeat
  r> drop
;
[then]

: -TRAILING     \ c-addr u1 -- c-addr u2                      17.6.1.0170
\ *G Modify a string address/length pair to ignore any trailing space
\ ** or tab characters.
  dup 0 ?do
    2dup + 1 - c@  dup bl <> swap ATAB <> and ?leave
    1-
  loop
;

: -leading      \ caddr len -- caddr' len'
\ *G Modify a string address/length pair to ignore any leading space
\ ** or tab characters.
  bl skip
;

: -white	\ caddr len -- caddr' len'
\ *G Remove leading and trailing white space from a string.
  -leading -trailing
;

: UPC           \ char -- char'
\ *G Convert supplied character to upper case if it was alphabetic
\ ** otherwise return the unmodified character.
\ ** *\fo{UPC} is English language specific.
  dup [char] a >= if
    dup [char] z <= if
      $DF and
    then
  then
;
compiler
: UPC           \ char -- char'
  dup $61 >= if			\ 'a'
    dup $7A <= if		\ 'z'
      $DF and
    then
  then
;
target

: UPPER         \ addr len --
\ *G Convert the ASCII string described to upper-case. This operation
\ ** happens in place.
\ ** *\fo{UPPER} is English language specific.
  bounds ?do
    i dup c@ upc swap c!
  loop
;

[undefined] ucmove [if]
: ucmove	\ addr1 addr2 len --
\ *G Copy *\i{len} bytes/characters of memory forwards from
\ ** *\i{addr1} to *\i{addr2}, converting to upper case.
\ ** Note that as VFX Forth characters are 8 bit units, there is
\ ** an implicit connection between a byte and a character.
  bounds
  ?do  dup c@ upc i c!  1+  loop
  drop
;
[then]

[undefined] ucmove> [if]
: ucmove>	\ addr1 addr2 len --
\ *G Copy *\i{len} bytes/characters of memory backwards starting
\ ** at *\i{addr1_len-1} to *\i{addr2+len-1}, converting to upper case.
\ ** Note that as VFX Forth characters are 8 bit units, there is
\ ** an implicit connection between a byte and a character.
  dup if
    tuck over + 1-			\ -- addr1 len addr2 addr2+len-1
    2swap + -rot			\ -- addr1+len addr2 addr2+len-1
    do  1- dup c@ upc i c!  -1 +loop
    drop  exit
  endif
  3drop
;
[then]

: umove		\ addr1 addr2 u --
\ *G An intelligent memory move which avoids memory overlap problems.
\ ** Characters are converted to upper case during the move.
\ ** Note that as VFX Forth characters are 8 bit units, there is
\ ** an implicit connection between a byte and a character.
  -rot 2dup u<
  if  rot ucmove>  else  rot ucmove  endif
;

: uplace	\ c-addr1 u c-addr2 --
\ *G Copy the string described by *\i{c-addr1/u} to an upper-case
\ ** counted string at *\i{c-addr2}.
  2dup 2>r			\ write count last
  1 chars + swap umove
  2r> c!			\ to avoid in-place problems
;

[undefined] s= [if]	\ could be in REQDCODE.FTH
: s=            \ addr1 addr2 len -- flag
\ *G Compare two same-length strings or memory blocks, returning
\ ** true if they are identical.
  dup if
    bounds do
      dup c@ i c@ <> if
        drop false  unloop exit
      endif
      1 chars +
    loop
    drop true
  else
    3drop true
  endif
;
[then]

: str=		\ addr1 len1 addr2 len2 -- flag
\ *G Compare two addr/len memory blocks, returning true if
\ ** they are identical both in length and contents.
\ ** The comparison is case sensitive.
  rot over = if				\ -- addr1 addr2 len2
    s=  exit
  endif
  3drop 0
;

\ SFP042...
: is=		\ c-addr1 c-addr2 u -- flag
\ *G Compare two same-length strings/memory blocks, returning true if
\ ** they are identical. The comparison is case insensitive.
  bounds ?do
    dup c@ upc  i c@ upc <>
    if  drop 0  unloop exit  endif
    1+
  loop
  drop -1
;

: istr=		\ addr1 len1 addr2 len2 -- flag
\ *G Compare two addr/len memory blocks, returning TRUE if
\ ** they are identical both in length and contents.
\ ** The comparison is case insensitive.
  rot over = if				\ -- addr1 addr2 len2
    is=  exit
  endif
  3drop 0
;
\ ...SFP042

[undefined] compare [if]
: compare       \ c-addr1 u1 c-addr2 u2 -- n                    17.6.1.0935
\ *G Compare two strings. The return result is 0 for a match or can be
\ ** -ve/+ve indicating string differences.
\ ** If the two strings are identical, n is zero. If the two strings
\ ** are identical up to the length of the shorter string, n is
\ ** minus-one (-1) if u1 is less than u2 and one (1) otherwise.
\ ** If the two strings are not identical up to the length of the
\ ** shorter string, n is minus-one (-1) if the first non-matching
\ ** character in the string specified by c-addr1 u1 has a lesser
\ ** numeric value than the corresponding character in the string
\ ** specified by c-addr2 u2 and one (1) otherwise.
  rot swap                      \ c-addr1 c-addr2 u1 u2
  2dup - >r min                 \ c-addr1 c-addr2 minlen -- R: lendiff? --

  begin
    dup
  while
    -rot over c@ over c@ -      \ length c-addr1 c-addr2 (char1-char2)
\   ?dup if                     \ If chars are different
    dup if                      \ If chars are different
      r> drop >r                \  replace lendiff result with error code
      drop 0                    \  and put 0 on TOS (make len==0 at BEGIN)
    else                        \ otherwise
      drop			\ discard 0=lendiff
      1+ swap 1+ swap rot 1-    \ increment addresses and decrement length
    then
  repeat
  drop 2drop                    \ remove addresses and null count from stack
                                \ -- ; R: result --
  r> dup if 0< 1 or then        \ make nice flag, 0 becomes 0, -ve becomes -1
                                \            and  +ve becomes 1
;
[then]

-short-branches
: icompare      \ c-addr1 u1 c-addr2 u2 -- n
( *G A case insensitive version of COMPARE.                             )
  rot swap                      \ c-addr1 c-addr2 u1 u2
\  2dup - >r min                 \ c-addr1 c-addr2 minlen -- R: lendiff? --
  2dup - >r umin		\ c-addr1 c-addr2 minlen -- R: lendiff? -- ; SFP052

  begin
    dup
  while
    -rot over c@ upc over c@ upc -      \ length c-addr1 c-addr2 (char1-char2)

    dup if			\ If chars are different
      r> drop >r		\  replace lendiff result with error code
      drop 0			\  and put 0 on TOS (make len==0 at BEGIN)
    else                        \ otherwise
      drop
      1+ swap 1+ swap rot 1-	\ increment addresses and decrement length
    then

  repeat

  drop 2drop                    \ remove addresses and null count from stack
                                \ -- ; R: result --
  r> dup if 0< 1 or then        \ make nice flag, 0 becomes 0, -ve becomes -1
                                \            and  +ve becomes 1
;
+short-branches

: (search)      { c-addr1 u1 c-addr2 u2 -- c-addr3 u3 flag }
  c-addr1 u1 u2 - 1+ bounds     \ Search for first char of $2 in $1.  Note that
  ?do                           \ we only check LEN($1)-LEN($2)+1 chars of $1.
    i c@  c-addr2 c@  = if	\ Compare next char of $1 with first char of $2.
      i c-addr2 u2 s= if        \ Is the whole of $2 present?
        i u1 i c-addr1 - - true \ Yes - build return parameters...
        unloop exit             \ ...and bail out.
      then
    then
  loop
  c-addr1 u1 false            \ End of loop and first char not found - no match.
;

: SEARCH        \ c-addr1 u1 c-addr2 u2 -- c-addr3 u3 f     17.6.1.2191
\ *G Search the string *\i{c-addr1/u1} for the string (\i{c-addr2/u2}.
\ ** If a match is found return *\i{c-addr3/u3}, the address of
\ ** the start of the match and the number of characters remaining
\ ** in *\i{c-addr1/u1}, plus flag *\i{f} set to true. If no match
\ ** was found return *\i{c-addr1/u1} and *\i{f=0}. Case sensitive.
  2 pick over < if      \ Is $1 shorter than $2?
    2drop false exit    \ Yes - $2 *can't* be in $1.
  then
  dup 0 <= if           \ Is $2 zero length?
    2drop true exit     \ Yes - we have found it at the start of $1.
  then
  2 pick 0 <= if        \ Is $1 zero length?
    2drop false exit    \ Yes - string not found.
  then
  (search)
;

: instring      \ pattern lenp source lens -- flag
\ *G Return true if the source text contains the pattern text.
\ ** Case-sensitive.
  2 pick 0=				\ zero length pattern matches all
  if  2drop 2drop  true  exit  then
  2 pick - 0 max			\ -- pattern lenp source lens'
  bounds ?do                            \ -- pattern lenp
    2dup i swap s=			\ get out if match found
    if  unloop  2drop true  exit  then
  loop
  2drop false
;

: $Null		\ -- caddr 0
\ *G Return a null string.
  s" "
;

: extractNum	\ caddr len base -- caddr' len' u
\ *G Extract a number in the given base from the start of the
\ ** string, returning the remaining string starting at the first
\ ** non-numeric character and the converted number.
  base @ >r  base !
  0 0 2swap >number 2swap drop
  r> base !
;

: ExtractText	\ caddr len char -- raddr rlen laddr llen
\ *G Extract text delimited by *\i{char} from the string *\i{caddr/len}.
\ ** Text before the leading delimiter is ignored.
\ ** Return the string remaining and string between the delimiters.
\ ** For example:
\ *C   s"     'foo' 1 2 10 " char ' ExtractText
\ *P will return the strings "*\fo{ 1 2 10 }" and "*\fo{foo}". If
\ ** either of the delimiters is not present, the original string
\ ** is returned as *\i{raddr/rlen} and *\i{laddr/llen} is a null
\ ** string.
  -rot  2dup 2>r  rot dup >r		\ -- ca l char ; R: -- ca l char
  scan dup if				\ step to leading delimiter, exists?
    1 /string				\ skip delimiter
    2dup r> scan dup if			\ -- ca1 l1 ca2 l2 ; R: -- ca l ; exists?
      2r> 2drop				\ discard original string
      tuck 1 /string 2>r		\ preserve residue
      - 2r> 2swap
    else
      2drop 2drop  2r> $Null
    endif
  else
    2drop  r> drop  2r> $Null
  endif
;

\ SFP088...
: csplit	\ addr len char -- raddr rlen laddr llen
\ *G Extract a substring at the start of addr/len, returning
\ ** the string raddr/rlen which includes char (if found) and
\ ** the string laddr/llen which contains the text to left of char.
\ ** If the string does not contain the character, raddr is
\ ** addr+len and rlen=0.
  >r 2dup r> scan                       \ -- addr len addr' len'
  2swap 2 pick -                        \ -- addr' len' addr len-len'
;
\ ...SFP088

: not-overlapped?	\ caddr1 len1 caddr2 len2 --
\ *G Return true if the two strings do not overlap.
  2over +  2 pick u<			\ caddr1+len1 < caddr2
  if  4drop true  exit  then
  + rot u<				\ caddr2+len2 < caddr1
  nip
;

: overlapped?	\ caddr1 len1 caddr2 len2 --
\ *G Return true if the two strings overlap.
  not-overlapped? 0=  ;


\ ******************
\ *N Counted strings
\ ******************

create cNull	\ -- addr
\ *G Return the address of an empty counted string.
  0 ,

: place		\ c-addr1 u c-addr2 --
\ *G Copy the string described by c-addr1 u to a counted string at
\ ** the memory address described by c-addr2.
  2dup 2>r			\ write count last
  1 chars + swap move
  2r> c!			\ to avoid in-place problems
;

: count         \ addr1 -- addr2 len                             6.1.0980
( *G Given the address of a counted string in memory this word will     )
( ** return the address of the first character and the length in        )
( ** characters of the string.                                          )
  dup 1 chars + swap c@
;

: $move         \ caddr1 caddr2 -- ; move counted string
\ *G Copy a counted string from *\i{caddr1} to *\i{caddr2}.
\ ** Overlapped strings are handled properly.
  over c@ 1+ move
;

: SMOVE         \ caddr1 caddr2 --
\ *G Copy the counted string at *\i{caddr1} to *\i{caddr2}.
\ ** Overlapped strings are handled properly.
  over c@ 1+ move
;

: addchar       \ char string --
\ *G Add the character to the end of the counted string.
  tuck count + c!
  1 swap c+!
;

: append	\ c-addr u $dest --
\ *G Add the string described by *\i{c-addr/u} to the counted
\ ** string at *\i{$dest}.
  2dup c@ tuck +			\ -- caddr u $dest lend lens+lend ; new len
  2 pick c!				\ -- caddr u $dest lend ; update length
  char+ +  				\ -- caddr u $d+1+lend ; dest buffer address
  swap move				\ -- ; copy string
;
((
: +place	\ adr1 len adr2 -- ; Anton, c.l.f. 15 March 2020
    2dup c@ tuck + 2 pick c! char+ +  swap move ;
: append	\ c-addr u $dest -- ; original
  >r
  tuck  r@ count +  swap cmove          \ add source to end
  r> c+!                                \ add length to count
;
\ To fix overlap use:
\ : append  2dup 2>r  count + swap move  2r> c+!  ;
))

: $+		\ $addr1 $addr2 --
( *G Add the counted string $ADDR1 to the counted buffer at $ADDR2.     )
  >r count r> append
;

: s+            \ source dest --
\ *G Given the addresses of two counted strings, add the
\ ** source string to the end of the destination string.
  >r count r> append
;


\ ==========================
\ *N Zero-terminated strings
\ ==========================
\ *P This section provides a set of simple words for handling
\ ** zero-terminated strings. Additional words can be found in
\ ** the tools layer.

create zNull	\ -- addr
\ *G Return the address of a zero terminated null string.
  0 ,

: zstrlen	\ addr -- len
\ *G Return the length of a 0 terminated string.
  dup
  begin
    dup c@ ( 0<> )
   while
     1+
  repeat
  swap -
;

: zcount        \ zaddr -- zaddr len
\ *G A version of *\fo{COUNT} for zero terminated strings, returning
\ ** the address of the first character and the length.
  dup
  begin
    dup c@ ( 0<> )
   while
     1+
  repeat
  over -
;

: zplace        \ caddr len zaddr --
\ *G Copy the string caddr/len to zaddr as a 0 terminated string.
  2dup + >r				\ save location of zero
  swap move				\ copy string
  0 r> c!				\ terminate afterwards in case of overlap
;

: zmove		\ src dst -- ; shows off the optimiser
\ *G Copy a zero terminated string.
  begin
    over c@ 2dup
    swap c!
    rot 1+ rot 1+ rot
    0=
  until
  2drop
;

: zAppend	\ caddr len zdest --
\ *G Add the string defined by *\i{caddr/len} to the end of the
\ ** zero terminated string at *\i{zdest}.
  zcount + zplace
;

((
: Appendz       \ caddr len zdest --
\ *G *\b{OBSOLETE} and REMOVED: use *\fo{zAppend} above instead.
  zcount + zplace
;
))

(( for DocGen
: (z$+)		\ caddr u zdest$ --
\ *G Add the source string caddr/u to the end of the zero terminated
\ ** destination string.
\ ** *\b{OBSOLETE} and REMOVED: use *\fo{zAppend} above instead.
  zcount + zplace
;
))

: z$+           \ zsrc$ zdest$ -- ; add zsrc$ to end of zdest$
\ *G Add the source string to the end of the destination string. Both
\ ** strings are zero terminated.
\  >r  zcount  r> zcount + zplace
  swap zcount  rot zcount + zplace
;

: zterm		\ caddr len -- caddr len
\ *G Zero terminate the given string.
  2dup + 0 swap c!
;

: >zterm	\ caddr len -- z$
\ *G Convert a *\i{caddr/len} string to a zero-terminated string.
  over +  0 swap c!
;

: c>czterm	\ c$ -- z$
\ *G Convert a counted string in place to a counted and zero
\ ** terminated string. The address of the zero-terminated
\ ** section is returned.
  count  over +  0 swap c!
;

: czplace	\ caddr len dest
\ *G Store the string *\i{caddr/len} as a counted and zero-terminated string
\ ** at *\i{dest}. The strings must not overlap.
  2dup c!  2dup + 1+ 0 swap c!			\ count and terminate bytes
  1+ swap move
;


\ ===================
\ *N Pattern matching
\ ===================
\ *P VFX Forth provides a few words that check if a string matches
\ ** a template string that can have simple wildcards. If you need
\ ** something more sophisticated, you are probably best off
\ ** interfacing to a regex library such as the one at
\ *C   www.pcre.org

\ *P Our thanks to Graham Smith at Tectime for the code.

\ *P Take two strings, a 'source' string and a 'pattern'. The test
\ ** is to see if the source matches the pattern where the pattern
\ ** can contain the wildcard characters '?' and '*'. These two
\ ** characters can be 'escaped' using the character '\'.

\ *P The asterisk as a wildcard implies 'any of zero or more
\ ** characters match'. Thus '*' will match with each of 'a',
\ ** '12abxyz' and the zero length string ''. An asterisk then
\ ** matches anything. A pattern of "ab*12" will match any text
\ ** which starts with 'ab' and ends with '12'.

\ *P The question mark indicates any one character. Under
\ ** DOS/Windows the question mark can also match zero characters
\ ** but this behaviour seems inconsistant - see below for an
\ ** example. The code here insists that a question mark matches
\ ** exactly one of any one character. Thus '?' matches 'a', 'b'
\ ** and '%'. It does not match the zero-length string ''.

\ *E Source           Pattern         Match
\ ** --------------   --------------  -----
\ ** "abc"            "abc"           yes
\ ** "abcd"           "abc"           no
\ ** "abc"            "abc*"          yes
\ ** "abc"            "abc?"          yes
\ ** "abc"            "*abc"          yes
\ ** "abc"            "?abc"          no
\ ** "ab"             "a?b"           no
\ ** "a"              "?"             yes
\ ** "123abc"         "*abc"          yes
\ ** "123abc"         "?abc"          no
\ ** "123abc"         "???abc"        yes
\ ** "123abc"         "1*c"           yes
\ ** ""               ""              yes

: ic=   \ ch1 ch2 -- t/f
\ A case insensitive test for equality of two characters. This is
\ the action assigned to *\fo{ch=} above when performing a case-insensitive
\ match.
    upc swap upc =
;

: *wcm      \ src slen ptn plen xt -- t/f
\ The action taken by *\fo{WCMatch?} when an asterisk character
\ is encountered during traversal through the pattern. xt is the
\ execution token of the character comparison word which is needed
\ dues to the recursive nature of the pattern matching routine.
  { | xt ptn plen -- }
  -> xt
  1- swap 1+ swap			\ -- s sl p pl ; skip '*'

  \ since '*' matches anything, if there
  \ is no pattern left, it MUST be a match!
  dup 0= if 4drop TRUE exit then

  -> plen -> ptn			\ -- s sl
  begin					\ -- s sl ; sl=0 is allowed here
    2dup ptn plen xt (wcMatch?)		\ -- s sl flag
    if  2drop True exit  then
    dup					\ -- s sl sl
   while
    1- swap 1+ swap			\ -- s' sl'
  repeat

  \ if we have reached here, there is no
  \ source string left, and no match occurred.
  2drop False
;

[-short-branches
: (wcMatch?)	\ src slen ptn plen xt -- t/f
\ Wild Card Match. *\i{src} is the address of the start of a
\ souce string and *\i{slen} is its length. Similarly, *\i{ptn}
\ is the address of a pattern string and its length is *\i{plen}.
\ A value of TRUE is returned only if the source string matches
\ the pattern according to the rules described above. *\i{xt} is
\ the executiion token of the word which performs a character
\ comparision.
  { src slen ptn plen xt -- flag }
  begin  plen  while			\ -- ; while more pattern
    case ptn c@				\ -- ch
      '*' of  src slen ptn plen xt *wcm exit  endof
      '?' of   endof	\ inc src dec slen inc ptn dec plen
      ( else)				\ -- ch ; the pattern char
        '\' = if                    \ -- ; if backslash
          ptn 1+ to ptn  plen 1- to plen
\          inc ptn dec plen        \ -- ; we want the next one
          plen 0= if FALSE exit then \ -- ; if there is one!
        then                        \ --
        slen 0= if False exit then  \ failed if no source
        src c@ ptn c@ xt execute    \ flag ; matched?
        0= if False Exit then       \ if not, we failed
    end-case

    \ We have not failed so far. So we
    \ will now move onto next chars ..
    src 1+ to src  slen 1- to slen	\ next source char
    ptn 1+ to ptn  plen 1- to plen
    \ inc src dec slen            \ next source char
    \ inc ptn dec plen
  repeat

  \ no pattern remains. A match only
  \ if there is also no source...
  slen 0=
;
short-branches]

: wcMatch?      \ src slen ptn plen -- t/f
\ *G Wild Card Match. *\i{src} is the address of the start of a
\ ** souce string and *\i{slen} is its length. Similarly, *\i{ptn}
\ ** is the address of a pattern string and its length is *\i{plen}.
\ ** A value of TRUE is returned only if the source string matches
\ ** the pattern according to the rules described above.
\ ** The comparison is case sensitive.
  ['] = (wcMatch?)
;

: iwcMatch?     \ src slen ptn plen -- t/f
\ *G As *\fo{wcMatch?} above, but the comparison is case
\ ** insensitive.
  ['] ic= (wcMatch?)
;

: strRmatch     \ *s lastS il *p lastP jl -- flag
\ *G Return true if the string described by *\i{addr last first}
\ ** matches the pattern described by a similar set of three
\ ** parameters. In the set of three parameters (triple), *\i{addr}
\ ** is the start of the string, *\i{last} is the zero-based index
\ ** of the last character in the string. and *\i{first} is the
\ ** zero-based index of the first character. Originally coded as
\ ** a primitive of *\fo{$cstrmatch} and *\fo{$strmatch}, this
\ ** word now converts the two triples to the more standard Forth
\ ** *\i{addr length} doubles and calls *\fo{wcMatch?}.
  /string 1+ 2>r
  /string 1+ 2r>
  WCMatch?
;

: $cstrmatch    \ src srclen patt pattlen -- flag
\ *G A synonym for *\fo{WCMatch?}.
  wcMatch?
;

: $strmatch     \ src patt -- flag
\ *G Perform *\fo{wcMatch?} on two counted strings.
  swap count rot count wcMatch?
;

: zstrmatch     \ src patt -- flag
\ *G Perform *\fo{wcMatch?} on two zero-terminated strings.
  swap zcount rot zcount wcMatch?
;

0 [if]

256 buffer: src
256 buffer: ptn
0 value result

: -blanks   \ --
  bl parse-leading 			\ skip leading spaces
;

: tib?  \ -- flag ; any chars in text input buffer?
    #tib @ >in @ >
;

: quoted?  \ -- ch|0
    tib? if tib >in @ + c@ else 0 then
;

: getString \ "test" ++ ca u
  bl parse-leading 			\ skip leading spaces
  quoted? if 1 >in +! [char] " parse
          else bl parse then
;

: get-yes   \ "test" -- t/f
    bl word count 2dup upper \ ca u
    3 min s" YES" str=
;

: PreTest  \ "text1" "Text2" ++ src slen ptn plen
    getString src place
    getString ptn place
    get-yes to Result
    src $. space 10 >pos
    ptn $. space 20 >pos
    Src count ptn count
;

: PostTest  \ t/f --
    dup if ." True  " else ." False " then
    Result = if ." OK" else ." *Wrong*" then
    0 parse-word 2drop
    cr
;

: Test:
    PreTest    \ src slen ptn plen
    ."  WCMATCH? -> "
    WCMatch?    \ flag
    PostTest
;

: iTest:    \ case-insensitive test
    PreTest    \ src slen ptn plen
    ." iWCMATCH? -> "
    iWCMatch?    \ flag
    PostTest
;

cr
test: "abc"                   "abc"           yes
test: "abcd"                  "abc"           no

test: "abc"                   "abc*"          yes
test: "abcxyz"                "abc*"          yes
test: "abc"                   "*abc"          yes
test: "123abc"                "*abc"          yes
test: "123abc"                "1*c"           yes

test: "abc"                   "abc?"          no
test: "abc"                   "?abc"          no
test: "ab"                    "a?b"           no
test: "a"                     "?"             yes
test: "axyz"                  "?xyz"          yes
test: "axyzb"                 "?xyz?"         yes
test: "123abc"                "?abc"          no
test: "123abc"                "???abc"        yes
test: ""                      ""              yes (i.e. zero-lengths match)

test:   "abc"               "Abc"           no
itest:  "abc"               "Abc"           yes

test:   "abc"               "ABC"           no
itest:  "abc"               "ABC"           yes


[then]

\ ----------------------------
\ *H DOS/Windows inconsistency
\ ----------------------------
\ *P When using the wildcard character '?' in a file path/name
\ ** matching routine in Windows or DOS, e.g. the DIR shell command,
\ ** the question mark sometimes matches zero characters. For
\ ** instance a pattern of 'ab?.*' matches the file nme 'ab.txt'.
\ ** However, placing the question mark in another position causes
\ ** the match to fail. For example, the pattern '?ab.*' does not
\ ** match 'ab.txt'.


\ ===================
\ *N SYSPAD buffering
\ ===================
\ *P The *\fo{SYSPAD} mechanism replaces the use of *\fo{PAD} in the kernel.
\ ** *\fo{SYSPAD} is built in the user area of each task and forms a
\ ** circular buffer of strings. The lifetime of each string is
\ ** not defined. It will last until another buffer request causes
\ ** the memory to be reused.

: getSyspad	\ u -- addr
\ *G Reserve *\i{u} bytes in the *\fo{SYSPAD} area and return the
\ ** base address.
  dup /SysPad u>
  if  #-419 throw  endif
  ^Syspad @ SyspadStart u<		\ check start
  if  SyspadStart ^Syspad !  endif
  dup ^Syspad @ + SyspadEnd u< 0=	\ check end
  if  SyspadStart ^Syspad !  endif
  ^SysPad @  swap ^Syspad +!
;

: >Syspad	\ caddr len -- caddr' len
\ *G Copy a string to *\fo{SYSPAD} and return the new string.
  dup >r getSyspad tuck r@ move  r>  ;
: >SyspadC	\ caddr len -- caddr'
\ *G Copy a string to *\fo{SYSPAD} and return the new counted
\ ** string.
  dup 1+ getSyspad dup >r place r>  ;
: >SyspadZ	\ caddr len -- zaddr
\ *G Copy a string to *\fo{SYSPAD} and return the new zero
\ ** terminated string.
  dup 1+ getSyspad dup >r zplace r>  ;


\ ***********
\ *> kerneldf
\ *S Formatted and Unformatted number conversion
\ ***********

\ ========
\ *N Tools
\ ========

: BELL          \ --
\ *G *\fo{EMIT} the ASCII '7' bell character. Not all output
\ ** devices support this function. The *\fo{USER} variable
\ ** *\fo{OUT} is not incremented by this word.
  out @  abell emit  out !
;

: SPACE         \ --                                            6.1.2220
\ *G Output a space (ASCII #32) character to the terminal.
  bl emit
;

L: space-table ",                 "     \ 16 spaces

: SPACES        \ n --                                           6.1.2230
\ *G Output 'n' spaces to the terminal, where n>0. For n<=0
\ ** no action is taken.
  begin
    dup #16 >
   while
    space-table 1+ #16 type
    #16 -
  repeat
  dup 0> if
    space-table 1+ over type
  endif
  drop
;

: >pos          \ +n --
\ *G Place cursor on current line to column n if possible.
  out @ - spaces
;

: BS            \ --
\ *G Output a destructive backspace sequence to the terminal.
\ ** If the cursor is not at column 0, ASCII characters 8, 32 and 8
\ ** are *\fo{EMIT}ted and the *\fo{USER} variable *\fo{OUT} is
\ ** decremented by one.
  out @ ?dup 0= if
    bell
  else
    bsout emit  space  bsout emit  1- out !
  then
;

: HEX           \ --                                             6.2.1660
\ *G Change current number conversion base to base 16.
  #16 base !
;

: DECIMAL       \ --                                             6.1.1170
\ *G Change current number conversion base to base 10.
  #10 base !
;

: BINARY        \ --
\ *G Change current number conversion base to base 2.
  2 base !
;


\ =================
\ *N Numeric output
\ =================
\ *P These words are used for displaying numbers.

: HOLD          \ char --                                       6.1.1670
\ *G Insert the ASCII 'char' value into the pictured numeric output
\ ** string currently being assembled.
  -1 hld +!  hld @ c!
;

: HOLDS         \ caddr len --
\ *G Insert the string *\i{caddr/len} into the pictured numeric
\ ** output string currently being assembled.
  dup hld -!  hld @ swap move
;

: SIGN          \ n --                                          6.1.2210
( *G Insert the ASCII 'minus' symbol into the numeric output string if  )
( ** 'n' is negative.                                                   )
  0< if [char] - hold  then
;

: #             \ ud1 -- ud2                                    6.1.0030
\ *G Given a double number on the stack this will add the next digit to
\ ** the pictured numeric output buffer and return the next double
\ ** number to work with. N.B. the output string is built from
\ ** right (lsd) to left (msd).
  base @ mu/mod rot 9 over <
  if  7 +  then
  [char] 0 + hold
;

: #S            \ ud1 -- ud2                                    6.1.0050
\ *G Keep performing *\fo{#} until all digits are generated.
  begin  #  2dup or 0=  until
;

: <#            \ --                                            6.1.0490
( *G Begin definition of a new numeric output string buffer.            )
  pad hld !
;

: #>            \ xd -- c-addr u                                6.1.0040
( *G Terminate defnition of a numeric output string. Returns address    )
( ** and length of the ASCII result.                                    )
  2drop  hld @ pad over -
;

: .BYTE         \ b --
\ *G Display the byte *\i{b} as a 2 digit hex number.
  base @ hex  swap
  0 <# # # #> type
  base !
;

: .WORD         \ w --
\ *G Display the 16 bit word 'w' as a 4 digit hex number.
  base @ hex  swap
  0 <# # # # # #> type
  base !
;

: .LWORD        \ dw --
\ *G Display the 32 bit long word 'dw' as an 8 digit hex number.
\ ** The two groups of four digits are separated by a ':'.
  base @ hex  swap
  0 <# # # # # [char] : hold # # # # #> type
  base !
;

: .DWORD        \ dw --
\ *G An 'Intel-ised' alias for *\fo{.LWORD}.
  .LWORD
;

64bit? [if]
: .XWORD        \ dx --
\ *G Display the 64 bit xlong word 'dx' as an 16 digit hex number.
\ ** The four groups of four digits are separated by ':' characters.
  dup #32 rshift .lword ." :" .lword
;
[then]

: .ASCII        \ char --
\ *G Output the supplied ASCII character 'char' via *\fo{EMIT} if
\ ** it is a  displayable character. Otherwise a period '.' is
\ ** output.
  $7F and  dup $20 $7E within? 0=
  if  drop $2E  then
  emit
;

: (u.)		\ u -- caddr len
\ *G Return the ASCII string corresponding to the unsigned number *\i{u}.
  0 <# #S #>
;

: (.)		\ n -- caddr len
\ *G Create an ASCII string for the the signed number *\i{n}.
  dup abs s>d <# #s rot sign #>
;

64bit? [if]
: (u.r)		\ u +n -- caddr len
\ *G Return the string corresponding to the unsigned number *\i{u}.
\ ** The string is right aligned in a field *\i{+n} characters wide.
  { | buff[ #160 ] -- }
  >r  (u.) dup r@ < if			\ -- caddr len
    buff[ r@ blank			\ fill field with spaces
    r@ over - buff[ + swap move		\ copy to right aligned field
    buff[ r@
  endif
  >syspad  r> drop
;
[then]
32bit? [if]
: (u.r)		\ u +n -- caddr len
\ *G Return the string corresponding to the unsigned number *\i{u}.
\ ** The string is right aligned in a field *\i{+n} characters wide.
  { | buff[ #80 ] -- }
  >r  (u.) dup r@ < if			\ -- caddr len
    buff[ r@ blank			\ fill field with spaces
    r@ over - buff[ + swap move		\ copy to right aligned field
    buff[ r@
  endif
  >syspad  r> drop
;
[then]

: UD.R          \ ud n --
\ *G Output the unsigned double number 'ud' using the current *\fo{BASE},
\ ** right justified to 'n' characters. Padding is inserted using
\ ** spaces on the left side.
  >r  <# #s #>  r> over - spaces type
;

: D.R           \ d n --                                       8.6.1.1070
\ *G Output the signed double number 'd' using the current *\fo{BASE},
\ ** right justified to 'n' characters. Padding is inserted using
\ ** spaces on the left side.
  >r  tuck dabs <# #s rot sign #>
  r> over - spaces type
;

: D.            \ d --                                         8.6.1.1060
( *G Output the double number 'd' without padding.                      )
  0 d.r space
;

: .             \ n --                                           6.1.0180
( *G Output the cell signed value 'n' without justification.            )
  s>d d.
;

: U.            \ u --                                           6.1.2320
\ *G As with *\fo{.} but treat as unsigned.
  0 d.
;

: U.R           \ u n --                                         6.2.2330
\ *G As with *\fo{D.R} but uses a single-unsigned cell value.
  0 swap d.r
;

: .R            \ n1 n2 --                                       6.2.0210
\ *G As with *\fo{D.R} but uses a single-signed cell value.
  swap s>d rot d.r
;


\ ===========================
\ *N Numeric input conversion
\ ===========================
\ *P VFX Forth provides a flexible number conversion system. It is
\ ** designed for application use as well as for compiling Forth
\ ** source code.

\ *P The ANS and Forth200x Forth standards specify that floating
\ ** point numbers must be entered in the form 1.234e5 and must
\ ** contain a point '.' and 'e' or 'E'. Double numbers
\ ** (integers) are terminated by a point '.'.

\ *P This situation prevents the use of the standard conversion words
\ ** in international applications because of the interchangable use of
\ ** the '.' and ',' characters in numbers. To ease this, VFX Forth
\ ** uses two system variables, *\fo{FP-CHAR} and *\fo{DP-CHAR},
\ ** to hold the characters used as the floating point and double
\ ** number integer indicator characters.
\ ** By default, *\fo{FP-CHAR} is initialised to '.' and *\fo{DP-CHAR}
\ ** is initialised to ',' and '.'. For ANS and Forth200x compliance,
\ ** you should set them as follows:

\ *E \ ANS standard setting
\ **   char . dp-char !
\ **   char . fp-char !
\ ** : ans-floats	\ -- ; for strict ANS compliance
\ **   [char] . dp-char !
\ **   [char] . fp-char !
\ ** ;
\ ** \ MPE defaults
\ **   char , dp-char c!
\ **   char . dp-char 1+ c!
\ **   0 dp-char 2+ c!
\ **   char . fp-char !
\ ** : mpe-floats	\ -- ; for VFX Forth v4.4 onwards
\ **   [char] , dp-char c!
\ **   [char] . dp-char 1+ c!
\ **   0 dp-char 2+ c!
\ **   [char] . fp-char !
\ ** ;
\ ** : mpe-floats	\ -- ; for VFX Forth before v4.4
\ **   [char] , dp-char !
\ **   [char] . fp-char !
\ ** ;

\ *P You can of course set these variables to any value that suits
\ ** your application's language and locale. Note that integer
\ ** conversion is always attempted before floating point conversion.
\ ** This means that if *\fo{FP-CHAR} and *\fo{DP-CHAR} contain
\ ** the same characters, floating point numbers must contain 'e'
\ ** or 'E'. If they are different, a number containg a character
\ ** in *\fo{FP-CHAR} will be successfully converted as a floating
\ ** point number, even if it does not contain 'e' or 'E'.

: DIGIT         \ char base -- 0 | n true
\ *G If the ASCII value *\i{char} can be treated as a digit for a
\ ** number within the number conversion base *\i{base}, i.e. in
\ ** the range 0..base-1, then return the digit and a TRUE/-1 flag,
\ ** otherwise return FALSE/0.
  swap upc [char] 0 -		\ base val -- ; SFP045
  dup 0< if
    2drop FALSE
  else
    dup 9 > if
      7 - dup #10 <
      if  nip 0 swap  then	\ force radix to 0 (make fail)
    then
    dup rot			\ -- val val base
    < if TRUE else drop FALSE then
  then
;

: SKIP-SIGN     \ addr1 len1 -- addr2 len2 t/f
\ *G Given the address and length of a string skip a leading plus or
\ ** minus symbol and return modified address and length. The flag
\ ** t/f is TRUE if a leading minus was found.
\ ** From build 2514 onwards, conversion is case insensitive.
  dup if				\ len1 <> 0 ; SFP104
    over c@ dup [char] + =
    swap [char] - =  dup >r or
    if  1 /string  then
    r>
  else
    0
  then
;

: +DIGIT        \ d1 n -- d2
\ *G Accumulate digit value n into double d1 to form d2 such that
\ ** d2=d1*base+n.
  swap base @ um* drop          \ accumulate into double
  rot base @ um*  d+
  1 #d +!  dpl @ 1+             \ incr. #digits, double?
  if  1 dpl +!  then            \ yes, incr. after d.p.
;

: isSep?	\ char addr -- flag
\ *G Return true if *\i{char} is one of the four bytes at *\i{addr}.
\ ** If less than than four bytes are needed, a zero byte acts as
\ ** a terminator.
  cell bounds do
    i c@ 0= if
      drop false  unloop exit
    endif
    i c@ over = if
      drop true  unloop exit
    endif
  loop
  drop 0
;

: +CHAR         \ char -- flag
\ *G The character char is not a digit, so check to see if it is
\ ** another permitted character in a number such as a double
\ ** number separator. Return true if char is valid.
  dup dp-char isSep? if
    drop  dpl @ 0<			\ see if allowed
    if  dpl off  2  else  0  then
    dup #l !  exit
  endif
  ign-char isSep?
  if  true  else  false dup #l !  endif
;

: +ASCII-DIGIT  \ d1 char -- d2 flag
( *G Accumulate the double number d1 with the conversion of char,	)
( ** returning true if the character is a valid digit or part of an	)
( ** integer.								)
  dup base @ digit if           \ digit?
    nip +digit  #l @            \   yes, accumulate into double
  else
    +char                       \   not digit, try ","
  then
;

-short-branches

: (INTEGER?)    \ c-addr u --  d/n/- 2/1/0
  #d off  -1 dpl !  1 #l !
  skip-sign
  over if
    >r  0 0 2swap  bounds ?do
      i c@ +ascii-digit 0= ?leave
    loop
    r> ?dnegate
    #d @ 0=  #l @ 0= or if
      #l off  2drop
    else
      #l @ 1 =  if  drop  then
    then
  else
    drop 2drop  #l off
  then
  #l @
;

\ SFP030...
: OverrideBase	\ caddr u -- caddr' u'
\ *G Used by *\fo{isInteger?} to force a *\fo{BASE} override. See
\ ** *\fo{isInteger?} below for details.
    dup 1 u> if				\ length > 1, check for 0xABCD
      base @ #18 < if			\ check to allow BASE=36 pathology ; SFP028
        2dup + 1 - c@ upc [char] H =	\ and ends in 'H' ; SFP045
        if  1-  hex  exit  endif	\ treat as HEX number
      endif
    endif
    case  over c@			\ look at leading character
      [char] 0 of
        dup 2 > if			\ must be at least 0X?
          base @ #33 < if		\ check to allow BASE=36 pathology ; SFP028
            over 1 + c@ upc [char] X =	\ SFP045
            if  2 /string  hex  then
	  then
	then
      endof
      [char] $ of  1 /string  hex      endof
      [char] # of  1 /string  decimal  endof
      [char] % of  1 /string  binary   endof
    endcase
;
\ ...SFP030

+short-branches

: isInteger?	\ caddr len -- d 2 | n 1 | 0
\ *G Attempt to convert the string *\i{caddr/len} to an integer.
\ ** The return result is either 0 for failed, 1 for a single-cell
\ ** integer return result above that cell or 2 above a double cell
\ ** integer. The ASCII number string supplied can also contain
\ ** number conversion base overrides. A leading $ enforces
\ ** hexadecimal, a leading # enforces decimal and a leading %
\ **enforces binary. Hexadecimal numbers can also be specified by
\ ** a leading '0x' or trailing 'h'. Character literals can be
\ ** obtained with 'x' where x is the character. A double number
\ ** contains one of the characters in the variable *\fo{DP-CHAR},
\ ** by default ',' and '.'.
  DUP IF				\ -- caddr len
\ SFP040...
    dup 3 = if				\ 'c' check
      over c@ [char] ' = if
        over 2 + c@ [char] ' = if
          drop 1 + c@ 1 exit
        endif
      endif
    endif
\ ...SFP040
\    2dup upper				\ SFP045
    base @ >r
    OverrideBase (INTEGER?)		\ SFP030
    r> base !
  ELSE
    2DROP  #L OFF  0
  ENDIF
;

: integer?      \ caddr -- d 2 | n 1 | 0
\ *G As *\fo{isInteger?} but takes a counted string.
  count isInteger?
;

: >NUMBER       \ ud1 c-addr1 u1 -- ud2 c-addr2 u2              6.1.0570
( *G Accumulate digits from string c-addr1/u1 into double number ud1	)
( ** to produce ud2 until the first non-convertible character is found.	)
( ** c-addr2/u2 represents the remaining string with c-addr2 pointing	)
( ** the non-convertible character. The number base for conversion is	)
( ** defined by the contents of *\fo{USER} variable *\fo{BASE}.		)
\ ** From build 1656 onwards *\fo{>NUMBER} is case insensitive.
  dup 0 ?do
    >r >r                       \ save count & addr for a mo ***JL003***
    r@ c@ upc                   \ get next char ; SFP026
    base @ digit if             \ convert to digit
      +digit  false             \ accumulate digit and go round again
    else
      true                      \ not digit so exit loop
    then
    r> r>                       \ retrieve the addr & count  ***JL003***
    rot                         \ get flag to top
    if  leave  then             \ exit from the loop immediately
    swap 1+ swap 1-             \ bump address & dec char count
  loop
;


\ ======================
\ *S More string words
\ ======================

: $.            \ c-addr --
\ *G Output a counted string to the output device.
  count type
;

((
: (")           \ -- a-addr
\ *G OBSOLETE and REMOVED.
  r>
  r> dup count + aligned >r
  swap >r
;
))

: (.")          \ --
\ Runtime action of ."
  r> count  2dup + aligned >r  type
;

: ."            \ "ccc<quote>"  --
\ *G Output the text up to the closing double-quotes character.
  [char] " word $.  ;
ndcs: ( -- )  compile (.")  ",  discard-sinline  ;

: ?cr		\ -- ; issue CR if required
  out @ c/line @ >=
  if  cr  endif
;

variable ^null	\ -- *null
\ *G Return a "pointer-to-null" address.
  0 ^null !

: wcount         \ addr1 -- addr2 len
\ *G Given the address of a 16-bit word-counted string in memory *\fo{WCOUNT} will
\ ** return the address of the first character and the length in
\ ** characters of the string.
  dup 2+ swap w@
;
compiler
: wcount         \ addr1 -- addr2 len
  dup 2+ swap w@
;
target

: (W")		\ -- waddr u ; step over caller's in line string
\ *G Returns the address and length of inline 16-bit word-counted
\ ** and 16-bit zero-terminated string.
\ ** Steps over the inline text to a cell-aligned boundary.
  r> wcount 2dup +  2+  aligned >r	\ step over count, string, 0, align
;

: ((W"))	\ -- waddr u ; dangerous factor!
\ *G A factor provided for the generation of long string actions
\ ** that have to step over an inline string. For example, to
\ ** define *\fo{W."} which uses a long string, you might compile
\ ** *\fo{(W.")} and then use *\fo{W",} to compile the inline
\ ** string. The definition of *\fo{(W.")} then might be:
\ *E : (W.")     \ --
\ **   ((W")) type
\ ** ;
  r>					\ caller's return address
  r> wcount 2dup +  2+ aligned >r
  rot >r
;

\ ***************
\ *S Linked lists
\ ***************

: link,		\ var-addr -- ; lay a link in a chain whose head is at var-addr
\ *G Add a link to a chain anchored at address var-addr. The old contents of
\ ** var-addr are added to the dictionary as the new link, and the address
\ ** of the new link is placed at var-addr.
  here  over @ ,  swap !
;
interpreter
: link,		\ addr -- ; update chain anchored at addr
  here  over @ ,  swap !
;
target

: AddLink	\ item anchor -- ; add a new item to end of chain, link is first
\ *G Used instead of *\fo{LINK,} when a new item in the chain
\ ** already exists, e.g. it has been *\fo{ALLOCATE}d. The item
\ ** is added to the start of the chain. Note that this word
\ ** requires the link to be at offset 0 in the item being added.
  2dup @ swap !				\ place old anchor at item+0
  !					\ item becomes new anchor
;

: AddEndLink	\ item anchor --
\ *G Add an *\i{item} (a structure) to the end of of the chain
\ ** anchored at *\i{anchor}. The link field must be at offset 0
\ ** in *\i{item}.
  begin
    dup @
  while					\ -- item prev
    @
  repeat
  over swap !  off			\ add at end of chain, zero item
;

: DelLink	\ item anchor -- ; remove item from chain
\ *G Delete/Remove an item from a chain achored at address anchor.
\ ** Note that this word requires the link to be at offset 0
\ ** in the item being removed.
  begin					\ -- item curr
    dup @ 0=				\ get out if at end of chain
    if  2drop  exit  endif
    2dup @ <>				\ while curr. does not point to target
   while				\ step through chain
    @ 					\ get next item
  repeat                                \ -- item link
\ set item that points to target to point to item pointed to by the target
  swap @  swap !			\ item's link into link
;

: ExecChain	\ anchor --
\ *G Execute the contents of chain with the following structure:
\ *C   link | xt | ...
\ *P Each word that is run has the stack effect
\ *C   ^link -- ^link
\ *P Where *\i{^link} is the address of the link field in the structure.
\ ** Thus, data that follows the xt can easily be accessed.
  @
  begin
    dup
  while
    dup cell + @ execute
    @
  repeat
  drop
;

: AtExecChain	\ xt anchor --
\ *G Add the word whose *\i{xt} is given to the chain anchored
\ ** at address *\i{anchor}.
  link, ,
;

: ShowChain	\ anchor --
\ *G Display the names of the words in the chain. If the word is
\ ** headerless, the name of the first header before it will be shown.
  @ begin
    dup
  while
    dup cell + @ ip>nfa cr .name
    @
  repeat
  drop
;


\ =======================================================================
( *> dict                                                               )
( *T Dictionary Organisation/Manipulation                               )
\ =======================================================================
( *P The heart of any Forth system is the dictionary. There are two     )
( ** types of word which act on the dictionary. The first are those     )
( ** words which act on definition headers, whilst the second set act on)
( ** dictionary "data-space."                                           )

\ ******************************
\ *S Definition Header Structure
\ ******************************
\ *P Definitions created with any standard defining word except
\ ** *\fo{:NONAME} have a header within the dictionary. The header
\ ** format is:
( *E Link | Ctrl | Count | <name> | Term | Line# | Info | XRef | Len/xt | Cgen )
( ** ------------------------------------------------------------------------- )
( ** Cell | Byte |  Byte | n Bytes| Byte |  Word | Word | Cell |  Cell  | Cell )
( ** ------------------------------------------------------------------------- )
( *D Link       Also called LFA. This field contains the address of the )
( **            "Ctrl Byte" of the previous word in the same wordlist.  )
\ *D Ctrl       The Control Byte: The top two bits are set.
\ **            The lower six bits are:
\ *E            Bit5    NDCS bit
\ **            Bit4    SYNONYM bit
\ **            Bit3    Smudge bit
\ **            Bit2    Immediate bit
\ **            Bit1    ** bit
\ **            Bit0    *** bit
\ *D Count      Also called the Count Byte. This field contains a byte
\ **            which is the length of the name. The address of
\ **            the byte is often called the "Name Field Address"
\ **		or NFA.
( *D <name>     A string of ASCII characters which make up the     )
( **            definition name.                                        )
( *D Term       All definition names are terminated with a 0 ASCII byte.)
( *D Line#      This field holds the line number of the first line of   )
( **            source which built the definition. The actual source    )
( **            file reponsible can be found from the SOURCES structure )
( **            described in the FILE section of this manual.           )
\ *D Info       MPE/CCS Reserved field.
\               low byte for MPE, high byte for CCS
\               bit 0: 1 = optimised
\ 		bits 7:4 = RS undershoot.
( *D XRef       Pointer to XREF Information                             )
\ *D Len/xt     Binary length of the word, or the xt of the code generator
\ **            for this word.
\ *D Cgen       Holds the address of additional code generator information.

64bit? [if] #29 [else] #17 [then] equ /AfterName
\ *G The number of bytes that follow the name of a word.


\ ============================
\ *S Header Manipulation Words
\ ============================
\ *P These words allow the manipulation and navigation of
\ ** dictionary headers.

$0001 constant HDRINFO_OPTIMISED    \ Definition is optimised!
$8000 constant HDRINFO_PLUGGED      \ Definition has been plugged

cell 2+ /AfterName + constant HEADSIZE	\ -- n
\ *G Return the size of a standard dictionary header minus the name text.

/AfterName 2 + equ minXt>Cntb	\ -- n
\ The minimum distance from an XT to a count byte, assuming at
\ least one character in the name.

: .NAME         \ nfa --
\ *G Display a definition's name given an NFA.
  $. space
;

: unalign       \ xt -- end-of-header
  begin
    dup 1 - c@ $CC =
   while
    1-
  repeat
;

CPU_ARM 0= [if]
: name>         \ nfa -- xt
\ *G Move a pointer from an NFA to the XT.
  count + /AfterName +
  begin dup c@ $CC = while 1+ repeat	\ skip INT3 padding
;
[else]
: name>         \ nfa -- xt
\ *G Move a pointer from an NFA to the XT.
  count + /AfterName + aligned
  begin dup @ $CCCC:CCCC = while 4+ repeat	\ skip INT3 padding
;
[then]

: ctrl>nfa      \ ^ctrl -- nfa
\ *G Move a pointer from the control byte to the name field.
  1+  ;
: nfa>ctrl      \ nfa -- ^ctrl
\ *G Move a pointer from the NFA to the control byte field.
  1-  ;
: ctrl>link     \ ^ctrl -- ^link
  cell-  ;
: link>ctrl	\ link -- ctrl
\ Move a pointer from the link field to the control field.
  cell +  ;

compiler
: ctrl>nfa      \ ^ctrl -- nfa
  1+  ;
: nfa>ctrl      \ nfa -- ^ctrl
  1-  ;
: ctrl>link     \ ^ctrl -- ^link
  cell-  ;
: link>ctrl	\ link -- ctrl
  cell +  ;
target

create dummyNFA \ -- addr
  ", ???"

: >name         \ xt -- nfa|xt
\ *G Move a pointer from an XT back to the NFA or name-pointer.
\ ** If the original pointer was not an XT or if the definition in
\ ** question has no name header in the dictionary the returned pointer
\ ** will be useless. Care should be taken when manipulating or scanning
\ ** the Forth dictionary in this way. If *\i{xt} is outside the
\ ** dictionary, a dummy for "???" is returned.
  dup inForth? if
    unalign  ip>nfa
  else
    drop  dummyNFA
  endif
;

: >BODY         \ xt -- a-addr                                   6.1.0550
\ *G Move a pointer from an xt to the body of a definition.
\ ** This should only be used with children of *\fo{CREATE}.
\ ** For example, if *\fo{FOOBAR} is defined by
\ ** *\fo{CREATE FOOBAR}, then the phrase *\fo{' FOOBAR >BODY}
\ ** would yield the same result as executing *\fo{FOOBAR}.
  >body
;

: BODY>         \ a-addr -- xt
\ *G The inverse of *\fo{>BODY}. Note that this word is only
\ ** valid for children of *\fo{CREATE} for which the data
\ ** area follows the code portion. For words created by
\ ** *\fo{VARIABLE}, *\fo{VALUE}, and *\fo{BUFFER:} amongst
\ ** others, the result may/will be invalid, especially if
\ ** the *\fo{+IDATA} switch is in use.
  0 >body -
;

32bit? [if]
: >line#        \ xt -- addr
( *G Move a pointer from an XT to the Line# field.                      )
  unalign 4 cells -
;

: >info         \ xt -- addr
\ *G Move a pointer from an XT to the header INFO field.
  unalign 4 cells - 2+
;
[then]

64bit? [if]
: >line#        \ xt -- addr
( *G Move a pointer from an XT to the Line# field.                      )
  unalign 3 cells - 4-
;

: >info         \ xt -- addr
\ *G Move a pointer from an XT to the header INFO field.
  unalign 3 cells - 2-
;
[then]


: >xref         \ xt -- xref
\ *G Move a pointer from a supplied XT to the XREF field in the header.
  unalign 3 cells -
;

\ N.B. the len field MUST be one cell before the gen field, or
\ the tokeniser code in Tokeniser.fth will break.

: >code-len     \ xt -- addr
\ *G Move a pointer from an XT to the length/xt field.
  unalign 2 cells -
;

: >code-gen     \ xt -- addr
\ *G Move a pointer from an XT to the optimiser token stream field.
  unalign cell-
;

: ZeroOptData	\ cl --
\ *G Zero the optimiser fields at *\i{code-len}.
  dup off  cell + off
;
compiler
: ZeroOptData	\ cl --
  dup off  cell + off
;
target

interpreter
: unpad         \ addr byte -- 'addr
  >r
  begin
    dup 1- c@ r@ =
  while
    1-
  repeat
  r> drop
;

: unalign       \ xt -- end-of-header
  $CC unpad
;

: >code-len     \ xt -- addr
  unalign 2 cells -
;

: >code-gen     \ xt -- addr
  unalign cell-
;

: ZeroOptData	\ cl --
  dup off  cell + off
;
target

: N>LINK        \ addr -- a-addr'
\ *G Move a pointer from a NFA field to the Link Field.
  1 - cell -  ;
: LINK>N        \ a-addr -- addr'
\ *G The inverse of *\fo{N>LINK}.
  cell + 1 +  ;
compiler
: N>LINK        \ a-addr -- a-addr'
  1 - cell -  ;
: LINK>N        \ a-addr -- a-addr'
  cell + 1 +  ;
target

: >LINK         \ xt -- a-addr'
\ *G Move a pointer from an XT to the link field address.
  >name n>link
;

: LINK>         \ a-addr -- xt
\ *G The inverse of *\fo{>LINK}.
  link>n name>
;

: name?         \ addr -- flag
\ *G Check to see if the supplied address is a valid NFA.
\ ** A valid NFA satisfies the following:
\ *(
\ *B Previous byte is hex Cx, bit 7 and 6 set,
\ *B Previous byte is at an aligned address,
\ *B String has a 0 terminator,
\ *B All characters within string are printable ASCII within range 33..255,
\ *B String Length is non-zero.
\ *)
  dup 1 chars - c@ $C3 and $C0 <>		\ check ctrl byte ; SFP024
  if  drop false  exit  then
  dup 1 chars -  cell 1- and			\ check ctrl byte is aligned ; SFP024
  if  drop false  exit  endif
  count                                         ( c-addr u -- )
  dup 0=         if 2drop FALSE exit then       \ length>0
  2dup + c@ 0<>  if 2drop FALSE exit then       \ 0 terminator?
  bounds ?do
    i c@ #33 u<					\ check all ASCII chars
    if  unloop  FALSE exit  then
  loop
  TRUE
;

\ WARNING! SOME PARTS OF OVLVFX ARE HERE!
Struct /OVI	\ -- len ; overlay information block
		\ MUST match BUILDOVERLAY
  int OVI.link		\ link to previously loaded overlay (initialised to 0)
  int OVI.magic		\ $5555AAxx
  int OVI.len		\ length of overlay
  int OVI.end		\ end of overlay - must precede start
  int OVI.start		\ start of overlay at OVI.link - just for speed
  int OVI.flags		\ bit 0 = 1 = in dictionary
  int OVI.loadhook	\ xt of load action
  int OVI.unloadhook	\ xt of unload action
  int OVI.ID		\ overlay unique ID
  0 field OVI.name	\ name follows as a counted and zero terminated string
end-struct

: InOvl?      \ addr1 -- addr2|0
\ *G Returns the overlay address (addr2) if the given address (addr1)
\ ** is within an overlay, otherwise returns 0.
  ovl-link @
  begin					\ -- addr *ovl
    dup
  while					\ -- addr *ovl
    2dup OVI.end 2@ within if		\ -- addr *ovl
      nip  exit
    then
    ovi.link @
  repeat
  nip					\ remove addr
;

: InForth?      \ addr -- flag
( *G Returns true if the given address is within the Forth dictionary	)
( ** or an overlay.							)
  dup inOvl? dup if
    nip  exit
  endif
  drop
  dup inLocals? dup if
    nip  exit
  endif
  drop
  firstname here within
;

: IP>NFA        \ addr -- nfa
\ *G Attempt to move backwards from an address within a definition to
\ ** the relevant NFA.
  MinXt>Cntb -			\ NFA (count byte) is at least this far back
  begin
    dup InForth? 0=
    if  drop  C" * outside dictionary * " exit  then
    dup name? 0=		\ -- addr flag
   while
    1-
  repeat
;

: xtoptimised?  \ xt -- flag
\ *G Is the definition with the given XT optimised?
  >info w@ HDRINFO_OPTIMISED and 0<>
;

: patched?      \ xt -- flag
\ *G Is the definition with the given XT patched/plugged?
  >info w@ HDRINFO_PLUGGED and 0<>
;

: patchxt       \ xtnew xtold -- ud patchflag
\ *G Patch the code for *\i{xtold} to jump to *\i{xtnew}. Return
\ ** the first 8 bytes of *\i{xtold} as *\i{ud}. *i{Patchflag}
\ ** is non-zero if *\i{xtold} had already been patched.
\ ** All optimisation for *\i{xtold} is disabled.
  dup >code-len zeroOptData		\ -- new old
  dup >info dup				\ -- new old ^info ^info
  w@ dup HDRINFO_PLUGGED and 0<> >r	\ -- new old ^info INFO -- ; R: patched? --
  HDRINFO_PLUGGED or swap w!		\ -- new old
  dup 2@ 2swap !jump
  r>
;

: unpatch       \ ud patchflag xt --
\ *G Reverse the effect of *\fo{PATCHXT}.
  tuck >info dup w@			\ ud xt pf ^info info --
  rot if HDRINFO_PLUGGED or else HDRINFO_PLUGGED invert and then
  swap w!				\ -- ud xt
  2!
;


\ =======================================================================
( **                                                                    )
( *S Definition and Data space access.                                  )
( **                                                                    )
( *P These words act upon definition information or dictionary data     )
( ** space.                                                             )
( **                                                                    )
\ =======================================================================

: LATEST        \ -- c-addr
( *G Return pointer past the Link of the last definition. Note that     )
( ** this is NOT the name field, but the control field of the		)
( ** dictionary header. Use *\fo{CTRL>NFA} to move to the name field.	)
  Last @
;
compiler
: LATEST        \ -- c-addr
  Last @
;
target

: latest-xt	\ -- xt
\ *G Returns the xt of the last definition to have a dictionary header.
  latest ctrl>nfa name>
;

: SMUDGE        \ --
\ *G Toggle the SMUDGE bit of the latest definition.
  $08 latest toggle-bit
;

: HideName	\ nfa --
\ *G Hide (make un*\fo{FIND}able) the word whose NFA is given.
  $08 swap nfa>ctrl set-bit
;

: RevealName	\ nfa --
\ *G Reveal (make *\fo{FIND}able) the word whose NFA is given.
  $08 swap nfa>ctrl clear-bit
;

: HIDE          \ --
\ *G Make the last word defined invisible to *\fo{SEARCH-WORDLIST},
\ ** *\fo{FIND} and friends.
  <HeaderLess> @ 0=
  if  $08 latest set-bit  then
;

: REVEAL        \ --
\ *G Make the last word defined visible to *\fo{SEARCH-WORDLIST},
\ ** *\fo{FIND} and friends.
  <HeaderLess> @ 0=
  if  $08 latest clear-bit  then
;

: >VOC-LINK     \ wid -- a-addr
  2 cells -
;

compiler
: >#THREADS     \ wid -- a-addr
;

: >THREADS      \ wid -- a-addr
  >#threads cell+
;
target

: >#THREADS     \ wid -- a-addr
\ *G Converts a wid wordlist identifier to address of the cell holding
\ ** the number of threads in the wordlist.
;
comp: drop  ;				\ currently a NOOP ; SFP079

: >THREADS      \ wid -- a-addr
\ *G Converts a wid wordlist identifier to address of the first thread
\ ** in the wordlist.
  >#threads cell+
;
comp: drop  postpone cell+  ;		\ currently CELL + ; SFP079

: WID-THREADS	\ wid -- addr len
\ *G Given a wid, return the address and length of its table of
\ ** threads.
  dup >threads  swap >#threads @ cells
;


: >wid-link     \ wid -- a-addr
  dup >#threads @ cells swap >threads +
;

: >VOCNAME      \ wid -- a-addr
  cell - @
;


\ If you change the hash function, you MUST also change the
\ hash functions in the cross compiler VfxHead.fth, the target
\ files KERNEL.FTH and REQDCODE.FTH to be the same.
[undefined] GenHash [if]	\ coded hash routine present?

\ $8FDB equ CRCPoly
 $A001 equ CrcPoly
\ $013C equ CrcPoly

create CRCTBL	\ -- addr ; 256 entry hash table
   #256 2* ALLOT

interpreter
: INIT-CRC16-TABLE	\ --
  #256 0 DO
    I  8 0 DO
      DUP 1 AND  >R
      1 RSHIFT  R>
      IF  CrcPoly XOR  THEN
    LOOP
    I 2*  CRCTBL + W!
  LOOP
;
target
INIT-CRC16-TABLE

compiler
: CRC-16	\ crc byte -- crc'
  OVER  XOR  255 AND  2* CRCTBL + W@  SWAP  8 RSHIFT  XOR
;

: CRChash1	\ caddr len -- hash
  dup 3 lshift -rot		\ crc caddr len
  bounds ?do			\ -- crc
    i c@ crc-16
  loop
  $FFFF and
;

: GenHash	\ caddr len -- hash
  CRChash1
;
target

[then]

: HASH-THREAD   \ wid c-addr -- a-addr
\ c-addr contains a counted string
  count GenHash swap			\ form hash
  dup >#threads @ 1 - rot and cells     \ mask for #threads
  swap >threads +                       \ form thread addr
;

TRUE value warnings?	\ -- flag
\ *G Returns true if redefinition warnings are enabled.

: +warnings     \ --
\ *G Enable redefined warnings.
  true -> warnings?			\ SFP009
; immediate

: -warnings     \ --
\ *G Disable redefined warnings.
  false -> warnings?			\ SFP009
; immediate

0 value LastNameFound	\ -- nfa|0
\ *G Set by *\fo{SEARCH-WORDLIST} to contain the NFA of the last
\ ** word found, or zero if no word was found. Use of
\ ** *\fo{LASTNAMEFOUND} avoids having to use *\fo{>NAME} later.

Defer RedefHook	\ --
\ *G A hook available for handling redefinitions.
\ ** The NFA of the previous word is given by *\fo{LastNameFound},
\ ** and its xt by *\fo{Original-Xt}.

\ SFP029...
: (RedefHook)	\ --
\ *G The default action of *\fo{RedefHook}, which is to display the
\ ** name of the word being redefined.
  CR LastNameFound .NAME ." is redefined "
;
\ ...SFP029

: HEADER        \ caddr u --
  { | temp[ #256 ] -- }
  #255 umin temp[ uplace		\ headers are always upper case ; SFP045 SFP052
  temp[ count				\ SFP045
  warnings? if
    2dup current @ (search-wordlist) if	\ see if name exists
      -> original-xt			\ preserve xt of previous definition - see COMPILE-REF ; SFP009 SFP024
      RedefHook
    else
      0 -> original-xt
    then
  then

  here aligned cell+ 1 chars + place	\ put name at right place BEFORE changes
  align					\ ERASEs ; SFP020
  current @ here cell + 1 chars + hash-thread	\ find thread-addr
  dup @ ,                               \ lay old thread
  here swap !                           \ link this word
  here last !                           \ this is latest word
  $0C0 c,                               \ control byte ; SJC001 SFP085 SFP097
  <HeaderLess> off                      \ YES, there is a header!
  here c@ 1+ allot                      \ reserve space for name
  0 c,                                  \ 0 terminate name field
[ CPU_ARM ] [if]  align  [then]		\ SFP020
  line# @ w,                            \ lay line#                             \ SJC001
  ( Make Info Word )
  0
  Optimising @ if HDRINFO_OPTIMISED or then
  w,                                    \ lay info word
  0 ,                                   \ Default XREF Entry
  0 ,                                   \ code len | code gen xt | ndcs xt
  0 ,                                   \ code gen data
\  code-align                            \ SJC000 ; del SFP020
\  xt-align
;

Target_SArm_Twk   [IF]
: ($CREATE)     \ caddr u --
  header docreate,
;
[ELSE]
: ($CREATE)     \ caddr u --
\ *G Create a new definition in the dictionary with the name
\ ** described by *\i{caddr/u}. The phrase *\fo{S" foobar" ($CREATE)}
\ ** has the same effect as typing *\fo{CREATE foobar} at the
\ ** console.
  header data-align docreate,		\ SFP020
;
[THEN]

: $create-in	\ caddr len wid --
\ *G Create a new definition in the dictionary with the name
\ ** described by *\i{caddr/u} in the wordlist given by *\i{wid}.
  get-current >r  set-current		\ save and set CURRENT
  ($create)				\ like CREATE but takes caddr/len
  r> set-current			\ restore CURRENT
;

: $CREATE       \ c-addr --
\ *G As with *\fo{($CREATE)} but takes a counted string.
  count ($CREATE)
;

: CREATE        \ -- ; CREATE <name>
\ *G Create a new definition in the dictionary. When the new definition
\ ** is executed it will return the address of the definition's data area.
  parse-name ($create)			\ SFP045
;

: ndcs		\ --
\ *G Mark the last defined word as NDCS, i.e having "non-default
\ ** compilation semantics". NDCS words will
\ ** execute special behaviour during compilation.
  $20 latest set-bit
;

: ndcs:		\ --
\ *G Defines the compilation actions of an NDCS word after the
\ ** interpretation action has been defined. *\fo{NDCS:} sets flags,
\ ** starts compilation of a *\fo{:NONAME} definition and sets the
\ ** compilation action of the last word defined. Use this for code
\ ** generators for words that have different interpretation and
\ ** compilation actions, e.g. *\fo{IF} or *\fo{S"}. Such words
\ ** may parse or produce or consume items from the stack. NOTE that
\ ** the *\fo{NDCS: word must not contain the word it is applied to
\ ** because the word would be compiled before its compilation
\ ** word has been completed.
\ *E : ."    \ "ccc<quote>"  --
\ ** \ Output the text up to the closing double-quotes character.
\ **   [char] " word $.  ;
\ ** ndcs: ( -- )  compile (.")  ",  discard-sinline  ;
  ndcs  latest-xt >code-len >r
  :noname r@ !  r> cell+ off  !csp	\ set len field, clear Cgen field
;

: ndcs?    \ xt -- flag
\ *G Return true if the word at *\i{xt} is an NDCS word. Immediate
\ ** words are also NDCS words.
\ IMMEDIATE words do not return true.
  >name nfa>ctrl c@ $20 and 0<>
;

: IMMEDIATE     \ --                                            6.1.1710
\ *G Mark the last defined word as immediate. Immediate words will
\ ** execute whenever encountered regardless of *\fo{STATE}.
\ ** IMMEDIATE words are marked as NDCS.
  $04 latest set-bit  ndcs		\ IMMEDIATE and NDCS bits
  latest-xt dup >code-len 		\ -- xt ^codelen
  dup -rot !				\ -- ^codelen ; set NDCS action
  cell + off				\ clear token stream pointer
;

: Immediate?    \ xt -- flag
\ *G Return true if the word at *\i{xt} is immediate.
  >name nfa>ctrl c@ $04 and 0<>
;


\ ===========
\ *> kerneldf
\ *S Wordlists and Vocabularies
\ ===========
\ *P Wordlists and vocabularies are described in a separate chapter.

\ ======
\ *> wid
\ *T Search Order: Wordlists, Vocabularies and Modules
\ ======
\ *P The definitions within the Forth dictionary are divided into
\ ** groups called *\fo{WORDLIST}s. A wordlist is identified by a
\ ** unique number called a WID (Wordlist IDentifier), which is
\ ** returned when a wordlist is created by the word *\fo{WORDLIST}.

\ *P At any given time the system has a "search-order", which is an
\ ** array of WID values representing the wordlists which are searched.
\ ** This is the *\fo{CONTEXT} array. The system also uses one WID
\ ** to contain any new definitions. This is called the *\fo{CURRENT}
\ ** wid.

\ *P Vocabularies are named wordlists.
\ ** When a vocabulary is created by *\fo{VOCABULARY <name>} a
\ ** word is built which has a new wordlist. When *\fo{<name>} executes
\ ** the wordlist replaces the first entry in the search order

\ *P Modules are special wordlists for hiding implementation details
\ ** that should not be modified by application programmers.


\ *****************************
\ *S Wordlists and Vocabularies
\ *****************************

\ ===========
\ *N Creation
\ ===========

: WORDLIST      \ -- wid                              16.6.1.2460
\ *G Create a new wordlist and return a unique identifier for it.
  align here
  #threads @ dup ,                      \ lay default number of threads
  0 ?do 0 , loop                        \ zero allot threads
  wid-link @ , dup wid-link !
;

: VOCABULARY    \ -- ; VOCABULARY <name>
\ *G Create a *\fo{VOCABULARY} called *\fo{<name>}. When
\ ** *\fo{<name>} executes, its wordlist replaces the first entry
\ ** in the search order
  create
    here 3 cells + dup ,		\ pointer to wordlist
    voc-link @ ,  voc-link !            \ update voc-link
    latest ctrl>nfa ,                   \ pointer to name
    wordlist drop
  does>
    @ context !
;

: voc>wid       \ xt(voc) -- wid
\ *G Return the WID from a vocabulary with the XT supplied.
  >body @  ;
compiler
: voc>wid       \ xt(voc) -- wid
  >body @  ;
target
interpreter
: voc>wid       \ xt(voc) -- wid
  >body @  ;
target


\ ============
\ *N Searching
\ ============

also system definitions

\ The 2variable SEARCH-RANGE controls the scope of searching when
\ a word's source code is being rerun instead of calling the binary.
\ The first cell holds the upper search address. The second cell holds
\ the base address of the overlay, or 0 for the kernel/app.
\ The variable SEARCH-OVL holds the value of OVL-LINK at the time
\ the search range was first in force.
\ In order to avoid problems with redefinitions and multiple definitions
\ in other wordlists, the source inliner marks the overlay and highest
\ address in that overlay. Words that were compiled or loaded later
\ will not be found.

: inSearchRange?	\ nfa -- flag ; true if acceptable ; SFP012
\ always acceptable if no search range set
  search-range cell + @ -1 =		\ accept if not set
  if  -1 or  exit  endif
\ -- nfa ; process acceptable overlays
  search-ovl @
  begin					\ -- nfa ovl
    dup
   while				\ -- nfa ovl
    2dup ovi.end 2@ within if		\ nfa in this overlay?
      search-range cell + @ = if	\ in restricted overlay?
        search-range @ u<		\ test
      else
        -1 or
      endif
      exit
    endif
    ovi.link @				\ next overlay
  repeat
  drop
\ check kernel/app
  firstname search-range @ within
;

previous definitions

variable LVCOUNT	\ -- addr ; offset of integer local arg/value
variable FLVCOUNT	\ -- addr ; offset of FP local arg/value

1 value CheckSynonym?	\ -- flag
\ *G If true, words with the synonym bit set in the header will
\ ** return the original word's xt, otherwise the xt of the
\ ** child of *\fo{SYNONYM} will be returned. The setting
\ ** affects *\fo{SEARCH-WORDLIST} and any words that use it,
\ ** e.g. *\fo{'}, *\fo{[']} and *\fo{FIND}.

-short-branches
: (search-wordlist)	\ c-addr u wid -- 0 | xt 1 | xt -1
\ The guts of SEARCH-WORDLIST with no case checking. -1 is returned
\ for normal words and 1 is returned for IMMEDIATE words.
  0 -> LastNameFound
  dup 0= if				\ quick exit if wid=0
    nip nip  exit
  endif
  2 pick 2 pick GenHash  over @ 1- and	\ -- c-addr u wid thread#
  1+ cells + @				\ -- c-addr u ^ctrl ; get control byte from thread
  begin					\ -- caddr u ctrl
    dup
  while					\ -- caddr u ctrl
    ctrl>nfa				\ -- caddr u nfa
    dup nfa>ctrl c@ $08 and 0= if	\ if SMUDGE bit not set
      2dup c@ = if			\ -- caddr u nfa ; names the same *length*?
        dup 1+ 3 pick 3 pick s= if	\ -- caddr u nfa ; compare text
          dup [ also system ] inSearchRange? [ previous ] if
            nip nip			\ -- nfa
	    dup -> LastNameFound	\ to avoid later >NAMEs ; SFP024
            dup name>	             	\ -- nfa xt
            dup AddXRef			\ -- nfa xt
            swap nfa>ctrl c@		\ -- xt byte
            CheckSynonym? if		\ Check for aliases ; SFP085
              dup $010 and		\ alias? ; SFP085
              if swap >body @ swap then	\ find original xt ; SFP085
            then			\ SFP085
            $04 and			\ immediate?
            if  1  else  -1  then	\ -- xt +/-1
            exit
          then
        then
      then
    then
    n>link @				\ -- caddr u ctrl'
  repeat
  nip nip				\ -- 0 ; discard caddr/u
;
+short-branches

: SEARCH-WORDLIST       \ c-addr u wid -- 0 | xt 1 | xt -1    16.6.1.2192
\ *G Search the given wordlist for a definition. If the definition is
\ ** not found then 0 is returned, otherwise the XT of the definition
\ ** is returned along with a non-zero code. A -ve code indicates a
\ ** "normal" definition and a +ve code indicates an *\fo{IMMEDIATE} word.
  { | temp[ #256 ] -- }
  -rot
  #255 umin temp[ uplace  temp[ count	\ force upper case ; SFP045 SFP052
  rot (search-wordlist)
;

: hasLVs?	\ -- flag
\ Return true if current definition contains locals.
  lvcount @ flvcount @ or
;

[-short-branches
: Search-Context	\ c-addr len -- 0 | xt 1 | xt -1
\ *G Perform the *\fo{SEARCH-WORDLIST} operation on all wordlists
\ ** within the search order. Returns -1 for a "normal" word and
\ ** +1 for an *\fo{IMMEDIATE} word.
  {: | temp[ #256 ] -- :}
  dup if				\ if there is any search text
    #255 umin temp[ uplace		\ convert to upper case
    hasLVs? if				\ check locals if present
      temp[ count ['] localvars voc>wid (search-wordlist)
      ?dup if  exit  endif
    endif
    0  context vsize bounds do          \ with all word lists in search order:
      drop
      temp[ count i @ (search-wordlist)	\ search word list for text
      dup ?leave			\ if text is found then bail out now
    cell +loop                          \ on loop completion last search will have returned 0
    exit
  then
  nip  dup -> LastNameFound
;

: FIND		\ c-addr -- c-addr 0 | xt 1 | xt -1           6.1.1550
\ *G Perform the *\fo{SEARCH-WORDLIST} operation on all wordlists within
\ ** the current search order. This definition takes a counted string
\ ** rather than a c-addr/u pair. The counted string is returned as well
\ ** as the 0 on failure. On success, -1 is returned for normal words,
\ ** or 1 is returned for immediate words.
  {: | temp[ #256 ] -- :}		\ SFP045
  dup c@ if                             \ if there is any search text
    dup count temp[ uplace		\ convert to upper case ; SFP045
    hasLVs? if				\ check locals if present
      temp[ count ['] localvars voc>wid (search-wordlist)
      ?dup if  rot drop exit  endif
    endif
    0 context vsize bounds do           \ with all word lists in search order:
      drop
      temp[ count i @ (search-wordlist) dup \    search word list for text ; SFP045
      if  rot drop leave  then          \    if text is found then bail out now
    cell +loop                          \   on loop completion last search will have returned 0
    exit
  then
  0 dup -> LastNameFound
;
short-branches]

also root definitions


' forth equ OLDFORTH

\ Forth is redefined in ROOT so that it is always available, the vocabulary
\ 'Forth' is actually within itself.
: FORTH         \ --                                  16.6.2.1590
( *G Install Forth Wordlist into search-order.                          )
  oldforth execute
;
\ also forth definitions : forth forth ; previous definitions
\ cr ." This redefinition is OK!"

: FORTH-WORDLIST        \ -- wid                              16.6.1.1595
\ *G Return the WID of the *\fo{FORTH} wordlist.
  oldforth >body @
; also forth definitions : forth-wordlist forth-wordlist ; previous definitions

: ResetMinSearchOrder   \ --
\ *G Reset the minimum search-order. The minimum search-order
\ ** reflects a minimal set of WIDs which make up the search
\ ** order when *\fo{ONLY} is executed.
  mincontext vsize erase                \ setup shadow CONTEXT for minimum
  ['] root >body @ dup                  \ search-order (ROOT)
  mincontext vsize + cell - !
  mincontext !
  ['] Externals >body @                 \ search-order (+EXTERNALS)
  mincontext vsize + cell - cell - !
; also forth definitions : resetminsearchorder resetminsearchorder ; previous definitions

: >MIN-ORDER    \ wid --
( *G Add a given WID to the minimum search-order.                       )
  #vocs 0 ?do
    mincontext vsize + cell -
    i cells -
    dup @ 0= if
      ! unloop exit
    else
      drop
    then
  loop
  drop
; also forth definitions : >min-order >min-order ; previous definitions

: GET-CURRENT   \ -- wid                                      16.6.1.1643
( *G Return the WID for the wordlist which holds any definitions made   )
( ** at this point.                                                     )
  current @
; also forth definitions : get-current get-current ; previous definitions

: SET-CURRENT   \ wid --                                      16.6.1.2195
( *G Change the wordlist which will hold future definitions.            )
  current !
; also forth definitions : set-current set-current ; previous definitions

: GET-ORDER     \ -- widn...wid1 n                            16.6.1.1647
\ *G Return the list of WIDs which make up the current search-order.
\ ** The last value returned on top-of-stack is the number of WIDs
\ ** returned.
  0                                     \ voc counter
  context vsize cell- bounds swap
  do
    i @ ?dup                            \ not null
    if  swap 1+  then                   \ push under count & bump count
  cell negate
  +loop
; also forth definitions : get-order get-order ; previous definitions

: SET-ORDER     \ widn...wid1 n -- ; unless n = -1            16.6.1.2197
( *G Set the new search-order. The top-of-stack is the number of WIDs   )
( ** to place in the search-order. If N is -1 then the minimum search   )
( ** order is inserted.                                                 )
  context vsize erase                   \ wipe context area (empty order)
  dup 0< if
    drop
    mincontext context vsize move       \ reset minimum search order
  else
    ?dup if                             \ nothing to do if n=0
      cells vsize min                   \ ensure its not too big !!!
      context swap bounds
      do  i !  cell +loop               \ set wid into context
    then
  then
; also forth definitions : set-order set-order ; previous definitions

: ONLY          \ --                                          16.6.2.1965
\ *G Set the minimum search order as the current search-order.
  -1 set-order
; also forth definitions : only only ; previous definitions

: ALSO          \ --                                          16.6.2.0715
\ *G Duplicate the first WID in the search order.
  get-order ?dup
  if  over swap 1+ set-order  then
; also forth definitions : also also ; previous definitions

: PREVIOUS      \ --                                          16.6.2.2037
\ *G Drop the current top of the search order.
  get-order ?dup
  if  nip 1- set-order  then
; also forth definitions : previous previous ; previous definitions

: DEFINITIONS   \ --                                          16.6.1.1180
\ *G Set the current top of the search order as the current definitions
\ ** wordlist.
  get-order ?dup if
    swap set-current
    1- 0 ?do  drop  loop
  then
; also forth definitions : definitions definitions ; previous definitions

: VOC?          \ wid -- flag
( *G Return TRUE if 'wid' is actually a vocabulary                      )
  >r FALSE                      \ assume 'wid' is not a vocabulary
  voc-link @
  begin
    ?dup                        \ for all vocabularies:
  while
    dup r@ = if                 \   is 'wid' this vocabulary?
      2drop r> drop TRUE        \   found it so don't bother to
      EXIT                      \   continue searching
    then
    >voc-link @                 \   try the next vocabulary
  repeat
  r> drop
; also forth definitions : voc? voc? ; previous definitions

: .VOC          \ wid --
( *G Display the name of a vocabulary if the WID is a valid wordlist    )
( ** identifier associated with a vocabulary.                           )
  ?dup if                       \ valid wid<>0
    dup voc? if                 \   is the wid really a vocabulary?
      >vocname .name            \     display the vocabulary name
    else                        \   otherwise,
      u.                        \     all we can do is display value
    then
    space
  then
; also forth definitions : .voc .voc ; previous definitions

: ORDER         \ --
\ *G Display the current search-order. WIDs created with
\ ** *\fo{VOCABULARY} are displayed by name, others are displayed
\ ** as numeric representations of the WID.
  cr
  get-order 0 ?do  .voc  loop
  cr ." Current: " get-current .voc cr
; also forth definitions : order order ; previous definitions

: VOCS          \ --
\ *G Display all vocabularies by name.
  cr
  voc-link @                    \ fetch first vocab.
  begin
    ?cr
    dup >vocname .name          \ display its name
    >voc-link @ dup 0=          \ try next one
  until
  drop
  cr
; also forth definitions : vocs vocs ; previous definitions

: WIDS          \ -- ; display wordlists by address or VOC name
( *G Display all created wordlists by address or vocabulary name. )
  cr
  wid-link
  begin
    @ ?dup
   while
    ?cr
    dup .voc
    >wid-link
  repeat
  cr
; also forth definitions : wids wids ; previous definitions

previous definitions

\ SFP067...
: -ORDER	\ wid --
\ *G Remove all instances of the given wordlist from the
\ ** *\fo{CONTEXT} search order.
  >R GET-ORDER R>			\ -- wid1 ... widn n wid
  0 >R BEGIN
    SWAP ?DUP
   WHILE
    1- SWAP ( wid...wid n wid)
    ROT 2DUP =
    IF  DROP  ELSE  R> SWAP >R 1+ >R  THEN
  REPEAT
  DROP  R> DUP BEGIN			\ -- n n
    ?DUP
   WHILE
    1- R> -ROT
  REPEAT
  SET-ORDER
;

: +ORDER	\ wid --
\ *G The given wordlist becomes the top of the search order. Duplicate
\ ** entries are removed.
  DUP -ORDER  >R GET-ORDER R> SWAP 1+ SET-ORDER  ;

: ?ORDER	\ wid -- flag
\ *G Return true if the given wordlist is in the search order.
  >R GET-ORDER ( ... n ) R> 0 ROT 0 ?DO ( ... wid flag)
    ROT ROT  TUCK = ROT OR
  LOOP
  NIP
;
\ ...SFP067


\ =================
\ *N Removing words
\ =================

also system definitions

: trim-chain	\ start end anchor xt -- ; trim a chain
		\ where xt applies offset of link from start of structure.
		\ xt must have stack effect ( addr -- addr' )
		\ Link MUST point to start of structure
  >r
  begin					\ -- start end link
    dup @
   while				\ -- start end link
    3dup @ -rot within if		\ if link points to item to trim
      dup @ r@ execute @ over !		\ update link, and run link again
    else
      @ r@ execute			\ get next entry
    endif
  repeat
  3drop  r> drop
;

: trim-links	\ start end anchor -- ; trim a "proper" chain"
  ['] noop trim-chain
;

: trim-wid	\ start end wid -- ; remove words between start and end in wid
\  dup >threads swap >#threads @ cells
  wid-threads
  bounds ?do
    2dup i ['] ctrl>link trim-chain
  cell +loop
  2drop
;

: trim-wids	\ start end --
  wid-link				\ Part#1: Walk every wordlist asking for a trim
  begin					\ -- start end link
    @ ?dup
  while					\ -- start end wid
    3dup trim-wid
    >wid-link
  repeat
  2drop
;

variable prune-link	\ -- addr ; anchor for MARKER removal chain
variable remember-link	\ -- addr ; anchor for MARKER state save chain

: run-links	\ anchor --
  begin
    @ ?dup                              \ get next link
   while
    dup >r  cell+ @ execute  r>         \ execute required xt
  repeat
;

previous definitions

also system

: trim-dictionary	\ start end --
\ *G Unlink all definitions in the memory region from *\i{start}
\ ** to *\i{end}. See *\fo{MARKER} for more details of removing words
\ ** from the dictionary. The dictionary pointer *\fo{DP} and
\ ** *\fo{HERE} remain unchanged.
\ SFP034 ...
  prune-link run-links			\ execute chain *** MUST preserve: start end -- start end ***
  2dup prune-link trim-links		\ cut chains back
  2dup remember-link trim-links
\ ...SFP034
  2dup trim-wids				\ word lists
  2dup voc-link ['] >voc-link trim-chain	\ Vocabularies
  2dup wid-link ['] >wid-link trim-chain	\ Wordlists
  2dup res-link ['] cell+ trim-chain		\ resource definitions
  2dup import-func-link trim-links	\ EXTERNs
  2dup lib-link trim-links		\ DLL libraries
  2dup ColdChain trim-links		\ COLD actions
  2dup ExitChain trim-links		\ BYE Chain actions
  2dup TextChain trim-links		\ Messages ; SFP070
  2drop
;

: cut-dictionary	\ start --
\ *G Unlink all definitions in the memory region from *\i{start}
\ ** to *\i{HERE}. Reset the dictionary pointer to *\i{start}.
  dup here trim-dictionary  dp !
;

: prune:        \ --
\ *G Starts a nameless definition that is added to the prune chain
\ ** and is later executed by children of *\fo{MARKER}.
\ ** See *\fo{MARKER} for more details.
\ ** Pruning words are passed the start and end addresses of the
\ ** region being pruned. The stack action of the definition must be:
\ *C   start end -- start end
  prune-link link,  here 0 ,  :noname swap !  !csp  ;

: prunes	\ xt -- ; add xt to prune chain
\ *G Adds the xt to the prune chain that is executed by children
\ ** of *\fo{MARKER}. See *\fo{MARKER} for more details.
\ ** Pruning words are passed the start and end addresses of the
\ ** region being pruned. The stack action of *\i{xt} must be:
\ *C   start end -- start end
  prune-link link, ,
;

: remember:     \ --
\ *G Starts a nameless definition that is added to the remember
\ ** chain that is executed by *\fo{MARKER}. See *\fo{MARKER} for
\ ** more details.
\ ** The stack action of the new definition must be:
\ *C   --
  remember-link link,  here 0 ,  :noname swap !  !csp  ;

: remembers	\ xt -- ; add xt to remember chain
\ *G Adds *\i{xt} to the remember chain that is executed by
\ ** *\fo{MARKER}. See *\fo{MARKER} for more details.
\ ** The stack action of *\i{xt} must be:
\ *C   --
  remember-link link, ,
;

: marker	\ "<spaces>name"                        6.2.1850
\ *G *\fo{MARKER <name>} creates a word that when executed removes
\ ** itself and *\b{all} following definitions from the dictionary.
\ ** *\fo{MARKER} is the ANS replacement for *\fo{FORGET}.
\ ** *\fo{MARKER} automatically trims all vocabulary and
\ ** wordlist vocabulary-based chains. If you need to clean up your
\ ** data structures, you can add code to do this using the words
\ ** *\fo{PRUNE:}, *\fo{PRUNES}, *\fo{REMEMBER:} and *\fo{REMEMBERS}.
\ ** When *\fo{MARKER} runs, the 'remember' chain words are executed
\ ** to construct preservation data. When the child of *\fo{MARKER},
\ ** *\fo{<name>}, is run, all the words in the 'prune' chain are
\ ** executed to remove/restore the data to its previous state.
  last @  here
  create				\ does not affect CONTEXT or CURRENT
    ,                                   \ DP when i did it
    ,                                   \ LAST when I did it!
    get-current ,                       \ store CURRENT
    <id> @ ,                            \ Unique Identifier Seed
    here  VSIZE allot                   \ and SEARCH-ORDER
    context swap VSIZE move
    remember-link run-links		\ user chain to preserve dictionary state
  does>
    dup @ cut-dictionary		\ clean dictionary, PRUNE,  SFP070
    dup @ dp !				\ restore HERE
    dup 1 cells + @ last !		\ restore LAST
    dup 2 cells + @ set-current		\ restore CURRENT
    dup 4 cells + context VSIZE move	\ restore CONTEXT
    dup 3 cells + @ <id> !              \ restore Unique ID Seed value
    drop
;

: anew		\ " name" --
\ *G A variant of *\fo{MARKER} that executes a previous child of
\ ** *\fo{MARKER} of the same name if it exists, and then creates
\ ** the marker. This allows you to place *\fo{ANEW FOO} at the
\ ** start of a source file being debugged so that previous
\ ** versions of the code are always replaced.
  >in @                                 \ will reuse following name later
  get-token find                        \ look for previously defined MARKER
  if  execute  else  drop  endif
  >in !  marker
;

\ SFP043
: Empty		\ --
\ *G Remove all words added since the system was loaded or *\fo{SAVE}d.
  here init-dp @ u> if
    init-dp @ cut-dictionary		\ SFP070
  endif
;

: forget	\ "<spaces>name"                        15.6.2.1580
\ *G Used in the form *\fo{FORGET <name>}, *\fo{<name>} and all
\ ** following words are removed from the dictionary. This word
\ ** is marked as obsolescent in the ANS specification, and is
\ ** replaced by the extensible	and more powerful word *\fo{MARKER}.
  ' >link cut-dictionary		\ SFP070
;

: $forget       \ $ --
\ *G *\fo{FORGET} the word whose name is the given counted string.
\ ** See *\fo{FORGET} and *\fo{MARKER}.
  find if
    >link cut-dictionary		\ SFP070
  else
    #-13 throw
  then
;

previous


\ =================================
\ *N Processing words in a wordlist
\ =================================

: (MAX-DEF)     \ wid-copy -- addr c-addr
\ *G Returns addr and top definition pointer from a copy of a wordlist.
\ ** The thread is then truncated by one ready for the next call.
  0 0                                   \ clear result
  rot
  dup cell+ swap @ cells bounds         \ for all threads
  do
    i @  over u>                        \ if greater
    if
      2drop  i  i @                     \ replace current set
    then
  CELL +loop                            \ step on
;

[-short-branches
: WalkWordList  \ xt wid --
\ *G Walk through a wordlist calling the definition XT for each word.
\ ** The definitions are walked in reverse chronological order.
\ ** The definition at XT will be passed the THREAD# and NFA.
\ ** This provides a future-proof method of parsing through a wordlist.
\ ** It will be supported by future versions of the compiler.
\ ** The XT definition has the stack form:
\ *E : MyDef    \ thread# nfa -- flag ; Return TRUE to continue

  { xt wid | temp[ New#Thr 2+ cells ] -- }
  \ Note, Temp[ is big enough for the
  \ maximum number of threads + 1 cell
  \ for #threads
  \ Copy wordlist to temporary buffer
  wid temp[ over >#threads @ 1+ cells move

  begin
    temp[ (max-def) dup
  while
    ctrl>nfa                    \ t-addr nfa --
    over temp[ cell+ - cell/    \ t-addr nfa #thread --
    over XT execute
    FALSE = if 2drop exit then
    n>link @ swap !
  repeat
  2drop
;
short-branches]

: WalkAllWordLists      \ xt-to-call --
\ *G Call the given XT once for each *\fo{WORDLIST}. The callback
\ ** is given the WID and a flag and will return TRUE to continue
\ ** the walk or false to abandon it. The FLAG supplied will be
\ ** TRUE if the WID represents a *\fo{VOCABULARY} and FALSE if
\ ** the WID represents a child of *\fo{WORDLIST}.
\ *E : MyDef    \ wid flag -- t/f ; return TRUE to continue
  wid-link @
  begin
    ?dup
  while
    ( xt wid -- )
    2dup dup voc? rot execute
    false = if 2drop exit then
    >wid-link @
  repeat
  drop
;

internal
0 value walkerXt	\ -- xt ; xt for WALKWORDLIST
0 value walkerWid	\ -- wid ; wid being processed

: walkxt	\ wid flag -- t/f ; true to continue
  drop  dup -> walkerWid
  walkerXt swap WalkWordList
  true
;
external

: WalkAllWords	\ xt --
\ *G Walk through all wordlists calling the given XT for each word.
\ ** The definitions are walked in reverse chronological order of wordlists
\ ** and then by reverse chronological order within each wordlist.
\ ** When run, the XT will be passed the THREAD# and NFA.
\ ** This provides a future-proof method of parsing through all wordlists.
\ ** The XT definition has the stack form:
\ *E : MyDef    \ thread# nfa -- flag ; return TRUE to continue
  -> walkerXt
  ['] walkxt WalkAllWordLists
;

\ SFP086...
: traverse-wordlist  \ xt wid -- ; Forth2012
\ *G Walk through the wordlist identified by *\i{wid} calling the
\ ** definition *\i{xt} for each word. The words in the wordlist
\ ** are walked in reverse chronological order. The word defined
\ ** by *\i{xt} is passed an *\i{nt}, which in VFX Forth is
\ ** an NFA. The XT definition has the stack form:
\ *E : MyDef    \ nt -- flag ; Return TRUE to continue

  { xt wid | temp[ New#Thr 2+ cells ] -- }
  \ Note, Temp[ is big enough for the
  \ maximum number of threads + 1 cell
  \ for #threads

  \ Copy wordlist to temporary buffer
  wid temp[ over >#threads @ 1+ cells move

  begin
    temp[ (max-def) dup
  while                                 \ -- buff ^ctrl
    ctrl>nfa swap >r >r			\ -- ; R: -- buff nfa
    r@ XT execute 0=
    if  2r> 2drop  exit then
    2r> n>link @ swap !
  repeat
  2drop
;

: name>string	\ nt/nfa -- caddr len ; Forth2012
\ *G Given an NT/NFA return the name string.
  count
;

: name>interpret  \ nt/nfa -- xt ; Forth2012
\ *G Convert an NT/NFA to the corresponding xt.
  name>
;

: name>compile	\ nt/nfa -- xt1 xt2 ; Forth2012
\ *G Given an NT/NFA return *\i{xt1}, the xt of the word, and
\ ** *\i{xt2}, the word used to compile it. If *\i{xt1} is
\ ** immediate, *\i{xt2} is of *\fo{EXECUTE}, otherwise it is
\ ** of *\fo{COMPILE-WORD}.
  name> dup immediate?
  if  ['] execute  else  ['] compile-word  then	\ SFP097
;
\ ...SFP086

0 value DictBad	\ true if dictionary bad

internal
: (dict-bad?)	\ thread# nfa -- flag ; return TRUE to continue
  nip
  dup n>link @ ?dup if
    inForth? 0=
    if  dup -> DictBad  endif
  endif
  drop DictBad 0=
;
external

: CheckDict	\ --
\ *G Check the dictionary for corruption and if corrupt
\ ** perform a *\fo{#-418 THROW}.
  0 -> DictBad
  ['] (dict-bad?) WalkAllWords
  DictBad #-418 ?throw
;

internal

0 value xt>wid_searching
0 value xt>wid_lookfor
0 value xt>wid_result

: (xtinwid?)    \ #thread nfa -- continue?
  nip  name> xt>wid_lookfor = if
    xt>wid_searching to xt>wid_result
    false
  else
    true
  then
;

: (xt>wid)      \ wid flag -- continue?
  drop
  dup to xt>wid_searching
  ['] (xtinwid?) swap WalkWordList
  xt>wid_result 0=
;

external

: Xt>Wid        \ xt -- wid|0
\ *G Attempts to locate the wordlist which contains the given XT.
\ ** This word is designed for interpreter extensions and
\ ** tools - it is *\b{not} thread safe or re-entrant! *\fo{Xt>Wid}
\ ** searches all wordlists and vocabularies - it can be slow.
  to xt>wid_lookfor
  0 to xt>wid_result
  ['] (xt>wid) WalkAllWordLists
  xt>wid_result
;

\ SFP024...

internal

: UnhookFromWid \ wid nfa --
\ Remove word from wordlist. The *\i{nfa} must be in the
\ given wordlist. No error checking is performed.
  dup nfa>ctrl -rot		\ -- target wid nfa ; target control field
  hash-thread			\ -- target ^thread
  begin				\ find word that links to target
    2dup @ <>
  while
    @ ctrl>link
  repeat			\ -- target next-link
  swap ctrl>link @ swap !
;

: AttachToWid	\ wid nfa --
\ Attach a word whose *\i{nfa} is given to wordlist *\i{wid}.
\ The word whose *\i{nfa} is given may not be in a wordlist.
\ No error checking is performed.
  dup nfa>ctrl -rot		\ -- target wid nfa ; target control field
  hash-thread			\ -- target ^thread
  begin				\ find word that links to target
    2dup @ u<
  while
    @ ctrl>link
  repeat			\ -- target next-link
  2dup @ swap ctrl>link !       \ -- target next-link
  !
;

external

: MoveNameToWid	\ nfa new-wid -- okay?
\ *G Detach the the word whose *\i{nfa} is given from its wordlist and
\ ** attach it to the wordlist specified by *\i{new-wid}. The word
\ ** is attached to the new WID at the correct place in a thread
\ ** to match its original chronological origin.
\ ** *\i{Okay?} is returned true if the operation was successful.
\ 1) Get owner word-list, fail if not possible
  over name> xt>wid ?dup 0= if
    2drop false  exit	        \ -- 0
  then
  \ nfa new-wid old-wid --
\ 2) Detach definition from its owning WID
  rot tuck			\ -- new-wid nfa old-wid nfa
  UnhookFromWid			\ -- new-wid nfa
\ 3) Hook definition to end of new WID
  AttachToWid			\ --
  true				\ -- -1
;

\ ...SFP024
\ SFP091...
: changeNameWid	{ nfa oldwid newwid -- }
\ *G Move the word whose *\i{nfa} is given from the wordlist
\ ** *\i{oldwid} to the wordlist *\i{newwid}. No error checking
\ ** is performed. *\fo{ChangeNameWid} is much faster than
\ ** *\fo{MoveNameToWid}.
   oldwid nfa unhookFromWid  newwid nfa attachToWid
;
\ ...SFP091


\ ===========
\ *> kerneldf
\ *S Input Specification and Parsing
\ ===========
\ *P The Forth interpreter operates on a "terminal input buffer".
\ ** This buffer is parsed space-delimited token by token by the
\ ** system. Standard words exist for managing the source of the
\ ** text.

0 value SOURCE-ID                               \                6.2.2218
\ *G *\fo{SOURCE-ID} describes the method used to refill the terminal input
\ ** buffer. If the value is "0" the input source is the console, a
\ ** value of "-1" indicates the input source is a string - via
\ ** *\fo{EVALUATE} - any other value is taken to be a file-id for source
\ ** inclusion from a text file.

: TIB           \ -- c-addr                                     6.2.2290
\ *G Returns the address of the terminal input buffer. Note that
\ ** tasks requiring user input must initialise the *\fo{USER}
\ ** variable *\fo{'TIB}. New code should use *\fo{SOURCE} and
\ ** *\fo{TO-SOURCE} instead for ANS Forth compatibility.
  'tib @  ;
comp: drop  postpone 'tib  postpone @  ;
compiler
: tib  'tib @  ;
target

tib-len constant tib-len	\ -- u
( *G Returns the size of the console input buffer. )

: SOURCE        \ -- c-addr u                                   6.1.2216
\ *G Returns the address and length of the current terminal input
\ ** buffer contents.
  'tib @ #tib @
;
compiler
: SOURCE        \ -- c-addr u                                   6.1.2216
  'tib @ #tib @
;
target

: TO-SOURCE     \ c-addr u --
\ *G Set the address and length of the system terminal input buffer.
  #tib ! 'tib !
;
compiler
: TO-SOURCE     \ c-addr u --
  #tib ! 'tib !
;
target

: SAVE-INPUT    \ -- xn..x1 n                                    6.2.2182
\ *G Save all the details of the input source onto the data stack.
\ ** If it later becomes necessary to discard the saved input,
\ ** *\fo{NDROP} will do the job. If you want to move the data to
\ ** the return stack, *\fo{N>R} and *\fo{NR>} are available.
  source
  source-id
  blk @
  >in @
  line# @
  'SourceFile @
  source-line-pos 2@
  9
;

-short-branches
: RESTORE-INPUT \ xn..x1 n -- flag                               6.2.2148
\ *G Attempt to restore input specification from the data stack.
\ ** If the stack picture between *\fo{SAVE-INPUT} and *\fo{RESTORE-INPUT}
\ ** is not balanced, a non-zero is returned in place of *\i{n}. On
\ ** success a 0 is returned.
  9 = if                            	\ parameters are likely to be valid?
    source-line-pos 2!
    'SourceFile !
    line# !
    >in !  blk !  to source-id  to-source  \ set input source

\ SFP003...
    case  source-id
      0  of  endof
      -1 of  endof
             source  >in @
             source-line-pos 2@ source-id reposition-file drop
             source drop FILETIBSZ source-id read-line 3drop
	     >in !  to-source
    endcase
\ ...SFP003

    false                               \ return false flag for okay!
  else
    true                                \ return true flag, don't touch stack
  then
;
+short-branches

: QUERY         \ --                                             6.2.2040
\ *G Reset the input source specification to the console and accept a
\ ** line of text into the input buffer.
  -1 line# !
  tib tib-len 1- accept #tib !		\ allow for trailing space/0
  0 to source-id
  ( tib #tib @ to-source  )
  >in off
;

-short-branches
: REFILL        \ -- flag                                        6.2.2125
\ *G Attempt to refill the terminal input buffer from the current
\ ** source. This may be a file or the console. An attempt to refill
\ ** when the input source is a string will fail. The return result
\ ** is a flag indicating success with TRUE and failure with FALSE.
\ ** A failure to refill when the input source is a text file indicates
\ ** the end of file condition.
  blk @ 0= if
    case  source-id
      0  of  query TRUE  endof          \ REFILL from terminal
      -1 of  0 line# !  FALSE  endof	\ Cannot REFILL from string source
      DOCGEN_PREREFILL
      source drop FILETIBSZ rot
      dup file-position drop source-line-pos 2!
      Read-Line swap 0= or
      1 line# +!
      swap                      \ ior #bytes --
      source drop swap to-source
      >in off
      0=
      dup if DOCGEN_REFILL then
      0                         \ give ENDCASE something to DROP
    endcase
  else
    false                       \ cannot REFILL from block yet!
  then
;
+short-branches

: PARSE         \ char"ccc<char>" -- c-addr u                    6.2.2008
\ *G Parse the next token from the terminal input buffer using
\ ** <char> as the delimiter. The next token is returned as a
\ ** c-addr/u string description. Note that *\fo{PARSE} does not
\ ** skip leading delimiters. If you need to skip leading
\ ** delimiters, use *\fo{PARSE-WORD} instead.
  >r
  source >in @ /string          \ remainder of input is substring
  over swap r> scan             \ look for char
  >r over -                     \ subtract addresses to get length
  dup r> 0<> -                  \ if string found then bump >IN past char
  >in +!                        \ update >IN to reflect parsed text
;

: PARSE-WORD    \ char -- c-addr u
\ *G An alternative to *\fo{WORD} below. The returned string is a
\ ** c-addr/u pair rather than a counted string and no copy has
\ ** occured, i.e. the contents of *\fo{HERE} are unaffected.
\ ** The returned string is in the input buffer, which should not
\ ** be modified.
\ ** Because no intermediate global buffers are used *\fo{PARSE-WORD}
\ ** is more reliable than *\fo{WORD} for text scanning in
\ ** multi-threaded applications and in callbacks.
  >r  source tuck  >in @ /string  r@ skip
  over swap r> scan
  >r  over - rot  r> dup 0<> + - >in !
;

: parse-name	\ -- c-addr u ; Forth200x
\ *G Equivalent to *\fo{BL PARSE-WORD} above. *\b{Do not} modify
\ ** the returned string if you want to be compliant with the ANS
\ ** or Forth-2012 standards. *\fo{PARSE-NAME} can replace *\fo{BL WORD COUNT}
\ ** in most cases.
\ ** Because no intermediate global buffers are used *\fo{PARSE-NAME}
\ ** is faster and more reliable than *\fo{WORD} for text scanning in
\ ** multi-threaded applications and in callbacks.
  source tuck  >in @ /string  bl skip
  over swap bl scan
  >r  over - rot  r> dup 0<> + - >in !
;

: WORD          \ char"<chars>ccc<char>" -- c-addr               6.1.2450
\ *G Similar behaviour to the ANS *\fo{PARSE} definition but the returned
\ ** string is described as a counted string which is found at *\fo{HERE}.
  parse-word  here place here
;

: parse-leading	\ char --
\ *G skip over leading characters of char in the input stream.
\ ** Tab characters are treated as spaces.
  begin
    source >in @ tuck <= 		\ -- char caddr >in flag
    if  3drop  exit  then
    + c@				\ get character
    dup ATAB =				\ if character is TAB
    if  drop BL  endif			\ convert to space
    over =
  while
    >in incr
  repeat
  drop
;

: GET-TOKEN     \ "<name>" -- addr
\ *G A version of *\fo{BL WORD} in which the returned string is
\ ** converted to upper case.
  bl word dup count upper
;

: next-name	\ -- c-addr u
\ *G A version of *\fo{parse-name} that works across multiple lines.
\ ** If a name cannot be obtained, the input stream is *\fo{REFILL}ed.
  begin					\ --
    parse-name dup 0=			\ scan input, no token?
  while					\ -- char addr
    2drop  refill 0= #-411 ?throw	\ discard null, reload i/p
  repeat				\ -- char
;

: get-word	\ char -- c-addr
\ *G A version of *\fo{WORD} that works across multiple lines. If a word
\ ** cannot be obtained, the input stream is *\fo{REFILL}ed.
  begin					\ -- char
    dup word dup c@ 0=			\ scan input, no token?
  while					\ -- char addr
    drop  refill 0= #-411 ?throw	\ discard null, reload i/p
  repeat				\ -- char
  nip
;

: GetPathSpec   \ -- c-addr u | c-addr 0 ; 0 if null string
\ *G Parse the input stream for a file/path name and return
\ ** the address and length. If the name starts with a '"'
\ ** character the returned string contains the characters
\ ** between the first and second '"' characters but does
\ ** not include the '"' characters themselves. If you need
\ ** to include names that include '"' characters, delimit
\ ** the string with '(' and ')'. In all other cases a space
\ ** is used as the delimiting character. *\fo{GetPathSpec} does
\ ** not expand text macro names.
  bl parse-leading 			\ skip leading spaces
  >in @ >r
  bl parse dup 0=			\ check length
  if  r> drop  exit  then
  case  over c@				\ inspect first character
    [char] " of
      2drop  r> >in !  [char] " parse-word
    endof
    [char] ( of
      2drop  r> 1+ >in !  [char] ) parse-word	\ SFP014
    endof
    r> drop
  endcase
;

: "xxx"		\ "xxx" -- caddr len
\ *G Parse a string enclosed by quotes from the input stream, e.g.
\ *C   "Quoted string"
  [char] " parse 2drop			\ step up to first quote
  [char] " parse			\ string up to second quote
;


\ =================================
\ *> kerneldf
\ *S Support for constructing words
\ =================================

defer DOCOLON,          \ --
\ *G Compile the code required at entry to a colon definitions.
defer DOSEMICOLON,      \ --
\ *G Compile the code required at exit from a colon definitions by *\fo{;}.
defer Compile,          \ xt --                         6.2.0945
\ *G Compile the word specified by xt into the current definition.
\ ** Only for "normal" words that are not NDCS.
defer ndcs,		\ xt --
\ *G Perform the compilation action of an NDCS word. This may have
\ ** a stack effect or parse the input stream.
: compile-word	\ i*x xt -- j*x
\ *G Process an XT for compilation.
  dup ndcs?				\ NDCS or normal
  if  ndcs,  else  compile,  then
;

[undefined] (DOCOLON,) [if]
: (DOCOLON,)    \ --
;
[then]

[undefined] (DOEXIT,) [if]
: (DOEXIT,)     \ --
  $C3 c,
;
[THEN]

[undefined] (;CODE) [if]
: (;CODE)       \ -- ; R: a-addr --
\ *G Part of the run time action of *\fo{;CODE} and *\fo{DOES>},
\ ** executed when the defining word executes to create a new
\ ** child word. Patch the last word defined (by *\fo{CREATE}) to
\ ** have the run time action that follows immediately after
\ ** *\fo{(;CODE)}.
  r> latest-xt PatchCall		\ SFP020
  reveal
;
[then]

[undefined] DOCREATE, [if]
: DOCREATE,     \ --
\ *G Compile the run time action of *\fo{CREATE}.
  DOCREATE doLayAbscall			\ SFP002
;
[THEN]

: (compile,)	\ xt --
\ primitive version of COMPILE, used when unoptimised.
  dup >code-len @ $FFFF u> if		\ must have bit set in top 16 bits
    dup ndcs? 0= if			\ only normal words ; SFP098
      dup >code-len @ execute  		\ pass XT to compiling word
      flushCode  exit			\ in case optimiser used
    endif
  endif
  doLayAbsCall
;

: (ndcs,)	\ i*x xt -- j*x
\ *G Like *\fo{(COMPILE,)} but executes the NDCS action for a word
\ ** and may parse and/or have a stack effect during compilation.
  >code-len @ execute			\ execute NDCS/IMMEDIATE word
;

: LIT           \ -- x
( *G Code which when CALLED at runtime will return an inline cell       )
( ** value.                                                             )
  r> dup @ swap cell+ >r
;

#16 value /code-alignment	\ -- n
\ *G The default code alignment used by *\fo{FASTER} below.
\ ** Must be a power of two.

#16 value /data-alignment	\ -- n
\ *G The default data alignment used by *\fo{FASTER} below.
\ ** Must be a power of two.

/code-alignment value code-alignment	\ -- n
\ *G The start of a colon or *\fo{CODE} definition is aligned to
\ ** an alignment boundary defined by this value, which *\b{must}
\ ** be a power of two.

/data-alignment value data-alignment	\ -- n
\ *G The start of the data areas defined by CREATE and friends
\ ** is aligned to a boundary defined by this value, which *\b{must}
\ ** be a power of two.

: smaller	\ --
\ *G Selects smaller code using the minimum of alignment.
  4 to code-alignment
  4 to data-alignment
;

: faster	\ --
\ *G Selects faster code using the preset alignment in *\fo{/CODE-ALIGNMENT},
\ ** which will usually increase speed and the size of the dictionary headers.
  /code-alignment to code-alignment
  /data-alignment to data-alignment
;

: CODE-ALIGN    \ --
\ *G *\fo{ALIGN} filling with breakpoints (used for code boundaries).
  here dup				\ -- here here'
  code-alignment dup 1- rot +  swap negate and
  swap -
  begin
    dup
   while
    $CC c,  1-
  repeat
  drop
;

0 >body equ /create	\ -- n ; size of DOCREATE code

: data-align	\ --
\ *G *\fo{ALIGN} filling with breakpoints (used for data boundaries).
\ ** The alignment is followed by the run-time code for *\fo{CREATE}
\ ** and the data area is then aligned on the boundary.
  data-alignment 8 < if
    begin  here $3 and  3 <> while  $CC c,  repeat
    exit
  then
  begin
    here data-alignment 1- and		\ mask to alignment unit
    data-alignment /create - <>		\ check if data will be aligned
   while
    $CC c,
  repeat
;

: set-compiler  \ xt --
\ *G Set *\i{xt} as the compiler of the *\fo{LATEST} definition.
\ ** The word whose xt is given to *\fo{SET-COMPILER} receives the
\ ** *\i{xt} of the word it is to compile *\fo{( xt -- )}. This is
\ ** done so that information can be extracted from the word.
\ ** If you use this in a defining word use *\fo{INTERP>} rather
\ ** *\fo{DOES>}. See the VFX code generator section of the manual
\ ** for more details.
  latest-xt >code-len !
[ CPU_ARM ] [if]  FlushCache  [then]
;

: get-compiler  \ -- xt
\ *G Get *\i{xt} of the compiler of the *\fo{LATEST} definition.
\ ** If the return value is zero, the word has no compiler.
  latest-xt >code-len @
;


\ =================
\ *> kerneldf
\ *S Defining words
\ =================
\ *P These are word involved in the construct of new words.

target-only

: (:)		\ C: caddr len -- colon-sys ; Exec: i*x -- j*x ; R: -- nest-sys
\ *G Begin a new colon definition with the name given by
\ ** *\i{caddr/len}.
  2>r
  cleanup-locals  ?exec  !csp
  2r> header  code-align
  hide
  here last-colon-xt !
  docolon,  state on
;

: :		\ C: "<spaces>name" -- colon-sys ; Exec: i*x -- j*x ; R: -- nest-sys 6.1.0450
\ *G Begin a new definition called *\fo{name}.
  cleanup-locals  ?exec  !csp
  parse-name header code-align
  hide
  here last-colon-xt !
  docolon,  state on
;

: :NONAME       \ C: -- colon-sys ; Exec: i*x -- j*x ; R: -- nest-sys  6.2.0455
\ *G Begin a new colon definition which does not have a name.
\ ** After the  definition is complete the semi-colon operator
\ ** returns the XT of the newly compiled code on the stack.
  cleanup-locals
  ?exec
  align			\ SFP020
  0 , 0 ,               \ gives dummy code gen field for CCOMPILE,      \ SFP001
  <headerless> on       \ NO Header! Does not count as the LATEST definition
  0 -> original-xt	\ cannot be a redefinition ; SFP009
  here                  \ return XT
  dup last-colon-xt !
  docolon,              \ start compilation of : definition     \ SFP001
  state on
;

host&target

: ;             \ C: colon-sys -- ; Run: -- ; R: nest-sys --    6.1.0460
\ *G Complete the definition of a new 'colon' or *\fo{:NONAME} word.
  ?comp
  OperatorType @off #-402 ?throw	\ check for unconsumed operator
  <HeaderLess> @ 0=
  if  ?csp reveal  then
  drop-locals                           \ compiles in stack cleanup
  cleanup-locals                        \ cleans up local dictionary etc.
  dosemicolon,                          \ close colon definition        \ SFP001
  state off
  last-colon-xt off
  0 -> original-xt			\ out of any redefinition ; SFP009
[ CPU_ARM ] [if]  FlushCache  [then]
; IMMEDIATE

: DOES>         \ C: colon-sys1 -- colon-sys2 ; R: nest-sys --  6.1.1250
\ *G Begin definition of the runtime-action of a child of a defining word.
\ ** You may not use *\fo{RECURSE} after *\fo{DOES>}.
  drop-locals                           \ compiles in stack cleanup ; SFP023
  cleanup-locals                        \ cleans up local dictionary etc. ; SFP023
  last-colon-xt off
  COMPILE (;CODE)  dodoes doLayAbsCall	\ SFP002
; immediate

: INTERP>         \ C: colon-sys1 -- colon-sys2 ; R: nest-sys --
\ *G Begin definition of the runtime-action of a child of a
\ ** defining word that sets a compiler with *\fo{SET-COMPILER}
\ ** for its children between *\fo{CREATE} and *\fo{INTERP>}. You
\ ** may not use *\fo{RECURSE} after *\fo{INTERP>}. *\fo{INTERP>}
\ ** and *\fo{setCompiler} are used to avoid defining words with
\ ** state-smart run-time actions.
  drop-locals                           \ compiles in stack cleanup ; SFP023
  cleanup-locals                        \ cleans up local dictionary etc. ; SFP023
  last-colon-xt off
  COMPILE (;CODE)  dodoes DoLayAbsCall	\ SFP002
; immediate

: COMP:		\ --
\ *G Start a *\fo{:NONAME} word that is the compiler for the
\ ** previous word. When executed, the*\fo{:NONAME} word is passed
\ ** the xt of the word that is being compiled. NOTE that
\ ** the *\fo{COMP:} word must not contain the word it is applied to
\ ** because the word would be compiled before its compilation
\ ** word has been completed.
  latest-xt >code-len >r  :noname r@ !  r> cell+ off	\ SFP071
;

: >DOES         \ xt -- addr
\ *G Given the xt of the child of a defining word, return the
\ ** address of the run-time code.
  GetCallDest
;

: SynComp,	\ xt --
\ Compile a child of SYNONYM.
  >body @ compile-word			\ SFP097
;

target-only
: Synonym	\ "<new-name>" "<curdef>" --
\ *G Create a new definition which redirects to an existing one.
\ ** Normal dictionary searches for *\i{<new-name>} will return
\ ** the xt of *\i{<curdef>}.
  create
    hide ' reveal dup ,
    dup immediate?
    if  immediate  then
    ndcs?
    if  ndcs  then
    ['] SynComp, set-compiler
    $010 latest set-bit			\ set header's alias bit
  interp>
    @ execute
;
host&target

: Alias:	\ <"new-name"> <"curdef"> --
\ *G A synonym for *\fo{SYNONYM}.
  Synonym
;

: CONSTANT      \ x "<spaces>name"  -- ; Exec: -- x             6.1.0950
\ *G Create a new *\fo{CONSTANT} called *\fo{name} which has the
\ ** value x. When *\fo{NAME} is executed the value is returned.
  CREATE ,  does> @
;

: 2constant     \ n1 n2 -- ; Exec -- n1 n2                     8.6.1.0830
\ *G A double number equivalent of *\fo{CONSTANT}.
  create
    , ,
  does>
    dup cell+ @ swap @
;

: VARIABLE      \ "<spaces>name" -- ; Exec: -- a-addr           6.1.2410
\ *G Create a new variable called *\fo{name}. When *\fo{Name} is
\ ** executed the address of the data-cell is returned for use with
\ ** *\fo{@} and *\fo{!} operators.
  CREATE  0 ,  DOES>
;

: 2VARIABLE     \ "<spaces>name" -- ; Exec: -- a-addr         8.6.1.0440
\ *G A double number equivalent of *\fo{VARIABLE}.
  CREATE  0 , 0 , does>
;

: user          \ u "<name>" -- ; Exec: -- addr
\ *G Create a new *\fo{USER} variable called *\fo{name}. The 'u'
\ ** parameter specifies the index into the user-area table at which
\ ** to place the A *\fo{-405 THROW} occurs if there is no more
\ ** user space. The VFX kernel supports 4K bytes of *\fo{USER}
\ ** area space starting at offset 4096. *\fo{USER} variables are
\ ** located in a separate area of memory for each task or callback
\ ** procedure. They are equivalent to "thread local storage" in
\ ** Windows parlance. Use in the form:
\ *C   $1000 USER TaskData
  create
    dup USER-SIZE >= #-405 ?throw
    here cell+ , ,
  does>
    cell+ @ up@ +
;
\ This is a silly concession to embedded systems. The address pointer
\ ( here cell+ , ) should be removed. See also U# below and the cross
\ compiler's C_USERxxx and USER@ words.

: +USER         \ n "<spaces>name" -- ; Exec: -- user-a-addr
\ *G Create a new *\fo{USER} variable called *\fo{name} and
\ ** reserve N bytes of *\fo{USER} space, e.g. *\fo{8 CELLS +USER TaskStruct}.
\ ** N is rounded up to the next CELL boundary. See *\fo{USER}
\ ** above. The use of *\fo{+USER} avoids having to keep track of
\ ** assigned *\fo{USER} variable offsets.							)
\ ** *\fo{+USER} is non-ANS but for portability is trivially
\ ** defined by:
\ *E VARIABLE NEXTUSER
\ ** : +USER         \ n -- ; -- addr
\ **   NextUser @ user  aligned NextUser +!
\ ** ;
  NextUser @ user  aligned NextUser +!  ;
interpreter
: +USER         \ n "<spaces>name" -- ; Exec: -- user-a-addr
  NextUser @ user  aligned NextUser +!  ;
target

: u#		\ "<name>"-- u
\ *G Return the index of the *\fo{USER} variable whose name follows, e.g.
\ *C   u# S0
  ' >body cell + @
;

: Buffer:       \ n "name" -- ; [child] -- addr
\ *G Create a memory buffer called *\fo{name} which is 'n' bytes long.
\ ** When *\fo{name} is executed the address of the buffer is returned.
  Create
    Here Over Allot Swap Erase
;

defer s_val,    \ pfa -- ; compile a child of VALUE

variable next-operator  \ specifies the next operator number to be used by OPERATOR     \ SFP010
variable OperatorChain	\ -- addr ; anchors operator list

: BAD-METHOD    \ --
  #-404 throw
;

: (s_val,)	\ caddr --
\ Given the data address, compile the run time action for a VALUE.
  [compile] literal
  case  OperatorType @off
    0 of  postpone @  endof
    1 of  postpone !  endof
    2 of  endof
    3 of  postpone incr  endof
    4 of  postpone decr  endof
    5 of  postpone +!  endof
    6 of  postpone off  endof
    7 of  postpone -!  endof
    8 of  postpone drop  postpone cell  endof
    9 of  postpone on  endof
      bad-method
  endcase
;

: valInterp	\ addr --
\ Given a data address, interpret the VALUE.
  case  OperatorType @off
    0 of  @  endof
    1 of  !  endof
    2 of  endof
    3 of  incr  endof
    4 of  decr  endof
    5 of  +!  endof
    6 of  off  endof
    7 of  -!  endof
    8 of  drop cell  endof
    9 of  on  endof
      bad-method
  endcase
;

: value         \ n -- ; ??? -- ??? ; 6.2.2405
\ *G Create a variable with an initial value. When the *\fo{VALUE}'s
\ ** name is referenced, the value is returned. Precede the name
\ ** with *\fo{TO} or *\fo{->} to store to it. Precede the name
\ ** with *\fo{ADDR} to get the address of the data. The full list
\ ** of operators is displayed by *\fo{.OPERATORS ( -- )}.
\ *E 5 VALUE FOO                \ initial value of FOO is 5
\ **   FOO .                    \ will give 5
\ **   6 TO FOO                 \ new value is 6
\ **   FOO .                    \ will give 6
\ **   ADDR FOO @ .             \ will give 6
  create
    ,  ['] valComp, set-compiler
  interp>
    valInterp
;

: 2val,	\ addr --
\ Given the data address, compile the run time action for a 2VALUE.
  clit,
  case  OperatorType @off
    0 of  postpone 2@  endof
    1 of  postpone 2!  endof
    2 of  endof
    8 of  postpone drop  2 cells clit,  endof
      bad-method
  endcase
;

: 2valComp,	\ xt --
\ Given the xt, compile the run time action for a 2VALUE.
  >body 2val,  ;

: 2valInterp	\ addr --
\ Given a data address, interpret the 2VALUE.
  case  OperatorType @off
    0 of  2@  endof
    1 of  2!  endof
    2 of  endof
    8 of  drop 2 cells  endof
      bad-method
  endcase
;

: 2value	\ x1 x2 -- ; ??? -- ??? ; 6.2.2405
\ *G Create a cell pair with an initial value. When the *\fo{2VALUE}'s
\ ** name is referenced, the value is returned. Precede the name
\ ** with *\fo{TO} or *\fo{->} to store to it. Precede the name
\ ** with *\fo{ADDR} to get the address of the data.
  create
    , ,
    ['] 2valComp, set-compiler
  interp>
    2valInterp
;

: opCompiler	\ xt --
\ Compiler for children of OPERATOR.
  >body @ OperatorType !
;

target-only
: operator      \ n --
\ *G Define an operator with the given number.
  create
    here  swap ,  OperatorChain @ ,  OperatorChain !
    ['] opCompiler set-compiler
  interp>
    @ OperatorType !  ;
host&target

interpreter
: operator      \ n -- ; define an operator
  create
    here  swap ,  OperatorChain @ ,  OperatorChain !
    ['] opCompiler set-compiler
  interp>
    @ OperatorType !  ;
target

: Operator:     \ --
\ *G Define a new operator with automatic numbering.
  next-operator @ operator  next-operator incr
;

: op#		\ "name" -- n [int] ; "name" -- [comp]
\ *G Return or compile the operator number
  ' >body @  state @
  if  clit,  endif
; immediate

: .Operators	\ --
\ *G List the operators by number and name.
  OperatorChain @
  begin
    dup
   while
    cr  dup @ 4 .r space  dup body> >name .name
    cell+ @
  repeat
  drop
;

decimal
 0 operator default		\ fetch
 1 operator to			\ store
 1 operator ->			\ store operator
 2 operator addr		\ address operator
 3 operator inc
 4 operator dec
 5 operator add
 5 operator +to
 6 operator zero
 7 operator sub
 7 operator -to
 8 operator sizeof
 9 operator set
10 operator offsetof
11 operator +offsetof
12 OPERATOR FETCH
13 OPERATOR ADDR\CNT		\ address under count
14 OPERATOR TWIST		\ change endian of the data type
15 OPERATOR CONSTRUCT		\ build an instance of this type
15 OPERATOR MAKE		\ build an instance of this type

16 next-operator !

(( \ for DocGen
\ *P The standard VFX Forth set of operators is as follows. All
\ ** of them are supported by children of *\fo{VALUE}, but not
\ ** all are supported by other words that use operators.
\ *E  0 operator default      \ fetch
\ **  1 operator ->           \ store
\ **  1 operator to           \   "
\ **  2 operator addr         \ address operator
\ **  3 operator inc          \ increment by one
\ **  4 operator dec          \ decrement by one
\ **  5 operator add          \ add stack item to contents
\ **  6 operator zero         \ set to zero
\ **  7 operator sub          \ subtract stack item from contents
\ **  8 operator sizeof       \ return item size
\ **  9 operator set          \ set to -1
\ *P The following are provided to ease porting from other systems.
\ *E  5 operator +to          \ add stack item to contents
\ **  7 operator -to          \ subtract stack item from contents

: DEFER         \ Comp: "<spaces>name" -- ; Run: i*x -- j*x
\ *G Creates a new *\fo{DEFER}ed word. A default action, *\fo{CRASH}, is
\ ** automatically assigned. See *\fo{CRASH} and the section on
\ ** vectored execution.
;
))


\ ********************
\ *S Compilation tools
\ ********************
\ *P These words are mostly used for building new interpreting and
\ ** compiling words

: !CSP          \ x --
( *G Mark the position of the compilation stack pointer for later	)
( ** compile time checking.						)
  sp@ csp !
;

: ?CSP          \ --
( *G Check that the compilation stack pointer is the same as when last	)
( ** marked by *\fo{!CSP}.						)
  sp@ csp @ - #-22 ?throw
;

: ?EXEC         \ --
( *G Perform *\fo{#-403 THROW} if not in interpretation state.		)
  state @ #-403 ?throw
;

: ?COMP         \ --
( *G Perform *\fo{-14 THROW} if not in compilation state.		)
  state @ 0= #-14 ?throw
;

: ?STACK        \ --
( *G Perform *\fo{-4 THROW} if the data stack pointer is out of range.	)
  sp@ s0 @ u> #-4 ?throw
;

: ?UNDEF        \ flag --
\ *G Perform *\fo{-13 THROW} if flag is false/0, usually because a word is
\ ** undefined.
  0= #-13 ?throw
;

: [             \ --                                            6.1.2500
\ *G Switch compiler into interpreter state.
  state off
; IMMEDIATE

: ]             \ --                                            6.1.2540
\ *G Switch compiler into compilation state.
  state on  ( discard-sinline )		\ SFP048
;


\ ****************
\ *S Literal tools
\ ****************

: (clit,)       \ x -- ; compile single literal         \ SFP001
  compile lit  ,
;

: #LITERAL      \ n1 ... nn n  --
  ?dup if
    0 swap 1- do		\ n1..nn 0 n-1 --
      i roll  clit,
    -1 +loop
  then
;

: (FLITERAL)    \ -ve F: nn .. n1 --
  TRUE abort" Attempt to compile real number with no float support!"
;

: LITERAL       \ Comp: x -- ; Run: --  x                       6.1.1780
\ *G Compile a literal into the current definition. Usually used
\ ** in the form
\ *C   [ <expression ] LITERAL
\ *P inside a colon definition. Note that *\fo{LITERAL} is
\ ** *\fo{IMMEDIATE}.
  clit,
; IMMEDIATE

: DLITERAL      \ Comp: d -- ; Run: -- d
\ *G A double number version of *\fo{LITERAL}.
  swap clit, clit,
; IMMEDIATE

: 2LITERAL      \ Comp: x1 x2 -- ; Run: -- x1 x2              8.6.1.0390
\ *G A two cell version of *\fo{LITERAL}.
  [compile] dliteral
; IMMEDIATE

: DoIsNumber?     \ caddr len -- Nn .. N1 n | 0
\ *G Wrapper for *\fo{isNumber?} Used by the system to add the
\ ** XREF hook for literals. See *\fo{isNumber?}.
  isNumber? dup
  if  AddXrefLit  then
;


\ ==============
\ *S Finding xts
\ ==============

: '             \ "<spaces>name" -- xt                          6.1.0070
\ *G Find the xt of the next word in the input stream. An error occurs
\ ** if the xt cannot be found.
  bl word find ?undef
;

: [']           \ Comp: "<spaces>name" -- ; Run: -- xt          6.1.2510
\ *G Find the xt of the next word in the input stream, and compile it
\ ** as a literal. An error occurs if the xt cannot be found.
  ' [compile] literal
; IMMEDIATE

: 'syn		\ "<spaces>name" -- xt
\ *G Find the xt of the next word in the input stream. Unlike *\fo{'}
\ ** above, if the word is a child of *\fo{SYNONYM}, the xt of the
\ ** *\fo{SYNONYM} is returned, not the xt of the original word.
  CheckSynonym? >r  0 to CheckSynonym?
  '
  r> to CheckSynonym?
;

(( for DocGen
defer Compile,	\ xt --                                         6.2.0945
\ *G Compile the word specified by *\i{xt} into the current definition.
: EXECUTE       \ xt --                                         6.1.1370
\ *G Execute the word specified by *\i{xt}.
  >r
;
))

: [COMPILE]     \ "<spaces>name" -- ; 6.2.2530
\ *G Compile the *\b{compilation} action of the next word in the input
\ ** stream. *\fo{[COMPILE]} ignores the *\fo{IMMEDIATE} state of
\ ** the word. Its operation is mostly superceded by *\fo{POSTPONE}.
\ ** See also *\fo{[INTERP]} below.
  ' dup ndcs?
  if  >code-len @ doCall,  else  compile,  then
; IMMEDIATE

: [INTERP]	\ "<spaces>name" --
\ *G Compile the *\b{interpretation} action of the next word in
\ ** the input stream. *\fo{[INTERP]} is necessary when you want
\ ** the interpretation behaviour of words such as *\fo{S"} to
\ ** be compiled.
\ ** See also *\fo{[COMPILE]} above.
  ' postpone literal  postpone execute
; immediate


\ *********************************
\ *S Parsing strings and characters
\ *********************************

: $,		\ caddr len --
\ *G Lay the string into the dictionary at *\fo{HERE}, reserve
\ ** space for it and *\fo{ALIGN} the dictionary.
  dup >r
  here place
  r> 1 chars + allot
  align
;

: ",            \ "ccc<quote>"  --
\ *G Parse text up to the closing quote and compile into
\ ** the dictionary at *\fo{HERE} as a counted string.
\ ** The end of the string is aligned.
  [char] " parse $,
;

: ,"            \ "ccc<quote>"  --
\ *G An alias for *\fo{",} added because it is in common use.
  ",
;

: (C")          \ -- c-addr
\ Runtime action of C"
  r> dup count + aligned >r
;

: (S")          \ -- c-addr u
\ Runtime action of S"
  r> count  2dup + aligned >r
;

: (z")		\ -- addr
\ The run time action of *\fo{Z"} is to return the start
\ address of the zero terminated string and to step over it.
  r> dup
  begin
    dup c@
    swap 1+ swap
    0=
  until
[ CPU_ARM ] [if] aligned [then]
  >r
;

: S"            \ Comp: "ccc<quote>" -- ; Run: -- c-addr u      6.1.2165
\ *G Describe a string. Text is taken up to the next double-quote
\ ** character. The address and length of the string are returned.
  [char] " parse >syspad		\ SFP058
;
ndcs: ( -- )  compile (s") ",  discard-sinline  ;

: C"            \ Comp: "ccc<quote>" -- ; Run: -- c-addr        6.2.0855
\ *G As *\fo{S"} except the address of a counted string is returned.
  [char] " parse >SyspadC		\ SFP058
;
ndcs: ( -- )  compile (c") ",  discard-sinline  ;

: Z"            \ Comp: "ccc<quote>" -- ; Run: -- c-addr
\ *G A Version of *\fo{C"} which returns the address of a
\ ** zero-terminated string.
  [char] " parse >SyspadZ		\ SFP058
;
ndcs: ( -- )
  compile (z")  [char] " parse z$,
  [ CPU_ARM ] [if] align [then]
  discard-sinline  ;

\ SFP031...

create EscapeTable	\ -- addr
\ *G Table of translations for \a..\z.
\ If the size of this table is changed, also make changes
\ in Lib\ConfigTools.fth.
  7 c,		\ \a
  8 c,		\ \b
  char c c,	\ \c
  char d c,	\ \d
  #27 c,	\ \e
  #12 c,	\ \f
  char g c,	\ \g
  char h c,	\ \h
  char i c,	\ \i
  char j c,	\ \j
  char k c,	\ \k
  #10 c,	\ \l
  char m c,	\ \m
  #10 c,	\ \n (Unices only)
  char o c,	\ \o
  char p c,	\ \p
  char " c,     \ \q
  #13 c,	\ \r
  char s c,	\ \s
  9 c,		\ \t
  char u c,	\ \u
  #11 c,	\ \v
  char w c,	\ \w
  char x c,	\ \x
  char y c,	\ \y
  0 c,		\ \z

internal
: addEscape	\ caddr len dest -- caddr' len'
\ +G Add an escape sequence to the counted string at dest,
\ +* returning the remaining string.
  over 0=				\ zero length check
  if  drop  exit  endif
  >r					\ -- caddr len ; R: -- dest
  over c@ [char] 0 [char] 7 within? if	\ octal number?
    8 extractNum r> addchar  exit
  endif
  over c@ [char] x = if			\ hex number?
\    1 /string #16 extractNum r> addchar  exit
    1 /string				\ -- caddr len ; R: -- dest ; SFP087
    >r 2 #16 extractNum  nip r> 2- swap	\ -- caddr' len' u ; R: -- dest ; SFP087
    r> addchar  exit			\ SFP087
  endif
  over c@ [char] m = if			\ CR/LF pair
    1 /string  #13 r@ addchar  #10 r> addchar  exit
  endif
  over c@ [char] n = if			\ CR/LF pair?
    1 /string  eol$ count r> append  exit
  endif
  over c@ [char] a [char] z within? if
    over c@ [char] a - EscapeTable + c@  r> addchar
  else
    over c@ r> addchar
  endif
  1 /string
;
external

: parse\"	\ caddr len dest -- caddr' len'
\ *G Parses a string up to an unescaped '"', translating '\'
\ ** escapes to characters much as C does. The returned
\ ** translated string is a counted string at *\i{dest}
\ ** The supported escapes (case sensitive) are:
\ *D \a      BEL (alert)
\ *D \b      BS (backspace)
\ *D \e      ESC (escape, ASCII 27)
\ *D \f      FF (form feed, ASCII 12)
\ *D \l      LF (ASCII 10)
\ *D \m      CR/LF pair - for HTML etc.
\ *D \n      newline - CR/LF for Windows/DOS, LF for Unices
\ *D \q      double-quote
\ *D \r      CR (ASCII 13)
\ *D \t      HT (tab, ASCII 9)
\ *D \v      VT
\ *D \z      NUL (ASCII 0)
\ *D \"      "
\ *D \[0-7]+ Octal numerical character value, finishes at the
\ **         first non-octal character
\ *D \x[0-9a-f][0-9a-f]  Two digit hex numerical character value.
\ *D \\      backslash itself
\ *D \       before any other character represents that character
  dup >r  0 swap c!			\ zero destination
  begin					\ -- caddr len ; R: -- dest
    dup
   while
    over c@ [char] " <>			\ check for terminator
   while
    over c@ [char] \ = if		\ deal with escapes
      1 /string r@ addEscape
    else				\ normal character
      over c@ r@ addchar  1 /string
    endif
  repeat then
  dup 					\ step over terminating "
  if  1 /string  endif
  r> drop
;

: readEscaped	\ "string" -- caddr
\ *G Parses an escaped string from the input stream according to
\ ** the rules of *\fo{parse\"} above, returning the address
\ ** of the translated counted string.
  source >in @ /string tuck		\ -- len caddr len
  #256 getSyspad dup >r parse\"		\ SFP058
  nip - >in +!  r>
;

: \",		\ "string" --
\ *G Parse text up to the closing quote and compile into
\ ** the dictionary at *\fo{HERE} as a counted string.
\ ** The end of the string is aligned.
  readEscaped count $,
;

: .\"            \ "ccc<quote>"  --
\ *G As *\fo{."}, but translates escaped characters using
\ ** *\fo{parse\"} above.
  readescaped count type
;
ndcs: ( -- )
  readEscaped  compile (.")  count $,  discard-sinline  ;

: S\"		\ "string" -- caddr u
\ *G As *\fo{S"}, but translates escaped characters using
\ ** *\fo{parse\"} above.
  readEscaped count
;
ndcs: ( -- )
  readEscaped count  compile (s") $, discard-sinline  ;

: C\"		\ "string" -- caddr
\ *G As *\fo{C"}, but translates escaped characters using
\ ** *\fo{parse\"} above
  readEscaped
;
ndcs: ( -- )
  readEscaped  compile (c") count $,  discard-sinline  ;

: Z\"            \ "string" -- z$
\ *G As *\fo{Z"}, but translates escaped characters using
\ ** *\fo{parse\"} above
  readEscaped c>czterm
;
ndcs: ( -- )
  readEscaped  compile (z")  count z$,  discard-sinline  ;

\ ...SFP031

: z\",		\ "cc<quote>" --
\ *G Parse text up to the closing quote and compile into
\ ** the dictionary at *\fo{HERE} as a zero terminated string.
\ ** The end of the string is *\b{not} aligned.
  ReadEscaped $>z,
;

: CHAR          \ "<spaces>name" -- char                        6.1.0895
( *G Return the first character of the next token in the input stream.	)
( ** Usually used to avoid magic numbers in the source code.		)
  bl word 1 + c@
;

: [CHAR]        \ Comp: "<spaces>name" -- ; Run: -- char        6.1.2520
( *G Compile the first character of the next token in the input stream	)
( ** as a literal. Usually used to avoid magic numbers in the source 	)
( ** code.								)
  ?comp  char [compile] literal
; IMMEDIATE

: SLITERAL      \ comp: c-addr1 u -- ; Run: -- c-addr2 u     17.6.1.2212
( *G Compile the string c-addr1/u into the dictionary so that at run time )
( ** the identical string c-addr2/u is returned. Note that because of	)
( ** the use of dynamic strings at compile time the address c-addr2 is	)
( ** unlikely to be the same as c-addr1.				)
  compile (s")
  here over char+ allot align place
  discard-sinline
; IMMEDIATE


\ ***********
\ *S Comments
\ ***********

: \             \ "ccc<eol>" -- ; 6.2.2535
\ *G Begin a single-line comment. All text up to the end of the line is
\ ** ignored.
  AEOL word drop
; IMMEDIATE

: (             \ "ccc<paren>"  -- ; ( ... ) ; 6.1.0080
\ *G Begin an inline comment. All text up to the closing bracket
\ ** is ignored. In VFX Forth, the comment may extend over
\ ** several lines.
  begin
    source [char] ) scan nip
    if  [char] ) parse  2drop  exit  then
    refill false =
  until
; IMMEDIATE

: .(            \ "cc<paren>"  -- ; .( ... )                    6.2.0200
\ *G A documenting comment. Behaves in the same manner as *\fo{(} except
\ ** that the enclosed text is written to the console.
  [char] ) word $.
; IMMEDIATE

: ParseUntil    \ c-addr u --
\ *G Parse the input stream for a white-space delimited string,
\ ** *\fo{REFILL}ing as necessary until the string is found or
\ ** input is exhausted. Mostly used for block comments. The
\ ** string compare is case insensitive.
  2>r
  begin
    begin
      get-token count dup
    while			\ -- token toklen ; R: -- c-addr u
      2r@ istr=
      if  2r> 2drop  exit  then
    repeat
    2drop  refill
    dup if
      debug1 @
      if  source type cr  key? drop  then
    then
    false =
  until
  2r> 2drop
;

: ((            \ -- ; (( ... ))
\ *G Block comment operator. Any source following this is ignored
\ ** upto and including the terminator, '))', which must be white
\ ** space separated.
\ ))
  S" ))" ParseUntil
; immediate

: (*            \ -- ; (* ... *)
\ *G Block comment operator. Any source following this is ignored upto
\ ** and including the terminator, '*)', which must be white space separated.
  S" *)" ParseUntil
; immediate

: #!		\ -- ; #! /bin/bash
\ *G Begin a single-line comment. All text up to the end of the
\ ** line is ignored. This form is provided for Unix-based systems
\ ** whose shells use *\fo{#!} to specify the program to use with
\ ** the file.
  postpone \
; immediate

: StopIncluding	\ --
\ *G Used in a source file to skip the rest of a file, otherwise
\ ** behaves like *\fo{\}.
  postpone \
  source-id 0= if exit endif
  source-id -1 = if exit endif
  begin  refill  0= until
; immediate

: \\		\ --
\ *G A synonymm for *\fo{StopIncluding} above.
  postpone StopIncluding
; immediate


\ ========================
\ *S Generic stack get/set
\ ========================
\ *P What is called a stack here is actually a table whose first
\ ** element contains the number of items in the stack. The 'top'
\ ** of the stack is the last entry in the table.
\ *C   n | xn | ... | x1 |

#32 constant /max-stack	\ -- u
\ *G Maximum number of items in a stack.

: gs-check	\ u -- ; check #items on stack
  /max-stack u>= #-426 ?throw
;

: STACK		\ #items -- stack
  1+ ( size ) CELLS HERE SWAP ALLOT
  0 OVER ! \ empty stack
;

: stack:	\ "<name>" -- ; -- stack
\ *G Create a stack of *\fo{/max-stack} elenents. At run time
\ **the address of the stack structure is returned.
\ *C   stack: rec-stack1
  /max-stack 1+ cells buffer:
;

: get-stack	\ stack -- x1 ... xn n
\ *G Retrieve the contents of the stack, where xn is the top of
\ ** the stack.
  dup @ dup >r		\ -- stack #items
  swap cell +  swap cells  bounds
  ?do  i @  cell +loop
  r> ;

: set-stack	\ x1 ... xn n stack --
\ *G place n items on the empty stack, where xn is the
\ ** top of the stack.
  over gs-check				\ stack check
  2dup !  over if			\ -- x1 ... xn n stack
    dup cell + -rot			\ -- x1 ... xn stack+cell n stack
    swap cells +			\ -- x1 ... xn stack+cell stack+ncells
    do  i !  cell negate +loop
  else
    2drop
  then
;

: -stack	{: x astack -- :}
\ *G Remove all instances of the given item from the given stack.
  astack dup @ cells +			\ current item to inspect is last one
  4					\ length beyond current (residue)
  begin					\ -- curr residue
    over astack <>
   while
    over @ x = if			\ matches item to remove?
      2dup over cell+ -rot cmove	\ y: copy down
      -1 astack +!			\ count down contents
    else
      cell +				\ n: increase residue size
    then
    swap cell - swap 			\ step down
  repeat
  2drop
;

: (+stack-top)	\ x astack --
\ Add x to stack top
  dup @ gs-check  1 over +!  dup @ cells + !
;

: stack-up	\ astack --
\ Make space for another item at the bottom/start of the stack.
  dup cell + dup cell + rot @ cells cmove>
;

: (+stack-bot)	\ x astack --
\ Add x to stack bottom.
  dup @ gs-check  dup stack-up  1 over +!  cell + !
;

: +stack	\ x astack --
\ *G The given item is added as the top of the stack. Duplicate
\ ** entries are removed.
  2dup -stack  (+stack-top)
;

: +stack-bot	\ x astack --
\ *G The given item is added at the bottom of the stack. Duplicate
\ ** entries are removed.
  2dup -stack  (+stack-bot)
;

((
stack: foo
11 22 33 3 foo set-stack
55 foo -stack
44 foo +stack
55 foo +stack
33 foo -stack  55 foo -stack  11 foo -stack
foo 40 ldump
))


\ *******************
\ *S Text interpreter
\ *******************
\ *P From VFX 5.1 onwards, the text interpreter is built around
\ ** recognisers. The major advantage of recongnisers is that
\ ** they provide an extensible interpreter, and in particular
\ ** they permit different OOP packages to be installed and
\ ** removed at will, so permitting the various OOP packages
\ ** to coexist in one application.

\ *P Recognisers are a technique to allow the Forth text interpreter
\ ** to be extended and reconfigured for application purposes.
\ ** Text items are parsed to see if they fit into one or another
\ ** type. An action for the appropriate type is then performed.

\ *P A recogniser for a particular type of data consists of a
\ ** parsing word which determines whether the string matches
\ ** a particular data type. Associated with each parsing word
\ ** is a data structure that holds the interpret, compile and
\ ** postpone xts for that data type. On a match, the relevant
\ ** xt is executed.

\ *P Applications use a set of recognisers as required. In VFX,
\ ** minimum set is usually the Forth word finder (dictionary
\ ** look up) and the literal handler (single, double, float).
\ ** A set of recognisers is held as a table of xts of the parsing
\ ** words.

\ ============================
\ *N Recognizer type structure
\ ============================
\ *P The recognizer type structure is the interface between the
\ ** type information returned by the parser and the actions (xts)
\ ** contained in the type structure.

: RecType:	\ xtint xtcomp xtpost "name" -- ; -- struct
\ *G Create a  recogniser data structure associated with the three
\ ** actions (interpret, compile, postpone) associated with its data
\ ** type.
    Create rot , swap , ,  does>  ;	\ DOES> keeps cross-compiler happy

: RECTYPE>INT  ( rectype-token -- xt-interpret)             @ ;
\ *G Given a recogniser structure, return the interpretation xt
\ ** for it. Execution of the xt converts the data returned by
\ ** the parser into the form returned by the text interpreter.
: RECTYPE>COMP ( rectype-token -- xt-compile  )       cell+ @ ;
\ *G Given a recogniser structure, return the compilation xt
\ ** for it. Execution of the xt compiles the data returned by
\ ** the parser into the form used inside a colon definition.
: RECTYPE>POST ( rectype-token -- xt-postpone ) cell+ cell+ @ ;
\ *G Given a recogniser structure, return the postpone xt for it.


\ ==============================
\ *N Word and number recognition
\ ==============================

here equ start-recs

: ]]		\ --
\ *G Switch the compiler into *\fo{POSTPONE} state. All words between
\ ** *\fo{]]} and *\fo{[[} are *\fo{POSTPONE}d. The code below is
\ ** evalent to *\fo{postpone dup  postpone 5  postpone 6}.
\ *C : t  ]] dup 5 6 [[  ;
\ *P The *\fo{]] ... [[} notation is experimental and my be removed in
\ ** a future version
  -2 state !  ; immediate
: [[
\ *G Switch the compiler out of *\fo{POSTPONE} state.
  -1 state !  ; immediate
' [[ constant xt[[

: Undefined     \ c-addr u --
\ *G Default action taken by compiler when a parsed token is not
\ ** recognised as a word or number.
  #-13 throw
;

\ This block contains recognisers whose postpone action performs
\ the full action of POSTPONE.
: postnorm	\ xt --
\ postpone a normal, non-immediate, non-ndcs xt.
  clit,  ['] compile, compile,
;

: postimm	\ xt --
\ postpone an immediate word
  state @ abs 2 = if			\ POSTPONE mode?
    dup xt[[ =				\ xt of [[ ?
    if  drop  -1 state !  exit  then	\ get out, clear POSTPONE
  then
  doCall,				\ lay simple subroutine call
;

: postndcs	\ xt --
\ postpone an NDCS word
  >code-len @ doCall,
;

' undefined dup dup RecType: r:fail	\ -- struct
\ *G Contains the three actions for unrecognised words,
\ ** i.e. the fail case.

' execute ' compile, ' postnorm RecType: r:word
\ *G Contains the three actions for non-immediate words.

' execute ' ndcs, ' postndcs RecType: r:ndcs
\ *G Contains the three actions for NDCS words.

' execute ' execute ' postimm RecType: r:immediate
\ *G Contains the three actions for immediate words.

: rec-find	\ addr u -- xt r:word | r:fail
\ *G Searches a word in the search order (wordlist stack).
\ ** The xref utility code is contained inside the dictionary
\ ** search code.
  search-context dup 0= if
    drop r:fail
  else
    0< if				\ -- xt
      dup ndcs?
      if  r:ndcs  else  r:word  then
    else
      r:immediate
    then
  then ;

: xlit,		\ x1 .. xn n --
\ *G Lay a numeric literal.
  dup 0< IF  c#fliteral  ELSE  c#literal  THEN ; doNotSin

: post-xlit	\ x1 .. xn n --
\ *G Postpone a numeric literal.
  dup >r xlit, r> clit,			\ lay literal
  postpone xlit, ;			\ compile it

' drop  ' xlit,  ' post-xlit RecType: r:num	\ -- type
\ *G Contains the three actions for numbers, including single
\ ** integers, double integers and floating point numbers.

: rec-num	\ addr u -- n 1 r:num | d 2 r:num | r: -2 r:num | r:fail
\ *G The parsing portion that checks for a literal number.
  doIsNumber? dup IF  r:num  ELSE  drop r:fail  THEN
; doNotSin


\ =======================================
\ *N Main recognizer and text interpreter
\ =======================================

/max-stack 1+ cells buffer: main-recognizer	\ -- stack
\ *G The default stack used for recognizers.
  2 main-recognizer !
  ' rec-num main-recognizer cell + !
  ' rec-find main-recognizer 2 cells + !

main-recognizer value forth-recognizer
\ *G Set the current recognizer.

: get-recognizers	\ -- xt1 ... xtn n
\ *G Return the content of the recognizer stack.
  forth-recognizer get-stack ;
: set-recognizers	\ xt1 ... xtn n
\ *G Set the recognizer stack from the data stack.
  forth-recognizer set-stack ;

[-short-branches
: recognize	\ caddr len stack -- tokens data-type | fail-type
\ *G Apply a recognizer stack to a string, delivering optional
\ ** tokens and a data type indicator.
  dup @ if				\ stack not empty
    dup cell+ swap @ 1- cells  over +	\ -- caddr len start end ; start at top
    do					\ -- caddr len
      2dup i -rot 2>r			\ caddr len ptr ; r: -- caddr len
      @ execute dup r:fail <>		\ i*x type flag ; r: -- caddr len ; found?
      if  2r> 2drop  unloop exit  then
      drop  2r>				\ -- caddr len
    cell negate +loop
    2drop r:fail
  else
    3drop r:fail
  then
;
short-branches]

: parser	\ addr u -- i*x xt
\ *G Pass the string to the current recognizer stack and extract
\ ** the xt needed to process it.
  forth-recognizer recognize  state @ abs cells + @
;

: page-check	\ --
\ *G For legacy reasons, the VFX *\fo{INCLUDE} allows files with
\ ** page breaks (ASCII form feed character) at the start of the
\ ** line and replaces them with spaces.
  source if
    dup c@ FFEED =
    if  abl swap c!  else  drop  then
  else
    drop
  then
;

: (interpret)	\ --
\ *G The default action of *\fo{INTERPRET}.
[defined] FlushCache [if]  FlushCache  [then]
  page-check
  begin  ?stack parse-name dup
  while  parser execute
  repeat
  2drop
;

: postpone	\ "<name>" -- ; POSTPONE <name> ; 6.1.2033
\ *G Append the compilation semantics of name to the current definition,
\ ** i.e. the one containing *\fo{POSTPONE <name>}.
\ ** For a normal word, the current definition compiles *\fo{<name>}.
\ ** For an immediate word, the current definition will execute
\ ** *\fo{<name>} rather than it executing immediately.
\ ** *\fo{POSTPONE} delays the execution of a word by one time frame.
  parse-name forth-recognizer recognize  2 cells + @ execute
; immediate

here equ end-recs
cr ." Recognizer base for words and ints takes " end-recs start-recs - . ." bytes."


: EVALUATE      \ i*x c-addr u -- j*x                         6.1.1360
\ *G Process the supplied string as though it had been entered via the
\ ** interpreter.
  save-input n>r			\ SFP008
  to-source  -1 to source-id  >in off
  'SourceFile off			\ SFP047
  ['] interpret catch 			\ SFP010
  nr> restore-input drop		\ SFP008
  throw					\ SFP010
;

: assess	\ i*x c-addr u -- j*x
\ *G A version of *\fo{EVALUATE} that saves the current state,
\ ** switches to interpret mode, interprets the string and then
\ ** restores state.
  state @ >r  state off  save-input n>r
  to-source  -1 to source-id  >in off
  'SourceFile off
  ['] interpret catch
  nr> restore-input drop  r> state !
  throw
;

: init-quit	\ --
\ *G Perform the set up required before entering the text
\ ** interpreter.
  base @ -> SbBase
  depth -> SbDepth
  context @ -> sbContext
  current @ -> sbCurrent
  last-colon-xt off
  blk off  0 to source-id
  0 'SourceFile !
  0 op-line# !				\ SFP001
  [compile] [
;

defer QuitHook	\ --
\ *G A place holder for user defined clean up actions after a
\ ** *\fo{THROW) occurs in *\fo{QUIT}.

\ SFP093...
: reset-stacks	\ ?? -- ; F: ?? --
\ *G Reset the data and floating point stacks.
[defined] fsp! [if]
  s0 @ sp!  fs0 @ fsp!  reset-fpu
[else]
  s0 @ sp!  fs0 @ fsp !  reset-fpu
[then]
;
\ ...SFP093

-short-branches
: ((QUIT))	\ -- ; R: i*x  --
  begin
    init-quit  r0 @ rp!  exc0 @ excp !	\ SFP072
    begin
      cr refill
    while
      ['] interpret catch dup if
        .throw				\ error display
	clean-opt cleanup-locals	\ compiler state clean up
        OperatorType off		\ SFP055
        QuitHook			\ User defined clean up
        init-quit  r0 @ rp!  exc0 @ excp !  \ QUIT loop clean up ; SFP072
        reset-stacks
      else
        drop  state @ 0=
        if  .Prompt  then
      then
    repeat
  again
;
+short-branches

: (Quit)        \ --
  begin  ['] ((Quit)) catch drop  again	\ SFP078
\  ['] ((Quit)) catch drop recurse
;

: .SYSPROMPT    \ --
  ."  ok" depth ?dup if ." -" . then
  depth -> SbDepth
  base @ -> SbBase
  context @ -> sbContext
  current @ -> sbCurrent
;


\ ===========
\ *> kerneldf
\ *S DEFERred words and Vectored Execution
\ ===========
\ *P A *\fo{DEFER}red word is defined at one point in the
\ ** source and can have its action *\fo{ASSIGN}ed later both
\ ** during compile time and at execution time.
\ ** It is similar to a *\fo{VARIABLE} which has *\fo{@ EXECUTE}
\ ** appended to its execution semantics.

\ *P *\fo{DEFER} words are used to
\ *(
\ *B avoid forward references
\ *B define words whose actions are modified at run time.
\ *)

[undefined] CRASH [if]
: CRASH         \ --
\ *G The default action of a *\fo{DEFER}ed word. *\fo{CRASH} will
\ ** *\fo{THROW} a code back to the system.
  #-256 throw
;
[then]

: DEFER         \ Comp: "<spaces>name" -- ; Run: i*x -- j*x
\ *G Creates a new *\fo{DEFER}ed word. A default action, *\fo{CRASH}, is
\ ** automatically assigned.
  CREATE
    ['] CRASH ,
  does>
    @ execute
;

: IS		\ xt "<spaces>name" -- ; Forth200x
\ *G The second part of the *\fo{' xxx IS yyy} construct.
\ ** *\fo{IS} assigns the given XT to be the action of a
\ ** *\fo{DEFER}ed word *\fo{yyy} which is named in the
\ ** input stream.
  ' >body state @
  if  [compile] literal  postpone !  else  !  then
; immediate

: ASSIGN        \ "<spaces>name"  -- xt
\ *G A state smart word to get the XT of a word. The source word is
\ ** parsed from the input stream. Used as part of a
\ ** *\fo{ASSIGN xxx TO-DO yyy} construct.
  state @ if
    [compile] [']
  else
    '
  then
; IMMEDIATE

: TO-DO         \ xt "<spaces>name"  --
\ *G The second part of the *\fo{ASSIGN xxx TO-DO yyy} construct.
\ ** *\fo{TO-DO} assigns the given XT to be the action of a
\ ** *\fo{DEFER}ed word which is named in the input stream.
  ' >body state @
  if  [compile] literal  postpone !  else  !  then
; immediate

: action-of	\ "<name" -- xt ; Forth200x
\ *G Returns the xt of the current action of the *\fo{DEFER}red word
\ ** whose name is given. Use in the form *\fo{ACTION-OF <deferred-word>}
\ ** if you need to save and later restore the action of a word. The
\ ** xt returned by *\fo{ACTION-OF} can be used by *\fo{TO-DO}.
  state @ if
   ' >body 1 #literal
   ['] @ compile-word			\ ????? ; SFP097
  else
   ' >body @
  then
; immediate

((
: BEHAVIOR	\ "<spaces>name" -- xt
\ *G Returns the xt of the current action of the *\fo{DEFER}red
\ ** word whose name is given.
\ ** Since *\fo{BEHAVIOR} is just a synonym for *\fo{ACTION-OF},
\ ** OBSOLETE and REMOVED.
  postpone action-of
; immediate
))

: DEFER@	\ xt1 -- xt2				Forth200x
\ *G Given xt1, the xt of a *\fo{DEFER}red word, return xt2, the
\ ** action of xt1.
  >body @
;

: DEFER!	\ xt1 xt2 --				Forth200x
\ *G Xt1 becomes the action of the *\fo{DEFER}red word defined
\ ** by xt2.
  >body !
;


\ ==========
\ *> texterr
\ *T Exception and Error Handling
\ ==========
\ *S CATCH and THROW

\ *P *\fo{CATCH} and *\fo{THROW} form the basis of all VFX Forth
\ ** error handling. The following description of *\fo{CATCH} and
\ ** *\fo{THROW} originates with Mitch Bradley and is taken from
\ ** an ANS Forth standard draft.

\ *P *\fo{CATCH} and *\fo{THROW} provide a reliable mechanism for
\ ** handling exceptions, without having to propagate exception
\ ** flags through multiple levels of word nesting.  It is similar
\ ** in spirit to the "non-local return" mechanisms of many other
\ ** languages, such as C's *\b{setjmp()} and *\b{longjmp()}, and
\ ** LISP's *\b{CATCH} and *\b{THROW}. In the Forth context,
\ ** *\fo{THROW} may be described as a "multi-level *\fo{EXIT}",
\ ** with *\fo{CATCH} marking a location to which a *\fo{THROW} may
\ ** return.

\ *P Several similar Forth "multi-level *\fo{EXIT}"
\ ** exception-handling schemes have been described and used in
\ ** past years. It is not possible to implement such a scheme
\ ** using only standard words (other than *\fo{CATCH} and
\ ** *\fo{THROW}), because there is no portable way to "unwind"
\ ** the return stack to a predetermined place.

\ *P *\fo{THROW} also provides a convenient implementation
\ ** technique for the standard words *\fo{ABORT} and *\fo{ABORT"},
\ ** allowing an application to define, through the use of
\ ** *\fo{CATCH}, the behavior in the event of a system *\fo{ABORT}.

\ *N Example implementation
\ *P This sample implementation of *\fo{CATCH} and *\fo{THROW}
\ ** uses the non-standard words described below. They or their
\ ** equivalents are available in many systems.  Other
\ ** implementation strategies, including directly saving the value
\ ** of *\fo{DEPTH}, are possible if such words are not available.
\ *D *\fo{SP@}  ( -- addr )  returns the address corresponding to
\ **            the top of data stack.
\ *D *\fo{SP!}  ( addr -- )  sets the stack pointer to addr, thus
\ **            restoring the stack depth to the same depth that
\ **            existed just before addr was acquired by executing
\ **            *\fo{SP@}.
\ *D *\fo{RP@}  ( -- addr )  returns the address corresponding to
\ **             the top of return stack.
\ *D *\fo{RP!}  ( addr -- )  sets the return stack pointer to addr,
\ **            thus restoring the return stack depth to the same
\ **            depth that existed just before addr was acquired
\ **            by executing *\fo{RP@}.
\ *E nnn USER HANDLER   0 HANDLER !  \ last exception handler
\ ** : CATCH  ( xt -- exception# | 0 ) \ return addr on stack
\ ** 	SP@ >R	( xt )	\ save data stack pointer
\ ** 	HANDLER @ >R	( xt )	\ and previous handler
\ ** 	RP@ HANDLER !	( xt )	\ set current handler
\ ** 	EXECUTE	( )	\ execute returns if no THROW
\ ** 	R> HANDLER !	( )	\ restore previous handler
\ ** 	R> DROP	( )	\ discard saved stack ptr
\ ** 	0	( 0 )	\ normal completion
\ ** ;
\ ** : THROW  ( ??? exception# -- ??? exception# )
\ ** 	?DUP IF	( exc# )	\ 0 THROW is no-op
\ ** 		HANDLER @ RP!	( exc# )	\ restore prev return stack
\ ** 		R> HANDLER !	( exc# )	\ restore prev handler
\ ** 		R> SWAP >R	( saved-sp ) \ exc# on return stack
\ ** 		SP! DROP R>	( exc# )	\ restore stack
\ ** 		\	Return to the caller of CATCH because return
\ ** 		\	stack is restored to the state that existed
\ ** 		\	when CATCH began execution
\ ** 	THEN
\ ** ;
\ *P The VFX Forth implementation is similar to the one described
\ ** above, but is not identical.

\ *N Example use
\ *P If *\fo{THROW} is executed with a non zero argument, the effect
\ ** is as if the corresponding *\fo{CATCH} had returned it. In
\ ** that case, the stack depth is the same as it was just before
\ ** *\fo{CATCH} began execution. The values of the i*x stack
\ ** arguments could have been modified arbitrarily during the
\ ** execution of xt. In general, nothing useful may be done with
\ ** those stack items, but since their number is known (because
\ ** the stack depth is deterministic), the application may
\ ** *\fo{DROP} them to return to a predictable stack state.

\ *P Typical use:
\ *E : could-fail	\ -- char
\ **   KEY DUP [CHAR] Q =
\ **   IF  1 THROW  THEN
\ ** ;
\ **
\ ** : do-it		\ a b -- c
\ **   2DROP could-fail
\ ** ;
\ **
\ ** : try-it		\ --
\ **   1 2 ['] do-it CATCH IF
\ **     ( -- x1 x2 ) 2DROP ." There was an exception" CR
\ **   ELSE
\ **     ." The character was " EMIT CR
\ **   THEN
\ ** ;
\ **
\ ** : retry-it		\ --
\ **   BEGIN
\ **     1 2 ['] do-it CATCH
\ **    WHILE
\ **     ( -- x1 x2 ) 2DROP  ." Exception, keep trying" CR
\ **   REPEAT ( char )
\ **   ." The character was " EMIT CR
\ ** ;

\ ==========
\ *N Wordset
\ ==========

: >ep           \ x --
\ *G Push a cell item onto the exception stack.
  cell negate excp +!		\ update EXCP
  excp @ !			\ store as new top of EXCP stack
;

: ep>           \ -- x
\ *G Pop a cell item from the exception stack.
  excp @ @			\ get top of EXCP stack
  cell excp +!			\ update EXCP
;
compiler
: >ep           \ x --
  cell negate excp +!		\ update EXCP
  excp @ !			\ store as new top of EXCP stack
;

: ep>           \ -- x
  excp @ @			\ get top of EXCP stack
  cell excp +!			\ update EXCP
;
target

\ SFP078...
defer o_ABORT	\ i*x -- ; R: j*x --
\ *G The exception handler of last resort. Clears the stacks and
\ ** calls the *\fo{DEFER}red word *\fo{QUIT}.

: (o_ABORT)	\ i*x -- ; R: j*x --
  reset-stacks  quit			\ SFP093
;
\ ...SFP078

internal
defer catch-save	\ -- n
defer catch-restore	\ n --

: (catch-save)		\ -- 0
  0
;
' (catch-save) to-do catch-save
' drop         to-do catch-restore
external


\ Exception stack frame equates
5 cells equ /es-frame
4 cells equ off_sp
3 cells equ off_rp
2 cells equ off_lp
1 cells equ off_fsp
0 cells equ off_currobj		\ *** do not change this one ***

: CATCH         \ i*x xt -- j*x 0|i*x n                        9.6.1.0875
\ *G Execute the code at XT with an exception frame protecting it.
\ ** *\fo{CATCH} returns a 0 if no error has occurred, otherwise
\ ** it returns the throw-code passed to the last *\fo{THROW}.
  r> >ep                                \ preserve return address on exception stack
  /es-frame negate excp +!		\ reserve space on frame
  sp@ excp @ tuck off_sp + !		\ save PSP
  rp@ over off_rp + !			\ save RSP
  lp@ over off_lp + !			\ save LP
[defined] fsp@ [if]
  fsp@ over off_fsp + !			\ save Float Stack Pointer
[else]
  fsp @ over off_fsp + !		\ save Float Stack Pointer
[then]
  currobj @ swap ( off_currobj + ) !	\ save object pointer ***
  catch-save >ep
  execute                               \ this gets back if there is no THROW
  ep> cells /es-frame + excp +!		\ drop additional plus frame items
  ep> >r
  0                                     \ good exit = 0
;

[-short-branches
: THROW         \ k*x n -- k*x|i*x n                           9.6.1.2275
\ *G Throw a non-zero exception code n back to the last *\fo{CATCH}
\ ** call. If n is 0, no action is taken except to *\fo{DROP} n.
\ ** If n is non-zero and no previous *\fo{CATCH} has been
\ ** performed, there is an exception frame error, and *\fo{O_ABORT}
\ ** is performed which finally calls the *\fo{DEFER}red word
\ ** *\fo{QUIT}.
  ?dup 0=
  if  exit  endif

  exc0 @ excp @ <> if			\ if a previous CATCH has been performed ...
    ep> catch-restore
    excp @ [o/f]			\ the [O/F] prevents the reload of EXCP
    dup ( off_currobj + ) @ currobj !	\ ***
[defined] fsp! [if]
    dup off_fsp + @ fsp!
[else]
    dup off_fsp + @ fsp !
[then]
    dup off_lp + @ lp!
    dup off_rp + @ rp!
    off_sp + @
    swap >r				\ preserve throw code
    sp! drop			        \ the drop discards the xt slot
    r>					\ restore throw code
    /es-frame excp +!			\ remove exception frame
    ep> >r  exit
  endif

\ we only get here if no previous CATCH has been performed.
  case
    -2 of  'AbortText @ $.  endof
  endcase
  o_abort
;
short-branches]

: ?THROW        \ k*x flag throw-code -- k*x|i*x n
\ *G Perform a *\fo{THROW} of value *\i{throw-code} if flag is non-zero.
  swap if throw else drop then
;


\ ============================
\ *N Extending CATCH and THROW
\ ============================

\ *P The *\fo{CATCH} and *\fo{THROW} mechanism can be extended by
\ ** the user if additional information needs to be preserved.
\ ** By default the following pointers are preserved - data stack,
\ ** return stack, float stack, local frame and current object.
\ ** Additional information is saved and restored by user-defined
\ ** words as follows.

\ *P The save word must return n, the number of cells saved
\ ** on the exception stack. The restore word must consume
\ ** n and restore n items from the return stack. The words
\ ** *\fo{>EP ( x -- )} and *\fo{EP> ( -- x )} are used to
\ ** push and pop items respectively to and from the exception
\ ** stack.
\ *E variable v1
\ ** variable v2
\ **
\ ** : MySave     \ -- n ; number of cells
\ **   v1 @ >ep  v2 @ >ep  2
\ ** ;
\ **
\ ** : MyRestore  \ n -- ; number of cells
\ **   drop  ep> v2 !  ep> v1 !
\ ** ;

\ *P The new save and restore words are activated by the word
\ ** *\fo{EXTENDS-CATCH} and the default action is restored by
\ ** *\fo{DEFAULT-CATCH}. See below.

: extends-catch	\ xt-save xt-restore --
\ *G Sets the new save and restore actions of *\fo{CATCH} and
\ ** *\fo{THROW}.
  to-do catch-restore
  to-do catch-save
;

: default-catch	\ --
\ *G Restores the default actions of *\fo{CATCH} and *\fo{THROW}.
  ['] drop         to-do catch-restore
  ['] (catch-save) to-do catch-save
;


\ =====================
( *S ABORT and ABORT" )
\ =====================
\ *P These words are built on top of *\fo{CATCH} and *\fo{THROW}.

: (ABORT)       \ i*x -- ; R: j*x --
  -1 throw
;

: (ABORT")      \ i*x x1 -- | i*x
  r> dup  count + aligned >r  swap if
    'AbortText !  -2 throw
  else
    drop
  then
;

(( for DocGen
defer ABORT	\ i*x -- ; R: j*x -- ; error handler
\ *G Empty the data stack and perform the action of *\fo{QUIT}, which
\ ** includes emptying the return stack, without displaying a
\ ** message.
))

: ABORT"        \ Comp: "ccc<quote>" -- ; Run: i*x x1 -- | i*x ; R: j*x -- | j*x  9.6.2.0680
\ *G If x1 is true at run-time, display the following string and
\ ** perform *\fo{ABORT}, otherwise do nothing. This is handled by
\ ** performing *\fo{-2 THROW} after setting the variable
\ ** *\fo{'ABORTTEXT}.
  ?comp
  compile (abort") ",  discard-sinline
; IMMEDIATE


\ =============================
\ *S Defining Error/Throw codes
\ =============================
\ *P As of VFX Forth v3.6, the user definable mechanism has changed.

\ *P In order to simplify the construction and allocation of error
\ ** messages and references, they can be constructed automatically.
\ ** Use *\fo{ERRDEF} and *\fo{#ERRDEF} as shown below to construct
\ ** messages for error handlers. These messages are created as
\ ** *\fo{/ERRDEF} structures which are also used for messages that
\ ** can be internationalised. Note also that this structure and
\ ** mechanism may be subject to change to cope with
\ ** internationalisation, which is documented in a separate
\ ** chapter of the manual.
\ *E ErrDef ScrewUp "Oh bother, something went wrong"
\ *P defines a constant called *\fo{SCREWUP} associated with a
\ ** string. The constant *\fo{SCREWUP} can be passed to *\fo{ERR$}
\ ** to retrieve the address and length of the string. The value
\ ** of the constant is generated from the contents of variable
\ ** *\fo{NEXTERROR}.

\ *E 999 #ErrDef Snafu "Situation Normal, All ****ed Up"
\ *P defines a constant called *\fo{SNAFU} of value 999 and an
\ ** associated	text message.

\ *P When assigning error codes, please note that the ANS
\ ** specification reserves error codes -255..-1 for ANS defined
\ ** error messages. Error codes in the range -4095..-256 are
\ ** reserved for use by VFX Forth iteself. Applications may use
\ ** other codes. Please do not use error codes 0..499 as these
\ ** are reserved by VFX Forth for optional system extensions.
\ ** By default, automatically assigned	error codes start at 501.
\ =======================================================================

\ *P The error system relies on a data structure *\fo{/ERRDEF}
\ ** which follows a constant value for the error number. The
\ ** *\fo{/ERRDEF} structure contains a link to the previous
\ ** *\fo{ERRDEF} or *\fo{#ERRDEF} definition, a message identifier
\ ** which is 0 for non-databased strings in the ISO Latin1
\ ** coding, the address of the text, and the length of the text
\ ** in bytes. The text is followed by two zero bytes, and the
\ ** text is long aligned. The *\fo{/ERRDEF} structure is a
\ ** subset of the *\fo{/TEXTDEF} structure described in the
\ ** internationalisation chapter. This chapter also includes a
\ ** discussion of the concepts used for internationalisation.						)

\ *P Error messages are linked into the chain used for all
\ ** application strings that can be internationalised. This chain
\ ** is anchored by the variable *\fo{TEXTCHAIN}.

\ *P The words *\fo{PARSEERRDEF}, *\fo{ERR$} and *\fo{.ERR} are
\ ** *\fo{DEFER}red. *\fo{PARSEERRDEF} creates the *\fo{/ERRDEF}
\ ** structure from the source text. It is the basis of error
\ ** defining words such as *\fo{ERRDEF}. You can install
\ ** alternative versions of these words for internationalised
\ ** applications. In this context, *\fo{#ERRDEF} and friends can
\ ** be used as the basis of any text handler that requires
\ ** translation. Note that *\fo{PARSEERRDEF} can be modified so
\ ** that a message file is produced at compile time, and
\ ** *\fo{ERR$} modified so that the message file is accessed at
\ ** run time. Similarly, providing that the application language
\ ** is correctly handled, the run time can access translated
\ ** messages in other languages, character sets and character
\ ** sizes. *\fo{.ERR} is similarly *\fo{DEFER}red and is used to
\ ** display the message.							)

( *E struct /errdef	\ -- len ; DOES NOT include constant definition )
( **   int ed.link		\ link to previous ERRDEF		)
( **   int ed.id		\ 0 or message ID			)
( **   int ed.caddr		\ address of text string to use		)
( **   int ed.len		\ length of text string to use in bytes	)
( **   int ed.lenInline		\ length of inline text string in bytes	)
( ** end-struct								)

\ *P The previous kernel words *\fo{GETERRORTEXT} and
\ ** *\fo{GETERRORTEXTEX} that existed up to VFX Forth v3.3 have
\ ** been removed and are replaced by *\fo{ERR$}, which has the
\ ** same stack effect.

struct /errdef	\ -- len ; DOES NOT include constant definition
  int ed.link			\ link to previous ERRDEF
  int ed.id			\ 0 or message ID
  int ed.caddr			\ address of text string to use
  int ed.len			\ length of text string to use in bytes
  int ed.lenInline		\ length of inline text string in bytes
end-struct

defer ParseErrDef	\ "<text>" -- ; create /ErrDef structure
\ *G Create a /ErrDef structure in the dictionary, parsing the
\ ** required text. The error number must already have been laid.

defer Err$	\ n -- addr/n len/0
\ *G Convert an error/message number to the address of the relevant
\ ** string. *\i{Addr} is the start of the string, and *\i{len} is
\ ** its length in bytes. If the string cannot be found, *\i{addr}
\ ** is set to *\i{n} and *\i{len} is set to 0.

defer .Err	\ caddr u --
\ *G Given the address and length in bytes of a message that may
\ ** have been internationalised, display it. The default action
\ ** is *\fo{TYPE}.
  assign type to-do .Err

variable NextError
\ *G Holds the value of the next application error number to be
\ ** allocated by *\fo{ERRDEF}. Application error numbers are
\ ** positive and are incremented by *\fo{ERRDEF}.
  #501 NextError !

variable NextSysError
\ *G Holds the value of the next system error number to be
\ ** allocated by *\fo{SYSERRDEF}. System error numbers are
\ ** negative and are decremented by *\fo{SYSERRDEF}.
  -1001 NextSysError !

(( for DocGen
variable TextChain
\ *G The anchor for the chain of error and text messages that may
\ ** be internationalised.
  0 TextChain !
))

: ErrStruct	\ n -- struct|0 ; produce pointer to error structure
\ *G Given an error number n, return the address of the
\ ** *\fo{/ERRDEF} error structure containing its details.
  TextChain @
  begin
    dup
   while
    2dup cell- @ =
    if  nip exit  endif
    ed.link @
  repeat
  2drop  0
;

[-short-branches
: .TextChain	\ -- ; display all error messages
\ *G Display a list of all the error codes and messages defined by
\ ** *\fo{ERRDEF} and *\fo{#ERRDEF} and other text chain users.
  TextChain @
  begin
    dup
   while
    cr  dup cell - @ 8 .r  2 spaces
    [char] " emit  dup ed.caddr 2@ swap .Err  [char] " emit
    ed.link @
  repeat
  drop
;
short-branches]

: (Err$)	\ throw#/msg# -- c-addr u | throw#/msg# 0
\ *G The default action of *\fo{ERR$}.
  dup ErrStruct dup if
    nip  ed.caddr 2@ swap
  then
;  assign (Err$) to-do Err$


: (ParseErrDef)	\ "<text>" -- ; create /ErrDef structure
\ *G The default action of *\fo{PARSEERRDEF}.
    here >r				\ address of /ERRDEF structure
    /errdef allot&erase			\ reserve /ERRDEF structure
    TextChain @ r@ ed.link !		\ update chain
    r@ TextChain !
    [char] " parse 2drop		\ skip past leading "
\   align				\ for PFW2.x
    here  z",  0 c, 			\ lay double terminated zstring
    zcount
    dup r@ ed.lenInline !		\ set inline text length
    swap r> ed.caddr 2!			\ stash default addr/len
;  assign (ParseErrDef) to-do ParseErrDef

interpreter
: zcount	\ caddr -- caddr len
  0 over
  begin					\ -- caddr len caddr'
    dup c@
   while
    swap 1+ swap 1+
  repeat
  drop
;

: #ErrDef	\ n -- ; -- n ; used as throw/error codes
  create
    align
    ,					\ lay value
    here /errdef allot&erase		\ reserve ERRDEF structure
    TextChain @ over ed.link !		\ update chain
    dup TextChain !
    [char] " parse 2drop		\ skip past leading "
    here  z",  0 c, 			\ lay double terminated zstring
    zcount			        \ -- ^struct addr len
    dup 3 pick ed.lenInline !		\ set inline text length
    swap rot ed.caddr 2!		\ stash addr/len
  does>
    aligned @
;

: ErrDef	\ -- ; -- n ; used as throw/error codes
  NextError @ #ErrDef  1 NextError +!	\ constant and update
;
target

: #ErrDef	\ n -- ; -- n ; used as throw/error codes
\ *G Define a constant and associated message in the form:
\ *C   <n> #ERRDEF <name> "<text>".
\ *P Execution of *\fo{<name>} returns <n>.
  create
    align , ParseErrDef			\ constant, no update
  does>
    aligned @
;

: ErrDef	\ -- ; -- n ; used as throw/error codes
\ *G Define a constant and associated message in the form:
\ *C   ERRDEF <name> "<text>"
\ *P Execution of *\fo{<name>} returns the constant automatically
\ ** allocated from *\fo{NEXTERROR}.
  NextError @ #ErrDef  NextError Incr	\ constant and update
;

: SysErrDef	\ -- ; -- n ; used as throw/error codes
\ *G Define a constant and associated message in the form:
\ *C   SYSERRDEF <name> "<text>"
\ ** Execution of *\fo{<name>} returns the constant automatically
\ ** allocated from *\fo{NEXTSYSERROR}.
  NextSysError @ #ErrDef  NextSysError Decr	\ constant and update
;

: #AnonErr	\ n "<text>" -- ; create anonymous error text
\ *G Create an anonymous error definition that has no name, e.g.
\ *C WSAEWOULDBLOCK #AnonErr "WSAEWOULDBLOCK"
\ *P *\fo{#AnonErr} is useful when dealing with operating
\ ** system return codes whose names are available from the
\ ** support DLL.
  align , ParseErrDef
;


\ ========================
\ *S System Error Handling
\ ========================
\ *P The VFX Forth kernel handles the display of error messages
\ ** using the word *\fo{.THROW ( n -- )} which recognises two
\ ** classes of message. The first class consists of the messages
\ ** handled by *\fo{ABORT" <text>"}. At present these cannot be
\ ** internationalised, and they are displayed by the deferred
\ ** word *\fo{DOABORTMESSAGE}. The second class handles all
\ ** other error messages, and these are displayed by the deferred
\ ** word *\fo{DOERRORMESSAGE}.

\ *P See also:
( *D LINE#       Current source input line number.                      )
( *D 'SourceFile Pointer to source include struct for current source file, or 0. )
\ *D SOURCE      Return source line ; -- c-addr u
\ *D CurrSourceName Return source file name ; -- c-addr u

( *P Other subsidiary words are also documented here.			)

: .ErrDef	\ n --
( *G Display the error/message number n and the associated message. )
  base @ >r  decimal
  cr ." Err# " dup .
  Err$ .Err
  r> base !
;

[-short-branches
: ShowErrorLine	\ -- ; display error line
\ *G Show the current source file and line number.
\ ** If *\fo{LINE#} contains -1, no action is taken.
  line# @ -1 <> if
    cr ."  Source: "
    [char] " emit  'SourceFile @ .SourceName  [char] " emit
    ."  on line "
    base @ >r  decimal  line# @ .  r> base !
  then
;

: ShowSourceOnError     \ -- ; display pointer to error
\ *G Show the current text input line and a pointer to the error
\ ** location defined by the current value of *\fo{>IN}.
\ ** If *\fo{>IN} contains -1, no action is taken.
  >in @ -1 <> if
    cr ."  -> " source type
    cr >in @ 1- 4 + spaces [char] ^ emit
    ShowSourceOnErrorHook
  endif
;
short-branches]

: .source-line  \ --
\ *G Show the current source file, line and a pointer to the
\ ** source position.
  ShowErrorLine ShowSourceOnError
;

defer DoAbortMessage	\ c-addr --
\ *G The action of this word is used by the kernel to print the
\ ** text associated with an *\fo{ABORT"} from the system. By
\ ** default it simply *\fo{TYPE}s the counted string at c-addr,
\ ** and shows the offending source line. You can replace this
\ ** action at any time, using:
\ *C   ASSIGN <xxx> to-do DoAbortMessage
\ *P Note that *\fo{ABORT"} messages cannot be internationalised at
\ ** present because all these messages share a common throw code,
\ ** -2. *\fo{DOABORTMESSAGE} is used by *\fo{.THROW} below.

: (DoAbortMessage)	\ c-addr -- ; default action
\  out @ if  cr  endif
  $. .source-line
; assign (DoAbortMessage) to-do DoAbortMessage

defer DoErrorMessage	\ n --
\ *G A deferred word which handles the display of error messages
\ ** for the VFX Forth system's text interpreter. By default the
\ ** *\fo{ERRDEF} mechanism above is used. *\fo{DOERRORMESSAGE}
\ ** is used by *\fo{.THROW} below.

: (DoErrorMessage)	\ n --
  dup Err$ nip if			\ if text available
    .ErrDef				\ generate error message
  else
    cr ." No text available for THROW code "
    base @ >r  decimal 0 .r ." (10)"  r> base !
  then
  .source-line EditOnError
; assign (DoErrorMessage) to-do DoErrorMessage

: .throw	\ n -- ; show throw code n
\ *G Process the given *\fo{THROW} code. Throw codes 0 and -1 are
\ ** silent by specification. Throw code -2 displays the string
\ ** set by the last *\fo{ABORT" <string>"} and all other error
\ ** messages are searched for in the *\fo{ERRDEF} chain. See
\ ** *\fo{ERRDEF} and *\fo{#ERRDEF}.
  case
     0 of  endof				\ not an error
    -1 of  endof				\ quiet
    -2 of  'AbortText @ DoAbortMessage  endof	\ ABORT" ..."
           DoErrorMessage
  end-case
;

create zSysName	\ -- zaddr
\ *G Returns the system name "VFX Forth" as a zero terminated
\ ** string.
  z", VFX Forth"

decimal

internal
\ Forth-2012 reserved codes
-3      #Errdef err_dso		"ERR: Data stack overflow."
-4	#ErrDef err_dsu		"ERR: Data stack underflow."
-5      #Errdef err_rso		"ERR: Return stack overflow."
-6	#ErrDef err_rsu		"ERR: Return stack underflow."
-13	#ErrDef err_undef	"ERR: Undefined word."
-14	#ErrDef err_comp	"ERR: Attempt to interpret a compile only definition."
-15	#ErrDef err_forget	"ERR: Invalid FORGET operation."
-21	#ErrDef err_unsupported "ERR: Unsupported operation"
-22	#ErrDef err_control	"ERR: Control structure mismatch."
-59	#ErrDef err_allocate    "ERR: from ALLOCATE"
-60	#ErrDef err_free        "ERR: from FREE"
-61	#ErrDef err_resize      "ERR: from RESIZE"
-62	#ErrDef err_close	"ERR: from CLOSE-FILE"
-63	#ErrDef err_create	"ERR: from CREATE-FILE"
-64	#ErrDef err_delete	"ERR: from DELETE-FILE"
-65	#ErrDef err_filepos	"ERR: from FILE-POSITION"
-66	#ErrDef err_filesize	"ERR: from FILE-SIZE"
-67	#ErrDef err_filestatus	"ERR: from FILE-STATUS"
-68	#ErrDef err_flushfile	"ERR: from FLUSH-FILE"
-69	#ErrDef err_openfile	"ERR: from OPEN-FILE"
-70	#ErrDef err_readfile	"ERR: from READ-FILE"
-71	#ErrDef err_readline	"ERR: from READ-LINE"
-72	#ErrDef err_renamefile	"ERR: from RENAME-FILE"
-73	#ErrDef err_repositionfile	"ERR: from REPOSITION-FILE"
-74	#ErrDef err_resizefile	"ERR: from RESIZE-FILE"
-75	#ErrDef err_writefile	"ERR: from WRITE-FILE"
-76	#ErrDef err_writeline	"ERR: from WRITE-LINE"
-77	#ErrDef err_malxchar	"ERR: Malformed xchar"
-78     #ErrDef err_substitute  "ERR: from SUBSTITUTE"
-79     #ErrDef err_replaces    "ERR: from REPLACES"

-256	#ErrDef err_defer	"ERR: Execution of a DEFERed word with no ASSIGNed action."
-257	#ErrDef err_fwdref	"ERR: Unresolved forward references in definition."
-258	#ErrDef err_open	"ERR: Failed to open requested file."
-259	#ErrDef err_recurse	"ERR: Invalid use of RECURSE."
(( -3xx moved to OPT386.FTH
-300	#ErrDef opt_oflow	"ERR: Working stack overflow in code optimiser."
-301	#ErrDef opt_		"ERR: No free literals for code optimiser. Definition too complex."
-302	#ErrDef opt_mempool	"ERR: Full memory pool in code optimiser. Definition too complex."
-303	#ErrDef opt_regs	"ERR: No free registers in code optimiser. Definition too complex."
-304	#ErrDef opt_scratch	"ERR: Couldn't free scratch resource in code optimiser."
-305	#ErrDef opt_shuffle	"ERR: Couldn't shuffle stack in code optimiser."
-306	#ErrDef opt_pick	"ERR: Attempt to optimise PICK with a -ve input."
-307	#ErrDef opt_short	"ERR: Short branch out of range in optimiser."
-308	#ErrDef opt_argneg	"ERR: -Ve offset to argument promoter (nsbwiden etc...)"
))
\ -4xx are MPE extended kernel error codes
-400	#ErrDef err_fsu		"ERR: Float stack underflow."
-401	#ErrDef err_generic	"ERR: Illegal Generic IO device action exception."
-402	#ErrDef err_operator	"ERR: Unconsumed operator at end of definition"
-403	#ErrDef err_interp	"ERR: Attempt to compile an interpret only word"
-404	#ErrDef err_method	"ERR: Invalid prefix operator"
-405	#ErrDef err_uservar	"ERR: Too many USER variables."
-406	#ErrDef err_OutOfMemory	"ALLOCATE/RESIZE failed"
-407	#ErrDef err_CannotFree	"FREE failed"
-408	#ErrDef err_RichEdit	"Unsupported GENIO operation for a RICHEDIT device"
-409	#ErrDef err_save	"Fatal error during SAVE operation"
-410	#ErrDef err_reloc	"Fatal error during RELOC operation"
-411	#ErrDef err_EOI		"Unexpected end of input"
-412	#ErrDef err_create	"File create error"
-413	#ErrDef err_open2	"File open error"
-414	#ErrDef err_read	"File read error"
-415	#ErrDef err_write	"File write error"
-416	#ErrDef err_close2	"File close error"
-417	#ErrDef err_seek	"File seek error"
-418    #ErrDef err_dict	"Dictionary corrupt at DICTBAD"
-419	#ErrDef err_syspad	"Too much data for SYSPAD"
-420    #ErrDef err_localsep	"Repeated '|' in local variable definition"
-421    #ErrDef err_replocal    "Multiple local definitions in one word"
-422	#ErrDef err_badhandle	"Bad file or device handle"
-423	#ErrDef err_badSID	"invalid SID - probably zero"
-424	#ErrDef err_CondComp	"Unfinished conditional compilation in INCLUDE-FILE"
-425	#ErrDef err_DirCreate	"Directory creation err"
-426	#ErrDef gs_overflow	"Generic stack overflow/underflow"

\  -3xx are VFX code generator errors
\  -4xx are MPE extended error codes
\  -5xx are DOCGEN errors
\  -6xx are overlay errors - see LIB\OVLVFX.FTH
\  -7xx are ASSEMBLER errors
\  -8xx are BNF errors
\  -9xx are XREF errors
\ -10xx are DLL errors

Target_x64_Windows Target_386_Windows or [if]
-57005	#ErrDef err_windows	"ERR: Windows exception"
[then]
Target_386_Linux  Target_ARM_Linux or [if]
-57005	#ErrDef err_linux	"ERR: Linux Exception"
[then]
Target_386_OSX Target_x64_OSX or [if]
-57005	#ErrDef err_osx		"ERR: OSX Exception"
[then]
Target_386_WDOSX [if]
-57005	#ErrDef err_wdosx	"ERR: WDOSX Exception"
[then]
external


\ ========
\ *> tools
\ *T Tools and Utilities
\ ========

\ ==========================
\ *S Conditional Compilation
\ ==========================
\ *P The following words allow the use of
\ ** *\fo{[IF] ... [ELSE] ... [THEN]} blocks to control which
\ ** pieces of code are compiled/executed and which are not. These
\ ** words behave in the same manner as compiled definitions of
\ ** *\fo{IF ... ELSE ... THEN} structures but take immediate
\ ** effect even outside definitions. Nesting is supported.

variable cc-level	\ -- addr
\ *G A variable used for error checking during compilation.
\ ** It holds the number of *\fo{[IF] ... [THEN]} blocks we
\ ** currently inside. Cleared at cold start.

VOCABULARY Compilation?	\ --
\ *G The *\fo{COMPILATON?} vocabulary holds the control code for
\ ** passover operations during a conditional block.

: PassOver      \ n --
\ *G Skip n levels of nested conditional code.
  begin
    begin
      get-token count dup
    while
      ['] Compilation? >body @ search-wordlist if execute then
      ?dup 0= if exit then
    repeat
    2drop
    refill 0=
  until
  drop
;

: have		\ "<name>" -- flag
\ *G Look to see if the word exists in the *\fo{CONTEXT} search order
\ ** and return flag true if found.
  bl word find nip 0<>
;

: [defined]     \ "<name>" -- flag                            Forth200x
\ *G Look to see if the word exists in the *\fo{CONTEXT} search
\ ** order and return flag TRUE if the word exists.
\ ** This is an immediate version of *\fo{HAVE}.
  have
; immediate

: [undefined]   \ "<name>" -- flag                            Forth200x
\ *G The inverse of *\fo{[DEFINED]}. Return TRUE if *\fo{<name>}
\ ** does not exist.
  have not
; immediate

: [ELSE]        \ --                                          15.6.2.2531
\ *G Marks the start of the ELSE clause of a conditional compilation
\ ** block.
  1 PassOver
; immediate

: [IF]          \ flag --                                     15.6.2.2532
\ *G Marks the start of a conditional compilation clause. If
\ ** flag is TRUE compile/execute the following code, otherwise
\ ** ignore all up to the next *\fo{[ELSE]} or *\fo{[THEN]}.
\ ** Note that the parser for *\fo{[IF]} and *\fo{[ELSE]} is
\ ** really dumb. You cannot comment out an *\fo{[ELSE]} or
\ ** or *\fo{THEN}. However they are nestable.
  1 cc-level +!				\ start of block
  0= if postpone [ELSE] then
; immediate

: [THEN]        \ --                                          15.6.2.2533
\ *G Marks the end of a conditional compilation clause.
  -1 cc-level +!			\ end of block
; immediate

: [ENDIF]	\ --
\ *G Marks the end of a conditional compilation clause.
  -1 cc-level +!			\ end of block
; immediate

also Compilation? definitions

\ *P The following definitions exist in the *\fo{Compilation?}
\ ** vocabulary.

: [IF]          1+  1 cc-level +!  ;
\ *G *\fo{[IF]} increments the number of levels to skip.

: [THEN]        1-  -1 cc-level +!  ;
\ *G *\fo{[THEN]} decrements the number of levels to skip.

: [ENDIF]       1-  -1 cc-level +!  ;
\ *G *\fo{[ENDIF]} decrements the number of levels to skip.

: [ELSE]        1- dup if 1+ then ;
\ *G *\fo{[ELSE]} switches the redirection level.

previous definitions


\ ================================
\ *S Console and development tools
\ ================================
\ *P The following words provide useful diagnostic routines and/or
\ ** general purpose functions in the spirit of the ANS Forth TOOLS
\ ** and TOOLS EXT wordsets.

also system definitions
: (.tabword)    \ addr len -- addr len
\ +G Tab or CR if string won't fit on line.
  out @ 0> if                                   \ not at start of line?
    tabwordstop @ dup out @ swap mod - spaces	\ Pad out a few chars.
    dup out @ +                                 \ Calc OUT after display
    c/line @ tabwordstop @ - >
    if  cr  endif                               \ CR if the name won't fit.
  endif
;
previous definitions

also system

: .tabword      \ addr$ --
\ *G Displays tabbed string, CRing if required. Variable
\ ** *\fo{TABWORDSTOP} contains the size of a tab.
  count (.tabword) type
;

: .tabwordN     \ addr$ --
\ *G Displays tabbed *NAME*, CRing if required. Variable
\ ** *\fo{TABWORDSTOP} contains the size of a tab.
  count (.tabword) type
;

0 value PauseConsole	\ -- device
\ *G Some tools, e.g. *\fo{WORDS} and *\fo{DUMP} will pause
\ ** periodically if *\fo{PauseConsole} returns the same value
\ ** as the output device in *\fo{OP-HANDLE}. Any interactive
\ ** console can select this behaviour with:
\ *C  op-handle @ to PauseConsole
\ *P You can stop any pausing with:
\ *C  0 to PauseConsole

: flushKeys	\ --
\ *G Flush any pending input that might be returned by *\fo{KEY}.
  begin  key? while  key drop  repeat
;

: HaltKey?      \ char -- flag
  dup bl =  over #13 = or  swap #10 = or
;

: HaltKey2	\ -- flag
  10 ms flushKeys
  key haltKey? 0=
  10 ms flushKeys
;

: HALT?         \ -- flag
\ *G Used in listed displays. This word will check the keyboard for a
\ ** pause key (<space> or <lf> or <cr>). If a pause key is pressed it will
\ ** then wait for another key. The return flag is TRUE if the second
\ ** key is not a pause key. If the first key is not a pause key TRUE
\ ** is returned and no key wait occurs. Line Feed characters are
\ ** ignored.
  op-handle @ PauseConsole =		\ default console, e.g. DOS/Linux
  op-line# @ c/cols @ 2- mod 0=		\ output limit exceeded
  and if
    out @ if  cr  endif
    ." <sp> or <cr> to continue, other to stop "
    HaltKey2  cr
    exit
  endif
  key? dup if
    drop  key haltKey?
    if  HaltKey2  else  true  endif
  endif
;

-short-branches

: DUMP          \ addr u --                                   15.6.1.1280
\ *G Display an arbitrary block of memory in a 'hex-dump' fashion
\ ** which displays in both HEX and printable ASCII.
  op-line# off
  bounds ?do                            \ over range
    cr  i .lword  space   i 8 + i	\ print address
    do  space i c@ .byte  loop          \ first eight bytes
    space  i $10 + i 8 +                \ gap
    do  space i c@ .byte  loop          \ second eight bytes
    2 spaces  i $10 + i                 \ gap
    do  i c@ .ascii  loop               \ ascii o/p
    halt? ?leave                        \ quit or halt
  $10 +loop                             \ until done
  cr
;

: LDUMP		\ addr len -- ; dump 32 bit long words
\ *G Display (dump) len bytes of memory starting at addr
\ ** as 32 bit words.
  op-line# off
  bounds ?do				\ get limits
    cr  i .lword  space   i 8 + i       \ print address
    do  space i @ .lword  4 +loop	\ first eight bytes
    space  i $010 + i 8 +               \ gap
    do  space i @ .lword  4 +loop	\ second eight bytes
    2 spaces  i $010 + i                \ gap
    do  i c@ .ascii  loop               \ ascii o/p
    halt? ?leave			\ quit or halt
  $010 +loop                            \ until done
  cr  					\ restore base
;

: .S            \ --                                          15.6.1.0220
\ *G Display to the console the current contents of the data
\ ** stack. If the number base is not *\fo{HEX} than a dump is
\ ** also made in HEX.
  cr  ." DATA STACK" depth ?dup if
    dup 0< #-4 ?throw
    cr ."      top"
    0 do
      i pick
      cr  dup s>d #15 d.r space                         \ show word in current base
      base @ #16 <>                                     \ if base is not HEX
      if  .lword  else  drop  then                      \ also show it in HEX
    loop
  else
    cr ." empty stack"
  then
  cr
;

: .rs           \ --
\ *G Display to the console the current contents of the return
\ ** stack. Where possible a word name is also displayed with
\ ** the data value.
  cr  rdepth ?dup if                    \ get depth of return stack
    dup 0< abort" urk! return stack underflow"
    ." *** top: " dup . ." items"
    0
    do  i 3 + rpick                     \ DO LOOP uses 3 items
        cr ."  #"
        dup 8 u.r                       \ display stack item as number
        dup $0400 u>                    \ if not a small number
        over here u< and                \ and not beyond the dictionary
        if                              \ assume its a return address
          2 spaces                      \ separator
          ip>nfa .name                  \ show word name
        else
          drop
        endif
        halt? ?leave
    loop
  else
    ." Return stack empty"
  endif
;

+short-branches

: ?             \ a-addr --                                   15.6.1.0600
\ *G Display the contents of a memory location. It has the same
\ ** effect as *\fo{@ .}.
  @ .
;

previous

also root definitions

also system definitions
-short-branches
: (words)       \ #thread nfa -- flag
  nip .name				\ --
  #16 out @ #15 and -			\ -- n ; #spaces to next
  dup out @ + c/line @ >= if		\ -- n
    drop cr  halt? 0=
  else
    spaces TRUE
  then
;
+short-branches
previous definitions

: WORDS         \ --
\ *G Display the names of all definitions in the wordlist at the
\ ** top of the search order.
  op-line# off				\ for C/LINE check
  [ also system ]  ['] (words)  [ previous ]
  context @
  dup cr ." Words in " .voc
  cr WalkWordList
; also forth definitions : words words ; previous definitions

previous definitions

: .FREE         \ --
( *G Text display of size of unused dictionary area in Kbytes           )
  ." Free dictionary = "
  unused 0 max u.
  ." bytes [" unused 0 max #10 rshift 0 .r ." kb]"
;


also system definitions

FALSE value donematch?
NULL  value *vocname

-short-branches
: (.mat)        \ thread nfa -- flag
  nip
  dup >r count  here count  $cstrmatch if
    donematch? FALSE = if
      TRUE -> donematch?
      cr cr ." Definitions in: " *vocname .name cr
    then
    r> $.
    #16 out @ #15 and - spaces  ?cr
  else
    r> drop
  then
  TRUE
;
+short-branches

: .mat          \ wid --
  ['] (.mat) swap WalkWordList
;

: (mat)         \ --
  voc-link
  begin
    @ ?dup
    FALSE to donematch?
  while
    dup >vocname -> *vocname
    dup .mat
    >voc-link
  repeat
;

previous definitions

: mat           \ -- ; MAT <wildcardpattern>
( *G Search the current search-order for all definitions whose name     )
( ** matches the wild-carded expression supplied. Expressions can       )
( ** contain either an asterix '*' to match 0 or more characters, or can be )
( ** a query '?' to mark any single character.                          )
  get-token drop
  [ also system ] (mat) [ previous ]
  cr
;

defer Similars-Extension
assign noop to-do similars-extension

: similars      { | temp[ MAX_PATH ] -- }
( *G A slightly faster version of *\fo{MAT} with a limited range. The   )
( ** definitions listed will contain <pattern> within their name.       )
( ** The <pattern> can only contain printable ASCII characters.         )
  get-token drop

  here temp[ smove		\ preserved copy of original string at HERE

  \ Now build a SIM style string at HERE
  \ It should take the current one and escape any wildcards, then wrap
  \ *'s around it.
  \
  \ Therefore the string        'harry*test'
  \ should become               '*harry\*test*'

  here  0 over c!		\ initialise counted string built at HERE
  [char] * over addchar		\ with leading '*'

  temp[ count bounds ?do	\ convert * or ? to \* or \?
    case  i c@
      [char] * of  c" \*" over $+  endof
      [char] ? of  c" \?" over $+  endof
        over addchar
    end-case
  loop

  [char] * swap addchar		\ add trailing '*'

  [ also system ] (mat) [ previous ]

  temp[ here MAX_PATH move      \ put preserved string back for extension
  Similars-Extension
  cr
;

: sim           \ -- ; SIM <pattern>
\ *G A slightly faster version of *\fo{MAT} with a limited range. The
\ ** definitions listed will contain <pattern> within their name.
\ ** <pattern> can only contain printable ASCII characters.
\ ** A synonym for *\fo{SIMILARS}.
  similars
;


\ ===========
\ *> kerneldf
\ *S Time and Date
\ ===========

0 value dow	\ -- dow ; 0=Sunday
\ *G Returns the local day of the week, starting at 0=Sunday.
\ ** This value is updated when *\fo{TIME&DATE} below is called.

: time&date     \ -- seconds mins hours day month year
\ *G Return the operating system local time and date, and
\ ** set *\fo{DOW} as a side effect.
  [ also system ] OS_GetLocalTime [ previous ]
  to Dow
;

0 value SysDow	\ -- dow ; 0=Sunday
\ *G Returns the system day of the week, starting at 0=Sunday.
\ ** This value is updated when *\fo{SYSTIME&DATE} below is called.

: systime&date     \ -- seconds mins hours day month year
\ *G Return the operating system local time and date, and
\ ** set *\fo{SYSDOW} as a side effect.
  [ also system ] OS_GetSystemTime [ previous ]
  to SysDow
;


\ =====================
\ *S Millisecond timing
\ =====================
\ *P Most timing in VFX Forth application uses a millisecond
\ ** timer provided by the host operating system. The words
\ ** provided are compatible with those used by MPE's embedded
\ ** systems. The primary word is *\fo{ticks} which returns a
\ ** time in milliseconds.

\ SFP051...
(( for DocGen
defer ms	\ n --
\ *G Wait for *\i{n} milliseconds. Calls the multitasker through
\ ** *\fo{PAUSE}.
defer ticks	\ -- n
\ *G Return the system timer value in milliseconds. Treat the
\ ** returned value as a 32 bit unsigned number that wraps on
\ ** overflow.
))

: later         \ n -- n'
\ *G Generates a time value for termination in *\i{n} milliseconds
\ ** time. Because many applications use a timer value of zero to
\ ** indicate that a timer is not in use, *\fo{later} never returns
\ ** a value of zero, and always forces the bottom bit of *\i{n'}
\ ** to be set to 1.
  ticks +  1 or				\ never returns zero.
;

: expired       \ n -- flag ; true if timed out
\ *G Flag is returned true if the time value *\i{n} has timed out.
\ ** Calls *\fo{PAUSE}.
  pause  ticks - 0<                     \ must use circular arithmetic
;

: timedout?     \ n -- flag ; true if timed out
\ *G Flag is returned true if the time value n has timed out.
\ ** Does not call *\fo{PAUSE}, so *\fo{timedout?} can be used
\ ** in callbacks. In particular, *\fo{TIMEDOUT?} should be used
\ ** rather than *\fo{EXPIRED} inside timer action words to
\ ** reduce timer jitter.
  ticks - 0<                            \ must use circular arithmetic
;
\ ...SFP051


\ ========
\ *> tools
\ *S Zero Terminated Strings
\ ========
( *P A group of simple primitive words to work with 0 terminated ASCII  )
( ** strings.                                                           )

: caddr>zaddr	\ caddr zaddr --
\ *G Copy a counted string to a 0 terminated string.
\  >r count r> zplace			\ return stack is expensive
  swap count rot zplace
;

: .z$		\ zaddr --
\ *G *\fo{TYPE} a zero terminated string.
  begin
    dup c@
   while
    dup c@ emit  1+
  repeat
  drop
;

: z$.		\ zaddr --
\ *G *\fo{TYPE} a zero terminated string. Depending on the output
\ ** device, this may be a bit more efficient than *\fo{.z$}.
  zcount type
;

: .z$EXPANDED           \ zaddr --
\ *G *\fo{TYPE} a zero terminated string after macro expansion.
  { | xs[ MAX_PATH ] -- }
  zcount xs[ ExpandMacro type
;

: z$,		\ c-addr u --
\ *G Lay the given string in the dictionary as a zero terminated string.
\ ** The end of the string is not aligned.
  >r					\ get string length
  here r@ move  r> allot  0 c,          \ make zero terminated
;

: $>z,          \ addr --
\ *G Lay a zero terminated string in the dictionary, given a counted string.
\ ** The end of the string is not aligned.
  count z$,
;

: z",           \ "cc<quote>" --
\ *G "comma" in a zero terminated string from the following text.
\ ** The end of the string is not aligned.
  [char] " word $>z,
;

: $>ASCIIZ      \ caddr -- zaddr
\ *G Convert a counted string to a zero terminated string. The
\ ** converted string is in a thread-local buffer of limited
\ ** lifetime
  count >SyspadZ			\ SFP058
;

: asciiz>$      \ zaddr -- caddr
\ *G Convert a zero terminated string to a counted string. The
\ ** conversion happens in place.
  dup 2dup 255 0 scan drop swap - >r  dup 1+ r@ cmove>  r> over c!
;


\ =======
\ *> kerneldf
\ *S Heap - Runtime memory allocation
\ =======
\ *P The heap memory access wordset is compliant with the
\ ** ANS Standard. The heap is provided and managed by the host
\ ** operating system and is only limited by the available memory
\ ** and/or maximum paging file size. See the later paragraphs
\ ** for implementation-specific details.

defer allocate	\ size -- a-addr ior
\ *G Allocate SIZE address units of contiguous data space. If successful
\ ** an aligned pointer and a 0 IOR are returned. On failure the A-ADDR
\ ** item is invalid and a non-0 IOR is returned. The contents of newly
\ ** allocated heap memory are undefined.

defer resize	\ a-addr newlen -- a-addr ior
\ *G Attempt to resize a block of allocated heap memory to *\i{newlen} size
\ ** in address units. The contents of the memory block are preserved on
\ ** a successful resize operation but the address of the memory block
\ ** may change depending on heap load and the type of resizing
\ ** requested.

defer free	\ a-addr -- ior
\ *G Attempt to release allocated memory at A-ADDR back to the system.
\ ** IOR will return as 0 on success or non-zero for failure.

\ SFP031...
: ProtAlloc	\ n -- addr
\ *G A protected version of *\fo{ALLOCATE} which *\fo{THROW}s
\ ** on failure.
  allocate #-406 ?throw
;

: ProtFree	\ addr --
\ *G A protected version of *\fo{FREE} which does nothing if
\ ** addr=0, and *\fo{THROW}s on failure.
  ?dup if  free #-407 ?throw  endif
;
\ ...SFP031

\ *P From VFX Forth 4.0 onwards, the heap system has changed.
\ ** *\fo{ALLOCATE}, *\fo{FREE} and *\fo{RESIZE } are now
\ **  directly *\fo{DEFER}red to use operating system dependent
\ ** words.

\ *P Under Windows the new heap is much faster but is far less
\ ** tolerant of programming errors. In particular, releasing the
\ ** same block twice or *\fo{FREE}ing memory you did not
\ ** *\fo{ALLOCATE} may/will lead to a crash with the crash
\ ** screen showing a fault outside VFX Forth. Newly allocated
\ ** memory is zeroed and executable.

\ *P The Linux man page for *\b{malloc()} says:
\ *Q "Crashes in malloc(), free() or realloc() are almost always
\ ** related  to heap corruption, such as overflowing an allocated
\ ** chunk or freeing the same pointer twice."

\ *P The *\fo{SYSTEM} vocabulary contains *\fo{INITVFXHEAP ( -- )}
\ ** and *\fo{TERMVFXHEAP ( -- )} which initialise and destroy the
\ ** heap. They are in the cold and exit chains. Note that if you
\ ** are generating a DLL or shared library, these words must be
\ ** explicitly run as the cold and exit chains are not run
\ ** before *\fo{DLLMAIN}.


\ =========
\ *> tmacro
\ *T Text macro substitution
\ =========
\ ********
\ *S Usage
\ ********
\ *P VFX Forth implements text macro substitution, where a text macro
\ ** named *\fo{FOO} my be substituted in a string. When referenced in a
\ ** string the macro name must be surrounded by % characters. If a %
\ ** character is needed in a string it must be entered as %%.

\ *P Thus if *\fo{FOO} is defined as "c:\apps\vfxforth" then the string
\ *E   "Error in file %FOO%\myfile.fth at line "
\ *P would be expanded to
\ *E   "Error in file c:\apps\vfxforth\myfile.fth at line "

\ *P Macros are defined in the *\fo{Substitutions} vocabulary
\ ** which is searched when the string is expanded. When executed
\ ** these words return the address of a counted string for the
\ ** text to substitute.

\ *P *\fo{TextMacro: <name>} defines an empty macro with a 255
\ ** character buffer in the *\fo{Substitutions} vocabulary.

\ *P *\fo{<string> SETMACRO <name>} sets the given string into the
\ ** required macro *\fo{<name>}. If *\fo{<name>} does not exist in
\ ** the *\fo{Substitutions} vocabulary an error is reported.
\ ** *\fo{SETMACRO} may also be used in colon definitions, providing
\ ** that the macro name already exists. If a colon definition needs
\ ** to create a new macro name it should use *\fo{$SETMACRO}
\ ** instead.

\ *E TEXTMACRO: FOO
\ **   C" c:\apps\vfxforth" SETMACRO FOO
\ **
\ ** : BAR           \ --
\ **   C" h:\myapp" SETMACRO FOO
\ ** ;
\ **
\ ** $100 buffer: temp
\ **
\ ** <source> <dest> $EXPAND \ expand source string into destination


\ **************
\ *S Basic words
\ **************

also system definitions

' substitutions voc>wid constant wid-subst
\ Wordlist ID of the wordlist used to hold substitution names
\ and replacement text.

cell +user DestLen	\ -- addr
\ Maximum length of the destination buffer.
2 cells +user Dest	\ -- addr
\ Holds destination string current length and address.
cell +user  SubstErr	\ -- addr
\ Holds zero or an error code.

#300 constant /gMEbuff		\ -- len ; size of global buffer
/gMEbuff cell+ buffer: gMEbuff	\ -- addr ; global macro expansion buffer

: makeSubst	\ caddr len -- caddr'
\ Given a name string create a substution and storage space.
\ Return the address of the buffer for the substitution text.
\ This word requires carnal knowledge of the host Forth.
\ Some systems may need to perform case conversion here.
  wid-subst $create-in		\ CREATE in wid-subst
  here  256 allot  0 over c!	\ create buffer space
;

: findSubst	\ caddr len -- xt flag | 0
\ Given a name string, find the substitution. Return xt and flag
\ if found, or just zero if not found. Some systems may need to
\ perform case conversion here.
  wid-subst search-wordlist  ;

: initSubst	\ dest dlen --
\ Initialise handling with dest/dlen as the output buffer.
  Destlen !  0 Dest 2!  0 SubstErr !  ;

: addDest	\ char --
\ Add the character to the destination string.
  Dest @ DestLen @ < if
    SubstErr @ 0= if
      Dest 2@ + c!  1 chars Dest +!
    else
      drop
    endif
  else
    drop  -1 SubstErr !
  then
;

: >dest		\ caddr len --
\ Add a string to the output string.
  bounds
  ?do  i c@ addDest  1 chars +loop
;

: formName	\ caddr len -- caddr' len' name nlen ; SFP081
\ Given a source string pointing at a leading delimiter return the
\ remainder of the source string after the trailing delimiter and
\ the name string. If the string does not contain a trailing
\ delimiter, nlen is returned zero.
  1 /string				\ step over delimiter
  2dup [char] % scan dup if
    >r drop				\ use length of residue
    2dup r> - tuck			\ caddr' len' nlen name nlen
    2>r  1+ /string  2r>		\ step over name and trailing %
  endif
;

: processName	\ caddr len -- flag
\ Process the substitution name. Return true if found,
\ 0 if not found.
  2dup findSubst if			\ -- caddr len xt | -- caddr len
    nip nip  execute count >dest  true
  else
    [char] % addDest  >dest  [char] % addDest  false
  then
;

previous definitions

also system

\ SFP081...
[-short-branches
: substitute	\ src slen dest dlen -- dest dlen' n ; 17.6.2.2255
\ *G Expand the source string using text macro substitutions,
\ ** placing the result in the buffer *\i{dest/dlen} and
\ ** returning the destination string *\i{dest/dlen'} and the
\ ** number *\i{n} of substitutions made. If an error occurred,
\ ** *\i{n} is negative. Ambiguous conditions occur if the
\ ** result of a substitution is too long to fit into the given
\ ** buffer or the source and destination buffers are the same.
\ *P Substitution occurs left to right from the start of *\i{src/slen}
\ ** in one pass and is non-recursive. When text of a potential
\ ** substitution name, surrounded by ?%? (ASCII $25) delimiters
\ ** is encountered by *\fo{SUBSTITUTE}, the following occurs:*\br{}
\ ** a) If the name is null, a single delimiter character is passed
\ ** to the output, i.e., %% is replaced by %. The current number
\ ** of substitutions is not changed.*\br{}
\ ** b) If the text is a valid substitution name, the leading and
\ ** trailing delimiter characters and the enclosed substitution
\ ** name are replaced by the substitution text. The current number
\ ** of substitutions is incremented.*\br{}
\ ** c) If the text is not a valid substitution name, the name with
\ ** leading and trailing delimiters is passed unchanged to the
\ ** output. The current number of substitutions is not changed.*\br{}
\ ** d) Parsing of the input string resumes after the trailing delimiter.
  4dup overlapped? if
    drop nip nip  0 err_substitute  exit
  then
  initSubst  0 -rot			\ -- 0 src slen
  begin
    dup 0 >
   while
    over c@ [char] % <> if		\ character not %
      over c@ addDest  1 /string
    else
      over 1 chars + c@ [char] % = if	\ %% for one output %
        [char] % addDest  2 /string	\ add one % to output
      else
        formName dup if			\ check good name (two delimiters)
          processName
          if  rot 1+ -rot  then		\ count substitutions
        else
          2drop  [char] % addDest
        then
      then
    then
  repeat
  2drop  Dest 2@			\ -- n dest dlen
  rot SubstErr @			\ if an error has occurred
  if  drop  SubstErr @  then		\ replace #subs with error code.
;
short-branches]
\ ...SFP081

: substituteC	\ src slen dest dlen --
\ *G Expand the source string using text macro substitutions,
\ ** placing the result as a counted string at *\i{dest/dlen}.
\ ** If an error occurred, the length of the counted string
\ ** is zero.
  over >r  1 /string  substitute 0<
  if  2drop 0 r> c!  else  nip r> c!  endif
;

: substituteZ	\ src slen dest dlen --
\ *G Expand the source string using text macro substitutions,
\ ** placing the result as a zero terminated string at *\i{dest/dlen}.
\ ** If an error occurred, the length of the string is zero.
  substitute 0<				\ -- dest dlen' n
  if  drop  else  +  endif		\ -- end+1
  0 swap c!
;

: replaces	\ text tlen name nlen -- ; 17.6.2.2141
\ *G Define the string text/tlen as the text to substitute for the
\ ** substitution named name/nlen. If the substitution does not
\ ** exist it is created.
  2dup findSubst if
    nip nip  execute			\ get buffer address
  else
    makeSubst
  then
  place					\ copy as counted string
[ CPU_ARM ] [if]  FlushCache  [then]
;

: subsitute-safe  \ c-addr1 len1 c-addr2 len2 -- c-addr2 len3 ior
\ *G Replace each '%' character in the input string *\i{c-addr1/len1}
\ ** by two '%' characters. The output buffer is represented by
\ ** *\i{caddr2/len2}. The output is *\i{caddr2/len3} and ior
\ ** is zero on success.
\ ** If you pass a string through *\fo{SUBSITUTE-SAFE} and then
\ ** *\fo{SUBSTITUTE}, you get the original string.
  initSubst  bounds ?do
    i c@ dup addDest  [char] % =
    if  [char] % addDest  then
  loop
  Dest 2@  SubstErr @
;

\ SFP092...
: unescape	\ caddr1 len1 caddr2 -- caddr2 len2 ; 17.6.2.2375
\ *G Replace each '%' character in the input string *\i{caddr1/len1}
\ ** by two '%' characters. The output is represented by *\i{caddr2/len2}.
\ ** The buffer at *\i{caddr2} shall be big enough to hold the
\ ** unescaped string. An ambiguous condition occurs if the
\ ** resulting string will not fit into the destination buffer
\ ** *\i{caddr2}.
  dup  2swap bounds ?do
    i c@ [char] % = if
      [char] % over c! 1+
    then
    i c@ over c!  1+
  loop
  over -
;
\ ...SFP092


\ ************
\ *S Utilities
\ ************

\ SFP039...
: MacroExists?	\ caddr -- xt nz | 0
\ *G If a macro of the given name exists, return its xt and a
\ ** non-zero flag, otherwise just return zero. The name is a
\ ** counted string.
  count wid-subst search-wordlist
;

: MacroSet?	\ caddr -- flag
\ *G If a macro of the given name exists and text has been set
\ ** for it, return true. Often used to find out if a macro has
\ ** been set, so that a sensible default can be defined. In the
\ ** following example, *\fo{IDIR} is the current include directory
\ ** and *\fo{MC"} is a version of *\fo{C"} that expands macros.
\ *E c" GuiLib" MacroSet? 0= [if]
\ **   mc" %IDIR%" SetMacro GuiLib
\ ** [then]
  MacroExists? dup
  if  drop  execute c@ 0<>  endif		\ ??: drop >body c@ 0<>
;
\ ...SFP039

target-only

: TextMacro:    \ <"name"> --
\ *G Builds a new text-macro with an empty macro string.
\ *C   TextMacro: Foo
  also substitutions definitions
    create  0 c,  $0FF allot            \ empty string
  previous definitions
;

: setMacro      \ string "<name>" --
\ *G Reset/Create a text macro. Used in the form:
\ *C   C" abcd" SETMACRO <name>
\ *P For historical reasons, this word can be used inside
\ ** a colon definition in the form:
\ *C   C" abcd" SETMACRO <name>
\ *P If you want to use *\fo{setMacro} as a factor in another word,
\ ** you probably want the interpretation action, so use:
\ *C   ... [INTERP] setMacro ...
\ *P rather than
\ *C   ... setMacro ...
  count parse-name replaces  ;
ndcs: ( -- )
  discard-sinline  postpone count  parse-name postpone sliteral  postpone replaces  ;

: $setmacro     \ string name --
\ *G This version of *\fo{SETMACRO} takes both the string and
\ ** macro name as counted strings.
  swap count  rot count  replaces  ;

: getTextMacro	\ caddr len -- macro$
\ *G Given a macro name, return the address of its text (a counted
\ ** string). If the name cannot be found the null counted string
\ ** *\fo{cNull} is returned.
  ['] substitutions voc>wid  search-wordlist
  if  execute  else  cNull  endif
;

host&target

: .macros       \ --
\ *G Display all text macros by macro name.
  also substitutions  words  previous  ;

: .macro	\ "<name>" -- ; .MACRO <name>
\ *G Display the text for macro *\fo{<name>}.
  also substitutions  ' execute $.  previous
;

internal
: ShowMacro	\ thread nfa -- flag
  cr dup .name ." = " name> execute $.
  drop true
;
external

: ShowMacros	\ --
\ *G Display all macro names and text.
  ['] ShowMacro ['] substitutions voc>wid WalkWordlist
;

: Expand	\ caddr len -- caddr' len'
\ *G Macro expand the given string, returning a global buffer
\ ** containing the expanded string. The string is zero-terminated
\ ** and has a count byte before *\i{caddr'}. If *\i{len} is longer
\ ** than 254 bytes only the first 254 bytes will be processed.
  #254 umin gMEbuff 1+ #254 substitute drop	\ -- caddr len
  zterm					\ zero terminate output ; SFPxxx
  #255 umin dup gMEbuff c!
;

: $expand       \ $source $dest --
\ *G Macro expand a counted string at *\i{$source} to a counted
\ ** string at *\i{$dest}. The returned string is counted and
\ ** zero terminated.
  >r  count r@ 1+ #254 substitute drop
  zterm					\ zero terminate output ; SFPxxx
  nip  r> c!
;

: $ExpandMacros \ $ -- $'
\ *G Macro expand a counted string. Note that the returned string
\ ** buffer is in a global buffer.
  gMEbuff $expand gMEbuff  ;

: z$ExpandMacros        \ z$ -- 'z$
\ *G Macro expand a 0 terminated string. The
\ ** returned string buffer is a global buffer.
  zcount  gMEbuff /gmeBuff 1- substitute drop	\ -- caddr len
 >zterm  ;				\ -- caddr  ; zero terminate output ; SFPxxx

: ExpandMacro   \ c-addr len buff -- 'buff len'
\ *G Perform TextMacro expansion on a string in *\i{c-addr u} with
\ ** the result being placed as a counted string at *\i{buff}. The
\ ** address and length of the expanded string are returned. The
\ ** string at *\i{buff'} is zero terminated.
  dup >r 1+ #254 substitute drop
  zterm						\ zero terminate output ; SFPxxx
  dup r> c!
;

: M",		\ "text" --
\ *G Compile the text string up to the closing quote into the
\ ** dictionary as a counted string, expanding text macros as
\ ** *\fo{M",} executes, usually at compile time.
\ ** The end of the string is aligned.
  [char] " word $expandmacros count $,  ;

: MS"		\ Comp: "<quote>" -- ; Run: -- c-addr u
\ *G Like *\fo{S"} but expands text macros. Text is taken up to
\ ** the next double-quotes character. Text macros are expanded
\ ** at compile time. The address and length of the string are
\ ** returned. To expand macros at run time, use:
\ *C   s" <string>" expand
  [char] " word $expandmacros count  ;
ndcs: ( -- )  compile (s") M",  discard-sinline  ;

: MC"		\ Comp: "<quote>" -- ; Run: -- c-addr
\ *G Like *\fo{C"} but expands text macros. Text is taken up to
\ ** the next double-quotes character. Text macros are expanded at
\ ** compile time. At run-time the address of the counted string
\ ** is returned. To expand macros at run time, use:
\ *C   c" <string>" $ExpandMacros
  [char] " word $expandmacros  ;
ndcs: ( -- )  compile (c") M",  discard-sinline  ;

previous


\ ========================
\ *S System Defined Macros
\ ========================
\ *P The following text macros are defined by the system and are
\ ** always available. They are implemented as words in the
\ ** *\fo{substitutions} vocabulary.

also substitutions definitions
create VfxPath		( -- c$ )   0 c, $FF allot
\ *G The path containing the VFX Forth source code.
\ ** For most users, this is the root
\ ** folder of the VFX Forth installation; however for *\i{Mission}
\ ** and *\i{Ultimate} edition users, *\fo{VfxPath} must be set to
\ ** the *\i{Sources} folder of the VFX Forth installation.
\ ** You must set this yourself. It is preserved in the INI
\ ** file.
create BasePath		( -- c$ )   0 c, $FF allot
\ *G The root folder of the VFX Forth installation. You
\ ** must set this yourself. It is preserved in the INI
\ ** file. Do *\b{not} use *\fo{BasePath} as the root of the VFX
\ ** source tree.
create DevPath		( -- c$ )   0 c, $FF allot
\ *G The path containing the developer's application source.
\ ** If selected by setting *\fo{BuildLevel} to -1, the contents
\ ** of this macro will be prepended to source file names in
\ ** the *\fo{SOURCEFILES} vocabulary.
create LOCATE_PATH	( -- c$ )   0 c, $FF allot
\ *G The name of the current/last file to be compiled.
\ ** Used by *\fo{LOCATE} and friends.
create LOCATE_LINE	( -- c$ )   0 c, $FF allot
\ *G The line number of the line in the current file being compiled.
\ ** Used by *\fo{LOCATE} and friends.
: f locate_path ;
\ *G The name of the current/last file to be compiled.
\ ** A synonym for *\fo{LOCATE_PATH}. Used by *\fo{LOCATE}
\ ** and friends.
: l locate_line ;
\ *G The line number of the line in the current file being compiled.
\ ** A synonym for *\fo{LOCATE_LINE}. Used by *\fo{LOCATE}
\ ** and friends.
create LIBRARYDIR	( -- c$ )   0 c, $FF allot
\ *G The pathname of the VFX Forth *\i{Lib} directory.
: lib LIBRARYDIR ;
\ *G A synonym for *\fo{LIBRARYDIR} above, which returns
\ ** the pathname of the VFX Forth *\i{Lib} directory.
create LOAD_PATH	( -- c$ )   0 c, $FF allot
\ *G The directory containg the running program's executable.
: bin LOAD_PATH ;
\ *G The directory containing the VFX Forth executables.
\ ** A synonym for *\fo{LOAD_PATH}.

(( for DocHen
: idir		\ -- c$
\ *G The current include directory. This string is '.' if no file
\ ** is being *\fo{INCLUDE}d and allows a load file to be
\ ** in the form below. The load file can then be referenced
\ ** from any other directory.
\ *E \ include \dir1\dir2\dir3\loadfile.fth
\ **                               \ in loadfile.fth
\ **  include %idir%\file1.fth     \ file1 in dir3
\ **  include %idir%\file2.fth     \ file2 in dir3
\ **  ...
  CurrDir cell +  ;
))
create wd	\ -- c$
\ *G The working directory. Under Windows, DOS, Unices and OS X
\ ** this is ".". *\b{Do not} change this macro.
  ", ."

previous definitions

also substitutions
LOAD_PATH constant Forth-Buff	\ -- caddr
\ *G Returns the address of a counted string holding the directory
\ ** from which the application was loaded. This gives programs
\ ** easy access to the *\fo{LOAD_PATH} macro.
previous

((
\ ===========
\ Macro Tests
\ ===========

create tb  256 allot	\ -- addr
\ Buffer for text.
create db  256 allot	\ -- addr
\ destination buffer for text.

: >tb		\ caddr len -- caddr' len
\ Place string in TB, and return the string. Done
\ this way to avoid problems with transient regions.
  tb place  tb count
;

: .sub		\ caddr len n --
\ Display the result of a substitution.
  cr . ." Substitutions, result:" type ." :"
;

: tsub		\ caddr len --
\ Run the substitution text and display the results.
  db 256 substitute .sub
;

: MacroTests	\ --
  s" hello" >tb s" hl" replaces
  s" world" >tb s" wld" replaces

\ Test Basics
  s" Start: %hl%,%wld%! :End" tsub
  s" Hello, world!" tsub
  s" aaa%foobar%bbb" tsub
  s" aaa%%bbb" tsub
  s" 12345%6789" tsub

\ Test Utilities
  s" Start: %hl%,%wld%! :End" Expand cr type
  c" Start: %hl%,%wld%! :End" db $expand  cr db $.
  c" Start: %hl%,%wld%! :End" $ExpandMacros  cr $.
  z" Start: %hl%,%wld%! :End" z$ExpandMacros cr zcount type
  s" Start: %hl%,%wld%! :End" db ExpandMacro cr type
;
))


\ =======================================================================
( *> file                                                               )
( *T Working with Files                                                 )
\ =======================================================================

also system definitions

FALSE   value   bCachedINCLUDED?
TRUE    value   bSmartFileLookUp?
TRUE    value   bVerboseInclude?
TRUE    value   bAddSourceFiles

struct SFSTRUCT
  cell field SFSTRUCT.startHERE
  cell field SFSTRUCT.LastHERE
  0    field SFSTRUCT.szPathName
end-struct

struct  VFCACHE
  cell field VFCACHE.sinlink			\ link to previous SIN file or 0
  cell field VFCACHE.hFile			\ O/S file handle
  cell field VFCACHE.lpCache			\ working version
  cell field VFCACHE.nFileSize			\ working version
  cell field VFCACHE.nFilePointer		\ working version
  max_path cell + field VFCACHE.Filename	\ counted string
end-struct

variable foundsf
variable lookfor

: LookForSF     \ @thread nfa -- flag
  foundsf @ if 2drop FALSE exit then          \ already found it!
  nip name> execute >r
  lookfor @
  r@ SFSTRUCT.startHERE @ r@ SFSTRUCT.lastHERE @
  within if
    r@ foundsf !
  then
  r> drop TRUE
;

: SFSTRUCTFromXT        \ xt -- SFSTRUCT | 0
  lookfor !
  0 foundsf !
  ['] lookforSF ['] SourceFiles >body @ WalkWordList
  foundsf @
;
previous definitions


\ ====================
\ *S Source file names
\ ====================
\ *P The following words are useful when writing your own tools.

also system  also forth definitions

l: ns-fb
  ", <File cached in memory>"

: .SourceName   \ ^SFSTRUCT --
\ *G Given a source file structure such as that held by
\ ** the variable *\fo{'SourceFile} display the current file name.
  dup -1 <> if
    SFSTRUCT.szPathName .z$EXPANDED
  else
    drop  ns-fb $.
    cr ." Last word defined is " latest ctrl>nfa .name	\ SFP019
  then
;

: CurrSourceName	\ -- c-addr u
\ *G Returns the current source file name *\b{without} expanding
\ ** any text macros.
  case  'SourceFile @
    0 of  S" console"  endof
    -1 of  ns-fb count  endof
           SFSTRUCT.szPathName zcount
  end-case
;

previous previous definitions

[-short-branches
: stripFilename	\ cstring --
\ *G The input is a counted string containing a full path
\ ** and filename e.g. "C:\WINDOWS\SYSTEM32\COMMAND.COM".
\ ** The file name is removed to leave "C:\WINDOWS\SYSTEM32".
\ ** Note that the actual directory separator used depends
\ ** on the host operating system.
  dup c@ if
    dup count over + 1- do		\ -- c$ ; work backwards
      i c@ dirChar?			\ check for / or \
      over 1 swap c-!
      ?leave
    -1 +loop
  endif
  drop
;
short-branches]

create cDot	\ -- addr
\ bottom level IncDir structure
  cDot ,			\ link to previous structure
  1 c,  char . c, aligned	\ directory name

cDot value IncDir	\ -- struct
\ Returns a structure for the directory containing the current
\ include file. A dot string "." is returned if no *\fo{INCLUDE}
\ is in progress.
cDot value CurrDir	\ -- c$

also system definitions
: ++IncDir	\ caddr len --
\ Given a file name, set a new include directory.
  expand #255 umin  #256 cell + protAlloc	\ -- caddr' len' struct
  IncDir over !					\ link to previous struct
  dup -> IncDir cell + place			\ -- ; string to buffer
  IncDir cell + stripFilename			\ remove file name to leave dir
  IncDir cell + c@ 0=				\ check for null dir
  if  s" ." IncDir cell + place  endif
  IncDir -> CurrDir
;

: --IncDir	\ --
\ Restore the previous include directory.
  IncDir dup @  swap protFree  dup -> IncDir -> CurrDir
;
previous definitions

also substitutions definitions
: idir  CurrDir cell +  ;
previous definitions


\ **************************
\ *S ANS File Access Wordset
\ **************************
( *P The basis for all file operations comes from the ANS specification )
( ** wordset for Files. The following group of definitions are          )
( ** implementations of the ANS standard set.                           )
( **                                                                    )
( *P The following data types are used:                                 )
( *D fam        "File Access Method", describes read/write permission )
( **            etc.                                                    )
( *D ior        "IO Result", A return result from most IO calls, this   )
( **            value is 0 for success or non-zero as an error-code.    )
( *D fileid     "File Identifier", a handle for a file.       )
( **                                                                    )
\ =======================================================================

also system

: bin           \ fam -- 'fam
\ *G Modify a file-access method to include BINARY.
  os_bin
;

: r/o           \ -- fam
\ *G Get ReadOnly fam
  os_r/o
;

: w/o           \ -- fam
\ *G Get WriteOnly fam
  os_w/o
;

: r/w           \ -- fam
\ *G Get ReadWrite fam
  os_r/w
;

: Create-File   \ c-addr u fam -- fileid ior
\ *G Create a file on disk, returning a 0 ior for success and
\ ** a file id. Macro names are expanded before
\ ** the operating system file create call is made.
  { c-addr u fam | ExpandedName[ MAX_PATH ] -- fileid ior }
  c-addr u ExpandedName[ ExpandMacro
  fam os_Create-File
;

: Open-File     \ c-addr u fam -- fileid ior
\ *G Open an existing file on disk. Macro names are expanded before
\ ** the operating system file open call is made.
  { c-addr u fam | ExpandedName[ MAX_PATH ] -- fileid ior }
  c-addr u ExpandedName[ ExpandMacro
  fam os_Open-File
;

[-short-branches
: ?Relative-Open-File	\ c-addr u fam -- fileid ior
\ *G Open an existing file on disk. Macro names are expanded before
\ ** the operating system file open call is made. If the first two
\ ** characters of the file name are './' the file path is taken
\ ** to be relative to the directory of the containing include file.
  { c-addr u fam | File[ MAX_PATH ] ExpandedName[ MAX_PATH ] -- fileid ior }
  u 2 > if
    c-addr s" ./" s= if
      File[ MAX_PATH erase
      s" %idir%" File[ place  dir1-char c@ File[ addchar
      c-addr u 2 /string File[ append
      File[ count ExpandedName[ ExpandMacro
    else
      c-addr u ExpandedName[ ExpandMacro
    then
  then
  fam os_Open-File
;
short-branches]
: Close-File    \ fileid -- ior
\ *G Close an open file. Use correct method for VFCACHED files.
  dup -1 =
  if  drop 0  exit  then
  dup IsFileIDCached?
  if  VF-Close-File  exit  then
  OS_Close-File
;

: Write-File    \ caddr u fileid -- ior
\ *G Write a block of memory to a file.
  OS_Write-File
;

: write-line    \ c-addr u fileid -- ior
\ *G Write data followed by EOL. IOR=0 for success. Note that the
\ ** end of line sequence is given by *\fo{EOL$} and is operating
\ ** system dependent.
  dup >r Write-File  eol$ count r> Write-File  or
;

: Read-File     \ caddr u fileid -- u2 ior
\ *G Read data from a file, use VF-CACHE Version where appropriate.
\ ** The number of characters actually read is returned as u2, and ior
\ ** is returned 0 for a successful read.
  dup IsFileIDCached? if
    VF-READ-FILE
  else
    OS_Read-File
  then
;

: read-line     \ c-addr u1 fileid -- u2 flag ior	11.6.1.2090
\ *G Read an ASCII line of text from a file into a buffer, without EOL.
\ ** Read the next line from the file specified by fileid into memory
\ ** at the address *\i{c-addr}. At most *\i{u1} characters are read.
\ ** Up to two line-terminating characters may be read into memory
\ ** at the end of the line, but are not included in the count *\i{u2}.
\ ** The line buffer provided by *\i{c-addr} should be at least *\i{u1+2}
\ ** characters long.
\ *P If the operation succeeds, *\i{flag} is true and *\i{ior} is zero. If a
\ ** line terminator was received before *\i{u1} characters were read,
\ ** then *\i{u2} is the number of characters, not including the line
\ ** terminator, actually read (*\i{0 <= u2 <= u1}). When *\i{u1 = u2}, the
\ ** line terminator has yet to be reached.
\ *P If the operation is initiated when the value returned by
\ ** *\fo{FILE-POSITION} is equal to the value returned by *\fo{FILE-SIZE}
\ ** for the file identified by *\i{fileid}, *\i{flag} is false, *\i{ior} is zero,
\ ** and *\i{u2} is zero. If *\i{ior} is non-zero, an exception occurred
\ ** during the operation and *\i{ior} is the I/O result code.
\ *P An ambiguous condition exists if the operation is initiated
\ ** when the value returned by *\fo{FILE-POSITION} is greater than the
\ ** value returned by *\fo{FILE-SIZE} for the file identified by *\i{fileid},
\ ** or if the requested operation attempts to read portions of the
\ ** file not written.
\ *P At the conclusion of the operation, *\fo{FILE-POSITION} returns the
\ ** next file position after the last character read.

  { c-addr u fileid | len ur -- u2 flag ior }

  c-addr u fileid read-file             \ read whole 'u' bytes
  if  drop  0 0 -71  exit  then         \ bad ior, bomb ; SFP098
  dup -> ur                             \ UR is now number of bytes read ; SFP098
  0= if
    u if				\ SFP098...
      0 false 0				\ null read, eof!
    else
      0 true 0				\ asked for 0, ok
    then				\ ...SFP098
    exit
  then

  \ find eol terminator byte '\n'
  c-addr ur ALF scan ?dup 0=
  if  drop  ur true 0  exit  then       \ no terminator

  \ c-addrR uR --
  nip                                   \ UR -- ; number of bytes overrun including terminator
  ur over - -> len                      \ the return length
  1-                                    \ #chars to put back in file
  s>d dnegate
  fileid file-position drop             \ #chars(d) u(d)
  d+ fileid reposition-file drop	\ does not work for RS232 and pipes

  len if
    c-addr len 1- + c@ ACR =
    if  len 1- -> len  then
  then

  len true 0                            \ normal exit path
;

: file-size     \ fileid -- ud ior
\ *G Get size in bytes of an open file as a double number,
\ ** and return ior=0 on success.
  dup IsFileIDCached? if
    VF-FILE-SIZE
  else
    OS_File-Size
  then
;

: file-position \ fileid -- ud ior
\ *G Return file position, and return ior=0 on success.
  dup IsFileIDCached? if
    VF-FILE-POSITION
  else
    OS_File-Position
  then
;

: Reposition-File	\ ud fileid -- ior
\ *G Set file position, and return ior=0 on success.
  dup IsFileIDCached? if
    VF-REPOSITION-FILE
  else
    OS_Reposition-File
  then
;

: Resize-File	\ ud fileid -- ior
\ *G Set the size of the file to *\i{ud}, an unsigned double number.
\ ** After using *\fo{RESIZE-FILE}, the result returned by
\ ** *\fo{FILE-POSITION} may be invalid. Note that for a
\ ** VF-CACHEd file, this operation is performed on the
\ ** underlying physical file.
  dup IsFileIDCached?			\ if cached
  if  $7FFFFFFF and  then		\ get underlying file handle
  dup >r
  reposition-file ?dup
  if  r> drop  exit  then
  r> OS_SetEndOfFile
;

: delete-file   \ caddr len -- ior
\ *G Delete a named file from disk, and return ior=0 on success.
\ ** Text macros will be expanded before the file is opened.
  expand OS_Delete-File			\ SFP075
;

: FileExists?	\ caddr len -- flag
\ *G Look to see if a specified file exists, returning TRUE
\ ** if the file exists. Text macros are expanded.
  r/o Open-File if
    drop FALSE
  else
    close-file drop  TRUE
  then
;

: RelFileExists?	\ caddr len -- flag
\ *G Look to see if a specified file exists, returning TRUE
\ ** if the file exists. A './' prefix is treated as a relative
\ ** file. Text macros are expanded.
  r/o ?Relative-Open-File if
    drop FALSE
  else
    close-file drop  TRUE
  then
;

: FileExist?    \ caddr len -- flag
\ *G Use *\fo{FileExists?} above. OBSOLETE, WILL BE REMOVED.
  FileExists?
;

: RelFileExist?    \ caddr len -- flag
\ *G Use *\fo{RelFileExists?} above. OBSOLETE, WILL BE REMOVED.
  RelFileExists?
;

: file-status	\ caddr len -- x ior                     11.6.2.1524
\ *G Return the status of the file identified by the character
\ ** string *\i{c-addr/len}. If the file exists, *\i{ior} is zero;
\ ** otherwise *\i{ior} is the implementation-defined I/O result
\ ** code. *\i{X} contains implementation-defined information about
\ ** the file (always zero for VFX Forth).
   FileExists? 0= 0 swap
;

: rename-file	\ caddr1 len1 caddr2 len2 -- ior         11.6.2.2130
\ *G Rename the file named by the character string *\i{c1addr/len1}
\ ** to the name in the character string *\i{caddr2/len2}. *\i{Ior}
\ ** is the I/O result code.
  { | old[ 256 ] new[ 256 ] -- }		\ SFP075
  new[ 256 substituteC  old[ 256 substituteC	\ SFP075
  old[ count  new[ count  OS_Rename-File	\ SFP075
;

\ SFP046...
: flush-file	\ fileid -- ior
\ *G Flush changed file data to disk, and return ior=0 on success.
  OS_Flush-File
;
\ ...SFP046

variable LinesCompiled
  0 LinesCompiled !

: debug1-on     ( -- )  debug1 on ;
: debug1-off    ( -- )  debug1 off ;

: ((include-file))      \ --
\ The guts of the include system
  begin
    refill  debug1 @
    if  source type cr  key? drop  then
  while
    LinesCompiled incr
    interpret
  repeat
;

: ?markEndOfSource	\ -- ; SFP077
\ Set HERE as end of source file if structure is valid
  'SourceFile @ if
    'SourceFile @ -1 <> if
      here 'SourceFile @ SFSTRUCT.LastHERE !
[ CPU_ARM ] [if]  FlushCache  [then]
    then
  then
;

: (include-file)        \ ^SFSTRUCT|-1 file-id -- ior ; SFO007 SFP094
\ The file is already open. The file is not closed afterwards.
  cc-level @ >r  cc-level off		\ prepare cond. comp. check

  save-input n>r

  0 line# !
  to source-id  'SourceFile !

  FILETIBSZ allocate if
    drop  err_allocate
  else
    0 to-source
    ['] ((include-file)) catch dup if
      IncDir @ -> CurrDir		\ unnest IDIR
      .throw  -1
    endif
    source drop free drop
  then
  ?markEndOfSource			\ SFP077
  nr> restore-input drop		\ SFP007

  dup 0= if				\ check only on success, SFP102
    cc-level @				\ check cond. comp. level
    if  drop -424  then
  then					\ SFP102
  r> cc-level !				\ restore cond. comp. level
;

: include-file          \ file-id --
\ *G Include source code from an open file whose file-id (handle)
\ ** is given. The file is closed by *\fo{INCLUDE-FILE}.
  dup >r
  -1 swap (include-file)
  r> close-file drop
  throw
;

: included      \ c-addr u --
\ *G Include source code from a file whose name is given by *\i{c-addr/u}.
\ ** Text macros will be expanded before the file is opened.
  EmptyIdle
  ResolveIncludeFileName
  bVerboseInclude?
  if  cr ." Including " 2dup type  then
  AddSourceFile -rot            	\ ^SFSTRUCT c-addr u
  2dup r/o  bCachedINCLUDED? if
    VF-Open-File
  else
    ?Relative-Open-File
  then
  #-258 ?throw
  -rot  ++IncDir
  dup >r (include-file)
  r> close-file drop
  --IncDir
  throw
  base @ -> SbBase
  depth -> SbDepth
  context @ -> sbContext
  current @ -> sbCurrent
;

: include       \ "<name>" --
\ *G A more convenient form of *\fo{INCLUDED}. Use in the form:
\ *C   INCLUDE <name>
\ *P Text macros will be expanded before the file is opened.
\ ** See *\fo{GetPathSpec} for a discussion of file name formats
\ ** including spaces.
  getPathSpec included  ;

: required	\ c-addr u --
\ *G If the file specified by *\i{c-addr/u} has already been
\ ** *\fo{INCLUDED}, discard *\i{c-addr/u}; otherwise, perform
\ ** the function of *\fo{INCLUDED}. You must provide the
\ ** source file's extension.
  2dup ['] SourceFiles voc>wid search-wordlist
  if  drop 2drop  else  included  endif
;

: require	\ "<name>" --
\ *G Skip leading white space and parse name delimited by a white
\ ** space character. Put the address and length of the name on
\ ** the stack and perform the function of *\fo{REQUIRED}.
\ ** You must provide the source file's extension.
  getPathSpec required  ;

: data-file	\ -- size ; DATA-FILE <filename>
\ *G Loads a file to memory at *\fo{HERE} and *\fo{ALLOT}s memory.
\ ** The size of the file is returned. This is a good way to load
\ ** data directly into the dictionary at compile time. It avoids
\ ** having to convert binary data into streams of digits and commas.
\ ** For example, DocGen keeps a CSS file in the dictionary:
\ *E CREATE BootstrapAddr    \ --
\ **   data-file bootstrap.min.css     \ load the file
\ ** constant /Bootstrap               \ keep the length
  GetPathSpec r/o open-file #-413 ?throw >r	\ open-file
  r@ file-size #-414 ?throw drop		\ -- size ; R: -- handle
  here over r@ read-file #-414 ?throw drop	\ -- size ; R: -- handle
  dup allot
  r> close-file #-416 ?throw		\ close
;
previous


\ =======================================================================
\ *S File Caching
\ **
\ *P VFX Forth supports memory caching of read-only files. Any file
\ ** which is to be cached is opened using *\fo{VF-OPEN-FILE} rather
\ ** than the ANS word *\fo{OPEN-FILE}. The normal ANS wordset can then
\ ** be used with re-vectoring being automatic. The control directive
\ ** *\fo{+VFCACHE} (see later) enables *\fo{INCLUDE} and friends to
\ ** use file caching automatically, which decreases compilation
\ ** time for larger projects.
\ =======================================================================

also system

256 equ #VFcached		\ -- u
\ Number of slots in the VFCACHE array.
#VFcached cells equ /VFcached	\ -- len
\ Size of the array.
/VFcached buffer: VFcached[]	\ -- sddr
\ Holds addresses of VFCACHE structures for open files so that
\ high ALLOCATEd addresses can be used.

: +VFslot	\ -- slot# 0 | -- true
\ Try to find a slot in the VFCACHE structure array. Slots are
\ cell indices starting at CELL.
  VFcached[] /VFcached bounds do
    i @ 0= if
      i VFcached[] - cell +
      0 unloop exit
    endif
  cell +loop
  -1
;

: -VFslot	\ slot# --
\ free up the given slot
  cell - VFcached[] + off
;

: VFslot@	\ slot# -- *vfcache
  $7FFF:FFFF and cell - VFcached[] + @
;

: VFslot!	\ *vfcache slot# --
  $7FFF:FFFF and cell - VFcached[] + !
;

: IsFileIDCached?       \ fileid -- flag
\ *G Determine if an open file referenced by FILEID is a cached file.
  $8000:0000 and 0<>
;

: VF-Open-File          \ caddr len fam -- fileid ior
\ *G Open a file using VFCACHE Mode. This means read the whole file
\ ** into memory.
  >r 2dup r> ?Relative-Open-File dup if	\ -- caddr len fileid ior
    2swap 2drop  exit
  endif
  drop					\ -- caddr len fileid

  +VFslot if				\ if no slot available
    nip nip 0  exit			\ just do normal open
  endif
  >r					\ -- c-addr u fileid ; R: -- slot#

  VFCACHE allocate if			\ -- c-addr u fileid addr ; R: -- slot#
    drop  Close-File drop
    2drop  r> drop
    -1 -258  exit
  then
  >r					\ -- caddr u fileid ; R: -- slot# *VFCACHE
  -rot  r@ VFCACHE.FileName place	\ save name as counted string

  dup file-size 2drop			\ -- fileid filesize ; R: -- slot# *VFCACHE

  dup allocate if			\ -- fileid filesize membuff ; R: -- slot# *VFCACHE
    2drop  Close-File drop
    r> free drop  r> drop
    -1 -258  exit
  then
                                	\ -- fileid filesize membuff ; R: -- slot# *VFCACHE
  swap rot                      	\ -- membuff filesize fileid ; R: -- slot# *VFCACHE

\ initialise pointers - working and fixed
  dup    r@ VFCACHE.hFile !
  over   r@ VFCACHE.nFileSize !
  2 pick r@ VFCACHE.lpCache !
  0      r@ VFCACHE.nFilePointer !

  Read-File 2drop
  0 r@ VFCACHE.nFilePointer !		\ -- ; R: -- slot# *VFCACHE

((
[defined] (FLushCache) [if]		\ ARMs
  r@ VFCACHE.lpCache @			\ start
  dup r@ VFCACHE.nFileSize @ +		\ end
  (FlushCache)
[then]
))

\ ." VFCACHE" cr
\ ." hFile = " r@ VFCACHE.hFile @ .dword cr
\ ." Size  = " r@ VFCACHE.nFileSize @ .dword cr
\ ." Buff  = " r@ VFCACHE.lpCache @ .dword cr

  r> r> tuck VFslot!			\ -- slot#
  $8000:0000 or 0			\ -- slot#' 0
;

: VF-Close-File         \ fileid -- ior
\ *G Close a VFCACHED file, i.e. free its memory.
  VFslot@
  dup VFCACHE.hFile @ -1 <> if		\ SFP032
    dup VFCACHE.hFile @ close-file drop
    dup VFCACHE.lpCache @ free drop	\ SFP032
  endif					\ SFP032
  free drop				\ SFP032
  0
;

: VF-Read-File          \ caddr u fileid -- u2 ior
\ *G Read into a buffer from a VFCached file.
  { caddr u fileid -- u2 ior }

  fileid VFslot@ -> fileid

  fileid VFCACHE.nFilePointer @
  fileid VFCACHE.nFileSize @ = if
    0 -1
  else
    fileid VFCACHE.nFileSize @ fileid VFCACHE.nFilePointer @ -
\    u MIN -> u
    u UMIN -> u				\ SFP052

    fileid VFCACHE.lpCache @ fileid VFCACHE.nFilePointer @ +
    caddr u move

    u fileid VFCACHE.nFilePointer +!

    u 0
  then
;

: VF-FILE-SIZE          \ fileid -- ud ior
  VFslot@ VFCACHE.nFileSize @ s>d 0
;

: VF-FILE-POSITION      \ fileid -- ud ior
  VFslot@ VFCACHE.nFilePointer @ s>d 0
;

: VF-REPOSITION-FILE    \ ud fileid -- ior
  nip  VFslot@ VFCACHE.nFilePointer ! 0
;

\ SFP032...
: Mem-Open-File	\ c-addr u fam -- fileid ior
\ *G Open a memory block *\i{caddr/u} using VFCACHE mode.
\ ** *\i{Fam} is ignored. When this file is closed, no attempt is
\ ** made to *\fo{FREE} *\i{caddr/u}.
  drop					\ discard fam

  +VFslot if				\ if no slot available
    2drop  -1 -258 exit			\ fail the operation
  endif
  >r					\ -- c-addr u ; R: -- slot#

  VFCACHE allocate if			\ -- c-addr u *VFcache ; R: -- slot#
    2drop r> drop  -1 -258  exit
  then
  >r					\ -- caddr u ; R: -- slot# *VFCACHE

\ initialise pointers - working and fixed
  -1 r@ VFCACHE.hFile !			\ dummy handle
  r@ VFCACHE.nFileSize !		\ file size
  r@ VFCACHE.lpCache !			\ memory buffer
  0 r@ VFCACHE.nFilePointer !		\ from the beginning
  0 r@ VFCACHE.FileName c!		\ null file name

  r> r> tuck VFslot!			\ -- slot#
  $8000:0000 or 0			\ -- slot#' 0
;

: IncludeMem	\ c-addr u --
\ *G Include source code from a memory buffer. Errors cause a
\ ** *\fo{THROW}.
  r/o Mem-Open-File #-258 ?throw
  -1 swap  dup >r (include-file)
  r> close-file drop
  throw
;
\ ...SFP032

previous


\ =========================
\ *S "Smart File" Inclusion
\ =========================
( *P Any pathname used to include source from a text-file passes through)
( ** the Smart File filter. This code attempts to resolve the file      )
( ** extension for a name passed to it. The resolve algorithm looks for )
( ** the file path as specifed, then with a number of common file       )
\ ** extensions. See the *\fo{ResolveIncludefilename} definition below.
( ** If no match is found then the original name is passed back.        )
( **                                                                    )
\ =======================================================================

(( \ for documentation only
TRUE value bSmartFileLookUp?
\ *G When non-zero, the smart file filter is enabled.
\ ** See also *\fo{+SMARTINCLUDE} and *\fo{-SMARTINCLUDE} which should
\ ** be used to control the smart file filter.
))

also system

: dirChar?	\ char -- flag
\ *G Returns true if the character is one of the two directory
\ ** separators specified in the system variables *\fo{DIR1-CHAR}
\ ** and *\fo{DIR2-CHAR}.
  dup dir1-char @ =
  if  drop true exit  endif
  dir2-char @ =
;

-short-branches
: Extension?	\ c-addr u -- len true | false
\ *G Treats *\i{c-addr/u} as a file name and returns the extension
\ ** length and true if the file name has an extension
\ ** (i.e. it ends in '.xxx'), or just false if no extension
\ ** is present. The extension can be of any length (including 0)
\ ** as names of the form "name." are treated as having an extension.
\ ** Unfortunately such names can exist. A name of zero length
\ ** returns false.
  dup if
    over + 1-  2dup do			\ -- first last
      i c@ dirChar? ?leave		\ done if directory separator
      i c@ [char] . = if		\ found dot in name?
        over i = ?leave			\ if first char, no extension
        i 1- c@	BL [char] z within? if	\ check that prev char is BL..z?
	  nip i - true  unloop  exit	\
	endif
      endif
    -1 chars +loop
  endif
  2drop false
;
+short-branches

: ChangeEXT3    \ c-addr u c-addr1 u1 -- c-addr u
\ *G Change the last 3 characters of the string at c-addr u to use
\ ** the text at c-addr1 u1 (where u1 is always 3).
  2over + 3 chars -
  swap move
;

: ResolveIncludeFileName        \ c-addr u -- c-addr u
\ *G Given what may be a extension-less filename attempt to locate a
\ ** matching file and return its string description.
\ ** Note that the returned string is built at *\fo{HERE}.
\ ** Matching rules are:
\ *(
\ *B If the file name exists, return
\ *B If an extension is present, return.
\ *B Look for a recognized extension.
\ *)
\ *P The extensions ".BLD" ".FTH" ".F" ".CTL" ".SEQ" are searched for
\ ** in that order. For case-sensitive file systems, lower case
\ ** extensions are tried before upper case. Mixed case is not
\ ** attempted.
  bSmartFileLookUp? 0= if exit then

  \ step#0. If a file by the given name exists, don't change it
  2dup RelFileExists? if exit then		\ SFP069

  \ step#1. If the file name already has an extension,
  \ return the original string
  2dup Extension?
  if  drop  exit  endif
  \ -- caddr u

  \ Step#2. Copy string to here (probably already there!)
  dup >r here swap move
  here r>               \ c-addr u --

  \ Step#3. Ensure a trailing ASCII .
  2dup +
  1 chars - c@
  [char] . <> if
    2dup + [char] . swap c!
    1 chars +
  then

  \ Step#4. Look for file now (with . ensured, some people use files like that!)
  2dup RelFileExists? if exit then

  \ Step#5. Append BLD to string and look
  2dup +
  S" bld" rot swap move 3 chars +
  2dup RelFileExists? if exit then

  \ Step#6. Replace BLD with others and try
  \ Note that we have to deal with ".forth" at some time.
  2dup S" fth" ChangeExt3 RelFileExists? if exit then
  2dup S" f  " ChangeExt3 RelFileExists? if exit then
  2dup S" fs " ChangeExt3 RelFileExists? if exit then
  2dup S" 4th" ChangeExt3 RelFileExists? if exit then
  2dup S" ctl" ChangeExt3 RelFileExists? if exit then
  2dup S" seq" ChangeExt3 RelFileExists? if exit then

[ Target_386_Linux  Target_ARM_Linux or  Target_386_OSX or ] [IF]     \ try uppercase too. Case-sensitive file system
  2dup S" BLD" ChangeExt3 RelFileExists? if exit then
  2dup S" FTH" ChangeExt3 RelFileExists? if exit then
  2dup S" F  " ChangeExt3 RelFileExists? if exit then
  2dup S" FS " ChangeExt3 RelFileExists? if exit then
  2dup S" 4TH" ChangeExt3 RelFileExists? if exit then
  2dup S" CTL" ChangeExt3 RelFileExists? if exit then
  2dup S" SEQ" ChangeExt3 RelFileExists? if exit then
[THEN]

  \ Step#7. Just return the name and be done with it!
  3 chars -			\ Remove the file extension
;

previous

\ =======================================================================
( **                                                                    )
( *S Source File Tracking                                               )
( **                                                                    )
( *P VFX Forth automatically keeps track of compiled source files.      )
( ** Whenever a new source is compiled into the system, the file        )
( ** location and dictionary impact is recorded. One use of this system )
( ** is *\fo{LOCATE} specified below which can attempt to find the   )
( ** source for a definition and automatically load it into your        )
( ** favourite editor for review.                                       )
( **                                                                    )
\ *P Many users keep their source code in a path (directory or folder)
\ ** with all the files being loaded by a control file which contains
\ ** many lines of the form:
\ *E include part1\petrol
\ ** include part1\gas
\ ** include part2\forms
\ ** include part2\recalculate
\ ** ...
\ *P If the source code is moved, for example to a laptop, the new path
\ ** may be different and *\fo{LOCATE} and friends may then fail. In order to
\ ** cope with this, additional tracking text can be added at the start
\ ** of the file name. This text is usually a macro name. What text is
\ ** added is controlled by the value *\fo{BuildLevel} and the
\ ** macro *\fo{DEVPATH}.

\ *P If *\fo{BuildLevel} is set to 0, no additional information
\ ** is added. If *\fo{BuildLevel} is set to -1, the contents of
\ ** the macro *\fo{DEVPATH} are prepended to the file name.
\ ** *\b{ Do not} set *\fo{BuildLevel} to any other values!

\ *P *\fo{DEVPATH} may itself contain a macro name. *\fo{LOCATE}
\ ** expands macros before attempting to open the file. This
\ ** enables you to partition an application across several build
\ ** phases, and still be able to *\fo{LOCATE} words when the
\ ** tree structures have been moved or modified.
\ =======================================================================

0 value BuildLevel	\ -- n
\ *G Used to control what is added to the start of the file
\ ** name for source file tracking. See above for more details.

also system

: +source-files \ --
( *G Enable source file tracking. )
  true to bAddSourceFiles
;

: -source-files \ --
( *G Disable source file tracking. )
  false to bAddSourceFiles
;

defer sourceTrackRename	\ zaddr --
\ *G A hook so that names for the source file tracking system
\ ** can be updated to suit user habit. The input *\i{zaddr}
\ ** is a pointer to a buffer containing a zero-terminated file
\ ** name. The updated name must be returned in the same buffer.
\ ** The buffer is of size *\fo{MAX_PATH} bytes.
\ ** The default action is *\fo{drop}.

: AddSourceFile	\ c-addr u -- 'c-addr 'u ^SFSTRUCT | c-addr u -1
\ *G Add a source file to the tracking vocabulary. *\i{caddr/u}
\ ** represents  the pathname supplied to *\fo{INCLUDED}.
  { | tempname[ MAX_PATH cell + ] -- }

\ Checks and set up
  bAddSourceFiles 0= if			\ bail out if not required
    bVerboseInclude? if
      cr ." Untracked source " 2dup type
    endif
    -1  exit
  then

  over s" %idir%" is=  over 6 > and if	\ if name starts with %IDIR%, not unique ; SFP076
    IncDir cell+ count tempname[ zplace
    6 /string tempname[ zappend
  else
    tempname[ zplace
  then
  tempname[ sourceTrackRename		\ user hook

  here					\ start of code built by this INCLUDE

\ create entry in SOURCEFILES vocabulary
  get-current >r
  ['] SourceFiles >body @ set-current	\ create in SOURCEFILES
  warnings? >r  -warnings
  tempname[ zcount ($CREATE)		\ N.B. includes UPPER
  1 latest-xt >line# w!			\ SFP006 SFP020
  r> if +warnings then
  r> set-current

\ build the SFSTRUCT
  here >r				\ base of new SFSTRUCT
  ,					\ start address is BEFORE source file
  0 ,                                   \ end address will be filled in later

\ SFP002...
  case  buildLevel
    -1 of  [ also substitutions ] DevPath [ previous ] count  endof
[ host_linux Host_OSX or ] [if]
    1 of  s" %VFXPATH%/Kernel/"  endof
    2 of  s" %VFXPATH%/VFXBase/"  endof
    3 of  s" %VFXPATH%/Studio/"  endof
[else]
    1 of  s" %VFXPATH%\Kernel\"  endof
    2 of  s" %VFXPATH%\VFXBase\"  endof
    3 of  s" %VFXPATH%\Studio\"  endof
[then]
          drop  0 0
  end-case
\ ...SFP002

\ -- c-addr u ; string to prepend
  dup >r  here swap move  r> allot	\ lay it - N.B. zero terminated string
  here					\ pass back original filename
  tempname[ zcount z$,			\ lay ORIGINAL file name, but upper case
  align here r@ SFSTRUCT.LastHere !	\ this is the current end
  zcount r>				\ return file name - UPPERed
[ CPU_ARM ] [if]  FlushCache  [then]
;

interpreter
: sfile:	\ start end -- ; <start> <end> SFILE: <name> <longname>"
  also sourcefiles definitions
  create
    swap , ,  z", align
  previous definitions
;

: end-sfile	\ end -- ; <end> END-SFILE <name>
  also sourcefiles
  ' >body cell+ !
  previous
;
target

-short-branches

: (whereis)     \ xt -- c-addr u line# TRUE | FALSE
\ *G Given the XT of a word this will return the filename string,
\ ** the line number and TRUE for the definition.
\ ** If the xt cannot be found, just a 0 is returned.
  dup SFSTRUCTFromXT ?dup if
    SFSTRUCT.szPathName zcount rot >line# w@ TRUE
  else
    drop FALSE
  then
;

: whereis	\ -- ; WHEREIS <name>
\ *G Use in the form *\fo{WHEREIS <name>} to find the source
\ ** location of a word.
  ' (whereis) if
    -rot  cr ." File: " type  ." , line " .
  else
    cr ." No information"
  endif
;

: source-info   \ c-addr u -- start end size true | false
\ *G Return dictionary start/end and binary size of a compiled
\ ** source file from a string. Returns FALSE only if the source
\ ** name was not recognized.
  ['] sourcefiles >body @ search-wordlist if
    execute
    dup @ swap cell+ @			\ -- start end
    2dup swap -				\ -- start end size
    true
  else
    false
  then
;

defer .locate	\ --
\ *G Perform the desired action of *\fo{LOCATE} below. The
\ ** *\fo{LOCATE_PATH} and *\fo{LOCATE_LINE} macros have
\ ** been set up.

defer .nolocate	\ --
\ *G Perform the action of *\fo{LOCATE} below when the word has been
\ ** found but has no source information.

:NONAME		\ --
  { | temp[ MAX_PATH ] -- }
  S" Definition found in %LOCATE_PATH% at line %LOCATE_LINE%."
  temp[ ExpandMacro
  cr type cr
; to-do .locate

:noname		\ --
  cr ." No source information available" cr
; to-do .nolocate

also substitutions
: LocateInfo	\ caddr u line# --
\ *G Set the locate macros using *\i{caddr/u} as the file name and
\ ** *\i{line#} as the line number. The file name is expanded.
  base @ >r  decimal s>d <# #S #>  r> base ! locate_line place
  expand locate_path place
;
previous

: locate	\ <"name"> --
\ *G Use in the form *\fo{LOCATE <name>} and display its source code.
\ ** This word is redefined by the Windows Studio environment.
  'syn (whereis) if			\ caddr u line# --
    LocateInfo .locate
  else
    .nolocate
  then
;

+short-branches

previous

\ =======
\ *> file
\ =======

also system

: (.Source)     \ #thread nfa -- flag
  base @ >r decimal
  nip name> execute             \ ^SFSTRUCT --
  cr dup SFSTRUCT.szPathName  .z$
  out @ #38 >
  if  cr  endif
  #40 >pos
  dup SFSTRUCT.startHERE @ .lword
  ." ..$" dup SFSTRUCT.lastHERE  @ .lword
  ."   " dup SFSTRUCT.lastHERE  @ over SFSTRUCT.startHERE @ - u.
  drop
  halt? 0=			\ return true unless HALT requested
  r> base !
;

: .sources      \ --
\ *G Display list of sources used in build so far, includes size,
\ ** source file name and dictionary pointers.
  op-line# off
  cr cr ." Source Files in Current Build:"
  cr ." Name"  #40 >pos ." Range (16)" #63 >pos ." Size (10)"
  ['] (.source) ['] SourceFiles >body @ WalkWordList
  cr
;

previous

\ =======================================================================
( **                                                                    )
( *S Control Directives                                                 )
( **                                                                    )
( *P The following words can be used to control the filesystem          )
( ** extensions.                                                        )
( **                                                                    )
\ =======================================================================

also system

: +VFCACHE              \ --
( *G Enable caching of read-only files when opened.                     )
  TRUE to bCachedINCLUDED?
; immediate

: -VFCACHE              \ --
( *G Disable caching of read-only files.                                )
  FALSE to bCachedINCLUDED?
; immediate

: +SMARTINCLUDE         \ --
( *G Enable smart resolution of file extensions when including sources. )
  TRUE to bSmartFileLookUp?
; immediate

: -SMARTINCLUDE         \ --
( *G Disable smart resolution of file extensions when including sources.)
  FALSE to bSmartFileLookUp?
; immediate

: +VERBOSEINCLUDE       \ --
\ *G Enable verbose mode for file includes and overlay handling.
  TRUE to bVerboseInclude?
; immediate

: -VERBOSEINCLUDE       \ --
\ *G Disable verbose mode for file includes and overlay handling.
  FALSE to bVerboseInclude?
; immediate

previous


\ ==========
\ *> turnkey
\ *T Building Standalone Programs
\ ==========

\ *************
\ *S The basics
\ *************
\ *P After all the initialisation has been performed, the deferred
\ ** word *\fo{ENTRYPOINT} is executed. The most basic way to make
\ ** a turnkey application is just to set *\fo{ENTRYPOINT} and then
\ ** *\fo{SAVE} the application. Some examples follow.

\ *P Later sections in this chapter discuss startup and shutdown
\ ** in detail.

\ =========================
\ *N Windows GUI
\ =========================
\ *P You can use a messagebox or a modal dialog as the application;
\ ** anything that runs the Windows message pump will work.
\ *E : start  \ hmodule 0 commandline show -- res
\ **   4drop
\ **   WalkColdChain          \ run startup chain
\ **   0 z" Hello World" z" VFX Forth" MB_OK MessageBox drop
\ **   0
\ ** ;
\ ** ' start is EntryPoint
\ ** Save hello
\ ** bye

\ =========================
\ *N Windows console
\ =========================

\ *E : start  \ hmodule 0 commandline show -- res
\ **   4drop
\ **   WalkColdChain          \ run startup chain
\ **   ." Hello World! from VFX" cr
\ **   0
\ ** ;
\ ** ' start is EntryPoint
\ ** SaveConsole hello
\ ** bye

\ =========================
\ *N OS X and Linux console
\ =========================
\ *E : start  \ hmodule 0 commandline show -- res
\ **   4drop
\ **   WalkColdChain          \ run startup chain
\ **   ." Hello World! from VFX" cr
\ **   0
\ ** ;
\ ** ' start is EntryPoint
\ ** Save hello
\ ** bye

\ *********************
\ *S Sequence of Events
\ *********************
\ *P When a Forth program runs there are five stages from program
\ ** launch to termination.

\ *D OS_Startup         The code required to bridge the gap between
\ **                    Forth and the host operating system. This
\ **                    code is handwritten by MPE and cannot be changed
\ **                    in any manner to do so would cripple the
\ **                    system
\ *D Initialisation     The setup of various system variables, stack
\ **                    pointers, user areas etc. Also the
\ **                    initialisation of import DLL functions etc.
\ **                    The various words which perform these operations
\ **                    are formed into a linked list called the
\ **                    Cold Chain which is executed automatically
\ **                    at the start of EntryChain.
\ *D BootStrap          The execution of either the default interpreter
\ **                    or the end-user's turnkey application.
\ **                    There is a little stub of code which sets up
\ **                    some input parameters before calling the *\fo{DEFER}ed
\ **                    word *\fo{EntryPoint}.
\ *D EntryPoint		Should run *\fo{WalkColdChain} and then the
\ **                    application code which runs until
\ **                    shut down.
\ *D Shutdown		When the application terminates, VFX Forth
\ **                    runs an exit chain similar to the cold
\ **                    chain. Any actions required for a clean
\ **                    shutdown should be added to this chain.

\ *P To generate stand-alone executable programs, three steps
\ ** are required.
\ *(
\ *B Compile your application - you do this in the same way as you
\ ** would during development. The required initialisation and
\ ** shutdown actions are usually defined using
\ *C   xt AtCold
\ *C   ' foo AtExit
\ *B Assign your entry point - you must define a word which serves
\ ** as your program entry point and assign it as the action of
\ ** the entry point word *\fo{EntryPoint}.
\ *B Save the compiled image - after compilation and entry point
\ ** definition you commit your compiled code to a file.
\ *)

\ ****************************
\ *S The *\fo{EntryPoint} word
\ ****************************
\ *P At the end of the start up chain *\fo{EntryPoint} is called.
\ ** This word is *\fo{DEFER}ed and can be re-assigned by the user.

\ *P The entrypoint definition is supplied by the end-user for a turnkey
\ ** application. The system has a default entry point which simply
\ ** launches the interpreter. An entry point definition has the
\ ** following format:-
\ *E   MyEntryPoint    \ hmodule 0 commandline show -- res
\ *P Where the parameters are:
\ *D HMODULE            The "module handle". For instance under Windows
\ **                    the module-handle is the base address of the
\ **                    parent process when running in memory.

\ *D 0                  A reserved field.

\ *D COMMANDLINE        A zero terminated string from the operating
\ **                    system describing the command line used to
\ **                    launch the system. Where this information is
\ **                    unavailable this field will be 0.

\ *D SHOW               An operating system specific field describing
\ **                    what visual effect should be used to start
\ **                    the application. In Windows this value can
\ **                    be passed directly to *\b{ShowWindow()}.

\ *D RES                The result with which to exit the program.

\ *P The syntax used to reset the entry point is:
\ *E   ASSIGN <myword> TO-DO ENTRYPOINT
\ ** or
\ **   ' <myword> IS ENTRYPOINT
\ *P and should be placed at the end of your source build before
\ ** *\fo{SAVE}.

\ *P Under some operating systems and I/O devices, you must flush
\ ** pending output before shutting down, otherwise it will be
\ ** unseen (still be buffered) when the program terminates. For
\ ** example, this may not work.
\ *E : start  \ hmodule 0 commandline show -- res
\ **   4drop
\ **   ." Hello World! from VFX" cr
\ **   0
\ ** ;
\ ** Assign start to-do EntryPoint
\ ** Save hello
\ ** bye
\ *P What happens is that the buffered output has not been
\ ** displayed before the program terminates. To fix this there
\ ** are three options:
\ *(
\ *B Use *\fo{flushOP-gen drop} to flush the current output.
\ *B Use *\fo{key? drop} as I/O drivers (should) flush output when
\ ** an input request is made.
\ *B Use *\fo{200 ms} if you are uncertain or the O/S layer needs
\ ** time, as can happen in some networking situations.
\ *)

\ *P Note that under some operating systems you cannot save a file
\ ** of the same name as the one that is currently executing.

\ *****************************
\ *S Startup and Shutdown words
\ *****************************

-short-branches

: ShowColdChain         \ --
\ *G Show on the console the sequence of events which make up the
\ ** current start up code. The sequence is shown in the order in
\ ** which it is executed.

\ Push the actions on the return stack to reverse the chain order
  $DEADFACE >r
  coldchain @
  begin
    dup
  while
    dup cell+ @ >r
    @
  repeat
  drop

\ Display the return stack items
  cr ." XT Address        Definition"
  cr ." (entrypoint)      System Start up CODE. Create stacks etc."
  begin
    r> dup $DEADFACE <>
   while
    cr ." $" dup .dword ."         " >name .name
  repeat
  drop
  cr ."     ??            Calls supplied action for ENTRYPOINT."
;

: ShowExitChain         \ --
\ *G Show on the console the sequence of events which make up the
\ ** current exit actions. The sequence is shown in the order in
\ ** which it is executed.
  cr
  cr ." XT Address        Definition"
  ExitChain @
  begin
    ?dup
  while
    dup cell + @
    cr ." $" dup .dword  ."         " >name .name
    @
  repeat
  cr ."    ??             Return to O/S"
;

+short-branches

: WalkColdChain         \ --
\ *G Walk the cold chain. Used during startup.

  $DEADBEEF >r

  coldchain @
  begin
    dup
  while
    dup cell+ @ >r
    @
  repeat
  drop

  begin
    r@ $DEADBEEF <>
  while
    r> execute
  repeat
  r> drop
;

: WalkExitChain         \ --
\ *G Walk the exit chain. Used during shutdown.
  ExitChain ExecChain
;

interpreter
: AtCold        \ xt(t) --
  chere(t) ColdChain @c(t) ,c(t) ColdChain !c(t) ,c(t)
;
: AtExit        \ xt(t) --
  chere(t) ExitChain @c(t) ,c(t) ExitChain !c(t) ,c(t)
;
target

: AtCold        \ xt --
\ *G Specify a new XT to execute when the Cold chain sequence is run.
  here ColdChain @ , swap , ColdChain !
;

: AtExit        \ xt --
\ *G Add a new XT to execute on BYE.
  here ExitChain @ , swap , ExitChain !
;

: FREEZE        \ --
\ *G Setup initial user area/global values for *\fo{SAVE}.
\ ** *\fo{FREEZE} is performed by the guts of *\fo{SAVE}.
  here init-dp !                        \ DP
  here init-fence !                     \ FENCE
  voc-link @ init-voc-link !            \ VOC-LINK

  postpone +VerboseInclude              \ Establish config defaults again
  postpone +SmartInclude
  postpone +vfcache
  postpone +warnings
  0 to buildLevel			\ SFP002
;

: (init)        \ --
\ *G Set up system variables, task0 user area, search order etc.
  user-reset s0 2 cells cmove           \ initialise user vars
  init-tib 'tib !
  #tib off
  init-fence @ fence !
  init-dp @ dp !
  init-voc-link @ voc-link !
  blk off  0 to source-id
  $40 c/line !

  ResetMinSearchOrder                   \ Reset minimum search order to include
                                        \ only ROOT
  only forth definitions                \ set up search order

  decimal                               \ force BASE

  SyspadStart ^Syspad !			\ initialise SysPad ; SFP095
  ExceptStackStart dup exc0 ! excp !	\ initialise exception stack

  blk off  0 to source-id
  state off
  cc-level off				\ SFP105

\  fstack0 fs-size + fs0 !               \ Task0 float stack
[defined] fsp! [if]
  fs0 @ fsp! reset-fpu
[else]
  fs0 @ fsp ! reset-fpu
[then]
;
' (init) AtCold

(( for DocGen
variable ExitCode	\ -- addr
\ *G Holds exit code returned to the operating system.
  0 ExitCode !
))

: bye           \ --
\ *G Runs the shutdown chain, and exits to the operating system,
\ ** returning the exit code from the variable *\fo{ExitCode}. The
\ ** meaning of the exit code is operating system dependent.
  ['] WalkExitChain catch drop  (bye)
;

Target_x64_Windows  Target_386_Windows or [IF]
: cold          \ --
\ *G System entry point. Runs the cold chain and then the application
\ ** *\fo{EntryPoint} code. When the application finishes, the exit
\ ** chain is run and the application terminates.
  WalkColdChain
  [ also system ]
    os_GetLoadAddress NULL os_GetCommandLine SW_SHOWNORMAL
  [ previous ]
  EntryPoint ExitCode !
  bye
;
[ELSE]
: cold          \ --
  Empty
  WalkColdChain
  [ also system ]
  os_GetLoadAddress NULL os_GetCommandLine 0
  [ previous ]
  EntryPoint ExitCode !
  bye
;
[THEN]

\ SFP023...
[-short-branches
: RethreadForth	\ --
  { | wid[ New#Thr 2+ cells ] fwid fthr f#thr -- }
  ['] forth voc>wid dup -> fwid
  dup >threads -> fthr
  >#threads @ dup -> f#thr  New#Thr =
  if  exit  endif
\ initialise temporary wordlist
  wid[ New#Thr 2+ cells erase
  New#Thr wid[ !
  fwid >wid-link @  wid[ >wid-link !
\ walk the old threads
  fthr f#thr cells bounds do
    i @					\ -- ctrl
    begin
      dup
     while
      ctrl>nfa dup n>link @ swap	\ -- next curr
      dup wid[ MoveNametoWid if
        drop
      else
        cr ." Can't move " .name
      endif
    repeat
    drop
  cell +loop
\ put wordlist back
  wid[ fwid New#Thr 2+ cells cmove
;
short-branches]
' RethreadForth AtCold
\ ...SFP023

: ShowBalance	\ --
  { | fwid fthr f#thr #Min #Max -- }

  0 -> #Max  $7FFFFFFF -> #Min
\  ['] forth voc>wid dup -> fwid
  context @ dup -> fwid
  dup >threads -> fthr
  >#threads @  -> f#thr

  0					\ counter for number of words
  f#thr 0 do
    cr ." Thread # " i 3 .r space
    0  fthr i cells + @			\ -- n 0 ctrl
    begin
      dup
     while
      rot 1+ -rot			\ count words in Forth
      swap 1+ swap			\ count words in thread
      ctrl>nfa n>link @			\ step on
    repeat
    drop
\    dup #Min min -> #Min
\    dup #Max max -> #Max
    dup #Min umin -> #Min		\ SFP052
    dup #Max umax -> #Max		\ SFP052
    ." contains " . ." words"
  loop
  cr ." Forth vocabulary contains " . ." words"
  cr ." Max words in any thread = " #Max .
  cr ." Min words in any thread = " #Min .
  cr ." Ratio = " #Max #100 #Min 1 max */
  0 <# # # [char] . hold #s #> type
;

Target_386_OSX Target_x64_OSX or [if]		\ SFP083

internal
: >arguments	\ caddr1 len1 -- caddr2 len2
\ Step over the executable name in the command line.
  argc 1 > if				\ any arguments for us?
    0 argv[ @ zcount nip /string  exit	\ yep, skip past processname
  then
  drop 0
;			  		\ no extra arguments
external

[-short-branches
: goForth		\ hinst hpint lpstrcmd nshow -- flag
  drop nip nip				\ -- lpstrcmd
  .cold
  ?dup if
    zcount >arguments ['] evaluate catch ?dup if	\ command line error
      .throw
      clean-opt cleanup-locals		\ compiler state clean up
      OperatorType off
      QuitHook				\ User defined clean up
      init-quit  r0 @ rp!  exc0 @ excp ! \ QUIT loop clean up ; SFP072
      s0 @ sp!
      cr ." ERROR on command line"
    then
  then
  ( reset-stacks )  quit  0			\ SFP093
; ' goForth to-do EntryPoint
short-branches]

[else]

[-short-branches
:noname		\ hinst hpint lpstrcmd nshow -- flag
  drop nip nip				\ -- lpstrcmd
  .cold
  ?dup if
    zcount bl scan ['] evaluate catch ?dup if
      .throw
      clean-opt cleanup-locals		\ compiler state clean up
      OperatorType off
      QuitHook				\ User defined clean up
      init-quit  r0 @ rp!  exc0 @ excp ! \ QUIT loop clean up ; SFP072
      s0 @ sp!
      cr ." ERROR on command line"
    then
  then
  ( reset-stacks )  quit  0
; to-do EntryPoint
short-branches]

[then]


\ ========
\ *> tools
\ *S Structures
\ ========
( *P The data structure words implement records, fields, field types,   )
( ** subrecords and variant records.                                    )

( *P The following syntax is used:                                      )
( *E STRUCT <name>                                                      )
( **   n FIELD <field1>                                                 )
( **   m FIELD <field2>                                                 )
( **   SUBRECORD <subrec1>                                              )
( **     a FIELD <sf1>                                                  )
( **     b FIELD <sf2>                                                  )
( **   END-SUBRECORD                                                    )
( ** END-STRUCT                                                         )
( *P A structure may contain multiple subrecords, and subrecords may    )
( ** be nested.                                                         )

( *P A field adds its base offset to the given address [that of the     )
( ** record or subrecord].  A record returns its length, and so can     )
( ** be used as an input to field.                                      )
( *E    len FIELD <name>                                                )
( **  n len ARRAY-OF <name>                                             )
( *P Subrecords are checked for stack depth, like branch structures.    )
( ** They may be nested as required.                                    )

( *P Variant records describe an alternative view of the current        )
( ** record or subrecord from the start to the current point.  The      )
( ** variant need not be of the same length, but the larger is taken    )
( *E SUBRECORD <name>                                                   )
( **    ----                                                            )
( **   VARIANT <name2>  ..............  END-VARIANT                     )
( ** END-SUBRECORD                                                      )
( *P use                                                                )
( *E <structure> BUFFER: <name>                                        )
( *P to create a new instance of a previously defined structure.        )

( *P The VFX structures package has also been enhanced to handle areas  )
( ** of overlapping data called "UNIONS". Consider the example:         )
( *E    struct test                                                     )
( **      int a                                                         )
( **      int b                                                         )
( **      union                                                         )
( **        int c                                                       )
( **        int d                                                       )
( **       part                                                         )
( **        1 field e1                                                  )
( **        1 field e2                                                  )
( **       part                                                         )
( **        int f                                                       )
( **        subrecord jim                                               )
( **          float jim1                                                )
( **          int jim2                                                  )
( **        end-subrecord                                               )
( **      end-union                                                     )
( **      20 field g                                                    )
( **    end-struct                                                      )
( *P Each part of a union is overlapped, but fields within a part are   )
( ** treated as individual items. So, in the above example, c and f     )
( ** refer to the same cell, but c and d refer to different cells.      )

: struct        \ -- addr 0 ; -- size
\ *G Begin definition of a new structure. Use in the form
\ ** *\fo{STRUCT <name>}. At run time *\fo{<name>} returns the
\ ** size of the structure.
  create
    here 0  !csp  0 ,                   \ mark stack, lay dummy
  does> @  ;                            \ -- rec-len

: end-struct    \ addr n --
\ *G Terminate definition of a structure.
  ?csp  swap !  ;                       \ check stack, set len

: field         \ n <"name"> -- ; Exec: addr -- 'addr
\ *G Create a new field within a structure definition of size n bytes.
  create
    over , +
  does>
    @ +
;

: int		\ <"name"> -- ; Exec: addr -- 'addr
\ *G Create a new field within a structure definition of size one cell.
  cell field
;

: array-of      \ n #entries size -- n+(#entries*size)
( *G Create a new field within a structure definition of size	)
( ** #entries*size. 						)
  create
    2 pick , dup ,      \ lay offset, unit size
    *  +                \ generate new offset
  does>
    2@                  \ addr n -- addr+offset+(n*size)
    -rot * + +          \ addr n size offset -- addr'
;

: subrecord     \ n -- n csp 0  [parent]
( *G Begin definition of a subrecord.                                   )
  create  dup ,  csp @  0  !csp         \ lay offset, mark stack
  does> @ + ;                           \ addr -- addr+offset

: end-subrecord \ n csp len -- n+len
( *G End definition of a subrecord.                                     )
  ?csp  swap csp !  +  ;                \ check, restore, add

: variant       \ n -- n csp 0
\ *G Currently an alias for *\fo{subrecord}. Begin a variant.
  subrecord
;

: end-variant   \ n csp m -- n|m
( *G Terminate a variant clause.                                        )
  ?csp  swap csp !  max         \ check, use greater len
;

: union         \ currentOffset -- csp 0 currentOffset currentOffset
\ *G Begin *\fo{UNION} definition block.
  csp @ swap
  0 swap dup
;

: part          \ max base last -- max base start
\ *G Begin definition of alternative data description within a
\ ** *\fo{UNION}.
  rot max       ( baseOffset maxoffset)
  swap dup      ( maxoffset baseOffset baseOffset)
;

: end-union     \ csp maxLength baseOffset lastOffset -- next-offset
\ *G Mark end of a *\fo{UNION} definition block.
  nip max       \ take greatest offset
  swap >r ?csp r> csp !
;

: field-type    \ n --
\ *G Define a new field type of size n bytes. Use in the form
\ ** *\fo{<size> FIELD-TYPE <name>}. When *\fo{<name>} executes
\ ** used in the form *\fo{<name> <name2>} a field *\fo{<name2>}
\ ** is created of size n bytes.
  create
    ,
  does>
    @ field
;


\ =======================
\ *N Forth200x structures
\ =======================
\ *P The Forth200x standards effort has adopted s notation that
\ ** is compatible with VFX Forth, but changes some names.

: begin-structure	\ -- addr 0 ; -- size
\ *G Begin definition of a new structure. Use in the form
\ ** *\fo{BEGIN-STRUCTURE <name>}. At run time *\fo{<name>}
\ ** returns the size of the structure. The Forth200x version
\ ** of the MPE word *\fo{struct}.
  create
    here 0  !csp  0 ,                   \ mark stack, lay dummy
  does> @  ;                            \ -- rec-len

: end-structure		\ addr n --
\ *G Terminate definition of a structure.
\ ** The Forth200x version of the MPE word *\fo{end-struct}.
  ?csp  swap !  ;                       \ check stack, set len

: +FIELD	\ n <"name"> -- ; Exec: addr -- 'addr
\ *G Create a new field of size *\i{n} bytes within a structure
\ ** definition. The Forth200x version of the MPE word *\fo{field}.
  create  over , +  does>  @ +  ;

: cfield:       \ n1 <"name"> -- n2 ; Exec: addr -- 'addr
\ *G Create a new field of size *\fo{1 CHARS} within a structure
\ ** definition,
  1 chars +FIELD  ;

: field:        \ n1 <"name"> -- n2 ; Exec: addr -- 'addr
\ *G Create a new field of size *\fo{1 CELLS} within a structure
\ ** definition. The field is *\fo{ALIGNED}.
  aligned  1 cells +FIELD  ;


\ ======
\ *> ###
\ ======


\ ======
\ \ *S DEFERed word Resolution
\ ======
\ \ *P Resolving outstanding defered words with their base actions.

\ assign noop       to-do OnCompilation
\ assign execute    to-do Cexecute
assign #literal   to-do C#literal
assign (fliteral) to-do C#Fliteral
\ assign undefined  to-do CUndefined
assign isInteger? to-do isNumber?
\ assign integer?   to-do number?
\ assign (classhook) to-do ClassHook
assign (QUIT)     to-do QUIT
assign noop       to-do ShowSourceOnErrorHook
assign noop       to-do EditOnError

assign .SYSPROMPT to-do .PROMPT
assign noop       to-do DOCGEN_PREREFILL
assign noop       to-do DOCGEN_REFILL
assign (abort)    to-do abort
assign (interpret) to-do interpret
assign drop       to-do AddXRef
assign noop       to-do AddXRefLit

assign (docolon,) to-do docolon,
assign (doexit,)  to-do doexit,
assign (doexit,)  to-do dosemicolon,
assign (clit,)    to-do clit,
assign doLayAbsCall to-do docall,	\ SFP002
assign (compile,) to-do Compile,	\ SFP002
assign (ndcs,)    to-do ndcs,		\ SFP002
assign (s_do,)    to-do s_do,
assign (s_?do,)   to-do s_?do,
assign (s_loop,)  to-do s_loop,
assign (s_+loop,) to-do s_+loop,
assign (s_leave,) to-do s_leave,
assign (s_?leave,) to-do s_?leave,
assign (s_mrk_br<,) to-do s_mrk_br<,
assign (s_br<,)   to-do s_br<,
assign (s_?br<,)  to-do s_?br<,
assign (s_res_br>,) to-do s_res_br>,
assign (s_br>,)   to-do s_br>,
assign (s_?br>,)  to-do s_?br>,
assign (s_of,)    to-do s_of,
assign (s_?of,)   to-do s_?of,
assign (else)     to-do s_endof,
assign (s_drop,)  to-do s_drop,
assign (s_val,)   to-do s_val,

\ assign noop       to-do discard-sinline
assign noop       to-do +docgen_hook
assign noop       to-do -docgen_hook
assign noop       to-do EmptyIdle
assign noop       to-do pause
assign drop       to-do ms
assign (RedefHook) to-do RedefHook
assign noop       to-do QuitHook

Target_x64_Windows  Target_386_Windows or [if]
assign noop	to-do Idle		\ --
[else]
assign noop	to-do WaitIdle		\ --
[then]
assign noop	to-do BusyIdle		\ --
assign noop	to-do EmptyIdle		\ --

assign drop	to-do sourceTrackRename	\ zaddr --

:noname  0  ;     to-do ticks		\ SFP051

assign (o_abort)  to-do	o_abort		\ SFP078
\ [THEN]

\ assign oldSearchWid to-do (SEARCH-WORDLIST)

\ ======================================================================

:noname  0 LinesCompiled !  cDot dup -> IncDir -> CurrDir  ; AtCold

: FORTH-KERNEL-END ;


\ ******
\ *> ###
\ ******

