
\ MACFORTH "SIBLEY EDITOR"
\ Last Revision: 10/10/08  06:42:42 AM  wjm
\ VFX  Revision: 11 Dec 2011  06:30:42  ward@megawolf.com
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\    to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


((
Long nicknamed the "Sibley Editor" due to its original development by
our late and dearly missed friend Dave Sibley. Hence the "SE" that prefixes
so many of its words.

Many additions and modifications over the years by Don Colburn,
	Doug Hoffman, Roelf Toxopeus, George Furnival, Greg Guerin, Xan Gregg, 
	Jeff Dripps, John Jeppson, Ward McFarland, Craig Treleaven, and others.

This version has SIXTEEN SE.Windows available as default.  To change the
number of windows, do a LOCATE for the single occurrence of SE.Window16
and add or delete as many as you like.

Advanced uses include specialized text display (non-editable) windows,
such as used by our old Glossary Tool, interactive Terminal-like windows,
loggging utilies, etc. 

0         0         0         0         0         0         0         0         0         0         1         1         1         1
0         1         2         3         4         5         6         7         8         9         0         1         2         3
01234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
))



Only Forth definitions
>M4TH
decimal

vocabulary EditorVocab				\ editor private vocabulary


create SE.LINK	 0 , 0 ,		\ head of SE.Window linkage+
\ mfCHAIN SE.LINK				\ Not a standard mfChain

0 value SE.WINDOW			\ current editor wptr


: OK ;									\ ignore this in input


create SE.VERSION# 		2012:02:03 ,


ALSO EditorVocab DEFINITIONS

0 constant CR=EOL
1 constant LF=EOL
2 constant CRLF=EOL


\ ****** USER-SETTABLE PARAMETERS ******************************************



4   value SE.TABS					\ spaces between tab stops
$7E value theChangedMark

variable NewSearchMode   NewSearchMode ON


LF=EOL  value default.EOLMODE		\ For new files
LF=EOL  value Interpreter.EOLMode	\ Expected by "parent" forth
true    value useCRsInScrap?		\ false converts CRs->LFs, True LFs->CRS when copying to SCRAP

 
 2 value SE.SCROLL.SPEED
 8 value SE.PAGE.SPEED
 
variable Return.before.output  	Return.before.output OFF	\ ? add CR before output during interpret
variable ShowOKPrompt  			ShowOKPrompt off			\ ? show OK prompt after interpret
 1 value +CR			\ for SE.Interpret formatting - 0 , 1 or 2 valid
 						\ this is default, can be changed on per-window basis

 4 value SE.TEXTFONT		\ Monaco default
11 value SE.TEXTSIZE
14 value SE.LINEHEIGHT

 3 value SE.DESCENT


300  value SE.MINXGROW			\ narrowest window
 62  value SE.MINYGROW			\ shortest window
true value WillShowBlankPage	\ appearance of last page of documents
 20  value NumPriorLines		\ how many lines of last "real" page to show on last page

hex	\ set default colors
  RGBBlack   @RGB RGBColor SE.ForeColor
  RGBWhite   @RGB RGBColor SE.BackColor
  RGBMagenta @RGB RGBColor InfoForeColor
  RGBLtGray  @RGB RGBColor InfoBackColor
  FAE1 F852 BAE2  RGBColor SE.DuplicateColor
  FFFF 8080 0000  RGBColor NBSpaceColor
decimal


127 value MissingCharChar	\ draw this for unknown control chars (empty rect)
\  - 240 is another alternative

800 value PreferredSEZoomWidth		\ control maximum zoomed out width


\ ---------------------------------------------------------------------------

0 value	 WHEN.SE.ADDED		\ user token to execute when adding a window
0 value	 AFTER.SE.LOADED	\ user token to execute after loading a file
0 value	 BEFORE.SE.SAVE		( ref# -- )		\ user token to execute before saving a file
0 value  AFTER.SE.OPEN$		( ref# -- )
0 value	 BEFORE.SE.SAVE.AS	( ref# -- )


\ ---------------------------------------------------------------------------
\ ---------------------------------------------------------------------------
\ NOT USER-SETTABLE

  3 constant SE.LEFTMARGIN
  0 constant SE.BottomMargin
198 value HbarLeftOffset		\ width of "special" space in horiz scroll area



create	 AUTO.HSCROLL	true w,				\ controls Horiz scrolling
create	 AUTO.INDENT	true w,				\ controls Horiz scrolling

 4 value     #FILETYPES						\ # available filetypes
   create    SE.FILETYPELIST  -1 , -1 , -1 , "TEXT , \ room for 3 more file types
   create    SE.DfltFileType  "TEXT ,			\ default type of file created

128 value SE.TYPE.BUFFER.SIZE	\ see documentation


\ dup set-current

variable  SE.RESTORER  			\ if TRUE, on opening returns to last place
	se.restorer ON

variable  SAVE.MARKS
	save.marks ON				\ ON is default = save marks in file

variable  RESTORE.POSITIONS		\ restore editor window size/position
	RESTORE.POSITIONS ON		\ ON is default


create DELIMITER.SET    \ Set [0..255] of bits -- 1 = delimiter
	    ( default set = NOT IN ['0'..'1','A'..'Z','a'..'z'] )
HEX		FFFFFFFF , FFFF003F endianswap32 , 8000001F endianswap32 , 8000001F endianswap32 ,
		FFFFFFFF , FFFFFFFF , FFFFFFFF , FFFFFFFF ,
DECIMAL


202 constant NBSpChar		\ non-breaking space

\ create SECURSOR    0 ,    \ semaphore for editor cursor
create ?QUIT.BLINK 0 ,   	 \ mailbox for cursor blink

variable LEAPING		leaping off


\ variable PRINTER?		\ flag for presence of PRINT...
variable OLD.VBAR		\ for digital thumb
variable CONTINUE?		\ flag for file handling

10 constant Max#JumpMarks	\ for JUMP stuff

22 value <LineEndingHierId>	\ menuid for LineEnding sub menu

se.leftmargin 2 + constant SE.RIGHTMARGIN


(( 
\ create CR$ 	1 C, 13 C,			\ CR in a string.
create LF$ 		1 C, 10 C,			\ LF in a string.
create CRLF$ 	2 C, 13 C, 10 C,	\ CRLF in a string.
create TAB$ 	1 C, 9 C,
 ))

1001 value NotFound#
\ 2413 value SearchResId
2414 value SearchResId



0 value OldScrapCount
0 value SEScrapCount

0 value SE.CHARWIDTH
0 value SE.TABWIDTH
0 value SE.RGN
0 value TempRgn
0 value SE.SCRAP.CHANGED
0 value SE.SCRAP			\ handle
0 value SE.TIB
0 value ArrowColumn
0 value LAST.DOWN		\ time of last mouse down
0 value LAST.PLACE		\ place of last mouse down
0 value FILE.END			\ addr one char beyond end of file (temp)
0 value ANCHOR			\ char offset of anchor of last sel. range
0 value DOUBLE.CLICK?	\ for double and triple clicks
0 value TRIPLE.CLICK?	\ for double and triple clicks



\ ********** forward references ***********************************************

defer StopGhosting		' noop is StopGhosting
defer StopLeaping		' noop is StopLeaping

defer SE.INCLUDE..    	' noop is SE.INCLUDE.. 
	' include.. is SE.INCLUDE..

defer DrawInfo	   			' noop is DrawInfo

defer DO.CONTROL.CHAR		' noop is DO.CONTROL.CHAR
defer DO.INSERT.CHAR		' noop is DO.INSERT.CHAR
defer DO.SE.INSERT			' noop is DO.SE.INSERT	
defer DO.SE.DELETE			' noop is DO.SE.DELETE
defer DO.SE.ACTION			' noop is DO.SE.ACTION
defer DO.SE.ACTIVATE		' noop is DO.SE.ACTIVATE
defer DO.SEARCH.ACTIVATE	' noop is DO.SEARCH.ACTIVATE
defer DO.SEARCH.HILITE		' noop is DO.SEARCH.HILITE
defer DO.SEARCH.ACTION		' noop is DO.SEARCH.ACTION
defer DO.SE.PROGRAM			' noop is DO.SE.PROGRAM
defer DO.UPDATE.SE			' noop is DO.UPDATE.SE	
defer FIND.FIRST			' noop is FIND.FIRST

defer Editor-Cmd-Click		' noop is Editor-Cmd-Click
defer Editor-Cntrl-Click ( -- quickExit )  ' false is Editor-Cntrl-Click

defer SEExitHook			' noop is SEExitHook
defer update.SE.Size		' noop is update.SE.Size



defer reset.undo		' noop is reset.undo
defer AdjustUndoMenu	' noop is AdjustUndoMenu
defer DisposeUndoListH  ' noop is DisposeUndoListH
defer SE.UNDO           ' noop is SE.UNDO
defer SE.REDO			' noop is SE.REDO 
defer SaveRangeOp		' drop is SaveRangeOp
defer SaveOp			' drop is SaveOp

variable InhibitUndo		InhibitUndo off




\ ********** SE WINDOW TAIL **************************************************


structure EditorMiscInfo
	Max#JumpMarks longs: +JumpMarks
	long:				 +SavedSelStart
	long:				 +SavedSelEnd
	long:				 +SE.ColorFlag		\ & EOL mode?
	point:				 +SavedWindowPos
	point:				 +SavedWindowSize
\	4 +					\ spare
structure.end


(( 
: ++,	\ same as "[ dup ] literal +"
	dup postpone literal postpone + ;  immediate


0	\ compile-time byte count

: SE.BUFFER			se.window  dup   +wfile.ptr @  + ;   4 +	\ holds handle to editor text
: TOP.LINE			se.buffer  4 + ;	4 +
: #VISLINES			se.buffer  8 + ;	4 +
: SE.FILE.SIZE		se.buffer ++, ;	4 +
: #LINES			se.buffer ++, ;	4 +
: SELSTART			se.buffer ++, ;	4 +
: SELEND			se.buffer ++, ;	4 +
: ENTRY.START		se.buffer ++, ;	4 +	
\ : IBVIS			se.buffer ++, ;	4 +
: RANGEVIS			se.buffer ++, ;	4 +
: IBPT				se.buffer ++, ;	4 +
: CHANGETIME		se.buffer ++, ;	4 +
: SE.orginalEOLMODE	se.buffer ++, ;	4 +			\ eol mode of file
: SE.REALFILE		se.buffer ++, ;	2 +
: SE.LOCKED			se.buffer ++, ;	2 +
: SE.VOLREF#		se.buffer ++, ;	2 +
: SE.IODIR			se.buffer ++, ;	4 +
: SE.IORESULT		se.buffer ++, ;	4 +			\ io-result  of open
: SCREEN.END		se.buffer ++, ;	4 +
: SE.CHANGED		se.buffer ++, ;	4 +
: seBounds			se.buffer ++, ;	8 +
: ActiveBounds		se.buffer ++, ;	8 +
: PageMarksBounds	se.buffer ++, ;	8 +
: TextBounds		se.buffer ++, ;	8 +
: BorderTop			se.buffer ++, ;	2 +
: BorderLeft		se.buffer ++, ;	2 +
: BorderRgn			se.buffer ++, ;	4 +
: HBarIndentWidth	se.buffer ++, ;	2 +
: HBarPanel			se.buffer ++, ;	8 +
: SE.LastTop    	se.buffer ++, ;	4 +
: SE.UndoListH    	se.buffer ++, ;	4 +
: SE.CurrentUndoListOffset	se.buffer ++, ;	4 +
\ : SE.Reserved    	se.buffer ++, ;	4 +

: SE.FILETYPE 		se.buffer ++, ;	4 +	\ 4 byte file type (or 0) for creating files
: SE.SPECIAL		se.buffer ++, ;	4 +	\ can hold a 4 byte identifying "signature"
: Export.ENTER  	se.buffer ++, ;	4 +	\ can hold token to execute during SE.EnterKey
: Export.PASTE  	se.buffer ++, ;	4 +	\ can hold token to execute during SE.PASTE
: Export.KEY		se.buffer ++, ;	4 +	\ can hold token to execute during DO.SE.KEY
: Export.CLOSE		se.buffer ++, ;	4 +	\ can hold token to execute during SE.CLOSE
: Export.UPDATE		se.buffer ++, ;	4 +	\ can hold token to draw/update border regions, etc.
: MySE.ENTER		se.buffer ++, ;	4 +	\ can hold special SEWindow entry token
: MySE.EXIT			se.buffer ++, ;	4 +	\ can hold special SEWindow exit token
: MySE.BS			se.buffer ++, ;	4 +	\ TRUE if we should REALLY do a backspace in (DRAW.LINE)
: MySE.CR			se.buffer ++, ;	4 +	\ window specific replacement for +CR
: MySE.OTHER		se.buffer ++, ;	4 +	\ window specific special control in (DRAW.LINE)
: SE.InfoRect		se.buffer ++, ;	8 +		\ rect for showing file stats
: SE.InfoMode		se.buffer ++, ; 4 +		\ 
: SE.ColorRect		se.buffer ++, ;	8 +		\ rect for showing color mode
\ : SE.ColorFlag	se.buffer ++, ;	4 +		\ this is in MiscInfo

: SE.EOLModeRect	se.buffer ++, ;	8 +		\ rect for showing EOL mode
: SE.EOLMode		se.buffer ++, ;	4 +		\ current EOL status - 
										 	\ 0 is CR
										 	\ 1 is LF
										 	\ 2 is CRLF
: SE.EOLChar		se.buffer ++, ;	4 +
\ top line state uses a fair chunk to keep the colorizer happy
: SE.oldtopline			se.buffer ++, ;	4 +		\ 
: SE.oldtopStyle		se.buffer ++, ;	4 +		\ 
: SE.oldTopLineState	se.buffer ++, ;	4 +		\ 
: SE.wasTopBackColor	se.buffer ++, ;	8 +		\ 
: SE.wasTopForeColor	se.buffer ++, ;	8 +		\ 

: SE.oldwasColorizerState	se.buffer ++, ;	4 +
: SE.oldSavedStyle 			se.buffer ++, ;	4 +
: SE.old[IF]Depth 			se.buffer ++, ;	4 +
: SE.oldSavedTopForeColor 	se.buffer ++, ;	8 +
: SE.oldSavedTopBackColor 	se.buffer ++, ;	8 +

: SE.RECT			se.buffer ++, ;	8 +				  \ temporary rectangle for drawing
: LastJumpedFrom    se.buffer ++, ;	4 +				  \ last point when jumped
: +MISCINFO			se.buffer ++, ;	EditorMiscInfo +  \ table of Jump Mark offsets	

: SE.TYPE.BUFFER	se.buffer ++, ;	se.type.buffer.size 2 +  +	\ see documentation

 constant SE.TAIL.SIZE

 ))




struct SE.WINDOW.STRUCT		\ SE.WINDOW.TAIL
	WINDOW.TAIL.STRUCTURE FIELD +theSE.WINDOW
	int +SE.BUFFER
	int +TOP.LINE
	int +#VISLINES
	int +SE.FILE.SIZE
	int +#LINES
	int +SELSTART
	int +SELEND
	int +ENTRY.START
	int +RANGEVIS
	int +IBPT
	int +CHANGETIME
	int +SE.orginalEOLMODE
2 field +SE.REALFILE
2 field +SE.LOCKED
2 field +SE.VOLREF#
	int +SE.IODIR
	int +SE.IORESULT
	int +SCREEN.END
	int +SE.CHANGED
8 field +seBounds
8 field +ActiveBounds
8 field +PageMarksBounds
8 field +TextBounds
2 field +BorderTop
2 field +BorderLeft
	int +BorderRgn
2 field +HBarIndentWidth
8 field +HBarPanel
	int +SE.LastTop
	int +SE.UndoListH
	int +SE.CurrentUndoListOffset
	int +SE.FILETYPE
	int +SE.SPECIAL
	int +Export.ENTER
	int +Export.PASTE
	int +Export.KEY
	int +Export.CLOSE
	int +Export.UPDATE
	int +MySE.ENTER
	int +MySE.EXIT
	int +MySE.MenuTweaks
	int +MySE.CtrlClick
	int +MySE.BS
	int +MySE.CR
	int +MySE.OTHER
8 field +SE.InfoRect
	int +SE.InfoMode
8 field +SE.ColorRect
8 field +SE.EOLModeRect
	int +SE.EOLMode
	int +SE.EOLChar
	int +SE.oldtopline
	int +SE.oldtopStyle
	int +SE.oldTopLineState
8 field +SE.wasTopBackColor
8 field +SE.wasTopForeColor
	int +SE.oldwasColorizerState
	int +SE.oldSavedStyle
	int +SE.old[IF]Depth
8 field +SE.oldSavedTopForeColor
8 field +SE.oldSavedTopBackColor
8 field +SE.RECT
	int +LastJumpedFrom
EditorMiscInfo FIELD ++MISCINFO
se.type.buffer.size 2 +	field +SE.TYPE.BUFFER
END-STRUCT



se.window.struct window.tail.structure - constant SE.TAIL.SIZE




: SE.BUFFER			se.window +se.buffer ; 	\ holds handle to editor text
: TOP.LINE			se.window +top.line  ;	
: #VISLINES			se.window +#vislines ;	
: SE.FILE.SIZE		se.window +se.file.size ;	
: #LINES			se.window +#lines ;	
: SELSTART			se.window +selstart ;	
: SELEND			se.window +selend ;	
: ENTRY.START		se.window +entry.start ;		
: RANGEVIS			se.window +rangevis ;	
: IBPT				se.window +ibpt ;	
: CHANGETIME		se.window +changetime ;	
: SE.orginalEOLMODE	se.window +se.orginaleolmode ;				\ eol mode of file
: SE.REALFILE		se.window +se.realfile ;	
: SE.LOCKED			se.window +se.locked ;	
: SE.VOLREF#		se.window +se.volref# ;	
: SE.IODIR			se.window +se.iodir ;	
: SE.IORESULT		se.window +se.ioresult ;				\ io-result  of open
: SCREEN.END		se.window +screen.end ;	
: SE.CHANGED		se.window +se.changed ;	
: seBounds			se.window +sebounds ;	
: ActiveBounds		se.window +activebounds ;	
: PageMarksBounds	se.window +pagemarksbounds ;	
: TextBounds		se.window +textbounds ;	
: BorderTop			se.window +bordertop ;	
: BorderLeft		se.window +borderleft ;	
: BorderRgn			se.window +borderrgn ;	
: HBarIndentWidth	se.window +hbarindentwidth ;	
: HBarPanel			se.window +hbarpanel ;	
: SE.LastTop    	se.window +se.lasttop ;	
: SE.UndoListH    	se.window +se.undolisth ;	
: SE.CurrentUndoListOffset	se.window +se.currentundolistoffset ;	

: SE.FILETYPE 		se.window +se.filetype ;	\ 4 byte file type (or 0) for creating files
: SE.SPECIAL		se.window +se.special ;		\ can hold a 4 byte identifying "signature"
: Export.ENTER  	se.window +export.enter ;	\ can hold token to execute during SE.EnterKey
: Export.PASTE  	se.window +export.paste ;	\ can hold token to execute during SE.PASTE
: Export.KEY		se.window +export.key ;		\ can hold token to execute during DO.KEY
: Export.CLOSE		se.window +export.close ;	\ can hold token to execute during SE.CLOSE
: Export.UPDATE		se.window +export.update ;	\ can hold token to draw/update border regions, etc.
: MySE.ENTER		se.window +myse.enter ;		\ can hold special SEWindow entry token
: MySE.EXIT			se.window +myse.exit ;		\ can hold special SEWindow exit token
: MySE.MenuTweaks	se.window +MySE.MenuTweaks ;
: MySE.CtrlClick	se.window +MySE.CtrlClick ;
: MySE.BS			se.window +myse.bs ;		\ TRUE if we should REALLY do a backspace in (DRAW.LINE)
: MySE.CR			se.window +myse.cr ;		\ window specific replacement for +CR
: MySE.OTHER		se.window +myse.other ;		\ window specific special control in (DRAW.LINE)
: SE.InfoRect		se.window +se.inforect ;	\ rect for showing file stats
: SE.InfoMode		se.window +se.infomode ; 	\ 
: SE.ColorRect		se.window +se.colorrect ;	\ rect for showing color mode

: SE.EOLModeRect	se.window +se.eolmoderect ;		\ rect for showing EOL mode
: SE.EOLMode		se.window +se.eolmode ;			\ current EOL status - 
										 	\ 0 is CR
										 	\ 1 is LF
										 	\ 2 is CRLF
: SE.EOLChar		se.window +se.eolchar ;	
\ top line state uses a fair chunk to keep the colorizer happy
: SE.oldtopline			se.window +se.oldtopline ;			\ 
: SE.oldtopStyle		se.window +se.oldtopstyle ;			\ 
: SE.oldTopLineState	se.window +se.oldtoplinestate ;			\ 
: SE.wasTopBackColor	se.window +se.wastopbackcolor ;			\ 
: SE.wasTopForeColor	se.window +se.wastopforecolor ;			\ 

: SE.oldwasColorizerState	se.window +se.oldwascolorizerstate ;	
: SE.oldSavedStyle 			se.window +se.oldsavedstyle ;	
: SE.old[IF]Depth 			se.window +se.old[if]depth ;	
: SE.oldSavedTopForeColor 	se.window +se.oldsavedtopforecolor ;	
: SE.oldSavedTopBackColor 	se.window +se.oldsavedtopbackcolor ;	

: SE.RECT			se.window +se.rect ;					  \ temporary rectangle for drawing
: LastJumpedFrom    se.window +lastjumpedfrom ;					  \ last point when jumped
: +MISCINFO			se.window ++miscinfo ;	  \ table of Jump Mark offsets	

: SE.TYPE.BUFFER	se.window +se.type.buffer  ;		\ see documentation


\ ********** UTILITIES & SHORTCUTS **********************************************


: APPEND.SE.TAIL.SIZE  ( wptr -- )	\ allocate space for SE.TAIL after window
	locals| wptr |
	here se.tail.size allot&erase
	wptr - wptr +wfile.ptr ! ;	\  offset tail from Wptr


: SE.HANDLE ( -- datahandle )
	se.buffer @ ;


: SE.DataStart ( -- addr )
	se.buffer @@ ;


: SE.DataRange ( -- addr\cnt )
	se.handle dup @ swap GetHandleSize ;


: FrontLink>SE
	8 +		\ start of Link field
	LINK>
	>body	\ start of actual window data
;

: SE>FrontLink
	BODY>
	>LINK
	8 -
;

: ToEachSEUntil ( xt\linkaddr -- flag )	\ xt ( xt\^sewindow -- xt\flag )
										\ until end of chain or flag <>0
	FrontLink>SE
	over execute
;

: ToEachSE ( xt\linkaddr -- flag )	\ xt ( xt\^sewindow --  )
									\ until end of chain
	FrontLink>SE
	over execute
	false
;


: SE.RESERVED? ( se.window - flag )
\ protected against STACK TILE NEXT.SE.WINDOW FIRST.FREE.WINDOW
\ ?? CLOSE.ALL
	SE>FrontLink 4 + @
;


: ConvertCharInRange ( WasChar\ToBeChar\addr\cnt -- #changed )
	0
	locals| #Changed theCnt theAddr ToBeChar WasChar |
	theAddr theCnt +  theAddr
	?DO
		i c@ WasChar =
		IF
			ToBeChar i c!
			1 +to #Changed
		THEN
	LOOP
	#Changed
;


: NormalizeEOLinRange ( addr\cnt -- )	\ 10.45
	$0d $0a
	SE.EOLMode @ 0 =		\ CR = EOLChar
	IF
		swap
	THEN
	2swap
	ConvertCharInRange drop ;


: CountLF/CRs ( addr/cnt -- #CRS/#LFS )
	0 0
	locals| #crs #lfs cnt addr |
	Addr Cnt +  Addr
	?DO
		i c@
		CASE
			$0d OF 1 +to #crs ENDOF
			$0a OF 1 +to #lfs ENDOF
		ENDCASE
	LOOP
	#crs  #lfs
;


: ReplaceAll ( RplcWith$\Find$\theH -- howmany )
	0 -1
	locals| howmany theOff theH find$ with$ |
	BEGIN
		1 +to howmany
		theH theOff
		Find$ count
		with$ count
		munger dup to theOff
		0<
	UNTIL
	howmany
;


: (ReplaceAllInHandle) ( with$\find$\theH -- howmany )
	dup
	IF
		ReplaceAll ( RplcWith$\Find$\theH -- howmany )
	ELSE
		3drop
		0
	THEN
;

: ReplaceAllInHandle ( with$\find$\theH -- )
	(ReplaceAllInHandle) drop
;

: ReplaceAllLFsWithCRs { theH -- }
	cr$ crlf$ theH ReplaceAllInHandle
	cr$ lf$   theH ReplaceAllInHandle
;

: ReplaceAllCRsWithLFs { theH -- }
	lf$ crlf$ theH ReplaceAllInHandle
	lf$ cr$   theH ReplaceAllInHandle
;



defer SE.QUIT	' noop is SE.QUIT


: NoEditAllowed  ( -- )
	beep
	c" Modifying DOS files not supported."
	cr$ cr$
	c" Switch format to edit."
	OK# IssueWindowCenteredAlert drop
	SE.QUIT
;


: ?NoEditAllowed  ( -- )
	SE.EOLMode @ CRLF=EOL =
	IF 
		NoEditAllowed
	THEN ;



: INIT.SE.FONT ( -- )
	se.textfont  TextFont
	se.textsize  _TextSize
	srcor  TextMode
	ascii M  CharWidth -> se.charwidth	\ assume M-width is widest
	se.charwidth se.tabs * to se.tabwidth ;


\ **********  **************************************************

new.window SEARCH.DLOG


create SEARCH$ 256 allot&erase
create CHANGE$ 256 allot&erase


new.console SE.CONSOLE
	dflt.con se.console consoleRecord move


5 constant DoubleDist				\ double click distance


\ : theLatest  ( ... -- ... )		\ execute the latest token
\	LatestToken execute  ;


: theLatest  ( ... -- ... )		\ execute the latest token
	latest-xt execute  ;		\ skips to data field

: SE.SETGROW ( wptr -- )
	locals| wptr |
	se.minxgrow se.minygrow wptr +wgrow !point  ;


400 value SEditHigh		\ 24 lines, less scroll-bar
500 value SEditWide		\ 80 cols, less scroll-bar

defer SE.CLOSE? ( event - event' )	' noop is SE.CLOSE?


scroll.up/down scroll.left/right + close.box +
		size.box + not.visible + zoom.box + 
		CLOSE.BEHIND +
constant se.attributes


: SEWINDOW ( name ( t\l\bo\ro -- | bo & ro are offsets )
	align
	se.link link,				\ add to the linked list
	0 ,							\ room to save RESERVED  flag
	4 needed  
	locals|  rOff bOff left top  |
	New.Window
	theLatest append.se.tail.size
	['] SE.CLOSE?  theLatest +on.close !
	C" untitled" theLatest w.title
	top  left
	 top bOff +  screen.bounds 4 + w@ 2 -  min
	  left rOff +  screen.bounds 6 + w@ 4 -  min
	   theLatest w.bounds
	  se.attributes theLatest w.attributes 
	  theLatest se.setgrow
	kWindowCollapseBoxAttribute theLatest NewWAttributes
;


: PrependMarker ( str$ -- )
	locals| theStr |
	theChangedMark
	IF
		theStr count
		over 1+ swap cmove>
		theChangedMark theStr 1+ c!
		theStr c@ 1+ theStr c!
	THEN
;


: StripMarker ( str$ -- )
	dup c@
	locals| theCnt theStr |
	theChangedMark
	IF
		theStr 1+ c@ theChangedMark =
		IF
			theStr 2 + theStr 1 + theCnt 1- cmove
			theCnt 1- theStr c!
		THEN
	THEN
;


: CountNameMatches ( name$\cnt\xt\sewindow --  str$\cnt\xt )
	{  name$ count xt wPtr | this$[ 256 ]  }
	wPtr ?wvisible
	IF
		this$[ wPtr Get.WTitle
		this$[ StripMarker
		this$[ name$ -string false=
		IF 1 +to count THEN	
	THEN
	name$ count xt
;


: NumSameNameWindowsOpen ( str$ -- n ) 	
	\ return number of editor windows with name = str$
	0			\ starting count
	['] CountNameMatches  ['] ToEachSE  SE.Link mfCHAINSearch
	2drop
	nip
;


: CheckForSameName ( sewptr -- flag )	\ true if more than 1
	{ | scratch[ 1024 ] }
	scratch[ swap Get.WTitle
	scratch[ StripMarker
	scratch[ NumSameNameWindowsOpen
	1 >
;


(( 
: RestoreWindowSize ( x\y\wptr -- )	-> changed to SetWindowSize
	+windowref# @
	rot 200 max		Screen.Width  min	\ width clip
	rot  60 max		Screen.Height min	\ height clip
	true
	SizeWindow  ( WindowRef\wide\high\updateFlag -- )
; ))


: SetSEWindowSize ( x\y\wptr -- )
	dup >R CheckForSameName				\ moved
	IF
		10 15 +point
	THEN
	
	R> 
	SetWindowPos ( x\y\wptr -- )
;


: RestoreSize&Position ( -- )
	+miscinfo +SavedWindowPos  @ ?dup
	IF	\ possibly saved on PPC version
		EndianSwap32 swapw
		point>xy   se.window SetSEWindowSize
	
	THEN
	+miscinfo +SavedWindowSize  @ ?dup
	IF	\ possibly saved on PPC version
		EndianSwap32 swapw
		point>xy   se.window SetWindowSize 
	THEN

	update.SE.Size
;

: SaveSize&Position (  -- )
	get.window >R
	se.window window
		0 0 xy>point local>global
			swapw EndianSwap32		\ retain compatibility with PPC version
			+miscinfo +SavedWindowPos !
		get.window GetWindowPortBounds 4 + @
			swapw EndianSwap32		\ retain compatibility with PPC version
			+miscinfo +SavedWindowSize !
	R> window
;



create EDITOR.BOUNDS  0 , 0 ,				\ 0 0 0 0 rect EDITOR.BOUNDS
 5 value dXsmall	12 value dYsmall
12 value dXbig		15 value dYbig


: AdjustOneSEWindow (  dy\dx\t\l\h\w\xt\sewindow -- dy\dx\t'\l'\h\w\xt )
	locals|  wPtr xt wide high  |
	wptr SE.RESERVED?  false=		\ protect reserved windows
	IF	2dup 2dup high wide +point	\ S: dy\dx\t\l\t\l\b\r
		wPtr w.bounds				\ set window bounds  S: -- dy\dx\t\l
		2over +point				\ dy\dx\t'\l'
	THEN
	high wide xt
;

: AdjustEditorWindows  ( -- )	\ replace SCREEN.BOUNDS with EDITOR.BOUNDS
	\ Space windows farther apart if screen size allows it
	SEditHigh  50 max   SEditWide 50 max  
	editor.bounds 2 + w@  4 +			 	\ left edge
	dXsmall 		\ dX - #pixels to stagger - was  5
	dYsmall			\ dY - #pixels to stagger - was 12
	locals|  dY dX left  howWide howHigh  |

	editor.bounds @rect  2swap -point		\ Height\Width
	512 >  IF	\ wide screen, so increase left edge and stagger width
				dXbig -> dX  			\ was 20
				editor.bounds 2 + w@ 8 + -> left
				20 +to howWide  
		   THEN

	dup GetMBarHeight -  140 -  howHigh min -> howHigh
	350 > IF	\ tall screen, so increase top edge and stagger height
				dYbig -> dY
				20 +to howHigh
		  THEN

	dY dX
	GetMBarHeight  40 min  20 +		\ initial TOP value
	left								\ arrange: dY\dX\T\L
	howHigh howWide

	\ walk chain SE.LINK and change coords
	\ window parameter-field directly follows chain node.
	['] AdjustOneSEWindow  ['] ToEachSE  SE.Link mfCHAINSearch 
	drop
	drop 2drop 2drop 2drop  ;		\ discard final dY\dX\T\L\h\w\0


: InitializeEditorWindowPositions ( -- )
	screen.bounds @rect  editor.bounds !rect	\ initialize EDITOR.BOUNDS
	AdjustEditorWindows ;  Restorer LinkLastToken


?building 0= [IF]  InitializeEditorWindowPositions  [THEN]


: wptr=  ( wptr1\xt\wptr2 -- wptr1\xt\stop? )
	2 pick =
;


: VALID.SE? ( wptr -- flag | true if valid Se.Window )
	['] wptr=  ['] ToEachSEUntil  SE.Link mfCHAINSearch
	\ ToEachSE gets  wptr\xt\sewin
	\ wptr\xt\nodePtr(or 0)
	nip nip  0<>
;


: incCt ( count\xt\wptr -- count\xt\stop? )
	drop swap 1+ swap
	false
;


: NumSEWindows ( -- n )
	0
	['] incCt   ['] ToEachSEUntil  SE.Link mfCHAINSearch
	2drop
 ;


: ->SE.WINDOW ( wptr -- )
	dup VALID.SE? 
	IF
		-> se.window
	ELSE
		drop
		\ " invalid se.window in ->SE.WINDOW" DebugStr
	THEN
;


: SE.WINDOW1 ( -- wptr |or| 0 | returns Wptr of first SE window in linked list )
    se.link @ dup
    IF FrontLink>SE THEN
;


: SE.BUSY ( flag -- | do BUSY only if the front window )
	se.window   active.window @ =
	search.dlog active.window @ = or
	IF	 busy
	ELSE drop
	THEN ;


: SE.EVENT.LOOP
	old.window.behavior @
	IF  event.loop  ELSE maineventloop THEN
;


: NEXT.SE.WINDOW ( wptr -- wptr' | cycles )
	dup valid.se?
	IF
		SE>FrontLink
	ELSE
		drop se.link
	THEN
	@ ?dup
	IF
		FrontLink>SE 
	ELSE
		se.window1 
	THEN
;


: FIRST.FREE.WINDOW ( -- [wptr] or [0] )
    se.window1
    BEGIN dup               \ must be NON-ZERO
          ?wvisible         \ ?active.wptr
          over SE.RESERVED?  \ 4 - @		\ is it reserved?
          OR
    WHILE next.se.window
          dup  se.window1 = 
          IF drop 0 exit THEN
    REPEAT ;


: NEXT.ACTIVE.WINDOW ( wptr -- [wptr] or [0] )
    dup false= IF exit THEN
    dup
    locals| THE.WPTR |
	BEGIN  next.se.window
		   dup ?wvisible	\ ?active.wptr
		   over the.wptr = or
	UNTIL
	dup the.wptr = 
	IF drop 0 THEN ;


: NEXT.TO.EDIT ( -- [wptr] or [0] )
	se.window active.window @ =
	se.window ?wvisible	0=
	or
	IF 	 se.window next.active.window
	ELSE se.window
	THEN ;


: EDIT.NEXT ( -- )
	next.to.edit ?dup 0= abort" No next window!"
	dup Show.Window select.window ;



CREATE SE.PAD 256 allot&erase

: MAKE.EDIT.NEXT ( -- )
	{ | localbuff[ 256 ]  }
	next.to.edit dup
	IF
		c" Edit '" count 1+ se.pad 1+ swap cmove
		localbuff[ dup rot Get.WTITLE
		dup c@ 7 + 	dup se.pad c!
		ascii ' swap se.pad + c!
		count se.pad 7 + swap cmove				\ wtitle
		15  se.pad FileMenu# set.item$
		15 true FileMenu# item.enable
	ELSE drop
		15 c" No next window" FileMenu# set.item$
		15 false FileMenu# item.enable
	THEN ;



\ *********** MISCINFO & JUMP ROUTINES ************************************

ascii MIFO constant "MIFO			\ MiscInfo resource type
128 	   constant MiscInfoID		\ MiscInfo resource ID
create MiscInfoName ," MiscInfo"	\ MiscInfo resource name

variable RFILE
variable TFILE




: OPEN.TextFileRF ( createRF? -- )
	se.pad tfile @ GetFCBInfo ( ^namePtr\fileRef# -- VolRefNum\DirID\flags )
	{ createRF? VolRefNum DirID flags  }

	io-result @ 0=
	IF
		createRF?					\ optional create
		IF
			VolRefNum DirID se.pad	\ vRefNum\dirID\namePtr
			HCreateResFile			\ does nothing if RF already exists
		THEN
		
		VolRefNum DirID se.pad		\ vRefNum\dirID\namePtr
		3 ( 0 ) HOpenResFile		\ try to open RW
		dup 0> false=				\ if we failed, try to open RO
		IF  
			drop
			VolRefNum DirID se.pad	\ vRefNum\dirID\namePtr
			1  HOpenResFile			\ open read only then
		THEN
									\ rfile#
	ELSE
		0
	THEN
	rfile !
;


: CLOSE.TextFileRF ( -- )
	rfile @ ?dup IF CloseResFile	rfile off THEN ;


: GET.MIFO.RESOURCE ( -- [hdl] or [0] )
	0 locals| mifoHdl |
	rfile @  0>
	IF
		"MIFO MiscInfoID Get1Resource 			\ use our res file
		dup to mifoHdl
		dup IF	HomeResFile rfile @ = THEN
		IF	 mifoHdl exit
		ELSE 0
		THEN
		mifoHdl ?dup IF ReleaseResource 0 THEN   \ if it wasn't ours
	ELSE
		0
	THEN
;


: (LOAD.MiscInfo) ( -- )
	get.MIFO.resource
	dup 
	locals| mifoHdl |
	IF	\ mifoHdl @	MiscInfo ( src\dest -- )
		mifoHdl @	+MiscInfo ( src\dest -- )
		mifoHdl GetHandleSize	EditorMiscInfo	min  cmove
		mifoHdl ReleaseResource
	ELSE
		\ if no resource, MiscInfo remains erased
	THEN ;


: (SAVE.MiscInfo) ( -- )
	0 locals| hdl |
	false SetResLoad
	get.MIFO.resource
	?dup IF dup RemoveResource DisposeHandle THEN
	true SetResLoad
	EditorMiscInfo MakeHandle to hdl
	+MiscInfo hdl @ EditorMiscInfo cmove
	hdl "MIFO MiscInfoID MiscInfoName AddResource ;


: LOAD.MiscInfo  ( textfileRefNum -- )
	tfile !
	+MiscInfo EditorMiscInfo erase		\ clear it
	save.marks  @ 
	SE.RESTORER @        or
	RESTORE.POSITIONS c@ or
	IF
		false open.textfileRF	\ don't create if one doesn't exist
		(load.MiscInfo)
		close.textfileRF
	THEN
;



: SAVE.MiscInfo ( -- )
	save.marks @
	SE.RESTORER @        or
	RESTORE.POSITIONS c@ or
	IF	
		true open.textfileRF	\ create if one doesn't exist
		(save.MiscInfo)
		close.textfileRF
	THEN ;


: INIT.MiscInfo ( -- )
	+miscinfo   EditorMiscInfo erase
;


: (?lowerMark) ( wptr\selstart\selend -- )
	\ Called just before deleting the given range, so any mark
	\ can be adjusted
	locals| end start wptr |	
	+miscinfo
	max#JumpMarks 0 DO
		dup @								\ cur mark
		EndianSwap32
		start end range IF drop start THEN	\ in range? set to start
		dup start > IF end - start + THEN	\ after range? subtract sel.length
		EndianSwap32
		over !
		4 +
	LOOP drop ;
	

: (?raiseMark) ( wptr\selstart\cnt -- )
	\ Called just before inserting the given cnt, so any mark
	\ can be adjusted
	locals| cnt start wptr |	
	+miscinfo
	max#JumpMarks 0 ?DO
		dup @ 
		EndianSwap32
		dup start > IF cnt + THEN
		EndianSwap32
		over ! 4 +
	LOOP drop ;


: ?LowerMark ( -- )
	get.window selstart @ selend @ (?lowerMark) ;


: ?RaiseMark ( cnt -- )
	locals| cnt |
	?lowerMark
	get.window	selstart @	cnt	(?raiseMark) ;

\ END JUMP ROUTINES


\ ****** MENU ITEM HILITING  **************************************************

defer MoreEditMenuHiliting ( flag --  )
		' drop is MoreEditMenuHiliting


: SE.EDIT.HILITE ( flag -- )	\ en/disables Edit items after SELECT ALL
	locals| THE.FLAG |
\	21 9
	24 9
	DO
		i the.flag EditMenu# item.enable
	LOOP	
	the.flag MoreEditMenuHiliting			\ allow Tools to extend this function
;


0 value RecentFiles?


: SE.MENU.ITEMS ( flag -- )	\ pass TRUE when enabling Editor
							\ this sets up the FILE Menu (menid 2)
							\ FALSE disables all window-specific functions
	boolean					\ 
	se.realfile w@ boolean
	se.changed   @ boolean
	se.locked   w@ boolean
	locals|  ?LOCKED  ?CHANGED  ?REAL  THE.FLAG |
	FileMenu# MENU.HANDLE
	IF
		1 first.free.window boolean	
					FileMenu# item.enable		\ NEW
		first.free.window boolean				\ is there a free window?
		2 over		FileMenu# item.enable		\ OPEN
		3 over		FileMenu# item.enable		\ OPEN ANY
		4 swap RecentFiles? AND
					FileMenu# item.enable		\ OPENRECENT
	
		5 the.flag	FileMenu# item.enable		\ CLOSE
		6 true 		FileMenu# item.enable		\ CLOSE ALL
		7 the.flag	FileMenu# item.enable		\ Dispose/Close
	
		?changed								\ was file changed ?
		?real   false= OR						\ OR has it never been saved
		?locked false= AND						\ disable SAVE if locked
		the.flag    AND							\ AND editor window is active
		8 swap		FileMenu# item.enable		\ SAVE
		9 true		FileMenu# item.enable		\ SAVE ALL  ?? no windows?
		10 the.flag	FileMenu# item.enable		\ SAVE AS...
		
		8 ?locked  IF c" read only or moved" ELSE c" Save" THEN
					FileMenu# set.item$
	
		11 the.flag ?locked false= and  ?turnkey false= and		\ 10.45 handle turnkey
					FileMenu# item.enable		\ SAVE & INCLUDE
		12 the.flag  ?turnkey false= and						\ 10.45 handle turnkey
					FileMenu# item.enable		\ INCLUDE no SAVE
	
		14 the.flag ?real and					\ front is not an Untitled window
			?changed and						\ AND it has been changed
					FileMenu# item.enable		\ REVERT
		15 true		FileMenu# item.enable		\ Edit Next
	
		17 the.flag FileMenu# item.enable		\ SEARCH DLOG - next
		18 the.flag FileMenu# item.enable		\ SEARCH DLOG - from top
		19 the.flag FileMenu# item.enable		\ SEARCH DLOG - prior
		20 the.flag FileMenu# item.enable		\ SEARCH DLOG - from end
		the.flag search$ c@ boolean and
		21 over		FileMenu# item.enable		\ FIND NEXT
		22 over		FileMenu# item.enable		\ FIND PRIOR
		23 over		FileMenu# item.enable		\ FIND FROM TOP
		24 swap		FileMenu# item.enable		\ FIND FROM END
	
		the.flag
		25 over FileMenu# item.enable 		\ FIND NEXT SELECTED
		26 over FileMenu# item.enable 		\ FIND PRIOR SELECTED
		27 over FileMenu# item.enable 		\ FIND SELECTED FROM TOP
		28 swap FileMenu# item.enable 		\ FIND SELECTED FROM END
	
		30 the.flag FileMenu# item.enable 		\ CHANGE LINE ENDINGS
	
	\	printer? @	IF 34 the.flag FileMenu# item.enable THEN
		34 the.flag FileMenu# item.enable		\ PRINT SELECTION/WINDOW
		
		36 ?turnkey false= FileMenu# item.enable	\ INCLUDE..	\ 10.45
	THEN
	make.edit.next

	EditMenu# menu.handle
	IF
\		the.flag EnableEditMenuItems				\ 10.46
		the.flag 									\ 10.47
		IF
			6 c" Paste" EditMenu# set.item$
			true EnableEditMenuItems
		THEN
		the.flag se.edit.hilite
		AdjustUndoMenu
	\	make.edit.next
	THEN

	MySE.MenuTweaks @ ?dup
	IF the.flag swap execute THEN
;


\ **********  **************************************************


: MARK.CHANGE ( flag -- )		\ mark a file as having been changed or not
	{ | LocalBuf[ 256 ] }
	se.changed @				\ get current se.changed flag
	over se.changed !
	boolean swap boolean <>		\ if prior value <> current value
	IF
		LocalBuf[ 
		dup SE.Window Get.WTitle
		dup 
		se.changed @
		IF
			PrependMarker
		ELSE
			StripMarker
		THEN
		se.window set.wtitle
		SE.Window @ se.changed @  1 and SetWindowModified drop
	THEN
	true se.menu.items
;


: SE.FILE? ( fname\volref#\ioDir -- flag )
	SE.Window 0 
	{ %fname %volref#  %ioDir %wPtr result | strbuf[ 256 ] }

	se.window1
	BEGIN
	    dup ?WVISIBLE	\ ?active.wptr
	    IF  dup ->SE.Window
	        %fname 
	        strbuf[ SE.Window Get.WTitle  
	        se.changed @
	        IF
	        	strbuf[ StripMarker
	        THEN
	        strbuf[ -String false=
	        se.volref#  w@s %volref# = and
	        se.iodir     @ %ioDir   = and
	        IF  true -> result
	        THEN
	    THEN
	    next.se.window
	    dup se.window1 =
	UNTIL drop
	%wPtr ->SE.Window      \ restore original SE wPtr
	result ;


: TOP.EDGE
	TextBounds w@ ;

: LEFT.EDGE
	TextBounds 2 + w@ ;

: RIGHT.EDGE ( -- n )
	TextBounds 6 + w@ ;

: BOTTOM.EDGE ( -- n )
	TextBounds 4 + w@ ;

: SE.VBAR ( -- handle )
	se.window +vbar @ ;

: @SE.VBAR ( -- value = top line# )
	se.vbar GetControl32BitValue ;


: ClipToControl ( ctrl -- )
	ScratchBoundsRect GetControlBounds   ClipRect
;


: (!SE.VBAR) ( value -- )
	se.vbar ClipToControl
	se.vbar  swap   SetControl32BitValue
	TextBounds ClipRect ;



: SET.VBAR.RANGE ( -- )
	0 0 locals| was themax |
	se.vbar ClipToControl
	@se.vbar  -> was
	
	#lines @  #vislines @  2/ <		\ not enough lines to bother with a scroll bar?
	se.vbar GetControl32BitMaximum	  0= 
	and
	IF 
		0
	ELSE	\ fixed 10.45
		#lines @  #vislines @ - 	\ full scroll range
		WillShowBlankPage
		IF
			#vislines @ 			\ add full blank screen
			NumPriorLines -			\ less how many lines of prior page to show
			dup 0 <=
			IF						\ window shorter than NumPriorLines
				drop
				#vislines @ 2-		\ then arbitrarily pick 2 visible lines
			THEN
			+
		THEN
(( 
		#lines @
		WillShowBlankPage
		IF
			NumPriorLines -		\ #lines to show of last real page
		ELSE
			#vislines @   -   
		THEN
 ))
		dup -> themax 
	THEN
	se.vbar 0 rot set.control.32bitrange
	
	was themax > IF  se.vbar themax SetControl32BitValue THEN

	\ adjust thumb size - per Doug Hoffman
	#lines @ #vislines @ <=
	IF	 se.vbar #vislines @ se.lineheight *
	ELSE se.vbar #vislines @ 5 * 3 /   
	THEN
	SetControlViewSize

	TextBounds ClipRect ; 


: !SE.VBAR ( value -- )
	dup
	se.vbar  GetControl32BitMaximum  0= and
	IF
		set.vbar.range
	THEN
	(!se.vbar) ;


: HILITE.VBAR ( partcode -- )
	se.vbar ClipToControl
	se.vbar swap  hilitecontrol
	TextBounds ClipRect ;


: SE.HBAR ( -- handle )
	se.window +hbar @ ;


: @SE.HBAR ( -- value  )
	se.hbar GetControl32BitValue ;


: !SE.HBAR ( value -- )
	se.hbar ClipToControl
	se.hbar swap   SetControl32BitValue 
	TextBounds ClipRect ;


: !SE.HBAR.RANGE ( min\max -- )	
	se.hbar ClipToControl
	se.hbar -rot   set.control.32bitrange
	TextBounds ClipRect ;


: QUERY.EVENT ( --- flag )
	event.record events @ ?event
	pause ?quit.blink @ or  ;	


: (LINE.LENGTH)	( buf+file.size\buf^\tab size -- n\buf^' )
	locals| tabSize start end |
	0	\ current length
	BEGIN
		start end <>
	WHILE
		start c@  1 +to start		\ fetch char and bump ptr
		tuck  						\ count char -- char count char
		9 = IF tabSize / 1 + tabSize * ELSE 1 + THEN
		swap SE.EOLChar @ =
		IF start exit THEN
	REPEAT 
	start ;


: GET.LINE.LENGTH  ( offset -- offset'\n)
	SE.DataStart  dup >R 
	se.file.size @ over +				( offset\se.buf\se.buf+file.size)
	-rot + 	se.tabs						( se.buf+file.size\buf^)
	(line.length)						( n\buf^')
	R> - swap
; 


: GET.MAX.X  ( --- max.x )  ( pixels )
	top.line @ 0
	locals| MAX.X OFFSET |
	#VISLINES @ ?DUP
	IF
		0 ?DO
			offset se.file.size @ >=
			IF leave THEN
			offset get.line.length 
				   max.x max to max.x 
				   to offset
			query.event
			IF -1 to max.x  leave THEN
		LOOP
	THEN
	max.x se.charwidth * ;


: SET.HBAR.RANGE ( -- )
	get.max.x locals| mx |		\ widest line on-screen (in pixels)
	mx 0 >=
	IF  0				\ scroll bar minimum
		mx   right.edge se.rightmargin -  < 	\ is widest line < screen width?
		IF
			0
		ELSE
			mx 
				right.edge se.rightmargin -
				- 
				se.charwidth 1- +  
		THEN
		!se.hbar.range
	THEN
;


: HILITE.HBAR ( part code -- )
	se.hbar ClipToControl
	se.hbar swap HiliteControl
	TextBounds ClipRect ;


: CHECK.BARS ( --- )
	set.hbar.range
	set.vbar.range ;


: LEFT.EDGE+HBar ( -- n )
	LEFT.EDGE @se.hbar negate 1+ + ;

: HALF.WINDOW ( -- n )
	right.edge left.edge - 2/ ;


: NEAR?  ( point1\point2 -- flag )
	point>xy rot point>xy -point abs swap abs
	DoubleDist < swap DoubleDist < and ;


: CHECK.MULTIPLE.CLICKS ( -- )
	false false		\ assume neither double nor triple
	mouse.down.record 8 + @ last.down - GetDblTime  <
	IF
		mouse.down.record 12 + @ last.place near? 
		IF	drop true double.click? triple.click? or IF swap THEN
		THEN
	THEN -> double.click? -> triple.click? ;



\	TEXT MANIPULATIONS

: COMPUTE.TABWIDTH ( x -- additional pixels for tab )
	LEFT.EDGE+HBar - se.tabwidth mod	se.tabwidth swap - ;


: ((GET.LINE.OFFSET))   ( cur\end -- cur' )
	locals| end cur |
	cur end < 
	IF
		BEGIN
			  cur c@
			  1 +to cur
			  SE.EOLChar @ =
			  cur end >= 
			  OR
		UNTIL
		cur
	ELSE
		cur
	THEN
;


: (GET.LINE.OFFSET)   ( n\buf\len -- offset )
	over + 			\ n\buf\len+buf
	over 			\ n\buf\len+buf\buf
	locals| CUR END START LINE# |
	BEGIN
		line# 0>
	WHILE
		cur end ((get.line.offset)) -> cur
		-1 +to line#
	REPEAT
	cur start - ;


: MAKE.TOP.LINE ( n -- )
	!se.vbar @se.vbar
	SE.DataRange
	(get.line.offset)  top.line !
;


: (COUNT.LINES)  ( start offset\end offset\buf -- #lines in range )
\ actually just counts the #EOL's in range
	dup >R + swap R> + 
	locals| START END |
	END START >
	IF
		0
		BEGIN
			start end <
		WHILE
			start c@ 
			SE.EOLChar @ =
			IF 1 + THEN
			1 +to start
		REPEAT
	ELSE
		0
	THEN
;


: (COUNT.LINES)+  ( start offset\end offset\buf -- #lines in range )
\ empty file has no lines
\ partial filled line = 1 line
\ each EOLChar = 1 line
	dup >R + swap R> + 
	locals| START END |
	END START >
	IF
		1
		BEGIN
			start end <
		WHILE
			start c@ 
			SE.EOLChar @ =
			IF 1 + THEN
			1 +to start
		REPEAT
	ELSE
		0
	THEN
;


: FIND.LINE# ( offset -- line# containing that char )
	0 swap SE.DataStart (count.lines)+
;


: ~FIND.LINE# ( offset -- line# containing that char )	\ was FIND.LINE#
\ not as accurate as (COUNT.LINES) and (COUNT.LINES)+   but fast
	true se.busy
	0 0 
	SE.DataRange
	locals| len buf old.line# start limit |
	limit len min -> limit
	limit top.line @ >=
	  IF top.line @ -> start
	     @se.vbar -> old.line#
	  THEN
	start limit buf  (count.lines)
	old.line# +
	false se.busy ;


: (BACK.ONE.LINE)  ( bufAddr\offset -- flag\offset' )
	1-		\ always go back at least one char
	0 max
	over + locals| PTR START |
	BEGIN
		ptr start >		\ 	stop if we're at the beginning of the file
	WHILE
		\ exit when the preceding char is a <CR>
		-1 +to ptr
		ptr c@ 
		SE.EOLChar @ =
		IF true ptr start - 1+ EXIT THEN
	REPEAT
	false 0 ;


: BACK.ONE.LINE ( -- flag )  \ really went back?
	SE.HANDLE DUP
	IF
		@ top.line @ (back.one.line) top.line !
	THEN
;


: BACK.LINES ( n -- )
	@se.vbar dup rot - !se.vbar
	@se.vbar - dup 0>
	IF 0 ?DO back.one.line false=
			IF 0 !se.vbar THEN
		LOOP
	ELSE drop
	THEN ;


: (FORWARD.ONE.LINE)  ( bufHdl\offset -- flag\offset' )
	swap dup GetHandleSize swap @ 
	locals| START LEN OFFSET |
	BEGIN
		offset len <
	WHILE
		start offset + c@
		1 +to offset
		SE.EOLChar @ =
		IF true offset EXIT THEN
	REPEAT
	false len ;
	
	
: FORWARD.ONE.LINE ( -- flag | really went forward? )
	se.handle   
	dup IF
	 	top.line @ (forward.one.line) top.line !
	THEN ;


: FORWARD.LINES ( n -- )
	@se.vbar dup rot + !se.vbar
	@se.vbar swap -
	dup 0>
	IF 0 ?DO forward.one.line drop LOOP
	ELSE drop THEN ;


: CHANGE.TOP.LINE ( #lines -- )
	dup 0<
	IF   abs back.lines
	ELSE forward.lines
	THEN ;


: LOCATE.LINE ( n -- offset of n'th line on screen\n' )
	top.line @ locals| REAL.TOP N |
	n IF n 0 ?DO forward.one.line false=
		IF -1 +to n THEN
	LOOP THEN
	top.line @ n	real.top top.line ! ;


: (CHAR>X) ( charOffset -- x-coord | offset must be in TOP.LINE line )
	LEFT.EDGE+HBar locals| X |
	top.line @ 2dup >
	IF
		?DO SE.DataStart
			i + c@ 
			09 =
			IF
				 x compute.tabwidth
			ELSE 
				 se.charwidth
			THEN
			+to x
		LOOP
	ELSE 2drop
	THEN x ;


defer CHAR>X ( charOffset -- x-coord | offset must be in TOP.LINE line )
	 ' (CHAR>X) is CHAR>X


: LineY  ( line# -- y )
	se.lineheight * top.edge + ;


: xCHAR>XY ( charOffset -- x\y )	\ charoffset in file -> x\y on screen
	top.line @  -100  -100
	locals| X Y REAL.TOP THE.OFFSET |
	the.offset top.line @ >=		\ is offset below top line ?
	IF  #vislines @ 1+ dup
		0 ?DO							\ scan for line#
			forward.one.line false= dup
			IF se.file.size @ 1+ top.line ! THEN
			the.offset top.line @ < or
			IF drop i leave THEN
		LOOP
		LineY -> y
		the.offset top.line @ <
		IF
			back.one.line drop			\ adjusts top line
			the.offset char>x 1- to x
		ELSE
			top.line @ the.offset -
			char>x to x
		THEN
	THEN 
	real.top top.line !
	x y ;


defer CHAR>XY ( charOffset -- x\y )
	 ' xCHAR>XY is CHAR>XY

: SET.IBPT ( -- )
	selstart @ selend @ =
	IF	 selstart @ char>xy
	ELSE -100 -100
	THEN
	IBPt !point ;


: COUNT.LINES ( start offset\end offset -- #lines in range )
	se.handle   dup >R GetHandleSize min   \ clip end-offset to max length
	r> @ (count.lines) ;


\	SCREEN DRAWING ROUTINES

: SE.INVERT ( t\l\b\r -- )
    se.rect !rect
    se.window VALID.SE?
    se.window ?WVISIBLE AND
    IF
        se.rect 
        se.window @ IsWindowUpdatePending false=
        IF    InvertRect                       \ go ahead and draw
        ELSE  InvalRect                        \ let update do the drawing
        THEN
    THEN ;

: INVERT.XYS ( x1\y1\x2\y2 -- )
	left.edge  locals| THE.LEFT Y2 X2 Y1 X1 |
	the.left x1 max to x1	the.left x2 max to x2
	y1 y2 =
	IF	y1 x1 x2 min y1 se.lineheight + x1 x2 max se.invert
	ELSE y1 y2 >
		IF y1 y2 to y1 to y2	x1 x2 to x1 to x2 THEN
		y1 x1 over se.lineheight + right.edge se.invert
		y2 y1 - se.lineheight >
		IF	y1 se.lineheight + the.left y2 right.edge se.invert
		THEN
		x2 the.left >
		IF	y2 the.left over se.lineheight + x2 se.invert THEN
	THEN  ;


: INVERT.RANGE ( one end\other end -- )
	locals| END1 END2 |
	end1 end2 over over min to end1 max to end2
	end1 end2 =
	end2 top.line @	< or
	end1 screen.end @ > or false=		\ anything to draw?
	IF	end1 top.line   @ max char>xy
		end2 screen.end @ min char>xy	invert.xys
	THEN ;


: INVERT.SEL.RANGE ( -- )
	selstart @ selend @ invert.range
;


: SHOW.RANGE ( -- )
 	se.window   front.window <> 
 	search.dlog front.window <>  	
 	AND
 	IF exit THEN

	RangeVis @
	IF
	ELSE
		invert.sel.range RangeVis on
	THEN

	leaping @ 0=
	IF
		selstart @ selend @ =
		IF
				34 c" Print Window" FileMenu# set.item$
		ELSE
				34 c" Print Selection" FileMenu# set.item$
		THEN
	THEN

	DrawInfo		\ needed here?
	se.window ?FlushWindow
;

: HIDE.RANGE ( -- )
	RangeVis @ IF invert.sel.range RangeVis off THEN ;


-1 value TheIB

: (DRAW.IB) ( -- | draws\undraws insertion bar )
\	selstart @ selend @ =
\	IF
		patxor _PenMode 1 1 _PenSize
		0 se.lineheight 1- Line
\	THEN 
;


: SET.CHANGETIME ( -- )
	TickCount GetCaretTime  + ChangeTime ! ;


: PUT.IB ( ---- )
	set.IBPt IBPt @point MoveTo ;


: DRAW.IB ( ---- )
	selstart @ dup selend @ =
	IF
		-> TheIB
		put.ib (draw.ib) 
	ELSE
		drop
		-1 -> TheIB
	THEN ;


: Get.SEBounds ( -- ^rect )
	se.window GetWindowPortBounds
;


: ERASE.SE ( -- )
	Get.SEBounds EraseRect ;


: TAB.MOVE ( -- )
	@pen drop compute.tabwidth 0 qdMOVE ;
\ 	bl  DrawChar ;


: MoveToNewLine ( -- )	\ was CR.MOVE
	@pen swap drop se.lineheight +
	LEFT.EDGE+HBar swap MoveTo ;


: SE.BACKSPACE.MOVE ( -- )
	MySE.BS @
	IF	\ note this is NON-destructive Backspace - 
		\ it will get overwritten by the next character
		@pen swap se.charwidth - LEFT.EDGE+HBar max
		swap  MoveTo
	ELSE
		255 DrawChar			\ missing char for other controls
	THEN
;


: DrawLongText ( textBuf\byteOffset\byteCount -- )
	\ allow _DrawText to work with long lines
	locals| cnt off start |
	cnt
	IF
		BEGIN
			cnt 255 >
			IF
				start off 255 _DrawText
				-255 +to cnt
				 255 +to off
			ELSE
				start off cnt _DrawText
				exit
			THEN
		AGAIN
	THEN
;


: DrawBlank ( -- )
	@pen 2dup se.charwidth se.lineheight 1 4 -point negate +point
	XYXY>ScratchRECT
	EraseRect
	se.charwidth 0 qdMOVE
\	bl  DrawChar
;


: Draw.NBspace ( -- )
	{ | localbuf[ 8 ] }
	localbuf[    GetBackColor
	NBSpaceColor RGBBackColor
	DrawBlank			\ 202 DrawChar
\	get.window ?FlushWindow
	localbuf[ RGBBackColor
;


: ?LF.MOVE ( -- )
\ handle new line depending on EOL display mode
\	SE.EOLMode @ LF=EOL  =		\ LF = EOL mode
	SE.EOLMode @ CRLF=EOL <>	\ CRLF <> EOL mode
	IF
		MoveToNewLine
	THEN
;

: ?CR.MOVE ( -- )
	SE.EOLMode @ LF=EOL <>		\ CR or CRLF = EOL mode
	IF
		MoveToNewLine
	THEN
;


: SE.DrawPrintableText  ( addr\cnt --  addr'\cnt' )		\ was DrawPrintableText2
					 ( leave residue for CONTROL intrepreter )
	over					\ addr\cnt\addr
	BEGIN					\ addr\cnt'\addr'
		over 0>				\ while there are more characters
	    over c@ bl >= 		\ AND while char at addr2 >= BL
		and
	    over c@ NBSpChar <> \ AND not a non-breaking space
	    AND
	WHILE
		1+ swap 1- swap
	REPEAT				\ addr\cnt'-1\addr'+1            \ addr\cnt'\addr'
	\ addr' now points to 1st control character or end of string
	rot 				\ cnt'\addr'\addr
	2dup -				\ cnt'\addr'\addr\addr'-addr
	0 swap 				\ cnt'\addr'\addr\0\addr'-addr
	DrawLongText		\ (DrawText)  ( textBuf\byteOffset\byteCount -- )
						\ cnt'\addr'
	swap ;


: ((DRAW.LINE)) ( addr -- addr' | draw line up to EOLN )
	BEGIN										\ addr
			file.end 	over -					\ addr\cnt
			dup 0>								\ addr\cnt\flag
	WHILE
  			SE.DrawPrintableText				\ addr'\cnt'
			IF  count							\ addr'+1\char	(little trick)
				CASE
					
	\				EOLChar OF	MoveToNewLine	exit	ENDOF	\ unstructured for speed
					
					10 OF  ?LF.MOVE		exit		ENDOF	\ LF
					13 OF  ?CR.MOVE		exit		ENDOF	\ CR
					
					09 OF	tab.move			ENDOF	\ tab
					08 OF	se.backspace.move	ENDOF	\ backspace
					NBSpChar OF	Draw.NBspace	ENDOF	\ non-breaking space
					MissingCharChar DrawChar			\ show missing char for other controls
				ENDCASE
			ELSE exit							\ unstructured for speed
			THEN
	REPEAT										\ addr'
	\ addr'\cnt'
	drop ;


defer DRAW.LINE  ( addr --  addr' )
	 ' ((draw.line)) is DRAW.LINE


: DRAW.PART.LINE  ( offset\x\y -- next offset )
	MoveTo
	se.handle HLock
	SE.DataRange
		+ to file.end
	SE.DataStart  + draw.line
	SE.DataStart  -
	se.handle HUnlock ;


: <DRAW.ALL.LINES  ( -- )
	LEFT.EDGE+HBar ActiveBounds w@ se.lineheight + MoveTo
	se.handle HLock
	SE.DataRange
		+ to file.end
	SE.DataStart  top.line @ +
		#vislines @
		SE.EOLMode @ CRLF=EOL =	\ if CRLF, then we get 2 draw.line 's for every real line
		IF 2* THEN
		0 ?DO draw.line LOOP
	SE.DataStart  - screen.end !
	se.handle HUnlock ;


defer DRAW.ALL.LINES				\ factored for colorizer to patch
	 ' <DRAW.ALL.LINES is DRAW.ALL.LINES


: DRAW.PAGE.MARKS  ( -- )
	se.lastTop @ top.line @ -
	event.record w@ update.event = or
	IF  top.line @ se.lastTop !
	    tempRgn GetClip
	    PageMarksBounds dup ClipRect EraseRect
	    1 3 _PenSize   pator _PenMode
	    @se.vbar lines/page @ mod negate
	    dup 0< IF lines/page @ + THEN
	    BEGIN
			PageMarksBounds 2 + w@ over LineY MoveTo
	        2 0  Line
	        lines/page @ + dup #vislines @ >
	    UNTIL drop 1 1 _PenSize
	    tempRgn SetClip
	THEN ;



: DRAW.SCREEN  ( -- )
	draw.all.lines
	RangeVis @ IF invert.sel.range THEN
	draw.page.marks
	DrawInfo
;


: <TOP.ONE  ( -- )
	true top.line @ locals| REAL.TOP DRAW? |
	LEFT.EDGE+HBar se.lineheight ActiveBounds w@ + MoveTo
	se.handle HLock
	SE.DataRange
	+ to file.end
	SE.DataStart  top.line @ + draw.line drop
	se.handle HUnlock
	selend @ top.line @ < to draw?
	forward.one.line false= IF se.file.size @ top.line ! THEN
	draw? selstart @ top.line @ > or false= to draw?
	#vislines @ 1-
	0 ?DO	forward.one.line false=
		IF se.file.size @ top.line ! leave THEN
	LOOP
	top.line @ screen.end !	real.top top.line !
	draw? RangeVis @ and IF invert.sel.range THEN
	draw.page.marks ;


defer TOP.ONE
	' <top.one is TOP.ONE


: <BOTTOM.ONE ( -- )
	true top.line @ locals| REAL.TOP DRAW? |
	LEFT.EDGE+HBar #vislines @ se.lineheight * ActiveBounds w@ +  MoveTo
	se.handle    HLock
	SE.DataRange
	+ to file.end
	#vislines @ 1- 0 ?DO forward.one.line to draw? LOOP
	draw?
	IF	SE.DataStart  top.line @ + draw.line drop
	THEN
	se.handle    HUnlock
	selend @ top.line @ < to draw?
	forward.one.line false= IF se.file.size @ top.line ! THEN
	draw? selstart @ top.line @ > or false= to draw?
	top.line @ screen.end !	real.top top.line !
	draw? RangeVis @ and IF invert.sel.range THEN
	draw.page.marks ;


defer BOTTOM.ONE
	 ' <BOTTOM.ONE is BOTTOM.ONE


\ ********** WINDOW RE-SIZING **************************************************

: calcActiveBounds
	seBounds @rect locals| R B L T |
	T if 1 +to T then
	L if 1 +to L then
	-15 +to B
	-16 +to R
	T L B R ActiveBounds !rect ;


: calcTextParameters ( -- )
	ActiveBounds @rect locals| R B L T |
	se.descent +to T
	se.leftmargin 4 + +to L
	R dup L 1+ - se.charwidth  mod -  -> R
	B SE.BottomMargin - dup T - 
				 se.lineheight mod -  -> B
	T L B R TextBounds !rect
	B T - se.lineheight /  #vislines ! ;


: calcPageMarksBounds ( -- )
	TextBounds @rect locals| R B L T |
	T  L 5 -  B  L  PageMarksBounds !rect ;


: calcHBarPanel ( -- )
	seBounds @rect locals| R B L T |
	L if 1 +to L then
	B 14 - -> T
	L HBarIndentWidth w@ + -> R
	T L B R  HBarPanel !rect ;


: resizeVBar ( -- )
	se.window vbar.bounds  0 0 0
		locals| cHdl h w R B L T |
	T L B R se.rect !rect
	se.rect dup  ClipRect  EraseRect
	ActiveBounds w@  1+   +to T				\ ???
	B T - -> h
	R L - -> w
	se.window +vbar @ -> cHdl
	cHdl  HideControl
	cHdl L T  MoveControl
	cHdl w h  SizeControl
	cHdl  ShowControl
	H se.lineheight   /  c/cols !  op-line# off
;


: resizeHBar ( -- )
	se.window hbar.bounds  0 0 0
		locals| cHdl h w R B L T |
	T L B R se.rect !rect
	se.rect dup  ClipRect  EraseRect
	HBarIndentWidth w@
		if 	 HBarPanel 6 + w@ 1+
		else ActiveBounds 2 + w@
		then +to L
	B T - -> h
	R L - -> w
	se.hbar -> cHdl
	cHdl  HideControl
	cHdl L HbarLeftOffset + T    MoveControl
	cHdl w HbarLeftOffset - h    SizeControl
	t 0   b  HbarLeftOffset 19 - 30 - dup >R	 SE.InfoRect !rect
	t R> 1-   b  HbarLeftOffset 1-	34  - dup >R SE.ColorRect !rect
	t R> 1-   b  HbarLeftOffset 1-	SE.EOLModeRect !rect
	
	cHdl  ShowControl
	W 30 - se.charwidth 1+   /  c/line !
;


: RESIZE.CONTENT ( -- )
	Get.SEBounds
	borderRgn @ over  RectRgn
	@rect  locals| R B L T |
	BorderTop    w@ +to T
	BorderLeft   w@ +to L
	T L B R seBounds !rect
	seBounds  ClipRect erase.se
	se.rgn seBounds  RectRgn
	borderRgn @ se.rgn over  DiffRgn
	calcActiveBounds
	calcTextParameters
	calcPageMarksBounds ;


: RESIZE.SE ( -- )
	resize.content
	Get.SEBounds InvalRect
	calcHBarPanel
	resizeVBar
	resizeHBar
	TextBounds  ClipRect
;

'  RESIZE.SE is update.SE.Size


: HBarIndent ( nn -- )
	get.window locals| oldWindow |
	se.window window
	HBarIndentWidth w!
	resize.se
	oldWindow (window) ;


\ ********** WINDOW UPDATING **************************************************

: drawFrame  ( -- )		\ ?? needed
	seBounds @rect 
	{ T L B R |  buf[ 20 ] }
	buf[ GetPenState
	patCopy  _PenMode
	T if  L T  MoveTo R T  LineTo then
	L if  L T  MoveTo L B  LineTo then
	HBarIndentWidth w@
		?dup if
			-15 +to B
			L B     MoveTo
			L + B   LineTo
		then
	buf[ SetPenState ;



: UPDATE.SE	( -- )	\ Does all the drawing for the contents
	outfile @   mfCONSOLE @   se.window
	locals| oldSE oldCon oldOutfile |

	get.window ->SE.Window			
	se.window no.clip
	erase.se					\ per Apple specs

	dflt.con mfCONSOLE ! 
	outfile on
	Export.UPDATE  @execute
	se.console mfCONSOLE !

	outfile on
	seBounds  ClipRect
	drawFrame
	TextBounds  ClipRect
	draw.screen

	oldSE ->SE.Window
	oldCon mfCONSOLE !
	oldOutfile outfile !
 ;


\ ********** WINDOW SCROLLING **************************************************

: ADJUST.DY ( dy -- dy' )			\ dY is #LINES requested --> dY' is actual #lines
									\ positive dY moves scroll UP
	@se.vbar swap
	negate change.top.line 			\ this can change se.bar value
	@se.vbar - ;


: ADJUST.DX ( dx -- dx' )
	dup se.charwidth mod -
	@se.hbar locals| THE.BAR DX |
	dx 0> the.bar or
	IF  the.bar dx + !se.hbar
		@se.hbar the.bar -
	ELSE 0
	THEN ;



: DO.SE.SCROLL ( dx\dy -- dx'\dy' )
	locals| DY DX |
	TextBounds  ClipRect
	dy adjust.dy to dy
	dx adjust.dx to dx
	dy
	IF
		dy abs  #lines @ >
		IF
			\  ScrollRect makes no sense to use for scrolls taller than the window
			\ and dY > 32K would fail anyway
			TextBounds   ClipRect
			TextBounds   EraseRect
		ELSE
			\ this was a neat trick for slow macs, but not really needed any more
			se.rgn  SetEmptyRgn
			TextBounds dx negate dy se.lineheight * se.rgn  ScrollRect
			se.rgn  SetClip
		THEN
	THEN
	dx
	IF
		TextBounds  ClipRect
		TextBounds  EraseRect
		draw.screen
	ELSE
		dy
		CASE  1 OF top.one	  DrawInfo  ENDOF
			  0 OF						ENDOF	\ don't need to redraw
			 -1 OF bottom.one DrawInfo  ENDOF
			 \ sort of brutish to force a full redraw, but works much better
			 \ when thumb scrolling VERY large files
			 se.rgn	 EraseRgn
			 draw.screen
		ENDCASE
	THEN	dx dy ;


defer UpdateAfterScroll				\ for recolorizing
		' noop is UpdateAfterScroll


: (CONT.SCROLL) ( dx\dy\delay -- )
	dup  TickCount + 1-
	locals|  TheTime  TheDelay  |
	2dup  do.se.scroll  2drop
	BEGIN
		  BEGIN   TickCount thetime  > UNTIL
		   TickCount thedelay + 1- to TheTime	\ set next time to wait for
		   StillDown
	WHILE this.control @ @mouse  TestControl this.part @ =
		  IF  2dup  do.se.scroll 2drop
		  THEN
	REPEAT
	2drop 
	UpdateAfterScroll				\ for recolorizing
	TextBounds  ClipRect ;


: CONT.SCROLL ( dx\dy -- )
	se.scroll.speed (cont.scroll) ;


: SCROLL.TO ( line# -- )
	0 !se.hbar
	erase.se
	ActiveBounds  InvalRect
	make.top.line ;


: (RLSCROLL) ( desired x -- )
	locals| x |
	x left.edge <
	IF   x left.edge 1+ -
	ELSE x right.edge - se.charwidth +
	THEN
	0 do.se.scroll 2drop 
	UpdateAfterScroll				\ for recolorizing
	TextBounds  ClipRect  ;


: RLSCROLL  ( char offset -- )
	char>xy drop
	left.edge right.edge se.charwidth -  range
	IF
		drop
	ELSE
		set.hbar.range
		(rlscroll)
	THEN ;


: (?RLSCROLL) ( offset -- | handles right/left auto-scrolling, when desired )
	auto.hscroll c@
	IF	 RLScroll
	ELSE drop
	THEN ;


: ?RLSCROLL ( -- | handles right/left auto-scrolling, when desired )
	selend @ (?rlscroll) ;


: MAKE.BOX  ( -- )
	TextBounds @rect 
	{ t l b r | buf[ 20 ]  }
	TextBounds  ClipRect
	10 +to T
	R L - 2/ 75 - +to L
	T 60 + -> B
	L 150 + -> R
	T L B R  se.rect !rect
	buf[ GetPenState		\ &penState
	2 2  _PenSize 
	black  PenPat 
	patcopy  _PenMode
	se.rect dup  EraseRect
			dup  InvalRect
			     FrameRect 
	buf[ SetPenState
	se.window ?FlushWindow
 ;


: (.+R) ( n -- | draw n without IO.EVENTS - like . )
	S>D <# #S #> DrawText ;



\ **********  Live Scrolling  thanks to Doug Hoffman ******************************

1 value ScrollMultipier
1 value ComputedMultiplier


: ComputeMultiplier ( -- )
	#lines @ 
	se.lineheight #vislines @ 4 - * / 
	1+ 
	-> computedMultiplier ;


0 value wasThumbY

: ThumbScroll ( -- )
	skip.events @ >R
	skip.events ON		\ this must be uninterruptible
	action-of PAUSE >R	\ as it is run by the OS inside TrackControl
	['] noop is PAUSE

	wasThumbY
	@mouse point>xy nip
	dup -> wasThumbY
	-
	?dup
	IF
		?CmdKey IF 1  ELSE computedMultiplier THEN
			-> scrollMultipier
		0 swap scrollMultipier * do.se.scroll 2drop 
\ ****		30 ms
		se.window ?FlushWindow	\ FlushWindow
	
	THEN

	R> is PAUSE
	R> skip.events !
;


0 value ThumbActionUPP

0 0 CALLBACK: ThumbActionProcPtr

' ThumbScroll to-callback ThumbActionProcPtr



: DO.VTHUMB ( -- )
	SE.InfoMode OFF					\ force line# display
	se.vbar   GetControl32BitMaximum 
	locals| controlMax |
	get.window no.clip		( need for vbar )
	computeMultiplier

	@mouse.dn point>xy -> wasThumbY drop

	se.vbar  				\ ControlRef
	@mouse.dn				\ localPt
	ThumbActionUPP			\ 			\ actionProc
	TrackControl ( part code )

	TextBounds  InvalRect				\ force full redraw 
	0 top.line @ SE.DataStart
	(count.lines)
	controlMax min
	!se.vbar
	( part_code ) update.control
;


: DO.VBAR ( -- )
	this.part @ dup  hilite.vbar
	CASE
		up.button	OF 0  1 cont.scroll  ENDOF
		down.button OF 0 -1 cont.scroll ENDOF
		page.up		OF 0 #vislines @ 2 -  se.page.speed (cont.scroll) ENDOF
		page.down	OF 0 2 #vislines @ -  se.page.speed (cont.scroll) ENDOF
		in.thumb	OF do.vthumb	ENDOF
	ENDCASE
	0 hilite.vbar ;


: DO.HTHUMB ( -- )
	se.hbar @mouse.dn track.control
	IF	se.charwidth @se.hbar over / * !se.hbar	\ integral characters only
		TextBounds  ClipRect erase.se
		TextBounds  InvalRect
	THEN ;


: DO.HBAR ( -- )
	this.part @ dup hilite.hbar
	CASE
		up.button	OF	se.charwidth negate 0 cont.scroll ENDOF
		down.button OF	se.charwidth		0 cont.scroll ENDOF
		page.up		OF	half.window	negate  0 cont.scroll ENDOF
		page.down	OF	half.window			0 cont.scroll ENDOF
		in.thumb	OF	do.hthumb						  ENDOF
	ENDCASE		0 hilite.hbar ;


0 value LastScrollTicks

: ?DO.SE.SCROLL  ( x\y -- x'\y')
	 TickCount LastScrollTicks se.scroll.speed + >
	IF
		do.se.scroll
		 TickCount -> LastScrollTicks
	ELSE
		swap 0 max swap
	THEN 
;


: DRAG.SCROLL ( x\y -- dx\dy )
	TextBounds @rect
	locals| THE.RIGHT THE.BOTTOM THE.LEFT THE.TOP Y X |
	0
	x the.right > IF drop se.charwidth THEN
	x the.left	< IF drop se.charwidth negate THEN
	0
	y the.top	< IF drop	1 THEN
	y the.bottom > IF drop -1 THEN
	2dup or
	IF 	?do.se.scroll
		TextBounds  ClipRect
	THEN
	se.lineheight *				\ convert dy back to pixels
	swap negate swap ;			\ re-orient dx



\ **********  ***********************************************


: SE.MEMERROR? ( flag -- )
	IF	reset.undo
		HIDE.RANGE  SELEND @ SELSTART !
		true memerror?
	THEN ;


: SE.MAKEHANDLE ( size -- handle )
	MakeHandle dup false=				\	bytehandle? false=
	se.memerror? ;



: RANGE>HDL  ( -- hdl )
	selend @ selstart @ -
	dup se.Makehandle
	locals| HDL |
	?dup
	IF
		SE.DataStart  selstart @ +  hdl @  rot cmove
	THEN
	hdl ;


: SE.RESIZE.HANDLE ( handle\desired  --  )
	resize.handle 0< se.memerror? ;


: SE.MUNGER ( like munger, but checks errors and returns nothing on stack )
			( destStrH\offset\findStr\findLen\replcStr\replcLen -- offset )
	 Munger 0< abort" Munger Failed" ;


\ ********** UNDO/REDO **************************************************

: DisableUndo ( -- )
	InhibitUndo on
;

: EnableUndo ( -- )
	InhibitUndo off
;


structure UndoItem
	short: +UndoOP
	2+						\ spare
	long:  +UndoSelStart
	long:  +UndoSelEnd
	long:  +UndoDataHandle
structure.end

((
+UndoOP values
	$8001 - cut			- > one character
	$8002 - paste		- > one character
	$8003 - typing		- one character at a time
	$8004 - backspace	- one character at a time
	$8005 - formatting  - same behavior as paste, different menu name 

No attempt is made to manage branching undos
Any new UNDOable action removes any pending REDOable item

Inserted characters are accumulated and UNDO removes all until prior EOL
Any Interpreting in an editor window clears its Undo list


A separate Undo List is kept for each window as a handle saved at:
	SE.UndoListH 
with the current Undo insertion point saved at:
	SE.CurrentUndoListOffset


Editor uses SaveRangeOp & SaveOp to tell us what to append to SE.UndoListH


	---------	<--start (also possibly 1st redoable action if list length > 0 )
	undoitem1
				<-- ^1st undoable action
	undoitem2
				<--
	undoitem3
				<--
	undoitem4
				<-- ^CurrentUndoListOffset 
					(points AFTER last undo and at START of next redo)
	redoitem1
				<--
	redoitem2
				<--

+UndoOP
	
$8001 - CUT/DELETE - saves original selstart and selend
		saves deleted data as +UndoDataHandle for undoing

$8002 - PASTE/INSERT - saves original selstart/selend
		saves replaced data as +UndoHandle for undoing
		when UNDOne, swaps selstart/selend/UndoHandle for REDO
		
		SE.PASTE
		SE.PASTE.HANDLE
		(SE.PASTE.STRING)		also called by   APPEND.TO.TYPE.BUFFER   SE.PASTE.STRING
		SE.INSERT				DELETE.SEL.RANGE  4 saveRangeOp


$8003 - CHAR INSERT/TYPING
		1st time:
			saves original selstart/selend (should be equal)
			puts new character as data in +UndoHandle
		subsequent times:
			increments Selend
			appends new character to data in +UndoHandle

$8004 - BACKSPACING
		1st time:
			saves original selstart/selend (should be equal)
			puts deleted charcter as data in +UndoHandle
		subsequent times:
			decrements Selstart
			PRE-pends new character to data in +UndoHandle

$8005 - basically same as PASTE/INSERT except for menu item name
	    used for  SE.MARGIN  SE.UPPER  SE.LOWER  DoUnindent  DoIndent

))




: @AddUndoListH ( -- handle )	\ creates one if it does not exist
	SE.UndoListH @ handle? 0=
	IF 
		0 from.heap dup SE.UndoListH !
		SE.CurrentUndoListOffset off
	THEN
;


: ^UndoListInsertion ( -- addr |or| 0 )		\ this also points to redoable item if any
	@AddUndoListH dup
	IF
		dup GetHandleSize
		IF
			@ SE.CurrentUndoListOffset @  +
		ELSE									\ empty handle
			SE.CurrentUndoListOffset off
			@
		THEN
	ELSE										\ cant make handle ??
		SE.CurrentUndoListOffset off
		0
	THEN
;


: ^TheUndoableItem ( -- addr |or| 0 )	\ 0 if no undoable item
	SE.CurrentUndoListOffset @			\ 
	IF
		^UndoListInsertion dup
		IF
			UndoItem -					\ back up to undoable item start
	\	ELSE							\ no offset means no undoable items
	\		0
		THEN
	ELSE								\ no undoable items
		0
	THEN
;


: TheUndoableOp ( -- op |or| 0 )
	^TheUndoableItem dup
	IF
		SE.UndoListH @ GetHandleSize 0>
		IF
			+UndoOP w@
		ELSE
			drop 0
		THEN
\	ELSE								\ no undo action == 0
	THEN
;

: TheRedoableOp ( -- op |or| 0 )		\ 0 if no redoable item
	^UndoListInsertion dup
	IF
		dup
		SE.UndoListH @ dup GetHandleSize swap @ +
		<				\ make sure we have something to redo
		IF
			+UndoOP w@
		ELSE
			drop 0
		THEN
	THEN
;

: PruneUndoList ( offset -- )		\ offset must be multiple of UndoItem
	{: theOffset | theH  :}			\ remove all undoitems beyond offset
	SE.UndoListH @ handle?
	IF
		-> theH
		BEGIN
			theH gethandlesize  
			dup  theOffset >
		WHILE
			UndoItem -					\ offset  to last undo item
				dup theH @ +			\ address of last undo item
				+UndoDataHandle @
					handle? IF DisposeHandle THEN
			theH swap sethandlesize
		REPEAT
		drop
	THEN
;

: AddUndoableItem ( type -- itsAddr )	\ saves current selstart & selend - +UndoDataHandle 
\ WE DO NOT MAINTAIN BRANCHING UNDO LIST
	@AddUndoListH
	
	SE.CurrentUndoListOffset @ PruneUndoList	\ PENDING REDOS ARE REMOVED
	
	SE.CurrentUndoListOffset @  UndoItem +
			SetHandleSize						\ add room for another

	^UndoListInsertion							\ address to insert the new undoable item at
		swap over  +UndoOP w!
		selstart @ over +UndoSelStart !
		selend   @ over +UndoSelEnd   !
		0		   over +UndoDataHandle !		\ start with nil handle

		UndoItem SE.CurrentUndoListOffset +!
		AdjustUndoMenu
;


\ ********** UNDO/REDO MENU **************************************************

create tempUndoName$ 50 allot&erase

: BuildOpMenuName ( c$\Op -- c$' )
	swap count tempUndoName$ place

	( the op# )
	CASE
		0	  OF "" 				ENDOF
		$8001 OF c" Cut" 			ENDOF
		$8002 OF c" Paste" 			ENDOF
		$8003 OF c" Typing" 		ENDOF
		$8004 OF c" Backspacing" 	ENDOF
		$8005 OF c" Formatting" 	ENDOF
		c"  ?????" swap
	ENDCASE
	count tempUndoName$ append
	tempUndoName$
;


: <AdjustUndoRedoMenus ( -- )
	\ rename as appropriate
	se.window active.window @ =
	InhibitUndo @ 0= AND
	IF
		1 c" Undo " TheUndoableOp dup >R BuildOpMenuName
				EditMenu# set.item$  ( item\item$\menu id -- )
		1 R> 0<>  EditMenu# item.enable
	
		2 c" Redo " TheRedoableOp dup >R BuildOpMenuName
				EditMenu# set.item$  ( item\item$\menu id -- )
		2 R> 0<>  EditMenu# item.enable
	ELSE
		1 false  EditMenu# item.enable
		2 false  EditMenu# item.enable
	THEN
;

' <AdjustUndoRedoMenus is AdjustUndoMenu


0 value WAS.IB




\ ************************************************************
\  BOUNDARY-FINDING UTILITY WORDS

: SE.EOLN ( position\n -- new position | move to CR or to FILE.SIZE )
	SE.DataStart  locals| buf n pos |
	BEGIN
	    pos buf + c@ 
		SE.EOLChar @ =
	    IF -1 +to n THEN
		pos se.file.size @ >= IF 0 to n THEN
	n WHILE 1 +to pos 
	REPEAT pos ;


: SE.BOLN ( position\n -- new position | move to previous CR or file beginning)
	over SE.DataStart  locals| buf start n pos |
	pos 0> IF -1 +to pos THEN
	BEGIN
	    pos buf + c@
		SE.EOLChar @ =
	    IF -1 +to n THEN
		pos 0 <= IF -1 to n THEN		\ n = -1 means we crashed into BOF
	n 0> WHILE -1 +to pos
	REPEAT pos
	n 0= IF pos buf + c@ 
	SE.EOLChar @ =
	start 0> and IF 1+ THEN THEN ;


: SE.NEXT.WORD ( position -- new position | move to white space or to FILE.SIZE )
	SE.DataStart   locals| buf pos |
	BEGIN
	    pos buf + c@ bl <=
		pos se.file.size @ < and
	WHILE
	    1 +to pos
	REPEAT
	BEGIN
	    pos buf + c@ bl >
		pos se.file.size @ < and
	WHILE
	    1 +to pos
	REPEAT pos ;


: SE.PREV.WORD ( position -- new position | move to white space or to FILE.SIZE )
	SE.DataStart   locals| buf pos |
	pos 0> IF -1 +to pos THEN
	BEGIN
	    pos buf + c@ bl > false=
		pos 0> and
	WHILE
	    -1 +to pos
	REPEAT
	
	BEGIN
		pos 0>
		pos 1- buf + c@ bl >
		AND
	WHILE
	    -1 +to pos
	REPEAT 
	pos ;

((
multiwhiles @ multiwhiles ON
: SE.PREV.WORD ( position -- new position | move to white space or to FILE.SIZE )
	SE.DataStart   locals| buf pos |
	pos 0> IF -1 +to pos THEN
	BEGIN
	    pos buf + c@ bl > false=
		pos 0> and
	WHILE
	    -1 +to pos
	REPEAT
	
	BEGIN
		pos 0>
	WHILE
		pos 1- buf + c@ bl >
	WHILE
	    -1 +to pos
	REPEAT pos ;
multiwhiles !
))


: CHARS.FROM.BOLN  ( char offset -- offset from cr )
	dup 1 se.boln - ;


: COLUMN.OF.OFFSET  ( offset -- col )
	0 locals| col offset |
	offset dup chars.from.boln dup >R - SE.DataStart  +
	r> 0 ?DO
	    dup c@ 9 =
	    IF   se.tabs col over mod -
	    ELSE 1
	    THEN +to col
	         1+
	LOOP drop
	col ;


\	MOUSE DOWN IN CONTENT REGION

(( 
: WORD.START ( offset -- offset' )
	BEGIN 1- dup 0< false=
		  over SE.DataStart  + c@ bl > and
	WHILE 
	REPEAT 1+ ;
 ))

checking @  checking off

: WORD.START ( offset -- offset' )		\ 10.47 - prevent c@ prior to SE.DataStart
	BEGIN
		1- dup 0< false=
	WHILE
		dup SE.DataStart  + c@ bl >
	WHILE 
	REPEAT THEN
	1+ ;
	
checking !





: WORD.END ( offset -- offset' )
	BEGIN dup se.file.size @ <
		  over SE.DataStart  + c@ bl > and
	WHILE 1+
	REPEAT  ;


: LOCATE.CHAR ( line offset\x -- char offset )
	LEFT.EDGE+HBar locals| X.GOT X.WANT |
	BEGIN
		x.got se.charwidth 2/ + 1-	x.want < over se.file.size @ < and
	WHILE 
		dup SE.DataStart  + c@ dup bl <
		IF
			CASE
				09 OF x.got compute.tabwidth +to x.got ENDOF
				SE.EOLChar @ OF x.got to x.want 1-		  ENDOF
				se.charwidth +to x.got
			ENDCASE
		ELSE
			drop se.charwidth +to x.got
		THEN 1+
	REPEAT
	se.file.size @ min ;


: CLICK.LINE# ( y -- line# on screen )
	top.edge - se.lineheight / ;


: XY>CHAR ( x\y\dir -- char offset )
	0 locals| LINE.START THE.DIR Y X |
	y click.line# dup locate.line  swap -> line.start
	= 
	IF 
		line.start x locate.char
	ELSE 				\ otherwise click is below end of text
		line.start 1 se.eoln 
	THEN
	double.click? 
	IF
		the.dir 0> IF word.end ELSE word.start THEN
	ELSE
		triple.click? 
		IF	the.dir 0> 
			IF  1 se.eoln 
				dup se.file.size @ < 
				IF 1+ THEN
			ELSE drop line.start 
			THEN
		THEN
	THEN ;


: GET.START.RANGE ( -- loose end | global anchor is set )
	0 locals| LOOSE.END |
	@mouse.dn point>xy
	-1 xy>char -> anchor \ beginning of boundary by default if double/triple click
	double.click?
	IF
		anchor word.end to loose.end
	ELSE
		triple.click?
		IF
			anchor 1 se.eoln  dup se.file.size @ < IF 1+ THEN
			-> loose.end
		ELSE
			anchor to loose.end
		THEN
	THEN
	?shiftKey
	IF	anchor selstart @ >
		IF   loose.end selend @ invert.range selstart @ to anchor
		ELSE anchor to loose.end
			 loose.end selstart @ invert.range selend @ to anchor
		THEN
	ELSE
		hide.range 
		anchor loose.end invert.range
	THEN
	anchor loose.end min selstart !
	anchor loose.end max selend !
	RangeVis on
	loose.end ;


0 value BackFind?	
defer FindBackWards
	 ' noop is FindBackWards


: CLICK.LOOP ( looseEnd -- )
	anchor dup 0 locals| NEW.LOOSE.END END.ANCHOR START.ANCHOR LOOSE.END |
	\ figure end.anchor

	?CntrlKey
	IF	
		mySE.CtrlClick @ ?dup		\ 10.43
		IF execute exit THEN		\ if there is a token, it supercedes

		Editor-Cntrl-Click
		IF exit THEN	
	THEN

	?shiftKey false=	\ no end.anchor if extending a selection
	IF	start.anchor
		double.click? 
		IF
			word.end
		ELSE 
			triple.click?
			IF	1 se.eoln dup se.file.size @ < IF 1+ THEN
			THEN
		THEN 
		-> end.anchor
	THEN


	BEGIN
		@mousexy 2dup drag.scroll ( x\y\dx\dy )
		rot + >R + R>  ( x\y )
		top.edge  max	\ for scrolling
		loose.end anchor < IF -1 ELSE 1 THEN
		xy>char	-> new.loose.end 

\ now make sure the selection range does not disappear if in line or word mode
		double.click? triple.click? or
		?shiftKey false= and 							\  without shift key
		IF	new.loose.end end.anchor < 
			IF	loose.end end.anchor >=
				IF	end.anchor loose.end invert.range
					start.anchor -> loose.end
				THEN
				end.anchor
			ELSE loose.end end.anchor <
				IF	loose.end start.anchor invert.range
					end.anchor -> loose.end
				THEN
				start.anchor 
			THEN
			-> anchor
		THEN
		new.loose.end loose.end invert.range 
		new.loose.end -> loose.end

		anchor loose.end min selstart !
		anchor loose.end max selend !
		StillDown false=
	UNTIL
	selend @ selstart @ - IF RangeVis ON THEN

	selstart @ selend @ = false=	\ search from top when selection + option
	IF	
		?OptionKey  IF	find.first THEN
		?CmdKey     IF	Editor-Cmd-Click THEN
	THEN
	UpdateAfterScroll				\ for recolorizing
;

defer InfoRectClicked			' noop is InfoRectClicked
defer ColorRectClicked			' beep is ColorRectClicked
defer EOLModeRectClicked		' beep is EOLModeRectClicked
defer SpecialClick? ( -- flag )	' false is SpecialClick?


: SE.CLICK  ( -- )
	SpecialClick? IF exit THEN		\ sepcial case clicks
	@mouse.dn ActiveBounds  PtInRect
	IF
		show.range  
		check.multiple.clicks
		TextBounds  ClipRect
		get.start.range
		click.loop
		mouse.down.record  8 + @ to last.down
		mouse.down.record 12 + @ to last.place
	ELSE
		0 to last.down
		@mouse.dn SE.InfoRect  PtInRect
		IF
			InfoRectClicked
		ELSE
			@mouse.dn SE.ColorRect  PtInRect
			IF
				ColorRectClicked
			ELSE
				@mouse.dn SE.EOLModeRect  PtInRect
				IF
					EOLModeRectClicked
				THEN
			THEN
		THEN
	THEN
	DrawInfo
;


: DO.SE.MOUSE ( -- )		\ LOOK
	-1 -> arrowColumn
	?in.control
	IF  
		this.control @
		CASE se.vbar OF do.vbar ENDOF
			 se.hbar OF do.hbar ENDOF
		ENDCASE
		0 to last.down
	ELSE
		se.click
	THEN
	show.range ;



\ ********** CURSOR MAINTENANCE **********************************************

create hiliteRect  0 , 0 ,

: CursorOnHilite?  ( -- b ) 	\ from Doug Hoffman
\ true if ibeam cursor is over a black hilited range
    selstart @  selend @ = IF false exit THEN
    selstart @  CHAR>XY ( l t ) swap drop SE.LEFTMARGIN
    selend @ CHAR>XY ( t l r b ) swap drop ActiveBounds 6 + w@
        hiliteRect !rect
    @mouse hiliteRect  PtInRect ;


defer SECursorHook ( -- flag )		' false is SECursorHook

: ADJUST.SECURSOR ( -- )		\ LOOK
	SECursorHook 0=				\ handle special case cursor controls
	IF
		@mouse ActiveBounds  PtInRect
		IF
			cursorOnHilite?		\ from Doug Hoffman
			IF   wIBEAM
			ELSE IBEAM
			THEN 
			Set.Cursor
		ELSE
			init.cursor 
		THEN
	THEN
;


\ ****** CUT & PASTE  **********************************************

defer TO.CENTER ( charOffset -- )

: <TO.CENTER ( charOffset -- )
	0 se.file.size @ 			\ offset\0\filesize
	range swap					\ flag\offset
	top.line @ 
	locals| REAL.TOP CharOffs |
	IF
		TextBounds  ClipRect
		CharOffs top.line !
		#vislines @ 2/ 1 max 0 
		?DO back.one.line drop LOOP
		top.line @ dup 
		real.top top.line !
		~find.line# !se.vbar
		top.line !
		0 !se.hbar
		erase.se
		draw.screen  
		CharOffs (?RLScroll)
\	ELSE
\		drop		\ 10.43
	THEN
;

' <TO.CENTER is TO.CENTER


: SHOW.OFFSET  ( offset -- )
	top.line @   screen.end @
	range
	IF
		(?RLScroll)
	ELSE
		to.center
	THEN ;


: SHOW.SELEND ( -- )
	selend @ show.offset ;


defer UpdateAfterRedrawFrom				\ for recolorizing
		' noop is UpdateAfterRedrawFrom


: REDRAW.FROM ( x\y\addr -- | one line only! )
	locals| THE.ADDR Y X |
\	y bottom.edge min  x left.edge max 
	y bottom.edge min  x left.edge max 1 + 	\ 04/15/05 dbh
	over se.lineheight + bottom.edge min   right.edge
	se.rect !rect
	se.rect dup  ClipRect  EraseRect
	the.addr x 1+ y se.lineheight + se.descent - draw.part.line drop

	UpdateAfterRedrawFrom				\ for recolorizing

	TextBounds  ClipRect ;


: PARTIAL.SCROLL ( top y\bottom y -- )
	locals| END.Y START.Y |
	patcopy  _PenMode
	TextBounds se.rect copy.rect
	start.y se.lineheight + se.rect w!	\ just below top line of selection
	se.rgn  SetEmptyRgn
	se.rect 
	 0 
	  start.y end.y - 
	    se.rgn  ScrollRect
	se.rgn  SetClip
	Get.SEBounds  EraseRect 
	draw.screen
	TextBounds  ClipRect
;

: (DELETE.SEL.RANGE)  ( -- )	\ no undrawing - no undo
	?lowerMark

	selstart @ selend @ - screen.end +!
	selstart @ selend @ count.lines negate #lines +!
	set.vbar.range
	se.handle   selstart @
	0  selend @ selstart @ -
	"" 0	se.munger
	selstart @ selend !
	se.handle    GetHandleSize se.file.size !
	true mark.change
;

: DELETE.SEL.RANGE  ( -- )	\ remove text from SE.HANDLE - no drawing
	?lowerMark
	selstart @ selend @ -
	IF
		was.IB
		IF   SE.DataStart  selstart @ + c@
			 1 saveOp 
			 false -> was.IB
		ELSE
			3 saveRangeOp
		THEN
		selstart @ selend @ - screen.end +!
		selstart @ selend @ count.lines negate #lines +!
		set.vbar.range
		se.handle   selstart @
		0  selend @ selstart @ -
		"" 0	se.munger
		selstart @ selend !
		se.handle    GetHandleSize se.file.size !
		true mark.change
	THEN    ;


: (SE.DELETE) ( -- )
	selstart @ selend @ = IF exit THEN	\ nothing to do
	selstart @ char>xy   selend @ char>xy
	locals| END.Y END.X START.Y START.X |
	delete.sel.range
	
	selstart @ top.line @ >=
	IF	
		start.y end.y - 
		IF start.y end.y partial.scroll THEN
		start.x start.y selend @ redraw.from
	THEN

	SET.HBAR.RANGE
	0 !se.hbar
	?RLSCROLL
	set.IBpt
;


: SE.DELETE   ( -- )
	selstart @ selend @ = IF exit THEN
	?NoEditAllowed
	TextBounds  ClipRect
	selstart @ top.line @ screen.end @ range	\ selstart in visible area?
	IF   drop
		 hide.range (se.delete)
	ELSE drop top.line off 0 !se.vbar
		 delete.sel.range
		 selstart @ ~find.line# #vislines @ 2/ - 0 max scroll.to
		 draw.screen 
		 Get.SEBounds   ValidRect		\ can't wait for update!
	THEN
	show.range	
	?rlscroll  ;


: SE.CLEAR ( -- )
	se.delete ;


: CHAR>BUFFER ( char -- )
	1 ?raiseMark
	dup >R   2 saveOP
	se.handle selend @
	0 0
	RP@	 1			\	RP@ 3 + 1		ENDIAN !!
	se.munger R> drop
	se.handle   GetHandleSize 
	se.file.size !
;
 

\ ******* TEXT INSERTION ***********************************************


defer AfterCharInsert		' drop is AfterCharInsert

: INSERT.CHAR ( char -- )		\ LOOK
	?NoEditAllowed
	dup >r
	se.delete        \ deletes selection when any key is pressed
	char>buffer      \ char in buffer
	set.IBPt 
	IBPt @point selstart @ redraw.from
	1 selstart +!   selstart @ selend !
	1 screen.end +!
	show.selend
	r> AfterCharInsert		\ AfterInsert
;

defer AfterRangeInsert		' 2drop is AfterRangeInsert



: ((SE.INSERT)) ( addr\count -- )
\ inserts text at SELEND
\ does not delete selection
\ does not redraw
\ does not affect UNDO list
	locals| THE.CNT THE.ADDR |
	the.cnt 0>
	IF	
		the.cnt ?raiseMark
		se.handle    selend @			\ selstart @
		0 0
		the.addr the.cnt
		se.munger
\		selstart @ the.cnt over + count.lines #lines +!
		selend @ the.cnt over + count.lines #lines +!
		set.vbar.range
		se.handle    GetHandleSize se.file.size !

		selend @ the.cnt +  selend !
\		selstart @ the.cnt +  selend !
		the.cnt screen.end +!
	THEN
;

: (SE.INSERT) ( addr\count -- )		\ does not delete nor affect UNDO LIST
	?NoEditAllowed
	2dup
	((se.insert))
	AfterRangeInsert	\ AfterInsert
;


: SE.INSERT ( addr\count -- )
	?NoEditAllowed

	4 SaveRangeOp		\ SaveInsertRange
	InhibitUndo @ >R
	InhibitUndo ON

	delete.sel.range	\ updates UNDO
	(se.insert)

	R> InhibitUndo !
	6 SaveRangeOp		\ CorrectFormattingEnd

	selend @ selstart !
;


: SE.BACKSPACE ( -- )
	?NoEditAllowed
	selstart @ selend @ =
	IF	show.selend
		-1 selstart +!	selstart @ 0<
		IF selstart off beep exit THEN 	\ going too far
		true -> was.IB
		(se.delete) 
		selstart @ top.line @ <
		IF	back.one.line drop @se.vbar 1- !se.vbar
			LEFT.EDGE+HBar 1-  top.edge
				top.line @  redraw.from
			draw.page.marks
		THEN
		?rlscroll
	ELSE se.clear
	THEN ;


: SE.TAB ( -- )
	?NoEditAllowed
	se.delete
	set.IBPt 
	IBPt @point locals| Y X |
	09 char>buffer
	x y selstart @ redraw.from
	1 selstart +! selstart @ selend ! 1 screen.end +!
	?rlscroll ;


: (SE.PASTE.STRING) ( addr\count -- )
	?NoEditAllowed

	locals| TheCount TheAddr |
	selstart @ char>xy nip
	TheAddr TheCount  se.insert
	TextBounds se.rect copy.rect
	se.rect w!
	se.rect dup    EraseRect    ClipRect
	draw.screen
	TextBounds  ClipRect
	show.selend
	true mark.change ;


\ ********** TEXT ENTRY STUFF **************************************************


defer UpdateAfterFlush				\ for recolorizing
		' noop is UpdateAfterFlush

: (FLUSH.TYPE.BUFFER)  ( -- | draws text in SE.TYPE.BUFFER at SELEND )
	0 LOCALS| Y |
	se.type.buffer c@								\ anything in se.type.buffer ?
	IF  SE.Window  get.window =
		IF	selend @ char>xy dup to y 			\ x\y
			selend @							\ save on stack for redrawing
			se.type.buffer count se.insert		\ se.insert changes selend & adds text to buffer
			redraw.from							\ redraw first line
			true mark.change
			selend @ char>xy nip dup y <>		\ has Y changed due to insertion?
			swap se.lineheight 2* +  
			bottom.edge  >= OR					\ or are we close to bottom?
			y 0< OR								\ of is Y above screen?
			IF	TextBounds se.rect copy.rect
				y
				se.rect w!
				se.rect dup  EraseRect  ClipRect
				draw.screen    
				TextBounds  ClipRect
				show.selend
			THEN
			se.type.buffer off		\ clear only when written successfully
			UpdateAfterFlush		\ for recolorizing
		THEN
	THEN
	selend @  col !
;


: FLUSH.TYPE.BUFFER  ( -- | draws text in SE.TYPE.BUFFER )
	do.io.events
	(flush.type.buffer) ;


: APPEND.TO.TYPE.BUFFER ( addr\count -- )
	?NoEditAllowed
	dup >R
	se.type.buffer.size  >		\ is it bigger than the buffer?
	IF	(flush.type.buffer)
		R> (se.paste.string)
	ELSE
		R@  se.type.buffer c@ +   se.type.buffer.size >
		IF (flush.type.buffer) THEN
		R@ col +!			\ COL not maintained exactly right, but good enough
		se.type.buffer count +	R@ cmove
		r> se.type.buffer c@ + se.type.buffer c!
	THEN ;


: (SE.RETURN) ( -- )
	selstart @ selend @ <>
	IF se.delete THEN
	SE.EOLMode @
	CASE
		CR=EOL   OF cr$ count append.to.type.buffer col off ENDOF
		LF=EOL   OF lf$ count append.to.type.buffer col off ENDOF
		CRLF=EOL OF NoEditAllowed ENDOF
	ENDCASE
	(flush.type.buffer) ;


: SE.RETURN ( -- | forces one line scrolling at end of page)
	set.IBPt 
	IBPt @point swap drop se.lineheight  + bottom.edge >=
	IF 	0 -1 do.se.scroll 2drop
		se.window clip>content
		show.selend		\ just in case we got more than one line down
	THEN
	(se.return)
	UpdateAfterScroll				\ for recolorizing
;


: SE.CTRL ( char -- | check single characters for BELL or BS )
	CASE
		  03 OF se.return							ENDOF
		  09 OF (flush.type.buffer) se.tab			ENDOF
	      SE.EOLChar @ OF (se.return)				ENDOF
	
	      10 OF (se.return)							ENDOF
	      13 OF (se.return)							ENDOF
	      
		  08 OF (flush.type.buffer) se.backspace	ENDOF \ backspace
		  07 OF beep  								ENDOF
		 	  (flush.type.buffer)
	ENDCASE ;



: AddPrintableText  ( addr\cnt --  addr'\cnt' )
	over
	BEGIN				\ addr\cnt\addr2
		over 0>			\ addr\cnt\addr2\flag
		over c@ bl >= 
		AND
	WHILE				\ while char at addr2 >= BL
						\ addr\cnt\addr2
		1+ swap 1- swap
	REPEAT				\ addr\cnt-1\addr2+1            \ addr\cnt'\addr'
	\ addr2 now points to 1st control character or end of string
	rot 				\ cnt'\addr'\addr
	2dup -				\ cnt'\addr'\addr\addr'-addr
	append.to.type.buffer
	swap
;

\ old version did not handle embedded controls well.
\ was fine for keyboard input, but not for pseudo-pastes
: ((SE.TYPE)) ( addr\count -- | no window checking )
	?dup
	IF
		BEGIN
			AddPrintableText  ( addr\cnt --  addr'\cnt' )
			dup
		WHILE
			over c@
			se.ctrl
			1- swap 1+ swap
			dup
			0= IF 2drop exit THEN
		REPEAT
		2drop
	ELSE
		drop
	THEN ;


: (SE.TYPE) ( addr\count -- )
	outfile @ -1 =				\ OUTFILE = -1 means send to current window
	IF	get.window se.window =
		IF  ((se.type)) ELSE dflttype THEN
	ELSE
		outfile @ valid.se?		\ OUTFILE = SE.WPTR ?
		IF outfile @ ?WVISIBLE	\ ?active.wptr
			IF  get.window >R  se.window >R
				outfile @ dup ->SE.Window  (window)
				((se.type))
				R> ->SE.Window
				R>  (window)
			ELSE 2drop			\ tried to write to closed window!
			THEN
		ELSE dflttype			\ OUTFILE not a SE.WPTR, so use default
		THEN
	THEN ;


: SE.TYPE ( addr\count -- )
	do.io.events
	(se.type) ;


: SE.EPRINT ( addr\count -- )
	io.events @ >R				\ ?? SKIP.EVENTS OFF HERE instead ??
	IO.EVENTS OFF
	debugfile @ ?dup
	IF	 outfile @ >R
		 outfile !
		 (se.type)
		 0 >R rp@  1 (se.type) R> drop		\ force a flush of type buffer  ENDIAN
		 r> outfile !
	ELSE 2DROP
	THEN
	R> io.events ! ;


: SE.consEXPECT ( addr\count -- )
\	streamRefNum @ ?interactive	
	true	
	IF (flush.type.buffer) THEN
	dflt.con +conExpectToken @execute  ;	\ DfltExpect


: SE.consACCEPT ( addr\count -- )
\	streamRefNum @ ?interactive	
	true	
	dflt.con +conAcceptToken @execute  ;	\ DfltAccept


: SE.?TERMINAL ( -- cnt )
	(flush.type.buffer)
	ansKEY?
;

: SE.consKEY ( -- char )
	(flush.type.buffer)
	dflt.con +conKeyToken @execute  ;	\ DfltKey

: SE.ANSEXPECT ( addr\count -- )
	(flush.type.buffer)  ansexpect  ;

: SE.ANSACCEPT ( addr\count -- )
	(flush.type.buffer)  ansaccept  ;

: SE.ANSKEY ( -- char )
	(flush.type.buffer) anskey  ;


: StartOfSelectedLine ( -- offset )
	\ start of first line in selected range
	selstart @ 
	SE.DataRange
	locals| the.size the.bfr the.start |
	BEGIN
		the.start 1- 0 max the.bfr +  c@ 
			SE.EOLChar @ <>
		the.start 0> and
	WHILE
		-1 +to the.start
	REPEAT
	the.start	
;

: EndOfSelectedLine ( -- offset )
	\ end of last line in selected range
	selend   @ 
	selstart @  over <>
	IF 1- 0 max THEN
	SE.DataRange
	locals| the.size the.bfr the.end |
	BEGIN
		the.end the.bfr + c@
			SE.EOLChar @ <>
		the.end the.size < and
	WHILE
		1 +to the.end
	REPEAT
	the.end
;


: SELECT.LINE ( -- )	\ can select multiple lines
	StartOfSelectedLine selstart !
	EndOfSelectedLine   selend !
;


\ ********** EDITOR INTERPRET **************************************************

defer  se.enterKey  ' beep is  se.enterKey


: CLEAR.SE.TIB ( -- | free up SE.TIB )
	se.tib  handle?
	IF	 
		 \ DUP tib.handle = IF console.stream THEN
		 DisposeHandle
	THEN
	0 to se.tib ;



: RANGE>SE.TIB  ( -- )
	clear.se.tib
	range>hdl -> se.tib
;


: Normalize.SE.TIB.BeforeInterpret ( -- )
	Interpreter.EOLMode			\ make result match Interpreter's preferred mode
	CASE
		CR=EOL   OF se.tib ReplaceAllLFsWithCRs ENDOF	\ eol = CR
		LF=EOL   OF se.tib ReplaceAllCRsWithLFs ENDOF	\ eol = LF
		CRLF=EOL OF NoEditAllowed ENDOF
	ENDCASE
;



variable SE.INTERPRETING		se.interpreting OFF

: SE.DONE.INTERPRETING  ( -- )
	state off
	(flush.type.buffer)
	update.status @execute
	dflt.con mfCONSOLE !
	clear.se.tib

	se.window  get.window =
	se.interpreting @ AND
	IF	init.se.font		\ make sure user can't change  default font settings
		se.type.buffer c@
		IF 
			(SE.RETURN)		\ se.return
		
		THEN	\ PERHAPS SHOULD INSERT A CR AT START OF BUFFER?
		reset.undo
		EnableUndo					\ 10.43
		show.selend
	THEN
	(flush.type.buffer)
	se.interpreting OFF

	outfile off
	events on
	false se.busy

	UpdateAfterScroll				\ for recolorizing

;



defer SE.INTERPRET.ERROR? ( abort$\err# -- )  ' 2drop is SE.INTERPRET.ERROR?
0 value WAS.SE.ERROR
0 value IncludeStartOffset

: (SE.INTERPRET)	\ assume SE.TIB has selected text
	se.interpreting ON
	DisableUndo							\ 10.43

	hide.range
	0 -> was.se.error

	Return.before.output @
	myse.cr @ 1 >  OR
	IF
		(SE.RETURN)	\ se.return	 				\ ??
	ELSE
		space
	THEN
	se.tib @  se.tib GetHandleSize
	IncludeMem						\ do we need to catch here?
;


: Safe.Prompt	\ like .SYSPROMPT but safe to include in editor
	." ok" depth ?dup if ."  \ " . then
	depth  -> SbDepth
	base @ -> SbBase
	context @ -> sbContext
	current @ -> sbCurrent
	cr
;


: SE.INTERPRET ( wptr -- )	\ assume SE.TIB has selected text
	locals| OriginalWindow |
	(SE.INTERPRET)

	compiling false=				 \ from kernel "quit" for continuity
	get.window originalwindow = and  \ only print OK if in the same window
	was.se.error 0=  and			 \ dont overwrite stuff if error hilited
	IF	
		MySE.CR @  0 > IF se.return  THEN
		events off
		io.events @ >R
		io.events off
		?stack
		ShowOKPrompt @
		selstart @ selend @ =
		AND 
		IF
			mfCONSOLE @ >R
			se.console mfCONSOLE !

			MySE.CR @  1 > IF  se.return  THEN
			Safe.Prompt		\ .prompt			\ ."  ok"
			debug @
			IF
				depth IF  .s	THEN	\ show stack contents
				\ debug.action
				se.return
			THEN

			R> mfCONSOLE !

		THEN
		R> io.events !

	THEN
	se.done.interpreting
;


: (SE.EnterKey) ( -- )
	StopGhosting
	get.window  locals| OriginalWindow |
	selstart @ selend @ =
	IF	select.line THEN	
	selstart @  entry.start !
	selstart @  -> IncludeStartOffset
	range>se.tib
	Normalize.SE.TIB.BeforeInterpret	\ correct line endings

	?OptionKey			\ option key, replace selection
	IF 
		(se.delete)
	ELSE
		selend @ selstart !
	THEN
\	MySE.CR @   IF	se.return THEN

	se.console mfCONSOLE !
	outfile on

	OriginalWindow	export.enter @	?dup
	IF 
		 execute  	\ ( wptr -- ) optional user function overrides INTERPRET
	ELSE
		 ?turnkey false=
	     IF   
	     	se.interpret
	     ELSE 
	     	drop
		 THEN
	THEN
;

' (SE.EnterKey) is SE.ENTERKEY




(( 
: (SE.QUIT)  ( -- )
  	ExceptStackStart dup exc0 ! excp !	\ initialise exception stack
	se.window  get.window =
	IF
		skip.events off
		events on
		quitter execchain	\ chainexecute
		postpone [
\		console.stream
		se.done.interpreting
		r0 @ rp!
		true do.se.program
	ELSE 
\		DfltQuit
		(QUIT)
	THEN ;

 ))

: (SE.QUIT)  ( -- )
  	ExceptStackStart dup exc0 ! excp !	\ initialise exception stack
  	r0 @ rp!
	skip.events off
	events on
	quitter execchain	\ chainexecute
	postpone [
	se.window  get.window =
	IF
\		console.stream
		se.done.interpreting
		true do.se.program
	ELSE 
\		DfltQuit
		(QUIT)
	THEN ;

' (SE.QUIT) is SE.QUIT


\ ********** AUTO INDENT **************************************************

: COPY.LEADING.BLANKS&TABS ( offset of prior line# -- )
	SE.DataStart 
	locals| BuffStart TheOffset |
	BEGIN	\ get next character from preceeding line
		BuffStart  TheOffset + c@
		dup   bl =						\ is it blank or tab ?
		swap  09 = OR
	WHILE
		BuffStart  TheOffset + 1 append.to.type.buffer
		1 +to TheOffset
	REPEAT
	(flush.type.buffer)
;


: FIND.PRIOR.CR.OFFSET ( offset -- offset' )
	0 max
	SE.DataRange rot min
	locals| TheOffset BuffStart |
	BEGIN	\ get next character from preceeding line
		TheOffset 0>
		BuffStart  TheOffset + c@
			SE.EOLChar @ <>
		AND
	WHILE
		-1 +to TheOffset
	REPEAT
	TheOffset ;


: STRIP.OLD.LEADING.BLANKS&TABS (  -- )
	selend @
	SE.DataStart 
	locals| BuffStart TheOffset |
	BEGIN
		theoffset se.file.size @ <
		BuffStart  TheOffset + c@
		dup   bl =						\ is it blank or tab ?
		swap  09 = OR
		AND
	WHILE
		1 +to TheOffset
	REPEAT
	TheOffset  selend !
	(se.delete) ;


: DO.AUTO.INDENT ( -- )
	selend @
	2 -   find.prior.cr.offset   dup
	IF 1+ THEN 					\ get past CR
	copy.leading.blanks&tabs
	strip.old.leading.blanks&tabs
 ;


\ ********** ARROW KEYS **************************************************


: OFFSET.NOT.VISIBLE?  ( offset -- flg )
\ 0 = offset on screen, 1 = above, -1 = below )
	top.line @  SE.DataStart    0 0
	locals| linecnt result buf top target |
	target top <
	IF
		1 -> result					\ above
	ELSE
		top buf +  target top -
	    over + swap 
	    ?DO
	        i c@
			SE.EOLChar @ =
	        IF  1 +to linecnt
	            linecnt #vislines @  < false=
	            IF -1 -> result
	               leave
	            THEN
	        THEN
	     LOOP
	THEN result ;


: ?SCROLL.TO.SHOW ( offset -- )
	locals| offset |
	BEGIN  offset offset.not.visible? ?dup
	WHILE  0 swap do.se.scroll 2drop
	       TextBounds  ClipRect
	REPEAT
	set.IBpt  ?RLscroll
	UpdateAfterScroll				\ for recolorizing
 ;


: ?saveArrowColumn   ( offset -- )
	arrowColumn 0<
	IF  column.of.offset -> arrowColumn
	ELSE drop
	THEN ;


: ADVANCE.SEL ( sel -- | move sel to arrowColumn or to CR or to FILE.SIZE )
	SE.DataStart   0 0 locals| col char buf sel |
	BEGIN
	    sel @ buf + c@ -> char
	    char 
		SE.EOLChar @ <>
		sel @ se.file.size @ < and
	    col arrowColumn <  and
	WHILE
	    1 sel +!
	    char 9 =
	    IF   se.tabs col over mod -
	    ELSE 1
	    THEN +to col
	REPEAT ;


: >LINE.ABOVE  ( ^offset -- | move IB up one line if possible )
	locals| sel |
	sel @ ?saveArrowColumn
	sel @ 1 se.boln 0=	\ are we on the first line?
	IF	sel off
	ELSE
		sel @ 2 se.boln sel !	\ move to line start of prev line
		sel advance.sel				\ find the right column
	THEN ;

: >LINE.BELOW   ( ^offset -- | move IB down one line if possible )
	locals| sel |
	sel @ ?saveArrowColumn
	sel @ 1 se.eoln dup se.file.size @ <	\ move to end of line
	IF 1+ sel !						\ and skip the CR
		sel advance.sel				\ and find the right column
\	ELSE se.file.size @ 1- sel !		\ we're on the last line, move to end
	ELSE drop se.file.size @ dup selstart ! selend ! \ 07/07/04 dbh  
	THEN ;

\ arrow key movements - same actions as MPW, not currently undo-able though

: ?EXTEND.RANGE  ( new free end\->free end -- )
	?shiftKey IF
		2dup @ invert.range
	THEN
	! ;
	
: SE.LeftArrow ( -- )
	0 0 locals| selanchor selfree |
	anchor selend @ =
	IF selend -> selanchor selstart -> selfree
	ELSE selstart -> selanchor selend -> selfree 
		selstart @ -> anchor
	THEN
	?shiftkey  selstart @ selend @ = OR
	IF	selfree @ show.offset
		selfree @ 0>
		IF	command.key?
			IF selfree @ 1 se.boln
			ELSE ?OptionKey 
				IF	selfree @ se.prev.word
				ELSE selfree @ 1-
				THEN
			THEN
			selfree ?extend.range
			selfree @ selanchor @ 2dup > IF swap THEN
			selend ! selstart !
		THEN
	ELSE hide.range selstart @ show.offset
	THEN
	?shiftKey false= IF  selstart @ selend ! THEN
	selfree @ ?scroll.to.show ;


: SE.RightArrow ( -- )
	0 0 locals| selanchor selfree |
	anchor selend @ =
	IF selend -> selanchor selstart -> selfree
	ELSE selstart -> selanchor selend -> selfree 
		selstart @ -> anchor
	THEN
	?shiftkey  selstart @ selend @ = OR
	IF	selfree @ show.offset
		selfree @ se.file.size @ < 
		IF	command.key?
			IF	selfree @ 1 se.eoln
			ELSE ?OptionKey 
				IF	selfree @ se.next.word
				ELSE selfree @ 1+
				THEN
			THEN
			selfree ?extend.range
			selfree @ selanchor @ 2dup > IF swap THEN
			selend ! selstart !
		THEN
	ELSE hide.range selstart @ show.offset
	THEN
	?shiftKey false= IF  selend @ selstart ! THEN
	selend @ ?scroll.to.show ;


: SE.UpArrow ( -- )
	0 0 locals| selanchor selfree |
	anchor selend @ =
	IF selend -> selanchor selstart -> selfree
	ELSE selstart -> selanchor selend -> selfree 
		selstart @ -> anchor
	THEN
	?shiftKey false= IF  hide.range selstart @ selend !  THEN
	selfree @ show.offset 
	selfree @ 0>
	IF	selfree @ ?OptionKey		\ command.key? 
		IF	-1 -> arrowColumn
			dup top.line @ =
			IF selfree @ ~find.line# #vislines @ 2 - - 0 max scroll.to
			THEN
			top.line @ selfree ! 
		ELSE
			command.key?
			IF
				0 show.offset selfree off
			ELSE
				selfree >line.above
			THEN 
		THEN 
		?shiftkey
		IF   selfree @ invert.range 
		ELSE drop selfree @ selanchor !
		THEN
		selfree @ selanchor @ 2dup > IF swap THEN
		selend ! selstart !
		command.key? false= IF selfree @ ?scroll.to.show THEN
	THEN
;

: SE.DownArrow  ( -- )
	0 0 locals| selanchor selfree |
	anchor selend @ =
	IF   selend -> selanchor
	     selstart -> selfree
	ELSE selstart -> selanchor
	     selend -> selfree 
		 selstart @ -> anchor
	THEN
	?shiftKey false= IF hide.range selend @ selstart !  THEN
	selfree @ show.offset 
	selend @ se.file.size @ <
	IF	selfree @ 
		?OptionKey		\ command.key? 
		IF	-1 -> arrowColumn
			selfree @ 
			screen.end @ 1- 1 se.boln =
			IF	top.line @ ~find.line# #vislines @ 2 - +
					#lines @ #vislines @ 2 - - min dup scroll.to
				#vislines @ + 1- 
				SE.DataRange
				(get.line.offset) 1 se.boln selfree !
			ELSE
				screen.end @ 1- 1 se.boln selfree !
			THEN
		ELSE
			command.key?
			IF
				se.file.size @ dup show.offset selfree !
			ELSE
				selfree >line.below
			THEN 
		THEN	\ old selfree@ is on stack
		?shiftkey
		IF   selfree @ invert.range 
		ELSE drop selfree @ selanchor !
		THEN
		selfree @ selanchor @ 2dup > IF swap THEN
		selend ! selstart !
		command.key? false= IF selfree @ ?scroll.to.show THEN
	THEN
;


: SE.BACKSPACEKEY ( -- )	\ handles cmd and option modifiers
	selstart @ selend @ =
	IF	show.selend
		command.Key?
		IF
			se.file.size @ selend ! se.clear
		ELSE
			?OptionKey
			IF   selstart @ se.prev.word selstart ! se.clear
			ELSE se.backspace
			THEN
		THEN
	ELSE se.clear
	THEN ;


: SE.deleteKey  ( -- )
	selstart @ selend @ =
	IF	show.selend
		command.Key?
		IF	se.file.size @ selend ! se.clear
		ELSE ?OptionKey
			IF	selend @ se.next.word selend ! se.clear
			ELSE
				1 selend +!	selend @ se.file.size @ >=
				IF -1 selend +! beep exit THEN 	\ going too far
				true -> was.IB
				(se.delete)
				?rlscroll
			THEN
		THEN
	ELSE se.clear
	THEN ;


: HANDLE.MOVEMENT.KEYS ( char -- flag )	\ 0 if handled, return char if not
	0 swap
	CASE
		30 OF se.upArrow     	ENDOF
		31 OF se.downArrow   	ENDOF

		-1 -> arrowColumn
		28 OF se.leftArrow   	ENDOF
		29 OF se.rightArrow  	ENDOF
		05 OF beep				ENDOF				\ Help
		01 OF 0 scroll.to 		ENDOF				\ Home
		11 OF 0 #vislines @ 2 - do.se.scroll UpdateAfterScroll 2drop	ENDOF	\ PageDown
		12 OF 0 2 #vislines @ - do.se.scroll UpdateAfterScroll 2drop	ENDOF	\ PageUp
		04 OF #lines @ 		\ #vislines @ 2 - - 0 max scroll.to	
			  WillShowBlankPage	
			  IF
					NumPriorLines -							\ #lines to show of last real page
			  ELSE
					#vislines @   -   
			  THEN
			  0 max scroll.to											ENDOF	\ END 
		nip dup 	\ not found - return the char
	ENDCASE
;


\ ********** KEYBOARD **************************************************

defer AfterSEKeyEntry ( -- )  ' noop is AfterSEKeyEntry

: CONTROL.CHAR  ( char -- )
	handle.movement.keys ?dup
	IF	?NoEditAllowed
		hide.range
		true mark.change
		CASE
	        03 OF se.enterKey     ENDOF
	        08 OF se.backspaceKey AfterSEKeyEntry ENDOF
			09 OF se.tab		  ENDOF
			13 OF ?shiftKey						\ Return Key
				  IF    se.enterKey				\ shift return is shortcut for Enter
				  ELSE  se.return
						auto.indent c@
						?OptionKey false=		\ DON'T INDENT WITH OPTION KEY DOWN
						AND
						IF do.auto.indent THEN
				  THEN
				ENDOF
	        27 OF se.clear			  ENDOF
	       127 OF se.deleteKey		  ENDOF		\ Del
			 0 OF (flush.type.buffer) ENDOF		\ ignore 0
	    	 beep   \ unknown control char
		ENDCASE
	THEN
;


: (DO.SE.KEY) ( char -- )			\ LOOK
	dup 
	bl < 						\ control key
	over 127 = or				\ DELETE key?
	IF
		 control.char
	ELSE
		?NoEditAllowed
		hide.range				\ HIDE.RANGE is only done here for non-control keys
		-1 -> arrowColumn
		insert.char
		true mark.change
		show.range
		DrawInfo
		AfterSEKeyEntry		\ possible special action after insertion
	THEN
;


defer EditorKeyFilter ( char -- char' )
		' noop is EditorKeyFilter
	\ if filter wants to "consume" the keystroke, as with custom control
	\ sequences (using OPT-SHIFT-CONTROL) then char' should be 0


: DO.SE.KEY ( char -- )
	1 false editmenu# item.enable
	ObscureCursor
	EditorKeyFilter		\ ( char - char' ) global intercept prior to Export.Key
	Export.KEY @execute	\ ( char - char' ) optional user per-window function
	pause				\ allow task to examine things before handling key
	(do.se.key)
;


\ ********** CUT/COPY/PASTE AND SCRAP **********************************************

: TO.SE.SCRAP ( -- )
	selend @ selstart @ -	locals| #TOADD |
	?shiftKey
	IF		se.scrap dup  GetHandleSize
	ELSE	se.scrap handle? IF  DisposeHandle THEN
			0  NewHandle to se.scrap
			se.scrap 0
	THEN
	#toAdd +	se.resize.handle
	SE.DataStart  selstart @ +	se.scrap @
	?shiftKey	IF se.scrap  GetHandleSize	#toAdd - + THEN
	#toAdd cmove ;


: PUT.SE.SCRAP  ( -- | copy SE.SCRAP to Clipboard )
\ cannot call in suspend event !!
    se.scrap  GetHandleSize 0> 
    se.scrap.changed and
    IF
    	useCRsInScrap?
    	IF
    		se.scrap ReplaceAllLFsWithCRs	\ Exported scrap should have CRs
    	ELSE
    		se.scrap ReplaceAllCRsWithLFs
    	THEN
    	se.scrap HLock
        se.scrap dup @ swap  GetHandleSize ascii TEXT put.scrap
        dup io-result !
        abort" PUT.SE.SCRAP error" 
        false to se.scrap.changed
        se.scrap  HUnlock
        GetCurrentScrap
        dup to OldScrapCount to SEScrapCount
    THEN ;


defer NoSelectionInSE.Copy
	 ' beep is NoSelectionInSE.Copy


: SE.COPY ( -- )
	selstart @ selend @ = IF NoSelectionInSE.Copy exit THEN
	to.se.scrap
	show.selend true to se.scrap.changed
	put.se.scrap
;


: SE.CUT ( -- )
	se.copy se.delete ;


0 value InhibitResetUndoOnPaste		\ one-shot


: SE.PASTE.STRING ( addr\count -- )
	Export.Paste @execute		\ ( addr\cnt - addr\cnt ) optional user function
	(se.paste.string) ;


: SE.PASTE.HANDLE ( handle -- )			\ 
	locals| TheHandle |
	TheHandle  HLock
	TheHandle dup @ swap  GetHandleSize
	se.paste.string
	TheHandle  HUnlock  ;


: NormalizeScrapBeforePaste ( -- )
	SE.EOLMode @
	CASE
		CR=EOL   OF se.scrap ReplaceAllLFsWithCRs 	ENDOF	\ eol = CR
		LF=EOL   OF se.scrap ReplaceAllCRsWithLFs	ENDOF	\ eol = LF
		CRLF=EOL OF NoEditAllowed ENDOF
	ENDCASE
;


: SE.PASTE	 ( -- )
	NormalizeScrapBeforePaste
	se.scrap se.paste.handle ;


: GET.SE.SCRAP ( -- | Copy Clipboard to SE.SCRAP )
    scrap.len @ 0> 
    \ Has desk scrap changed since last put or get?
    IF  se.scrap handle?  IF  DisposeHandle THEN
        0  NewHandle to se.scrap
        0 ascii TEXT get.scrap dup 0>	\ length or error
        IF
        	 drop se.scrap ascii TEXT get.scrap drop
        ELSE
        	true abort" GET.SE.SCRAP error"
        THEN 
        false to se.scrap.changed
           GetCurrentScrap ( OldScrapCount 1+ ) to OldScrapCount
    THEN
;


: OKForMultiples? ( sewptr -- flag )  \ true if OK
	CheckForSameName
	IF
		c" There are multiple editor windows open with this name." 
		cr$ cr$
		c" Are you sure you want to save this one?"
		Continue# IssueWindowCenteredAlert 2 =
		discard.activates
	ELSE
		true
	THEN
;



\ ********** OTHER EVENTS **************************************************


: SET.SE.ONE.SHOTS ( -- )
	se.volref# w@s volref# !
	se.ioDir @ ioDir ! ;


: ModifyBackgroundColor? ( -- )		\ do this before colorizer draws
	se.window CheckForSameName		\ is this window a duplicate?
	IF
		SE.DuplicateColor
	ELSE							\ normal color if not a duplicate
		SE.BackColor
	THEN
	dup @rgb SE.wasTopBackColor !rgb	\ needed for (SE.SAVE.AS)
	RGBBackColor
	TextBounds invalrect		\ resize.se	\ update the window
;

: (SE.SAVE.AS) ( -- file# )
	0 { FILE# | buf[ 1024 ] }
	se.filetype @ ?dup false=		\ does this file have a special type?
	IF  SE.DfltFileType @ 			\ if not, use the default
	THEN
	fileType !						\ leave CREATOR as is (usually ours)

	\ default name
	buf[ SE.Window Get.WTitle
	se.changed @
	IF
		buf[ StripMarker
	THEN

	C" Save As what name?"
	buf[ NRRecord StandardPutFile

	discard.activates	
\	active.window @ (window)
	se.window (window)
	NavReplyOK? dup continue? !
	IF
		NavReplyName se.window set.wtitle
		\ remove prior copy if any
		NavReplyVolume NavReplyDir NavReplyName  HDelete drop
		\ create the file
		NavReplyVolume se.volref# w!	
		NavReplyDir    se.ioDir !
		set.se.one.shots
		se.file.size @ NavReplyName new.file to file#	?file.error
		true se.realfile w!
		ModifyBackgroundColor?
	THEN
	SE.DfltFileType @  FileType !	\ reset file type for the next guy
	file# ;



: LOST.FILE ( -- )
	c" Can't open file.  Please locate it again."  "" "" ""
	NotFound# IssueWindowCenteredAlert drop 
	discard.activates
	BEGIN do.events 0= UNTIL	\ must flush everything!
\	ClearReply
	0 #filetypes se.filetypelist NRRecord

	0 c" Find Misplaced File" 0 0 c" Please re-locate file"
	NavGetFile ( fileFilter\numTypes\&typeList\&reply\...
	 				...\ client$\title$\action$\cancel$\message -- OSErr )
	drop
	discard.activates
	active.window @ (window)
	NavReplyOK? boolean dup continue? !
	IF	NavReplyName se.window set.wtitle
		NavReplyVolume se.volref# w!
		NavReplyDir se.ioDir !
		-1 se.realfile w!
	THEN ;


0 value WasFileLocked?		\ one-shot retains value until next open attempt


: (SE.OPEN$) ( str$ -- ref# )
\ volref# and ioDir assumed  already set up
	volref# @   
	ioDir @
	0 
	locals| theRef#  TheDir TheVol theName$ |

	0 -> WasFileLocked?
	theName$ rw open$ to theRef#			\ try to open as RW

\ if file already open, open it RO
\	io-result @ -49 = IF io-result off THEN 	\ ignore "File already open" error
	io-result @ 	\ -54 = 					\ file locked. permission error, etc
	dup se.ioresult !
	IF  			\ cannot open RW
		TheVol volref# !    TheDir ioDir !
		theName$ ro open$ to theRef#			\ try AGAIN to open, this time  as RO
		io-result @ -49 = IF io-result off THEN	\ ignore "File already open"
		true to WasFileLocked?
	THEN
	theRef#
;


: (RE-OPEN) ( -- file# )
	{ | buf[ 256 ] }
	buf[ SE.Window Get.WTitle  
	se.changed @
	IF
		buf[ StripMarker
	THEN

	set.se.one.shots
    buf[
	(se.open$) ( str$ -- ref# )	
	WasFileLocked?  SE.LOCKED w!
	0 -> WasFileLocked?
;


: RE-OPEN ( -- file# )
	(re-open) io-result @
	IF	drop lost.file continue? @ IF recurse ELSE 0 THEN
	THEN ;


: SAVE.SELECTION ( -- )
	se.restorer @						\ check flag
	IF
		selstart @ 
			endianswap32
			+miscinfo +SavedSelStart !
			\ over !
		selend  @ 
			endianswap32
			+miscinfo +SavedSelEnd !
			\ swap 4 + ! 
	ELSE
		LastJumpedFrom @
			endianswap32
			+miscinfo +SavedSelEnd !
	THEN
;


: (SE.SAVE) ( file# -- )
	locals| FILE# |
 	true se.busy
 	\ optional user action before saving:
	file# BEFORE.SE.SAVE  ?dup IF execute ELSE drop THEN
	se.handle    HLock
	file# rewind
	SE.DataRange
		file#  sync FileWrite drop ?file.error
	se.handle  GetHandleSize  file# set.eof

	restore.positions c@
	IF 
		SaveSize&Position
	THEN
	save.selection
	file# tfile !
	save.MiscInfo

	se.handle  HUnlock
	false mark.change
	file# FileClose
	after.se.loaded  execute			\ optional user action after loading
	false se.busy
;


: SetProxyIcon ( Fref -- )
	FRef->Alias ?dup
	IF
		get.window	>R		\ preserve grafport around this call
		se.window @ over  SetWindowProxyAlias drop
		to.heap				\ alias handle no longer needed
		R> window
	THEN
;


: SE.SAVE.AS ( -- )
	continue? on
	se.realfile w@			\  - an unsaved document will set SE.LOCKED
	IF
		(re-open) ?dup		\ update SE.LOCKED flag
		IF FileClose THEN
	THEN

	(se.save.as)			\ file#
	continue? @				\ re-set by NavReplyOK?
	IF
		dup before.se.save.as ?dup IF execute ELSE drop THEN
		dup SetProxyIcon
		(se.save)
	ELSE
		drop 
	THEN

 ;


: SE.SAVE ( -- )
	se.realfile w@
	IF
		se.window OKForMultiples? ( sewptr -- flag )
		IF
			continue? on
			re-open
			continue? @
			IF (se.save) ELSE drop THEN
		THEN
	ELSE
		se.save.as
	THEN ;


: ASK.SAVE ( -- )
	{ | scratch[ 256 ] }
	continue? on
	se.changed @			\ has it changed?
	IF
		C" Save changes to " 
		scratch[ 
		dup SE.Window Get.WTitle
		dup StripMarker
		C" ?" ""
		se.window bring.to.front	\ ??
	
		YNC# IssueWindowCenteredAlert 
		discard.activates
		CASE 1 OF se.realfile w@
					IF	 se.save 
					ELSE se.save.as 
					THEN			ENDOF
			( 2 is "No" )
			  3 OF continue? off ENDOF			\ CANCEL
		ENDCASE
		DrawMenuBar
	THEN ;




\ ********** PRINT SELECTION **************************************************

exists? PrintFile  			\ is print support loaded ?
[IF]

: PrintScrap ( -- )
\	256	LocalBuf
	se.scrap { sc | strbuf[ 256 ] }
	line# off					\ optional
	sc  HLock

	selstart @ selend @ =
	IF
		strbuf[ SE.Window Get.WTitle  
		se.changed @
		IF
			 strbuf[ StripMarker
		THEN
		strbuf[
	ELSE
		C" Editor Selection"
	THEN
	true sc 
	['] PrintText catch  drop

	sc  HUnlock
	line# off ;					\ optional


: SE.PRTSEL ( -- )
	selstart @ selend @ =
	IF
		selstart @  selend @
		se.file.size @  ?dup false= 
		IF								\ empty window, no print
			2drop
			beep exit 
		THEN
		selend !		selstart off	
		to.se.scrap						\ copy the whole current window
		selend ! 		selstart !		\ restore selection
	ELSE
		to.se.scrap
	THEN
	True Busy
	printScrap
	False Busy

;
[THEN]



\ ********** RE-MARGIN **************************************************

true constant DoubleSpace	\ if true places extra space after periods (.)
variable SELECTION.OFFSET
variable TEHANDLE
create   TERECTANGLE	8 allot
create   BLANKTEXT		se.tabs 16 max 32 min  here over allot swap blank 
create   TABTEXT		here 	2 allot  2 9 fill
create 	 PERIOD-SPACES	$2e c, $20 c, $20 c, $20 c,	\ hex# 2E202020 ,



: ADJUST.SELSTART ( -- )
	SE.DataStart  locals| the.bfr |
	selection.offset off
	BEGIN
		selstart @ 0>
		selstart @ the.bfr + 1- c@
		SE.EOLChar @ <>
		and
	WHILE
		-1 selstart +!
		1 selection.offset +!
	REPEAT ;


: COLUMN# ( offset -- col# )
	se.scrap @ locals| bb offset |
	offset
		BEGIN
			1- dup 0< over bb + c@ 
			SE.EOLChar @ =
			or
		UNTIL
	1+ offset swap - ;


: FIND.TAB ( offset -- new.offset )
	se.scrap swap	tabtext 1	0 0  Munger ;


: REPLACE.ONE.TAB ( offset -- new.offset )
	0 locals| cnt offset |
	offset column#
	se.tabs mod se.tabs swap - to cnt
	cnt 1- selection.offset +!			\ adjust for added SPACEs
	se.scrap offset	0 1	blanktext cnt	 Munger ;


: DETAB.PHASE1	\ detab with column alignment, updating selection.offset
	0 BEGIN	find.tab
			dup 0<	over selection.offset @ >	or false=
	WHILE	replace.one.tab
	REPEAT drop ;


: DETAB.PHASE2	\ detab with column alignment, updating selection.offset
	selection.offset @	0 locals| char pp |
	BEGIN
		pp se.scrap @ + c@	to char		\ current character
		char 9 =	char bl =	or		\ while char is tab or space
		pp se.scrap  GetHandleSize <	and	\ and still within scrap
	WHILE
		char 9 =	IF pp replace.one.tab drop THEN
		1 +to pp
	REPEAT ;


: DETAB.PHASE3	( simple replacement: tab -> space )
	BEGIN
		se.scrap	selection.offset @
		tabtext 1	blanktext 1  Munger 0<
	UNTIL ;


: RemoveTABs ( -- )
	detab.phase1		\ tabs prior to original SelStart
	detab.phase2		\ initial tabs within selection
	detab.phase3 ;		\ remaining tabs within selection


: RemoveCRs ( -- )
	se.scrap dup @ swap  GetHandleSize
		over + swap
		?DO
			i c@
			13 =			\ SE.CUT normalizes to CRs
			IF bl i c! THEN
		LOOP ;


: SKIP.INITIAL.BLANKS ( -- )
	BEGIN
		selection.offset @	se.scrap  GetHandleSize	<
		selection.offset @	se.scrap @ + c@	bl =	AND
	WHILE
		1 selection.offset +!
	REPEAT ;


: RemoveBLs ( -- )
	skip.initial.blanks
	BEGIN
		se.scrap selection.offset @	blanktext 2	blanktext 1	 Munger 0<
	UNTIL ;


: DO.DOUBLESPACES	( -- | inserts an extra space after periods )
	selection.offset @
	BEGIN
		se.scrap	swap	period-spaces 2 period-spaces 3  Munger
		dup 0<
	UNTIL drop ;


: MakeTErec
	TextBounds @rect se.rightmargin - TERectangle !rect
	TERectangle dup  TENew TEHandle ! ;


: EmbedCR ( offset\handle -- )	\ eliminate spaces at end of line
	swap  1- blanktext 1   \ crlf 1    
	SE.EOLMode @
	CASE
		CR=EOL   OF CR$		ENDOF
		LF=EOL   OF LF$		ENDOF
		CRLF=EOL OF CRLF$ 	ENDOF
	ENDCASE
	count
	Munger drop ;


\ Find a better way to do this without TE !!!!
: InsertCRs ( handle -- )
	Locals| TheHandle |
	TheHandle  HLock
	TheHandle dup @ swap  GetHandleSize TEHandle @  TESetText
	TEHandle @  TECalText
	TheHandle  HUnlock
	TEHandle @ dup  HLock @ 96 +
	dup 2 - w@ 1 swap
	?DO
		dup i 2* + w@	TheHandle embedCR
	-1 +LOOP
	drop ;


: SE.insertCRs ( -- )
	se.scrap InsertCRs ;


: ReleaseTErec ( -- )
	TEHandle @  TEDispose ;


: RE-MARGIN ( -- )
	true se.busy
	removeTABs	removeCRs	removeBLs
	DoubleSpace IF do.doublespaces THEN
	makeTErec
	SE.insertCRs
	releaseTErec
	false se.busy ;


: SE.MARGIN ( -- )
	selstart @ selend @ =
	IF	beep
	ELSE
		se.scrap >R
		0 -> se.scrap
		adjust.selstart
	\			--> save here as formatting, then disable undo
		5 SaveRangeOp		\ SaveFormattingRange
		
		InhibitUndo @ >R
		InhibitUndo ON

		se.cut

		re-margin
		se.paste
		
		R> InhibitUndo !
		6 SaveRangeOp		\ CorrectFormattingEnd

		R> -> se.scrap
	THEN ;



\ ***** UPPER/LOWER CASE ************************************************


: SE.UPPER ( -- )
	selstart @ selend @ = IF beep exit THEN
	SE.SCRAP >R
	0 -> SE.SCRAP
	5 SaveRangeOp		\ SaveFormattingRange
	se.copy
	se.scrap dup @ swap  GetHandleSize upper
	se.paste
	R> -> se.scrap
;


: SE.LOWER ( -- )
	selstart @ selend @ = IF beep exit THEN
	SE.SCRAP >R
	0 -> SE.SCRAP
	se.copy

	5 SaveRangeOp		\ SaveFormattingRange

	se.scrap dup @ swap  GetHandleSize
	over + swap ?DO
		i c@  ascii A ascii Z range
		IF	32 or i c!
		ELSE drop
		THEN
	LOOP
	se.paste
	R> -> se.scrap
;


\ ***** JUMP/MARK ***********************************************


: SetJumpMark ( index -- )
	save.marks @ IF true mark.change  THEN
	selend @ 
	EndianSwap32
	swap 4 * +MiscInfo + ! ;


: (GoJumpMark) ( offset -- )
	selend @  LastJumpedFrom !
	0 max   se.handle GetHandleSize min
	dup selstart ! dup selend !	to.center
;

: GoJumpMark ( index -- )
	hide.range
	4 * +MiscInfo + @ 
\	4 * MiscInfo + @ 
	EndianSwap32
	(goJumpMark) ;


: JumpEnd ( -- | jump to end of the file )
	selend @  LastJumpedFrom !
	#lines @ 
	WillShowBlankPage
	IF
			NumPriorLines -							\ #lines to show of last real page
	ELSE
			#vislines @   -   
	THEN
	0 max scroll.to
	se.handle  GetHandleSize dup selstart ! dup selend !
\	show.selend
;


: JumpHalfway ( -- | jump to middle of the file )
	se.file.size @ 2/ (goJumpMark)  ;


\ JumpMiddle added per Roelf Toxopeus
: to.pos ( offset line# -- 'offset )  ( learned form GET.MAX.X in EDITOR file )
	dup
	IF
		0 DO
			dup se.file.size @ >=
			IF leave THEN
			get.line.length drop
		LOOP
	THEN ;


: top.pos ( -- offset-1st-char )   
	top.line @ ;


: halfway.pos ( -- offset-start-middle-line )
	top.pos #VISLINES @ 2/ to.pos ;


: mid.pos ( -- offset-middle-char )
	halfway.pos dup get.line.length nip 2/ + ;


: bottom.pos ( -- offset-last-char ) 
	top.pos #VISLINES @ to.pos ;


: JumpMiddle ( -- | jump to middle of the current page )
	mid.pos (goJumpMark) ;



: SE.JUMPMARK ( -- )
	?shiftKey  events @ 
	get.textsize
	get.textfont
	locals| wasFont wasSize oldEvents shft |
	1 key.down lshift events !      \ disable all but key downs

	make.box 
	outfile on
	4   TextFont			\ use Monaco
	12  _TextSize
	se.rect @point  2dup
	6 21 +point  MoveTo   
	shft
	IF
		s" 0-9, other cxls"
		s" Set Jump Mark:"
	ELSE
		s" 0-9, E, B, L, H, M"
		s" Go to Jump Mark:"
	THEN
	DrawText
	2swap 6 42 +point  MoveTo
	DrawText

	wasFont  TextFont
	wasSize  _TextSize

	BEGIN 
		 do.events drop
		 ?keystroke
	UNTIL
	oldEvents events !
	dup
	CASE
		ascii 0 ascii 9 RANGE.OF	ascii 0 -  shft
									IF setJumpMark	ELSE goJumpMark	THEN
									0	\ something to leave for drop
						ENDOF

	\ jump to END of file
		ascii e OF JumpEnd			ENDOF
		ascii E OF JumpEnd 			ENDOF

	\ jump to BEGINNING of file,  Optional, use cmd-B(eginning) or cmd-S(tart)?
		ascii b OF 0 (goJumpMark)	ENDOF
		ascii B OF 0 (goJumpMark)	ENDOF

	\ jump to last spot of file,  Optional, use cmd-L(ast)
		ascii l OF LastJumpedFrom @ (goJumpMark)	ENDOF
		ascii L OF LastJumpedFrom @ (goJumpMark)	ENDOF


	\ jump to middle of current page,  use cmd-M(iddle)
		ascii m OF JumpMiddle	ENDOF
		ascii M OF JumpMiddle	ENDOF

	\ jump to Halfway point of current file,  use cmd-H(alf)
		ascii h OF JumpHalfway	ENDOF
		ascii H OF JumpHalfway	ENDOF

		beep
	ENDCASE
	drop ;



\ ****** EDIT MENU ACTIONS **************************************************


: GOTO.LINE/PAGE# ( flag -- )
							\ changed primary function to LINE# per Doug Hoffman
	events @  get.textsize  infile @  mfCONSOLE @ +conTypeToken @
	locals| wasTypeToken wasInfile wasTextSize wasEvents theFlag |
	8 events !              \ disable all but key downs
	
	make.box 
	outfile on
	12  _TextSize  
	se.window infile !
	se.rect @point  2dup
	4 21 +point  MoveTo   
	theFlag
	IF							\ go to page# if flag is true
		C" Cursor on page " count DrawText
		selstart @  ~find.line#  lines/page @ / 1+  (.+R)
		4 42 +point  MoveTo   C" Go To Page > " count DrawText
	ELSE
		C" Cursor on line " count DrawText
		selstart @  ~find.line#  1+  (.+R)		\ !!!
		4 42 +point  MoveTo   C" Go To Line > " count DrawText
	THEN
	se.window ?FlushWindow
	beep   6 ask.number
	IF  wasTextSize  _TextSize
		theFlag
		IF
			1-  lines/page @ *
	    THEN
		1-	0 max #lines @ min		\ !!!
	\ use the next line instead of the following 3 if you want line# centered
	\	SE.DataRange (get.line.offset)  (GoJumpMark)
	    scroll.to					\ bring selected line to the top
		selend @  LastJumpedFrom !
	    top.line @  dup selend !   selstart !
	ELSE
		 wasTextSize  _TextSize
		 beep
	THEN
	DrawInfo
	wasInfile infile !
	outfile off 
	wasEvents events ! ;



: PASTE.CR's ( n -- | used to fill to the end of current page)
	se.scrap  DisposeHandle	0  NewHandle to se.scrap
	se.scrap over se.resize.handle
	se.scrap  HLock
	se.scrap @ 2dup c!		\ save length
	swap SE.EOLChar @ fill		\ fill with cr's
	se.scrap  HUnlock
	se.paste ;


: PADPAGE ( -- | fill rest of current page with cr's )
	hide.range
	selend @ dup selstart !
	selstart @	~find.line#
	lines/page @ /mod drop
	lines/page @ swap -
	paste.cr's ;


: SELALL ( -- | select entire file )
	hide.range
	0  selstart !
	se.file.size @  selend !
	show.range ;


: CHECK.AUTOSCROLL ( -- )
	21 auto.hscroll c@ boolean EditMenu# item.check ;


: TOGGLE.AUTOSCROLL ( -- )
	auto.hscroll -1 toggle
	check.autoscroll ;


: CHECK.AUTOINDENT
	22 auto.indent c@ boolean EditMenu# item.check ;


: TOGGLE.AUTOINDENT ( -- )
	auto.indent -1 toggle
	check.autoindent ;


: CHECK.RESTORE.POSITIONS ( -- )
	24 restore.positions c@ boolean EditMenu# item.check ;


: TOGGLE.RESTORE.POSITIONS ( -- )
	restore.positions -1 toggle
	check.restore.positions
;


: SE.EDIT.MENU.ITEMS ( -- )		\ added to minimal edit menu
	C" -(;Select All/A;Page Break;Go to Line#;Go to Page#" 			EditMenu# append.items	\ 7..11
	C" Jump To Mark/J"												EditMenu# append.items
	C" -(;Upper Case/U;Lower Case/L;Indent/];Outdent/[;Re-Margin/M"	EditMenu# append.items
	C" -(;R\L Auto Scroll;Auto-Indent"								EditMenu# append.items 
	C" -(;Remember Window Positions"								EditMenu# append.items
	11 0 0 EditMenu# MakeMenuItemDynamic			\ no modifier - go to line#
	12 0 2 EditMenu# MakeMenuItemDynamic 			\ option key  - go to page#
;


defer InDentRange	' beep is InDentRange
defer OutDentRange  ' beep is OutDentRange

defer MoreEditMenuActions ( n -- n )		' noop is MoreEditMenuActions

: SE.DO.EDIT.MENU  ( n -- )
	0  HiliteMenu
	CASE
		 1 OF se.undo		ENDOF
		 2 OF se.redo		ENDOF
		 \ 3 is separator
		 4 OF se.cut		ENDOF
		 5 OF se.copy		ENDOF
		 6 OF se.paste		ENDOF
		 7 OF se.clear		ENDOF
		 \ 8 is separator
		 9 OF SelAll		ENDOF
		10 OF PadPage		ENDOF
		11 OF false goto.line/page#	ENDOF	\ separate numbered items for option
		12 OF true  goto.line/page#	ENDOF
		13 OF se.jumpmark	ENDOF
		 \ 14 is separator
		15 OF se.upper		ENDOF
		16 OF se.lower		ENDOF
		
		17 OF InDentRange   ENDOF
		18 OF OutDentRange  ENDOF
		
		19 OF se.margin		ENDOF
		 \ 20 is separator
		21 OF toggle.autoscroll	ENDOF
		22 OF toggle.autoindent	ENDOF
		 \ 23 is separator
		24 OF toggle.restore.positions ENDOF
		MoreEditMenuActions				\ allow tools to extend menu
	ENDCASE
;


: SE.EDIT.MENU ( -- )
	check.autoscroll
	check.autoindent
	check.restore.positions
	EditMenu# menu.selection: se.do.edit.menu ;



\ **********  **************************************************

: ((SE.CLOSE))
	se.handle   handle? IF  DisposeHandle se.buffer off THEN
	borderRgn @ handle? IF  DisposeRgn    borderRgn off THEN
	
	reset.undo
	\ SE.UndoListH @ handle? IF DisposeUndoListH THEN
	\ SE.UndoListH  OFF

\	se.window 4 - @		\	?reserved
	se.window SE.RESERVED?
	IF	\ protect special tokens of reserved se.windows
		se.buffer se.lasttop over - erase
		se.rect   se.type.buffer 4 + over - erase
	ELSE
		se.buffer se.tail.size erase
		+CR MySE.CR !			\ restore this default
	THEN ;




CREATE OPENING 0 ,

\ OSX Opening a file that has been minimized in the dock generates
\ an Activate before the prior wiindow is deactivated
\ So we must handle that correctly

0 value LastActivatedSE



: (EXIT.SE) ( wptr4 -- )
	se.window >R
	get.window >R
	dup ?active.wptr
	IF
		->se.window
		se.window window
\		dflt.con mfCONSOLE !
\ !!		reset.undo
		SE.DONE.INTERPRETING
\		(flush.type.buffer)
		hide.range
		get.cursor IBeam =  IF init.cursor  THEN
		minimal.edit.menu
		put.se.scrap
\		clear.se.tib
        false se.menu.items

        MySE.EXIT @execute     \ ( -- ) optional user settable token

        se.window ?wvisible false=
        IF 
        	switched.out? @  false=
        	IF
        		((se.close))
            	se.window close.window
            THEN
		THEN
	ELSE
		drop
	THEN
	R> window
	R> ->se.window
;


: EXIT.SE ( -- )
	SEExitHook
	get.window 
	dup LastActivatedSE =
	IF						\ only do this for the previously activated SEWindow
		StopGhosting
		StopLeaping
		dup (EXIT.SE)
		-1 to LastActivatedSE
		dup  ?wvisible   false=
		switched.out? @  false=  AND
		IF
			drop front.window
		THEN
		dup ?wptr
		IF
			(window)
		ELSE
			drop
		THEN
	ELSE
		drop
	THEN
;


: ENTER.SE ( -- )
	LastActivatedSE VALID.SE?
	IF 
		LastActivatedSE (EXIT.SE)
	THEN

	get.window dup  ->SE.Window
			   dup	-> LastActivatedSE
			   infile !					\ 10.45
	clear.se.tib			\ ??????? needed
\	state off
	-1 -> arrowColumn
	-1 -> TheIB
	InitGraf
	patCopy  _PenMode
	init.se.font
	se.type.buffer off
	false se.busy
\ !!	reset.undo
	resize.se

	0  to double.click?
	0  to triple.click?
	-1 to last.down
	-1 to last.place
	StopLeaping

\	1 key.down scale events !
\	BEGIN do.events 0= UNTIL	\ purge pending keystrokes  on OPEN
	events on
	show.range

	opening @ IF selend @ to.center opening off THEN  \ ??? not needed ???
											\ unless MIFO saves last position
	se.edit.menu 
	true se.menu.items
	get.se.scrap
	outfile off
	dflt.con mfCONSOLE !
	se.realfile w@ IF (re-open) FileClose  THEN			\ TESTING
	MySE.ENTER @execute 	\ ( -- ) optional user settable token
	console.stream			\	se.quit
;


: ?CloseSearch ( -- )
	search.dlog ?active.wptr
	IF
		search.dlog ?wvisible
		IF
			search.dlog  @  HideWindow	\ false ShowHide	\ 
			search.dlog +dlogref# @ 
			?DUP IF
				 DisposeDialog 
			THEN
			search.dlog +dlogref# off
			search.dlog off
		THEN
	THEN
;

: (SE.CLOSE) ( -- | rude -- does not ask to save )
	?CloseSearch
	(re-open) ?dup	IF FileClose THEN

	se.window   hide.window					\ close.window
	false se.menu.items						\ ????
	EXIT.SE
 ;


: SE.SUSPEND  ( -- ) 
	se.window ?active.wptr
	IF
		(flush.type.buffer)
		hide.range
		put.se.scrap
		clear.se.tib        
	THEN ;


: SE.RESUME  ( -- )
	se.window ?active.wptr
	IF	show.range
		event.record 5 + c@ 2 and  \ bit 1 of event.message = convertClipboard
		IF get.se.scrap THEN
	THEN ;
	

: SE.EARLYMOVE ( -- )
	mouse.moved >event @execute ;	\ usually a null event


: SE.QUERY.EVENT ( --- event code\flag )		\ was @QUERY.EVENT
	pause
	events @ dup >R
	$FFFF:FFBF and   ( exclude update events)
	events !
	GetNextEvent			\ first part of DO.EVENTS
	R> events !
	dup mouse.moved = IF se.earlymove THEN
	dup
	?quit.blink @ or  ;		\ ?quit.blink allows early exit 


variable SE.EVENT.FLAG se.event.flag off

: WAIT.IB ( --- event code )
\ this lowers the frequency of DO.EVENTS called for null events
\ when in an editor window
	0 locals| THE.EVENT |
	set.ChangeTime
	BEGIN 
		adjust.secursor 				\ check.bars
    	se.query.event dup se.event.flag !
    	swap to the.event
	  	TickCount ChangeTime @ > or  
	UNTIL
	the.event ; 


: BLINK.IB ( ---- event code )	\ LOOK
\	SEcursor get
	se.event.flag @ IF check.bars se.event.flag off THEN
	draw.ib						\ invert IB
	wait.ib						\ stall for ChangeTime or non-0 event
	draw.ib						\ invert IB
	dup false=					\ stall again if event was 0
	IF drop wait.ib THEN
\	SEcursor release
; 


\ ********** MAIN EVENT LOOP **************************************************


: @SE.EVENT ( --- event code)
	GetNextEvent 
	dup false=
	switched.out?			@ false=  AND
	key.stroke				@ false=  AND
	se.window active.window @ =	   AND
	se.window get.window      =	   AND
	IF drop blink.ib THEN 
;


: DO.SE.EVENTS ( --- event code )
	@se.event 
	>events 
;


: DO.MOUSEWHEEL ( -- )
	event.record 14 + w@		\ get Control Part
	CASE
		20 OF -1  1 				ENDOF	\ scroll up
		21 OF  1 -1 				ENDOF	\ scroll down
		22 OF -1 #vislines @ 		ENDOF	\ page up
		23 OF  1 #vislines @ negate ENDOF	\ page down
	ENDCASE

	event.record 10 + @			\ get Control Ref
	se.window +VBAR @ =			\ if not VBAR, then must be HBAR
	IF nip 0 swap ELSE drop se.charwidth * 0 THEN

	do.se.scroll 2drop
	UpdateAfterScroll				\ for recolorizing
;



: SE.ACTION	 ( -- | main Editor event handling )	\ LOOK
	?stack
	do.se.events ?dup
	IF
		se.window ?activated.window
		IF
			CASE
				mouse.down		OF do.se.mouse		ENDOF
				in.size.box		OF resize.se 		ENDOF
				in.zoom.in		OF resize.se 		ENDOF
				in.zoom.out		OF resize.se 		ENDOF
				31 				OF do.mousewheel	ENDOF
			ENDCASE
		ELSE
			drop		\ this rarely happens
		THEN
	THEN
	?keystroke IF do.se.key THEN
;


: SE.ACTIVATE ( flag --- )  \ beep
(*		\ REMOVED 1/19/11 - purges the pseudo-CMD-V from PasteMaster
	events @
	1 key.down scale events !
	BEGIN do.events 0= UNTIL	\ purge pending keystrokes  on OPEN
	events !
*)
	IF
		enter.se 
	ELSE
		exit.se 
	THEN

;


: SE.PROGRAM ( flag -- | old-style ON.ACTIVATE )
	dup se.activate
	IF
		BEGIN
			get.window VALID.SE?
			IF
				get.window ->SE.Window
			THEN
			do.se.action 	\ handle events
		AGAIN
	THEN ;



\ **********  **************************************************


: ADJUST.SE.ZOOM ( -- )
	get.zoom.out ( -- t\l\b\r )	\ standard zoom state*
	drop
	2 pick						\ L
	PreferredSEZoomWidth +
	screen.bounds 6 + w@ 		\ right bounds of screen
	min
	set.zoom.out ;


: (ADD.SE.WINDOW) ( wptr -- )
	\  dup VALID.SE? false= abort" Not an SEWindow"	\ external program should
	\  dup active.wptr? IF drop exit THEN			\ do this little "pre-check"
	->SE.Window
	WHEN.SE.ADDED execute					\ Optional user-settable token
	se.window add.window
	se.window (window)

	adjust.se.zoom
	init.se.font
	SE.BackColor  RGBBackColor
	SE.ForeColor  RGBForeColor
	NewRgn borderRgn !
	resize.se
	-1 se.lastTop !
	SE.UndoListH  OFF
	SE.CurrentUndoListOffset OFF
	SE.oldtopline ON			\ force color update from top
	init.MiscInfo
;


: ADD.SE.WINDOW ( -- )
	first.free.window dup 0= abort" No available window"
	(add.se.window)
 ;


: SETUP.BARS ( -- )
	0 se.handle dup  GetHandleSize swap @ (count.lines)+  #lines !
\	0 se.handle    GetHandleSize count.lines #lines !
	0 (!se.vbar) se.vbar 0 0 SET.CONTROL.32bitRANGE
	0 !se.hbar 	 se.hbar 0 0 SET.CONTROL.32bitRANGE	;


: SetupSEWindow		\ home ( -- | initial setup for newly opened SE.Window )
	se.window force.window
	TextBounds  ClipRect
	erase.se
	borderRgn @  SetClip
	erase.se
	Get.SEBounds InvalRect
	TextBounds   ClipRect
	setup.bars
	selend off  selstart off  top.line off 
	0 -> anchor ;


: ADD.SE ( wptr -- )
	\ SE.WINDOW set to WPTR , WINDOW unchanged unless old SE.WINDOW was WINDOW
	get.window
	dup se.window =
	locals| WasSE? OLDWIND |	
	(add.se.window)
	se.handle   handle? IF  DisposeHandle THEN
	0  NewHandle se.buffer !
	se.file.size off
	SetupSEWindow
	
	false se.menu.items
	se.changed on			\ make sure MARK.CHANGE does something
	false mark.change

	wasSE? false=
	IF
		oldwind  ?wptr
		IF
			oldwind (window)
		THEN
	THEN ;


: SE.NEW ( -- )			\ opens it, and makes it SE.WINDOW
	first.free.window 	dup 0= abort" No available window"
	C" untitled.fth"	over w.title
	dup >R add.se
	
	r> @
	creator @ FILETYPE @
	$FFFF8000	( kOnSystemDisk )
	SetWindowProxyCreatorAndType drop

	default.EOLMODE
	dup SE.orginalEOLMODE !
	dup	SE.EOLMode !
	LF=EOL =
	IF
		10
	ELSE
		13 
	THEN
	SE.EOLChar !	\ -> EOLChar
;


: ?OPEN.ERROR ( -- )
	io-result @
	IF	
		se.window ?dup
		IF
			se.handle    DisposeHandle se.buffer off
			Hide.Window
			se.window next.active.window ->SE.Window
			Front.Window ?dup false= IF sys.window THEN
			(window)
		THEN
		false se.menu.items
		?file.error
	THEN  ;


: LOAD.FILE ( file# -- )
	locals| FILE# |
	se.handle   ?dup IF  DisposeHandle THEN
	file# filesize?  
	se.Makehandle se.buffer !
	se.handle    HLock	
	file# rewind
	se.handle    GetHandleSize se.file.size !
	SE.DataStart  se.file.size @ file# FileREAD
	drop
	se.handle    HUnlock
	?open.error

	SE.DataRange CountLF/CRs ( addr/cnt -- #CRS/#LFS )
	2dup =
	IF
		+ 0=
		IF
			default.EOLMODE
		ELSE
			CRLF=EOL
		THEN
	ELSE
		>
		IF	  CR=EOL
		ELSE  LF=EOL
		THEN
	THEN
	dup SE.orginalEOLMODE !
	dup	SE.EOLMode !
	CR=EOL =
	IF
		13
	ELSE
		10
	THEN
	SE.EOLChar !	\ -> EOLChar
;

: RESTORE.SELECTION ( -- )
	se.restorer @						\ check flag
	IF	 +miscinfo +SavedSelStart @ 
			endianswap32
			selstart !					\ restore selection range
		 +miscinfo +SavedSelEnd @  
			endianswap32
			selend !
		 0 -> anchor
	ELSE
		+miscinfo +SavedSelEnd @
			endianswap32
			LastJumpedFrom !			\ set LastJumpedFrom
	THEN ;


: (SE.OPEN) ( file# -- )
	load.file
	-1 se.realfile w!
	se.changed on						\ make sure MARK.CHANGE does something
	false mark.change
	reset.undo
	
	after.se.loaded execute				\ Optional user-settable token
	SetupSEWindow ;


: SE.OPEN$ ( str$\volref#\DirID -- | attempt to open editor with file STR$ )
   0 
\   locals| theRef# TheDir TheVol TheName |
   { TheName TheVol TheDir theRef#  | localname[ 256 ]  }
   \ keep a private copy of str$ (source could be reused by after.se.open$ )
   TheName count localname[ place
   
   
   TheVol volref# !    TheDir ioDir !

	localname[  (se.open$) to theRef#
	io-result @ >R			\ move this BEFORE  AFTER.SE.OPEN$ executes

	theRef#   after.se.open$ ?dup IF execute ELSE drop THEN
	R>
	IF
		?file.error
	ELSE
		true se.busy
		\ data fork of file is open at this point
		
		add.se.window
		
		TheDir se.ioDir !   
		TheVol se.volref#  w!
		WasFileLocked?  se.locked w!
		0 -> WasFileLocked?
		localname[ se.window set.wtitle
		theRef#  (se.open)
		ModifyBackgroundColor?

		theRef# load.MiscInfo
		
		restore.positions c@
		IF RestoreSize&Position THEN

		restore.selection
		show.range
		show.selend
		
		se.window BRING.TO.FRONT

((		se.window CheckForSameName
		IF	\ colorize duplicated windows - thanks Ferren !
			SE.DuplicateColor   RGBBackColor
		THEN
))
		se.event.flag ON			\ to trigger initial CHECK.BARS
		OPENING ON
		
		theRef# SetProxyIcon
		
		theRef# FileClose
	THEN
	false se.busy ;


: DO.SE.OPEN ( -- )
	NavReplyName NavReplyVolume NavReplyDir se.open$ ;


: SE.FILETYPE?  ( fileType -- flag )
	locals| TheFileType |
	#filetypes		\ allow open any if this = 0
	IF
		false 
		#filetypes 0 
		?DO
			se.filetypelist i 4 * + @ TheFileType = OR
		LOOP
	ELSE
		true
	THEN
;


: ALREADY.OPEN? \ ( file# -- wptr or 0 | non-0 if the file is unmodified in a SEWindow)
	{ THE.FILE | old.sewptr THE.WPTR  namebuf[ 256 ] }
    se.window
    DUP -> old.sewptr -> THE.WPTR
	namebuf[ the.file GetFileName

    the.wptr valid.se? 0=
    the.wptr ?wvisible 0=
    OR
    IF
    	se.window1 -> se.window
        se.window1 -> the.wptr
    THEN

	BEGIN
		se.window
	WHILE
		se.realfile w@
		se.window ?wvisible AND
		se.changed @ false=    AND
		IF
			namebuf[ 100 + SE.Window Get.WTitle
			namebuf[  namebuf[ 100 + -string false=
			IF									\ we have a match
				se.window						\ return the window
				old.sewptr ->SE.Window        	\ restore original SE.WINDOW
				\ swap
				exit
			THEN
		THEN

        se.window next.se.window ->SE.Window
        se.window the.wptr =            	\ did we go all the way around ??
		IF 
			 old.sewptr ->SE.Window     	\ restore original SE.WINDOW
			 false
			 exit 
		THEN
	 REPEAT
    old.sewptr ->SE.Window        \ restore original SE.WINDOW
    false ;


: OpenEditorFromFSSpec  ( FSSpec -- sewptr |or| 0 )
	{ FSSpec | thefile  -- }
	FSSpec +FSSvRefNum w@s volref# !
	FSSpec +FSSparID @     iodir !
	FSSpec +FSSname
	(SE.OPEN$)
	dup -> thefile
	0= IF 0 exit THEN

	thefile already.open?
	?dup
	thefile fileclose
	IF
		dup  se.window =		\ is it the current window?
		over front.window =
		and 0=
		IF
			dup -> se.window
			force.window
		THEN
	ELSE
		FSSpec +FSSname 
		FSSpec +FSSvRefNum w@s
		FSSpec +FSSparID @
		se.open$
	THEN
	se.window
;


: SE.OPEN.FROM.PATH ( path$\len -- sewptr |or| 0 )
	Path->FSSpec dup
						\ ?dup 0= abort" Path->FSSpec failed"
	IF
		OpenEditorFromFSSpec
	THEN
;



\ ********** SEARCH **************************************************

: FOUND.IT ( -- )
	get.window >r
	se.window ( dup outfile ! ) window
	show.range
	selstart @ to.center
	selend @ rlscroll
	r> (window) ;


0 value wasSelStart
0 value wasSelEnd


: DoneSearch ( -- )
	NewSearchMode @	
	IF		\ return last location
		wasSelStart  selstart !
		wasSelEnd    selend	 !
	ELSE
		selstart off 
		selend   off
	THEN	\ go to top
	0 -> anchor 
	found.it
;


defer FOUND? ( flag -- )		' drop is FOUND?


\ FOLDER SEARCH STUFF

490 value FileMsgDlgID

0		value DirListHdl
0		value #TEXTFILES
0		value CURFILE#
0		value numSearched
0		value OriginalFile#
\ 0 value FileMsgDlgHdl
0		value FileMsgDlgRef
false	value FolderFlag
false	value ProjectFlag
true	value UncaseFlag
false	value WholeWordFlag
0		value SEARCH.WINDOW

create TEMP.NAME     32 allot&erase
create TEMP.STRING  256 allot&erase


structure FILEINFO.SIZE
	     long: +creation.date
	     long: +dirIndex
	     long: +FIdirID
	    short: +FIvRef#
	63 string: +filename
\	31 string: +filename
structure.end

create TEMP.INFO  fileinfo.size allot


100 constant PBLEN
create PB   pblen allot

variable search.volref#
variable search.iodir


: STANDARD.NUM.FILES  ( -- number files in current file's directory )
	search.volref# @ search.iodir @ se.pad -1 

	SYNC
	get.cat.info	\ handle (unlocked)
	?file.error
	dup @ 52 + w@		\ ioDrNmFls
	swap  DisposeHandle ;


: !FILENAME  ( -- )
	pb 18 + @
	temp.info +filename
	over c@ 1+ 32 min cmove ;


: !CREATION.DATE  ( -- )
	pb 72 + @  temp.info +creation.date ! ;


: !VOL&DIR  ( -- )
	pb 22 + w@s   temp.info +FIvRef# 	w!	\ ioVRefNum
	pb 48 +   @   temp.info +FIdirID	!	\ ioDirID
;


: !DIRINDEX  ( -- )
	pb 28 + w@
	temp.info +dirIndex ! ;


: GetDirInfo ( filename$\volref#\iodir\fileIndex -- )
\ given an index and a directory, returns name and finder info
\ given a name and directory, returns finder info
	pb pblen erase
	pb 28 + w!					\ file index
	dup >R  pb 48 + !			\ ioDirID - On input, a directory ID; on output, a file ID
	pb 22 + w!					\ ioVRefNum
	pb 18 + !					\ ioNamePtr
	pb  PBHGetFInfoSync
	R>  pb 48 + !				\ restore this for use by !VOL&DIR
	IF pb pblen erase THEN ;    \ sub-directories produce errors


variable fileflags  fileflags off

: GetDirEntry  ( fileIndex# -- )
	>R
	se.pad 			\ ioNamePtr
	search.volref# @
	search.iodir   @
	3dup
	R> GetDirInfo 		\ we need this one to do the indexing

	rot GetInfoForRef	\ and this one to check flags
	2drop
	fileflags !
;


: !TextFileInfo ( -- )
	!dirIndex  !creation.date  !filename
	!vol&dir
	1 +to #textfiles
	DirListHdl dup  GetHandleSize  0 0
	    temp.info fileinfo.size  se.munger ;


defer NUM.FILES		' standard.num.files is num.files

: Standard.Load.DirList  ( -- | fill dirList for current WDirectory )
	0 -> #textfiles
	num.files 1+  1
	  ?DO
	  	temp.info  fileinfo.size erase
  		i getDirEntry
        pb 32 + @ se.fileType?		\ #filetypes = 0 will allow all files

		fileflags @ 1 and		\ kLSItemInfoIsPlainFile - not dir, vol, alias
		AND
		fileflags @ $40 and		\ kLSItemInfoIsInvisible
		0= AND
        pb 18 + @	0<>				\ be sure we have a filename
        AND
        pb 30 + c@ 16 AND 0=		\ NOT a directory
        AND
        IF !textFileInfo THEN
	  LOOP
;


: AddPathToDirList ( ^szPathName -- )
	temp.info  fileinfo.size erase
	zcount expand
	MakeCFURLfromPath dup >R  CFUrl->ZString zcount	\ 10.44 
	R> cfrelease
	Path->FSSpec ?dup
	IF
		dup +FSSparID @     temp.info +FIdirID !
		dup +FSSvRefNum w@s temp.info +FIvRef# w!
		    +FSSname count  temp.info +filename place		
		1 +to #textfiles
		DirListHdl dup  GetHandleSize  0 0
	    	temp.info fileinfo.size  se.munger
	THEN
;


also system
: AddOneFromSourceToDirList ( thread# nfa -- flag )
	nip
	name> >body sfstruct.szPathName
	AddPathToDirList
	true
;
previous


: Project.LoadDirList ( -- )
	0 -> #textfiles
	['] AddOneFromSourceToDirList 
		['] sourcefiles voc>wid
			WalkWordList
;


defer Load.DirList		' standard.Load.DirList is Load.DirList


: Save.OriginalFile# ( -- | get index # of original file )
	{ | scratch$[ 256 ] }
    scratch$[ SE.Window Get.WTitle
	se.changed @
	IF
	    scratch$[ StripMarker
	THEN
	-1 -> originalFile#

	#textfiles 0 ?DO
	    scratch$[ DirListHdl @ i fileinfo.size * + 
	    dup >R +filename -string false=
	    IF	\ also check folder and dir
	    	se.volref# w@s r@ +FIvRef#  w@s =
	    	se.iodir   @   r> +FIdirID    @ =
	    	and
	    	IF
	    		i -> originalFile# leave
	    	THEN
	    ELSE
	    	R> drop
	    THEN
	LOOP

	originalFile# 0<	\ wasn't in the list, so we add it
	IF
		0 -> originalFile#
		scratch$[
		se.volref# w@s 
		se.iodir     @ 
		0
		GetDirInfo ( filename$\volref#\iodir\fileIndex -- )
	    pb 32 + @ se.fileType? 
	    IF   !textFileInfo 
	    	 #textfiles 1-  -> originalFile#  
	    THEN
	THEN
 ;


: SET.FOLDER.CONTROL ( -- )
	search.dlog 8 se.pad GetDialogItemAsControl4 drop
	se.pad @
	folderFlag IF 1 ELSE 0 THEN   SetControlValue ;


: SET.PROJECT.CONTROL ( -- )
	search.dlog 15 se.pad GetDialogItemAsControl4 drop
	se.pad @
	ProjectFlag IF 1 ELSE 0 THEN   SetControlValue ;



: QuitFolderSearch ( -- )
	DirListHdl ?dup
	  IF   DisposeHandle
	      0 -> DirListHdl
	  THEN
	0 -> numSearched
	0 -> curfile#
	0 -> search.window
	0 -> #textfiles
	false -> folderFlag
	false -> ProjectFlag
	get.window search.dlog =
	IF
		set.folder.control
		set.project.control
	THEN
;

: InitFolderSearch ( -- )
	0 -> #textfiles
	se.realfile w@
	IF  true se.busy
		se.volref# w@s search.volref# !
		se.iodir     @ search.iodir !
	    0  NewHandle -> DirListHdl

	    load.dirList
	    #textfiles 2 <
	        IF quitFolderSearch beep exit
	        THEN
	    \ sort.dirList

		se.window to search.window
	    save.originalFile#
	    originalFile# -> curfile#
	    0 -> numSearched
\	    true -> folderFlag			\ 10.44
	    false se.busy
	ELSE
	    beep
	    QuitFolderSearch
	THEN ;




: FolderHit ( -- )
	folderFlag
	IF
		 quitFolderSearch
	ELSE
		 false -> ProjectFlag
		 set.project.control
		 ['] standard.Load.DirList is Load.DirList
		 true  -> folderFlag
		 set.folder.control
		 initFolderSearch
	THEN
;

: ProjectHit ( -- )
	ProjectFlag
	IF
		 quitFolderSearch
	ELSE
		 false -> folderFlag
		 set.folder.control
		 ['] Project.LoadDirList is Load.DirList
		 true  -> ProjectFlag
		 set.project.control
		 initFolderSearch
	THEN
;


0 value d5	\ 12/30/05 dbh  
0 value fs  \ a place to keep SE.DataStart	\ 12/30/05 dbh  

	\ 12/30/05 dbh  
: BackMatch ( textAddr\textLen\patternAddr\patternLen\notCaseSens? ... )
			( ... -- [false] or [hitaddr\true])
	0 0 0 locals| char1 char2 nohitflag ucflag Scnt Saddr Dcnt Daddr |
	Saddr Scnt + 1- -> Saddr  \ make Saddr point to last byte of $addr
	Daddr Dcnt + 1- -> Daddr  \ make Daddr point to last byte of text
	Daddr Scnt >=	\ don't do back search if srch$ > text !
	IF	SE.DataStart -> fs
		Daddr Scnt - 1+ 0
		DO false -> nohitflag
			0 -> d5
			BEGIN
				Daddr d5 - c@ -> char1
				ucflag IF char1 97 >=
							IF char1 122 <=
							  IF -32 +to char1 THEN \ assure upper case
							THEN
					   THEN
				Saddr d5 - c@ -> char2
				char1 char2 <>
				IF  true -> nohitflag THEN
			1 +to d5		Scnt d5 =
			UNTIL
			nohitflag 0= IF leave THEN  \ leave if you have a hit
			-1 +to Daddr  \ decrement target address
			Daddr fs < IF leave THEN
		LOOP
	THEN
	nohitflag 0= IF Daddr Scnt 1- - 0 max THEN
	nohitflag false= ;


: (FindMatch)  ( -- foundflag )		\ was ((RE-SEARCH))))
\ the guts of FIND 
	0 false  SE.DataRange
	locals| cnt text theFlag addr |
	text selend @ +  -> addr
	cnt  selend @ -  -> cnt
	cnt 0 >=		\ for search from end
	IF
		BackFind?
		IF	  text ( begin search addr)  selstart @ 1- ( cnt)
					   temp.string count uncaseFlag BackMatch
		ELSE  addr cnt temp.string count uncaseFlag search-text		\ pocket (search-text)
		THEN
	    IF  text - search$ c@ over selstart ! + selend !
	        true -> theFlag
	    THEN
	THEN
	theFlag
;


defer FindMatch			\ was (RE-SEARCH))))
	 ' (FindMatch) is FindMatch


: ?ValidDelimiter  ( char -- flag )
	8 /mod 
	locals| qq rr |
	delimiter.set qq + c@ 1 7 rr - lshift and 0<> ;


: ?DELIMITED  ( -- flag )
	selstart @ 0>
	    IF   SE.DataStart  selstart @ + 1-  c@ ?validDelimiter
	    ELSE true
	    THEN
	selend @  se.handle    GetHandleSize <
	    IF   SE.DataStart  selend @ + c@ ?validDelimiter
	    ELSE true
	    THEN
	and ;


: (RE-SEARCH)))  ( -- foundflag )
	0 locals| result |
	wholeWordFlag
	IF
		BEGIN
			FindMatch dup -> result
			IF   ?delimited
			ELSE true
			THEN
		UNTIL
		result
	ELSE
		FindMatch
	THEN
;


defer FileMsgExtras ( FileMsgDlgRef -- FileMsgDlgRef )
			' noop is FileMsgExtras


: ShowFileMsg ( -- )	\ show file name in folder searches
	FileMsgDlgRef ?dup false=
	    IF   FileMsgDlgID
	         begin.dialog
	            dup -> FileMsgDlgRef
	    THEN
	FileMsgExtras					\ hook for customization
	temp.name 0 0 0  ParamText
	DrawDialog
;


: DisposeFileMsg ( -- )
	FileMsgDlgRef ?dup
	IF	end.dialog
		0 -> FileMsgDlgRef
		discard.activates
	THEN
;


: LoadNextFile ( -- )	\ use saved dirID & vref# if available
	temp.info  +FIdirID  @  dup se.ioDir    !  iodir !
	temp.info  +FIvRef# w@s dup se.volref# w!  volref# !
	\ changing se.ioDir & se.volref# is ok here as we are in fact using this
	\ se.window to handle multiple files
	temp.info  +filename
	(se.open$) ( str$ -- ref# ) 
	dup >R
	?file.error
	WasFileLocked?  se.locked w!
	0 -> WasFileLocked?

	dup SetProxyIcon
	load.file

	se.locked w@ false=
	IF
		R@ load.MiscInfo
	THEN

	R> FileClose
	AFTER.SE.LOADED EXECUTE	;		\ Optional user-settable token


: Get.Cur.FileInfo ( -- )
	curfile# #textfiles >=
	    IF 0 -> curfile#  THEN
	DirListHdl ?dup
	IF
		@ curfile# fileinfo.size * +
			temp.info fileinfo.size cmove
	ELSE
		temp.info fileinfo.size erase
	THEN ;


: Next.FileInfo ( -- )
	1 +to curfile#
	1 +to numSearched
	Get.Cur.FileInfo
	curfile# originalFile# =
	IF quitFolderSearch THEN  ;


: NameForMsgDlg ( -- )
	temp.info +filename  temp.name over c@ 1+ 18 min cmove
	temp.name c@ 17 >
    IF  17 temp.name c!
        ascii . temp.name 2dup  16 + c!  17 + c!
    THEN ;


0 value FILECHANGE

: CLOSE.SE.FILE ( -- quitSearch? )
	get.window locals| old.se.window |
	se.window window
	ask.save continue? @
	IF	 filechange
	     IF   set.se.one.shots
	          temp.info +filename 
	       	  (se.open$) ( str$ -- ref# )
	     ELSE (re-open)
	     THEN
		 ?dup	IF FileClose THEN
	     false mark.change  false
	ELSE quitFolderSearch  true
	THEN
	old.se.window (window) ;


: ?KILL.FOLDER ( -- | turn off folder when switch windows )
	search.window se.window <>		\ if we are still in the same window
	IF 	disposefilemsg
		quitfoldersearch
	THEN  ;


: (RE-SEARCH)) ( -- foundflag )
	0 locals| theFlag |
	0 -> filechange
	search$ c@ 0= IF 0 exit THEN	\ empty string

	search$ temp.string over c@ 1+ cmove
	uncaseFlag
	IF temp.string count upper THEN

	BEGIN
	    (re-search))) -> theFlag

		event.record 10 @event		\ ? mouse.down or key.press
		IF quitFolderSearch THEN	\ %%%

	    theFlag     false=  
	    folderFlag  ProjectFlag OR
	    and
	WHILE			\ continue to next file if folder search and not found
	    close.se.file
	    IF
			false EXIT
		ELSE		\ 10.44
			search.dlog ?wvisible	\ 10.45
			IF
				search.dlog bring.to.front
			THEN
	    THEN
		next.fileInfo
	    nameForMsgDlg  showFileMsg
	    loadNextFile
		true -> filechange
	    0 selstart ! 0 selend !
	REPEAT
	disposeFileMsg

	filechange
    IF 
    	get.window >r
    	se.window window
        temp.info +filename  se.window set.wtitle
        TextBounds ClipRect erase.se
        TextBounds InvalRect
        TextBounds ClipRect

		ModifyBackgroundColor?
        -1 se.realfile w!
        false mark.change
		top.line off
        enter.se
        setup.bars
        check.bars
        r> (window)
    THEN
	theFlag
	true se.menu.items
;


: (RE-SEARCH) ( -- foundflag )
	selstart @ to wasSelstart
	selend   @ to wasSelend

	put.se.scrap
	get.se.scrap
	(re-search)) ;


: RE-SEARCH ( -- )
	?kill.folder
	get.window >r
	se.window window
	hide.range
	(re-search) found?
	show.range
	r>  (window) ;


: FROM.TOP ( -- )
	0 selstart ! 0 selend ! ;

: FROM.END ( -- )
	SE.DataRange nip
	dup selstart ! selend ! ;

: ?FROM.TOP ( -- )
	?shiftKey IF from.top THEN ;


: SearchNext ( -- )		\ very similar to EDIT.NEXT
	se.window next.active.window ?dup 0= abort" No next window!"
	dup Show.Window
	dup BRING.TO.FRONT
	dup select.window			\ ???
\	dup active.window !
		->SE.Window
	from.top
	re-search
;

: NOT.FOUND ( -- )
	NotFound# Hcenter.alert
	search$ c@
	IF   C" The string '" search$ C" ' was not found." ""
	ELSE C" Empty Search String " "" "" ""
	THEN

	NewSearchMode @ BackFind? and
	IF
		NotFound# 1+
	ELSE
		NotFound#
	THEN
	
	IssueWindowCenteredAlert
	CASE
		1 OF DoneSearch					ENDOF
		2 OF selend @  LastJumpedFrom !
			 BackFind?
			 IF from.end ELSE from.top THEN 	
			 re-search  				ENDOF
		3 OF SearchNext					ENDOF		\ next window
	ENDCASE
;


: (FOUND?) ( flag -- )
	IF   found.it 
	ELSE not.found 
	THEN 
;

' (FOUND?) is FOUND?


: START.SEARCH ( -- found flag )		\ was MAKE.SEARCH
\ 10.45 move the string extraction routine to SEARCH.HIT
\	search.dlog 4 se.pad se.pad 4 + se.pad 8 + GetDialogItem4
\	se.pad 4 + @ search$ GetDialogItemText
	(re-search)
	true se.menu.items
	event.record off ;		\ prevent re-processing of keystroke


: JUST.CHANGE ( -- )
\ 10.45 move the string extraction routine to SEARCH.HIT
\	search.dlog 5 se.pad se.pad 4 + se.pad 8 + GetDialogItem4
\	se.pad 4 + @ change$ GetDialogItemText
	get.window >r 
	se.window window
	change$ count se.insert 
	true mark.change
	r> (window)
;


: CHANGE.ONE ( -- found flag )
\ change current selection and find next occurence
\ even if next occurrence is in another file in folder search
	just.change
	start.search ;	\ find next


: CHANGE.ALL ( -- found flag )	\ ( -- found flag )
	true se.busy
	selend @ selstart !
	start.search 
	IF 1 ELSE 0 THEN
	locals| THE.COUNT |
	the.count
	IF
		BEGIN
			change.one dup 
			IF 1 +to the.count THEN
\	  		the.flag or to the.flag	
	  		false=
		UNTIL
	THEN
	selstart off selend off
	false se.busy
	the.count 
;


: Set.WholeWord.Control ( -- )
	search.dlog 9 se.pad GetDialogItemAsControl4 drop 
	se.pad @  wholeWordFlag IF 1 ELSE 0 THEN  SetControlValue ;


: WholeWordHit ( -- )
	wholeWordFlag -1 xor -> wholeWordFlag
	set.wholeWord.control ;


: SET.CASE.CONTROL ( -- )
	search.dlog 10 se.pad GetDialogItemAsControl4 drop
	se.pad @  uncaseFlag IF 0 ELSE 1 THEN  SetControlValue ;


: CaseFlgHit ( -- )
	uncaseFlag false= -> uncaseFlag
	set.case.control ;


: Show#Found ( count -- )
	?dup
	IF
		s>d <# #S #> se.pad place
		se.pad c"  items changed" "" ""
		OK# IssueWindowCenteredAlert drop
	ELSE
		 not.found 
	THEN
;


defer SearchHit8	' folderHit  is SearchHit8		\ Folder Search checkbox
defer SearchHit15	' ProjectHit is SearchHit15		\ Project Search checkbox


: CopySearchStrings ( -- )	\ 10.45
	\ if we paste a multi-line string, we need to be sure EOL is OK
	\ also move the string extraction here so they get copied more reliably
	search.dlog 4 se.pad se.pad 4 + se.pad 8 + GetDialogItem4
	se.pad 4 + @ search$ GetDialogItemText
	search$ count NormalizeEOLinRange

	search.dlog 5 se.pad se.pad 4 + se.pad 8 + GetDialogItem4
	se.pad 4 + @ change$ GetDialogItemText
	change$ count NormalizeEOLinRange
;


: SEARCH.HIT ( dlog ptr\item# -- )
	CopySearchStrings		\ 10.45
	swap search.dlog +dlogref#  @  =
	IF
		CASE
			1 OF 0 -> BackFind? start.search found?  	ENDOF		\ find next
			2 OF 0 -> BackFind? change.one	 found?  	ENDOF		\ change, then find
			3 OF 0 -> BackFind? change.all	 Show#Found	 ENDOF		\ change all

	       11 OF true -> BackFind? start.search found? 	ENDOF	\ Find Prior
	       12 OF from.top start.search found?  			ENDOF	\ Find From Top
	       13 OF just.change							ENDOF	\ Replace

	        8 OF SearchHit8          	ENDOF		\ Folder Search checkbox
	        9 OF wholeWordHit        	ENDOF		\ Whole Word checkbox
	       10 OF caseFlgHit          	ENDOF		\ Case Sensitive checkbox
	       14 OF beep					ENDOF		\ Wrap checkbox
	    	
	       15 OF SearchHit15         	ENDOF		\ Project Search
		ENDCASE
	ELSE drop
		 BEEP
	THEN ;


: END.SEARCH.DLOG ( -- )
	CopySearchStrings		\ 10.45
	?CloseSearch
	se.window active.window @ <>
	IF
		minimal.edit.menu
	THEN
	?put.tescrap
;


: DO.SEARCH.KEY ( char -- )
	CopySearchStrings
	CASE
		03 OF start.search found? ENDOF
		13 OF start.search found? ENDOF
		27 OF ?CloseSearch ( end.search.dlog )	 ENDOF	\ Escape
	ENDCASE ;


defer MoreSearchSetup ( -- )		' noop is MoreSearchSetup

: BEGIN.SEARCH.DLOG ( -- )
	search.dlog 4 0 32000  SelectDialogItemText4 
	set.folder.control
	set.project.control
	set.wholeWord.control
	set.case.control
	MoreSearchSetup									\ hook for customization
	3 true filemenu# item.enable
	true EnableEditMenuItems
	dlog.edit.menu
	ScrapImport
	\ disable wrap for now
	search.dlog 14 se.pad GetDialogItemAsControl4 drop
	se.pad @  DisableControl drop
	search.dlog GetWindowPortBounds InvalRect		\ force an update
;


: SEARCH.ACTION	( -- )	\ default DO.SEARCH.ACTION
	do.events
	search.dlog ?activated.window
	IF
		in.close.box =  IF ?CloseSearch  THEN
		?keystroke 		IF do.search.key THEN					
		dialog.event?	IF search.hit ELSE 2drop THEN
	ELSE
		drop
		se.event.loop
	THEN ;


: DO.SEARCH.DLOG ( flag --- | OLD ON.ACTIVATE )
	IF
		 begin.search.dlog
		 BEGIN 
		 	search.action
		 AGAIN
	ELSE
		end.search.dlog
	THEN ;


: SEARCH.ACTIVATE  ( flag --- )
	IF
		begin.search.dlog
	ELSE
		end.search.dlog
	THEN
;


: SEARCH.HILITE ( flag --- )
	drop ;


: UPD.SEARCH.DLOG ( -- )
	search.dlog DrawDialog4
	search.dlog +dlogref# @ 1 SetDialogDefaultItem drop
;

search.dlog 			 on.update	 UPD.SEARCH.DLOG
search.dlog 			 on.activate DO.SEARCH.DLOG

' do.search.action     search.dlog +Window.Action !
' do.search.activate   search.dlog +ON.NEWACTIVATE !
' do.search.hilite	   search.dlog +W.HILITE !


: MOVE.TO.BOTTOM ( DLOG handle -- )  \ :GG align to bottom of current window
	locals| THE.HNDL |
	the.hndl @ @rect se.rect !rect
	Get.Window GetWindowPortBounds
	4 + @								\ BR of window, in local coords
	 local>global point>XY				\ S: Rx\By in global coords
	  nip								\ only use By of window..
	Screen.Bounds 4 + w@s  min			\ ..but keep on screen
	3 - dup								\ new bottom of DLOG
	se.rect 4 + w@s  se.rect w@s  -		\ DLOG height
	- se.rect w!						\ top
	se.rect 4 + w!						\ bottom
	se.rect @rect  the.hndl @ !rect ;


: SE.SEARCH ( -- )
	?kill.folder
	hide.range
	SearchResId hcenter.dialog
	ascii DLOG SearchResId GetResource
	    dup false= abort" Unable to find Search Dialog"
	move.to.bottom

	put.se.scrap
	SearchResId search.dlog add.dialog
	search.dlog 4 se.pad se.pad 4 + se.pad 8 + GetDialogItem4
		se.pad 4 + @ search$ SetDialogItemText
	search.dlog 5 se.pad se.pad 4 + se.pad 8 + GetDialogItem4
		se.pad 4 + @ change$ SetDialogItemText
	se.event.loop ;


: FindFrom ( str$\line# -- )		\ see FIND.SE.ERROR
	BackFind? WholeWordFlag UncaseFlag  get.window
	locals| wasWindow wasUncase wasWhole wasBack |

	0 max							\ 10.43
	\ find next occurrence of STR$ starting at LINE#
	swap count search$ place

	se.datarange (get.line.offset)	\ offset of start of line#
	1-  dup selstart ! selend !
	se.window bring.to.front

	true  -> UncaseFlag
	true  -> WholeWordFlag
	false -> BackFind?				\ only forward search
	?kill.folder					\ almost the same as RE-SEARCH
\	get.window >r
	se.window window
	hide.range
	(re-search)						\ returns foundflag
	?dup 0=
	IF
		true -> BackFind?			\ failed forward, try backward
		(re-search)
	THEN

	wasUncase -> UncaseFlag
	wasWhole  -> WholeWordFlag
	wasBack   -> BackFind?

	found?							\ (FOUND?)
	show.range
	wasWindow  (window)
;


: (OpenEditor&Locate)  ( $find\fromline\FSSpec -- sewptr |or| 0 )
	\ modified from SE.EDIT.TOKEN
	{ $find fromline FSSpec  }
	FSSpec OpenEditorFromFSSpec  ( FSSpec -- sewptr |or| 0 )
	dup
	IF
		dup -> se.window			\ ???
		selend @  LastJumpedFrom !
		$find fromline FindFrom
	THEN
;


variable LineToStartLocate 		LineToStartLocate off

: OpenEditor&Locate	( FSSpec  -- )	\ LineToStartLocate & search$ already set up
	LineToStartLocate @ 1 - swap
	search$ -rot
	(OpenEditor&Locate)
	0= abort" OpenEditorFromFSSpec failed"
;


: HANDLE.SE.INTERPRET.ERROR ( abort$\err# -- )
	\ offending word assumed already in POCKET
	\ abort$ = 0  means was a regular error
	{ abort$ err# | theline# }
	err#
	IF
		err# -> was.se.error
		err# c" Handle.SE.INTERPRET.ERROR"  SysLogNumber ( n\c1$ -- )
	
\		se.interpreting OFF		\ done by SE.DONE.INTERPRETING
		state off
		s0 @ sp!
		(flush.type.buffer)
		
		IncludeStartOffset find.line#
		line# @  +  -> theline#

		abort$
		IF
			pocket theline#  abort$ AbortAlert ( badword$ line# c-addr -- )
		ELSE
			pocket theline#  err#   ErrorAlert ( badword$ line# err# -- )
		THEN

		pocket theline# 2 - FindFrom
		se.done.interpreting
	THEN
;

' handle.se.interpret.error is SE.INTERPRET.ERROR?


: ?RE-OPEN  ( fileID -- fileID )	\ try to reopen as RW - FIXED
	0 0 locals| vol dir f# |
	f# ?open                            \ not an untitled window
	if  f# ?FileLocked	\ ?readOnly  - locked  if we opened RW
		0=
		if
			se.pad f# GetFCBInfo  ( ^namePtr\fileRef# -- VolRefNum\DirID\flags )
			drop
			io-result @  0=
		 	IF
				f# FileClose
				ioDir !
				volref# !
				se.pad 
				(SE.OPEN$) ( str$ -- ref# )
				-> f#
				\ io-result @ -49 = if io-result off then
			ELSE
				\ should never get here
				2drop
				
				?file.error			\  TEST
				
			THEN
		then
	then
	f# ;



\ **********  **************************************************

: SE.OPEN..	 ( -- )		\ via standard file
\	ClearReply
	0 #filetypes se.filetypelist NRRecord
	
	0  c" Open File for Editor"  c" Edit"  0  c" Select a text file for editing"
	aNavEventProcPtr
	(NavGetFile)
	drop
	discard.activates
	NavReplyOK? IF	do.se.open THEN
;


: DoAnyEditorFilter ( ^AEDesc\^info\^callBackUD\filterMode -- flag )
	2drop 2drop
	true		\ ACCEPT ANY FILE TYPE
;


3 0 CALLBACK: aNewNavObjectFilterProcPtr
' DoAnyEditorFilter to-callback aNavEventProcPtr


: SE.OPENANY  ( -- )
	\ kNavAllowOpenPackages + kNavSupportPackages + kNavSelectAllReadableItem +
	\ 	+ kNavAllFilesInPopup + kNavAllowInvisibleFiles
	$3920  -> NavOptionFlags
\	ClearReply
	aNewNavObjectFilterProcPtr NewNavObjectFilterUPP dup >R
	0 0			\ 0 for numTypes returns a 0 NavTypeListHandle which allows filter free reign
	NRRecord
	0								\ " client"
	c" Open Any File in Editor"		\ " title"
	c" Edit"						\ " select"
	0								\ " skip"
	c" !!! CAUTION NOT ALL FILES HAVE EDITABLE TEXT !!!"
	NavGetFile ( fileFilter\numTypes\&typeList\&reply\...
 				...\ client$\title$\action$\cancel$\message -- OSErr )
	R> DisposeNavEventUPP
 	discard.activates
	NavReplyOK? IF	do.se.open THEN
;


exists? >mf.window false=
[IF]
	M4TH definitions
	: (>MF.WINDOW) ( -- )
		dflt.con mfCONSOLE !
		sys.window Show.Window 
		sys.window Select.Window
		sys.window window
		sys.window infile !
		sys.window active.window ! ;
	
	: >MF.WINDOW ( -- )
		0 HiliteMenu
		console.stream
		(>mf.window)
	    outfile on
		abort ;

	EditorVocab definitions
[THEN]


: CLOSE.DON'T.ASK ( -- | close it without asking to quit - EXPORT.CLOSE option )
\	debugfile ON
	(se.close)
	r> drop				\ exit calling word ( which would be SE.CLOSE)
; DoNotSin  \ NEVER-INLINE



: SE.CLOSE ( -- )
	se.window ?wvisible
	IF
		Export.CLOSE @execute		\ ( -- ) optional user function
		ask.save
		continue? @
		IF
			quitFolderSearch
			(se.close)
		ELSE
			>mf.window
		THEN
	THEN ;


: (SE.CLOSE?) ( in.close.box --  0 )
\ this allows closing a non-Front Editor window
	get.window ->se.window
	SE.CLOSE
	drop 0 ;	\	continue? @ false= IF drop 0 THEN ;

' (SE.CLOSE?) is SE.CLOSE?


: CLOSE.SE.FRONT
	search.dlog ?wvisible
	IF
		?CloseSearch
	ELSE
		se.close
	THEN ;


: SE.REVERT ( -- )
	se.changed @
	IF  \ ync# hcenter.alert
	    Continue# hcenter.alert
	    C" Do you really want to discard the changes you've made?"
	    "" "" ""    Continue# IssueWindowCenteredAlert 2 =
	    discard.activates
		active.window @ (window)
	    IF
	    	se.window window
	    	init.MiscInfo
	        re-open ?dup
	        IF
	            dup >R (se.open)
				R@ load.MiscInfo
				R> FileClose
				top.line @   screen.end !	\ give a safe value for screen.end
											\ it will be corrected the first time
											\ <DRAW.ALL.LINES runs
				restore.positions c@
				IF RestoreSize&Position THEN 
				restore.selection
				show.range
				show.selend
				UpdateAfterScroll				\ for recolorizing
	        THEN
	    THEN
	THEN ;      \ does nothing if file is not marked changed


: SE.PATHNAME ( -- Z-str |or| 0 )	\ full pathname of file owning SE.Window
	{ | buf$[ 256 ] }
	buf$[ SE.Window Get.WTitle
	se.changed @
	IF
		buf$[ StripMarker
	THEN
	se.volref# w@s  se.iodir @  buf$[
	FileInfo->ZString ( volref\iodir\file$ -- zStr )	
;


: (SAVE&INCLUDE) ( -- ) { theWindow -- }	 \  window to end up in
	Interpreter.EOLMode  SE.EOLMode @ <>
	IF
		c" Wrong format for interpreter.  Change line endings to "
		Interpreter.EOLMode
		CASE
			CR=EOL OF c" CR" ENDOF
			LF=EOL OF c" LF" ENDOF
		ENDCASE
		c"  before Include" "" 
		ok# IssueWindowCenteredAlert drop exit
	THEN
	
	selend @  LastJumpedFrom !
	se.changed @
	se.realfile w@ false= OR
	IF
		se.save	continue? @ false= IF exit THEN
	THEN
	set.se.one.shots

	false wake.window
	exit.se							\ ???????

	theWindow force.window	
	discard.activates
	theWindow active.window !
(( 
	sys.window force.window	
	discard.activates
	sys.window active.window !
 ))

	make.edit.next
	outfile ON

	se.pathname
	?ShortenPath					\ 10.44
	zcount <<included>>				\ included 
	
	Front.Window theWindow =
	IF
		 theWindow window
		 theWindow (activate.window)
	ELSE
		event.loop
	THEN
(( 
	Front.Window sys.window =
	IF
		 sys.window window
		 sys.window (activate.window)
	ELSE
		event.loop
	THEN
 ))
;



: SAVE&INCLUDE ( -- )			\ file menu action of the same name	
	['] included is <<included>>
	sys.window (save&include)
;


: SE.INCLUDE ( -- )
	true se.busy
	ACTIVE.WINDOW @ SYS.WINDOW <>
	IF	se.console mfCONSOLE !
		outfile on
		se.include..
		se.done.interpreting
	ELSE
		se.include..
	THEN
	(FLUSH.TYPE.BUFFER)
	FALSE SE.BUSY ;


: RANGE->SEARCH$ ( -- | patch sel range to search$  )
	selend @  LastJumpedFrom !
	selend @ selstart @ -  255 min
	dup	search$ c!
	selstart @ SE.DataStart + search$ 1+ rot cmove ;


: HILITED.SEARCH ( -- )
	selstart @ selend @ = 		\ nothing selected ?
	IF beep exit THEN
	range->search$				\ move selection range to Search$
	quitFolderSearch
	\ ?from.top 
	re-search ;


: OPTION.FIND ( -- )
	false -> BackFind?
	range->search$	
	quitFolderSearch
	?CmdKey false= IF from.top THEN
	re-search ;


: (FindBackWards)	\ 12/30/05 dbh
 	WholeWordFlag 
 	locals| priorSetting |
 	true -> WholeWordFlag	\ always whole word on find backwards
 	range->search$	
 	quitFolderSearch
 	true -> BackFind?
 	re-search
\ 	false -> BackFind?
 	priorSetting -> WholeWordFlag ; \ restore
 	
' (FindBackWards) is FindBackWards	\ 12/30/05 dbh



\ BEFORE.BYE routine

: MAX.SCRAP ( -- n )  FreeMem 2/ ;		\ LOL ???

: (REACTIVATE.SE.WINDOW)  ( -- )		\ was (REACTIVATE) ( -- )
	exit.se
	active.window @ sys.window <>
	IF  se.window window
		se.window select.window
	    se.window active.window !
		discard.activates
		true wake.window
	THEN
	events on
	true old.window.behavior @
	IF	 SE.Program
	ELSE se.activate
		 MainEventLoop
	THEN ;


: CheckScrap  ( -- )
    scrap.len @ max.scrap > 
        SEScrapCount GetCurrentScrap = and 
    \ Is current desk scrap responsibility of SE?
	IF  c" Save large clipboard?" "" "" ""
		YNC# IssueWindowCenteredAlert discard.activates
        CASE 1 OF ( do nothing )   			ENDOF
             2 OF ClearCurrentScrap drop 	ENDOF
             3 OF >MF.Window       			ENDOF
        ENDCASE
    THEN ;


: InitScrap  ( -- )
    0 to OldScrapCount
    0 to SEScrapCount
    true to se.scrap.changed 
    0 NewHandle to se.scrap ;   
 

: FILE.CHECK   ( -- )
	put.se.scrap
	get.se.scrap
	continue? on
	se.window1
	BEGIN
	    dup ?wvisible	\ ?active.wptr
	    IF  dup ->SE.Window
	    	se.close
	        continue? @  IF exit.se  ELSE  (reactivate.se.window) THEN
	    THEN
	    next.se.window dup se.window1 =
	UNTIL
	drop

    continue? @		\ are we really out of here?
    IF 
     	0 -> SE.WINDOW
	THEN

	disposeFileMsg
	quitFolderSearch
	checkScrap ;
EXODUS linklasttoken


true value NotWarned

: ?WarnChange ( -- )
	se.realfile w@
	NotWarned and
	IF
		false to NotWarned
		c" You have changed this file's format and it may " 
		c" no longer be readable by its original creator." 
		c"  Be careful about saving it without reverting or renaming." 
		""
		OK# IssueWindowCenteredAlert drop
	THEN
;


: ConvertCharInEditor  ( WasChar\ToBeChar --  )
\	SE.DataStart se.file.size @
	SE.DataRange
	ConvertCharInRange
	IF
		SetupSEWindow
		true mark.change
		?WarnChange
	ELSE
		beep
	THEN
;

: LF->CRLF
	crlf$ lf$
	se.handle
	ReplaceAll ( RplcWith$\Find$\theH -- howmany )
	0 >
	IF
		SetupSEWindow
		true mark.change
		?WarnChange
	THEN
;

: CRLF->CR
	cr$ crlf$
	se.handle
	ReplaceAll ( RplcWith$\Find$\theH -- howmany )
	0 >
	IF
		SetupSEWindow
		true mark.change
		?WarnChange
	THEN
;

: LF->CR ( -- )		\ convert all LineFeeds to CR's
	$0a	 $0d  ConvertCharInEditor
;

: CR->LF ( -- )		\ convert all CR's to LineFeeds
	$0d	 $0a  ConvertCharInEditor
;

: StripLFs	( -- ) 	\ strip line feeds - thanks to Doug Hoffman
	0 0 0 0 locals| cnt pos destPtr destHandle |
	se.handle   dup Hlock
	handtohand drop ( drop oserr ) dup @ -> destPtr
	dup Hlock -> destHandle
	
	SE.DataStart ( begAddr ) dup se.file.size @ + ( begAddr endAddr )
	swap
	?DO
		i c@ dup 10 <> 
		IF
			destPtr pos + c!
			1 +to pos
			1 +to cnt
		ELSE
			drop
		THEN
	LOOP
	destHandle Hunlock
	destHandle pos SetHandleSize	\ will be <= original size
	se.handle   dup Hunlock DisposeHandle
	destHandle se.buffer !
	cnt
	IF
		SetupSEWindow
		true mark.change
		?WarnChange
	ELSE
		beep
	THEN
;


: CloseSE_NoSave ( -- )
	se.window ?wvisible
	IF
		?CloseSearch
		se.window front.window =
		IF
			exit.se
		ELSE			\ just do some essential cleanup
        	((se.close))
            se.window close.window
            se.window next.active.window  -> se.window
		THEN
	ELSE
	    beep
	THEN
;

: SAVE.ALL.SE ( -- )
	\ saves all SE.WINDOWS that were opened from files.
	\ (optional) skips Debugger window and Untitled windows.
	[ also EditorVocab ]
	se.window >R						\ save old SE.WINDOW
	se.window1							\ start with SE.Window1
	BEGIN
	    dup ?wvisible					\ if it is visible
	    over SE.RESERVED? 0= AND			\ AND it is not a reserved window
	    IF  dup to se.window
			se.save						\ save it if necessary
	    THEN
	    next.se.window
		dup se.window1 =				\ go through the whole list
	UNTIL
	drop
	R> to se.window ;						\ restore old SE.WINDOW


: IncludeNoSave			\ sort of like SAVE&INCLUDE
	selend @  LastJumpedFrom !
	0 entry.start !
	se.handle >R
	\ we want to redirect output during INTERPRET to SYS.WINDOW
	\ else user can do SELECT-ALL then ENTER
	false wake.window
	exit.se
	sys.window force.window
	discard.activates
	sys.window active.window !
	make.edit.next
	R>	HandToHand MemError? 
;


variable ^SE.FILE.MENU

also printvocab

: SE.DO.FILE.MENU  ( n -- )
	0 HiliteMenu
	CASE
		 1 OF se.new				ENDOF
		 2 OF se.open..				ENDOF
		 3 OF se.openany			ENDOF
		 \ 4 ... OPENRECENT				--> Grayed out if submenu not available

		 5 OF close.se.front 		ENDOF		\ **
		 6 OF file.check			ENDOF		\ option-cmd-W  close all
		 7 OF CloseSE_NoSave		ENDOF		\ shift-cmd-W   Dispose/Close

		 8 OF se.save				ENDOF
		 9 OF save.all.se			ENDOF		\ option-cmd-S

		10 OF se.save.as			ENDOF

		11 OF save&include			ENDOF		\ **
		12 OF includeNoSave			ENDOF		\ option-cmd-K
			( separator )
		14 OF se.revert				ENDOF
		15 OF edit.next				ENDOF
			( separator )
		17 OF false to BackFind? 			se.search	ENDOF		\ cmd-F       FIND
		18 OF true  to BackFind? 			se.search	ENDOF		\ opt-cmd-F   FIND PRIOR
		19 OF false to BackFind? from.top	se.search	ENDOF		\ shift-cmd-F FIND FROM TOP
		20 OF true  to BackFind? from.end	se.search	ENDOF		\ shift-cmd-F FIND FROM END

		21 OF false to BackFind? 			re-search	ENDOF		\ cmd-G       FIND NEXT
		22 OF false to BackFind? from.top	re-search	ENDOF		\ shift-cmd-G FIND FROM TOP
		23 OF true  to BackFind? 			re-search	ENDOF		\ opt-cmd-G   FIND PRIOR
		24 OF true  to BackFind? from.end	re-search	ENDOF		\ shift-cmd-G FIND FROM END

		25 OF false to BackFind? 			hilited.search	ENDOF			\ cmd-H       FIND SELECTED
		26 OF false to BackFind? range->search$	from.top  re-search ENDOF	\ shift-cmd-H FIND FROM TOP
		27 OF true  to BackFind? 			hilited.search	ENDOF			\ opt-cmd-H   FIND PRIOR
		28 OF true  to BackFind? range->search$	from.end  re-search ENDOF	\ shift-cmd-H FIND FROM END

			( separator )
	\	30 Change Line Endings			--> submenu
			( separator )
			32 OF PrStyleDialog drop	ENDOF
			33 OF Print...				ENDOF
			34 OF se.prtsel				ENDOF
			( separator )
		36 OF se.include			ENDOF
		37 OF file.check bye		ENDOF
	ENDCASE
	DrawMenuBar
\ !!	reset.undo
;
previous

: DO.LINE.ENDING.SUBMENU ( item# -- )
		0 HiliteMenu
		CASE
			1 OF LF->CR		ENDOF
			2 OF CR->LF		ENDOF
			3 OF StripLFs	ENDOF
		ENDCASE
;

: AddLineEndingSubMenu ( -- )
	-1  c" LineEndingMenu" <LineEndingHierId> new.menu
	c" LF's->CR's;CR's->LF's;Strip LF's" <LineEndingHierId> append.items	

	FileMenu# -menu.handle 30 <LineEndingHierId> SetMenuItemHierarchicalID drop	
	<LineEndingHierId> menu.selection: do.line.ending.submenu
;

: +FileMenu ( str$ -- )
	FileMenu# append.items
;

: SE.FILE.MENU ( -- )
	FileMenu# get.next.id C" File" 					  FileMenu# new.menu

	C" New/N;Open.../O;Open Any As Text.../O;Open Recent" 		+FileMenu	\ 1..4
	C" Close/W;Close All Editor Windows/W;Discard Front Window/W" +FileMenu	\ 5..7
	C" Save/S;Save All Editor Windows/S" 						+FileMenu	\ 8..9
	C" Save As...;Save & Include/K;Include Front Window/K"		+FileMenu	\ 10..12
	C" -(;Revert to Saved;Edit Next/E" 							+FileMenu	\ 13.15
	C" -(;Find.../F;Find From Top.../F;Find Prior.../F;Find From End.../F" +FileMenu	\ 16..20
	C" Find Next/G;Find Again From Top/G;Find Again Prior/G;Find Again From End/G"  +FileMenu	\ 21..24
	C" Find Next Selected/H;Find Selected From Top/H"			+FileMenu	\ 25..26
	C" Find Prior Selected/H;Find Selected From End/H"			+FileMenu	\ 27..28
	C" -(;Change Line Endings" 									+FileMenu	\ 29..30
	C" -(;Page Setup...;Print...;Print Selection"				+FileMenu	\ 31..34
	C" -(;Include.../I" 										+FileMenu	\ 35..36

	\ the OPEN group..
	2 ascii O 0 FileMenu# MakeMenuItemDynamic \ no modifier - Just Open
	3 ascii O 2 FileMenu# MakeMenuItemDynamic \ option - Open Any File
	
	\ the CLOSE group..
	5 ascii W 0 FileMenu# MakeMenuItemDynamic \ no modifier - Just Close
	6 ascii W 2 FileMenu# MakeMenuItemDynamic \ option - Close All
	7 ascii W 3 FileMenu# MakeMenuItemDynamic \ option+shift - Discard + Close
	
	\ the SAVE group..
	8 ascii S 0 FileMenu# MakeMenuItemDynamic \ no modifier - Just Save
	9 ascii S 2 FileMenu# MakeMenuItemDynamic \ option - Save All
	
	\ the SAVE&INCLUDE  group..
	11 ascii K 0 FileMenu# MakeMenuItemDynamic \ no modifier - Save & Include
	12 ascii K 2 FileMenu# MakeMenuItemDynamic \ option - Include no save
	
	\ the FIND DIALOG  group..
	17 ascii F 0 FileMenu# MakeMenuItemDynamic \ no modifier - Just FIND DLOG
	18 ascii F 2 FileMenu# MakeMenuItemDynamic \ option - FIND FROM TOP
	19 ascii F 1 FileMenu# MakeMenuItemDynamic \ shift -  FIND PRIOR
	20 ascii F 3 FileMenu# MakeMenuItemDynamic \ option-shift - FIND FROM END

	\ the FIND NEXT  group..
	21 ascii G 0 FileMenu# MakeMenuItemDynamic \ no modifier - Just FIND NEXT
	22 ascii G 2 FileMenu# MakeMenuItemDynamic \ option - FIND FROM TOP
	23 ascii G 1 FileMenu# MakeMenuItemDynamic \ shift -  FIND PRIOR
	24 ascii G 3 FileMenu# MakeMenuItemDynamic \ option-shift - FIND FROM END
	
	\ the FIND SELECTED  group..
	25 ascii H 0 FileMenu# MakeMenuItemDynamic \ no modifier - FIND SELECTED NEXT
	26 ascii H 2 FileMenu# MakeMenuItemDynamic \ option - FIND SELECTED FROM TOP
	27 ascii H 1 FileMenu# MakeMenuItemDynamic \ shift -  FIND PRIOR SELECTED
	28 ascii H 3 FileMenu# MakeMenuItemDynamic \ option-shift - FIND SELECTED FROM END

	AddLineEndingSubMenu
	DrawMenuBar
	['] SE.DO.FILE.MENU ^SE.FILE.MENU !
	FileMenu# menu.selection: SE.DO.FILE.MENU
;



: CheckLockedStatus  ( -- )		\ determine a file's locked status
	se.realfile w@		\ does SE.WINDOW represent a file?
	IF
		(re-open) FileClose
		se.locked w@
		IF					\ if locked, try again, in case it was Time Machine
			100 ms			\ 10 delay
			(re-open) FileClose
		THEN
	THEN
;


: SEMenuBarAction  ( -- )		\ handle changes in a file's locked status
	se.window front.window =
	IF
		CheckLockedStatus
		true se.menu.items
	ELSE
		false se.menu.items		\ 10.46
	THEN
; BeforeMenuSelect linklasttoken




\ **********  INITIALIZATION  **********************************************

: INIT.SE.WINDOW ( wptr -- )		\ dup cr ." init " .
	locals| THE.WPTR |
	C" untitled" the.wptr w.title
	the.wptr dup +wfile.ptr @  +  se.tail.size erase

	['] do.SE.Program	the.wptr +on.activate !
	['] do.update.se	the.wptr +on.update !
	['] do.se.activate  the.wptr +on.newactivate !
	['] do.se.action	the.wptr +Window.Action !
	
	the.wptr ->SE.Window 		\ leave pointing to last one
	+CR MySE.CR	!				\ now a window specific setting
	SE.oldtopline ON			\ force color update from top
;

\ dup set-current

: DISPOSE.SE  ( -- )
	file.check
    continue? @		\ are we really out of here?
    IF
		file.menu 
		edit.menu	
		minimal.edit.menu
		clear.se.tib
		se.rgn  handle?   IF DisposeRgn THEN  0 to se.rgn
		tempRgn  handle?  IF DisposeRgn THEN  0 to tempRgn
		se.scrap  handle? IF DisposeHandle	THEN  0 to se.scrap
		0 ->SE.Window
		ThumbActionUPP  DisposeControlActionUPP

		['] noop	is AEOpenApp			\ 10.45
		['] 3drop	is AEOpenFile
		['] 3drop   IS AEPrintFile
		before.resume off
		before.suspend off

        dflt.con mfconsole !
		discard.activates
	THEN
;
ON.FORGET DISPOSE.SE
presnapshot linklasttoken



\ ********** INFO FRAME **************************************************

0 0 0   RGBColor WasForecolor
0 0 0   RGBColor WasBackcolor


: ShowTopLine ( -- )
	c" topline: "  count drawtext
	@se.vbar 1+ s>d <# ascii \ hold #S #>  drawtext
	#lines @ s>d <# #S #>  drawtext
;

: ShowSelectedLine ( -- )
	c" selline: "  count drawtext
	selend @ ~find.line# 1+  s>d <# ascii \ hold #S #>  drawtext
	#lines @ s>d <# #S #>  drawtext
;

: ShowSize ( -- )
	c" size: "  count drawtext
	selend @ selstart @ - s>d <# ascii \ hold #S #>  drawtext
	se.file.size @ s>d <# #S #>  drawtext
;

: ShowInsertion ( -- )
	c" insert: "  count drawtext
	selend   @ ~find.line# 1+
	selstart @ ~find.line# 1+
	2dup <>
	IF
		s>d <# ascii : hold #S #>  drawtext
	ELSE
		drop
	THEN
	s>d <#  #S #>  drawtext
;

: ColorThisFile? ( -- flag )
	+MISCINFO +SE.ColorFlag @ boolean
	SE.EOLMode @ CRLF=EOL <>			\ no colorizing in CRLF mode
	and
	se.interpreting @ 0=				\ inhibit colorizing during interpret
	and
;

: ShowColorMode ( -- )
	colorthisfile?
	IF
		6000
	ELSE
		6001
	THEN
	Getpicture ?dup IF SE.ColorRect  DrawPicture THEN
	SE.ColorRect FrameRect
;

: ShowEOLMode ( -- )
	SE.EOLMode @ default.EOLMODE <>
	IF
		rgbred    RGBForeColor
		rgbyellow RGBBackColor
	THEN
	SE.EOLModeRect EraseRect
	SE.EOLModeRect FrameRect

	SE.EOLMode @
	CASE
		CR=EOL OF s"  CR"  ENDOF
		LF=EOL OF s"  LF"  ENDOF
		CRLF=EOL OF s" CRLF" ENDOF
		s" ????"  swap
	ENDCASE
	HbarLeftOffset 32 - seBounds 4 + w@ se.descent - moveto		\ ?ENDIAN
	bold TextFace
	drawtext
;

: (DrawInfo) ( -- )
	StopGhosting
	se.window get.window =
	HbarLeftOffset AND
	IF
		tempRgn GetClip
		se.window no.clip
		get.textsize  >R
		get.textmode  >R
		get.textstyle >R
		get.textfont  >R
	
		WasForecolor  GetForeColor
		WasBackcolor  GetBackColor
		InfoForeColor RGBForeColor
		InfoBackColor RGBBackColor
		4 textfont
		9 _TextSize
		srccopy textmode
		patcopy _PenMode
		SE.InfoRect EraseRect
		SE.InfoRect FrameRect
		ShowColorMode

\ doing this here makes all the prior tweaking of #lines unneccessary
\ a smidgen slower ths way
\ the prior method needs work to handle the new method of including partial lines
\ in the count

 		0 se.handle dup GetHandleSize swap @ (count.lines)+  #lines !
		left.edge seBounds 4 + w@ se.descent - moveto		\ ?ENDIAN

		base @ >R
		decimal
\ this can get called during live scrolling, inside a procptr
\ so DP may not be what we expect, affecting <# # HOLD #>
\ so we will force it to be "safer"
		SKIP.EVENTS @ >R	\ Protect normal PAD
		SKIP.EVENTS ON		\ 
		SE.InfoMode @
		CASE
			0 OF ShowTopLine		ENDOF
			1 OF ShowSelectedLine	ENDOF
			2 OF ShowSize			ENDOF
			3 OF ShowInsertion		ENDOF
		ENDCASE

		ShowEOLMode

		R> SKIP.EVENTS !	\ Protect normal PAD
		R> base !
		R> TextFont
		R> TextFace
		R> textmode
		R> _TextSize
		WasForecolor RGBForeColor
		WasBackcolor RGBBackColor
		tempRgn SetClip
	THEN
;

' (DrawInfo) is DrawInfo


: ToggleColorMode ( -- )
	SE.EOLMode @ CRLF=EOL =
	IF
		c" Colorizing not available for DOS EOL Mode" "" "" "" 
		OK# IssueWindowCenteredAlert drop
	ELSE
		?OptionKey
		IF
			c" color preference dialog goes here?" "" "" "" 
			OK# IssueWindowCenteredAlert drop
		ELSE
			+MISCINFO +SE.ColorFlag dup @ boolean invert swap !
			true MARK.CHANGE
			coord.bounds InvalRect
			resize.se			\ dbh
		THEN
	THEN
;

' ToggleColorMode is ColorRectClicked


: ChangeInfoMode ( -- )
\ [ having SNICK ] snick
\ ]
	SE.InfoMode @ 1+ dup 
	3 >				\ 2 >
	IF drop 0 THEN
	SE.InfoMode !
	DrawInfo
;

' ChangeInfoMode is InfoRectClicked 


: ChangeEOLMode ( -- )
\ [ having SNICK ] snick
\ ]
	SE.EOLMode @ 1 +
	dup 2 >
	IF drop 0 THEN
	dup SE.EOLMode !

	CASE
		CR=EOL   OF CRLF->CR	13 SE.EOLChar ! ENDOF
		LF=EOL   OF CR->LF		10 SE.EOLChar ! ENDOF
		CRLF=EOL OF LF->CRLF 	13 SE.EOLChar ! ENDOF
	ENDCASE

	DrawInfo
;

' ChangeEOLMode is EOLModeRectClicked 



\ ********** old SE EXTRAS **************************************************


\ create a new editor window - use ADD.SE to open it
: NEW.SEWINDOW  ( name ( T\L\Height\Width --  )
	se.window >R
	sewindow
	thelatest init.se.window

	default.EOLMODE
	dup SE.orginalEOLMODE !
	dup	SE.EOLMode !
	LF=EOL =
	IF
		10
	ELSE
		13 
	THEN
	SE.EOLChar !	\ -> EOLChar
	R> to se.window
;

also system

: Prune.SEWindows  ( start end -- start end )
	\ clean up extra windows created by NEW.SEWINDOW if they are forgotten
	2dup   se.link  trim-links
;
' Prune.SEWindows prunes

previous


 
: HisTAIL ( tail variable\SE.WPTR -- addr | does not check for a valid SE.WPTR)
	\ example   EXPORT.KEY  SE.WINDOW04  HisTAIL 
	\ returns the address of the EXPORT.KEY fireld in the tail of SE.WINDOW04
	dup +wfile.ptr @  +		\ start of Se.Buffer for Wptr
	swap se.buffer -		\ offset from se.buffer for current SE.WPTR
	+ ;


: SE.RESERVED! ( flag\SEWindow -- | set the Reserved flag of an SE.WPTR )
	dup
	valid.se? 				\ remove stack parameters only if not VALID.SE?
	IF SE>FrontLink 4 + ! ELSE 2drop THEN ;


((
: CLOSE.SE ( wptr -- | allows your program to close an existing SE.WPTR )
	\ replace (SE.CLOSE) with SE.CLOSE to get the "Do you want to save.." alert
	dup  ?wvisible		\ ?active.wptr  
	IF  dup  valid.se?
		IF   hide.window
		ELSE drop
		THEN
	ELSE drop
	THEN  ;
))

new.console SE.CALLBACK.CONSOLE		\ stub out event handlers
(( 				\ 10.47 -- moved
	se.console  se.callback.console  consoleRecord move
	' null  	se.callback.console +conDo.EventsToken    !
	' noop  	se.callback.console +conDo.IO.EventsToken !
 ))


: (INSERT.TEXT>SE) ( addr\cnt\SEWindow\offset -- )
\ THIS DOES NOT DRAW TEXT - drawing is done on next update event
\ changes SELEND and SELSTART
\ does NOT delete selected text
\ offset = -1  then append to EOF
\ offset <0    then insert to SELEND
\ else insert at Offset
\ NOTE; This does not scroll to the new selend
\ ( the 4 + places insertion 4 lines from bottom of screen )
	mfconsole @
	se.window 
\	outfile @
	get.window
	action-of pause
	skip.events @
	locals| wasSkip wasPause OldWindow  OldSE OldConsole TheOFFSET DestWindow |
	\ addr\cnt  remain on stack
	dup 0>							\ non-0 Count
	DestWindow valid.se? AND		\ is it SE window?
	DestWindow ?wvisible AND		\ is the window visinle ?
	IF  
		['] noop is pause
		skip.events ON
		DestWindow   window
\		DestWindow   outfile !
		DestWindow   ->se.window
		se.callback.console  mfconsole !
		TheOffset -1 =
		IF
			 se.file.size @					\ offset of -1 pastes to EOF
		ELSE
			 TheOffset 0<
			 IF   selend @					\ negative offsets uses SELEND
			 ELSE TheOffset
			 THEN
		THEN
		dup  selend ! selstart !
\ for speed, replace ((se.type)) with ((SE.INSERT))
		((se.insert))
		selend @  selstart !
		true mark.change
		\ mark for updating, instead of redrawing now
		DestWindow @ seBounds InvalWindowRect drop	\ force an update to do the drawing
		\ seBounds  InvalRect		
		\ ((se.type))  (flush.type.buffer)
		
\		OldOutfile   outfile !
		OldWindow ?dup IF window THEN
		OldSE       ->se.window
		OldConsole  mfconsole !
		wasSkip     skip.events !
		wasPause  is pause
	ELSE
		2drop					\ throw away data if not SE.WPTR
	THEN
;


\ OFFSET.NOT.VISIBLE?

: MakeSelendVisible ( SEWindow\offset -- )
\ (INSERT.TEXT>SE) does not scroll to the new selend
\ to do that place this after (INSERT.TEXT>SE)
\ offset is #lines from bottom of screen to show selend
	mfconsole @
	se.window 
\	outfile @
	get.window
	action-of pause
	skip.events @
	locals| wasSkip wasPause  OldWindow  OldSE OldConsole TheOFFSET DestWindow |
	DestWindow valid.se?
	DestWindow ?wvisible AND
	IF  
		['] noop is pause
		skip.events ON
		DestWindow   window
\		DestWindow   outfile !
		DestWindow   ->se.window
		se.callback.console  mfconsole !
		selend @ offset.not.visible?
		IF
			selend @ find.line#  #vislines @ - theoffset + 0 max make.top.line
			seBounds  InvalRect		\ mark for updating, instead of redrawing now
		THEN
\		OldOutfile   outfile !
		OldWindow ?dup IF window THEN
		OldSE       ->se.window
		OldConsole   mfconsole !
		wasSkip      skip.events !
		wasPause   is pause
	THEN
;


: INSERT.TEXT>SE ( addr\cnt\SEWindow\offset -- ) 
\ RESTORES SELECTED RANGE UNLESS THE INSERT IS WITHIN SELECTION
	se.window >R
	over ->se.window
	selstart @ >R 	selend @ >R			\ save current (user) range
	(insert.text>se)
	R> selend !		R> selstart !		\ restore user range
	R> ->se.window
;

\ *** End of stuff from SE Extras ***


\ ********** UNDO **************************************************

: RedrawAfterUndo  ( -- )
	SET.HBAR.RANGE
	0 !se.hbar
	?rlscroll
	set.IBpt
	show.selend
	Get.SEBounds  EraseRect 
	TextBounds    ClipRect
	draw.screen
	AdjustUndoMenu
;


: UNDO.INSERT ( ^itemtoundo -- )
	dup +UndoSelStart @ selstart !
		+UndoSelEnd   @ selend ! 

	(delete.sel.range)
	\ note: +UndoDataHandle already setup by SaveInsertRange 
	
	SE.CurrentUndoListOffset @ UndoItem - 0 max
		SE.CurrentUndoListOffset !
	
	RedrawAfterUndo
;


: UNDO.DELETE ( ^itemtoundo -- )
	dup +UndoSelStart @ dup selend ! selstart !

	dup +UndoDataHandle @
	  dup @ swap GetHandleSize
	     (se.insert)		\ (SE.PASTE.STRING)	\ se.insert
		
	dup +UndoSelStart @  selstart !
	    +UndoSelEnd   @  selend ! 
	show.selend

	SE.CurrentUndoListOffset @ UndoItem - 0 max
		SE.CurrentUndoListOffset !

	AdjustUndoMenu
;


: UNDO.BACKSPACE ( ^itemtoundo -- )
	dup >R +UndoSelStart incr		\ adjust before restoring
	R@ undo.delete
	R> +UndoSelEnd @ selstart !
	RedrawAfterUndo
;


: UNDO.FORMATTING ( ^itemtoundo -- )			\ similar to UNDO.DELETE
	dup +UndoSelStart @ selstart !
	dup +UndoSelEnd   @ selend   !
	range>hdl >R							\ save formatted data

	(delete.sel.range)
	dup +UndoDataHandle @ dup >R
	  dup @ swap GetHandleSize
	     (se.insert)						\ restore original data
	R> DisposeHandle						\ discard orginal +UndoDataHandle
		
	dup +UndoSelStart @  selstart !
	selend @ over +UndoSelEnd !

	R> swap +UndoDataHandle !				\ save formatted data for possible redo

	SE.CurrentUndoListOffset @ UndoItem - 0 max
		SE.CurrentUndoListOffset !

	AdjustUndoMenu
;


: <<SE.UNDO
	^TheUndoableItem ?dup 0= IF AdjustUndoMenu exit THEN
	{ ^itemtoundo }
	se.window active.window @ =
	IF
		^itemtoundo +UndoOP w@
		CASE
			$8001 OF  ^itemtoundo undo.delete 		ENDOF	\ cut
			$8002 OF  ^itemtoundo undo.formatting 	ENDOF	\ copy
			$8003 OF  ^itemtoundo undo.insert		ENDOF	\ typing
			$8004 OF  ^itemtoundo undo.backspace 	ENDOF	\ backspace
			$8005 OF  ^itemtoundo undo.formatting 	ENDOF	\ formatting
		ENDCASE
	ELSE
		AdjustUndoMenu
		beep
	THEN
;

' <<SE.UNDO is SE.UNDO



\ ********** REDO **************************************************

: REDO.DELETE ( ^itemtoredo -- )
	dup +UndoSelStart @ selstart !
	    +UndoSelEnd   @ selend  !
	(delete.sel.range)
	SE.CurrentUndoListOffset @ UndoItem +
		SE.CurrentUndoListOffset !

	RedrawAfterUndo
;

\ this version does not handle deleted text - use it only for typing
: REDO.INSERT ( ^itemtoredo -- )
	dup +UndoSelStart @ dup selend ! selstart !
	dup +UndoDataHandle @
	  dup @ swap GetHandleSize
	     (se.insert)
	SE.CurrentUndoListOffset @ UndoItem +
		SE.CurrentUndoListOffset !
	dup +UndoSelEnd @ dup selend ! selstart !

	RedrawAfterUndo
;


: REDO.BACKSPACE ( ^itemtoredo -- )
	redo.delete
;


: REDO.FORMATTING ( ^itemtoredo -- )
\ this version saves text prior to deletion
	dup +UndoSelStart @ selstart !
	dup +UndoSelEnd   @ selend   !
	range>hdl >R							\ save unformatted data
	(delete.sel.range)

	dup +UndoDataHandle @ dup >R
	  dup @ swap GetHandleSize
	     (se.insert)						\ restore formatted data
	R> DisposeHandle						\ discard unformatted data

	selend @ over +UndoSelEnd !
	R> swap +UndoDataHandle !				\ save formatted data for possible undo

	SE.CurrentUndoListOffset @ UndoItem +
		SE.CurrentUndoListOffset !

	RedrawAfterUndo
;


: <<SE.REDO
	^UndoListInsertion ?dup 0= IF exit THEN
	{ ^itemtoredo }
	se.window active.window @ =
	IF
		TheRedoableOp
		CASE
			$8001 OF  ^itemtoredo redo.delete 		ENDOF	\ cut
			$8002 OF  ^itemtoredo redo.formatting 	ENDOF	\ paste
			$8003 OF  ^itemtoredo redo.insert		ENDOF	\ typing
			$8004 OF  ^itemtoredo redo.backspace 	ENDOF	\ backspace
			$8005 OF  ^itemtoredo redo.formatting 	ENDOF	\ formatting
		ENDCASE
	ELSE
		AdjustUndoMenu
		beep
	THEN
;

' <<SE.REDO is SE.REDO



\ ********** Add Items to +UndoDataHandle *****************************************

: SaveDeleteRange ( -- )		\ invoked early in DELETE.SEL.RANGE
	selend @ selstart @ -
	IF		
		$8001 AddUndoableItem
		range>hdl swap +UndoDataHandle !
\	ELSE 			\ should not happen
	THEN
;

: SaveInsertRange ( -- )		\ invoked early in SE.INSERT
	$8002 AddUndoableItem
	range>hdl swap +UndoDataHandle !
;

: SaveFormattingRange ( -- )
	$8005 AddUndoableItem
	range>hdl swap +UndoDataHandle !
;


: CorrectFormattingEnd ( -- )	\ formatting likely changes Selend
	selend @
	^TheUndoableItem +UndoSelEnd !
;


: AppendCharToUndoDataHandle ( char -- )
	^TheUndoableItem +UndoDataHandle @  handle?
	IF
		dup     GetHandleSize  					\ handle\size
		2dup 1+ SetHandleSize					\ grow the handle
		swap @ swap + c!						\ save char to handle
	ELSE
		1 from.heap dup ^TheUndoableItem +UndoDataHandle !	\ make & save handle
		@ c!									\ save char
	THEN
	^TheUndoableItem +UndoSelEnd incr
;


: SaveInsertedChar ( n -- )
	selend @ selstart @ - 0=		\ delete should have happened before we get this
	IF
		^TheUndoableItem ?dup
		IF
			dup  +UndoSelEnd @ selend @ <>	\ selend has moved OR
			swap +UndoOP w@  $8003 <>		\ if current undoable item <> Typing
			OR
			IF								\ we must create a new undoable item
				$8003 AddUndoableItem drop
			THEN
		ELSE							\ no undoable items, must make one
			$8003 AddUndoableItem drop
		THEN
		AppendCharToUndoDataHandle
	ELSE 								\ ERROR CASE
		drop
	THEN
;


: PrependCharToUndoDataHandle ( char -- )
	^TheUndoableItem +UndoDataHandle @  handle?
	IF		\ +UndoDataHandle already exists, so extend it
		dup     GetHandleSize  					\ handle\size
		2dup 1+ SetHandleSize					\ grow the handle
												\ handle\origsize
		swap @ dup rot							\ addr\addr\origsize
		over 1+ 								\ addr\addr\origsize\addr+1
		swap move
		c!										\ save char to handle
		\ swap @ swap + c!						\ save char to handle
	ELSE
		1 from.heap dup ^TheUndoableItem +UndoDataHandle !	\ make & save handle
		@ c!									\ save char
	THEN
	^TheUndoableItem +UndoSelStart decr
;


: SaveDeletedChar ( n -- )
	^TheUndoableItem ?dup
	IF
		dup  +UndoSelstart @ selstart @ <>	\ selend has moved OR
		swap +UndoOP w@  $8004 <>		\ if current undoable item <> backspacing
		OR
		IF								\ we must create a new undoable item
			$8004 AddUndoableItem drop
		THEN
	ELSE							\ no undoable items, must make one
		$8003 AddUndoableItem drop
	THEN
	PrependCharToUndoDataHandle
;


: <<SaveRangeOp ( opType -- )
\ 1= BS, 2= charInsert, 3= rangeDelete, 4= rangeInsert
	InhibitUndo @ IF drop AdjustUndoMenu exit THEN
	CASE
		3 OF SaveDeleteRange	 ENDOF	\ rangeDelete
		4 OF SaveInsertRange	 ENDOF	\ rangeInsert
		5 OF SaveFormattingRange ENDOF
		6 OF CorrectFormattingEnd ENDOF
	ENDCASE
;
' <<SaveRangeOp is SaveRangeOp


: <<SaveOp ( char\opType -- )
\ 1= BS, 2= charInsert, 3= rangeDelete, 4= rangeInsert
	InhibitUndo @ IF 2drop AdjustUndoMenu exit THEN
	CASE
		1 OF SaveDeletedChar	ENDOF
		2 OF SaveInsertedChar	ENDOF
		DROP
	ENDCASE
;
' <<SaveOp is SaveOp


: <<CLEAR.UNDOLIST	( per window )
	{ | theH theSize }
	SE.UndoListH @ handle?
	IF
		-> theH
		0 PruneUndoList
		theH DisposeHandle
	THEN
	0  SE.UndoListH !
	0  SE.CurrentUndoListOffset !
	AdjustUndoMenu
;
' <<CLEAR.UNDOLIST is RESET.UNDO


\ **********  **************************************************

: (INSTALL.SE)  ( -- )
	0 -> se.window
	['] init.se.window  ['] ToEachSE  SE.Link mfCHAINSearch 2drop
	true to NotWarned
	edit.menu 			se.edit.menu.items
	se.file.menu 		false se.menu.items
\	['] file.check    	before.bye !

	['] se.suspend		before.suspend !
	['] se.resume		before.resume !
	['] se.quit 	 IS quit
	ThumbActionProcPtr  NewControlActionUPP -> ThumbActionUPP

	clear.se.tib
	( 0 to se.tib)			0 to se.scrap
	0 -> LastActivatedSE
	0 -> LastScrollTicks
	search$ off			change$ off	
	NewRgn to se.rgn	
	NewRgn to tempRgn
	InitScrap


	ascii ALRT 1001 GetResource ?dup
	IF	\ is the new not found alert available from resource bag ?
		to.heap
		1001
		NewSearchMode ON
	ELSE
		OK#
	THEN  -> NotFound#
	se.interpreting OFF
;
restorer linklasttoken


: EditorInstalled?  ( -- flag )
	se.window ?wptr				\ se.windows instantiated?
	^se.file.menu @  
		FileMenu# >menu @ = 	\ is SE.FILE.MENU installed ?
	AND
;


: INSTALL.SE  ( -- )
	EditorInstalled? false= 
	IF (install.se) THEN ;



\ SET UP SE.CONSOLE TABLEs
	' SE.?TERMINAL		se.console +con?TerminalToken !
	' se.type			se.console +conTypeToken !
	' se.eprint  		se.console +conEPrintToken !
	' se.consexpect		se.console +conExpectToken !
	' se.conskey	    se.console +conKeyToken !
	' se.consaccept		se.console +conAcceptToken !
	0					se.console +conEolEchoChar 	c!

\ 10.47 do this after SE.CONSOLE is set up
	se.console  se.callback.console  consoleRecord move
	' null  	se.callback.console +conDo.EventsToken    !
	' noop  	se.callback.console +conDo.IO.EventsToken !



\ ASSIGN FORWARD REFERENCES
	' option.find		is find.first
	' se.delete			is do.se.delete
	' insert.char		is do.insert.char
	' se.insert			is do.se.insert
	' control.char  	is do.control.char

	' se.action			is do.se.action
	' search.action		is do.search.action
	' se.activate		is do.se.activate
	' search.activate	is do.search.activate
	' search.hilite		is do.search.hilite

	' se.program		is do.se.program
	' update.se			is do.update.se




: SE.AEOPENFILE  ( vrefnum\dirID\fileName -- )
	locals| fileName dirID vRefNum |
\	c" SE.AEOPENFILE"  SysLogMsg1
	c" SE.AEOPENFILE"  fileName  SysLogMsg2

	install.se
	\ 10.47 - do NOT allow LION to open our mach-o app
	\ or try and open our bundle
	fileName count MyNameBuffer count istr=		\ is name = our mach-o name?

	upcasepocket 500 GetMyAppName
	IF
		fileName count upcasepocket  count istr=
		OR
	THEN

	IF	\ do NOT allow LION to try and open our app
		c" ignore our app" SysLogMsg1
	ELSE
		OptionKey? 0=	\ don't restore windows on Lion if OPTION down at launch
		IF
			vRefNum dirID fileName 0 get.cat.info ?dup
			IF
				dup >R @  32 + @	\ ioFlFndrInfo
				se.fileType?
			\	r@ @  54 + @		\ ioFlLgLen
			\	200:000 <		\ prevent Lion from trying to open our APP here
			\	and
				r> DisposeHandle
				IF install.se fileName vRefNum dirID se.open$ THEN
			THEN 
		THEN
	THEN
;


: SE.AEOPENAPP  ( -- )	\ normally only called if no files to open
	c" SE.AEOPENAPP" SysLogMsg1
	install.se 
	3 ModifierKey? 0=
	se.window ?wvisible 0= AND		\ 10.47 - skip if already a window open
	IF		\ don't add an empty window if shift key or caps lock
		se.new
	THEN
;


: InstallEditorHandlers ( -- )
\ Install AppleEvent handling words
	^se.file.menu ON				\ mark it is as not loaded
	['] se.AEOpenApp		is AEOpenApp
	['] se.AEOpenFile		is AEOpenFile
;  restorer linklasttoken



\ T   L   BO  RO		--  BO & RO are offsets ( Height and Width )
\ ** MORE WINDOWS CAN GO HERE **

263 168  SEditHigh SEditWide  SEWindow SE.Window16		\ this one is last to be opened
248 158  SEditHigh SEditWide  SEWindow SE.Window15
233 148  SEditHigh SEditWide  SEWindow SE.Window14
218 138  SEditHigh SEditWide  SEWindow SE.Window13

203 118  SEditHigh SEditWide  SEWindow SE.Window12
188 108  SEditHigh SEditWide  SEWindow SE.Window11
173  98  SEditHigh SEditWide  SEWindow SE.Window10
158  88  SEditHigh SEditWide  SEWindow SE.Window09

143  78  SEditHigh SEditWide  SEWindow SE.Window08
128  68  SEditHigh SEditWide  SEWindow SE.Window07
113  58  SEditHigh SEditWide  SEWindow SE.Window06
 98  48  SEditHigh SEditWide  SEWindow SE.Window05
 
 83  38  SEditHigh SEditWide  SEWindow SE.Window04
 68  28  SEditHigh SEditWide  SEWindow SE.Window03
 53  18  SEditHigh SEditWide  SEWindow SE.Window02
 38   8  SEditHigh SEditWide  SEWindow SE.Window01		\ this one is opened first


	\ you may optionally decide to remove the Editor vocabulary, but
	\ several utilities require Editor be intact
	\	ZAPVOCAB Editor
	\	AXE Editor


0 -> SE.WINDOW
\ INSTALL.SE			\ optional - autostartup


: SET.SE.TEXTSIZE ( n -- )
	dup -> se.textsize
	dup dup 4 / + -> se.lineheight	\ this seems a good value
	3 -> se.descent
;


: AdjustSESizetoScreen ( -- )
	screen.bounds 4 + w@	\ max height
	NumSEWindows 15 * -		\ stagger room
	8 * 10 /
	to SEditHigh
;  restorer linklasttoken


: SET.SE.WINDOW.WH ( width\height -- )
	-> sedithigh
	-> seditwide
	AdjustEditorWindows ;

